#!/usr/bin/perl
# Prueba OpenURL a bases de datos de libros en Aleph

#use CGI qw/:standard/;
use CGI;
use DBI;
use LWP;
use LWP::Simple qw($ua get);

require('../variables.pl');

## Tiempo maximo en segundos para que responda el catalogo
$ua->timeout(50);

system('clear');

$start = `date '+%H:%M:%S'`;

print "\nRoVer - Verificacin de URLs de la Multibase Nacional\n\n";

$query = new CGI;
$termino = "mexico";
$campo = "Ttulo";
$campostabla ='t.id,t.institucion,t.indice_titulo,t.indice_tema,t.indice_autor,t.indice_todo,t.software,t.url,t.id_region,tr.region,t.siglas,t.status';
$i=0;
$cantidad=0;
undef(@texto1);
undef(@texto2);
$HTML='';
$linea='';

#Archivo de salida
$fecha=`date '+%y%m%d'`;
chop($fecha);
$file_salida="rover_multibase_"."$fecha".".txt";

open(SALIDA,"> $file_salida")||die "No existe archivo de salida: $file_salida\n\n";

print "\nConect\341ndose a la base de datos en PostgreSQL ($bd)..... \n";

$conn = DBI->connect("dbi:Pg:dbname=$bd",$user,$pass);
   
if (!$conn)
{  
      print "\nNO HAY CONEXION A LA BASE DE DATOS $bd";
}
else   #Si existe conexin a la BD 
{
      print "\nVerificando URLs....\n";

      $consulta="select $campostabla from $tabla t,$tregion tr where t.software like '%%' and t.id_region=tr.id_region order by t.id_region,t.institucion";

      $sqlconsulta = $conn->prepare($consulta);
      $sqlconsulta->execute;
      $ary1=$sqlconsulta->fetchall_arrayref;
      $tary1=$sqlconsulta->rows;

      #print "\n$consulta \nTotal de registros: $tary1";
      $i=0;
      #Valida cada biblioteca recuperada en la busqueda
      while ($i <= $tary1-1)
      {
            $region = "$ary1->[$i]->[9]";
            $id = "$ary1->[$i]->[0]";
            $institucion= "$ary1->[$i]->[1]";
            $software="$ary1->[$i]->[6]";
            $url="$ary1->[$i]->[7]";
            $siglas="$ary1->[$i]->[10]";
            $status="$ary1->[$i]->[11]";
            $i++;
            creaurl($id);
#            print "\n$i=$siglas # $urlbases";
            validaurl($urlbases);
      } #fin while arreglo
} #fin valida conexion
#Cierre de archivos
close(SALIDA);

### Procedimientos

   ## Genera el url pasando los parametros de termino e indice
   sub creaurl()
   {
       $indice="";
       $urlbases="";
       # Identifica el campo de busqueda
       if ($campo eq 'Ttulo')
       {
          $indice=$ary1->[$i]->[2];
       }
       if ($campo eq 'Tema')
       {
          $indice=$ary1->[$i]->[3];
       }
       if ($campo eq 'Autor')
       {
          $indice=$ary1->[$i]->[4];
       }
       if ($campo eq 'Todos los campos')
       {
          $indice=$ary1->[$i]->[5];
       }

       $termino =~ tr//a/;
       $termino =~ tr//e/;
       $termino =~ tr//i/;
       $termino =~ tr//o/;
       $termino =~ tr//u/;
       $termino =~ tr//u/;
       $termino =~ tr//a/;
       $termino =~ tr//e/;
       $termino =~ tr//i/;
       $termino =~ tr//o/;
       $termino =~ tr//u/;
       $termino =~ tr//u/;
       $car_ntilde = "%C3%B1";
       $termino =~ s//$car_ntilde/g; 
       $termino =~ s//$car_ntilde/g;

       if ($software =~ /Aleph 500/) ## Bibliotecas ALEPH 500 
       {
          $urlbases="$url&request=".$termino."&find_code=".$indice."&adjacent=N"; 
          if ($siglas =~ /UA/)
          { 
             $urlbases .="&filter_code_1=WLN&filter_code_2=WYR&filter_code_3=WYR&filter_code_4=WFM&filter_request_4=BK&filter_code_5=WSL";
          }
          if ($siglas =~ /CFATA/)
          {
             $urlbases="$url&find_code=".$indice."&request=".$termino;
          }
       }
       if ($software =~ /Alephino/) ## Alephino 4.1
       {
          $urlbases="$url".$termino."&C2=%29&F1=".$indice."&A1=N&x=0&y=0";
       }
       if ($software =~ /Horizon-Dynix/)  ## Bibliotecas Horizon-Dynix 
       {
          $urlbases=$url."&index=".$indice."&term=".$termino;
       }
       if ($software =~ /Horizonte/) ## Horizonte v.5.3
       {
          $urlbases="$url?pt=welcome&ts=template%5Fcide&mc=spa&bc=CIDE&lb=licide&sd=ipcide&bd=ipcide&cs=928020889&ls=1&db=ipcide&se=%2E".$indice.$termino."&de=".$termino."&sn=0&tm=sum";
       }
       if ($software =~ /INNOPAC/) ##  Innopac-Millenium
       { 
          $urlbases="$url".$indice."(".$termino.")";
       }
       if ($software =~ /Siabuc Siglo/) ##  Siabuc Siglo XXI 
       {
          $urlbases=$url."&$indice=$termino";
       }
       if ($software =~ /Siabuc 9/) ##  Siabuc 9 
       {
          if (($siglas =~ /INECOL/) or ($siglas =~ /UCOL/) or ($siglas =~ /CMQ/))
          {
             $urlbases=$url."&Termino1=$termino&Campo1=$indice&IdBiblioteca=-1&IdMaterial=1&SearchButton=Search";
          }
          else
          {
             $urlbases=$url."&Termino1=$termino&Campo1=$indice";
          }
          if ($siglas =~ /CENAPRED/)
          {
             $urlbases="http://www.catalogolinea.cenapred.unam.mx/CatalogoBasico/Home/BusquedaAvanzadaPorBiblioteca?campo1=1&termino1=sismos&idbiblioteca=16&idtipomaterial=0&registros=194";
          }
       }
       if ($software =~ /Siabuc 8/) ##  Siabuc 8
       {
          $indice =~ s/^\s+//;
          $urlbases=$url."?FormatoFicha=0&Cantidad=20&ACERVO=LIBROS&FichaINI=1&ArchivoCFG=Lib_Gral.cfg&$indice=$termino";
          if ($institucion =~ /Sinaloa/)
          {
             $urlbases=$url."?FormatoFicha=1&Cantidad=10&ACERVO=LIBROS&FichaINI=1&ArchivoCFG=abLib_Gral.CFG&mostrarFICHABIB=1&BUSQ_AVANZADA=1&BaseDTA=1&$indice=$termino";
          } 
          if ($siglas =~ /CICESE/)
          {
             $urlbases=$url."?FormatoFicha=0&Cantidad=10&ACERVO=LIBROS&FichaINI=1&ArchivoCFG=mono.cfg&mostrarFICHABIB=1&BUSQ_AVANZADA=1&BaseDTA=1&$indice=$termino";
          }
          if ($siglas =~ /UCOL/) ##Univ. Colima
          {
             $urlbases=$url."?FormatoFicha=1&Cantidad=10&ACERVO=LIBROS&FichaINI=1&ArchivoCFG=abLib_Mult.CFG&mostrarFICHABIB=1&BUSQ_AVANZADA=1&BaseDTA=99&txtEXPR1=$termino&opCAMPO1=$indice";
          }
          if ($software =~ /Act. 4.0/) ## Siabuc 8 act. 4.0
          {
             $urlbases=$url."?FormatoFicha=0&Cantidad=10&ACERVO=LIBROS&FichaINI=1&ArchivoCFG=BDL_Gral.CFG&opCampo1=".$indice."&txtEXPR1=".$termino."&BUSQ_AVANZADA=1&mostrarFICHABDL=1";
             $termino=~ tr/+/ /;
          }
       }
       if ($software =~ /Alexandria/) ## Alexandria 5.11
       {
          if (($siglas =~ /FLACSO/) or ($siglas=~ /UAEH/))
          {
             if ($siglas =~ /FLACSO/) ## Alex. 6.1.5
             {
                $urlbases="$url/?results=Interface=advanced&SearchField0=$termino&SearchType0=$indice&OperatorType0=And#_";
             }
             if ($siglas =~ /UAEH/)
             {
                # primero obtiene numero de sesion
                $url0="http://dbci.uaeh.edu.mx:81";
                $HTML = LWP::UserAgent->new;
                $response = $HTML->get( $url0 );
                $HTML= $response->as_string;
                @lineas = split (/\n/,$HTML);
                foreach $linea (@lineas){
                   if( $linea =~ /sessionid=/){
                       @texto1 = split (/sessionid=/,$linea);
                       @texto2 = split (/">/,$texto1[1]);
                       $sesionid = $texto2[0];
                   }
                }
                $urlbases="$url/boolean/results/?collection=1&S0=$indice&SearchField0=$termino&O0=And&S1=Keyword&SearchField1=&B2=Search&B3=Expert&sessionid=$sesionid";
             }
          }
          else
          {
             $urlbases="$url".$indice."&SearchField0=".$termino."&O0=And&S1=Keyword&SearchField1=&B2=Search&B3=Expert";
          }
       }
       if ($software =~ /Innovative/) ##  Innovative-Millenium
       {
          if ($id == 5)
          { $urlbases="$url".$indice."?SEARCH=".$termino."&SORT=D&searchscope=5"; }
          if ($id == 38)
          { $urlbases="$url".$indice."?SEARCH=".$termino."&SORT=D&searchscope=18"; }
       }
       if ($software =~ /IMCED/) ## Propio o desconocido 
       {
          $urlbases="$url&".$indice."=1&user_query=".$termino;
       }
       if ($software =~ /Acervo/) ## Acervo v.2007
       {
          $urlbases=$url."&$indice=$termino";
       }
       if ($software =~ /CIO/) ## Propio
       {
          $urlbases=$url."?tipo1=".$indice."&patron=".$termino;
       }
       if ($software =~ /INECOL/) ## Propio
       {
          $urlbases=$url."?sql=".$indice."+LIKE+'*".$termino."*'";
       }
       if ($software =~ /CIMAT/) ## Propio
       {
          $urlbases=$url."?cad=$termino&campo=$indice";
       }
       if ($software =~ /Altair/) ## Altair v.1.8
       {
          $urlbases=$url."&qry=$indice=($termino)&txtTema=$termino&cboTag=*$indice*";
       }
       if ($software =~ /USON/) ## Propio
       {
          $urlbases=$url."&c1=$indice&t1=$termino";
       }
       if ($software =~ /UJAT/) ## Propio
       {
          $urlbases="$url?Consulta=1&opcion1=LB&nombre1=$termino&opcion=$indice";
       }
       if ($software =~ /CICESE/) ## Propio
       {
             $urlbases=$url."termino[1][query]=$termino&termino[1][logic]=and&termino[1][where]=$indice&logic[1]=AND&termino[2][query]=&termino[2][logic]=and&termino[2][where]=$indice&logic[2]=AND&termino[3][query]=&termino[3][logic]=and&termino[3][where]=$indice&tipo=1&grado=&programa=0&year_condition=&year1=&year2=&order=titulo&dpp=20&advance=true";
       }
       if ($software =~ /Sirsi/) ## SirsiDynix Webcat 
       {
          $urlbases="$url?searchdata1=$termino&words+or+phrase&searcgoper1=AND&srchfield1=$indice&sort_by=-PBYR&user_id=WEBSERVER&password=&submit=Search";
          $numlinea=0;
          $banderasirsi=0;
       }
       if ($software =~ /Micro/) ## Micro CDS/ISIS  
       {
             $urlbases=$url."&expresion=$termino";
       }
       if ($software =~ /EOS /) ## EOS Web 
       {
          $urlbases="$url&selectField1=$indice&txtSearch1=$termino";
       }
       if ($software =~ /Janium/) 
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&$indice=$termino";
       }
       if ($software =~ /Micro CDS/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&expresion=$termino";
       }
       if ($software =~ /Glifos/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&field1=$indice&value1=$termino";
       }
       if ($software =~ /EverGreen/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&qtype=$indice&contains=contains&query=$termino&fi%3Aaudience=&locg=1&pubdate=is&date1=&date2=&sort=&_adv=1";
       }
       if ($software =~ /VTLS/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&field_1=$indice&term_1=$termino";
       }
       if ($software =~ /Koha/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&idx=$indice&q=$termino";
       }
       if ($software =~ /ECOSUR/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url"."sb[req][]=$termino&sb[cod][]=$indice";
       }
       if ($software =~ /Primo/)
       {
          $termino=~ tr/+/ /;
          $urlbases="$url&query=$indice,contains,$termino&query=facet_rtype,exact,books";
       }
       return($urlbases,$urlinicio);
   }


    ## Verifica la disponibilidad del url de la biblioteca 
    sub validaurl()
    {
       # Solo para el protocolo https
       $response = $ua->get( $urlbases );
       $HTML= $response->code;

       print "\n$siglas\t$urlbases\t\t$HTML";

       print SALIDA "\n$siglas#$urlbases#$HTML";
       return($urlbases);
    }

$end = `date '+%H:%M:%S'`;
 
print "\n\nTiempo de verificacin para $tary1 URL(s)\n";
print "\nInicio: $start";
print "Fin: $end\n";

print "Finaliz la verificaci\363n de URLs de la BD $bd \n";

exit;

