--
-- Selected TOC Entries:
--
\connect - israeld

--
-- TOC Entry ID 16 (OID 3045857)
--
-- Name: Bitacora Type: TABLE Owner: israeld
--

CREATE TABLE "Bitacora" (
	"Identificador" integer,
	"fecha" character varying(30),
	"hora" character varying(20),
	"IP" character varying(20)
);

--
-- TOC Entry ID 2 (OID 3235330)
--
-- Name: apdopost_apdo_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "apdopost_apdo_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 17 (OID 3235332)
--
-- Name: apdopost Type: TABLE Owner: israeld
--

CREATE TABLE "apdopost" (
	"apdo_id" integer DEFAULT nextval('"apdopost_apdo_id_seq"'::text) NOT NULL,
	"cod_post" character varying(100),
	"ciudad" character varying(20),
	"pais" character varying(20),
	"localidad" character varying(50),
	"municipio" character varying(50),
	"apdo_post" character varying(75),
	Constraint "apdopost_pkey" Primary Key ("apdo_id")
);

--
-- TOC Entry ID 4 (OID 3235335)
--
-- Name: datosdepen_dep_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "datosdepen_dep_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 18 (OID 3235337)
--
-- Name: datosdepen Type: TABLE Owner: israeld
--

CREATE TABLE "datosdepen" (
	"dep_id" integer DEFAULT nextval('"datosdepen_dep_id_seq"'::text) NOT NULL,
	"nom_int" character varying(100) NOT NULL,
	"siglas_inst" character varying(20),
	"nom_depen" character varying(200),
	"siglas_depen" character varying(10),
	"nom_subdepen" character(150),
	"ano_fundacion" character varying(50),
	"pag_web" character varying(100),
	"observaciones" character varying(1000),
	"dep_obs" character varying(1000),
	"objetivo" character varying(1000),
	"semaforo" character varying(100),
	Constraint "datosdepen_pkey" Primary Key ("dep_id")
);

--
-- TOC Entry ID 6 (OID 3235343)
--
-- Name: datosubdep_subdep_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "datosubdep_subdep_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 19 (OID 3235345)
--
-- Name: datosubdep Type: TABLE Owner: israeld
--

CREATE TABLE "datosubdep" (
	"subdep_id" integer DEFAULT nextval('"datosubdep_subdep_id_seq"'::text) NOT NULL,
	"dep_id" integer NOT NULL,
	"nom_subdepen" character varying(200),
	"subdepen_siglas" character varying(10),
	"subdepen_ano_fundacion" numeric(4,0),
	"subdepen_pag_web" character varying(100),
	"observaciones" character varying(1000),
	"subdepen_obs" character varying(1000),
	Constraint "datosubdep_pkey" Primary Key ("subdep_id", "dep_id")
);

--
-- TOC Entry ID 8 (OID 3235351)
--
-- Name: datosbiblio_bib_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "datosbiblio_bib_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 20 (OID 3235353)
--
-- Name: datosbiblio Type: TABLE Owner: israeld
--

CREATE TABLE "datosbiblio" (
	"bib_id" integer DEFAULT nextval('"datosbiblio_bib_id_seq"'::text) NOT NULL,
	"nombre" character varying(200),
	"nombre_abrev" character varying(50),
	"adscripcion" character varying(100),
	"subsistema" character(100),
	"ano_fundacion" character varying(50),
	"ref_historica" character varying(12500),
	"pag_web" character varying(400),
	"control_dgb" character varying(30),
	"control_lc" character varying(30),
	"control_hx" character varying(30),
	"categoria" character varying(20),
	"cod_prog_lib" character varying(50),
	"cod_prog_rev" character varying(50),
	"prep_asig521" character varying(150),
	"prep_ejer521" character varying(150),
	"prep_asig523" character varying(150),
	"prep_ejer523" character varying(150),
	"prep_asig421" character varying(150),
	"prep_ejer421" character varying(150),
	"prep_enc_asig" character varying(150),
	"prep_enc_ejer" character varying(150),
	"superficie" numeric(9,2),
	"observaciones" character varying(1000),
	"datospropbib_obs" character varying(1000),
	"status" character varying(25),
	"spnosis" character varying(3000),
	"objetivo" character varying(1000),
	"foto" character varying(500),
	"catalogolibros" character varying(1000),
	"catalogorev" character varying(1000),
	"catalogomap" character varying(1000),
	"ariel" character varying(500),
	"contacto" character varying(500),
	"fotomapa" character varying(500),
	"opac" character varying(2000),
	"google" character varying(2000),
	"nombrecorto" character varying(2000),
	Constraint "datosbiblio_pkey" Primary Key ("bib_id")
);

--
-- TOC Entry ID 21 (OID 3235359)
--
-- Name: direccion Type: TABLE Owner: israeld
--

CREATE TABLE "direccion" (
	"dir_id" integer NOT NULL,
	"bib_id" integer NOT NULL,
	"dep_id" integer NOT NULL,
	"subdep_id" integer NOT NULL,
	"calle" character varying(100),
	"localidad" character varying(80),
	"municipio" character varying(80),
	"ciudad" character varying(80),
	"estado" character varying(50),
	"pais" character varying(80),
	"apdo_id" integer,
	"cod_post" character varying(50),
	"observaciones" character varying(1000),
	"dir_obs" character varying(1000),
	Constraint "direccion_pkey" Primary Key ("dir_id", "bib_id", "dep_id", "subdep_id")
);

--
-- TOC Entry ID 22 (OID 3235365)
--
-- Name: coleccion Type: TABLE Owner: israeld
--

CREATE TABLE "coleccion" (
	"bib_id" integer NOT NULL,
	"num_tit_lib" numeric(10,0),
	"num_vol_lib" numeric(10,0),
	"num_tit_rev" numeric(10,0),
	"num_fasc_rev" numeric(10,0),
	"num_tit_tes" numeric(10,0),
	"num_vol_tes" numeric(10,0),
	"otros_mat_doc" character varying(1000),
	"num_usuarios" numeric(10,0),
	"num_asistentes" numeric(10,0),
	"pub_editadas" character varying(2000),
	"clasif_conacyt" character varying(1000),
	"cobert_geogra" character varying(25),
	"descriptores" character varying(1500),
	"descript_entidad" character varying(2500),
	"idioma" character varying(300),
	"sist_clasif" character varying(250),
	"observaciones" character varying(1000),
	"colec_obs" character varying(1000),
	Constraint "coleccion_pkey" Primary Key ("bib_id")
);

--
-- TOC Entry ID 10 (OID 3235371)
--
-- Name: datospersona_per_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "datospersona_per_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 23 (OID 3235373)
--
-- Name: datospersona Type: TABLE Owner: israeld
--

CREATE TABLE "datospersona" (
	"per_id" integer DEFAULT nextval('"datospersona_per_id_seq"'::text) NOT NULL,
	"grado" character varying(15),
	"nombre" character varying(150),
	"tel_1" character varying(75),
	"tel_2" character varying(75),
	"tel_3" character varying(75),
	"fax_1" character varying(75),
	"fax_2" character varying(75),
	"mail_1" character varying(80),
	"mail_2" character varying(80),
	"horario" character varying(150),
	"observaciones" character varying(1000),
	"per_obs" character varying(1000),
	"foto" character varying(500),
	"funcion" character varying(100),
	Constraint "datospersona_pkey" Primary Key ("per_id")
);

--
-- TOC Entry ID 24 (OID 3235373)
--
-- Name: datospersona Type: ACL Owner: 
--

REVOKE ALL on "datospersona" from PUBLIC;
GRANT ALL on "datospersona" to "israeld";

--
-- TOC Entry ID 25 (OID 3235379)
--
-- Name: infraestructura Type: TABLE Owner: israeld
--

CREATE TABLE "infraestructura" (
	"bib_id" integer NOT NULL,
	"num_cpu" numeric(4,0),
	"num_term" numeric(4,0),
	"num_impr" numeric(4,0),
	"num_serv" numeric(4,0),
	"sw" character varying(2000),
	"activ_autom" character varying(1000),
	"observaciones" character varying(1000),
	"infra_obs" character varying(1000),
	Constraint "infraestructura_pkey" Primary Key ("bib_id")
);

--
-- TOC Entry ID 26 (OID 3235385)
--
-- Name: normatividad Type: TABLE Owner: israeld
--

CREATE TABLE "normatividad" (
	"bib_id" integer NOT NULL,
	"comision" character varying(2),
	"reglamento" character varying(2),
	"manuales" character varying(200),
	"observaciones" character varying(1000),
	"norm_obs" character varying(1000),
	Constraint "normatividad_pkey" Primary Key ("bib_id")
);

--
-- TOC Entry ID 27 (OID 3235391)
--
-- Name: persona Type: TABLE Owner: israeld
--

CREATE TABLE "persona" (
	"bib_id" integer NOT NULL,
	"per_id" integer NOT NULL,
	"cargo" integer NOT NULL,
	Constraint "persona_pkey" Primary Key ("bib_id", "per_id")
);

--
-- TOC Entry ID 28 (OID 3235394)
--
-- Name: rechumanos Type: TABLE Owner: israeld
--

CREATE TABLE "rechumanos" (
	"bib_id" integer NOT NULL,
	"academicos" numeric(4,0),
	"admvos" numeric(4,0),
	"honorarios" numeric(3,0),
	"total" numeric(6,0),
	"observaciones" character varying(1000),
	"rechum_obs" character varying(1000),
	Constraint "rechumanos_pkey" Primary Key ("bib_id")
);

--
-- TOC Entry ID 29 (OID 3235400)
--
-- Name: servicio Type: TABLE Owner: israeld
--

CREATE TABLE "servicio" (
	"bib_id" integer NOT NULL,
	"horario" character varying(1000) NOT NULL,
	"t_acceso_acervo" character varying(100),
	"t_matdoc_prest" character varying(2000),
	"servs_especial" character varying(2000),
	"t_fuentes_impr" character varying(2000),
	"t_fuentes_elec" character varying(2000),
	"servicios" character varying(2000),
	"t_prestamo" character varying(1000),
	"inst_usuario" character varying(2000),
	"acceso_internet" character varying(2),
	"acceso_redunam" character varying(2),
	"acceso_bd_dgb" character varying(2),
	"observaciones" character varying(1000),
	"serv_obs" character varying(1000),
	Constraint "servicio_pkey" Primary Key ("bib_id")
);

--
-- TOC Entry ID 12 (OID 3235406)
--
-- Name: usuario_usu_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "usuario_usu_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 30 (OID 3235408)
--
-- Name: usuario Type: TABLE Owner: israeld
--

CREATE TABLE "usuario" (
	"usu_id" integer DEFAULT nextval('"usuario_usu_id_seq"'::text) NOT NULL,
	"area" integer NOT NULL,
	"usu_login" character varying(20),
	"usu_passwd" character varying(20),
	Constraint "usuario_pkey" Primary Key ("usu_id")
);

--
-- TOC Entry ID 14 (OID 3235411)
--
-- Name: modificacion_mod_id_seq Type: SEQUENCE Owner: israeld
--

CREATE SEQUENCE "modificacion_mod_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 31 (OID 3235413)
--
-- Name: modificacion Type: TABLE Owner: israeld
--

CREATE TABLE "modificacion" (
	"mod_id" integer DEFAULT nextval('"modificacion_mod_id_seq"'::text) NOT NULL,
	"mod_id_tabla" integer,
	"mod_tabla" character(30),
	"mod_fecha" character(50),
	"mod_area" integer,
	Constraint "modificacion_pkey" Primary Key ("mod_id")
);

--
-- TOC Entry ID 32 (OID 3235416)
--
-- Name: bitacora Type: TABLE Owner: israeld
--

CREATE TABLE "bitacora" (
	"identificador" integer,
	"fecha" character varying(30),
	"hora" character varying(30),
	"ip" character varying(20)
);

--
-- Data for TOC Entry ID 54 (OID 3045857)
--
-- Name: Bitacora Type: TABLE DATA Owner: israeld
--


--
-- Data for TOC Entry ID 55 (OID 3235332)
--
-- Name: apdopost Type: TABLE DATA Owner: israeld
--


INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (0,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (144,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (145,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (166,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (198,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (213,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (214,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (215,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (216,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (217,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (218,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (219,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (220,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (221,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (222,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (223,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (224,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (225,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (226,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (227,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (228,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (229,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (230,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (231,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (232,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (233,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (234,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (235,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (236,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (237,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (238,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (239,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (240,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (241,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (242,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (243,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (244,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (245,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (246,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (247,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (248,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (249,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (250,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (251,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (252,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (253,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (254,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (255,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (256,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (257,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (258,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (259,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (260,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (261,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (262,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (263,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (264,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (265,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (266,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (267,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (268,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (269,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (270,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (271,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (272,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (273,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (274,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (275,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (276,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (277,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (278,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (279,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (280,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (281,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (282,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (283,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (284,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (285,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (286,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (287,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (288,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (289,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (290,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (291,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (292,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (293,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (294,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (295,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (296,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (297,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (298,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (326,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (332,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (333,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (339,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (133,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (31,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (48,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (72,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (23,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (336,'78283-0426','Texas','USA','','San Antonio','P. O. Box 830426');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (161,'62280','Cuernavaca','Mxico','','','565-A');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (157,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (160,'0','Morelos','Mxico','','Temixco','34');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (139,'62250','Cuernavaca','Mxico','','','510-3');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (330,'62250','Cuernavaca','Mxico','','','510-3');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (152,'62251','Cuernavaca','Mxico','','','48-3');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (206,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (80,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (79,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (78,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (83,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (341,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (346,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (334,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (324,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (128,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (153,'22800','','Mxico','','Ensenada, Baja California','356');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (205,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (171,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (335,'0','','Canad','','','78034');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (140,'93600','','','','','136');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (54,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (338,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (90,'62431','Morelos','Mxico','','Cuernavaca','4-106');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (86,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (76,'0','0','','0','0','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (22,'62280','Cuernavaca','Mxico','','','48-3');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (340,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (2,'22800','B. C.','Mxico','Ensenada','','106');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (52,'95701','','Mxico','San Andrs Tuxtla','','94');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (113,'77580','Cancn','Mxico','Puerto Morelos','Benito Jurez','1152');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (112,'82000','','Mxico','','Mazatln','811');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (111,'24140','','Mxico','El Carmen','Campeche','30');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (116,'04510','D. F.','Mxico','','Del. Coyoacn','70-543');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (74,'62580','Morelos','Mxico','','Temixco','34');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (84,'83000','Hermosillo','Mxico','','','1039');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (85,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (347,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (191,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (5,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (33,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (91,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (36,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (190,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (3,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (34,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (142,'62251','','Mxico','','Cuernavaca','273-3');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (67,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (70,'22800','','Mxico','','Ensenada','14');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (53,'48980','Jalisco','Mxico','','San Patricio','21');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (69,'62251','Cuernavaca','Mxico','','','62251');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (11,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (151,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (27,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (331,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (141,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (28,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (88,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (155,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (55,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (19,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (148,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (45,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (150,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (35,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (343,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (342,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (348,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (349,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (350,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (351,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (170,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (162,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (353,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (360,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (361,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (362,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (363,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (163,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (61,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (165,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (26,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (354,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (355,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (47,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (174,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (167,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (10,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (24,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (175,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (127,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (126,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (169,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (105,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (356,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (357,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (168,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (119,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (358,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (359,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (364,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (365,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (366,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (368,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (369,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (176,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (50,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (164,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (44,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (189,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (143,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (193,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (131,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (177,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (17,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (194,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (37,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (195,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (40,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (196,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (39,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (197,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (38,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (178,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (96,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (182,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (187,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (100,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (181,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (101,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (180,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (102,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (185,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (103,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (186,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (104,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (97,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (183,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (199,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (8,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (9,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (29,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (188,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (6,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (200,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (57,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (202,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (13,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (14,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (203,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (204,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (129,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (30,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (207,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (134,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (135,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (208,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (209,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (63,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (65,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (64,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (210,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (77,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (81,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (211,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (118,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (66,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (192,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (92,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (212,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (93,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (94,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (123,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (124,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (300,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (109,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (106,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (110,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (108,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (107,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (301,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (1,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (302,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (51,'04510','Cd. Mx.','Mxico','Ciudad Universitaria','Del. Coyoacn','70-233');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (304,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (136,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (303,'0','Cd. Mx.','Mxico','','Col. Coyoacn','70-543');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (305,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (16,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (307,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (68,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (306,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (21,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (308,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (138,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (309,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (71,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (310,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (137,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (311,'0','Cd. Mx.','Mxico','Ciudad Universitaria','','70-472');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (87,'04510','Cd. Mx.','Mxico','','Del. Coyoacn','70-472');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (4,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (25,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (313,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (82,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (89,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (322,'01000','Cd. Mx.','Mxico','San ngel','Del. lvaro Obregn','20-726');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (18,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (321,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (73,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (12,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (60,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (58,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (59,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (42,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (43,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (20,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (49,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (323,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (75,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (325,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (114,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (121,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (345,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (370,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (371,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (372,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (373,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (320,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (315,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (319,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (314,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (317,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (318,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (154,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (312,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (316,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (156,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (146,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (149,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (147,'62431','Morelos','Mxico','','Cuernavaca','4-106');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (327,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (159,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (158,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (337,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (329,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (344,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (299,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (352,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (125,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (46,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (179,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (95,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (184,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (32,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (201,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (115,'0','','','','','70-391');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (117,'0','','','','Taxco de Alarcn','70');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (132,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (367,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (328,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (120,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (7,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (99,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (41,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (62,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (130,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (98,'0','','','','','0');
INSERT INTO "apdopost" ("apdo_id","cod_post","ciudad","pais","localidad","municipio","apdo_post") VALUES (56,'0','Cd. Mx.','Mxico','','','20-234');
--
-- Data for TOC Entry ID 56 (OID 3235337)
--
-- Name: datosdepen Type: TABLE DATA Owner: israeld
--


INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (65,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Ingeniera','FING','                                                                                                                                                      ','0','http://www.ingenieria.unam.mx/menu_principal.php','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (74,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Ciencias del Mar y Limnologa','ICML','                                                                                                                                                      ','0','http://www.icmyl.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (0,'Universidad Nacional Autnoma de Mxico','UNAM','Universidad Nacional Autnoma de Mxico',NULL,'                                                                                                                                                      ','0','http://www.ier.unam.mx/\011\011','Biblioteca dada de alta 14 febrero 2014','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (125,'Universidad Nacional Autnoma de Mxico',NULL,'Centro de Investigaciones en Geografa Ambiental. Campus Morelia, Mich.',NULL,'                                                                                                                                                      ','0','http://www.ciga.unam.mx','Biblioteca dada de alta 14 febrero 2014','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (93,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Matemticas','IMAT','                                                                                                                                                      ','0','http://www.matem.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (104,'UNAM',NULL,'Biblioteca del Campus Juriquilla','','                                                                                                                                                      ','0','http://www.biblioteca.juriquilla.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (11,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Enseanza para Extranjeros','CEPE','                                                                                                                                                      ','0','http://www.cepe.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (55,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Arquitectura','FARQ','                                                                                                                                                      ','0','http://www.arq.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (7,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Ciencias Aplicadas y Desarrollo Tecnolgico','CCAD','                                                                                                                                                      ','0','http://www.ccadet.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (61,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Estudios Superiores Cuautitln','FESC','                                                                                                                                                      ','0','http://www.cuautitlan.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (72,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Biologa','IBIO','                                                                                                                                                      ','0','http://www.ib.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (73,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Ciencias Nucleares','ICNU','                                                                                                                                                      ','0','http://www.nucleares.unam.mx/icn2/\011','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (63,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Estudios Superiores Zaragoza','FESZ','                                                                                                                                                      ','0','http://www.zaragoza.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (100,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Biotecnologa. Cuernavaca, Mor.','IBIT','                                                                                                                                                      ','0','http://www.ibt.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (62,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Estudios Superiores Iztacala','FESI','                                                                                                                                                      ','0','http://www.iztacala.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (1,'Universidad Nacional Autnoma de Mxico','UNAM','Biblioteca Conjunta de Ciencias de la Tierra','BCCT','                                                                                                                                                      ','0','http://bcct.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (17,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Ciencias Genmicas. Cuernavaca, Mor.','CIFN','                                                                                                                                                      ','0','http://www.ccg.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (101,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Ciencias de la Atmsfera','CCAT','                                                                                                                                                      ','0','http://www.atmosfera.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (82,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Antropolgicas','IIAN','                                                                                                                                                      ','0','http://www.iia.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (66,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Medicina','FMED','                                                                                                                                                      ','0','http://www.facmed.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (2,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Investigaciones sobre Amrica Latina y el Caribe','CCDE  ','                                                                                                                                                      ','0','http://www.cialc.unam.mx/','Gaceta del 20 de agosto 2007 el CCyDEL cambia a CIALC. DPLybf','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (44,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Artes y Diseo','ENAP','                                                                                                                                                      ','0','http://www.enap.unam.mx','Cambio de denominacin de Escuela Nacional de Artes Plsticas a Facultad de Artes y Diseo. Lunes 24 de marzo de 2014.','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (37,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 4, Vidal Castaeda y Njera','ENP4','                                                                                                                                                      ','0','http://enp4.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (40,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 8, Miguel E. Schulz','ENP8','                                                                                                                                                      ','0','http://prepa8.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (4,'Universidad Nacional Autnoma de Mxico','UNAM','Centro Universitario de Estudios Cinematogrficos','CUEC','                                                                                                                                                      ','0','http://www.cuec.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (35,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Direccin General','ENPD','                                                                                                                                                      ','0','http://dgenp.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (67,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Medicina Veterinaria y Zootecnia','FMVZ','                                                                                                                                                      ','0','http://www.fmvz.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (43,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 3, Justo Sierra','ENP3','                                                                                                                                                      ','0','http://enp3.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (36,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 5, Jos Vasconcelos','ENP5','                                                                                                                                                      ','0','http://www.prepa5.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (106,'Universidad Nacional Autnoma de Mxico',NULL,'Unidad Acadmica de Estudios Regionales. Sede La Cinega, Jiquilpan de Jurez, Mich.',NULL,'                                                                                                                                                      ','0','http://uaer.humanidades.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (15,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Investigaciones sobre Amrica del Norte','CIAN','                                                                                                                                                      ','0','http://www.cisan.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (3,'Universidad Nacional Autnoma de Mxico','UNAM','Centro Regional de Investigaciones Multidisciplinarias de la UNAM. Cuernavaca, Mor.','CRIM','                                                                                                                                                      ','0','http://www.crim.unam.mx/drupal/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (6,'Universidad Nacional Autnoma de Mxico','UNAM','Centro Universitario de Teatro','CUTE','                                                                                                                                                      ','0','http://www.cut.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (107,'Universidad Nacional Autnoma de Mxico','UNAM','Consejo Acadmico del Bachillerato','CAB','                                                                                                                                                      ','0','http://www.cab.unam.mx','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (110,'Universidad Nacional Autnoma de Mxico','UNAM','Consejo Tcnico y Coordinacin de la Investigacin Cientfica','CIC','                                                                                                                                                      ','0','http://www.cic-ctic.unam.mx/cic/index_cic.html','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (26,'Universidad Nacional Autnoma de Mxico','UNAM','Coordinacin de Estudios de Posgrado','DGEP','                                                                                                                                                      ','0','http://www.posgrado.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (18,'Universidad Nacional Autnoma de Mxico','UNAM','Coordinacin de Universidad Abierta y Educacin a Distancia','CUAE','                                                                                                                                                      ','0','http://www.cuaed.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (116,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de  Comunicacin Social','DPR','                                                                                                                                                      ','0','http://www.dgcs.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (117,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de  Planeacin','PL','                                                                                                                                                      ','0','http://www.planeacion.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (21,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Artes Visuales','DGAR','                                                                                                                                                      ','0','http://www.muac.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (23,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Bibliotecas','DGBI','                                                                                                                                                      ','0','http://dgb.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (31,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Cmputo y de Tecnologas de Informacin y Comunicacin','DGSC','                                                                                                                                                      ','0','http://www.tic.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (24,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Divulgacin de la Ciencia','DGDC','                                                                                                                                                      ','0','http://www.dgdc.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (25,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Estudios de Legislacin Universitaria','DGEL','                                                                                                                                                      ','0','http://www.dgelu.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (114,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Evaluacin  Educativa','DEE','                                                                                                                                                      ','0','http://www.evaluacion.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (115,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Incorporacin y Revalidacin de Estudios','DIR','                                                                                                                                                      ','0','http://www.dgire.unam.mx/contenido/home.htm','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (118,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Personal','DGP','                                                                                                                                                      ','0','http://www.personal.unam.mx/DGPE/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (119,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Publicaciones y Fomento Editorial','DPB','                                                                                                                                                      ','0','http://www.libros.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (120,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Radio UNAM','RU','                                                                                                                                                      ','0','http://www.radiounam.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (32,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Televisin Universitaria','DGTV','                                                                                                                                                      ','0','http://www.tvunam.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (45,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional de Enfermera y Obstetricia','ENEO','                                                                                                                                                      ','0','http://www.eneo.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (48,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Msica','ENMU','                                                                                                                                                      ','0','http://www.enmusica.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (39,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 9, Pedro de Alba','ENP9','                                                                                                                                                      ','0','http://www.prepa9.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (42,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 7, Ezequiel A. Chvez','ENP7','                                                                                                                                                      ','0','http://prepa7.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (34,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria Plantel 1, Gabino Barreda','ENP1','                                                                                                                                                      ','0','http://prepa1.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (56,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Ciencias','FCIE','                                                                                                                                                      ','0','http://www.fciencias.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (13,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Geociencias. Campus Juriquilla, Qro.','I3','                                                                                                                                                      ','0','http://www.geociencias.unam.mx/geociencias/index.html','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (102,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Fsica Aplicada y Tecnologa Avanzada. Campus Juriquilla. Qro.',NULL,'                                                                                                                                                      ','0','http://www.fata.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (94,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Neurobiologa. Campus Juriquilla, Qro.','INEU','                                                                                                                                                      ','0','http://www.inb.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (87,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Filosficas','IIFS','                                                                                                                                                      ','0','http://recursos.filosoficas.unam.mx/~jrg/iifs/sitio/index.php\011','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (78,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Geofsica','IGEF','                                                                                                                                                      ','0','http://www.igeofcu.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (80,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Geologa','IGEL','                                                                                                                                                      ','0','http://www.geologia.unam.mx/igl','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (57,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Ciencias Polticas y Sociales','FCPS','                                                                                                                                                      ','0','http://www.politicas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (58,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Contadura y Administracin','FCAD','                                                                                                                                                      ','0','http://www.fca.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (59,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Derecho','FDER','                                                                                                                                                      ','0','http://www.derecho.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (60,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Economa','FECO','                                                                                                                                                      ','0','http://herzog.economia.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (46,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Estudios Superiores  Acatln','FESA','                                                                                                                                                      ','0','http://www.acatlan.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (47,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Estudios Superiores Aragn','FESAR','                                                                                                                                                      ','0','http://www.aragon.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (64,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Filosofa y Letras','FFLE','                                                                                                                                                      ','0','http://www.filos.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (68,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Odontologa','FODO','                                                                                                                                                      ','0','http://www.odonto.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (69,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Psicologa','FPSI','                                                                                                                                                      ','0','http://www.psicologia.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (70,'Universidad Nacional Autnoma de Mxico','UNAM','Facultad de Qumica','FQUI','                                                                                                                                                      ','0','http://www.quimica.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (5,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Bibliotecolgicas y de la Informacin','CUIB','                                                                                                                                                      ','0','http://iibi.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (84,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Econmicas','IIEC','                                                                                                                                                      ','0','http://www.iiec.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (86,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Filolgicas','IIFL','                                                                                                                                                      ','0','http://www.iifilologicas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (88,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Histricas','IIHI','                                                                                                                                                      ','0','http://www.historicas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (89,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Jurdicas','IIJU','                                                                                                                                                      ','0','http://info.juridicas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (12,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones sobre la Universidad y la Educacin','CESU','                                                                                                                                                      ','0','http://www.iisue.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (90,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Sociales','IISO','                                                                                                                                                      ','0','http://www.iis.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (71,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Astronoma','IAST','                                                                                                                                                      ','0','http://www.astroscu.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (8,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Ciencias Fsicas. Cuernavaca, Mor.','CCFI','                                                                                                                                                      ','0','http://www.fis.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (77,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Fsica','IFIS','                                                                                                                                                      ','0','http://www.fisica.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (76,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Fisiologa Celular','IFCE','                                                                                                                                                      ','0','http://www.ifc.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (79,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Geografa','IGEO','                                                                                                                                                      ','0','http://www.igg.unam.mx/sigg/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (81,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Ingeniera','IING','                                                                                                                                                      ','0','http://www.iingen.unam.mx/es-mx/Paginas/default.aspx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (92,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones en Matemticas Aplicadas y en Sistemas','IIMA','                                                                                                                                                      ','0','http://www.iimas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (121,'Universidad Nacional Autnoma de Mxico','UNAM','Secretara de Desarrollo Institucional','CRU','                                                                                                                                                      ','0','http://www.sdei.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (122,'Universidad Nacional Autnoma de Mxico','UNAM','Unidad Coordinadora de Servicios Acadmicos','USA','                                                                                                                                                      ','0','http://www.cab.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (85,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Estticas','IIES','                                                                                                                                                      ','0','http://www.esteticas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (38,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 2, Erasmo Castellanos Quinto','ENP2','                                                                                                                                                      ','0','http://prepa2.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (41,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Preparatoria. Plantel 6, Antonio Caso','ENP6','                                                                                                                                                      ','0','http://www.prepa6.unam.mx/ENP6/_P6/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (108,'Universidad Nacional Autnoma de Mxico','UNAM','Programa Universitario de Estudios de la Diversidad Cultural y la Interculturalidad','PUMN','                                                                                                                                                      ','0','http://www.nacionmulticultural.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (123,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Ciencias Matemticas. Campus Morelia, Mich.','CCM','                                                                                                                                                      ','0','http://www.matmor.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (103,'Universidad Nacional Autnoma de Mxico','UNAM','Centro Peninsular en Humanidades y Ciencias Sociales. Mrida, Yuc.',NULL,'                                                                                                                                                      ','0','http://www.cephcis.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (98,'Universidad Nacional Autnoma de Mxico','UNAM','Programa Universitario de Estudios sobre la Ciudad','PUEC','                                                                                                                                                      ','0','http://www.puec.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (91,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones en Materiales','IIMT','                                                                                                                                                      ','0','http://www.iim.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (75,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Ecologa','IECO','                                                                                                                                                      ','0','http://web.ecologia.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (95,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Qumica','IQUI','                                                                                                                                                      ','0','http://www.iquimica.unam.mx','Cuenta con una sede foranea desde 2008: el Centro Conjunto de Investigacin en Qumica Sustentable  en Toluca','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (19,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Actividades Cinematogrficas','DGAC','                                                                                                                                                      ','0','http://www.filmoteca.unam.mx/','Gaceta 8 de marzo 2012. Nuevo espacio  con 2,522 m2 en donde incluye bvedas, tienda, videoclub y biblioteca. DPLybf','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (124,'Universidad Nacional Autnoma de Mxico',NULL,'Escuela Nacional de Estudios Superiores. Unidad Len, Gto.',NULL,'                                                                                                                                                      ','0','http://enes.unam.mx/?lang=es_MX','Gaceta 5 septiembre 2011. ENES ocupa el predio del saucillo y el potrero, con una superficie de 10795m2. DPLybf','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (9,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Nanociencias y Nanotecnologa. Ensenada, B. C.','CCMC','                                                                                                                                                      ','0','http://www.cnyn.unam.mx/','Gaceta 3 marzo 2014. Construccin de edificio C, Incluye aulas, laboratorios e investigacin, cmputo, sala de seminarios y biblioteca. DPLybf','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (16,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Energas Renovables. Temixco, Mor.','CIEN','                                                                                                                                                      ','0','http://xml.cie.unam.mx/xml/','CAMBIO DE DENOMINACION: Centro de Investigacin en Energia. Temixco, Mor. A Instituto de Energas Renovables. Publicado en Gaceta 4485. 28/enero/2013. DPLybf','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (83,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Investigaciones Biomdicas','IIBO','                                                                                                                                                      ','0','http://www.biomedicas.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (105,'Universidad Nacional Autnoma de Mxico',NULL,'Instituto de Investigaciones en Ecosistemas y Sustentabilidad. Campus Morelia, Mich.',NULL,'                                                                                                                                                      ','0','http://www.oikos.unam.mx/CIEco/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (99,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Investigaciones Multidisciplinarias sobre Chiapas y la Frontera Sur. San Cristbal de las Casas, Chis.','PIMM','                                                                                                                                                      ','0','http://proimmse.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (109,'Universidad Nacional Autnoma de Mxico','UNAM','Instituto de Radioastronoma y Astrofsica. Campus Morelia, Mich.','A2','                                                                                                                                                      ','0','http://www.crya.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (126,'Universidad Nacional Autnoma de Mxico',NULL,'Escuela Nacional de Estudios Superiores. Unidad Morelia, Mich.','ENESM',NULL,NULL,'http://www.enesmorelia.unam.mx/index.php',NULL,NULL,NULL,'u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (30,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Atencin a la Salud','DGSM','                                                                                                                                                      ','0','http://www.dgsm.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (49,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional de Trabajo Social','ENTS','                                                                                                                                                      ','0','http://www.trabajosocial.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (113,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General de Atencin a la Comunidad','SC','                                                                                                                                                      ','0','http://www.tucomunidad.unam.mx/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (14,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Investigaciones Interdisciplinarias en Ciencias y Humanidades','CEII','                                                                                                                                                      ','0','http://www.ceiich.unam.mx/0/index.php','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (20,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin General del Deporte Universitario','DGAD','                                                                                                                                                      ','0','http://www.deporte.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (112,'Universidad Nacional Autnoma de Mxico','UNAM','Direccin de Relaciones Laborales','DRL','                                                                                                                                                      ','0','http://web.dgp.unam.mx:9090/laborales/','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (97,'Universidad Nacional Autnoma de Mxico','UNAM','Centro de Investigaciones y Estudios de Gnero','PUEG','                                                                                                                                                      ','0','http://www.pueg.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (111,'Universidad Nacional Autnoma de Mxico','UNAM','Coordinacin de Difusin Cultural','DF','                                                                                                                                                      ','0','http://www.cultura.unam.mx/index.aspx','','','','');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (10,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional de Lenguas, Lingstica y Traduccin','CELE','                                                                                                                                                      ','0','http://comenius.cele.unam.mx/cele/','Cuenta con una sede fuera de CU desde 2011: CELE, Tlalpan. G. 5 diciembre 2011. DPLybf','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (33,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Colegio de Ciencias y Humanidades. Direccin General','CCHD','                                                                                                                                                      ','0','http://www.cch.unam.mx','La biblioteca se encuentra en las instalaciones del Centro de Formacin Docente del CCH desde el 9 de abril de 2012. Ubicado en Guty Crdenas. G. 19 abril 2012. DPLybf.','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (50,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Azcapozalco','CCHA','                                                                                                                                                      ','0','http://www.cchazc.unam.mx','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (51,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Naucalpan','CCHN','                                                                                                                                                      ','0','http://www.cch-naucalpan.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (52,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Oriente','CCHO','                                                                                                                                                      ','0','http://www.cch-oriente.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (53,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Sur','CCHS','                                                                                                                                                      ','0','http://www.cch-sur.unam.mx/','','','','u');
INSERT INTO "datosdepen" ("dep_id","nom_int","siglas_inst","nom_depen","siglas_depen","nom_subdepen","ano_fundacion","pag_web","observaciones","dep_obs","objetivo","semaforo") VALUES (54,'Universidad Nacional Autnoma de Mxico','UNAM','Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Vallejo','CCHV','                                                                                                                                                      ','0','http://www.cch-vallejo.unam.mx/','','','','u');
--
-- Data for TOC Entry ID 57 (OID 3235345)
--
-- Name: datosubdep Type: TABLE DATA Owner: israeld
--


INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (0,0,'','','1950','',NULL,NULL);
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (8,81,'Grupo de Estudios Sobre Innovacin Tecnologica','','1950','www.unam.mx',NULL,NULL);
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (34,70,'Divisin de Estudios de Posgrado','','1950','www.unam.mx',NULL,NULL);
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (5,23,'Biblioteca Central','DGBI','1956','http://bc.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (29,66,'Departamento de Medicina Familiar','','1993',' http://www.facmed.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (27,66,'Departamento de Salud Pblica','','1984',' http://www.facmed.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (31,66,'Divisin de Estudios de Posgrado e Investigacin','','1954','http://www.facmed.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (19,65,'Acervo Histrico','','1959','http://www.ingenieria.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (15,56,'Divisin de Estudios de Profesionales','','1950','http://www.fciencias.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (3,55,'Centro de Investigaciones de Diseo Industrial','','1984','http://ce-atl.posgrado.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (12,72,'','','1929','http://132.248.13.40/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (51,11,'Escuela de Extensin, Gatineau, Canad','','1950','http://www.unameseca.com/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (11,89,'Unidad de Documentacin de Legislacin y Jurisprudencia','','1950','http://info.juridicas.unam.mx/infjur/leg/direc.htm','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (9,60,'Divisin de Estudios de Posgrado','','1950','http://www.depfe.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (32,68,'Divisin de Estudios Profesionales','','1975','http://www.odonto.unam.mx/licenciatura/index.html','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (28,66,'Departamento de Psicologa Mdica, Psiquiatra y Salud Mental','','1950','http://www.facmed.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (30,66,'Departamento de Historia y Filosofia de la Medicina','','1954','http://www.facmed.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (16,65,'Estudios de Posgrado','','1959','http://www.ingenieria.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (43,31,'Centro de Extensin en Cmputo y Telecomunicaciones Coapa','','2001','http://www.coapa.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (17,65,'Divisin de Educacin Continua y a Distancia','DEC','1959','http://www.mineria.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (38,11,'Campus Taxco, Gro.','CEET','1992','http://www.cepetaxco.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (52,11,'Escuela Permanente de Extensin, San Antonio, Texas','','1950','http://www.usa.unam.edu/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (53,18,'Centro de  Alta Tecnologa de Educacin a Distancia, Tlaxcala. Tlax.','','1950','http://www.cated.cuaed.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (44,63,'Campo 2','','1950',' http://www.zaragoza.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (20,67,'Centro de Enseanza, Inv. y Ext.en Produccin Avcola','CEIEPA','1971',' http://www.fmvz.unam.mx/fmvz/centros/ceiepa/ceiepa.htm','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (23,67,'Centro de Enseanza, Inv. y Ext en Produccin Ovina, Huitzilac, Mor.','CEIEPO','1992','http://www.fmvz.unam.mx/fmvz/centros/ceiepo/ceiepo.htm','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (49,67,'Centro de Enseanza, Inv. y Ext. en Produccin Porcina, Jilotepec','CEIEPP','1969','http://www.fmvz.unam.mx/fmvz/centros/ceiepp/ceiepp.htm','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (35,70,'Divisin de Estudios Profesionales (Anexo)','','1965','http://www.fquim.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (36,70,'Divisin de Estudios de Posgrado (Anexo)','','1965','http://www.fquim.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (37,70,'Hemeroteca','','1965','http://www.fquim.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (47,74,'Unidad Acadmica Mazatln, Sin.','','1980','http://ola.icmyl.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (26,93,'Unidad Cuernavaca, Mor.','','1950','http://www.matcuer.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (25,93,'Campus Morelia, Mich.','','1990','http://www.matmor.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (39,69,'Divisin de Estudios Profesionales','','1973','http://www.psicol.unam.mx/Principal/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (10,61,'Campo 4','','1974','0','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (50,67,'Centro de Enseanza, Inv. y Ext. en Ganadera Tropical, Martnez de la Torre, Ver.','CEIEGT','1977','http://www.fmvz.unam.mx/fmvz/centros/ceiegt/ceiegt.html','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (18,65,'Divisin de Estudios Profesionales (Anexo)','','1959',' ','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (41,31,'Centro de Extensin Nuevo Len','','1992','http://www.nuevoleon.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (42,31,'Centro de Extensin Mascarones','','1995','http://hermes.mascarones.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (33,68,'Divisin de Estudios de Posgrado','','1975','http://www.odonto.unam.mx/posgrado/index.html','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (21,67,'Centro de Enseanza, Inv. y Ext.en Produccin Animal en Altiplano, Tequisquiapan, Qro.','CEIEPByC','1969',' http://www.fmvz.unam.mx/fmvz/centros/ceiepaa/acerca.html','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (6,23,'Subdireccin de Servicios de Informacin Especializada. Departamento de Informacin y Servicios Documentales','','1971','http://www.dgbiblio.unam.mx','*En 1971 fue creado como Centro de Informacin Cientfica y Humanstica (CICH) $*En 1997 pasa a formar parte de la Direccin General de Bibliotecas.$*10 de enero 2006 la Subdireccin de Servicios Especializados se denominar Subdireccin de Servicios de Informacin Especializada. DPLybf','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (7,58,'Divisin de Estudios de Posgrado','','1973','http://posgrado.fca.unam.mx','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (4,55,'Divisin de Estudios de Posgrado','','1990','http://ciepfa.posgrado.unam.mx/index_flash.html','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (40,69,'Divisin de Estudios de Posgrado','','1973','http://www.psicologia.unam.mx/pagina/es/238/division-de-investigaciony-posgrado','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (13,72,'Estacin de Biologa Tropical Los Tuxtlas, Veracruz','','1967','http://www.ibiologia.unam.mx/tuxtlas/tuxtlas.htm','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (14,72,'Estacin de Investigacin, Experimentacin y Difusin Chamela, Jalisco','','1971','http://www.ibiologia.unam.mx/ebchamela/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (46,74,'Estacin Ciudad del Carmen, Campeche','','1950','http://www.icmyl.unam.mx/?q=node/23','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (54,85,'Sede Oaxaca',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (45,80,'Estacin Regional del Noroeste, Hermosillo, Son.','ERNO','1974','http://www.geologia-son.unam.mx/','0','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (1,71,'Observatorio Astronmico Nacional San Pedro Mrtir. Ensenada, B. C.','OANS','1979','http://bufadora.astrosen.unam.mx/indexeda.html','0','Inaugurada 03.09.1988. Gaceta 3214');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (2,44,'Posgrado en Artes y Diseo','','1950','http://academiasancarlos.unam.mx/index.html','Cambio de denominacin de Divisin Estudios de Posgrado a POSGRADO EN ARTES Y DISEO. 30 marzo 2011. DPLybf','');
INSERT INTO "datosubdep" ("subdep_id","dep_id","nom_subdepen","subdepen_siglas","subdepen_ano_fundacion","subdepen_pag_web","observaciones","subdepen_obs") VALUES (48,74,'Unidad Acadmica Sistemas Arrecifales Puerto Morelos, Quintana Roo','','1950','http://www.icmyl.unam.mx/arrecifes/rsu.html','0','');
--
-- Data for TOC Entry ID 58 (OID 3235353)
--
-- Name: datosbiblio Type: TABLE DATA Owner: israeld
--


INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (5,'Biblioteca "Juan Comas"','','','Investigacin en Humanidades                                                                        ','1973','1973 ','http://biblio.unam.mx:8250/','AN','','P06','','32202210152107','32202210152303','0','0.00','0','0.00','0.00','0.00','0','0','986.00','','',NULL,NULL,'','bib05.jpg','','','','','','Mbib05.jpg','http://jcomas.iia.unam.mx:8991','https://goo.gl/maps/h2NgUoCM9pR2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (146,'Biblioteca Conjunta de Ciencias de la Tierra','','','Investigacin Cientfica                                                                            ','1997','',' http://bcct.unam.mx/ ','CAT','','P1A','','31203110252105','31203110252301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','','',NULL,NULL,'','bib146.jpg','','','','','','Mbib146.jpg','http://132.248.182.16:8991','https://goo.gl/maps/5dwmWq2BygH2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (43,'Biblioteca "Guillermo Haro"','','','Bachillerato                                                                                        ','1972','','http://www.cch-oriente.unam.mx/','CYHE','','P4A','','21204720552101','21204720552307','0','0.00','0','0.00','0.00','0.00','0','0','1871.00','','',NULL,NULL,'','bib43.jpg','','','','','','Mbib43.jpg','http://biblioteca.cch-oriente.unam.mx:8991','https://goo.gl/maps/CAxK9Hs1twS2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (16,'Biblioteca "C.P.Wilfrido Castillo Miranda"','','','Licenciatura y Posgrado                                                                             ','1997','',' http://biblio.contad.unam.mx/ ','C1','','PF1','','11204130252102','11204130252308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1946.00','','',NULL,NULL,'','bib16.jpg','','','','','','Mbib16.jpg','http://alephfca.fca.unam.mx:8991','https://goo.gl/maps/iqurukJR83p','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (3,'Biblioteca. Observatorio Astronmico Nacional ','','','Investigacin Cientfica                                                                            ','1980','',' http://bufadora.astrosen.unam.mx/~bibens/biblioteca.html ','A1','','P03','','31203120252102','31203120252308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','282.00','','',NULL,NULL,'','bib03.jpg','','','','','','Mbib03.jpg','http://microens.astrosen.unam.mx:8991','https://goo.gl/maps/z4Ki7NHZ6Ut','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (46,'Biblioteca "Javier Elola Fernndez"','','','Investigacin en Humanidades                                                                        ','1940','','http://www.juridicas.unam.mx/infjur/leg/','DC1','','PF4','','','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','573.00','','',NULL,NULL,'','bib46.jpg','','','','','','Mbib46.jpg','SIN CATLOGOS','https://goo.gl/maps/JquSpveTpF42','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (78,'Biblioteca "Mtro. Sotero Prieto"','','','Investigacin Cientfica                                                                            ','1948','','http://biblioteca.matem.unam.mx/','GM','','P90','','31203190152104','31203190152300','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','645.00','','',NULL,NULL,'','bib78.jpg','','','','','','Mbib78.jpg','http://132.248.17.225:8991','https://goo.gl/maps/dYvNFUFGAr42','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (147,'Biblioteca "Solomon Lefschetz"','','','Investigacin Cientfica                                                                            ','1999','','http://132.248.41.35:8991/F','GM2','','','','31023190352100','31023190352306','0','0.00','0','0.00','0.00','0.00','0.00','0.00','114.00','','',NULL,NULL,'','bib147.jpg','','','','','','Mbib147.jpg','http://presli.matcuer.unam.mx:8991','https://goo.gl/maps/K6kTpj6HfHG2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (0,'',NULL,NULL,'                                                                                                    ','0',NULL,'','',NULL,'',NULL,NULL,NULL,'0.00',NULL,'0.00','0.00','0.00','0.00','0.00','0.00','0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1070,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1080,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1100,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1110,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1130,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1150,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1160,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1180,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1200,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1210,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (1220,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (149,'"Biblioteca Grupo de Estudios sobre Innovacin Tecnolgica"',NULL,NULL,'Licenciatura y Posgrado                                                                             ','1952',NULL,' http://www.unam.mx ','CIT',NULL,'P31',NULL,NULL,NULL,'0.00',NULL,'0.00','0.00','0.00','0.00','0.00','0.00','0.00',NULL,NULL,NULL,NULL,NULL,'bib149.jpg',NULL,NULL,NULL,NULL,NULL,'Mbib149.jpg',NULL,NULL,'NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (119,'Biblioteca "Simn Bolvar"','','','Extensin y Administracin Universitaria                                                            ','1926','La biblioteca del Centro de Enseanza para Extranjeros (CEPE) inici sus actividades en el ao de 1926, en el edificio conocido con el nombre de Mascarones, ubicado en la calle de Ribera de San Cosme, nm. 71, sede, en ese entonces, de la Escuela de Verano, hoy CEPE. En el Catlogo de la Universidad Nacional de Mxico, 1926-1927, se sealaba que la biblioteca contaba con un acervo de 1000 volmenes. $En el folleto de propaganda de la Escuela de Verano, del ao 1929, se mencionaba que: Los alumnos de la Escuela de Verano pueden hacer uso, sin costo alguno, de los libros que forman la biblioteca de la Escuela de Verano.... La biblioteca ha sido partcipe de los cambios de sede de la escuela antes mencionada. En 1955 comparti espacio con la biblioteca de la Facultad de Filosofa y Letras y, en 1978, se le dota de las instalaciones que hasta la fecha ocupa.$$Texto elaborado por Rebeca Garca.','http://www.cepe.unam.mx/biblioteca.php','N','','PB8','','43206130152106','43206130152302','0','0.00','0','0.00','0.00','0.00','0','0','157.00','','',NULL,NULL,'','bib119.jpg','','','','','','Mbib119.jpg','http://biblioteca.cepe.unam.mx:8991','https://goo.gl/maps/V3ZGMwzon7x','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (28,'Biblioteca. Direccin General de Artes Visuales','','','Extensin y Administracin Universitaria                                                            ','1980','La Biblioteca se inici en 1980 como centro documental del Centro de Investigacin y Servicios Museolgicos (CISM), adscrito al Departamento de Museos y Galeras de la Coordinacin de Humanidades, cambiando posteriormente su adscripcin a la Coordinacin de Extensin Universitaria.$Uno de sus fondos ms importantes est formado por los catlogos de exposiciones realizadas en el MUCA y en la Galera Universitaria Aristos.$Informacin proporcionada por: Lic. Patricia de la Fuente Merino.','http://muac.unam.mx/biblioteca.php','CIM','','P30','','41026210152101','41016210152304','0','0.00','0','0.00','0.00','0.00','0.00','0.00','109.00','','',NULL,NULL,'','bib28.jpg','','','','','','Mbib28.jpg','http://biblio192.dgbiblio.unam.mx:8994','https://goo.gl/maps/UT93YxfjPUS2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (123,'Biblioteca "Manuel Sandoval Vallarta"','','','Extensin y Administracin Universitaria                                                            ','1992','La biblioteca Manuel Sandoval Vallarta  anteriormente perteneca al  Consejo Nacional para la Ciencia y la Tecnologa (CONACYT),  que al dejar las instalaciones en el Ciudad Universitaria,  deja una  coleccin  de  aproximadamente  9, 000  ejemplares, que sumados a los  5, 000 ejemplares del  Centro Universitario de Comunicacin de la Ciencia, hoy DGDC,  conforman la base para integrar una coleccin documental  no solo en la divulgacin de las ciencias sino en otras reas afines.Para dar cumplimiento a los objetivos de difusin y divulgacin de la ciencia, as como el apoyo a la docencia e investigacin y extensin de la cultura, la biblioteca,  el 12 de diciembre de 1992, fecha en la que el Museo de las Ciencias UNIVERSUM, es inaugurado por el Dr. Jos Sarukhn Kermez,  inicia el desarrollo de una coleccin especializada en la divulgacin de la ciencia, con la cual ofrece a los usuarios una gama de recursos documentales.La constante actualizacin  de su  coleccin  monogrfica,  la facilidad de acceso directo a sus colecciones,  con  ms  de 18, 000 ejemplares, de donde  se destaca la coleccin infantil, nica en su gnero en el Sistema Bibliotecario de la UNAM. Adicionalmente la coleccin de 1, 500  materiales videogrficos entre los que encontramos formatos VHS y  DVD  interactivos. Su coleccin de publicaciones peridicas, ofrece las ltimas novedades en el campo de la divulgacin y enseanza de la ciencia y la tecnologa, con 75  ttulos adquiridos por compra y donacin. Como complemento a toda sta  riqueza documental,  existen otras colecciones especiales como INEGI, Tesis en el rea de  divulgacin, Mapas en Ciencias de la Tierra y Astronoma  y Libros antiguos, con todos ellos se atiende a la comunidad de la DGDC y al pblico que asiste al museo,  sumando ms de 100, 000 usuarios desde  su apertura. Sus confortables instalaciones las cuales para beneplcito de sus usuarios,  en agosto de 2007,  despus de 15 aos de servicio se remodelan  adecuando espacios y mobiliario acorde  al tipo de servicios y usuarios.La automatizacin de su control de prstamo y de  registro de usuarios, el acceso en la recuperacin de sus colecciones mediante los catlogos automatizados, y las distintas bases de datos, auspiciadas por la DGB,  entre las que destacan la de videos y temtica, sus servicios de documentacin y los recursos electrnicos, sumados  al  equipo de trabajo de su personal administrativo y profesional,  ofrecen una atencin  personalizada en busca de satisfacer las necesidades de informacin de los usuarios. Logrando hacer de la biblioteca una de las primeras a nivel nacional en el rea de divulgacin y la enseanza de la ciencia y la tecnologa. Texto enviado por  Mtro. Ral Ortega','http://biblioteca.universum.unam.mx/  ','PCC','','PBC','','44016410152103','44016410152309','159939.00','0.00','0','0.00','0','0.00','0','0','998.00','','',NULL,NULL,'','bib123.jpg','','','','','','Mbib123.jpg','http://perseo.universum.unam.mx:8991','https://goo.gl/maps/AZU8NZtbieD2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (159,'Biblioteca. Escuela Nacional de Estudios Superiores. Unidad Len, Gto.','','','Licenciatura y Posgrado                                                                             ','2011','0','http://enes.unam.mx/?lang=es_MX',NULL,'ENESL','ENESL','','','','','','','','','','','','1635.00','','',NULL,NULL,'0','bib159.jpg','','','','0','0','Mbib159.jpg','http://biblioteca.enes.unam.mx:8991','https://goo.gl/maps/hUaNY8ehj2C2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (162,'Biblioteca. Escuela Nacional de Estudios Superiores. Unidad Morelia, Mich.','','','Licenciatura y Posgrado                                                                             ','2013','','http://www.enesmorelia.unam.mx/index.php/vida-universitaria/biblioteca/',NULL,'ENESM','ENESM','','','','','','','','','','','','819.00','Biblioteca ingresada en el directorio en 19 noviembre de 2015. DPLybf','',NULL,NULL,'','bib162.jpg','','','','','',NULL,'http://biblioteca.enesmorelia.unam.mx:8991','https://goo.gl/maps/C74mGXQ6f5q','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (70,'Biblioteca. Centro de Enseanza, Inv. y Ext. en Produccin Porcina','','','Licenciatura y Posgrado                                                                             ','1996','','http://www.fmvz.unam.mx/fmvz/centros/ceiepp/acerca.html','GEP','','P8C','','10014190552101','10014190552307','0','0.00','0','0.00','0.00','0.00','0.00','0.00','11.00','','',NULL,NULL,'','bib70.jpg','','','','','','Mbib70.jpg','http://bibliodigital.fmvz.unam.mx:8991','https://goo.gl/maps/EYqbLu1gyom','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (2,'Biblioteca "Guillermo Haro"','','','Investigacin Cientfica                                                                            ','1967','Sus colecciones se encuentran sistematizadas y automatizadas en diferentes mdulos de Automated Library Expandable Program (Aleph).$La coleccin hemerogrfica est constituida por revistas, boletines, reportes, anuarios nacionales y extranjeros algunas de estas revistas datan del siglo XIX, colecciones que se siguen adquiriendo como es el caso de: Astrophysical Journal 1895- , Monthly Notices of the Royal Astronomical Society, 1886- , Publications of the Astronomical Society of the Pacific, 1890- entre otras, 1266 microfichas que corresponden a 4 ttulos de revistas, 1979 cartas del cielo y una coleccin especial de 385 libros antiguos del siglo XIX.$Informacin proporcionada por: Lic. Vernica Mata Acosta.','http://www.astroscu.unam.mx/IA/index.php?option=com_content&view=article&id=21&Itemid=46&lang=es','A','','P02','','31203120152105','31203120152301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','375.00','','',NULL,NULL,'','bib02.jpg','','','','','','Mbib02.jpg','http://132.248.230.114:8991','https://goo.gl/maps/vozXFrjtHCK2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (72,'Biblioteca. Instituto de Ciencias Fsicas','','','Investigacin Cientfica                                                                            ','1987','','http://www.fis.unam.mx/biblioteca.php','GF1','','PDE','','31023110752102 $31033110752105 $31043110752108','31203110752306','0','0','0','0.00','0','0.00','0','0','206.00','','',NULL,NULL,'','bib72.jpg','','','','','','Mbib72.jpg','http://leona.fis.unam.mx:8991','https://goo.gl/maps/Rxy1ZfVYPiF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (120,'Biblioteca "Marcos Rosenbaum"','','','Investigacin Cientfica                                                                            ','1969','1969 ','http://sigi.nucleares.unam.mx/uib/site/index','NC','','P01','','31203270152103','31203270152309','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','776.00','','',NULL,NULL,'','bib120.jpg','','','','','','Mbib120.jpg','http://xochitl.nucleares.unam.mx:8991','https://goo.gl/maps/yFL39FwGeDo','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (13,'"Biblioteca Conjunta de Ciencias de la Tierra"','','','Investigacin Cientfica                                                                            ','1997','La Biblioteca Conjunta de Ciencias de la Tierra (BCCT) se encuentra conformada por los recursos documentales, humanos, econmicos y materiales de cinco dependencias de investigacin, las cuales son los Institutos de Geologa, Geofsica y Ciencias del Mar y Limnologa, as como los Centros de Ciencias de la Atmsfera y Geociencias (en Juriquilla, Qro.). contando con bibliotecas en las Unidades Acadmicas de Hermosillo, Son., Mazatln, Sin., El Carmen, Camp. y Puerto Morelos, Q. Roo, ofreciendo servicios adems a los buques universitarios Justo Sierra y PUMA.$La BCCT fue inaugurada oficialmente en diciembre de 2005. Desde sus inicios unific fsicamente sus colecciones en Ciudad Universitaria en un solo local y desarrollando y fortaleciendo las propias en las unidades acadmicas en provincia, las cuales forman parte activa de la BCCT pero trabajando bajo la estructura organizacional de la unidad a la que pertenecen y explotando los servicios electrnicos generados por la Biblioteca Conjunta en CU y los creados exprofeso para los acadmicos que en ellas laboran.$La coordinacin general de la BCCT se encuentra en el Campus Universitario y cada biblioteca de las Unidades Acadmicas cuenta con un jefe o responsable de la misma, siendo autnomas en la prestacin de los servicios y reglamentacin, realizando el desarrollo de sus colecciones con el apoyo directo de la biblioteca principal en Ciudad Universitaria, que permite evitar la duplicidad de materiales.$El Campus Universitario en la Ciudad de Mxico ha sido su sede original desde la fecha de su creacin, contando con tres remodelaciones a lo largo de los ltimos diez aos, para la creacin de la mapoteca y de oficinas.$Informacin proporcionada por: Lic. Sal Armendriz Snchez.',' http://bcct.unam.mx ','BCCT','','','','','','0.00','0.00','0.00','0.00','0','0.00','0','0','1859.00','','',NULL,NULL,'','bib13.jpg','','','','','','Mbib13.jpg','http://132.248.182.16:8991','https://goo.gl/maps/5dwmWq2BygH2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (155,'"Biblioteca del Campus Juriquilla"','','','Investigacin Cientfica                                                                            ','2007','El Campus Juriquilla, Quertaro data de 1996 y es resultado de un proyecto para contribuir a la descentralizacin de las actividades de investigacin cientfica, de educacin superior, desarrollo tecnolgico y formacin de recursos humanos en la Regin del Bajo.$Debido al crecimiento de las actuales  dependencias del Campus: Centro de Fsica Aplicada y Tecnologa Avanzada (CFATA), Centro de Geociencias (CGEO), Instituto de Neurobiologa (INB), la Unidad de Neurodesarrollo y de Resonancia Magntica y la Coordinacin de Servicios Administrativos (COSJ), el Consejo de Direccin del Campus consider que las entonces tres ex Bibliotecas pertenecientes a las dependencias de investigacin antes mencionadas, y que presentaban una saturacin en sus espacios, se integraran al proyecto del Centro Acadmico y Cultural (CAC), lo que dio por resultado la  fusin de las colecciones y el personal de las mismas en un nico espacio, buscando optimizar sus recursos.$El 24 de Noviembre del 2006 se inaugur la Biblioteca del Campus Juriquilla, la cual forma parte del  CAC, conformado por diversos espacios de uso comn como el Teatro-Auditorio, la Unidad de Docencia y Seminarios, as como una Cafetera. El proyecto de diseo y construccin del CAC estuvo a cargo de la Direccin de Proyectos Especiales de la UNAM, y arranc en octubre del 2005 para finalizar en noviembre del 2006. La Biblioteca tiene una superficie total de 1,306.86 m2 de construccin.$Informacin proporcionada por: Pilar Galarza Barrios.','http://www.biblioteca.juriquilla.unam.mx/','BCJ',NULL,NULL,'','','','','','','','','','','','1478.00','','',NULL,NULL,'','bib155.jpg','','','','','',NULL,'http://132.248.248.1:8991','https://goo.gl/maps/mudgSTkd9NF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (30,'Biblioteca. Centro de Ciencias Aplicadas y Desarrollo Tecnolgico','','','Investigacin Cientfica                                                                            ','1971','En 1971 es fundada como Centro de Instrumentos (C.I.).$En 2002 cambia de nombre a Centro de Ciencias Aplicadas  y Desarrollo Tecnolgico (CCADET).$El Edificio donde se encuentra actualmente la Biblioteca fue construido en 1999 para tal fin, el cual cuenta con espacios adecuados y con servicios propios de una Biblioteca Especializada, la cual conforma el Sistema Bibliotecario de la UNAM, para cubrir de manera directa las necesidades de informacin de los usuarios.$Informacin proporcionada por: Lic. Mara Roco Bastida Garca.','http://www.ccadet.unam.mx/secciones/bibli/biblio.html','CK','','P32','','31013110552105 $31023110552108 $31033110552101','31023110552304, 31033110552307, 31043110552300','0','0.00','0','0.00','0','0.00','0','0','318.00','','',NULL,NULL,'','bib30.jpg','','','','','','Mbib30.jpg','http://biblio192.dgbiblio.unam.mx:8996','https://goo.gl/maps/FUArutv3GrG2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (24,' Biblioteca. Centro de Ciencias Genmicas','','','Investigacin Cientfica                                                                            ','1981','','http://www.ccg.unam.mx/es/biblioteca','CFN','','P24','','31203110352102','31203110352308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','144.00','La biblioteca del Centro de Ciencias Genmicas (CCG) e Instituto de Biotecnologia (IBT) funciona temporalmente en las instalaciones de la biblioteca del Instituto de Ciencias Fsicas (IFC) a partir de enero de 2013. Solo dispone de acervo de libros impresos, las revistas se encuentran en  bodega. 21mayo2013  DPLybf','',NULL,NULL,'','bib24.jpg','','','','','','Mbib24.jpg','http://biblioteca.ccg.unam.mx:8991','https://goo.gl/maps/s1Z2v65U92H2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (158,'Unidad de Documentacin','','','Investigacin Cientfica                                                                            ','1991','','http://www.matmor.unam.mx/documentacion/','GM1','','P35','','31023190252103','31023190252309','0','0.00','0','0.00','0','0.00','0.00','0','110.00','NUEVO NOMBRAMIENTO: Unidad de Documentacin. Comunicado 20 septiembre 2012. DPLybf','El IM en campus Morelia se transforma en Centro de Ciencias Matemticas por Acuerdo del Rector en septiembre de 2011. DPLybf',NULL,NULL,'','bib158.jpg','','','','','','Mbib158.jpg','http://alephmor.matmor.unam.mx:8995','https://goo.gl/maps/CgU2biBE2tp','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (121,'Biblioteca "Juan Ruz de Alarcn"','','','Extensin y Administracin Universitaria                                                            ','1992','','http://www.cepetaxco.unam.mx/biblioteca/','NT','','','','','43206130152302','0.00','0.00','0','0.00','0.00','0.00','0.00','0.00','69.00','','',NULL,NULL,'','bib121.jpg','','','','','','Mbib121.jpg','http://biblioteca.cepe.unam.mx:8991','https://goo.gl/maps/L2kpb5a188Q2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (150,'Biblioteca del Campus Juriquilla','','','Investigacin Cientfica                                                                            ','1999','','http://www.biblioteca.juriquilla.unam.mx/BCJ.htm','GF3',NULL,'GF3','','','','0','','0','0','0','0','0','0','0.00','','',NULL,NULL,'','bib150.jpg','','','','','','Mbib150.jpg','http://132.248.248.1:8991','https://goo.gl/maps/mudgSTkd9NF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (89,'Biblioteca del Campus Juriquilla','','','Investigacin Cientfica                                                                            ','1998','','http://www.geociencias.unam.mx/geociencias/infraestructura/biblioteca.html','I3','','P0C','','31023110352104','00000','0','0.00','0.00','0.00','0.00','0.00','0','0','0.00','','',NULL,NULL,'','bib89.jpg','','','','','','Mbib89.jpg','http://132.248.248.1:8991','https://goo.gl/maps/mudgSTkd9NF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (92,'Departamento de Informacin y Documentacin ','','','Investigacin en Humanidades                                                                        ','1986','El 20 de enero de 1986 se cre el Centro de Investigaciones Interdisciplinarias en Humanidades (CIIH) con la fusin de los recursos del Programa Universitario Justo Sierra y el Centro de Estudios sobre los Estados Unidos de Norteamrica, bajo esas condiciones se integr el acervo de la biblioteca. A partir del 28 de abril del 1995, por acuerdo del Consejo Universitario, se asign al CIICH la tarea de ampliar sus funciones enfocadas a las ciencias sociales y las humanidades, para incorporar de manera institucional a las dems disciplinas cientficas. Por esta razn desde entonces se denomina Centro de Investigaciones Interdisciplinarias en Ciencias y Humanidades (CEIICH). Desde su integracin las polticas para incrementar los acervos e implementar los servicios bibliotecarios del Departamento de Informacin y Documentacin se han diseado para apoyar el trabajo acadmico y los programas de investigacin que se llevan a cabo la comunidad de este Centro. El Departamento de Informacin y Documentacin tiene como objetivo fomentar el desarrollo de sus colecciones, preservarlas y difundirlas de acuerdo con las necesidades de los programas de investigacin que se llevan a cabo en el CEIICH, adems de facilitar, promover y actualizar los procesos y las tareas relacionadas con el apoyo a las actividades de investigacin del propio Centro.  Programas de investigacin: Estudios Interdisciplinarios de Ciencia y Tecnologa Ciencias Sociales y Literatura, Ciudades y Gestin en el Mundo Actual: Gobiernos, Sociedad, Territorio y Pluriculturalidad, El Mundo en el Siglo XXI, Epistemologa de las Ciencias y Sistemas de Informacin y Comunicacin, Investigacin Feminista, Procesos de Democratizacin, Produccin de Bienes y Servicios Bsicos, Historia de la Ciencia, Derecho y sociedad, Prevencin de Conflictos y Negociacin, Prospectiva Global: Estudios de Futuros. Texto enviado por Leonor Garca Urbano','http://biblio.unam.mx:8170/index.php/la-biblioteca','IIH','','PDA','','32022110352100','32022110352306','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','225.00','','',NULL,NULL,'','bib92.jpg','','','','','','Mbib92.jpg','http://ceiich.ceiich.unam.mx:8991','https://goo.gl/maps/1dNZqmrd6Zv','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (90,'Biblioteca "Paul Kirchhoff"','','','Investigacin en Humanidades                                                                        ','1985','1985 Inicio actividades como Centro de Investigaciones Humansticas de Mesoamrica y el Estado de Chiapas (CIHMECH)','http://proimmse.unam.mx/cbiblioteca/index.php','IHM','','PE4','','32022210252106','32022210252302','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','167.00','Cambio de edificio en marzo-abril 2013. DPLybf','Cambio de denominacin de Programa a Centro. Mayo 2015. DPLybf',NULL,NULL,'','bib90.jpg','','','','','','Mbib90.jpg','http://201.122.222.105:8991','https://goo.gl/maps/DDwjwbhaNHJ2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (58,'Biblioteca "Rosa Cusminsky Mogilner"','','','Investigacin en Humanidades                                                                        ','1989','','http://biblio.unam.mx:8180/ ','EUA','','PEF','','32022110752108 $32212110752109','32022110752304','0','0.00','0','0.00','0','0.00','0','0','230.00','','',NULL,NULL,'','bib58.jpg','','','','','','Mbib58.jpg','http://biblios.super.unam.mx:8991','https://goo.gl/maps/1dNZqmrd6Zv','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (21,'Biblioteca "Simn Bolvar"','','','Investigacin en Humanidades                                                                        ','1980','La Biblioteca ',' http://www.cialc.unam.mx/biblioteca.html ','CEL','','P21','','32202110552102','32202110552308','0','0.00','0','0.00','0.00','0.00','0','0','460.00','','',NULL,NULL,'','bib21.jpg','','','','','','Mbib21.jpg','http://bolivar.cialc.unam.mx:8991','https://goo.gl/maps/1dNZqmrd6Zv','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (125,'Biblioteca "Rosario Castellanos"','','','Investigacin en Humanidades                                                                        ','1992','En 1984, con la creacin del Centro de Estudios de la Mujer (CEM), de la Facultad de Psicologa de la UNAM, se conform una unidad de informacin y documentacin dedicada a recopilar y organizar la informacin documental sobre mujeres a nivel nacional. $El acervo documental del CEM, creci gradualmente, a travs de: donaciones, compras y canjes, llegando a formarse una valiosa y original coleccin documental especializada en los Estudios de y sobre las Mujeres.$Con la creacin del Programa Universitario de Estudios de Gnero (PUEG) en 1992, el Centro de Informacin adquiri una mayor importancia, conformando a lo largo de los aos de vida de sta institucin, el acervo bibliogrfico y documental especializado en gnero ms importante en la Universidad y a nivel nacional. Adems, ha desarrollado una serie de servicios de informacin para atender la demanda estudiantil, as como la de investigacin y docencia que se realiza en la perspectiva de gnero.  $Tiempo despus, surgi la necesidad de dar un nombre a este centro de informacin. El nombre elegido fue: Biblioteca ','http://www.pueg.unam.mx/index.php/biblioteca','PEG','','P15','','45022110952108','45022110952304','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','89.00','','El PUEG se traslada  al 7o. piso de la Torre II de Humanidades en 1998. DPLybf',NULL,NULL,'','bib125.jpg','','','','','','Mbib125.jpg','http://biblioteca.pueg.unam.mx:8991','https://goo.gl/maps/1dNZqmrd6Zv','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (73,'Biblioteca. Centro de Nanociencias y Nanotecnologa','','','Investigacin Cientfica                                                                            ','1983','','http://www.cnyn.unam.mx/biblio/index.html','GF2','','PE1','','31023110652105','31023110652301','0','0.00','0','0.00','0.00','0.00','0.00','0.00','569.00','Cambio de edificio en febrero-marzo 2014. DPLybf','',NULL,NULL,'','bib73.jpg','','','','','','Mbib73.jpg','http://gigante.cnyn.unam.mx:8991','https://goo.gl/maps/ewECnjBPkHN2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (154,'Biblioteca. Centro Peninsular en Humanidades y Ciencias Sociales','','','Investigacin en Humanidades                                                                        ','2004','La biblioteca fue creada en julio de 2004, slo un mes despus de que la Unidad Acadmica de Ciencias Sociales y Humanidades, antecedente del CEPHCIS, se instalara en el edificio histrico que actualmente ocupa, el Ex - Sanatorio Rendn Peniche (estilo Neomaya, 1919). En un principio la biblioteca ocup el pabelln oeste mientras era restaurado y acondicionado el resto del inmueble. En junio de 2005, ya reconstruido la totalidad del edificio, la biblioteca se instala en el pabelln este, donde actualmente se encuentra.$El llamado fondo de origen de la biblioteca se constituy con los donativos que hicieron de sus publicaciones los institutos, centros y programas que conforman la Coordinacin de Humanidades, cerca de 1,200 volmenes de libros y 800 fascculos de revistas; en julio de 2006 se inicia la compra de libros y para el ao de 2007 se tramitan las primeras suscripciones a 16 ttulos de revistas impresas. En febrero de 2007 el Centro hace una importante adquisicin bibliogrfica al comprar la biblioteca particular del abogado Rodolfo Ruz Menndez, compuesta de libros, revistas, folletos y manuscritos, de los que sobresalen documentos relativos la historia de Yucatn, lengua maya, henequn, educacin, literatura, leyes, decretos y, textos escritos por autores yucatecos o autores forneos que escribieron sobre los estados que actualmente conforman la Pennsula de Yucatn; esta coleccin conforma el llamado Fondo Ruz Menndez.$Informacin proporcionada por: Lic. Ral Novelo Pea.','http://www.cephcis.unam.mx/index.php/biblioteca/','UCSY',NULL,'P18','','','','0','','0','0','0','0','0','0','365.00','','',NULL,NULL,'','bib154.jpg','','','','','','Mbib154.jpg','http://catalogo.cephcis.unam.mx:8991','https://goo.gl/maps/5JzbZhnLv5N2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (94,' Biblioteca "Dr. Francisco Lpez Cmara"','','','Investigacin en Humanidades                                                                        ','1985','1985 ','http://www.crim.unam.mx/drupal/?q=node/171','ISC','','PDB','','32022110652101','32022110652307','0','0.00','0','0.00','0.00','0.00','0.00','0.00','157.00','NOMBRAMIENTO DE LA BIBLIOTECA: Maestro Francisco Lpez Cmara. Comunicado 25 enero 2013. DPLybf','cambio septiembre 2013 de maestro a doctor a peticin de la responsable',NULL,NULL,'','bib94.jpg','','','','','','Mbib94.jpg','http://132.248.35.100:8991','https://goo.gl/maps/qJAEokH246R2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (48,'Biblioteca. Centro Universitario de Estudios Cinematogrficos','','','Extensin y Administracin Universitaria                                                            ','1963','OBJETIVOS$*  Apoyar los programas y proyectos docentes del CUEC, proporcionando el material adecuado y requerido por cada una de las reas acadmicas.$*  Seleccionar,  adquirir por compra, donacin o canje las obras bibliogrficas, videogrficas y hemerogrficas para su consulta,  y de cualquier otro material siempre y cuando est relacionado con el rea de la cinematografa, de acuerdo con los programas y proyectos de la docencia e investigacin del Centro Universitario de Estudios Cinematogrficos.$*  Organizar y preservar este acervo a fin de que permanezca en ptimas condiciones para su consulta.$*  Tomar las medidas pertinentes para  una mejor conservacin de mobiliario y  equipo de la biblioteca.$La biblioteca fue creada en 1974 y formalizada como tal a mediados de 1975.$Informacin proporcionada por: Gregoria Bustamante Rojas.','http://www.cuec.unam.mx/','DF3','','P66','','43206140152103','43206140152309','0','0.00','0','0.00','0.00','0.00','0','0','169.00','30.00 antes de 2013','',NULL,NULL,'','bib48.jpg','','','','','','Mbib48.jpg','http://biblioteca.cuec.unam.mx:8991','https://goo.gl/maps/zvUWFx8tDeu','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (38,'Biblioteca "Hctor Mendoza"','','','Extensin y Administracin Universitaria                                                            ','1994','En marzo del ao de 1994 se contaban con 500 ttulos aun sin ser registrados en Direccin General de Bibliotecas, para el mes de septiembre del mismo ao, se inaugura oficialmente la biblioteca con nombre de Hctor Mendoza contando con estantera cerrada. En este mismo ao se logra la adquisicin de material bibliogrfico y se inicia la captura de publicaciones peridicas, VHS, libretos y CDs.$Con el aumento del acervo se contempl un nuevo espacio a la biblioteca en el nuevo edificio (anexo) que fue inaugurado en marzo del 2005. Adems de aumentar al servicio una nueva seccin de digital video disc (DVD).$En el ao 2006 se instalan los servicios de Internet, Librunam y computo para el servicio de profesores y alumnos.$En el  mes de Junio del 2007 se instal el nuevo equipo de cmputo donado por DGB, y el uso de los programas  de Circula y Mantale para la administracin de los bienes de la biblioteca.$Informacin proporcionada por: Margarita Chvez Martn del Campo.','http://www.cut.unam.mx/  ','CUT','','','','43026150152102','','57065.00','0.00','0.00','0.00','0.00','0.00','0.00','8781.00','36.00','','',NULL,NULL,'','bib38.jpg','','','','','','Mbib38.jpg','http://biblio192.dgbiblio.unam.mx:8992','https://goo.gl/maps/XX9s4qg79U32','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (49,'Centro de Informacin. Coordinacin de Estudios de Posgrado','','','Extensin y Administracin Universitaria                                                            ','1992','',' http://www.posgrado.unam.mx/','CGP','','P6B','','11015130152100','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','76.00','','La  Unidad de Posgrado cambia de denominacin a Direccin General de Estudios de Posgrado, gaceta 6 feb. 1997. DPLybf',NULL,NULL,'','bib49.jpg','','','','','','Mbib49.jpg','http://biblio192.dgbiblio.unam.mx:8998','https://goo.gl/maps/WpTJ6cvjUVt','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (136,'Centro de Documentacin','','','Extensin y Administracin Universitaria                                                            ','0','En 1997 el Centro de Documentacin adquiere mayor importancia y gracias a la remodelacin de las instalaciones, el acervo bibliogrfico se traslad a las instalaciones actuales en 1998, lo que ha facilitado el crecimiento y diversificacin de la coleccin bibliogrfica.$En septiembre de 2000 se firma el Acta Constitutiva del Comit del Centro de Documentacin de la CUAED (denominado Comisin de Biblioteca) y se procede a designar a los miembros que lo integran, quienes asumen, entre sus funciones, la de sugerir las polticas de desarrollo y crecimiento del acervo, as como la definicin del Reglamento de dicho Centro.$Actualmente el Centro de Documentacin cuenta con la informacin automatizada de todo su acervo bibliogrfico especializado en temas afines a la educacin abierta, continua, a distancia y nuevas tecnologas.  El material se encuentra en idioma espaol e ingls.$Informacin proporcionada por: Lic. Mara Guadalupe Rojo Czares.','http://biblioteca.cuaed.unam.mx/','UA','','','','15014810152103 $43024810252108','00000','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','35.00','Ampliacin y remodelacin de la biblioteca  del 2 de marzo a 16 de agosto. Reapertura el 17 de agosto 2015. DPLybf.','',NULL,NULL,'','bib136.jpg','','','','','','Mbib136.jpg','http://biblio.cuaed.unam.mx:8991','https://goo.gl/maps/cp59StG3yGt','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (153,'Biblioteca. Centro de Alta Tecnologa de Educacin a Distancia','','','Extensin y Administracin Universitaria                                                            ','2004','','http://biblioteca.cuaed.unam.mx/localizacion.html','UA1',NULL,'UA1','','','','0','','0','0','0','0','0','0','117.00','','',NULL,NULL,'','bib153.jpg','','','','','','Mbib153.jpg','http://catedaleph500.cuaed.unam.mx:8991','https://goo.gl/maps/sAACEd6KGdL2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (64,'Biblioteca. Direccin General de Actividades Cinematogrficas','','','Extensin y Administracin Universitaria                                                            ','1981','','http://www.filmoteca.unam.mx/pages/servicios/centro-de-documentacion','FU','','P86','','41206230152103','41206230152309','0','0.00','0','0.00','0.00','0.00','0','0','429.00','','',NULL,NULL,'','bib64.jpg','','','','','','Mbib64.jpg','http://dgb1.dgac.unam.mx:8991','https://goo.gl/maps/HSF95Fr6DL72','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (50,'Biblioteca "Dr. Lzaro Benavides Vzquez"','','','Extensin y Administracin Universitaria                                                            ','1975','','http://www.dgsm.unam.mx/biblioteca.html','DM','','P6E','','18205630152108','18205630152304','0','0.00','0','0.00','0.00','0.00','0','0.00','43.00','','',NULL,NULL,'','bib50.jpg','','','','','','Mbib50.jpg','SIN CATLOGOS','https://goo.gl/maps/2QK5TiDeSQr','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (12,'"Biblioteca Central"','','','Extensin y Administracin Universitaria                                                            ','1956','El 5 de abril de 1956, la Biblioteca Central abri sus puertas y espacios a la comunidad de la Universidad Nacional Autnoma de Mxico (UNAM). El edificio que alberga la Biblioteca Central tuvo como propsito original servir de sede a la Biblioteca y Hemeroteca Nacionales. Contaba con un acervo de 80,000 volmenes: 20,000 adquiridos ex profeso para ella, 60,000 provenientes del Departamento Tcnico de Bibliotecas.$La primera remodelacin (1981-1983) tuvo como objetivo: la interaccin de los usuarios con las colecciones. Los principales fueron: redistribucin del acervo y servicios a los usuarios en el edificio; el acceso de los usuarios a las colecciones y nuevo horario de servicio.$La automatizacin de los servicios (1986).$En el ao 2000 se realiza una segunda remodelacin y distribucin del acervo en la Biblioteca, se ampla el horario de servicio de 8:30 hrs. a 21:30 hrs. y se crea la videoteca.$En el 2003 se remodela la Sala de Consulta y se ampla la seccin de recursos electrnicos de informacin con ms equipos y nueva rea de servicio en el entrepiso.$En el 2006, en el primer piso se acondiciona la sala modelo de acervos y videoteca; en el basamento se concluye la sala de videoconferencias y de educacin a distancia. Para el ao 2007, se genera un nuevo servicio en el jardn interior de la biblioteca denominado jardn ciberntico donde se  instalaron cinco mesas con conexiones elctricas y red inalmbrica.$Informacin proporcionada por: Lic. Gloria Adriana Hernndez Snchez.','http://bibliotecacentral.unam.mx/','BC','','P10','','18205640152105','18205640152301','0','0','0','0','0','0','0','0','10066.00','*De acuerdo a un anlisis a la estructura orgnica de la DGB, a partir de 15 febrero de 2002, la Subdireccin de  de Servicios bibliotecarios cambiar de denominacin a Subdireccin de Biblioteca Central. periodo directora Silvia Gonzlez Marin. DPLybf','',NULL,NULL,'','bib12.jpg','','','','','','Mbib12.jpg','http://informatica.dgbiblio.unam.mx:8991','https://goo.gl/maps/rtCcFRPoJVv','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (26,'Departamento de Informacin y Servicios Documentales','','','Extensin y Administracin Universitaria                                                            ','1971','Se crea en 1972, tiene sus orgenes con el Centro de Informacin Cientfica y Humanstica (CICH) como Departamento de Biblioteca. Cabe mencionar que a partir de 1997 el antes CICH pertenece a la Direccin General de Bibliotecas, cambiando a Unidad de Informacin Cientfica y Humanstica-DGB, despus se le nombr Subdireccin de Servicios Especializados-DGB; el 10 de enero de 2006  su nuevo nombre  es Subdireccin de Servicios de Informacin Especializada-DGB. Por otra parte el Depto. de Biblioteca a partir de 2002 cambia a Departamento de Informacin y Servicios Documentales perteneciente a dicha Subdireccin.$De 1972 a 1976 se ubico en las oficinas de la DGOSE, de noviembre de 1976 a la fecha ha permanecido en el rea de la investigacin cientfica sin cambios; con una ampliacin, en la planta baja (antes imprenta), para reacomodar la coleccin de ndices y abstracts.$Desde octubre 2005 se tiene el nuevo servicio de informacin especializada Inforvm para el sector externo en: http://inforum.unam.mx/$Informacin proporcionada por: Mtro. Federico Russell Turnbull Muoz.','http://bidi.unam.mx/web/dgbsite/serv_info_esp.htm ','CI','','P2A','','36205640152103','','0','0.00','0.00','0.00','0.00','0.00','0','0','296.00','','',NULL,NULL,'','bib26.jpg','','','','','','Mbib26.jpg','SIN CATLOGOS','https://goo.gl/maps/V8FNtjJcdA62','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (129,'Biblioteca. Direccin General de Cmputo y de Tecnologas de Informacin y Comunicacin','','','Extensin y Administracin Universitaria                                                            ','1985','1985 ','http://bibliotecas.tic.unam.mx/','PUC','','PC3','','18015220152108 $18025220152101 $36035220152102 ','','0','0.00','0.00','0.00','0.00','0.00','0','0','170.00','','LA biblioteca  DGSCA Coapa, inicia sus labores el 11 de junio de 2001, para 20.. se da de baja en el SIBIUNAM. DPL.',NULL,NULL,'','bib129.jpg','','','','','','Mbib129.jpg','http://132.248.168.125:8991','https://goo.gl/maps/BVrEWn5WuWF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (130,'Biblioteca. Centro de Extensin Nuevo Len','','','Extensin y Administracin Universitaria                                                            ','1992','La Biblioteca del Centro de Extensin en Cmputo y Telecomunicaciones Nuevo Len es una de las cuatro que forman el conjunto de bibliotecas de la Direccin General de Servicios de Cmputo Acadmico (DGSCA).$La Biblioteca en sus 59 m2 alberga una coleccin especializada en cmputo y telecomunicaciones seleccionada con un alto nivel de actualizacin para apoyar al Centro en la imparticin de cursos sobre ms de 200 tpicos diferentes organizados en 19 reas temticas, abarcando desde temas introductorios hasta avanzados.$Sus servicios estn dirigidos a docentes, alumnos de los cursos, personal de la DGSCA y pblico en general para satisfacer sus necesidades de informacin y documentacin.$Informacin proporcionada por: Lic. Xchitl Aguilar Gonzlez.','http://bibliotecas.tic.unam.mx/conocenos.html','PUC1','','P5D','','43055220152106','','72016.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','59.00','','',NULL,NULL,'','bib130.jpg','','','','','','Mbib130.jpg','http://132.248.168.125:8991','https://goo.gl/maps/pqTcWFc83372','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (131,'Biblioteca. Centro de Extensin Mascarones','','','Extensin y Administracin Universitaria                                                            ','1995','En noviembre de 1994 se crea el Centro Mascarones que es una extensin multidisciplinaria. A unos aos de su apertura se inician los preparativos para la biblioteca necesaria para la investigacin del Centro.$En 1995 se inician actividades la Biblioteca del Centro Mascarones. En este primer ao el acervo estuvo orientado a la temtica de la computacin.$En 1996 se incorpora una pequea coleccin del Centro de Enseanza de Lenguas Extranjeras (CELE), en calidad de resguardo, con el propsito de atender a los usuarios que asisten a los cursos de idiomas impartidos en esta sede.$En 1997 el catlogo en lnea est disponible en World Wide Web a travs del programa Aleph. Al igual que la biblioteca de la DGSCA incorporan las colecciones electrnicas en los aos 2002 y 2003.$La BCM es una biblioteca especializada en cmputo e idiomas, aunque el acervo de sta ltima especialidad es mnimo, pues la coleccin es provista por el CELE, institucin que se aloj ms recientemente en este centro, y el sostenimiento de la biblioteca corre a cargo de la DGSCA.$Informacin proporcionada por: Lic. Erndira Montiel Calzadilla.','http://bibliotecas.tic.unam.mx/conocenos.html','PUC2','','PF7','','43065220152109','','72016.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','66.00','','',NULL,NULL,'','bib131.jpg','','','','','','Mbib131.jpg','http://132.248.168.125:8991','https://goo.gl/maps/ixWecmpxw5S2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (109,'Biblioteca "Jorge Carpizo"','','','Extensin y Administracin Universitaria                                                            ','1981','','http://biblio192.dgbiblio.unam.mx:8999/F','LU','','PAE','','55027310152100 $55037310152103','55037310152309','0','0.00','0','0.00','0.00','0.00','0','0','106.00','','',NULL,NULL,'','bib109.jpg','','','','','','Mbib109.jpg','http://biblio192.dgbiblio.unam.mx:8999','https://goo.gl/maps/U8sK38eci9H2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (53,'Departamento de Acervo y Documentacin','','','Extensin y Administracin Universitaria                                                            ','1985','OBJETIVO$*  Ofrecer  alternativas de consulta a los productores de TV-UNAM para complementar sus contenidos en la realizacin de programas de televisin. De igual forma, ofrecer a la comunidad universitaria y al pblico en general los materiales bibliogrficos que se tienen, relacionados con los medios audiovisuales y las ciencias de la comunicacin.$HISTORIA$Anteriormente el acervo bibliogrfico se encontraba adscrito a la Subdireccin de Comunicacin, dentro del Departamento de Acervo y documentacin y se contaba con una pequea oficina en donde estaban agrupados los materiales. Desde el 2007, se encuentra adscrito a la Subdireccin de Programacin, e igualmente dentro del departamento de acervo y documentacin, contando con un rea exclusiva para su acomodo, resguardo y consulta.$Informacin proporcionada por: Enrique Dvila Diez.',' http://www.tvunam.unam.mx/ ','DTU','','PE3','','44016530152100','44026530152309','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','36.00','','',NULL,NULL,'','bib53.jpg','','','','','','Mbib53.jpg','SIN CATLOGOS','https://goo.gl/maps/Fa9Pod2PZKm','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (47,'Centro de Documentacin del Deporte y la Recreacin ','','','Extensin y Administracin Universitaria                                                            ','1978','','http://deporte.unam.mx/biblioteca/','DD','','P61','','43065620152101','43065620152307','0','0.00','0','0.00','0.00','0.00','0.00','0.00','120.00','','',NULL,NULL,'','bib47.jpg','','','','','','Mbib47.jpg','http://deportivas.dgadyr.unam.mx:8991','https://goo.gl/maps/mPRDmoQUyZw','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (19,'Biblioteca. Escuela Nacional Colegio de Ciencias y Humanidades. Direccin General','','','Bachillerato                                                                                        ','1972','Con la creacin del Colegio de Ciencias y Humanidades en 1971 nace la Biblioteca de la Direccin General del Colegio de Ciencias y Humanidades.$La biblioteca cuenta con un acervo dirigido a profesores, funcionarios y dems personal interesado en conocer el bachillerato de la UNAM, por lo que sus ttulos estn orientados, principalmente, a educacin y pedagoga. El acervo incluye el Centro de Documentacin Acadmica (CDA), que desde su creacin en febrero de 1979, est dedicado a organizar y resguardar los productos acadmicos elaborados por los profesores de carrera del Colegio.$Su primer sede estuvo en avenida Universidad 3000, en lo que era  la Unidad Acadmica del Ciclo del Bachillerato del Colegio de Ciencias y Humanidades (UACB), hoy Escuela Nacional Colegio de Ciencias y Humanidades.SAcadmicamente dependa de la Secretara General del Colegio, posteriormente a la Secretara Acadmica, y hoy da a la Secretara de Servicios de Apoyo al Aprendizaje; su funcin sustantiva es apoyar la educacin universitaria.$Informacin proporcionada por: Profa. Cristina Altamirano Velazco.',' http://www.cch.unam.mx/aprendizaje/bibliotecas','CCH','','P1D','','24014720152101 $24024720152104 $24034720152107','','0','0.00','0.00','0.00','0.00','0.00','0.00','0.00','53.00','Nueva ubicacin de la biblioteca a partir de 2014 en Av. Universidad 3000. DPLybf. Espacio antes de 2012 = 96, espacio a partir de 14 de enero de 2012= 164.$CAMBIO DE LUGAR :la biblioteca ocupa un espacio dentro del edificio de CCH ubicado en  Av. Universidad No. 3000, primer piso. DPLybf 10/2/15 con 52 m2','',NULL,NULL,'','bib19.jpg','','','','','','Mbib19.jpg','http://biblioteca.cch-sur.unam.mx:8991','https://goo.gl/maps/nekTfsDkwft','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (40,'Biblioteca. Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Azcapotzalco','','','Bachillerato                                                                                        ','1981','','http://www.cchazc.unam.mx/?page_id=166 ','CYHB','','P47','','21204720252100','21204720252306','0','0.00','0','0.00','0.00','0.00','0','0','2538.00','','',NULL,NULL,'','bib40.jpg','','','','','','Mbib40.jpg','http://biblioteca.cchazc.unam.mx:8991','https://goo.gl/maps/aFk4TJK5HRD2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (42,'Biblioteca. Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Sur','','','Bachillerato                                                                                        ','1972','','http://www.cch-sur.unam.mx/#','CYHD','','P49','','21014720652107 $21024720652100 $21034720652103','21204720652304','0','0.00','0','0.00','0.00','0.00','0','0.00','2780.00','','',NULL,NULL,'','bib42.jpg','','','','','','Mbib42.jpg','http://biblioteca.cch-sur.unam.mx:8991','https://goo.gl/maps/gxvWATZnEsA2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (41,'Biblioteca. Escuela Nacional Colegio de Ciencias y Humanidades. Plantel Vallejo','','','Bachillerato                                                                                        ','1971','','http://www.cch-vallejo.unam.mx/','CYHC','','P48','','21204720452104','21204720452300','0','0.00','0','0.00','0.00','0.00','0.00','0','2569.00','','',NULL,NULL,'','bib41.jpg','','','','','','Mbib41.jpg','http://biblioteca.cch-vallejo.unam.mx:8991','https://goo.gl/maps/ggUeyMGSRKw','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (148,'Biblioteca "Graciela Arroyo de Cordero"','','','Licenciatura y Posgrado                                                                             ','1952','1952 Misin: ','http://www.eneo.unam.mx/alumnos/biblioteca_enfermeria.php','HB','','P93','','10204340152105','10204340152301','0','0.00','0','0.00','0.00','0.00','0','0','1088.00','Gaceta 12 abril de 2004 se le asigna el nombre de Graciela Arroyo a la biblioteca. DPLybf','',NULL,NULL,'','bib148.jpg','','','','','','Mbib148.jpg','http://eneo-a500.eneo.unam.mx:8991','https://goo.gl/maps/szKHvWhThfN2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (135,'Centro de Informacin y Servicios Bibliotecarios','','','Licenciatura y Posgrado                                                                             ','1972','En 1972 la alumna Mara del Carmen Mendoza Rangel inici el trabajo de recoleccin y ordenamiento de materiales. En 1973 Jos Humberto Caballero Miranda, egresado de la carrera, asume la tarea de organizar el servicio de prstamo y en 1976 se le designa como primer Coordinador de Biblioteca.$La biblioteca inici con materiales nacionales y temas mdicos y jurdicos, los de la especialidad provenan del exterior. Con la licenciatura, pronto se enriqueci con otras reas del conocimiento.$En 1972 da servicio en un cubculo del Anexo de la Facultad de Derecho. De 1973 a 1980 funciona en el hoy edificio ','http://www.trabajosocial.unam.mx/dirs/biblioteca/biblioteca.html','TS','','PD2','','10014360152108 $10204360152109','10204360152305','0','0.00','0','0.00','0.00','0.00','0','0','984.00','','',NULL,NULL,'','bib135.jpg','','','','','','Mbib135.jpg','http://www.cisbents.unam.mx:8991','https://goo.gl/maps/veeUaFW3cRp','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (100,'Biblioteca "Mtro. Antonio Caso"','','','Bachillerato                                                                                        ','1979','Sus labores se inauguran el 03 de febrero de 1868, en el venerable y monumental edificio del antiguo colegio de San Ildefonso, por lo que ah es donde se forma la primera Biblioteca de la UNAM.$El 08 de diciembre de 1980, se inauguran las nuevas instalaciones de la Preparatoria N 1, campus Xochimilco.$En su coleccin, la biblioteca cuenta con materiales en diferentes formatos como CD, CD-ROOM, VHS, Diapositivas, Publicaciones peridicas, Cassetes, etc.$Informacin proporcionada por: Graciela Flores Pacheco.','http://biblio.unam.mx:8010','L1','','PA4','','21204520152107','21204520152303','0','0.00','0','0.00','0.00','0.00','0','0','2062.00','','',NULL,NULL,'','bib100.jpg','','','','','','Mbib100.jpg','http://biblio1.prepa1.unam.mx:8991','https://goo.gl/maps/y4YJsZVPZUJ2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (99,'Biblioteca. Escuela Nacional Preparatoria. Direccin General','','','Bachillerato                                                                                        ','1950','La biblioteca tiene sus inicios en la dcada de los aos 60`s en la calle de Justo Sierra 16 Col. Centro, posteriormente en los aos 80`s es trasladada a las instalaciones de Difusin Cultural de la DGENP, en la calle de San Ildefonso 30 Col. Centro. La siguiente  reubicacin tiene lugar en el ao 2001 a la planta baja del edificio donde actualmente se sita la DGENP Adolfo Prieto 722 Col. Del Valle delegacin Benito Jurez.$La biblioteca de la DGENP forma parte de 10 bibliotecas que conforman el subsistema bibliotecario de la Escuela Nacional Preparatoria y  tiene como objetivo fundamental ofrecer espacios para apoyar las actividades acadmicas y de difusin de la cultura de la comunidad preparatoriana.$Sus acervos se actualizan con base a lo requerido por los Planes y Programas de Estudio de la ENP, las necesidades reales de los miembros de la comunidad acadmica y las solicitudes que se generan en la Muestra Bibliogrfica y Videogrfica de la ENP.$La biblioteca cuenta con una sala de lectura con amplios espacios, luz y ventilacin natural, catlogos en lnea y estantera abierta, permitiendo as al lector una estada amena y confortable, el orden que predomina en la biblioteca facilita el poder identificar y localizar los materiales de manera fcil y rpida.$Informacin proporcionada por: C.D. Ral Roberto Marichi Rodrguez.','http://biblio.unam.mx:8100/','L','','PA3','','24204510152109','24204510152305','0.00','0.00','0.00','0.00','0.00','0.00','0','0.00','151.00','Remodelacin de la biblioteca en 2012. DPLybf','En diciembre de 1993 dio inicio a la construccin de las nuevas bibliotecas de los planteles 4, 7 y 9 cuyo trmino se tiene programado par diciembre 1994. Gaceta 7 julio 1994 DPLybf',NULL,NULL,'','bib99.jpg','','','','','','Mbib99.jpg','http://biblio192.dgbiblio.unam.mx:8993','https://goo.gl/maps/uNRiGcviM7K2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (103,'Biblioteca "Prof. Ral Martnez y Rosas"','','','Bachillerato                                                                                        ','1979','La biblioteca ha existido desde el ao de 1943. En la administracin del Lic. Ral Pons Ortiz (1951-1958) ocup el espacio llamado anexo, en las calles de Primo Verdad y Guatemala del centro histrico de la Ciudad de Mxico.$En 1978 la biblioteca  se traslada a sus actuales instalaciones, ocupando un espacio de 400 m2.$En 1982 se realiza la primera remodelacin que consisti en la construccin de un mezanine y la eliminacin  de salones donde se impartan clases, aumentando en un 25 por ciento su superficie.$Tuvo una segunda remodelacin en el ao 1990, que consisti en la eliminacin de muros, implementndose el  servicio de estantera abierta.$En 1992 se comienza la automatizacin del servicio de prstamo, por medio del  sistema circula.Es la primer biblioteca de las preparatorias en que se comienza a usar el cdigo de barras en las credenciales de los usuarios y el cdigo en los libros, haciendo ms rpido y efectivo el servicio.$La tercera remodelacin se da en el ao 2004, consistiendo en la construccin de un edificio de 500 m2, terminado en septiembre del 2005, posteriormente se hace la unin de los dos edificios, dichas obras fueron terminadas en julio del 2006. En la actualidad la biblioteca cuenta con una superficie total de 1100 m2.$La biblioteca fue inaugurada el 11 de agosto del 2006 por el Prof. Ral Martnez y Rosas, de quien la biblioteca lleva el nombre.$Informacin proporcionada por: Biol. Rosendo Daz Rojas','http://biblio.unam.mx:8030','L2','','PA7','','21204520252104','21204520252300','0','0.00','0','0.00','0.00','0.00','0','0.00','635.00','','',NULL,NULL,'','bib103.jpg','','','','','','Mbib103.jpg','http://biblio1.prepa2.unam.mx:8991','https://goo.gl/maps/6cQHRDDV8dt','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (104,'Biblioteca "Erasmo Castellanos Quinto"','','','Bachillerato                                                                                        ','1964','Erasmo Castellanos Quinto dispuso que su biblioteca pasara a servir a la Escuela Nacional Preparatoria ','http://biblio.unam.mx:8140/','L3','','PA8','','21204520352101','21204520352307','0','0.00','0','0.00','0.00','0.00','0','0','1858.00','','',NULL,NULL,'','bib104.jpg','','','','','','Mbib104.jpg','http://biblio1.prepa3.unam.mx:8991','https://goo.gl/maps/Zh4WNSkn9mR2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (105,'Biblioteca "Concepcin Glvez de Tovar"','','','Bachillerato                                                                                        ','1964','La Biblioteca tiene su origen en los ao 50`s  en las calles de Puente de Alvarado, lugar en donde se encontraba el edificio que albergaba las instalaciones del plantel en las cuales fue necesario improvisar una Biblioteca ya que no se contaba con un espacio. Se acondicion un pasillo del edificio cubrindolo con mamparas para depositar el acervo y as  proporcionar el servicio.$Inicialmente, la coleccin se obtuvo mediante donaciones de profesores y ex alumnos y con compras que se efectuaban a consideracin del encargado de la biblioteca.$En 1964 se trasladan las instalaciones de la preparatoria a la Avenida Observatorio # 170, conocida como preparatoria de Tacubaya. En las nuevas instalaciones se contaba  con un espacio destinado para la Biblioteca pero por el crecimiento de la poblacin estudiantil y las necesidades de sta, en 1994 se inicia la construccin del nuevo edificio donde se instalaran los laboratorios LASE y servira para la ampliacin de la Biblioteca, inaugurada en 1996.$De 1964 al 1994 el servicio es estantera cerrada. Al estrenarse las nuevas instalaciones se cambia a estantera abierta. Se cuenta con dos salas de proyecciones equipadas con sus respectivas caseteras y reproductores de DVD para 12 personas cada una, contando adems con 10 espacios individuales para proyectar el material, una sala de tareas con 20 computadoras que cuentan con el servicio de Internet y un tcnico para dar asesora a los usuarios. Asimismo existen 6 salas para trabajar en grupo.$Informacin proporcionada por: Rubn Hinojosa Martnez.','http://biblio.unam.mx:8040/','L4','','PA9','','21204520452108','21204520452304','0','0.00','0','0.00','0.00','0.00','0','0','1250.00','','',NULL,NULL,'','bib105.jpg','','','','','','Mbib105.jpg','http://biblio1.prepa4.unam.mx:8991','https://goo.gl/maps/hfdfEzrtZfK2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (106,'Biblioteca. Escuela Nacional Preparatoria. Plantel 5','','','Bachillerato                                                                                        ','1956','','http://biblio.unam.mx:8050','L5','','PAA','','21204520552105','21204520552301','0','0.00','0','0.00','0.00','0.00','0','0','1017.00','','',NULL,NULL,'','bib106.jpg','','','','','','Mbib106.jpg','http://biblio1.prepa5.unam.mx:8991','https://goo.gl/maps/ayoTtMDTAA92','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (107,'Biblioteca. Escuela Nacional Preparatoria. Plantel 6','','','Bachillerato                                                                                        ','1964','','http://biblio.unam.mx:8000','L6','','PAB','','21204520652102','21204520652308','0','0.00','0','0.00','0.00','0.00','0','0','667.00','','',NULL,NULL,'','bib107.jpg','','','','','','Mbib107.jpg','http://biblio1.prepa6.unam.mx:8991','https://goo.gl/maps/kLay2jzXs5z','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (108,'Biblioteca "Prof. Jos Castillo Farreras"','','','Bachillerato                                                                                        ','1964','','http://biblio.unam.mx:8060','L7','','PAC','','21204520752109','21204520752305','0','0.00','0','0.00','0.00','0.00','0','0','1276.00','El 14 de abril de 2005 se le asigna el nombre a la biblioteca ','',NULL,NULL,'','bib108.jpg','','','','','','Mbib108.jpg','http://biblio1.prepa7.unam.mx:8991','https://goo.gl/maps/fbWZ1LHPt9L2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (101,'Biblioteca "Ral Pous Ortz"','','','Bachillerato                                                                                        ','1965','','http://biblio.unam.mx:8080','L18','','PA5','','21204520852106','21204520852302','0','0.00','0','0.00','0.00','0.00','0','0','1050.00','','',NULL,NULL,'','bib101.jpg','','','','','','Mbib101.jpg','http://biblio1.prepa8.unam.mx:8991','https://goo.gl/maps/6JkBv6MVEtG2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (102,'Biblioteca "Benito Jurez Garca"','','','Bachillerato                                                                                        ','1965','El edificio actual data de junio de 1996. Fue inaugurada por el director  Hctor Hugo Figueroa Tapia. En ese entonces, la biblioteca fue diseada en cinco niveles con cubculos de estudio, una sala de cmputo para consulta a Internet y para realizar trabajos, as como amplias salas de lectura.$Sus acervos con coleccin general y coleccin de consulta.$Los catlogos computarizados permiten la consulta de manera automatizada. Al ser inaugurada la biblioteca se dejo el viejo sistema de prstamo Gaylor y Newark y posteriormente se adopt el sistema computarizado de prstamo Aleph 500. Asimismo se cambi a estantera abierta permitiendo el libre acceso a las colecciones a todos sus usuarios.$Informacin proporcionada por: Mario Rafael Ojeda Pia.','http://biblio.unam.mx:8090','L19','','PA6','','21204520952103','21204520952309','0','0.00','0','0.00','0.00','0.00','0','0','1309.00','','',NULL,NULL,'','bib102.jpg','','','','','','Mbib102.jpg','http://biblio1.prepa9.unam.mx:8991','https://goo.gl/maps/JP2Qo6GUNGK2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (10,'Biblioteca "Lino Picaseo"','','','Licenciatura y Posgrado                                                                             ','1784','','http://arquitectura.unam.mx/bibliotecas.html','BA','','P0B','','10204240152102','10204240152308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1187.00','','Biblioteca Lino Picaseo el  5 dic. al 15 feb. 2014. Gaceta 27 de febrero 2014. Superficie de 60.75 m2. Incremento de equipo y renovacin. Gaceta 8 de marzo 2012',NULL,NULL,'','bib10.jpg','','','','','','Mbib10.jpg','http://biblioarq.arq.unam.mx:8991','https://goo.gl/maps/86gbzBP16gP2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (11,'Biblioteca "Clara Porset Dumas"','','','Licenciatura y Posgrado                                                                             ','1984','','http://arquitectura.unam.mx/biblioteca-disentildeo-industrial.html','BAI','','P0E','','10204240452103','10204240452309','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','196.00','','',NULL,NULL,'','bib11.jpg','','','','','','Mbib11.jpg','http://biblioarq.arq.unam.mx:8991','https://goo.gl/maps/GdWtxF2w4gF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (32,'Biblioteca "Luis Unikel"','','','Licenciatura y Posgrado                                                                             ','1990','La biblioteca Luis Unikel fue creada en 1990 como una biblioteca multidisciplinaria del Posgrado, bajo la entonces administracin del Jefe de Estudios de Posgrado, arquitecto Ernesto Alva Martnez.$Junto con las bibliotecas Lino Picaseo y Clara Porset,  forma parte del Sistema Bibliotecario de la Facultad de Arquitectura.$Debe su nombre al ingeniero Luis Unikel, quien dentro de su amplia trayectoria acadmica imparti cursos en la entonces Escuela Nacional de Arquitectura; realiz diversas publicaciones en libros y revistas; ocup importantes cargos nacionales e internacionales; y obtuvo mltiples premios nacionales en economa.  Sin embargo, su mayor legado al pas son las aportaciones al proceso de urbanizacin en Mxico.$La biblioteca Luis Unikel de la Divisin de Estudios de Posgrado se readecu en el ao 2001-2002, bajo la administracin del Coordinador de Estudios del Posgrado arquitecto Juan Giral y Mazn.  Su acervo general est conformado principalmente por libros y revistas de arquitectura, urbanismo, vivienda, restauracin, arte e historia y tesis de maestra y doctorado.$Informacin proporcionada por: Mara de Lourdes Robleda Gonzlez de Castilla.','http://arquitectura.unam.mx/biblioteca-luis-unikel.html ','CMP1','','P36','','11204240252102','11204240252308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','304.00','','',NULL,NULL,'','bib32.jpg','','','','','','Mbib32.jpg','http://biblioarq.arq.unam.mx:8991','https://goo.gl/maps/7girZK2CXDt','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (8,'Centro de Documentacin "Prof. Jos Ma. Natividad Correa Toca"','','','Licenciatura y Posgrado                                                                             ','1979','','http://blogs.enap.unam.mx/centro_documentacion/','B','','P09','','10204320152101','10204320152307','0','0.00','0','0.00','0.00','0.00','0','0','664.00','','',NULL,NULL,'','bib08.jpg','','','','','','Mbib08.jpg','http://biblio.enap.unam.mx:8991','https://goo.gl/maps/cQ4fGmxDPrn','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (9,'Biblioteca. Facultad de Artes y Diseo. Posgrado en Artes y Diseo','','','Licenciatura y Posgrado                                                                             ','1974','1785 orgenes de la fundacin de la Biblioteca (Antigua Academia de San Carlos)','http://academiasancarlos.unam.mx/biblioteca.html','B1','','P0A','','11204320152104','11204320152300','0','0.00','0','0.00','0.00','0.00','0','0','286.00','REMODELACIN DE LA BIBLIOTECA 2007. CAMBIO DE LUGAR PLANTA BAJA','',NULL,NULL,'','bib09.jpg','','','','','','Mbib09.jpg','http://132.247.30.5:8991','https://goo.gl/maps/1CMHUKWqPCm','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (60,'Biblioteca "Ricardo Monges Lpez"','','','Licenciatura y Posgrado                                                                             ','1995','Los antecedentes de la actual Biblioteca Ricardo Monges Lpez se remontan al ao de 1954 en que fue inaugurada la Facultad de Ciencias, en las instalaciones de la entonces recin construida Ciudad Universitaria. En la Facultad se contaba ya con una pequea coleccin de 50 libros. An con estos pocos ejemplares se design un espacio que durante algunos aos constituy la primera biblioteca de la Facultad de Ciencias.  Naturalmente que este acervo se fue incrementando con el paso del tiempo, y con la creacin en 1967 de nuevos planes de estudio para las carreras de Actuara, Biologa, Fsica y Matemticas se impuls notablemente el crecimiento de la coleccin de libros; en ese momento el acervo alcanz los nueve mil ejemplares aproximadamente. Diez aos despus, en 1977, la Facultad de Ciencias se traslad a las instalaciones, que ocupa en la actualidad. En el diseo de estos edificios se consider el espacio dedicado a contener la biblioteca, que ya para entonces contaba con un acervo bibliogrfico de aproximadamente once mil ejemplares. Esta biblioteca fue pensada de manera que pudiera atender a las necesidades de un mayor nmero de usuarios, por lo que contaba ya con una sala de estudios, un rea que contena la coleccin general y una sala con ejemplares de consulta. Esta biblioteca tuvo como propsito principal ofrecer servicios a los estudiantes de las cuatro carreras que entonces se impartan en la facultad. El personal acadmico se organiz en tres departamentos: Biologa, Fsica y Matemticas, y cada uno de estos ha contado desde entonces con sus edificios independientes. Ante los requerimientos de informacin especficos de la planta acadmica de cada uno de los departamentos, se desarrollaron bibliotecas departamentales con materiales bibliogrficos de niveles de posgrado e investigacin. Paralelamente se fue conformando en cada una de stas un acervo hemerogrfico acorde a cada rea del conocimiento. En particular, la biblioteca del Departamento de Fsica recibi en donacin aproximadamente cinco mil libros que fueron propiedad del Dr. Alejandro Medina, distinguido miembro de ese departamento. Al fallecer el Dr. Medina, en un gesto de aprecio por la facultad, sus familiares tuvieron a bien realizar esta noble accin y en un acto de reconocimiento y reciprocidad, el departamento de Fsica nombr a su biblioteca como Biblioteca Alejandro Medina. De manera semejante la biblioteca departamental de Matemticas recibi el nombre del Dr. Guillermo Torres, quien fuera un excelente profesor y director de la facultad. En 1995 se inaugur el conjunto Amoxcalli (Casa de los libros) que cuenta con diferentes espacios como el Auditorio Carlos Graef, el Aula Leonila Vzquez, los Salones de Seminarios Sotero Prieto I, II y III, el Anfiteatro Alfredo Barrera, el centro de Cmputo Toms A. Brody y por supuesto su espacio principal destinado a contener la Biblioteca Ricardo Monges Lpez. Este nombre le fue otorgado en honor al primer director de la Facultad de Ciencias.  La gran coleccin bibliogrfica actual se conform con los acervos de la biblioteca principal y de las bibliotecas departamentales. De igual forma las colecciones de revistas y tesis de las bibliotecas departamentales se reunieron para conformar el acervo de la hemeroteca. En resumen, la Biblioteca Ricardo Monges Lpez posee una coleccin que se ha ido conformando durante un poco ms de medio siglo y que se mantiene en constante crecimiento y actualizacin. Esta biblioteca tiene ahora la capacidad para atender a la comunidad de la Facultad de Ciencias con aproximadamente una decena de miles de usuarios y a sus visitantes externos. Texto enviado por Mat. Adrin Girard','http://www.fciencias.unam.mx/servicios/biblioteca/Index','FC','','P7F','','10204110152108','10204110152304','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','5047.00','','',NULL,NULL,'','bib60.jpg','','','','','','Mbib60.jpg','http://aleph.fciencias.unam.mx:8980','https://goo.gl/maps/Mg6QDKNwme92','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (35,'Biblioteca "Isidro Fabela"','','','Licenciatura y Posgrado                                                                             ','1984','','http://www.politicas.unam.mx/principal/biblioteca.php ','CP','','P3C','','10204120152105','10204120152301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1564.00','Creacin de licenciatura en Antropologia con participacin del IA, Filolgicas, CPHCS y CIMCHFS. Gaceta 4707. 2 julio 2015. DPLybf','La biblioteca cuenta con biblioteca digital llamada Henrique Gonzlez Casanova, puesta a disposicin el 14 febrero 2005, Gaceta 3784. DPLybf',NULL,NULL,'','bib35.jpg','','','','','','Mbib35.jpg','http://biblioteca.politicas.unam.mx:8991','https://goo.gl/maps/aw1qJVgTTrF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (15,'Biblioteca "C.P. Alfredo Adam Adam"','','','Licenciatura y Posgrado                                                                             ','1986','1986 inauguracin de Biblioteca con el nombre de C.P. Alfredo Adam Adam. ','http://biblio.contad.unam.mx/ ','C','','P14','','10204130152102, 11204130252102','10204130152308','0','0.00','0','0.00','0.00','0.00','0','0','3139.00','','',NULL,NULL,'','bib15.jpg','','','','','','Mbib15.jpg','http://alephfca.fca.unam.mx:8991','https://goo.gl/maps/JAp1C3dxbCx','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (44,'Biblioteca "Antonio Caso"','','','Licenciatura y Posgrado                                                                             ','1954','',' http://www.derecho.unam.mx/biblioteca/index-biblioteca.php ','D','','P4C','','10204140152109','10204140152305','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','4695.00','','',NULL,NULL,'','bib44.jpg','','','','','','Mbib44.jpg','http://bassi.derecho.unam.mx:8991','https://goo.gl/maps/S1bnPSciXAB2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (33,'Biblioteca "Ramn Ramrez Gmez"','','','Licenciatura y Posgrado                                                                             ','1976','1974 ','http://www.depfe.unam.mx/biblioteca/index.htm','CMP5','','P3A','Activa','11024230252107','11024230252303','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1520.00','','',NULL,NULL,'','bib33.jpg','No','No','No','','','Mbib33.jpg','http://biblioteca.economia.unam.mx:8991','https://goo.gl/maps/durUh9X1TyR2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (133,'Biblioteca "Enrique Gonzlez Aparicio"','','','Licenciatura y Posgrado                                                                             ','1937','','http://132.248.45.5/biblioteca/index.html','Q','','PC4','','10204230152105 $11024230252107','10204230152301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','3850.00','','',NULL,NULL,'','bib133.jpg','','','','','','Mbib133.jpg','http://biblioteca.economia.unam.mx:8991','https://goo.gl/maps/bBVQ1pAm7R82','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (4,'Centro de Informacin y Documentacin','','','Licenciatura y Posgrado                                                                             ','1975','La Escuela Nacional de Estudios Profesionales Acatln fue fundada en 1975.  Ese mismo ao inician las funciones de la Biblioteca que contaba con un acervo de 3,750 volmenes.$En el ao de 1982, debido al crecimiento natural del servicio y del propio acervo bibliogrfico se vio la necesidad de contar con un edificio donde se brindaran los servicios en espacios funcionales; de esta manera fueron ampliadas las instalaciones a una superficie de 4,500 m2; se cambi su denominacin a Centro de Informacin y Documentacin y se establece tambin el sistema de estantera abierta.$En 1989, con la utilizacin de cdigos de barras en credenciales y libros, se realiz desde esa poca el prstamo y devolucin del material en forma automatizada.  Previniendo el auge que tendra la informacin en formato electrnico y tomando en cuenta el avance tecnolgico, en 1997, inicia su funcionamiento la Sala de Consulta Especializada.$Informacin proporcionada por: Lic. Patricia Espinosa Martnez.','http://www.acatlan.unam.mx/cid/ ','ACA','','P04','','10204420152104','10204420152300','00','0.00','0','0.00','0.00','0.00','0','0','4531.00','','',NULL,NULL,'','bib04.jpg','','','','','','Mbib04.jpg','http://132.248.80.61:8991','https://goo.gl/maps/AvKzCnWWy7S2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (7,'Biblioteca "Jess Reyes Heroles"','','','Licenciatura y Posgrado                                                                             ','1976','','http://www.aragon.unam.mx/aragon/biblioteca.html','ARA','','P08','','10204440152108','10204440152304','0','0.00','0','0.00','0.00','0.00','0','0','5310.00','Gaceta 10 enero de 2013 en la biblioteca se habilit la puerta de emergencia y se instal un radiorreceptor para recibir la seal de alerta ssmica. DPLybf','',NULL,NULL,'','bib07.jpg','','','','','','Mbib07.jpg','http://biblioteca-fes.aragon.unam.mx:8991','https://goo.gl/maps/obF8qYQJzV32','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (36,'Biblioteca. Facultad de Estudios Superiores Cuautitln. Campo 1','','','Licenciatura y Posgrado                                                                             ','1974','',' http://avalon.cuautitlan2.unam.mx/biblioteca/ ','CUA','','P44','','10204410152107','10204410152303','0','0.00','0','0.00','0.00','0.00','0.00','0.00','1420.00','','',NULL,NULL,'','bib36.jpg','','','','','','Mbib36.jpg','http://dgb1.cuautitlan2.unam.mx:8991','https://goo.gl/maps/CEQ7EayCpeJ2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (37,'Biblioteca. Facultad de Estudios Superiores Cuautitln. Campo 4','','','Licenciatura y Posgrado                                                                             ','1974','','http://avalon.cuautitlan2.unam.mx/biblioteca/','CUA4','','PF3','','','','0.00','0.00','0','0.00','0','0.00','0','0','2114.00','','',NULL,NULL,'','bib37.jpg','','','','','','Mbib37.jpg','http://bib2.cuautitlan1.unam.mx:8991','https://goo.gl/maps/3tbrXHyP4jF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (95,'Unidad de Documentacin Cientfica','','','Licenciatura y Posgrado                                                                             ','1975','',' http://www.iztacala.unam.mx/sga/udc/ ','IZT','','P9E','','10204430152101','10204430152307','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','4577.00','','',NULL,NULL,'','bib95.jpg','','','','','','Mbib95.jpg','http://udc.iztacala.unam.mx:8991','https://goo.gl/maps/82vo9nfjvzE2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (138,'Biblioteca. Facultad de Estudios Superiores Zaragoza. Campo 1','','','Licenciatura y Posgrado                                                                             ','1976','','http://www.bibliotecampus1.org/','ZAR','','PD8','','10204450152105','10204450152301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','2149.00','','',NULL,NULL,'','bib138.jpg','','','','','','Mbib138.jpg','http://biblio66.zaragoza.unam.mx:8991','https://goo.gl/maps/Z22YMzUUtoB2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (139,'Biblioteca.  Facultad de Estudios Superiores Zaragoza. Campo 2','','','Licenciatura y Posgrado                                                                             ','1979','','http://bibliotecacampus2.blogspot.mx/','ZAR2','','PD9','','','10204450152301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','2393.00','En enero de 2014 se encuentran provisionalmente en otro recinto del campus con 1200m2','',NULL,NULL,'','bib139.jpg','','','','','','Mbib139.jpg','http://132.248.193.2:8991','https://goo.gl/maps/Xn3iigP7AH12','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (59,'Biblioteca "Samuel Ramos"','','','Licenciatura y Posgrado                                                                             ','1959','Sus races se encuentran en el siglo XVI, cuando se instaura la Facultad de Artes de la Real y Pontificia Universidad de Mxico.$A principios del siglo XX, se funda la Escuela de Altos Estudios, antecedente de la Facultad. En los aos treinta, la biblioteca ocup una sala adaptada en el edificio de Mascarones.$Tras el desplazamiento a Ciudad Universitaria se le asign una planta con 780m2, y all funcion durante casi cuarenta aos (actualmente es la segunda seccin de la biblioteca). Las necesidades de espacio y de modernizacin de los servicios hicieron prioritaria la construccin de una nueva biblioteca, con edificio propio y con acceso a las innovaciones tecnolgicas.$Mediante el apoyo del Programa UNAM-BID, se logr la construccin de la nueva Biblioteca Samuel Ramos que se inaugur el 27 de abril de 1995.$En la planta principal de la biblioteca se localizan la hemeroteca, los catlogos electrnicos para el servicio a los usuarios, el mdulo de prstamo, la sala automatizada, el rea de lectura y la Coordinacin.$La planta baja guarda el acervo general y el fondo reservado. En este mismo nivel est ubicado el Departamento de Adquisiciones y Procesos Tcnicos y el rea de fotocopiado.$Informacin proporcionada por: Mtro. Jorge Gmez Briseo.','http://palas-atenea.filos.unam.mx/ ','F','','P7D','','10014150152105$12024150452105','10204150152302$11014150252301','0','0.00','0','0.00','0.00','0.00','0.00','0','3949.00','REMODELACION: cambio de loseta asfltica por loseta cermica 2008. DPLybf','Biblioteca construida en dos niveles con un rea de 2507m2. Gaceta 4 mayo 1995. DPLybf.',NULL,NULL,'','bib59.jpg','','','','','','Mbib59.jpg','http://bsr.filos.unam.mx:8991','https://goo.gl/maps/S1bnPSciXAB2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (65,'Biblioteca "Ing. Antonio Doval Jaime"','','','Licenciatura y Posgrado                                                                             ','1954','','http://www.ingenieria.unam.mx/bibliotecas/','G','','P87','','10204160152103','10204160152309','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','600.00','','',NULL,NULL,'','bib65.jpg','','','','','','Mbib65.jpg','http://bibliotecasfi.fi-a.unam.mx:8991','https://goo.gl/maps/5UQvPdSWKm42','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (68,'Biblioteca "Mtro. Enrique Rivero Borrell"','','','Licenciatura y Posgrado                                                                             ','1967','','http://www.ingenieria.unam.mx/bibliotecas/','G1','','PEE','','','','0.00','0.00','1363927.00','1363927.00','0.00','0.00','0.00','0.00','3390.00','','',NULL,NULL,'','bib68.jpg','','','','','','Mbib68.jpg','http://bibliotecasfi.fi-a.unam.mx:8991','https://goo.gl/maps/xs4RBio7YPt','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (66,'Biblioteca "Dr. Enzo Levi"','','','Licenciatura y Posgrado                                                                             ','1957','','http://www.ingenieria.unam.mx/bibliotecas/','G2','','P89','','11204160252103','11204160252309','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','2000.00','','',NULL,NULL,'','bib66.jpg','','','','','','Mbib66.jpg','http://bibliotecaenzolevi.fi-p.unam.mx:8991','https://goo.gl/maps/kjrBbMnYEBw','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (67,'Centro de Informacin y Documentacin "Ing. Bruno Mascanzoni"','','','Licenciatura y Posgrado                                                                             ','1984','','http://www.mineria.unam.mx/cid.php','G3','','P8A','','14024160352101','14024160352307','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','139.00','2012. Cambio de lugar. Se encontraban en primer piso y se reubicaron en planta baja del mismo edificio de ','',NULL,NULL,'','bib67.jpg','','','','','','Mbib67.jpg','http://biblio192.dgbiblio.unam.mx:8995','https://goo.gl/maps/tVe5aZEXLfL2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (75,'Biblioteca "Ing. Antonio M. Anza"','','','Licenciatura y Posgrado                                                                             ','1987','La Biblioteca del Acervo Histrico del Palacio de Minera resguarda aproximadamente 200,000 volmenes entre monografas y publicaciones peridicas de los siglos XVI a XX. Sus antecedentes se remontan a 1792, ao de la fundacin del Real Seminario o Colegio de Minera de Mxico. Durante la poca virreinal, la biblioteca de esta institucin se nutri de compras hechas en Europa y Mxico.$En 1867, el colegio se transform en Escuela Nacional de Ingenieros. Durante el gobierno de Porfirio Daz, dicha institucin particip en la construccin de la infraestructura ferroviaria, portuaria, etc. del pas. En 1910, la Escuela se incorpor a la Universidad Nacional de Mxico. Importantes ingenieros hicieron llegar sus colecciones personales a la biblioteca durante esta poca.$La Escuela sigui sus actividades en el Palacio de Minera hasta 1959, ao en que se traslad de manera definitiva a la Ciudad Universitaria y se transform en Facultad de Ingeniera. En ese momento, la coleccin qued en desuso, para despus constituirse en Acervo Histrico del Palacio de Minera, cuya biblioteca comenz a brindar servicio al pblico en 1989. Adicionalmente, se agregaron los fondos bibliogrficos y hemerogrficos de dos importantes asociaciones cientficas mexicanas fundadas en el siglo XIX: la Sociedad Cientfica ',' http://www.mineria.unam.mx/acervo.php ','GH3',NULL,'PE7','','','','','','','','','','','','821.00','','',NULL,NULL,'','bib75.jpg','','','','','','Mbib75.jpg','http://biblio192.dgbiblio.unam.mx:8995','https://goo.gl/maps/nWo1Mrp3spS2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (80,'Biblioteca. Facultad de Medicina','','','Licenciatura y Posgrado                                                                             ','1954','En 1956 la Escuela de Medicina ocup las nuevas instalaciones de la Facultad de Medicina, en la recin inaugurada Ciudad Universitaria. La Biblioteca se localizaba en la planta baja del edificio E, en ese espacio evolucion y, por ende, mejor la calidad de sus servicios, se adopt la modalidad de estantera abierta en 1989; el uso de catlogos y servicios de circulacin automatizados se inici en 1992.$El Dr. Jos Narro Robles, Director de la Facultad, anunci la construccin de un nuevo edificio para las Bibliotecas en su informe de actividades 2003. Despus de analizar varios proyectos, la opcin seleccionada fue construir un edificio nuevo donde estuviera el edificio E. Esto provoc que los Departamentos que ocupaban ese edificio (Servicios Escolares, Consejo Tcnico, Oficina de Personal Acadmico y Biblioteca) se mudaran a otras instalaciones. La Biblioteca ocup un lugar provisional, construido para tal efecto, en la planta baja del edificio B, de febrero a diciembre de 2006.$El 8 de enero de 2007 el nuevo edificio de 3 niveles abre sus puertas a la comunidad de la Facultad, incluyendo la Biblioteca Dr. Valentn Gmez faras, la Hemerobiblioteca ','http://www.facmed.unam.mx/bibliotecas/index.php?bib_ver=2 ','H','','P91','','10204170152100','10204170152306','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','3105.00','','',NULL,NULL,'','bib80.jpg','','','','','','Mbib80.jpg','http://aleph1.facmed.unam.mx:8991','https://goo.gl/maps/2bfdKVHLcnK2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (85,'Biblioteca "Dr. Nicols Len"','','','Licenciatura y Posgrado                                                                             ','1956','El Departamento de Historia y Filosofa de la Medicina y su biblioteca fueron creados en 1956 por el Dr. Francisco Fernndez del Castillo; l se aboc a clasificar, ordenar y catalogar el archivo histrico de la Facultad, adems de organizar simultneamente todo el material bibliogrfico, constituido por libros, tesis y revistas especializadas en el rea mdica, tanto nacionales como extranjeras que constituy la base para la creacin de la biblioteca histrica.$El nombre de la biblioteca le fue dado por el Dr. Fernndez del Castillo ya que l admiraba al Dr. Len, mdico obstetra, quien adems realiz estudios de bibliotecologa.$El acervo aument considerablemente para el ao de 1960 con la adquisicin de un lote de libros y documentos histricos.$En 1973 el Fondo Antiguo de la FM fue incorporado a la Biblioteca Histrica incrementando sus colecciones. Asimismo fueron recibidas diferentes donaciones de familiares de mdicos de reconocido prestigio.$Esta biblioteca tambin puede ser considerada una biblioteca museo debido a que existen obras que por su antigedad, valor cientfico, cultural y artstico, exclusivamente se exhiben dentro de la misma biblioteca as como en salas del Museo de la Historia de la Medicina Mexicana y se prestan y consultan reproducciones de las mismas para apoyar su preservacin.$Esta biblioteca es considerada como la primera en su gnero en nuestro pas y est entre las mejores en Amrica Latina ya que posee libros que en ocasiones tienen valores incalculables no slo desde el punto de vista econmico, sino tambin cultural, ya que son ejemplares de los que existen contados en el mundo.$Informacin proporcionada por: Mtra. Analicia Hinojosa.','http://fournier.facmed.unam.mx/deptos/hfm/index.php/biblioteca','HBM','','PE5','','','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','607.00','http://fournier.facmed.unam.mx/deptos/hfm/index.php/biblioteca','',NULL,NULL,'','bib85.jpg','','','','','','Mbib85.jpg','http://aleph3.facmed.unam.mx:8991','https://goo.gl/maps/9ABLnxWnCoQ2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (145,'Biblioteca. Centro de Enseanza, Inv. y Ext. en Ganadera Tropical','','','Licenciatura y Posgrado                                                                             ','1981','Debido a las actividades propias del CEIEGT en la formacin de recursos humanos y el desarrollo de investigaciones en el sector pecuario, la Biblioteca del CEIEGT juega un papel importante en la aportacin de informacin de este sector productivo.$La biblioteca se fund el 19 de Febrero de 1981, con el apoyo de la Facultad de Medicina Veterinaria y Zootecnia de la UNAM y de la Organizacin de las Naciones Unidas para la Agricultura y la Alimentacin (FAO) a travs del Programa de las Naciones Unidas para el Desarrollo (PNUD).$De 1981 a 1984 se ubico en el edificio B, al finalizar la construccin de los edificios C y D en el ao de 1985 se realizo el cambio de ubicacin al edificio D, permitiendo la ampliacin de las reas de colecciones y servicios.$Cuenta con dos bibliotecarios del personal administrativo, quienes ofrecen el servicio al pblico de lunes a sbado.$Informacin proporcionada por: Sra. Victoria Alfonso Villa.','http://www.fmvz.unam.mx/fmvz/centros/ceiegt/servicios.html','CGT','','P27','','10024190852105','10024190852301','101167.00','0.00','864359.00','0.00','0.00','0.00','0.00','0.00','144.00','*Informacin (521) 2004$*Informacin (523) 2005$*Informacin encuadernacin (Censo 2004)','',NULL,NULL,'','bib145.jpg','','','','','','Mbib145.jpg','http://bibliodigital.fmvz.unam.mx:8991','https://goo.gl/maps/MDFH1koBq8m','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (57,'Biblioteca. Centro de Enseanza, Inv. y Ext. en Produccin  Ovina','','','Licenciatura y Posgrado                                                                             ','1992','','http://www.fmvz.unam.mx/fmvz/centros/ceiepo/acerca.html','EIB','','P78','','10024190652101','10024190652307','22246.00','0.00','108532.00','0.00','0.00','0.00','0.00','0.00','34.00','*Informacin (521) 2004$*Informacin (523) 2005 $*Informacin encuadernacin (Censo 2004)','',NULL,NULL,'','bib57.jpg','','','','','','Mbib57.jpg','http://bibliodigital.fmvz.unam.mx:8991','https://goo.gl/maps/VoxsTb6DF9x','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (69,'Biblioteca. Centro de Enseanza, Inv. y Ext. en Produccin Avcola','','','Licenciatura y Posgrado                                                                             ','2002','','http://www.fmvz.unam.mx/fmvz/centros/ceiepav/acerca.html','GEA','','P8B','','10024190752108','10024190752304','36517.00','0.00','34119.00','0.00','0.00','0.00','0.00','0.00','19.00','*Informacin (521) 2004$*Informacin (523) 2005 $*Informacin encuadernacin (Censo 2004)','',NULL,NULL,'','bib69.jpg','','','','','','Mbib69.jpg','http://bibliodigital.fmvz.unam.mx:8991','https://goo.gl/maps/FfrqkBwTZws','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (122,'Biblioteca "M.V. Jos de la Luz Gmez"','','','Licenciatura y Posgrado                                                                             ','1857','1969 Misin de la Biblioteca ','http://www.fmvz.unam.mx/fmvz/biblioteca/acerca.html','P','','PBA','','10204190152104 $11014190252103','10204190152300','0','0.00','0','0.00','0','0.00','0','0.00','3226.00','La coleccin de la divisin de sistema universidad abierta se integr a la biblioteca principal en 2006, DPLybf','Con el apoyo del programa UNAM-BID se construye la biblioteca con 3000m2 (noticia gaceta 3,783- 10-feb-2005) DPLybf',NULL,NULL,'','bib122.jpg','','','','','','Mbib122.jpg','http://bibliodigital.fmvz.unam.mx:8991','https://goo.gl/maps/RP7HC5GJfAJ2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (134,'Biblioteca. Centro de Enseanza, Inv. y Ext. en Produccin Animal en Altiplano','','','Licenciatura y Posgrado                                                                             ','2002','La Biblioteca del CEIEPAA es el resultado del traslado de dos Centros de Enseanza a su nueva ubicacin en Tequisquiapan, Quertaro en el Altiplano Mexicano.  En el ao 2002 es reubicado el hasta entonces Centro de Enseanza, Investigacin y Extensin en Produccin Agrcola y Ganadera (CEIEPAG) en Chalco, Estado de Mxico a su nueva sede en el Poblado de Santilln, Municipio de Tequisquiapan, Quertaro. Es en el casco de una Ex-Hacienda con ms de 350 aos de antigedad donde es preservado el acervo bibliogrfico proveniente de este Centro  para el uso de los alumnos. En el 2004 se incorpora el material bibliogrfico proveniente del Centro de Enseanza, Investigacin y Extensin en Produccin Bovina y Caprina (CEIEPBC), situado en el poblado de Tepotzotln, Estado de Mxico,  para conformar as la Biblioteca del Centro de Enseanza, Investigacin y Extensin en Produccin Animal en Altiplano, donde permaneci hasta el ao 2006. Cuando se concluye la construccin del nuevo complejo acadmico nuevamente se traslada el acervo a las actuales instalaciones, las cuales ya cuentan con infraestructura moderna para brindar un mejor servicio a los usuarios.Texto elaborado por Jos Alfredo Carranza Velzquez','http://www.fmvz.unam.mx/fmvz/centros/ceiepaa/acerca.html','RCM','','PC6','','10024191152109','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','50.00','Se integran los acervos de Agricola y Ganadera (CGA) y Bovina y Caprina (RCM) oficialmente en 2006. DPLybf','',NULL,NULL,'','bib134.jpg','','','','','','Mbib134.jpg','http://bibliodigital.fmvz.unam.mx:8991','https://goo.gl/maps/t7ra8yjCCbk','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (96,'Biblioteca "Cuicamatini" ','','','Licenciatura y Posgrado                                                                             ','1943','La Escuela Nacional de Msica (ENM), que en aquellos das llevaba el nombre de Facultad de Msica (FM) de la UNAM, fue fundada el 7 de octubre de 1929. El Sr. Gonzalo Angulo fue el primer Bibliotecario que tuvo la Escuela (Facultad en ese entonces) de Msica. Se preocup por crear un acervo de msica para los alumnos de aquella poca.$En 1979 se crea un nuevo edificio, actual sede de la Escuela Nacional de Msica con l se traslada la biblioteca a un espacio con ciertas adaptaciones en dos niveles que permitan que los estudiantes pudieran consultar los materiales que se tenan en existencia.$Las colecciones que tena la biblioteca estaban integradas de materiales donados por algunos profesores y estudiantes, muy poco era adquirido.$Es el 7 de agosto de 1996 cuando se inaugura el nuevo edificio de la Biblioteca. A partir de este momento cambia de denominacin y se convierte en Coordinacin de Acervos Musicales que alberga la coleccin de la Biblioteca Cuicamatini.$Los usuarios que atiende van desde 5 o 6 aos de edad (iniciacin musical), hasta aquellos que realizan estudios de maestra y/o doctorado, sin olvidar a las personas que se encuentran en condiciones especiales.$Informacin proporcionada por: Lic. Daniel Villanueva Rivas.','http://www.fam.unam.mx/servicios/biblioteca.php','J','','P9F','','10204350152102','10204350152308','0','0.00','0','0.00','0.00','0.00','0','0','1493.00','','Biblioteca inaugurada  23 noviembre 1995. Gaceta 2972. DPLybf',NULL,NULL,'','bib96.jpg','','','','','','Mbib96.jpg','http://athenas.enmusica.unam.mx:8991','https://goo.gl/maps/Uw98VZZXPF82','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (97,'Biblioteca "Dr. Ignacio Aguilar Alvarez"','','','Licenciatura y Posgrado                                                                             ','1991','El 19 de abril de 1904 se inaugura el Consultorio Nacional de Enseanza Dental contando con una biblioteca integrada por 19 volmenes. Los temas de estos libros eran principalmente referentes a las reas mdicas y odontolgicas. Inclua un volumen de la Constitucin Mexicana y diccionarios ingls-espaol y francs-espaol, pues casi todos los volmenes estaban escritos en estos idiomas.$Es el 15 de marzo de 1958, cuando la Facultad de Odontologa ocupa la nueva sede definitiva de sus instalaciones en Ciudad Universitaria, se destina un local para la biblioteca situado en el 1er. Piso del edificio ','http://www.odonto.unam.mx/admin.php?IDPagina=biblioteca','K','','PA1','','10204210152101','10204210152307','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','660.00','','',NULL,NULL,'','bib97.jpg','','','','','','Mbib97.jpg','http://bibliotecafo.odonto.unam.mx:8991','https://goo.gl/maps/6zooyeyRvC92','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (98,'Biblioteca "Barnet M. Levy"','','','Licenciatura y Posgrado                                                                             ','1988','En el ao de 1988 la biblioteca inicia en un cubculo en el rea de investigacin y en ese mismo ao se le asigna la mitad del primer piso del edificio principal de posgrado. El Rector Jorge Carpizo, inaugura la Biblioteca de Posgrado ','http://www.odonto.unam.mx/admin.php?IDPagina=Bblioteca&idm=27','K1','','PA2','','11204210252101','11204210252307','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','441.00','','',NULL,NULL,'','bib98.jpg','','','','','','Mbib98.jpg','http://bibliotecafo.odonto.unam.mx:8991','https://goo.gl/maps/3EA5Svm2p4J2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (127,'Biblioteca "Dra. Graciela Rodrguez  Ortega"','','','Licenciatura y Posgrado                                                                             ','1973','Con la creacin de la Facultad de Psicologa el 27 de febrero de 1973, surge la Biblioteca como elemento fundamental del proceso de formacin acadmica de los estudiantes y en apoyo a la docencia, con la finalidad de cubrir la demanda de informacin requerida por la comunidad de la institucin. Con un acervo inicial de 2,787 volmenes, se fueron integrando y acrecentando mediante compra y donacin las colecciones de libros, tesis de licenciatura, pruebas psicolgicas, material audiovisual, etc.$De 1973 a 1976 se localiz en la planta baja del edificio ','http://www.psicologia.unam.mx/biblioteca-y-centro-de-documentacion/','PS','','PS','','10014220152107','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1103.00','sala de lectura anexa a la biblioteca. G. 3 de mayo de 2012. DPLybf','',NULL,NULL,'','bib127.jpg','','','','','','Mbib127.jpg','http://exlibris.psicol.unam.mx:8991','https://goo.gl/maps/UPnoDphx6732','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (128,'Centro de Documentacin "Dr. Rogelio Daz Guerrero"','','','Licenciatura y Posgrado                                                                             ','1976','El Centro de Documentacin Dr Rogelio Daz Guerrero, de la Divisin de Estudios de Posgrado de la Facultad de Psicologa , fundado en 1976, es una fuente importante de suministro de informacin para  la investigacin, la docencia y la prctica profesional. Todas estas tareas importantes para la incorporacin de avances del conocimiento en la disciplina, tanto en escenarios nacionales como internacionales.$El Centro tambin ha desarrollado el SIPAL. Sistema de Informacin Psicolgica para Amrica Latina, con la finalidad de apoyar la difusin de artculos publicados en revistas cientficas latinoamericanas especializadas en psicologa.$Informacin proporcionada por: Lic. Magdalena Zrate Santamara.','http://biblio.unam.mx:8390/index.php','PS1','','PC1','','11204220252108','11204220252304','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','702.00','','',NULL,NULL,'','bib128.jpg','','','','','','Mbib128.jpg','http://exlibris.psicol.unam.mx:8991','https://goo.gl/maps/duzbHpNAPT42','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (110,'Biblioteca. Facultad de Quimica. Divisin de Estudios Profesionales','','','Licenciatura y Posgrado                                                                             ','1957','Con el registro de 4795 unidades (libros, tesis, folletos y revistas) ocuparon el local construido ex profeso en la planta baja del edificio principal [de la Facultad de Qumica].  En Tacuba continuaron funcionando con algunos materiales hemerobibliogrficos.  En 1969 se registra un total de 6179 unidades documentales (ya que se haban reunido las dos colecciones).  En 1963 se  report que los acervos estaban conformados por 8 mil obras monogrficas y cien ttulos de publicaciones peridicas; para el ao siguiente el acervo se haba incrementado a 10500 volmenes.$El desarrollo de las bibliotecas fue continuo, de hecho la Facultad tiene cinco unidades bibliotecarias. Dos de las unidades pertenecen a Estudios Profesionales (Edificio A y D), dos a Estudios de Posgrado (Edificio B stano y E) y la Hemeroteca que resguarda publicaciones peridicas.$El incremento de la matrcula y la organizacin interna de la dependencia provocaron que en 1994 se empezara a trabajar en la ampliacin de la biblioteca principal.  Se cre la campaa ','http://quimica.webcom.com.mx/cont_seccion.php?id_rubrique=7&id_article=36&color=08346F ','M','','PAF','','10204180152107','10204180152303','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1533.00','','El proyecto de ampliacin y modernizacin de la biblioteca tiene 1200 m2 ms de construccin, distribuidos en tres niveles inicia el 22 de junio de 1994.  Gaceta 3013. 13 mayo 1996. DPLybf',NULL,NULL,'','bib110.jpg','','','','','','Mbib110.jpg','http://alepha.quimica.unam.mx:8991','https://goo.gl/maps/mUiicxQedHu','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (111,'Biblioteca. Facultad de Qumica. Divisin de Estudios de Posgrado','','','Licenciatura y Posgrado                                                                             ','1965','En 1916 es fundada la Escuela Nacional de Industrias Qumicas que ms tarde se transforma en Escuela Nacional de Ciencias Qumicas y a partir de 1965 en Facultad de Qumica. Este mismo ao, con las donaciones de miembros de la comunidad de la Facultad y la del Instituto de Qumica, se forma la coleccin de la biblioteca de la Divisin de Estudios Superiores, que posteriormente formar la coleccin de la biblioteca de posgrado. La biblioteca qued ubicada en el stano del edificio ','http://quimica.webcom.com.mx/cont_espe2.php?id_rubrique=7&id_article=948&color=08346F&rub2=467','M1','','PB0','','11204180252107','11204180252303','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','450.00','desde julio del ao 2013 se han trasladado a nuevo lugar llamado antiguo  edificio de Biomdicas, se espera que el traslado se termine a finales de enero 2014.','',NULL,NULL,'','bib111.jpg','','','','','','Mbib111.jpg','http://alepha.quimica.unam.mx:8991','https://goo.gl/maps/wccuC77nFiL2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (112,'Biblioteca de Metalurgia','','','Licenciatura y Posgrado                                                                             ','1983','La carrera de Metalurgia surge a partir de 1920, teniendo algunos cambios en su nombre. Hasta 1967 adopta el nombre de Ingeniera Qumica Metalrgica (IQM). La infraestructura que se utilizaba  para el desarrollo de esta disciplina era muy limitada y se llevaba a cabo en el laboratorio 9, del edificio ','http://quimica.webcom.com.mx/cont_espe2.php?id_rubrique=7&id_article=949&color=08346F&rub2=468','M2','','PFD','','','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','271.00','','',NULL,NULL,'','bib112.jpg','','','','','','Mbib112.jpg','http://alepha.quimica.unam.mx:8991','https://goo.gl/maps/h1gbsVNc1U22','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (113,'Biblioteca de Farmacia y Alimentos','','','Licenciatura y Posgrado                                                                             ','1993','La biblioteca de posgrado del Conjunto E, de la Facultad de Qumica, surge como parte de un proyecto de descentralizacin de la facultad debido a la demanda de espacios fsicos que requeran los investigadores y alumnos de posgrado, ya que literalmente no caban ms. En el inicio del proyecto se tena contemplado crear una Escuela de Alimentos en Cuernavaca, Iztapalapa  o Xochimilco.$Hacia finales de los 80s e inicios de los 90s, al agudizarse el problema de los espacios, cambia la idea original y se crea el Conjunto E en Ciudad Universitaria que albergara a los investigadores de Alimentos, Biofarmacia e Ingeniera Qumica.$La biblioteca del Conjunto E abri por primera vez sus puertas a los usuarios el da 6 de septiembre de 1993.$Actualmente se puede consultar tambin el SciFinder que es una de bases de datos ms completas en el campo cientfico, adems de recuperar documentos de instituciones externas a la UNAM, va fax, correo electrnico  y compra de documentos en el extranjero con el apoyo de la Direccin General de Bibliotecas.$Informacin proporcionada por: David Morales Zapatero.','http://quimica.webcom.com.mx/cont_espe2.php?id_rubrique=7&id_article=950&color=08346F&rub2=469','M3','','','','','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','387.00','','',NULL,NULL,'','bib113.jpg','','','','','','Mbib113.jpg','http://alepha.quimica.unam.mx:8991','https://goo.gl/maps/h1gbsVNc1U22','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (114,'Hemeroteca. Facultad de Qumica','','','Licenciatura y Posgrado                                                                             ','1965','La Hemeroteca est en funcionamiento a partir  del  4  de junio de 1991 y forma parte del sistema Bibliotecario de dicha Facultad.$Su funcin es:$*  Apoyar con sus recursos  las labores de investigacin y docencia y difusin de la cultura en el rea de la Qumica.$*  Satisfacer las necesidades de los usuarios y asesorar en la recuperacin de informacin de los diferentes servicios que proporciona la Hemeroteca.$Informacin proporcionada por: Zayda Jimnez Bautista.',' http://quimica.webcom.com.mx/cont_espe2.php?id_rubrique=7&id_article=951&color=08346F&rub2=100','M5','','','','','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','495.00','','',NULL,NULL,'','bib114.jpg','','','','','','Mbib114.jpg','SIN CATLOGOS','https://goo.gl/maps/YEArjkB139k','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (54,'Biblioteca. Instituto de Biologa','','','Investigacin Cientfica                                                                            ','1929','La Biblioteca del Instituto de Biologa es un acervo especializado en biologa organsmica, sistemtica, ecologa y otras disciplinas afines. Ubicada desde 1999 en sus nuevas instalaciones, fue reinaugurada en enero del ao 2000 con los acervos integrados de tres bibliotecas: la Biblioteca General (coleccin de zoologa, historia natural y biologa en general), Biblioteca del Herbario Nacional y Biblioteca del Jardn Botnico. Actualmente cuenta con un acervo de ms de 24,200 ejemplares, con un ingreso promedio de 750 libros por ao, adems recibe anualmente por suscripcin, canje o donacin 632 ttulos de publicaciones peridicas y seriadas. El acceso a la informacin de estos recursos es a travs de un servicio electrnico de informacin, en la direccin de Internet http://biblio68.ibiologia.unam.mx, donde los usuarios pueden consultar los catlogos del acervo bibliogrfico de la biblioteca, as como obtener informacin de publicaciones en formato electrnico y diversas bases de datos en las reas de inters. Texto tomado de la Web del Instituto de Biologa.',' http://www.ibiologia.unam.mx/bib/www/index.html','E','','P75','','31203130152102','31203130152308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1120.00','','',NULL,NULL,'','bib54.jpg','','','','','','Mbib54.jpg','http://132.248.13.22:8991','https://goo.gl/maps/tYmR9TTHtSK2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (55,'Biblioteca.Estacin de Biologa Tropical Los Tuxtlas','','','Investigacin Cientfica                                                                            ','1984','','http://www.ibiologia.unam.mx/tuxtlas/frame/infra/frame.htm','E1','','P76','','31013130352105','31013130352301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','39.00','','',NULL,NULL,'','bib55.jpg','','','','','','Mbib55.jpg','http://132.248.13.22:8991','https://goo.gl/maps/RRQ2oJB93o12','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (56,'Biblioteca. Estacin de Investigacin Experimentacin y Difusin Chamela ','','','Investigacin Cientfica                                                                            ','1984','','http://www.ibiologia.unam.mx/ebchamela/www/servicios.html','E2','','P77','','31013130452102','31013130452308','0','0.00','0','0.00','0.00','0.00','0.00','0.00','77.00','noticia de gaceta 12 de agosto 2013: nueva construccin que alberga la biblioteca en  la Estacin de Biologa Chamela. DPL.ybf actualizar m2 y foto','Biblioteca que tenia 68 m2 antes de 2013',NULL,NULL,'','bib56.jpg','','','','','','Mbib56.jpg','http://132.248.13.22:8991','https://goo.gl/maps/BF1Tzd7opuk','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (144,'Biblioteca. Instituto de Biotecnologa','','','Investigacin Cientfica                                                                            ','1981','','http://biblioteca.ibt.unam.mx/revistas.php','CGB','','P26','','31203280152100','31203280152306','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','','',NULL,NULL,'','bib144.jpg','','','','','','Mbib144.jpg','http://biblioteca.ccg.unam.mx:8991','https://goo.gl/maps/iwKjXx57bit','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (141,'"Biblioteca Conjunta de Ciencias de la Tierra"','','','Investigacin Cientfica                                                                            ','1997','','http://bcct.unam.mx','MAR','','PB','','0','0','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','','En 1939 se creo el laboratorio de Hidrobiologia, en 1967 se transforma en Departamento de Ciencias del Mar y Limnologia y en julio de 1980 se transforma de Centro a Instituto. DPLybf ',NULL,NULL,'','bib141.jpg','','','','','','Mbib141.jpg','http://132.248.182.16:8991','https://goo.gl/maps/5dwmWq2BygH2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (115,'Biblioteca.  Estacin Ciudad del Carmen','','','Investigacin Cientfica                                                                            ','1980','','http://www.icmyl.unam.mx/?q=node/23','MAR1','','PB2','','','','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','60.00','','',NULL,NULL,'','bib115.jpg','','','','','','Mbib115.jpg','http://132.248.182.16:8991','https://goo.gl/maps/twR6p5AWE3F2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (116,'Biblioteca "Dra. Mara Elena Caso Muoz"','','','Investigacin Cientfica                                                                            ','1979','La biblioteca de la Unidad Acadmica Mazatln inici sus actividades de una manera muy limitada en 1976 en un espacio de 32 m2, y fue hasta 1983 que se inici su organizacin formal. En 1986 se incorporaron ms documentos y se emprendi la organizacin temtica del acervo con catlogos manuales. En 1994 se inici el sistema de captura del acervo en bases de datos y es hasta 1999 que se cuenta con catlogos electrnicos. El 6 de noviembre de 1991 se decidi dar nombre a la biblioteca, en honor de la Dra. Mara Elena Caso Muoz, quien fuera una insigne investigadora del Instituto de Ciencias del Mar y Limnologa en Ciudad Universitaria, tuvo durante su carrera acadmica una particular afinidad con el personal de la Estacin Mazatln. En septiembre de 1996, se logr ampliar el espacio fsico a 75 m2. En 1999 se construy un edificio ex profeso de 120 m2 con mobiliario y equipo acorde con la tecnologa de dicho perodo. En 2013 se cuenta con el Edificio de Unidades de Servicios, donde la biblioteca se muda al segundo piso con un rea aprox. de 260 m2. Actualmente la Biblioteca Regional Dra. Mara Elena Caso Muoz permite a los interesados en las Ciencias del Mar y otras disciplinas, el acceso a innumerables fuentes de informacin, por medios tradicionales y electrnicos, adems brinda servicios de colaboracin y envo de documentacin a instituciones nacionales, Latinoamrica y a nivel internacional. $Informacin enviada por Lic. Daniel Oviedo Jurez ',' http://ola.icmyl.unam.mx/biblio ','MAR2','','PB3','','31023250352105','31023250352301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','120.00','','',NULL,NULL,'','bib116.jpg','','','','','','Mbib116.jpg','http://132.248.182.16:8991','https://goo.gl/maps/DtN5pJEscMm','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (117,'Biblioteca. Unidad Acadmica Sistemas Arrecifales','','','Investigacin Cientfica                                                                            ','1988','',' http://www.icmyl.unam.mx/arrecifes/library.html ','MAR3','','PB4','','31023250452102','31013250452305','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','38.00','','',NULL,NULL,'','bib117.jpg','','','','','','Mbib117.jpg','http://132.248.182.16:8991','https://goo.gl/maps/Fy96mjUFxWS2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (18,'Biblioteca. Instituto de Ecologa','','','Investigacin Cientfica                                                                            ','1988','','http://web.ecologia.unam.mx/index.php','CCE','','PE8','','31203290152107','31203290152303','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','184.00','http://web.ecologia.unam.mx/servicios/biblioteca/index.php','',NULL,NULL,'','bib18.jpg','','','','','','Mbib18.jpg','http://biblioteca.ecologia.unam.mx:8991','https://goo.gl/maps/5yjmGMnee1C2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (77,'Unidad de Informacin ','','','Investigacin Cientfica                                                                            ','1982','1996 ',' http://xml.cie.unam.mx/xml/sacad/bib/ ','GI2','','PDF','','31013110852106','31013110852302','0','0.00','0','0.00','0.00','0.00','00','0','220.00','','',NULL,NULL,'','bib77.jpg','','','','','','Mbib77.jpg','http://aleph.cie.unam.mx:8991','https://goo.gl/maps/6cs2LWnaLXF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (71,'Biblioteca "Juan B. de Oyarzbal"','','','Investigacin Cientfica                                                                            ','1938','La historia de la Biblioteca del IFUNAM est ntimamente vinculada con la fundacin del Instituto en 1939, ya que desde esa fecha, existi la necesidad de tener una unidad de informacin que brindara soporte para el desarrollo de sus actividades acadmicas.I.ObjetivoProporcionar a los usuarios en forma eficiente y oportuna, los servicios bibliotecarios y de informacin, necesarios, para las actividades docentes y de investigacin que se llevan a cabo en el Instituto de Fsica.II. Colecciones La biblioteca tiene bsicamente tres tipos de colecciones.1. Coleccin bibliogrfica. Est formada por 13,250 volmenes de libros, distribuidos en dos categoras: Obras de consulta y acervo general. La temtica de estos materiales est orientada al campo de la fsica y reas afines.2. Coleccin hemerogrfica. A esta coleccin la integran ms de 230 ttulos de publicaciones peridicas vigentes. Algunos ttulos pueden ser consultados va electrnica, a travs de la opcin: Revistas Electrnicas3. Coleccin de tesis. Se tienen 689 volmenes de tesis de nivel licenciatura, maestra y doctorado. Los tpicos de estos materiales estn dirigidos al rea de fsica y disciplinas relacionadas. Texto tomado de la WEB del Instituto de Fsica.','http://w2.fisica.unam.mx/bif','GF','','P8D','','31203140152109','31203140152305','0','0.00','0','0.00','0','0.00','0','0','2000.00','','',NULL,NULL,'','bib71.jpg','','','','','','Mbib71.jpg','http://newton.fisica.unam.mx:8991','https://goo.gl/maps/c7UcEYH8Jfk','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (23,'Biblioteca "Dr. Armando Gmez Puyou"','','','Investigacin Cientfica                                                                            ','1986','','http://132.248.16.13:8991/F','CFC','','P23','','31023260152108','31023260152304','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','426.00','','',NULL,NULL,'','bib23.jpg','','','','','','Mbib23.jpg','http://sunbiblio.ifc.unam.mx:8991','https://goo.gl/maps/EKhu4NgLve82','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (143,'"Biblioteca Conjunta de Ciencias de la Tierra"','','','Investigacin Cientfica                                                                            ','1997','',' http://bcct.unam.mx ','IF','','','','31203150152106','31203150152302','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','','',NULL,NULL,'','bib143.jpg','','','','','','Mbib143.jpg','http://132.248.182.16:8991','https://goo.gl/maps/5dwmWq2BygH2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (74,'Biblioteca "Ing. Antonio Garca Cubas"','','','Investigacin Cientfica                                                                            ','1946','Biblioteca-Mapoteca especializada en el rea de geografa y disciplinas afines.$Su creacin data del ao 1946 con colecciones pequeas existentes en espacios no apropiados para biblioteca. De 1954-1975 el Instituto de Geografa se ubic en un edificio adjunto a la ex torre de ciencias, hoy Torre de Humanidades II, y en el curso de 1975 el Instituto se traslad al rea de la Investigacin Cientfica y la Biblioteca cont con un espacio de 250 m2 en dos reas separadas.$En 1986 la coleccin era de 7000 vols. de libros y el servicio era de estantera cerrada.$En 1992 se estableci el servicio de estantera abierta de las colecciones de libros, revistas y tesis; quedando en servicio de estantera cerrada la cartografa, el material digital y el audiovisual.$En 1994 se presentaron varios proyectos para remodelar la biblioteca que no lograron culminar. Fue hasta 2002 con la reestructuracin completa del edificio del Instituto en que se cont con 1028 m2 que se tradujo espacios ptimos para contener el crecimiento de las colecciones: libros, publicaciones peridicas, mapas, un fondo reservado de 250 ttulos de obras del siglo XIX a 1930 y materiales digitales y audiovisuales.$Informacin proporcionada por: Mtra. Concepcin Basilio Romero.',' http://www.igeograf.unam.mx/sigg/biblioteca/intro.php ','GG','','P8E','','31203160152103','31203160152309','0','0.00','0','0.00','0.00','0.00','0','0','1029.00','Incluye Mapoteca "Alejandro de Humboldt"','',NULL,NULL,'','bib74.jpg','','','','','','Mbib74.jpg','http://cubas.igeograf.unam.mx:8991','https://goo.gl/maps/1Mij6UHVbF32','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (142,'"Biblioteca Conjunta de Ciencias de la Tierra"','','','Investigacin Cientfica                                                                            ','1997','',' http://bcct.unam.mx ','I','','','','31203170152100 $41023170152109','31203170152306','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','','',NULL,NULL,'','bib142.jpg','','','','','','Mbib142.jpg','http://132.248.182.16:8991','https://goo.gl/maps/5dwmWq2BygH2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (88,'Biblioteca. Estacin Regional del Noroeste ','','','Investigacin Cientfica                                                                            ','1974','OBJETIVOS$*  Dar apoyo bibliogrfico a los proyectos de investigacin generados en la ERNO, al posgrado en Ciencias de la Tierra de la UNAM, a los estudiantes y acadmicos de otras instituciones de la localidad e interesados en el rea.$*  Ofrecer servicios y acervos especializados sobre las ciencias de la tierra que permitan el desarrollo institucional en particular y de los usuarios en general.$HISTORIA$La Estacin Regional del Noroeste (ERNO) del Instituto de Geologa, ubicada en Hermosillo, Sonora, fue creada en 1974 como parte de la poltica de descentralizacin que inici la UNAM ese mismo ao. Obtiene un terreno en comodato con la Universidad de Sonora, donde construye un edificio que se inaugura el 20 de noviembre de 1980, destinndose un espacio para la biblioteca.$Informacin proporcionada por: Rosa Mara Contreras Garca.','http://www.geologia-son.unam.mx/biblioteca.html','I1','','P97','','','00000','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','46.00','','',NULL,NULL,'','bib88.jpg','','','','','','Mbib88.jpg','http://132.248.182.16:8991','https://goo.gl/maps/6qCg8Gsvo7t','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (91,'Unidad de Servicios de Informacin ','','','Investigacin Cientfica                                                                            ','1978','La Unidad de Servicios de Informacin del Instituto de Ingeniera fue creada en 1978 y tiene como misin ser una entidad dinmica y de vanguardia que incida de manera decisiva, oportuna y eficiente en los procesos de generacin, transmisin y difusin del conocimiento en el pas, a travs de sus servicios$Hasta 2003 el acervo de la USI estaba dispersa en varias colecciones ubicadas en los diferentes edificios del Instituto de Ingeniera, a partir de esta fecha se logr reunir en un solo espacio todo el material bibliogrfico y hemerogrfico. Actualmente la USI se encuentra ubicada en el basamento de la Torre de Ingeniera del Instituto de Ingeniera.$Informacin proporcionada por: Guillermina Snchez Nahucatl.','http://www.iingen.unam.mx/es-mx/BancoDeInformacion/USI/Paginas/default.aspx','II','','P9B','','31023230152107','31023230152303','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','183.00','','',NULL,NULL,'','bib91.jpg','','','','','','Mbib91.jpg','http://amoxtli.iingen.unam.mx:8991','https://goo.gl/maps/8mHmQF93CAy','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (27,'Biblioteca. Instituto de Investigaciones Bibliotecolgicas y de la Informacin','','','Investigacin en Humanidades                                                                        ','1982','$La biblioteca fue fundada en 1982, unos meses despus de la creacin del CUIB en diciembre de 1981. Inicialmente se instal en el antiguo Colegio de San Idelfonso en el Centro Histrico de la Ciudad de Mxico. En 1988 se cambi a su sede actual en la Torre II de Humanidades en Ciudad Universitaria, donde se ubic en el piso 12, dividida fsicamente en dos secciones. $En 1989 se integr en una sola rea en el piso 13. En el ao 2000 se cambi provisionalmente de sede a las instalaciones de la Direccin de CCH, debido a la remodelacin de los tres pisos del entonces CUIB. A partir del 2002 se encuentra ocupando el piso 11 de la Torre II de Humanidades.$En 2013 con la creacin del Instituto, se consolida como una biblioteca acadmica con carcter de especializada, que rene, organiza, resguarda y difunde una importante cantidad de documentos, en las reas de bibliotecologa y estudios de la informacin, as como disciplinas afines. $Su misin es apoyar las labores de investigacin y docencia del Instituto a travs de los servicios de informacin que se ofrecen a los investigadores y alumnos del posgrado a partir de su acervo documental que se actualiza de forma constante.$$Informacin proporcionada por: Mtro. Jos Manuel Moya Valadz','http://iibi.unam.mx/servicios.html','CIB','','P2B','','32022110452107','32022110452303','0','0.00','0','0.00','0.00','0.00','0','0','408.00','El Centro Universitario de Investigaciones Bibliotecolgicas se transforma en Instituto de Investigaciones Bibliotecolgicas y de la Informacin por Acuerdo del Rector en marzo de 2012. DPLybf','',NULL,NULL,'','bib27.jpg','','','','','','Mbib27.jpg','http://iibiblio.unam.mx:8991','https://goo.gl/maps/xohBPPENYS72','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (86,'Biblioteca "Dr. Dionisio Nieto Gmez"','','','Investigacin Cientfica                                                                            ','1955','1955 ','http://www.biomedicas.unam.mx/_biblioteca/biblioteca.html','HE','','P94','','31203180152107','31203180152303','0','0.00','0.00','0.00','0.00','0.00','0.00','0.00','864.00','','',NULL,NULL,'','bib86.jpg','','','','','','Mbib86.jpg','http://bibliodgb.biomedicas.unam.mx:8991','https://goo.gl/maps/8C36qqDjM5v','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (93,'Biblioteca "Mtro. Jess Silva Herzog"','','','Investigacin en Humanidades                                                                        ','1968','El Centro de Informacin y Documentacin tiene como misin fundamental apoyar el trabajo acadmico de las unidades, seminarios y proyectos de investigacin que se desarrollan en el Instituto de Investigaciones Econmicas de la UNAM, comunidad universitaria y pblico en general.Fundado en 1968, el Centro de Informacin contiene un valioso acervo de fuentes de informacin especializada centrndose en aspectos de la problemtica econmica y social a nivel nacional y regional dentro de Amrica Latina y el Caribe, as como de asuntos a nivel internacional, poltica econmica, finanzas e instituciones financieras, comercio, medio ambiente, industria, empleo, teora econmica, entre otros interesantes temas. El catlogo bibliogrfico dispone actualmente de 18,688 ttulos de libros. Tiene integrada una coleccin de publicaciones peridicas impresas que incluye cerca de 619 ttulos, as como 219 ttulos de bases de datos en disco compacto. Asimismo, cuenta con colecciones especiales conteniendo una amplia cobertura temtica actualizada: artculos de publicaciones peridicas, bibliografas, censos econmicos y de poblacin, aspectos geogrficos del territorio nacional, enciclopedias, obras monogrficas, directorios, diccionarios, tratados y acuerdos comerciales, peridicos de circulacin nacional y aspectos legislativos, anuarios producidos por entidades nacionales y de organismos gubernamentales, regionales e internacionales, as como de otras importantes fuentes de informacin adquiridas y donadas por instituciones acadmicas. Tambin se incluye material estadstico, demogrfico, sectorial y trabajos emanados de conferencias y seminarios que anualmente organiza el Instituto. Texto tomado de la Web del Instituto de Investigaciones Econmicas.',' http://biblioteca.iiec.unam.mx/ ','IQ','','P9D','','32202130152108','32202130152304','0','0.00','0','0.00','0','0.00','0','0','910.00','','',NULL,NULL,'','bib93.jpg','','','','','','Mbib93.jpg','http://biblio192.dgbiblio.unam.mx:8991','https://goo.gl/maps/6sbqzi3sd8t','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (156,'Biblioteca. Instituto de Investigaciones en Ecosistemas y Sustentabilidad','','','Investigacin Cientfica                                                                            ','2003','','http://www.iies.unam.mx/docencia/biblioteca/','CIEC',NULL,NULL,'','','','','','','','','','','','72.00','El Centro de Investigaciones en Ecosistemas creci en docencia, investigacin e infraestructura por lo que se transforma en IIES. Gaceta 14 mayo 2015. DPLybf.','',NULL,NULL,'','bib156.jpg','','','','','','Mbib156.jpg','http://alephmor.matmor.unam.mx:8997','https://goo.gl/maps/sTfKVi5RNYv','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (20,'Biblioteca. Instituto de Matemticas Aplicadas y en Sistemas','','','Investigacin Cientfica                                                                            ','1973','1973 ','http://www.iimas.unam.mx/biblio/','CE','','P1F','','31203220152108','31203220152304','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1067.00','En 2014 se redujo el espacio (40m2) de la biblioteca para hacer sanitarios para discapacitados','',NULL,NULL,'','bib20.jpg','','','','','','Mbib20.jpg','http://132.248.51.234:8991','https://goo.gl/maps/KiEZqNJt4cw','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (76,'Biblioteca. Instituto de Investigaciones en Materiales','','','Investigacin Cientfica                                                                            ','1967','La biblioteca del Instituto de Investigaciones en Materiales fue creada en 1967 en el entonces Centro de Investigaciones en Materiales, se localizaba en un cubculo del mismo Centro en la Torre de Ciencias hoy Torre de Humanidades II. En 1969 el Centro junto con la biblioteca se trasladaron a sus instalaciones actuales en la zona de la investigacin cientfica. Con el paso de los aos y el incremento del acervo y los usuarios la biblioteca se tuvo que mudar a la tambin entonces Unidad de Bibliotecas. Fue en junio de 1994 que se inaugur un nuevo edificio para la biblioteca, el cual fue diseado y construido ex profeso y que junto con el auditorio (con un aforo de 183 personas), constituye uno de los conjuntos ms importante del Instituto.$Actualmente la biblioteca apoya prioritariamente las labores acadmicas que realiza el personal acadmico del Instituto. Posee libros clsicos y recientes sobre ciencia e ingeniera de materiales, forman parte de la coleccin tesis elaboradas por el personal acadmico del IIM, estudiantes asociados y recientemente tesis del posgrado en ciencia e ingeniera de materiales.$Informacin proporcionada por: Lic. Mara Teresa Vzquez Meja.','http://www.iim.unam.mx/biblioteca/','GI','','P8F','','31203240152102','31203240152308','0','0.00','0','0.00','0','0.00','0','0','1297.00','El 2 de diciembre de 2010 sala nueva para la biblioteca','',NULL,NULL,'','bib76.jpg','','','','','','Mbib76.jpg','http://132.248.12.246:8991','https://goo.gl/maps/RJq7DXvNpuN2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (14,'Biblioteca "Justino Fernndez"','','','Investigacin en Humanidades                                                                        ','1936','1936 ',' http://www.esteticas.unam.mx/node/8\011\011 \011\011 ','BE','','P12','','32202140152105','32202140152301','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','741.00','','',NULL,NULL,'','bib14.jpg','','','','','','Mbib14.jpg','http://justino.esteticas.unam.mx:8991','https://goo.gl/maps/z5pjJgkCxXk','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (161,'Biblioteca "Beatriz de la Fuente"','','','Investigacin en Humanidades                                                                        ','2007','$ El Instituto de Investigaciones Estticas de la UNAM en su sede acadmica en Oaxaca da cabida a la Biblioteca Beatriz de la Fuente, instalada en uno de los salones del ex-Palacio Arzobispal, en el Centro Histrico de la ciudad a partir de mayo del 2007.$El acervo de la Biblioteca est integrado por cerca de 8,000 ejemplares y 871 fascculos de publicaciones peridicas que en su mayora pertenecieron a la Dra. Beatriz Ramrez de la Fuente (1929-2005), investigadora emrita especialista en arte prehispnico cuya perspectiva de anlisis ahondaba en la integracin plstica de la arquitectura, la escultura y la pintura en la obra de arte.$El fondo bibliogrfico comprende ttulos relativos al arte prehispnico mesoamericano en particular y a la historia del arte en general; comprende adems temas del rea de humanidades como filosofa, historia, antropologa, sociologa, economa, literatura y educacin. Nuestro creciente acervo incluye publicaciones de apoyo a las lneas de investigacin de los investigadores de la sede y alumnos de la Licenciatura en Historia del Arte de la UABJO, as como publicaciones del Instituto de Investigaciones Estticas y una importante coleccin de facsmiles de cdices prehispnicos y coloniales.$Informacin proporcionada por: Lic. Luca Mercedes Prez Rojas.','http://www.esteticas.unam.mx/node/218','BE1',NULL,'BE1','','','','','','','','','','','','164.00','','',NULL,NULL,'','bib161.jpg','','','','','','Mbib161.jpg','http://justino.esteticas.unam.mx:8991','https://goo.gl/maps/trWs7KZ14122','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (63,'Biblioteca "Dr. Rubn Bonifaz Nuo"','','','Investigacin en Humanidades                                                                        ','1988','Con el propsito de reunir en un solo acervo y un nico espacio arquitectnico los recursos humanos y documentales pertenecientes a las bibliotecas de los cuatro centros y el seminario que entonces lo integraban, el Instituto de Investigaciones Filolgicas (IIFL) cre en 1988 su Biblioteca.$En un principio, la Biblioteca del IIFL slo concentr los acervos de la Biblioteca y Hemeroteca del Centro de Estudios Literarios -creados en 1956-, la Biblioteca del Centro de Estudios Mayas -conformada en 1970 a partir de los acervos de los Seminarios de Cultura (1959) y de Escritura Maya (1967)-, la Biblioteca del Centro de Estudios Clsicos -instituida en 1973 y antecedida por la Biblioteca del Centro de Traductores de Lenguas Clsicas (1966)-, la Biblioteca del Centro de Lingstica Hispnica -fundada en 1967-, y la Biblioteca del Seminario de Potica -creada en 1977-. $sus colecciones se han ido enriqueciendo con la fundacin del Seminario de Lenguas Indgenas en septiembre de 1988, a los acuerdos interinstitucionales y las generosas donaciones de particulares. En 1961, diez mil volmenes provenientes de la biblioteca personal del Dr. Julio Jimnez Rueda fueron integrados al acervo de la Biblioteca del Centro de Estudios Literarios; en 1979, la empresa Altos Hornos de Mxico cedi al IIFL la coleccin de libros franceses de la biblioteca de Jaime Torres Bodet; en 1982, la biblioteca particular de Demetrio Sodi Morales fue donada al Centro de Estudios Mayas, y en 1991, el IIFL recibi en donacin la biblioteca del escritor Manuel Maples Arce.$El 26 de noviembre de 1996, se inaugura la Biblioteca ','http://www.iifilologicas.unam.mx/bibliotecaiifl/ ','FL','','P84','','32022190152102','32022190152308$32202190152306','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','2100.00','','',NULL,NULL,'','bib63.jpg','','','','','','Mbib63.jpg','http://filologicas.filologicas.unam.mx:8991','https://goo.gl/maps/cmPRGjDk55B2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (61,'Biblioteca "Eduardo Garca Mynez"','','','Investigacin en Humanidades                                                                        ','1940','Los antecedentes de la biblioteca se remontan al ao de 1940 cuando en el mes de enero se fund el Centro de Estudios Filosficos como parte de la Facultad de Filosofa y Letras en las instalaciones del edificio Mascarones.$Sin embargo, es hasta 1945 cuando se estableci la Biblioteca del Centro de Estudios Filosficos de manera formal. En 1954 el Centro se instal en Ciudad Universitaria, en el cuarto piso de la Torre de Humanidades. En 1966 la Biblioteca reuna ya cerca de 8,000 volmenes.$En 1967 el Consejo Universitario aprob los estatutos para que el Instituto adquiriera su actual denominacin. En 1968 la Biblioteca contaba con 15,500 volmenes y 156 ttulos de publicaciones seriadas. Dos dcadas despus el Instituto cambi de sede a las instalaciones actuales, en los terrenos de la Ciudad de las Humanidades, con un espacio diseado ex profeso para la Biblioteca.$En 1996 se inici el proyecto de ampliacin y remodelacin de la misma. En el ao 2001 se realizaron obras de ampliacin y remodelacin de la Biblioteca. En 2005 se contaba con un acervo de ms de 30 mil ttulos y ms de 40 mil volmenes y con 353 ttulos de revistas algunas de ellas disponibles en lnea.$En 2006 se llevaron a cabo obras de ampliacin y remodelacin de la biblioteca, creando dos nuevas reas: Fondo Reservado y Biblioteca Digital. Asimismo se puso en marcha el mdulo de circulacin en la nueva versin del programa de automatizacin ALEPH. En materia de desarrollo de colecciones se incorporaron libros electrnicos y se modific la pgina web de la biblioteca. En 2007 se liber el catlogo en lnea de las publicaciones seriadas.$Informacin proporcionada por: Mtro. Miguel Gama Ramrez.','http://biblio.unam.mx:8230/','FE','','P81','','32202150152102','32202150152308','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','789.00','','',NULL,NULL,'','bib61.jpg','','','','','','Mbib61.jpg','http://biblioteca1.filosoficas.unam.mx:8991','https://goo.gl/maps/UxdMZW6huWx','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (62,'Biblioteca "Rafael Garca Granados"','','','Investigacin en Humanidades                                                                        ','1954','En 1954 se cre la biblioteca; en ese ao el entonces Instituto de Historia se traslad del pequeo local que ocupaba en la Biblioteca Nacional, antiguo templo de San Agustn (Uruguay e Isabel La Catlica) al sptimo piso de la Torre de Humanidades, en Ciudad Universitaria. Fue entonces cuando por primera vez se cont con un espacio apropiado para la organizacin de la biblioteca. El cambio de sus instalaciones se realiz en 1986 a la Ciudad de la Investigacin en Humanidades, donde comparte desde aquel entonces el edificio con el Instituto de Investigaciones Estticas. La biblioteca ha sufrido dos remodelaciones arquitectnicas, la primera tuvo lugar en 1996-1997 y la segunda en 2004-2006.$El ncleo original de su acervo lo constituye la donacin de la coleccin particular de Rafael Garca Granados, fundador del Instituto y en cuyo honor la biblioteca lleva su nombre. A esta donacin se fueron agregando otras donaciones importantes, como han sido las colecciones de Juan Comas, Manuel Maldonado Koerdel, Peter Gerhard, H. Pittschman,  el Legado Miguel Muoz, la Hacienda Ysita Rubio, Ernesto de la Torre Villar y Jess de Garritz.$Las colecciones con las que cuenta la Biblioteca son la coleccin de consulta, la coleccin general, la coleccin hemerogrfica, las bases de datos Hermes e Histrica, el Fondo Reservado, la coleccin ','http://www.historicas.unam.mx/biblioteca/metabuscador.html','FH','','P83','','32202160152109','32202160152305','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','1023.00','Remodelacin de la biblioteca adaptacin de un segundo piso 2012-2013','Incorporacin de 8 mil titulos pertenecientes a la biblioteca de la Sociedad Antonio Alzate.  Gaceta 22 agosto 1994. DPLybf.',NULL,NULL,'','bib62.jpg','','','','','','Mbib62.jpg','http://exlibris.historicas.unam.mx:8991','https://goo.gl/maps/RmVFkhr3CXS2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (45,'Biblioteca "Jorge Carpizo"','','','Investigacin en Humanidades                                                                        ','1940','El Acervo Tradicional de la Biblioteca se comenz a formar desde 1940, ao en el que se fund el Instituto de Investigaciones Jurdicas.$La primera sede de la Biblioteca se aloj en el Centro Histrico de la Ciudad de Mxico en un despacho de la Calle Artculo 123, que se alquil en 1941 para alojar al entonces Instituto de Derecho Comparado. En 1945, el Instituto se traslad al anexo de la Escuela Nacional de Jurisprudencia, en San Ildefonso. Con la inauguracin de la Ciudad Universitaria, en 1954, el Instituto y su Biblioteca se mudan al tercer piso de la Torre I de Humanidades, en donde permanecen hasta 1976, ao en que se reubican en el piso cuarto, quinto y mitad del decimotercero de la Torre de Ciencias, hoy Torre II de Humanidades.$El 31 de julio de 1986 se inaugur la nueva sede del Instituto en la Ciudad de la Investigacin en Humanidades en donde se aloj la Biblioteca Jorge Carpizo en un espacio especialmente dispuesto para la misma. En el ao 2007 se construy una bveda con temperatura y humedad especiales para conservar los diez mil volmenes que conforman el Fondo Reservado de la  Biblioteca.$Informacin proporcionada por: Mtra. Rosa Mara Alvarez de Lara','http://www.juridicas.unam.mx/infjur/bib/','DC','','P60','','32202170152106','32202170152302','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','2377.00','','',NULL,NULL,'','bib45.jpg','','','','','','Mbib45.jpg','http://biblioteca.juridicas.unam.mx:8991','https://goo.gl/maps/JquSpveTpF42','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (22,'Biblioteca. Instituto de Investigaciones sobre la Universidad y la Educacin','','','Investigacin en Humanidades                                                                        ','1980','La biblioteca   fue creada  en 1976 en el Centro de Estudios sobre la Universidad (CESU) como apoyo a las investigaciones del Archivo Histrico de la UNAM (AHUNAM)  separando los materiales bibliohemerogrficos de la coleccin documental del Archivo Histrico.  $En septiembre de 2006, el H. Consejo Universitario, reconociendo la labor acadmica del CESU, cambi su denominacin y responsabilidad  institucional como Instituto de Investigaciones sobre la Universidad y la Educacin (IISUE)$Desde agosto de ese mismo ao la biblioteca ocupa sus nuevas instalaciones, en el Centro Cultural Universitario, al lado norte de la Sala Nezahualcoyotl.$Su acervo  ocupa un lugar prominente entre las bibliotecas especializadas en el campo educativo en Mxico. $Informacin proporcionada por: Graciela A. T. Alessio-Robles Paredes.','http://www.iisue.unam.mx/biblioteca/','CEU','','P22','','32042110252109','32022110252309$32032110252302$32042110252305','0','0.00','0','0.00','0.00','0.00','0.00','0.00','961.00','','',NULL,NULL,'','bib22.jpg','','','','','','Mbib22.jpg','http://biblioteca.isue.unam.mx:8991','https://goo.gl/maps/zMdWaqEmxQm','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (52,'Biblioteca. Instituto de Investigaciones Sociales','','','Investigacin en Humanidades                                                                        ','1939','El Instituto de Investigaciones Sociales (IIS) de la UNAM se distingue en el contexto latinoamericano por una labor acadmica ininterrumpida de ms de 60 aos, y en su trayectoria se manifiestan diversas tendencias temticas, as como variaciones metodolgicas y tcnicas que hasta la fecha siguen vigentes. En 1939:, el trabajo de las diversas reas del Instituto demanda ya la creacin de un espacio para resguardar el material de investigacin, de estudio y de comprobacin que se vaya obteniendo. El Dr. Mendieta organiza el Instituto en reas; en donde considera la Seccin de Biblioteca, Archivo y Relaciones Exteriores ','http://www.iis.unam.mx/indexcontent.php?_module=415&517a2b06a743137f8c3bad3be21a6e32','DS','','P73','','32202180152103','32202180152309','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','862.00','','',NULL,NULL,'','bib52.jpg','','','','','','Mbib52.jpg','http://132.248.234.82:8991','https://goo.gl/maps/GvXbshn9YsP2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (34,'Biblioteca del Campus Juriquilla','','','Investigacin Cientfica                                                                            ','1995','',' http://www.inb.unam.mx/biblioteca/biblioteca.html ','CNQ','','PF5','','31013310152103','31023310152302','0','0.00','0','0.00','0','0.00','0','0','0.00','','Las instalaciones  del Instituto de Neurobiologia se construyeron de abril a octubre de 1996 en Campus Juriquilla, con una superficie de 10 mil m2.  Gaceta  2987. 6 febrero 1996',NULL,NULL,'','bib34.jpg','','','','','','Mbib34.jpg','http://132.248.248.1:8991','https://goo.gl/maps/mudgSTkd9NF2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (118,'Biblioteca "Jess Romo Armera"','','','Investigacin Cientfica                                                                            ','1941','El Instituto de Qumica se funda el 5 de abril de 1941 gracias al empeo de su primer director (1941-1953) el Dr. Fernando Orozco y al Dr. Antonio Medinaveitia, quien haba sido nombrado investigador  del Instituto.  $El Instituto se ubicaba en la Escuela Nacional de Ciencias Qumicas de Tacuba. Constaba de dos laboratorios y una biblioteca, que en realidad se trataba de una coleccin de unos cuantos libros y una copia del Beilstein (coleccin de gran importancia para la qumica orgnica)  en cuatro tomos.  $ A partir de 1942 el Instituto  logr publicar el primer volumen del Boletn del Instituto de Qumica en diciembre de 1945.  Otra donacin que apoyara fundamentalmente la adquisicin de acervo para la biblioteca fue la del Comit Interamericano de Publicacin Cientfica de Nueva York.  Con esta donacin se adquirieron obras de consulta y colecciones de revistas, algunas de ellas desde su inicio de publicacin.$En el ao de 1954, con la construccin de Ciudad Universitaria, el Instituto se traslada a los pisos 11, 12 y 13 de la Torre de Ciencias (actualmente Torre II de Humanidades). La biblioteca se aloj en el piso 11.   $En 1977 el Instituto se traslada a sus nuevas instalaciones en donde se le da un espacio a la biblioteca con estantera cerrada y se le confiere el nombre de ','http://www.iquimica.unam.mx/biblioteca/','MQ','','PB7','','31203210152101','31203210152307','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','775.00','','',NULL,NULL,'','bib118.jpg','','','','','','Mbib118.jpg','http://132.248.11.3:8991','https://goo.gl/maps/Egn4VVtpRuR2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (124,'Biblioteca. Programa Universitario de Estudios sobre la Ciudad','','','Investigacin en Humanidades                                                                        ','1995','','http://biblio.unam.mx:8380/','PEC','','P29','','45022110852101','45022110852307','0.00','0.00','0.00','0.00','0.00','0.00','0.00','0.00','25.00','A partir de junio 2016 cambia de sede la biblioteca a Repblica de Cuba. En censo 2017 revisar que se actualizen los metros cuadrados. DPLybf','A partir del 6 de marzo de 2000 el PUEC forma parte de la Coordinacin de Humanidades. Gaceta 3375. El 15 junio 2000.DPLybf',NULL,NULL,'','bib124.jpg','','','','','','Mbib124.jpg','http://132.248.114.6:8991','https://goo.gl/maps/nLqejLAxF6M2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (157,'Biblioteca. Unidad Acadmica de Estudios Regionales ','','','Investigacin en Humanidades                                                                        ','2005','En el ao de 1976 se cre el Centro de Estudios de la Revolucin Mexicana Lzaro Crdenas A. C., en la ciudad de Jiquilpan de Jurez, Michoacn, con el objetivo de estudiar la revolucin mexicana y promover investigaciones sobre los problemas socioeconmicos de la regin. Con este cometido el Centro promovi y realiz investigaciones sobre migracin, historia y testimonios orales; adems, reuni una biblioteca, un acervo de documentos de valor histrico significativo, una hemeroteca, una coleccin de piezas prehispnicas de la regin y un museo dedicado al General Lzaro Crdenas. El 1 de diciembre de 2005 la UNAM recibi en comodato las instalaciones, el mobiliario, el acervo documental, bibliogrfico y museogrfico del Centro de Estudios de la Revolucin Mexicana Lzaro Crdenas A. C, dando lugar a la creacin de la Unidad Acadmica de Estudios Regionales (UAER) de la Coordinacin de Humanidades en atencin a los siguientes antecedentes: La experiencia del subsistema de Humanidades desde la creacin del CRIM en el ao de 1985 y de UACSHUM en 2004.  El renovado inters y compromiso de la actual administracin de la UNAM de ampliar su presencia en las distintas regiones del pas para fortalecer su carcter y responsabilidad nacional; atender lneas de investigacin de relevancia regional y en perspectiva mundial; promover la realizacin de las estrategias de investigacin que demanda la creciente complejidad del conocimiento; y la afirmacin de problemticas que requieren el concurso pluridisciplinario y la colaboracin interinstitucional. El renovado compromiso de la Coordinacin de Humanidades de impulsar la descentralizacin de la investigacin social y humanstica que se realiza en la UNAM y de fomentar nuevas estrategias de investigacin, as como en la formacin de recursos humanos y la difusin de la cultura. texto tomado de la WEB de la Unidad  Acadmica de Estudios Regionales','http://uaer.humanidades.unam.mx/biblioteca/introduccion/','UAER',NULL,NULL,'','','','','','','','','','','','223.00','Biblioteca dada de alta en 2007. DPLybf','',NULL,NULL,'','bib157.jpg','','','','','','Mbib157.jpg','http://201.109.10.69:8991','https://goo.gl/maps/yDK7GDriVBB2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (160,'Centro de Documentacin','','','Investigacin Cientfica                                                                            ','2006','El Centro de Investigaciones en Geografa Ambiental (CIGA) de la UNAM, tiene su origen en el Instituto de Geografa de la UNAM, en 2001 se dio la oportunidad de que un grupo de investigadores y tcnicos acadmicos se vinieran a trabajar a la Ciudad de Morelia para realizar investigaciones en temas geogrficos que coadyuven a estudiar y solucionar problemas ambientales de la regin, gracias a la poltica de descentralizacin de la UNAM y a los logros obtenidos durante estos 6 aos, se pudo crear el 17 de agosto de 2007 el Centro de Investigaciones en Geografa Ambiental, durante sus inicios se pens en contar con instalaciones adecuadas, laboratorios, aulas y el Centro de Documentacin que debera cumplir el siguiente objetivo: Centro bibliogrfico, cartogrfico y documentacin para apoyar la investigacin y docencia en geografa ambiental, que formar parte de la Red de Bibliotecas de la UNAM, con la tarea de generar una base de datos bibliogrfica automatizada, una mapoteca digital y la difusin de los productos generados a travs de medios electrnicos. El Centro de Documentacin inicia sus actividades en 2009 en un espacio ex profeso para el desarrollo de sus colecciones y servicios de informacin, durante este periodo recibi la donacin de libros y revistas tanto de particulares como de instituciones ligadas al estudio de la Geografa, actualmente alberga una coleccin de 3200 volmenes de libros,  contiene en su acervo mapas, atlas, diccionarios, enciclopedias y revistas, el Centro de Documentacin se ha especializado en temas concernientes a la Geografa Ambiental como: Ambientes Rurales, Urbanos y Periurbanos, Historia Ambiental, Territorialidad,  Paisaje, etc.. Apoya a la licenciatura en GeoHistoria que es impartida en la Escuela Nacional de Estudios Superiores Campus Morelia, as como tambin al posgrado de la Maestra en Geografa con la especialidad en Manejo Integrado del Paisaje y el Doctorado en Geografa, adems apoya aquellas personas e instituciones interesadas en este campo del conocimiento.','http://www.ciga.unam.mx/index.php/servicios/2014-04-08-23-00-28',NULL,'GG1','GG1','','','','','','','','','','','','285.99','Biblioteca dada de alta en 14 feb 2014. DPLybf','',NULL,NULL,'0','bib160.jpg','','','','','','Mbib160.jpg','http://alephmor.matmor.unam.mx:8998','https://goo.gl/maps/4rsA1fzATvx','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (31,'Biblioteca "Stephen A. Bastien"','','','Licenciatura y Posgrado                                                                             ','1980','En 1979 se instala la biblioteca e inicia el servicio de prstamo, con un acervo de 5000 volmenes aproximadamente. El acervo original proviene de las donaciones realizadas por las embajadas de Alemania, Francia, Estados Unidos y el Consejo Britnico, de los materiales que se encontraban en los cubculos de los profesores y de las adquisiciones  realizadas por el proyecto  de la maestra en lingstica aplicada de la Unidad Acadmica de los Ciclos Profesional y Posgrado del CCH.$En 1980 la biblioteca abre sus puertas al pblico, ofrece los servicios de prstamo interno, a domicilio e interbibliotecario. Ms tarde en 1984 la biblioteca se trasladada a un local adaptado en el edificio A del CELE. El 14 de mayo de ese ao el Consejo Asesor del CELE acord nombrar a la biblioteca ','http://cele.unam.mx/index.php?categoria=15','CL','','P33','','11206120152102','11206120152308','0','0.00','0','0.00','0.00','0.00','0','0','535.00','','',NULL,NULL,'','bib31.jpg','','','','','','Mbib31.jpg','http://catalogo.cele.unam.mx:8991','https://goo.gl/maps/1xTi2Ctwi2J2','NOMBREcorto');
INSERT INTO "datosbiblio" ("bib_id","nombre","nombre_abrev","adscripcion","subsistema","ano_fundacion","ref_historica","pag_web","control_dgb","control_lc","control_hx","categoria","cod_prog_lib","cod_prog_rev","prep_asig521","prep_ejer521","prep_asig523","prep_ejer523","prep_asig421","prep_ejer421","prep_enc_asig","prep_enc_ejer","superficie","observaciones","datospropbib_obs","status","spnosis","objetivo","foto","catalogolibros","catalogorev","catalogomap","ariel","contacto","fotomapa","opac","google","nombrecorto") VALUES (39,'Biblioteca. "Dr. Ignacio Renero Ambros"','','','Bachillerato                                                                                        ','1971','La biblioteca del Colegio de Ciencias y Humanidades Plantel Naucalpan comienza a funcionar poco tiempo despus de la fundacin del Colegio en 1971. En un principio su acervo esta dividido y resguardado en 2 edificios distintos: La coleccin para uso de los docentes se ubicaba en el Edificio del PEC y la coleccin general comparta espacio con la sala de Usos mltiples y Teatro, en el edificio que actualmente ocupa Audiovisuales. Los servicios que ofreca era Consulta, Hemeroteca, Consulta en Sala y Prstamo  a domicilio. La estantera era cerrada.  Conforme fueron creciendo el acervo y los servicios se vio la necesidad de contar con un edificio propio, el cual fue inaugurado en el ao de 1981 y en el que sigue funcionando a la fecha. Los servicios que se ofrecen son: Estantera abierta (desde 1991), sala de lectura, Consulta, Hemeroteca, Prstamo a domicilio automatizado, catalogo en lnea y sala computo para maestros. El acervo esta conformado 17103 ttulos y 182897 ejemplares, entre libros, revistas, peridicos, CD y mapas. Es a partir de agosto de 2005, que la biblioteca lleva el nombre de ','http://www.cch-naucalpan.unam.mx/index.php','CYHA','','P46','','21014720352106','21204720352303','0','0.00','0','0.00','0.00','0.00','0','0','1897.00','','',NULL,NULL,'','bib39.jpg','','','','','','Mbib39.jpg','http://biblioteca.cch-naucalpan.unam.mx:8991','https://goo.gl/maps/FNAUB5Kp2Zy','NOMBREcorto');
--
-- Data for TOC Entry ID 59 (OID 3235359)
--
-- Name: direccion Type: TABLE DATA Owner: israeld
--


INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (94,34,94,0,'Centro Acadmico Cultural (UNAM)','Boulevard Juriquilla No. 3001','Juriquilla','','Quertaro','Mxico',31,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (17,0,17,0,'Av. Universidad No.  2001','Col.  Chamilpa','','Cuernavaca','Morelos','Mxico',161,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (207,0,104,0,'','','','','','',NULL,'0','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (13,0,13,0,'Boulevard Juriquilla No. 3001','','Juriquilla','','Quertaro','Mxico',157,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (16,0,16,0,'Privada  Xochicalco S/N','Col. Centro','Temixco','','Morelos','Mxico',160,'62580','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (100,144,100,0,'Av. Universidad 2001','Col. Chamilpa','Cuernavaca','','Morelos','Mxico',139,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (100,0,100,0,'Av. Universidad No. 2001','Col. Chamilpa','','Cuernavaca','Morelos','Mxico',330,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (8,0,8,0,'Av. Universidad S/N','Col. Chamilpa','','Cuernavaca','Morelos','Mxico',152,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (62,0,62,0,'Av. de los Barrios  No. 1 ','Col. Los Reyes Iztacala','Tlalnepantla de Baz','','Estado de Mxico','Mxico',206,'54090','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (105,0,105,0,'Antigua Carr. a Ptzcuaro No. 8701 ','Col. Ex Hacienda de San Jos de la Huerta','Morelia','','Michoacn','Mxico',341,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (215,0,109,0,'Antigua Carr. a Ptzcuaro  No. 8701, ','Col. Ex-Hacienda San Jos de la Huerta','','Morelia','Michoacn','Mxico',346,'58089','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (102,0,102,0,'Boulevard Juriquilla No. 3001','','Juriquilla','','Quertaro','Mxico',334,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (94,0,94,0,'Boulevard Juriquilla No. 3001','','Juriquilla','','Quertaro','Mxico',324,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (9,0,9,0,'Km. 107, Carr. Tijuana-Ensenada S/N','','Ensenada','','Baja California','Mxico',153,'22800','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (61,0,61,0,'Edif. de Gobierno de la FES-Cuautitln, P. A. Km. 2.5   Carr. Cuautitln-Teoloyucan','Col. San Sebastin Xhala','Cuautitln Izcalli','','Estado de Mxico','Mxico',205,'54714','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (123,0,123,0,'Antigua Carr. a Ptzcuaro No. 8701','Col. Ex-Hacienda San Jos de la Huerta','Morelia','','Michoacn','Mxico',76,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (244,0,124,0,'Blvd. UNAM 2911','El Saucillo y el Potrero','Comunidad de los tepetates','','Len, Guanajuato','',NULL,'37684','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (246,0,125,0,'Antigua carretera a Ptzcuario No. 8701','','Ex hacienda de San Jos de la Huerta','Morelia','Michoacan','',NULL,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (243,159,124,0,'Blvd. UNAM 2011.','Predio el Saucillo y el Potrero','Comunidad de los Tepetates','Len,','Gto.','Mxico',NULL,'37684','0','0');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,145,67,50,'Km. 5.5 Carr. Federal  Martnez de la Torre-Tlapacoyan.','','Martnez de la Torre,','','Veracruz','Mxico',140,'93600','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,57,67,23,'Km. 53.1 Carr. Federal Mxico-Cuernavaca.','Pueblo de Tres Maras','Huitzilac,','','Morelos','Mxico',54,'62515','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (103,154,103,0,' Ex sanatorio Rendn Peniche, Calle 43 s/n entre 44 y 46','Col. Industrial','Mrida,','','Yucatn','Mxico',338,'97150','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (3,94,3,0,'Av. Universidad n. 2001','Col. Chamilpa','Cuernavaca,','','Morelos','Mxico',90,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (85,161,85,54,'Edif. ex palacio Arzobispal, 1er. piso. Antonio de Len No. 2, Altos.','Centro Histrico','','Oaxaca,','Oaxaca','Mxico',NULL,'68000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (99,90,99,0,'Mara Adelina Flores n. 34 A','Barrio de Guadalupe','San Cristbal de las Casas,','','Chiapas','Mxico',86,'29230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (209,157,106,0,'Av.  Lzaro Crdenas s/n, esq. Felicitas del Ro. ','Col. Jiquilpan','Jiquilpan de Jurez,','','Michoacn','Mxico',NULL,'59510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (208,155,104,0,'Centro Acadmico Cultural (UNAM)','Boulevard Juriquilla n. 3001','Juriquilla,','','Quertaro','Mxico',NULL,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (123,158,123,0,'Antigua Carr. a Ptzcuaro n. 8701','Col. ex hacienda San Jos de la Huerta','Morelia,','','Michoacn','Mxico',76,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (17,24,17,0,'Av. Universidad n. 2001','Col. Chamilpa','Cuernavaca,','','Morelos','Mxico',22,'62210','La biblioteca del Centro de Ciencia Genmicas e Instituto de Biotecnologia funciona temporalmente en las instalaciones de  la Biblioteca del Instituto de Ciencias Fsicas enfrente de CCG a partir de enero 2013, disponen de acervo impreso en libros, las revistas se encuentran en bodega. 21/mayo/2013. DPLybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (105,156,105,0,'Antigua Carr. a Ptzcuaro No. 8701.','Col. ex hacienda de San Jos de la Huerta','Morelia,','','Michoacn','Mxico',340,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (245,160,125,0,'Antigua Carr. a Ptzcuaro n. 8701.','Col. ex hacienda de San Jos de la Huerta','Morelia','Morelia,','Michoacn','Mxico',NULL,'58190','0','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (71,3,71,1,'Km.103, Carr. Tijuana-Ensenada','','Ensenada,','','Baja California','Mxico',2,'22860','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (72,55,72,13,'Km. 30, Carr. Catemaco-Montepo.','','San Andrs Tuxtla,','','Veracruz','Mxico',52,'95701','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (74,117,74,48,'Prolong. Av. Nios Hroes s/n','Puerto Morelos,','','','Quintana Roo','Mxico',113,'77580','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (74,116,74,47,'Av. Cap. Joel Montes Camarena s/n.','Col. Cerro del Crestn','Mazatln,','','Sinaloa','Mxico',112,'82040','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (74,115,74,46,'Av. Adolfo Lpez Mateos n. 1.','Cd. del Carmen,','','','Campeche','Mxico',111,'24140','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (16,77,16,0,'Privada  Xochicalco s/n','Col. Centro','Temixco,','','Morelos','Mxico',74,'62580','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (80,88,80,45,'Av. Luis Donaldo Colosio, esq. Madrid s/n. ','Campus UNISON','Hermosillo,','','Sonora','Mxico',84,'83000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (18,153,18,53,'Ex fbrica de San Manuel s/n.','San Miguel Contla','Mpio. Santa Cruz,','Tlaxcala,','Tlaxcala','Mxico',337,'90640','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (102,150,102,0,'Centro Acadmico Cultural (UNAM)','Boulevard Juriquilla n. 3001','Juriquilla,','','Quertaro','Mxico',NULL,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (13,89,13,0,'Centro Acadmico Cultural (UNAM)','Boulevard Juriquilla n. 3001','Juriquilla,','','Quertaro','Mxico',85,'76230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (216,1090,109,0,'Antigua Carr. a Ptzcuaro n. 8701, ','Col. ex hacienda San Jos de la Huerta','','Morelia,','Michoacn','Mxico',347,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (73,120,73,0,'Edif. contiguo al Inst. de Inv. en Materiales. Circuito Exterior. ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','D.F.','Mxico',116,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (47,7,47,0,'Av. Rancho Seco s/n.','Col. Impulsora','Mpio. Nezahualcyotl,','','Estado de Mxico','Mxico',5,'57130','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (47,0,47,0,'Av. Rancho Seco S/N','Col. Impulsora','Cd. Nezahualcyotl','','Estado de Mxico','Mxico',191,'57130','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (61,36,61,0,'Av. Primero de Mayo s/n.','Col. Sta. Mara las Torres','Cuautitln Izcalli,','','Estado de Mxico','Mxico',33,'54740','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (62,95,62,0,'Av. de los Barrios n. 1.','Col. Los Reyes Iztacala,','Tlalnepantla de Baz,','','Estado de Mxico','Mxico',91,'54090','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (51,0,51,0,'Av. de los Remedios No. 10','Col. Bosques de los Remedios','Naucalpan de Jurez','','Estado de Mxico','Mxico',194,'53400','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (51,39,51,0,'Av. de los Remedios n. 10.','Col. Bosque de los Remedios','Mpio. Naucalpan de Jurez,','','Estado de Mxico','Mxico',36,'53400','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (46,0,46,0,'Av. Alcanfores S/N y Av. San Juan Totoltepec','Col. Santa Cruz Acatln','Naucalpan de Jurez','','Estado de Mxico','Mxico',190,'53150','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (46,4,46,0,'Av. Alcanfores y San Juan Totoltepec.','Col. Santa Cruz Acatln','Naucalpan de Jurez,','','Estado de Mxico','Mxico',3,'53150','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (61,37,61,10,'Km. 2.5  Carr. Cuautitln-Teoloyucan. ','Col. San Sebastin Xhala','Cuautitln Izcalli,','','Estado de Mxico','Mxico',34,'54714','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (93,147,93,26,'Av. Universidad s/n','Col. Lomas de Chamilpa','Cuernavaca,','','Morelos','Mxico',142,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,70,67,49,'Km. 2 Carr. Jilotepec-Corrales.','Col. La Dalia','Jilotepec,','','Estado de Mxico','Mxico',67,'54240','0','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (9,73,9,0,'CNyN-UNAM. Km. 107, Carr. Tijuana-Ensenada s/n. Edif. C','','Ensenada,','','Baja California','Mxico',70,'22800','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (72,56,72,14,'Km.59, Carr. Federal  200, Barra de Navidad-Puerto Vallarta','','Chamela','','Jalisco','Mxico',53,'48895','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (248,162,126,0,'Antigua carretera a Ptzcuaro No. 8701','Col. ex hacienda San Jos de la Huerta','Morelia,','','Michoacn','Mxico',NULL,'58190','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (8,72,8,0,'Av. Universidad n. 2001.','Col. Chamilpa,','Cuernavaca,','','Morelos','Mxico',69,'62210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (1,13,1,0,'Edif. de la ex Unidad de Bibliotecas de la Inv. Cientfica. Circuito Exterior de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',11,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (7,0,7,0,'Circuito Exterior ','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',151,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (7,30,7,0,'Circuito Exterior ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',27,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (101,0,101,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',331,'4510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (101,146,101,0,'Edif. de la ex Unidad de Bibliotecas de la Inv. Cientfica, Circuito de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',141,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (10,31,10,0,'Edif. B, Stano (entre las facultades de Qumica e Ingeniera) Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',28,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (14,92,14,0,'Torre II de Humanidades 6o. piso. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',88,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (11,0,11,0,'Av. Universidad No. 3002 (Col. Copilco)','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',155,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (15,58,15,0,'Torre II de Humanidades 1er. piso. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',55,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (2,21,2,0,'Torre II de Humanidades 2o. piso. Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',19,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (4,0,4,0,'Circuito Mario de la Cueva, entre Filmoteca y TV UNAM','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',148,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (4,48,4,0,'Edif. entre Filmoteca y TV UNAM. Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',45,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (6,0,6,0,'Centro Cultural Universitario','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',150,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (6,38,6,0,'Edif.  anexo  al CUT, 1er. piso, Centro Cultural Universitario, atrs de la Sala Nezahualcyotl.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',35,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (212,1070,107,0,'Edif. Consejos Acadmicos de rea, Planta Alta a un costado de la DGCCH, Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','',343,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (211,0,107,0,'Edif. Consejos Acadmicos de rea, a un costado de la DGCCH, Circuito Exterior','Ciudad  Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',342,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (217,0,110,0,'Edif. de la Coordinacin Cientfica, Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',348,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (218,1100,110,0,'Edif. de la Coordinacin Cientfica. Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',349,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (219,0,111,0,'Av. Insurgentes Sur  No. 3000','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',350,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (220,1110,111,0,'Av. Insurgentes Sur n. 3000','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',351,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (26,0,26,0,'Unidad de Posgrado, Edif. H.  P. B. Circuito de Posgrados','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',170,'04510','Cambio de lugar antes de ubicaban en  circuito escolar en la unidad de posgrado a un lado de la Torre II de Humanidades  a partir de mayo de 2013 cambian a  la Unidad de Posgrado ubicado cerca de la Av. Insurgentes y la Reserva  Ecolgica del Pedregal. DPL. ybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (18,0,18,0,'Edif. de la CUAED, frente a la ENTS, Circuito Exterior, ','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',162,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (222,1120,112,0,'Lado Norte del Estadio Olmpico. Circuito Estadio Olmpico.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',353,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (229,0,116,0,'Edif. Rectora 2o. piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',360,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (230,1160,116,0,'Edif. Rectora 2o. piso. Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',361,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (231,0,117,0,'Edif. Estudios Administrativos 2o. Piso, Circuito de la Zona Adminstrativa Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',362,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (232,1170,117,0,'Edif. Estudios Admnistrativos 2o. piso, Circuito de la Zona Administrativa Exterior','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',363,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (19,0,19,0,'Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',163,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (19,64,19,0,'Circuito Mtro. M. de la Cueva. ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',61,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (21,0,21,0,'Museo Universitario Arte Contemporneo, Insurgentes Sur, No. 3000','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',165,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (21,28,21,0,'Museo Universitario de Arte Contemporneo, Planta Baja. Insurgentes Sur  n. 3000.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',26,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (223,0,113,0,'Edif. C, 1er. Piso,  Circuito Zona Administrativa Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',354,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (224,1130,113,0,'Edif. C, 1er. piso. Circuito Zona Administrativa Exterior','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',355,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (30,50,30,0,'Edif. de Servicios Mdicos, Planta Baja. Entrada Principal, lado poniente. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',47,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (30,0,30,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',174,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (23,0,23,0,'Edif. Biblioteca Central, Entrepiso. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',167,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (23,12,23,5,'Edif. de Biblioteca Central, Planta Principal. Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',10,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (23,26,23,6,'Edif. Anexo de la D.G.B.,  contiguo a la BCCT, 1er. piso, Circuito de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',24,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (31,0,31,0,'Edif.  DGCTIC. P. B., Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',175,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (31,131,31,42,'Ribera de San Cosme n. 71.','Col. Sta. Mara la Ribera','Del. Cuauhtmoc,','Mxico, ','Cd. Mx.','Mxico',127,'06400','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (31,130,31,41,'Av. Nuevo Len n. 167, Edif. DGCTIC Nuevo Len, 3er. piso.','Col. Hipdromo Condesa','Del. Cuauhtmoc,','Mxico, ','Cd. Mx.','Mxico',126,'06100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (25,0,25,0,'Edif. B, 4o. piso, Circuito de la Zona Administrativa  Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',169,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (25,109,25,0,'Edif. B, 4o. piso, Circuito de la Zona Administrativa Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',105,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (225,0,114,0,'Edif.  Consejos Acadmicos de rea a un costado de la DGCCH, Circuito  Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',356,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (226,1140,114,0,'Edif. Consejos Acadmicos de rea a un costado de la DGCCH. Circuito Exterior','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',357,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (24,0,24,0,'Edif. UNIVERSUM. Zona Cultural, Circuito de la Inv. en Humanidades ','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',168,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (24,123,24,0,'Edif. UNIVERSUM, Zona Cultural. Circuito de la Inv. en Humanidades.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',119,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (227,0,115,0,'Lado Sur de la Sala Nezahualcyotl, Centro Cultural Universitario','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',358,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (228,1150,115,0,'Lado Sur de la Sala Nezahualcyotl, Centro Cultural Universitario','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',359,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (233,0,118,0,'Av. Universidad No. 3000','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',364,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (234,1180,118,0,'Av. Universidad n. 3000','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',365,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (235,0,119,0,'Av. del Imn No. 5','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',366,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (237,0,120,0,'Adolfo Prieto No. 133','Col. Del Valle','Del. Benito Jurez','Mxico','Cd. Mx.','Mxico',368,'03100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (238,1200,120,0,'Adolfo Prieto n. 133','Col. Del Valle','Del. Benito Jurez,','Mxico, ','Cd. Mx.','Mxico',369,'03100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (32,0,32,0,'Circuito Mtro. M. de la Cueva ','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',176,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (221,0,112,0,'Lado Norte del Estadio Olimpico,  Edif. B. 3er. piso','Ciudad Universitaria','Del. Coyoacn','Mxico, ','Cd. Mx.','Mxico',352,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (32,53,32,0,'Edif. anexo a DGTV-UNAM. Planta Baja. Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',50,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (20,0,20,0,'Lado Sur, Estacionamiento No.3, Circuito Estadio Olimpico','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',164,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (20,47,20,0,'Lado Sur, Estacionamiento no. 8. Circuito Estadio Olmpico. ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',44,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (45,0,45,0,'Camino Viejo a Xochimilco y Viaducto Tlalpan S/N','Col. San Lorenzo Huipulco','Del. Tlalpan','Mxico','Cd. Mx.','Mxico',189,'14370','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (45,148,45,0,'Camino Viejo a Xochimilco y Viaducto Tlalpan s/n','Col. San Lorenzo Huipulco','Del. Tlalpan,','Mxico, ','Cd. Mx.','Mxico',143,'14370','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (49,0,49,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',193,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (49,135,49,0,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',131,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (33,0,33,0,'Av. Insurgentes Sur esq. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',177,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (33,19,33,0,'Av. Universidad No. 3000, 1er. piso','Ciudad Universitaria, Col. Copilco','Del. Coyoacn,','Mxico','Cd. Mx.','Mxico',17,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (50,0,50,0,'Av. Aquiles Serdn No. 2060','Col. Ex-Hacienda El Rosario','Del. Azcapotzalco','Mxico','Cd. Mx.','Mxico',194,'02410','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (66,40,50,0,'Av. Aquiles Serdn n. 2060.','Col. ex hacienda El Rosario.','Del. Azcapotzalco,','Mxico','Cd. Mx.','Mxico',37,'02410','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (52,0,52,0,'Prol. Canal de San Juan S/N esq. Av. Universidad','Col. Tepalcates','Del. Iztapalapa','Mxico','Cd. Mx.','Mxico',195,'09220','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (52,43,52,0,'Prol. Canal de San Juan s/n, esq. Av. Universidad.','Col. Tepalcates','Del. Iztapalapa,','Mxico','Cd. Mx.','Mxico',40,'09220','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (53,0,53,0,'Cataratas y Llanura S/N','Col. Jardines del Pedregal de San Angel','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',196,'04500','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (53,42,53,0,'Cataratas y Llanura s/n.','Col. Jardines del Pedregal de San Angel','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',39,'04500','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (54,0,54,0,'Av. de los Cien Metros S/N esq. Fortuna','Col. Magdalena de las Salinas','Del. Gustavo A. Madero','Mxico','Cd. Mx.','Mxico',197,'07760','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (54,41,54,0,'Av. de los Cien Metros s/n, esq. Fortuna','Col. Magdalena de las Salinas.','Del. Gustavo A. Madero,','Mxico, ','Cd. Mx.','Mxico',38,'07760','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (34,0,34,0,'Av. de las Torres y  Aldama S/N','Col. Tepepan','Del. Xochimilco','Mxico','Cd. Mx.','Mxico',178,'16020','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (34,100,34,0,'Av. de la Noria y  Prolongacin de Aldama s/n','Col. Tepepan','Del. Xochimilco,','Mxico, ','Cd. Mx.','Mxico',96,'16020','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (38,0,38,0,'Av. Ro Churubusco S/N esq. Tezontle','Col. Zapata Vela','Del. Iztacalco','Mxico','Cd. Mx.','Mxico',182,'08040','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (43,0,43,0,'Ing. Eduardo Molina No. 1577','Col. Salvador Daz Mirn','Del. Gustavo A. Madero','Mxico','Cd. Mx.','Mxico',187,'07400','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (43,104,43,0,'Av. Ing. Eduardo Molina n. 1577.','Col. Salvador Daz Mirn','Del. Gustavo A. Madero,','Mxico, ','Cd. Mx.','Mxico',100,'07400','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (37,0,37,0,'Av. Observatorio No. 170','Col.  Observatorio','Del. Miguel Hidalgo','Mxico','Cd. Mx.','Mxico',181,'11860','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (37,105,37,0,'Av. Observatorio n. 170.','Col. Observatorio','Del. Miguel Hidalgo,','Mxico, ','Cd. Mx.','Mxico',101,'11860','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (36,0,36,0,'Calz.del Hueso No.729','Col. Ex-Hacienda Coapa','Del. Tlalpan','Mxico','Cd. Mx.','Mxico',180,'14300','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (36,106,36,0,'Calz. del Hueso n. 729','Col. ex hacienda  de Coapa','Del. Tlalpan,','Mxico, ','Cd. Mx.','Mxico',102,'14000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (41,0,41,0,'Corina No. 3','Col. Del Carmen Coyoacn','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',185,'04000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (41,107,41,0,'Corina n. 3.','Col. Del Carmen','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',103,'04000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (42,0,42,0,'Calz. de la Viga No. 54','Col. Merced Balbuena','Del. Venustiano Carranza','Mxico','Cd. Mx.','Mxico',186,'15810','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (42,108,42,0,'Calz. de la Viga n. 54.','Col. Merced Balbuena','Del. Venustiano Carranza,','Mxico, ','Cd. Mx.','Mxico',104,'15810','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (40,101,40,0,'Av. Lomas de Plateros s/n, esq. Dr. Fco. de la P. Miranda ','Col. Merced Gmez','Del. Alvaro Obregn,','Mxico, ','Cd. Mx.','Mxico',97,'01600','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (39,0,39,0,'Insurgentes Norte No. 1698','Col. Lindavista','Del. Gustavo A. Madero','Mxico','Cd. Mx.','Mxico',183,'07300','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (55,0,55,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',199,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (55,10,55,0,'Circuito Escolar,','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',8,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (55,11,55,3,'Edif. de Diseo Industrial, 1er. piso. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',9,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (55,32,55,4,'Edif. de Posgrado de Arquitectura, Planta Baja. Unidad de Posgrado. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',29,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (44,0,44,0,'Av. Constitucin No. 600','Col. Barrio La Concha','Del. Xochimilco','Mxico','Cd. Mx.','Mxico',188,'016210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (44,8,44,0,'Av. Constitucin n. 600.','Col. Barrio la Concha','Del. Xochimilco,','Mxico, ','Cd. Mx.','Mxico',6,'16210','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (56,0,56,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',200,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (56,60,56,15,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',57,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (58,0,58,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',202,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (58,15,58,0,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',13,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (58,16,58,7,'Edif. de Posgrado a un costado de DGCTIC, Planta Baja. Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',14,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (59,0,59,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',203,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (60,0,60,0,'Circuito Escolar','Cudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',204,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (60,133,60,0,'Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',129,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (60,33,60,9,'Edif.  de Posgrado de Economa, Stano. Zona cultural, Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',30,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (63,0,63,0,'Av. Guelatao No. 66','Col. Ejrcito de Oriente','Del. Iztapalapa','Mxico','Cd. Mx.','Mxico',207,'09230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (63,138,63,0,'Av. Guelatao n. 66.','Col. Unidad Habitacional Ejrcito de Oriente','Del. Iztapalapa,','Mxico,','Cd. Mx.','Mxico',134,'09230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (63,139,63,44,'Batalla 5 de Mayo s/n, esq. Fuerte de Loreto.','Col. Unidad Habitacional Ejrcito de Oriente','Del. Iztapalapa,','Mxico, ','Cd. Mx.','Mxico',135,'09230','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (64,0,64,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',208,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (65,0,65,0,'Circuito Interior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',209,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (65,66,65,16,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',63,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (65,68,65,18,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',65,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (65,67,65,17,'Tacuba n. 5, Palacio de Minera. Planta Baja','Col. Centro','Del. Cuauhtmoc,','Mxico, ','Cd. Mx.','Mxico',64,'06000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (65,75,65,19,'Tacuba n. 5, Palacio de Minera. Planta Baja.','Col. Centro ','Del. Cuahutmoc,','Mxico, ','Cd. Mx.','Mxico',NULL,'06000','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (66,0,66,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',210,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (66,80,66,0,'Edif. E, Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',77,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (66,85,66,30,'Repblica de Brasil No.33, Esq. Venezuela, Edif. Palacio de la antigua Escuela de Medicina 1er. piso','Col. Centro','Del. Cuauhtmoc','Mxico,','Cd. Mx.','Mxico',81,'06020','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,0,67,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',211,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,122,67,0,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',118,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,69,67,20,'Manuel M. Lpez s/n.','Col. Zapotitln','Del. Tlhuac,','Mxico, ','Cd. Mx.','Mxico',66,'13209','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (48,0,48,0,'Xicotncatl No. 126','Col. Del Carmen','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',192,'04100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (48,96,48,0,'Xicotncatl n. 126.','Col. Del Carmen','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',92,'04100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (68,0,68,0,' Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',212,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (68,97,68,32,'Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',93,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (68,98,68,33,'Edif. de Posgrado 1er. piso, Circuito de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',94,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (69,127,69,39,'Av. Universidad n. 3004, Edif. B, Planta Baja (Col. Copilco)','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',123,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (69,128,69,40,'Av. Universidad n. 3004, Edif. E, P lanta Baja (Col. Copilco)','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',124,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (70,0,70,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',300,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (70,113,70,36,'Edif. E, Planta Baja. Conjunto Facultad de Qumica. Circuito de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',109,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (70,110,70,0,'Edif. A, Planta Baja. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',106,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (70,114,70,37,'Edif. B, Planta Baja. Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',110,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (70,112,70,35,'Edif. D, 2o. piso. Conjunto Facultad de Qumica. Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',108,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (70,111,70,34,'Edif. F, Planta Baja. (antes Instituto de Investigaciones Biomdicas) Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',107,'04510','Cambio de lugar, antes la biblioteca se ubicaba en el stano del edif. B de la FQ. a partir de 10 enero de 2014 pasa al edificio de Biomdicas. DPLybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (71,0,71,0,'Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',301,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (71,2,71,0,'Circuito de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',1,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (72,0,72,0,'Edif. contiguo al Jardn Botnico, 3er Circuito exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',302,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (72,54,72,12,'Edif. A, Planta Baja. 3er. Circuito exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico,   ','Cd. Mx.','Mxico',51,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (74,0,74,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',304,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (74,141,74,0,'Edif. de la Unidad de Bibliotecas de la Inv. Cientfica, Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',136,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (73,0,73,0,'Edif. Contiguo a Instituto de Materiales, Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',303,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (75,0,75,0,'Circuito Deportivo','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',305,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (75,18,75,0,'Edif. contiguo al Jardn Botnico, Circuito Deportivo','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',16,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (77,0,77,0,'Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',307,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (77,71,77,0,'Circuito de la Inv. Cientfica.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',68,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (76,0,76,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',306,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (76,23,76,0,'Circuito exterior s/n. Edif. entre los Institutos de Quimica y Ciencias del Mar, 1er. piso ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',21,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (78,0,78,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',308,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (78,143,78,0,'Edif. de la Unidad de Bibliotecas de la Inv. Cientfica, Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',138,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (79,0,79,0,'Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',309,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (79,74,79,0,'Circuito de la Inv. Cientfica,','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',71,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (80,0,80,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',310,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (80,142,80,0,'Edif. de la Unidad de Bibliotecas de la Inv. Cientfica, Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',137,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (81,0,81,0,'Edif. 1 Nivel 2, Circuito  Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',311,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (81,91,81,0,'Edif. 1 ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',87,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (82,5,82,0,'Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',4,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (5,27,5,0,'Torre II de Humanidades 11o. piso. Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',25,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (83,0,83,0,'Edif. de Apoyo ','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',313,'04520','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (83,86,83,0,'Edif. de Gobierno del I.I.Biomdicas, 1er. piso. Circuito Deportivo.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',82,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (84,93,84,0,'Edif. A, Planta Baja. Circuito Mtro.  M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',89,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (92,0,92,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',322,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (92,20,92,0,'Edif.  anexo del  IIMAS, 1er. piso, Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',18,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (91,0,91,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',321,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (91,76,91,0,'Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',73,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (85,14,85,0,'Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',12,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (86,63,86,0,'Circuito Mtro. M. de la Cueva. ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',60,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (87,61,87,0,'Circuito Mtro. M. de la Cueva. ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',58,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (88,62,88,0,'Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',59,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (89,45,89,0,'Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',42,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (89,46,89,11,'Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',43,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (12,22,12,0,'Edif. del IISUE, Planta Baja. (entre Biblioteca Nacional y Sala Nezahualcyotl) ','Ciudad Universitaria','Del. Coyoacn,','Mxico,   ','Cd. Mx.','Mxico',20,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (90,52,90,0,'Edif. IIS,  Planta Baja. Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',49,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (93,0,93,0,'Edif. entre los Institutos de Astronoma y Materiales, Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',323,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (93,78,93,0,'Edif. entre los Institutos de Materiales y Astronoma. Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',75,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (95,0,95,0,'Circuito Exterior','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',325,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (95,118,95,0,'Edif. contiguo a Fisiologa Celular. Circuito Exterior','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',114,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (206,125,97,0,'Torre II de Humanidades 7o. piso, Circuito Escolar.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',121,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (214,1080,108,0,'Av. Ro Magdalena n. 100','Col. La Otra Banda','Del. Alvaro Obregn,','Mxico, ','Cd. Mx.','Mxico',345,'01090','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (239,0,121,0,'Edif.  Rectora 8o. Piso. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',370,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (240,1210,121,0,'Edif. Rectora 8o. piso. Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',371,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (241,0,122,0,'Edif. Rectora 7o. Piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',372,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (242,1220,122,0,'Edif. Rectora 7o. Piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',373,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (90,0,90,0,'Edif. IIS, Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',320,'04510','Entidad creada en 1930. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. octubre 2015 ao XI Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (85,0,85,0,'Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico, ','Cd. Mx.','Mxico',315,'04510','En 1936 el Laboratorio de arte (fundado en 1935 ) se convierte en IIE. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (89,0,89,0,'Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',319,'04510','En 1940 se crea el  Instituto de Derecho Comparado; En 1967 se transforma en el IIJurdicas. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (84,0,84,0,'Edif. A,  2o. Piso, Circuito Mtro. M. de la Cueva S/N, ','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',314,'04510','En 1940 se crea el IIEconmicas. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (88,0,88,0,'Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',318,'04510','En 1945 se crea el IIH. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (87,0,87,0,'Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',317,'04510','En 1940 se crea el  Centro de Estudios Filosficos; En 1967 adquiere rango de IIF. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (10,0,10,0,'Circuito Escolar ','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',154,'04510','En 1966 se crea el CELE. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (82,0,82,0,'Circuito de la Inv. Cientfica','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',312,'04510','En 1973 se funda el IIA. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (86,0,86,0,'Circuito Mtro. M. de la Cueva','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',316,'04510','Entra en funciones el IIFilolgicas, incorporando al Centro de Estudios Literarios (1956), Centro de Estudios Clsicos (1966), Centro de Linguistica Hispnica (1967) y el Centro de Estudios Mayas (1970). Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (12,0,12,0,'Edif. del IISUE entre Biblioteca Nacional y Sala Nezahualcyotl, Centro Cultural Universitario','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',156,'04510','En 1976 nace el Centro de Estudios sobre la Universidad; En 2006 se transforma en  I. I. sobre la Universidad y la Educacin. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (2,0,2,0,'Torre II de Humanidades, 8o Piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',146,'04510','En 1979 entra en funciones el Centro Coordinador y Difusor de Estudios Latinoamericanos; en  2007 adquiere el nombre de Centro de Estudios sobre Amrica Latina y el Caribe. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (5,0,5,0,'Torre II de Humanidades, 12o Piso, Circuito Interior','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',149,'04510','En 1981 se funda el Centro Universitario de Investigaciones Bibliotecolgicas. En 2012 se transforma en IIB y de la Informacin. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (3,0,3,0,'Av. Universidad S/N, 2o. Circuito Universitario','Col. Chamilpa','Cuernavaca','','Morelos','Mxico',147,'62210','En 1987 entra en funciones el CRIM antes se conocia como Centro de Investigaciones Multidiciplinarias sobre Sociedad y Cultura (1985) y el Centro de Estudios sobre la Identidad Nacional en Zonas Fronterizas (1983). Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (97,0,97,0,'Torre II de Humanidades, 7o. Piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',327,'04510','En 1992 nace el PUEG. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (15,0,15,0,'Torre II de Humanidades 10o. Piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico, ','Cd. Mx.','Mxico',159,'04510','En 1993 queda establecido EL CISAN, a partir del Programa Universitario de Investigaciones sobre Estados Unidos de Amrica. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (14,0,14,0,'Torre II de Humanidades 4o. Piso, Circuito Escolar','Ciudad Universitaria','Del. Coyoacn','Mxico,','Cd. Mx.','Mxico',158,'04510','En 1986 se instituye el Centro de Investigaciones Interdisciplinarias. En 1995 El CIIH amplia sus funciones como Centro de Investigaciones Interdisciplinarias en Ciencias y Humanidades. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (210,0,106,0,'Av. Lzaro Crdenas S/N,  esq.  Felicitas  del  Ro ','Jiquilpan','Jiquilpan de Jurez','','Michoacn','Mxico',NULL,'59510','En  2005 entra en funciones la Unidad Acadmica de Estudios Regionales, en Jiquilpan de Jurez, Mich. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (103,0,103,0,'Calle 43 S/N entre 44 y 46','Col. Industrial','','Mrida','Yucatn','Mxico',337,'97150','En  2007 se crea el Centro Peninsular en Humanidades y Ciencias Sociales en Mrida, Yucatn. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (99,0,99,0,'Mara Adelina Flores No. 34 A','Barrio de Guadalupe','San Cristobal de las Casas','','Chiapas','Mxico',329,'29230','En  2015 entra en funciones el Centro de Investigaciones Multidisciplinarias sobre Chiapas y la Frontera Sur a partir del Programa  de Investigaciones Multidisciplinarias sobre Mesoamrica y el Sureste. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (247,0,126,0,'Antigua carretera a Ptzcuaro No. 8701','Col. ex hacienda San Jos de la Huerta','Morelia,','','Michoacn','Mxico',NULL,'58190','El 31 de agosto  de 2015 se crea la Unidad de Investigacin sobre Representaciones Culturales y Sociales de la Coordinacin de Humanidades en ENES, U. Morelia. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (213,0,108,0,'Av. Rio de la Magdalena No. 100   \011','Col. La Otra Banda','Del. Alvaro Obregn','Mxico,','Cd. Mx.','Mxico',344,'01090','En  2004 se establece el Programa Universitario Mxico Nacin Multicultural. En 2014 el Programa Universitario Mxico Nacin Multicultural se covierte en Programa Universitario de Estudios de la Diversidad Cultural y al Multiculturalidad. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (69,0,69,0,'Av. Universidad No. 3004.  Edif. E, 1er. piso (Col. Copilco)','Ciudad Universitaria','Del. Coyoacn','Mxico, ','Cd. Mx.','Mxico',299,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (31,129,31,0,'Edif. DGCTIC.  Planta Baja. Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico,','Cd. Mx.','Mxico',125,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (26,49,26,0,'Unidad de Posgrado, Edif. K,  Circuito de Posgrados','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',46,'04510','Cambio de lugar antes de ubicaban en  circuito escolar en la unidad de posgrado a un lado de la Torre II de Humanidades  a partir de mayo de 2013 cambian a  la Unidad de Posgrado ubicado cerca de la Av. Insurgentes y la Reserva  Ecolgica del Pedregal. DPL. ybf','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (35,0,35,0,'Adolfo Prieto No. 722, 7o. Piso','Col. Del Valle','Del. Benito Jurez','Mxico','Cd. Mx.','Mxico',179,'03100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (35,99,35,0,'Adolfo Prieto n. 722, Planta Baja.','Col. Del Valle','Del. Benito Jurez,','Mxico, ','Cd. Mx.','Mxico',95,'03100','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (40,0,40,0,'Av. Lomas de Plateros s/n esq. Dr. Fco. de la P. Miranda ','Col. Merced Gmez','Del. Alvaro Obregn','Mxico','Cd. Mx.','Mxico',184,'01600','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (57,35,57,0,'Circuito Mtro. M. de la Cueva.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',32,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (57,0,57,0,'Circuito Mario de la Cueva ','Ciudad Universitaria','Del. Coyoacn','Mxico','Cd. Mx.','Mxico',201,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (11,119,11,0,'Av. Universidad No. 3002 (Col. Copilco)','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','0',115,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (11,121,11,38,'Ex-hacienda El Chorrillo s/n.','Taxco de Alarcn,','','','Guerrero','0',117,'40220','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (18,136,18,0,'Edif. de la CUAED, Planta Baja. frente a la ENTS. Circuito Exterior.','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','0',132,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (236,1190,119,0,'Av. del Imn n. 5','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',367,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (98,0,98,0,'Repblica de Cuba No. 79','Col. Centro','Del.  Cuauhtmoc','Mxico, ','Cd. Mx.','Mxico',328,'06010','En 1994 inicia labores el Programa Universitario de Estudios sobre la Ciudad. Noticia publicada en HUMANIDADES Y CIENCIAS SOCIALES. Octubre 2015. Ao XI, Nmero 88. DPLybf.','Cambio de domicilio a partir de junio 2016 se encuentra en Rep. de Cuba. DPLybf.');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (98,124,98,0,'Repblica de Cuba n. 79','Col. Centro','Del. Cuauhtmoc','Mxico, ','Cd. Mx.','Mxico',120,'06010','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (44,9,44,2,'Academia n.  22. Planta Baja.','Col. Centro','Del. Cuauhtmoc','Mxico, ','Cd. Mx.','Mxico',7,'06060','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (38,103,38,0,'Av. Ro Churubusco no. 654, entre  Av. Apatlaco y Av. Tezontle','Col. Zapata Vela','Del. Iztacalco,','Mxico, ','Cd. Mx.','Mxico',99,'08040','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (59,44,59,0,'Circuito Escolar','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',41,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (65,65,65,0,'Circuito Escolar ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',62,'04510','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (67,134,67,21,'Km. 8.5  Carr. Tequisquiapan-Ezequiel Montes.','','Tequisquiapan,','','Quertaro','Mxico',130,'76790','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (39,102,39,0,'Insurgentes Norte n. 1698','Col. Lindavista','Del. Gustavo A. Madero,','Mxico, ','Cd. Mx.','Mxico',98,'07300','','');
INSERT INTO "direccion" ("dir_id","bib_id","dep_id","subdep_id","calle","localidad","municipio","ciudad","estado","pais","apdo_id","cod_post","observaciones","dir_obs") VALUES (64,59,64,0,'Circuito Escolar ','Ciudad Universitaria','Del. Coyoacn,','Mxico, ','Cd. Mx.','Mxico',56,'04510','','');
--
-- Data for TOC Entry ID 60 (OID 3235365)
--
-- Name: coleccion Type: TABLE DATA Owner: israeld
--


INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1070,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1080,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1100,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1110,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1130,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1150,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1160,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1180,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1200,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1210,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (1220,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (145,'0','0','0','0','0','0','0','0','3102','','310000 Ciencias Agronmicas y Veterinarias','','','Maestra en Ciencias veterinarias$Produccin animal$Doctorado en Ciencias veterinarias','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (3,'4802','5670','200','14826','219','219','89 tts. = 12085 vols. ','0','348','','210000 Astronoma y Astrofsica','','','Astrofsica estelar$Astronoma extragalctica$Dinmica galctica$Instrumentacin astronmica$Medio interestelar','','Library of Congress','Fuente: Censo Automatizado del Sistema Bibliotecario de la UNAM 2009','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (156,'0','0','0','0','0','0','0','0','0','','','','Ecologia$Ecosistemas$Biodiversidad','Ciencias Ambientales$Ciencias Biolgicas','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (121,'0','0','0','0','0','0','0 ','0','1015','','0','','Arte$Espaol$Estudios latinoamericanos$Historia de Mxico$Lingstica$Literatura$','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (28,'0','0','0','0','0','0','0','116','114','','620000 Artes y Letras','','Arte contemporneo$Arte Moderno$Museografia$Museologia$','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (94,'0','0','0','0','0','0','0  ','0','0','','Ciencias Sociales y Humanidades','','Antropologa social$Biodiversidad$Ciencia poltica$Demografa$Economa$Educacin Superior$Sociologa','Cultura Sentimental y tica de la Convivencia$Estudios de Poblacin$ Estudios de lo Imaginario$Estudios Sobre Educacin y Formacin$Estudios Socioambientales$Programa de Cambio mundial, Globalizacin y Desarrollo$Programa Cultura, Poltica y Diversidad$Programa de Equidad de Gnero$Programa de Estudios Regionales$Programa Violencia(s), Derecho y Salud$Investigacin en Gobierno y Polticas Pblicas$','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (62,'0','0','0','0','0','0','0','0','10000','','550000 Historia','','Estados Unidos$Europa$Historia de Amrica latina$Historia de Mxico desde la poca prehispnica hasta la poca contempornea','Historia colonial $Historia Moderna y contemporanea$Historia Prehispnica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (12,'0','0','0','0','0','0','0 ','0','1674401','','Multidisciplinaria','','Multidisciplinaria','','','Library of Congress','','Se tiene 360482 tits. = 360482 vols. de tesis en cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (30,'0','0','0','0','0','0',' 0 ','0','3477','','330000 Ciencias de la Tecnologa','','','Acstica, ptica y fotonica $Materiales avanzados y nanotecnologa$Pedagoga cognitiva de la ciencia$Tecnologas de la informacin y electrnica$Microtecnologa y tecnologas avanzadas para la instrumentacin','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (24,'0','0','0','0','0','0','0','0','2423','','Ciencias Exactas y Naturales$Tecnologas y Ciencia Agropecuarias','','','Genmica computacional$Genmica ecolgica$Evolucin genmica$Dinmica genmica$Ingeniera genmica$Genmica funcional de eucariote$Genmica funcional de procariote','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (31,'0','0','0','0','0','0','0','0','42098','','570111 Enseanza de Idiomas','','Lingstica$Lingstica aplicada$Sociolingstica$Enseanza de lenguas$Didctica de la lengua','Adquisicin de segundas lenguas por adultos$Anlisis de discurso$Aprendizaje autodirigido$ Diseo curricular y desarrollo de materiales$Evaluacin$Lengua y cultura$Lexicologa$Sociolingstica','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (119,'0','0','0','0','0','0','0','0','2100','','570111 Enseanza de Idiomas','','Enseanza del espaol como segunda lengua$Historia, literatura y arte de Mxico y Latinoamrica$','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (92,'0','0','0','0','0','0','0','0','628','','Multidisciplinaria','','Aspectos sociales, econmicos, polticos y culturales$Ciencia y tecnologa$Crisis del capitalismo$Educacin superior$Epistemologa de las ciencias$Estudios sobre la prospectiva global$Fundamentos, anlisis, teora y metodologa sobre y para el desarrollo de la interdisciplina$Investigacin feminista','rea Alternativas $rea de Estudios avanzados y vinculacin en posgrados$rea de Programas, proyectos y actividades especiales$rea de Teora y metodologa ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (58,'0','0','0','0','0','0','0','0','1409','','Ciencias Sociales y Humanidades','','Cultura, Economa, Politica y Sociedad en la regin de Amrica del Norte','Estudios de la Globalidad$Estudios de la Integracin$Estudios Estratgicos','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (73,'0','0','0','0','0','0','0','0','0','','220000 Fsica','','','Catlisis$Fsica terica$Fsico qumica$Propiedades pticas$Nanoestructuras$Posgrado en Fsica de materiales$Ciencias fsicas e Ingeniera de materiales','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (48,'0','0','0','0','0','0','0','0','987','','620301 Cinematografa','','Cinematografa$Direccin artstica$Edicin$Guin$Produccin$Realizacin$Sonido','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (38,'0','0','0','0','0','0','0','0','799','','620310 Teatro','','Artes$Literatura$Teatro','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (49,'0','0','0','0','0','0','0','0','5128','','Multidisciplinaria','','Planes y Programas de estudios a nivel Licenciatura, Maestra y Doctorado','','','Library of Congress','0','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (153,'0','0','0','0','0','0','0','0','1946','','','','','Administracin pblica$Contadura$Derecho$Economa$Periodismo$Psicologa','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (136,'0','0','0','0','0','0','0','0','512','','531204 Educacin','','Educacin abierta$Educacin continua (computacin, filosofa, pedagoga y psicologa)$Educacin a distancia (medios y tecnologas)','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (64,'0','0','0','0','0','0','0','0','1438','','620301 Cinematografa','','Especializada en cinematografa nacional y extranjera','','','Numrica','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (47,'0','0','0','0','0','0','0','0','1197','','631199 Otros (Deportes)','','Historia del deporte$Medicina$Nutricin$Psicologa deportiva$Sociologa','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (26,'0','0','0','0','0','0','0 ','0','9967','','Multidisciplinaria','','Multidisciplinaria','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (131,'0','0','0','0','0','0','0','0','8256','','333100 Ciencias de la computacin','','Computacin$Tecnolologa$Telecomunicaciones','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (123,'0','0','0','0','0','0','0','0','9339','','','','Ciencia$Comunicacin$Comunicacin de las ciencias$Historia$Historia de la divulgacin de la ciencia$Medio ambiente y diversidad$Medios$Pedagoga   ','Divulgacin y difusin de las ciencias$Enseanza de las ciencias$Estudios de la ciencias$Museologa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (129,'0','0','0','0','0','0','0','0','9918','','333100 Ciencias de la computacin','','Cmputo bsico y avanzado$Tecnologa de la Informacin$Telecomunicaciones$Cmputo aplicado$Multimedia$Realidad virtual$Visualizacin','','Espaol e Ingls','Library of Congress',' ','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (130,'0','0','0','0','0','0','0','0','4252','','333100 Ciencias de la computacin','','Computacin$Tecnologa$Telecomunicaciones','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (109,'0','0','0','0','0','0','0 ','0','1200','','560000 Ciencias Jurdicas y Derecho','','Derecho$Educacin superior$Legislacin universitaria','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (50,'0','0','0','0','0','0','0','0','2426','','321500 Administracin de Hospitales y de la Atencin Mdica','','Educacin para la salud$Orientacin en salud$Salud ambiental','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (53,'0','0','0','0','0','0','0','0','535','','332509 Televisin','','Cine$Comunicacin$Fotografa$Literatura$Radio$Televisin','','','Library of Congress',' ','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (148,'0','0','0','0','0','0','0 ','0','258627','','320000 Medicina y Patologa Humanas','','','Enfermera y Obstetricia','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (96,'0','0','0','0','0','0','0','0','13852','','620000 Artes y Letras','','','Canto $Composicin $Educacin musical $Etnomusicologa $Instrumentista $Piano$ Maestra y Doctorado en Msica','','Library of Congress','','En tesis se registraron tits. y vols. de formato cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (135,'0','0','0','0','0','0','0','0','274995','','630000 Sociologa','','','Trabajo social','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (19,'0','0','0','0','0','0',' 0 ','0','600','','Muldisciplinaria','','','','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (40,'0','0','0','0','0','0','0. ','0','30782','','Multidisciplinaria','','','Area 1 Matemticas $Area 2 Ciencias experimentales $Area 3 Histrico social $Area 4 Talleres de lenguaje y comunicacin','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (39,'0','0','0','0','0','0','0','0','450000','','Multidisciplinaria','','','Area 1 Matemticas $Area 2 Ciencias experimentales $Area 3 Histrico social. $Area 4 Talleres de lenguaje y comunicacin','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (43,'0','0','0','0','0','0','0 ','0','509000','','Multidisciplinaria','','','Area 1 Matemticas $Area 2 Ciencias experimentales $Area 3 Histrico social $Area 4 Talleres de lenguaje y comunicacin','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (42,'0','0','0','0','0','0','0','0','595000','','Multidisciplinaria','','','Area 1 Matemticas $Area 2 Ciencias experimentales $Area 3 Histrico social $Area 4 Talleres de lenguaje y comunicacin','Espaol $Ingls ','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (41,'0','0','0','0','0','0',' 0 ','0','752500','','Multidisciplinaria','','','Area 1 Matemticas $Area 2 Ciencias experimentales $Area 3 Histrico social $Area 4 Talleres de lenguaje y comunicacin','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (100,'0','0','0','0','0','0','0','0','354806','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (103,'0','0','0','0','0','0','0 ','0','403786','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (104,'0','0','0','0','0','0','0','0','475823','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (105,'0','0','0','0','0','0','0','0','427593','','Multidisciplinaria','','','Fsico-matematicas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (106,'0','0','0','0','0','0','0 ','0','859339','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $ Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (107,'0','0','0','0','0','0','0','0','426000','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (108,'0','0','0','0','0','0','0','0','449679','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (101,'0','0','0','0','0','0','0 ','0','559248','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud  $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (102,'0','0','0','0','0','0',' 1407 tts. = 6906 vols. ','0','524238','','Multidisciplinaria','','','Fsico matemticas $Ciencias biolgicas y de la salud $Ciencias sociales $Humanidades y arte','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (10,'0','0','0','0','0','0','0','6002','150000','','620100 Arquitectura','','','Arquitectura $Arquitectura de paisaje $Diseo industrial $Urbanismo','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (32,'0','0','0','0','0','0','0','0','15000','','620100 Arquitectura','','','Especilizacin en vivienda, cubiertas ligeras, valuacin inmobiliaria$Maestra en Arquitectura$Diseo Industrial$Tecnologa$Urbanismo$Doctorado en Arquitectura','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (60,'0','0','0','0','0','0','0','0','0','','Multidisciplinaria','','','Actuara$Biologa$Ciencias ambientales$Ciencias de la computacin$Fsica$Manejo sustentable de zonas costeras$Matemticas$Maestra y Doctorado en Ciencias matemticas$','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (11,'0','0','0','0','0','0','0','0','25920','','620100 Arquitectura. Ergonomia. Diseo','','','Diseo Industrial','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (133,'0','0','0','0','0','0','0','0','572889','','530000 Ciencias Econmicas','','','Economa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (33,'0','0','0','0','0','0','0','0','38060','','530000 Ciencias Econmicas','','','Economa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (37,'0','0','0','0','0','0','0','0','106850','','Multidisciplinaria','','','Administracin$Contadura$Informtica$Ingeniera agrcola$Ingeniera mecnica elctrica$Medicina veterinaria y zootecnia$Maestra en Administracin$Ciencias de la prod. y de la salud animal$Ciencias Qumicas$Ingeniera$Doctorado en Ciencias de la prod. y de la salud animal$Ciencia e ingeniera de la computacin$Ciencias Qumicas$Ingeniera','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (95,'0','0','0','0','0','0',' 0 ','0','821286','','Multidisciplinaria','','','Biologa$Cirujano dentista$Enfermera$Mdico cirujano$Optometra$Psicologa ','','Library of Congress','','En tesis se incluyen  vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (139,'0','0','0','0','0','0','0','0','466000','','Multidisciplinaria','','','Biologa$Ingeniera qumica$Qumica Farmacutico Biolgica$Maestra en Administracin$Ciencias biolgicas$Enfermera$Psicologa (Educacin especial)$Psicopatologa (Neuropsicologa)$Trabajo social$Doctorado en Ciencias biolgicas$Psicologa','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (59,'0','0','0','0','0','0','0','0','976814','','Multidisciplinaria','','','Bibliotecologa$Estudios Latinoamericanos$Filosofa$Geografa $Historia$Letras clsicas$Letras hispnicas$Letras modernas$Literatura dramtica y teatro$Pedagoga$Maestra y Doctorado en: Antropologa; Bibliotecologa y Estudios de la Informacin; Estudios Latinoamericanos; Estudios Mesoamericanos; Filosofa; Filosofa de las Ciencias; Geografa; Historia; Historia del Arte; Letras; Linguistica; Pedagoga','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (138,'0','0','0','0','0','0','0','0','486268','','Multidisciplinaria','','','Cirujano dentista $Enfermera $Mdico cirujano$Psicologa$Maestra en Administracin$Ciencias Biolgicas$Enfermera$Psicologa(Educacin especial)$Psicopatologa(Neuropsicologa)$Trabajo social$Doctorado en Ciencias Biolgicas$Psicologa','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (68,'0','0','0','0','0','0','0 ','0','779481','','330000 Ciencias de la Tecnologa','','','Ingeniera civil$Ingeniera de minas y metalurga$Ingeniera elctrica y electrnica$Ingeniera en computacin$Ingeniera en telecomunicaciones$Ingeniera geofsica$Ingeniera geolgica$Ingeniera geomtica$Ingeniera industrial$Ingeniera mecnica$Ingeniera mecatrnica$Ingeniera petrolera ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (66,'0','0','0','0','0','0','0 ','0','64172','','330000 Ciencias de la Tecnologa','','','Posgrado en: Ingeniera ambiental$Ingeniera civil$Ingeniera elctrica$Ingeniera mecnica$Ingeniera petrolera y gas natural$Ingeniera de sistemas$Energa$Qumica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (65,'0','0','0','0','0','0','0 ','0','710230','','330000 Ciencias de la Tecnologa','','','Ingeniera civil $Ingeniera de minas y metalurga $Ingeniera elctrica y electrnica $Ingeniera en computacin $Ingeniera en telecomunicaciones $Ingeniera geofsica $Ingeniera geolgica $Ingeniera geomtica$Ingeniera industrial $Ingeniera mecnica $Ingeniera mecatrnica$Ingeniera petrolera ','Ingls$Espaol','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (67,'0','0','0','0','0','0','0','0','1835','','330000 Ciencias de la Tecnologa','','','Ingeniera civil$Ingeniera de minas y metalurga$Ingeniera elctrica y electrnica$Ingeniera en computacin$Ingeniera en telecomunicaciones$Ingeniera geofsica$Ingeniera geolgica$Ingeniera geomtica$Ingeniera industrial$Ingeniera mecnica$Ingeniera mecatrnica$Ingeniera petrolera ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (80,'0','0','0','0','0','0','0','15746','825000','','320000 Medicina y Patologa Humanas','','Anatoma$Bioqumica$Ciruga$Embriologa$Farmacologa$Fisiologa$Gentica$Histologa$Inmunologa$Medicina clnica$Medicina interna$Microbiologa$Propedutica$Psicologa mdica$Salud pblica','Investigacin Biomdica Bsica $Mdico cirujano','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (85,'0','0','0','0','0','0','0','0','6200','','320000 Medicina y Patologa Humanas','','','Historia y filosofa de la medicina','','Library of Congress $Dewey','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (57,'0','0','0','0','0','0','0','0','120','','310000 Ciencias Agronmicas y Veterinarias','','','Maestra en Ciencias veterinarias$Produccin animal$Doctorado en Ciencias veterinarias','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (134,'0','0','0','0','0','0','0','0','190','','310000 Ciencias Agronmicas y Veterinarias','','','Maestra en Ciencias veterinarias$Produccin animal$Doctorado en Ciencias veterinarias','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (122,'0','0','0','0','0','0','0','0','825800','','310000 Ciencias Agronmicas y Veterinarias','','','Medicina veterinaria y zootecnia$Maestra en Ciencias veterinarias$Produccin animal$Doctorado en Ciencias veterinarias','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (69,'0','0','0','0','0','0','0','0','117','','310000 Ciencias Agronmicas y Veterinarias','','','Maestra en Ciencias veterinarias$Produccin animal$Doctorado en Ciencias veterinarias','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (70,'0','0','0','0','0','0','0','0','60','','310000 Ciencias Agronmicas y Veterinarias','','','Maestra en Ciencias veterinarias$Produccin animal$Doctorado en Ciencias veterinarias','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (97,'0','0','0','0','0','0','0','0','454414','','320000 Medicina y Patologa Humanas','','','Cirujano Dentista','','Library of Congress','','En tesis se incluyen tits. y vols. de formato en cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (98,'0','0','0','0','0','0','0','0','110186','','320000 Medicina y Patologa Humanas','','','Maestra y Doctorado en: Ciencias mdicas, Odontolgicas y de la Salud','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (127,'0','0','0','0','0','0','0','0','393910','','610000 Psicologa','','','Psicologa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (128,'0','0','0','0','0','0','0','0','55385','','610000 Psicologa','','','Maestra y Doctorado en Psicologa','Ingls$Espaol','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (113,'0','0','0','0','0','0','0','0','3903','','230000 Qumica','','','Maestra y Doctorado en Ciencias Bioqumicas$Ciencias Qumicas$Posgrado en Ciencia e ingeniera de materiales$Ciencias de la Administracin$Ciencias del Mar y Limnologa$Especializacin en Bioqumica clnica','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (110,'0','0','0','0','0','0','0 ','0','752026','','230000 Qumica','','','Ingeniera qumica $Ingeniera qumica metalrgica $Qumica $Qumica de alimentos $Qumica farmacutica biolgica','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (114,'0','0','0','0','0','0','0 ','0','50354','','230000 Qumica','','','Ingeniera qumica$Ingeniera qumica metalrgica$Qumica$Qumica de alimentos$Qumica Farmacetica Biolgica','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (112,'0','0','0','0','0','0','0 ','0','0','','230000 Qumica','','','Ingeniera Qumica metalrgica$Maestra y Doctorado en Ciencias Bioqumicas$Ciencias Qumicas$Posgrado en Ciencia e Ingeniera de Materiales$Ciencias de la Administracin$Ciencias del Mar y Limnologa$Especializaciones en Bioqumica Clnica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (111,'0','0','0','0','0','0','0','0','6511','','230000 Qumica','','','Maestra y Doctorado en Ciencias bioqumicas$Ciencias qumicas$Posgrado en  Ciencia e Ingeniera de Materiales$Ciencias de la Administracin$Ciencias del Mar y Limnologa $Especializacin en Bioqumica Clnica$Maestra de Enseanza en Educacin Media y Superior$','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (55,'0','0','0','0','0','0','0','0','70','','240000 Ciencias de la Vida','','','Ecologa de primates, otros mamferos y aves$Diversidad, manejo y economa forestal$Ornotologa y coleciones en general$Taxonoma de reptiles y anfibios$Taxonoma vegetal','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (56,'0','0','0','0','0','0','0','0','455','','240000 Ciencias de la Vida','','','Ecologa e historia natural$Educacin ambiental$Faunstica$Florstica$Taxonoma y sistemtica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (54,'0','0','0','0','0','0','0','0','7513','','240000 Ciencias de la Vida','','','Biologa estructural$Biologa evolutiva$Biologa molecular$Ciencias biolgicas$Maestras en  Biogeografa$Evolucin$Paleobiologa$Sistemtica','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (117,'0','0','0','0','0','0','0 ','0','842','','240000 Ciencias de la Vida','','','Comunidades coralinas$Crustceos$Fotobiologa$Geologa de arrecifes$Microbiologa$Pastos marinos$Plancton$Toxinologa','Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (72,'0','0','0','0','0','0','0 ','0','1141','','220000 Fsica','','','Biofsica y Ciencia de materiales $Fsica atmica, molecular y ptica $Fsica terica $Fsica no-lineal ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (120,'0','0','0','0','0','0','0','0','0','','220000 Fsica$230000 Qumica','','','Estructura de la materia$Fsica de altas energas$Fsica de plasmas$Gravitacin y teora de campos$Qumica de radiacin y raduioqumica','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (77,'0','0','0','0','0','0','0','0','2840','','220000 Fsica','','','Materiales solares$Sistemas energticos$Termociencias','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (71,'0','0','0','0','0','0','0','0','0','','220000 Fsica','','','Aplicaciones mdico biolgicas$Exploracin del universo$Nuevos materiales$Sistemas complejos$Tecnologa cuntica$Visin unificada de las fuerzas$Posgrado en Ciencias fsicas$Maestra en Fsica Mdica','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (5,'0','0','0','0','0','0','0','0','6525','','510000 Antropologa','','Antropologa fsica$Antropologa social$Arqueologa$Etnologa$Lingstica antropolgica','Antropologia ambiental$Antropologa biolgica$Antropologa del patrimonio natural, cultural, histrico, arqueolgico e industrial$Antropologa de la muerte$Antropologa de las sociedades urbanas y rurales desde sus origenes$Funcin simblica y sistemas representativos','','Propia','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (86,'0','0','0','0','0','0','0','0','18520','','Ciencias Exactas y Naturales$Tecnologas y Ciencias Mdicas','','','Biologa celular$Fisiologa$Biologa molecular$Biotecnologa$Inmunologa$Medicina genmica$Toxicologa ambiental$Doctorado en Ciencias biomdicas','','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (93,'0','0','0','0','0','0','0','0','3451','','530000 Ciencias Econmicas','','Economa','Departamento de anlisis$Economa aplicada $Economa de la educacin, la ciencia y tecnologa$Economa del sector energtico$Economa del sector primario y medio ambiente$Economa del  trabajo y de la tecnologa$Economa fiscal y financiera$Economa industrial$Economa mundial$Economa poltica del desarrollo$Economa urbana y regional$Historia econmica$Macroeconmicos prospectivos y de coyuntura','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (20,'0','0','0','0','0','0','0','0','10400','','120000 Matemticas','','','Ciencias de la computacin$Ingeniera de sistemas computaciones y automatizacin$Matemticas y mecnica$Mtodos matemticos y numricos$Modelacin matemtica de sistemas sociales$Probabilidad y estadstica$Especializacin en Estadstica aplicada$Posgrado  en Ciencia e Ingeniera de la Computacin$Posgrado de Ciencias Matemticas$','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (76,'0','0','0','0','0','0','0','0','10438','','331200 Tecnologa de los Materiales','','','Biomateriales$Dinmica no lineal y reologa$Estructura electrnica y fonnica de los materiales$Materiales cermicos$Mecnica de fluidos$Polmeros estructurales$Procesos de solidificacin $Maestra y Doctorado en Ciencia e Ingeniera de materiales','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (63,'0','0','0','0','0','0','0','0','51906','','Ciencias Sociales y Humanidades','','Civilizacin y cultura grecorromana, medieval y maya$Filologa$Fnetica$Gramtica$Lenguas y literaturas grecolatinas, hispnicas y amerindias$Lexicologa$Lingstica$Morfologa$Potica$Semitica','Estudio del espaol como  lengua materna$Estudios sincrnico y diacrnico del espaol$Lengua y literatura griegas$Lengua y literatura latinas$Tradicin Clsica en Mxico','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (22,'0','0','0','0','0','0','0','0','7257','','580203 Planificacin  y Financiacin de la Educacin','','Educacin$Estudios sobre la Universidad','Archivo histrico de la UNAM$Campo terico de la educacin$Educacin superior$Evaluacin educativa$Formacin profesional y planes de estudio$Historia de la educacin$Poltica educativa nacional, educacin, ciencia, tecnologa y cultural$Temas emergentes en el campo de la educacin$Vida cotidiana y dimensin pedaggica del trabajo en el aula','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (147,'0','0','0','0','0','0','0','0','1844','','120000 Matemticas','','','lgebra$Anlisis$Ecuaciones diferenciales$Fsica-matemtica$Geometra$Modelacin matemtica$Optimizacin y combinatoria$Sistemas dinmicos$Teora de singularidades$Topologa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (78,'0','0','0','0','0','0','0','0','7895','','120000 Matemticas','','','Algebra $Anlisis matemtico$Cmputacin cientfica $Docencia y formacin$Ecuaciones diferenciales $Estadstica$Geometra$Matemticas discretas$Probabilidad$Sistemas continuos$Topologa$Especializacin en estadstica aplicada$Doctorado en reas del conocimiento','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (118,'0','0','0','0','0','0','0 ','0','0','','230000 Qumica','','','Bioqumica $Fisicoqumica$Productos naturales$Qumica analtica $Qumica de productos naturales $Qumica inorgnica $Sntesis orgnica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (34,'0','0','0','0','0','0','0','0','0','','Ciencias Exactas y Naturales','','Neurobiologa celular y molecular$Neurobiologa conductual y cognitiva$Neurobiologa del desarrollo$Neurofisiologa','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (161,'0','0','0','0','0','0','','0','0','','','','Arte / Arte en Mxico','Arte rupestre / Arte prehispnico mesoamericano','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (99,'0','0','0','0','0','0','0','0','2752','','Multidisciplinaria','','','','Espaol $Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (160,'0','0','0','0','0','0','','0','0','','0','0','Geografa','Geografa$Historia de la Geografa$Medio Ambiente y Recursos Naturales$ Estados y Regiones de la Repblica Mexicana','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (2,'0','0','0','0','0','0','0','0','0','','210000 Astronoma y Astrofsica','','','Arqueoastronoma$Astrofsica estelar y extragalctica$Cosmologa$Estrellas$Galctica planetaria$Galaxias$Instrumentacin astronmica$Medio interestelar$ptica atmosfrica$Telescopios','','Library of Congress','Gaceta 9 enero 2014. Donacin del Fondo Arcadio Poveda que consta de 97 cajas incluye proyectos de investigacin, publicaciones, manuscritos. DPLybf.','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (144,'0','0','0','0','0','0','','0','0','','Ciencias Exactas y Naturales','','','Ingenieria Celular y Biocatlisis$ Biologa Molecular de Plantas$ Gentica del Desarrollo y Fisiologa Molecular$Microbiologa Molecular$ Medicina Molecular y Bioprocesos ','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (23,'0','0','0','0','0','0','0 ','0','2137','','Ciencias Exactas y Naturales$Tecnologas y Ciencias Mdicas','','','Investigacin bsica: Bioqumica y Biologia estructural, Gentica molecular, Biologia celular y del desarrollo$ Investigacin en Neurociencias$Doctorado en Ciencias biomdicas$Maestra y doctorado en Ciencias bioqumicas$Maestra y doctorado en Ciencias Biolgicas','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (157,'0','0','0','0','0','0','0','0','235','','','','Historia de Mxico$Ciencias Sociales$Michoacn','Accin colectiva en el manejo integral de los recursos hdricos$Organizaciones indgenas-campesinas y desarrollo local$Estudios regionales','Espaol','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (155,'0','0','0','0','0','0','0','0','0','','','','Acstica$Catlisis$Corrosin$Dispersin de luz$Espectroscopa ptica y elctrica$Fibras pticas de plstico$Instrumentacin$Lseres$Materiales cermicos$Materiales compositos$Morfognesis$Reometra$Neurobiologia celular y molecular$Tectnica y geologa estructural y sismologia','Fsica aplicada$Neurobiologa$Geociencias','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (150,'0','0','0','0','0','0','0','0','0','','0','0','Acstica$Catlisis$Corrosin$Dispersin de luz$Espectroscopa ptica y elctrica$Fibras pticas de plstico$Instrumentacin$Lseres$Materiales cermicos$Materiales compositos$Morfognesis$Reometra','','','',' ','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (89,'0','0','0','0','0','0','0','0','0','','250000 Ciencias de la Tierra y del Cosmos','','Tectnica, geologa estructural y sismologa $Magmatismo y petrognesis $Geomagnetismo y Exploracin geofsica $Geofluidos','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (13,'0','0','0','0','0','0','0','0','11141','','250000 Ciencias de la Tierra y del Cosmos ','','Agrometeorologa$Geocronologa$Metereologa$Modelos climticos$Sismologa$Termocronologa$Vulcanologa$Geomagnetismo$Fisica espacial$Biologa marina$Ecologa$Geoqumica$Geofsica$Geologa$Tctnica','','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (143,'0','0','0','0','0','0','','0','0','','250000 Ciencias de la Tierra y del Cosmos','','Radiacin solar$Sismologia$Vulcanologia$Geomagnetismo y Exploracin geofsica$Recursos naturales$Ciencias espaciales','','Ingls$Espaol','Library of Congress','El dato de colecciones se registra en la Biblioteca Conjunta de Ciencias de la Tierra (BCCT)','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (142,'0','0','0','0','0','0','','0','0','','250000 Ciencias de la Tierra y del Cosmos','','Paleontologia experimental$Difraccin de Rayos X$Espectrometria de masas$Palcoambientes$Palentologia y Palinologia$Fertilidad de suelos$Fsica de suelos$Invernadero','Geologia Regional$Geoqumica$Paleontologia$Edafologia','','','El dato de colecciones se registra en la Biblioteca Conjunta de Ciencias de la Tierra (BCCT)','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (141,'0','0','0','0','0','0','','0','0','','Ciencias Exactas y Naturales','','','Biologa Acutica$Geologia Marina$Limnologia$Qumica Acutica$Oceanografia Fsica','Ingls$Espaol','Library of Congress','El dato de colecciones se registra en la Biblioteca Conjunta de Ciencias de la Tierra (BCCT)','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (146,'0','0','0','0','0','0','','0','0','','Ciencias Exactas y Naturales','','Aerobiologa$Cambio climtico y Radiacin solar $Citogentica y Mutagnesis ambiental$Meteorologa tropical, Climatologia urbana$','Ciencias Ambientales$Ciencias Atmsfericas','Ingls$Espaol','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (115,'0','0','0','0','0','0','0 ','0','36','','240000 Ciencias de la Vida','','','Oceonografa biolgica$Oceonografa Fsica$Oceonografa Geolgica$Oceonografa Qumica y Limnologa','Ingls$Espaol','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (116,'0','0','0','0','0','0','0','0','0','','240000 Ciencias de la Vida','','','Biologa Marina$Geologa Marina$Limnologa$Oceanografa Fsica$Qumica Acutica','Ingls $Espaol','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (88,'0','0','0','0','0','0','0','0','1500','','250000 Ciencias de la Tierra y del Cosmos','','Ecologa$Estudios geolgico-ambientales en Mxico$Evolucin Tectnica de Mxico$Origen y evolucin de cuencas sedimentarias$Volcanismo y tectnica del Cenozoico$Petrognesis, Estratigrafa y geocronologa del magmatismo Mesozoico y Cenozoico$Posgrados en Ciencias de la tierra$Biolgicas y Biomdicas','Geologia Regional$Geoqumica$Paleontologia$Edafologia$Qumica y micropaelentologia$Corte y Laminacin de rocas$Petrografa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (91,'0','0','0','0','0','0','0','0','894','','330000 Ciencias de la Tecnologa','','','Ecosistemas$Infraestructura y Ciencias de la Tierra$Recursos Hdricos$Transporte$Energa$Planeacin$Tecnologas de la Informacin$Vivienda$Formacin de Recursos Humanos: Maestra y Doctorado en Ingeniera','','Numrico','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (21,'0','0','0','0','0','0','0','0','3702','','630106 Caractersticas y Civilizacin Nacionales','','Filosofa e historia de las ideas en Amrica Latina y el Caribe$Historia de Amrica Latina y el Caribe $Poltica, economa y sociedad en Amrica Latina y el Caribe $Literatura y ensayo latinoamericanos y del Caribe','Estudios Latinoamericanos  ','Espaol$Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (90,'0','0','0','0','0','0',' 0 ','0','2833','','Ciencias Sociales y Humanidades','','Ciudadania y derechos indigenas$Movimientos sociales y resistencias$ Municipalismo y poder local$Transfronterismo e integracin Centroamericana$Estudios Chiapanecos y Centroamericanos','Ciudadania y movimientos sociales$Migracin$Identidades y fronteras$Territorio y cambio ambiental global','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (154,'0','0','0','0','0','0','0','0','1843','','','','Antropologia$Historia$Etnologia$Filosofia$Economa$Literatura$Linguistica$Arqueologia$Cultura maya','','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (27,'0','0','0','0','0','0','0','0','0','','591104 Bibliotecologa','','Bibliotecologa$Ciencias de la Informacin$Estudios de la informacin','Educacin bibliotecolgica$Historia y fundamentos de la bibliotecologa y estudios de la informacin$Informacin, conocimiento y sociedad$Lectura$Metra de la informacin y del conocimiento cientfico$Organizacin de la informacin y el conocimiento$Servicios y recursos de informacin$Tecnologas de la informacin y del conocimiento$Usuarios de la informacin','Espaol$Ingls','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (14,'0','0','0','0','0','0','0','0','15262','','620305 Esttica de las Bellas Artes','','Conservacin del patrimonio cultural$ Esttica$Historia $Teora crtica del arte','Arte mundial$Arte colonial$Arte contemporneo $Arte indgena en Amrica $Pensamiento artstico','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (52,'0','0','0','0','0','0','0 ','0','8965','','Ciencias Sociales y Humanidades','','Sociologa','Actores y procesos sociales$Estudios agrarios$Estudios de la educacin y la ciencia $Estudios urbanos y regionales$Gobierno, procesos y actores sociales$Historia social y poltica$Instituciones polticas$Poblacin y estudios demogrficos$Sociedad y cultura$Sociologa de los procesos polticos$Sociolingustica y cultura ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (61,'0','0','0','0','0','0','0 ','0','0','','Ciencias Sociales y Humanidades','','Filosofia','Epistemologa$Esttica$Etica$Filosofa de la ciencia $Filosofa del lenguaje $Filosofa de la mente$Filosofa poltica $Filosofa de la religin $Filosofa en Mxico$Filosofa del derecho$Filosofa de la historia e historia intelectual$Historia de la filosofa$Lgica$Metafisica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (45,'0','0','0','0','0','0','0 ','0','13380','','560000 Ciencias Jurdicas y Derecho','','Derecho','Derecho administrativo $Derecho ambiental$Derecho civil y mercantil$Derecho constitucional $Derecho de la informacin$Derecho electoral y procesos democrticos$Derecho fiscal$Derecho internacional$Derecho penal $Derecho procesal$Derecho social$Filosofa y teora del derecho $Historia del derecho$Investigacin aplicada y opinin$Ncleo de estudios de salud y derecho$Ncleo Multidisciplinario sobre el derecho de las mujeres a una vida libre de violencia$Sociologa del derecho','','Propia','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (46,'0','0','0','0','0','0','0','0','3640','','560000 Ciencias Jurdicas y Derecho','','Derecho Civil$Constitucional$Laboral$Legislacin federal y estatal$Penal$','Jureconst-Sistema de informacin jurdico constitucional$JusLab-SIstema de informacin jurdico laboral$ISSSTEJure-Sistema de informacin jurdico del ISSSTE$UniJus- Sistema de informacin jurdico universitario','Espaol','Propia','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (125,'0','0','0','0','0','0','0 ','0','2700','','630909 Condicin de la Mujer','','Acoso sexual$Cultura e interculturalidad$Derechos humanos de las mujeres$Diversidad sexual$Equidad$Hostigamiento y acoso social$Identidad y sexualidad$Masculinidad$Migracin$Violencia de gnero','Cuestiones terico metodolgicas$Cultura y educacin $Estado, derecho y participacin social $Poblacin y salud $Subjetividad e identidad $Trabajo y medio ambiente ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (124,'0','0','0','0','0','0','0','0','98','','Tecnologas y Ciencias de la Ingeniera','','Aspectos histricos de la ciudad de Mxico y otras ciudades$Planeacin territorial, urbano-regional, poblacional, vivienda$Servicios ambientales$Temas hidrulicos','Centros histricos e identidad cultural$Competitividad urbana y economa social$Gobernanza, participacin ciudadana y coordinacin metropolitana$Planeacin participativa y gestin urbana$Pobreza urbana y politicas  sociales urbanas$Recursos naturales, agua y cambio climtico$Vivienda y desarrollo urbano sustentable y poltica habitacional','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (4,'0','0','0','0','0','0','0','0','678233','','Multidisciplinaria','','Multidisciplinaria','Actuara$Arquitectura$Artes visuales$Comunicacin$Ciencias polticas y Administracin pblica$Derecho$Diseo grfico$Economa$Enseanza de alemn, espaol, francs, ingls, italiano$Filosofa$Historia$Ingeniera civil$Lengua y literatura hispnicas$Matemticas aplicadas y computacin$Pedagoga$Relaciones internacionales$Sociologa','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (7,'0','0','0','0','0','0','0','0','0','','Multidisciplinaria','','Multidisciplinaria','Arquitectura$Comunicacin y Periodismo$Derecho$Diseo industrial$Economa$Ingeniera civil$Ingeniera en computacin$Ingeniera industrial$Ingenieria elctrica-electrnica$Ingenieria mecnica$Pedagoga$Planificacin para el desarrollo agropecuario$Relaciones internacionales$Sociologa$Maestra en Derecho$Pedagoga$Especialidad en puentes','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (159,'0','0','0','0','0','0','0','0','0','','0','0','0','Odontologia$ Fisioterapia$ Economa industrial$Desarrollo y Gestin intercultural$Administracin Agropecuaria$Ciencias Agrogenmicas','0','0','Biblioteca dada de alta el 14 feb 2014 ','0');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (8,'0','0','0','0','0','0','0','3206','247871','','620000 Artes y Letras','','','Artes visuales$Artes y Diseo$Cinematografa$Diseo y Comunicacin visual ','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (9,'0','0','0','0','0','0','0','0','1914','','620000 Artes y Letras','','Artes y Diseo$Artes visuales$Diseo y comunicacin visual','Maestra en Artes Visuales$Maestra en Diseo y Comunicacin Visual$Maestra en Docencia en Artes y Diseo$Maestra en  Cine Documental$ Doctorado en Artes y Diseo','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (35,'0','0','0','0','0','0','0','0','0','','590000 Ciencias Polticas','','Politica','Administracin pblica$Ciencias de la comunicacin y periodismo $Ciencia poltica$Relaciones internacionales$Sociologa$Maestra en Estudios polticos y sociales$Gobierno y asuntos pblicos$Comunicacin$Estudios en relaciones internacionales$Estudios Mxico-Estados Unidos$ Doctorado en Ciencias polticas y sociales','Espaol$Ingls','Library of Congress','','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (15,'0','0','0','0','0','0','0 ','0','0','','530000 Ciencias Econmicas','','','Administracin $Contadura $Informtica','','Library of Congress','Fuente: Censo Automatizado del Sistema Bibliotecario de la UNAM 2009','En tesis se incluyen tits. y vols.  formato en papel y cd-dvd');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (16,'0','0','0','0','0','0','0','0','69714','','530000 Ciencias Econmicas','','','Maestra en Administracin (Organizaciones)$Administracin (Sistemas de salud)$Administracin (Negocios internacionales)$Informtica administrativa$Alta direccin$Doctorado en Ciencias de la Administracin','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (44,'0','0','0','0','0','0','0','0','0','','560000 Ciencias Jurdicas y Derecho','','','Derecho','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (36,'0','0','0','0','0','0','0','0','133650','','Multidisciplinaria','','Multidisciplinaria','Diseo y comunicacin visual$Ingeniera en alimentos$Ingeniera qumica$Qumica$Qumica farmacutica biolgica$Qumica industrial$Farmacia$MVZ$Ingenieria agrcola$ Ingenieria Mecanica elctrica$ Tecnologa$Contadura y Administracin$Informtica','','Library of Congress','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (75,'0','0','0','0','0','0','','0','0','','','','Historia de Mxico siglo XVI a XVIII$ Historia de la minera$Historia de la Ingeniera$','Ingeniera','','','','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (162,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ciencias Ambientales$Geociencias$Geohistoria$Literatura Intercultural$EstudiosSociales y Gestin Local$Historia del Arte$Arte y Diseo$Ciencia de Materiales Sustentables$Tecnologas para la Informacin en Ciencias$Ecologa$Administracin de Archivos y Gestin Documental',NULL,NULL,NULL,NULL);
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (74,'0','0','0','0','0','0','0','0','19243','','540000 Geografa','','','Anlisis de suelos$Climatologa$geoeconoma$Geografa histrica$Geografa industrial$Geografa rural$Geomorfologa$Hidrologa$Percepcin remota$Residuos peligrosos$Sistema de informacin','','Library of Congress','Mapoteca "Alejandro de Humboldt"','');
INSERT INTO "coleccion" ("bib_id","num_tit_lib","num_vol_lib","num_tit_rev","num_fasc_rev","num_tit_tes","num_vol_tes","otros_mat_doc","num_usuarios","num_asistentes","pub_editadas","clasif_conacyt","cobert_geogra","descriptores","descript_entidad","idioma","sist_clasif","observaciones","colec_obs") VALUES (18,'0','0','0','0','0','0','0','0','3440','','240000 Ciencias de la Vida','','','Ecologa de la Biodiversidad$Ecologa Evolutiva$Ecologa Funcional$Ciencias de la Sostenibilidad$Ciencias Biomdicas','','Library of Congress','','');
--
-- Data for TOC Entry ID 61 (OID 3235373)
--
-- Name: datospersona Type: TABLE DATA Owner: israeld
--


INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1037,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1115,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1193,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1280,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1363,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1443,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1013,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1030,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1002,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1003,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1004,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1008,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1009,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1010,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1011,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1012,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1014,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1015,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1016,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1017,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1018,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1019,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1020,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1021,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1022,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1026,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1027,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1028,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1029,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1031,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1032,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1033,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1034,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1035,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1036,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1038,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1039,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1040,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1041,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1042,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1043,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1050,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1051,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1052,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1053,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1054,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1055,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1056,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1057,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1058,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1059,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1060,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1061,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1062,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1063,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1064,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1065,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1066,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1067,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1068,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1069,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1070,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1077,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1078,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1079,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1080,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1081,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1082,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1083,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1084,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1085,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1086,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1087,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1088,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1089,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1090,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1091,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1092,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1093,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1094,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1098,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1099,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1100,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1101,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1102,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1103,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1104,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1105,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1106,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1107,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1108,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1109,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1110,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1111,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1112,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1113,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1114,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1116,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1117,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1118,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1119,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1120,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1121,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1122,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1123,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1124,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1125,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1126,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1127,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1128,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1129,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1130,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1131,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1132,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1133,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1134,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1135,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1136,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1137,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1138,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1139,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1140,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1141,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1142,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1143,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1144,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1145,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1146,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1147,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1148,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1152,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1153,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1154,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1155,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1156,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1157,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1158,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1159,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1160,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1170,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1171,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1172,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1173,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1174,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1175,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1176,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1177,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1178,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1179,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1180,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1181,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1182,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1183,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1184,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1185,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1186,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1187,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1188,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1189,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1190,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1191,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1192,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1194,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1195,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1196,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1200,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1201,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1202,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1209,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1210,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1211,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1212,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1213,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1214,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1215,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1216,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1217,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1218,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1219,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1220,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1221,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1222,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1223,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1224,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1225,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1226,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1227,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1228,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1229,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1230,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1231,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1232,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1236,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1237,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1238,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1248,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1249,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1250,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1251,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1252,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1253,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1254,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1255,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1256,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1263,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1264,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1265,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1266,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1267,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1268,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1269,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1270,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1271,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1272,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1273,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1274,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1275,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1276,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1277,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1278,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1279,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1281,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1282,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1283,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1284,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1285,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1286,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1287,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1288,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1289,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1293,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1294,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1295,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1296,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1297,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1298,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1299,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1300,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1301,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1302,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1303,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1304,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1305,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1306,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1307,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1308,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1309,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1310,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1311,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1312,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1313,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1314,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1315,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1316,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1317,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1318,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1319,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1320,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1321,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1322,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1323,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1324,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1325,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1326,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1327,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1328,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1329,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1330,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1331,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1335,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1336,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1337,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1338,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1339,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1340,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1350,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1351,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1352,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1353,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1354,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1355,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1356,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1357,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1358,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1362,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1364,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1365,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1366,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1367,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1368,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1369,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1370,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1371,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1372,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1373,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1377,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1378,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1379,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1380,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1383,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1384,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1385,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1392,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1393,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1394,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1395,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1396,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1397,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1401,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1402,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1403,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1404,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1405,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1406,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1410,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1411,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1412,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1413,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1414,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1415,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1416,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1417,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1418,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1419,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1420,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1421,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1422,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1423,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1424,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1425,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1426,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1427,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1428,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1429,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1430,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1434,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1435,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1436,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1440,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1441,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1442,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1444,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1445,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1453,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1454,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1455,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1513,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1514,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1515,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1541,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1542,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1543,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1544,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1545,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1656,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1657,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1658,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1659,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1660,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2246,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2247,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2248,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2249,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2250,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2251,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2252,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2253,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2254,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2255,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2256,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2257,'','','','','','','','','',NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1197,'M. en I.','Alberto Moreno Bonett','56-23-29-00','56-23-29-01','56-23-29-02','55-10-05-73','','bonett@servidor.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1198,'Dra.','Rosa Mara Lpez Gmez','56-23-29-45','56-23-29-46','','56-23-29-62','','rmlopez@tolsa.mineria.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1044,'Dr.','Ignacio Mercado Gasca','56-22-84-74','','','55-50-43-83','','imercado_posgrado@hotmail.com','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1199,'C.P.','Lilia Rojas Mndez','56-23-29-75','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1045,'Lic.','David Vzquez Morales','56-22-84-66','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1381,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1046,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1382,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1699,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1290,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1291,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1292,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2189,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1759,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1341,'Lic.','Rosa del Carmen Zetina Castellanos','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1342,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1343,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1539,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1774,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1161,'Biol.','Ione Rosamond Coates Estrada (Jefe de la Estacin)','','','','','','rcoates@ibiologia.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1162,'Lic.','Jorge Perea Guzmn','01-(200) 125-54-04','','','01-(200) 125-54-07','','biblio@mail.ibiologia.unam.mx','','9:00 a 15:00 hrs.',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1163,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1006,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1869,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1609,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1779,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1674,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1095,'Dr.','Gerardo Fujii Gambero','56-22-21-63','56-22 -21-59','','','','fujii@servidor.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1096,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1097,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2204,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1629,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1884,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2209,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2089,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2084,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2265,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2266,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2267,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1164,'Dr.','Jorge Humberto Vega Rivera (Jefe de Estacin)','01(315) + 35-10-200','','','01(315) + 35-10-202','','jhvega@ibiologia.unam.mx','chamela@ibiologia.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1165,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1166,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2280,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2281,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2149,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2239,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (81,'Lic.','Patricia Espinosa Martnez','56-23-17-01','','','53-63-09-85','','coordcid@apolo.acatlan.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2296,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2297,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1764,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1347,'Dr.','Roberto Iglesias Prieto','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1348,'C.P.','Juan Ramn Ramos','01(998) +87 -10-219 ext. 13','','','01(998) + 87-10-138','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1349,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2094,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1939,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1332,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1333,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1334,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1744,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2307,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2308,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2310,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2311,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2312,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2313,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2314,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2317,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2321,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2322,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2323,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2324,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2325,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2326,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2327,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2329,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2330,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2331,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2332,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2336,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2337,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2338,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2339,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2340,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2341,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2342,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2343,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2344,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2345,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2347,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2351,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2354,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2355,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2357,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2358,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2359,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2360,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2361,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2362,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2366,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2367,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2368,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2369,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2370,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2371,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2372,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2373,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2374,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2377,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2383,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2385,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2386,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2388,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2389,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2391,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2392,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2400,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2401,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2402,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2403,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2404,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2406,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2411,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2412,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2414,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2415,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2416,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2418,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2419,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2420,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2421,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2422,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2426,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2427,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2428,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2429,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2430,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2431,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2432,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2433,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2434,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2435,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2436,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2437,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2441,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2442,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2443,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2444,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2445,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2446,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2447,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2448,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2449,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2450,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2451,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2456,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2457,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2460,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2461,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2463,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2464,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2465,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2466,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2467,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2471,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2472,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2473,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2474,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2475,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2476,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2477,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2478,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2479,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2480,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2482,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2487,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2489,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2490,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2491,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2493,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2494,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2495,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2505,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2506,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2507,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2516,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2517,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2518,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2520,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2521,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2522,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2523,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2524,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2525,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2526,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2535,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2537,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2541,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (20,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (21,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (22,'','','','','','','','','','','','El Director del Instituto de Geofsica es el encargado de manejar el presupuesto de la BCCT. La BCCT surge de conformidad con el convenio firmado el 11 de junio de 1998 por los Directores de los Institutos de Ciencias del Mar y Limnologa, Geofsica y Geologa y del Centro de Ciencias de la Atmsfera.',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2258,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2259,'','','','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2260,'','','','','','','','','','','','El Director del Centro de Fsica Aplicada y Tecnologa Avanzada va a fungir como Presidente del Consejo de Direccin del Campus Juriquilla. El Consejo est integrado por el Director del Instituto de Neurobiologa, el Director del Centro de Geociencias, el Jefe de Ext. de la Facultad de Contadura y Administracin y el Coordinador de Servicios Administrativos (Fuente: OFICIO:CDCJ/003/2007)',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1904,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1844,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1854,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1849,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2214,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (667,'Dr.','Ignacio de Jess Ania Briseo','56-22-85-41','','','56-22-85-40','','ignacio.ania@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (567,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (568,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1483,'Mtro. ','Jos Antonio Vela','001 (210) + 22-28-620','','','001 (210) + 22-51-772','','unamsa@servidor.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1484,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1485,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1074,'Mtra.','Margarita Lugo Hubp ','56-22-39-57','56-22-39-55','','55-50-80-68','','mlugo@servidor.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1075,'Lic.','Jernimo Snchez Caravantes','56-22-39-50','56-22-39-54','','56-22-40-29','','jeronimo@dgb.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1076,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1934,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1579,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1949,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2154,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2169,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2159,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1604,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1644,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1534,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1519,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1794,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1789,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1524,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2049,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2019,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1489,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1799,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1864,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2114,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1474,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1859,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2179,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1594,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2271,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1569,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1824,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2501,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2502,'Lic.','Alejandro Prez Fernndez','56-23-99-57','56-23-32-58','','55-23-46-40','','pefa656@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2503,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2504,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2508,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2509,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2510,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2512,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1959,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2074,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2079,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2069,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2064,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2164,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1704,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1889,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1669,'Lic.','Elvia Rodrguez Alcal','56-22-06-75 Ext. 230','','','','','elvia_roal@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1954,'Lic.','Teresa Soledad Medina Malagn','56-23-42-37','','','','','smedina@teljuriquilla.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1684,'Lic.','Teresa soledad Medina Malagn','56-23-42-37','','','','','smedina@teljuriquilla.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2286,'Sra.','Ireri Guzmn Pin','56-23-28 -28','','','','','iguzman@oikos.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1969,'Lic.','Leonor Garca Urbano','56-23-00-31','56-23-04-25','','56-23-01-97','','igu@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2024,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1694,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1979,'Mtra.','Martha Frias','56-22-78-20','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2301,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1679,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1974,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1734,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1504,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (810,'Dr.','Enrique Luis Graue Wiechers',' ','56-23-24-01','56-23-24-02','56-16-11-62 (Directo)','','egrauew@servidor.unam.mx','graue@servidor.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2346,'Lic.','Leonardo Arroyo Lira','32752','','','(01-443) 322 2726','','l.arroyo@crya.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (912,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (569,'Lic.','Jorge Alberto Coln Rojas (Interino)','56-22-84-91','','','56-22-84-91 (Solicitar tono)','','bibdgsca@unam.mx','george@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (570,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (571,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2166,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2167,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2168,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2170,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (981,'Lic.','Sal Armendriz Snchez','56-22-40-30 (Servicios)','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (647,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (648,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (649,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2206,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2207,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2208,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2210,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (978,'Lic.','Sal Armendriz Snchez','56-22-40-30 (Servicios)','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (637,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (638,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (639,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2211,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2212,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2213,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2215,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (979,'Lic.','Sal Armendriz Snchez','56-22-40-30','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (641,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (642,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (643,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2216,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2217,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2218,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2220,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1005,'Dr.','David Hiriart Garca (Jefe de Estacin)','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1007,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2099,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1989,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1719,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1814,'Lic.','Antonio Pizarro Monzn','56-22-48-10','56-22-49-00','','56-22-49-00','56-22-48-10','pmonzon@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1804,'Lic.','Celia Martnez Garca','56-23-03-14','','','56-23-03-15','','zairon@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1619,'C.P.','Felipe Flores Gonzlez','56 23 02 11 Ext. 42217 o 42076','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2219,'C. P.','Francisco Ferruzco Guido','56-22 43-80','','','56-22-43-80','','fguido@geofisica.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1914,'Lic.','Marisela Rivera Rosales','56-23-21-03','','','','','escailena@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1549,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (420,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (872,'','Marcos Garca Marcial','56-23-22-17','','','','','biblioteca.fo@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (421,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (422,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1991,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1992,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1993,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1995,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2039,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1984,'Lic.','Vctor Hugo Daz Muro (Coord. de Informtica y Bases de datos)','56-23-13-20','','','','','dmuro@campus.iztacala.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (80,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (922,'Lic.','Vernica  Beatriz Corts Nez','53-63-09-85','Red UNAM, ext. 31700 (Servicios)','Red UNAM, ext. 31701 (Responsable)','53-63-09-85 (Solicitar tono)','','coordcid@apolo.acatlan.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (82,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1531,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1532,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1533,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1535,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1624,'C.P.','Gabriel Flores de la Torre','56-22-69-95 ext. 2438','56-22-69-86 ext. 2705','','','','gfdelatorre@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2109,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2054,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1879,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2550,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2551,'Lic.','Mireya Fabin Ramrez (Delegada Administrativa)','562-32-733','562-32-798','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2552,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2556,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1709,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1714,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2316,'Lic. ','Rodrigo Santana Magro','5622 1573','','','5622 1564','','rsantana@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2376,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (507,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (948,'Lic.','Rebeca Garca','56-22-24-75 (Acervo)','56-22-24-65 (Responsable)','','56-16-26-72 (Secretara General. Solicitar tono)','','biblioteca@cepe.unam.mx','rjg@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (508,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (509,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2101,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2102,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2103,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2105,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2229,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1874,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1479,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1480,'Lic.','Mara Elena Corts (Secretaria acadmica)','001(210) + 22-28-626, ext. 225','','','001(210)  + 22-51-772','','mecs@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1481,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1482,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1486,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1487,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1488,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1490,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (461,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (708,'Lic.','Edna Alicia Contreras Ramrez','56-22-63-77','Red UNAM ext. 48062 (Servicios)','Red UNAM ext. 48047 (Responsable)','Red UNAM ext. 48062 (Solicitar tono)','','edialis91@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (462,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (463,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2051,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2052,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2053,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2055,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (46,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (864,'Lic.','Marco Alberto Soto Velasco','56-23-10-69 (Jefatura)','','','56-23-09-50 (Solicitar tono)','','sotov@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (47,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (53,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1546,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1547,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1548,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1550,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1819,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1260,'Dr.','Martn A. Valencia Moreno (jefe de Estacin Regional)','01 (662) + 21-75-019','','','01 (662) + 217-53-40','56-22-60-52','valencia@geologia.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1261,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1262,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (30,'Lic.','Godofredo Lpez Santos','56-22-82-61 (Servicios)','56-22-82-63 (Coordinador)','','56-22-82-61 (Solicitar tono)','','gnlopez@fca.unam.mx','lsantos@unam.mx','','correo alternativo de responsable Lic. Gabriela Dominguez. gdominguez@fca.unam.mx','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (805,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (31,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (32,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1586,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1587,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1588,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1590,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (17,'Lic.','Godofredo Lpez Santos','56-22-84-83 (Circulacin)','56-22-84-84 (Servicios especializados)','56-22-82-63 (Coordinador)','56-22-84-82 (Solicitar tono)','','gnlopez@fca.unam.mx ','lsantos@unam.mx','','correo alternativo de responsable Lic. Carlos Snchez. csanchez@fca.unam.mx','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (806,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (18,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (19,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1591,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1592,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1593,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1595,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (253,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (252,'','','','','','','','','','','cambio de  Coordinador de biblioteca de confianza en 16 de abril 2012  Departamento de Planeacin','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (903,'Lic.','Antonio Estanislao Urea valos','56-22-49-81 y  56-22-49-83 (Circulacin)','56-22-49-77 (Servicios especializados) 56-22-49-82 (Hemeroteca)','56-22-49-75 (Responsable)','56-22-49-75 (Solicitar tono)','','biblioteca@ciencias.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (254,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1811,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1812,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1813,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1815,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1461,'Dr.','Roberto Castan Romo','56-22-24-72','','','56-16-26-72','','rcastanon@cepe.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1462,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1463,'','','','','','','','','','','','Cambio de director nuevo Castan Romo 16/01/12, Dpto.  Planeacin verificado  via telefonica  Rebeca Garca',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1476,'Dr. ','Roberto Castan Romo','56-22-24-72','','','56-16-26-72','','rcastanon@cepe.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1477,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1478,'','','','','','','','','','','','Nuevo director Castan Romo 16/1/2012. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (702,'Bil.','Mara Dolores Valle Martnez','56-78-20-96','56-78-20-97','','56-78-20-97 (Solicitar tono)','','prepa5direccion@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (712,'Sra.','Iris Oliver Guterrez','56-77-81-99','56-78-21-04','','','','iolivergtz2903@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (450,'C.P.','Calos Ramrez Paniagua','56-77-81-99','56-78-21-04','','','','charly_3030@hotmail.com','','','','Nueva directora Valle Martnez, 2010-2014, noticia  04/10/2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (976,'Dr.','Jorge Manuel Vzquez Ramos','56-22-36-90','57-16-26-04','','56-16-18-28','','jorman@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (477,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (478,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (977,'Dr.','Jorge Manuel Vzquez Ramos','56-22-36-90','56-16-26-04','','56-16-18-68','','jorman@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (481,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (482,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (975,'Dr.','Jorge Manuel Vzquez Ramos','56-22-36-90','56-16-26-04','','56-16-18-68','','jorman@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (473,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (474,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (974,'Dr.','Jorge Manuel Vzquez Ramos','56-22-36-90','56-16-26-04','','56-16-18-68','','jorman@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (472,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (469,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (813,'Lic.','Mario Espinosa Ricalde','56-22-71-08','56-22-71-02','56-65-51-96','56-22-71-02 (Solicitar tono)','','cutdir@unam.mx','marioespinosaricalde@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (988,'C.P.','Teresa Isabel Castaeda Rojano','56-22-71-07','','','','','cutadmon@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (634,'C.P.','Teresa Isabel Castaeda Rojano','56-22-71-02','','','','','cutadmon@servidor.unam.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (665,'Dr.','Felipe Bracho Carpizo','56-22-85-41','56-22-85-42','','56-22-85-40','','felipe.bracho@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (559,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (560,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (916,'Lic.','Sandra Guadalupe Aguilar Fonseca','53-18-55-38, ext. 108','53-18-55-43',' ','53-18-55-38, ext. 109','','tandy0994@yahoo.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (740,'C.P.','Jos Valencia Chavez (Secretario Administrativo)','53-18-55-39  ext. 105','','','53-18-55-39 ext.109','','jvalencia57@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (165,'Lic.','Nstor Ruz Soria','53-18-55-39 ext.103','','','53-18-55-39- ext. 109','','nrs@servidor.unam.mx','','','','Nueva directora, Aguilar Fonseca, periodo 2009-2013, gaceta UNAM 224/4,214. 14/ene/10 (Depto Planeacin)',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1468,'Dr.','Federico Fernndez Christlieb','001 (819) +77-78-626, ext. 311','','','001 (819) +77-78-628','','ffernandez@unam.canada,com','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1469,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1470,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1464,'','','','','','','','','','','liturbe@unamcanada.com  (hasta finales de septiembre de 2012)','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1465,'Mtra.','Patricia Almazn Dirzo','001(819)  + 77-78-626 ','','','001(819)  + 77-78-628','','biblioteca@unameseca.com','patricia.almazan@unamcanada.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1466,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1467,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1471,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1472,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1473,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1475,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (556,'Lic.','Jorge Alberto Coln Rojas ','56-22-85-03 (Servicios)','56-22-84-91 (Responsable)','56-22-81-93','56-22-84-91 (Solicitar tono)','','bibliotecatic@unam.mx','george@unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (909,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (557,'Sr.','Carlos Gonzles Elvira ','56-22-80-78','','','','','hemero_dgsca@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (558,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2151,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2152,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2153,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2155,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (910,'Lic.','Jorge Alberto Coln Rojas','56-22-84-91 (Coordinador)','56-22-81-93','','56-22-84-91 (Solicitar tono)','','bibliotecatic@unam.mx','george@unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (997,'Lic.','Jorge Alberto Coln Rojas','55-53-87-34 (Servicios)','56-22-84-91 (Coordinador)','','55-53-92-32 (Coordinacin del Centro Nuevo Len)','','bibliotecatic@unam.mx','bibnl@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (561,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (562,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2156,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2157,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2158,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2160,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (824,'Dr.','Vctor Manuel Mendoza Nez','56-23-05-40','57-73-63-10','','57-73-63-10 (Solcicitar tono)','','vmmn@puma2.zaragoza.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (599,'Lic.','Pedro Pablo Gmez Flores (Secretario Administrativo)','56-23-06-35','','','','','gfpp@puma2.zaragoza.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (600,'Lic.','Sergio Silva Salgado','56-23-06-44','','','','','silva@puma2.zaragoza.unam.mx','','','','Nuevo director: Mendoza (2010-2014) boletin 16 noviembre 2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2119,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1729,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2059,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1754,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2234,'Lic.','Carlos Alberto Ronquillo Mercado','56-22-40-93','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1689,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1459,'Lic.','Teresa Soledad Medina Malagn','56-23- 42-37','','','','','smedina@teljuriquilla.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1589,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1023,'','','','','','','','','','',NULL,'Posgrado de Artes y Diseo. Cambio de denominacin 30 de marzo 2011 por Consejo acadmico del Area de las Humanidades y de las Artes.19/04/2012 cambio en directorio a peticin del responsable ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1024,'Dra.','Lucia Andrade Barrenechea (Delegada Administrativa)','55-22-06-30 ext. 116','','','','','','','8:00 a 15:00 hrs. y de 17:00 a 20:00 hrs.',NULL,'Posgrado de Artes y Diseo. Cambio de denominacin 30 de marzo 2011 por Consejo acadmico del Area de las Humanidades y de las Artes.19/04/2012 cambio en directorio a peticin del responsable ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1025,'L.C.','Edel Obregn Velasco','55-22-06-30 ext.','','','','','','','','','Posgrado de Artes y Diseo. Cambio de denominacin 30 de marzo 2011 por Consejo acadmico del Area de las Humanidades y de las Artes.19/04/2012 cambio en directorio a peticin del responsable ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1899,'Lic. ','Laura Macias Rodrguez','56-22-97-61','','','','','lmr@cie.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1398,'M.V.Z.','ngel Rosendo Pulido Albores','52 (414) + 29-18-100 ','56-23- 42-98','56-23-42-99','52 (414) + 29-18-105 ','','ceiepaa@unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1399,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1400,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1167,'Dr.','Octavio Meja Villanueva','(739) + 39-30-142','','','(739) + 39-30-616','','omejia@unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1168,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1169,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1203,'MVZ.','Ernesto Avila Gonzlez','58-63-42-39 ','58-45-15-30','','58-45-15-30 (Solicitar tono)','','avilaernesto@yahoo.com','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1204,'MVZ M en C','Ezequiel Snchez Ramrez','58-45-00-29','58-45-15-30','','58-45-15-30','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1205,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (190,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (713,'Lic.','Guadalupe Hermelinda Palma Anaya','56-22-28-17','','','','','dulsebrisamarina@gmail.com   ','dulcebrisamarina@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (191,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (192,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1746,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1747,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1748,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1750,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2014,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (752,'Mtra.','Hortensia Lobato Reyes','56-22-20-91','56-22-21-82','','56-22-21-82 (Solicitar tono)','','hlr@economia.unam.mx','','','Responsable desde 2009 Irma Esquivel maestra titulada en Bibliotecologa y Estudios de la Informacin. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (902,'Mtra. ','Irma Esquivel Esquivel','56-22-66-28','56-22-66-31 (Responsable)','','56-22-18-88, ext. 4887 (Solicitar tono)','','bibdepfe@economia.unam.mx','iees@economia.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1676,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (138,'Lic.','Juana Yolanda Guilln Cruz','56-22-21-62','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (139,'Lic.','Luis Alberto Velasco Jimnez','56-22-21-62','','','','','luisvj@economia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1677,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1678,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1680,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (517,'','','','','','','','','','','Nueva responsable: Romero Corona licenciada en bibliotecologia 04/10/12. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (966,'Lic.','Sonia Romero Corona','56-22-99-66 (Red UNAM, Secretario Acadmico, Taxco)','01 (762)  + 62-23-410 (Taxco)','','01 (762)  + 62-20-124 Taxco)','','biblioteca.taxco@cepe.unam.mx','sonia.romero@cepe.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (518,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (519,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2111,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2112,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2113,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2115,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (747,'Dr.','Roberto Castan Romo','56-16-14-74','56-22-24-72','','56-16-14-74 (Solicitar tono)','','rcastanon@cepe.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (515,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (516,'','','','','','','','','','','','Nuevo director Castan Romo 16/1/2012.DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (911,'Lic.','Jorge Alberto Coln Rojas','56-22-84-91 (Coordinador)','56-22-81-93','','56-22-84-91 (Solicitar tono)','','bibliotecatic@unam.mx','george@unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (987,'Lic.','Erndira Montiel  Calzadilla','56-22-79-70','','','','','bibmas@unam.mx','emontiel@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (565,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (566,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2161,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2162,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2163,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2165,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (91,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (919,'Lic.','Mara Xitlaly Zugarazo Navarro','54-89-49-21, ext. 146 (Servicios)','54-89-49-21, ext. 149 (Responsable)','','54-89-49-23 (Direccin)','','cendocenapx@gmail.com','xzugarazo@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (92,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (93,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1551,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1552,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1553,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1555,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (574,'Mtra.','Hortensia Lobato Reyes','56-22-20-91','56-22-21-82 ','56-22-21-84 (Servicios)','56-22-21-82 (Solicitar tono)','','hlr@economia.unam.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (753,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (575,'','Catalina Tllez Chvez','56-22-21-84','','','','','catalina@economia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (576,'','Gerardo Gutirrez Muoz','56-22-21-87','','','','','gerardo@economia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2171,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2172,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2173,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2175,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (720,'Mtro.','Marcos Mazari Hiriart','56-22-02-14','56-22-02-15','56-16-19-60 ','56-18-17-73','','dir.arq@.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (63,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (68,'','','','','','','','','','','','Nuevo director  MAZARI 2013-2017 Boletin 111. 19/feb/2013 Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (721,'Mtro.','Marcos Mazari Hiriart','56-22-02-14','56-22-02-15','56-16-19-60 ','56-18-17-73','','dir.arq@.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (128,'Mtro.','Abel Salto Rojas (Secretario Administrativo)','56-22-03-20','56-22-03-21','','','','salto@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (129,'C.P.','Silvia Meza Fernndez','56-22-03-04','','','','','besafi@hotmail.com','','','','Nuevo director  MAZARI 2013-2017 Boletin 111. 19/feb/2013 Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (993,'Dra.','Ana Carolina Ibarra Gonzlez','56-22-75-25','56-22-75-26','','56-22-75-15 (Solicitar tono)','','historicas@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (261,'Sr.','Rubn Olmedo Ponce (Secretario Administrativo)','56-22-75-17, 18 y 28','','','56-22-75-36','','rolmedop@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (262,'C.P.','Leticia Salinas Coroy','56-22-75-17 y 18','56-22-75-18','','56-22-75-36','','plesa_973@yahoo.com.mx','','','','Directora actual: Ana Carolina Ibarra 2013-2017. Boletin 443- 22/07/13. Antecedentes: Dra. Mayer (2009-2013) boletin 3 julio 2009.  tercer informe del segundo periodo /28 junio 2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2531,'','Juana Kuri Labarthe','56-22-14-14','','','','','kuri@unam.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2532,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2533,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2534,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2538,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2539,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2540,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2542,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (403,'','','','','','','','','','','Nuevo responsable a partir de 12 de agosto de 2013, Licenciatura y maestria en sociologia. Tec. acadmico titular A y de confianza ( acad.-adm)','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (956,'Lic.','Vctor Medina Corona','56-23-01-00, ext. 42497 (Servicios)','56-23-00-96 (Secretaria)','56-23-00-98 (Responsable)','','','biblioie@unam.mx','corona@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (404,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (405,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1971,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1972,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1973,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1975,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (780,' Lic.','Gerardo Arvalo Guzmn','56-22-91-10','Red UNAM ext. 47782','','56-22-91-09','','biblio@ib.unam.mx','arevalo@ib.unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (791,'Biol.','Rosamond Ione Coates Lutes','56-22-80-38','01(200) + 12-55-409','','01(200)  + 12-55-407','','rcoates@ib.unam.mx','rcoates@ibunam2.ib.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (230,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (231,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1786,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1787,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1788,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1790,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (781,' Lic. ','Gerardo Arvalo Guzmn','56-22-91-10','Red UNAM ext. 47782','','56-22-91-09','','biblio@ib.unam.mx','arevalo@ib.unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (951,'Dr.','Jorge Humberto Vega Rivera','','01(315) + 35-10-200','','01(315) + 35-10-202','','jhvega@ib.unam.mx','chamela@ib.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (234,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (235,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1791,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1792,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1793,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1795,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (676,'Dr.','Juan Alberto Adam Siade','56-22-83-75 ','56-22-83-76','','56-16-15-61','','jadam@fca.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (28,'Lic.','Araceli Mosqueda Lpez (Secretario Administrativo)','56-22-83-78','','','','','amosqueda@correo.fca.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (29,'Mtra.','Ana Ruth Bravo Sosa','56-22-83-64','','','','','bavososa@yahoo.com.mx','','','','Segundo periodo de Adam, (2013-2017) Boletin 662. 05/nov/2013 DPLybf. Nuevo Director: Adam Siade (2009-2013) Boletin 3 noviembre 2009./ Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1839,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2174,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2199,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1574,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2565,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2567,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2580,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2581,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2582,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2029,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1784,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2004,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1809,'Lic.','Roberto Gonzlez Moreno','56-22-72-94','','','56-22-18-28','','rgmoreno_@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1654,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1724,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (624,'Dr.','Jos Antonio Seade Kuri','56-22-45-23','56-22-45-24','56-22-45-25','55-50-13-42','','jseade@matcuer.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (625,'C.P.','Armando Ramrez Manjarrez','5622 4528','5622 4757','','5622 4473','','aramirez@matem.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (626,'Lic.','Patricia Valle Garca','5622 4754','','','5622 4473','','paty@matem.unam.mx','','','','Nuevo director  Seade 2014-2018. Boletin 326. 22/abril/2014  DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1437,'Dr.','David Guillermo Romero Vargas (Jefe de Unidad)','56-22-77-21','56-22-78-80','','52 (777)+317-00-44','','davidr@matcuer.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1438,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1439,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (815,'Dr.','Jess Salinas Herrera','56-22-00-22','','','56-22-00-22 (Solicitar tono)','','jesus.salinas25@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (907,'L.A.E.','Miguel Agustn Garca Domnguez','56-22-01-69','56-22-00-24','','56-22-23-88','','escorpio@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (4,'Lic.','Zaira Salinas Sierra','56-63-35-88','56-63-34-87 ext. 13 ','','56-22-00-31','','','','','','Nuevo director Salinas Herrera (2014-2018) Boletin 130. 04/03/2014 DPLybf / directora Muoz Corona (2010-1014) gaceta 04/03/10, 4, 228. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (671,'Dr.','Benjamn Barajas Snchez','53-60-03-23 y 53-60-03-24, ext. 203','53-60-03-23 y 53-60-03-24, ext. 202','','','','bbarajas45@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (959,'Mtro.','Adrian Aguilar Cruz','53-73-12-56','53-60-03-24 y 25 Ext. 209','','53-73-12-64','','','patgro_67@hotmail.com','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (162,'Lic.','Ral Gonzlez Rodrguez','53-60-03-24 y 25  Ext. 245','','','','','raulglezrguez@yahoo.com.mx','','','','Nuevo director: Barajas (2012-2016) 24 junio/ 2012. Gaceta 09ago2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (677,'Dr.','Juan Alberto Adam Siade','56-22-83-75 ','56-22-83-76','','56-16-15-61','','jadam@fca.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (15,'L.C. ',' Adriana Padilla Morales ','56-22-83-78','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (16,'','','','','','','','','','','','Ratificacin Adam Siade 2013-2017 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (803,'Dra.','Silvia Nez Garca','56-23-03-00','56-23-03-01','','55-50-03-79','','nugar@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (245,'Act.','Erich Stephen Ferrera Abre','56-23-03-02','56-23-03-06','','56-23-03-09','','cisanadm@servidor.unam.mx ','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (241,'Sra.','Mara Soledad Reyes Lucero','56-23-02-46','42-286','','56-23-03-09','53-36-35-97','luceror@servidor.unam.mx','','','','Ratificacin Nuez 2013-2017, boletin 527, 2 septiembre 2013. Primer periodo (2008-2012) Segundo informe 2010-2011 /24 octubre 2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (949,'Dr.','Manuel Perl Cohen','56-22-73-71','56-22-73-73','56-65-07-86','','','iis@sociales.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (214,'Lic.','Juana Esquivel Flores  (Secretario Administrativo)','56-22-73-99','','','56-65-24-43','','jesquive@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (215,'C.P.','Ruth Botello Landa','56-22-73-82','','','56-65-24-43','','','','','','Nuevo director Perl Cohen 2013-2017. Boletin 20 agosto 2013. DPLybf. Directora: Casas (2009-2013) boletin 17 agosto 2009. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (664,'Dr.','Felipe Bracho Carpizo','56-22-85-41','56-22-85-42','','56-22-85-40','','felipe.bracho@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (554,'Lic.','Mara Cristina Ordez Rangel','56-22-85-16','56-22-85-15','','','','ordonez@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (555,'Lic.','Juan Carlos Osnaya Gamboa','56-22-85-17','56-22-84-92','','','','jcgamboa@servidor.unam.mx','','','','Nuevo director Dr. Bracho (2011-2015) 2 mayo 2011. DPLybf ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (790,'Dra.','Vernica Ofelia Villarespe Reyes','56-23-00-87','56-23-00-91','','56-23-00-92','','direcc@unam.mx','reyesvv@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (401,'Lic.',' Alberto Antonio Pedroza Mena(Secretario Administrativo)','56-23-01-00 ext. 30143','','','56-23-01-49','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (402,'C.P.','Humberto Mondragn Correa','56-23-01-00 ext. 42479','','','','','presupuesto.iiec@correounam.mx','','','','Ratificacin Villarespe (2014-2018) Boletin 279 13 de mayo 2014. Primer periodo (2010-2014) boletin 11 mayo 2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2318,'Etnlgo. ','Jos Manuel del Val Blanco ','56-16-10-45, ext. 103','56-16-00-20, ext. 103','56-16-03-55','56-16-10-45, ext. 216','','multicultural@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2319,'C.P.','Antonio Aguilar Lagunes (Delegado Administrativo)','56-16-00-20 ext. 205','','','5-16-00-20 ext. 216','','antag@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2320,'C.P.','Gabriel Alberto Morales Caballero','56-16-00-20 ext. 209','','','56-16-00-20 ext. 216','','gabrielmc79@hotmail.com.mx','','','','Cambio de denominacin por acuerdo del Rector, marzo 2014. Director del Val (2014-2018) 25 marzo 2014. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (840,'Mtra.','Graciela de la Torre Prez','56-22-69-01','56-22-69-02','','56-22-69-44','','gdelatorre@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (119,'Lic.','Daniel Zamora Fbila','56-22-04-01','56-22-02-99','','56-22-02-99','','zfabila@prodigy.net.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (120,'Lic. ','Antonio Espinoza de los Montero Snchez','','','','5-22-02-99','','objetoae@hotmail.com','','','','Ratificacin de la Torre (2012-2016) Primer periodo (2008-2012)sf. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (617,'Dra.','Telma Gloria Castro Romero','56-22-40-69','56-22-40-76','','56-16-07-89','','telma@unam.mx','telma@atmosfera.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (618,'Lic.','Lidia Barrera Snchez','56-22-40-65','56-16-08-59','','56-16-07-89','','lbarrera@atmosfera.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (619,'Act.','Jorge Alberto Aldana Jamaica','56-16-24-08','','','56-16-07-89','','jaldanaj@atmosfera.unam.mx','','','','Ratificacin Castro 2013-2017,  Boletin 648/ 29 octubre 2013. Primer periodo 2009-2013. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (842,'Dr.','Gerardo Carrasco Nez','56-23-41-04, ext. 196','','','56-23-41-29','','direccin@dragon.geociencias.unam.mx','gerardoc@geociencias.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (385,'Lic.','Dionisio Len Salas','56-23-41-03','42-38-11-04 ext 170','','','','dls@geociencias.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (381,'Ing.','Carlos Hernndez Cabrera','56-23-41-04 ext. 174','','','','','carlosh@dragon.geociencias.unam.mx','','','','Ratificacin Carrasco (2014-2018) Boletin 266. 07 mayo 2014. Primer periodo (2010-2014) Gaceta 4,245. 11/05/2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2303,'M. C. ','Lidia Guadalupe Ortega Gonzlez  (Coordinadora)','56-22-15-38','','','56-22-05-15','','cab@unam.mx ','lortegag@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2304,'Lic. ','Misael Dominguez Hernndez (Deleg. Unid. Adva.)','5622 1564','5622 1544','','5622 1413','','misaeld@oficina.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2305,'Lic. ','Aracel Valdez Len','5622 1564','40762','','5622 1564','','araval_2006@hotmail.com','','','','Ratificacin (2013-2015). Primer periodo 2011-2013.fp. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2378,'Lic.','Mario Dubn Peniche','56-22-29-87','','','56 16 24 58','','mdubon@dgp.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2379,'Lic.','Mario Dubn Peniche','56-2228-45','','','56-22-28-46','','mdubon@dgb.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2380,'Lic. ','Yuridia Camara Aisa','56-22-28-44','','','56-22-28-46','','yuri01_@hotmail.com.mx','','','','Nuevo director Dubn (2013-2017).  17/enero/2013.DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2129,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2601,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (23,'Lic.','Sal Armendriz Snchez','56-22-40-30','56-22-40-31','','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','2008 reporta nombramiento de coordinador y tcnico acadmico titular B, pasante en maestra de Bibliotecologia y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (980,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (24,'Lic.','Ofelia Barrientos Bernab  ','56-22-40-33','56-22-40-37','','55-50-66-44','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (25,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1576,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1577,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1578,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1580,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (125,'','','','','','','','','','','2008 reporta nombramiento de jefe de seccin acadmica y tcnico acadmico asociado C, Licenciada en Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (732,'Lic.','Mara Roco Bastida Garca','56-22-86-02, ext. 1105 (Servicios)','56-22-86-02, ext. 1106 (Responsable) ','56-22-86-25 (Responsable)','56-22-86-25 (Solicitar tono)','','rocio.bastida@ccadet.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (126,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (127,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1661,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1662,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1663,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1665,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (527,'','','','','','','','','','','2008 reporta nombramiento de jefe de la Unidad de biblioteca y de honorarios, Maestro en Bibliotecologia. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (870,'Mtro.','Ral Ortega Muoz','56-22-72-52  y 56-22-72-54 (Servicios)','56-65-13-73 (Responsable)','','56-22-72-51','','biblioteca@universum.unam.mx','rortega@universum.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (528,'','Miriam Navarrete','56-22-72-54','','','','','namiriam@universum.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (529,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2121,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2122,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2123,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2125,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (50,'','','','','','','','','','','2008 reporta nombramiento de  tcnico acadmico  Titular A. Licenciada en informtica. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (878,'Lic.','Mara Elena Jimnez Fragozo','56-22-65-26, 56-22-65-27 y 56-22-65-28','01(646)  + 17-44-593, ext. 323','','01(646)  + 17-44-607','','bibens@astrosen.unam.mx','jimenez@astrosen.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (51,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (52,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1526,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1527,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1528,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1530,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (304,'','','','','','','','','','','2008 reporta nombramiento de Jefe de seccin acadmica y  tcnico acadmico Asociado C. Pasante en la maestria de Bibliotecologia y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (844,'Lic.','Lucila Martnez Arellano','56-22-50-31','','','','','bif@fisica.unam.mx','lucila@fisica.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (305,'Lic.','Pablo Carrasco Caas ','','','','pablo@fisica.unam.mx ','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (306,'Lic.','Ma. de la Luz Vela Rosales','','','','luz@fisica.unam.mx','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1866,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1867,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1868,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1870,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (368,'','','','','','','','','','','2008 Reporta nombramiento de Jefe de departamento y Tcnico Acadmico Titular A. Pasante en la maestria de Bibliotecologia y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (369,'Lic.','Lucia Brito Ocampo','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (716,'Lic.','Luca Brito Ocampo','56-22-89-07','','','56-22-89-23','','biblioteca@biomedicas.unam.mx','lucia@biomedicas.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (370,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1936,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1937,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1938,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1940,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (661,'','','','','','','','','','','2008 reporta nombramiento de Coordinador de Biblioteca y   tcnico acadmico  Titular B. Doctor en Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (723,'Dr.','Felipe Meneses Tello','56-22-44-77 (Servicios)','56-22-44-75 (Responsable)','','56-22-44-76 (Solicitar tono)','','biblioteca@matem.unam.mx','felipemt@matem.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (336,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (337,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1901,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1902,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1903,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1905,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (627,'','','','','','','','','','','2008 reporta nombramiento de tcnico acadmico Asociado C. Maestra en Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (628,'Mtra.','Mara del Pilar Lpez Rico','56-22-78-90','Ext. Red UNAM 38255','','56-22-77-22','','mplr@unam.mx','pilar@matcuer.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (629,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (630,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2236,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2237,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2238,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2240,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2546,'','','','','','','','','','','2008 reporta nombramiento de  tcnico acadmico Titular A. Pasante en maestra de Bibliotecologia. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2547,'Lic.','Lidia Gonzlez Garca','56-23-27-72','01(443)  + 32-22-772 (Morelia)','','56-23-27-32 ','01(443)  + 32-22-732 (Direccin)','lidia@matmor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2548,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2549,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2553,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2554,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2555,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2557,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (257,'','','','','','','','','','','2008 reporta nombramiento de Coordinador de biblioteca y tcnico acadmico Titular B. Maestro en Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (908,'Mtro.','Miguel Gama Ramrez ','56-22-74-25 (Prstamo)','56-65-14-51 (Responsable)','','56-65-14-51(Solicitar tono)','','bib@filosoficas.unam.mx','mgamar@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (258,'','Pedro Espinosa Ruiz','56-22-74-28','','','','','pedroer@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (259,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1816,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1817,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1818,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1820,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (748,'Dra.','Elena Centeno Garca','56-16-05-57','56-22-43-10, ext. 113','','55-50-66-44','','centeno@unam.mx','hildals@geologia.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (376,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (377,'','','','','','','','','','','','Segundo periodo de Centeno 2014-2018, Boletin 366. 24 junio 2014 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (763,'Mtra.','Silvia Estela Jurado Cullar','56-87-68-28, ext. 1701','56-87-62-38, ext. 1704','','silvia.jurado@dgenp.unam.mx','','silvia.jurado@dgenp.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (871,'Lic.','Luis Felipe Ortega Montiel','56-87-68-28 ext. 1211','55-36-74-25','','55-36-74-25','','luisfelipeom@yahoo.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (427,'C.P.','Sonia Marn Flores','56-87-69-09 ext. 1101, 1102','56-87-69-29 ext. 1101, 1102','','55-36-74-25','','','','','','Ratificacin Jurado Cullar (2014-2018) Boletin 380. 1 julio 2014, DPLybf. Nueva directora: Jurado (2010-2014) gaceta 4,261. 26 julio 2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (995,'','','','','','','','','','','NOTA: se cancela el registro de certificacin ISO, el 21 de mayo de 2013. confirmado con Mauricio Ramrez','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (904,'','Mauricio Ramrez Cuevas','56-23-05-30','56-23-06-25','56-23-05-00, ext. 30534','','','fesz.bc1@gmail.com','mauricio.ramrezcuevas@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (597,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (598,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2196,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2197,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2198,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2200,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (928,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (731,'Lic.','Luca Castro Prez','56-23-07-65 (Servicios)','56-23-07-64 (Responsable)','56-23-07-28 ','56-23-07-64 (Solicitar tono)','','lkastro71@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (601,'','Juan Pramo','56-23-07-64','','','','','56-23-07-65','','L - V  8:30 a 20:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (602,'','Silvia Gmez Rodrguez','56-23-07-28','','','56-23-07-65','','sigomr@correo.unam.mx','','L -V  8:30 a 18:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2201,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2202,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2203,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2205,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (833,'Mtro. ','Carlos Vieyra Sedano','56-22-20-08','56-22-19-86','','','','cvieyras@derecho.unam.mx','cvieyra@unam.mx','','Nuevo coordinador de biblioteca de confianza. Mtro en Derecho titulado, Vieyra a partir del 01 agosto 2014, Confirmado via tel. Cese de responsable Sara Arellano 22 mayo 2014 via telefonica','6/6/14 interinos Eugenia y Emmanuel',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (950,'','Mara Eugenia Esparza Orozco (Jefa de biblioteca)','56-22-19-56 (Servicios)','56-22-19-86 (Hemeroteca)','','56 22 19 56 (Solicitar tono)','','mesparzao@derecho.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (177,'Lic.','Sara Arellano Palafox','56-22-20-19','','','56-22-19-56','','','','L - V 8:00 a 14:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (178,'Mtro.','Alejandro Ortiz Mar','56-22-20-19','','','56-22-19-56','','','','L - V 8:00 a 18:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1731,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1732,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1733,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1735,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1834,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (606,'','','','','','','','','','','eliminacin de telefonos a peticin de Shirley, por "acoso" 12.08.2014. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (607,'Mtra.','Shirley Ainsworth','','','','','','shirley@ibt.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (608,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (609,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2221,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2222,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2223,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2225,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1206,'M. V. Z.','Oscar Gutirrez Prez','(761) + 73-40-454','(761) + 73-41-382','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1207,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1208,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1431,'M.P.A.','Hctor Basurto Camberos','(232) + 3 2-43-941','(232) + 32-43-942','','(232) + 32-43-943','','basurtoh@unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1432,'','Vctor Manuel Morales Huesca','01-323-324-3941 al 43','','','','','victormorales55@hotmail.com','','7:30 a 13:30   y 15:30 a 17:30',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1433,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (694,'Lic.','Concepcin Christlieb Robles','56-22-03-54 (Servicios)','56-22-02-97 (Coordinadora)','56-22-07-04','','','biblio_arquitectura_unam@yahoo.com.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (894,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (75,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (76,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1561,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1562,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1563,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1565,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (696,'Lic.','Concepcin Christlieb Robles','56-22-02-97','56-22-03-54','56-22-07-04','','','biblio_arquitectura_unam@yahoo.com.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (697,'','Mara de Lourdes Robleda Gonzlez de Castilla','56-23-00-62 (Servicios)','56-23-00-63 (Responsable)','','56-23-00-61 (Solicitar tono)','','lrobledag@unam.mx','lrobleda@prodigy.net.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (130,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (131,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1671,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1672,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1673,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1675,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (695,'Lic.','Concepcin Christlieb Robles','56-22-02-97','56-22-03-54','56-22-07-04','','','biblio_arquitectura_unam@yahoo.com.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (865,'','Marco Miguel Moreno Crdova','56-22-07-12','','','56-22-08-35 (Unidad Administrativa)','','biblioteca_cidi@unam.mx','komar59@terra.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (69,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (70,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1566,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1567,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1568,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1570,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (996,'Arq.','ngel Huitrn Bernal','55-93-33-34','56-80-11-02','','56-80-09-31','','huitronb@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (802,'Lic.','Armando Hernndez Gutirrez','55-93-36-04','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (436,'Ing.','Rosa Maria Nares Ruiz','56-80-10-06','','','','','','','','','Nuevo director Angel Huitrn a partir del 29 de agosto de 2014. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (931,'Dra.','Rosaura Ruiz Gutirrez','56-22-49-94','56-16-18-03','','56-22-49-48 (Solicitar tono)','','direccion@ciencias.unam.mx','rosaura@ciencias.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (255,'Mtro.','Francisco Xavier Garca Santos (Secretario Administrativo)','56-22-48-97','56-16-04-51','','','','sadmin@hp.fciencias.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (251,'Ing.','Rosa Mara Nares Ruz','56-22-48-11','','','','','naresunam@hotmail.com','','','','Ratificacion 2014-2018 Rosaura Ruiz. 02.09.2014. DPLybf. Nueva directora: Ruiz (2010-2014) boletin  30 agosto 2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (704,'Dr.','Pedro Salazar Ugarte','56-22-74-74, ext. 1214','','','','','pedsalug@yahoo.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (188,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (184,'','','','','','','','','','','','Nuevo director Dr. Salazar (2014-2018) 9.sept. 2014. DPLybf. Ratificacin Fix-Fierro (2010-2014)  boletin 08/09/10, Primer periodo 2006-2010 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (620,'Lic.','Sal Armendriz Snchez','56-22-40-30','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Solicitar tono)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (621,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (622,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (623,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2231,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2232,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2233,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2235,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (955,'Mtro.','Rosalio Luis Aguilar Almazn','56-68-08-08','56-22-92-68','','56-22-92-47','','director.sur.cch@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (954,'Lic.',' (Secretario Administrativo)','56-22-92-66','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (174,'','','56-22-92-69','56-22-92-84','','','','','','','','Nuevo director Aguilar (2014-2018) 10 Abril 2014. DPLybf. Lic. Jaime Flores Suaste. 2o. perodo 2010-2014 a partir del 5 de abril de 2010 publicado en su pagina. Depto. Planeacin ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (311,'','','','','','','','','','','2008 reporta nombramiento de  tcnico acadmico  Titular A. Mtria. Fsica de materiales. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (691,'Mtra.','Citlali Martnez Sisniega','56-22-65-20 al 24, ext. 601 (Servicios)','56-22-65-20 al 24, ext. 500 (Responsable)','01(646)  + 17-44-602, exts.  501 y 504 ','','','citlali@cnyn.unam.mx','apatron@cnyn.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (312,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (313,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1876,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1877,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1878,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1880,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (722,'Dr.','Rodolfo Zanella Specia','55-50-03-57','56-22-86-01','','56-22-86-20','','rodolfo.zanella@ccadet.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (123,'C.P.','Delia Angelica OReilly Haro (Secretario Administrativo)','56-22-86-02 Ext. 1104','','','','','delia@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (124,'LIC.','Nancy Pedroza','56-22-86-02 Ext. 1103','','','','','jorge.aldana@ccadet.unam','','','','Nuevo director Zanella 2013-2017 Boletin 734bis 9 dic.2013. Director  Saniger. Segundo informe del segundo periodo 13 febrero 2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1664,'Sra.','Carmen Chagoyan Garca','56-22-86-02 Ext. 1113','','','','','carmenchag@correo.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1564,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1829,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (823,'Dr.','Vctor Manuel Mendoza Nez','56-23-05-40','57-73-63-10','','57-73-63-10 (Solicitar tono)','','vmmn@puma2.zaragoza.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (595,'Lic.','Raymundo David Garca Barrn (Secretario Administrativo)','56-23-06-35','','','','','gbr@fragoso.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (596,'Lic.','Elizabeth Olivares Castillo','56-23-06-44','','','','','','','','','Segundo periodo (2014-2018) 15 de nov. 2014. DPLybf. Mendoza Nez Primer periodo (2010-2014). 16 nov 2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (678,'Dr.','Mario Rueda Beltrn','56-22-69-86, exts. 2453','56-65-16-61','','','','diriisue@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (72,'Lic.','Jos Mara Garca Rojas(Secretario Administrativo)','56-22-69-77','56-22-69-95 exts. 2018 y 2019','','56-22-69-76','','jmaria@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (77,'C.P.','Gabriel Flores de la Torre','56-22-69-95 ext. 2438','56-22-69-86 ext. 2705','','','','gfdelatorre@hotmail.com','','','','Nuevo director Rueda (2014-2018) Boletin 684. 25 nov. 2014. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (135,'','','','','','','','','','','cambio de responsable Coordinador de biblioteca de confianza en 28 marzo 2012  .OTRO CORREO ALTERNATIVO : zapaliname56@libe.com.mx','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (786,'Dr.','Jess Valdez Ramos   ','56-22-06-79','','','55-50-30-08 (Direccin. Solicitar Tono)','','biblioteca@cele.unam.mx','valram@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (134,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (133,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1666,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1667,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1668,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1670,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1359,'Dra.','Berta Gilabert Hidalgo','56-22-99-68 (Red UNAM)','01 (762) + 62-23-410','','01 (762) + 62-20-124','','bgilabert@cepe.unam.mx','','',NULL,'Nueva directora CEPE TAXCO, Gilabert gaceta 10/marzo/2014 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1360,'','','','','','','','','','',NULL,'Nueva directora CEPE TAXCO, Gilabert gaceta 10/marzo/2014 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1361,'','','','','','','','','','','','Nueva directora CEPE TAXCO, Gilabert gaceta 10/marzo/2014 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (61,'','','','','','','','','','','cambio de correos 9/11/12. CAMBIO RESPONSABLE Dr,  en matemticas Arturo Vargas  abril/2013. su nombramiento es de investigador, no tiene nombramiento oficial de responsable de la bca. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (936,'Dr.','Carlos Arturo Vargas Guadarrama','56-22-36-54 (Servicios al pblico)','56-22-36-56 (Prstamos)','56-22-36-11  y 56-22-35-61 (Responsable)','55-50-75-92','','biblio@iimas.unam.mx','cav@mym.iimas.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (62,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (71,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1611,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1612,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1613,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1615,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (322,'Lic.','Mara de Guadalupe Flor Daz de Len Fernndez de Castro','56-22-82-12','56-22-81-56','56-22-08-97','','','diazdeleonflor@ingenieria.unam.mx','diazdeleonsua@gmail.com','','A partir de abril 2012, el espacio en mezanine fue ocupado para archivo histrico y la biblioteca  ','Nueva coordinadora a partir de 25 de julio/2012 Diaz de Len',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (882,'','Francisco Omar Escamilla Gonzlez','56-23-29-92','56-23-29-93','','55-10-05-73','','acervohistoricopalaciomineria@yahoo.com.mx','omareg@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (323,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (324,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1886,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1887,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1888,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1890,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2588,'Dr.','Renato Gonzlez Mello','','','','','','iie.direccion@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2589,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2590,'','','','','','','','','','','','Ratificacin de director. Segundo periodo 2014-2018. Boletin 698. 2 dic. 2014. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2134,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (736,'Dr.','Carlos Agustn Escalante Sandoval','56-22-08-66','56-16-28-27','','56-16-28-90','','faing@unam.mx','caes@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (281,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (282,'','','','','','','','','','','','Nuevo Director Agustin Escalante (2015-2019) Boletin 98. 17 feb 2015 DPLybf. Segundo periodo: Guerrero (2011-2015) gaceta 4,313, 17 febrero 2011. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (739,'Dr.','Carlos Agustn Escalante Sandoval','56-22-08-66','56-16-28-27','','56-16-28-90','','faing@unam.mx','caes@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (320,'','','','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (321,'','','','','','','','','','','','Nuevo director (2015-2019) 17 feb 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (738,'Dr.','Carlos Agustn Escalante Sandoval','56-22-08-66','56-16-28-27','','56-16-28-90','','faing@unam.mx','caes@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (289,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (290,'','','','','','','','','','','','Nuevo director (2015-2019) 17 feb 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (425,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (737,'Dr.','Carlos Agustn Escalante Sandoval','56-22-08-66','56-16-28-27','','56-16-28-90','','faing@unam.mx','caes@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (285,'Ing.','Luis Jmenez Escobar (Secretario Administrativo)','56-22-08-68','56-22-08-67','55-50-71-50','','','jimeneze@yahoo.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (286,'Lic.','Martn Santa Olalla Calvo','56-23-29-67','','','','','martinsan@mineria.unam.mx','','','','Nuevo director (2015-2019) 17 feb 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (735,'Dr.','Carlos Agustn Escalante Sandoval','56-22-08-66','56-16-28-27','','56-16-28-90','','faing@unam.mx','caes@unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (280,'Ing.','Luis Jmenez Escobar','55-50-71-50','','','','','jimeneze@yahoo.com','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (276,'Lic.','Pablo Cervantes Prez','56-22-08-69','','','','','dte18@hotmail.com','','','','Nuevo director (2015-2019) 17 feb 2015 DPLybf. Ratificacin Guerrero (2011-2015) 17 febrero 2011. Primer periodo (2007-2011)  DPLybf. director Carrasco Nez, 2010-2014, g. 4,245. 11/05/2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (327,'','','','','','','','','','','2008 reporta nombramiento de Coordinador de Biblioteca y tcnico acadmico  Titular B. Maestra en Bibliotecologia y Estudios de la Informacin. PLybf ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (328,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (329,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (884,'Mtra.','Mara Teresa Vzquez Meja','56-16-11-48','56-22-46-09','','56-16-11-48 (Solicitar tono)','','biblioteca@iim.unam.mx','mtvm@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1891,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1892,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1893,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1895,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (832,'','','','','','','','','','','Nueva responsable Mtra. en  bibliotecologia (COLMEX) Alexa Milley. 12 enero 2015. DPLybf. La Lic. Edith Cinta Elias est en trmites de Jubilacin enero-abril 2014. El coordinador de la biblioteca es el Dr. Julio Collado Vides- enero 2014 DPLyb','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (707,'Mtra.','Alexa Milley Gmez Restrepo','56-22-77-06 (Servicios)','56-22-77-07 (Responsable) ','','','','biblio@ccg.unam.mx','amgomez@ccg.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (105,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (106,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1631,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1632,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1633,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1635,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (99,'','','','','','','','','','','2008 reporta nombramiento de tcnico Acadmico Titular B. Pasante en la maestria de Bibliotecologia y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (971,'Lic.','Sandra Guillermina Moncada Hernndez','56-22-56-06','','','','','smoncada@ifc.unam.mx','moncada@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (100,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (101,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1626,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1627,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1628,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1630,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (411,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (778,'Lic.','Luis Alfonso Vilchis Romero ','56-23-13-21 (Servicios)','56-23-13-19 (Responsable)','53-90-76-03','53-90-76-03 (Solicitar tono)','','udc@campus.iztacala.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (412,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (413,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1981,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1982,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1983,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1985,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2034,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (711,'Lic. ','Diana Cecilia Ortega Amieva','56-22-63-71 al 74','','','56-22-63-70','','dcortega@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (459,'Lic. ','Luis Rogelio Fvela Hernndez','56-22-63-77','56-24-80-64','','56-22-63-13','','hcastuera@servidor.unam.mx','lrfavela@unam.com.mx','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (460,'Sr.','Francisco Aguilar Vargas (encargado del rea)','56-22-63-77','56-24-80-66 ','','56-22-63-13','','efaufran@yahoo.com.mx','','','','cambio de director. Lic. Ortega a partir de 16 de enero 2015. DPLybf. Ratificacin Director Eslava (2012-2016) Primer periodo (2008 -2012) marzo 2008. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1649,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (156,'Mtra. ','Rosa Guadalupe Valadez Olguin','56-23-19-97 (Coordinadora)','56-23-19-95 (Coordinadora)','56-23-19-96 (Servicios)','58-70-56-73','','fesc@unam.mx','','','CAMBIO DE RESPONSABLE: lic. Escobedo termina y continua la Mtra. Valadez a partir del 17. de febrero 2014. DPLybf ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (963,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (157,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (158,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1696,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1697,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1698,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1700,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1529,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2124,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2104,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (66,'','','','','','','','','','','Nueva responsable Mtra Valdez ingreso abril 2015. DPL. ybf. Provisional Bibiotecario. 5 marzo 2015. Nuevo coordinador Belmont, ingresa el 1 de octubre 2013. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (893,'Mtra.','Georgina Yuriko Valdez Angeles','55-22-06-30, exts. 236 (Servicios) ','55-22-31-02, exts. 236 y 237 ','55-22-04-77, ext. 237 (Responsable)','','','gyvaldeza@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (67,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (60,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1556,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1557,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1558,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1560,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (795,'Mtro.','Jos Arturo Fernndez Pedrero','56-23-22-00','56-16-27-12','','55-50-87-07','','pedrero1@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (423,'Lic.','Jorge Ramrez Oropeza  (Secretario Administrativo)','56-23-22-34','','','','','jramirez@fo.odonto.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (424,'C.P.','Silvia Meza Fernndez','56-23-22-02','','','','','saravm@economia.unam.mx','','','','Segundo periodo Pedrero (2014-2018) Boletin 541. 17 sept. 2014. DPLybf. Nuevo director Fernndez Pedrero, 2010-2014, noticia 14/09/2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1999,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (915,'Mtra. ','Mara del Carmen de Lara Rangel','56-23-38-01','56-22-48-00, ext. 47126','','','','dircuec@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (755,'Lic.','Jos Antonio Martnez Durn','56-82-61-95','56-82-71-23 ext. 109','','56-82-78-44','','joseamtz@correo.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (194,'C.P.','Rosana Bates Acosta','56-82-61-95 ext. 122 y126','','','56-82-78-44','','','','','','Designacin de nueva directora cineasta De Lara. Boletin 274. 12 mayo 2015 DPLybf. Nuevo director: Coria Coral 2012-2016 Via telefonica 1o. agosto/2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (873,'','','','','','','','','','','','Nuevo responsable Maestro en bibliotecologia (UNAM) Fernando con nombramiento de jefe de biblioteca, administrativo. DPLybf. 13 mayo 2015.Cambio de responsable interina. Bibliotecaria Silvia Mndez. 16/feb/2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (866,'Mtro.','Fernando Xochiteotzin Pea','56-22-55-51','','','56-22-55-51 (Solicitar tono)','','biblioposgrado.fo@gmail.com','fxoch@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (426,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1996,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1997,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1998,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2000,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (493,'Lic.','Sal Armendriz Snchez','56-22-40-30','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 ','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','Nueva responsable  Mtra. en Ciencias, Tcnico Acadmico titular A, 01 junio 2014. DPLybf  .','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (924,'Mtra.','Laura Celis Gutirrez','56-22-85-96, ext. 152','56-22-85-97, ext. 152','01(998)  + 87-10-009, ext. 152','','','lcelis@cmarl.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (499,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (496,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2091,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2092,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2093,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2095,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2184,'Lic.','Ma. Eugenia Iniestra Figueroa (encargada)','56-22-87-89','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (725,'Dr.','Manuel Torres Labansat','56-22-50-32','56-65-72-63','','56-16-15-35','','direccion-if@fisica.unam.mx','torres@fisica.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (302,'C.P.','Rosa Ma. Pacheco Lpez','56-22-50-35','','','56-22-50-00','','rosma@fisica.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (388,'','','','','','','','','','','2015 abril Nuevo responsable Lic. en bibliotecologa, tcnico acadmico. DPLybf. 2008 reporta nombramiento de Jefe de biblioteca.Bachillerato. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (303,'C.P.','Marcos Snchez Csar','56-22-50-36','','','56-22-50-00','','marcos@fisica.unam.mx','','','','Ratificacin, 2o. periodo de Torres (2015-2019) 18 de mayo 2015 DPLybf. Nuevo director Torres Labansat  (2011-2015) Boletin 16 mayo 2011.  Depto. Planeacin ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2273,'Dr.','Alejandro Casas Fernndez','56- 23- 27- 04','01 (443) +  32-22-704 (Morelia)','','01 (443) +  32-22-719 (Morelia)','','acasas@cieco.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2274,'Lic.','Claudia Sanchez Hernndez','56-23-27-02','','','56-23-27-22','','csanchez@cikos.unam','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2275,'Ing.','Jess Enrique Velazquez Barrera','56-23-28-29','','','56-23-27-22','','evelazquez@cikos.unam.mx','','','','Ratificacin  Dr. Casas como primer director de IIES (2015-2019) 28 mayo 2015. DPLybf. Nuevo director  Casas Fernndez, 2011-2015 boletin 298-20/mayo/2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (96,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (990,'Mtra.','Beatrz Jurez Santamara ','56-22-39-04 (Servicios)','56-24-49-36 (Responsable)','','','','bibliotecacu@astro.unam.mx','bjuarez@astro.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (95,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (94,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1521,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1522,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1523,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1525,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (779,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (973,'Dr.','Jorge Manuel Vzquez Ramos','56-22-36-90','56-16-26-04','','56-16-18-68','','jorman@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (464,'Dr.','Rodolfo Luis Moreno Gonzlez(Secretario Administrativo)','56-22 3510','','','5622 3715','','rodolfo@dgp.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (465,'L.A.E.','Liliana Snchez Lpez','56-22-30-96','56-16-13-13','','','','','','','','Ratificacin de Vzquez (2015-2019) DPLybf. 2 de junio 2015. Nuevo director : Vzquez Ramos 2011-2015 boletin 31/05/2011. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1634,'Lic.','Mara del Carmen Armijo Abdo','56-22-76-99','','','01(777) + 31-75-581','','armijo@ccg.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (200,'','','','','','','','','','','Licenciada en psicologa: Briseida nueva responsable del CI, cambio 5/12/13 DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (827,'Psic.','Briseida Garca Verdugo','56-23-70-85, ext. 80319','56-22-66-66, ext. 80319','','','','bgarcia@posgrado.unam.mx','begobass@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (201,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (202,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1756,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1757,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1758,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1760,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (398,'','','','','','','','','','','Cambio de responsable 1o. mayo 2013 Licenciada en bibliotecologia.UNAM, Nicolasa Ramrez. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (836,'Lic.','Nicolasa Ramrez Vicente','56-23-04-25 (Servicios)','56-23-00-31 (Responsable)','','','','bibliosceiich@gmail.com','nicolasa@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (399,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (400,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1966,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1967,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1968,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1970,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (9,'','','','','','','','','','','2008 reporta nombramiento de Jefe de Departamento y tcnico acadmico titular B. Pasante en la Maestra en Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (798,'Lic.','Jos Juan Betn Gonzlez','56-23-02-20','56-23-02-21','Ext. RedUNAM 42233 (Responsable)','56-23-02-19','','bcialc@unam.mx','betan@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (10,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (11,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1616,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1617,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1618,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1620,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (242,'','','','','','','','','','','2008 reporta nombramiento de Coordinador y tcnico acadmico Asociado B. Licenciada en Bibliotecologa. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (788,'Lic.','Celia Martnez Garca','56-23-03-15 ','56-23-03-14 (Responsable)','Ext. RedUNAM 42029 (Informacin especializada)','56-23-03-15 (Solicitar tono)','','zairon@hotmail.com','zairon@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (243,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (244,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1801,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1802,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1803,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1805,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (905,'Lic.','Mara Eidi Crdova Moreno','01(967)  + 67-82-997, ext. 121 (Servicios)','01(967)  + 67-81-491, ext. 136 (Responsable)','','01(967)  + 67-80-631','','cmeidi@hotmail.com','angovez@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (389,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (390,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1956,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1957,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1958,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1960,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (406,'','','','','','','','','','','Cambio responsable 17 sept 2013. Licenciada en bibliotecologia titulada: Flores./1o. feb. cambio de responsable por lo menos en tres meses posteriores se tendr responsable interina la S. T. Gallardo Gutirrez. Prejubilacin de Martha Alicia Fras. DPLybf','Correo alternativo stecnica@correo.crim.unam.mx. 22 mayo 2013',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (876,'Lic.','Alva Flores Romero','56-22-78-20 ','01(777) + 317-50-11, ext. 118 (Cuernavaca)','01(777) + 317-52-99, ext. 118 (Cuernavaca)','','','biblioteca@correo.crim.unam.mx','floralv@correo.crim.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (407,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (408,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1976,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1977,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1978,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1980,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1509,'','','','','','','','','','','santiago@humanidades.unam.mx (alternativo). Nuevo responsable oficial desde mayo 2013, Maestro en bibliotecologia y Estudios de la Informacin: Santiago Pacheco. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1510,'Mtro.','Luis E. Santiago Pacheco ','56-22-67-28, ext. 111 ','01(999) + 92-28-446 al 48, ext. 111 (Mrida)','','','','lsantiago@humanidades.unam.mx','zanthiago@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1511,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1512,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1516,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1517,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1518,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1520,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2595,'Mtra.','Alba Eugenia Vsquez Miranda','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2596,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2597,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2591,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2592,'Lic.','Luca Mercedes Prez Rojas','01 (951) + 51-12-150, ext. 519 ','01 (951) + 51-60-541, ext. 519','','','','luciaperezrojas@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2593,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2594,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2598,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2599,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2600,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2602,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (537,'','','','','','','','','','','ejoel62@hotmail.com (Alternativo) junio2015. 2008 reporta nombramiento de  Coordinador de biblioteca y Tcnico Acadmico Titular B. Maestro en Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (775,'Mtro.','Joel Estudillo Garca','56-23-00-07','Ext. RedUNAM 42155 (Responsable)','','56-23-00-19 (Direccin)','','joel_estudillo@pueg.unam.mx','ejoel@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (538,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (539,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2131,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2132,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2133,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2135,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2511,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (673,'Mtra.','Alma Anglica Martnez Prez ','56-01-35-62 ','56-01-35-59','','56-01-35-61, ext. 132 (Solicitar tono)','','alma_angelica_s@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (831,'Lic.','Luis Felipe Ortega Montiel','56-01-35-61','56-01-35-61','','','','luisfelipeom@yahoo.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (453,'C.P.','Perla Xochitl Escutia Montiel','56-01-35-61 al 70 ext. 124','','','','','','','','','Ratificacin directora nuevo periodo 2009-2013 DPLybf, Gaceta 221/4212. 7/1/10 CAMBIO DE DIRECTOR EL 5 DE JULIO DE 2010 Jurado Cullar a la Dir. Gral. de Preparatoria, Nueva directora Martinez Prez a partir de nov. 2010 ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2044,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1344,'Dr.','Samuel Enrique Gmez Noguera (Jefe de Unidad)','01(669) 98-52-848 ext. 205','','','01(669) 98-13-688','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1345,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1346,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (767,'Dr.','Vctor Snchez-Cordero Dvila','56-22-90-65','56-22-90-66','','56-16-23-26','','dibunam@ibiologia.unam.mx','victor@ibiologia.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (232,'C.P.','Pedro Enrique Muoz Jurez','56-22-90-83','','','55-50-14-14','','secadmon@ibiologia.unam.mx','','9:00 a 16:00 y de 17:00 a 19:30 hrs.',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (229,'Lic. ','Ramn Santiago Guadalupe','56-22-90-81','','','55-50-14-14','','rsg@ibiologia.unam.mx','','9:00 a 15:00 y de 16:00 a 18:30 hrs.','','Segundo periodo de Snchez Cordero (2015-2019), gaceta 2 de julio 2105, DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (768,'Dr.','Vctor Snchez-Cordero Dvila','56-22-90-65','56-22-90-66','','56-16-23-26','','dibunam@ibiologia.unam.mx','victor@ibiologia.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (236,'C.P.','Pedro Enrique Muoz Juarz','56-22-90-83','','','55-50-14-14','','secadmon@ibiologia.unam.mx','','9:00 a 16:00 y de 17:00 a 19:30 hrs.',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (233,'Lic.','Ramn Santiago Guadalupe','56-22-90-81','','','55-50-14-14','','rsg@ibiologia.unam.mx','','9:00 a 15:00 y de 16:00 a 18:30 hrs.','','Segundo periodo de Snchez (2015-2019), 2 julio 2015 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (332,'','','','','','','','','','','2008 reporta nombramiento de jefe de departamento y de confianza, Pasante en Biblioteconoma. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (834,'','Fernando Garca Prez','56-22-98-46 (Responsable)','56-22-98-47 (Jefa de Biblioteca)','56-22-98-45 (Servicios)','56-22-98-45 (Solicitar tono)','','biblioteca@ier.unam.mx','fgp@ier.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (333,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (334,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1896,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1897,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1898,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1900,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (588,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (885,'Lic.','Mara Guadalupe Rojo Czares','56-22-87-19','','','55-50-84-05 (Coordinacin)','','biblioteca_cuaed@cuaed.unam.mx','guadalupe_rojo@cuaed.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (589,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (590,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2186,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2187,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2188,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2190,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (78,'','','','','','','','','','','Nuevo Coordinador de la biblioteca y tcnico acadmico: Mtro. en bibliotecologia y ciencias de la informacin, titulado. 04 sept. 2015. DPLybf. Domnguez, 19 agosto 2013- baja 26 de agosto 2015.  DPLybf ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (717,'Mtro.','Sergio Arregun Meneses','56-22-69-86, exts. 2109 y 1312 (Servicios)','56-22-69-86, ext. 2101 (Responsable)','56-22-69-86, ext. 2103 ','56-65-01-23 (Direccin)','','bibiisue@gmail.com','biblioteca_iisue@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (88,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (89,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1621,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1622,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1623,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1625,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (858,'Dra.','Elizabeth Fuentes Rojas','54-89-49-24, exts. 119 y 121','','','54-89-49-23','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (999,'Lic.','Luis Carlos Santana quintana (Secretario Administrativo)','54-89-54-25','','','','','luiscs@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (930,'Mtro.','Jos Cupertino Rubio Rubio','57-19-21-93','50-97-21-01 ','','53-68-87-67','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (90,'L.C.','Olmpica Obregn Velasco','54-89-49-18, 22','','','','','maxyamy@hotmail.com','','','','Nueva directora FAD: Fuentes (2014-2018) Boletin 29 abril 2014 DPLybf. Nuevo director: Manzano (2010- 2014) Boletin informativo 28 abril 2010. Departamento de Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1554,'Lic.','Daniel Garca Barragn','54-89-49-21  ext. 110 y 106','','','','','abidan66@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (501,'','','','','','','','','','','2008 reporta nombramiento de Coordinador de Biblioteca  y tcnico acadmico Titular B. Pasante en la maestra de Bibliotecologa y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (690,'Lic.','Sandra Guadalupe Rosas Poblano','56-22-45-66','56-24-56-07','','56-16-62-27 (Solicitar tono)','','biblioteca@iquimica.unam.mx','sandrarp@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (502,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (503,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2096,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2097,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2098,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2100,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2543,'Dr.','Daniel Juan Pineda','56-23-27-98','01 (443) + 322-27-98 (Morelia)','','56-23-27-32','01 (443) + 322-27-32 (Morelia)','daniel@matmor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2544,'Lic','Mireya Fabin Ramrez (deleg. admva.)','56-23-27-31','','','56-23-27-32','','mireya@matmor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2545,'Lic.','Mireya Fabin Ramrez','562-32-733','562-32-798','','56-23-27-32','','mireya@matmor.unam.mx','','','','Ratificacin  Juan Pineda (2015-2019) Boletin 524. 11.sept. 2015. DPLybf. Primer director Juan Pineda 2011-2015, Gaceta 12/septiembre/2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2573,'Dr.','Jos Antonio Vieyra Medrano','56-23-27-77','Red UNAM ext. 32865','01 (443) +322-38-65 (Morelia)','01 (443) +322 38 65 (Morelia, solicitar tono)','','avieyra@ciga.unam.mx','direccin@ciga.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2574,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2575,'','','','','','','','','','','','Nuevo director Vieyra Medrano (2015-2019) G. 4722. 14 sept. 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2333,'Dr.','Enrique Cristian Vzquez Semadeni','56-23-27-95','Ext. Red UNAM  32795','01 (443) +322-27-95 (Morelia)','','','direccin@crya.unam.mx','e.vazquez@crya.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2334,'Lic.','Reynaldo Hernndez Delgado','01(443) 322 2728 ','5623 2728','','56-23-27-26 ','','rhernandez@crya.unam.mx','rhernandez@astrosmo.unam.mx','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2335,'Lic.','Carol Rangel Castro','56-23-27-95 y 96','56-23-22-78','01(443) 322 3884','56-23-27-26','','c.rangel@astrosmos.unam.mx','','','','Nuevo director Vzquez Semadeni (2015-2019) G. 4722. 14 sept. 2015. DPLybf. Ratificacin Lizano (2011-2015) 20 mayo 2011. Primer periodo (2007-2011) DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (766,'Dr.','Vctor Snchez-Cordero Dvila','56-22-90-63','56-22-90-67','','55-50-01-64','','dibunam@ib.unam.mx','victor@ib.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (228,'Lic.','Claudia A. Canela Galvn ','56-22-90-83','56-22-90-69','','55-50-14-14','','ccanela@ibiologia.unam.mx','','9:00 a 16:00 y 17:00 a 19:30',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (224,'Ing.','Enrique Sandoval Ballesteros','56-22-90-81','56-22-91-28','','55-50-14-14','56-22-89-70','rsg@ibiologia.unam.mx','ifcomi@ibiologia.unam.mx','9:00 a 15:00 y de 16:00 a 18:30','','Ratificacin de director (2015-2019) segundo periodo de Snchez Cordero, gaceta 2 julio 2015. DPLybf. Nuevo director, nombre completo Vctor Manuel Guillermo Snchez Cordero Dvila (2011-2015) Boletin 28 junio 2011 DPLybf, Primer informe 2011-2012 Gaceta 07/01/13. Segundo informe, gaceta 02/dic/2013.',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (777,'Dr.','Arturo Iglesias Mendoza','56-16-23-44','56-22-41-22','','55-50-24-86','','director@geofisica.unam.mx','arturo@geofisica.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (644,'Sra.','Cecilia Pliego Garza (Secretario Administrativo)','56-16-27-33','56-22-41-08','','56-22-41-44','','cpliego@geofisica.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (640,'C. P. ','Viviana Torres Valle','56-22-41-11','56-22-41-02','','56-22-41-11','','viviana@geofisica.unam.mx','','','','Nuevo director: Iglesias (2013-2017) boletin DGCS 202, 02/abril/2013.  DPLybf. Director: Valds Galicia (2009-2013) Boletin 189 /31 marzo/2009. ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (826,'Dra.','Martha Patricia Ostrosky Shejet','56-22-89-05','56-22-89-06','','55-50-64-47','','direccion@biomedicas.unam.mx','ostrosky@biomedicas.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (371,'Lic.','Cristina Ordoez Rangel (Secretario Administrativo)','56-22-89-02','','','55-50-00-48','','bandrade@biomedicas.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (367,'Lic.','Mario Curel Fonseca','56-22-89-03','','','55-50-00-48','','mariocuriel@biomedicas.unam.mx','','','','Ratificacin  Dra. Ostrosky (2015-2019) segundo periodo 26/03/2015 DPLybf. Nueva directora: Ostrosky Shejet, (2011-2015) gaceta  4.323.  24 marzo 2011. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (796,'Dr.','Jos Antonio Seade Kuri','56-22-45-23','56-22-45-24','56-22-45-25','55-50-13-42','','jseade@matcuer.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (338,'C.P.','Armando Ramrez  Manjarrez (Secretario Administrativo)','56-22-45-54 y 57','56-22-44-74','56-22-45-82 y 29','56-22-44-73','','aramirez@matem.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (335,'Lic.','Patricia Valle Garca','56-22-47-54','','','56-22-44-73','','paty@matem.unam.mx','','','',' Nuevo director Seade (2014-2018) Boletin 236, 22 abril 2014. DPLybf. Segundo periodo: Bracho (2010-2014) gaceta 4,240  22/04/10. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (934,'Dr.','Jorge Pen Peralta','56-22-44-20','56-22-44-26','56-16-25-76','56-16-22-17','','direciq@unam.mx','jpeon@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (504,'Lic.','Jos Alejandro Roque (Secretario Administrativo)','56-22-44-34','56-16-68-96','','56-16-22-03','','jroque@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (500,'Sra.','Araceli  Vzquez','56-22-44-39','','','56-16-22-03','','araceliv@correo.unam.mx','','','','Nuevo director: Pen (2014-2018) Boletin 264. 06 mayo 2014 DPLybf.  Cuevas (2010-2014), gaceta 4,244.  06 mayo 2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1446,'Dr.','Ramiro Prez Campos','56-23-41-50','56-23-41-51','01 (442) 238-11-51 (Quertaro)','56-23-41-50','','ramiro@fis.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1447,'C. P.','Andrea','56-23-41-56 ','Qro. (442) 238-11-56','','','','ruma@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1448,'C.P.','Miguel Velzquez Mora','56-23-41-55','Qro. (442) 238-11-55','','','','','vemora@fata.unam.mx','','','Ratificacin Prez (2014-2018) Boletin 07 mayo 2014. Primer periodo 2010-2014. G. 4,245. 11/05/2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (835,'Dr.','scar Edel Contreras Lpez','56-22-65-20, exts. 704 y 706','01 (646) +17-44-602, exts. 704 y 706 (Ensenada)','','','','edel@cnyn.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (314,'C.P.','Rben Cruz Medrano','56-22-64-77','','','56-22-64-77','','ruben@dgsg.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (310,'C.P.','Jos Prez Gonzalez','56-22-65-20 Ext. 4333','','','01 646 1752361','','jperez@cnyn.unam.mx','','','','Cambio de director Contreras  (2014-2018) 05/03/14, Boletin 132, DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1506,'Dr.','Adrin Curiel Rivera','56-22-67-28, ext, 121','56-22-67-29, ext. 121','01 (999) 92-28-446, ext. 121 (Mrida)','','','acurielrivera@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1507,'Lic.','Gerardo Oceguera Jmenez (Deleg. Administrativo)','01 (353) 53-30-758 ext. 311','','','01 (353) 53-30-758 ext. 312','','goceguera@humanidades.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1508,'Lic.','Jess Ramos Cedillo','56-22-75-67 ext. 154','','','56-22-75-77','','jramosc@humanidades.unam.mx','','','','Nuevo Director Curiel Rivera (2015-2019) Boletin 540. 17 sept. 2015. DPLybf. Dir. anterior: Lisbona Guilln 2012-2016. Boletin 752bis/05/12/12. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (789,'Dr.','Jaime de Urquijo Carmona','56-22-77-45','56-22-77-46','01 (777) + 329-17-30 (Cuernavaca)','56-22-77-53','','direccion@fis.unam.mx','jdu@fis.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (674,'Lic.','Sabino Marban Ocampo','56-22-77-47','56-22-77-48','','56-22-77-53','','smo@fis.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (307,'Lic.','Martha Patricia Rodrguez Moran','56-23-82-11','','','56-22-77-39','','rodriguez@fis.unam.mx','','','','Nuevo director  2014- 2018 De Urquijo. BOLETIN 649, 8 nov 2014. DPLybf. Nuevo director : Ortega (2010-2014) boletin 10 noviembre 2010. Depto.  Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (782,'Dra.','Marcia Hiriart Urdanivia','56-22-56-65','56-22-56-04','Red UNAM ext. 45228','56-16-22-82 (Solicitar tono)','','mhiriart@ifc.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (102,'L.A.E.','Gilberto Escamilla Marvan (Secretario Administrativo)','56-22-55-95','56-22-55-96','','56-22-56-38','','gescami@ifisiol.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (37,'C.P.','Angel Cedillo Hernndez','56-22-56-00','56-22-56-01','','','','acedillo@ifisiol.unam.mx','','','','Ratificacin Hiriart 2013-2017, Boletin 618 , 15 oct. 2013. DPLybf. Primer periodo (2009-2013) boletin 607-14/oct/2009 . Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (749,'Dra.','Elena Centeno Garca','56-22-43-08','56-16-05-57','','55-50-66-44','','centeno@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (635,'Lic.','Ana Mara Rodrguez Simental (Secretario Administrativo)','56-22-42-95','56-22-49-07','','56-22-43-18','','simental@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (636,'Srita.','Guadalupe Chvez Villagrana','56-22-43-22','56-22-42-73','','56-22-43-22','','presup@geologia.unam.mx','','','','Segundo periodo: Centeno Garca ( 2014-2018), Boletin 366. 24 junio 2014 DPLybf. Primer periodo (2010-2014) noticia 30/06/2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (653,'Dra.','Elva Guadalupe Escobar Briones','56-22-57-70','56-22-57-71','56-22-58-41','56-16-27-45','','direccion@cmarl.unam.mx','escobri@cmarl.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (645,'L.C.','Myrna Jossie Avila Muoz (Secretario Administrativo)','56-22-57-74','56-22-57-75','','56-16-27-09','','administracion@icmyl.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (646,'Lic.','Alejandra Garca Reyes','56-22-57-74','56-22-57-75','56-22-58-08','56-16-27-09','','alejandra_garcia@icmyl.unam.mx','presupuesto@icmyl.unam.mx','','Segundo periodo de Escobar (2015-2019) Gaceta 24 septiembre 2015. DPLybf. Nueva directora: Escobar  (2011-2015) Boletin 508. 04/0ct/2011 Depto. Planeacin','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (652,'Dra.','Elva Guadalupe Escobar Briones','56-22-57-70','56-22-57-71','56-22-58-41','56-16-27-45','','direccion@cmarl.unam.mx','escobri@cmarl.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (487,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (490,'','','','','','','','','','','','Segundo periodo de Escobar (2015-2019) Gaceta 24 septiembre 2015. DPLybf.',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (651,'Dra.','Elva Guadalupe Escobar Briones','56-22-57-70','56-22-57-71','56-22-58-41','56-16-27-45','','direccion@cmarl.unam.mx','escobri@cmarl.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (486,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (489,'','','','','','','','','','','','Segundo periodo Escobar (2015-2019) Gaceta 24 septiembre 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (650,'Dra.','Elva Guadalupe Escobar Briones','56-22-57-70','56-22-57-71','56-22-58-41','56-16-27-45','','direccion@cmarl.unam.mx','escobri@cmarl.unam.mx','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (485,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (488,'','','','','','','','','','','','Segundo periodo de Escobar (2015-2019) Gaceta 24 septiembre 2015. DPLybf. Nueva directora Escobar, periodo 2011-2015. Gaceta 4,369. 03/octubre/2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1894,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (195,'','','','','','','','','','','Gregoria es egresada de la FCPyS, en carrera de comunicacin.(INF. 2015)','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (742,'','Gregoria Bustamante Rojas','56-22-48-00, ext. 47178','','','','','gregoria@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (196,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (197,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1751,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1752,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1753,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1755,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (984,'Mtra.','Mara Dolores Zarza Arizmendi','56-55-23-32, exts. 201 y 211','56-55-07-34','','56-55-71-53, ext. 209 (Solicitar tono)','','mdz55@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (733,'Mtra.','Gabriela Garza Infante','56-55-22-98','','','56-55-22-98 ext. 310','','ggarza@.eneo.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (362,'Lic.','Cristian Viviana Solares Vargas','56-55-22-98 ext. 280','','','','','alendramora41@hotmail.com','','','','Ratificacin de Zarza (2015-2019) Boletin 069. 3 de febrero 2015 DPLybf. Nueva directora: Zarza Arizmendi (2011-2015) Boletin.  01/02/2011. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2244,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1614,'','','56223550','','','','','jadquis@leibniz.iimas.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (765,'Dra.','Margarita Velzquez Gutirrez','56-22-78-35, ext. 102','56-22-77-77, ext. 102','','01(777) + 31-75-981','','mavg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (769,'Ing.','Hctor Silva Rhoads','01(777) +329-18-30 ','01(777) +313-05-55','56-22-78-30 ','01(777) + 317-59-81','','hsilva@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (409,'Lic.','Mara Claudia Snchez Garca','56-22-78-39','','','','','mcasg@correo.crim.unam.mx','','','','Ratificacin Dra. Velzquez, para segundo periodo 2015-2019. 12 nov 2015, DPLybf. Nueva directora: Velzquez 2011-2015. Boletin 20/10/2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2610,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2611,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2616,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2606,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2607,'Lic.','Jos Mauricio Anaya Rivas','56-23-73-00, ext. 80517','01 (443) + 689-35-00 (Morelia) ','','','','mauricio.anaya@enesmorelia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2608,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2609,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2613,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2614,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2615,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2617,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1498,'Mtra.','Adriana Daz Mrquez','01 (246) +465-18-02 (Mxico a Tlaxcala)','','','','','','','',NULL,'Nueva titular de SUAyED, Tlaxcala: Mtra. Adriana Daz, 24 noviembre 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1499,'','','','','','','','','','',NULL,'Nueva titular de SUAyED, Tlaxcala: Mtra. Adriana Daz, 24 noviembre 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1500,'','','','','','','','','','','','Nueva titular de SUAyED, Tlaxcala: Mtra. Adriana Daz, 24 noviembre 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1494,'','','','','','','','','','','Responsable de biblioteca provisional de la SUAyED, pasante de la licenciatura de diseo grfico (por tres meses) a partir del 15 de nov de 2015.DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1495,'','Francisco Varela Fuentes ','01 (246)  + 465-18-14 ( Mxico a Tlaxcala)','','','','','francisco_varela@cuaed.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1496,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1497,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1501,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1502,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1503,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1505,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (859,'Dra.','Elizabeth Fuentes Rojas','54-89-49-24, exts. 119 y 121','','','54-89-49-23','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (64,'Ing.','Jos Luis Dupinet Ztina (Delegado Administrativo)','56-22-06-30 ext. 216','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (65,'Lic.','Yolanda Valencia','56-22-06-30 ext. 221, 222','','','','','','','','','Nueva directora FAD: Fuentes (2014-2018) Boletin 29 abril 2014 DPLybf.',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1559,'Lic.','Georgina Daniela Hernndez Cruz','55-22-04-70   55-42-56-95 y 48-92','5542 4892 ext. 107','','55-22-31-02 y 06-30 ext. 107','','adquisiciones_asc@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (603,'Dr.','Octavio Tonatiuh Ramrez Reivich','56-22-76-46','01 (777)  32-91-671 (Cuernavaca)','','01 (777) 31-72-399 (Solicitar tono)','','tonatiuh@ibt.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (604,'C.P.','Francisco Arcos Milln','56-22-76-39','','','56-22-78-57','','farcos@ibt.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (605,'Lic. Admn.','Carlos Enrique Mendoza Nava','56-22-77-77  ext: 38367','','','','','','','','','Nuevo director Ramrez (2013-2017) gaceta 4,501, 01 abril 2013. Director: rias (2009-2013) Boletin 23 de marzo 2009. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2224,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (663,'C.P.','Ramn Trejo Gonzlez (Secretario Administrativo)','50-97-21-06','','','50-97-21-05','','ram_trejog@yahoo.com.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (168,'Lic. ','Diana Alatorre Hernandez','50-97-21-32','','','50-9721-05','','diana_reyna@hotmail.com','','','','El 31 de agosto 2015 deja de fungir como director el Dr. J. Jess Ceja. Nuevo director  Ceja (2014-2018) 05 mayo 2014 DPL.ybf. vila Antuna  2010-2014 a partir del 15 de abril de 2010, Gaceta  4,238 Depto de Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (48,'C.P.','Marina Ojeda Vera (Secretario Administrativo)','56-22-61-52 ext. 303','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (787,'Mtra.','Mara del Carmen Rodrguez Quilantn','57-64-40-29','','','57-64-40-20','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (856,'Lic.','Luis Omar Botello Landa','57-64-40-17','57-64-40-23','','57-64-40-11','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (456,'','','','','','','','','','','','Nuevo director: Garca Rodrguez (2011-2015) Gaceta 12/01/12, Depto.  Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2261,'','','','','','','','','','','2008 reporta nombramiento de coordinador de biblioteca y tcnico acadmico titular B, Dr. en Bibliotecologia y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2262,'Dr.','Francisco Javier Valles Valenzuela','56-23-42-41 (Servicios)','56-23-42-33 (Responsable)','01(442) + 19-26-143 (Quertaro)','56-23-42-43','01(442) + 19-26-143','biblio@juriquilla.unam.mx','jvalles@juriquilla.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2263,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2264,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2268,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2269,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2270,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2272,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (203,'Dr.','Javier Nieto Gutirrez','56-23-70-45','56-23-70-79','56-16-01-55','','','coordinacion@posgrado.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (198,'Lic.','Luis Eduardo Saenz Villa','55-50-75-69','56-23-02-33','56-23-02-39','56-23-02-44','','esaenz@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (199,'C.P.','Marisela Fajardo Zafra','56-23-03-36','','','56-23-03-36','','mfajardo@posgrado.unam.mx','','','','Sustitucin de Coordinador, Dr. Nieto. Gaceta 21 enero 2016. DPL.ybf. Cambio de director Laclette (2014-2018) 6/02/14 Gaceta 4578, DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2468,'Lic.','Marco Antonio Domnguez Mndez','56-22-25-22','56-16-21-72,  ext. 41136','','56-16-03-05','','marco@dgp.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2469,'Mtro.','Rodolfo Luis Moreno Gonzlez','5622 2525','','','5616 1894','','rodolfo@dgp.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2470,'C.P.','Cesar Avlos Hernndez','5622 2593','','','5616 1894','','cavalos@dgp.unam.mx','','','Ratificacin de  Lic. Antonio Domnguez. Gaceta 21 enero 2016. DPL.ybf.','El 7 de enero 2013 se nombra al Ing. Leopoldo Silva como Secretario Administrativo UNAM. *Dominguez Mndez nuevo director (2013- 2017) Gaceta 4482. 17 enero 2013. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (746,'Dr.','Roberto Castan Romo','56-16-14-74','56-22-24-72','','56-16-14-74 (Solicitar tono)','','rcastanon@cepe.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (505,'Lic.','Rosa Lina Snchez Molina','55-50-02-36','','','','','rina@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (506,'Lic.','Daniela Soraya Luna Oceguera','55-50-76-06','56- 22- 25- 67','','55-50-02-36','','','','','','Ratificacin de Castaon. Gaceta 21 enero 2016. DPL.ybf.Cambio de director Castaon Romo 16/01/12, verificado  via telefonica  Rebeca Garca 2012-2015. Gaceta 19 ene 2012.DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (804,'Dr.','Francisco Cervantes Prez','56-22-87-13','','','55-50-84-05','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (586,'Lic.','Jos Armando Galicia Rojas','56-22-87-30','','','56-16-05-76','','armando_galicia@cuaed.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (587,'C.P.','Felipe Paz Pacheco','56-22-87-01','','','56-16-05-76','','felipe_paiz@.cuaed.unam.mx','','','','Sustitucin de director Cervantes Prez. Gaceta 21 enero 2016. DPLybf. Cambio de directora nueva Zubieta Garca 23/01/12, (2012-2016) Dpto.  Planeacin gaceta19/ene/2012',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2453,'Dr.','Enrique del Val Blanco','56-22-60-79','','','56-65-09-43','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2454,'Mtro.','Rigoberto Len Berber ','5622 6078','5622 6076','','5622 6118','','rleonb@planeacin.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2455,'C.P.','Monica Patricia Gonzlez Lpez','56 22 60 90','','','5622 6090','','monicag@planeacion.unam.mx','','','','Sustitucin de director , ahora Val Blanco. Gaceta 21 enero 2016. DPLybf. Ratificacin (2012-2016) fp. Primer periodo (2008-2012) 11 febrero 2008. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (666,'Dr.','Felipe Bracho Carpizo','56-22-85-41','56-22-85-42','','56-22-85-40','','felipe.bracho@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (563,'Sra.','Rosa Ana Len  Rodrguez (Delegada Administrativa)','56-22-79-70','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (564,'','','','','','','','','','','','Ratificacin de Bracho. Gaceta 20 enero 2016. DPLybf. Nuevo director Dr. Bracho a partir de 2 mayo 2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1389,'Ing.','Sergio Alva Arguinzoniz (Coordinador del Centro Mascarones)','56-22-79-50','','','','','s.alva@unam.mx','','',NULL,'Coordinador del centro Mascarones Ing. Alva. 22 enero 2016. DPL.ybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1390,'','','','','','','','','','',NULL,'Coordinador del centro Mascarones Ing. Alva. 22 enero 2016. DPL.ybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1391,'','','','','','','','','','','','Coordinador del centro Mascarones Ing. Alva. 22 enero 2016. DPL.ybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1386,'Lic.','Alejandrina San Juan Reyes (Coordinadora del Centro Nuevo Len)','55-53-91-74','','','','','alesajur@unam.mx','','',NULL,'Coordinador a del Centro Nuievo Len Lic. Alejandrina. 22 enero 2016. DPL.ybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1387,'','','','','','','','','','',NULL,'Coordinador a del Centro Nuievo Len Lic. Alejandrina. 22 enero 2016. DPL.ybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1388,'','','','','','','','','','','','Coordinador a del Centro Nuievo Len Lic. Alejandrina. 22 enero 2016. DPL.ybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (764,'Dr.','Hctor Fernndez Varela Meja','56-22-01-46','56-22-01-48','','56-22-01-46 (Solicitar tono)','','hfernandezvar@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (213,'Lic.','Alma Anglica Jurez Soto','56-16-29-51','56-22-01-38','','56-22-01-38','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (212,'C.P.','Julio Rodolfo Cern Arregun','56-22-01-38','56-22-01-26','','56-22-01-38','','','','','Cambio de denominacin Antes Direccin General de Servicios Mdicos. 4 enero 2016. DPL.ybf','Ratificacin de Fernndez Varela. Gaceta 21 enero 2016. DPL.ybf. Continua Fernndez (2012-2016) Ratificacin (2008-2012) Gaceta 4042, 21 enero 2008. Primer periodo (2004-2008) DPL.ybf ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2513,'Dr.','Alberto Ken Oyama Nakagawa','56-22-11-81','56-22-11-82','','55-50-05-25','','carratia@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2514,'Mtro.','Daniel Ortz Martnez','5622 1186','','','5622 1185','','dortizma72@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2515,'L. C.','Isaias David Reyes Lpez','5622 1198','','','5622 1185','','eliasdavidreyes@yahoo.com.mx','','','','Sustitucin por Ken Oyama. Gaceta 21 enero 2016. DPL.ybf. Designacin Trigo Tavera (2011-2015) Nov, 2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (807,'Dr.','Germn Enrique Fajardo Dolci','56-23-24-02','','','56-16-16-16','','direccionfm@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (343,'C. P.','Francisco Cruz Ugarte (Secretario Administrativo)','56-23-24-10','56-23-24-30','','56-16-00-88','','f_ugarte@liceaga.fmg.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (344,'L.F.','Gabriel Tenorio Fuentes','56-23-24-36','','','56-23-24-77','','','','','Director interino Argero Snchez a partir del 24 de noviembre de 2015. DPLybf. ','Nuevo director, Dr. Fajardo . Gaceta 25 enero 2016. DPLybf. Designacin como rector del Dr. Graue, el 17 de noviembre de 2015. DPL.ybf. Ratificacin Graue (2012-2016) 26/01/2012. Primer periodo (2008- 2012) DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (811,'Dr.','Germn Enrique Fajardo Dolci','56-23-24-01','56-23-24-02','','56-16-16-16','','direccionfm@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (366,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (363,'','','','','','','','','','','Director interino Argero Snchez a partir del 24 de noviembre de 2015. DPLybf. ','Nuevo director Dr. Fajardo. Gaceta 25 enero 2016. DPL.ybf. Designacin como rector del Dr. Graue, el 17 de noviembre de 2015. DPL.ybf. Ratificacin Graue (2012-2016) 26/01/2012. Primer periodo (2008- 2012) DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2438,'Lic.','Nstor Martnez Cristo','56-22-14-38','56.-22-10-86','','56-22-10-10','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2439,'Lic.','Ignacio Antonio Rodrguez Hernndez','5622 1443','','','5622 1439','','ignacioa@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2440,'Sra.','Ma. de Lourdes Rivera Hernndez','5622 1430','5622 1432','5622 1433','5622 1439','','lulurivera_65@hotmail.com','','','','Sustitucin  por Lic. Martnez. 22 enero 2016. DPL.ybf. Nuevo director Dvalos (2013-2017) Boletin 327. 28 mayo 2013. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2393,'Mtro.','Eduardo Guerrero Villegas','56-22-61-74','','','56-65-12-25','','eduardogv@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2394,'Lic.','Oscar Ramrez Gonzlez','5622 6171','5622 6172','','5622 6171','','oscarrag@correo.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2395,'Lic.','Ramn Alvarez Rodrguez','5622 6171','5622 6172','','5622 6171','','r1064rar@yahoo.com.mx','','','Cambio de denominacin Gaceta 21 de enero 2016. antes: Direccin General de Atencin a la Comunidad. Universitaria.','Sustitucin por Dr. Guerrero en Gaceta 21 enero 2016. DPLybf. Nuevo director: Fernndez Varela 2012-2016. Gaceta 16 feb. 2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (958,'Mtro.','Eduardo Vega Lpez','56-22-21-00','','','56-16-08-14','','direccion@economia.unam.mx','angeles@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (572,'Ing.','Francisco Castaeda Miranda (Secretario Administrativo)','56-22-21-52','','','56-16-15-86','','fcm@economia.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (573,'C.P.','Mara del Carmen Aguilar Mendoza','56-22-20-97','56-22-21-54','','56-22-20-97','','inuk0875@hotmail.com','','','El dr. Leonardo Lomel fue designado como Secretario General a partir del 18 de noviembre de 2015. DPLybf.','Nuevo director doctorante Vega Lpez. B. 055. 26 enero 2016. DPL.ybf. Director interino Anaya Daz a partir de 24 de noviembre de 2015. DPLybf. Ratificacin Segundo perodo (2014-2018) Boletin 099. 18 feb 2014. DPLybf. Nuevo director: Lomel (2010-2014) boletin 15 febrero 2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (957,'Mtro.','Eduardo Vega Lpez','56-22-21-00','','','56-16-08-14','','direccion@economia.unam.mx','angeles@economa.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (140,'Ing.','Francisco Castaeda Miranda','56-16-15-86','','','','','fcm@economia.unam','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (132,'C.P.','Mara del Carmen Garca Moreno','56-22-20-97','','','','','inuk0875@hotmail.com','','','El dr. Leonardo Lomel fue designado como Secretario General a partir del 18 de noviembre de 2015. DPLybf.','Nuevo director, doctorante Vega Lpez (2016-2020) B. 26 enero 2016. DPL.ybf. Ratificacin Lomel Vanegas (2014-2018) 18 febrero 2014. Primer periodo 2010-2014/ g. 4,224, 18/feb/2010. Depto. de Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (814,'Dr.','Jos Recamier Angelini (Secretario Acadmico)','56-22-77-72','56-22-77-87','','','','pepe@fis.unam.mx','','','Cambio de Secretario Acadmico octubre 2015. dr. Recamier investigador en fsica terica y computacional.enero 2016. DPLybf. 2008 Reporta nombramiento de bibliotecario. Bachillerato. Nuevo Secretario acadmico agosto 2013','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (841,'','Linaloe Hurtado Lpez','56-22-77-67','01(777) +32-91-767','','56-22-77-75','01(777) +32-91-775','lina@fis.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (308,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (309,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1871,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1872,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1873,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1875,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1491,'Dr.','Francisco Cervantes Prez','56-22-87-13','','','55-50-84-05','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1492,'Lic.','Rogelio Snchez Vargas(Deleg. Administrativo)','5622-6110-56226111-56226112-56226113','','','5622-6113','','rogelio_sanchez@cuaed.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1493,'','','','','','','','','','','','Nuevo Coordinador enero 2016. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (899,'Lic.','Mara de Guadalupe Flor Daz de Len Fernndez de Castro','56-22-82-12','56-22-81-56','56-22-08-97','','','diazdeleonflor@ingenieria.unam.mx','diazdeleonsua@gmail.com','','Cambio de responsable Lic. en economa titulada Aurora Melquiades, coordinadora de confianza. a partir del 2 de feb. 2016. DPLybf. Juliana Guerrero es de confianza y responsable de la biblioteca. Lic. Anabell Branch es la Secretaria Acadmica/Nueva coordinadora Daz de Len a partir de 25 de julio/2012','anabell.branch@mineria.unam.mx',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (953,'Lic.','Aurora Mara Melquiades Gallegos','56-23-29-60 (Servicios)','56-23-29-23 (Responsable)','','','','centro.informacion@mineria.unam.mx ','ammelquiades@mineria.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (287,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (288,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1846,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1847,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1848,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1850,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (378,'Lic.','Sal Armendriz Snchez','56-22-40-30 ','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','Responsable Dr. en gentica Francisco es investigador y funge como responsable interino de la biblioteca. DPLybf. 9 feb. 2016. 2015 Responsable Dr. Valencia., DPLybf. cambio marzo 2012 de responsable.cambio enero 2014 con Tellechea','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (965,'Dr.','Francisco Molina Freaner (Interino)','56-22-65-34, exts. 104 y 109','01(662)  + 21-75-019, ext. 109','','56-22-65-35','01(662)  + 21-75-340  ','freaner@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (379,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (380,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1946,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1947,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1948,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1950,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (225,' Lic.','Gerardo Arvalo Guzmn','56-22-91-10 (Servicios)','Ext. RedUNAM 47872 (Servicios)','Ext. RedUNAM 47782 (Responsable)','56-22-91-09','','biblio@ib.unam.mx','arevalo@ib.unam.mx','','Ext. RED UNAM para Acervo histrico 47873 con Mtra. Socorro Tapia. 9 feb. 2016. DPLybf.','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (226,'','Jos Gumercindo Roldn Snchez','56-22-91-10 ext. 47873','56-22-91-11','','56-22-91-09','','jroldan@ibiologia.unam.mx','','L - V  15:00 a 21:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (227,'Lic.','Raymundo Garca Alcntara','56-22-91-10 ext. 47780','56-22-91-11','','56-22-91-09','','rgarcia@mail.ibiologia.unam.mx','','L - V 8:30 a 14:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1781,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1782,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1783,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1785,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (817,'Dr.','Jos de Jess Gonzlez Gonzlez','56-22-43-89','56-16-14-12','','56-22-39-05','','direc@astro.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (49,'LC','Erick Torres','56-22-65-26 ext 310','','','01-646-174-46-07','','raquel@astrosen.unam.mx','','','El Dr. William Lee fue designado Coordinador de la Investigacin cientfica en dic. 2015.','Nuevo director Dr. Gonzlez (2016-2020) G. 16 febrero 2016. DPLybf. Director pendiente 2016. Ratificacion de director. Segundo periodo 2014-2018. Boletin 715bis. 10 dic.2014. DPLybf. Nuevo director periodo 2010-2014 boletin 07/12/2010. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (816,'Dr.','Jos de Jess Gonzlez Gonzlez','56-22-43-89','56-16-14-12','','56-22-39-05','','direc@astro.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (98,'Lic.','Manuel Comi Aguilera (Secretario Administrativo)','56-22-39-41','','','','','mcomi@astroscu.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (97,'C.P.','Angelina Salmern Godoy','56-22-43-88','','','','','angelina@astroscu.unam.mx','','','','Nuevo director Dr. Gonzlez (2016-2020) G. 15 febrero 2016. DPLybf. El Dr. William Henry Lee Alardn fue asignado como coordinador de la investigacin cientfica en dic. 2015. Director pendeinte.Segundo periodo (2014-2018) Boletin 715bis. 09/12/14. DPLybf. Nuevo director: Lee Alardin (2010-2014) boletin 07 diciembre 2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (929,'Dra.','Patricia Dolores Dvila Aranda','56-23-11-64','56-23-11-50','','53-90-76-13 (Solicitar tono)','','pdavilaa@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (773,'Lic.','Eliseo Venegas Alvarado','56-23-11-53','56-23-13-35','53-90-76-14','','','eliseo@campus.iztacala.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (410,'Ing.','Sergio N. Vargas Gonzlez','56-23-13-54','56-23-11-52','','56-23-13-52','','s.vargasgonzalez@hotmail.com','','','','Segundo periodo para Dvila (2016-2010) G. 18 febrero 2016. DPLybf. Nueva directora: Dvila (2012-2016) gaceta 16/02/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (512,'','','','','','','','','','','Responsable desde 2008 con nombramiento de Coordinador de biblioteca y Tcnico Acadmico Titular B. Maestra titulada en Bibliotecologa y Estudios de la Informacin. DPLybf','act. datos feb2016bfy',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (972,'Mtra.','Mara Magdalena Sierra Flores','56-22-46-89','56-22-46-89, ext. 3322 (Responsable)','','56-22-47-04','','servicios@nucleares.unam.mx','sierra@nucleares.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (513,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (514,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2106,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2107,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2108,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2110,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1964,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (818,'Mtro.','Jorge Alfredo Cullar Ordaz','56-23-19-61','56-23-19-62','','58-70-56-71','','delacruz@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (154,'Lic.','Jos Carmen Barajas Troncoso (Secretario Administrativo)','56-23-19-10','','','','','jcbtron@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (151,'Lic.','Patricia Javier Prez','56-23-18-56','','','','','pjavierp@hotmail.com','','','','Nuevo director Cullar, 2013-2017 Boletin 736. 10/12/2013. DPLybf. Directora: Rodrguez (2009-2013) boletin 7 diciembre 2009. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (819,'Mtro.','Jorge Alfredo Cullar Ordaz','56-23-19-61','56-23-19-62','','58-70-56-71','','delacruz@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (848,'Dr.','Francisco Surez Gemes','56-22-58-83','56-22-58-84','','56-16-71-10','','fsg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (159,'Lic.','Jos Luis Castan Zurita (Secretario Administrativo)','56-23-19-09','','','','','jlcz@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (155,'C.P.','Jorge Arturo Romero Herrera','58-70-56-72','','','','','jarh@servidor.unam.mx','','','','Nuevo director Cullar  2013-2017 Boletin 736. 10/12/2013. Primer periodo Suemi Rodrguez 2009-2013. Dic. 2009 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (143,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (901,'Dr.','Francisco Javier Valles Valenzuela','56-23-42-41 (Servicios)','56-23-42-33 (Responsable)','01(442)  +19-26-137','56-23-42-43','01(442) +19-26-143','biblio@juriquilla.unam.mx','jvalles@juriquilla.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (144,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (145,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1681,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1682,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1683,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1685,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1449,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1450,'Dr.','Francisco Javier Valles Valenzuela','56-23-42-41 (Servicios)','56-23-42-33 (Responsable)','01(442)  +19-26-133 (Morelia)','56-23-42-43','01(442)  +19-26-143 (Morelia)','biblio@juriquilla.unam.mx','jvalles@juriquilla.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1451,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1452,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1456,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1457,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1458,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1460,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (382,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (989,'Dr.','Francisco Javier Valles Valenzuela','56-23-42-41 (Servicios)','56-23-42-33 (Responsable)','01(442)  +19-26-137(Quertaro)','56-23-42-43','01(442)  +19-26-143 (Quertaro)','biblio@juriquilla.unam.mx','jvalles@juriquilla.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (383,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (384,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1951,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1952,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1953,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1955,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (714,'Mtro.','Rubn Ruiz Guerra','56-23-02-11','56-23-02-12, ext. 42230','Ext. Red UNAM 42230','','','ruizg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (927,'Lic.','Manuel Ricardo Campos Garca','56-23-02-14','','','56-23-02-19 ','','camposman2002@yahoo.com.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (8,'C.P.','Gerardo Ramrez Huerta','56-23-02-11, 12 y 13 ext. 42132','','','','','gerramh@yahoo.com.mx','','','','Nuevo dir. Doctorante Estudios latinoamericanos Ruiz (2016-2020) G. 03/03/16. DPLybf. Ratificacin Santana (2012-2016) 27/02/2012. Boletin DGCS-123. Primer periodo 2008-2012. DPLybf          ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (794,'Mtro.','Jos Arturo Fernndez Pedrero','56-23-22-00','56-16-27-12','','55-50-87-07','','pedrero1@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (418,'L.A.','Jorge Ramrez Oropeza','56-23-22-34','','','56-16-11-57','','jramirez@fo.odonto.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (419,'','','56-23-22-02','','','56-23-22-02','','','','','','Segundo periodo Pedrero ( 2014-2018) Boletin 541. 17 sept.2014 DPLybf. Nuevo director: Fernndez Pedrero 2010-2014, noticia14/09/2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1994,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2603,'Dra.','Diana Tamara Martnez Ruiz','Red UNAM 37301 y 42547','01 (443)+689-35-01 ( Mxico a Morelia)','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2604,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2605,'','','','','','','','','','','El director dr. Ken Oyama fue designado como Secretario de Desarrollo Institucional a partir del 18 de noviembre de 2015. DPLybf.','Designacin directora Dra. Martnez (2016-2020). G. 10/03/2016. DPLybf. Directora interina Granados Vzquez a partir de 24 de noviembre de 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (757,'Dra.','Irene Durante Montiel (Secretaria General)','56-23-24-03','56-16-11-04','','56-25-21-55','','secretariageneral@licega.facmed.unam.mx','','','Cambio de Secretaria General Dra. Durante, 14/03/16.DPLybf. Exts. Red UNAM 45072 mostrador, 45073 jefatura de Biblioteca,  45074 hemeroteca','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (772,'Ing. ','David Flores Macas','56-29-50-80 y 56-29-50-81 (Servicios)','56-23-25-02 y 56-23-23-07 (Responsable)','Ext. Red UNAM 45085 (Responsable)','55-50-10-02 ','','documentacion@izquierdo.fmedic.unam.mx','fmacias@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (345,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (346,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1911,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1912,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1913,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1915,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (610,'Dr.','Francisco Surez Gemes','56-22-58-83','56-22-58-84','','56-16-71-10','','fsg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (611,'Mtro. ','Alfonso Ayala Rico','5622 5881','5616 6154','','','','aayalari@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (699,'Dra.','Guadalupe Valencia Garca','55-50-67-02','56-23-00-26','','56-16-29-88','','valencia@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (364,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (612,'L. A. ','Alejandra Cano Cosme','5622 5914','5622 59 15','','5616 6743','','alexca_19@hotmail.com','','','','Nuevo director Dr. Surez (2016-2020) B. 23 feb. 2016. DPLybf. Nueva directora Trujillo Ortega, periodo 2012-2016 boletin 21/02/2012. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (240,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (237,'','','','','','','','','','','','Nuevo director Dr. Surez (2016-2020) B. 116-23 feb. 2016. DPLybf. Nueva directora Trujillo Ortega, periodo 2012-2016 boletin 21/02/2012. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (852,'Dr.','Francisco Surez Gemes','56-22-58-83','56-22-58-84','','56-16-71-10','','fsg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (577,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (578,'','','','','','','','','','','','Nuevo director Dr. Surez. (2016-2020) B. 23 feb. 2014. DPLybf. Nueva directora Trujillo Ortega, periodo 2012-2016 boletin 21/02/2012. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (850,'Dr.','Francisco Surez Gemes','56-22-58-83','56-22-58-84','','56-16-71-10','','fsg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (298,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (299,'','','','','','','','','','','','Nuevo director Dr. Surez (2016-2020) B. 23 feb. 2016. DPLybf.  Directora Trujillo Ortega, periodo 2012-2016 boletin 21/02/2012. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (851,'Dr.','Francisco Surez Gemes','56-22-58-83','56-22-58-84','','56-16-71-10','','fsg@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (520,'Lic.','Alfonso Ayala Rico','56-22-58-81','','','56-16-67-43','','aayalari@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (521,'Lic.','Francisco Javier Angeles','56-22-59-15','','','','','','','','','Nuevo director Dr. Surez (2016-2020) B. 23 feb. 2016. DPLybf.  Directora: Trujillo Ortega 2012-2016 boletin 21/02/2012.Depto.  Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (849,'Dr.','Francisco Surez Gemes','56-22-58-83','56-22-58-84','','56-16-71-10','','fsg@unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (294,'','','','','','','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (295,'','','','','','','','','','','','Nuevo director Dr. Surez (2016-2020) B. 116-23 feb. 2016. DPLybf.  Directora Trujillo Ortega, periodo 2012-2016 boletin 21/02/2012. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (631,'','','','','','','','','','','Ricardo Loyola Elizarrars (bibliotecario) marzo 2016','ricardo-loyola-cut@hotmail.com',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (867,'Lic.','Anabel Rodrigo Cervantes (Secretaria Acadmica)','56-22-68-47 (Servicios)','56-22-71-04 (Responsable)','','56-22-68-46','','cutsec@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (632,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (633,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1701,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1702,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1703,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1705,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (434,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (801,'Dr.','Manuel Surez Lastra','56-22-43-41','','','','','direccion@igg.unam.mx','msuarez@igg.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (315,'Sra.','Iris Oliver Gutirrez (Secretario Administrativo)','56-22-43-38','','','56-16-05-39','','ioliver@igiris.igeograf.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (316,'Lic.','Jaime Gaytn Gil','56-22-43-38 ext. 45502','','','56-16-05-39','','jaime@igiris.igeograf.unam.mx','jaime@igg.unam.mx','','','Nueva designacin (2016-2020) Dr. en geografa Surez. Boletin 01 marzo 2016. DPLybf. Nuevo director Moncada Maya,  ( 2012-2016) Boletin dgcs 129- 29/feb/2012. Depto.  Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (914,'Lic.','Vctor Efran Peralta Terrazas','53-73-63-17, ext. 111','','','53-73-63-17, ext. 149 (Solicitar tono)','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (675,'M.I.','Andres Gmez Valle','57-73-63-47','','','57-73-63-47','','gratisdf@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1881,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (171,'Lic.','Leticia Granados Guante','57-73-63-15 Ext. 140','57-73-63-47','','57-73-63-47','','grahua_leticia@hotmail.com','','','','Nueva designacin Lic. Peralta, (2016-2020) G. CCH. 07/04/16. DPLybf. Segundo periodo: Lic. Delgado (2012-2016) gaceta CCH 1290 / 9 abril 2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (687,'Mtra.','Juana Leticia Cano Soriano','56-22-87-56','55-50-19-57','','55-50-08-98','','canosor@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (581,'Lic.','Raul Rafael Rodrguez Toledo (Secretario Advo.)','56-22-87-50','','','56-22-8790','','rraulrafael@yahoo.com.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (582,'Lic.','Pedro Javier Anzures Mosqueda','47352  ','47353','','','','','','','','Ratificacin 2o. periodo. Mtra. Cano (2016-2020) B. 234. 12/04/16. DPLybf. Nueva directora: Cano Soriano (2012-2016) boletin 10/04/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (55,'','','','','','','','','','','Correo alternativo Mtra. Jurez Jimnez: angelesjuarezj@gmail.com. 14/04/16. DPLybf. CAMBIO DE RESPONSABLE: Carmen Block por Mtra. en Bibliotecologa titulada Mara de los Angeles Jurez. 1o. de febrero 2013.  cambio 21/feb/2013 sin notificacin. DPLybf  ','Actualizacin de telefonos y exts. 14/04/16',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (689,'Mtra.','Mara de los ngeles Jurez Jimnez','56-22-72-50 y 56-22-69-99, exts. 85125, 85124 y 85123 (Servicios)','56-22-72-50 y 56-22-69-99,  exts. 85044 y 85122 (Responsable)','','','','bibjus@unam.mx','ajuarezj@comunidad.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (56,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (57,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1581,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1582,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1583,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1585,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (869,'Dr.','Rafael Antonio Prez-Taylor y Aldrete','56-22-95-35','56-65-29-59','','56-22-96-51','','inantrop@unam.mx ','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (83,'Lic.','Juan Fernando Caldern Salgado (Secretario Administrativo)','56-22-96-50','','','56-22-96-63','','fernandocalderon@correo.iia.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (84,'Lic. ','Julio Cesar Sandoval Reyes','56-22-96-73','','','56-22-96-63','','juliosandovaliia@yahoo.com.mx','','','','Nueva designacin Dr. Prez-Taylor (2016-2020) G. 21/04/16. DPLybf. Nueva directora: Oehmichen (2012-2016) boletin 134/17abril/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (728,'Dr.','Ral Juan Contreras Bustamante','56-22-20-01','56-22-20-03','','56-22-19-50 (Solicitar tono)','','director@derecho.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (175,'Lic.','David Marcos Garca Rosales (Secretario Administrativo)','56-22-22-64','56-22-20-05','','','','@derecho.unam.mx','','8:00 a 21:00 hrs.',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (176,'C.P.','Blanca Estela Montes Hernndez','56-22-19-53','','','','','bmontesh@hotmail.com','','8:00 a 21:00 hrs.','','Nuevo director Contreras (2016-2020) G. 31/03/2016. DPLybf. Nueva directora Leoba Castaeda,  2012-2016. Gaceta 4414 - 29/marzo/2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (846,'Dr.','Germn Palafox Palafox','56-22-23-12','','','55-50-25-60','','germanpalafox@gmail.com','gpp61@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (550,'C.P.','Juan Contreras Razo (Secretario Administrativo)','56-22-22-68','56-22-22-67','','','','jucora@correo.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (551,'C.P.','Ral Garca Gutirrez','56-22-22-61','','','','','rggarcia@correo.unam.mx','','','','Nueva designacin Dr. German Palafox (2016-2020) G. 04/04/16. DPLybf. Segundo periodo Nieto 2013-2017, Boletin 341 5junio2013. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (396,'Lic.','Ral Lugo Ramrez (Secretario Administrativo)','56-23-00-32','56-23-00-34','','56-23-01-97','','raul.lugo@correo.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (845,'Dr.','Germn Palafox Palafox','56-22-23-12','55-50-36-80','','55-50-25-60','','germanpalafox@gmail.com','gpp61@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (397,'Lic.','Patricia Fernndez Hidalgo','56-23-00-32','56-23-00-34','','56-23-01-97','','contaypresu@hotmail.com','','','','Designacin de Directora Valencia (2016-2020) B.14/03/16. DPLybf. Ratificacin Blazquez (2012-2016) 14/03/2012 Boletin DGCS-162. Primer periodo (2008-2012) DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (921,'Dr.','Gabriel Ascencio Franco','01 (967)+678-28-91, ext. 107','01 (967)+678-29-44, ext. 107','','','','cimsur@unam.mx  ','     ','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (386,'Lic.','Roger Emilio Esponda Ayanegui','01 (967) 6782891','01 (967) 6782944','','','','romajo@correo.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (387,'Sr. ','Martn Lpez Lpez','01 (967) 6782891','01 (967) 6782944','','','','1omar@hotmail.com','','','','Primer director del Centro (2015-2019) Gabriel Ascencio. 9 de junio 2015. DPL ybf. Nuevo coordinador Dr. Ascencio 20 enero 2015. DPLybf. Designacin Coordinador del ngel (2011- 2015)  enero 2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (982,'Dr.','Luis Agustn lvarez Icaza Longoria','56-23-36-01','56-23-36-00, ext. 1','',' 56-23-36-02','','direccion@iingen.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (391,'C.P.','Lic. Salvador Barba Echavarra','56-23-36-20','','','56-16-15-14','','L.SanchezI@iigen.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (392,'CP.','David Macario Martnez Espinoza','56-23-36-00  ext. 8224','','','','','','','','','Nuevo director (2016-2020) lvarez Icaza. Gaceta 11 febrero 2016. DPLybf. Segundo periodo: Noyola (2012-2016) gaceta 4,400  09/02/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (983,'Lic.','Mara Guadalupe Ferrer Andrade','56-22-95-95','56-22-48-00, ext. 47466','','56-22-95-85','','gferrer@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (271,'Lic.','Alfredo Gallardo Lugo','57-02-64-32','','','51-02-45-03','','emeliagl@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (272,'Lic.','Jacqueline Rodrguez Pavn','56-22-93-77','','','57-02-43-34 ext. 110','','pavon_jaqueline@hotmail.com','','','','Ratificacin directora Ferrer (2012-2016) 11 mayo 2012. Primer periodo (2008-2012) 11 mayo 2008. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2348,'Dr.','William H. Lee Alardin (Coordinador)','56-22-41-82 ','56-22-41-83','56-22-41-84','55-50-66-62','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2349,'Sra.','Alicia Mondragn Hurtado','56-22-41-88','','','56-22-42-01','','mhurtado@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2350,'C.P.','Ernesto Lino Luna','56-22-41-79','','','56-22-42-01','','ell@servidor.unam.mx','','','','Designacin Dr. William 10/12/15, DPLybf. Designacin de Aramburo de la Hoz como Coordinador de la Investigacin Cientfica desde (2007 - 2015) 6 diciembre 2007. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2408,'Dr.','Imanol Ordorika Sacristn','56-22-15-09','','','56-22-15-12','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2409,'C.P.','Gerardo Trejo Hernndez','5622 1511','','','5622 1512','','gerardotrejo2@yahoo.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2410,'C.P.','Gerardo Trejo Hernndez','5622 1511','','','5622 1512','','gerardotrejo2@yahoo.com','','','','Designacin de Director Dr. Ordorika. Gaceta 21 enero 2016. DPLybf. Nueva directora Valle Gmez (2012- 2016) 13 agosto 2012 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2423,'Lic.','Manola Giral Lpez de Lozano','56-22-60-25','56-65-20-52','','56-22-60-50','','dgire@dgire.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2424,'C.P.','Carlos Angeles Medina','5622 6038','','','5665 5217','','carlosa@www.dgire.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2425,'Lic.','Carlos Valdez Uriza','5622 6038','','','5665 5217','','cvaldezu@www.dgire.unam.mx','','','','Nueva designacin Lic. Giral, G 21/01/16. DPL.ybf. Nuevo director Sandoval (2012-2016) Gaceta 12 enero 2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (688,'Dr.','Alfredo Varela Echaverria','56-23-40-01 ','01 (442) + 23-81-001 (Quertaro)','','56-23-40-04','','avarela@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (141,'Lic.','Felipe Pablo Pedroza Montes de Oca (Secretario Administrativo)','56-23-40-09','','','56-23-40-10','','pedroza@inb.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (142,'C.P.','Antonio Gonzlez Cruz','56-23-40-11','','','56-23-40-11','','gonzalez@inb.unam.mx','','','','Designacin nuevo Director, Dr. Varela (2016-2020) B. 16 marzo 2016. DPLybf. Ratificacin Paredes (2012-2016) Boletin DGCS-163/14/03/2012 . Primer periodo (2008-2012) DPLybf      ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2528,'Dr.','Leonardo Lomel Vanegas (Secretario General)','56-22-12-30','56-22-12-31','56-22-12-32','55-50-75-28','','@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2529,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2530,'','','','','','','','','','','','Designacion de Secretario General Dr. Lomel 26/11/15. DPLybf. Designacin de Secretario General Brzana (2011-2015) 6 abril 2011. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (718,'Dr.','Hctor Bentez Prez','56-22-35-55','56-16-27-64 ','','55-50-00-47','','hector.benitez@iimas.unam.mx ','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (38,'Lic.','Margarita Aurora Garca Ramos(Secretario Administrativo)','56-22-35-53','56-22-35-89','','56-22-36-25','','aurora@leibniz.iimas.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (59,'Lic.','Nataly Vazquez Cervantes','56-22-35-52','','','56-22-36-25','','','','','','Ratificacin dr, Benitez (2016-2020) G. 28/04/16. e-mail alterno hbenper@yahoo.com.mx. DPLyb. Designacin director: Benitez (2012-2016) Boletn UNAM-DGCS 260/24 abril 2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (317,'','','','','','','','','','','Confirmacin por oficio 2 mayo 2016. Mtro. Iturbe. Nueva designacin Mtro.  titulado en Bibliotecologa y coordinador de la Bca y mapoteca, Iturbe a partir de 1o. abril 2016, CAMBIO DE RESPONSABLE: Mtra. Basilio A Mtra. en Bibliotecologia, titulada Antonia Santos Rosas a partir del 1o. de febrero 2013. DPLybf ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (693,'Mtro. ','Luis Ral Iturbe Fuentes','56-22-43-37 (Servicios)','56-23-02-22, ext. RedUNAM 44800 (Responsable)','56-23-02-22, ext. RedUNAM 44803','','','lfuentes@igg.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (318,'','David Velsquez Mancilla','56-22-43-37 ext. 44800','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (319,'','Juan Vargas Gonzlez','56-22-43-37 ext. 45530','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1882,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1883,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1885,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (727,'Dra.','Mara Anglica Cullar Vzquez','56-22-94-70, ext. 1013','56-65-75-32','','56-66-83-34','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (146,'Lic.','Aureliano Morales Vargas (Secretario Administrativo)','56-22-34-70 ext. 1075,1076 y 1077','','','56-65-11-00','','morales@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (147,'L. C. ','Pilar zendejas ','56-22-94-70  ext. 1083','','','','','shromx@yahoo.com.mx','','9:00 a 20:00 hrs.','','Designacin Nueva directora Cullar (2016-2020) B. 298. 3/05/16. DPLybf. Segundo perodo: Castaeda Sabido (2012-2016) Boletin 280. 02/mayo/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (771,'Lic.','Isabel Jimnez Tllez','56-48-54-80, ext. 102','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (440,'C.P.','Paula Aguirre Rosales','56-48-55-01 ext. 113','56-48-54-80','','56-48-55-01 ext. 112','','paulaaguirre@prodigy.net.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (441,'C.P.','Daro Ramrez Montes','56-48-55-01 ext. 114','56-48-54-80','','56-48-55-01 ext. 112','','darioramirezmontes@yahoo.com.mx','','','','Designacin Directora Lic. Jimnez 2016-2020. G. ENP 12/05/16. DPLybf. ',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (770,'Dr.','Constantino de Jess Macas Garca','56-22-89-96','56-16-17-76','','56-16-19-76','','direccion@ecologia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (39,'Lic.','Ofelia Castillo Estrada (Secretario Adminstrativo)','56-22-90-35','','','56-16-10-22','','ocastillo@miranda.ecologia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (40,'Lic.','Virgilio Lara','56-22-90-31','','','56-16-10-22','','virgilio@miranda.ecologia.unam.mx','','','','Designacin (2016-2020) Director Dr. Macas. B. 17/05/16. DPLybf. Ratificacin (2012-2016): Dominguez Prez. Boletn UNAM-DGCS 313/16 de mayo de 2012. Primer periodo 2008-2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2561,'','','','','','','','','','','Licenciada en Bibliotecologa Laura Reyes, nueva responsable de la biblioteca. 2014. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2562,'Lic.','Laura Reyes Herrera','01 (477) +194 08 00, ext. 43436','','','','','biblioteca@enes.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2563,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2564,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2568,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2569,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2570,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2572,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (923,'Dr.','Pedro Stepanenko Gutirrez','56-22-72-43','56-22-72-44','','56-22-73-76','','dir@filosoficas.unam.mx','pedros@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (260,'Lic.','Amado Luna Gutirrez(Secretario Administrativo)','56-22-72-46','56-22-72-47','','56-22-74-27','','lunag@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (256,'Lic. ','Amelia Rodrguez Rodrguez','56-22-72-49','','','56-22-74-27','','amelia@filosoficas.unam.mx','','','','Designacin  de Stenpaneko, segundo periodo (2016-2020) G. 26/05/16 DPLybf. Nuevo director: Stepanenko (2012-2016) Boletin 329 /22/mayo/2012 . Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (761,'Dra.','Irene Durante Montiel (Secretaria General)','56-16-11-04','56-23-24-03','','56-25-21-55','','secretariageneral@liceaga.facmed.unam.mx','','','Cambio de Secretaria General Dra. Durante. 14/03/16. DPLybf. Nuevo responsable Lic. en bibliotecologia, Responsable de la biblioteca personal acadmico Maya. 02/12/2015. DPLybf.','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (670,'Lic.','Oscar Maya Corzo','56-23-31-18  al 20 (Servicios)','55-29-69-07 (Responsable)','','','','omaya@izquierdo.fmedic.unam.mx','oscar.mcorzo@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (365,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1931,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1932,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1933,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1935,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (393,'','','','','','','','','','','4 de nov 2015 Nueva Coordinadora de la Unidad de Servicios de Informacin-Biblioteca en sustitucin de Guillermina. DPLybf. correo alternativo de Josefina plata: jplata@ii.unam.mx.reportado via telefonica. 2016. 2008 Reporta nombramiento de Coordinador de Biblioteca y Tcnico Acadmico Titular A. Pasante de Maestra en Bibliotecologa y Estudios de la Informacin. PLybf ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (745,'Lic.','Josefina Elizabeth Plata Garca','56-23-36 13 ','56-23-36-00, ext. 8120','','56-23-36-00, ext. 8065','','jplatag@iingen.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (394,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (395,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1961,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1962,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1963,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1965,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2576,'','','','','','','','','','','Cambio de responsable Mtra. en  Tecnologas de la Informacin en UNITEC; Morelia. oficio 4 enero 2016.  correo alternativo: rql.geoga@gmail.com. DPLybf.','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2577,'Mtra.','Raquel Gonzlez Garca','56-23-28-52 ','Ext. RedUNAM 32852 (Reponsable)','01 (443) + 322-38-52','','','cdoc@ciga.unam.mx','rgonzalez@ciga.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2578,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2579,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2583,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2584,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2585,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2587,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (985,'Dra.','Elsa Margarita Ramrez Leyva','56-22-16-32','56-22-16-03','','56-16-06-64 (Solicitar tono)','','eramirez@unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (33,'C.P.','Cruz Leopoldo Hernndez Jmenez','56-22-16-24','','','56-22-16-11','','leopoldo@dgb.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (34,'Ing.','David Daz Hernndez','56-22-16-57','56-22-16-35','','56-22-16-11','','dhrobie@hotmail.com','','','','Nueva designacin Elsa M. Ramrez Leyva (2016-2020) 31/05/2016. DPLybf. Ratificacin Rodrguez (2011-2015) . Primer periodo (2008- 2011) 21 enero 2008. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (3,'Dra. ','Elsa Margarita Ramrez Leyva','56-22-16-32','56-22-16-03','','56-16-06-64 (Solicitar tono)','','eramirez@unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (111,'C.P.','Leopoldo Hernndez Jimnez','56-22-16-24','','','56-22-16-11','','polo@dgb.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (112,'C.P.','David Daz Hernndez','56-22-16-24','','','','','servando@dgb.unam.mx','','','','Nueva desigancin Elsa M. Ramrez Leyva (2016-2020) 31/05/2016. DPLybf. Ratificacin Rodrguez (2011-2015) . Primer periodo (2008- 2011) 21 enero 2008. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (545,'C.P.','Juan Contreras Razo (Secretario Administrativo)','56-22-22-68','56-22-22-67','','','','jucora@correo.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (546,'C.P.','Alberto Garcia Valdez','56-22-22-61','','','','','','','','','Nueva designacin Dr. Palafox (2016-2020) G. 04/04/16 DPLybf. Ratificacin Nieto (2013-2017) Boletin 341. 5 junio 2013.Primer periodo (2009-2013) Boletin 1 junio 2009. segundo informe/ 29 sept/2012, DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2144,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (920,'Dr.','Miguel Alcubierre Moya','56-22-46-70','56-22-47-39, ext. 2253','','56-16-22-33','','malcubi@nucleares.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (510,'Lic.','Alejandra Reyes Mancilla (Secretario Administrativo)','56-22-46-77  ext. 257','','','56-22-46-78','','alejandra.reyes@nucleares.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (511,'Lic.','Liliana Jimnez Barrn','56-22-46-77 ext. 258','','','56-22-46-78','','lily.jimenez@nucleares.unam.mx','','','','Designacin segundo periodo 2016-2020 Dr. Alcubierre. G. 16/6/16. DPLYBF. Nuevo director:  Alcubierre (2012-2016) Boletin 373 /12 junio/2012. DPLybf. Primer informe gaceta 2/dic/2013.',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (730,'Dra.','Geogina Araceli Torres Vargas','56-23-03-27','56-23-03-29','56-23-03-39','55-50-74-61','','direccion@iibi.unam.mx','gatv@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (837,'Lic. ','Mara CristinaOrdoez Rangel  (Secretario Administrativo)','56-23-03-72','','','55-50-74-63','','ordones@servidor.unam.mx','','L - V  9:00 a 20:00 hrs.',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (118,'C.P.','Antonio Estrada Olivares ','56-23-03-32 ','','','55-50-74-63','','Nombre de su asistente: Consuelo','Tel: 42-130','L - V 9:00 a 20:00 hrs.','','Nueva designacin (2016-2020) Dra. Torres. G. 30 junio 2016. Designacin de primer director de IIBI: Jaime Ros Boletn ( 2012-2016) 400bis /26 junio 2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (917,'Lic.','Alejandro Fernndez Varela Jimnez','56-22-00-47 ','56-22-04-91','','56-16-07-26 ','','afvarela@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (193,'L.C.','Jos Luis Marin Correa','56-22-29-58','','','','','','terricolaxxx@hotmail.com','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (967,'Dr.','Federico Hernndez Pacheco','56-22-74-75 y 56-22-74-74, ext. 1714 (Servicios)','56-22-74-75 y 56-22-74-74, ext. 1715 (Responsable)','56-65-25-84 (Responsable)','56-65-21-93 (Direccin. Solicitar tono)','','iijbibli@unam.mx','federico_hdz@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (189,'Lic.','Alejandra Morales Vargas','5622 2958, o ext. 41797','','','','','jluismc751@hotmail.com','','','Cambio de denominacin Antes Direccin General de Actividades Deportivas y Recerativas. 4 rnro 2016. DPL.ybf','Designacin de Lic. Fernndez. (2016-2020) G. 21/01/16. DPL:ybf. Nuevo director  Rubio (2010-2014) 16 diciembre 2010. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1749,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2288,'Dr.','Eduardo Alejandro Lpez Snchez (Coordinador)','01(353) +53-30-758, ext. 101','','','01(353) +53-30-758, ext. 203','','elopez@humanidades.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2289,'C.P.','J. Gerardo Oceguera Jimnez','(01-353) 533 07 58 ext..200','(01-353) 533 05 57','','','','geroce58@hotmail.com','goceguera@humanidades.unam.mx','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2290,'C.P.','Jesus Ramos Cedillo','5622-7565 ext. 154','','','','','jramosc@humanidades.unam.mx','','','','Asignacin coordinador de la Unidad: Lpez, (2012-2016) verificado correo electrnico 24/01/2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2291,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2292,'Lic.','Julio Javier Bernal Lpez ','01(353) + 53-30-757, ext. 301','01(353) + 53-30-758, ext. 300 ','','','','biblioteca.uaer@gmail.com','alemus@humanidades.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2293,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2294,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2298,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2299,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2300,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2302,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (532,'Mtro.','Csar Olgun Camacho','55-22-54-89, ext. 102','55-22-23-26, ext. 102','','55-22-54-41 (Direccin)','','biblios@puec.unam.mx','colguin@puec.unam.mx','','2014. Ingreso de tcnico acadmico, licenciado en biblioteconoma, ENBA. Cesar Olguin. En febrero 2015 es Coordinador de biblioteca. DPLybf. En 2008 Alberta Moreno reporta nombramiento de Bibliotecario. Bachillerato. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (660,'','Alberta Moreno Prez','55-22-23-30, ext. 102','55-22-23-61, ext. 102','','55-22-54-41 (Direccin)','','biblios@puec.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (533,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (534,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2126,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2127,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2128,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2130,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (35,'Mtra.','Vernica Soria Ramrez (Subdirectora)','56-22-16-58 (Circulacin Bibliogrfica)','56-22-16-25 (Subdirectora)','56-22-16-13 (Consulta)','','','subbcentral@dgb.unam.mx','','','Nueva Subdirectora candidata a doctora en Estudios de la Informacin, tcnico acadmico y confianza a partir del 1 de agosto 2016. DPLybf.','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (857,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (36,'Lic.','Anglica Mara Briones Huerta','56-22-16-08','56-22-16-61','','56-22-16-61','','revistas@dgb.unam.mx','abrionesh@correo.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (58,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1571,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1572,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1573,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1575,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (220,'','','','','','','','','','','Jubilacin de Nohemi, Situacin de la Biblioteca indefinida, por el momento el responsable es Lic. Rojas 17/ago/16. DPLybf. Responsable Terrazas a partir de 8/feb/2012','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (710,'Lic.','Vicente Gerardo Rojas Moreno (Interino)','56-22-93-18 (Servicios)','56-22-48-00, exts. 47530 y 47534 (Responsable)','','','','gerojas@comunidad.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (221,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (222,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1776,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1777,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1778,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1780,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (360,'','','','','','','','','','','Jefe de biblioteca Martn Lemus  martynlemus@hotmail.com','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (743,'Mtra.','Patricia Gonzlez Ramrez','56-55-23-32, exts. 7 y 275 (Servicios)','56-55-23-45, exts. 7 y 276 (Jefe de biblioteca)','55-55-23-32, ext. 204 (Responsable)','','','patriciag07@yahoo.com.mx','patricia_eneo@comunidad.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (361,'','Martn Lemus','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (359,'','Mara Guadalupe Cuevas Hernndez','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2241,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2242,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2243,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2245,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (854,'Mtra.','Mara Teresa Gabriela Frenk Mora','56-88-13-95, ext. 103','','','56-01-32-10','','enm_direccion@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (829,'Dra.','Betty Luisa Zanolli Fabila','56-88-32-18 ext. 110 o 111','','','56-04-10-63','','bettyluisa@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (414,'Lic.','Medardo Zarate Vazquez','56-04-08-68 ext. 129','','','','','depdepres@hotmail.com','','','','Nueva designacin de Frenk en B. 06/09/16. DPLybf. Segundo periodo: Viesca (2012-2016). Boletin 545 /04 /09/2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (85,'','','','','','','','','','','Nueva responsable Coordinadora (confianza) Alicia Cervantes a partir del 1o. sept. 2016/DPLybf. Renuncia por motivos personales  de Espejel. a partir de primero de enero 2014. DPLybf','Nueva responsable licenciada en ciencias de la comunicacin. FCPYS, UNAM. Ingresa 16 de marzo. Categora: Coordinadora de la Biblioteca de confianza.DPLybf 24 mar 2014',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (756,'Mtra.','Alicia Cervantes Cruz','56-22-95-17 (Servicios)','56-22-96-83 (Responsable)','','56-22-96-83 (Solicitar tono)','','comas@unam.mx','alcecru@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (86,'Lic.','Elvira valos','56-22-96-83','','','','','','','L - V  10:00 a 17:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (87,'Lic.','Rosa Patricia Espejel Nieto','56-22-96-83','','','','','pespejel@gmail.com','','L. a V. 9:00 a 17:00',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1536,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1537,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1538,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1540,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (964,'Mtro.','Hugo Martn Flores Hernndez','52-77-23-67, ext. 1','52-77-08-48','','52-77-08-48, ext. 202 (Solicitar tono)','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (785,'Lic.','Carlos Alberto Jmenez Guadarrama','52-71-29-85 ','52-19-99-28','','','','cjimenezg@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (447,'C.P. ','Jorge Toledo Leyva','52-71-29-85','52-73-99-28 Ext. 1','','','','','','','','Nuevo director  Flores (2014-2018) Gaceta 3 abril 2014. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (925,'Mtro.','Enrique Espinosa Tern','54-89-49-39','54-89-49-38','54-89-49-37','56-75-14-33','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (654,'Ing.','Jos Ramn Gamboa Flix','54-89-49-44 Ext. 224','54-89-55-35','','54-89-49-42','','zoyladgb@yahoo.com.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (433,'Lic.','Juan Martnez','54-89-55-35','54-89-49-44 ext. 224','','5489 4942','','','','','','Nuevo director Doctorante en Enseanza Superior, Espinosa (2016-2020). G. 22  febrero 2016. DPLybf. Nueva directora: Hernndez R. (2012-2016) Gaceta 20/02/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2009,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2,'','','','','','','','','','','Ratificacin de responsable Federico Turbull en agosto 2016. DPLybf.','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1,'Mtro.','Federico Russell Turnbull Muoz ','56-22-39-60','56-22-39-64','','55-50-80-68 (Subdireccin)','','fturnbull@dgb.unam.mx','fturnbul@yahoo.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (113,'Lic.','Rodolfo Luna Castellanos','56-22-39-60','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (114,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1641,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1642,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1643,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1645,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (211,'','','','','','','','','','','Maestro De la Torre, es responsable de otra rea , pero est a cargo interino de la Biblioteca desde 2008. Ratificacin como responsable en septiembre de 2016. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (918,'Mtro.','Javier de la Torre Segura','56-22-01-34 (Servicios)','56-22-01-41 y 56-22-01-32 (Responsable)','','56-16-07-09 (Subdireccin. Solicitar tono)','','jdelatorre@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (210,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (209,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1761,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1762,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1763,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1765,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (855,'Dr.','Jos Israel Betancourt Reyes','56-22-45-00 ','55-50-19-35','','56-16-07-54 ','','ofdiriim@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (325,'Lic.','Irma Vieyra Olivares (Secretario Administrativo)','55-50-09-34','56-22-45-74','','56-16-11-42','','ivieyra@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (326,'Lic.','Beatriz Pea','56-22-46-07','','','56-16-11-42','','','','','','Nueva designacin Dr.  Betancourt (2016-2020) G. 06/10/2016. DPLybf. Nueva directora: Martnez (2012-2016) Boletin 606 . 02/oct/2012. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2276,'','','','','','','','','','','2008 reporta nombramiento de  tcnico acadmico asociado C. Mtria. en ciencias de la computacin. 030/03/2014.  PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2277,'Ing.','Atzimba Graciela Lpez Maldonado','56-23-28-11','01 (443) + 32-22-811 (Morelia)','','56-23-28-11','01 (443) + 32-22-811','atzimba@iies.unam.mx','atzimba1975@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2278,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2279,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2283,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2284,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2285,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2287,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (839,' Mtro.','Fernando Macedo Chagolla','56-23-08-28','56-23-08-30','57-96-31-16','56-23-08-56','','direccionaragon@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (776,'Lic.','Jaime Jimnez Cruz (Secretario Administrativo)','56-23-08-39','57-96-41-59','','56-23-08-06','','jaijc@hp-720.aragon.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (45,'L.C.','Simn Lpez Alvarez','56-23-08-37','56-23-08-38','','','','','','','','Nueva designacin Mtro. en ingenieria. Fernando Macedo (2016-2020) G. 20/10/2016. DPLybf. Segundo perodo Garca Santamara 2013-2017. Boletin 370, 18 junio 2013. DPLybf. Director Garcia 2009-2013. Boletin 15 junio 2009.Tercer informe 2011-2012 presentado 28 de junio 2012. Depto. de Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (703,'Dr.','Pedro Salazar Ugarte','56-22-74-74, ext. 1214','','','','','pedsalug@yahoo.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (183,'C.P.','Mara Luisa Mendoza Tello','56-65-22-01','','','56-65-21-93','','metl@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (179,'Mtra.','Raquel Dominguez','56-22-74-74  ext. 1723, 1733','','','56-65-21-93','','','','','','Nuevo director Dr. Salazar (2014-2018) 9.sept. 2014. DPLybf. Ratificacin Fix-Fierro (2010-2014)  boletin 08/09/10, Primer periodo 2006-2010 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1739,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (898,'Lic.','Mara de Guadalupe Flor Daz de Len Fernndez de Castro ','56-22-82-12','56-22-81-56','56-22-08-97','','','diazdeleonflor@ingenieria.unam.mx','diazdeleonsua@gmail.com','','Ocupacin de jefatura 16/11/2016 via telefonica con Obdulia Camao Cuevas. DPLybf.  jefe de biblioteca vacante 17 junio 2015','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (774,'','rsula del Carmen Ramos Soto (Jefa de Biblioteca)','56-22-32-54 (Servicios)','56-22-32-88 (Videoteca)','56-22-32-55','56-22-32-51','','cdjbs_enzolevi@ingenieria.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (283,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (284,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1841,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1842,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1843,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1845,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2498,'Mtro.','Benito Taibo','56-23-32-50','56-23-32-51','','56-87-39-89','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2499,'Lic.','Rodolfo Consuegra Reyes ','5623 32 56','','','5523 8806','','erudycon@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2500,'C.P.','Gilberto Benavides Maya','5623 32 57','','','','','benavides1972@hotmail.com','','','','Designacin de Taibo 2016-2020 G. 13/12/2016. ybfDPL. Designacin de Lic. Davlos (2016-2020) s/p 18/01/16. DPLybf. Nuevo director  Escalante 21 abril 2015. DPLybf. Ratificacin Chamizo (2012-2016). Primer periodo (2008-2012)fp. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (792,'','','','','','','','','','','Responsable pasante en Licenciatura de Bibliotecologia. Catalina Aguilar, nombramiento de confianza. DPLybf 2014','catalina.aguilar@muac.unam.mx',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (896,'','Catalina Aguilar  Gonzlez (Interina)','56-22-05-55, ext. 48777 ','56-22-15-99, ext. 48777','RedUNAM, ext. 48777 ','56-22-69-44','','arkheia2@muac.unam.mx','lina.aguilar07@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (121,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (122,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1651,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1652,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1653,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1655,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2363,'Dr.','Jorge Volpi Escalante (Coordinador)','56-22-70-03','56-22-70-05','','56-65-39-18','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2364,'C.P.','Oscar J. Maceda Daz','56-22-70-06, 30 y 32','','','56-65-01-77','','juliom@hotmail.com.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2365,'C.P.','Hctor Gmez Maldonado','56-22-70-01','','','56-65-01-77','','codcpres@unam.mx','','','','Nuevo coordinador  Dr. Volpi 13/12/2016, ybfDPL.  Ratificacin  de Uriarte en enero- feb. 2016. DPLybf. Designacin de Coordinadora de Difusin Cultural: Uriarte. (2012- ----) Mayo 2012 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (744,'Lic.','Armando Casas','56-22-93-02','','','','','mail@tvunam.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (223,'C.P','Jos Carlos Quiroga Gamboa','56-22-93-42','','','5665 7649','','jcqg69@yahoo.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (219,'C.P.','Claudia Prez Mondragn','56-22-93-54','','','5665 7649','','claus0600@yahoo.com.mx','','','','Designacin de Director Casas 2016-2020, G. 13/12/2016. ybfDPL. Cambio de director, renuncia de Alvarado. Subdirectora de vinculacin Gina Bechelany encargada del despacho 01/09/16. Boletin. DPLybfNuevo director  Alvarado Vale a partir de 19 enero 2016. DPLybf.Ratificacin Velzquez (2012-2016)sf. Primer periodo (2008-2012) DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (115,'','','','','','','','','','','Nuevo responsable pasante de bibliotecologia Perea Reyes. 05/01/2017. ybfDPL','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (880,'','Noel Perea Reyes','56-23-03-35 (Servicios)','56-23-03-70 y 56-23-03-67 (Consulta)','56-23-03-30 y 56-23-03-64 (Responsable)','55-50-78-04','','biblioteca@iibi.unam.mx','noel@comunidad.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (116,'','Felipe Zamora Cruz','56-23-03-67','','','','','','','L - V  12:30 a 20:30 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (117,'Lic.','Estela Rivera Moreno','56-23-03-00','56-23-03-64','','','','','','L - V  8:00 a 14:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1646,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1647,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1648,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1650,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (942,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','Ingreso de Josu,  enero 06/2014, licenciado en infrmatica y pasante de Derecho en escuela incorporada','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (968,'Lic.','Josu Lpez Vargas (Turno matutino)','56-48-54-77 al 84, ext. 122 (Jefatura)','56-48-54-80','','','','josdvd@msn.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (442,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (443,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2021,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2022,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2023,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2025,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (944,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','correo de Gerardo Becerra lekaosg@yahoo.com.mx. Otro Correo de Rodrigo rodripuma_4_2@hotmail.com  Jefe de biblioteca desde octubre de 2001','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (960,'','Rodrigo Cervantes Gutirrez / Jos Gerardo Becerra Lozada','52-77-23-67, ext. 261(Servicios), ext. 260 (Jefatura)','52-77-08-48, ext. 261(Servicios), ext. 260 (Jefatura)','52-71-29-85, ext. 261(Servicios), ext. 260 (Jefatura)','','','rodripuma_4_2@yahoo.com.mx','lekaosg@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (448,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (449,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2031,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2032,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2033,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2035,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (946,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','saedvg@yahoo.com.mx. Jos Pablo Vzquez. Nuevo jefe de biblioteca administrativo, pasante de bibliotecologa en la UNAM. Nombramiento del 16 de marzo 2014. Ingresa 21 de marzo con un horario de lunes a viernes de 8:30 a 15:00 y de 17:00 a 20:00 hrs. DPLybf.','notificacin de nuevo jefe 31 marzo 2014, Adriana Hernndez',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1001,'','Jos Pablo Vzquez Tapia','56-01-35-69, exts. 133 y 137 (Servicios)','56-01-35-62, ext. 140 (Responsable) ','56-01-35-68, ext. 139 (Secretaria)','','','prometeoalaluz@gmail.com ','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (454,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (455,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2041,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2042,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2043,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2045,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (939,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (431,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (432,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (940,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com ','','Jefe de biblioteca turno matutino  a partir de 8 de junio 2015. DPLybf. Jubilacin de Jefe de Biblioteca turno matutino. Ral Octavio Silva a partir de 1 de septiembre de 2014. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (937,'Lic.','Maria Leticia Velzquez Trejo / Abraham Peralta Hernndez','55-93-67-14, ext. 190','55-80-09-50, ext. 190','','','','biblioteca.p8@hotmail.com','lvtp8@hotmail.com / ahalan_pera@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (435,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2011,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2012,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2013,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2015,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (941,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (843,'','Gicela Robles Lpez / Carlos Girn Gutirrez','57-50-20-03, ext. 146','57-50-20-05, ext. 146','57-50-20-07, ext. 146','','','gicelabiblioteca_1@yahoo.com.mx ','carlos_giron5577@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (438,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (439,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2016,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2017,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2018,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2020,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (273,'','','','','','','','','','','Antonia es Jefe de departamento de Documentacin y pasante en la licenciatura de  (inf.2015) ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (672,'','Antonia Rojas vila','56-22-48-00, exts. 47491 al 93 (Servicios)','56-22-93-76','56-22-48-00, ext. 47490 (Responsable)','','','antonia@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (274,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (275,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1831,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1832,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1833,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1835,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (277,'Lic.','Mara de Guadalupe Flor Daz de Len Fernndez de Castro','56-22-82-12','56-22-81-56','56-22-08-97','','','diazdeleonflor@ingenieria.unam.mx','diazdeleonsua@gmail.com','','Sin jefe de biblioteca a partir del 16/01/2017. Nueva coordinadora, Lic. en Lengua y Literatura Hispanicas, titulada Mara de Guadalupe Flor Daz de Len. Comunicado 23 julio 2013. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (897,'','','56-22-08-65 (Servicios)','','','','','','','.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (278,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (279,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1836,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1837,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1838,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1840,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (263,'','','','','','','','','','','Ingreso Mtro. Garca, 5 feb 2016. /agosto 2016 Coordinador de biblioteca (confianza) y Tcnico acadmico.  DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (715,'Mtro.','Carlos Garca Lpez','56-22-75-33, ext. 8','56-22-75-34, ext. 284 (Responsable)','','56-22-75-19','','iihbiblio@unam.mx','carlos_garcia.iih@comunidad.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (264,'Dr.','Fernando Jess Betancourt Martnez','56-22-75-19','','','56-22-75-35','','bmfj@servidor.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (265,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1821,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1822,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1823,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1825,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (741,'Dra.','Ana Buquet Corleto','56-23-00-20 al 23','','','56-23-00-19','','ana_buquet@pueg.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (535,'Mtra.','Sheyla Flores Perez (delegada administrativa)','56-23-00-20','56-23-00-23','56-23-00-21','56-23-00-19','','reberogu@correo.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (701,'','David Morales Zapatero','56-22-53-24','','','56-22-53-24 (Solicitar tono)','','davidmorales.zapatero@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (536,'Mtra.','Sheyla Flores Perez (delegada administrativa)','56-23-00-21','','','56-23-00-19','','reberogu@correo.unam.mx','','','','Designacin de segundo periodo (2017-2021) como primera directora de CIEG. Boletin 14.02.2017. ybfDPL. Cambio directora, nueva Dra. Buquet (2014-2018) Boletin 040. 20 ene 2014 PLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (719,'Mtro.','Marcos Mazari Hiriart','56-22-02-14','56-22-02-15','56-22-03-00 ','56-16-17-73','','dir.arq@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (73,'Mtro.','Abel Salto Rojas (Secretario Administrativo)','56-22-03-20','89-22-03-21','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (74,'C.P.','David Galicia','56-22-03-04','','','','','','','','','Designacin segundo periodo (2017-2021) Marcos Mazari Boletin 15.02.2017. ybfDPL. Nuevo director  MAZARI 2013-2017 Boletin 111. 19/feb/2014 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2483,'Mtro.','Joaqun Dez-Canedo','56-22-65-70','56-65-26-53','','56-65-27-78','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2484,'Lic.','Sofia Margarita Chimal Gonzlez','5622 6592 ext. 122','5622 6189 ext. 122','5622 6580','5665 2354','','schimal@libros.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2485,'C.P.','Hector Castaares Meja','5622 6587','','','5665 2354','','hector@unam.mx','','','2012. Coordinadora de Difusin Cultural Dra. Mara Teresa Uriarte Castaeda. DPLybf','Cambio de director Dez-Canedo. G. 23/02/2017 ybfDPL. Ratificacin interno no publicada, G. 1.08.2016. DPLybf. Cambio director, nuevo Lic. Martnez (2012-2016)  noticia externa 9 de mayo 2012/24 abril 2012',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (5,'Mtra.','Ruth Ledesma Santoyo','56-22-24-99, ext. 394 ','56-22-24-99, ext. 396 (Responsable)','','','','biblioteca@cch.unam.mx','ruth.ledesma@cch.unam.mx / rodrigo.ramirez@cch.unam.mx','','rodrigo.ramirez@cch.unam.mx (Alternativo 2015)    COORDINADORA con lic. en historia y pasante de maestria en docencia, ingresa 15 de agosto 2014. DPLybf. LEDESMA SANTOYO. RUSAHISTORIADORA@OUTLOOK.COM. (21 de abril 2014 la biblioteca de Universidad se encuentra cerrada) Cambio de sede, a partir de diciembre de 2011, antes Luz Avin','aproximadamente en octubre de 2014 ya se encuentra la biblioteca en Av. Universidad 3000. 1er piso  la secretaria Imelda Mendoza con correo imelda.mendoza.nava@outlook.com (cambio 10 feb. 2015)',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (681,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (6,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (7,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1606,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1607,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1608,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1610,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (683,'Mtra.','Ruth Ledesma Santoyo','56-22-24-99, ext. 396 ','','','','','ruth.ledesma@cch.unam.mx','','','Responsable desde 16 de octubre 2012.JMR. Lic. en Bibliotecologia con maestria en Ciencias de la Educacin, cargo de confianza como Coordinador de Biblioteca','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (726,'Mtro.','Juan Manuel Ramos','53-18-55-39, ext. 113','53-18-55-40, ext. 113','','','','jmramos_18@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (163,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (164,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1711,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1712,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1713,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1715,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (685,'Mtra.','Ruth Ledesma Santoyo','56-22-24-99, ext. 396','','','','','ruth.ledesma@cch.unam.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (705,'','Pablo Romn Prez Ortega','56-22-92-84 (Servicios)','56-22-92-45 (Responsable)','51 35 07 64, ext. 110','','','bibliocchsur@yahoo.com.mx','pablopersus@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (173,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (172,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1721,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1722,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1723,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1725,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (684,'Mtra.','Ruth Ledesma Santoyo','56-22-24-99, ext. 396','','','','','ruth.ledesma@cch.unam.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (754,'','Dmaso Hernndez Roldn ','50-97-21-29 (Servicios)','50-97-21-28 (Responsable)','','','','bibliotecacchvallejo@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (167,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (166,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1716,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1717,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1718,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1720,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (682,'Mtra.','Ruth Ledesma Santoyo','56-22-24-99, ext. 396','','','','','ruth.ledesma@cch.unam.mx','','','Ingreso Licenciada en Biblioteconoma  Granados, en noviembre 2013 DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (729,'Lic.','Xchitl Yetlanezi Granados Martnez','53-60-03-23, exts. 241 y 242 (Bibliotecarios)','53-60-03-25, exts. 241 y 242 ','','53-73-12-64 (Secretara Administrativa)','','delphynyetla@yahoo.com.mx','victor_fabian2003@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (160,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (161,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1706,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1707,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1708,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1710,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (686,'Mtra.','Ruth Ledesma Santoyo','56-22-24-99, ext. 396','','','','','ruth.ledesma@cch.unam.mx','','','Designacin nueva responsable Lic. Paz. publicado en G. Oriente 25/04/16. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (874,'Lic.','Mara Guadalupe Paz Martnez','57-73-63-23, ext. 139','57-73-63-17, ext. 139','57-73-88-66, ext. 139','','','biblioriente@gmail.com','guillermoharo@gmail.com / pita54910@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (170,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (169,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1726,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1727,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1728,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1730,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (938,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (428,'','','56-87-68-28, ext. 1007','56-87-68-38, ext. 1009','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (429,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (430,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2001,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2002,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2003,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2005,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (868,'','Ral Ortiz Martnez (Turno vespertino)','54-89-49-33, exts. 252 y 251 (Jefatura)','54-89-49-33, ext. 603','','','','','perry8715@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2006,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2007,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2008,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2010,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (945,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','prepa5_paty@hotmail.com (otro correo)','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (913,'Lic.','Patricia Pea Herrera /Hilda Gmez Serrato','56-78-25-45','56-78-21-01, ext. 503','','','','prepa5_biblio@hotmail.com','prepa5_paty@hotmail.com /  hilda.serrato@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (451,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (452,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2036,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2037,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2038,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2040,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (947,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','Sin responsable en turno matutino enero 2016. ybfDPL. Jubilacin de Jefe de Biblioteca turno matutino. Ral Guerrero a partir de 1 de septiembre de 2014. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (932,'Ing. ','Mara Eugenia Bautista Bazn (Secretaria Academica) / Lic. Gloria Santilln Garca (Turno vespertino)','57-64-40-14 (Jefatura)','57-64-40-23, exts. 248 (Jefatura) y 249 (Prstamo)','57-64-40-12 (Secretaria Acadmica)','57-64-40-23 (Unidad Administrativa. Solicitar tono)','','eugenia.bautista@enp.unam.mx ','unam.gsantillan@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (457,'','Guadalupe Camal Ibez','57-64-40-23 ext. 249','','','','','','','L - V  16:00 a 22:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (458,'','Manuel Enrique Gmez Cabrera','57-64-40-23 ext. 249','','','','','rositas@correo.unam.mx','','L 7:00 a 17:15 V 7:00 a 16:30',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2046,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2047,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2048,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2050,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (830,'Dr.','Csar Augusto Domnguez Prez Tejeda','56-22-75-07','56-22-22-77','56-65-37-61 ','56-65-37-69 (Solicitar tono)','','@unam.mx','@','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (525,'Lic.','Mara Itziar Isla Zavala','56-65-44-26','','','','','itziar@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (526,'Lic.','Maria Elena Arcos Almazan','56-22-72-90','','','56-65-44-26','','jtoledo@universum.unam.mx','','','','Designacin Nuevo director Dr. Domnguez (2017-2021) 06/03/2017 Franco Lpez  2012-2015. Gaceta 19/ene/2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (883,'Dr.','Renato Gonzlez Mello','56-22-75-50, exts. 85027 y 85028','56-22-69-99, exts. 85027 y 85028 ','','56-22-75-50','','iie.direccion@gmail.com','mello@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (44,'Lic. ','Fernando Rojas Zamora (Secretario Administrativo)','56-22-75-42','','','56-65-47-40','','fondodebac@hotmail.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (54,'Lic.','Michel Vilchis','56-22-75-42 ext. 228','56-22-75-42','','56-65-47-40','','jestrada@unam.mx','','','','Ratificacin segundo periodo de Gnzlez (2014-2018) Boletin 698. 2 dic. 2014. DPLybf. Nuevo director: Gonzlez Mello (2010-2014) boletin 30/11/2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1584,'Sr.','Jos Luis Jauregui Ibarra','56-22-75-42 ext. 228','','','56-65-47-40','','jljauregui@correo.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (669,'Dr.','Jorge Enrique Linares Salgado','56-22-18-11','56-16-00-47','56-16-24-15','56-16-00-47 (Solicitar tono)','','','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (246,'Lic.','Samuel Hernndez Lpez (Secretario Administrativo)','55-50-08-43','56-22-18-50','56-22-19-11','55-50-08-43','','samuelhl@servidor.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (247,'C.P.','Regino Daz Paredes','56-22-18-03','','','55-50-08-43','','reginodiaz@comunidad.unam.mx','','','','Nueva designacin Linares Salgado (2017-2021) G. 09/03/2017. ybfDPL. Ratificacin Villegas (2013-2017) Boletin 5 marzo 2013. Primer periodo (2009-2013) Boletin  2 marzo 2009. /DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (994,'Lic.','Candelaria Patricia Lpez Fernndez','56-22-52-50 ','','','','','palomapatos@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (658,'Lic.','Mara Olimpia Torres Osorio','56-22-36-99','56-22-38-95','','56-22-38-95 (Solicitar tono)','','olimpiatorres1nf0@gmail.com','','','Designacin Coordinadora 03/03/2017. ybfDPL. Sin coordinadora a partir del 1 de feb. 2017.','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (479,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (480,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2071,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2072,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2073,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2075,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (466,'Lic.','Mara Olimpia Torres Osorio','56-22-38-95','56-22-32-20','','56-22-38-95 (Solicitar tono)','','olimpiatorres1nf0@gmail.com','','','Nueva designacin 03/03/2017. ybfDPL','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (655,'','Mara Martha Soria Guerrero','56-22-36-99 (Prestamo)','','','56-22-38-95 (Solicitar tono)','','sogue66@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (467,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (468,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2056,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2057,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2058,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2060,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (659,'Lic.','Mara Olimpia Torres Osorio','56-22-36-99','56-22-38-95','','56-22-38-95 (Solicitar tono)','','olimpiatorres1nf0@gmail.com','','','Nueva designacin 03/03/2017. ybfDPL','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1000,'','Zayda Jimnez Bautista','56-22-32-19 ','56-22-35-30 (responsable)','','','','zaydajimenez@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (483,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (484,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2076,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2077,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2078,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2080,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (657,'Lic.','Mara Olimpia Torres Osorio','56-22-52-50 (Servicios)','56-22-38-95','','56-22-38-95 (Solicitar tono)','','olimpiatorres1nf0@gmail.com','','','Coordinadora 03/03/2017. Responsable enero 2017.ybfDPL','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (475,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (476,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2066,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2067,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2068,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2070,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (656,'Lic.','Mara Olimpia Torres Osorio','56-22-36-99','56-22-38-95 ','','56-22-38-95 (Solicitar tono)','','olimpiatorres1nf0@gmail.com','','','Nueva designacin 03/03/2017. ybfDPL','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (706,'','Patricia Coronado Garca','56-22-38-99','Red UNAM 44453 y 44404','','','','coefora_gcp@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (471,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (470,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2061,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2062,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2063,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2065,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (750,'Dr.','Manuel Martnez Justo','56-23-16-44','Ext. Red UNAM  31646','','53-63-58-57','','direccion@apolo.acatlan.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (822,'C.D.','Amada Lpez Tamanaja (Secretaria Administrativa)','56-23-16-67','56-23-16-77','','53-63-09-40','','cdamlota@yahoo.com','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (79,'C.P.','Pedro Gonzlez Fuentes','56-23-16-75','','','56-23-16-75','','huehuetla_pgf@yahoo.com.mx','','','','Nueva designacin Martnez (2017-2021) 16/03/2017 ybfDPL. Ratificacin: Salcedo (2013-2017) Boletin 12 marzo 2013.  Primer periodo (2009-2013) Boletin 9 marzo 2013.DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (734,'Dr.','Christian Sohlenkamp','56-22-76-95','01 (777) +77-13-98-77 (Cuernavaca)','','01 (777) + 73-11-67-10 (Cuernavaca)','','chsohlen@ccg.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (103,'C. P.','Felipe Nava Fabin (Secretario Administrativo)','56-22-76-98','56-22-76-96','','','','fnava@cifn.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (104,'C. P.','Pablo Castorena Fuentes','56-22-76-94','','','','','pcastore@cifn.unam.mx','','','Nueva designacin Dr. Christian (2017- 2021) g. 21/03/2017. ybfDPL. El Dr, David Ren Romero Camarena  se design como presidente del Consejo de Direccin del Campus Morelos del 10 de nov. 2014 al 15 de enero de 2016. Of. 7.1.15 DPLybf.','Ratificacin Romero (2013-2017) Gaceta  4,498. Primer periodo (2009-2013) Boletin 160 /20 marzo/2009. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (415,'','','','','','','','','','','Nuevo responsable licenciado titulado en Bibliotecologia, confianza Coordinador de Acervos musicales, a partir de 11 de junio 2013. DPLybf ','Se tiene activo el correo de renemendez69cervantes@gmail.com (20.08.2014)',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (692,'Mtra.','Martha Nualart Snchez','56-04-07-78, ext. 119','56-04-10-06, ext. 119','56-04-34-65, ext. 119','','','cuicamatini@gmail.com','mnualart@fam.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (416,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (417,'Lic.','Mara del Consuelo Garca Martnez','56-04-34-65','','','56-04-34-65','','','','12:00 a 20:00 hrs.',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1986,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1987,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1988,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1990,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (970,'Mtra.','Laura Elena Cruz Lara','57-37-37-00, ext. 101','57-37-37-01','','57-57-64-51','','laura.cruz@enp.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (784,'Lic.','Jorge Arriaga Reynoso','57-37-35-27 ext. 131','','','','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (444,'L.C.','Narciso Leija Snchez','57-37-35-27 ext. 136','','','','','leijan@servidor.unam.mx','','','','Nueva directora Cruz (2013-2017) gaceta 296, 5/sept/2013 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (861,'Dr.','Jess Antonio del Ro Portilla','56-22-97-44','52 (777)+ 362-00-90 (Temixco)','','52 (777)+ 325-00-18','','dir@cie.unam.mx','','',NULL,'',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (330,'Lic.','Beatriz Olvera Rodrguez (Secretara Administrativa)','56-22-97-97 y 98','','','56-22-97-97','','bor@cie.unam.mx','','',NULL,'',NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (331,'L.C.','Mara de la Luz Ortz Garca','56-22-97-59','','','56-22-97-71','','mlorg@cie.unam.mx','','','','Nueva designacin, segundo periodo (2017-2021) G. 20/04/2017, DPLybf.  Ro Portilla  primer director de IER (2013-2017). Boletin 233. 16 abril. 2013 Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (895,'Mtra.','Gabriela Martnez Miranda','57-50-20-04, ext. 5','57-50-20-04, exts.135','','57-50-20-04, ext. 133 ','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (698,'Lic.','Marcela Marn Quiones','57-50-20-03','55-77-17-21','','','','marmarinq@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (437,'L.E.','Alvaro Marco Solis Rivero','57-50-20-03','','','','','asolis@infotec.com.mx','','','','Nueva designacin QFB Martinez (2017-2021) G. 20/04/2017. DPLybf. Nueva directora QFB. Orozco 2013-2017 a partir del 5 de abril de 2013./directora Lara Arzate, 2010-2014, gaceta  4.282.  7/10/2010. Depto. Planeacin',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (583,'','','','','','','','','','','Nueva designacin (01/04/17) Mtra. Borja inicia 18/04/2017. DPLybf. ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (797,'Mtra.','G. Araceli Borja Prez','56-22-88-10','56-22-87-80 (Responsable)','','56-22-88-11 (Solicitar tono)','','araborjaperez@gmail.com','libro trabajo_social@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (584,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (585,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2181,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2182,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2183,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2185,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (862,'Dr.','Javier Delgado Campos','55-22-54-89','55-22-23-26','55-22-22-60, exts. 116 y 122','55-22-54-41','','puec@unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (530,'Lic.','Julio Cesar Estrada Subizar (Deleg. Advo.)','55-22-23-30 ext.126','55-22-23-26','','55-22-23-30 ext.214','','','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (531,'Lic.','Ismael Barranco Rangel','55-22-23-30  ','ext 125','','55-22-23-30 ext. 214','','','','','','Nueva designacin Dr. Delgado (2017-2021) ybfDPL. G. 11.05.2017. Segundo periodo de Ziccardi 2013-2017, gaceta 4537. 26 agosto 2013 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (216,'','','','','','','','','','','Designacin como Coordinador Acadmico de la Biblioteca Moya, 01/mayo/2017 Lic. Bibl. Mtria. otra. DPLybf. Nuevo responsable Licenciado en Bibliotecologia,UNAM.y Maestra en Administracin, con especialidad en recursos humanos, UVM. Titulado. Reyes a partir de 1 de julio 2014. DPLybf. Junio 2014 con asignacin de Coordinador Acadmico de la Biblioteca. ','56-22-73-53',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (783,'Mtro.','Jos Manuel Moya Valadez','56-22-73-62 (Servicios)','56-22-79-03 (Responsable)','56-22-74-00, ext. 222 ','56-22-73-53 (Solicitar tono)','','biblioteca.iis@sociales.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (217,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (218,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1771,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1772,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1773,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1775,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (185,'','','','','','','','','','','Cambio reestructuracin de Acervo: Supresin de la Unidad de Documentacin de Legislacin y Jurisprudencia , notificacin 8 mayo 2017. DGBybf. 2008 reporta nombramiento de Coordinador de biblioteca y tcnico acadmico Asociado C. Licenciada en Derecho. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (793,'Dr.','Federico Hernndez Pacheco','56-22-74-75 y 56-22-74-74, ext. 1714 (Servicios)','56-22-74-75 y 56-22-74-74, exts. 1715 (Responsable)','56-65-21-93 (Responsable)','56-65-21-93 (Direccin. Solicitar tono)','','iijbibli@unam.mx','federico_hdz@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (186,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (187,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1741,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1742,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1743,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1745,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (180,'','','','','','','','','','','Nuevo coordinador comisionado del IIBI Dr. Hernndez ingresa a bib. 22 junio 2015. DPLybf . 2015 Nuevo Coordinador Acadmico de la biblioteca. Dr. en Derecho. Nombramiento de confianza y Tec. Inv. Titular. Comunicado  5 enero 2015. DPLybf. 2008 reporta nombramiento de Coordinadora Acadmica de la Biblioteca e Investigadora Titular A. Pasante en Doctor de Derecho. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (181,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (182,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1736,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1737,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1738,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1740,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (42,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (41,'','','','','','','','','','','2008 reporta nombramiento de Coordinadora de la Unidad de Informacin y Biblioteca. Tcnico Acadmico  Titular A. Maestra en Bibliotecologia y Estudios de la Informacin. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (825,'Dra.','Rosa Jimena Rey Loaiza','56-22-89-99','','','','','biblioteca@ecologia.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (43,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1601,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1602,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1603,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1605,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2558,'','','01 (477) 194-08-00, ext. 43304','','','','','direccion@enes.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2559,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2560,'','','','','','','','','','','El dr. Javier fue designado secretario de Atencin a la Comunidad 1 junio 2017. DPL','Ratificacin  boletin 447. 3 de agosto 2015 DPLybf. Segundo periodo de de la Fuente (2015-2019) via  telefnica 1 julio 2015 DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (881,'Dra.','Mara del Carmen Contijoch Escontria','56-22-06-76','56-22-06-82','','','','direccin@cele.unam.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (137,'Lic.','Csar Adrin Andrade Rodrguez','55-50-00-52','56-22-06-89','','','','candrader2002@yahoo.com.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (136,'Lic.','Alicia Gonzlez Granados','56-22-06-75','56-22-06-89 ext. 235','','','','provalis2@yahoo.com.mx','','','Designacin  de Carmen Contijoch (2017-2021) 01/06/2017. DPL','Ratificacin Alina Signoret (2013-2017). Boletin 326/ 28 mayo 2013. Primer periodo (2009-2013) segundo y tercer informe 30 abril 2012. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (962,'Mtra.','Rosa Guadalupe Valadez Olguin','56-23-19-97 ','56-23-19-95 ','','58-70-56-73','','fesc@unam.mx','','','Cambio de coordinador y responsable a partir de 17 de febrero de 2014. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (961,'Mtra.','Margarita Zapata Guerrero','56-23-20-52 (Servicios)','56-23-20-33 (Responsable)','','','','margaret@unam.mx','margaretmzg@comunidad.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (152,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (153,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1691,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1692,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1693,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1695,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (291,'Lic.','Mara de Guadalupe Flor Daz de Len Fernndez de Castro','56-22-82-12','56-22-81-56','56-22-08-97','','','diazdeleonflor@ingenieria.unam.mx','diazdeleonsua@gmail.com','','Nueva coordinadora a partir de 25 julio/2012  Daz de Len. correo alternativo  diazdeleonflor@fingenieria.unam.mx','Correo alternativo Lic. Garca. oicoracilegna@gmail.com  DPL.bfy 25 mayo 2015',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (900,'Lic.','Roco Anglica Garca Garca (Jefa de Biblioteca)','56-22-82-11 (Servicios)','56-22-82-15 (Prstamo)','56-22-82-12','','','bibliotecaanexo@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (292,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (293,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1851,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1852,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1853,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1855,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (547,'','','','','','','','','','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (724,'Mtra.','Rosa Atzimba Morales Monroy','56-22-22-44 ','56-22-22-34','','56-22-22-44 (Solicitar tono)','','biblio.psicologia@unam.mx','atzimba@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (548,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (549,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2141,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2142,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2143,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2145,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (148,'','','','','','','','','','','Cambio de responsable 05/03/2013 Maestra titulada en ciencias politicas, de confianza inicia en febrero. Depto. Planeacin','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (821,'Mtra.','Montserrat Castells Rivera','56-22-94-00, ext. 0','56-22-94-00, ext. 84370','56-23-38-53, ext. 84371','','','bibliotecaisidrofabela@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (149,'','Reina Prez Delgado (T.Mat.) /  Judith Valderrama Garca (T. Vesp.)','56-22-94-20 red 72','56-22-94-21 red 72','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (150,'','Mara Ortz Rivera (T.Mat.) / Fernando Avila Vzquez (T.Vesp.)','56-22-94-20 red 38','56-22-94-21 red 38','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1686,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1687,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1688,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1690,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (613,'Lic.','Sal Acua Paredes','56-22-59-57','56-22-59-04 (Coordinacin)','Ext. RedUNAM 45325','','','saul3710@gmail.com','','','Nuevo coordinador a partir del 1 de junio de 2015 Licenciado en bibliotecologa titulado por la UNAM. DPLybf 1 junio 2015. Cambio de coordinador a partir de 1 de agosto 2013, ingresa Novelo','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (614,'Dr.','Jess Jarillo Rodriguez','01(232)  + 32-43-941, ext. 122 (Servicios)','01(232)  + 32-43-942, ext. 103 (Responsable)','','01(232)  + 32-43-943 (Solicitar tono)','','jarilloj22@hotmail.com','alonsodm@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (615,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (616,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2226,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2227,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2228,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2230,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (890,'Lic.','Sal Acua Paredes','56-22-59-57 ','56-22-59-04 (Coordinacin)','Ext. RedUNAM 45325','','','saul3710@gmail.com','','','Nuevo coordinador licenciado en bibliotecologia titulado por la UNAM, ingresa el 1 de junio de 2015. DPLybf.Oficialmente a partir del 1 de abril 2015 no hay coordinador. Nuevo coordinador Novelo Pea oficialmente se integra el 1 de agosto 2013. Sin coordinador junio 10 2013. Cambio de coordinador  Lic. Olvera, 22 abril 2013 en forma interina. Cambio de coordinador Orozco 16/junio/2012. Notificacin recibida 29/junio/2012','Arturo Durazno: arturotuck@hotmail.com',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (522,'','Francisco Pasos Hernndez / Adriana Roldn Garca ','56-22-59-32 (Servicios) ','56-22-59-57','','56-22-59-11 (Hemeroteca.Solicitar tono)','','luz-roldan@hotmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (523,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (524,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2116,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2117,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2118,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2120,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (888,'Lic.','Sal Acua Paredes','56-22-59-57','56-22-59-04 (Coordinacin)','Ext. RedUNAM 45325','','','saul3710@gmail.com','','','Nuevo coordinador licenciado en bibliotecologia titulado por la UNAM ingresa el 1 de junio 2015. DPLybf ','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (679,'M.V.Z','Alma Selene Vzquez Delgado','58-45-00-29','58-45-15-30','','58-45-15-30 (Solicitar tono)','','mvzalmavazquez@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (296,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (297,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1856,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1857,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1858,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1860,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (891,'Lic.','Sal Acua Paredes','56-22-59-57','56-22-59-04 (Coordinacin)','Ext. RedUNAM 45325','','','saul3710@gmail.com','','','Nuevo coordinador licenciado en bibliotecologia titulado por la UNAM el 1 de junio 2015. DPLybf 1 junio 2015','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (991,'M. V. Z.','Juan Antonio Rodrguez Garca','01 (414) + 291-81-00','','','01 (414) + 291- 81- 05','','ceiepaa@unam.mx','jarg9702@hotmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (579,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (580,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2176,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2177,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2178,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2180,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (887,'Lic.','Sal Acua Paredes','56-22-59-57','56-22-59-04 (Coordinacin)','Ext. RedUNAM 45325','','','saul3710@gmail.com','','','Nuevo coordinador licenciado en bibliotecologia titulado por la UNAM el 1 de junio 2015. DPLybf 1 junio 2015','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (952,'M. V. Z.','Csar Flores Serrano','01(739)  + 39-30-142 ','01(739)  + 39-30-616 ','','01(739)  + 39-30-616 (Solicitar tono)','','ceflose@yahoo.com.mx','lambcfs@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (238,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (239,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1796,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1797,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1798,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1800,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (889,'Lic.','Sal Acua Paredes','56-22-59-57','56-22-59-04 (Coordinacin)','Ext. RedUNAM 45325','','','saul3710@gmail.com','','','Acadmico director tcnico Gutirrez. 10/mar/2015 DPL','Nuevo coordinador de bibliotecas licenciado en bibliotecologia, titulado por la UNAM. ingresa el 1 de junio de 2015. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (926,'M.V.Z.','Oscar Gutirrez Prez','01(761)  + 73-40-454','01(761)  + 73-41-382','','','','koala630816@yahoo.com.mx','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (300,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (301,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1861,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1862,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1863,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1865,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (680,'','','','','','','','','','','Lic. Cruz Romero, ingresa como coordinadora de la Bca. 1o de octubre 2012. depto. Planeacin','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (860,'Mtra.','Adriana Cruz Romero','56-22-22-45','Red UNAM ext. 41236','','','','cedoc.psicologia@unam.mx','adcruzro@unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (552,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (553,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2146,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2147,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2148,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2150,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (943,'Lic.','Gloria Adriana Hernndez Snchez','56-87-68-28, ext. 1009','56-87-68-38, ext. 1007','','','','adrianahs@enp.unam.mx','adria568@hotmail.com','','','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (820,'','Lic. Emilia Fonseca Rosas ','57-37-35-25, ext. 193','57-37-35-24, ext. 193','','','','biblioprepa3@yahoo.com.mx','lbforen@yahoo.com.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (445,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (446,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2026,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2027,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2028,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2030,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (492,'Lic.','Sal Armendriz Snchez','56-22-40-30','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','2015 Nuevo responsable Oviedo y tcnico acadmico asociado c. Licenciado en biblioteconoma. 25 feb 2015. DPLybf. 2008 reporta nombramiento de  Tcnico Acadmico Titular A. Bachillerato. PLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (877,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (495,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (498,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2086,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2087,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2088,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2090,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (491,'Lic.','Sal Armendriz Snchez','56-22-40-30','56-22-40-31','56-22-40-36 (Coordinador)','56-22-40-36 (Coordinacin de la BCCT)','','asaul@bcct.unam.mx','asaul@xcaret.igeofcu.unam.mx','','otro correo de Alvarez: icmlcarmen@prodigy.net.mx 2014. DPLybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (751,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (494,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (497,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2081,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2082,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2083,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (2085,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (906,'Dr.','Mario Humberto Ruz Sosa','56-22-74-85','56-06-08-04','','','','mhruzs@gmail.com','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (266,'C. P.','Ilia Parres Ilizaliturri (Secretario Administrativo)','56-65-04-11','','','','','ilia@servidor.unam.mx','','',NULL,NULL,NULL,'');
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (267,'Mtra.','Virginia Muoz Miranda','56-65-04-11','','','','','lindaval@servidor.unam.mx','','','Dr. Alberto Vital es nombrado coordinador de la investigacin en humanidades.','Nuevo director (2016-2020) en sustitucin de Vital. Boletin 74, 3 feb. 2016. DPLybf. Nuevo director Vital (2013-2017) Boletin 722, 3 dic. 2013. DPLybf. Directora: Vargas ( 2009-2013) boletin 30 noviembre 2009. DPLybf',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (268,'','','','','','','','','','','Nueva responsable a partir del 01/04/16. Lic. en bibliotecologia y tcnico acadmico Angeles Ciprs. DPLybf. CAMBIO DE RESPONSABLE: Mtra.en Bibliotecologia, titulada  Luz Mara a partir del 31 de enero 2014. tiene nombramiento de coordinador de biblioteca y tcnico acadmico, DPLybf envio de notificacin 7 de feb 2014 recibido 10 de feb','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (800,'Lic.','Mara de los Angeles Ciprs Oliva','56-22-74-97 (Servicios)','56-22-74-86 (Responsable)','','56-22-74-86 (Solicitar tono)','','iiflbiblio.angeles@gmail.com','rbnbiblio@gmail.com','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (269,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (270,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1826,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1827,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1828,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1830,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (248,'','','','','','','','','','','Nuevo responsable Dr. Azotla. a partir de 19 de junio de 2017. DPL.ybf','',NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (799,'Dr.','Magdaleno Azotla lvarez','56-22-18-91 (Prstamo)','56-22-18-53 (Responsable)','','','','biblioteca@filos.unam.mx','mazotla@comunidad.unam.mx','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (249,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (250,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1806,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1807,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1808,'','','','','','','','','','',NULL,NULL,NULL,NULL);
INSERT INTO "datospersona" ("per_id","grado","nombre","tel_1","tel_2","tel_3","fax_1","fax_2","mail_1","mail_2","horario","observaciones","per_obs","foto","funcion") VALUES (1810,'','','','','','','','','','',NULL,NULL,NULL,NULL);
--
-- Data for TOC Entry ID 62 (OID 3235379)
--
-- Name: infraestructura Type: TABLE DATA Owner: israeld
--


INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (144,'0','0','0','0','','',NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (142,'0','0','0','0','','','*Informacin integrada en BCCT','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (143,'0','0','0','0','','','*Informacin integrada en BCCT','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (146,'0','0','0','0','','','*Informacin integrada en BCCT','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (141,'0','0','0','0','','','*Informacin integrada en BCCT','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (19,'5','0','1','0','Aleph $Excel','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (99,'8','0','2','1','Circula $Excel','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (40,'14','0','2','1','Aleph $Excel','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (39,'21','4','2','1','Aleph $Create a label','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (43,'16','0','3','1','Aleph $Create a Label 3','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (42,'15','10','2','1','Aleph','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (41,'12','0','2','1','Aleph $Label view','Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (106,'16','0','0','1','Aleph $CAL 3','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (105,'14','6','1','1','Aleph $Cal 3','Adquisiciones $Procesos tcnicos (produccin de etiquetas)$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (103,'15','0','0','0','Aleph $Cal 3','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (102,'16','0','1','1','Aleph $Create a Label 3','Prstamo $Procesos tcnicos ','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (101,'16','4','1','1','Aleph $Calc 3','Adquisiciones $Prstamo $Procesos tcnicos (produccin de etiquetas)','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (104,'8','0','2','1','Aleph $Adqunam $Created Label 3','Adquisiciones $Procesos tcnicos (produccin de etiquetas)$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (107,'14','0','1','1','Circula $Create Label 3','Procesos tcnicos (produccin de etiquetas)$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (108,'13','3','2','1','Aleph $Create a Label 3','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (56,'1','5','1','0','','','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (8,'8','1','1','1','No Software','Actividades Manuales, No Automatizadas','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (9,'6','3','2','1','Aleph','Procesos tcnicos$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (148,'16','2','2','1','Aleph$Adqunam $Dbase $Abery label','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (96,'17','5','2','1','Aleph $Excel','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (135,'33','6','3','2','Aleph $Label limited $Excel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (10,'17','0','3','1','Aleph','Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (32,'7','0','2','1','No Software','Actividades Manuales, No Actividades Automatizadas','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (60,'28','9','4','2','Aleph $Adqunam $Label Pro $Excel $Bases DGB','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (15,'54','30','5','2','Aleph $Access $Minisis $Excel','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (16,'17','7','3','1','Minisis $Excel','Procesos tcnicos$Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (33,'11','0','1','1','Aleph $Circula $Avery label pro $Excel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (37,'86','2','21','3','Aleph $Peridicas $Label-Pro $Access','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (100,'0','1','0','0','0','0','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (139,'15','0','5','1','Aleph $Avery Label Pro $Excel','Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (65,'8','3','3','2','Aleph $Circula','Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (66,'20','5','2','2','Aleph $Sistema Dolphin $Excel $Label Unlimited','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (68,'42','6','4','1','Aleph $Circula $Access','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (80,'8','6','3','2','Aleph $Adqunam $Circula','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (69,'1','0','0','0','','Centralizados en Biblioteca Principal (P)','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (122,'56','2','9','2','Aleph$Microisis$Internet','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (145,'3','0','0','0','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (70,'0','0','0','0','','Centralizados en Biblioteca Principal (P)','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (57,'1','0','0','0','','Centralizada en Biblioteca Principal (P)','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (97,'11','1','3','1','Aleph$Circula$Label Matrix','Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (98,'7','0','1','1','Aleph $Label Matrix$Excel','Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (127,'38','3','3','1','Aleph $Excel$Base de datos','Adquisiciones $Procesos tcnicos $Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (128,'27','0','4','0','Aleph $Label Matrix $Swetsnet','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (111,'6','1','2','1','Access Label','Procesos tcnicos','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (113,'5','0','2','0','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (114,'12','0','2','0','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (112,'4','0','1','0','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (110,'27','0','3','2','Aleph $Access Label Pro $Circula','Adquisiciones $Procesos tcnicos $Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (13,'22','0','3','4','Aleph $Excel $Bases de datos en lnea $Ariel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (30,'8','0','3','0','SABE$Aleph$Internet$Bases de datos DGB','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (73,'4','0','3','1','Aleph$Excel','Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (72,'4','0','1','1','SIAF $Word $Internet $Ariel','Adquisiciones $Prstamo $Consulta Especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (24,'6','2','3','1','Word $Internet','Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (89,'4','0','1','0','Aleph$Ariel','Adquisiciones$Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (77,'5','0','1','1','Aleph$Linux$Red UNAM','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (123,'19','3','1','2','Aleph$Ariel$Internet','Procesos tcnicos$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (3,'4','0','2','1','Aleph$Access$My label','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (2,'4','1','1','0','Aleph$Avery Label Pro$Astronomical Digital Services','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (55,'1','0','0','0','','','*Informacin Censo 2004 (Las actividades automatizadas se hacen desde la Coordinacin del IB)','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (134,'1','0','0','0','','Centralizado en la Biblioteca Principal (P)','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (54,'19','0','2','1','Microisis$Aleph$Excel$Servicios en lnea DGB','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (115,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (116,'8','0','1','0','Access','Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (117,'2','0','1','0','Aleph $Web BCCT $Ariel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (23,'8','0','3','1','Diseo propio Dependencia','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (74,'12','0','4','1','Aleph','Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (88,'2','0','1','0','Ariel','Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (91,'4','0','1','0','Diseo Propio $Excel $Ariel','Adquisiciones $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (86,'11','0','3','1','Aleph$Software Propio','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (20,'13','0','3','1','Aleph$Microisis$Excel$Label Pro$Ariel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (34,'11','0','2','1','Aleph $Excel$BD en lnea','Adquisiciones $Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (147,'4','0','1','1','Aleph$Internet','Adquisiciones$Procesos tcnicos$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (78,'8','0','3','0','Aleph$Label Matrix$Internet','Adquisiciones $Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (21,'9','0','4','1','Aleph $Internet','Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (22,'10','0','5','1','Aleph $Adqunam $Microisis','Adquisiciones $Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (92,'8','0','1','1','Aleph$Excel$Internet','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (58,'9','0','2','1','Aleph $Winisis $Excel $Internet','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (27,'11','0','1','1','Aleph$Peridica$End note','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (5,'23','0','4','1','Aleph$File Maker$Excel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (14,'11','0','3','1','Aleph $Excel $Internet','Adquisiciones $Procesos tcnicos $Consulta especializada.','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (63,'24','0','7','1','Aleph$Claris-Works$Lotus','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (62,'11','3','4','1','Aleph $Adqunam $Internet','Adquisiciones$Procesos tcnicos$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (46,'1','0','0','0','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (90,'5','0','3','0','Micro CDS-ISIS','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (124,'3','0','1','1','Aleph$Label Matrix','Procesos tcnicos','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (31,'14','0','3','1','Aleph$Access $Excel','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (121,'6','0','2','0','Access','Procesos tcnicos','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (119,'10','0','3','1','Aleph$Adqunam$Bar Code label printers$Circula','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (48,'6','0','3','1','Aleph$Excel','Adquisiciones$Procesos tcnicos$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (38,'4','0','0','1','Aleph','Adquisiciones$Procesos tcnicos','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (136,'3','0','0','1','Aleph $Excel','Adquisiciones $Procesos tcnicos $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (64,'11','0','1','1','Microisis $Excel','Adquisiciones $Procesos tcnicos','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (47,'3','0','1','1','Aleph$Adqunam','Adquisiciones$Procesos tcnicos$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (28,'2','0','1','0','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (26,'25','0','2','0','Aleph$Microsis$OCLC$ISI','Adquisiciones$Procesos tcnicos$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (109,'3','0','1','1','Aleph$Word','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (49,'7','0','2','0','Winisis','Adquisiciones$Procesos tcnicos$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (129,'11','0','5','1','Aleph $Label Pro $Excel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (130,'4','0','2','0','Aleph','Adquisiciones$Procesos tcnicos$Prstamo','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (131,'4','0','1','0','Aleph$Avery Label Pro$Access','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (50,'2','0','0','1','','Realiza Actividades Manuales','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (53,'3','0','0','1','Word','Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (150,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (153,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (154,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (155,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (156,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (12,'159','52','19','0','Aleph$Adqunam$Bases de datos de DGB$Access$Label Matrix','Adquisiciones$Procesos tcnicos$Prstamo$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1070,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1080,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1100,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1110,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1130,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1150,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1160,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1180,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1200,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1210,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (1220,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (158,'2','0','1','1','Aleph$Adqunam$Internet','Adquisiciones$Procesos tcnicos$Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (160,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (161,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (138,'61','12','9','1','Aleph $Avery Label Pro $Excel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','*Informacin Censo 2004','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (11,'0','0','0','0','Circula','Prstamo','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (76,'0','0','0','1','Aleph $Excel $Web DGB $Ariel','Adquisiciones $Procesos tcnicos $Prstamo $Consulta especializada','0','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (118,'0','2','0','1','Aleph$Circula','Procesos tcnicos$Prstamo','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (120,'8','2','1','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (18,'0','0','0','0','0','0','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (71,'0','0','0','0','','Adquisiciones $Procesos tcnicos $Consulta especializada','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (94,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (52,'0','0','0','0','0','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (61,'0','2','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (93,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (45,'0','12','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (125,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (4,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (7,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (95,'0','5','0','0','0','0','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (75,'0',NULL,'0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (67,'0','0','0','0','0','0','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (159,'0',NULL,'0','0','','','','Creacin de la licenciatura en Desarrollo Territorial con opciones terminales en las reas de Gestin Econmica y Social Territorial, Gestin Ambiental y Gobernanza Territorial. Gaceta 4707. 2 julio 2015. DPL:ybf');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (35,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (44,'0','0','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (133,'0','0','0','0','0','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (36,'0','5','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (59,'0','1','0','0','','','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (85,'0','0','0','0','Aleph $Excel','Adquisiciones $Procesos tcnicos','','');
INSERT INTO "infraestructura" ("bib_id","num_cpu","num_term","num_impr","num_serv","sw","activ_autom","observaciones","infra_obs") VALUES (162,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
--
-- Data for TOC Entry ID 63 (OID 3235385)
--
-- Name: normatividad Type: TABLE DATA Owner: israeld
--


INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (115,'','','',NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (144,'','','',NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (40,'No','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (41,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (42,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (43,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (19,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (100,'Si','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (103,'Si','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (104,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (105,'Si','Si','Cargos remotos $Procesos menores $Servicios al Pblico $ Publicaciones peridicas','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (106,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (107,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (108,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (102,'Si','No','Manual de rutinas','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (99,'No','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (33,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (66,'Si','Si','Manual polticas de prstamo','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (68,'Si','Si','Manual de organizacin $Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (67,'Si','Si','Manual de procedimientos de seleccin $Manual de adquisiciones bibliogrficas','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (80,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (85,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (8,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (65,'Si','Si','Manual de procedimientos $Manual de organizacin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (139,'Si','Si','Manual de organizacin $Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (138,'Si','Si','Procedimientos generales: 1.Control de documentos 2. Control de registros 3.Auditorias internas 4.Control de producto, etc.','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (37,'Si','Si','Manual de procedimientos de: adquisiciones; suscripciones;  prstamos de libros; registro de tesis.','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (95,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (35,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (133,'Si','Si','Manual de procesos y procedimientos $Manual de polticas de trabajo / organizacin ','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (135,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (96,'Si','Si','Manual de procedimientos (Servicios)','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (7,'Si','Si','Manual de organizacin $Manual de procedimientos $Manual de poltica de trabajo','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (4,'Si','Si','Manual de funciones $Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (9,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (148,'Si','Si','Manual de organizacin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (60,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (10,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (11,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (32,'Si','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (15,'Si','Si','Manual de seleccin y adquisicin$Manual de polticas de adquisicin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (16,'Si','Si','Manual de seleccin y adquisicin$Manual de polticas de adquisicin','*Informacin Censo 2003$*Informacin de manuales (Se emplean en C y C1)','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (122,'Si','Si','Manual de procedimientos $Manual de organizacin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (110,'Si','Si','Manual de organizacin y procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (70,'Si','Si','No','*Informacin Censo 2003$*Informacin de Comisin y Reglamento se apoyan en el de la Biblioteca Principal (P)(Censo 2003)','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (57,'Si','Si','No','*Informacin Comisin y Reglamento pertenecen a la Biblioteca Principal (P) (Censo 2003)','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (134,'Si','Si','No','*Informacin Comisin y Reglamento pertenecen a Biblioteca Principal (P)(Censo 2003)','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (69,'Si','Si','No','*Informacin Comisin y Reglamento pertenecen a la Biblioteca Principal (P)(Censo 2003)','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (145,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (97,'Si','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (98,'No','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (127,'Si','Si','Manual de procedimientos de los servicios y organizacin de la biblioteca','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (128,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (112,'Si','Si','Manual de procedimientos $Manual de polticas de trabajo','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (111,'Si','Si','Manual de organizacin Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (113,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (114,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (119,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (50,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (64,'Si','Si','Manual de organizacin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (48,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (47,'Si','Si','Manual de funciones $Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (28,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (12,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (26,'No','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (130,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (131,'Si','Si','Manuales de organizacin, polticas y procesos en elaboracin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (129,'Si','Si','Manual de organizacin $Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (136,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (53,'No','Si','Manual de procedimientos del Departamento','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (38,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (121,'No','Si','Manuales de procedimientos (adquisiciones, prstamos, proceso tcnicos)','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (31,'Si','Si','Manual de adquisiciones $Manual de procesos tcnicos $Manual de suscripciones','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (109,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (49,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (58,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (92,'Si','Si','Manual de procedimientos para realizar el proceso de preparacin fsica de los libros','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (22,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (21,'Si','Si','Manual de procedimientos para la seleccin y adquisicin de libros','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (27,'Si','No','Manual de adquisiciones','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (94,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (124,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (125,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (90,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (52,'Si','Si','Manual de organizacin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (14,'Si','Si','Manual de organizacin para el Coordinador','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (62,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (61,'Si','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (45,'Si','Si','Sistema de Clasificacin de la Biblioteca IIJ$Catlogos de Voces, Lineamientos para captura y tabla de 3 cifras','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (63,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (46,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (93,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (123,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (147,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (2,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (3,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (77,'Si','Si','Manual del usuario','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (55,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (89,'No','No','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (30,'No','Si','Manual de procedimientos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (72,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (24,'No','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (88,'No','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (23,'Si','Si','Recuperacin de documentos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (54,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (73,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (78,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (118,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (71,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (34,'Si','Si','Manual de polticas de seleccin y adquisicin de libros','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (120,'Si','Si','Manual Reestructuracin de la Biblioteca del ICN $Manual Proyecto para la Jefatura de Servicios de Informacin','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (91,'Si','No','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (76,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (20,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (86,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (56,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (116,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (5,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (117,'Si','Si','Manual de adquisiciones; Suscripciones; Procesos menores; Preparacin fsica de libros y otros documentos','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (74,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (142,'','','','*Informacin integrada en BCCT','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (143,'','','','*Informacin integrada en BCCT','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (146,'','','','*Informacin integrada en BCCT','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (141,'','','','*Informacin integrada en BCCT','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (39,'Si','Si','Manual de procedimientos de Procesos Tcnicos $Manual de procedimientos de Prstamo Interno y a Domicilio','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (150,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (153,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (154,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (13,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (155,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (156,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (157,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1070,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1080,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1090,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1100,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1110,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1120,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1130,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1140,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1150,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1160,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1170,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1180,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1190,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1200,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1210,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (1220,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (158,'Si','Si','No','*Informacin Censo 2003','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (159,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (160,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (161,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (75,'Si','Si','No','','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (44,'0','0','0','','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (36,'Si','Si','','','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (59,'Si','Si','','','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (162,'Si','Si','','','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (101,'Si','Si','Manual de seleccin y adquisicin','','');
INSERT INTO "normatividad" ("bib_id","comision","reglamento","manuales","observaciones","norm_obs") VALUES (18,'No','Si','No','','');
--
-- Data for TOC Entry ID 64 (OID 3235391)
--
-- Name: persona Type: TABLE DATA Owner: israeld
--


INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,650,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,651,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,652,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,654,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,655,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,656,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,657,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,658,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,659,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,660,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,661,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,663,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,664,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,665,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,666,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,669,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,670,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,671,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,672,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,673,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,674,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,675,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,676,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,677,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,678,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,679,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,680,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,681,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,682,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,683,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,684,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,685,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,686,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,687,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,688,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,689,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,690,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,691,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,692,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,693,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,694,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,695,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,696,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,697,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,698,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,699,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,701,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,702,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,703,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,704,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,705,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,706,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,707,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,708,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,710,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,711,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,712,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,713,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,714,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,715,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,716,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,717,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,718,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,719,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,720,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,721,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,722,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,723,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,724,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,725,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,726,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,727,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,728,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,729,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,730,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,731,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,732,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,733,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,734,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,735,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,736,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,737,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,738,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,739,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,740,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,741,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,742,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,743,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,744,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,745,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,746,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,747,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,748,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,750,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,751,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,752,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,753,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,754,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,755,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,756,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,757,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,761,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,763,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,764,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,765,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,766,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,767,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,768,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,769,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,770,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,771,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,772,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,773,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,774,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,775,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,776,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,778,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,779,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,780,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,781,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,782,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,783,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,784,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,785,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,786,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,787,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,788,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,789,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,790,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,791,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,792,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,793,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,794,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,795,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,796,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,797,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,798,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,799,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,800,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,801,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,802,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,803,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,804,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,805,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,806,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,807,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,811,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,814,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,815,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,816,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,817,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,818,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,819,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,820,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,821,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,822,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,823,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,824,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,825,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,826,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,827,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,829,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,830,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,831,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,832,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,833,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,834,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,835,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,836,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,837,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,839,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,840,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,841,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,842,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,843,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,844,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,845,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,846,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,848,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,849,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,850,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,851,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,852,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,854,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,855,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,856,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,857,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,858,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,859,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,860,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,861,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,862,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,864,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,865,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,866,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,2,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,868,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,869,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,870,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,871,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,872,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,873,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,874,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,876,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,877,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,878,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,880,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,881,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,882,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,883,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,884,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,885,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,887,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,888,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,889,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,890,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,891,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,893,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,894,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,895,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,896,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,897,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,898,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,899,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,900,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,901,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,902,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,903,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,904,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,905,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,906,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,907,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,908,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,909,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,910,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,911,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,913,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,914,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,915,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,916,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,917,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,918,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,919,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,920,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,921,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,922,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,923,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,924,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,925,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,926,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,927,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,928,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,929,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,930,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,931,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,932,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,934,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,936,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,937,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,938,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,939,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,940,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,941,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,942,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,943,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,944,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,945,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,946,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,947,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,948,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,949,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,950,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,951,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,952,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,953,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,954,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,955,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,956,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,957,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,958,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,959,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,960,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,961,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,962,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,963,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,964,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,965,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,966,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,967,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,968,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,970,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,971,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,972,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,973,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,974,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,975,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,976,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,977,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,980,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,982,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,983,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,984,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,985,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,3,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,987,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,989,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,990,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,991,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,993,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,994,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,995,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,996,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,997,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,999,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,1000,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,1001,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,4,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,5,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,6,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,7,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,8,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,9,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,10,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,11,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,15,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,16,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,17,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,18,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,19,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,20,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,21,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,22,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,23,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,24,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,25,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,28,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,29,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,30,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,31,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,32,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,33,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,34,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,35,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,36,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,37,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,38,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,39,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,40,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,41,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,42,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,43,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,44,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,45,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,46,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,47,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,48,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,49,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,50,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,51,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,52,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,53,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,54,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,55,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,56,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,57,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,58,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,59,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,60,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,61,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,62,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,63,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,64,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,65,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,66,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,67,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,68,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,69,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,70,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,71,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,72,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,73,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,74,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,75,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,76,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,77,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,78,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,79,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,80,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,82,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,83,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,84,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,85,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,86,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,87,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,88,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,89,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,90,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,91,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,92,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,93,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,94,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,95,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,96,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,97,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,98,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,99,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,100,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,101,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,102,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,103,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,104,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,105,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,106,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,111,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,112,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,113,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,114,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,115,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,116,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,117,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,118,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,119,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,120,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,121,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,122,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,123,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,124,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,125,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,126,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,127,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,128,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,129,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,130,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,131,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,132,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,133,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,134,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,135,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,136,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,137,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,138,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,139,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,140,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,141,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,142,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,143,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,144,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,145,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,146,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,147,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,148,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,149,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,150,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,151,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,152,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,153,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,154,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,155,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,156,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,157,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,158,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,159,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,160,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,161,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,162,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,163,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,164,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,165,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,166,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,167,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,168,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,169,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,170,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,171,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,172,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,173,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,174,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,175,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,176,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,177,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,178,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,179,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,180,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,181,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,182,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,183,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,184,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,185,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,186,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,187,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,188,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,189,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,190,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,191,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,192,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,193,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,194,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,195,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,196,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,197,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,198,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,199,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,200,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,201,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,202,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,203,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,209,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,210,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,211,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,212,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,213,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,214,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,215,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,216,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,217,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,218,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,219,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,220,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,221,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,222,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,223,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,224,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,225,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,226,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,227,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,228,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,229,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,230,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,231,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,232,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,233,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,234,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,235,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,236,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,237,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,238,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,239,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,240,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,241,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,242,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,243,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,244,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,245,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,246,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,247,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,248,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,249,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,250,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,251,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,252,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,253,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,254,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,255,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,256,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,257,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,258,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,259,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,260,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,261,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,262,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,263,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,264,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,265,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,266,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,267,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,268,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,269,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,270,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,271,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,272,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,273,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,274,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,275,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,276,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,277,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,278,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,279,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,280,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,281,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,282,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,283,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,284,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,285,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,286,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,287,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,288,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,289,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,290,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,291,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,292,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,293,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,294,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,295,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,296,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,297,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,298,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,299,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,300,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,301,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,302,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,303,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,304,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,305,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,306,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,307,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,308,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,309,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,310,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,311,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,312,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,313,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,314,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,315,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,316,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,317,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,318,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,319,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,320,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,321,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,322,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,323,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,324,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,325,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,326,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,327,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,328,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,329,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,330,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,331,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,332,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,333,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,334,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,335,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,336,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,337,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,338,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,343,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,344,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,345,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,346,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,359,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,360,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,361,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,362,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,363,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,364,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,365,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,366,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,367,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,368,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,369,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,370,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,371,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,376,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,377,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,378,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,379,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,380,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,381,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,382,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,383,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,384,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,385,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,386,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,387,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,388,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,389,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,390,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,391,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,392,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,393,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,394,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,395,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,396,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,397,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,398,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,399,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,400,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,401,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,402,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,403,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,404,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,405,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,406,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,407,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,408,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,409,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,410,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,411,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,412,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,413,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,414,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,415,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,416,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,417,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,418,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,419,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,420,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,421,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,422,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,423,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,424,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,425,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,426,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,427,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,428,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,429,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,430,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,431,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,432,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,433,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,434,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,435,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,436,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,437,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,438,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,439,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,440,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,441,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,442,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,443,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,444,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,445,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,446,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,447,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,448,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,449,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,450,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,451,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,452,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,453,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,454,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,455,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,456,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,457,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,458,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,459,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,460,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,461,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,462,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,463,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,464,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,465,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,466,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,467,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,468,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,469,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,470,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,471,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,472,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,473,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,474,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,475,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,476,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,477,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,478,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,479,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,480,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,481,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,482,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,483,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,484,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,485,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,486,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,487,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,488,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,489,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,490,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,491,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,492,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,493,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,494,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,495,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,496,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,497,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,498,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,499,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,500,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,501,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,502,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,503,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,504,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,505,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,506,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,507,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,508,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,509,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,510,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,511,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,512,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,513,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,514,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,515,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,516,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,517,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,518,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,519,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,520,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,521,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,522,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,523,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,524,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,525,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,526,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,527,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,528,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,529,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,530,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,531,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,532,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,533,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,534,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,535,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,536,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,537,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,538,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,539,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,545,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,546,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,547,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,548,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,549,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,550,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,551,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,552,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,553,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,554,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,555,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,556,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,557,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,558,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,559,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,560,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,561,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,562,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,563,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,564,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,565,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,566,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,572,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,573,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,574,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,575,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,576,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,577,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,578,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,579,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,580,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,581,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,582,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,583,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,584,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,585,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,586,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,587,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,588,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,589,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,590,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,595,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,596,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,597,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,598,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,599,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,600,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,601,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,602,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,603,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,604,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,605,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,606,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,607,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,608,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,609,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,610,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,611,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,612,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,613,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,614,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,615,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,616,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,617,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,618,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,619,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,620,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,621,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,622,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,623,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,624,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,625,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,626,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,627,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,628,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,629,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,630,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,813,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,867,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,988,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,631,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,632,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,633,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,634,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,749,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,978,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,635,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,636,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,637,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,638,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,639,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,777,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,979,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,640,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,641,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,642,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,643,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,644,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,653,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,981,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,645,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,646,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,647,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,648,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,649,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1003,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1004,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1005,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1006,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1007,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1008,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1009,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1010,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1011,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1012,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1013,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1017,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1018,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1019,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1020,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1021,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1022,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1023,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1024,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1025,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1026,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1027,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1028,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1029,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1030,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1031,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1032,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1033,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1034,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1035,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1036,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1037,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1038,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1039,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1040,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1041,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1042,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1043,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1044,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1045,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1046,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1050,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1051,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1052,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1053,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1054,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1055,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1056,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1057,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1058,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1059,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1060,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1061,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1062,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1063,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1064,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1065,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1066,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1067,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1068,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1069,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1070,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1074,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1075,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1076,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1077,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1078,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1079,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1080,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1081,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1082,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1086,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1087,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1088,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1089,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1090,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1091,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1092,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1093,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1094,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1095,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1096,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1097,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1098,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1099,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1100,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1101,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1102,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1103,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1104,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1105,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1106,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1107,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1108,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1109,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1110,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1111,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1112,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1113,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1114,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1115,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1116,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1117,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1118,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1119,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1120,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1121,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1122,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1123,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1124,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1125,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1126,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1127,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1128,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1129,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1130,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1131,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1132,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1133,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1134,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1135,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1136,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1137,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1138,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1139,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1140,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1141,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1142,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1143,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1144,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1145,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1146,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1147,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1148,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1152,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1153,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1154,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1155,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1156,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1157,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1158,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1159,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1160,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1161,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1162,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1163,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1164,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1165,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1166,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1167,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1168,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1169,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1170,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1171,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1172,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1173,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1174,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1175,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1176,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1177,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1178,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1179,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1180,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1181,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1182,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1183,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1184,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1185,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1186,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1187,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1188,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1189,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1190,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1191,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1192,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1193,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1194,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1195,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1196,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1197,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1198,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1199,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1200,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1201,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1202,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1203,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1204,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1205,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1206,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1207,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1208,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1209,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1210,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1211,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1212,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1213,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1214,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1215,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1216,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1217,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1218,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1219,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1220,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1221,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1222,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1223,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1224,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1225,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1226,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1227,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1228,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1229,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1230,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1231,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1232,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1236,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1237,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1238,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (84,1248,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (84,1249,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (84,1250,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1251,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1252,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1253,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1254,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1255,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1256,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1260,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1261,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1262,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1263,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1264,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1265,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1266,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1267,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1268,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1269,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1270,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1271,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1272,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1273,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1274,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1275,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1276,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1277,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1278,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1279,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1280,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1281,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1282,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1283,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1284,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1285,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1286,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1287,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1288,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1289,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1290,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1291,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1292,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,1293,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,1294,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,1295,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,1296,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,1297,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,1298,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,1299,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,1300,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,1301,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,1302,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,1303,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,1304,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,1305,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,1306,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,1307,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,1308,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,1309,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,1310,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,1311,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,1312,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,1313,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,1314,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,1315,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,1316,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,1317,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,1318,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,1319,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,1320,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,1321,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,1322,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,1323,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,1324,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,1325,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,1326,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,1327,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,1328,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,1329,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,1330,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,1331,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,1332,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,1333,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,1334,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,1335,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,1336,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,1337,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,1338,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,1339,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,1340,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,1341,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,1342,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,1343,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,1344,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,1345,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,1346,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,1347,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,1348,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,1349,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,1350,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,1351,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,1352,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,1353,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,1354,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,1355,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,1356,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,1357,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,1358,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,1359,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,1360,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,1361,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,1362,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,1363,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,1364,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,1365,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,1366,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,1367,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,1368,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,1369,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,1370,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,1371,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,1372,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,1373,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,1377,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,1378,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,1379,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,1380,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,1381,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,1382,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,1383,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,1384,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,1385,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,1386,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,1387,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,1388,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,1389,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,1390,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,1391,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,1395,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,1396,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,1397,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,1398,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,1399,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,1400,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,1401,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,1402,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,1403,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,1404,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,1405,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,1406,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,1410,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,1411,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,1412,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,1413,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,1414,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,1415,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (140,1416,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (140,1417,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (140,1418,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,1419,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,1420,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,1421,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,1422,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,1423,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,1424,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,1425,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,1426,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,1427,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,1428,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,1429,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,1430,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,1431,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,1432,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,1433,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,1434,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,1435,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,1436,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,1437,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,1438,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,1439,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,1440,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,1441,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,1442,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,1443,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,1444,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,1445,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1446,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1447,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1448,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1449,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1450,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1451,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1452,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1453,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1454,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1455,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1456,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1457,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1458,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1459,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (150,1460,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1476,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1477,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1478,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1479,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1480,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1481,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1482,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1483,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1484,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1485,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1486,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1487,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1488,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1489,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (152,1490,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1491,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1492,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1493,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1494,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1495,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1496,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1497,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1498,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1499,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1500,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1501,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1502,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1503,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1504,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (153,1505,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1506,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1507,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1508,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1509,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1510,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1511,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1512,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1513,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1514,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1515,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1516,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1517,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1518,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1519,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (154,1520,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1521,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1522,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1523,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1524,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (2,1525,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1526,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1527,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1528,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1529,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (3,1530,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1531,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1532,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1533,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1534,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (4,1535,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1536,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1537,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1538,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1539,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (5,1540,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (6,1541,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (6,1542,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (6,1543,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (6,1544,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (6,1545,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1546,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1547,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1548,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1549,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (7,1550,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1551,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1552,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1553,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1554,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (8,1555,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1556,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1557,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1558,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1559,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (9,1560,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1561,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1562,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1563,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1564,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (10,1565,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1566,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1567,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1568,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1569,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (11,1570,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1571,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1572,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1573,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1574,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (12,1575,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1576,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1577,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1578,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1579,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (13,1580,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1581,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1582,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1583,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1584,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (14,1585,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1586,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1587,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1588,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1589,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (15,1590,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1591,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1592,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1593,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1594,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (16,1595,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1601,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1602,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1603,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1604,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (18,1605,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1606,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1607,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1608,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1609,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (19,1610,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1611,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1612,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1613,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1614,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (20,1615,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1616,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1617,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1618,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1619,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (21,1620,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1621,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1622,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1623,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1624,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (22,1625,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1626,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1627,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1628,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1629,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (23,1630,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1631,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1632,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1633,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1634,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (24,1635,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1641,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1642,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1643,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1644,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (26,1645,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1646,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1647,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1648,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1649,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (27,1650,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1651,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1652,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1653,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1654,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (28,1655,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (29,1656,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (29,1657,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (29,1658,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (29,1659,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (29,1660,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1661,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1662,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1663,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1664,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (30,1665,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1666,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1667,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1668,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1669,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (31,1670,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1671,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1672,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1673,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1674,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (32,1675,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1676,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1677,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1678,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1679,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (33,1680,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1681,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1682,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1683,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1684,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (34,1685,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1686,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1687,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1688,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1689,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (35,1690,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1691,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1692,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1693,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1694,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (36,1695,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1696,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1697,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1698,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1699,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (37,1700,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1701,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1702,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1703,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1704,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (38,1705,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1706,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1707,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1708,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1709,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (39,1710,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1711,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1712,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1713,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1714,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (40,1715,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1716,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1717,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1718,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1719,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (41,1720,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1721,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1722,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1723,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1724,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (42,1725,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1726,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1727,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1728,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1729,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (43,1730,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1731,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1732,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1733,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1734,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (44,1735,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1736,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1737,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1738,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1739,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (45,1740,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1741,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1742,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1743,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1744,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (46,1745,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1746,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1747,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1748,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1749,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (47,1750,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1751,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1752,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1753,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1754,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (48,1755,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1756,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1757,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1758,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1759,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (49,1760,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1761,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1762,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1763,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1764,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (50,1765,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1771,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1772,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1773,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1774,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (52,1775,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1776,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1777,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1778,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1779,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (53,1780,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1781,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1782,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1783,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1784,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (54,1785,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1786,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1787,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1788,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1789,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (55,1790,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1791,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1792,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1793,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1794,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (56,1795,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1796,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1797,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1798,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1799,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (57,1800,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1801,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1802,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1803,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1804,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (58,1805,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1806,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1807,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1808,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1809,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (59,1810,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1811,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1812,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1813,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1814,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (60,1815,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1816,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1817,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1818,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1819,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (61,1820,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1821,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1822,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1823,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1824,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (62,1825,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1826,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1827,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1828,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1829,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (63,1830,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1831,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1832,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1833,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1834,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (64,1835,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1836,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1837,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1838,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1839,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (65,1840,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1841,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1842,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1843,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1844,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (66,1845,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1846,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1847,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1848,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1849,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (67,1850,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1851,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1852,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1853,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1854,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (68,1855,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1856,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1857,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1858,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1859,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (69,1860,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1861,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1862,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1863,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1864,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (70,1865,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1866,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1867,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1868,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1869,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (71,1870,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1871,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1872,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1873,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1874,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (72,1875,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1876,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1877,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1878,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1879,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (73,1880,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1881,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1882,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1883,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1884,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (74,1885,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1886,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1887,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1888,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1889,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (75,1890,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1891,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1892,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1893,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1894,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (76,1895,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1896,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1897,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1898,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1899,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (77,1900,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1901,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1902,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1903,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1904,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (78,1905,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1911,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1912,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1913,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1914,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (80,1915,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1931,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1932,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1933,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1934,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (85,1935,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1936,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1937,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1938,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1939,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (86,1940,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1946,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1947,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1948,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1949,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (88,1950,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1951,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1952,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1953,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1954,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (89,1955,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1956,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1957,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1958,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1959,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (90,1960,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1961,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1962,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1963,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1964,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (91,1965,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1966,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1967,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1968,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1969,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (92,1970,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1971,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1972,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1973,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1974,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (93,1975,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1976,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1977,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1978,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1979,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (94,1980,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1981,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1982,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1983,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1984,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (95,1985,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1986,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1987,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1988,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1989,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (96,1990,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1991,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1992,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1993,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1994,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (97,1995,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1996,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1997,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1998,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,1999,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (98,2000,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,2001,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,2002,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,2003,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,2004,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (99,2005,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,2006,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,2007,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,2008,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,2009,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (100,2010,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,2011,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,2012,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,2013,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,2014,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (101,2015,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,2016,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,2017,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,2018,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,2019,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (102,2020,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,2021,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,2022,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,2023,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,2024,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (103,2025,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,2026,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,2027,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,2028,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,2029,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (104,2030,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,2031,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,2032,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,2033,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,2034,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (105,2035,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,2036,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,2037,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,2038,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,2039,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (106,2040,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,2041,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,2042,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,2043,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,2044,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (107,2045,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,2046,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,2047,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,2048,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,2049,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (108,2050,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,2051,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,2052,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,2053,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,2054,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (109,2055,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,2056,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,2057,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,2058,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,2059,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (110,2060,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,2061,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,2062,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,2063,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,2064,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (111,2065,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,2066,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,2067,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,2068,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,2069,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (112,2070,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,2071,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,2072,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,2073,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,2074,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (113,2075,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,2076,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,2077,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,2078,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,2079,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (114,2080,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,2081,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,2082,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,2083,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,2084,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (115,2085,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,2086,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,2087,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,2088,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,2089,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (116,2090,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,2091,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,2092,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,2093,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,2094,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (117,2095,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,2096,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,2097,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,2098,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,2099,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (118,2100,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,2101,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,2102,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,2103,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,2104,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (119,2105,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,2106,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,2107,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,2108,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,2109,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (120,2110,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,2111,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,2112,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,2113,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,2114,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (121,2115,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,2116,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,2117,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,2118,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,2119,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (122,2120,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,2121,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,2122,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,2123,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,2124,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (123,2125,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,2126,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,2127,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,2128,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,2129,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (124,2130,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,2131,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,2132,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,2133,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,2134,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (125,2135,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,2141,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,2142,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,2143,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,2144,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (127,2145,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,2146,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,2147,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,2148,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,2149,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (128,2150,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,2151,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,2152,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,2153,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,2154,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (129,2155,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,2156,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,2157,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,2158,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,2159,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (130,2160,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,2161,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,2162,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,2163,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,2164,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (131,2165,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,2171,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,2172,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,2173,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,2174,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (133,2175,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,2176,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,2177,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,2178,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,2179,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (134,2180,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,2181,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,2182,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,2183,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,2184,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (135,2185,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,2186,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,2187,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,2188,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,2189,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (136,2190,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,2196,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,2197,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,2198,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,2199,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (138,2200,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,2201,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,2202,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,2203,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,2204,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (139,2205,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,2206,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,2207,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,2208,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,2209,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (141,2210,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,2211,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,2212,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,2213,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,2214,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (142,2215,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,2216,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,2217,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,2218,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,2219,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (143,2220,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,2221,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,2222,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,2223,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,2224,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (144,2225,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,2226,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,2227,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,2228,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,2229,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (145,2230,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,2231,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,2232,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,2233,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,2234,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (146,2235,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,2236,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,2237,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,2238,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,2239,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (147,2240,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,2241,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,2242,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,2243,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,2244,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (148,2245,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2246,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2247,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2248,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2249,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2250,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2251,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2252,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2253,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2254,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2255,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2256,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (149,2257,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2258,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2259,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2260,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2261,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2262,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2263,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2264,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2265,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2266,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2267,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2268,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2269,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2270,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2271,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (155,2272,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2273,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2274,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2275,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2276,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2277,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2278,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2279,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2280,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2281,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2282,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2283,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2284,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2285,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2286,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (156,2287,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2288,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2289,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2290,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2291,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2292,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2293,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2294,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2295,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2296,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2297,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2298,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2299,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2300,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2301,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (157,2302,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2303,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2304,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2305,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2306,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2307,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2308,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2309,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2310,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2311,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2312,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2313,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2314,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2315,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2316,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1070,2317,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2318,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2319,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2320,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2321,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2322,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2323,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2324,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2325,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2326,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2327,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2328,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2329,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2330,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2331,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1080,2332,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2333,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2334,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2335,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2336,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2337,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2338,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2339,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2340,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2341,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2342,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2343,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2344,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2345,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2346,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1090,2347,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2348,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2349,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2350,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2351,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2352,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2353,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2354,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2355,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2356,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2357,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2358,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2359,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2360,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2361,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1100,2362,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2363,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2364,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2365,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2366,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2367,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2368,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2369,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2370,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2371,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2372,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2373,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2374,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2375,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2376,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1110,2377,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2378,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2379,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2380,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2381,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2382,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2383,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2384,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2385,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2386,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2387,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2388,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2389,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2390,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2391,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1120,2392,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2393,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2394,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2395,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2396,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2397,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2398,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2399,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2400,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2401,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2402,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2403,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2404,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2405,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2406,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1130,2407,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2408,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2409,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2410,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2411,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2412,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2413,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2414,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2415,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2416,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2417,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2418,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2419,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2420,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2421,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1140,2422,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2423,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2424,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2425,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2426,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2427,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2428,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2429,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2430,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2431,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2432,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2433,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2434,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2435,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2436,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1150,2437,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2438,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2439,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2440,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2441,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2442,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2443,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2444,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2445,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2446,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2447,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2448,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2449,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2450,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2451,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1160,2452,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2453,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2454,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2455,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2456,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2457,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2458,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2459,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2460,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2461,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2462,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2463,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2464,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2465,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2466,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1170,2467,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2468,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2469,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2470,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2471,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2472,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2473,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2474,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2475,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2476,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2477,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2478,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2479,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2480,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2481,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1180,2482,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2483,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2484,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2485,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2486,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2487,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2488,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2489,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2490,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2491,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2492,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2493,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2494,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2495,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2496,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1190,2497,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2498,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2499,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2500,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2501,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2502,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2503,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2504,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2505,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2506,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2507,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2508,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2509,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2510,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2511,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1200,2512,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2513,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2514,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2515,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2516,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2517,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2518,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2519,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2520,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2521,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2522,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2523,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2524,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2525,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2526,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1210,2527,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2528,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2529,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2530,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2531,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2532,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2533,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2534,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2535,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2536,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2537,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2538,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2539,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2540,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2541,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (1220,2542,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2543,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2544,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2545,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2546,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2547,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2548,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2549,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2550,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2551,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2554,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2555,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2556,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2557,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2552,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (158,2553,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2558,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2559,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2560,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2561,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2562,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2563,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2564,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2565,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2566,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2567,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2568,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2569,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2570,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2571,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (159,2572,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2573,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2574,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2575,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2576,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2577,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2578,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2579,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2580,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2581,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2582,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2583,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2584,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2585,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2586,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (160,2587,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2588,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2589,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2590,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2591,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2592,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2593,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2594,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2595,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2596,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2597,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2598,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2599,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2600,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2601,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (161,2602,15);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2603,1);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2604,2);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2605,3);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2606,4);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2607,5);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2608,6);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2609,7);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2610,8);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2611,9);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2612,10);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2613,11);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2614,12);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2615,13);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2616,14);
INSERT INTO "persona" ("bib_id","per_id","cargo") VALUES (162,2617,15);
--
-- Data for TOC Entry ID 65 (OID 3235394)
--
-- Name: rechumanos Type: TABLE DATA Owner: israeld
--


INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (144,'0','0','0','0',NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (70,'0','0','0','0','*Informacin (No tiene personal adscrito) (Censo 2003)','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (142,'0','0','0','0','*Informacin integrada en BCCT','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (143,'0','0','0','0','*Informacin integrada en BCCT','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (146,'0','0','0','0','*Informacin integrada en BCCT','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (141,'0','0','0','0','*Informacin integrada en BCCT','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (19,'1','5','0','6','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (40,'0','47','0','47','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (39,'0','32','0','32','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (43,'2','37','0','39','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (42,'0','49','0','49','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (41,'2','49','0','51','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (99,'0','3','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (100,'0','20','0','20','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (103,'1','17','0','18','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (104,'0','19','0','19','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (105,'2','21','0','23','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (106,'1','27','0','28','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (107,'0','13','0','13','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (108,'1','31','0','32','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (101,'1','18','0','19','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (102,'0','27','0','27','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (8,'0','13','0','13','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (9,'0','10','0','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (148,'2','14','0','16','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (7,'1','85','0','86','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (96,'6','21','0','27','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (135,'0','26','0','26','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (10,'6','24','1','31','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (11,'1','2','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (32,'1','9','0','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (60,'3','28','0','31','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (35,'6','58','0','64','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (15,'6','41','0','47','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (16,'0','17','0','17','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (44,'1','63','0','64','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (133,'3','48','0','51','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (33,'2','10','0','12','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (4,'18','45','9','72','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (36,'2','17','0','19','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (37,'7','32','0','39','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (95,'2','41','0','43','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (138,'2','33','0','35','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (139,'1','31','0','32','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (59,'4','45','0','49','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (65,'1','30','0','31','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (67,'0','8','1','9','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (66,'2','18','0','20','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (68,'2','35','0','37','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (80,'3','28','0','31','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (85,'0','8','0','8','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (122,'2','51','0','53','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (145,'0','2','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (69,'0','0','0','0','*Informacin (No tiene personal adscrito a la Biblioteca) (Censo 2004)','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (134,'0','0','0','0','*Informacin (No tiene personal adscrito a la Biblioteca) (Censo 2004)','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (13,'9','17','0','26','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (57,'0','0','0','0','*Informacin (No tiene personal adscrito a la Biblioteca) (Censo 2004)','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (97,'0','17','0','17','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (98,'0','8','0','8','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (127,'7','27','0','34','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (128,'5','14','0','19','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (110,'1','64','0','65','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (113,'0','8','0','8','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (112,'0','5','0','5','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (114,'0','13','0','13','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (30,'2','4','0','6','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (73,'1','1','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (72,'0','2','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (24,'1','3','0','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (77,'1','3','0','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (123,'1','8','1','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (2,'1','2','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (3,'1','1','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (54,'5','10','1','16','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (55,'0','1','0','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (56,'0','0','0','0','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (115,'0','0','0','0','No envi censo','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (116,'2','1','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (117,'1','0','0','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (120,'2','5','1','8','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (18,'1','3','0','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (71,'4','8','0','12','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (23,'2','5','0','7','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (74,'4','5','1','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (88,'0','1','0','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (91,'3','0','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (86,'4','8','0','12','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (20,'4','8','0','12','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (76,'2','11','0','13','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (78,'3','4','0','7','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (147,'1','1','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (34,'1','4','0','5','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (118,'1','5','0','6','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (21,'3','3','0','6','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (22,'2','8','0','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (92,'4','2','0','6','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (58,'2','2','0','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (94,'2','1','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (27,'6','6','0','12','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (5,'10','9','5','24','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (93,'3','7','0','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (14,'8','5','0','13','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (63,'5','13','0','18','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (61,'4','6','0','10','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (62,'4','7','0','11','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (45,'11','29','0','40','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (46,'1','4','0','5','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (52,'4','9','0','13','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (90,'0','2','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (125,'2','1','1','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (124,'0','1','0','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (31,'7','4','0','11','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (119,'1','3','0','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (121,'0','0','1','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (48,'1','1','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (38,'0','0','1','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (136,'0','3','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (64,'0','11','1','12','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (47,'0','2','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (12,'26','137','7','170','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (26,'7','9','5','21','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (109,'0','3','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (49,'0','5','0','5','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (129,'1','7','1','9','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (131,'1','1','0','2','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (130,'1','0','0','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (89,'0','0','0','0','','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (50,'0','4','0','4','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (53,'0','6','0','6','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (150,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (153,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (154,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (155,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (75,'0','4','1','5','* Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (156,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (157,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (28,'1','2','0','3','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1070,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1080,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1090,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1100,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1110,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1120,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1130,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1140,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1150,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1160,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1170,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1180,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1190,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1200,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1210,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (1220,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (158,'1','0','0','1','*Informacin Censo 2004','');
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (159,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (160,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (161,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (162,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "rechumanos" ("bib_id","academicos","admvos","honorarios","total","observaciones","rechum_obs") VALUES (111,'0','0','0','0','0','');
--
-- Data for TOC Entry ID 66 (OID 3235400)
--
-- Name: servicio Type: TABLE DATA Owner: israeld
--


INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1070,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1080,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1090,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1100,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1110,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1120,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1130,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1140,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1150,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1160,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1170,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1180,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1190,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1200,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1210,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (1220,'No existe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (97,'Lun.-Vie. 8:00 a 20:00 hrs. Sb. de 10:00 a 14:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis','Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$Elaboracin de bibliografas$  Sala de computadoras$ Fotocopiado (Servicio concesionado)$  ','','','','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','*Informacin prstamo interno (No disponible Censo 2002 y 2003)$Prstamo interno (N.D.)$Prstamo externo (N.D.)$Prstamo interbibliotecario (396 vols.)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (28,'Lun. a Jue. de 10:00 a 18:30 hrs.$Vie. de 10:00 a 17:00 hrs.','Estanteria mixta','Libros $Publicaciones peridicas $Audiovisuales','Alerta bibliogrfica$Archivo Histrico de exposiciones de arte$Referencia bibliogrfica$Hemeroteca$Fotocopiado$Red Inalmbrica Universitaria$Catlogos de exposiciones MUAC, Catlogos de exposiciones MUCA de 1960 a 2008','','','','Interno$ Externo$Interbibliotecario','','Si','SI','','enlace al catlogo http://132.247.192.251:8991/F/-/?func=find-b-0&local_base=L3001','Estanteria cerrada: Archivo historico');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (113,'Lun.-Vie. 8:30 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Conexin inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a revistas electrnicas$ Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio propio)$Fotocopiado (Servicio con tarjeta electrnica)$','','','','Interno$Externo$Interbibliotecario','Instruccin a usuarios individual','Si','Si','','Las mquinas de escribir mecnicas ya  no se solicitan, pero pueden usarse junio2013','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (114,'Lun.-Vie. 8:30 a 19:50 hrs.','Estantera abierta','Publicaciones peridicas','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a Scifinder$Consulta a revistas electrnicas$Fotocopiado (Servicio propio)$Fotocopiado (Servicio con tarjeta electrnica)$Obtencin de documentos$Sala de computadoras$','','','','Interno$Interbibliotecario','Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (111,'Lun. a Vie. de 8:30  a  20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Conexin inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a bases de datos en lnea$Consulta a Nuevas adquiciones$Consulta a revistas electrnicas$ Fotocopiado (Servicio propio)$ Fotocopiado (Autoservicio con tarjeta electrnica)$Obtencin de documentos$','','','','Interno$Externo$Interbibliotecario','Instruccin a usuarios colectiva$','Si','Si','','Nuevo espacio traslado de biblioteca al edificio F,  lugar donde antiguamente se encontraba la Biblioteca del Instituto de Biomdicas. Febrero 2014 ','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (145,' Lun. a Vie. de 11:00 a 18:30 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$Fotocopiado (Servicio propio)$Obtencin de documentos','','','','Interno$Externo','Individual$Colectiva','No','No','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (134,'Lun. a  Jue. de 13:30 a 15:00 hrs. y de 15:30 a 20:00 hrs. Vie. de 13:30 a 15:00 hrs. y de 15:30 a 19:30 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Fotocopiado (Servicio concesionado)$','','','','Interno$Externo$','','No','No','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (57,'Lun. a Vie. de 8:00 a 14:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','','','','','Interno','Instruccin a usuarios individual','No','No','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (69,'Lun. a Vie. de 9:00 a 15:00 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','','','','','Interno','','No','No','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (98,'Lun. a Vie. 7:30 a 19:30 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Abstracts o resmenes$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Sala de computadoras$ Fotocopiado (Servicio concesionado)$Renovacin de prstamo (8:00 a 23 hrs. de lun. a dom.)','','','','Interno$Externo$Interbibliotecario','Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (2,'Lun. a Jue. de 9:00 a 18:30 hrs.$ Viernes 9:00 a 18:00 hrs. ','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y boletn de Nuevas adquisiciones$Consulta a bases de datos en lnea$ Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de Bibliografias$Obtencin de documentos$Fotocopiado$','','','','Interno$ Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (144,'Lun. a Vie. de 8:00 a 18:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica$Consulta a bases de datos en lnea$Consulta de libros electrnicos$Consulta a revistas electrnicas$Obtencin de documentos','','','BIBLIOTECA QUE NO CUENTA CON EDIFICIO PROPIO, EL SERVICIO QUE PROPORCIONA ES EN LINEA','Interno$Externo$Interbibliotecario','','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (77,'Lun. a Vie. de 8:30 a 20:30 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$ Consulta a libros electrnicos$ Consulta a revistas electrnicas$Cubculo de estudio$Diseminacin Selectiva de Informacin$Obtencin de documentos$','','','','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin de usuarios$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (55,'Lun. a Vie. de 9:30 a 16:30 hrs.','Estantera cerrada','Libros$Publicaciones peridicas$Tesis','Obtencin de documentos ','','','','Interno$Externo','Desarrollo de habilidades informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (30,'Lun. a Vie. de 8:00 a 18:00 hrs.','Estanteria mixta (Abierta a usuarios internos y Cerrada a usuarios externos)','Libros$Publicaciones peridicas$Tesis','Alerta bibliogrfica y/o alerta previa $Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin $Obtencin de documentos $Fotocopiado (Servicio propio) $','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (40,'Lun. a Vie.  de 8:30 a 20:30 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Conexin inalmbrica a Internet$Consulta a bases de datos en CDROM$Fotocopiado (Servicio concesionado)$  ','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','No','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (156,'Lun. a Vie. de 9:00 a 15:00 hrs. y de 17:00 a 19:00 hrs.','Estanteria abierta','','Alerta bibliogrfica$Cubculo de estudio','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (20,'Lun. a Vie. de 9:00  a  19:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Anlisis de citas$Boletines de Nuevas adquisiciones y Alerta bibliogrfico$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin$Fotocopiado (Autoservicio)$Obtencin de documentos (solo usuarios internos)$','','','','Interno$Externo$ Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (88,'Lun. a Vie. de 8:00 a 14:30 hrs. (Horario local)','Estantera cerrada','Libros$Publicaciones peridicas$Tesis','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$ Obtencin de documentos$ Fotocopiado (Servicio propio)$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','','El horario tiene una hora de diferencia, ejem. Distrito Federal: 9:00 am. Hermosillo: 8:00 am','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (115,'Lun. a Vie. de 9:00 a 15:00 y de 17:00 a 20:00 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','','Consulta a libros electrnicos$Consulta a revistas electrnicas','','','','Interno','','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (78,'Lun. a Vie. de 8:30 a 20:30 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis','Anlisis de citas$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio y concesionado)$Obtencin de documentos','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (147,'Lun. a Vie. de 8:30 a 18:00 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Fotocopiado (Servicio propio solo para usuarios internos)$Obtencin de documentos$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (91,'Lun. a Vie. de 9:00 a  19:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Alerta bibliogrfica$Alerta hemerogrfica$Anlisis de citas$Consulta a bases de datos en lnea$Consulta de libros electrnicos$Consulta de revistas electrnicas$Cubculo de estudio$Diseminacin Selectiva de la Informacin$Fotocopiado (Servicio Propio)$Obtencin de documentos$Reproduccin de material documental (Servicio propio de escaneo)$','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (72,'Lun. a Jue. de 8:30 a 20:15 hrs. Vie. de 8:30 a 19:30 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: En las instalaciones de esta Biblioteca se encuentra funcionando temporalmente la biblioteca del Centro de Ciencias Genmicas$$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Equipo de cmputo para consulta$Fotocopiado (Servicio propio)$Obtencin de documentos$','','','','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Orientacin de usuarios','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (120,'Lun. a Vie. de 9:00 a 19:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio propio y autoservicio)$ ','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (118,'Lun. a Vie. de 9:00 a 21:00 hrs. (Usuarios internos) $Lun. a Vie. de 10:00 a 17:00 hrs. (Usuarios externos)','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Fotocopiado (Servicio propio y autoservicio)$Obtencin de documentos$Sala de computadoras$ ','Chemische Berichte desde (1868)$ Angewandte fr chemie desde (1887)$Chemical Abstracts desde (1907)','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','En junio 2014 tuvo inventario. El autoservicio de fotocopiado es con tarjeta de prepago.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (92,'Lun. a Vie. de 8:30 a 16:30 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$','','','','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (21,'Lun. a Vie. de 9:00 a 18:00 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la informacin$Elaboracin de bibliografas$Obtencin de documentos$  ','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (90,'Lun. a Jue. de 8:30 a 18:15 hrs. Vie. de 8:30 a 17:30 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Fotocopiado (Servicio propio)$Obtencin de documentos$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$','Si','No','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (94,'Lun. a Vie. de 9:00 a 18:00 hrs.','Estantera mixta (Abierta a usuarios internos y Cerrada a usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Obtencin de documentos$  ','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (62,'Lun. a Vie. de 9:00 a 19:00 hrs.','Estanteria mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$ Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Otros: Escaneo de microformatos$','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (125,'Lun. a Jue. de 9:00 a 18:00 hrs. Vie.  de 9:00 a 17:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Anlisis de citas$Alerta bibliografia y/o alerta previa$Conexin inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta de libros electrnicos$Consulta de revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Equipo de cmputo para consulta$Obtencin de documentos$  ','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (157,'Lun. a  Vie. de 9:00 a 15:00 y de 17:00 a  19:00 hrs.','Estanteria abierta','','Alerta bibliografica y/o alerta previa$Cubiculo de estudio grupal$Equipo de cmputo para consulta$Obtencin de documentos','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (71,'Lun. a Vie. de 8:00 a 20:00 hrs.','Estanteria mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas $Tesis','Anlisis de  citas$Conexin inalmbrica a Internet$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$ Obtencin de documentos$ Fotocopiado (Servicio propio)$','','','','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (23,'Lun. a Vie. de 8:00 a 20:00 hrs. (Usuarios externos)$Lun. a Dom. las 24 hrs. (Usuarios internos)','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Conexin inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio)$ Fotocopiado (Autoservicio con tarjeta electrnica)$ Obtencin de documentos$Sala de computadoras','','','','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (117,'Lun. a Vie. de 9:00 a 17:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$Conexin inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Obtencin de documentos$ Fotocopiado (Servicio propio)$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','Si','cambio de servicios segun lo enviado por nueva responsable 2.9.14 DPLybf','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (54,'Lun. a  Vie. de 9:00 a 21:00 hrs. (Usuarios internos)$Lun. a Vie. de 9:00 a 19:00 hrs.(Usuarios externos)','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Consulta a libros electrnicos$Consulta a revistas electrnicas$Disponibilidad de equipo de cmputo y escaner$Elaboracin de bibliografas$ Obtencin de documentos$ Fotocopiado (Servicio propio)$ Fotocopiado (Servicio con tarjeta electrnica)$Otros: Envo de documentos va electrnica$','','','','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','No','Estanteria abierta para personal acadmico. Cerrada para usuarios externos','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (56,'Lun. a Jue. de 9:00 a 15:00 y de 16:00 a 19:00 hrs.$Vie. de 9:00 a 14:30 y de 16:00 a 18:30 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis','Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Fotocopiado (Servicio concesionado)$  ','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','','Cambio de espacio: rea de lectura igual, estanteria menos espacio 2012-2013. Inauguracin agosto 2013.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (3,'Lun. a Dom. 24 horas (Usuarios internos)$Lun. a Jue. 8:30 a 15:00 hrs. $Vie. 8:30 a 14:30 hrs. (Usuarios externos) (Hora local)','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Conexin inalmbrica a Internet $Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Fotocopiado (Autoservicio con tarjeta)$Obtencin de documentos$Reservacin de material para cursos$','','','','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Instruccin a usuarios individual$Orientacin de usuarios$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','Existe una diferencia de horario: Ensenada registra 10:00 am, el Distrito Federal registra 12:00 pm ');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (73,'Lun. a Jue. de 9:00 a 19:40 hrs. $Vie. de 9:00 a 19:00 hrs.(Hora local)','Estantera abierta','Libros$Publicaciones peridicas$Tesis','Boletn de Nuevas Adquisiciones$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Fotocopiado (Autoservicio)','','','','Interno$Externo$Renovacin de prstamo de libros va WEB$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','Diferencia de horario por dos horas: Ensenada: 11:00 am, Distrito Federal: 13:00 pm','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (158,'Lun. a Vie. de 10:00 a 18:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Alerta bibliogrfica y/o alerta previa$ Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$  Obtencin de documentos$Fotocopiado (Servicio propio)$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (24,'Lun. a  Vie. de 8:00 a 18:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','La biblioteca del Centro de Ciencias Genmicas e Instituto de Biotecnologia funciona temporalmente en las instalaciones de la biblioteca del Instituto de  Ciencias Fsicas $$Alerta bibliogrfica$Computadoras para usuario$Conexin inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de la Informacin$Fotocopiado (Servicio propio y de autoservicio)$Obtencin de documentos$','','HERMES$Current Protocols$Encyclopedia of Life Sciences$Ergito$Life Sciences of Wiley','','Interno$Externo$Renovacin de prstamo de libros via Web $Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (76,'Lun. a Vie. de 8:30 a 20:30 hrs.','Estanteria mixta (Abierta en libros y Cerrada en publicaciones peridicas)','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Anlisis de citas$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio y de autoservicio)$Obtencin de documentos','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','Si','Fotocopiado de autoservicio con tarjeta de prepago','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (74,'Lun. a Vie. de 9:00 a 21:30 hrs.$Sb. de 8:30 a 14:00 hrs.','Estanteria mixta (Abierta en libros y revistas y Cerrada para cartografia, audivisual y digital) ','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Cubculo de estudio$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Diseminacin Selectiva de informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio y de autoservicio)$Obtencin de documentos$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (86,'Lun. a  Jue. de 9:00 a 20:00 hrs.$ Vie. de 9:00 a 17:30 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis','Alerta bibliogrfica$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Equipo de cmputo para consulta$Obtencin de documentos$Fotocopiado (Servicio propio y de autoservicio)$','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (31,'Lun. a Vie. de 8:30 a 19:30 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Audiovisuales','Conexin inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$Diseminacin Selectiva de Informacin$Fotocopiado (Autoservicio) ','','','','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario$Especial','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (154,'Lun. a Vie.  de 8:30 a 15:00 hrs. y de 15:30 a 20:00 hrs.','Estantera mixta (Abierta para Acervo general y Cerrada para Fondo Reservado)','','Alerta bibliogrfica y/o alerta previa$Anlisis de citas$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Equipo de cmputo para consulta$Fotocopiado (Servicio propio)$Obtencin de documentos$Reproduccin por digitalizacin de documentos histricos','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','','','','Anexo a la biblioteca se encuentra el espacio de fondo reservado con estantera cerrada atendida por Tec. Aca. Lic. Bruno Euan. 22/05/2013. DPLybf','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (5,'Lun. a Vie. de 9:00  a  19:30 hrs.','Estanteria mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis','Alerta bibliogrfica y/o alerta previa$Anlisis de citas$Conexin inalmbrica a Internet$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio propio$Escaneo de documentos (autoservicio) ','','Human Relations Area File (Base de datos en lnea slo dentro del Instituto)','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (14,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera mixta (Abierta para usuarios internos  y Cerrada a usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a  revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio propio y de autoservicio)','','Base de datos BEXART','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (161,'Lun. a Vie. de 9:00 a 18:00 hrs','Estantera cerrada','','Fotocopiado (Servicio propio)$','','','','Interno','Orientacin de usuarios$Visitas guiadas$','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (93,'Lun. a Vie. de 8:30 a 18:00 hrs. ','Estantera abierta','Libros $Publicaciones peridicas','Alerta bibliogrfica y/o alerta previa$Anlisis de citas$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Equipo de cmputo para consulta$Fotocopiado (Autoservicio con clave de acceso)$Obtencin de documentos$Escner e impresin de documentos ','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (61,'Lun. a Vie. de 8:30 a 20:30 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada a usuarios externos)','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$Anlisis de citas$Conexin inalmbrica a Internet$Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio y de autoservicio)$Mediateca$Obtencin de documentos$  ','','FILOS$The Philosophers Index ','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin a usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (22,'Lun. a Vie. de 9:00 a 19:00 hrs.','Estanteria mixta (Abierta en libros y Cerrada en publicaciones peridicas)','Libros$Publicaciones peridicas$Tesis','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$  ','','Banco de datos IRESIE','','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (116,'Lun. a Vie. de 9:00 a 18:00 hrs. (horario local)                            ','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$ Conexin inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Elaboracin de bibliografas$Obtencin y digitalizacin de articulos cientificos$ Fotocopiado (Servicio propio)','','','','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Sin RIU para conexin inalmbrica, es por Nextel','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (148,'Lun. a Jue. 7:30 a 20:30 hrs. $Vie. 7:30 a 20:00 hrs.','Estantera mixta (Abierta para acervo general y Cerrada para reserva, hemeroteca y tesis)','Libros $Publicaciones peridicas $Tesis$ Audiovisual','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$Obtencin de documentos$  Fotocopiado (Servicio concesionado)$  ','','','','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','Estanteria abierta: acervo general y de consulta. Estanteria cerrada: reserva, hemeroteca y tesis','edificio con reinauguracin marzo 2010');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (10,'Lun. a  Vie. 9:00 a 20:00 hrs.','Estantera mixta (Abierta en libros, consulta, tesis y Cerrada en hemeroteca y archivos)','Libros $Publicaciones peridicas $Tesis $Audiovisuales','NOTA: Las Bibliotecas de la Facultad de Artes y Diseo y Facultad de Arquitectura comparten una coleccin de libros con temas especializados que ponen a disposicin del pblico a travs del catlogo del Centro de Informacin de Arte, Diseo y Arquitectura (CIADA)$Alerta bibliogrfica y/o alerta previa$Conexin inalmbrica a Internet$Consulta a libros electrnicos$Consulta de revistas electrnicas$Fotocopiado (Servicio concesionado)$Equipo de cmputo para consulta$Archivo de la Academia de San Carlos$Archivo de Arquitectos mexicanos$Diapositeca de arquitectura$Mapoteca de INEGI$Mediateca','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','Estanteria abierta: libros, consulta, tesis. Cerrada: hemeroteca y archivos','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (32,'Lun. a Vie. 9:00 a 21:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$Consulta a revistas electrnicas$Obtencin de documentos','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (11,'Lun. a Jue. 9:00 a 20:00 hrs.$Vie. 9:00 a 19:00 hrs','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Fotocopiado (Servicio propio)$','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (70,'Lun. a Jue. de 9:00 a 15:30 y  Vie. de 9:00 a 15:00 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Tesis','','','','Fotocopiado (Servicio propio)','Interno$Externo','','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (95,'Lun. a Vie. 8:00 a 20:00 hrs.$Sb. 8:00 a 14:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Consulta a tesis digitales$Elaboracin de bibliografas$Sala de equipo de cmputo$Fotocopiado (Servicio concesionado)$  ','','','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Consulta a tesis digitales$Elaboracin de bibliografas$Sala de equipo de cmputo$Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin a usuarios$Visitas guiadas$','Si','Si','','Horario de sbados es todo el ao escolar','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (139,'Lun. a Vie. de 8:30 a 19:45 hrs. $Sb. de 9:00 a 14:30 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Conexin Inalmbrica a Internet$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos$Fotocopiado (Servicio concesionado)$Hemeroteca$Mapoteca$  ','','','Conexin Inalmbrica a Internet$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos$Fotocopiado (Servicio concesionado)$Hemeroteca$Mapoteca$  ','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (136,'Lun. a Jue. de 9:00 a 18:45 hrs.$Vie. de 9:00 a 18:30 hrs.','Estantera abierta','Libros$Publicaciones peridicas','Alerta bibliogrfica y/o alerta previa$ Consulta a bases de datos en lnea$ Fotocopiado (Servicio concesionado)$','','','Alerta bibliogrfica y/o alerta previa$ Consulta a bases de datos en lnea$ Fotocopiado (Servicio concesionado)$','Interno$Externo$Interbibliotecario','','Si','Si','','Ampliacin de la biblioteca del 2 de marzo a 16 de agosto de 2015.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (129,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones Peridicas $Audiovisuales','Alerta bibliogrfica y/o alerta previa $Conexin Inalmbrica a Internet$Consulta a bases de datos en lnea $Consulta a libros electrnicos $Consulta a revistas electrnicas $Elaboracin de bibliografas $Fotocopiado (Servicio concesionado)$Obtencin de docuemntos$Otros: prstamo de material audiovisual $Hemeroteca$','','','Alerta bibliogrfica y/o alerta previa $Conexin Inalmbrica a Internet$Consulta a bases de datos en lnea $Consulta a libros electrnicos $Consulta a revistas electrnicas $Elaboracin de bibliografas $Fotocopiado (Servicio concesionado)$Obtencin de docuemntos$Otros: prstamo de material audiovisual $Hemeroteca$','Interno$Externo$Interbibliotecario','Orientacin al usuario$','Si','Si','','Conexin inalmbrica a Internet atravs de RIU. DPLybf','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (49,'Lun. a Vie. de 9:00 a 15:00 hrs. y de 17:00 a 20:00 hrs. ','Estantera abierta','Libros$Publicaciones peridicas$Audiovisuales','Alerta bibliogrfica $Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$Fotocopiado (Servicio propio)$Obtencin de documentos','','','Alerta bibliogrfica $Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$Fotocopiado (Servicio propio)$Obtencin de documentos','Interno$Externo$Interbibliotecario','','Si','Si','','a travs de un Boletn de nuevas adquisiciones','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (15,'Lun. a Vie. de 8:00 a 20:45 hrs. $Sb de 8:00 a 13:45 hrs. (Horario en sbado slo en periodo semestral escolar)  ','Estantera mixta (Abierta para libros y tesis y Cerrada para revistas) ','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o Alerta previa$Consulta a bases de datos en lnea$ Consulta a libros electrnicos$ Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Cubculos de estudio$Fotocopiado (Servicio concesionado y de autoservicio)$ ','','','Alerta bibliogrfica y/o Alerta previa$Consulta a bases de datos en lnea$ Consulta a libros electrnicos$ Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Cubculos de estudio$Fotocopiado (Servicio concesionado y de autoservicio)$ ','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','Estantera abierta para libros y tesis. Estantera cerrada publicaciones periodicas','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (16,'Lun. a Vie. de 9:00 a 21:00 hrs.$Sb de 8:00 a 14:00 hrs.(Horario en sbado slo en periodo semestral escolar)','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$','','','Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (44,'Lun. a Vie. de 8:00 a 20:00 hrs.$Sb. de 8:00 a 16:00 hrs.','Estantera mixta','Libros $Publicaciones peridicas','Consulta a bases de datos en CDROM$Cubculos de estudio$ Elaboracin de bibliografas$ Fotocopiado (Servicio concesionado y autoservicio)$Otros: Bsquedas en internet$','','','Consulta a bases de datos en CDROM$Cubculos de estudio$ Elaboracin de bibliografas$ Fotocopiado (Servicio concesionado y autoservicio)$Otros: Bsquedas en internet$','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (133,'Lun. a Vie. 8:30 a 20:30 hrs.$Sb. de 9:00 a 14:00 hrs.','Estantera abierta ','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de  Informacin$Elaboracin de bibliografas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$','','','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de  Informacin$Elaboracin de bibliografas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (33,'Lun. a Vie. 8:00 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$ Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$  ','','','Alerta bibliogrfica y/o alerta previa$ Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (75,'Lun. a Jue. de 9:00 a 18:00 hrs.$Vie. de 9:00 a 17:30 hrs.','Estantera Cerrada','Libros$Publicaciones perodicas$Tesis','Archivo Histrico Lun. a Vie. de 9:00 a 15:00 hrs. y previa cita de 16:00 a 18:00 hrs. $Fotocopiado (Servicio propio)$Digitalizacin de documentos','','','Archivo Histrico Lun. a Vie. de 9:00 a 15:00 hrs. y previa cita de 16:00 a 18:00 hrs. $Fotocopiado (Servicio propio)$Digitalizacin de documentos','Interno','Orientacin de usuarios','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (80,'Lun. a Vie. de 8:00 a 20:00 hrs.$Sb. de 8:30 a 16:00 hrs.','Estantera abierta','Libros $Tesis','NOTA: En esta biblioteca se concentran los acervos y servicios$que se encontraban diseminados en las siguientes reas:$Hemerobiblioteca, Medicina familiar, Psicologa mdica, Psiquiatra, Salud mental y Salud pblica$$ Anlisis de citas$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Cubculos de estudio$Fotocopiado (Servicio propio y de Autoservicio)$Hemeroteca$Sala de computadoras','','','NOTA: En esta biblioteca se concentran los acervos y servicios$que se encontraban diseminados en las siguientes reas:$Hemerobiblioteca, Medicina familiar, Psicologa mdica, Psiquiatra, Salud mental y Salud pblica$$ Anlisis de citas$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Cubculos de estudio$Fotocopiado (Servicio propio y de Autoservicio)$Hemeroteca$Sala de computadoras','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (48,'Lun. a Jue. de 9:00 a 20:00 hrs.$ Vie. de 9:00 a 17:30 hrs.','Estantera abierta','Libros $Publicaciones peridicas','','','','','Interno$Externo$Interbibliotecario','','Si','Si','','Cambio a otro edificio en CU en agosto 2013.EL 1o DE AGOSTO 2012 SOLO SE PROPORCIONA SERVICIO A USUARIOS INTERNOS','Por oficio CUEC/BIB/034/15 de 6 nov de 2015.  Modificacin del horario de la biblioteca de acuerdo al articulo 34 de los transitorios del Reglamento de la B. Cuec se cambia el horario por falta de personal para cubrir el tiempo vespertino que era de 9 a 21 hrs. DPLybf 19 nov 2015.');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (162,'Lun. a Vie. de 9:00 a 20:00 hrs.','Mixto','','Equipo de cmputo para consulta$Escaneo de material','','','Equipo de cmputo para consulta$Escaneo de material','Interno$Externo$Interbibliotecario','Orientacin a usuarios','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (159,'Lun. a Vie. de 9:00 a 18:00 hrs.','Estantera abierta','','Alerta bibliogrfica y/o alerta previa$Conexin Inalmbrica a Internet$Cubculos de estudio$Diseminacin Selectiva de Informacin$Equipo de cmputo para consulta$Fotocopiado (Servicio concesionado)$Obtencin de documentos','','','Alerta bibliogrfica y/o alerta previa$Conexin Inalmbrica a Internet$Cubculos de estudio$Diseminacin Selectiva de Informacin$Equipo de cmputo para consulta$Fotocopiado (Servicio concesionado)$Obtencin de documentos','Interno$Externo','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (153,'Lun. a Vie. de 9:00 a 19:30 hrs.$Sb. de 9:00 a 12:00 hrs.','Estantera abierta','','Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Obtencin de documentos$  ','','','Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Obtencin de documentos$  ','Interno$Externo$Interbibliotecario','Orientacin a usuarios$Visitas guiadas$','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (85,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Tesis','Consulta a bases de datos en lnea$ Fotocopiado (Servicio propio)$','','','Consulta a bases de datos en lnea$ Fotocopiado (Servicio propio)$','Interno','Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (160,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera mixta ','','Boletin de nuevas adquisiciones$Consulta de libros electrnicos$Consulta de revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado','','','Boletin de nuevas adquisiciones$Consulta de libros electrnicos$Consulta de revistas electrnicas$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','','','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (47,'Lun. a Jue. de 9:45 a 14:30 hrs.$Vie. de 9:00 a 14:00 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Audiovisuales','Consulta a catlogo impreso$ Fotocopiado (Servicio propio)$','','','Consulta a catlogo impreso$ Fotocopiado (Servicio propio)$','Interno$Externo$Interbibliotecario','','Si','Si','','por el momento no se tiene catlogo en linea,  el acceso a  internet  est fallando. 13 junio 2012','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (53,'Lun. a Vie. de 9:00 a 20:30 hrs.','Estantera mixta','Libros $Publicaciones peridicas$Tesis$Audiovisuales','Fotocopiado (Servicio concesionado)  ','','','Fotocopiado (Servicio concesionado)  ','Interno$Externo$Interbibliotecario','','Si','Si','','Estanteria abierta en libros. Cerrada en videos y revistas. DPLybf','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (124,'Lun. a Jue. de 9:00 a 15:00 hrs. y de 16:00 a 18:00 hrs. Vie. de 9:00 a 17:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas','Elaboracin de bibliografas$Fotocopiado $Obtencin de documentos$Otros: Escaneo; Fotografa digital$','','','Elaboracin de bibliografas$Fotocopiado $Obtencin de documentos$Otros: Escaneo; Fotografa digital$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$','Si','Si','Si','Cambio de sede 2016 de Isabel la catlica a Repblica de Cuba.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (12,'Lun. a Dom. y das festivos de 8:30 a 21:30 hrs.','Combina estantera abierta  y cerrada','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos (Solicitar a  consulta@dgb.unam.mx)$Sala de computadoras$ Fotocopiado (Servicio concesionado)$Servicio bibliotecario para  personas discapacitadas (Dbiles visuales)','','LIBRUNAM$SERIUNAM$TESIUNAM$MAPAMEX$LIB@UNAM$TESIS@UNAM$Obras de Consulta$Revistas de Texto Completo$Bases de Datos Especializadas','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos (Solicitar a  consulta@dgb.unam.mx)$Sala de computadoras$ Fotocopiado (Servicio concesionado)$Servicio bibliotecario para  personas discapacitadas (Dbiles visuales)','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (26,'Lun.a Vie. de 8:00 a 16:00 hrs.','Estantera mixta (Abierta en libros y obras de consulta y Cerrada en publicaciones peridicas)','Libros $Publicaciones peridicas','Abstracts o resmenes$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos(Solicitar a: sinfo@dgb.unam.mx)$Sala de computadoras$Fotocopiado (Servicio propio)$Otros: Anlisis de citas; Bsquedas especializadas$','','CLASE$PERIODICA$HELA','Abstracts o resmenes$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos(Solicitar a: sinfo@dgb.unam.mx)$Sala de computadoras$Fotocopiado (Servicio propio)$Otros: Anlisis de citas; Bsquedas especializadas$','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (38,'Lun. a Jue. de 9:00 a 15:00 hrs y de 16:00 a 19:00 hrs.$ Vie de 9:00 a 15:00 hrs y de 16:00 a 18:00 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Audiovisuales','Fotocopiado (Suspendido por el momento)$','','','Fotocopiado (Suspendido por el momento)$','Interno$Externo$Interbibliotecario','','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (64,'Lun. a Jue. de 9:00 a 19:00 hrs. $Vie.  de 9:00 a 18:30 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Audiovisuales$Carteles$ Fotomontajes$Fotografias$Programas de mano$VHS$DVD$Hemerografa$ Base de datos en cd-rom$Press Kits$Guiones originales de peliculas$Ploters$Mantas publicitarias$Banderines$Programas de mano$Invitaciones$Postales','Abstracts o resmenes$ Consulta a bases de datos en CDROM$Diseminacin selectiva de la informacin$Digitalizacin$Videoteca$Obtencin de documentos$ Fotocopiado (Servicio propio)$','','','Abstracts o resmenes$ Consulta a bases de datos en CDROM$Diseminacin selectiva de la informacin$Digitalizacin$Videoteca$Obtencin de documentos$ Fotocopiado (Servicio propio)$','Interno$Interbibliotecario','Visitas guiadas$','Si','Si','','','Traslado de la biblioteca a Ciudad Universitaria antes se encontraban en Miguel Angel de Quevedo,  septiembre 2011');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (109,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estanteria abierta','Libros $Publicaciones peridicas$Audiovisuales','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Elaboracin de bibliografas$ Obtencin de documentos$ Fotocopiado (Servicio propio)$','','','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Elaboracin de bibliografas$ Obtencin de documentos$ Fotocopiado (Servicio propio)$','Interno$Externo$Interbibliotecario','Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','Estanteria abierta en libros, Cerrada en revistas y audiovisuales','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (119,'Lun. a Jue.  8:00  a 19:00 hrs. $ Vie. 8:00 a 17:00 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Diseminacin selectiva de la informacin$Elaboracin de bibliografas$ Obtencin de documentos$Fotocopiado (Servicio concesionado)$  ','','','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Diseminacin selectiva de la informacin$Elaboracin de bibliografas$ Obtencin de documentos$Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','Revistas y fondo reservado se encuentran bajo llave es estanteria cerrada, libros estanteria abierta','Remodelacin en 2 de junio a 19 octubre 2009');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (121,'Lun. a Vie. de 9:00 a 14:00 hrs. y de 15:00 a 18:30 hrs.','Estanteria mixta (Abierta y Cerrada) ','Libros $Publicaciones peridicas $Audiovisuales$Archivo Histrico','Consulta a bases de datos en lnea$Internet inlambrico$Sala de computadoras$ ','','','Consulta a bases de datos en lnea$Internet inlambrico$Sala de computadoras$ ','Interno$Externo','Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (123,'Lun. a Vie. de 9:00 a 18:00 hrs.$Sb., Dom. y das festivos de 10:00 a 17:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales$Colecciones especiales: INEGI, CONAPO, Libros antiguos, Cartas geogrficas','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Obtencin de documentos: correo namiriam@universum.unam.mx$Sala de Recursos electrnicos$Fotocopiado y escaneo (Servicio propio)$','','','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Obtencin de documentos: correo namiriam@universum.unam.mx$Sala de Recursos electrnicos$Fotocopiado y escaneo (Servicio propio)$','Interno$Externo$Interbibliotecario','Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (131,'Lun. a Vie. de 9:00 a 19:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Audiovisuales','Alerta bibliogrfica  a travs de Boletn de nuevas adquisiciones$ Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$Elaboracin de bibliografas$','','','Alerta bibliogrfica  a travs de Boletn de nuevas adquisiciones$ Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$Elaboracin de bibliografas$','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Instruccin a usuarios individual','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (130,'Lun. a Vie. de 9:00 a  20:00 hrs. ','Estantera abierta ','Libros$Publicaciones peridicas $Audiovisuales','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$ Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio)$','','','Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$ Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin selectiva de la informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio)$','Interno$Externo$Interbibliotecario','','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (27,'Lun. a  Vie. 8:30 a 20:00 hrs. ','Estantera mixta (Abierta para usuarios internos  y Cerrada a usuarios externos)','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio)$Obtencin de documentos$','','INFOBILA. Informacin y Bibliotecologa Latinoamericana','Alerta bibliogrfica$Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Fotocopiado (Servicio propio)$Obtencin de documentos$','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario ','Desarrollo de Habilidades Informativas$Orientacin de usuarios$','Si','Si','Si','cambio de horario, estanteria, servicios, prestamos 6nov12','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (43,'Lun. a Vie. de 7:30 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Conexin inalmbrica a Internet$Fotocopiado (Servicio concesionado)$Sala de computadoras$','','','Conexin inalmbrica a Internet$Fotocopiado (Servicio concesionado)$Sala de computadoras$','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (19,'Lun. a Vie.  de 8:00 a 18:00 hrs.','Estantera abierta','Libros','Conexin Inhalmbrica a Internet','','','Conexin Inhalmbrica a Internet','Interno$Externo$Interbibliotecario','Orientacin de usuarios ','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (42,'Lun. a Vie. de 8:00 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Alerta bibliogrfica y/o alerta previa$Conexin Inalmbrica a Internet$Fotocopiado (Servicio concesionado)  ','','','Alerta bibliogrfica y/o alerta previa$Conexin Inalmbrica a Internet$Fotocopiado (Servicio concesionado)  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (41,'Lun. a Vie. de 8:00 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Conexin Inalmbrica a Internet$Elaboracin de bibliografas$ Fotocopiado (Servicio concesionado)$  ','','','Conexin Inalmbrica a Internet$Elaboracin de bibliografas$ Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (39,'Lun. a Vie. de 7:00 a 20:00 hrs.','Estantera mixta (Abierta en libros y obras de consulta y Cerrada en publicaciones peridicas)','Libros $Publicaciones peridicas','Consulta a bases de datos en lnea$Fotocopiado (Servicio concesionado)$Sala de computadoras$  ','','','Consulta a bases de datos en lnea$Fotocopiado (Servicio concesionado)$Sala de computadoras$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (99,'Lun. a Vie. de 9:00 a 21:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','','','','','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (108,'Lun. a Vie. de 8:00 a 21:00 hrs. ','Estantera abierta','Libros $Publicaciones peridicas $Audiovisuales','Conexin Inalmbrica a Internet$Cubculos de estudio$Fotocopiado (Servicio concesionado)$','','','Conexin Inalmbrica a Internet$Cubculos de estudio$Fotocopiado (Servicio concesionado)$','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (101,'Lun. a Vie. de 8:00 a 21:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Audiovisuales','Conexin Inalmbrica a Internet$Fotocopiado (Servicio concesionado)$Prstamo de netbooks$  ','','','Conexin Inalmbrica a Internet$Fotocopiado (Servicio concesionado)$Prstamo de netbooks$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (112,'Lun. a Vie. 8:30 a 20:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica y/o alerta previa$Conexin inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a revistas electrnicas$Fotocopiado (Servicio propio)$Obtencin de documentos','','','Alerta bibliogrfica y/o alerta previa$Conexin inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a revistas electrnicas$Fotocopiado (Servicio propio)$Obtencin de documentos','Interno$Externo$Interbibliotecario','Instruccin a usuarios individual','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (96,'Lun. a Jue. 8:30 a 20:00 hrs.$Vie. 8:30 a 19:30 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$Otros: Fonoteca; Videoteca; Sala de audiovisuales; Consultas al Blog de la Biblioteca (http://www.cuicamatini.blogspot.com)','','','$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$Otros: Fonoteca; Videoteca; Sala de audiovisuales; Consultas al Blog de la Biblioteca (http://www.cuicamatini.blogspot.com)','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Visitas guiadas','Si','Si','','Estanteria abierta en libros, tesis y revistas. Cerrada en partituras, msica grabada y video. Mayo 2013. DPLybf','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (110,'Lun. a Vie. de 8:00 a 20:00 hrs.$Sb., Dom. y Dias festivos de 8:30 a 20:00 hrs.','Estantera mixta (Estanteria Abierta en libros, revistas, tesis. Cerrada en audiovisuales)','Libros$Tesis',' Conexin inalmbrica a Internet a travs de RIU (Red inalmbrica Universitaria)$Fotocopiado (Servicio concesionado)$Renovacin electrnica de prstamos$  ','','',' Conexin inalmbrica a Internet a travs de RIU (Red inalmbrica Universitaria)$Fotocopiado (Servicio concesionado)$Renovacin electrnica de prstamos$  ','Interno$Externo$Interbibliotecario','Visitas guiadas$','Si','Si','','Estanteria abierta en libros, revistas, tesis. Cerrada en audiovisuales','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (107,'Lun. a Vie. de 8:00 a 20:40 hrs.','Estantera abierta','Libros$Publicaciones peridicas','Conexin Inalmbrica a Internet a travs de RIU$Fotocopiado (Servicio concesionado)$Prstamo de netbooks$  ','','','Conexin Inalmbrica a Internet a travs de RIU$Fotocopiado (Servicio concesionado)$Prstamo de netbooks$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (9,'Lun. a Vie. de 8:30 a 20:00 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Tesis','Alerta de nuevas adquisiciones$Conexin inalambrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Fotocopiado (Servicio propio)$','','','Alerta de nuevas adquisiciones$Conexin inalambrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Fotocopiado (Servicio propio)$','Interno$Externo$Interbibliotecario$Reserva de materiales','Orientacin a usuarios','Si','No','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (8,'Lun. a Vie. 9:00 a 19:45 hrs.$Sb. 9:00 a 13:45 hrs.(Horario de sbado slo en periodo semestral escolar)','Estanteria abierta','Libros $Publicaciones peridicas $Tesis','NOTA: Las Bibliotecas de la Facultad de Artes y Diseo y Facultad de Arquitectura comparten una coleccin de libros con temas especializados que ponen a disposicin del pblico a travs del catlogo del Centro de Informacin de Arte, Diseo y Arquitectura (CIADA)$$Alerta bibliogrfica y/o alerta previa$Consulta de Libros electrnicos$Diseminacin Selectiva de Informacin$Equipo de cmputo para consulta$Fotocopiado (Servicio propio)$Prstamo de equipo de cmputo','','','NOTA: Las Bibliotecas de la Facultad de Artes y Diseo y Facultad de Arquitectura comparten una coleccin de libros con temas especializados que ponen a disposicin del pblico a travs del catlogo del Centro de Informacin de Arte, Diseo y Arquitectura (CIADA)$$Alerta bibliogrfica y/o alerta previa$Consulta de Libros electrnicos$Diseminacin Selectiva de Informacin$Equipo de cmputo para consulta$Fotocopiado (Servicio propio)$Prstamo de equipo de cmputo','Interno$Externo (Renovacin de prstamo via Web)$Interbibliotecario','Desarrollo de Habilidades Informativas$Consulta de  Recursos en linea$Orientacin de usuarios$Visitas guiadas$','Si','Si','','CIADA aparece en junio 2015 en la facultad de Arquitectura, pero adquieren libros impresos con presupuesto de ambas Facultades. DPLybf','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (60,'Lun. a Vie. 7:00 a 20:30 hrs.$Sb. 8:00 a 16:00 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis','Anlisis de citas$Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta a tesis electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$','','','Anlisis de citas$Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta a tesis electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$','Interno$Externo$Renovacin de prstamo via Web$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','Horario de sbados es todo el ao escolar.  An no se termina de acondicionar nuevo espacio para tesis. La Unidad Acadmica SISALen Yucatn contempla  la facultad de Ciencias en la licenciatura de Manejo Sustentable de Zonas Costeras, en las carrera de  biologia. junio 2013. DPLybf','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (13,'Lun. a Vie. de 8:30 a 20:15 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas $Tesis $Audiovisuales','NOTA: En esta biblioteca se encuentran los acervos de las bibliotecas de:$Centro de Ciencias de la Atmsfera (CAT)$Instituto de Geofsica (IF)$Instituto de Geologa (I)$Instituto de Ciencias del Mar y Limnologa(MAR)$Se fusionaron  a partir de febrero de 2001. Adems el Centro de Geociencias I(3) tambien participa en el programa cooperativo de BCCT y de BCJ$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales$','','','NOTA: En esta biblioteca se encuentran los acervos de las bibliotecas de:$Centro de Ciencias de la Atmsfera (CAT)$Instituto de Geofsica (IF)$Instituto de Geologa (I)$Instituto de Ciencias del Mar y Limnologa(MAR)$Se fusionaron  a partir de febrero de 2001. Adems el Centro de Geociencias I(3) tambien participa en el programa cooperativo de BCCT y de BCJ$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales$','Interno$Externo$Renovacin de prstamo de libros via Web$ Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (135,'Lun. a Vie. 8:30 a 21:30 hrs.$Sb. 8:30 a 13:30 hrs.','Estanteria mixta (Abierta en coleccin general y Cerrada  en publicaciones periodcas','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio colectivo$Diseminacin selectiva de informacin$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$  ','','','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio colectivo$Diseminacin selectiva de informacin$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin a usuarios$Visitas guiadas$','Si','Si','Si','Estanteria abierta en coleccin general. Cerrada en  hemeroteca, tesis, informes de prcticas escolares, archivo vertical, archivo histrico. Mayo 2013. DPLybf','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (58,'Lun. a Vie. de  8:00 a 17:00 hrs. ','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','Alerta bibliogrfica$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio propio y de autoservicio)$','','','Alerta bibliogrfica$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio propio y de autoservicio)$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (52,'Lun. a Jue. 9:00 a 19:00 hrs. $Vie. 9:00 a 18:00 hrs. ','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas $Tesis','Nuevas adquisiciones$Conexin Inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Elaboracin de ndices$Equipo para lectura de microfichas y microfilm$Obtencin de documentos$Reproduccin de documentos por escaneo  ','','','Nuevas adquisiciones$Conexin Inalmbrica a Internet$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$ Diseminacin Selectiva de la Informacin$Elaboracin de bibliografas$Elaboracin de ndices$Equipo para lectura de microfichas y microfilm$Obtencin de documentos$Reproduccin de documentos por escaneo  ','Interno$Externo$Renovacin de prstamo de libro va Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (50,'Lun. a Vie. de 8:00 a 20:30 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Audiovisuales','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Elaboracin de bibliografas$ Obtencin de documentos$Fotocopiado (Servicio propio)$','','','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$ Elaboracin de bibliografas$ Obtencin de documentos$Fotocopiado (Servicio propio)$','Interno$Externo$Interbibliotecario','Orientacin a usuarios ','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (18,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis','Consulta a libros electrnicos$ Consulta a revistas electrnicas$Obtencin de documentos$Otros: Envo y recepcin de artculos por Ariel$','','','Consulta a libros electrnicos$ Consulta a revistas electrnicas$Obtencin de documentos$Otros: Envo y recepcin de artculos por Ariel$','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de habilidades informativas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (146,'Lun. a Vie. de 8:00 a 20:15 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde  febrero de 2001$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales','','','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde  febrero de 2001$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (150,'Lun. a Vie. de 9:00 a  20:00 hrs.','Estanteria abierta ','','NOTA: El acervo de esta entidad se encuentra integrado en la Biblioteca del Campus Juriquilla a partir del 1 de febrero de 2007$$Boletines de Nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin$Documentacin (Bsqueda y obtencin de documentos)$Equipo de cmputo disponible a usuarios$Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos','','','NOTA: El acervo de esta entidad se encuentra integrado en la Biblioteca del Campus Juriquilla a partir del 1 de febrero de 2007$$Boletines de Nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin$Documentacin (Bsqueda y obtencin de documentos)$Equipo de cmputo disponible a usuarios$Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (155,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera abierta','','NOTA: En esta biblioteca se encuentran los acervos de las bibliotecas de:$Centro de Fsica Aplicada y Tecnologa Avanzada(GF3)$Centro de Geociencias (I3)$Instituto de Neurobiologa(CNQ)$Se fusionaron a fines de noviembre de 2006 para integrarse en las nuevas instalaciones del$Centro Acadmico y Cultural como Biblioteca Campus Juriquilla. Formalmente abri sus servicios el 1 de febrero de 2007.$$Boletines de nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin $ Documentacin ( Bsqueda y obtencin de documentos)$Equipo de cmputo disponible al usuarios$Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos$','','','NOTA: En esta biblioteca se encuentran los acervos de las bibliotecas de:$Centro de Fsica Aplicada y Tecnologa Avanzada(GF3)$Centro de Geociencias (I3)$Instituto de Neurobiologa(CNQ)$Se fusionaron a fines de noviembre de 2006 para integrarse en las nuevas instalaciones del$Centro Acadmico y Cultural como Biblioteca Campus Juriquilla. Formalmente abri sus servicios el 1 de febrero de 2007.$$Boletines de nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin $ Documentacin ( Bsqueda y obtencin de documentos)$Equipo de cmputo disponible al usuarios$Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','','','','Para acceso a Internet cuenta con RIU. Fotocopiado de autoservicio es con tarjeta prepago','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (89,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera abierta ','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: El acervo de esta entidad se encuentra integrado en la "Biblioteca Campus Juriquilla" a partir de  noviembre de 2006.$$ Boletines de nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$ Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin$Documentacin (Bsqueda y obtencin de documentos)$ Equipo de cmputo disponible a usuarios$ Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos$','','','NOTA: El acervo de esta entidad se encuentra integrado en la "Biblioteca Campus Juriquilla" a partir de  noviembre de 2006.$$ Boletines de nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$ Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de la Informacin$Documentacin (Bsqueda y obtencin de documentos)$ Equipo de cmputo disponible a usuarios$ Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (34,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: El acervo de esta entidad se encuentra integrado en la Biblioteca del Campus Juriquilla a partir del 1 de febrero de 2007$$Boletines de nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de Informacin$Documentacin (Bsqueda y obtencin de documentos)$Equipo de cmputo disponible a usuarios$Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos','','','NOTA: El acervo de esta entidad se encuentra integrado en la Biblioteca del Campus Juriquilla a partir del 1 de febrero de 2007$$Boletines de nuevas adquisiciones$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en linea$Consulta a libros electrnicos$Consulta a Patentes$Consulta a revistas electrnicas$Cubculos de estudio grupal$Diseminacin Selectiva de Informacin$Documentacin (Bsqueda y obtencin de documentos)$Equipo de cmputo disponible a usuarios$Fotocopiado (Servicio propio y de autoservicio)$Impresin de textos y digitalizacin de documentos y textos','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (143,'Lun. a Vie. de 8:00 a 20:15 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde  febrero de 2001$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales','','','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde  febrero de 2001$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (142,'Lun. a Vie. de 8:00 a 20:15 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde febrero de 2001$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$ Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y reproduccin electrnica de materiales$','','','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde febrero de 2001$$Alerta bibliogrfica$Bsqueda de citas$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea$Consulta a libros electrnicos$ Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y reproduccin electrnica de materiales$','Interno$Externo$ Renovacin de Prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (141,'Lun. a Vie. 8:00 a 20:15 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros$Publicaciones peridicas$Tesis$Audiovisuales','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde  febrero de 2001$$ Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea $Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales','','','NOTA: El acervo de esta entidad se encuentra integrado a BCCT desde  febrero de 2001$$ Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Constancia de no adeudo$Consulta a bases de datos en lnea $Consulta a libros electrnicos$Consulta a revistas electrnicas$Consulta y Referencia$Documentacin (Manuales para usuarios, bsqueda y obtencin de documentos)$Fotocopiado (Servicio propio) y Reproduccin electrnica de materiales','Interno$Externo$ Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (4,'Lun. a Vie. 9:00 a 19:45 hrs.$Sb. 9:00 a 13:45 hrs. (Horario en sbado slo en periodo semestral escolar)','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Boletin de nuevas adquisiciones$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Reproduccin por digitalizacin$Equipo de cmputo disponible a usuarios$','','','Boletin de nuevas adquisiciones$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Elaboracin de bibliografas$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Reproduccin por digitalizacin$Equipo de cmputo disponible a usuarios$','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (7,'Lun. a Vie. de 8:30 a 20:00 hrs.$Sb. de 9:00 a 14:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en linea$Cubculos de estudio grupal$Equipo de cmputo disponible a usuarios$Fotocopiado (Autoservicio)$Reproduccin de material audiovisual$Hemeroteca$Mapoteca (Cartas geogrficas)$Videoteca$','','','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en linea$Cubculos de estudio grupal$Equipo de cmputo disponible a usuarios$Fotocopiado (Autoservicio)$Reproduccin de material audiovisual$Hemeroteca$Mapoteca (Cartas geogrficas)$Videoteca$','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Orientacin a usuarios$Visitas guiadas$','Si','Si','Si','Horario sbados todo el ao, ya cuentan con alarma en las puertas de emergencia y alarma sismica avisada por radio, junio 2013. ','Acervos de hemeroteca, videoteca y mapoteca cerrados. Cuentan on 4 cubculos de estudio  con una mesa de 6 lugares cada uno. DPL.junio.2017.');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (138,'Lun. a Vie. 8:00 a 20:00 hrs. $Sb. 9:00 a 15:00 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Obtencin de documentos$Sala de computadoras$ Fotocopiado (Servicio concesionado)$','','','$Alerta bibliogrfica y/o alerta previa$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Obtencin de documentos$Sala de computadoras$ Fotocopiado (Servicio concesionado)$','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Visitas guiadas$Instruccin a usuarios colectiva$Instruccin a usuarios individual','Si','Si','','Estanteria abierta: acervo general, consulta. Cerrada: tesis, hemeroteca, pruebas psicolgicas. Horario sbado todo el ao escolar.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (36,'Lun. a Vie. de 9:00 a 20:00 hrs.$Sb. de 9:00 a 13:30 hrs.','Estantera abierta ','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea y CD$Consulta a libros electrnicos$Consulta a revistas electrnicas$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Hemeroteca y Equipo de cmputo para consulta de usuarios de Lun. a Vie.  de 9:00 a 19:30 hrs$Equipo de cmputo disponible a usuarios$Sala de usos mltiples (Con equipo para proyecciones y exposiciones)$Softwarteca','','','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea y CD$Consulta a libros electrnicos$Consulta a revistas electrnicas$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Hemeroteca y Equipo de cmputo para consulta de usuarios de Lun. a Vie.  de 9:00 a 19:30 hrs$Equipo de cmputo disponible a usuarios$Sala de usos mltiples (Con equipo para proyecciones y exposiciones)$Softwarteca','Interno$Externo$Renovacin de prstamo de libros via web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','Horario de sbados todo el ao.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (37,'Lun. a Vie. de 8:30 a 20:45 hrs. $Sb. de 9:00 a 15:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Conexin Inlambrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Equipo de cmputo disponible a usuarios$Obtencin de documentos$Fotocopiado (Servicio concesionado)$Mapoteca$Sala de usos mltiples con equipo para presentaciones$Softwarteca (CDs, diapositivas. DVDs)$','','','Alerta bibliogrfica$Conexin Inlambrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Equipo de cmputo disponible a usuarios$Obtencin de documentos$Fotocopiado (Servicio concesionado)$Mapoteca$Sala de usos mltiples con equipo para presentaciones$Softwarteca (CDs, diapositivas. DVDs)$','Interno$Externo$Renovacin de prtamo de libros via web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','Horario de sbado todo el ao.','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (67,'Lun. a Vie. de 9:00 a 20:30 hrs.','Estantera cerrada','Libros $Publicaciones peridicas $Tesis','Boletin de nuevas adquisiciones$Consulta a bases de datos en lnea$Obtencin de documentos$Equipo de cmputo disponible a usuarios$Fotocopiado (Servicio concesionado)$','','','Boletin de nuevas adquisiciones$Consulta a bases de datos en lnea$Obtencin de documentos$Equipo de cmputo disponible a usuarios$Fotocopiado (Servicio concesionado)$','Interno$Externo$Interbibliotecario','Orientacin de usuarios','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (66,'Lun. a Vie. 7:30 a 21:00 hrs.$Sb. de 8:30 a 14:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en CDROM$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio grupal$Obtencin de documentos$Sala de equipo de computo$Fotocopiado (Servicio concesionado)$Hemeroteca$Mapoteca$Tesis','','','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en CDROM$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio grupal$Obtencin de documentos$Sala de equipo de computo$Fotocopiado (Servicio concesionado)$Hemeroteca$Mapoteca$Tesis','Interno$Externo$Interbibliotecario','Orientacin a usuarios$','Si','Si','','','Cuenta con 3 cubiculos con una mesa para 4 lugares cada uno');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (65,'Lun. a Vie. de 7:30 a 21:00  hrs.$Sb. de 8:00 a 14:00 hrs.','Estantera abierta','Libros $Tesis','Consulta a bases de datos en lnea$Consulta a libros electrnicos$ Fotocopiado (Servicio concesionado)$  ','','','Consulta a bases de datos en lnea$Consulta a libros electrnicos$ Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Renovacin de prstamo via Web$Interbibliotecario','Orientacin a usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (68,'Lun. a Vie. 7:30 a 21:00 hrs.$Sb. de 8:00 a 14:00 hrs.','Estantera mixta (Abierta para libros y Cerrada para publicaciones peridicas y videoteca) ','Libros $Publicaciones peridicas $Audiovisuales','Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$ Sala de equipo de cmputo$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Hemeroteca ','','','Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Cubculos de estudio$ Sala de equipo de cmputo$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Hemeroteca ','Interno$Externo$Renovacin de prstamo de libros via Web$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin a usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (35,'Lun. a Vie. de  9:00 a 20:00 hrs.$Sb. de 9:00 a 15:00 hrs.','Estantera mixta (Abierta en acervo general y Cerrada en Consulta, Hemeroteca y Tesis)','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica $Consulta a bases de datos en linea$Consulta a libros electrnicos$Diseminacin selectiva de la informacin$  Obtencin de documentos$  Fotocopiado (Servicio concesionado)$  ','','','Alerta bibliogrfica $Consulta a bases de datos en linea$Consulta a libros electrnicos$Diseminacin selectiva de la informacin$  Obtencin de documentos$  Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','','Estantera abierta en acervo general. Estantera cerrada en consulta, hemeroteca y tesis','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (59,'Lun. a Vie. de 9:00 a 19:45 hrs.$Sb. de 9:00 a 14:45 hrs.','Estantera mixta (Abierta en coleccin general y Cerrada en videos, mapas, fondo reservado)','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Sala de computadoras disponibles a usuarios$Fotocopiado (Servicio concesionado)$Otros: Esteroscopios para lectura de mapas$','','','Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Sala de computadoras disponibles a usuarios$Fotocopiado (Servicio concesionado)$Otros: Esteroscopios para lectura de mapas$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin de usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (122,'Lun. a Vie. de 8:00 a 20:30 hrs.$Sbado de 9:00 a 14:00 hrs.','Estantera abierta','Libros$Publicaciones peridicas$Tesis $Audiovisuales','Consulta a bases de datos en lnea$Cubculos de estudio$Diseminacin selectiva de informacin$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Sala de computadoras$  ','','','Consulta a bases de datos en lnea$Cubculos de estudio$Diseminacin selectiva de informacin$Fotocopiado (Servicio concesionado)$Obtencin de documentos$Sala de computadoras$  ','Interno$Externo$Interbibliotecario','Visitas guiadas$Instruccin a usuarios colectiva$','Si','Si','','Horario de sbados es todo el ao escolar. ','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (128,'Lun. a Vie. 8:30 a 20:00 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta de Revistas Electrnicas$Obtencin de documentos$Fotocopiado (Servicio con tarjeta electrnica)$ ','','','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$Consulta de Revistas Electrnicas$Obtencin de documentos$Fotocopiado (Servicio con tarjeta electrnica)$ ','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$Orientacin a usuarios$Visitas guiadas$','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (127,'Lun. a Vie. de 8:30 a 20:00 hrs. Sb. de 9:00 a 14:30 hrs.(Horario de sbado programado)','Estantera mixta (Abierta en Acervo general, Consulta y SUA. Cerrada en Tesis)','Libros$Tesis$Audiovisuales','Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$Material Audiovisual$  ','','','Conexin Inalmbrica a Internet a travs de RIU$Consulta a bases de datos en lnea$ Consulta a revistas electrnicas$ Obtencin de documentos$  Fotocopiado (Servicio concesionado)$Material Audiovisual$  ','Interno$Externo$Interbibliotecario','Desarrollo de habilidades informativas$ Orientacin a usuarios$Visitas guiadas$','Si','Si','','Estanteria abierta: Acervo general, Consulta y SUA. Cerrada: Tesis','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (100,'Lun. a Vie. de 8:00 a 21:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Audiovisuales','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Cubculos de estudio colectivo$Fotocopiado propio$Prstamo de netbooks$Hemeroteca$Videoteca','','','Alerta bibliogrfica$Conexin Inalmbrica a Internet a travs de RIU$Cubculos de estudio colectivo$Fotocopiado propio$Prstamo de netbooks$Hemeroteca$Videoteca','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (103,'Lun. a Vie. de 7:30 a 21:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Conexin Inalmbrica a Internet a travs de RIU$Prstamo de netbooks$ ','','','Conexin Inalmbrica a Internet a travs de RIU$Prstamo de netbooks$ ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (46,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estantera mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas','NOTA: Los acervos pertenecientes a la Unidad de Documentacin de Legislacin y Jurisprudencia quedan bajo el resguardo y administracin de la Biblioteca ','','','NOTA: Los acervos pertenecientes a la Unidad de Documentacin de Legislacin y Jurisprudencia quedan bajo el resguardo y administracin de la Biblioteca ','Interno$Externo','Orientacin de usuarios','Si','Si','','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (45,'Lun. a Vie. de 9:00 a 20:00 hrs.','Estanteria mixta (Abierta para usuarios internos y Cerrada para usuarios externos)','Libros $Publicaciones peridicas','Nota: Los acervos pertenecientes a la Unidad de Documentacin de Legislacin y Jurisprudencia pasan  a resguardo y administracin de la Biblioteca "Dr. Jorge Carpizo" a partir del 8 de mayo de 2017$$Alerta bibliogrfica$Avance hemerogrfico jurdico$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio concesionado)$  ','','Juslib$Jusrev$Jusobcol','Nota: Los acervos pertenecientes a la Unidad de Documentacin de Legislacin y Jurisprudencia pasan  a resguardo y administracin de la Biblioteca "Dr. Jorge Carpizo" a partir del 8 de mayo de 2017$$Alerta bibliogrfica$Avance hemerogrfico jurdico$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (106,'Lun. a Vie. de 7:30 a 21:30 hrs.','Estantera abierta','Libros $Publicaciones peridicas $Audiovisuales','Auditorio$Conexin Inalmbrica a Internet a travs de RIU$Fotocopiado (Servicio concesionado)$Hemeroteca','','','Auditorio$Conexin Inalmbrica a Internet a travs de RIU$Fotocopiado (Servicio concesionado)$Hemeroteca','Prstamo interno$Prstamo externo$Prstamo interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (102,'Lun. a Vie. de 8:00 a  21:00 hrs.','Estantera mixta (Abierta en libros y obras de consulta y Cerrada en publicaciones peridicas)','Libros$Publicaciones peridicas$Audiovisuales','Conexin Inalmbrica a Internet$  ','','','Conexin Inalmbrica a Internet$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (105,'Lun. a Vie. de 8:00 a 21:00 hrs.','Estantera abierta ','Libros $Publicaciones peridicas $Audiovisuales','Alerta bibliogrfica y/o alerta previa$Conexin Inalmbrica a Internet a travs de RIU$Cubculos de estudio$Fotocopiado (Servicio concesionado)$Sala de computadoras$  ','','','Alerta bibliogrfica y/o alerta previa$Conexin Inalmbrica a Internet a travs de RIU$Cubculos de estudio$Fotocopiado (Servicio concesionado)$Sala de computadoras$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (104,'Lun. a Vie. de 9:00 a 21:00 hrs.','Estantera abierta','Libros $Publicaciones peridicas','Conexin Inalmbrica a Internet a travs de RIU$Fotocopiado (Servicio concesionado)$  ','','','Conexin Inalmbrica a Internet a travs de RIU$Fotocopiado (Servicio concesionado)$  ','Interno$Externo$Interbibliotecario','Orientacin de usuarios$Visitas guiadas$','Si','Si','Si','Conexin Inalmbrica a Internet a travs de RIU (Red Inalmbrica Universitaria)','');
INSERT INTO "servicio" ("bib_id","horario","t_acceso_acervo","t_matdoc_prest","servs_especial","t_fuentes_impr","t_fuentes_elec","servicios","t_prestamo","inst_usuario","acceso_internet","acceso_redunam","acceso_bd_dgb","observaciones","serv_obs") VALUES (63,'Lun. a Vie. de 8:30 a 19:45 hrs.','Estantera mixta','Libros $Publicaciones peridicas $Tesis $Audiovisuales','Alerta bibliogrfica $Anlisis de citas$Conexin Inalmbrica a Internet$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Digitalizacin de documentos$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Sala de computadoras$Fotocopiado (Autoservicio)$','','','Alerta bibliogrfica $Anlisis de citas$Conexin Inalmbrica a Internet$Consulta a bases de datos en CDROM$Consulta a bases de datos en lnea$Consulta a libros electrnicos$Consulta a revistas electrnicas$Digitalizacin de documentos$Diseminacin Selectiva de Informacin$Elaboracin de bibliografas$Obtencin de documentos$Sala de computadoras$Fotocopiado (Autoservicio)$','Interno$Externo$Interbibliotecario','Desarrollo de Habilidades Informativas$Orientacin a usuarios$Visitas guiadas$','Si','Si','Si','','');
--
-- Data for TOC Entry ID 67 (OID 3235408)
--
-- Name: usuario Type: TABLE DATA Owner: israeld
--


INSERT INTO "usuario" ("usu_id","area","usu_login","usu_passwd") VALUES (2,2,'CatalogColec','cat');
INSERT INTO "usuario" ("usu_id","area","usu_login","usu_passwd") VALUES (3,3,'Planeacion','pla');
INSERT INTO "usuario" ("usu_id","area","usu_login","usu_passwd") VALUES (4,4,'ProTec','pro');
INSERT INTO "usuario" ("usu_id","area","usu_login","usu_passwd") VALUES (5,5,'Suscripciones','sus');
INSERT INTO "usuario" ("usu_id","area","usu_login","usu_passwd") VALUES (6,6,'Plandesar','Aln23U5.');
INSERT INTO "usuario" ("usu_id","area","usu_login","usu_passwd") VALUES (1,1,'Adquisiciones','N34$.ea.');
--
-- Data for TOC Entry ID 68 (OID 3235413)
--
-- Name: modificacion Type: TABLE DATA Owner: israeld
--


INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1,51,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2,52,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3,53,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4,2,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5,3,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6,6,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7,8,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8,9,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9,4,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10,12,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11,11,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12,10,'                              ','Mircoles 4 de Febrero del 04, a las 13:27:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13,2,'Bib Datos Propopios           ','Viernes 6 de Febrero del 04, a las 13:51:31       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14,2,'Bib Datos Propopios           ','Viernes 6 de Febrero del 04, a las 16:34:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15,2,'Bib Datos Propopios           ','Viernes 6 de Febrero del 04, a las 16:38:22       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16,8,'                              ','Viernes 6 de Febrero del 04, a las 16:44:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (17,2,'Bib Datos Propopios           ','Viernes 6 de Febrero del 04, a las 19:15:32       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (18,8,'                              ','Viernes 6 de Febrero del 04, a las 19:18:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (19,2,'Bib Datos Propopios           ','Viernes 6 de Febrero del 04, a las 19:20:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (20,2,'Bib Datos Propopios           ','Viernes 6 de Febrero del 04, a las 19:22:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (21,8,'                              ','Viernes 6 de Febrero del 04, a las 19:26:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (22,8,'                              ','Lunes 9 de Febrero del 04, a las 12:38:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (23,8,'                              ','Lunes 9 de Febrero del 04, a las 13:02:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (24,8,'                              ','Lunes 9 de Febrero del 04, a las 13:06:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (25,8,'                              ','Lunes 9 de Febrero del 04, a las 13:06:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (26,8,'                              ','Lunes 9 de Febrero del 04, a las 13:09:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (27,8,'                              ','Lunes 9 de Febrero del 04, a las 13:14:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (28,2,'Bib Datos Propopios           ','Lunes 9 de Febrero del 04, a las 13:16:15         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (29,8,'                              ','Lunes 9 de Febrero del 04, a las 13:16:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (30,8,'                              ','Lunes 9 de Febrero del 04, a las 13:23:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (31,8,'                              ','Lunes 9 de Febrero del 04, a las 13:24:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (32,8,'                              ','Lunes 9 de Febrero del 04, a las 13:31:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (33,8,'                              ','Lunes 9 de Febrero del 04, a las 14:02:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (34,8,'                              ','Lunes 9 de Febrero del 04, a las 14:21:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (35,8,'                              ','Lunes 9 de Febrero del 04, a las 14:23:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (36,8,'                              ','Lunes 9 de Febrero del 04, a las 14:26:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (37,8,'                              ','Lunes 9 de Febrero del 04, a las 14:30:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (38,8,'                              ','Lunes 9 de Febrero del 04, a las 14:33:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (39,8,'                              ','Lunes 9 de Febrero del 04, a las 14:36:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (40,8,'                              ','Lunes 9 de Febrero del 04, a las 14:42:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (41,8,'                              ','Lunes 9 de Febrero del 04, a las 14:47:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (42,8,'                              ','Lunes 9 de Febrero del 04, a las 15:01:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (43,2,'Bib Datos Propopios           ','Lunes 9 de Febrero del 04, a las 15:22:36         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (44,8,'                              ','Lunes 9 de Febrero del 04, a las 15:28:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (45,8,'                              ','Lunes 9 de Febrero del 04, a las 15:29:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (46,8,'                              ','Lunes 9 de Febrero del 04, a las 15:32:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (47,8,'                              ','Lunes 9 de Febrero del 04, a las 15:33:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (48,8,'                              ','Lunes 9 de Febrero del 04, a las 17:06:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (49,8,'                              ','Lunes 9 de Febrero del 04, a las 17:12:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (50,8,'                              ','Lunes 9 de Febrero del 04, a las 17:14:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (51,8,'                              ','Lunes 9 de Febrero del 04, a las 18:20:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (52,3,'                              ','Mircoles 11 de Febrero del 04, a las 10:10:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (53,3,'                              ','Mircoles 11 de Febrero del 04, a las 10:12:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (54,4,'                              ','Mircoles 11 de Febrero del 04, a las 10:47:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (55,4,'                              ','Mircoles 11 de Febrero del 04, a las 10:51:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (56,3,'                              ','Mircoles 11 de Febrero del 04, a las 10:53:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (57,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:31:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (58,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:33:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (59,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:34:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (60,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:36:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (61,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:37:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (62,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:38:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (63,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:39:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (64,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:41:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (65,3,'                              ','Mircoles 11 de Febrero del 04, a las 12:42:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (66,4,'                              ','Mircoles 11 de Febrero del 04, a las 13:03:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (67,4,'                              ','Mircoles 11 de Febrero del 04, a las 13:04:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (68,4,'                              ','Mircoles 11 de Febrero del 04, a las 13:05:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (69,2,'Bib Datos Propopios           ','Mircoles 11 de Febrero del 04, a las 13:58:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (70,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 10:49:07       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (71,3,'                              ','Jueves 12 de Febrero del 04, a las 10:51:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (72,3,'                              ','Jueves 12 de Febrero del 04, a las 10:55:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (73,6,'                              ','Jueves 12 de Febrero del 04, a las 11:05:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (74,6,'                              ','Jueves 12 de Febrero del 04, a las 11:06:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (75,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:09:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (76,6,'                              ','Jueves 12 de Febrero del 04, a las 11:15:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (77,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:18:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (78,8,'                              ','Jueves 12 de Febrero del 04, a las 11:21:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (79,8,'                              ','Jueves 12 de Febrero del 04, a las 11:25:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (80,8,'                              ','Jueves 12 de Febrero del 04, a las 11:25:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (81,6,'                              ','Jueves 12 de Febrero del 04, a las 11:30:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (82,8,'                              ','Jueves 12 de Febrero del 04, a las 11:38:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (83,8,'                              ','Jueves 12 de Febrero del 04, a las 11:41:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (84,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:43:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (85,4,'                              ','Jueves 12 de Febrero del 04, a las 11:49:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (86,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:53:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (87,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:54:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (88,8,'                              ','Jueves 12 de Febrero del 04, a las 11:55:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (89,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:56:37       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (90,8,'                              ','Jueves 12 de Febrero del 04, a las 11:57:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (91,8,'                              ','Jueves 12 de Febrero del 04, a las 11:58:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (92,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 11:59:18       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (93,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:00:22       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (94,8,'                              ','Jueves 12 de Febrero del 04, a las 12:04:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (95,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:06:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (96,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:07:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (97,8,'                              ','Jueves 12 de Febrero del 04, a las 12:09:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (98,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:11:24       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (99,8,'                              ','Jueves 12 de Febrero del 04, a las 12:12:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (100,8,'                              ','Jueves 12 de Febrero del 04, a las 12:15:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (101,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:21:18       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (102,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:22:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (103,8,'                              ','Jueves 12 de Febrero del 04, a las 12:27:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (104,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:49:20       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (105,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:49:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (106,8,'                              ','Jueves 12 de Febrero del 04, a las 12:51:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (107,8,'                              ','Jueves 12 de Febrero del 04, a las 12:51:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (108,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 12:56:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (109,8,'                              ','Jueves 12 de Febrero del 04, a las 13:06:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (110,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 13:09:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (111,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 13:12:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (112,8,'                              ','Jueves 12 de Febrero del 04, a las 13:14:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (113,2,'Bib Datos Propopios           ','Jueves 12 de Febrero del 04, a las 13:15:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (114,8,'                              ','Jueves 12 de Febrero del 04, a las 13:20:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (115,6,'                              ','Jueves 12 de Febrero del 04, a las 20:05:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (116,53,'                              ','Jueves 12 de Febrero del 04, a las 20:21:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (117,6,'                              ','Viernes 13 de Febrero del 04, a las 19:18:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (118,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 11:36:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (119,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 11:37:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (120,8,'                              ','Lunes 16 de Febrero del 04, a las 11:38:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (121,6,'                              ','Lunes 16 de Febrero del 04, a las 11:40:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (122,4,'                              ','Lunes 16 de Febrero del 04, a las 11:45:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (123,4,'                              ','Lunes 16 de Febrero del 04, a las 11:47:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (124,8,'                              ','Lunes 16 de Febrero del 04, a las 12:00:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (125,8,'                              ','Lunes 16 de Febrero del 04, a las 12:00:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (126,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:02:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (127,8,'                              ','Lunes 16 de Febrero del 04, a las 12:03:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (128,6,'                              ','Lunes 16 de Febrero del 04, a las 12:07:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (129,6,'                              ','Lunes 16 de Febrero del 04, a las 12:08:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (130,6,'                              ','Lunes 16 de Febrero del 04, a las 12:08:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (131,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:13:46        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (132,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:15:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (133,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:16:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (134,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:17:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (135,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:18:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (136,6,'                              ','Lunes 16 de Febrero del 04, a las 12:19:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (137,51,'Direccion                     ','Lunes 16 de Febrero del 04, a las 12:21:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (138,51,'Direccion                     ','Lunes 16 de Febrero del 04, a las 12:22:45        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (139,8,'                              ','Lunes 16 de Febrero del 04, a las 12:25:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (140,8,'                              ','Lunes 16 de Febrero del 04, a las 12:25:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (141,6,'                              ','Lunes 16 de Febrero del 04, a las 12:26:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (142,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:31:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (143,8,'                              ','Lunes 16 de Febrero del 04, a las 12:33:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (144,6,'                              ','Lunes 16 de Febrero del 04, a las 12:35:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (145,6,'                              ','Lunes 16 de Febrero del 04, a las 12:35:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (146,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:45:25        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (147,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:46:16        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (148,8,'                              ','Lunes 16 de Febrero del 04, a las 12:48:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (149,6,'                              ','Lunes 16 de Febrero del 04, a las 12:49:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (150,6,'                              ','Lunes 16 de Febrero del 04, a las 12:52:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (151,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:55:46        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (152,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 12:56:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (153,6,'                              ','Lunes 16 de Febrero del 04, a las 12:58:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (154,8,'                              ','Lunes 16 de Febrero del 04, a las 13:00:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (155,6,'                              ','Lunes 16 de Febrero del 04, a las 13:09:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (156,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 13:10:26        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (157,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 13:11:24        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (158,8,'                              ','Lunes 16 de Febrero del 04, a las 13:13:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (159,6,'                              ','Lunes 16 de Febrero del 04, a las 13:17:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (160,6,'                              ','Lunes 16 de Febrero del 04, a las 13:46:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (161,51,'Direccion                     ','Lunes 16 de Febrero del 04, a las 13:49:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (162,51,'Direccion                     ','Lunes 16 de Febrero del 04, a las 13:51:48        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (163,6,'                              ','Lunes 16 de Febrero del 04, a las 13:53:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (164,6,'                              ','Lunes 16 de Febrero del 04, a las 13:54:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (165,6,'                              ','Lunes 16 de Febrero del 04, a las 13:58:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (166,51,'Direccion                     ','Lunes 16 de Febrero del 04, a las 13:59:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (167,2,'Bib Datos Propopios           ','Lunes 16 de Febrero del 04, a las 14:03:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (168,6,'                              ','Lunes 16 de Febrero del 04, a las 14:06:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (169,6,'                              ','Lunes 16 de Febrero del 04, a las 14:07:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (170,6,'                              ','Lunes 16 de Febrero del 04, a las 14:08:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (171,6,'                              ','Lunes 16 de Febrero del 04, a las 14:09:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (172,2,'Bib Datos Propopios           ','Martes 17 de Febrero del 04, a las 12:29:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (173,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 11:51:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (174,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:11:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (175,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:12:38          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (176,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:12:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (177,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:38:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (178,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:40:31          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (179,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:42:05          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (180,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:43:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (181,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:46:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (182,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:48:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (183,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:50:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (184,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:51:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (185,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:55:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (186,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 12:57:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (187,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:00:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (188,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:02:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (189,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:04:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (190,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:06:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (191,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:21:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (192,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:23:54          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (193,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:26:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (194,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:28:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (195,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:29:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (196,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:30:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (197,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:32:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (198,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:33:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (199,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:36:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (200,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:38:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (201,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:39:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (202,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:42:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (203,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:43:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (204,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:45:35          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (205,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:47:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (206,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:48:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (207,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:49:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (208,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:53:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (209,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:55:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (210,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:56:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (211,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 13:59:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (212,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 14:02:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (213,3,'                              ','Martes 2 de Marzo del 04, a las 14:04:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (214,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 14:07:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (215,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 14:27:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (216,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 14:29:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (217,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 14:32:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (218,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 14:32:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (219,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:38:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (220,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:39:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (221,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:41:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (222,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:43:03          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (223,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:45:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (224,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:47:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (225,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:48:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (226,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:50:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (227,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:52:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (228,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:53:31          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (229,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:54:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (230,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:56:20          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (231,2,'Bib Datos Propopios           ','Martes 2 de Marzo del 04, a las 15:57:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (232,2,'Bib Datos Propopios           ','Mircoles 3 de Marzo del 04, a las 00:19:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (233,2,'Bib Datos Propopios           ','Mircoles 3 de Marzo del 04, a las 10:32:33       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (234,3,'                              ','Mircoles 3 de Marzo del 04, a las 10:33:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (235,3,'                              ','Mircoles 3 de Marzo del 04, a las 10:37:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (236,3,'                              ','Mircoles 3 de Marzo del 04, a las 10:37:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (237,51,'Direccion                     ','Mircoles 3 de Marzo del 04, a las 10:38:33       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (238,3,'                              ','Mircoles 3 de Marzo del 04, a las 10:39:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (239,6,'                              ','Mircoles 3 de Marzo del 04, a las 10:43:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (240,6,'                              ','Mircoles 3 de Marzo del 04, a las 10:48:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (241,6,'                              ','Mircoles 3 de Marzo del 04, a las 10:52:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (242,3,'                              ','Mircoles 3 de Marzo del 04, a las 10:53:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (243,4,'                              ','Mircoles 3 de Marzo del 04, a las 10:54:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (244,4,'                              ','Mircoles 3 de Marzo del 04, a las 10:58:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (245,3,'                              ','Mircoles 3 de Marzo del 04, a las 11:01:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (246,6,'                              ','Mircoles 3 de Marzo del 04, a las 11:03:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (247,6,'                              ','Mircoles 3 de Marzo del 04, a las 11:06:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (248,6,'                              ','Mircoles 3 de Marzo del 04, a las 11:06:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (249,4,'                              ','Mircoles 3 de Marzo del 04, a las 11:41:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (250,4,'                              ','Mircoles 3 de Marzo del 04, a las 11:42:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (251,4,'                              ','Mircoles 3 de Marzo del 04, a las 11:43:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (252,4,'                              ','Mircoles 3 de Marzo del 04, a las 11:47:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (253,4,'                              ','Mircoles 3 de Marzo del 04, a las 11:48:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (254,2,'Bib Datos Propopios           ','Mircoles 3 de Marzo del 04, a las 13:00:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (255,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:00:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (256,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:01:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (257,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:11:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (258,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:12:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (259,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:13:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (260,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:14:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (261,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:15:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (262,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:17:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (263,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:19:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (264,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:19:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (265,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:23:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (266,2,'Bib Datos Propopios           ','Mircoles 3 de Marzo del 04, a las 13:29:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (267,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:32:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (268,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:33:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (269,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:35:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (270,4,'                              ','Mircoles 3 de Marzo del 04, a las 13:36:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (271,2,'Bib Datos Propopios           ','Martes 9 de Marzo del 04, a las 10:21:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (272,52,'                              ','Martes 9 de Marzo del 04, a las 13:51:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (273,52,'                              ','Martes 9 de Marzo del 04, a las 13:53:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (274,6,'                              ','Martes 9 de Marzo del 04, a las 13:56:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (275,52,'                              ','Martes 9 de Marzo del 04, a las 14:26:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (276,6,'                              ','Martes 9 de Marzo del 04, a las 14:29:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (277,6,'                              ','Martes 9 de Marzo del 04, a las 14:51:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (278,6,'                              ','Martes 9 de Marzo del 04, a las 15:56:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (279,6,'                              ','Martes 9 de Marzo del 04, a las 15:56:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (280,6,'                              ','Mircoles 10 de Marzo del 04, a las 10:53:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (281,6,'                              ','Mircoles 10 de Marzo del 04, a las 10:53:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (282,6,'                              ','Mircoles 10 de Marzo del 04, a las 12:48:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (283,6,'                              ','Mircoles 10 de Marzo del 04, a las 12:48:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (284,6,'                              ','Mircoles 10 de Marzo del 04, a las 13:01:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (285,2,'Bib Datos Propopios           ','Mircoles 10 de Marzo del 04, a las 13:08:45      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (286,4,'                              ','Mircoles 10 de Marzo del 04, a las 13:09:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (287,6,'                              ','Mircoles 10 de Marzo del 04, a las 13:22:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (288,6,'                              ','Mircoles 10 de Marzo del 04, a las 13:27:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (289,6,'                              ','Mircoles 10 de Marzo del 04, a las 13:45:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (290,6,'                              ','Mircoles 10 de Marzo del 04, a las 13:54:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (291,6,'                              ','Mircoles 10 de Marzo del 04, a las 14:00:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (292,6,'                              ','Mircoles 10 de Marzo del 04, a las 14:04:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (293,6,'                              ','Mircoles 10 de Marzo del 04, a las 14:07:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (294,6,'                              ','Mircoles 10 de Marzo del 04, a las 14:12:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (295,6,'                              ','Mircoles 10 de Marzo del 04, a las 14:13:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (296,6,'                              ','Mircoles 10 de Marzo del 04, a las 14:19:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (297,6,'                              ','Jueves 11 de Marzo del 04, a las 15:22:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (298,6,'                              ','Mircoles 17 de Marzo del 04, a las 10:47:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (299,6,'                              ','Mircoles 17 de Marzo del 04, a las 10:49:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (300,6,'                              ','Mircoles 17 de Marzo del 04, a las 11:42:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (301,6,'                              ','Mircoles 17 de Marzo del 04, a las 11:43:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (302,6,'                              ','Mircoles 17 de Marzo del 04, a las 11:47:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (303,6,'                              ','Mircoles 17 de Marzo del 04, a las 11:49:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (304,6,'                              ','Mircoles 17 de Marzo del 04, a las 11:53:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (305,6,'                              ','Mircoles 17 de Marzo del 04, a las 16:08:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (306,6,'                              ','Viernes 19 de Marzo del 04, a las 09:22:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (307,6,'                              ','Viernes 19 de Marzo del 04, a las 09:22:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (308,6,'                              ','Viernes 19 de Marzo del 04, a las 09:59:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (309,6,'                              ','Viernes 19 de Marzo del 04, a las 10:00:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (310,6,'                              ','Viernes 19 de Marzo del 04, a las 10:04:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (311,6,'                              ','Viernes 19 de Marzo del 04, a las 10:05:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (312,6,'                              ','Viernes 26 de Marzo del 04, a las 12:58:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (313,6,'                              ','Viernes 26 de Marzo del 04, a las 12:59:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (314,6,'                              ','Viernes 26 de Marzo del 04, a las 13:00:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (315,6,'                              ','Viernes 26 de Marzo del 04, a las 13:02:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (316,6,'                              ','Viernes 26 de Marzo del 04, a las 13:04:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (317,6,'                              ','Viernes 26 de Marzo del 04, a las 13:04:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (318,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 13:06:00        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (319,4,'                              ','Viernes 26 de Marzo del 04, a las 13:06:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (320,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 13:07:49        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (321,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 13:08:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (322,4,'                              ','Viernes 26 de Marzo del 04, a las 13:11:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (323,6,'                              ','Viernes 26 de Marzo del 04, a las 13:12:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (324,6,'                              ','Viernes 26 de Marzo del 04, a las 13:13:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (325,6,'                              ','Viernes 26 de Marzo del 04, a las 13:14:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (326,53,'                              ','Viernes 26 de Marzo del 04, a las 13:17:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (327,53,'                              ','Viernes 26 de Marzo del 04, a las 13:19:24        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (328,4,'                              ','Viernes 26 de Marzo del 04, a las 13:24:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (329,4,'                              ','Viernes 26 de Marzo del 04, a las 13:27:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (330,6,'                              ','Viernes 26 de Marzo del 04, a las 17:12:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (331,4,'                              ','Viernes 26 de Marzo del 04, a las 17:13:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (332,6,'                              ','Viernes 26 de Marzo del 04, a las 17:16:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (333,4,'                              ','Viernes 26 de Marzo del 04, a las 17:18:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (334,6,'                              ','Viernes 26 de Marzo del 04, a las 17:20:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (335,6,'                              ','Viernes 26 de Marzo del 04, a las 17:22:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (336,6,'                              ','Viernes 26 de Marzo del 04, a las 17:25:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (337,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 17:27:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (338,4,'                              ','Viernes 26 de Marzo del 04, a las 17:29:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (339,4,'                              ','Viernes 26 de Marzo del 04, a las 17:30:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (340,6,'                              ','Viernes 26 de Marzo del 04, a las 17:32:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (341,6,'                              ','Viernes 26 de Marzo del 04, a las 17:34:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (342,6,'                              ','Viernes 26 de Marzo del 04, a las 17:35:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (343,6,'                              ','Viernes 26 de Marzo del 04, a las 17:36:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (344,4,'                              ','Viernes 26 de Marzo del 04, a las 17:38:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (345,6,'                              ','Viernes 26 de Marzo del 04, a las 17:42:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (346,6,'                              ','Viernes 26 de Marzo del 04, a las 17:42:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (347,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 17:44:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (348,6,'                              ','Viernes 26 de Marzo del 04, a las 17:45:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (349,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 17:46:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (350,6,'                              ','Viernes 26 de Marzo del 04, a las 17:47:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (351,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 17:48:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (352,4,'                              ','Viernes 26 de Marzo del 04, a las 17:49:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (353,6,'                              ','Viernes 26 de Marzo del 04, a las 18:23:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (354,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:25:00        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (355,4,'                              ','Viernes 26 de Marzo del 04, a las 18:26:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (356,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:30:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (357,6,'                              ','Viernes 26 de Marzo del 04, a las 18:32:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (358,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:33:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (359,3,'                              ','Viernes 26 de Marzo del 04, a las 18:35:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (360,3,'                              ','Viernes 26 de Marzo del 04, a las 18:35:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (361,3,'                              ','Viernes 26 de Marzo del 04, a las 18:39:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (362,3,'                              ','Viernes 26 de Marzo del 04, a las 18:40:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (363,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:41:40        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (364,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:43:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (365,6,'                              ','Viernes 26 de Marzo del 04, a las 18:44:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (366,4,'                              ','Viernes 26 de Marzo del 04, a las 18:46:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (367,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:49:29        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (368,6,'                              ','Viernes 26 de Marzo del 04, a las 18:51:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (369,4,'                              ','Viernes 26 de Marzo del 04, a las 18:52:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (370,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:54:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (371,4,'                              ','Viernes 26 de Marzo del 04, a las 18:55:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (372,2,'Bib Datos Propopios           ','Viernes 26 de Marzo del 04, a las 18:57:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (373,6,'                              ','Viernes 26 de Marzo del 04, a las 18:58:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (374,3,'                              ','Viernes 26 de Marzo del 04, a las 18:59:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (375,3,'                              ','Viernes 26 de Marzo del 04, a las 19:01:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (376,3,'                              ','Viernes 26 de Marzo del 04, a las 19:01:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (377,3,'                              ','Viernes 26 de Marzo del 04, a las 19:04:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (378,3,'                              ','Viernes 26 de Marzo del 04, a las 19:07:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (379,3,'                              ','Viernes 26 de Marzo del 04, a las 19:08:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (380,3,'                              ','Viernes 26 de Marzo del 04, a las 19:10:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (381,4,'                              ','Lunes 29 de Marzo del 04, a las 10:47:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (382,4,'                              ','Lunes 29 de Marzo del 04, a las 10:50:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (383,4,'                              ','Lunes 29 de Marzo del 04, a las 10:52:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (384,4,'                              ','Lunes 29 de Marzo del 04, a las 10:54:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (385,2,'Bib Datos Propopios           ','Lunes 29 de Marzo del 04, a las 10:55:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (386,4,'                              ','Lunes 29 de Marzo del 04, a las 10:56:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (387,6,'                              ','Lunes 29 de Marzo del 04, a las 11:26:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (388,2,'Bib Datos Propopios           ','Lunes 29 de Marzo del 04, a las 11:37:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (389,4,'                              ','Lunes 29 de Marzo del 04, a las 11:39:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (390,2,'Bib Datos Propopios           ','Lunes 29 de Marzo del 04, a las 11:42:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (391,53,'                              ','Lunes 29 de Marzo del 04, a las 11:51:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (392,51,'Direccion                     ','Lunes 29 de Marzo del 04, a las 11:52:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (393,6,'                              ','Lunes 29 de Marzo del 04, a las 11:55:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (394,53,'                              ','Lunes 29 de Marzo del 04, a las 11:57:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (395,6,'                              ','Lunes 29 de Marzo del 04, a las 12:01:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (396,53,'                              ','Lunes 29 de Marzo del 04, a las 12:03:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (397,6,'                              ','Lunes 29 de Marzo del 04, a las 12:07:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (398,53,'                              ','Lunes 29 de Marzo del 04, a las 12:12:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (399,53,'                              ','Lunes 29 de Marzo del 04, a las 12:15:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (400,53,'                              ','Lunes 29 de Marzo del 04, a las 12:22:18          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (401,4,'                              ','Martes 30 de Marzo del 04, a las 10:03:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (402,4,'                              ','Martes 30 de Marzo del 04, a las 10:05:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (403,4,'                              ','Martes 30 de Marzo del 04, a las 10:07:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (404,4,'                              ','Martes 30 de Marzo del 04, a las 10:09:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (405,4,'                              ','Martes 30 de Marzo del 04, a las 10:10:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (406,4,'                              ','Martes 30 de Marzo del 04, a las 10:13:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (407,4,'                              ','Martes 30 de Marzo del 04, a las 10:14:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (408,4,'                              ','Martes 30 de Marzo del 04, a las 10:17:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (409,4,'                              ','Martes 30 de Marzo del 04, a las 10:18:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (410,4,'                              ','Martes 30 de Marzo del 04, a las 10:20:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (411,4,'                              ','Martes 30 de Marzo del 04, a las 10:22:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (412,4,'                              ','Martes 30 de Marzo del 04, a las 10:24:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (413,4,'                              ','Martes 30 de Marzo del 04, a las 10:28:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (414,4,'                              ','Martes 30 de Marzo del 04, a las 10:29:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (415,4,'                              ','Martes 30 de Marzo del 04, a las 10:32:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (416,4,'                              ','Martes 30 de Marzo del 04, a las 10:37:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (417,4,'                              ','Martes 30 de Marzo del 04, a las 10:40:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (418,4,'                              ','Martes 30 de Marzo del 04, a las 10:43:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (419,4,'                              ','Martes 30 de Marzo del 04, a las 10:45:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (420,4,'                              ','Martes 30 de Marzo del 04, a las 10:46:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (421,4,'                              ','Martes 30 de Marzo del 04, a las 10:48:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (422,4,'                              ','Martes 30 de Marzo del 04, a las 10:50:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (423,4,'                              ','Martes 30 de Marzo del 04, a las 10:51:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (424,4,'                              ','Martes 30 de Marzo del 04, a las 10:54:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (425,4,'                              ','Martes 30 de Marzo del 04, a las 10:57:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (426,4,'                              ','Martes 30 de Marzo del 04, a las 10:58:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (427,4,'                              ','Martes 30 de Marzo del 04, a las 11:01:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (428,4,'                              ','Martes 30 de Marzo del 04, a las 11:04:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (429,4,'                              ','Martes 30 de Marzo del 04, a las 11:08:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (430,4,'                              ','Martes 30 de Marzo del 04, a las 11:10:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (431,6,'                              ','Martes 30 de Marzo del 04, a las 11:13:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (432,4,'                              ','Martes 30 de Marzo del 04, a las 11:16:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (433,4,'                              ','Martes 30 de Marzo del 04, a las 11:17:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (434,4,'                              ','Martes 30 de Marzo del 04, a las 11:29:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (435,6,'                              ','Martes 30 de Marzo del 04, a las 11:30:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (436,4,'                              ','Martes 30 de Marzo del 04, a las 11:33:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (437,4,'                              ','Martes 30 de Marzo del 04, a las 11:36:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (438,4,'                              ','Martes 30 de Marzo del 04, a las 11:39:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (439,4,'                              ','Martes 30 de Marzo del 04, a las 11:41:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (440,4,'                              ','Martes 30 de Marzo del 04, a las 11:43:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (441,4,'                              ','Martes 30 de Marzo del 04, a las 11:47:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (442,4,'                              ','Martes 30 de Marzo del 04, a las 11:49:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (443,4,'                              ','Martes 30 de Marzo del 04, a las 11:52:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (444,4,'                              ','Martes 30 de Marzo del 04, a las 11:55:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (445,4,'                              ','Martes 30 de Marzo del 04, a las 11:57:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (446,4,'                              ','Martes 30 de Marzo del 04, a las 11:59:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (447,4,'                              ','Martes 30 de Marzo del 04, a las 12:01:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (448,4,'                              ','Martes 30 de Marzo del 04, a las 12:03:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (449,4,'                              ','Martes 30 de Marzo del 04, a las 12:06:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (450,4,'                              ','Martes 30 de Marzo del 04, a las 12:09:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (451,4,'                              ','Martes 30 de Marzo del 04, a las 12:11:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (452,4,'                              ','Martes 30 de Marzo del 04, a las 12:13:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (453,4,'                              ','Martes 30 de Marzo del 04, a las 12:20:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (454,4,'                              ','Martes 30 de Marzo del 04, a las 12:23:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (455,4,'                              ','Martes 30 de Marzo del 04, a las 12:25:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (456,4,'                              ','Martes 30 de Marzo del 04, a las 12:28:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (457,4,'                              ','Martes 30 de Marzo del 04, a las 12:30:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (458,4,'                              ','Martes 30 de Marzo del 04, a las 12:32:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (459,4,'                              ','Martes 30 de Marzo del 04, a las 12:34:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (460,4,'                              ','Martes 30 de Marzo del 04, a las 12:37:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (461,4,'                              ','Martes 30 de Marzo del 04, a las 12:39:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (462,4,'                              ','Martes 30 de Marzo del 04, a las 12:43:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (463,4,'                              ','Martes 30 de Marzo del 04, a las 12:45:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (464,4,'                              ','Martes 30 de Marzo del 04, a las 12:47:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (465,4,'                              ','Martes 30 de Marzo del 04, a las 12:49:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (466,4,'                              ','Martes 30 de Marzo del 04, a las 12:51:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (467,4,'                              ','Martes 30 de Marzo del 04, a las 13:03:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (468,4,'                              ','Martes 30 de Marzo del 04, a las 16:29:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (469,4,'                              ','Martes 30 de Marzo del 04, a las 16:31:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (470,4,'                              ','Martes 30 de Marzo del 04, a las 16:33:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (471,4,'                              ','Martes 30 de Marzo del 04, a las 16:35:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (472,4,'                              ','Martes 30 de Marzo del 04, a las 16:37:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (473,4,'                              ','Martes 30 de Marzo del 04, a las 16:40:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (474,4,'                              ','Martes 30 de Marzo del 04, a las 16:43:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (475,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:39:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (476,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:41:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (477,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:45:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (478,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:47:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (479,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:49:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (480,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:52:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (481,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:55:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (482,4,'                              ','Mircoles 31 de Marzo del 04, a las 09:59:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (483,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:03:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (484,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:06:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (485,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:09:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (486,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:14:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (487,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:16:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (488,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:21:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (489,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:23:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (490,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:28:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (491,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:31:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (492,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:34:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (493,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:38:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (494,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:40:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (495,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:42:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (496,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:48:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (497,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:50:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (498,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:55:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (499,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:57:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (500,4,'                              ','Mircoles 31 de Marzo del 04, a las 10:59:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (501,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:04:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (502,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:07:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (503,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:10:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (504,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:13:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (505,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:16:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (506,2,'Bib Datos Propopios           ','Mircoles 31 de Marzo del 04, a las 11:18:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (507,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:19:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (508,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:22:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (509,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:24:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (510,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:27:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (511,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:29:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (512,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:32:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (513,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:37:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (514,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:39:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (515,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:41:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (516,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:43:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (517,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:45:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (518,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:49:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (519,4,'                              ','Mircoles 31 de Marzo del 04, a las 11:57:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (520,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:00:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (521,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:03:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (522,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:06:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (523,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:08:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (524,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:10:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (525,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:13:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (526,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:15:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (527,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:19:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (528,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:23:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (529,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:26:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (530,4,'                              ','Mircoles 31 de Marzo del 04, a las 12:28:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (531,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:03:34          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (532,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:04:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (533,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:05:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (534,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:07:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (535,3,'                              ','Lunes 12 de Abril del 04, a las 10:09:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (536,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:11:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (537,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:12:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (538,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:13:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (539,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:14:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (540,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:16:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (541,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:20:04          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (542,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:20:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (543,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:22:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (544,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:24:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (545,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:26:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (546,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:27:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (547,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:30:35          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (548,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:31:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (549,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:32:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (550,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:34:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (551,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:34:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (552,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:35:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (553,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:37:09          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (554,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:39:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (555,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:41:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (556,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:42:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (557,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:45:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (558,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:47:14          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (559,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:48:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (560,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:49:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (561,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:51:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (562,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:52:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (563,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:53:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (564,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:54:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (565,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:55:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (566,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:57:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (567,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 10:59:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (568,4,'                              ','Lunes 12 de Abril del 04, a las 11:01:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (569,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:03:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (570,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:05:09          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (571,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:06:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (572,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:07:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (573,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:08:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (574,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:09:54          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (575,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:11:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (576,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:12:03          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (577,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:12:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (578,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:13:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (579,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:15:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (580,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:15:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (581,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:19:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (582,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:20:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (583,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:21:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (584,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:23:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (585,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:24:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (586,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:26:34          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (587,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:27:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (588,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:28:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (589,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:29:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (590,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:31:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (591,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:34:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (592,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:36:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (593,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:37:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (594,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:38:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (595,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:39:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (596,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:40:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (597,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:41:38          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (598,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:42:35          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (599,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:44:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (600,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:45:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (601,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:46:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (602,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:47:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (603,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:48:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (604,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:49:29          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (605,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:50:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (606,3,'                              ','Lunes 12 de Abril del 04, a las 11:51:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (607,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:52:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (608,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:53:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (609,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:54:34          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (610,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:55:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (611,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:56:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (612,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:57:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (613,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 11:58:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (614,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:00:04          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (615,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:01:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (616,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:02:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (617,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:04:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (618,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:04:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (619,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:05:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (620,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:06:54          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (621,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:07:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (622,3,'                              ','Lunes 12 de Abril del 04, a las 12:08:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (623,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 12:09:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (624,4,'                              ','Lunes 12 de Abril del 04, a las 14:52:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (625,4,'                              ','Lunes 12 de Abril del 04, a las 14:54:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (626,4,'                              ','Lunes 12 de Abril del 04, a las 14:56:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (627,4,'                              ','Lunes 12 de Abril del 04, a las 14:58:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (628,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 14:59:29          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (629,4,'                              ','Lunes 12 de Abril del 04, a las 15:00:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (630,4,'                              ','Lunes 12 de Abril del 04, a las 15:01:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (631,3,'                              ','Lunes 12 de Abril del 04, a las 15:06:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (632,4,'                              ','Lunes 12 de Abril del 04, a las 15:06:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (633,4,'                              ','Lunes 12 de Abril del 04, a las 15:08:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (634,4,'                              ','Lunes 12 de Abril del 04, a las 15:10:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (635,4,'                              ','Lunes 12 de Abril del 04, a las 15:12:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (636,4,'                              ','Lunes 12 de Abril del 04, a las 15:18:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (637,4,'                              ','Lunes 12 de Abril del 04, a las 15:19:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (638,4,'                              ','Lunes 12 de Abril del 04, a las 15:21:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (639,4,'                              ','Lunes 12 de Abril del 04, a las 15:23:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (640,4,'                              ','Lunes 12 de Abril del 04, a las 15:25:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (641,2,'Bib Datos Propopios           ','Lunes 12 de Abril del 04, a las 15:26:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (642,4,'                              ','Lunes 12 de Abril del 04, a las 15:28:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (643,4,'                              ','Lunes 12 de Abril del 04, a las 15:33:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (644,4,'                              ','Lunes 12 de Abril del 04, a las 15:36:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (645,3,'                              ','Lunes 12 de Abril del 04, a las 15:37:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (646,4,'                              ','Martes 13 de Abril del 04, a las 12:04:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (647,2,'Bib Datos Propopios           ','Martes 13 de Abril del 04, a las 12:12:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (648,4,'                              ','Martes 13 de Abril del 04, a las 12:14:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (649,4,'                              ','Martes 13 de Abril del 04, a las 12:16:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (650,4,'                              ','Martes 13 de Abril del 04, a las 12:20:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (651,4,'                              ','Martes 13 de Abril del 04, a las 12:24:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (652,2,'Bib Datos Propopios           ','Martes 13 de Abril del 04, a las 12:25:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (653,2,'Bib Datos Propopios           ','Martes 13 de Abril del 04, a las 12:27:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (654,4,'                              ','Martes 13 de Abril del 04, a las 12:30:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (655,4,'                              ','Martes 13 de Abril del 04, a las 12:38:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (656,2,'Bib Datos Propopios           ','Martes 13 de Abril del 04, a las 12:40:34         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (657,4,'                              ','Martes 13 de Abril del 04, a las 12:43:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (658,2,'Bib Datos Propopios           ','Jueves 15 de Abril del 04, a las 10:06:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (659,4,'                              ','Jueves 15 de Abril del 04, a las 10:08:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (660,4,'                              ','Jueves 15 de Abril del 04, a las 10:09:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (661,3,'                              ','Jueves 15 de Abril del 04, a las 10:10:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (662,2,'Bib Datos Propopios           ','Jueves 15 de Abril del 04, a las 10:31:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (663,4,'                              ','Jueves 15 de Abril del 04, a las 10:34:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (664,4,'                              ','Jueves 15 de Abril del 04, a las 10:36:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (665,2,'Bib Datos Propopios           ','Jueves 15 de Abril del 04, a las 10:39:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (666,4,'                              ','Jueves 15 de Abril del 04, a las 10:47:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (667,2,'Bib Datos Propopios           ','Jueves 15 de Abril del 04, a las 10:55:57         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (668,4,'                              ','Jueves 15 de Abril del 04, a las 10:59:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (669,3,'                              ','Jueves 15 de Abril del 04, a las 11:06:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (670,4,'                              ','Jueves 15 de Abril del 04, a las 11:12:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (671,4,'                              ','Jueves 15 de Abril del 04, a las 11:44:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (672,4,'                              ','Jueves 15 de Abril del 04, a las 11:47:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (673,4,'                              ','Jueves 15 de Abril del 04, a las 11:48:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (674,3,'                              ','Jueves 15 de Abril del 04, a las 11:51:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (675,2,'Bib Datos Propopios           ','Jueves 15 de Abril del 04, a las 11:55:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (676,4,'                              ','Jueves 15 de Abril del 04, a las 11:58:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (677,6,'                              ','Jueves 15 de Abril del 04, a las 12:00:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (678,6,'                              ','Jueves 15 de Abril del 04, a las 12:03:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (679,3,'                              ','Jueves 15 de Abril del 04, a las 12:07:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (680,4,'                              ','Jueves 15 de Abril del 04, a las 12:09:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (681,6,'                              ','Lunes 19 de Abril del 04, a las 11:19:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (682,6,'                              ','Lunes 19 de Abril del 04, a las 11:19:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (683,6,'                              ','Lunes 19 de Abril del 04, a las 11:41:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (684,6,'                              ','Lunes 19 de Abril del 04, a las 11:46:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (685,6,'                              ','Lunes 19 de Abril del 04, a las 11:51:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (686,6,'                              ','Lunes 19 de Abril del 04, a las 11:54:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (687,6,'                              ','Lunes 19 de Abril del 04, a las 11:57:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (688,6,'                              ','Lunes 19 de Abril del 04, a las 12:00:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (689,6,'                              ','Lunes 19 de Abril del 04, a las 12:03:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (690,6,'                              ','Lunes 19 de Abril del 04, a las 12:06:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (691,6,'                              ','Lunes 19 de Abril del 04, a las 12:07:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (692,6,'                              ','Lunes 19 de Abril del 04, a las 12:10:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (693,6,'                              ','Lunes 19 de Abril del 04, a las 12:13:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (694,6,'                              ','Lunes 19 de Abril del 04, a las 12:16:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (695,6,'                              ','Lunes 19 de Abril del 04, a las 12:21:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (696,6,'                              ','Lunes 19 de Abril del 04, a las 12:24:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (697,6,'                              ','Lunes 19 de Abril del 04, a las 12:29:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (698,6,'                              ','Lunes 19 de Abril del 04, a las 12:35:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (699,6,'                              ','Lunes 19 de Abril del 04, a las 12:39:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (700,2,'Bib Datos Propopios           ','Lunes 19 de Abril del 04, a las 12:41:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (701,6,'                              ','Lunes 19 de Abril del 04, a las 12:43:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (702,6,'                              ','Lunes 19 de Abril del 04, a las 12:49:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (703,6,'                              ','Lunes 19 de Abril del 04, a las 12:54:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (704,6,'                              ','Lunes 19 de Abril del 04, a las 13:02:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (705,6,'                              ','Lunes 19 de Abril del 04, a las 13:07:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (706,6,'                              ','Lunes 19 de Abril del 04, a las 13:10:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (707,6,'                              ','Lunes 19 de Abril del 04, a las 14:47:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (708,6,'                              ','Lunes 19 de Abril del 04, a las 14:51:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (709,6,'                              ','Lunes 19 de Abril del 04, a las 14:57:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (710,6,'                              ','Lunes 19 de Abril del 04, a las 14:57:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (711,6,'                              ','Lunes 19 de Abril del 04, a las 15:02:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (712,6,'                              ','Lunes 19 de Abril del 04, a las 15:07:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (713,6,'                              ','Lunes 19 de Abril del 04, a las 15:13:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (714,6,'                              ','Lunes 19 de Abril del 04, a las 15:13:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (715,6,'                              ','Martes 20 de Abril del 04, a las 07:38:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (716,6,'                              ','Martes 20 de Abril del 04, a las 07:43:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (717,6,'                              ','Martes 20 de Abril del 04, a las 07:44:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (718,6,'                              ','Martes 20 de Abril del 04, a las 07:48:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (719,6,'                              ','Martes 20 de Abril del 04, a las 07:52:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (720,6,'                              ','Martes 20 de Abril del 04, a las 07:58:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (721,6,'                              ','Martes 20 de Abril del 04, a las 08:03:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (722,6,'                              ','Martes 20 de Abril del 04, a las 08:29:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (723,6,'                              ','Martes 20 de Abril del 04, a las 08:37:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (724,6,'                              ','Martes 20 de Abril del 04, a las 08:41:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (725,6,'                              ','Martes 20 de Abril del 04, a las 08:45:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (726,6,'                              ','Martes 20 de Abril del 04, a las 08:58:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (727,6,'                              ','Martes 20 de Abril del 04, a las 09:01:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (728,6,'                              ','Martes 20 de Abril del 04, a las 09:05:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (729,6,'                              ','Martes 20 de Abril del 04, a las 09:09:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (730,6,'                              ','Martes 20 de Abril del 04, a las 09:12:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (731,6,'                              ','Martes 20 de Abril del 04, a las 09:17:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (732,6,'                              ','Martes 20 de Abril del 04, a las 09:20:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (733,6,'                              ','Martes 20 de Abril del 04, a las 09:28:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (734,6,'                              ','Martes 20 de Abril del 04, a las 09:33:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (735,6,'                              ','Martes 20 de Abril del 04, a las 09:38:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (736,6,'                              ','Martes 20 de Abril del 04, a las 09:44:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (737,6,'                              ','Martes 20 de Abril del 04, a las 10:11:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (738,6,'                              ','Martes 20 de Abril del 04, a las 10:17:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (739,6,'                              ','Martes 20 de Abril del 04, a las 10:20:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (740,6,'                              ','Martes 20 de Abril del 04, a las 10:24:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (741,6,'                              ','Martes 20 de Abril del 04, a las 10:25:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (742,6,'                              ','Martes 20 de Abril del 04, a las 10:28:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (743,6,'                              ','Martes 20 de Abril del 04, a las 10:31:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (744,6,'                              ','Martes 20 de Abril del 04, a las 10:34:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (745,6,'                              ','Martes 20 de Abril del 04, a las 10:41:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (746,6,'                              ','Martes 20 de Abril del 04, a las 10:41:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (747,6,'                              ','Martes 20 de Abril del 04, a las 10:46:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (748,6,'                              ','Martes 20 de Abril del 04, a las 10:54:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (749,6,'                              ','Martes 20 de Abril del 04, a las 10:58:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (750,6,'                              ','Martes 20 de Abril del 04, a las 11:01:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (751,6,'                              ','Martes 20 de Abril del 04, a las 11:06:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (752,6,'                              ','Martes 20 de Abril del 04, a las 11:09:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (753,6,'                              ','Martes 20 de Abril del 04, a las 11:10:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (754,6,'                              ','Martes 20 de Abril del 04, a las 11:14:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (755,6,'                              ','Martes 20 de Abril del 04, a las 11:17:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (756,6,'                              ','Martes 20 de Abril del 04, a las 11:20:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (757,6,'                              ','Martes 20 de Abril del 04, a las 11:27:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (758,6,'                              ','Martes 20 de Abril del 04, a las 11:29:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (759,6,'                              ','Martes 20 de Abril del 04, a las 11:33:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (760,6,'                              ','Martes 20 de Abril del 04, a las 11:37:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (761,6,'                              ','Martes 20 de Abril del 04, a las 11:41:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (762,6,'                              ','Martes 20 de Abril del 04, a las 11:44:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (763,6,'                              ','Martes 20 de Abril del 04, a las 11:49:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (764,6,'                              ','Martes 20 de Abril del 04, a las 11:51:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (765,6,'                              ','Martes 20 de Abril del 04, a las 11:58:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (766,6,'                              ','Martes 20 de Abril del 04, a las 12:02:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (767,6,'                              ','Martes 20 de Abril del 04, a las 12:04:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (768,6,'                              ','Martes 20 de Abril del 04, a las 12:08:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (769,6,'                              ','Martes 20 de Abril del 04, a las 12:11:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (770,6,'                              ','Martes 20 de Abril del 04, a las 12:13:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (771,6,'                              ','Martes 20 de Abril del 04, a las 12:16:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (772,6,'                              ','Martes 20 de Abril del 04, a las 12:17:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (773,6,'                              ','Martes 20 de Abril del 04, a las 12:26:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (774,6,'                              ','Martes 20 de Abril del 04, a las 12:26:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (775,6,'                              ','Martes 20 de Abril del 04, a las 12:26:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (776,6,'                              ','Martes 20 de Abril del 04, a las 12:34:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (777,6,'                              ','Martes 20 de Abril del 04, a las 15:05:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (778,6,'                              ','Martes 20 de Abril del 04, a las 15:07:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (779,6,'                              ','Martes 20 de Abril del 04, a las 15:07:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (780,6,'                              ','Martes 20 de Abril del 04, a las 15:08:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (781,6,'                              ','Martes 20 de Abril del 04, a las 15:09:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (782,6,'                              ','Martes 20 de Abril del 04, a las 15:10:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (783,6,'                              ','Martes 20 de Abril del 04, a las 15:11:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (784,6,'                              ','Martes 20 de Abril del 04, a las 15:12:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (785,6,'                              ','Martes 20 de Abril del 04, a las 15:13:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (786,6,'                              ','Martes 20 de Abril del 04, a las 15:15:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (787,6,'                              ','Martes 20 de Abril del 04, a las 15:16:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (788,6,'                              ','Martes 20 de Abril del 04, a las 15:17:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (789,6,'                              ','Martes 20 de Abril del 04, a las 15:22:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (790,6,'                              ','Martes 20 de Abril del 04, a las 15:24:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (791,6,'                              ','Martes 20 de Abril del 04, a las 15:25:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (792,6,'                              ','Martes 20 de Abril del 04, a las 15:26:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (793,6,'                              ','Martes 20 de Abril del 04, a las 15:26:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (794,6,'                              ','Martes 20 de Abril del 04, a las 15:43:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (795,6,'                              ','Martes 20 de Abril del 04, a las 15:44:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (796,6,'                              ','Martes 20 de Abril del 04, a las 15:45:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (797,6,'                              ','Martes 20 de Abril del 04, a las 15:47:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (798,6,'                              ','Martes 20 de Abril del 04, a las 15:49:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (799,6,'                              ','Martes 20 de Abril del 04, a las 15:49:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (800,6,'                              ','Martes 20 de Abril del 04, a las 15:50:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (801,6,'                              ','Martes 20 de Abril del 04, a las 15:51:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (802,6,'                              ','Martes 20 de Abril del 04, a las 15:52:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (803,6,'                              ','Martes 20 de Abril del 04, a las 15:53:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (804,6,'                              ','Martes 20 de Abril del 04, a las 15:54:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (805,6,'                              ','Martes 20 de Abril del 04, a las 15:54:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (806,6,'                              ','Martes 20 de Abril del 04, a las 15:55:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (807,6,'                              ','Martes 20 de Abril del 04, a las 15:56:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (808,6,'                              ','Martes 20 de Abril del 04, a las 15:57:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (809,6,'                              ','Martes 20 de Abril del 04, a las 15:57:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (810,6,'                              ','Martes 20 de Abril del 04, a las 15:58:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (811,6,'                              ','Martes 20 de Abril del 04, a las 16:00:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (812,6,'                              ','Martes 20 de Abril del 04, a las 16:15:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (813,6,'                              ','Martes 20 de Abril del 04, a las 16:18:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (814,6,'                              ','Martes 20 de Abril del 04, a las 16:20:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (815,6,'                              ','Martes 20 de Abril del 04, a las 16:22:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (816,6,'                              ','Martes 20 de Abril del 04, a las 16:23:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (817,6,'                              ','Martes 20 de Abril del 04, a las 16:26:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (818,6,'                              ','Martes 20 de Abril del 04, a las 16:27:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (819,6,'                              ','Martes 20 de Abril del 04, a las 16:27:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (820,6,'                              ','Martes 20 de Abril del 04, a las 16:30:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (821,6,'                              ','Martes 20 de Abril del 04, a las 16:32:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (822,6,'                              ','Martes 20 de Abril del 04, a las 16:34:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (823,6,'                              ','Martes 20 de Abril del 04, a las 16:36:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (824,6,'                              ','Martes 20 de Abril del 04, a las 16:41:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (825,6,'                              ','Martes 20 de Abril del 04, a las 16:43:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (826,6,'                              ','Martes 20 de Abril del 04, a las 16:45:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (827,6,'                              ','Martes 20 de Abril del 04, a las 16:47:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (828,6,'                              ','Martes 20 de Abril del 04, a las 16:47:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (829,6,'                              ','Martes 20 de Abril del 04, a las 16:49:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (830,6,'                              ','Martes 20 de Abril del 04, a las 16:52:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (831,6,'                              ','Martes 20 de Abril del 04, a las 16:54:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (832,8,'                              ','Mircoles 21 de Abril del 04, a las 09:40:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (833,8,'                              ','Mircoles 21 de Abril del 04, a las 09:58:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (834,8,'                              ','Mircoles 21 de Abril del 04, a las 10:02:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (835,8,'                              ','Mircoles 21 de Abril del 04, a las 10:10:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (836,8,'                              ','Mircoles 21 de Abril del 04, a las 10:17:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (837,8,'                              ','Mircoles 21 de Abril del 04, a las 10:18:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (838,8,'                              ','Mircoles 21 de Abril del 04, a las 10:27:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (839,8,'                              ','Mircoles 21 de Abril del 04, a las 10:28:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (840,8,'                              ','Mircoles 21 de Abril del 04, a las 10:31:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (841,8,'                              ','Mircoles 21 de Abril del 04, a las 10:33:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (842,8,'                              ','Mircoles 21 de Abril del 04, a las 10:36:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (843,8,'                              ','Mircoles 21 de Abril del 04, a las 10:38:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (844,8,'                              ','Mircoles 21 de Abril del 04, a las 10:40:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (845,8,'                              ','Mircoles 21 de Abril del 04, a las 10:49:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (846,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 10:57:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (847,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 10:59:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (848,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 11:02:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (849,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 11:04:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (850,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 11:05:23      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (851,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 11:09:23      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (852,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 11:25:39      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (853,2,'Bib Datos Propopios           ','Mircoles 21 de Abril del 04, a las 11:28:14      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (854,4,'                              ','Mircoles 21 de Abril del 04, a las 11:30:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (855,4,'                              ','Mircoles 21 de Abril del 04, a las 11:32:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (856,4,'                              ','Mircoles 21 de Abril del 04, a las 11:34:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (857,4,'                              ','Mircoles 21 de Abril del 04, a las 11:35:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (858,4,'                              ','Mircoles 21 de Abril del 04, a las 11:37:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (859,4,'                              ','Mircoles 21 de Abril del 04, a las 11:39:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (860,4,'                              ','Mircoles 21 de Abril del 04, a las 11:40:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (861,4,'                              ','Mircoles 21 de Abril del 04, a las 11:42:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (862,4,'                              ','Mircoles 21 de Abril del 04, a las 11:43:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (863,4,'                              ','Mircoles 21 de Abril del 04, a las 11:45:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (864,4,'                              ','Mircoles 21 de Abril del 04, a las 11:47:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (865,4,'                              ','Mircoles 21 de Abril del 04, a las 11:47:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (866,4,'                              ','Mircoles 21 de Abril del 04, a las 11:48:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (867,4,'                              ','Mircoles 21 de Abril del 04, a las 11:50:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (868,4,'                              ','Mircoles 21 de Abril del 04, a las 11:50:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (869,4,'                              ','Mircoles 21 de Abril del 04, a las 11:51:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (870,4,'                              ','Mircoles 21 de Abril del 04, a las 11:52:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (871,4,'                              ','Mircoles 21 de Abril del 04, a las 11:56:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (872,4,'                              ','Mircoles 21 de Abril del 04, a las 11:57:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (873,4,'                              ','Mircoles 21 de Abril del 04, a las 11:59:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (874,4,'                              ','Mircoles 21 de Abril del 04, a las 12:00:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (875,4,'                              ','Mircoles 21 de Abril del 04, a las 12:01:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (876,4,'                              ','Mircoles 21 de Abril del 04, a las 12:03:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (877,4,'                              ','Mircoles 21 de Abril del 04, a las 12:04:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (878,4,'                              ','Mircoles 21 de Abril del 04, a las 12:05:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (879,4,'                              ','Mircoles 21 de Abril del 04, a las 12:07:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (880,4,'                              ','Mircoles 21 de Abril del 04, a las 12:09:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (881,4,'                              ','Mircoles 21 de Abril del 04, a las 12:10:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (882,4,'                              ','Martes 27 de Abril del 04, a las 11:32:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (883,4,'                              ','Martes 27 de Abril del 04, a las 11:34:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (884,4,'                              ','Martes 27 de Abril del 04, a las 11:36:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (885,4,'                              ','Lunes 3 de Mayo del 04, a las 11:08:51            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (886,4,'                              ','Lunes 3 de Mayo del 04, a las 11:10:41            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (887,4,'                              ','Lunes 17 de Mayo del 04, a las 13:41:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (888,4,'                              ','Lunes 17 de Mayo del 04, a las 13:46:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (889,4,'                              ','Lunes 17 de Mayo del 04, a las 13:49:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (890,53,'                              ','Lunes 17 de Mayo del 04, a las 13:51:36           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (891,4,'                              ','Lunes 17 de Mayo del 04, a las 13:53:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (892,4,'                              ','Lunes 17 de Mayo del 04, a las 15:26:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (893,4,'                              ','Lunes 17 de Mayo del 04, a las 15:29:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (894,4,'                              ','Lunes 17 de Mayo del 04, a las 15:32:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (895,4,'                              ','Lunes 17 de Mayo del 04, a las 15:44:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (896,4,'                              ','Lunes 17 de Mayo del 04, a las 15:48:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (897,4,'                              ','Lunes 17 de Mayo del 04, a las 15:51:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (898,4,'                              ','Lunes 17 de Mayo del 04, a las 15:54:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (899,4,'                              ','Martes 18 de Mayo del 04, a las 08:55:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (900,4,'                              ','Martes 18 de Mayo del 04, a las 08:59:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (901,4,'                              ','Martes 18 de Mayo del 04, a las 09:09:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (902,4,'                              ','Martes 18 de Mayo del 04, a las 09:13:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (903,4,'                              ','Martes 18 de Mayo del 04, a las 09:32:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (904,4,'                              ','Martes 18 de Mayo del 04, a las 09:36:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (905,4,'                              ','Martes 18 de Mayo del 04, a las 10:29:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (906,4,'                              ','Martes 18 de Mayo del 04, a las 10:32:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (907,4,'                              ','Martes 18 de Mayo del 04, a las 10:32:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (908,4,'                              ','Martes 18 de Mayo del 04, a las 10:36:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (909,4,'                              ','Martes 18 de Mayo del 04, a las 10:40:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (910,4,'                              ','Martes 18 de Mayo del 04, a las 10:50:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (911,4,'                              ','Martes 18 de Mayo del 04, a las 10:53:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (912,4,'                              ','Martes 18 de Mayo del 04, a las 10:56:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (913,4,'                              ','Martes 18 de Mayo del 04, a las 10:59:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (914,4,'                              ','Martes 18 de Mayo del 04, a las 11:00:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (915,4,'                              ','Martes 18 de Mayo del 04, a las 11:02:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (916,4,'                              ','Martes 18 de Mayo del 04, a las 11:04:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (917,4,'                              ','Martes 18 de Mayo del 04, a las 11:23:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (918,4,'                              ','Martes 18 de Mayo del 04, a las 11:24:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (919,4,'                              ','Martes 18 de Mayo del 04, a las 11:26:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (920,4,'                              ','Martes 18 de Mayo del 04, a las 11:27:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (921,4,'                              ','Martes 18 de Mayo del 04, a las 11:29:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (922,4,'                              ','Martes 18 de Mayo del 04, a las 11:30:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (923,4,'                              ','Martes 18 de Mayo del 04, a las 11:32:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (924,2,'Bib Datos Propopios           ','Martes 18 de Mayo del 04, a las 11:38:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (925,4,'                              ','Martes 18 de Mayo del 04, a las 11:42:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (926,4,'                              ','Martes 18 de Mayo del 04, a las 11:44:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (927,4,'                              ','Martes 18 de Mayo del 04, a las 11:50:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (928,4,'                              ','Martes 18 de Mayo del 04, a las 11:51:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (929,4,'                              ','Martes 18 de Mayo del 04, a las 12:09:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (930,4,'                              ','Martes 18 de Mayo del 04, a las 12:30:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (931,4,'                              ','Martes 18 de Mayo del 04, a las 12:30:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (932,4,'                              ','Martes 18 de Mayo del 04, a las 12:34:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (933,4,'                              ','Martes 18 de Mayo del 04, a las 12:38:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (934,4,'                              ','Martes 18 de Mayo del 04, a las 12:52:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (935,4,'                              ','Martes 18 de Mayo del 04, a las 12:54:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (936,4,'                              ','Martes 18 de Mayo del 04, a las 12:57:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (937,4,'                              ','Martes 18 de Mayo del 04, a las 13:00:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (938,4,'                              ','Martes 18 de Mayo del 04, a las 13:02:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (939,4,'                              ','Martes 18 de Mayo del 04, a las 13:06:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (940,4,'                              ','Martes 18 de Mayo del 04, a las 13:09:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (941,4,'                              ','Martes 18 de Mayo del 04, a las 13:11:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (942,4,'                              ','Martes 18 de Mayo del 04, a las 13:16:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (943,4,'                              ','Martes 18 de Mayo del 04, a las 13:20:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (944,4,'                              ','Martes 18 de Mayo del 04, a las 13:23:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (945,4,'                              ','Martes 18 de Mayo del 04, a las 13:25:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (946,4,'                              ','Martes 18 de Mayo del 04, a las 13:28:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (947,4,'                              ','Martes 18 de Mayo del 04, a las 13:30:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (948,4,'                              ','Martes 18 de Mayo del 04, a las 13:34:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (949,4,'                              ','Martes 18 de Mayo del 04, a las 13:48:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (950,4,'                              ','Martes 18 de Mayo del 04, a las 15:04:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (951,4,'                              ','Martes 18 de Mayo del 04, a las 15:07:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (952,4,'                              ','Martes 18 de Mayo del 04, a las 15:10:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (953,4,'                              ','Martes 18 de Mayo del 04, a las 15:13:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (954,4,'                              ','Martes 18 de Mayo del 04, a las 15:14:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (955,4,'                              ','Martes 18 de Mayo del 04, a las 15:16:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (956,4,'                              ','Martes 18 de Mayo del 04, a las 15:21:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (957,4,'                              ','Martes 18 de Mayo del 04, a las 15:23:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (958,4,'                              ','Martes 18 de Mayo del 04, a las 15:31:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (959,4,'                              ','Martes 18 de Mayo del 04, a las 15:34:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (960,4,'                              ','Martes 18 de Mayo del 04, a las 15:48:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (961,4,'                              ','Martes 18 de Mayo del 04, a las 15:51:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (962,4,'                              ','Martes 18 de Mayo del 04, a las 15:54:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (963,4,'                              ','Martes 18 de Mayo del 04, a las 15:55:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (964,4,'                              ','Martes 18 de Mayo del 04, a las 15:57:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (965,4,'                              ','Martes 18 de Mayo del 04, a las 15:59:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (966,4,'                              ','Martes 18 de Mayo del 04, a las 16:02:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (967,4,'                              ','Martes 18 de Mayo del 04, a las 16:05:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (968,4,'                              ','Martes 18 de Mayo del 04, a las 16:07:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (969,4,'                              ','Martes 18 de Mayo del 04, a las 16:11:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (970,4,'                              ','Mircoles 19 de Mayo del 04, a las 10:09:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (971,4,'                              ','Mircoles 19 de Mayo del 04, a las 10:12:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (972,4,'                              ','Mircoles 19 de Mayo del 04, a las 10:16:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (973,4,'                              ','Mircoles 19 de Mayo del 04, a las 10:20:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (974,4,'                              ','Mircoles 19 de Mayo del 04, a las 10:23:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (975,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:10:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (976,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:14:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (977,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:17:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (978,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:22:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (979,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:25:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (980,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:28:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (981,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:39:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (982,4,'                              ','Mircoles 19 de Mayo del 04, a las 11:42:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (983,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:25:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (984,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:28:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (985,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:30:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (986,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:33:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (987,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:36:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (988,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:39:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (989,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:41:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (990,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:44:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (991,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:48:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (992,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:51:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (993,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:54:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (994,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:57:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (995,4,'                              ','Mircoles 19 de Mayo del 04, a las 12:59:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (996,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:02:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (997,53,'                              ','Mircoles 19 de Mayo del 04, a las 13:10:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (998,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:12:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (999,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:15:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1000,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:18:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1001,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:21:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1002,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:23:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1003,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:26:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1004,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:28:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1005,4,'                              ','Mircoles 19 de Mayo del 04, a las 13:30:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1006,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:05:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1007,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:15:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1008,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:19:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1009,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:23:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1010,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:26:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1011,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:28:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1012,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:31:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1013,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:34:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1014,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:37:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1015,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:49:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1016,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:51:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1017,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:56:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1018,4,'                              ','Mircoles 19 de Mayo del 04, a las 15:58:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1019,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:05:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1020,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:09:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1021,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:11:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1022,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:18:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1023,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:31:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1024,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:34:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1025,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:37:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1026,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:40:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1027,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:42:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1028,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:43:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1029,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:44:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1030,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:45:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1031,4,'                              ','Mircoles 19 de Mayo del 04, a las 16:45:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1032,4,'                              ','Viernes 21 de Mayo del 04, a las 09:19:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1033,8,'                              ','Viernes 21 de Mayo del 04, a las 09:20:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1034,4,'                              ','Viernes 21 de Mayo del 04, a las 09:21:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1035,4,'                              ','Viernes 21 de Mayo del 04, a las 09:41:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1036,6,'                              ','Viernes 21 de Mayo del 04, a las 09:53:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1037,6,'                              ','Viernes 21 de Mayo del 04, a las 09:57:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1038,4,'                              ','Viernes 21 de Mayo del 04, a las 10:27:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1039,4,'                              ','Viernes 21 de Mayo del 04, a las 10:30:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1040,4,'                              ','Viernes 21 de Mayo del 04, a las 10:37:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1041,4,'                              ','Viernes 21 de Mayo del 04, a las 10:40:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1042,4,'                              ','Viernes 21 de Mayo del 04, a las 10:42:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1043,4,'                              ','Viernes 21 de Mayo del 04, a las 10:43:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1044,4,'                              ','Viernes 21 de Mayo del 04, a las 10:47:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1045,4,'                              ','Viernes 21 de Mayo del 04, a las 11:00:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1046,4,'                              ','Viernes 21 de Mayo del 04, a las 11:04:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1047,4,'                              ','Viernes 21 de Mayo del 04, a las 11:06:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1048,4,'                              ','Viernes 21 de Mayo del 04, a las 11:11:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1049,4,'                              ','Viernes 21 de Mayo del 04, a las 11:17:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1050,4,'                              ','Viernes 21 de Mayo del 04, a las 11:38:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1051,4,'                              ','Viernes 21 de Mayo del 04, a las 11:41:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1052,4,'                              ','Viernes 21 de Mayo del 04, a las 11:43:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1053,4,'                              ','Viernes 21 de Mayo del 04, a las 11:46:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1054,4,'                              ','Viernes 21 de Mayo del 04, a las 11:49:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1055,4,'                              ','Viernes 21 de Mayo del 04, a las 11:51:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1056,4,'                              ','Viernes 21 de Mayo del 04, a las 11:54:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1057,4,'                              ','Viernes 21 de Mayo del 04, a las 11:58:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1058,4,'                              ','Viernes 21 de Mayo del 04, a las 12:02:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1059,4,'                              ','Viernes 21 de Mayo del 04, a las 12:04:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1060,4,'                              ','Viernes 21 de Mayo del 04, a las 12:15:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1061,4,'                              ','Viernes 21 de Mayo del 04, a las 12:19:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1062,4,'                              ','Viernes 21 de Mayo del 04, a las 12:24:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1063,4,'                              ','Viernes 21 de Mayo del 04, a las 12:28:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1064,4,'                              ','Viernes 21 de Mayo del 04, a las 13:26:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1065,4,'                              ','Viernes 21 de Mayo del 04, a las 13:29:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1066,4,'                              ','Viernes 21 de Mayo del 04, a las 13:31:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1067,4,'                              ','Lunes 24 de Mayo del 04, a las 09:20:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1068,4,'                              ','Lunes 24 de Mayo del 04, a las 09:22:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1069,4,'                              ','Lunes 24 de Mayo del 04, a las 09:25:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1070,4,'                              ','Lunes 24 de Mayo del 04, a las 09:32:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1071,4,'                              ','Lunes 24 de Mayo del 04, a las 09:34:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1072,4,'                              ','Lunes 24 de Mayo del 04, a las 09:44:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1073,4,'                              ','Lunes 24 de Mayo del 04, a las 09:58:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1074,4,'                              ','Lunes 24 de Mayo del 04, a las 10:01:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1075,4,'                              ','Lunes 24 de Mayo del 04, a las 10:05:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1076,4,'                              ','Lunes 24 de Mayo del 04, a las 10:07:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1077,4,'                              ','Lunes 24 de Mayo del 04, a las 10:16:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1078,4,'                              ','Lunes 24 de Mayo del 04, a las 10:20:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1079,4,'                              ','Lunes 24 de Mayo del 04, a las 10:24:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1080,4,'                              ','Lunes 24 de Mayo del 04, a las 10:26:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1081,4,'                              ','Lunes 24 de Mayo del 04, a las 10:33:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1082,4,'                              ','Lunes 24 de Mayo del 04, a las 10:35:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1083,4,'                              ','Lunes 24 de Mayo del 04, a las 10:38:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1084,4,'                              ','Lunes 24 de Mayo del 04, a las 10:53:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1085,4,'                              ','Lunes 24 de Mayo del 04, a las 10:55:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1086,4,'                              ','Lunes 24 de Mayo del 04, a las 10:58:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1087,4,'                              ','Lunes 24 de Mayo del 04, a las 11:06:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1088,4,'                              ','Lunes 24 de Mayo del 04, a las 11:09:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1089,4,'                              ','Lunes 24 de Mayo del 04, a las 11:11:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1090,4,'                              ','Lunes 24 de Mayo del 04, a las 11:13:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1091,4,'                              ','Lunes 24 de Mayo del 04, a las 11:15:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1092,4,'                              ','Lunes 24 de Mayo del 04, a las 11:17:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1093,4,'                              ','Lunes 24 de Mayo del 04, a las 11:20:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1094,4,'                              ','Lunes 24 de Mayo del 04, a las 11:24:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1095,4,'                              ','Lunes 24 de Mayo del 04, a las 11:26:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1096,4,'                              ','Lunes 24 de Mayo del 04, a las 11:29:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1097,4,'                              ','Lunes 24 de Mayo del 04, a las 11:31:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1098,4,'                              ','Lunes 24 de Mayo del 04, a las 11:33:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1099,4,'                              ','Lunes 24 de Mayo del 04, a las 11:44:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1100,4,'                              ','Lunes 24 de Mayo del 04, a las 11:47:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1101,4,'                              ','Lunes 24 de Mayo del 04, a las 11:49:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1102,4,'                              ','Lunes 24 de Mayo del 04, a las 11:51:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1103,4,'                              ','Lunes 24 de Mayo del 04, a las 11:54:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1104,4,'                              ','Lunes 24 de Mayo del 04, a las 11:56:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1105,4,'                              ','Lunes 24 de Mayo del 04, a las 11:59:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1106,4,'                              ','Lunes 24 de Mayo del 04, a las 12:01:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1107,4,'                              ','Lunes 24 de Mayo del 04, a las 12:03:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1108,4,'                              ','Lunes 24 de Mayo del 04, a las 12:05:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1109,4,'                              ','Lunes 24 de Mayo del 04, a las 12:07:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1110,4,'                              ','Lunes 24 de Mayo del 04, a las 12:09:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1111,4,'                              ','Lunes 24 de Mayo del 04, a las 12:11:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1112,4,'                              ','Lunes 24 de Mayo del 04, a las 12:14:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1113,4,'                              ','Lunes 24 de Mayo del 04, a las 12:17:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1114,4,'                              ','Lunes 24 de Mayo del 04, a las 12:19:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1115,4,'                              ','Lunes 24 de Mayo del 04, a las 12:21:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1116,4,'                              ','Lunes 24 de Mayo del 04, a las 12:23:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1117,4,'                              ','Lunes 24 de Mayo del 04, a las 12:24:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1118,4,'                              ','Lunes 24 de Mayo del 04, a las 12:28:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1119,4,'                              ','Lunes 24 de Mayo del 04, a las 12:31:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1120,4,'                              ','Lunes 24 de Mayo del 04, a las 12:37:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1121,4,'                              ','Lunes 24 de Mayo del 04, a las 12:39:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1122,4,'                              ','Lunes 24 de Mayo del 04, a las 12:42:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1123,4,'                              ','Lunes 24 de Mayo del 04, a las 12:46:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1124,4,'                              ','Lunes 24 de Mayo del 04, a las 12:51:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1125,4,'                              ','Lunes 24 de Mayo del 04, a las 12:57:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1126,4,'                              ','Lunes 24 de Mayo del 04, a las 13:25:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1127,4,'                              ','Lunes 24 de Mayo del 04, a las 13:30:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1128,4,'                              ','Lunes 24 de Mayo del 04, a las 13:32:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1129,4,'                              ','Lunes 24 de Mayo del 04, a las 13:36:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1130,4,'                              ','Lunes 24 de Mayo del 04, a las 13:38:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1131,4,'                              ','Lunes 24 de Mayo del 04, a las 13:40:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1132,4,'                              ','Lunes 24 de Mayo del 04, a las 13:42:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1133,4,'                              ','Lunes 24 de Mayo del 04, a las 13:45:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1134,4,'                              ','Lunes 24 de Mayo del 04, a las 13:52:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1135,4,'                              ','Lunes 24 de Mayo del 04, a las 13:53:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1136,4,'                              ','Lunes 24 de Mayo del 04, a las 13:55:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1137,4,'                              ','Lunes 24 de Mayo del 04, a las 15:09:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1138,4,'                              ','Lunes 24 de Mayo del 04, a las 15:11:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1139,4,'                              ','Lunes 24 de Mayo del 04, a las 15:13:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1140,4,'                              ','Lunes 24 de Mayo del 04, a las 15:16:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1141,4,'                              ','Martes 25 de Mayo del 04, a las 10:27:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1142,4,'                              ','Martes 25 de Mayo del 04, a las 10:29:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1143,4,'                              ','Martes 25 de Mayo del 04, a las 10:32:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1144,4,'                              ','Martes 25 de Mayo del 04, a las 10:36:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1145,4,'                              ','Martes 25 de Mayo del 04, a las 10:50:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1146,4,'                              ','Martes 25 de Mayo del 04, a las 10:55:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1147,4,'                              ','Martes 25 de Mayo del 04, a las 11:00:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1148,6,'                              ','Martes 25 de Mayo del 04, a las 11:18:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1149,6,'                              ','Martes 25 de Mayo del 04, a las 11:22:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1150,8,'                              ','Martes 25 de Mayo del 04, a las 12:40:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1151,6,'                              ','Martes 25 de Mayo del 04, a las 12:47:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1152,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 12:59:29          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1153,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:01:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1154,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:06:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1155,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:07:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1156,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:21:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1157,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:23:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1158,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:43:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1159,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 13:44:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1160,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 14:09:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1161,2,'Bib Datos Propopios           ','Martes 25 de Mayo del 04, a las 14:10:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1162,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 10:54:58       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1163,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 10:55:45       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1164,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 10:56:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1165,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 10:58:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1166,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:00:07       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1167,6,'                              ','Mircoles 26 de Mayo del 04, a las 11:36:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1168,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:45:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1169,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:46:34       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1170,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:48:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1171,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:51:08       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1172,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:53:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1173,2,'Bib Datos Propopios           ','Mircoles 26 de Mayo del 04, a las 11:58:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1174,6,'                              ','Mircoles 26 de Mayo del 04, a las 12:02:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1175,11,'                              ','Mircoles 26 de Mayo del 04, a las 12:03:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1176,6,'                              ','Mircoles 26 de Mayo del 04, a las 12:15:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1177,9,'                              ','Jueves 27 de Mayo del 04, a las 11:45:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1178,4,'                              ','Jueves 27 de Mayo del 04, a las 11:49:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1179,10,'                              ','Jueves 27 de Mayo del 04, a las 11:51:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1180,10,'                              ','Jueves 27 de Mayo del 04, a las 11:52:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1181,8,'                              ','Jueves 27 de Mayo del 04, a las 11:54:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1182,8,'                              ','Jueves 27 de Mayo del 04, a las 11:55:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1183,8,'                              ','Jueves 27 de Mayo del 04, a las 12:00:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1184,8,'                              ','Jueves 27 de Mayo del 04, a las 12:02:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1185,8,'                              ','Jueves 27 de Mayo del 04, a las 12:02:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1186,11,'                              ','Jueves 27 de Mayo del 04, a las 12:05:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1187,11,'                              ','Jueves 27 de Mayo del 04, a las 12:07:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1188,10,'                              ','Jueves 27 de Mayo del 04, a las 12:11:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1189,2,'Bib Datos Propopios           ','Lunes 31 de Mayo del 04, a las 08:53:28           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1190,4,'                              ','Lunes 31 de Mayo del 04, a las 08:55:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1191,6,'                              ','Lunes 31 de Mayo del 04, a las 08:56:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1192,4,'                              ','Lunes 31 de Mayo del 04, a las 09:02:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1193,4,'                              ','Lunes 31 de Mayo del 04, a las 09:11:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1194,4,'                              ','Lunes 31 de Mayo del 04, a las 09:15:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1195,8,'                              ','Lunes 31 de Mayo del 04, a las 09:26:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1196,8,'                              ','Lunes 31 de Mayo del 04, a las 09:37:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1197,8,'                              ','Lunes 31 de Mayo del 04, a las 09:40:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1198,4,'                              ','Lunes 31 de Mayo del 04, a las 10:01:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1199,9,'                              ','Lunes 31 de Mayo del 04, a las 10:03:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1200,8,'                              ','Lunes 31 de Mayo del 04, a las 10:05:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1201,8,'                              ','Lunes 31 de Mayo del 04, a las 10:06:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1202,10,'                              ','Lunes 31 de Mayo del 04, a las 10:11:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1203,9,'                              ','Lunes 31 de Mayo del 04, a las 10:14:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1204,8,'                              ','Lunes 31 de Mayo del 04, a las 10:24:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1205,2,'Bib Datos Propopios           ','Lunes 31 de Mayo del 04, a las 10:31:46           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1206,9,'                              ','Lunes 31 de Mayo del 04, a las 10:57:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1207,4,'                              ','Lunes 31 de Mayo del 04, a las 11:00:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1208,8,'                              ','Lunes 31 de Mayo del 04, a las 11:12:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1209,8,'                              ','Lunes 31 de Mayo del 04, a las 11:16:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1210,8,'                              ','Lunes 31 de Mayo del 04, a las 11:19:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1211,8,'                              ','Lunes 31 de Mayo del 04, a las 11:20:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1212,11,'                              ','Lunes 31 de Mayo del 04, a las 11:21:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1213,11,'                              ','Lunes 31 de Mayo del 04, a las 11:25:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1214,10,'                              ','Lunes 31 de Mayo del 04, a las 11:31:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1215,2,'Bib Datos Propopios           ','Lunes 31 de Mayo del 04, a las 11:37:17           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1216,6,'                              ','Lunes 31 de Mayo del 04, a las 11:38:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1217,4,'                              ','Lunes 31 de Mayo del 04, a las 11:40:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1218,9,'                              ','Lunes 31 de Mayo del 04, a las 11:54:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1219,4,'                              ','Lunes 31 de Mayo del 04, a las 11:57:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1220,10,'                              ','Lunes 31 de Mayo del 04, a las 11:59:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1221,10,'                              ','Lunes 31 de Mayo del 04, a las 12:00:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1222,8,'                              ','Lunes 31 de Mayo del 04, a las 12:03:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1223,8,'                              ','Lunes 31 de Mayo del 04, a las 12:03:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1224,8,'                              ','Lunes 31 de Mayo del 04, a las 12:05:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1225,8,'                              ','Lunes 31 de Mayo del 04, a las 12:08:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1226,8,'                              ','Lunes 31 de Mayo del 04, a las 12:13:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1227,8,'                              ','Lunes 31 de Mayo del 04, a las 12:15:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1228,11,'                              ','Lunes 31 de Mayo del 04, a las 12:58:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1229,2,'Bib Datos Propopios           ','Lunes 31 de Mayo del 04, a las 13:01:49           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1230,4,'                              ','Lunes 31 de Mayo del 04, a las 13:06:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1231,9,'                              ','Lunes 31 de Mayo del 04, a las 13:09:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1232,8,'                              ','Lunes 31 de Mayo del 04, a las 16:00:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1233,8,'                              ','Lunes 31 de Mayo del 04, a las 16:01:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1234,8,'                              ','Lunes 31 de Mayo del 04, a las 16:04:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1235,8,'                              ','Lunes 31 de Mayo del 04, a las 16:06:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1236,8,'                              ','Lunes 31 de Mayo del 04, a las 16:08:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1237,8,'                              ','Lunes 31 de Mayo del 04, a las 16:10:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1238,8,'                              ','Lunes 31 de Mayo del 04, a las 16:12:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1239,8,'                              ','Lunes 31 de Mayo del 04, a las 16:13:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1240,11,'                              ','Lunes 31 de Mayo del 04, a las 16:15:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1241,11,'                              ','Lunes 31 de Mayo del 04, a las 16:16:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1242,11,'                              ','Lunes 31 de Mayo del 04, a las 16:20:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1243,11,'                              ','Lunes 31 de Mayo del 04, a las 16:20:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1244,11,'                              ','Lunes 31 de Mayo del 04, a las 16:23:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1245,11,'                              ','Lunes 31 de Mayo del 04, a las 16:23:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1246,10,'                              ','Lunes 31 de Mayo del 04, a las 16:30:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1247,51,'Direccion                     ','Martes 1 de Junio del 04, a las 09:39:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1248,6,'                              ','Martes 1 de Junio del 04, a las 09:42:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1249,6,'                              ','Martes 1 de Junio del 04, a las 09:47:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1250,6,'                              ','Martes 1 de Junio del 04, a las 09:50:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1251,6,'                              ','Martes 1 de Junio del 04, a las 09:52:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1252,6,'                              ','Martes 1 de Junio del 04, a las 09:55:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1253,6,'                              ','Martes 1 de Junio del 04, a las 09:57:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1254,4,'                              ','Martes 1 de Junio del 04, a las 10:02:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1255,9,'                              ','Martes 1 de Junio del 04, a las 10:06:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1256,10,'                              ','Martes 1 de Junio del 04, a las 10:07:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1257,8,'                              ','Martes 1 de Junio del 04, a las 10:10:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1258,8,'                              ','Martes 1 de Junio del 04, a las 10:12:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1259,8,'                              ','Martes 1 de Junio del 04, a las 10:13:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1260,8,'                              ','Martes 1 de Junio del 04, a las 10:15:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1261,11,'                              ','Martes 1 de Junio del 04, a las 10:16:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1262,11,'                              ','Martes 1 de Junio del 04, a las 10:19:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1263,4,'                              ','Martes 1 de Junio del 04, a las 10:23:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1264,9,'                              ','Martes 1 de Junio del 04, a las 10:30:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1265,4,'                              ','Martes 1 de Junio del 04, a las 10:32:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1266,10,'                              ','Martes 1 de Junio del 04, a las 10:33:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1267,8,'                              ','Martes 1 de Junio del 04, a las 10:36:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1268,8,'                              ','Martes 1 de Junio del 04, a las 10:37:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1269,8,'                              ','Martes 1 de Junio del 04, a las 10:40:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1270,8,'                              ','Martes 1 de Junio del 04, a las 10:45:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1271,11,'                              ','Martes 1 de Junio del 04, a las 10:48:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1272,4,'                              ','Martes 1 de Junio del 04, a las 10:50:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1273,6,'                              ','Martes 1 de Junio del 04, a las 11:02:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1274,6,'                              ','Martes 1 de Junio del 04, a las 11:03:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1275,6,'                              ','Martes 1 de Junio del 04, a las 11:03:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1276,11,'                              ','Martes 1 de Junio del 04, a las 11:13:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1277,9,'                              ','Martes 1 de Junio del 04, a las 11:14:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1278,4,'                              ','Martes 1 de Junio del 04, a las 11:16:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1279,8,'                              ','Martes 1 de Junio del 04, a las 11:19:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1280,8,'                              ','Martes 1 de Junio del 04, a las 11:21:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1281,8,'                              ','Martes 1 de Junio del 04, a las 11:25:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1282,11,'                              ','Martes 1 de Junio del 04, a las 11:28:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1283,10,'                              ','Martes 1 de Junio del 04, a las 11:30:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1284,8,'                              ','Martes 1 de Junio del 04, a las 17:12:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1285,6,'                              ','Mircoles 2 de Junio del 04, a las 10:25:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1286,4,'                              ','Mircoles 2 de Junio del 04, a las 10:26:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1287,9,'                              ','Mircoles 2 de Junio del 04, a las 10:29:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1288,4,'                              ','Mircoles 2 de Junio del 04, a las 10:31:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1289,8,'                              ','Mircoles 2 de Junio del 04, a las 10:43:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1290,8,'                              ','Mircoles 2 de Junio del 04, a las 10:45:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1291,8,'                              ','Mircoles 2 de Junio del 04, a las 10:56:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1292,8,'                              ','Mircoles 2 de Junio del 04, a las 10:59:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1293,8,'                              ','Mircoles 2 de Junio del 04, a las 11:00:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1294,11,'                              ','Mircoles 2 de Junio del 04, a las 11:04:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1295,11,'                              ','Mircoles 2 de Junio del 04, a las 11:04:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1296,10,'                              ','Mircoles 2 de Junio del 04, a las 11:05:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1297,9,'                              ','Mircoles 2 de Junio del 04, a las 11:41:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1298,4,'                              ','Mircoles 2 de Junio del 04, a las 11:43:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1299,10,'                              ','Mircoles 2 de Junio del 04, a las 11:45:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1300,8,'                              ','Mircoles 2 de Junio del 04, a las 11:48:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1301,8,'                              ','Mircoles 2 de Junio del 04, a las 11:54:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1302,8,'                              ','Mircoles 2 de Junio del 04, a las 11:55:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1303,8,'                              ','Mircoles 2 de Junio del 04, a las 11:58:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1304,11,'                              ','Mircoles 2 de Junio del 04, a las 12:02:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1305,11,'                              ','Mircoles 2 de Junio del 04, a las 12:05:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1306,10,'                              ','Mircoles 2 de Junio del 04, a las 12:38:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1307,9,'                              ','Mircoles 2 de Junio del 04, a las 12:39:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1308,4,'                              ','Mircoles 2 de Junio del 04, a las 12:41:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1309,8,'                              ','Mircoles 2 de Junio del 04, a las 12:46:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1310,8,'                              ','Mircoles 2 de Junio del 04, a las 12:52:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1311,8,'                              ','Mircoles 2 de Junio del 04, a las 14:09:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1312,11,'                              ','Mircoles 2 de Junio del 04, a las 14:14:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1313,8,'                              ','Mircoles 2 de Junio del 04, a las 14:20:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1314,11,'                              ','Mircoles 2 de Junio del 04, a las 14:25:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1315,11,'                              ','Mircoles 2 de Junio del 04, a las 14:25:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1316,11,'                              ','Mircoles 2 de Junio del 04, a las 14:26:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1317,11,'                              ','Mircoles 2 de Junio del 04, a las 14:28:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1318,11,'                              ','Mircoles 2 de Junio del 04, a las 14:48:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1319,11,'                              ','Mircoles 2 de Junio del 04, a las 15:05:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1320,11,'                              ','Mircoles 2 de Junio del 04, a las 15:06:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1321,11,'                              ','Mircoles 2 de Junio del 04, a las 15:07:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1322,11,'                              ','Mircoles 2 de Junio del 04, a las 15:08:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1323,11,'                              ','Jueves 3 de Junio del 04, a las 09:08:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1324,11,'                              ','Jueves 3 de Junio del 04, a las 09:32:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1325,11,'                              ','Jueves 3 de Junio del 04, a las 09:42:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1326,9,'                              ','Jueves 3 de Junio del 04, a las 09:44:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1327,4,'                              ','Jueves 3 de Junio del 04, a las 09:46:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1328,10,'                              ','Jueves 3 de Junio del 04, a las 09:57:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1329,8,'                              ','Jueves 3 de Junio del 04, a las 10:00:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1330,8,'                              ','Jueves 3 de Junio del 04, a las 10:02:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1331,8,'                              ','Jueves 3 de Junio del 04, a las 10:17:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1332,11,'                              ','Jueves 3 de Junio del 04, a las 10:24:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1333,6,'                              ','Jueves 3 de Junio del 04, a las 10:57:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1334,9,'                              ','Jueves 3 de Junio del 04, a las 11:03:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1335,4,'                              ','Jueves 3 de Junio del 04, a las 11:12:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1336,4,'                              ','Jueves 3 de Junio del 04, a las 11:14:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1337,10,'                              ','Jueves 3 de Junio del 04, a las 11:16:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1338,8,'                              ','Jueves 3 de Junio del 04, a las 11:18:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1339,8,'                              ','Jueves 3 de Junio del 04, a las 11:30:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1340,8,'                              ','Jueves 3 de Junio del 04, a las 11:33:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1341,11,'                              ','Jueves 3 de Junio del 04, a las 11:37:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1342,6,'                              ','Jueves 3 de Junio del 04, a las 11:46:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1343,9,'                              ','Jueves 3 de Junio del 04, a las 11:50:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1344,4,'                              ','Jueves 3 de Junio del 04, a las 11:52:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1345,10,'                              ','Jueves 3 de Junio del 04, a las 11:54:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1346,8,'                              ','Jueves 3 de Junio del 04, a las 12:00:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1347,11,'                              ','Jueves 3 de Junio del 04, a las 12:03:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1348,6,'                              ','Jueves 3 de Junio del 04, a las 12:11:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1349,9,'                              ','Jueves 3 de Junio del 04, a las 12:15:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1350,4,'                              ','Jueves 3 de Junio del 04, a las 12:16:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1351,10,'                              ','Jueves 3 de Junio del 04, a las 12:18:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1352,8,'                              ','Jueves 3 de Junio del 04, a las 12:22:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1353,11,'                              ','Jueves 3 de Junio del 04, a las 12:27:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1354,10,'                              ','Jueves 3 de Junio del 04, a las 12:28:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1355,4,'                              ','Jueves 3 de Junio del 04, a las 12:50:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1356,11,'                              ','Jueves 3 de Junio del 04, a las 12:53:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1357,6,'                              ','Jueves 3 de Junio del 04, a las 12:55:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1358,9,'                              ','Jueves 3 de Junio del 04, a las 12:57:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1359,10,'                              ','Jueves 3 de Junio del 04, a las 12:58:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1360,8,'                              ','Jueves 3 de Junio del 04, a las 13:05:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1361,8,'                              ','Jueves 3 de Junio del 04, a las 13:07:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1362,11,'                              ','Jueves 3 de Junio del 04, a las 13:10:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1363,11,'                              ','Jueves 3 de Junio del 04, a las 13:11:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1364,6,'                              ','Jueves 3 de Junio del 04, a las 13:14:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1365,6,'                              ','Viernes 4 de Junio del 04, a las 09:41:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1366,6,'                              ','Viernes 4 de Junio del 04, a las 09:43:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1367,6,'                              ','Viernes 4 de Junio del 04, a las 09:44:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1368,6,'                              ','Viernes 4 de Junio del 04, a las 09:45:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1369,6,'                              ','Viernes 4 de Junio del 04, a las 09:46:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1370,6,'                              ','Viernes 4 de Junio del 04, a las 09:46:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1371,6,'                              ','Viernes 4 de Junio del 04, a las 09:48:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1372,6,'                              ','Viernes 4 de Junio del 04, a las 09:49:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1373,6,'                              ','Viernes 4 de Junio del 04, a las 09:50:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1374,8,'                              ','Viernes 4 de Junio del 04, a las 09:55:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1375,8,'                              ','Viernes 4 de Junio del 04, a las 09:59:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1376,8,'                              ','Viernes 4 de Junio del 04, a las 10:00:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1377,8,'                              ','Viernes 4 de Junio del 04, a las 10:01:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1378,11,'                              ','Viernes 4 de Junio del 04, a las 10:13:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1379,11,'                              ','Viernes 4 de Junio del 04, a las 10:14:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1380,11,'                              ','Viernes 4 de Junio del 04, a las 10:15:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1381,11,'                              ','Viernes 4 de Junio del 04, a las 10:21:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1382,11,'                              ','Viernes 4 de Junio del 04, a las 10:29:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1383,11,'                              ','Viernes 4 de Junio del 04, a las 10:34:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1384,4,'                              ','Viernes 4 de Junio del 04, a las 10:42:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1385,11,'                              ','Viernes 4 de Junio del 04, a las 11:08:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1386,11,'                              ','Viernes 4 de Junio del 04, a las 11:09:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1387,11,'                              ','Viernes 4 de Junio del 04, a las 11:10:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1388,11,'                              ','Viernes 4 de Junio del 04, a las 11:11:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1389,11,'                              ','Viernes 4 de Junio del 04, a las 11:12:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1390,11,'                              ','Viernes 4 de Junio del 04, a las 11:13:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1391,11,'                              ','Viernes 4 de Junio del 04, a las 11:31:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1392,11,'                              ','Viernes 4 de Junio del 04, a las 11:32:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1393,11,'                              ','Viernes 4 de Junio del 04, a las 12:36:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1394,11,'                              ','Viernes 4 de Junio del 04, a las 12:37:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1395,11,'                              ','Viernes 4 de Junio del 04, a las 12:38:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1396,11,'                              ','Viernes 4 de Junio del 04, a las 12:39:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1397,11,'                              ','Viernes 4 de Junio del 04, a las 12:40:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1398,11,'                              ','Viernes 4 de Junio del 04, a las 12:40:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1399,11,'                              ','Viernes 4 de Junio del 04, a las 12:41:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1400,11,'                              ','Viernes 4 de Junio del 04, a las 12:42:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1401,11,'                              ','Viernes 4 de Junio del 04, a las 12:42:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1402,11,'                              ','Viernes 4 de Junio del 04, a las 12:42:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1403,11,'                              ','Viernes 4 de Junio del 04, a las 12:45:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1404,11,'                              ','Viernes 4 de Junio del 04, a las 12:47:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1405,6,'                              ','Viernes 4 de Junio del 04, a las 12:56:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1406,9,'                              ','Viernes 4 de Junio del 04, a las 13:03:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1407,4,'                              ','Viernes 4 de Junio del 04, a las 13:05:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1408,8,'                              ','Viernes 4 de Junio del 04, a las 13:09:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1409,8,'                              ','Viernes 4 de Junio del 04, a las 14:54:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1410,8,'                              ','Viernes 4 de Junio del 04, a las 14:55:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1411,11,'                              ','Viernes 4 de Junio del 04, a las 14:57:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1412,11,'                              ','Viernes 4 de Junio del 04, a las 14:59:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1413,11,'                              ','Viernes 4 de Junio del 04, a las 14:59:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1414,10,'                              ','Viernes 4 de Junio del 04, a las 15:03:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1415,3,'                              ','Viernes 4 de Junio del 04, a las 15:15:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1416,6,'                              ','Viernes 4 de Junio del 04, a las 15:24:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1417,9,'                              ','Viernes 4 de Junio del 04, a las 15:27:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1418,10,'                              ','Viernes 4 de Junio del 04, a las 15:29:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1419,8,'                              ','Viernes 4 de Junio del 04, a las 15:32:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1420,8,'                              ','Viernes 4 de Junio del 04, a las 15:57:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1421,8,'                              ','Viernes 4 de Junio del 04, a las 16:00:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1422,11,'                              ','Viernes 4 de Junio del 04, a las 16:03:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1423,11,'                              ','Viernes 4 de Junio del 04, a las 16:04:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1424,8,'                              ','Viernes 4 de Junio del 04, a las 16:06:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1425,8,'                              ','Viernes 4 de Junio del 04, a las 16:13:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1426,3,'                              ','Viernes 4 de Junio del 04, a las 16:32:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1427,9,'                              ','Viernes 4 de Junio del 04, a las 17:43:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1428,4,'                              ','Viernes 4 de Junio del 04, a las 17:45:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1429,4,'                              ','Viernes 4 de Junio del 04, a las 17:45:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1430,10,'                              ','Viernes 4 de Junio del 04, a las 17:46:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1431,8,'                              ','Viernes 4 de Junio del 04, a las 17:56:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1432,8,'                              ','Viernes 4 de Junio del 04, a las 17:58:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1433,8,'                              ','Viernes 4 de Junio del 04, a las 18:00:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1434,8,'                              ','Viernes 4 de Junio del 04, a las 18:02:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1435,11,'                              ','Viernes 4 de Junio del 04, a las 18:05:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1436,11,'                              ','Viernes 4 de Junio del 04, a las 18:06:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1437,8,'                              ','Lunes 7 de Junio del 04, a las 10:25:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1438,8,'                              ','Lunes 7 de Junio del 04, a las 10:27:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1439,8,'                              ','Lunes 7 de Junio del 04, a las 10:29:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1440,8,'                              ','Lunes 7 de Junio del 04, a las 10:32:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1441,8,'                              ','Lunes 7 de Junio del 04, a las 10:34:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1442,8,'                              ','Lunes 7 de Junio del 04, a las 10:35:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1443,8,'                              ','Lunes 7 de Junio del 04, a las 10:36:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1444,8,'                              ','Lunes 7 de Junio del 04, a las 10:36:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1445,8,'                              ','Lunes 7 de Junio del 04, a las 10:46:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1446,8,'                              ','Lunes 7 de Junio del 04, a las 10:49:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1447,4,'                              ','Lunes 7 de Junio del 04, a las 11:02:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1448,4,'                              ','Lunes 7 de Junio del 04, a las 11:10:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1449,3,'                              ','Lunes 7 de Junio del 04, a las 11:42:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1450,3,'                              ','Lunes 7 de Junio del 04, a las 11:43:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1451,6,'                              ','Lunes 7 de Junio del 04, a las 12:11:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1452,9,'                              ','Lunes 7 de Junio del 04, a las 12:22:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1453,4,'                              ','Lunes 7 de Junio del 04, a las 12:24:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1454,8,'                              ','Lunes 7 de Junio del 04, a las 12:33:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1455,8,'                              ','Lunes 7 de Junio del 04, a las 12:34:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1456,8,'                              ','Lunes 7 de Junio del 04, a las 12:44:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1457,11,'                              ','Lunes 7 de Junio del 04, a las 13:05:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1458,11,'                              ','Lunes 7 de Junio del 04, a las 13:06:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1459,10,'                              ','Lunes 7 de Junio del 04, a las 13:09:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1460,6,'                              ','Lunes 7 de Junio del 04, a las 13:12:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1461,11,'                              ','Lunes 7 de Junio del 04, a las 13:14:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1462,53,'                              ','Lunes 7 de Junio del 04, a las 13:19:12           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1463,4,'                              ','Lunes 7 de Junio del 04, a las 14:22:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1464,6,'                              ','Lunes 7 de Junio del 04, a las 14:24:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1465,6,'                              ','Lunes 7 de Junio del 04, a las 14:26:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1466,6,'                              ','Lunes 7 de Junio del 04, a las 14:38:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1467,6,'                              ','Lunes 7 de Junio del 04, a las 14:40:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1468,6,'                              ','Lunes 7 de Junio del 04, a las 14:40:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1469,6,'                              ','Lunes 7 de Junio del 04, a las 14:42:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1470,6,'                              ','Lunes 7 de Junio del 04, a las 14:45:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1471,6,'                              ','Lunes 7 de Junio del 04, a las 14:47:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1472,3,'                              ','Lunes 7 de Junio del 04, a las 14:54:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1473,6,'                              ','Lunes 7 de Junio del 04, a las 14:56:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1474,9,'                              ','Lunes 7 de Junio del 04, a las 15:00:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1475,3,'                              ','Lunes 7 de Junio del 04, a las 15:09:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1476,3,'                              ','Lunes 7 de Junio del 04, a las 15:45:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1477,10,'                              ','Lunes 7 de Junio del 04, a las 15:47:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1478,8,'                              ','Lunes 7 de Junio del 04, a las 15:50:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1479,8,'                              ','Lunes 7 de Junio del 04, a las 16:16:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1480,11,'                              ','Lunes 7 de Junio del 04, a las 16:34:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1481,4,'                              ','Lunes 7 de Junio del 04, a las 16:55:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1482,53,'                              ','Lunes 7 de Junio del 04, a las 16:58:50           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1483,53,'                              ','Lunes 7 de Junio del 04, a las 16:59:27           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1484,53,'                              ','Lunes 7 de Junio del 04, a las 16:59:54           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1485,9,'                              ','Lunes 7 de Junio del 04, a las 17:04:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1486,4,'                              ','Lunes 7 de Junio del 04, a las 17:06:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1487,10,'                              ','Lunes 7 de Junio del 04, a las 17:07:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1488,8,'                              ','Lunes 7 de Junio del 04, a las 17:10:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1489,8,'                              ','Lunes 7 de Junio del 04, a las 17:14:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1490,11,'                              ','Lunes 7 de Junio del 04, a las 17:17:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1491,6,'                              ','Martes 8 de Junio del 04, a las 10:01:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1492,3,'                              ','Martes 8 de Junio del 04, a las 10:02:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1493,6,'                              ','Martes 8 de Junio del 04, a las 10:05:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1494,4,'                              ','Martes 8 de Junio del 04, a las 10:06:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1495,9,'                              ','Martes 8 de Junio del 04, a las 10:11:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1496,10,'                              ','Martes 8 de Junio del 04, a las 10:13:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1497,8,'                              ','Martes 8 de Junio del 04, a las 10:16:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1498,8,'                              ','Martes 8 de Junio del 04, a las 10:17:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1499,8,'                              ','Martes 8 de Junio del 04, a las 10:18:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1500,8,'                              ','Martes 8 de Junio del 04, a las 10:26:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1501,8,'                              ','Martes 8 de Junio del 04, a las 10:29:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1502,11,'                              ','Martes 8 de Junio del 04, a las 10:35:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1503,11,'                              ','Martes 8 de Junio del 04, a las 10:37:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1504,3,'                              ','Martes 8 de Junio del 04, a las 10:44:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1505,6,'                              ','Martes 8 de Junio del 04, a las 10:50:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1506,9,'                              ','Martes 8 de Junio del 04, a las 11:08:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1507,8,'                              ','Martes 8 de Junio del 04, a las 11:21:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1508,8,'                              ','Martes 8 de Junio del 04, a las 11:21:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1509,8,'                              ','Martes 8 de Junio del 04, a las 11:45:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1510,11,'                              ','Martes 8 de Junio del 04, a las 11:46:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1511,11,'                              ','Martes 8 de Junio del 04, a las 11:48:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1512,11,'                              ','Martes 8 de Junio del 04, a las 11:51:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1513,4,'                              ','Martes 8 de Junio del 04, a las 11:56:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1514,9,'                              ','Martes 8 de Junio del 04, a las 12:01:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1515,10,'                              ','Martes 8 de Junio del 04, a las 12:03:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1516,8,'                              ','Martes 8 de Junio del 04, a las 12:08:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1517,8,'                              ','Martes 8 de Junio del 04, a las 12:32:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1518,8,'                              ','Martes 8 de Junio del 04, a las 12:35:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1519,8,'                              ','Martes 8 de Junio del 04, a las 12:38:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1520,8,'                              ','Martes 8 de Junio del 04, a las 12:43:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1521,11,'                              ','Martes 8 de Junio del 04, a las 12:50:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1522,3,'                              ','Martes 8 de Junio del 04, a las 12:56:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1523,6,'                              ','Martes 8 de Junio del 04, a las 13:01:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1524,11,'                              ','Martes 8 de Junio del 04, a las 13:37:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1525,11,'                              ','Martes 8 de Junio del 04, a las 13:38:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1526,11,'                              ','Martes 8 de Junio del 04, a las 13:39:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1527,9,'                              ','Martes 8 de Junio del 04, a las 13:40:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1528,8,'                              ','Martes 8 de Junio del 04, a las 13:43:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1529,8,'                              ','Martes 8 de Junio del 04, a las 13:44:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1530,8,'                              ','Martes 8 de Junio del 04, a las 13:48:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1531,11,'                              ','Martes 8 de Junio del 04, a las 13:49:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1532,11,'                              ','Martes 8 de Junio del 04, a las 13:57:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1533,11,'                              ','Martes 8 de Junio del 04, a las 13:58:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1534,10,'                              ','Martes 8 de Junio del 04, a las 14:00:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1535,9,'                              ','Martes 8 de Junio del 04, a las 14:01:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1536,3,'                              ','Martes 8 de Junio del 04, a las 14:24:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1537,6,'                              ','Martes 8 de Junio del 04, a las 14:27:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1538,11,'                              ','Martes 8 de Junio del 04, a las 14:30:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1539,9,'                              ','Martes 8 de Junio del 04, a las 14:31:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1540,10,'                              ','Martes 8 de Junio del 04, a las 14:33:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1541,8,'                              ','Martes 8 de Junio del 04, a las 14:40:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1542,8,'                              ','Martes 8 de Junio del 04, a las 14:43:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1543,11,'                              ','Martes 8 de Junio del 04, a las 14:45:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1544,11,'                              ','Martes 8 de Junio del 04, a las 14:59:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1545,3,'                              ','Martes 8 de Junio del 04, a las 15:03:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1546,3,'                              ','Martes 8 de Junio del 04, a las 15:04:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1547,6,'                              ','Martes 8 de Junio del 04, a las 15:06:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1548,9,'                              ','Martes 8 de Junio del 04, a las 15:09:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1549,10,'                              ','Martes 8 de Junio del 04, a las 15:10:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1550,10,'                              ','Martes 8 de Junio del 04, a las 16:04:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1551,11,'                              ','Martes 8 de Junio del 04, a las 16:05:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1552,11,'                              ','Martes 8 de Junio del 04, a las 16:06:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1553,4,'                              ','Martes 8 de Junio del 04, a las 16:06:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1554,4,'                              ','Martes 8 de Junio del 04, a las 16:07:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1555,8,'                              ','Martes 8 de Junio del 04, a las 16:21:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1556,8,'                              ','Martes 8 de Junio del 04, a las 16:56:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1557,8,'                              ','Martes 8 de Junio del 04, a las 16:58:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1558,8,'                              ','Martes 8 de Junio del 04, a las 16:59:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1559,11,'                              ','Martes 8 de Junio del 04, a las 17:03:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1560,8,'                              ','Martes 8 de Junio del 04, a las 17:07:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1561,11,'                              ','Martes 8 de Junio del 04, a las 17:08:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1562,11,'                              ','Martes 8 de Junio del 04, a las 17:09:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1563,11,'                              ','Martes 8 de Junio del 04, a las 17:10:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1564,11,'                              ','Martes 8 de Junio del 04, a las 17:11:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1565,8,'                              ','Martes 8 de Junio del 04, a las 17:12:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1566,8,'                              ','Martes 8 de Junio del 04, a las 17:13:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1567,8,'                              ','Martes 8 de Junio del 04, a las 17:15:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1568,8,'                              ','Martes 8 de Junio del 04, a las 17:18:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1569,8,'                              ','Martes 8 de Junio del 04, a las 17:20:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1570,8,'                              ','Martes 8 de Junio del 04, a las 17:21:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1571,4,'                              ','Martes 8 de Junio del 04, a las 17:22:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1572,11,'                              ','Martes 8 de Junio del 04, a las 17:24:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1573,4,'                              ','Martes 8 de Junio del 04, a las 17:25:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1574,11,'                              ','Martes 8 de Junio del 04, a las 17:26:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1575,4,'                              ','Martes 8 de Junio del 04, a las 17:27:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1576,8,'                              ','Martes 8 de Junio del 04, a las 17:28:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1577,8,'                              ','Martes 8 de Junio del 04, a las 17:29:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1578,8,'                              ','Martes 8 de Junio del 04, a las 17:32:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1579,4,'                              ','Martes 8 de Junio del 04, a las 17:34:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1580,8,'                              ','Martes 8 de Junio del 04, a las 17:43:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1581,4,'                              ','Martes 8 de Junio del 04, a las 17:44:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1582,8,'                              ','Martes 8 de Junio del 04, a las 17:46:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1583,4,'                              ','Martes 8 de Junio del 04, a las 17:47:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1584,8,'                              ','Martes 8 de Junio del 04, a las 17:48:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1585,4,'                              ','Martes 8 de Junio del 04, a las 17:49:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1586,8,'                              ','Martes 8 de Junio del 04, a las 17:50:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1587,11,'                              ','Martes 8 de Junio del 04, a las 17:51:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1588,4,'                              ','Martes 8 de Junio del 04, a las 17:53:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1589,8,'                              ','Martes 8 de Junio del 04, a las 17:54:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1590,4,'                              ','Martes 8 de Junio del 04, a las 17:55:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1591,8,'                              ','Martes 8 de Junio del 04, a las 17:56:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1592,8,'                              ','Martes 8 de Junio del 04, a las 17:57:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1593,11,'                              ','Martes 8 de Junio del 04, a las 17:58:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1594,11,'                              ','Martes 8 de Junio del 04, a las 17:58:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1595,4,'                              ','Martes 8 de Junio del 04, a las 17:59:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1596,8,'                              ','Martes 8 de Junio del 04, a las 18:00:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1597,4,'                              ','Martes 8 de Junio del 04, a las 18:01:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1598,8,'                              ','Martes 8 de Junio del 04, a las 18:02:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1599,4,'                              ','Martes 8 de Junio del 04, a las 18:03:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1600,8,'                              ','Martes 8 de Junio del 04, a las 18:03:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1601,4,'                              ','Martes 8 de Junio del 04, a las 18:04:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1602,8,'                              ','Martes 8 de Junio del 04, a las 18:05:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1603,4,'                              ','Martes 8 de Junio del 04, a las 18:06:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1604,8,'                              ','Martes 8 de Junio del 04, a las 18:07:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1605,4,'                              ','Martes 8 de Junio del 04, a las 18:09:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1606,8,'                              ','Martes 8 de Junio del 04, a las 18:10:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1607,6,'                              ','Martes 8 de Junio del 04, a las 18:40:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1608,6,'                              ','Martes 8 de Junio del 04, a las 18:41:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1609,6,'                              ','Martes 8 de Junio del 04, a las 18:43:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1610,6,'                              ','Martes 8 de Junio del 04, a las 18:45:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1611,6,'                              ','Martes 8 de Junio del 04, a las 18:46:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1612,6,'                              ','Martes 8 de Junio del 04, a las 18:48:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1613,4,'                              ','Martes 8 de Junio del 04, a las 18:49:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1614,4,'                              ','Martes 8 de Junio del 04, a las 18:53:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1615,8,'                              ','Martes 8 de Junio del 04, a las 18:53:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1616,4,'                              ','Martes 8 de Junio del 04, a las 18:55:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1617,4,'                              ','Martes 8 de Junio del 04, a las 18:56:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1618,8,'                              ','Martes 8 de Junio del 04, a las 18:57:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1619,4,'                              ','Martes 8 de Junio del 04, a las 18:58:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1620,8,'                              ','Martes 8 de Junio del 04, a las 18:58:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1621,8,'                              ','Martes 8 de Junio del 04, a las 18:59:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1622,8,'                              ','Martes 8 de Junio del 04, a las 19:00:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1623,3,'                              ','Mircoles 9 de Junio del 04, a las 09:54:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1624,3,'                              ','Mircoles 9 de Junio del 04, a las 09:54:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1625,4,'                              ','Mircoles 9 de Junio del 04, a las 10:00:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1626,4,'                              ','Mircoles 9 de Junio del 04, a las 10:03:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1627,4,'                              ','Mircoles 9 de Junio del 04, a las 10:35:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1628,9,'                              ','Mircoles 9 de Junio del 04, a las 10:41:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1629,4,'                              ','Mircoles 9 de Junio del 04, a las 10:43:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1630,10,'                              ','Mircoles 9 de Junio del 04, a las 10:47:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1631,8,'                              ','Mircoles 9 de Junio del 04, a las 10:52:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1632,8,'                              ','Mircoles 9 de Junio del 04, a las 10:57:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1633,8,'                              ','Mircoles 9 de Junio del 04, a las 11:01:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1634,11,'                              ','Mircoles 9 de Junio del 04, a las 11:04:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1635,11,'                              ','Mircoles 9 de Junio del 04, a las 11:05:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1636,11,'                              ','Mircoles 9 de Junio del 04, a las 11:05:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1637,3,'                              ','Mircoles 9 de Junio del 04, a las 11:27:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1638,9,'                              ','Mircoles 9 de Junio del 04, a las 11:40:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1639,4,'                              ','Mircoles 9 de Junio del 04, a las 11:40:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1640,4,'                              ','Mircoles 9 de Junio del 04, a las 11:42:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1641,4,'                              ','Mircoles 9 de Junio del 04, a las 11:43:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1642,10,'                              ','Mircoles 9 de Junio del 04, a las 11:45:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1643,10,'                              ','Mircoles 9 de Junio del 04, a las 11:45:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1644,8,'                              ','Mircoles 9 de Junio del 04, a las 11:58:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1645,8,'                              ','Mircoles 9 de Junio del 04, a las 12:05:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1646,8,'                              ','Mircoles 9 de Junio del 04, a las 12:06:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1647,8,'                              ','Mircoles 9 de Junio del 04, a las 12:09:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1648,11,'                              ','Mircoles 9 de Junio del 04, a las 12:11:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1649,11,'                              ','Mircoles 9 de Junio del 04, a las 12:14:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1650,6,'                              ','Mircoles 9 de Junio del 04, a las 12:45:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1651,9,'                              ','Mircoles 9 de Junio del 04, a las 13:14:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1652,4,'                              ','Mircoles 9 de Junio del 04, a las 13:16:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1653,8,'                              ','Mircoles 9 de Junio del 04, a las 13:20:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1654,8,'                              ','Mircoles 9 de Junio del 04, a las 13:20:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1655,8,'                              ','Mircoles 9 de Junio del 04, a las 13:25:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1656,11,'                              ','Mircoles 9 de Junio del 04, a las 13:28:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1657,10,'                              ','Mircoles 9 de Junio del 04, a las 13:29:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1658,6,'                              ','Mircoles 9 de Junio del 04, a las 16:51:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1659,6,'                              ','Mircoles 9 de Junio del 04, a las 16:56:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1660,6,'                              ','Mircoles 9 de Junio del 04, a las 16:57:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1661,6,'                              ','Mircoles 9 de Junio del 04, a las 16:58:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1662,6,'                              ','Mircoles 9 de Junio del 04, a las 16:58:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1663,6,'                              ','Jueves 10 de Junio del 04, a las 10:42:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1664,6,'                              ','Jueves 10 de Junio del 04, a las 10:43:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1665,6,'                              ','Jueves 10 de Junio del 04, a las 10:45:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1666,6,'                              ','Jueves 10 de Junio del 04, a las 10:46:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1667,6,'                              ','Jueves 10 de Junio del 04, a las 10:49:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1668,6,'                              ','Jueves 10 de Junio del 04, a las 10:51:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1669,6,'                              ','Jueves 10 de Junio del 04, a las 10:52:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1670,6,'                              ','Jueves 10 de Junio del 04, a las 10:53:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1671,6,'                              ','Jueves 10 de Junio del 04, a las 10:53:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1672,4,'                              ','Jueves 10 de Junio del 04, a las 10:59:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1673,6,'                              ','Jueves 10 de Junio del 04, a las 13:28:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1674,9,'                              ','Jueves 10 de Junio del 04, a las 14:31:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1675,4,'                              ','Jueves 10 de Junio del 04, a las 14:37:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1676,10,'                              ','Jueves 10 de Junio del 04, a las 14:39:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1677,8,'                              ','Jueves 10 de Junio del 04, a las 14:49:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1678,8,'                              ','Jueves 10 de Junio del 04, a las 15:17:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1679,8,'                              ','Jueves 10 de Junio del 04, a las 15:17:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1680,11,'                              ','Jueves 10 de Junio del 04, a las 15:23:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1681,11,'                              ','Jueves 10 de Junio del 04, a las 15:29:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1682,9,'                              ','Jueves 10 de Junio del 04, a las 15:35:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1683,10,'                              ','Jueves 10 de Junio del 04, a las 15:39:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1684,10,'                              ','Jueves 10 de Junio del 04, a las 15:40:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1685,8,'                              ','Jueves 10 de Junio del 04, a las 15:47:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1686,8,'                              ','Jueves 10 de Junio del 04, a las 15:48:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1687,11,'                              ','Jueves 10 de Junio del 04, a las 15:49:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1688,11,'                              ','Jueves 10 de Junio del 04, a las 15:54:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1689,11,'                              ','Jueves 10 de Junio del 04, a las 15:55:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1690,11,'                              ','Jueves 10 de Junio del 04, a las 15:57:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1691,6,'                              ','Viernes 11 de Junio del 04, a las 10:18:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1692,4,'                              ','Viernes 11 de Junio del 04, a las 10:27:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1693,8,'                              ','Viernes 11 de Junio del 04, a las 11:08:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1694,8,'                              ','Viernes 11 de Junio del 04, a las 11:09:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1695,11,'                              ','Viernes 11 de Junio del 04, a las 11:12:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1696,4,'                              ','Viernes 11 de Junio del 04, a las 11:14:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1697,6,'                              ','Viernes 11 de Junio del 04, a las 11:54:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1698,4,'                              ','Viernes 11 de Junio del 04, a las 12:05:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1699,8,'                              ','Viernes 11 de Junio del 04, a las 12:11:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1700,10,'                              ','Viernes 11 de Junio del 04, a las 12:15:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1701,11,'                              ','Viernes 11 de Junio del 04, a las 12:31:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1702,6,'                              ','Viernes 11 de Junio del 04, a las 13:05:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1703,6,'                              ','Viernes 11 de Junio del 04, a las 13:08:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1704,53,'                              ','Viernes 11 de Junio del 04, a las 14:22:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1705,6,'                              ','Viernes 11 de Junio del 04, a las 14:24:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1706,9,'                              ','Viernes 11 de Junio del 04, a las 14:37:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1707,4,'                              ','Lunes 14 de Junio del 04, a las 14:19:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1708,10,'                              ','Lunes 14 de Junio del 04, a las 14:26:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1709,4,'                              ','Martes 15 de Junio del 04, a las 18:56:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1710,4,'                              ','Martes 15 de Junio del 04, a las 18:57:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1711,4,'                              ','Martes 15 de Junio del 04, a las 18:58:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1712,4,'                              ','Martes 15 de Junio del 04, a las 18:58:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1713,4,'                              ','Martes 15 de Junio del 04, a las 19:00:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1714,4,'                              ','Martes 15 de Junio del 04, a las 19:01:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1715,4,'                              ','Martes 15 de Junio del 04, a las 19:02:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1716,4,'                              ','Martes 15 de Junio del 04, a las 19:02:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1717,8,'                              ','Mircoles 16 de Junio del 04, a las 07:59:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1718,8,'                              ','Mircoles 16 de Junio del 04, a las 14:13:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1719,11,'                              ','Mircoles 16 de Junio del 04, a las 14:14:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1720,4,'                              ','Mircoles 16 de Junio del 04, a las 14:43:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1721,4,'                              ','Jueves 17 de Junio del 04, a las 15:28:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1722,4,'                              ','Jueves 17 de Junio del 04, a las 15:28:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1723,8,'                              ','Jueves 17 de Junio del 04, a las 15:45:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1724,8,'                              ','Jueves 17 de Junio del 04, a las 15:49:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1725,8,'                              ','Jueves 17 de Junio del 04, a las 15:49:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1726,11,'                              ','Jueves 17 de Junio del 04, a las 15:52:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1727,11,'                              ','Jueves 17 de Junio del 04, a las 15:54:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1728,11,'                              ','Jueves 17 de Junio del 04, a las 15:56:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1729,11,'                              ','Jueves 17 de Junio del 04, a las 16:00:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1730,11,'                              ','Jueves 17 de Junio del 04, a las 16:00:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1731,11,'                              ','Jueves 17 de Junio del 04, a las 16:08:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1732,6,'                              ','Jueves 17 de Junio del 04, a las 16:15:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1733,6,'                              ','Jueves 17 de Junio del 04, a las 16:17:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1734,11,'                              ','Jueves 17 de Junio del 04, a las 16:23:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1735,11,'                              ','Jueves 17 de Junio del 04, a las 16:32:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1736,11,'                              ','Jueves 17 de Junio del 04, a las 16:34:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1737,11,'                              ','Jueves 17 de Junio del 04, a las 16:41:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1738,11,'                              ','Jueves 17 de Junio del 04, a las 17:47:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1739,11,'                              ','Jueves 17 de Junio del 04, a las 17:47:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1740,11,'                              ','Jueves 17 de Junio del 04, a las 17:50:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1741,11,'                              ','Jueves 17 de Junio del 04, a las 17:53:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1742,11,'                              ','Jueves 17 de Junio del 04, a las 17:59:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1743,11,'                              ','Jueves 17 de Junio del 04, a las 18:11:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1744,11,'                              ','Jueves 17 de Junio del 04, a las 18:13:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1745,11,'                              ','Jueves 17 de Junio del 04, a las 18:15:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1746,11,'                              ','Jueves 17 de Junio del 04, a las 18:16:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1747,11,'                              ','Jueves 17 de Junio del 04, a las 18:17:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1748,4,'                              ','Viernes 18 de Junio del 04, a las 16:54:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1749,11,'                              ','Viernes 18 de Junio del 04, a las 16:57:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1750,9,'                              ','Viernes 18 de Junio del 04, a las 16:59:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1751,4,'                              ','Viernes 18 de Junio del 04, a las 17:01:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1752,10,'                              ','Viernes 18 de Junio del 04, a las 17:02:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1753,8,'                              ','Viernes 18 de Junio del 04, a las 17:07:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1754,8,'                              ','Viernes 18 de Junio del 04, a las 17:13:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1755,8,'                              ','Viernes 18 de Junio del 04, a las 17:18:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1756,11,'                              ','Viernes 18 de Junio del 04, a las 17:22:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1757,2,'Bib Datos Propopios           ','Viernes 18 de Junio del 04, a las 17:32:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1758,6,'                              ','Viernes 18 de Junio del 04, a las 17:34:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1759,4,'                              ','Viernes 18 de Junio del 04, a las 17:36:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1760,9,'                              ','Viernes 18 de Junio del 04, a las 17:40:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1761,4,'                              ','Viernes 18 de Junio del 04, a las 17:42:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1762,4,'                              ','Viernes 18 de Junio del 04, a las 17:42:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1763,10,'                              ','Viernes 18 de Junio del 04, a las 17:45:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1764,8,'                              ','Viernes 18 de Junio del 04, a las 17:56:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1765,8,'                              ','Viernes 18 de Junio del 04, a las 18:08:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1766,8,'                              ','Viernes 18 de Junio del 04, a las 18:11:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1767,8,'                              ','Viernes 18 de Junio del 04, a las 18:15:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1768,11,'                              ','Viernes 18 de Junio del 04, a las 18:20:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1769,11,'                              ','Viernes 18 de Junio del 04, a las 18:21:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1770,11,'                              ','Viernes 18 de Junio del 04, a las 18:22:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1771,11,'                              ','Viernes 18 de Junio del 04, a las 18:23:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1772,10,'                              ','Viernes 18 de Junio del 04, a las 18:24:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1773,4,'                              ','Lunes 21 de Junio del 04, a las 09:39:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1774,9,'                              ','Lunes 21 de Junio del 04, a las 09:45:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1775,4,'                              ','Lunes 21 de Junio del 04, a las 09:48:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1776,10,'                              ','Lunes 21 de Junio del 04, a las 09:52:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1777,10,'                              ','Lunes 21 de Junio del 04, a las 10:02:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1778,4,'                              ','Lunes 21 de Junio del 04, a las 10:05:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1779,8,'                              ','Lunes 21 de Junio del 04, a las 10:35:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1780,8,'                              ','Lunes 21 de Junio del 04, a las 10:39:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1781,11,'                              ','Lunes 21 de Junio del 04, a las 10:42:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1782,11,'                              ','Lunes 21 de Junio del 04, a las 10:46:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1783,8,'                              ','Lunes 21 de Junio del 04, a las 10:53:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1784,4,'                              ','Lunes 21 de Junio del 04, a las 11:02:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1785,4,'                              ','Lunes 21 de Junio del 04, a las 11:10:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1786,6,'                              ','Lunes 21 de Junio del 04, a las 11:15:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1787,4,'                              ','Lunes 21 de Junio del 04, a las 11:17:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1788,9,'                              ','Lunes 21 de Junio del 04, a las 11:26:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1789,4,'                              ','Lunes 21 de Junio del 04, a las 11:38:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1790,10,'                              ','Lunes 21 de Junio del 04, a las 11:40:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1791,8,'                              ','Lunes 21 de Junio del 04, a las 11:48:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1792,8,'                              ','Lunes 21 de Junio del 04, a las 11:50:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1793,11,'                              ','Lunes 21 de Junio del 04, a las 11:52:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1794,11,'                              ','Lunes 21 de Junio del 04, a las 11:56:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1795,10,'                              ','Lunes 21 de Junio del 04, a las 11:57:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1796,11,'                              ','Lunes 21 de Junio del 04, a las 12:12:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1797,11,'                              ','Lunes 21 de Junio del 04, a las 12:18:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1798,11,'                              ','Lunes 21 de Junio del 04, a las 12:19:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1799,6,'                              ','Lunes 21 de Junio del 04, a las 12:21:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1800,6,'                              ','Lunes 21 de Junio del 04, a las 12:23:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1801,6,'                              ','Lunes 21 de Junio del 04, a las 12:24:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1802,6,'                              ','Lunes 21 de Junio del 04, a las 12:26:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1803,2,'Bib Datos Propopios           ','Lunes 21 de Junio del 04, a las 12:31:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1804,4,'                              ','Lunes 21 de Junio del 04, a las 12:34:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1805,6,'                              ','Lunes 21 de Junio del 04, a las 12:37:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1806,9,'                              ','Lunes 21 de Junio del 04, a las 12:44:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1807,4,'                              ','Lunes 21 de Junio del 04, a las 12:47:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1808,10,'                              ','Lunes 21 de Junio del 04, a las 12:48:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1809,8,'                              ','Lunes 21 de Junio del 04, a las 12:53:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1810,8,'                              ','Lunes 21 de Junio del 04, a las 12:55:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1811,8,'                              ','Lunes 21 de Junio del 04, a las 12:56:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1812,8,'                              ','Lunes 21 de Junio del 04, a las 15:02:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1813,8,'                              ','Lunes 21 de Junio del 04, a las 15:03:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1814,8,'                              ','Lunes 21 de Junio del 04, a las 15:10:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1815,11,'                              ','Lunes 21 de Junio del 04, a las 15:48:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1816,4,'                              ','Lunes 21 de Junio del 04, a las 16:06:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1817,4,'                              ','Lunes 21 de Junio del 04, a las 16:08:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1818,4,'                              ','Lunes 21 de Junio del 04, a las 16:14:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1819,4,'                              ','Lunes 21 de Junio del 04, a las 16:19:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1820,4,'                              ','Lunes 21 de Junio del 04, a las 16:45:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1821,9,'                              ','Lunes 21 de Junio del 04, a las 16:51:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1822,4,'                              ','Lunes 21 de Junio del 04, a las 16:54:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1823,10,'                              ','Lunes 21 de Junio del 04, a las 16:55:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1824,8,'                              ','Lunes 21 de Junio del 04, a las 16:59:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1825,8,'                              ','Lunes 21 de Junio del 04, a las 16:59:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1826,8,'                              ','Lunes 21 de Junio del 04, a las 17:16:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1827,8,'                              ','Lunes 21 de Junio del 04, a las 17:21:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1828,8,'                              ','Lunes 21 de Junio del 04, a las 17:25:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1829,11,'                              ','Lunes 21 de Junio del 04, a las 17:30:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1830,2,'Bib Datos Propopios           ','Lunes 21 de Junio del 04, a las 17:38:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1831,2,'Bib Datos Propopios           ','Lunes 21 de Junio del 04, a las 17:40:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1832,2,'Bib Datos Propopios           ','Lunes 21 de Junio del 04, a las 17:44:34          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1833,6,'                              ','Lunes 21 de Junio del 04, a las 17:48:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1834,4,'                              ','Lunes 21 de Junio del 04, a las 17:49:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1835,9,'                              ','Lunes 21 de Junio del 04, a las 17:53:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1836,4,'                              ','Lunes 21 de Junio del 04, a las 17:54:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1837,10,'                              ','Lunes 21 de Junio del 04, a las 17:55:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1838,8,'                              ','Lunes 21 de Junio del 04, a las 18:00:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1839,8,'                              ','Lunes 21 de Junio del 04, a las 18:08:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1840,8,'                              ','Lunes 21 de Junio del 04, a las 18:11:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1841,8,'                              ','Lunes 21 de Junio del 04, a las 18:11:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1842,11,'                              ','Lunes 21 de Junio del 04, a las 18:13:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1843,11,'                              ','Lunes 21 de Junio del 04, a las 18:15:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1844,11,'                              ','Lunes 21 de Junio del 04, a las 18:18:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1845,4,'                              ','Lunes 21 de Junio del 04, a las 18:23:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1846,4,'                              ','Lunes 21 de Junio del 04, a las 18:25:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1847,4,'                              ','Lunes 21 de Junio del 04, a las 18:26:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1848,4,'                              ','Lunes 21 de Junio del 04, a las 18:30:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1849,4,'                              ','Lunes 21 de Junio del 04, a las 18:31:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1850,4,'                              ','Martes 22 de Junio del 04, a las 08:48:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1851,6,'                              ','Martes 22 de Junio del 04, a las 08:50:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1852,11,'                              ','Martes 22 de Junio del 04, a las 08:53:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1853,9,'                              ','Martes 22 de Junio del 04, a las 08:54:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1854,4,'                              ','Martes 22 de Junio del 04, a las 08:56:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1855,8,'                              ','Martes 22 de Junio del 04, a las 08:59:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1856,8,'                              ','Martes 22 de Junio del 04, a las 09:01:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1857,8,'                              ','Martes 22 de Junio del 04, a las 09:04:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1858,11,'                              ','Martes 22 de Junio del 04, a las 09:07:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1859,11,'                              ','Martes 22 de Junio del 04, a las 09:09:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1860,10,'                              ','Martes 22 de Junio del 04, a las 09:10:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1861,6,'                              ','Martes 22 de Junio del 04, a las 09:21:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1862,4,'                              ','Martes 22 de Junio del 04, a las 09:25:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1863,9,'                              ','Martes 22 de Junio del 04, a las 09:28:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1864,4,'                              ','Martes 22 de Junio del 04, a las 09:31:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1865,10,'                              ','Martes 22 de Junio del 04, a las 09:32:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1866,8,'                              ','Martes 22 de Junio del 04, a las 09:35:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1867,8,'                              ','Martes 22 de Junio del 04, a las 09:37:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1868,8,'                              ','Martes 22 de Junio del 04, a las 09:38:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1869,11,'                              ','Martes 22 de Junio del 04, a las 09:41:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1870,53,'                              ','Martes 22 de Junio del 04, a las 10:05:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1871,51,'Direccion                     ','Martes 22 de Junio del 04, a las 10:06:28         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1872,4,'                              ','Martes 22 de Junio del 04, a las 10:07:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1873,9,'                              ','Martes 22 de Junio del 04, a las 10:13:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1874,4,'                              ','Martes 22 de Junio del 04, a las 10:16:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1875,10,'                              ','Martes 22 de Junio del 04, a las 10:17:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1876,8,'                              ','Martes 22 de Junio del 04, a las 10:21:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1877,8,'                              ','Martes 22 de Junio del 04, a las 10:25:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1878,8,'                              ','Martes 22 de Junio del 04, a las 10:28:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1879,11,'                              ','Martes 22 de Junio del 04, a las 10:44:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1880,11,'                              ','Martes 22 de Junio del 04, a las 10:46:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1881,11,'                              ','Martes 22 de Junio del 04, a las 10:56:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1882,11,'                              ','Martes 22 de Junio del 04, a las 10:57:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1883,9,'                              ','Martes 22 de Junio del 04, a las 10:59:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1884,4,'                              ','Martes 22 de Junio del 04, a las 11:44:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1885,3,'                              ','Martes 22 de Junio del 04, a las 11:47:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1886,6,'                              ','Martes 22 de Junio del 04, a las 11:49:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1887,9,'                              ','Martes 22 de Junio del 04, a las 11:53:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1888,4,'                              ','Martes 22 de Junio del 04, a las 11:55:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1889,4,'                              ','Martes 22 de Junio del 04, a las 11:57:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1890,8,'                              ','Martes 22 de Junio del 04, a las 11:59:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1891,8,'                              ','Martes 22 de Junio del 04, a las 12:01:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1892,8,'                              ','Martes 22 de Junio del 04, a las 12:04:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1893,8,'                              ','Martes 22 de Junio del 04, a las 12:05:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1894,8,'                              ','Martes 22 de Junio del 04, a las 12:07:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1895,11,'                              ','Martes 22 de Junio del 04, a las 12:13:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1896,10,'                              ','Martes 22 de Junio del 04, a las 12:14:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1897,8,'                              ','Martes 22 de Junio del 04, a las 12:16:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1898,2,'Bib Datos Propopios           ','Martes 22 de Junio del 04, a las 12:22:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1899,4,'                              ','Martes 22 de Junio del 04, a las 12:27:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1900,4,'                              ','Martes 22 de Junio del 04, a las 12:36:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1901,9,'                              ','Martes 22 de Junio del 04, a las 12:39:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1902,4,'                              ','Martes 22 de Junio del 04, a las 12:41:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1903,10,'                              ','Martes 22 de Junio del 04, a las 12:42:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1904,8,'                              ','Martes 22 de Junio del 04, a las 12:51:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1905,8,'                              ','Martes 22 de Junio del 04, a las 12:52:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1906,8,'                              ','Martes 22 de Junio del 04, a las 12:53:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1907,8,'                              ','Martes 22 de Junio del 04, a las 12:55:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1908,11,'                              ','Martes 22 de Junio del 04, a las 13:00:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1909,53,'                              ','Martes 22 de Junio del 04, a las 13:04:05         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1910,6,'                              ','Martes 22 de Junio del 04, a las 13:05:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1911,4,'                              ','Martes 22 de Junio del 04, a las 13:06:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1912,9,'                              ','Martes 22 de Junio del 04, a las 13:08:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1913,4,'                              ','Martes 22 de Junio del 04, a las 14:36:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1914,10,'                              ','Martes 22 de Junio del 04, a las 14:38:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1915,8,'                              ','Martes 22 de Junio del 04, a las 14:41:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1916,8,'                              ','Martes 22 de Junio del 04, a las 14:41:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1917,8,'                              ','Martes 22 de Junio del 04, a las 14:44:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1918,11,'                              ','Martes 22 de Junio del 04, a las 14:48:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1919,11,'                              ','Martes 22 de Junio del 04, a las 14:49:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1920,11,'                              ','Martes 22 de Junio del 04, a las 14:51:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1921,11,'                              ','Martes 22 de Junio del 04, a las 14:51:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1922,3,'                              ','Martes 22 de Junio del 04, a las 14:57:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1923,3,'                              ','Martes 22 de Junio del 04, a las 15:01:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1924,6,'                              ','Martes 22 de Junio del 04, a las 15:02:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1925,4,'                              ','Martes 22 de Junio del 04, a las 15:04:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1926,9,'                              ','Martes 22 de Junio del 04, a las 15:16:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1927,4,'                              ','Martes 22 de Junio del 04, a las 15:19:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1928,10,'                              ','Martes 22 de Junio del 04, a las 15:21:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1929,8,'                              ','Martes 22 de Junio del 04, a las 15:26:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1930,8,'                              ','Martes 22 de Junio del 04, a las 15:29:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1931,11,'                              ','Martes 22 de Junio del 04, a las 15:33:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1932,11,'                              ','Martes 22 de Junio del 04, a las 15:35:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1933,6,'                              ','Martes 22 de Junio del 04, a las 15:43:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1934,6,'                              ','Martes 22 de Junio del 04, a las 15:44:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1935,6,'                              ','Martes 22 de Junio del 04, a las 15:49:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1936,6,'                              ','Martes 22 de Junio del 04, a las 15:50:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1937,6,'                              ','Martes 22 de Junio del 04, a las 15:52:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1938,4,'                              ','Martes 22 de Junio del 04, a las 15:58:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1939,9,'                              ','Martes 22 de Junio del 04, a las 16:03:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1940,4,'                              ','Martes 22 de Junio del 04, a las 16:06:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1941,10,'                              ','Martes 22 de Junio del 04, a las 16:07:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1942,8,'                              ','Martes 22 de Junio del 04, a las 16:09:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1943,8,'                              ','Martes 22 de Junio del 04, a las 16:13:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1944,8,'                              ','Martes 22 de Junio del 04, a las 16:16:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1945,8,'                              ','Martes 22 de Junio del 04, a las 16:18:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1946,11,'                              ','Martes 22 de Junio del 04, a las 16:22:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1947,11,'                              ','Martes 22 de Junio del 04, a las 16:23:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1948,11,'                              ','Martes 22 de Junio del 04, a las 16:23:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1949,11,'                              ','Martes 22 de Junio del 04, a las 16:29:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1950,6,'                              ','Martes 22 de Junio del 04, a las 16:36:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1951,3,'                              ','Martes 22 de Junio del 04, a las 16:39:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1952,3,'                              ','Martes 22 de Junio del 04, a las 16:40:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1953,3,'                              ','Martes 22 de Junio del 04, a las 16:40:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1954,9,'                              ','Martes 22 de Junio del 04, a las 16:44:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1955,10,'                              ','Martes 22 de Junio del 04, a las 16:46:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1956,8,'                              ','Martes 22 de Junio del 04, a las 17:35:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1957,8,'                              ','Martes 22 de Junio del 04, a las 17:41:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1958,11,'                              ','Martes 22 de Junio del 04, a las 17:47:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1959,10,'                              ','Martes 22 de Junio del 04, a las 17:48:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1960,4,'                              ','Mircoles 23 de Junio del 04, a las 08:49:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1961,9,'                              ','Mircoles 23 de Junio del 04, a las 08:53:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1962,4,'                              ','Mircoles 23 de Junio del 04, a las 08:55:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1963,4,'                              ','Mircoles 23 de Junio del 04, a las 08:57:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1964,10,'                              ','Mircoles 23 de Junio del 04, a las 08:58:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1965,8,'                              ','Mircoles 23 de Junio del 04, a las 09:05:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1966,8,'                              ','Mircoles 23 de Junio del 04, a las 09:07:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1967,8,'                              ','Mircoles 23 de Junio del 04, a las 09:11:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1968,8,'                              ','Mircoles 23 de Junio del 04, a las 09:21:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1969,8,'                              ','Mircoles 23 de Junio del 04, a las 09:22:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1970,8,'                              ','Mircoles 23 de Junio del 04, a las 09:27:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1971,11,'                              ','Mircoles 23 de Junio del 04, a las 09:30:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1972,11,'                              ','Mircoles 23 de Junio del 04, a las 09:33:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1973,2,'Bib Datos Propopios           ','Mircoles 23 de Junio del 04, a las 09:47:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1974,2,'Bib Datos Propopios           ','Mircoles 23 de Junio del 04, a las 09:49:39      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1975,2,'Bib Datos Propopios           ','Mircoles 23 de Junio del 04, a las 09:50:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1976,4,'                              ','Mircoles 23 de Junio del 04, a las 09:59:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1977,51,'Direccion                     ','Mircoles 23 de Junio del 04, a las 10:06:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1978,51,'Direccion                     ','Mircoles 23 de Junio del 04, a las 10:08:12      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1979,4,'                              ','Mircoles 23 de Junio del 04, a las 10:17:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1980,9,'                              ','Mircoles 23 de Junio del 04, a las 10:21:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1981,4,'                              ','Mircoles 23 de Junio del 04, a las 10:22:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1982,10,'                              ','Mircoles 23 de Junio del 04, a las 10:23:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1983,8,'                              ','Mircoles 23 de Junio del 04, a las 10:25:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1984,8,'                              ','Mircoles 23 de Junio del 04, a las 10:26:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1985,8,'                              ','Mircoles 23 de Junio del 04, a las 10:29:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1986,8,'                              ','Mircoles 23 de Junio del 04, a las 10:32:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1987,11,'                              ','Mircoles 23 de Junio del 04, a las 10:38:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1988,6,'                              ','Mircoles 23 de Junio del 04, a las 11:25:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1989,3,'                              ','Mircoles 23 de Junio del 04, a las 11:36:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1990,3,'                              ','Mircoles 23 de Junio del 04, a las 11:37:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1991,3,'                              ','Mircoles 23 de Junio del 04, a las 11:38:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1992,53,'                              ','Mircoles 23 de Junio del 04, a las 11:42:33      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1993,53,'                              ','Mircoles 23 de Junio del 04, a las 11:44:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1994,53,'                              ','Mircoles 23 de Junio del 04, a las 11:45:55      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1995,3,'                              ','Mircoles 23 de Junio del 04, a las 11:47:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1996,6,'                              ','Mircoles 23 de Junio del 04, a las 11:50:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1997,4,'                              ','Mircoles 23 de Junio del 04, a las 11:51:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1998,10,'                              ','Mircoles 23 de Junio del 04, a las 11:59:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (1999,8,'                              ','Mircoles 23 de Junio del 04, a las 12:08:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2000,11,'                              ','Mircoles 23 de Junio del 04, a las 12:13:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2001,11,'                              ','Mircoles 23 de Junio del 04, a las 12:13:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2002,11,'                              ','Mircoles 23 de Junio del 04, a las 12:15:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2003,10,'                              ','Mircoles 23 de Junio del 04, a las 12:16:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2004,9,'                              ','Mircoles 23 de Junio del 04, a las 12:18:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2005,4,'                              ','Mircoles 23 de Junio del 04, a las 12:32:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2006,53,'                              ','Mircoles 23 de Junio del 04, a las 12:32:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2007,6,'                              ','Mircoles 23 de Junio del 04, a las 12:33:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2008,6,'                              ','Mircoles 23 de Junio del 04, a las 12:35:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2009,6,'                              ','Mircoles 23 de Junio del 04, a las 12:40:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2010,53,'                              ','Mircoles 23 de Junio del 04, a las 12:42:44      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2011,53,'                              ','Mircoles 23 de Junio del 04, a las 12:45:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2012,4,'                              ','Mircoles 23 de Junio del 04, a las 12:46:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2013,9,'                              ','Mircoles 23 de Junio del 04, a las 12:49:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2014,10,'                              ','Mircoles 23 de Junio del 04, a las 12:50:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2015,8,'                              ','Mircoles 23 de Junio del 04, a las 12:53:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2016,8,'                              ','Mircoles 23 de Junio del 04, a las 12:54:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2017,8,'                              ','Mircoles 23 de Junio del 04, a las 12:57:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2018,11,'                              ','Mircoles 23 de Junio del 04, a las 13:01:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2019,11,'                              ','Mircoles 23 de Junio del 04, a las 13:03:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2020,10,'                              ','Mircoles 23 de Junio del 04, a las 13:04:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2021,11,'                              ','Mircoles 23 de Junio del 04, a las 13:06:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2022,3,'                              ','Mircoles 23 de Junio del 04, a las 13:07:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2023,11,'                              ','Mircoles 23 de Junio del 04, a las 13:08:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2024,3,'                              ','Mircoles 23 de Junio del 04, a las 13:11:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2025,6,'                              ','Mircoles 23 de Junio del 04, a las 13:14:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2026,4,'                              ','Mircoles 23 de Junio del 04, a las 13:17:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2027,9,'                              ','Mircoles 23 de Junio del 04, a las 14:25:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2028,9,'                              ','Mircoles 23 de Junio del 04, a las 14:26:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2029,10,'                              ','Mircoles 23 de Junio del 04, a las 14:27:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2030,8,'                              ','Mircoles 23 de Junio del 04, a las 14:30:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2031,8,'                              ','Mircoles 23 de Junio del 04, a las 14:36:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2032,8,'                              ','Mircoles 23 de Junio del 04, a las 14:39:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2033,8,'                              ','Mircoles 23 de Junio del 04, a las 14:39:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2034,11,'                              ','Mircoles 23 de Junio del 04, a las 14:42:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2035,10,'                              ','Mircoles 23 de Junio del 04, a las 14:45:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2036,3,'                              ','Mircoles 23 de Junio del 04, a las 14:52:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2037,6,'                              ','Mircoles 23 de Junio del 04, a las 15:01:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2038,53,'                              ','Mircoles 23 de Junio del 04, a las 15:03:33      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2039,3,'                              ','Mircoles 23 de Junio del 04, a las 15:05:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2040,4,'                              ','Mircoles 23 de Junio del 04, a las 15:06:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2041,9,'                              ','Mircoles 23 de Junio del 04, a las 15:09:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2042,10,'                              ','Mircoles 23 de Junio del 04, a las 15:11:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2043,8,'                              ','Mircoles 23 de Junio del 04, a las 15:13:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2044,8,'                              ','Mircoles 23 de Junio del 04, a las 15:14:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2045,8,'                              ','Mircoles 23 de Junio del 04, a las 15:17:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2046,11,'                              ','Mircoles 23 de Junio del 04, a las 15:24:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2047,10,'                              ','Mircoles 23 de Junio del 04, a las 15:28:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2048,10,'                              ','Mircoles 23 de Junio del 04, a las 15:28:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2049,4,'                              ','Mircoles 23 de Junio del 04, a las 15:33:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2050,3,'                              ','Mircoles 23 de Junio del 04, a las 15:35:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2051,3,'                              ','Mircoles 23 de Junio del 04, a las 15:35:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2052,3,'                              ','Mircoles 23 de Junio del 04, a las 15:36:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2053,3,'                              ','Mircoles 23 de Junio del 04, a las 15:37:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2054,3,'                              ','Mircoles 23 de Junio del 04, a las 15:38:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2055,6,'                              ','Mircoles 23 de Junio del 04, a las 15:40:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2056,6,'                              ','Mircoles 23 de Junio del 04, a las 15:43:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2057,3,'                              ','Mircoles 23 de Junio del 04, a las 15:47:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2058,3,'                              ','Mircoles 23 de Junio del 04, a las 15:49:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2059,3,'                              ','Mircoles 23 de Junio del 04, a las 15:50:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2060,3,'                              ','Mircoles 23 de Junio del 04, a las 15:50:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2061,3,'                              ','Mircoles 23 de Junio del 04, a las 15:51:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2062,9,'                              ','Mircoles 23 de Junio del 04, a las 15:55:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2063,10,'                              ','Mircoles 23 de Junio del 04, a las 15:57:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2064,8,'                              ','Mircoles 23 de Junio del 04, a las 16:00:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2065,8,'                              ','Mircoles 23 de Junio del 04, a las 16:03:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2066,11,'                              ','Mircoles 23 de Junio del 04, a las 16:05:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2067,11,'                              ','Mircoles 23 de Junio del 04, a las 16:07:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2068,10,'                              ','Mircoles 23 de Junio del 04, a las 16:12:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2069,3,'                              ','Mircoles 23 de Junio del 04, a las 16:17:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2070,3,'                              ','Mircoles 23 de Junio del 04, a las 16:19:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2071,6,'                              ','Mircoles 23 de Junio del 04, a las 16:21:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2072,6,'                              ','Mircoles 23 de Junio del 04, a las 16:24:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2073,6,'                              ','Mircoles 23 de Junio del 04, a las 16:27:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2074,4,'                              ','Mircoles 23 de Junio del 04, a las 16:28:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2075,9,'                              ','Mircoles 23 de Junio del 04, a las 16:31:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2076,10,'                              ','Mircoles 23 de Junio del 04, a las 16:33:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2077,8,'                              ','Mircoles 23 de Junio del 04, a las 16:35:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2078,8,'                              ','Mircoles 23 de Junio del 04, a las 16:36:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2079,8,'                              ','Mircoles 23 de Junio del 04, a las 16:38:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2080,11,'                              ','Mircoles 23 de Junio del 04, a las 16:40:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2081,10,'                              ','Mircoles 23 de Junio del 04, a las 16:41:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2082,3,'                              ','Jueves 24 de Junio del 04, a las 11:50:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2083,4,'                              ','Jueves 24 de Junio del 04, a las 11:51:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2084,6,'                              ','Jueves 24 de Junio del 04, a las 11:56:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2085,4,'                              ','Jueves 24 de Junio del 04, a las 11:57:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2086,11,'                              ','Jueves 24 de Junio del 04, a las 12:01:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2087,9,'                              ','Jueves 24 de Junio del 04, a las 12:03:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2088,10,'                              ','Jueves 24 de Junio del 04, a las 12:13:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2089,8,'                              ','Jueves 24 de Junio del 04, a las 12:16:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2090,8,'                              ','Jueves 24 de Junio del 04, a las 12:18:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2091,8,'                              ','Jueves 24 de Junio del 04, a las 12:20:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2092,8,'                              ','Jueves 24 de Junio del 04, a las 12:24:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2093,11,'                              ','Jueves 24 de Junio del 04, a las 12:28:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2094,11,'                              ','Jueves 24 de Junio del 04, a las 12:59:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2095,11,'                              ','Jueves 24 de Junio del 04, a las 13:00:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2096,11,'                              ','Jueves 24 de Junio del 04, a las 13:01:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2097,11,'                              ','Jueves 24 de Junio del 04, a las 13:02:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2098,10,'                              ','Jueves 24 de Junio del 04, a las 13:04:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2099,6,'                              ','Jueves 24 de Junio del 04, a las 13:10:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2100,53,'                              ','Jueves 24 de Junio del 04, a las 13:16:33         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2101,53,'                              ','Jueves 24 de Junio del 04, a las 13:17:18         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2102,4,'                              ','Jueves 24 de Junio del 04, a las 13:18:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2103,4,'                              ','Jueves 24 de Junio del 04, a las 13:20:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2104,4,'                              ','Jueves 24 de Junio del 04, a las 13:23:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2105,3,'                              ','Jueves 24 de Junio del 04, a las 14:58:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2106,6,'                              ','Jueves 24 de Junio del 04, a las 15:01:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2107,6,'                              ','Jueves 24 de Junio del 04, a las 15:02:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2108,6,'                              ','Jueves 24 de Junio del 04, a las 15:05:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2109,4,'                              ','Jueves 24 de Junio del 04, a las 15:06:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2110,6,'                              ','Jueves 24 de Junio del 04, a las 15:11:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2111,9,'                              ','Jueves 24 de Junio del 04, a las 15:19:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2112,4,'                              ','Jueves 24 de Junio del 04, a las 15:22:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2113,10,'                              ','Jueves 24 de Junio del 04, a las 15:49:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2114,4,'                              ','Jueves 24 de Junio del 04, a las 15:51:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2115,8,'                              ','Jueves 24 de Junio del 04, a las 15:55:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2116,8,'                              ','Jueves 24 de Junio del 04, a las 16:00:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2117,8,'                              ','Jueves 24 de Junio del 04, a las 16:02:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2118,11,'                              ','Jueves 24 de Junio del 04, a las 16:09:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2119,6,'                              ','Jueves 24 de Junio del 04, a las 16:22:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2120,3,'                              ','Jueves 24 de Junio del 04, a las 16:28:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2121,4,'                              ','Jueves 24 de Junio del 04, a las 16:31:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2122,3,'                              ','Jueves 24 de Junio del 04, a las 16:35:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2123,4,'                              ','Jueves 24 de Junio del 04, a las 16:35:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2124,53,'                              ','Jueves 24 de Junio del 04, a las 16:37:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2125,6,'                              ','Jueves 24 de Junio del 04, a las 16:42:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2126,9,'                              ','Jueves 24 de Junio del 04, a las 16:43:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2127,6,'                              ','Jueves 24 de Junio del 04, a las 16:45:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2128,10,'                              ','Jueves 24 de Junio del 04, a las 16:46:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2129,8,'                              ','Jueves 24 de Junio del 04, a las 16:50:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2130,8,'                              ','Jueves 24 de Junio del 04, a las 16:53:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2131,11,'                              ','Jueves 24 de Junio del 04, a las 16:55:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2132,3,'                              ','Jueves 24 de Junio del 04, a las 16:57:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2133,6,'                              ','Jueves 24 de Junio del 04, a las 17:00:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2134,6,'                              ','Jueves 24 de Junio del 04, a las 17:02:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2135,6,'                              ','Jueves 24 de Junio del 04, a las 17:03:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2136,3,'                              ','Jueves 24 de Junio del 04, a las 17:10:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2137,3,'                              ','Jueves 24 de Junio del 04, a las 17:10:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2138,53,'                              ','Jueves 24 de Junio del 04, a las 17:12:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2139,53,'                              ','Jueves 24 de Junio del 04, a las 17:12:51         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2140,51,'Direccion                     ','Jueves 24 de Junio del 04, a las 17:14:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2141,9,'                              ','Jueves 24 de Junio del 04, a las 17:18:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2142,4,'                              ','Jueves 24 de Junio del 04, a las 17:20:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2143,10,'                              ','Jueves 24 de Junio del 04, a las 17:21:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2144,8,'                              ','Jueves 24 de Junio del 04, a las 17:25:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2145,8,'                              ','Jueves 24 de Junio del 04, a las 17:29:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2146,8,'                              ','Jueves 24 de Junio del 04, a las 17:32:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2147,8,'                              ','Jueves 24 de Junio del 04, a las 17:33:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2148,11,'                              ','Jueves 24 de Junio del 04, a las 17:36:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2149,2,'Bib Datos Propopios           ','Jueves 24 de Junio del 04, a las 17:42:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2150,2,'Bib Datos Propopios           ','Jueves 24 de Junio del 04, a las 17:43:19         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2151,3,'                              ','Jueves 24 de Junio del 04, a las 17:47:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2152,53,'                              ','Jueves 24 de Junio del 04, a las 17:48:51         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2153,53,'                              ','Jueves 24 de Junio del 04, a las 17:49:16         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2154,53,'                              ','Jueves 24 de Junio del 04, a las 17:49:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2155,4,'                              ','Jueves 24 de Junio del 04, a las 17:51:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2156,9,'                              ','Jueves 24 de Junio del 04, a las 17:54:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2157,9,'                              ','Jueves 24 de Junio del 04, a las 17:54:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2158,4,'                              ','Jueves 24 de Junio del 04, a las 17:56:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2159,4,'                              ','Jueves 24 de Junio del 04, a las 17:57:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2160,10,'                              ','Jueves 24 de Junio del 04, a las 17:58:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2161,8,'                              ','Jueves 24 de Junio del 04, a las 18:01:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2162,8,'                              ','Jueves 24 de Junio del 04, a las 18:05:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2163,11,'                              ','Jueves 24 de Junio del 04, a las 18:09:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2164,53,'                              ','Jueves 24 de Junio del 04, a las 18:12:26         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2165,51,'Direccion                     ','Viernes 25 de Junio del 04, a las 09:44:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2166,51,'Direccion                     ','Viernes 25 de Junio del 04, a las 09:44:30        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2167,51,'Direccion                     ','Viernes 25 de Junio del 04, a las 09:44:47        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2168,53,'                              ','Viernes 25 de Junio del 04, a las 09:45:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2169,53,'                              ','Viernes 25 de Junio del 04, a las 09:46:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2170,53,'                              ','Viernes 25 de Junio del 04, a las 09:48:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2171,3,'                              ','Viernes 25 de Junio del 04, a las 09:53:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2172,6,'                              ','Viernes 25 de Junio del 04, a las 09:58:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2173,6,'                              ','Viernes 25 de Junio del 04, a las 10:01:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2174,9,'                              ','Viernes 25 de Junio del 04, a las 10:04:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2175,4,'                              ','Viernes 25 de Junio del 04, a las 10:11:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2176,10,'                              ','Viernes 25 de Junio del 04, a las 10:12:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2177,8,'                              ','Viernes 25 de Junio del 04, a las 10:18:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2178,8,'                              ','Viernes 25 de Junio del 04, a las 10:22:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2179,11,'                              ','Viernes 25 de Junio del 04, a las 10:26:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2180,6,'                              ','Viernes 25 de Junio del 04, a las 10:36:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2181,6,'                              ','Viernes 25 de Junio del 04, a las 10:41:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2182,4,'                              ','Viernes 25 de Junio del 04, a las 10:42:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2183,9,'                              ','Viernes 25 de Junio del 04, a las 10:46:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2184,4,'                              ','Viernes 25 de Junio del 04, a las 10:59:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2185,4,'                              ','Viernes 25 de Junio del 04, a las 11:00:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2186,10,'                              ','Viernes 25 de Junio del 04, a las 11:01:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2187,8,'                              ','Viernes 25 de Junio del 04, a las 11:56:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2188,8,'                              ','Viernes 25 de Junio del 04, a las 12:02:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2189,8,'                              ','Viernes 25 de Junio del 04, a las 12:05:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2190,11,'                              ','Viernes 25 de Junio del 04, a las 12:08:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2191,6,'                              ','Viernes 25 de Junio del 04, a las 12:21:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2192,3,'                              ','Viernes 25 de Junio del 04, a las 12:22:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2193,4,'                              ','Viernes 25 de Junio del 04, a las 12:23:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2194,51,'Direccion                     ','Viernes 25 de Junio del 04, a las 12:27:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2195,9,'                              ','Viernes 25 de Junio del 04, a las 12:32:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2196,10,'                              ','Viernes 25 de Junio del 04, a las 12:33:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2197,8,'                              ','Viernes 25 de Junio del 04, a las 12:36:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2198,8,'                              ','Viernes 25 de Junio del 04, a las 12:38:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2199,8,'                              ','Viernes 25 de Junio del 04, a las 12:41:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2200,8,'                              ','Viernes 25 de Junio del 04, a las 12:42:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2201,11,'                              ','Viernes 25 de Junio del 04, a las 12:48:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2202,11,'                              ','Viernes 25 de Junio del 04, a las 12:52:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2203,6,'                              ','Viernes 25 de Junio del 04, a las 13:04:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2204,3,'                              ','Viernes 25 de Junio del 04, a las 13:05:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2205,4,'                              ','Viernes 25 de Junio del 04, a las 13:06:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2206,9,'                              ','Viernes 25 de Junio del 04, a las 13:09:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2207,10,'                              ','Viernes 25 de Junio del 04, a las 13:10:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2208,8,'                              ','Viernes 25 de Junio del 04, a las 13:16:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2209,8,'                              ','Viernes 25 de Junio del 04, a las 13:17:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2210,8,'                              ','Viernes 25 de Junio del 04, a las 13:20:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2211,11,'                              ','Viernes 25 de Junio del 04, a las 13:25:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2212,53,'                              ','Viernes 25 de Junio del 04, a las 15:11:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2213,6,'                              ','Viernes 25 de Junio del 04, a las 15:12:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2214,4,'                              ','Viernes 25 de Junio del 04, a las 15:14:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2215,9,'                              ','Viernes 25 de Junio del 04, a las 15:17:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2216,4,'                              ','Viernes 25 de Junio del 04, a las 15:19:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2217,10,'                              ','Viernes 25 de Junio del 04, a las 15:20:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2218,8,'                              ','Viernes 25 de Junio del 04, a las 15:25:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2219,8,'                              ','Viernes 25 de Junio del 04, a las 15:27:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2220,8,'                              ','Viernes 25 de Junio del 04, a las 15:30:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2221,11,'                              ','Viernes 25 de Junio del 04, a las 15:35:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2222,10,'                              ','Viernes 25 de Junio del 04, a las 15:36:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2223,6,'                              ','Viernes 25 de Junio del 04, a las 15:42:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2224,6,'                              ','Viernes 25 de Junio del 04, a las 15:43:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2225,4,'                              ','Viernes 25 de Junio del 04, a las 15:46:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2226,8,'                              ','Viernes 25 de Junio del 04, a las 15:47:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2227,4,'                              ','Viernes 25 de Junio del 04, a las 15:51:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2228,6,'                              ','Viernes 25 de Junio del 04, a las 15:53:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2229,9,'                              ','Viernes 25 de Junio del 04, a las 15:56:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2230,4,'                              ','Viernes 25 de Junio del 04, a las 15:57:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2231,10,'                              ','Viernes 25 de Junio del 04, a las 15:58:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2232,8,'                              ','Viernes 25 de Junio del 04, a las 16:02:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2233,8,'                              ','Viernes 25 de Junio del 04, a las 16:04:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2234,11,'                              ','Viernes 25 de Junio del 04, a las 16:08:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2235,2,'Bib Datos Propopios           ','Viernes 25 de Junio del 04, a las 16:16:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2236,6,'                              ','Viernes 25 de Junio del 04, a las 17:24:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2237,9,'                              ','Viernes 25 de Junio del 04, a las 17:28:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2238,4,'                              ','Viernes 25 de Junio del 04, a las 17:29:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2239,10,'                              ','Viernes 25 de Junio del 04, a las 17:30:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2240,8,'                              ','Viernes 25 de Junio del 04, a las 17:40:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2241,8,'                              ','Mircoles 30 de Junio del 04, a las 10:15:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2242,11,'                              ','Mircoles 30 de Junio del 04, a las 10:49:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2243,4,'                              ','Mircoles 30 de Junio del 04, a las 11:11:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2244,9,'                              ','Mircoles 30 de Junio del 04, a las 11:14:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2245,4,'                              ','Mircoles 30 de Junio del 04, a las 11:16:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2246,10,'                              ','Mircoles 30 de Junio del 04, a las 11:17:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2247,8,'                              ','Mircoles 30 de Junio del 04, a las 11:22:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2248,8,'                              ','Mircoles 30 de Junio del 04, a las 11:24:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2249,8,'                              ','Mircoles 30 de Junio del 04, a las 11:27:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2250,11,'                              ','Mircoles 30 de Junio del 04, a las 11:30:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2251,6,'                              ','Mircoles 30 de Junio del 04, a las 11:33:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2252,6,'                              ','Mircoles 30 de Junio del 04, a las 11:34:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2253,6,'                              ','Mircoles 30 de Junio del 04, a las 12:12:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2254,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 12:30:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2255,9,'                              ','Mircoles 30 de Junio del 04, a las 12:40:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2256,4,'                              ','Mircoles 30 de Junio del 04, a las 12:42:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2257,10,'                              ','Mircoles 30 de Junio del 04, a las 12:43:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2258,8,'                              ','Mircoles 30 de Junio del 04, a las 12:53:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2259,8,'                              ','Mircoles 30 de Junio del 04, a las 12:54:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2260,8,'                              ','Mircoles 30 de Junio del 04, a las 12:58:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2261,11,'                              ','Mircoles 30 de Junio del 04, a las 13:02:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2262,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 13:12:32      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2263,6,'                              ','Mircoles 30 de Junio del 04, a las 13:16:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2264,6,'                              ','Mircoles 30 de Junio del 04, a las 13:17:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2265,9,'                              ','Mircoles 30 de Junio del 04, a las 13:26:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2266,10,'                              ','Mircoles 30 de Junio del 04, a las 13:30:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2267,8,'                              ','Mircoles 30 de Junio del 04, a las 13:35:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2268,8,'                              ','Mircoles 30 de Junio del 04, a las 13:41:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2269,8,'                              ','Mircoles 30 de Junio del 04, a las 13:42:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2270,11,'                              ','Mircoles 30 de Junio del 04, a las 13:48:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2271,4,'                              ','Mircoles 30 de Junio del 04, a las 13:57:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2272,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 14:01:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2273,4,'                              ','Mircoles 30 de Junio del 04, a las 14:02:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2274,11,'                              ','Mircoles 30 de Junio del 04, a las 14:09:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2275,9,'                              ','Mircoles 30 de Junio del 04, a las 14:12:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2276,10,'                              ','Mircoles 30 de Junio del 04, a las 14:13:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2277,8,'                              ','Mircoles 30 de Junio del 04, a las 14:17:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2278,8,'                              ','Mircoles 30 de Junio del 04, a las 14:19:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2279,8,'                              ','Mircoles 30 de Junio del 04, a las 14:22:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2280,11,'                              ','Mircoles 30 de Junio del 04, a las 14:25:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2281,6,'                              ','Mircoles 30 de Junio del 04, a las 14:32:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2282,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 14:41:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2283,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 14:43:27      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2284,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 14:43:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2285,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 14:48:44      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2286,2,'Bib Datos Propopios           ','Mircoles 30 de Junio del 04, a las 14:49:17      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2287,4,'                              ','Jueves 1 de Julio del 04, a las 09:21:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2288,9,'                              ','Jueves 1 de Julio del 04, a las 09:30:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2289,4,'                              ','Jueves 1 de Julio del 04, a las 09:38:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2290,10,'                              ','Jueves 1 de Julio del 04, a las 09:39:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2291,8,'                              ','Jueves 1 de Julio del 04, a las 09:47:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2292,8,'                              ','Jueves 1 de Julio del 04, a las 10:05:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2293,8,'                              ','Jueves 1 de Julio del 04, a las 10:06:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2294,8,'                              ','Jueves 1 de Julio del 04, a las 10:27:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2295,11,'                              ','Jueves 1 de Julio del 04, a las 10:43:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2296,10,'                              ','Jueves 1 de Julio del 04, a las 10:45:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2297,6,'                              ','Jueves 1 de Julio del 04, a las 10:47:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2298,3,'                              ','Jueves 1 de Julio del 04, a las 10:59:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2299,6,'                              ','Jueves 1 de Julio del 04, a las 11:00:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2300,9,'                              ','Jueves 1 de Julio del 04, a las 11:06:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2301,4,'                              ','Jueves 1 de Julio del 04, a las 11:08:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2302,4,'                              ','Jueves 1 de Julio del 04, a las 11:08:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2303,8,'                              ','Jueves 1 de Julio del 04, a las 12:07:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2304,8,'                              ','Jueves 1 de Julio del 04, a las 12:11:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2305,8,'                              ','Jueves 1 de Julio del 04, a las 12:11:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2306,8,'                              ','Jueves 1 de Julio del 04, a las 12:14:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2307,11,'                              ','Jueves 1 de Julio del 04, a las 12:20:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2308,11,'                              ','Jueves 1 de Julio del 04, a las 12:21:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2309,10,'                              ','Jueves 1 de Julio del 04, a las 12:22:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2310,4,'                              ','Jueves 1 de Julio del 04, a las 12:33:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2311,4,'                              ','Jueves 1 de Julio del 04, a las 12:42:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2312,4,'                              ','Jueves 1 de Julio del 04, a las 12:45:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2313,9,'                              ','Jueves 1 de Julio del 04, a las 12:53:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2314,10,'                              ','Jueves 1 de Julio del 04, a las 13:14:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2315,8,'                              ','Jueves 1 de Julio del 04, a las 13:18:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2316,8,'                              ','Jueves 1 de Julio del 04, a las 13:48:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2317,11,'                              ','Jueves 1 de Julio del 04, a las 13:53:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2318,3,'                              ','Jueves 1 de Julio del 04, a las 14:07:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2319,9,'                              ','Jueves 1 de Julio del 04, a las 14:12:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2320,10,'                              ','Jueves 1 de Julio del 04, a las 14:17:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2321,8,'                              ','Jueves 1 de Julio del 04, a las 14:23:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2322,8,'                              ','Jueves 1 de Julio del 04, a las 14:25:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2323,11,'                              ','Jueves 1 de Julio del 04, a las 14:30:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2324,3,'                              ','Jueves 1 de Julio del 04, a las 14:34:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2325,6,'                              ','Jueves 1 de Julio del 04, a las 14:36:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2326,9,'                              ','Jueves 1 de Julio del 04, a las 14:40:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2327,9,'                              ','Jueves 1 de Julio del 04, a las 14:41:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2328,10,'                              ','Jueves 1 de Julio del 04, a las 14:42:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2329,8,'                              ','Jueves 1 de Julio del 04, a las 14:46:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2330,8,'                              ','Jueves 1 de Julio del 04, a las 14:50:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2331,11,'                              ','Jueves 1 de Julio del 04, a las 14:53:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2332,6,'                              ','Jueves 1 de Julio del 04, a las 14:59:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2333,9,'                              ','Jueves 1 de Julio del 04, a las 15:02:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2334,4,'                              ','Jueves 1 de Julio del 04, a las 15:03:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2335,10,'                              ','Jueves 1 de Julio del 04, a las 15:04:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2336,8,'                              ','Jueves 1 de Julio del 04, a las 15:12:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2337,8,'                              ','Jueves 1 de Julio del 04, a las 15:14:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2338,11,'                              ','Jueves 1 de Julio del 04, a las 15:20:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2339,11,'                              ','Jueves 1 de Julio del 04, a las 15:21:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2340,6,'                              ','Viernes 2 de Julio del 04, a las 09:31:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2341,6,'                              ','Viernes 2 de Julio del 04, a las 09:32:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2342,6,'                              ','Viernes 2 de Julio del 04, a las 09:34:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2343,6,'                              ','Viernes 2 de Julio del 04, a las 09:36:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2344,6,'                              ','Viernes 2 de Julio del 04, a las 10:24:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2345,6,'                              ','Viernes 2 de Julio del 04, a las 10:26:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2346,4,'                              ','Viernes 2 de Julio del 04, a las 10:28:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2347,4,'                              ','Viernes 2 de Julio del 04, a las 10:29:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2348,4,'                              ','Viernes 2 de Julio del 04, a las 10:30:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2349,6,'                              ','Viernes 2 de Julio del 04, a las 10:41:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2350,6,'                              ','Viernes 2 de Julio del 04, a las 10:43:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2351,9,'                              ','Viernes 2 de Julio del 04, a las 10:52:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2352,4,'                              ','Viernes 2 de Julio del 04, a las 10:53:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2353,10,'                              ','Viernes 2 de Julio del 04, a las 10:53:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2354,8,'                              ','Viernes 2 de Julio del 04, a las 10:57:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2355,8,'                              ','Viernes 2 de Julio del 04, a las 11:03:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2356,8,'                              ','Viernes 2 de Julio del 04, a las 11:10:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2357,8,'                              ','Viernes 2 de Julio del 04, a las 11:13:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2358,11,'                              ','Viernes 2 de Julio del 04, a las 11:17:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2359,10,'                              ','Viernes 2 de Julio del 04, a las 11:17:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2360,2,'Bib Datos Propopios           ','Viernes 2 de Julio del 04, a las 11:20:42         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2361,53,'                              ','Viernes 2 de Julio del 04, a las 11:42:18         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2362,4,'                              ','Viernes 2 de Julio del 04, a las 11:46:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2363,9,'                              ','Viernes 2 de Julio del 04, a las 11:50:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2364,4,'                              ','Viernes 2 de Julio del 04, a las 11:53:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2365,10,'                              ','Viernes 2 de Julio del 04, a las 11:54:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2366,8,'                              ','Viernes 2 de Julio del 04, a las 12:02:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2367,8,'                              ','Viernes 2 de Julio del 04, a las 12:07:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2368,8,'                              ','Viernes 2 de Julio del 04, a las 12:10:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2369,11,'                              ','Viernes 2 de Julio del 04, a las 12:13:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2370,51,'Direccion                     ','Viernes 2 de Julio del 04, a las 12:17:02         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2371,6,'                              ','Viernes 2 de Julio del 04, a las 12:27:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2372,6,'                              ','Viernes 2 de Julio del 04, a las 12:28:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2373,53,'                              ','Viernes 2 de Julio del 04, a las 12:34:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2374,6,'                              ','Viernes 2 de Julio del 04, a las 12:37:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2375,9,'                              ','Viernes 2 de Julio del 04, a las 12:41:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2376,4,'                              ','Viernes 2 de Julio del 04, a las 12:43:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2377,10,'                              ','Viernes 2 de Julio del 04, a las 12:44:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2378,8,'                              ','Viernes 2 de Julio del 04, a las 12:50:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2379,8,'                              ','Viernes 2 de Julio del 04, a las 12:53:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2380,8,'                              ','Viernes 2 de Julio del 04, a las 12:58:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2381,11,'                              ','Viernes 2 de Julio del 04, a las 13:04:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2382,9,'                              ','Viernes 2 de Julio del 04, a las 13:32:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2383,4,'                              ','Viernes 2 de Julio del 04, a las 13:34:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2384,10,'                              ','Viernes 2 de Julio del 04, a las 13:35:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2385,8,'                              ','Viernes 2 de Julio del 04, a las 13:39:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2386,8,'                              ','Viernes 2 de Julio del 04, a las 13:41:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2387,11,'                              ','Viernes 2 de Julio del 04, a las 13:45:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2388,6,'                              ','Viernes 2 de Julio del 04, a las 13:56:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2389,9,'                              ','Lunes 5 de Julio del 04, a las 10:03:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2390,10,'                              ','Lunes 5 de Julio del 04, a las 10:05:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2391,8,'                              ','Lunes 5 de Julio del 04, a las 10:13:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2392,8,'                              ','Lunes 5 de Julio del 04, a las 10:13:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2393,8,'                              ','Lunes 5 de Julio del 04, a las 10:16:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2394,11,'                              ','Lunes 5 de Julio del 04, a las 10:19:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2395,3,'                              ','Lunes 5 de Julio del 04, a las 10:21:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2396,51,'Direccion                     ','Lunes 5 de Julio del 04, a las 10:27:11           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2397,4,'                              ','Lunes 5 de Julio del 04, a las 10:29:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2398,9,'                              ','Lunes 5 de Julio del 04, a las 10:34:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2399,4,'                              ','Lunes 5 de Julio del 04, a las 10:36:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2400,4,'                              ','Lunes 5 de Julio del 04, a las 10:36:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2401,10,'                              ','Lunes 5 de Julio del 04, a las 10:37:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2402,8,'                              ','Lunes 5 de Julio del 04, a las 10:51:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2403,8,'                              ','Lunes 5 de Julio del 04, a las 10:54:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2404,8,'                              ','Lunes 5 de Julio del 04, a las 10:58:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2405,11,'                              ','Lunes 5 de Julio del 04, a las 11:04:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2406,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 11:20:21           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2407,4,'                              ','Lunes 5 de Julio del 04, a las 11:27:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2408,4,'                              ','Lunes 5 de Julio del 04, a las 11:28:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2409,4,'                              ','Lunes 5 de Julio del 04, a las 11:33:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2410,9,'                              ','Lunes 5 de Julio del 04, a las 11:39:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2411,4,'                              ','Lunes 5 de Julio del 04, a las 11:40:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2412,10,'                              ','Lunes 5 de Julio del 04, a las 11:41:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2413,8,'                              ','Lunes 5 de Julio del 04, a las 11:56:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2414,8,'                              ','Lunes 5 de Julio del 04, a las 12:03:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2415,11,'                              ','Lunes 5 de Julio del 04, a las 12:08:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2416,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 12:14:36           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2417,6,'                              ','Lunes 5 de Julio del 04, a las 12:20:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2418,9,'                              ','Lunes 5 de Julio del 04, a las 12:25:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2419,4,'                              ','Lunes 5 de Julio del 04, a las 12:30:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2420,10,'                              ','Lunes 5 de Julio del 04, a las 12:31:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2421,8,'                              ','Lunes 5 de Julio del 04, a las 12:36:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2422,8,'                              ','Lunes 5 de Julio del 04, a las 12:40:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2423,11,'                              ','Lunes 5 de Julio del 04, a las 12:47:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2424,6,'                              ','Lunes 5 de Julio del 04, a las 12:57:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2425,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 13:04:24           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2426,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 13:05:25           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2427,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 13:05:44           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2428,53,'                              ','Lunes 5 de Julio del 04, a las 13:10:12           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2429,6,'                              ','Lunes 5 de Julio del 04, a las 13:12:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2430,4,'                              ','Lunes 5 de Julio del 04, a las 13:14:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2431,9,'                              ','Lunes 5 de Julio del 04, a las 13:17:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2432,4,'                              ','Lunes 5 de Julio del 04, a las 13:18:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2433,10,'                              ','Lunes 5 de Julio del 04, a las 13:19:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2434,8,'                              ','Lunes 5 de Julio del 04, a las 13:21:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2435,8,'                              ','Lunes 5 de Julio del 04, a las 13:23:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2436,11,'                              ','Lunes 5 de Julio del 04, a las 13:28:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2437,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 13:31:45           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2438,8,'                              ','Lunes 5 de Julio del 04, a las 13:33:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2439,8,'                              ','Lunes 5 de Julio del 04, a las 13:49:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2440,8,'                              ','Lunes 5 de Julio del 04, a las 13:51:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2441,8,'                              ','Lunes 5 de Julio del 04, a las 13:52:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2442,8,'                              ','Lunes 5 de Julio del 04, a las 13:53:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2443,8,'                              ','Lunes 5 de Julio del 04, a las 13:54:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2444,8,'                              ','Lunes 5 de Julio del 04, a las 13:55:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2445,8,'                              ','Lunes 5 de Julio del 04, a las 13:56:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2446,8,'                              ','Lunes 5 de Julio del 04, a las 13:58:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2447,8,'                              ','Lunes 5 de Julio del 04, a las 13:59:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2448,8,'                              ','Lunes 5 de Julio del 04, a las 14:00:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2449,8,'                              ','Lunes 5 de Julio del 04, a las 14:01:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2450,8,'                              ','Lunes 5 de Julio del 04, a las 14:02:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2451,8,'                              ','Lunes 5 de Julio del 04, a las 14:03:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2452,8,'                              ','Lunes 5 de Julio del 04, a las 14:05:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2453,8,'                              ','Lunes 5 de Julio del 04, a las 14:07:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2454,8,'                              ','Lunes 5 de Julio del 04, a las 14:09:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2455,8,'                              ','Lunes 5 de Julio del 04, a las 14:49:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2456,8,'                              ','Lunes 5 de Julio del 04, a las 14:50:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2457,8,'                              ','Lunes 5 de Julio del 04, a las 14:51:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2458,8,'                              ','Lunes 5 de Julio del 04, a las 14:53:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2459,8,'                              ','Lunes 5 de Julio del 04, a las 14:55:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2460,8,'                              ','Lunes 5 de Julio del 04, a las 14:58:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2461,8,'                              ','Lunes 5 de Julio del 04, a las 14:59:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2462,8,'                              ','Lunes 5 de Julio del 04, a las 16:45:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2463,8,'                              ','Lunes 5 de Julio del 04, a las 16:47:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2464,8,'                              ','Lunes 5 de Julio del 04, a las 16:48:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2465,8,'                              ','Lunes 5 de Julio del 04, a las 16:57:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2466,8,'                              ','Lunes 5 de Julio del 04, a las 16:58:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2467,8,'                              ','Lunes 5 de Julio del 04, a las 17:13:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2468,8,'                              ','Lunes 5 de Julio del 04, a las 17:15:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2469,8,'                              ','Lunes 5 de Julio del 04, a las 17:17:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2470,8,'                              ','Lunes 5 de Julio del 04, a las 17:21:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2471,8,'                              ','Lunes 5 de Julio del 04, a las 17:22:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2472,8,'                              ','Lunes 5 de Julio del 04, a las 17:24:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2473,8,'                              ','Lunes 5 de Julio del 04, a las 17:24:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2474,8,'                              ','Lunes 5 de Julio del 04, a las 17:32:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2475,4,'                              ','Lunes 5 de Julio del 04, a las 17:53:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2476,4,'                              ','Lunes 5 de Julio del 04, a las 17:54:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2477,9,'                              ','Lunes 5 de Julio del 04, a las 17:58:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2478,4,'                              ','Lunes 5 de Julio del 04, a las 17:59:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2479,4,'                              ','Lunes 5 de Julio del 04, a las 18:01:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2480,4,'                              ','Lunes 5 de Julio del 04, a las 18:03:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2481,10,'                              ','Lunes 5 de Julio del 04, a las 18:04:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2482,8,'                              ','Lunes 5 de Julio del 04, a las 18:06:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2483,8,'                              ','Lunes 5 de Julio del 04, a las 18:09:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2484,8,'                              ','Lunes 5 de Julio del 04, a las 18:10:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2485,8,'                              ','Lunes 5 de Julio del 04, a las 18:13:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2486,11,'                              ','Lunes 5 de Julio del 04, a las 18:19:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2487,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 18:26:23           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2488,2,'Bib Datos Propopios           ','Lunes 5 de Julio del 04, a las 18:26:53           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2489,6,'                              ','Lunes 5 de Julio del 04, a las 18:28:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2490,6,'                              ','Lunes 5 de Julio del 04, a las 18:30:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2491,8,'                              ','Lunes 5 de Julio del 04, a las 18:32:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2492,4,'                              ','Martes 6 de Julio del 04, a las 07:53:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2493,9,'                              ','Martes 6 de Julio del 04, a las 07:56:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2494,4,'                              ','Martes 6 de Julio del 04, a las 07:59:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2495,10,'                              ','Martes 6 de Julio del 04, a las 08:00:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2496,8,'                              ','Martes 6 de Julio del 04, a las 08:03:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2497,8,'                              ','Martes 6 de Julio del 04, a las 08:07:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2498,8,'                              ','Martes 6 de Julio del 04, a las 08:11:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2499,11,'                              ','Martes 6 de Julio del 04, a las 08:18:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2500,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 08:22:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2501,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 08:33:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2502,4,'                              ','Martes 6 de Julio del 04, a las 08:36:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2503,53,'                              ','Martes 6 de Julio del 04, a las 08:39:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2504,53,'                              ','Martes 6 de Julio del 04, a las 08:40:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2505,6,'                              ','Martes 6 de Julio del 04, a las 08:42:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2506,4,'                              ','Martes 6 de Julio del 04, a las 08:43:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2507,9,'                              ','Martes 6 de Julio del 04, a las 08:47:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2508,4,'                              ','Martes 6 de Julio del 04, a las 08:50:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2509,10,'                              ','Martes 6 de Julio del 04, a las 08:51:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2510,8,'                              ','Martes 6 de Julio del 04, a las 08:54:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2511,8,'                              ','Martes 6 de Julio del 04, a las 08:56:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2512,8,'                              ','Martes 6 de Julio del 04, a las 08:59:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2513,11,'                              ','Martes 6 de Julio del 04, a las 09:04:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2514,4,'                              ','Martes 6 de Julio del 04, a las 09:09:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2515,6,'                              ','Martes 6 de Julio del 04, a las 09:12:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2516,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 09:13:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2517,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 09:16:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2518,6,'                              ','Martes 6 de Julio del 04, a las 09:20:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2519,9,'                              ','Martes 6 de Julio del 04, a las 09:24:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2520,4,'                              ','Martes 6 de Julio del 04, a las 09:28:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2521,4,'                              ','Martes 6 de Julio del 04, a las 09:30:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2522,10,'                              ','Martes 6 de Julio del 04, a las 09:31:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2523,8,'                              ','Martes 6 de Julio del 04, a las 09:35:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2524,8,'                              ','Martes 6 de Julio del 04, a las 09:39:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2525,8,'                              ','Martes 6 de Julio del 04, a las 09:42:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2526,8,'                              ','Martes 6 de Julio del 04, a las 09:44:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2527,11,'                              ','Martes 6 de Julio del 04, a las 09:49:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2528,4,'                              ','Martes 6 de Julio del 04, a las 09:54:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2529,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 09:56:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2530,51,'Direccion                     ','Martes 6 de Julio del 04, a las 10:02:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2531,53,'                              ','Martes 6 de Julio del 04, a las 10:03:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2532,6,'                              ','Martes 6 de Julio del 04, a las 10:05:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2533,9,'                              ','Martes 6 de Julio del 04, a las 10:09:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2534,4,'                              ','Martes 6 de Julio del 04, a las 10:11:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2535,4,'                              ','Martes 6 de Julio del 04, a las 10:13:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2536,8,'                              ','Martes 6 de Julio del 04, a las 10:17:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2537,8,'                              ','Martes 6 de Julio del 04, a las 10:36:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2538,8,'                              ','Martes 6 de Julio del 04, a las 10:38:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2539,8,'                              ','Martes 6 de Julio del 04, a las 10:40:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2540,8,'                              ','Martes 6 de Julio del 04, a las 10:46:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2541,11,'                              ','Martes 6 de Julio del 04, a las 10:52:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2542,11,'                              ','Martes 6 de Julio del 04, a las 10:56:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2543,11,'                              ','Martes 6 de Julio del 04, a las 10:58:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2544,10,'                              ','Martes 6 de Julio del 04, a las 10:59:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2545,10,'                              ','Martes 6 de Julio del 04, a las 11:00:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2546,4,'                              ','Martes 6 de Julio del 04, a las 11:10:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2547,4,'                              ','Martes 6 de Julio del 04, a las 11:11:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2548,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 11:38:09          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2549,6,'                              ','Martes 6 de Julio del 04, a las 11:45:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2550,6,'                              ','Martes 6 de Julio del 04, a las 11:53:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2551,6,'                              ','Martes 6 de Julio del 04, a las 11:54:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2552,6,'                              ','Martes 6 de Julio del 04, a las 11:55:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2553,4,'                              ','Martes 6 de Julio del 04, a las 11:57:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2554,4,'                              ','Martes 6 de Julio del 04, a las 12:09:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2555,9,'                              ','Martes 6 de Julio del 04, a las 12:13:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2556,4,'                              ','Martes 6 de Julio del 04, a las 12:40:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2557,10,'                              ','Martes 6 de Julio del 04, a las 13:46:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2558,8,'                              ','Martes 6 de Julio del 04, a las 13:54:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2559,8,'                              ','Martes 6 de Julio del 04, a las 14:04:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2560,8,'                              ','Martes 6 de Julio del 04, a las 14:06:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2561,11,'                              ','Martes 6 de Julio del 04, a las 14:09:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2562,8,'                              ','Martes 6 de Julio del 04, a las 14:12:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2563,11,'                              ','Martes 6 de Julio del 04, a las 14:17:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2564,11,'                              ','Martes 6 de Julio del 04, a las 14:18:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2565,8,'                              ','Martes 6 de Julio del 04, a las 14:34:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2566,8,'                              ','Martes 6 de Julio del 04, a las 14:38:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2567,8,'                              ','Martes 6 de Julio del 04, a las 14:39:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2568,8,'                              ','Martes 6 de Julio del 04, a las 14:41:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2569,8,'                              ','Martes 6 de Julio del 04, a las 14:42:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2570,8,'                              ','Martes 6 de Julio del 04, a las 14:45:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2571,8,'                              ','Martes 6 de Julio del 04, a las 14:46:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2572,8,'                              ','Martes 6 de Julio del 04, a las 14:49:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2573,8,'                              ','Martes 6 de Julio del 04, a las 14:51:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2574,11,'                              ','Martes 6 de Julio del 04, a las 14:53:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2575,11,'                              ','Martes 6 de Julio del 04, a las 14:54:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2576,8,'                              ','Martes 6 de Julio del 04, a las 14:55:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2577,11,'                              ','Martes 6 de Julio del 04, a las 14:57:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2578,8,'                              ','Martes 6 de Julio del 04, a las 16:47:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2579,8,'                              ','Martes 6 de Julio del 04, a las 16:47:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2580,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 16:52:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2581,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 16:53:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2582,2,'Bib Datos Propopios           ','Martes 6 de Julio del 04, a las 16:54:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2583,8,'                              ','Martes 6 de Julio del 04, a las 16:59:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2584,8,'                              ','Martes 6 de Julio del 04, a las 17:00:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2585,8,'                              ','Martes 6 de Julio del 04, a las 17:02:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2586,8,'                              ','Martes 6 de Julio del 04, a las 17:04:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2587,8,'                              ','Martes 6 de Julio del 04, a las 17:05:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2588,8,'                              ','Martes 6 de Julio del 04, a las 17:31:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2589,53,'                              ','Martes 6 de Julio del 04, a las 17:38:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2590,6,'                              ','Martes 6 de Julio del 04, a las 17:40:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2591,6,'                              ','Martes 6 de Julio del 04, a las 17:41:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2592,9,'                              ','Martes 6 de Julio del 04, a las 17:44:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2593,4,'                              ','Martes 6 de Julio del 04, a las 17:46:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2594,10,'                              ','Mircoles 7 de Julio del 04, a las 07:52:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2595,8,'                              ','Mircoles 7 de Julio del 04, a las 07:54:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2596,8,'                              ','Mircoles 7 de Julio del 04, a las 07:58:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2597,8,'                              ','Mircoles 7 de Julio del 04, a las 08:57:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2598,11,'                              ','Mircoles 7 de Julio del 04, a las 09:04:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2599,10,'                              ','Mircoles 7 de Julio del 04, a las 09:05:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2600,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 09:10:18       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2601,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 09:13:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2602,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 09:16:33       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2603,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 09:17:48       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2604,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 09:19:12       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2605,4,'                              ','Mircoles 7 de Julio del 04, a las 09:22:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2606,4,'                              ','Mircoles 7 de Julio del 04, a las 09:22:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2607,4,'                              ','Mircoles 7 de Julio del 04, a las 09:23:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2608,4,'                              ','Mircoles 7 de Julio del 04, a las 09:23:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2609,4,'                              ','Mircoles 7 de Julio del 04, a las 09:24:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2610,4,'                              ','Mircoles 7 de Julio del 04, a las 09:24:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2611,4,'                              ','Mircoles 7 de Julio del 04, a las 09:25:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2612,6,'                              ','Mircoles 7 de Julio del 04, a las 09:40:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2613,6,'                              ','Mircoles 7 de Julio del 04, a las 09:40:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2614,6,'                              ','Mircoles 7 de Julio del 04, a las 09:45:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2615,9,'                              ','Mircoles 7 de Julio del 04, a las 09:50:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2616,4,'                              ','Mircoles 7 de Julio del 04, a las 10:01:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2617,10,'                              ','Mircoles 7 de Julio del 04, a las 10:02:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2618,8,'                              ','Mircoles 7 de Julio del 04, a las 10:07:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2619,8,'                              ','Mircoles 7 de Julio del 04, a las 10:10:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2620,11,'                              ','Mircoles 7 de Julio del 04, a las 10:15:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2621,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 10:22:52       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2622,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 10:23:12       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2623,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 10:24:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2624,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 10:25:44       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2625,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 10:26:04       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2626,8,'                              ','Mircoles 7 de Julio del 04, a las 10:29:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2627,6,'                              ','Mircoles 7 de Julio del 04, a las 10:31:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2628,6,'                              ','Mircoles 7 de Julio del 04, a las 10:43:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2629,4,'                              ','Mircoles 7 de Julio del 04, a las 10:44:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2630,9,'                              ','Mircoles 7 de Julio del 04, a las 10:47:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2631,4,'                              ','Mircoles 7 de Julio del 04, a las 10:50:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2632,4,'                              ','Mircoles 7 de Julio del 04, a las 10:51:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2633,10,'                              ','Mircoles 7 de Julio del 04, a las 10:53:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2634,8,'                              ','Mircoles 7 de Julio del 04, a las 10:58:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2635,8,'                              ','Mircoles 7 de Julio del 04, a las 11:00:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2636,8,'                              ','Mircoles 7 de Julio del 04, a las 11:02:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2637,8,'                              ','Mircoles 7 de Julio del 04, a las 11:05:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2638,11,'                              ','Mircoles 7 de Julio del 04, a las 11:09:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2639,53,'                              ','Mircoles 7 de Julio del 04, a las 11:25:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2640,6,'                              ','Mircoles 7 de Julio del 04, a las 11:30:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2641,6,'                              ','Mircoles 7 de Julio del 04, a las 11:31:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2642,4,'                              ','Mircoles 7 de Julio del 04, a las 11:33:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2643,9,'                              ','Mircoles 7 de Julio del 04, a las 11:36:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2644,4,'                              ','Mircoles 7 de Julio del 04, a las 11:51:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2645,10,'                              ','Mircoles 7 de Julio del 04, a las 11:52:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2646,8,'                              ','Mircoles 7 de Julio del 04, a las 11:56:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2647,8,'                              ','Mircoles 7 de Julio del 04, a las 12:10:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2648,8,'                              ','Mircoles 7 de Julio del 04, a las 12:11:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2649,8,'                              ','Mircoles 7 de Julio del 04, a las 12:14:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2650,11,'                              ','Mircoles 7 de Julio del 04, a las 12:21:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2651,10,'                              ','Mircoles 7 de Julio del 04, a las 12:22:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2652,4,'                              ','Mircoles 7 de Julio del 04, a las 12:25:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2653,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 12:26:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2654,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 12:30:36       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2655,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 12:33:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2656,4,'                              ','Mircoles 7 de Julio del 04, a las 12:35:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2657,4,'                              ','Mircoles 7 de Julio del 04, a las 12:35:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2658,8,'                              ','Mircoles 7 de Julio del 04, a las 12:38:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2659,4,'                              ','Mircoles 7 de Julio del 04, a las 12:40:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2660,4,'                              ','Mircoles 7 de Julio del 04, a las 12:41:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2661,51,'Direccion                     ','Mircoles 7 de Julio del 04, a las 12:48:14       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2662,51,'Direccion                     ','Mircoles 7 de Julio del 04, a las 12:49:03       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2663,6,'                              ','Mircoles 7 de Julio del 04, a las 12:50:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2664,4,'                              ','Mircoles 7 de Julio del 04, a las 12:51:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2665,9,'                              ','Mircoles 7 de Julio del 04, a las 14:18:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2666,9,'                              ','Mircoles 7 de Julio del 04, a las 14:19:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2667,4,'                              ','Mircoles 7 de Julio del 04, a las 14:21:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2668,4,'                              ','Mircoles 7 de Julio del 04, a las 14:22:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2669,10,'                              ','Mircoles 7 de Julio del 04, a las 14:23:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2670,8,'                              ','Mircoles 7 de Julio del 04, a las 14:27:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2671,8,'                              ','Mircoles 7 de Julio del 04, a las 14:29:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2672,8,'                              ','Mircoles 7 de Julio del 04, a las 14:32:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2673,11,'                              ','Mircoles 7 de Julio del 04, a las 14:34:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2674,11,'                              ','Mircoles 7 de Julio del 04, a las 14:35:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2675,11,'                              ','Mircoles 7 de Julio del 04, a las 14:38:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2676,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 14:42:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2677,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 14:43:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2678,8,'                              ','Mircoles 7 de Julio del 04, a las 14:48:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2679,8,'                              ','Mircoles 7 de Julio del 04, a las 14:57:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2680,4,'                              ','Mircoles 7 de Julio del 04, a las 15:02:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2681,53,'                              ','Mircoles 7 de Julio del 04, a las 15:09:19       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2682,6,'                              ','Mircoles 7 de Julio del 04, a las 15:11:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2683,4,'                              ','Mircoles 7 de Julio del 04, a las 15:12:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2684,9,'                              ','Mircoles 7 de Julio del 04, a las 15:16:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2685,4,'                              ','Mircoles 7 de Julio del 04, a las 15:18:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2686,4,'                              ','Mircoles 7 de Julio del 04, a las 15:20:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2687,10,'                              ','Mircoles 7 de Julio del 04, a las 15:21:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2688,8,'                              ','Mircoles 7 de Julio del 04, a las 15:24:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2689,8,'                              ','Mircoles 7 de Julio del 04, a las 15:35:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2690,8,'                              ','Mircoles 7 de Julio del 04, a las 15:38:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2691,11,'                              ','Mircoles 7 de Julio del 04, a las 15:46:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2692,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 15:50:36       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2693,4,'                              ','Mircoles 7 de Julio del 04, a las 15:52:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2694,8,'                              ','Mircoles 7 de Julio del 04, a las 15:53:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2695,53,'                              ','Mircoles 7 de Julio del 04, a las 15:59:34       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2696,4,'                              ','Mircoles 7 de Julio del 04, a las 16:00:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2697,9,'                              ','Mircoles 7 de Julio del 04, a las 16:03:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2698,4,'                              ','Mircoles 7 de Julio del 04, a las 16:06:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2699,10,'                              ','Mircoles 7 de Julio del 04, a las 16:06:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2700,8,'                              ','Mircoles 7 de Julio del 04, a las 16:09:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2701,8,'                              ','Mircoles 7 de Julio del 04, a las 16:09:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2702,8,'                              ','Mircoles 7 de Julio del 04, a las 16:14:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2703,8,'                              ','Mircoles 7 de Julio del 04, a las 16:15:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2704,8,'                              ','Mircoles 7 de Julio del 04, a las 16:17:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2705,11,'                              ','Mircoles 7 de Julio del 04, a las 16:23:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2706,2,'Bib Datos Propopios           ','Mircoles 7 de Julio del 04, a las 16:25:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2707,8,'                              ','Mircoles 7 de Julio del 04, a las 16:28:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2708,11,'                              ','Jueves 8 de Julio del 04, a las 09:20:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2709,4,'                              ','Jueves 8 de Julio del 04, a las 09:21:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2710,6,'                              ','Jueves 8 de Julio del 04, a las 09:30:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2711,2,'Bib Datos Propopios           ','Jueves 8 de Julio del 04, a las 09:32:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2712,8,'                              ','Jueves 8 de Julio del 04, a las 09:34:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2713,8,'                              ','Jueves 8 de Julio del 04, a las 09:38:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2714,53,'                              ','Jueves 8 de Julio del 04, a las 09:43:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2715,6,'                              ','Jueves 8 de Julio del 04, a las 09:45:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2716,9,'                              ','Jueves 8 de Julio del 04, a las 09:49:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2717,4,'                              ','Jueves 8 de Julio del 04, a las 09:53:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2718,4,'                              ','Jueves 8 de Julio del 04, a las 09:55:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2719,10,'                              ','Jueves 8 de Julio del 04, a las 09:56:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2720,8,'                              ','Jueves 8 de Julio del 04, a las 09:59:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2721,8,'                              ','Jueves 8 de Julio del 04, a las 10:04:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2722,8,'                              ','Jueves 8 de Julio del 04, a las 10:06:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2723,11,'                              ','Jueves 8 de Julio del 04, a las 10:15:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2724,53,'                              ','Jueves 8 de Julio del 04, a las 10:20:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2725,6,'                              ','Jueves 8 de Julio del 04, a las 10:22:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2726,4,'                              ','Jueves 8 de Julio del 04, a las 10:24:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2727,9,'                              ','Jueves 8 de Julio del 04, a las 10:28:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2728,4,'                              ','Jueves 8 de Julio del 04, a las 10:30:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2729,8,'                              ','Jueves 8 de Julio del 04, a las 10:36:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2730,10,'                              ','Jueves 8 de Julio del 04, a las 10:38:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2731,8,'                              ','Jueves 8 de Julio del 04, a las 10:42:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2732,8,'                              ','Jueves 8 de Julio del 04, a las 10:44:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2733,11,'                              ','Jueves 8 de Julio del 04, a las 10:54:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2734,11,'                              ','Jueves 8 de Julio del 04, a las 10:55:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2735,6,'                              ','Jueves 8 de Julio del 04, a las 10:59:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2736,2,'Bib Datos Propopios           ','Jueves 8 de Julio del 04, a las 11:01:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2737,4,'                              ','Jueves 8 de Julio del 04, a las 11:04:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2738,4,'                              ','Jueves 8 de Julio del 04, a las 11:08:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2739,53,'                              ','Jueves 8 de Julio del 04, a las 11:10:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2740,6,'                              ','Jueves 8 de Julio del 04, a las 11:11:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2741,4,'                              ','Jueves 8 de Julio del 04, a las 11:13:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2742,9,'                              ','Jueves 8 de Julio del 04, a las 11:17:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2743,4,'                              ','Jueves 8 de Julio del 04, a las 11:19:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2744,4,'                              ','Jueves 8 de Julio del 04, a las 11:22:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2745,8,'                              ','Jueves 8 de Julio del 04, a las 11:27:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2746,8,'                              ','Jueves 8 de Julio del 04, a las 11:31:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2747,8,'                              ','Jueves 8 de Julio del 04, a las 11:36:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2748,11,'                              ','Jueves 8 de Julio del 04, a las 11:39:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2749,10,'                              ','Jueves 8 de Julio del 04, a las 11:40:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2750,6,'                              ','Jueves 8 de Julio del 04, a las 11:43:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2751,8,'                              ','Jueves 8 de Julio del 04, a las 11:49:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2752,8,'                              ','Jueves 8 de Julio del 04, a las 11:51:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2753,6,'                              ','Jueves 8 de Julio del 04, a las 11:56:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2754,9,'                              ','Jueves 8 de Julio del 04, a las 11:58:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2755,10,'                              ','Jueves 8 de Julio del 04, a las 12:00:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2756,8,'                              ','Jueves 8 de Julio del 04, a las 12:03:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2757,8,'                              ','Jueves 8 de Julio del 04, a las 12:04:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2758,8,'                              ','Jueves 8 de Julio del 04, a las 12:06:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2759,11,'                              ','Jueves 8 de Julio del 04, a las 12:09:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2760,8,'                              ','Jueves 8 de Julio del 04, a las 12:12:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2761,2,'Bib Datos Propopios           ','Jueves 8 de Julio del 04, a las 12:17:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2762,2,'Bib Datos Propopios           ','Jueves 8 de Julio del 04, a las 14:26:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2763,2,'Bib Datos Propopios           ','Jueves 8 de Julio del 04, a las 14:27:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2764,4,'                              ','Martes 3 de Agosto del 04, a las 08:50:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2765,9,'                              ','Martes 3 de Agosto del 04, a las 08:53:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2766,4,'                              ','Martes 3 de Agosto del 04, a las 08:56:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2767,4,'                              ','Martes 3 de Agosto del 04, a las 08:59:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2768,10,'                              ','Martes 3 de Agosto del 04, a las 09:34:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2769,8,'                              ','Martes 3 de Agosto del 04, a las 09:38:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2770,8,'                              ','Martes 3 de Agosto del 04, a las 09:42:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2771,8,'                              ','Martes 3 de Agosto del 04, a las 09:45:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2772,11,'                              ','Martes 3 de Agosto del 04, a las 09:51:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2773,11,'                              ','Martes 3 de Agosto del 04, a las 09:53:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2774,51,'Direccion                     ','Martes 3 de Agosto del 04, a las 09:56:05         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2775,53,'                              ','Mircoles 4 de Agosto del 04, a las 11:21:45      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2776,11,'                              ','Mircoles 4 de Agosto del 04, a las 11:25:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2777,9,'                              ','Mircoles 4 de Agosto del 04, a las 11:27:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2778,4,'                              ','Mircoles 4 de Agosto del 04, a las 11:31:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2779,4,'                              ','Mircoles 4 de Agosto del 04, a las 11:36:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2780,10,'                              ','Mircoles 4 de Agosto del 04, a las 11:37:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2781,10,'                              ','Mircoles 4 de Agosto del 04, a las 11:41:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2782,8,'                              ','Mircoles 4 de Agosto del 04, a las 11:51:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2783,8,'                              ','Mircoles 4 de Agosto del 04, a las 11:52:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2784,8,'                              ','Mircoles 4 de Agosto del 04, a las 11:52:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2785,8,'                              ','Mircoles 4 de Agosto del 04, a las 12:05:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2786,8,'                              ','Mircoles 4 de Agosto del 04, a las 12:06:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2787,8,'                              ','Mircoles 4 de Agosto del 04, a las 12:09:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2788,11,'                              ','Mircoles 4 de Agosto del 04, a las 12:16:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2789,6,'                              ','Mircoles 4 de Agosto del 04, a las 12:20:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2790,53,'                              ','Mircoles 4 de Agosto del 04, a las 12:33:21      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2791,4,'                              ','Mircoles 4 de Agosto del 04, a las 12:33:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2792,6,'                              ','Mircoles 4 de Agosto del 04, a las 12:36:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2793,9,'                              ','Mircoles 4 de Agosto del 04, a las 12:43:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2794,4,'                              ','Mircoles 4 de Agosto del 04, a las 12:45:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2795,10,'                              ','Mircoles 4 de Agosto del 04, a las 12:48:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2796,8,'                              ','Mircoles 4 de Agosto del 04, a las 12:51:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2797,8,'                              ','Mircoles 4 de Agosto del 04, a las 12:53:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2798,8,'                              ','Mircoles 4 de Agosto del 04, a las 12:57:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2799,11,'                              ','Mircoles 4 de Agosto del 04, a las 13:04:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2800,10,'                              ','Mircoles 4 de Agosto del 04, a las 13:06:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2801,4,'                              ','Mircoles 4 de Agosto del 04, a las 13:16:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2802,53,'                              ','Mircoles 4 de Agosto del 04, a las 13:19:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2803,4,'                              ','Mircoles 4 de Agosto del 04, a las 13:21:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2804,4,'                              ','Mircoles 4 de Agosto del 04, a las 13:21:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2805,6,'                              ','Mircoles 4 de Agosto del 04, a las 13:23:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2806,3,'                              ','Mircoles 4 de Agosto del 04, a las 13:25:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2807,4,'                              ','Mircoles 4 de Agosto del 04, a las 13:26:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2808,11,'                              ','Mircoles 4 de Agosto del 04, a las 13:39:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2809,6,'                              ','Mircoles 4 de Agosto del 04, a las 14:54:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2810,9,'                              ','Mircoles 4 de Agosto del 04, a las 14:55:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2811,4,'                              ','Mircoles 4 de Agosto del 04, a las 14:58:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2812,10,'                              ','Mircoles 4 de Agosto del 04, a las 14:59:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2813,8,'                              ','Mircoles 4 de Agosto del 04, a las 15:01:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2814,8,'                              ','Mircoles 4 de Agosto del 04, a las 15:09:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2815,8,'                              ','Mircoles 4 de Agosto del 04, a las 15:12:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2816,8,'                              ','Mircoles 4 de Agosto del 04, a las 15:13:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2817,11,'                              ','Mircoles 4 de Agosto del 04, a las 15:19:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2818,10,'                              ','Mircoles 4 de Agosto del 04, a las 15:20:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2819,4,'                              ','Mircoles 4 de Agosto del 04, a las 15:28:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2820,53,'                              ','Mircoles 4 de Agosto del 04, a las 15:33:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2821,4,'                              ','Mircoles 4 de Agosto del 04, a las 15:35:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2822,9,'                              ','Mircoles 4 de Agosto del 04, a las 15:39:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2823,4,'                              ','Mircoles 4 de Agosto del 04, a las 15:41:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2824,10,'                              ','Mircoles 4 de Agosto del 04, a las 15:42:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2825,8,'                              ','Mircoles 4 de Agosto del 04, a las 15:55:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2826,8,'                              ','Mircoles 4 de Agosto del 04, a las 15:59:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2827,11,'                              ','Mircoles 4 de Agosto del 04, a las 16:00:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2828,11,'                              ','Mircoles 4 de Agosto del 04, a las 16:03:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2829,2,'Bib Datos Propopios           ','Mircoles 4 de Agosto del 04, a las 16:38:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2830,53,'                              ','Mircoles 4 de Agosto del 04, a las 16:40:21      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2831,4,'                              ','Mircoles 4 de Agosto del 04, a las 16:53:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2832,9,'                              ','Mircoles 4 de Agosto del 04, a las 16:56:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2833,4,'                              ','Mircoles 4 de Agosto del 04, a las 17:00:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2834,10,'                              ','Mircoles 4 de Agosto del 04, a las 17:01:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2835,8,'                              ','Mircoles 4 de Agosto del 04, a las 17:08:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2836,8,'                              ','Mircoles 4 de Agosto del 04, a las 17:11:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2837,11,'                              ','Mircoles 4 de Agosto del 04, a las 17:17:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2838,10,'                              ','Mircoles 4 de Agosto del 04, a las 17:18:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2839,11,'                              ','Mircoles 4 de Agosto del 04, a las 17:31:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2840,53,'                              ','Jueves 5 de Agosto del 04, a las 09:23:09         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2841,6,'                              ','Jueves 5 de Agosto del 04, a las 09:25:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2842,4,'                              ','Jueves 5 de Agosto del 04, a las 09:29:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2843,9,'                              ','Jueves 5 de Agosto del 04, a las 09:34:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2844,4,'                              ','Jueves 5 de Agosto del 04, a las 09:36:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2845,4,'                              ','Jueves 5 de Agosto del 04, a las 09:38:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2846,10,'                              ','Jueves 5 de Agosto del 04, a las 09:40:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2847,8,'                              ','Jueves 5 de Agosto del 04, a las 09:50:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2848,8,'                              ','Jueves 5 de Agosto del 04, a las 09:54:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2849,8,'                              ','Jueves 5 de Agosto del 04, a las 09:55:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2850,11,'                              ','Jueves 5 de Agosto del 04, a las 10:06:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2851,4,'                              ','Jueves 5 de Agosto del 04, a las 10:10:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2852,53,'                              ','Jueves 5 de Agosto del 04, a las 10:15:17         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2853,51,'Direccion                     ','Jueves 5 de Agosto del 04, a las 10:16:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2854,2,'Bib Datos Propopios           ','Jueves 5 de Agosto del 04, a las 10:17:47         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2855,6,'                              ','Jueves 5 de Agosto del 04, a las 10:24:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2856,53,'                              ','Jueves 5 de Agosto del 04, a las 10:35:59         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2857,53,'                              ','Jueves 5 de Agosto del 04, a las 10:37:16         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2858,4,'                              ','Jueves 5 de Agosto del 04, a las 10:38:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2859,6,'                              ','Jueves 5 de Agosto del 04, a las 10:41:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2860,9,'                              ','Jueves 5 de Agosto del 04, a las 10:45:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2861,10,'                              ','Jueves 5 de Agosto del 04, a las 10:47:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2862,8,'                              ','Jueves 5 de Agosto del 04, a las 10:51:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2863,8,'                              ','Jueves 5 de Agosto del 04, a las 10:58:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2864,11,'                              ','Jueves 5 de Agosto del 04, a las 11:02:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2865,2,'Bib Datos Propopios           ','Jueves 5 de Agosto del 04, a las 11:06:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2866,3,'                              ','Jueves 5 de Agosto del 04, a las 11:11:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2867,6,'                              ','Jueves 5 de Agosto del 04, a las 11:17:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2868,8,'                              ','Jueves 5 de Agosto del 04, a las 11:20:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2869,53,'                              ','Jueves 5 de Agosto del 04, a las 11:47:00         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2870,6,'                              ','Jueves 5 de Agosto del 04, a las 11:55:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2871,9,'                              ','Jueves 5 de Agosto del 04, a las 11:56:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2872,4,'                              ','Jueves 5 de Agosto del 04, a las 11:58:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2873,10,'                              ','Jueves 5 de Agosto del 04, a las 11:58:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2874,8,'                              ','Jueves 5 de Agosto del 04, a las 12:01:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2875,8,'                              ','Jueves 5 de Agosto del 04, a las 12:08:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2876,8,'                              ','Jueves 5 de Agosto del 04, a las 12:11:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2877,11,'                              ','Jueves 5 de Agosto del 04, a las 12:15:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2878,51,'Direccion                     ','Jueves 5 de Agosto del 04, a las 12:23:05         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2879,53,'                              ','Jueves 5 de Agosto del 04, a las 12:24:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2880,4,'                              ','Jueves 5 de Agosto del 04, a las 12:26:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2881,4,'                              ','Jueves 5 de Agosto del 04, a las 12:27:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2882,6,'                              ','Jueves 5 de Agosto del 04, a las 12:29:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2883,9,'                              ','Jueves 5 de Agosto del 04, a las 12:37:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2884,4,'                              ','Jueves 5 de Agosto del 04, a las 12:44:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2885,4,'                              ','Jueves 5 de Agosto del 04, a las 12:46:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2886,10,'                              ','Jueves 5 de Agosto del 04, a las 12:47:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2887,8,'                              ','Jueves 5 de Agosto del 04, a las 12:51:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2888,8,'                              ','Jueves 5 de Agosto del 04, a las 12:54:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2889,8,'                              ','Jueves 5 de Agosto del 04, a las 13:00:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2890,11,'                              ','Jueves 5 de Agosto del 04, a las 13:20:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2891,2,'Bib Datos Propopios           ','Jueves 5 de Agosto del 04, a las 13:25:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2892,2,'Bib Datos Propopios           ','Jueves 5 de Agosto del 04, a las 13:27:23         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2893,6,'                              ','Jueves 5 de Agosto del 04, a las 14:57:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2894,9,'                              ','Jueves 5 de Agosto del 04, a las 15:03:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2895,4,'                              ','Jueves 5 de Agosto del 04, a las 15:07:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2896,8,'                              ','Jueves 5 de Agosto del 04, a las 15:11:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2897,8,'                              ','Jueves 5 de Agosto del 04, a las 15:15:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2898,11,'                              ','Jueves 5 de Agosto del 04, a las 15:23:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2899,10,'                              ','Jueves 5 de Agosto del 04, a las 15:26:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2900,6,'                              ','Jueves 5 de Agosto del 04, a las 15:30:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2901,2,'Bib Datos Propopios           ','Jueves 5 de Agosto del 04, a las 15:33:57         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2902,53,'                              ','Jueves 5 de Agosto del 04, a las 15:41:42         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2903,4,'                              ','Jueves 5 de Agosto del 04, a las 15:44:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2904,9,'                              ','Jueves 5 de Agosto del 04, a las 15:47:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2905,4,'                              ','Jueves 5 de Agosto del 04, a las 15:51:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2906,10,'                              ','Jueves 5 de Agosto del 04, a las 15:53:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2907,8,'                              ','Jueves 5 de Agosto del 04, a las 15:56:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2908,8,'                              ','Jueves 5 de Agosto del 04, a las 16:02:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2909,11,'                              ','Jueves 5 de Agosto del 04, a las 16:06:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2910,2,'Bib Datos Propopios           ','Jueves 5 de Agosto del 04, a las 16:10:59         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2911,53,'                              ','Viernes 6 de Agosto del 04, a las 10:05:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2912,3,'                              ','Viernes 6 de Agosto del 04, a las 10:10:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2913,8,'                              ','Viernes 6 de Agosto del 04, a las 10:23:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2914,9,'                              ','Viernes 6 de Agosto del 04, a las 10:29:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2915,4,'                              ','Viernes 6 de Agosto del 04, a las 10:34:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2916,4,'                              ','Viernes 6 de Agosto del 04, a las 10:35:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2917,8,'                              ','Viernes 6 de Agosto del 04, a las 10:40:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2918,8,'                              ','Viernes 6 de Agosto del 04, a las 11:00:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2919,8,'                              ','Viernes 6 de Agosto del 04, a las 11:12:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2920,11,'                              ','Viernes 6 de Agosto del 04, a las 11:18:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2921,10,'                              ','Viernes 6 de Agosto del 04, a las 11:20:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2922,6,'                              ','Viernes 6 de Agosto del 04, a las 11:27:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2923,53,'                              ','Lunes 9 de Agosto del 04, a las 09:01:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2924,6,'                              ','Lunes 9 de Agosto del 04, a las 09:02:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2925,4,'                              ','Lunes 9 de Agosto del 04, a las 09:03:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2926,9,'                              ','Lunes 9 de Agosto del 04, a las 09:06:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2927,9,'                              ','Lunes 9 de Agosto del 04, a las 09:06:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2928,4,'                              ','Lunes 9 de Agosto del 04, a las 09:08:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2929,4,'                              ','Lunes 9 de Agosto del 04, a las 09:10:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2930,10,'                              ','Lunes 9 de Agosto del 04, a las 12:40:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2931,8,'                              ','Lunes 9 de Agosto del 04, a las 12:43:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2932,8,'                              ','Lunes 9 de Agosto del 04, a las 12:54:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2933,8,'                              ','Lunes 9 de Agosto del 04, a las 12:58:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2934,11,'                              ','Lunes 9 de Agosto del 04, a las 13:07:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2935,4,'                              ','Lunes 9 de Agosto del 04, a las 13:17:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2936,6,'                              ','Lunes 9 de Agosto del 04, a las 13:19:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2937,2,'Bib Datos Propopios           ','Lunes 9 de Agosto del 04, a las 13:22:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2938,8,'                              ','Lunes 9 de Agosto del 04, a las 13:26:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2939,53,'                              ','Martes 10 de Agosto del 04, a las 08:16:43        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2940,6,'                              ','Martes 10 de Agosto del 04, a las 08:19:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2941,4,'                              ','Martes 10 de Agosto del 04, a las 08:21:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2942,9,'                              ','Martes 10 de Agosto del 04, a las 08:25:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2943,4,'                              ','Martes 10 de Agosto del 04, a las 08:54:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2944,10,'                              ','Martes 10 de Agosto del 04, a las 08:56:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2945,8,'                              ','Martes 10 de Agosto del 04, a las 09:26:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2946,8,'                              ','Martes 10 de Agosto del 04, a las 09:27:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2947,11,'                              ','Martes 10 de Agosto del 04, a las 09:41:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2948,11,'                              ','Martes 10 de Agosto del 04, a las 09:46:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2949,3,'                              ','Martes 10 de Agosto del 04, a las 09:48:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2950,4,'                              ','Martes 10 de Agosto del 04, a las 09:50:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2951,53,'                              ','Martes 10 de Agosto del 04, a las 14:23:24        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2952,4,'                              ','Martes 10 de Agosto del 04, a las 14:25:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2953,9,'                              ','Martes 10 de Agosto del 04, a las 14:29:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2954,8,'                              ','Martes 10 de Agosto del 04, a las 14:38:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2955,8,'                              ','Martes 10 de Agosto del 04, a las 14:45:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2956,8,'                              ','Martes 10 de Agosto del 04, a las 14:50:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2957,11,'                              ','Martes 10 de Agosto del 04, a las 15:14:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2958,10,'                              ','Martes 10 de Agosto del 04, a las 15:15:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2959,4,'                              ','Martes 10 de Agosto del 04, a las 15:18:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2960,9,'                              ','Jueves 12 de Agosto del 04, a las 12:33:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2961,4,'                              ','Jueves 12 de Agosto del 04, a las 12:34:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2962,4,'                              ','Jueves 12 de Agosto del 04, a las 12:36:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2963,10,'                              ','Jueves 12 de Agosto del 04, a las 12:41:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2964,8,'                              ','Jueves 12 de Agosto del 04, a las 12:45:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2965,8,'                              ','Jueves 12 de Agosto del 04, a las 12:50:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2966,8,'                              ','Jueves 12 de Agosto del 04, a las 12:59:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2967,11,'                              ','Jueves 12 de Agosto del 04, a las 13:21:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2968,4,'                              ','Jueves 12 de Agosto del 04, a las 13:29:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2969,53,'                              ','Viernes 13 de Agosto del 04, a las 09:02:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2970,4,'                              ','Viernes 13 de Agosto del 04, a las 09:05:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2971,9,'                              ','Viernes 13 de Agosto del 04, a las 09:09:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2972,4,'                              ','Viernes 13 de Agosto del 04, a las 09:13:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2973,10,'                              ','Viernes 13 de Agosto del 04, a las 09:15:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2974,8,'                              ','Viernes 13 de Agosto del 04, a las 09:24:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2975,8,'                              ','Viernes 13 de Agosto del 04, a las 09:27:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2976,11,'                              ','Viernes 13 de Agosto del 04, a las 09:32:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2977,3,'                              ','Viernes 13 de Agosto del 04, a las 09:34:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2978,3,'                              ','Viernes 13 de Agosto del 04, a las 09:34:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2979,6,'                              ','Viernes 13 de Agosto del 04, a las 09:38:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2980,6,'                              ','Viernes 13 de Agosto del 04, a las 09:41:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2981,6,'                              ','Viernes 13 de Agosto del 04, a las 09:50:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2982,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 09:56:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2983,6,'                              ','Viernes 13 de Agosto del 04, a las 09:59:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2984,6,'                              ','Viernes 13 de Agosto del 04, a las 10:06:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2985,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 10:07:58       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2986,4,'                              ','Viernes 13 de Agosto del 04, a las 10:09:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2987,6,'                              ','Viernes 13 de Agosto del 04, a las 10:16:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2988,6,'                              ','Viernes 13 de Agosto del 04, a las 10:17:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2989,6,'                              ','Viernes 13 de Agosto del 04, a las 10:18:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2990,6,'                              ','Viernes 13 de Agosto del 04, a las 10:20:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2991,6,'                              ','Viernes 13 de Agosto del 04, a las 10:27:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2992,3,'                              ','Viernes 13 de Agosto del 04, a las 10:31:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2993,4,'                              ','Viernes 13 de Agosto del 04, a las 10:32:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2994,51,'Direccion                     ','Viernes 13 de Agosto del 04, a las 10:42:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2995,6,'                              ','Viernes 13 de Agosto del 04, a las 10:47:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2996,4,'                              ','Viernes 13 de Agosto del 04, a las 10:48:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2997,9,'                              ','Viernes 13 de Agosto del 04, a las 10:52:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2998,4,'                              ','Viernes 13 de Agosto del 04, a las 10:57:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (2999,8,'                              ','Viernes 13 de Agosto del 04, a las 11:08:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3000,11,'                              ','Viernes 13 de Agosto del 04, a las 11:15:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3001,10,'                              ','Viernes 13 de Agosto del 04, a las 11:17:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3002,4,'                              ','Viernes 13 de Agosto del 04, a las 11:22:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3003,4,'                              ','Viernes 13 de Agosto del 04, a las 11:25:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3004,11,'                              ','Viernes 13 de Agosto del 04, a las 11:33:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3005,4,'                              ','Viernes 13 de Agosto del 04, a las 11:39:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3006,6,'                              ','Viernes 13 de Agosto del 04, a las 11:41:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3007,6,'                              ','Viernes 13 de Agosto del 04, a las 11:42:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3008,10,'                              ','Viernes 13 de Agosto del 04, a las 11:45:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3009,9,'                              ','Viernes 13 de Agosto del 04, a las 11:47:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3010,4,'                              ','Viernes 13 de Agosto del 04, a las 11:51:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3011,8,'                              ','Viernes 13 de Agosto del 04, a las 11:58:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3012,11,'                              ','Viernes 13 de Agosto del 04, a las 12:04:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3013,4,'                              ','Viernes 13 de Agosto del 04, a las 12:08:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3014,4,'                              ','Viernes 13 de Agosto del 04, a las 12:09:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3015,6,'                              ','Viernes 13 de Agosto del 04, a las 12:12:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3016,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 12:16:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3017,6,'                              ','Viernes 13 de Agosto del 04, a las 12:21:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3018,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 12:25:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3019,53,'                              ','Viernes 13 de Agosto del 04, a las 12:28:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3020,4,'                              ','Viernes 13 de Agosto del 04, a las 12:30:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3021,9,'                              ','Viernes 13 de Agosto del 04, a las 12:33:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3022,4,'                              ','Viernes 13 de Agosto del 04, a las 12:36:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3023,10,'                              ','Viernes 13 de Agosto del 04, a las 12:38:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3024,8,'                              ','Viernes 13 de Agosto del 04, a las 12:46:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3025,11,'                              ','Viernes 13 de Agosto del 04, a las 12:53:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3026,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 12:55:51       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3027,8,'                              ','Viernes 13 de Agosto del 04, a las 12:59:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3028,53,'                              ','Viernes 13 de Agosto del 04, a las 14:54:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3029,6,'                              ','Viernes 13 de Agosto del 04, a las 14:56:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3030,9,'                              ','Viernes 13 de Agosto del 04, a las 15:00:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3031,4,'                              ','Viernes 13 de Agosto del 04, a las 15:03:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3032,4,'                              ','Viernes 13 de Agosto del 04, a las 15:03:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3033,8,'                              ','Viernes 13 de Agosto del 04, a las 15:13:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3034,11,'                              ','Viernes 13 de Agosto del 04, a las 15:19:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3035,11,'                              ','Viernes 13 de Agosto del 04, a las 15:21:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3036,10,'                              ','Viernes 13 de Agosto del 04, a las 15:23:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3037,10,'                              ','Viernes 13 de Agosto del 04, a las 15:24:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3038,8,'                              ','Viernes 13 de Agosto del 04, a las 15:30:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3039,4,'                              ','Viernes 13 de Agosto del 04, a las 15:35:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3040,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 15:38:16       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3041,2,'Bib Datos Propopios           ','Viernes 13 de Agosto del 04, a las 15:41:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3042,6,'                              ','Viernes 13 de Agosto del 04, a las 15:46:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3043,53,'                              ','Viernes 13 de Agosto del 04, a las 15:55:08       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3044,4,'                              ','Viernes 13 de Agosto del 04, a las 15:56:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3045,51,'Direccion                     ','Viernes 13 de Agosto del 04, a las 16:47:08       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3046,6,'                              ','Domingo 15 de Agosto del 04, a las 20:07:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3047,53,'                              ','Domingo 15 de Agosto del 04, a las 20:10:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3048,4,'                              ','Domingo 15 de Agosto del 04, a las 20:11:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3049,9,'                              ','Domingo 15 de Agosto del 04, a las 20:14:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3050,4,'                              ','Domingo 15 de Agosto del 04, a las 20:18:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3051,8,'                              ','Domingo 15 de Agosto del 04, a las 20:22:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3052,8,'                              ','Domingo 15 de Agosto del 04, a las 20:26:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3053,8,'                              ','Domingo 15 de Agosto del 04, a las 20:27:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3054,8,'                              ','Domingo 15 de Agosto del 04, a las 20:31:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3055,11,'                              ','Domingo 15 de Agosto del 04, a las 20:37:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3056,11,'                              ','Domingo 15 de Agosto del 04, a las 20:39:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3057,10,'                              ','Domingo 15 de Agosto del 04, a las 20:41:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3058,53,'                              ','Domingo 15 de Agosto del 04, a las 20:50:04       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3059,9,'                              ','Domingo 15 de Agosto del 04, a las 21:00:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3060,4,'                              ','Domingo 15 de Agosto del 04, a las 21:04:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3061,10,'                              ','Domingo 15 de Agosto del 04, a las 21:54:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3062,8,'                              ','Domingo 15 de Agosto del 04, a las 21:59:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3063,8,'                              ','Domingo 15 de Agosto del 04, a las 22:04:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3064,11,'                              ','Domingo 15 de Agosto del 04, a las 22:09:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3065,53,'                              ','Lunes 16 de Agosto del 04, a las 08:50:07         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3066,9,'                              ','Lunes 16 de Agosto del 04, a las 08:54:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3067,4,'                              ','Lunes 16 de Agosto del 04, a las 08:57:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3068,4,'                              ','Lunes 16 de Agosto del 04, a las 08:57:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3069,8,'                              ','Lunes 16 de Agosto del 04, a las 09:01:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3070,8,'                              ','Lunes 16 de Agosto del 04, a las 09:12:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3071,11,'                              ','Lunes 16 de Agosto del 04, a las 09:28:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3072,11,'                              ','Lunes 16 de Agosto del 04, a las 09:29:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3073,10,'                              ','Lunes 16 de Agosto del 04, a las 09:30:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3074,53,'                              ','Lunes 16 de Agosto del 04, a las 09:33:33         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3075,4,'                              ','Lunes 16 de Agosto del 04, a las 09:36:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3076,4,'                              ','Lunes 16 de Agosto del 04, a las 09:37:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3077,6,'                              ','Lunes 16 de Agosto del 04, a las 10:17:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3078,2,'Bib Datos Propopios           ','Lunes 16 de Agosto del 04, a las 10:20:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3079,4,'                              ','Lunes 16 de Agosto del 04, a las 10:25:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3080,9,'                              ','Lunes 16 de Agosto del 04, a las 10:28:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3081,4,'                              ','Lunes 16 de Agosto del 04, a las 10:30:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3082,10,'                              ','Lunes 16 de Agosto del 04, a las 10:31:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3083,8,'                              ','Lunes 16 de Agosto del 04, a las 10:35:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3084,8,'                              ','Lunes 16 de Agosto del 04, a las 10:40:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3085,8,'                              ','Lunes 16 de Agosto del 04, a las 10:41:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3086,11,'                              ','Lunes 16 de Agosto del 04, a las 11:19:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3087,6,'                              ','Lunes 16 de Agosto del 04, a las 11:23:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3088,4,'                              ','Lunes 16 de Agosto del 04, a las 11:25:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3089,6,'                              ','Lunes 16 de Agosto del 04, a las 11:29:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3090,8,'                              ','Lunes 16 de Agosto del 04, a las 11:31:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3091,2,'Bib Datos Propopios           ','Lunes 16 de Agosto del 04, a las 11:33:36         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3092,3,'                              ','Lunes 16 de Agosto del 04, a las 11:35:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3093,4,'                              ','Lunes 16 de Agosto del 04, a las 11:36:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3094,53,'                              ','Lunes 16 de Agosto del 04, a las 11:39:21         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3095,4,'                              ','Lunes 16 de Agosto del 04, a las 11:40:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3096,9,'                              ','Lunes 16 de Agosto del 04, a las 11:43:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3097,4,'                              ','Lunes 16 de Agosto del 04, a las 11:45:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3098,10,'                              ','Lunes 16 de Agosto del 04, a las 11:46:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3099,8,'                              ','Lunes 16 de Agosto del 04, a las 11:52:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3100,11,'                              ','Lunes 16 de Agosto del 04, a las 12:02:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3101,6,'                              ','Lunes 16 de Agosto del 04, a las 12:05:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3102,4,'                              ','Lunes 16 de Agosto del 04, a las 12:08:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3103,4,'                              ','Lunes 16 de Agosto del 04, a las 12:10:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3104,6,'                              ','Lunes 16 de Agosto del 04, a las 12:15:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3105,6,'                              ','Lunes 16 de Agosto del 04, a las 12:18:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3106,6,'                              ','Lunes 16 de Agosto del 04, a las 12:19:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3107,6,'                              ','Lunes 16 de Agosto del 04, a las 12:20:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3140,2,'Bib Datos Propopios           ','Lunes 16 de Agosto del 04, a las 12:48:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3141,6,'                              ','Lunes 16 de Agosto del 04, a las 12:50:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3142,9,'                              ','Lunes 16 de Agosto del 04, a las 12:54:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3143,4,'                              ','Lunes 16 de Agosto del 04, a las 12:57:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3144,10,'                              ','Lunes 16 de Agosto del 04, a las 12:58:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3145,8,'                              ','Lunes 16 de Agosto del 04, a las 13:08:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3146,11,'                              ','Lunes 16 de Agosto del 04, a las 13:14:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3147,4,'                              ','Lunes 16 de Agosto del 04, a las 13:18:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3148,6,'                              ','Lunes 16 de Agosto del 04, a las 13:22:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3149,2,'Bib Datos Propopios           ','Lunes 16 de Agosto del 04, a las 13:23:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3150,3,'                              ','Lunes 16 de Agosto del 04, a las 14:57:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3151,53,'                              ','Lunes 16 de Agosto del 04, a las 15:00:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3152,4,'                              ','Lunes 16 de Agosto del 04, a las 15:01:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3153,9,'                              ','Lunes 16 de Agosto del 04, a las 15:04:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3154,10,'                              ','Lunes 16 de Agosto del 04, a las 15:05:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3155,8,'                              ','Lunes 16 de Agosto del 04, a las 15:13:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3156,11,'                              ','Lunes 16 de Agosto del 04, a las 15:18:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3157,6,'                              ','Lunes 16 de Agosto del 04, a las 15:24:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3158,4,'                              ','Lunes 16 de Agosto del 04, a las 15:31:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3159,4,'                              ','Lunes 16 de Agosto del 04, a las 15:35:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3160,53,'                              ','Lunes 16 de Agosto del 04, a las 15:37:07         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3161,6,'                              ','Lunes 16 de Agosto del 04, a las 15:38:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3162,9,'                              ','Lunes 16 de Agosto del 04, a las 15:43:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3163,10,'                              ','Lunes 16 de Agosto del 04, a las 15:45:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3164,8,'                              ','Lunes 16 de Agosto del 04, a las 15:50:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3165,8,'                              ','Lunes 16 de Agosto del 04, a las 15:53:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3166,8,'                              ','Lunes 16 de Agosto del 04, a las 15:55:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3167,11,'                              ','Lunes 16 de Agosto del 04, a las 16:00:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3168,11,'                              ','Lunes 16 de Agosto del 04, a las 16:01:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3169,6,'                              ','Lunes 16 de Agosto del 04, a las 16:07:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3170,4,'                              ','Lunes 16 de Agosto del 04, a las 16:10:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3171,6,'                              ','Lunes 16 de Agosto del 04, a las 16:14:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3172,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 09:54:21        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3173,6,'                              ','Martes 17 de Agosto del 04, a las 10:03:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3174,4,'                              ','Martes 17 de Agosto del 04, a las 10:04:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3175,4,'                              ','Martes 17 de Agosto del 04, a las 10:05:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3176,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:14:43        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3177,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:15:33        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3178,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:19:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3179,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:21:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3180,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:22:04        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3181,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:22:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3182,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:37:45        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3183,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:41:04        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3184,6,'                              ','Martes 17 de Agosto del 04, a las 10:42:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3185,6,'                              ','Martes 17 de Agosto del 04, a las 10:46:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3186,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 10:48:47        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3187,6,'                              ','Martes 17 de Agosto del 04, a las 10:54:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3188,6,'                              ','Martes 17 de Agosto del 04, a las 10:58:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3189,3,'                              ','Martes 17 de Agosto del 04, a las 11:01:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3190,3,'                              ','Martes 17 de Agosto del 04, a las 11:03:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3191,3,'                              ','Martes 17 de Agosto del 04, a las 11:07:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3192,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 11:10:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3193,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 11:20:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3194,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 11:21:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3195,6,'                              ','Martes 17 de Agosto del 04, a las 11:24:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3196,4,'                              ','Martes 17 de Agosto del 04, a las 11:28:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3197,4,'                              ','Martes 17 de Agosto del 04, a las 11:32:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3198,6,'                              ','Martes 17 de Agosto del 04, a las 11:34:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3199,3,'                              ','Martes 17 de Agosto del 04, a las 11:38:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3200,4,'                              ','Martes 17 de Agosto del 04, a las 11:40:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3201,4,'                              ','Martes 17 de Agosto del 04, a las 11:47:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3202,4,'                              ','Martes 17 de Agosto del 04, a las 11:50:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3203,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 11:54:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3204,4,'                              ','Martes 17 de Agosto del 04, a las 12:53:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3205,9,'                              ','Martes 17 de Agosto del 04, a las 12:57:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3206,4,'                              ','Martes 17 de Agosto del 04, a las 12:59:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3207,10,'                              ','Martes 17 de Agosto del 04, a las 13:00:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3208,8,'                              ','Martes 17 de Agosto del 04, a las 13:10:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3209,11,'                              ','Martes 17 de Agosto del 04, a las 13:19:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3210,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 13:22:46        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3211,6,'                              ','Martes 17 de Agosto del 04, a las 13:25:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3212,4,'                              ','Martes 17 de Agosto del 04, a las 13:27:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3213,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 14:35:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3214,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 14:35:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3215,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 14:40:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3216,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 14:43:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3217,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 14:45:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3218,2,'Bib Datos Propopios           ','Martes 17 de Agosto del 04, a las 14:45:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3219,4,'                              ','Martes 17 de Agosto del 04, a las 14:54:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3220,4,'                              ','Martes 17 de Agosto del 04, a las 14:56:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3221,9,'                              ','Martes 17 de Agosto del 04, a las 14:58:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3222,8,'                              ','Martes 17 de Agosto del 04, a las 14:59:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3223,11,'                              ','Martes 17 de Agosto del 04, a las 15:00:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3224,10,'                              ','Martes 17 de Agosto del 04, a las 15:02:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3225,4,'                              ','Martes 17 de Agosto del 04, a las 15:03:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3226,9,'                              ','Martes 17 de Agosto del 04, a las 15:04:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3227,8,'                              ','Martes 17 de Agosto del 04, a las 15:06:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3228,11,'                              ','Martes 17 de Agosto del 04, a las 15:07:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3229,10,'                              ','Martes 17 de Agosto del 04, a las 15:09:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3230,6,'                              ','Martes 17 de Agosto del 04, a las 15:10:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3231,9,'                              ','Martes 17 de Agosto del 04, a las 15:11:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3232,9,'                              ','Martes 17 de Agosto del 04, a las 15:11:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3233,8,'                              ','Martes 17 de Agosto del 04, a las 15:12:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3234,11,'                              ','Martes 17 de Agosto del 04, a las 15:13:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3235,11,'                              ','Martes 17 de Agosto del 04, a las 15:13:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3236,10,'                              ','Martes 17 de Agosto del 04, a las 15:14:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3237,9,'                              ','Martes 17 de Agosto del 04, a las 15:16:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3238,8,'                              ','Martes 17 de Agosto del 04, a las 15:17:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3239,11,'                              ','Martes 17 de Agosto del 04, a las 15:17:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3240,10,'                              ','Martes 17 de Agosto del 04, a las 15:19:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3241,6,'                              ','Lunes 23 de Agosto del 04, a las 15:05:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3242,6,'                              ','Lunes 23 de Agosto del 04, a las 15:07:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3243,6,'                              ','Lunes 23 de Agosto del 04, a las 15:08:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3244,11,'                              ','Mircoles 25 de Agosto del 04, a las 10:05:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3245,11,'                              ','Mircoles 25 de Agosto del 04, a las 10:14:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3246,4,'                              ','Mircoles 25 de Agosto del 04, a las 10:17:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3247,11,'                              ','Mircoles 25 de Agosto del 04, a las 10:21:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3248,51,'Direccion                     ','Mircoles 25 de Agosto del 04, a las 12:49:43     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3249,2,'Bib Datos Propopios           ','Mircoles 25 de Agosto del 04, a las 13:04:54     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3250,2,'Bib Datos Propopios           ','Mircoles 25 de Agosto del 04, a las 13:05:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3251,2,'Bib Datos Propopios           ','Mircoles 25 de Agosto del 04, a las 18:36:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3252,2,'Bib Datos Propopios           ','Mircoles 25 de Agosto del 04, a las 18:37:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3253,8,'                              ','Martes 7 de Septiembre del 04, a las 10:56:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3254,8,'                              ','Martes 7 de Septiembre del 04, a las 10:58:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3255,8,'                              ','Martes 7 de Septiembre del 04, a las 11:00:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3256,8,'                              ','Martes 7 de Septiembre del 04, a las 11:04:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3257,8,'                              ','Martes 7 de Septiembre del 04, a las 11:06:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3258,8,'                              ','Martes 7 de Septiembre del 04, a las 11:08:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3259,8,'                              ','Martes 7 de Septiembre del 04, a las 11:11:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3260,8,'                              ','Martes 7 de Septiembre del 04, a las 11:13:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3261,8,'                              ','Martes 7 de Septiembre del 04, a las 11:15:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3262,8,'                              ','Martes 7 de Septiembre del 04, a las 11:25:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3263,8,'                              ','Martes 7 de Septiembre del 04, a las 11:26:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3264,8,'                              ','Martes 7 de Septiembre del 04, a las 11:28:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3265,8,'                              ','Martes 7 de Septiembre del 04, a las 11:42:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3266,8,'                              ','Martes 7 de Septiembre del 04, a las 11:44:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3267,8,'                              ','Martes 7 de Septiembre del 04, a las 12:00:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3268,8,'                              ','Martes 7 de Septiembre del 04, a las 12:02:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3269,8,'                              ','Martes 7 de Septiembre del 04, a las 12:04:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3270,8,'                              ','Martes 7 de Septiembre del 04, a las 12:06:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3271,8,'                              ','Martes 7 de Septiembre del 04, a las 12:07:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3272,8,'                              ','Martes 7 de Septiembre del 04, a las 12:08:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3273,8,'                              ','Martes 7 de Septiembre del 04, a las 12:09:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3274,8,'                              ','Martes 7 de Septiembre del 04, a las 12:15:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3275,2,'Bib Datos Propopios           ','Martes 7 de Septiembre del 04, a las 12:24:49     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3276,2,'Bib Datos Propopios           ','Martes 7 de Septiembre del 04, a las 12:25:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3277,8,'                              ','Martes 7 de Septiembre del 04, a las 12:27:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3278,8,'                              ','Martes 7 de Septiembre del 04, a las 12:28:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3279,8,'                              ','Martes 7 de Septiembre del 04, a las 12:32:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3280,8,'                              ','Martes 7 de Septiembre del 04, a las 12:34:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3281,8,'                              ','Martes 7 de Septiembre del 04, a las 12:39:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3282,8,'                              ','Martes 7 de Septiembre del 04, a las 12:42:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3283,8,'                              ','Martes 7 de Septiembre del 04, a las 12:48:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3284,8,'                              ','Martes 7 de Septiembre del 04, a las 12:53:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3285,8,'                              ','Martes 7 de Septiembre del 04, a las 12:54:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3286,8,'                              ','Martes 7 de Septiembre del 04, a las 12:57:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3287,8,'                              ','Martes 7 de Septiembre del 04, a las 12:59:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3288,8,'                              ','Martes 7 de Septiembre del 04, a las 13:02:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3289,8,'                              ','Martes 7 de Septiembre del 04, a las 13:06:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3290,8,'                              ','Martes 7 de Septiembre del 04, a las 13:10:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3291,8,'                              ','Martes 7 de Septiembre del 04, a las 13:11:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3292,8,'                              ','Martes 7 de Septiembre del 04, a las 13:12:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3293,8,'                              ','Martes 7 de Septiembre del 04, a las 13:14:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3294,8,'                              ','Martes 7 de Septiembre del 04, a las 13:17:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3295,8,'                              ','Martes 7 de Septiembre del 04, a las 13:18:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3296,8,'                              ','Martes 7 de Septiembre del 04, a las 13:19:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3297,8,'                              ','Martes 7 de Septiembre del 04, a las 13:21:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3298,8,'                              ','Martes 7 de Septiembre del 04, a las 13:27:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3299,8,'                              ','Martes 7 de Septiembre del 04, a las 13:29:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3300,8,'                              ','Martes 7 de Septiembre del 04, a las 13:30:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3301,8,'                              ','Martes 7 de Septiembre del 04, a las 13:32:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3302,8,'                              ','Martes 7 de Septiembre del 04, a las 13:33:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3303,8,'                              ','Martes 7 de Septiembre del 04, a las 13:34:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3304,8,'                              ','Martes 7 de Septiembre del 04, a las 13:35:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3305,8,'                              ','Martes 7 de Septiembre del 04, a las 13:37:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3306,8,'                              ','Martes 7 de Septiembre del 04, a las 13:38:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3307,8,'                              ','Martes 7 de Septiembre del 04, a las 13:41:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3308,8,'                              ','Martes 7 de Septiembre del 04, a las 13:44:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3309,8,'                              ','Martes 7 de Septiembre del 04, a las 13:47:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3310,8,'                              ','Martes 7 de Septiembre del 04, a las 13:49:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3311,8,'                              ','Martes 7 de Septiembre del 04, a las 15:01:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3312,8,'                              ','Martes 7 de Septiembre del 04, a las 15:03:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3313,8,'                              ','Martes 7 de Septiembre del 04, a las 15:05:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3314,8,'                              ','Martes 7 de Septiembre del 04, a las 15:06:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3315,8,'                              ','Martes 7 de Septiembre del 04, a las 15:07:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3316,8,'                              ','Martes 7 de Septiembre del 04, a las 15:08:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3317,8,'                              ','Martes 7 de Septiembre del 04, a las 15:09:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3318,8,'                              ','Martes 7 de Septiembre del 04, a las 15:11:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3319,8,'                              ','Martes 7 de Septiembre del 04, a las 15:11:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3320,8,'                              ','Martes 7 de Septiembre del 04, a las 15:12:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3321,8,'                              ','Martes 7 de Septiembre del 04, a las 15:13:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3322,8,'                              ','Martes 7 de Septiembre del 04, a las 15:14:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3323,8,'                              ','Martes 7 de Septiembre del 04, a las 15:15:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3324,8,'                              ','Martes 7 de Septiembre del 04, a las 15:15:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3325,8,'                              ','Martes 7 de Septiembre del 04, a las 15:16:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3326,8,'                              ','Martes 7 de Septiembre del 04, a las 15:17:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3327,8,'                              ','Martes 7 de Septiembre del 04, a las 15:18:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3328,8,'                              ','Martes 7 de Septiembre del 04, a las 15:23:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3329,8,'                              ','Martes 7 de Septiembre del 04, a las 15:30:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3330,8,'                              ','Martes 7 de Septiembre del 04, a las 15:35:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3331,8,'                              ','Martes 7 de Septiembre del 04, a las 15:37:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3332,8,'                              ','Martes 7 de Septiembre del 04, a las 15:41:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3333,8,'                              ','Martes 7 de Septiembre del 04, a las 15:42:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3334,8,'                              ','Martes 7 de Septiembre del 04, a las 15:46:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3335,8,'                              ','Martes 7 de Septiembre del 04, a las 15:48:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3336,8,'                              ','Martes 7 de Septiembre del 04, a las 15:49:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3337,8,'                              ','Martes 7 de Septiembre del 04, a las 15:49:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3338,8,'                              ','Martes 7 de Septiembre del 04, a las 15:50:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3339,8,'                              ','Martes 7 de Septiembre del 04, a las 15:51:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3340,8,'                              ','Martes 7 de Septiembre del 04, a las 15:51:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3341,8,'                              ','Martes 7 de Septiembre del 04, a las 15:52:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3342,8,'                              ','Martes 7 de Septiembre del 04, a las 15:53:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3343,8,'                              ','Martes 7 de Septiembre del 04, a las 15:53:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3344,8,'                              ','Martes 7 de Septiembre del 04, a las 15:54:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3345,8,'                              ','Martes 7 de Septiembre del 04, a las 15:55:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3346,8,'                              ','Martes 7 de Septiembre del 04, a las 15:56:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3347,8,'                              ','Martes 7 de Septiembre del 04, a las 15:56:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3348,8,'                              ','Martes 7 de Septiembre del 04, a las 15:57:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3349,8,'                              ','Martes 7 de Septiembre del 04, a las 15:57:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3350,8,'                              ','Martes 7 de Septiembre del 04, a las 15:58:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3351,8,'                              ','Martes 7 de Septiembre del 04, a las 15:59:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3352,8,'                              ','Martes 7 de Septiembre del 04, a las 16:00:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3353,8,'                              ','Martes 7 de Septiembre del 04, a las 16:01:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3354,8,'                              ','Martes 7 de Septiembre del 04, a las 16:04:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3355,8,'                              ','Martes 7 de Septiembre del 04, a las 16:04:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3356,8,'                              ','Martes 7 de Septiembre del 04, a las 16:05:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3357,8,'                              ','Martes 7 de Septiembre del 04, a las 16:06:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3358,8,'                              ','Martes 7 de Septiembre del 04, a las 16:13:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3359,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:05:25  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3360,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:06:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3361,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:07:25  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3362,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:08:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3363,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:09:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3364,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:10:50  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3365,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:11:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3366,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:12:25  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3367,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:13:37  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3368,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:19:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3369,4,'                              ','Mircoles 8 de Septiembre del 04, a las 08:20:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3370,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:25:24  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3371,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:27:30  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3372,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:29:03  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3373,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:30:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3374,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:31:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3375,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:33:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3376,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:34:58  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3377,8,'                              ','Mircoles 8 de Septiembre del 04, a las 08:50:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3378,8,'                              ','Mircoles 8 de Septiembre del 04, a las 10:55:05  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3379,8,'                              ','Mircoles 8 de Septiembre del 04, a las 10:56:47  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3380,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:00:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3381,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:02:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3382,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:03:46  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3383,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:07:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3384,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:08:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3385,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:10:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3386,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:12:10  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3387,8,'                              ','Mircoles 8 de Septiembre del 04, a las 11:12:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3388,8,'                              ','Mircoles 8 de Septiembre del 04, a las 12:45:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3389,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:06:03  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3390,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:06:41  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3391,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:07:28  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3392,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:08:24  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3393,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:13:03  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3394,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:15:11  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3395,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:15:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3396,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:16:33  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3397,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:17:17  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3398,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:17:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3399,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:18:58  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3400,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:20:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3401,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:23:56  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3402,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:24:56  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3403,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:26:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3404,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:27:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3405,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:36:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3406,8,'                              ','Mircoles 8 de Septiembre del 04, a las 16:37:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3407,8,'                              ','Mircoles 8 de Septiembre del 04, a las 17:16:53  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3408,8,'                              ','Jueves 9 de Septiembre del 04, a las 12:29:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3409,8,'                              ','Lunes 13 de Septiembre del 04, a las 12:57:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3410,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:01:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3411,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:02:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3412,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:03:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3413,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:05:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3414,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:07:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3415,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:09:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3416,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:10:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3417,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:11:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3418,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:12:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3419,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:14:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3420,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:16:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3421,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:17:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3422,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:18:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3423,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:19:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3424,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:20:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3425,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:21:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3426,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:21:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3427,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:23:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3428,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:24:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3429,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:26:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3430,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:27:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3431,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:28:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3432,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:29:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3433,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:30:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3434,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:33:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3435,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:33:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3436,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:34:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3437,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:35:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3438,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:36:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3439,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:38:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3440,8,'                              ','Lunes 13 de Septiembre del 04, a las 13:46:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3441,8,'                              ','Lunes 13 de Septiembre del 04, a las 14:55:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3442,8,'                              ','Lunes 13 de Septiembre del 04, a las 14:56:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3443,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:00:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3444,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:02:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3445,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:03:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3446,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:06:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3447,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:07:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3448,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:08:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3449,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:09:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3450,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:11:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3451,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:12:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3452,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:15:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3453,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:17:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3454,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:21:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3455,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:22:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3456,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:23:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3457,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:25:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3458,8,'                              ','Lunes 13 de Septiembre del 04, a las 15:28:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3459,53,'                              ','Lunes 20 de Septiembre del 04, a las 14:26:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3460,53,'                              ','Lunes 20 de Septiembre del 04, a las 14:27:01     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3461,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:13:33     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3462,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:14:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3463,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:16:34     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3464,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:17:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3465,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:18:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3466,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:19:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3467,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:22:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3468,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:23:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3469,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:23:34     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3470,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:24:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3471,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:24:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3472,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:25:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3473,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:26:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3474,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:26:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3475,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:27:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3476,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:28:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3477,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:28:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3478,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:28:51     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3479,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:29:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3480,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:30:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3481,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:30:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3482,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:31:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3483,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:31:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3484,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:32:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3485,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:33:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3486,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:33:29     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3487,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:33:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3488,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:34:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3489,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:35:12     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3490,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:35:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3491,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:35:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3492,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:36:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3493,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:37:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3494,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:37:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3495,8,'                              ','Lunes 20 de Septiembre del 04, a las 15:38:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3496,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 15:38:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3497,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 17:35:58     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3498,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 17:36:23     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3499,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 17:39:53     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3500,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 19:00:16     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3501,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 19:02:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3502,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 19:03:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3503,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 19:04:44     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3504,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 19:05:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3505,2,'Bib Datos Propopios           ','Lunes 20 de Septiembre del 04, a las 19:07:48     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3506,4,'                              ','Lunes 20 de Septiembre del 04, a las 19:08:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3507,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 08:27:26    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3508,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 08:34:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3509,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 08:42:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3510,4,'                              ','Martes 21 de Septiembre del 04, a las 08:44:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3511,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 08:51:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3512,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:02:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3513,4,'                              ','Martes 21 de Septiembre del 04, a las 09:03:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3514,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:10:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3515,4,'                              ','Martes 21 de Septiembre del 04, a las 09:12:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3516,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:17:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3517,4,'                              ','Martes 21 de Septiembre del 04, a las 09:17:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3518,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:23:56    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3519,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:31:40    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3520,4,'                              ','Martes 21 de Septiembre del 04, a las 09:32:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3521,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:38:00    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3522,4,'                              ','Martes 21 de Septiembre del 04, a las 09:38:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3523,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:44:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3524,2,'Bib Datos Propopios           ','Martes 21 de Septiembre del 04, a las 09:45:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3525,4,'                              ','Martes 21 de Septiembre del 04, a las 09:46:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3526,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 12:13:15   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3527,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:15:19   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3528,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 12:18:24   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3529,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:20:57   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3530,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:21:59   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3531,53,'                              ','Viernes 24 de Septiembre del 04, a las 12:25:30   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3532,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:27:05   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3533,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:46:46   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3534,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:53:02   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3535,8,'                              ','Viernes 24 de Septiembre del 04, a las 12:58:09   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3536,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 14:04:02   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3537,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 14:37:34   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3538,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 14:38:17   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3539,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 14:41:41   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3540,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 14:42:31   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3541,6,'                              ','Viernes 24 de Septiembre del 04, a las 16:36:52   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3542,6,'                              ','Viernes 24 de Septiembre del 04, a las 16:41:09   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3543,6,'                              ','Viernes 24 de Septiembre del 04, a las 16:46:12   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3544,6,'                              ','Viernes 24 de Septiembre del 04, a las 16:49:35   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3545,4,'                              ','Viernes 24 de Septiembre del 04, a las 16:50:27   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3546,6,'                              ','Viernes 24 de Septiembre del 04, a las 16:57:07   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3547,8,'                              ','Viernes 24 de Septiembre del 04, a las 17:27:26   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3548,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 17:28:44   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3549,8,'                              ','Viernes 24 de Septiembre del 04, a las 17:36:55   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3550,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 17:48:49   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3551,2,'Bib Datos Propopios           ','Viernes 24 de Septiembre del 04, a las 18:28:01   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3552,6,'                              ','Viernes 24 de Septiembre del 04, a las 18:57:34   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3553,8,'                              ','Viernes 1 de Octubre del 04, a las 11:13:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3554,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 11:13:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3555,8,'                              ','Viernes 1 de Octubre del 04, a las 11:18:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3556,8,'                              ','Viernes 1 de Octubre del 04, a las 11:24:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3557,8,'                              ','Viernes 1 de Octubre del 04, a las 11:26:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3558,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 11:35:17       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3559,8,'                              ','Viernes 1 de Octubre del 04, a las 11:48:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3560,4,'                              ','Viernes 1 de Octubre del 04, a las 11:51:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3561,6,'                              ','Viernes 1 de Octubre del 04, a las 11:54:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3562,6,'                              ','Viernes 1 de Octubre del 04, a las 11:55:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3563,4,'                              ','Viernes 1 de Octubre del 04, a las 11:58:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3564,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 12:06:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3565,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 12:06:32       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3566,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 12:06:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3567,8,'                              ','Viernes 1 de Octubre del 04, a las 12:19:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3568,8,'                              ','Viernes 1 de Octubre del 04, a las 12:24:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3569,6,'                              ','Viernes 1 de Octubre del 04, a las 12:30:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3570,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 12:37:20       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3571,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 12:38:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3572,8,'                              ','Viernes 1 de Octubre del 04, a las 12:39:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3573,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 12:53:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3574,8,'                              ','Viernes 1 de Octubre del 04, a las 12:57:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3575,8,'                              ','Viernes 1 de Octubre del 04, a las 12:59:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3576,6,'                              ','Viernes 1 de Octubre del 04, a las 13:04:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3577,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 13:22:46       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3578,8,'                              ','Viernes 1 de Octubre del 04, a las 13:35:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3579,8,'                              ','Viernes 1 de Octubre del 04, a las 13:50:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3580,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 13:58:03       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3581,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 14:05:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3582,2,'Bib Datos Propopios           ','Viernes 1 de Octubre del 04, a las 14:05:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3583,6,'                              ','Viernes 1 de Octubre del 04, a las 14:08:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3584,6,'                              ','Viernes 1 de Octubre del 04, a las 14:11:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3585,6,'                              ','Viernes 1 de Octubre del 04, a las 14:21:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3586,4,'                              ','Viernes 1 de Octubre del 04, a las 14:23:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3587,4,'                              ','Viernes 1 de Octubre del 04, a las 14:25:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3588,6,'                              ','Viernes 1 de Octubre del 04, a las 14:27:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3589,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 15:27:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3590,8,'                              ','Lunes 4 de Octubre del 04, a las 15:31:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3591,8,'                              ','Lunes 4 de Octubre del 04, a las 15:33:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3592,6,'                              ','Lunes 4 de Octubre del 04, a las 17:04:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3593,6,'                              ','Lunes 4 de Octubre del 04, a las 17:05:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3594,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 17:14:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3595,8,'                              ','Lunes 4 de Octubre del 04, a las 17:18:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3596,8,'                              ','Lunes 4 de Octubre del 04, a las 17:21:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3597,6,'                              ','Lunes 4 de Octubre del 04, a las 17:31:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3598,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 17:32:52         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3599,6,'                              ','Lunes 4 de Octubre del 04, a las 17:34:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3600,8,'                              ','Lunes 4 de Octubre del 04, a las 17:36:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3601,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 17:47:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3602,8,'                              ','Lunes 4 de Octubre del 04, a las 17:52:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3603,6,'                              ','Lunes 4 de Octubre del 04, a las 17:58:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3604,8,'                              ','Lunes 4 de Octubre del 04, a las 18:00:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3605,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:07:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3606,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:09:53         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3607,8,'                              ','Lunes 4 de Octubre del 04, a las 18:13:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3608,8,'                              ','Lunes 4 de Octubre del 04, a las 18:13:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3609,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:19:30         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3610,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:21:00         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3611,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:23:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3612,8,'                              ','Lunes 4 de Octubre del 04, a las 18:25:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3613,8,'                              ','Lunes 4 de Octubre del 04, a las 18:43:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3614,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:51:49         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3615,8,'                              ','Lunes 4 de Octubre del 04, a las 18:56:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3616,2,'Bib Datos Propopios           ','Lunes 4 de Octubre del 04, a las 18:58:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3617,8,'                              ','Lunes 4 de Octubre del 04, a las 18:59:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3618,8,'                              ','Lunes 4 de Octubre del 04, a las 19:02:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3619,51,'Direccion                     ','Lunes 4 de Octubre del 04, a las 19:05:13         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3620,51,'Direccion                     ','Lunes 4 de Octubre del 04, a las 19:05:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3621,8,'                              ','Viernes 8 de Octubre del 04, a las 12:37:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3622,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 12:44:51       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3623,8,'                              ','Viernes 8 de Octubre del 04, a las 12:51:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3624,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 14:09:19       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3625,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 14:15:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3626,8,'                              ','Viernes 8 de Octubre del 04, a las 14:23:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3627,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 14:27:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3628,8,'                              ','Viernes 8 de Octubre del 04, a las 14:37:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3629,8,'                              ','Viernes 8 de Octubre del 04, a las 14:39:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3630,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 16:10:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3631,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 16:21:33       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3632,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 16:29:52       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3633,8,'                              ','Viernes 8 de Octubre del 04, a las 16:33:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3634,8,'                              ','Viernes 8 de Octubre del 04, a las 16:36:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3635,8,'                              ','Viernes 8 de Octubre del 04, a las 16:52:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3636,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:04:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3637,8,'                              ','Viernes 8 de Octubre del 04, a las 19:12:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3638,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:15:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3639,8,'                              ','Viernes 8 de Octubre del 04, a las 19:18:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3640,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:23:10       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3641,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:26:32       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3642,8,'                              ','Viernes 8 de Octubre del 04, a las 19:31:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3643,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:33:26       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3644,8,'                              ','Viernes 8 de Octubre del 04, a las 19:34:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3645,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:35:51       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3646,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:41:44       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3647,8,'                              ','Viernes 8 de Octubre del 04, a las 19:42:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3648,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:45:36       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3649,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:51:24       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3650,8,'                              ','Viernes 8 de Octubre del 04, a las 19:52:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3651,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:53:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3652,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 19:57:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3653,8,'                              ','Viernes 8 de Octubre del 04, a las 19:58:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3654,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 20:01:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3655,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 20:03:22       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3656,2,'Bib Datos Propopios           ','Viernes 8 de Octubre del 04, a las 20:06:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3657,8,'                              ','Viernes 8 de Octubre del 04, a las 20:08:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3658,2,'Bib Datos Propopios           ','Jueves 14 de Octubre del 04, a las 09:57:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3659,11,'                              ','Martes 19 de Octubre del 04, a las 14:52:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3660,51,'Direccion                     ','Jueves 21 de Octubre del 04, a las 17:32:08       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3661,51,'Direccion                     ','Jueves 21 de Octubre del 04, a las 17:38:12       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3662,53,'                              ','Jueves 21 de Octubre del 04, a las 17:52:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3663,51,'Direccion                     ','Jueves 21 de Octubre del 04, a las 18:52:52       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3664,51,'Direccion                     ','Jueves 21 de Octubre del 04, a las 18:57:22       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3665,53,'                              ','Jueves 21 de Octubre del 04, a las 18:57:48       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3666,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 09:27:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3667,6,'                              ','Viernes 22 de Octubre del 04, a las 09:31:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3668,53,'                              ','Viernes 22 de Octubre del 04, a las 09:34:15      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3669,6,'                              ','Viernes 22 de Octubre del 04, a las 09:44:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3670,6,'                              ','Viernes 22 de Octubre del 04, a las 09:51:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3671,11,'                              ','Viernes 22 de Octubre del 04, a las 09:54:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3672,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:10:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3673,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:16:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3674,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:17:50      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3675,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:19:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3676,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:24:27      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3677,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:25:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3678,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:34:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3679,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:35:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3680,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:42:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3681,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:43:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3682,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:56:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3683,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 10:57:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3684,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 11:07:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3685,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 15:46:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3686,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 15:47:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3687,2,'Bib Datos Propopios           ','Viernes 22 de Octubre del 04, a las 15:49:23      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3688,6,'                              ','Viernes 22 de Octubre del 04, a las 16:08:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3689,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 17:49:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3690,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 17:50:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3691,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 17:50:21        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3692,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 18:12:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3693,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 18:20:43        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3694,53,'                              ','Lunes 25 de Octubre del 04, a las 18:20:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3695,53,'                              ','Lunes 25 de Octubre del 04, a las 18:21:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3696,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 18:24:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3697,53,'                              ','Lunes 25 de Octubre del 04, a las 18:24:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3698,53,'                              ','Lunes 25 de Octubre del 04, a las 18:24:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3699,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 18:25:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3700,53,'                              ','Lunes 25 de Octubre del 04, a las 18:25:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3701,51,'Direccion                     ','Lunes 25 de Octubre del 04, a las 18:25:45        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3702,4,'                              ','Lunes 25 de Octubre del 04, a las 19:10:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3703,4,'                              ','Lunes 25 de Octubre del 04, a las 19:21:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3704,4,'                              ','Lunes 25 de Octubre del 04, a las 19:28:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3705,2,'Bib Datos Propopios           ','Lunes 25 de Octubre del 04, a las 19:29:26        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3706,4,'                              ','Lunes 25 de Octubre del 04, a las 19:36:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3707,2,'Bib Datos Propopios           ','Jueves 4 de Noviembre del 04, a las 15:17:23      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3708,2,'Bib Datos Propopios           ','Jueves 4 de Noviembre del 04, a las 15:17:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3709,6,'                              ','Martes 23 de Noviembre del 04, a las 10:00:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3710,2,'Bib Datos Propopios           ','Martes 23 de Noviembre del 04, a las 10:06:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3711,8,'                              ','Martes 23 de Noviembre del 04, a las 10:12:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3712,8,'                              ','Martes 23 de Noviembre del 04, a las 10:14:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3713,53,'                              ','Martes 23 de Noviembre del 04, a las 10:20:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3714,51,'Direccion                     ','Martes 23 de Noviembre del 04, a las 10:23:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3715,6,'                              ','Martes 23 de Noviembre del 04, a las 10:27:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3716,6,'                              ','Martes 23 de Noviembre del 04, a las 10:33:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3717,4,'                              ','Martes 23 de Noviembre del 04, a las 10:37:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3718,6,'                              ','Martes 23 de Noviembre del 04, a las 10:39:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3719,8,'                              ','Martes 23 de Noviembre del 04, a las 10:41:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3720,6,'                              ','Martes 23 de Noviembre del 04, a las 10:47:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3721,53,'                              ','Martes 23 de Noviembre del 04, a las 10:48:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3722,6,'                              ','Martes 23 de Noviembre del 04, a las 10:52:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3723,53,'                              ','Martes 23 de Noviembre del 04, a las 10:58:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3724,3,'                              ','Martes 23 de Noviembre del 04, a las 11:01:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3725,6,'                              ','Martes 23 de Noviembre del 04, a las 11:03:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3726,8,'                              ','Martes 23 de Noviembre del 04, a las 11:05:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3727,53,'                              ','Martes 23 de Noviembre del 04, a las 11:08:40     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3728,6,'                              ','Martes 23 de Noviembre del 04, a las 11:11:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3729,6,'                              ','Martes 23 de Noviembre del 04, a las 11:12:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3730,8,'                              ','Martes 23 de Noviembre del 04, a las 11:14:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3731,6,'                              ','Martes 23 de Noviembre del 04, a las 11:19:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3732,6,'                              ','Martes 23 de Noviembre del 04, a las 11:26:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3733,11,'                              ','Martes 23 de Noviembre del 04, a las 11:28:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3734,4,'                              ','Martes 23 de Noviembre del 04, a las 11:36:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3735,53,'                              ','Martes 23 de Noviembre del 04, a las 11:38:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3736,6,'                              ','Martes 23 de Noviembre del 04, a las 11:47:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3737,3,'                              ','Martes 23 de Noviembre del 04, a las 11:49:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3738,6,'                              ','Martes 23 de Noviembre del 04, a las 11:51:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3739,4,'                              ','Martes 23 de Noviembre del 04, a las 11:53:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3740,6,'                              ','Martes 23 de Noviembre del 04, a las 11:55:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3741,3,'                              ','Martes 23 de Noviembre del 04, a las 11:57:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3742,6,'                              ','Martes 23 de Noviembre del 04, a las 12:00:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3743,6,'                              ','Martes 23 de Noviembre del 04, a las 12:01:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3744,6,'                              ','Martes 23 de Noviembre del 04, a las 12:02:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3745,6,'                              ','Martes 23 de Noviembre del 04, a las 12:04:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3746,4,'                              ','Martes 23 de Noviembre del 04, a las 12:05:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3747,6,'                              ','Martes 23 de Noviembre del 04, a las 12:10:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3748,2,'Bib Datos Propopios           ','Martes 23 de Noviembre del 04, a las 12:12:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3749,4,'                              ','Martes 23 de Noviembre del 04, a las 12:14:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3750,6,'                              ','Martes 23 de Noviembre del 04, a las 12:17:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3751,6,'                              ','Martes 23 de Noviembre del 04, a las 12:22:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3752,6,'                              ','Martes 23 de Noviembre del 04, a las 12:27:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3753,6,'                              ','Martes 23 de Noviembre del 04, a las 12:35:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3754,3,'                              ','Martes 23 de Noviembre del 04, a las 12:39:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3755,6,'                              ','Martes 23 de Noviembre del 04, a las 12:43:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3756,6,'                              ','Martes 23 de Noviembre del 04, a las 12:45:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3757,6,'                              ','Martes 23 de Noviembre del 04, a las 12:46:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3758,4,'                              ','Martes 23 de Noviembre del 04, a las 12:47:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3759,8,'                              ','Martes 23 de Noviembre del 04, a las 12:50:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3760,11,'                              ','Martes 23 de Noviembre del 04, a las 12:51:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3761,6,'                              ','Martes 23 de Noviembre del 04, a las 12:54:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3762,11,'                              ','Martes 23 de Noviembre del 04, a las 12:56:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3763,6,'                              ','Martes 23 de Noviembre del 04, a las 12:59:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3764,6,'                              ','Martes 23 de Noviembre del 04, a las 13:01:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3765,53,'                              ','Martes 23 de Noviembre del 04, a las 13:02:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3766,6,'                              ','Martes 23 de Noviembre del 04, a las 13:05:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3767,4,'                              ','Martes 23 de Noviembre del 04, a las 13:06:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3768,6,'                              ','Martes 23 de Noviembre del 04, a las 13:10:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3769,8,'                              ','Martes 23 de Noviembre del 04, a las 13:13:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3770,8,'                              ','Mircoles 24 de Noviembre del 04, a las 11:48:02  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3771,6,'                              ','Mircoles 24 de Noviembre del 04, a las 11:53:07  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3772,6,'                              ','Mircoles 24 de Noviembre del 04, a las 11:57:16  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3773,8,'                              ','Mircoles 24 de Noviembre del 04, a las 12:00:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3774,6,'                              ','Mircoles 24 de Noviembre del 04, a las 14:03:52  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3775,6,'                              ','Mircoles 24 de Noviembre del 04, a las 14:08:41  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3776,10,'                              ','Mircoles 24 de Noviembre del 04, a las 14:10:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3777,2,'Bib Datos Propopios           ','Mircoles 24 de Noviembre del 04, a las 14:12:12  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3778,11,'                              ','Mircoles 24 de Noviembre del 04, a las 14:14:56  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3779,8,'                              ','Mircoles 24 de Noviembre del 04, a las 14:40:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3780,8,'                              ','Mircoles 24 de Noviembre del 04, a las 14:50:06  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3781,6,'                              ','Mircoles 24 de Noviembre del 04, a las 14:53:42  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3782,11,'                              ','Mircoles 24 de Noviembre del 04, a las 14:56:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3783,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:02:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3784,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:05:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3785,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:07:22  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3786,11,'                              ','Mircoles 24 de Noviembre del 04, a las 15:08:43  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3787,11,'                              ','Mircoles 24 de Noviembre del 04, a las 15:10:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3788,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:19:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3789,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:22:22  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3790,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:30:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3791,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:37:57  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3792,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:47:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3793,6,'                              ','Mircoles 24 de Noviembre del 04, a las 15:47:43  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3794,53,'                              ','Mircoles 24 de Noviembre del 04, a las 15:48:49  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3795,8,'                              ','Mircoles 24 de Noviembre del 04, a las 15:50:51  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3796,51,'Direccion                     ','Mircoles 24 de Noviembre del 04, a las 17:38:27  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3797,6,'                              ','Mircoles 24 de Noviembre del 04, a las 17:41:06  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3798,6,'                              ','Mircoles 24 de Noviembre del 04, a las 17:44:47  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3799,6,'                              ','Mircoles 24 de Noviembre del 04, a las 17:47:34  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3800,8,'                              ','Mircoles 24 de Noviembre del 04, a las 17:48:47  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3801,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:03:02  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3802,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:04:44  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3803,10,'                              ','Mircoles 24 de Noviembre del 04, a las 18:07:25  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3804,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:13:27  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3805,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:19:40  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3806,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:21:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3807,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:23:22  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3808,53,'                              ','Mircoles 24 de Noviembre del 04, a las 18:24:22  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3809,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:25:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3810,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:25:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3811,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:28:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3812,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:29:11  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3813,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:32:57  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3814,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:35:24  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3815,11,'                              ','Mircoles 24 de Noviembre del 04, a las 18:36:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3816,11,'                              ','Mircoles 24 de Noviembre del 04, a las 18:37:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3817,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:39:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3818,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:40:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3819,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:44:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3820,6,'                              ','Mircoles 24 de Noviembre del 04, a las 18:50:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3821,11,'                              ','Mircoles 24 de Noviembre del 04, a las 18:56:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3822,11,'                              ','Mircoles 24 de Noviembre del 04, a las 18:57:02  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3823,6,'                              ','Jueves 25 de Noviembre del 04, a las 11:42:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3824,6,'                              ','Jueves 25 de Noviembre del 04, a las 11:45:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3825,6,'                              ','Jueves 25 de Noviembre del 04, a las 11:48:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3826,8,'                              ','Jueves 25 de Noviembre del 04, a las 11:54:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3827,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:05:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3828,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:13:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3829,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:14:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3830,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:15:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3831,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:16:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3832,6,'                              ','Jueves 25 de Noviembre del 04, a las 12:21:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3833,4,'                              ','Jueves 25 de Noviembre del 04, a las 12:23:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3834,6,'                              ','Jueves 25 de Noviembre del 04, a las 12:24:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3835,6,'                              ','Jueves 25 de Noviembre del 04, a las 12:27:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3836,4,'                              ','Jueves 25 de Noviembre del 04, a las 12:29:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3837,6,'                              ','Jueves 25 de Noviembre del 04, a las 12:32:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3838,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:39:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3839,2,'Bib Datos Propopios           ','Jueves 25 de Noviembre del 04, a las 12:42:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3840,53,'                              ','Jueves 25 de Noviembre del 04, a las 12:43:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3841,8,'                              ','Jueves 25 de Noviembre del 04, a las 12:53:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3842,2,'Bib Datos Propopios           ','Jueves 25 de Noviembre del 04, a las 12:55:19     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3843,2,'Bib Datos Propopios           ','Jueves 25 de Noviembre del 04, a las 12:57:12     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3844,8,'                              ','Jueves 25 de Noviembre del 04, a las 13:01:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3845,2,'Bib Datos Propopios           ','Jueves 25 de Noviembre del 04, a las 13:03:24     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3846,2,'Bib Datos Propopios           ','Jueves 25 de Noviembre del 04, a las 13:04:34     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3847,6,'                              ','Jueves 25 de Noviembre del 04, a las 13:25:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3848,3,'                              ','Jueves 25 de Noviembre del 04, a las 13:35:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3849,4,'                              ','Jueves 25 de Noviembre del 04, a las 13:36:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3850,4,'                              ','Jueves 25 de Noviembre del 04, a las 13:37:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3851,53,'                              ','Jueves 25 de Noviembre del 04, a las 13:38:29     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3852,6,'                              ','Jueves 25 de Noviembre del 04, a las 13:44:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3853,6,'                              ','Jueves 25 de Noviembre del 04, a las 13:50:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3854,6,'                              ','Jueves 25 de Noviembre del 04, a las 13:55:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3855,6,'                              ','Jueves 25 de Noviembre del 04, a las 13:57:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3856,6,'                              ','Jueves 25 de Noviembre del 04, a las 13:57:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3857,6,'                              ','Jueves 25 de Noviembre del 04, a las 14:03:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3858,3,'                              ','Jueves 25 de Noviembre del 04, a las 14:04:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3859,6,'                              ','Jueves 25 de Noviembre del 04, a las 14:04:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3860,2,'Bib Datos Propopios           ','Viernes 26 de Noviembre del 04, a las 10:00:39    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3861,4,'                              ','Viernes 26 de Noviembre del 04, a las 10:02:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3862,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 12:05:49     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3863,8,'                              ','Martes 30 de Noviembre del 04, a las 12:16:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3864,8,'                              ','Martes 30 de Noviembre del 04, a las 12:17:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3865,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 12:18:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3866,8,'                              ','Martes 30 de Noviembre del 04, a las 12:20:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3867,8,'                              ','Martes 30 de Noviembre del 04, a las 12:22:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3868,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 12:24:13     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3869,8,'                              ','Martes 30 de Noviembre del 04, a las 12:29:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3870,8,'                              ','Martes 30 de Noviembre del 04, a las 12:32:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3871,8,'                              ','Martes 30 de Noviembre del 04, a las 12:33:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3872,8,'                              ','Martes 30 de Noviembre del 04, a las 12:34:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3873,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 12:35:58     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3874,8,'                              ','Martes 30 de Noviembre del 04, a las 12:38:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3875,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 12:39:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3876,8,'                              ','Martes 30 de Noviembre del 04, a las 13:06:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3877,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 13:07:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3878,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 13:07:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3879,8,'                              ','Martes 30 de Noviembre del 04, a las 13:08:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3880,6,'                              ','Martes 30 de Noviembre del 04, a las 13:17:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3881,6,'                              ','Martes 30 de Noviembre del 04, a las 13:19:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3882,6,'                              ','Martes 30 de Noviembre del 04, a las 13:20:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3883,3,'                              ','Martes 30 de Noviembre del 04, a las 13:23:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3884,3,'                              ','Martes 30 de Noviembre del 04, a las 13:24:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3885,3,'                              ','Martes 30 de Noviembre del 04, a las 13:24:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3886,6,'                              ','Martes 30 de Noviembre del 04, a las 13:26:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3887,6,'                              ','Martes 30 de Noviembre del 04, a las 13:31:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3888,6,'                              ','Martes 30 de Noviembre del 04, a las 13:32:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3889,6,'                              ','Martes 30 de Noviembre del 04, a las 13:32:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3890,6,'                              ','Martes 30 de Noviembre del 04, a las 13:37:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3891,6,'                              ','Martes 30 de Noviembre del 04, a las 13:39:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3892,6,'                              ','Martes 30 de Noviembre del 04, a las 13:41:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3893,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 13:43:04     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3894,8,'                              ','Martes 30 de Noviembre del 04, a las 13:52:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3895,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 13:53:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3896,8,'                              ','Martes 30 de Noviembre del 04, a las 13:54:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3897,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 13:55:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3898,8,'                              ','Martes 30 de Noviembre del 04, a las 14:02:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3899,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 14:04:01     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3900,8,'                              ','Martes 30 de Noviembre del 04, a las 14:06:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3901,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 14:08:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3902,8,'                              ','Martes 30 de Noviembre del 04, a las 14:12:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3903,2,'Bib Datos Propopios           ','Martes 30 de Noviembre del 04, a las 14:13:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3904,8,'                              ','Martes 30 de Noviembre del 04, a las 14:17:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3905,4,'                              ','Martes 11 de Enero del 05, a las 14:49:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3906,4,'                              ','Martes 11 de Enero del 05, a las 14:53:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3907,4,'                              ','Martes 11 de Enero del 05, a las 15:05:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3908,8,'                              ','Mircoles 12 de Enero del 05, a las 12:46:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3909,4,'                              ','Mircoles 12 de Enero del 05, a las 12:54:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3910,51,'Direccion                     ','Mircoles 12 de Enero del 05, a las 17:11:40      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3911,4,'                              ','Mircoles 12 de Enero del 05, a las 17:25:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3912,8,'                              ','Mircoles 12 de Enero del 05, a las 17:34:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3913,8,'                              ','Mircoles 12 de Enero del 05, a las 17:34:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3914,8,'                              ','Mircoles 12 de Enero del 05, a las 18:46:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3915,8,'                              ','Jueves 13 de Enero del 05, a las 11:26:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3916,53,'                              ','Jueves 13 de Enero del 05, a las 15:12:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3917,2,'Bib Datos Propopios           ','Viernes 14 de Enero del 05, a las 14:54:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3918,6,'                              ','Viernes 14 de Enero del 05, a las 19:24:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3919,6,'                              ','Viernes 14 de Enero del 05, a las 19:25:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3920,6,'                              ','Martes 18 de Enero del 05, a las 13:34:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3921,4,'                              ','Martes 18 de Enero del 05, a las 13:35:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3922,8,'                              ','Martes 18 de Enero del 05, a las 13:42:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3923,6,'                              ','Martes 18 de Enero del 05, a las 13:43:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3924,51,'Direccion                     ','Mircoles 19 de Enero del 05, a las 10:58:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3925,51,'Direccion                     ','Mircoles 19 de Enero del 05, a las 10:59:44      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3926,6,'                              ','Martes 25 de Enero del 05, a las 12:12:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3927,6,'                              ','Martes 8 de Marzo del 05, a las 14:37:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3928,6,'                              ','Martes 8 de Marzo del 05, a las 14:39:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3929,8,'                              ','Martes 8 de Marzo del 05, a las 14:45:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3930,11,'                              ','Martes 8 de Marzo del 05, a las 14:46:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3931,11,'                              ','Martes 8 de Marzo del 05, a las 14:46:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3932,6,'                              ','Martes 8 de Marzo del 05, a las 14:50:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3933,6,'                              ','Martes 8 de Marzo del 05, a las 14:52:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3934,8,'                              ','Martes 8 de Marzo del 05, a las 14:55:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3935,8,'                              ','Martes 8 de Marzo del 05, a las 14:55:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3936,11,'                              ','Martes 8 de Marzo del 05, a las 14:56:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3937,6,'                              ','Martes 8 de Marzo del 05, a las 14:57:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3938,6,'                              ','Martes 8 de Marzo del 05, a las 15:00:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3939,4,'                              ','Martes 8 de Marzo del 05, a las 15:01:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3940,6,'                              ','Martes 8 de Marzo del 05, a las 15:03:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3941,8,'                              ','Martes 8 de Marzo del 05, a las 15:04:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3942,6,'                              ','Martes 8 de Marzo del 05, a las 15:10:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3943,6,'                              ','Martes 8 de Marzo del 05, a las 15:11:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3944,6,'                              ','Martes 8 de Marzo del 05, a las 15:14:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3945,6,'                              ','Martes 8 de Marzo del 05, a las 15:20:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3946,8,'                              ','Martes 8 de Marzo del 05, a las 15:21:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3947,6,'                              ','Viernes 11 de Marzo del 05, a las 12:47:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3948,6,'                              ','Martes 29 de Marzo del 05, a las 14:28:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3949,6,'                              ','Martes 29 de Marzo del 05, a las 14:28:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3950,6,'                              ','Viernes 1 de Abril del 05, a las 12:20:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3951,6,'                              ','Viernes 1 de Abril del 05, a las 12:23:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3952,6,'                              ','Viernes 1 de Abril del 05, a las 12:24:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3953,6,'                              ','Viernes 1 de Abril del 05, a las 12:26:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3954,6,'                              ','Viernes 1 de Abril del 05, a las 12:27:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3955,6,'                              ','Viernes 1 de Abril del 05, a las 12:28:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3956,6,'                              ','Viernes 1 de Abril del 05, a las 12:29:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3957,6,'                              ','Viernes 1 de Abril del 05, a las 12:31:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3958,2,'Bib Datos Propopios           ','Lunes 4 de Abril del 05, a las 14:46:13           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3959,6,'                              ','Jueves 14 de Abril del 05, a las 10:13:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3960,6,'                              ','Jueves 14 de Abril del 05, a las 10:18:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3961,6,'                              ','Jueves 14 de Abril del 05, a las 12:40:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3962,6,'                              ','Jueves 14 de Abril del 05, a las 12:44:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3963,6,'                              ','Jueves 14 de Abril del 05, a las 12:47:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3964,6,'                              ','Jueves 14 de Abril del 05, a las 12:57:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3965,6,'                              ','Jueves 14 de Abril del 05, a las 13:11:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3966,6,'                              ','Jueves 14 de Abril del 05, a las 13:13:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3967,6,'                              ','Jueves 14 de Abril del 05, a las 13:38:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3968,6,'                              ','Jueves 14 de Abril del 05, a las 13:41:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3969,6,'                              ','Jueves 14 de Abril del 05, a las 13:43:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3970,6,'                              ','Jueves 14 de Abril del 05, a las 13:47:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3971,6,'                              ','Jueves 14 de Abril del 05, a las 13:51:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3972,6,'                              ','Jueves 14 de Abril del 05, a las 14:56:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3973,6,'                              ','Jueves 14 de Abril del 05, a las 14:57:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3974,6,'                              ','Jueves 14 de Abril del 05, a las 14:58:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3975,6,'                              ','Jueves 14 de Abril del 05, a las 14:59:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3976,6,'                              ','Jueves 14 de Abril del 05, a las 15:00:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3977,6,'                              ','Jueves 14 de Abril del 05, a las 15:01:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3978,6,'                              ','Jueves 14 de Abril del 05, a las 15:02:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3979,6,'                              ','Jueves 14 de Abril del 05, a las 15:02:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3980,6,'                              ','Jueves 14 de Abril del 05, a las 15:08:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3981,6,'                              ','Jueves 14 de Abril del 05, a las 15:10:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3982,6,'                              ','Viernes 15 de Abril del 05, a las 17:01:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3983,6,'                              ','Martes 19 de Abril del 05, a las 14:38:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3984,6,'                              ','Martes 19 de Abril del 05, a las 14:41:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3985,53,'                              ','Martes 19 de Abril del 05, a las 14:48:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3986,53,'                              ','Martes 19 de Abril del 05, a las 14:48:50         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3987,11,'                              ','Jueves 21 de Abril del 05, a las 09:45:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3988,11,'                              ','Jueves 21 de Abril del 05, a las 09:46:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3989,11,'                              ','Jueves 21 de Abril del 05, a las 09:47:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3990,11,'                              ','Jueves 21 de Abril del 05, a las 09:49:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3991,11,'                              ','Jueves 21 de Abril del 05, a las 09:51:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3992,11,'                              ','Jueves 21 de Abril del 05, a las 09:53:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3993,11,'                              ','Jueves 21 de Abril del 05, a las 09:54:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3994,11,'                              ','Jueves 21 de Abril del 05, a las 09:56:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3995,11,'                              ','Jueves 21 de Abril del 05, a las 09:57:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3996,11,'                              ','Jueves 21 de Abril del 05, a las 09:59:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3997,11,'                              ','Jueves 21 de Abril del 05, a las 10:01:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3998,11,'                              ','Jueves 21 de Abril del 05, a las 10:02:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (3999,11,'                              ','Jueves 21 de Abril del 05, a las 10:04:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4000,11,'                              ','Jueves 21 de Abril del 05, a las 10:08:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4001,11,'                              ','Jueves 21 de Abril del 05, a las 10:10:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4002,11,'                              ','Jueves 21 de Abril del 05, a las 10:11:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4003,11,'                              ','Jueves 21 de Abril del 05, a las 10:13:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4004,11,'                              ','Jueves 21 de Abril del 05, a las 10:16:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4005,11,'                              ','Jueves 21 de Abril del 05, a las 10:23:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4006,11,'                              ','Jueves 21 de Abril del 05, a las 10:26:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4007,11,'                              ','Jueves 21 de Abril del 05, a las 10:31:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4008,11,'                              ','Jueves 21 de Abril del 05, a las 10:33:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4009,11,'                              ','Jueves 21 de Abril del 05, a las 10:37:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4010,11,'                              ','Jueves 21 de Abril del 05, a las 10:39:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4011,11,'                              ','Jueves 21 de Abril del 05, a las 10:42:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4012,11,'                              ','Jueves 21 de Abril del 05, a las 10:54:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4013,11,'                              ','Jueves 21 de Abril del 05, a las 10:55:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4014,11,'                              ','Jueves 21 de Abril del 05, a las 10:57:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4015,11,'                              ','Jueves 21 de Abril del 05, a las 10:59:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4016,11,'                              ','Jueves 21 de Abril del 05, a las 11:01:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4017,11,'                              ','Jueves 21 de Abril del 05, a las 11:02:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4018,11,'                              ','Jueves 21 de Abril del 05, a las 11:03:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4019,11,'                              ','Jueves 21 de Abril del 05, a las 11:05:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4020,11,'                              ','Jueves 21 de Abril del 05, a las 11:06:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4021,11,'                              ','Jueves 21 de Abril del 05, a las 11:08:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4022,11,'                              ','Jueves 21 de Abril del 05, a las 11:09:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4023,11,'                              ','Jueves 21 de Abril del 05, a las 11:11:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4024,11,'                              ','Jueves 21 de Abril del 05, a las 11:14:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4025,11,'                              ','Jueves 21 de Abril del 05, a las 11:17:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4026,11,'                              ','Jueves 21 de Abril del 05, a las 11:19:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4027,11,'                              ','Jueves 21 de Abril del 05, a las 11:20:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4028,11,'                              ','Jueves 21 de Abril del 05, a las 11:22:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4029,11,'                              ','Jueves 21 de Abril del 05, a las 11:23:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4030,11,'                              ','Jueves 21 de Abril del 05, a las 11:25:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4031,11,'                              ','Jueves 21 de Abril del 05, a las 11:26:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4032,11,'                              ','Jueves 21 de Abril del 05, a las 11:28:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4033,11,'                              ','Jueves 21 de Abril del 05, a las 11:31:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4034,11,'                              ','Jueves 21 de Abril del 05, a las 11:33:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4035,11,'                              ','Jueves 21 de Abril del 05, a las 11:34:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4036,11,'                              ','Jueves 21 de Abril del 05, a las 11:37:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4037,11,'                              ','Jueves 21 de Abril del 05, a las 11:39:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4038,11,'                              ','Jueves 21 de Abril del 05, a las 11:41:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4039,11,'                              ','Jueves 21 de Abril del 05, a las 11:43:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4040,11,'                              ','Jueves 21 de Abril del 05, a las 11:44:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4041,11,'                              ','Jueves 21 de Abril del 05, a las 11:53:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4042,11,'                              ','Jueves 21 de Abril del 05, a las 12:18:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4043,11,'                              ','Jueves 21 de Abril del 05, a las 12:20:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4044,11,'                              ','Jueves 21 de Abril del 05, a las 12:27:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4045,11,'                              ','Jueves 21 de Abril del 05, a las 12:29:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4046,11,'                              ','Jueves 21 de Abril del 05, a las 12:30:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4047,11,'                              ','Jueves 21 de Abril del 05, a las 12:31:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4048,11,'                              ','Jueves 21 de Abril del 05, a las 12:33:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4049,11,'                              ','Jueves 21 de Abril del 05, a las 12:34:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4050,11,'                              ','Jueves 21 de Abril del 05, a las 12:36:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4051,11,'                              ','Jueves 21 de Abril del 05, a las 12:38:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4052,11,'                              ','Jueves 21 de Abril del 05, a las 12:39:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4053,11,'                              ','Jueves 21 de Abril del 05, a las 12:40:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4054,11,'                              ','Jueves 21 de Abril del 05, a las 12:41:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4055,11,'                              ','Jueves 21 de Abril del 05, a las 12:43:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4056,11,'                              ','Jueves 21 de Abril del 05, a las 12:45:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4057,11,'                              ','Jueves 21 de Abril del 05, a las 12:46:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4058,11,'                              ','Jueves 21 de Abril del 05, a las 12:47:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4059,11,'                              ','Jueves 21 de Abril del 05, a las 12:49:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4060,11,'                              ','Jueves 21 de Abril del 05, a las 12:50:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4061,11,'                              ','Jueves 21 de Abril del 05, a las 12:53:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4062,11,'                              ','Jueves 21 de Abril del 05, a las 12:54:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4063,11,'                              ','Jueves 21 de Abril del 05, a las 12:55:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4064,11,'                              ','Jueves 21 de Abril del 05, a las 12:57:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4065,11,'                              ','Jueves 21 de Abril del 05, a las 12:58:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4066,11,'                              ','Jueves 21 de Abril del 05, a las 12:59:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4067,11,'                              ','Jueves 21 de Abril del 05, a las 13:00:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4068,11,'                              ','Jueves 21 de Abril del 05, a las 13:02:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4069,11,'                              ','Jueves 21 de Abril del 05, a las 13:03:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4070,11,'                              ','Jueves 21 de Abril del 05, a las 13:05:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4071,11,'                              ','Jueves 21 de Abril del 05, a las 13:06:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4072,11,'                              ','Jueves 21 de Abril del 05, a las 13:10:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4073,11,'                              ','Jueves 21 de Abril del 05, a las 13:11:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4074,11,'                              ','Jueves 21 de Abril del 05, a las 13:23:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4075,11,'                              ','Jueves 21 de Abril del 05, a las 13:24:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4076,11,'                              ','Jueves 21 de Abril del 05, a las 13:25:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4077,11,'                              ','Jueves 21 de Abril del 05, a las 13:26:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4078,11,'                              ','Jueves 21 de Abril del 05, a las 13:28:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4079,11,'                              ','Jueves 21 de Abril del 05, a las 13:28:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4080,11,'                              ','Jueves 21 de Abril del 05, a las 13:29:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4081,11,'                              ','Jueves 21 de Abril del 05, a las 13:30:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4082,11,'                              ','Jueves 21 de Abril del 05, a las 13:33:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4083,11,'                              ','Jueves 21 de Abril del 05, a las 13:34:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4084,11,'                              ','Jueves 21 de Abril del 05, a las 13:35:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4085,11,'                              ','Jueves 21 de Abril del 05, a las 13:36:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4086,11,'                              ','Jueves 21 de Abril del 05, a las 13:38:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4087,11,'                              ','Jueves 21 de Abril del 05, a las 13:41:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4088,11,'                              ','Jueves 21 de Abril del 05, a las 13:42:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4089,11,'                              ','Jueves 21 de Abril del 05, a las 13:43:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4090,11,'                              ','Jueves 21 de Abril del 05, a las 13:44:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4091,11,'                              ','Jueves 21 de Abril del 05, a las 13:46:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4092,11,'                              ','Jueves 21 de Abril del 05, a las 13:47:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4093,11,'                              ','Jueves 21 de Abril del 05, a las 13:50:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4094,11,'                              ','Jueves 21 de Abril del 05, a las 13:51:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4095,11,'                              ','Jueves 21 de Abril del 05, a las 13:52:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4096,11,'                              ','Jueves 21 de Abril del 05, a las 13:55:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4097,11,'                              ','Jueves 21 de Abril del 05, a las 13:56:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4098,11,'                              ','Jueves 21 de Abril del 05, a las 13:59:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4099,11,'                              ','Jueves 21 de Abril del 05, a las 14:02:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4100,11,'                              ','Jueves 21 de Abril del 05, a las 14:03:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4101,11,'                              ','Jueves 21 de Abril del 05, a las 14:04:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4102,11,'                              ','Jueves 21 de Abril del 05, a las 14:07:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4103,11,'                              ','Jueves 21 de Abril del 05, a las 14:08:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4104,11,'                              ','Jueves 21 de Abril del 05, a las 14:10:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4105,11,'                              ','Jueves 21 de Abril del 05, a las 14:12:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4106,11,'                              ','Jueves 21 de Abril del 05, a las 14:13:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4107,11,'                              ','Jueves 21 de Abril del 05, a las 14:14:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4108,11,'                              ','Jueves 21 de Abril del 05, a las 14:16:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4109,11,'                              ','Jueves 21 de Abril del 05, a las 14:17:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4110,11,'                              ','Jueves 21 de Abril del 05, a las 14:18:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4111,11,'                              ','Jueves 21 de Abril del 05, a las 14:20:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4112,11,'                              ','Jueves 21 de Abril del 05, a las 14:21:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4113,11,'                              ','Jueves 21 de Abril del 05, a las 14:23:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4114,11,'                              ','Jueves 21 de Abril del 05, a las 14:24:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4115,11,'                              ','Jueves 21 de Abril del 05, a las 14:25:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4116,11,'                              ','Jueves 21 de Abril del 05, a las 14:26:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4117,11,'                              ','Jueves 21 de Abril del 05, a las 14:28:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4118,11,'                              ','Jueves 21 de Abril del 05, a las 14:31:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4119,11,'                              ','Jueves 21 de Abril del 05, a las 14:32:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4120,11,'                              ','Jueves 21 de Abril del 05, a las 14:34:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4121,11,'                              ','Jueves 21 de Abril del 05, a las 14:35:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4122,11,'                              ','Jueves 21 de Abril del 05, a las 14:37:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4123,11,'                              ','Jueves 21 de Abril del 05, a las 14:38:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4124,11,'                              ','Jueves 21 de Abril del 05, a las 14:40:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4125,8,'                              ','Jueves 21 de Abril del 05, a las 14:53:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4126,8,'                              ','Jueves 21 de Abril del 05, a las 14:54:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4127,6,'                              ','Jueves 21 de Abril del 05, a las 15:19:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4128,8,'                              ','Jueves 21 de Abril del 05, a las 15:19:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4129,6,'                              ','Viernes 29 de Abril del 05, a las 19:54:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4130,4,'                              ','Jueves 12 de Mayo del 05, a las 09:15:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4131,4,'                              ','Jueves 12 de Mayo del 05, a las 09:22:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4132,2,'Bib Datos Propopios           ','Jueves 12 de Mayo del 05, a las 11:02:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4133,4,'                              ','Jueves 12 de Mayo del 05, a las 11:04:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4134,4,'                              ','Jueves 12 de Mayo del 05, a las 11:09:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4135,4,'                              ','Jueves 12 de Mayo del 05, a las 11:12:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4136,2,'Bib Datos Propopios           ','Jueves 12 de Mayo del 05, a las 11:29:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4137,4,'                              ','Jueves 12 de Mayo del 05, a las 11:31:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4138,6,'                              ','Jueves 12 de Mayo del 05, a las 11:40:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4139,2,'Bib Datos Propopios           ','Jueves 12 de Mayo del 05, a las 12:18:08          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4140,4,'                              ','Jueves 12 de Mayo del 05, a las 12:18:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4141,2,'Bib Datos Propopios           ','Jueves 12 de Mayo del 05, a las 12:35:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4142,4,'                              ','Jueves 12 de Mayo del 05, a las 12:35:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4143,4,'                              ','Jueves 12 de Mayo del 05, a las 13:23:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4144,2,'Bib Datos Propopios           ','Jueves 12 de Mayo del 05, a las 14:11:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4145,4,'                              ','Jueves 12 de Mayo del 05, a las 14:13:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4146,2,'Bib Datos Propopios           ','Jueves 12 de Mayo del 05, a las 14:25:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4147,4,'                              ','Jueves 12 de Mayo del 05, a las 14:26:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4148,6,'                              ','Lunes 16 de Mayo del 05, a las 13:24:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4149,8,'                              ','Lunes 16 de Mayo del 05, a las 13:27:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4150,6,'                              ','Lunes 16 de Mayo del 05, a las 13:30:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4151,8,'                              ','Lunes 16 de Mayo del 05, a las 13:31:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4152,11,'                              ','Lunes 16 de Mayo del 05, a las 13:35:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4153,6,'                              ','Lunes 16 de Mayo del 05, a las 13:38:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4154,8,'                              ','Lunes 16 de Mayo del 05, a las 13:39:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4155,6,'                              ','Lunes 16 de Mayo del 05, a las 13:40:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4156,8,'                              ','Lunes 16 de Mayo del 05, a las 13:41:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4157,6,'                              ','Lunes 16 de Mayo del 05, a las 13:42:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4158,11,'                              ','Lunes 16 de Mayo del 05, a las 13:46:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4159,6,'                              ','Lunes 16 de Mayo del 05, a las 13:49:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4160,8,'                              ','Lunes 16 de Mayo del 05, a las 13:49:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4161,11,'                              ','Lunes 16 de Mayo del 05, a las 13:52:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4162,6,'                              ','Lunes 16 de Mayo del 05, a las 13:54:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4163,11,'                              ','Lunes 16 de Mayo del 05, a las 13:56:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4164,6,'                              ','Lunes 16 de Mayo del 05, a las 13:59:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4165,6,'                              ','Lunes 16 de Mayo del 05, a las 14:02:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4166,8,'                              ','Martes 17 de Mayo del 05, a las 12:02:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4167,6,'                              ','Martes 17 de Mayo del 05, a las 13:32:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4168,6,'                              ','Martes 17 de Mayo del 05, a las 13:33:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4169,6,'                              ','Martes 17 de Mayo del 05, a las 13:38:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4170,6,'                              ','Viernes 20 de Mayo del 05, a las 10:18:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4171,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:41:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4172,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:42:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4173,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:43:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4174,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:45:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4175,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:50:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4176,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:52:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4177,11,'                              ','Mircoles 25 de Mayo del 05, a las 11:59:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4178,6,'                              ','Mircoles 25 de Mayo del 05, a las 12:02:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4179,6,'                              ','Mircoles 25 de Mayo del 05, a las 12:02:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4180,4,'                              ','Mircoles 25 de Mayo del 05, a las 12:16:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4181,11,'                              ','Mircoles 25 de Mayo del 05, a las 12:29:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4182,4,'                              ','Mircoles 25 de Mayo del 05, a las 12:34:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4183,11,'                              ','Mircoles 25 de Mayo del 05, a las 12:35:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4184,11,'                              ','Mircoles 25 de Mayo del 05, a las 12:36:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4185,4,'                              ','Mircoles 25 de Mayo del 05, a las 12:39:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4186,4,'                              ','Mircoles 25 de Mayo del 05, a las 12:43:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4187,11,'                              ','Mircoles 25 de Mayo del 05, a las 12:45:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4188,11,'                              ','Mircoles 25 de Mayo del 05, a las 12:55:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4189,2,'Bib Datos Propopios           ','Mircoles 1 de Junio del 05, a las 09:01:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4190,2,'Bib Datos Propopios           ','Mircoles 1 de Junio del 05, a las 09:03:46       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4191,6,'                              ','Mircoles 1 de Junio del 05, a las 09:07:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4192,6,'                              ','Mircoles 1 de Junio del 05, a las 14:56:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4193,6,'                              ','Mircoles 1 de Junio del 05, a las 15:26:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4194,11,'                              ','Jueves 2 de Junio del 05, a las 09:28:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4195,10,'                              ','Viernes 3 de Junio del 05, a las 12:18:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4196,6,'                              ','Viernes 3 de Junio del 05, a las 13:42:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4197,6,'                              ','Viernes 3 de Junio del 05, a las 13:43:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4198,6,'                              ','Viernes 3 de Junio del 05, a las 13:44:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4199,8,'                              ','Jueves 9 de Junio del 05, a las 14:08:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4200,8,'                              ','Jueves 9 de Junio del 05, a las 14:09:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4201,8,'                              ','Jueves 9 de Junio del 05, a las 14:17:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4202,8,'                              ','Jueves 9 de Junio del 05, a las 14:19:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4203,8,'                              ','Jueves 9 de Junio del 05, a las 15:24:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4204,8,'                              ','Jueves 9 de Junio del 05, a las 15:26:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4205,8,'                              ','Jueves 9 de Junio del 05, a las 15:28:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4206,8,'                              ','Jueves 9 de Junio del 05, a las 15:29:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4207,8,'                              ','Jueves 9 de Junio del 05, a las 15:31:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4208,8,'                              ','Jueves 9 de Junio del 05, a las 15:32:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4209,8,'                              ','Jueves 9 de Junio del 05, a las 15:34:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4210,8,'                              ','Jueves 9 de Junio del 05, a las 15:38:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4211,8,'                              ','Jueves 9 de Junio del 05, a las 15:39:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4212,8,'                              ','Jueves 9 de Junio del 05, a las 15:41:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4213,8,'                              ','Jueves 9 de Junio del 05, a las 15:42:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4214,8,'                              ','Jueves 9 de Junio del 05, a las 15:44:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4215,8,'                              ','Jueves 9 de Junio del 05, a las 15:45:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4216,8,'                              ','Viernes 10 de Junio del 05, a las 10:02:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4217,8,'                              ','Viernes 10 de Junio del 05, a las 10:03:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4218,8,'                              ','Viernes 10 de Junio del 05, a las 10:05:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4219,8,'                              ','Viernes 10 de Junio del 05, a las 10:06:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4220,8,'                              ','Viernes 10 de Junio del 05, a las 10:14:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4221,8,'                              ','Viernes 10 de Junio del 05, a las 10:16:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4222,8,'                              ','Viernes 10 de Junio del 05, a las 10:16:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4223,6,'                              ','Lunes 13 de Junio del 05, a las 11:41:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4224,2,'Bib Datos Propopios           ','Mircoles 15 de Junio del 05, a las 13:37:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4225,2,'Bib Datos Propopios           ','Mircoles 15 de Junio del 05, a las 13:37:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4226,51,'Direccion                     ','Mircoles 15 de Junio del 05, a las 13:55:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4227,4,'                              ','Jueves 16 de Junio del 05, a las 11:32:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4228,4,'                              ','Jueves 16 de Junio del 05, a las 11:35:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4229,4,'                              ','Jueves 16 de Junio del 05, a las 11:37:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4230,4,'                              ','Jueves 16 de Junio del 05, a las 11:39:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4231,4,'                              ','Jueves 16 de Junio del 05, a las 11:41:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4232,4,'                              ','Jueves 16 de Junio del 05, a las 11:42:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4233,4,'                              ','Jueves 16 de Junio del 05, a las 11:43:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4234,4,'                              ','Jueves 16 de Junio del 05, a las 11:45:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4235,4,'                              ','Jueves 16 de Junio del 05, a las 11:47:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4236,4,'                              ','Jueves 16 de Junio del 05, a las 11:48:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4237,4,'                              ','Jueves 16 de Junio del 05, a las 11:50:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4238,4,'                              ','Jueves 16 de Junio del 05, a las 11:52:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4239,4,'                              ','Jueves 16 de Junio del 05, a las 11:53:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4240,4,'                              ','Jueves 16 de Junio del 05, a las 12:22:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4241,4,'                              ','Jueves 16 de Junio del 05, a las 12:24:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4242,4,'                              ','Jueves 16 de Junio del 05, a las 12:26:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4243,4,'                              ','Jueves 16 de Junio del 05, a las 12:28:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4244,4,'                              ','Jueves 16 de Junio del 05, a las 12:30:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4245,4,'                              ','Jueves 16 de Junio del 05, a las 12:33:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4246,4,'                              ','Jueves 16 de Junio del 05, a las 12:36:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4247,4,'                              ','Jueves 16 de Junio del 05, a las 12:38:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4248,4,'                              ','Jueves 16 de Junio del 05, a las 12:40:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4249,4,'                              ','Jueves 16 de Junio del 05, a las 12:42:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4250,4,'                              ','Jueves 16 de Junio del 05, a las 12:43:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4251,4,'                              ','Jueves 16 de Junio del 05, a las 12:45:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4252,8,'                              ','Jueves 16 de Junio del 05, a las 12:46:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4253,4,'                              ','Jueves 16 de Junio del 05, a las 12:47:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4254,8,'                              ','Jueves 16 de Junio del 05, a las 12:48:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4255,4,'                              ','Jueves 16 de Junio del 05, a las 12:49:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4256,8,'                              ','Jueves 16 de Junio del 05, a las 12:50:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4257,4,'                              ','Jueves 16 de Junio del 05, a las 12:51:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4258,8,'                              ','Jueves 16 de Junio del 05, a las 12:51:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4259,4,'                              ','Jueves 16 de Junio del 05, a las 12:52:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4260,8,'                              ','Jueves 16 de Junio del 05, a las 12:53:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4261,4,'                              ','Jueves 16 de Junio del 05, a las 12:54:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4262,8,'                              ','Jueves 16 de Junio del 05, a las 12:55:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4263,4,'                              ','Jueves 16 de Junio del 05, a las 12:56:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4264,8,'                              ','Jueves 16 de Junio del 05, a las 12:56:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4265,4,'                              ','Jueves 16 de Junio del 05, a las 12:57:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4266,8,'                              ','Jueves 16 de Junio del 05, a las 12:59:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4267,4,'                              ','Jueves 16 de Junio del 05, a las 12:59:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4268,8,'                              ','Jueves 16 de Junio del 05, a las 13:00:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4269,4,'                              ','Jueves 16 de Junio del 05, a las 13:01:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4270,8,'                              ','Jueves 16 de Junio del 05, a las 13:01:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4271,4,'                              ','Jueves 16 de Junio del 05, a las 13:02:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4272,8,'                              ','Jueves 16 de Junio del 05, a las 13:04:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4273,4,'                              ','Jueves 16 de Junio del 05, a las 13:05:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4274,4,'                              ','Jueves 16 de Junio del 05, a las 13:07:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4275,4,'                              ','Jueves 16 de Junio del 05, a las 13:08:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4276,4,'                              ','Jueves 16 de Junio del 05, a las 13:10:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4277,8,'                              ','Jueves 16 de Junio del 05, a las 13:12:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4278,4,'                              ','Jueves 16 de Junio del 05, a las 13:13:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4279,8,'                              ','Jueves 16 de Junio del 05, a las 13:13:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4280,8,'                              ','Jueves 16 de Junio del 05, a las 13:14:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4281,4,'                              ','Jueves 16 de Junio del 05, a las 13:15:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4282,8,'                              ','Jueves 16 de Junio del 05, a las 13:16:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4283,4,'                              ','Jueves 16 de Junio del 05, a las 13:17:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4284,8,'                              ','Jueves 16 de Junio del 05, a las 13:18:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4285,8,'                              ','Jueves 16 de Junio del 05, a las 13:19:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4286,8,'                              ','Jueves 16 de Junio del 05, a las 13:20:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4287,8,'                              ','Jueves 16 de Junio del 05, a las 13:21:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4288,8,'                              ','Jueves 16 de Junio del 05, a las 13:22:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4289,8,'                              ','Jueves 16 de Junio del 05, a las 13:22:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4290,8,'                              ','Jueves 16 de Junio del 05, a las 13:26:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4291,8,'                              ','Jueves 16 de Junio del 05, a las 13:27:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4292,8,'                              ','Jueves 16 de Junio del 05, a las 13:27:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4293,8,'                              ','Jueves 16 de Junio del 05, a las 13:29:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4294,8,'                              ','Jueves 16 de Junio del 05, a las 13:31:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4295,8,'                              ','Jueves 16 de Junio del 05, a las 13:32:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4296,8,'                              ','Jueves 16 de Junio del 05, a las 13:37:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4297,8,'                              ','Jueves 16 de Junio del 05, a las 13:45:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4298,8,'                              ','Jueves 16 de Junio del 05, a las 13:47:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4299,8,'                              ','Jueves 16 de Junio del 05, a las 13:48:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4300,4,'                              ','Jueves 16 de Junio del 05, a las 13:49:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4301,8,'                              ','Jueves 16 de Junio del 05, a las 13:49:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4302,8,'                              ','Jueves 16 de Junio del 05, a las 13:51:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4303,4,'                              ','Jueves 16 de Junio del 05, a las 13:53:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4304,4,'                              ','Jueves 16 de Junio del 05, a las 13:55:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4305,8,'                              ','Jueves 16 de Junio del 05, a las 13:56:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4306,4,'                              ','Jueves 16 de Junio del 05, a las 13:56:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4307,8,'                              ','Jueves 16 de Junio del 05, a las 13:57:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4308,4,'                              ','Jueves 16 de Junio del 05, a las 13:58:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4309,8,'                              ','Jueves 16 de Junio del 05, a las 13:58:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4310,4,'                              ','Jueves 16 de Junio del 05, a las 14:01:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4311,4,'                              ','Jueves 16 de Junio del 05, a las 14:03:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4312,8,'                              ','Jueves 16 de Junio del 05, a las 14:03:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4313,4,'                              ','Jueves 16 de Junio del 05, a las 14:04:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4314,4,'                              ','Jueves 16 de Junio del 05, a las 14:07:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4315,4,'                              ','Jueves 16 de Junio del 05, a las 14:08:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4316,4,'                              ','Jueves 16 de Junio del 05, a las 14:09:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4317,8,'                              ','Jueves 16 de Junio del 05, a las 14:11:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4318,8,'                              ','Jueves 16 de Junio del 05, a las 14:12:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4319,8,'                              ','Jueves 16 de Junio del 05, a las 14:13:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4320,4,'                              ','Jueves 16 de Junio del 05, a las 14:14:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4321,8,'                              ','Jueves 16 de Junio del 05, a las 14:15:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4322,4,'                              ','Jueves 16 de Junio del 05, a las 14:16:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4323,8,'                              ','Jueves 16 de Junio del 05, a las 14:16:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4324,8,'                              ','Jueves 16 de Junio del 05, a las 14:17:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4325,4,'                              ','Jueves 16 de Junio del 05, a las 14:17:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4326,4,'                              ','Jueves 16 de Junio del 05, a las 14:24:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4327,8,'                              ','Jueves 16 de Junio del 05, a las 14:25:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4328,8,'                              ','Jueves 16 de Junio del 05, a las 14:26:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4329,4,'                              ','Jueves 16 de Junio del 05, a las 14:26:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4330,4,'                              ','Jueves 16 de Junio del 05, a las 14:28:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4331,4,'                              ','Jueves 16 de Junio del 05, a las 14:29:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4332,4,'                              ','Jueves 16 de Junio del 05, a las 14:32:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4333,4,'                              ','Jueves 16 de Junio del 05, a las 14:33:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4334,4,'                              ','Jueves 16 de Junio del 05, a las 14:36:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4335,8,'                              ','Jueves 16 de Junio del 05, a las 14:37:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4336,4,'                              ','Jueves 16 de Junio del 05, a las 14:37:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4337,4,'                              ','Jueves 16 de Junio del 05, a las 14:39:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4338,8,'                              ','Jueves 16 de Junio del 05, a las 14:39:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4339,4,'                              ','Jueves 16 de Junio del 05, a las 14:40:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4340,4,'                              ','Jueves 16 de Junio del 05, a las 14:41:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4341,4,'                              ','Jueves 16 de Junio del 05, a las 14:41:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4342,8,'                              ','Jueves 16 de Junio del 05, a las 14:42:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4343,4,'                              ','Jueves 16 de Junio del 05, a las 14:42:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4344,8,'                              ','Jueves 16 de Junio del 05, a las 14:43:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4345,8,'                              ','Jueves 16 de Junio del 05, a las 14:44:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4346,8,'                              ','Jueves 16 de Junio del 05, a las 14:45:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4347,8,'                              ','Jueves 16 de Junio del 05, a las 14:47:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4348,8,'                              ','Jueves 16 de Junio del 05, a las 14:50:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4349,8,'                              ','Jueves 16 de Junio del 05, a las 14:51:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4350,8,'                              ','Jueves 16 de Junio del 05, a las 14:52:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4351,8,'                              ','Jueves 16 de Junio del 05, a las 14:56:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4352,8,'                              ','Jueves 16 de Junio del 05, a las 14:57:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4353,8,'                              ','Jueves 16 de Junio del 05, a las 14:58:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4354,8,'                              ','Jueves 16 de Junio del 05, a las 14:59:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4355,8,'                              ','Jueves 16 de Junio del 05, a las 15:00:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4356,8,'                              ','Jueves 16 de Junio del 05, a las 15:01:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4357,8,'                              ','Jueves 16 de Junio del 05, a las 15:02:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4358,8,'                              ','Jueves 16 de Junio del 05, a las 15:03:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4359,8,'                              ','Jueves 16 de Junio del 05, a las 15:04:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4360,8,'                              ','Jueves 16 de Junio del 05, a las 15:05:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4361,8,'                              ','Jueves 16 de Junio del 05, a las 15:06:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4362,8,'                              ','Jueves 16 de Junio del 05, a las 15:08:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4363,8,'                              ','Jueves 16 de Junio del 05, a las 15:09:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4364,8,'                              ','Jueves 16 de Junio del 05, a las 15:13:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4365,8,'                              ','Jueves 16 de Junio del 05, a las 15:14:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4366,8,'                              ','Jueves 16 de Junio del 05, a las 15:16:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4367,8,'                              ','Jueves 16 de Junio del 05, a las 15:18:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4368,8,'                              ','Jueves 16 de Junio del 05, a las 15:24:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4369,8,'                              ','Jueves 16 de Junio del 05, a las 15:28:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4370,8,'                              ','Jueves 16 de Junio del 05, a las 15:29:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4371,8,'                              ','Jueves 16 de Junio del 05, a las 15:32:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4372,8,'                              ','Jueves 16 de Junio del 05, a las 15:32:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4373,8,'                              ','Jueves 16 de Junio del 05, a las 15:34:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4374,8,'                              ','Jueves 16 de Junio del 05, a las 15:35:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4375,8,'                              ','Jueves 16 de Junio del 05, a las 15:35:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4376,8,'                              ','Jueves 16 de Junio del 05, a las 15:37:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4377,8,'                              ','Jueves 16 de Junio del 05, a las 15:38:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4378,4,'                              ','Jueves 16 de Junio del 05, a las 18:30:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4379,4,'                              ','Jueves 16 de Junio del 05, a las 18:32:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4380,4,'                              ','Jueves 16 de Junio del 05, a las 18:34:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4381,4,'                              ','Jueves 16 de Junio del 05, a las 18:35:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4382,4,'                              ','Jueves 16 de Junio del 05, a las 18:37:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4383,4,'                              ','Jueves 16 de Junio del 05, a las 18:40:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4384,4,'                              ','Jueves 16 de Junio del 05, a las 18:42:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4385,4,'                              ','Jueves 16 de Junio del 05, a las 18:44:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4386,4,'                              ','Jueves 16 de Junio del 05, a las 18:46:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4387,4,'                              ','Jueves 16 de Junio del 05, a las 18:48:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4388,4,'                              ','Jueves 16 de Junio del 05, a las 18:50:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4389,4,'                              ','Jueves 16 de Junio del 05, a las 18:51:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4390,4,'                              ','Jueves 16 de Junio del 05, a las 18:53:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4391,4,'                              ','Jueves 16 de Junio del 05, a las 18:56:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4392,4,'                              ','Jueves 16 de Junio del 05, a las 18:58:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4393,4,'                              ','Jueves 16 de Junio del 05, a las 18:59:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4394,4,'                              ','Jueves 16 de Junio del 05, a las 19:01:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4395,4,'                              ','Jueves 16 de Junio del 05, a las 19:03:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4396,4,'                              ','Jueves 16 de Junio del 05, a las 19:05:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4397,4,'                              ','Jueves 16 de Junio del 05, a las 19:07:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4398,4,'                              ','Jueves 16 de Junio del 05, a las 19:08:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4399,4,'                              ','Jueves 16 de Junio del 05, a las 19:09:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4400,4,'                              ','Jueves 16 de Junio del 05, a las 19:11:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4401,4,'                              ','Jueves 16 de Junio del 05, a las 19:12:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4402,4,'                              ','Jueves 16 de Junio del 05, a las 19:14:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4403,4,'                              ','Jueves 16 de Junio del 05, a las 19:16:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4404,4,'                              ','Jueves 16 de Junio del 05, a las 19:18:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4405,4,'                              ','Jueves 16 de Junio del 05, a las 19:19:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4406,4,'                              ','Jueves 16 de Junio del 05, a las 19:21:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4407,4,'                              ','Jueves 16 de Junio del 05, a las 19:22:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4408,4,'                              ','Jueves 16 de Junio del 05, a las 19:24:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4409,8,'                              ','Viernes 17 de Junio del 05, a las 10:00:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4410,8,'                              ','Viernes 17 de Junio del 05, a las 10:05:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4411,8,'                              ','Viernes 17 de Junio del 05, a las 10:07:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4412,8,'                              ','Viernes 17 de Junio del 05, a las 10:10:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4413,8,'                              ','Viernes 17 de Junio del 05, a las 11:12:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4414,8,'                              ','Viernes 17 de Junio del 05, a las 11:14:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4415,8,'                              ','Viernes 17 de Junio del 05, a las 11:15:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4416,8,'                              ','Viernes 17 de Junio del 05, a las 11:17:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4417,8,'                              ','Viernes 17 de Junio del 05, a las 11:20:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4418,8,'                              ','Viernes 17 de Junio del 05, a las 11:21:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4419,8,'                              ','Viernes 17 de Junio del 05, a las 11:22:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4420,8,'                              ','Viernes 17 de Junio del 05, a las 11:23:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4421,8,'                              ','Viernes 17 de Junio del 05, a las 11:24:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4422,8,'                              ','Viernes 17 de Junio del 05, a las 11:26:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4423,8,'                              ','Viernes 17 de Junio del 05, a las 11:28:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4424,8,'                              ','Viernes 17 de Junio del 05, a las 11:33:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4425,8,'                              ','Viernes 17 de Junio del 05, a las 11:34:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4426,8,'                              ','Viernes 17 de Junio del 05, a las 11:35:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4427,8,'                              ','Viernes 17 de Junio del 05, a las 11:37:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4428,8,'                              ','Viernes 17 de Junio del 05, a las 11:38:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4429,8,'                              ','Viernes 17 de Junio del 05, a las 11:40:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4430,8,'                              ','Viernes 17 de Junio del 05, a las 11:41:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4431,8,'                              ','Viernes 17 de Junio del 05, a las 11:42:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4432,8,'                              ','Viernes 17 de Junio del 05, a las 11:43:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4433,8,'                              ','Viernes 17 de Junio del 05, a las 11:45:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4434,8,'                              ','Viernes 17 de Junio del 05, a las 11:46:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4435,8,'                              ','Viernes 17 de Junio del 05, a las 11:47:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4436,8,'                              ','Viernes 17 de Junio del 05, a las 11:49:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4437,8,'                              ','Viernes 17 de Junio del 05, a las 11:50:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4438,8,'                              ','Viernes 17 de Junio del 05, a las 11:52:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4439,8,'                              ','Viernes 17 de Junio del 05, a las 11:53:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4440,8,'                              ','Viernes 17 de Junio del 05, a las 11:54:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4441,8,'                              ','Viernes 17 de Junio del 05, a las 11:55:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4442,8,'                              ','Viernes 17 de Junio del 05, a las 11:57:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4443,8,'                              ','Viernes 17 de Junio del 05, a las 11:58:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4444,8,'                              ','Viernes 17 de Junio del 05, a las 11:59:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4445,8,'                              ','Viernes 17 de Junio del 05, a las 12:00:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4446,8,'                              ','Viernes 17 de Junio del 05, a las 12:02:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4447,8,'                              ','Viernes 17 de Junio del 05, a las 12:03:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4448,8,'                              ','Viernes 17 de Junio del 05, a las 12:05:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4449,8,'                              ','Viernes 17 de Junio del 05, a las 12:06:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4450,8,'                              ','Viernes 17 de Junio del 05, a las 12:07:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4451,8,'                              ','Viernes 17 de Junio del 05, a las 12:08:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4452,9,'                              ','Viernes 17 de Junio del 05, a las 12:17:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4453,9,'                              ','Viernes 17 de Junio del 05, a las 12:22:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4454,9,'                              ','Viernes 17 de Junio del 05, a las 12:42:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4455,9,'                              ','Viernes 17 de Junio del 05, a las 12:43:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4456,9,'                              ','Viernes 17 de Junio del 05, a las 12:44:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4457,9,'                              ','Viernes 17 de Junio del 05, a las 12:47:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4458,9,'                              ','Viernes 17 de Junio del 05, a las 12:49:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4459,9,'                              ','Viernes 17 de Junio del 05, a las 12:50:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4460,9,'                              ','Viernes 17 de Junio del 05, a las 12:51:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4461,9,'                              ','Viernes 17 de Junio del 05, a las 12:55:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4462,9,'                              ','Viernes 17 de Junio del 05, a las 12:56:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4463,9,'                              ','Viernes 17 de Junio del 05, a las 12:58:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4464,9,'                              ','Viernes 17 de Junio del 05, a las 12:58:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4465,9,'                              ','Viernes 17 de Junio del 05, a las 12:59:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4466,9,'                              ','Viernes 17 de Junio del 05, a las 13:01:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4467,9,'                              ','Viernes 17 de Junio del 05, a las 13:02:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4468,9,'                              ','Viernes 17 de Junio del 05, a las 13:09:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4469,9,'                              ','Viernes 17 de Junio del 05, a las 13:10:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4470,9,'                              ','Viernes 17 de Junio del 05, a las 13:11:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4471,9,'                              ','Viernes 17 de Junio del 05, a las 13:13:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4472,9,'                              ','Viernes 17 de Junio del 05, a las 13:14:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4473,9,'                              ','Viernes 17 de Junio del 05, a las 13:15:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4474,9,'                              ','Viernes 17 de Junio del 05, a las 13:18:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4475,8,'                              ','Viernes 17 de Junio del 05, a las 13:42:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4476,8,'                              ','Viernes 17 de Junio del 05, a las 13:43:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4477,8,'                              ','Viernes 17 de Junio del 05, a las 13:52:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4478,8,'                              ','Viernes 17 de Junio del 05, a las 13:53:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4479,8,'                              ','Viernes 17 de Junio del 05, a las 13:54:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4480,8,'                              ','Viernes 17 de Junio del 05, a las 13:56:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4481,8,'                              ','Viernes 17 de Junio del 05, a las 13:57:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4482,8,'                              ','Viernes 17 de Junio del 05, a las 13:58:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4483,8,'                              ','Viernes 17 de Junio del 05, a las 13:59:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4484,8,'                              ','Viernes 17 de Junio del 05, a las 13:59:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4485,8,'                              ','Viernes 17 de Junio del 05, a las 14:00:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4486,8,'                              ','Viernes 17 de Junio del 05, a las 14:00:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4487,8,'                              ','Viernes 17 de Junio del 05, a las 14:01:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4488,8,'                              ','Viernes 17 de Junio del 05, a las 14:01:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4489,8,'                              ','Viernes 17 de Junio del 05, a las 14:02:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4490,8,'                              ','Viernes 17 de Junio del 05, a las 14:03:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4491,8,'                              ','Viernes 17 de Junio del 05, a las 14:04:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4492,8,'                              ','Viernes 17 de Junio del 05, a las 14:05:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4493,9,'                              ','Viernes 17 de Junio del 05, a las 14:05:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4494,8,'                              ','Viernes 17 de Junio del 05, a las 14:05:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4495,9,'                              ','Viernes 17 de Junio del 05, a las 14:06:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4496,8,'                              ','Viernes 17 de Junio del 05, a las 14:07:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4497,8,'                              ','Viernes 17 de Junio del 05, a las 14:11:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4498,8,'                              ','Viernes 17 de Junio del 05, a las 14:11:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4499,8,'                              ','Viernes 17 de Junio del 05, a las 14:13:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4500,8,'                              ','Viernes 17 de Junio del 05, a las 14:13:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4501,8,'                              ','Viernes 17 de Junio del 05, a las 14:13:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4502,8,'                              ','Viernes 17 de Junio del 05, a las 14:16:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4503,8,'                              ','Viernes 17 de Junio del 05, a las 14:29:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4504,9,'                              ','Viernes 17 de Junio del 05, a las 14:51:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4505,9,'                              ','Viernes 17 de Junio del 05, a las 14:52:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4506,9,'                              ','Viernes 17 de Junio del 05, a las 14:53:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4507,9,'                              ','Viernes 17 de Junio del 05, a las 14:53:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4508,9,'                              ','Viernes 17 de Junio del 05, a las 14:54:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4509,9,'                              ','Viernes 17 de Junio del 05, a las 14:55:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4510,9,'                              ','Viernes 17 de Junio del 05, a las 14:58:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4511,9,'                              ','Viernes 17 de Junio del 05, a las 14:59:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4512,9,'                              ','Viernes 17 de Junio del 05, a las 15:00:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4513,9,'                              ','Viernes 17 de Junio del 05, a las 15:02:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4514,9,'                              ','Viernes 17 de Junio del 05, a las 15:04:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4515,9,'                              ','Viernes 17 de Junio del 05, a las 15:05:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4516,9,'                              ','Viernes 17 de Junio del 05, a las 15:06:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4517,8,'                              ','Viernes 17 de Junio del 05, a las 15:37:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4518,9,'                              ','Viernes 17 de Junio del 05, a las 15:37:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4519,8,'                              ','Viernes 17 de Junio del 05, a las 16:08:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4520,8,'                              ','Viernes 17 de Junio del 05, a las 16:10:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4521,8,'                              ','Viernes 17 de Junio del 05, a las 16:11:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4522,8,'                              ','Viernes 17 de Junio del 05, a las 16:12:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4523,8,'                              ','Viernes 17 de Junio del 05, a las 16:12:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4524,8,'                              ','Viernes 17 de Junio del 05, a las 16:14:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4525,8,'                              ','Viernes 17 de Junio del 05, a las 16:14:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4526,8,'                              ','Viernes 17 de Junio del 05, a las 16:15:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4527,8,'                              ','Viernes 17 de Junio del 05, a las 16:16:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4528,8,'                              ','Viernes 17 de Junio del 05, a las 16:17:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4529,8,'                              ','Viernes 17 de Junio del 05, a las 16:17:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4530,4,'                              ','Viernes 17 de Junio del 05, a las 17:14:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4531,4,'                              ','Viernes 17 de Junio del 05, a las 17:15:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4532,4,'                              ','Viernes 17 de Junio del 05, a las 17:18:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4533,4,'                              ','Viernes 17 de Junio del 05, a las 17:20:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4534,4,'                              ','Viernes 17 de Junio del 05, a las 17:22:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4535,4,'                              ','Viernes 17 de Junio del 05, a las 17:24:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4536,4,'                              ','Viernes 17 de Junio del 05, a las 17:26:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4537,4,'                              ','Viernes 17 de Junio del 05, a las 17:27:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4538,4,'                              ','Viernes 17 de Junio del 05, a las 17:28:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4539,4,'                              ','Viernes 17 de Junio del 05, a las 17:30:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4540,4,'                              ','Viernes 17 de Junio del 05, a las 17:32:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4541,4,'                              ','Viernes 17 de Junio del 05, a las 17:34:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4542,4,'                              ','Viernes 17 de Junio del 05, a las 17:36:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4543,4,'                              ','Viernes 17 de Junio del 05, a las 17:38:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4544,4,'                              ','Viernes 17 de Junio del 05, a las 17:40:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4545,4,'                              ','Viernes 17 de Junio del 05, a las 17:42:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4546,4,'                              ','Viernes 17 de Junio del 05, a las 17:42:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4547,4,'                              ','Viernes 17 de Junio del 05, a las 17:43:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4548,4,'                              ','Viernes 17 de Junio del 05, a las 17:44:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4549,4,'                              ','Viernes 17 de Junio del 05, a las 17:46:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4550,4,'                              ','Viernes 17 de Junio del 05, a las 17:48:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4551,4,'                              ','Viernes 17 de Junio del 05, a las 17:49:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4552,4,'                              ','Viernes 17 de Junio del 05, a las 17:50:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4553,4,'                              ','Viernes 17 de Junio del 05, a las 17:52:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4554,4,'                              ','Viernes 17 de Junio del 05, a las 17:53:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4555,4,'                              ','Viernes 17 de Junio del 05, a las 17:54:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4556,4,'                              ','Viernes 17 de Junio del 05, a las 17:56:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4557,4,'                              ','Viernes 17 de Junio del 05, a las 17:57:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4558,4,'                              ','Viernes 17 de Junio del 05, a las 17:58:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4559,4,'                              ','Viernes 17 de Junio del 05, a las 18:00:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4560,4,'                              ','Viernes 17 de Junio del 05, a las 18:02:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4561,4,'                              ','Viernes 17 de Junio del 05, a las 18:03:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4562,4,'                              ','Viernes 17 de Junio del 05, a las 18:04:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4563,4,'                              ','Viernes 17 de Junio del 05, a las 18:05:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4564,4,'                              ','Viernes 17 de Junio del 05, a las 18:06:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4565,4,'                              ','Viernes 17 de Junio del 05, a las 18:07:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4566,4,'                              ','Viernes 17 de Junio del 05, a las 18:08:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4567,4,'                              ','Viernes 17 de Junio del 05, a las 18:10:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4568,4,'                              ','Viernes 17 de Junio del 05, a las 18:11:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4569,4,'                              ','Viernes 17 de Junio del 05, a las 18:13:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4570,4,'                              ','Viernes 17 de Junio del 05, a las 18:14:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4571,4,'                              ','Viernes 17 de Junio del 05, a las 18:15:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4572,4,'                              ','Viernes 17 de Junio del 05, a las 18:38:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4573,4,'                              ','Viernes 17 de Junio del 05, a las 18:43:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4574,9,'                              ','Lunes 20 de Junio del 05, a las 10:17:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4575,9,'                              ','Lunes 20 de Junio del 05, a las 10:18:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4576,9,'                              ','Lunes 20 de Junio del 05, a las 10:18:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4577,9,'                              ','Lunes 20 de Junio del 05, a las 10:20:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4578,9,'                              ','Lunes 20 de Junio del 05, a las 10:21:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4579,9,'                              ','Lunes 20 de Junio del 05, a las 10:22:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4580,9,'                              ','Lunes 20 de Junio del 05, a las 10:24:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4581,9,'                              ','Lunes 20 de Junio del 05, a las 10:30:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4582,9,'                              ','Lunes 20 de Junio del 05, a las 10:31:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4583,9,'                              ','Lunes 20 de Junio del 05, a las 10:32:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4584,9,'                              ','Lunes 20 de Junio del 05, a las 10:33:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4585,9,'                              ','Lunes 20 de Junio del 05, a las 10:33:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4586,9,'                              ','Lunes 20 de Junio del 05, a las 10:35:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4587,9,'                              ','Lunes 20 de Junio del 05, a las 10:36:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4588,9,'                              ','Lunes 20 de Junio del 05, a las 10:38:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4589,9,'                              ','Lunes 20 de Junio del 05, a las 10:39:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4590,9,'                              ','Lunes 20 de Junio del 05, a las 10:40:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4591,9,'                              ','Lunes 20 de Junio del 05, a las 10:41:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4592,9,'                              ','Lunes 20 de Junio del 05, a las 10:42:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4593,9,'                              ','Lunes 20 de Junio del 05, a las 10:44:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4594,9,'                              ','Lunes 20 de Junio del 05, a las 10:45:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4595,9,'                              ','Lunes 20 de Junio del 05, a las 10:46:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4596,9,'                              ','Lunes 20 de Junio del 05, a las 10:47:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4597,9,'                              ','Lunes 20 de Junio del 05, a las 10:48:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4598,9,'                              ','Lunes 20 de Junio del 05, a las 10:49:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4599,9,'                              ','Lunes 20 de Junio del 05, a las 10:50:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4600,9,'                              ','Lunes 20 de Junio del 05, a las 10:50:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4601,9,'                              ','Lunes 20 de Junio del 05, a las 10:51:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4602,9,'                              ','Lunes 20 de Junio del 05, a las 10:52:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4603,8,'                              ','Lunes 20 de Junio del 05, a las 10:52:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4604,8,'                              ','Lunes 20 de Junio del 05, a las 10:52:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4605,9,'                              ','Lunes 20 de Junio del 05, a las 10:53:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4606,8,'                              ','Lunes 20 de Junio del 05, a las 10:54:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4607,9,'                              ','Lunes 20 de Junio del 05, a las 10:54:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4608,9,'                              ','Lunes 20 de Junio del 05, a las 10:55:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4609,8,'                              ','Lunes 20 de Junio del 05, a las 10:55:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4610,9,'                              ','Lunes 20 de Junio del 05, a las 10:56:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4611,8,'                              ','Lunes 20 de Junio del 05, a las 10:56:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4612,9,'                              ','Lunes 20 de Junio del 05, a las 10:56:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4613,8,'                              ','Lunes 20 de Junio del 05, a las 10:57:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4614,8,'                              ','Lunes 20 de Junio del 05, a las 10:58:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4615,9,'                              ','Lunes 20 de Junio del 05, a las 10:59:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4616,8,'                              ','Lunes 20 de Junio del 05, a las 11:00:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4617,8,'                              ','Lunes 20 de Junio del 05, a las 11:01:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4618,8,'                              ','Lunes 20 de Junio del 05, a las 11:01:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4619,9,'                              ','Lunes 20 de Junio del 05, a las 11:02:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4620,8,'                              ','Lunes 20 de Junio del 05, a las 11:02:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4621,8,'                              ','Lunes 20 de Junio del 05, a las 11:03:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4622,9,'                              ','Lunes 20 de Junio del 05, a las 11:03:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4623,9,'                              ','Lunes 20 de Junio del 05, a las 11:05:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4624,9,'                              ','Lunes 20 de Junio del 05, a las 11:05:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4625,8,'                              ','Lunes 20 de Junio del 05, a las 11:05:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4626,8,'                              ','Lunes 20 de Junio del 05, a las 11:06:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4627,9,'                              ','Lunes 20 de Junio del 05, a las 11:07:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4628,8,'                              ','Lunes 20 de Junio del 05, a las 11:07:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4629,8,'                              ','Lunes 20 de Junio del 05, a las 11:08:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4630,8,'                              ','Lunes 20 de Junio del 05, a las 11:09:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4631,9,'                              ','Lunes 20 de Junio del 05, a las 11:09:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4632,9,'                              ','Lunes 20 de Junio del 05, a las 11:10:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4633,8,'                              ','Lunes 20 de Junio del 05, a las 11:11:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4634,9,'                              ','Lunes 20 de Junio del 05, a las 11:12:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4635,8,'                              ','Lunes 20 de Junio del 05, a las 11:14:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4636,9,'                              ','Lunes 20 de Junio del 05, a las 11:17:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4637,9,'                              ','Lunes 20 de Junio del 05, a las 11:17:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4638,9,'                              ','Lunes 20 de Junio del 05, a las 11:19:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4639,9,'                              ','Lunes 20 de Junio del 05, a las 11:24:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4640,9,'                              ','Lunes 20 de Junio del 05, a las 11:26:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4641,9,'                              ','Lunes 20 de Junio del 05, a las 11:28:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4642,9,'                              ','Lunes 20 de Junio del 05, a las 11:29:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4643,9,'                              ','Lunes 20 de Junio del 05, a las 11:31:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4644,9,'                              ','Lunes 20 de Junio del 05, a las 11:35:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4645,9,'                              ','Lunes 20 de Junio del 05, a las 11:36:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4646,9,'                              ','Lunes 20 de Junio del 05, a las 11:37:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4647,9,'                              ','Lunes 20 de Junio del 05, a las 11:38:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4648,9,'                              ','Lunes 20 de Junio del 05, a las 11:39:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4649,8,'                              ','Lunes 20 de Junio del 05, a las 11:39:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4650,9,'                              ','Lunes 20 de Junio del 05, a las 11:39:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4651,8,'                              ','Lunes 20 de Junio del 05, a las 11:40:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4652,9,'                              ','Lunes 20 de Junio del 05, a las 11:40:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4653,8,'                              ','Lunes 20 de Junio del 05, a las 11:41:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4654,8,'                              ','Lunes 20 de Junio del 05, a las 11:42:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4655,8,'                              ','Lunes 20 de Junio del 05, a las 11:43:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4656,8,'                              ','Lunes 20 de Junio del 05, a las 11:44:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4657,8,'                              ','Lunes 20 de Junio del 05, a las 11:45:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4658,8,'                              ','Lunes 20 de Junio del 05, a las 11:46:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4659,8,'                              ','Lunes 20 de Junio del 05, a las 11:47:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4660,8,'                              ','Lunes 20 de Junio del 05, a las 11:48:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4661,8,'                              ','Lunes 20 de Junio del 05, a las 11:49:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4662,8,'                              ','Lunes 20 de Junio del 05, a las 11:50:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4663,8,'                              ','Lunes 20 de Junio del 05, a las 11:51:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4664,8,'                              ','Lunes 20 de Junio del 05, a las 11:52:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4665,9,'                              ','Lunes 20 de Junio del 05, a las 12:15:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4666,8,'                              ','Lunes 20 de Junio del 05, a las 12:15:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4667,8,'                              ','Lunes 20 de Junio del 05, a las 12:16:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4668,9,'                              ','Lunes 20 de Junio del 05, a las 12:16:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4669,8,'                              ','Lunes 20 de Junio del 05, a las 12:16:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4670,8,'                              ','Lunes 20 de Junio del 05, a las 12:18:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4671,8,'                              ','Lunes 20 de Junio del 05, a las 12:19:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4672,8,'                              ','Lunes 20 de Junio del 05, a las 12:20:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4673,8,'                              ','Lunes 20 de Junio del 05, a las 12:21:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4674,8,'                              ','Lunes 20 de Junio del 05, a las 12:22:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4675,8,'                              ','Lunes 20 de Junio del 05, a las 12:23:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4676,8,'                              ','Lunes 20 de Junio del 05, a las 12:24:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4677,8,'                              ','Lunes 20 de Junio del 05, a las 12:25:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4678,8,'                              ','Lunes 20 de Junio del 05, a las 12:26:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4679,8,'                              ','Lunes 20 de Junio del 05, a las 12:27:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4680,8,'                              ','Lunes 20 de Junio del 05, a las 12:28:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4681,8,'                              ','Lunes 20 de Junio del 05, a las 12:28:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4682,8,'                              ','Lunes 20 de Junio del 05, a las 12:30:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4683,8,'                              ','Lunes 20 de Junio del 05, a las 12:30:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4684,8,'                              ','Lunes 20 de Junio del 05, a las 12:34:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4685,8,'                              ','Lunes 20 de Junio del 05, a las 12:34:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4686,8,'                              ','Lunes 20 de Junio del 05, a las 12:40:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4687,8,'                              ','Lunes 20 de Junio del 05, a las 12:40:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4688,8,'                              ','Lunes 20 de Junio del 05, a las 12:42:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4689,8,'                              ','Lunes 20 de Junio del 05, a las 12:43:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4690,8,'                              ','Lunes 20 de Junio del 05, a las 12:43:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4691,8,'                              ','Lunes 20 de Junio del 05, a las 12:44:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4692,9,'                              ','Lunes 20 de Junio del 05, a las 12:45:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4693,8,'                              ','Lunes 20 de Junio del 05, a las 12:45:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4694,9,'                              ','Lunes 20 de Junio del 05, a las 12:46:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4695,8,'                              ','Lunes 20 de Junio del 05, a las 12:46:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4696,8,'                              ','Lunes 20 de Junio del 05, a las 12:47:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4697,8,'                              ','Lunes 20 de Junio del 05, a las 12:48:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4698,8,'                              ','Lunes 20 de Junio del 05, a las 12:49:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4699,8,'                              ','Lunes 20 de Junio del 05, a las 12:49:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4700,8,'                              ','Lunes 20 de Junio del 05, a las 12:50:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4701,9,'                              ','Lunes 20 de Junio del 05, a las 12:50:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4702,9,'                              ','Lunes 20 de Junio del 05, a las 12:51:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4703,9,'                              ','Lunes 20 de Junio del 05, a las 12:52:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4704,9,'                              ','Lunes 20 de Junio del 05, a las 12:53:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4705,9,'                              ','Lunes 20 de Junio del 05, a las 12:54:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4706,8,'                              ','Lunes 20 de Junio del 05, a las 12:55:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4707,9,'                              ','Lunes 20 de Junio del 05, a las 12:56:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4708,8,'                              ','Lunes 20 de Junio del 05, a las 12:57:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4709,8,'                              ','Lunes 20 de Junio del 05, a las 12:57:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4710,9,'                              ','Lunes 20 de Junio del 05, a las 12:58:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4711,8,'                              ','Lunes 20 de Junio del 05, a las 12:58:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4712,8,'                              ','Lunes 20 de Junio del 05, a las 12:59:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4713,9,'                              ','Lunes 20 de Junio del 05, a las 12:59:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4714,8,'                              ','Lunes 20 de Junio del 05, a las 13:00:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4715,8,'                              ','Lunes 20 de Junio del 05, a las 13:01:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4716,8,'                              ','Lunes 20 de Junio del 05, a las 13:02:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4717,9,'                              ','Lunes 20 de Junio del 05, a las 13:03:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4718,9,'                              ','Lunes 20 de Junio del 05, a las 13:04:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4719,9,'                              ','Lunes 20 de Junio del 05, a las 13:05:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4720,8,'                              ','Lunes 20 de Junio del 05, a las 13:05:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4721,8,'                              ','Lunes 20 de Junio del 05, a las 13:05:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4722,9,'                              ','Lunes 20 de Junio del 05, a las 13:06:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4723,8,'                              ','Lunes 20 de Junio del 05, a las 13:08:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4724,8,'                              ','Lunes 20 de Junio del 05, a las 13:09:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4725,8,'                              ','Lunes 20 de Junio del 05, a las 13:10:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4726,9,'                              ','Lunes 20 de Junio del 05, a las 13:21:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4727,9,'                              ','Lunes 20 de Junio del 05, a las 13:22:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4728,9,'                              ','Lunes 20 de Junio del 05, a las 13:23:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4729,9,'                              ','Lunes 20 de Junio del 05, a las 13:25:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4730,9,'                              ','Lunes 20 de Junio del 05, a las 13:26:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4731,9,'                              ','Lunes 20 de Junio del 05, a las 13:27:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4732,9,'                              ','Lunes 20 de Junio del 05, a las 13:28:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4733,8,'                              ','Lunes 20 de Junio del 05, a las 13:28:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4734,9,'                              ','Lunes 20 de Junio del 05, a las 13:29:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4735,8,'                              ','Lunes 20 de Junio del 05, a las 13:29:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4736,9,'                              ','Lunes 20 de Junio del 05, a las 13:30:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4737,9,'                              ','Lunes 20 de Junio del 05, a las 13:31:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4738,8,'                              ','Lunes 20 de Junio del 05, a las 13:31:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4739,9,'                              ','Lunes 20 de Junio del 05, a las 13:31:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4740,8,'                              ','Lunes 20 de Junio del 05, a las 13:32:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4741,9,'                              ','Lunes 20 de Junio del 05, a las 13:33:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4742,8,'                              ','Lunes 20 de Junio del 05, a las 13:33:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4743,9,'                              ','Lunes 20 de Junio del 05, a las 13:34:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4744,9,'                              ','Lunes 20 de Junio del 05, a las 13:35:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4745,9,'                              ','Lunes 20 de Junio del 05, a las 13:36:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4746,9,'                              ','Lunes 20 de Junio del 05, a las 13:37:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4747,9,'                              ','Lunes 20 de Junio del 05, a las 13:38:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4748,9,'                              ','Lunes 20 de Junio del 05, a las 13:39:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4749,9,'                              ','Lunes 20 de Junio del 05, a las 13:39:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4750,8,'                              ','Lunes 20 de Junio del 05, a las 13:40:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4751,8,'                              ','Lunes 20 de Junio del 05, a las 13:40:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4752,9,'                              ','Lunes 20 de Junio del 05, a las 13:40:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4753,8,'                              ','Lunes 20 de Junio del 05, a las 13:41:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4754,9,'                              ','Lunes 20 de Junio del 05, a las 13:41:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4755,8,'                              ','Lunes 20 de Junio del 05, a las 13:41:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4756,9,'                              ','Lunes 20 de Junio del 05, a las 13:42:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4757,8,'                              ','Lunes 20 de Junio del 05, a las 13:42:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4758,9,'                              ','Lunes 20 de Junio del 05, a las 13:42:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4759,8,'                              ','Lunes 20 de Junio del 05, a las 13:43:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4760,9,'                              ','Lunes 20 de Junio del 05, a las 13:43:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4761,8,'                              ','Lunes 20 de Junio del 05, a las 13:43:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4762,8,'                              ','Lunes 20 de Junio del 05, a las 13:44:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4763,8,'                              ','Lunes 20 de Junio del 05, a las 13:45:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4764,9,'                              ','Lunes 20 de Junio del 05, a las 13:45:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4765,8,'                              ','Lunes 20 de Junio del 05, a las 13:45:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4766,9,'                              ','Lunes 20 de Junio del 05, a las 13:46:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4767,8,'                              ','Lunes 20 de Junio del 05, a las 13:46:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4768,9,'                              ','Lunes 20 de Junio del 05, a las 13:46:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4769,8,'                              ','Lunes 20 de Junio del 05, a las 13:47:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4770,8,'                              ','Lunes 20 de Junio del 05, a las 13:48:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4771,8,'                              ','Lunes 20 de Junio del 05, a las 13:48:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4772,8,'                              ','Lunes 20 de Junio del 05, a las 13:49:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4773,8,'                              ','Lunes 20 de Junio del 05, a las 13:50:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4774,8,'                              ','Lunes 20 de Junio del 05, a las 13:53:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4775,8,'                              ','Lunes 20 de Junio del 05, a las 13:53:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4776,8,'                              ','Lunes 20 de Junio del 05, a las 14:03:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4777,8,'                              ','Lunes 20 de Junio del 05, a las 14:03:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4778,8,'                              ','Lunes 20 de Junio del 05, a las 14:04:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4779,8,'                              ','Lunes 20 de Junio del 05, a las 14:05:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4780,8,'                              ','Lunes 20 de Junio del 05, a las 14:05:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4781,8,'                              ','Lunes 20 de Junio del 05, a las 14:06:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4782,8,'                              ','Lunes 20 de Junio del 05, a las 14:23:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4783,8,'                              ','Lunes 20 de Junio del 05, a las 14:24:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4784,8,'                              ','Lunes 20 de Junio del 05, a las 14:25:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4785,8,'                              ','Lunes 20 de Junio del 05, a las 14:25:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4786,8,'                              ','Lunes 20 de Junio del 05, a las 14:26:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4787,8,'                              ','Lunes 20 de Junio del 05, a las 14:29:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4788,8,'                              ','Lunes 20 de Junio del 05, a las 14:29:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4789,8,'                              ','Lunes 20 de Junio del 05, a las 14:30:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4790,8,'                              ','Lunes 20 de Junio del 05, a las 14:31:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4791,8,'                              ','Lunes 20 de Junio del 05, a las 14:31:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4792,8,'                              ','Lunes 20 de Junio del 05, a las 14:32:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4793,8,'                              ','Lunes 20 de Junio del 05, a las 14:33:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4794,8,'                              ','Lunes 20 de Junio del 05, a las 14:34:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4795,8,'                              ','Lunes 20 de Junio del 05, a las 14:35:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4796,8,'                              ','Lunes 20 de Junio del 05, a las 14:35:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4797,2,'Bib Datos Propopios           ','Martes 21 de Junio del 05, a las 13:05:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4798,4,'                              ','Mircoles 22 de Junio del 05, a las 11:46:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4799,4,'                              ','Mircoles 22 de Junio del 05, a las 11:47:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4800,4,'                              ','Mircoles 22 de Junio del 05, a las 11:54:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4801,4,'                              ','Mircoles 22 de Junio del 05, a las 11:54:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4802,4,'                              ','Mircoles 22 de Junio del 05, a las 11:55:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4803,4,'                              ','Mircoles 22 de Junio del 05, a las 11:56:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4804,4,'                              ','Mircoles 22 de Junio del 05, a las 12:02:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4805,4,'                              ','Mircoles 22 de Junio del 05, a las 12:03:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4806,4,'                              ','Mircoles 22 de Junio del 05, a las 12:06:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4807,4,'                              ','Mircoles 22 de Junio del 05, a las 12:06:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4808,4,'                              ','Mircoles 22 de Junio del 05, a las 12:08:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4809,4,'                              ','Mircoles 22 de Junio del 05, a las 12:08:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4810,4,'                              ','Mircoles 22 de Junio del 05, a las 12:09:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4811,4,'                              ','Mircoles 22 de Junio del 05, a las 12:15:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4812,4,'                              ','Mircoles 22 de Junio del 05, a las 12:15:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4813,4,'                              ','Mircoles 22 de Junio del 05, a las 12:17:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4814,4,'                              ','Mircoles 22 de Junio del 05, a las 12:19:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4815,4,'                              ','Mircoles 22 de Junio del 05, a las 12:21:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4816,4,'                              ','Mircoles 22 de Junio del 05, a las 12:22:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4817,4,'                              ','Mircoles 22 de Junio del 05, a las 12:27:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4818,4,'                              ','Mircoles 22 de Junio del 05, a las 12:36:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4819,4,'                              ','Mircoles 22 de Junio del 05, a las 12:36:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4820,4,'                              ','Mircoles 22 de Junio del 05, a las 12:49:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4821,4,'                              ','Mircoles 22 de Junio del 05, a las 12:50:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4822,4,'                              ','Mircoles 22 de Junio del 05, a las 12:51:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4823,4,'                              ','Mircoles 22 de Junio del 05, a las 12:51:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4824,4,'                              ','Mircoles 22 de Junio del 05, a las 12:52:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4825,4,'                              ','Mircoles 22 de Junio del 05, a las 12:53:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4826,4,'                              ','Mircoles 22 de Junio del 05, a las 13:01:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4827,4,'                              ','Mircoles 22 de Junio del 05, a las 13:02:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4828,4,'                              ','Mircoles 22 de Junio del 05, a las 13:03:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4829,4,'                              ','Mircoles 22 de Junio del 05, a las 13:03:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4830,4,'                              ','Mircoles 22 de Junio del 05, a las 13:04:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4831,4,'                              ','Mircoles 22 de Junio del 05, a las 13:05:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4832,4,'                              ','Mircoles 22 de Junio del 05, a las 13:05:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4833,4,'                              ','Mircoles 22 de Junio del 05, a las 13:06:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4834,4,'                              ','Mircoles 22 de Junio del 05, a las 13:45:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4835,4,'                              ','Mircoles 22 de Junio del 05, a las 13:45:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4836,4,'                              ','Mircoles 22 de Junio del 05, a las 13:47:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4837,4,'                              ','Mircoles 22 de Junio del 05, a las 13:48:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4838,4,'                              ','Mircoles 22 de Junio del 05, a las 13:49:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4839,4,'                              ','Mircoles 22 de Junio del 05, a las 13:50:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4840,4,'                              ','Mircoles 22 de Junio del 05, a las 13:50:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4841,4,'                              ','Mircoles 22 de Junio del 05, a las 13:51:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4842,4,'                              ','Mircoles 22 de Junio del 05, a las 13:52:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4843,4,'                              ','Mircoles 22 de Junio del 05, a las 15:39:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4844,4,'                              ','Mircoles 22 de Junio del 05, a las 15:39:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4845,4,'                              ','Mircoles 22 de Junio del 05, a las 15:40:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4846,4,'                              ','Mircoles 22 de Junio del 05, a las 15:40:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4847,4,'                              ','Mircoles 22 de Junio del 05, a las 15:41:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4848,4,'                              ','Mircoles 22 de Junio del 05, a las 15:42:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4849,4,'                              ','Mircoles 22 de Junio del 05, a las 15:42:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4850,4,'                              ','Mircoles 22 de Junio del 05, a las 15:43:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4851,4,'                              ','Mircoles 22 de Junio del 05, a las 15:44:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4852,4,'                              ','Mircoles 22 de Junio del 05, a las 15:44:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4853,4,'                              ','Mircoles 22 de Junio del 05, a las 15:45:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4854,4,'                              ','Mircoles 22 de Junio del 05, a las 15:46:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4855,4,'                              ','Mircoles 22 de Junio del 05, a las 15:47:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4856,4,'                              ','Mircoles 22 de Junio del 05, a las 15:47:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4857,4,'                              ','Mircoles 22 de Junio del 05, a las 15:48:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4858,4,'                              ','Mircoles 22 de Junio del 05, a las 15:49:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4859,4,'                              ','Mircoles 22 de Junio del 05, a las 15:49:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4860,4,'                              ','Mircoles 22 de Junio del 05, a las 15:50:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4861,4,'                              ','Mircoles 22 de Junio del 05, a las 15:51:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4862,4,'                              ','Mircoles 22 de Junio del 05, a las 15:51:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4863,4,'                              ','Mircoles 22 de Junio del 05, a las 15:52:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4864,4,'                              ','Mircoles 22 de Junio del 05, a las 15:53:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4865,4,'                              ','Mircoles 22 de Junio del 05, a las 15:54:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4866,4,'                              ','Mircoles 22 de Junio del 05, a las 15:54:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4867,4,'                              ','Mircoles 22 de Junio del 05, a las 15:54:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4868,4,'                              ','Mircoles 22 de Junio del 05, a las 15:55:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4869,4,'                              ','Mircoles 22 de Junio del 05, a las 15:55:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4870,4,'                              ','Mircoles 22 de Junio del 05, a las 15:56:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4871,4,'                              ','Mircoles 22 de Junio del 05, a las 15:56:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4872,4,'                              ','Mircoles 22 de Junio del 05, a las 15:58:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4873,4,'                              ','Jueves 23 de Junio del 05, a las 09:31:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4874,4,'                              ','Jueves 23 de Junio del 05, a las 09:32:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4875,4,'                              ','Jueves 23 de Junio del 05, a las 09:32:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4876,4,'                              ','Jueves 23 de Junio del 05, a las 09:33:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4877,4,'                              ','Jueves 23 de Junio del 05, a las 09:33:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4878,4,'                              ','Jueves 23 de Junio del 05, a las 09:35:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4879,4,'                              ','Jueves 23 de Junio del 05, a las 09:35:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4880,4,'                              ','Jueves 23 de Junio del 05, a las 09:36:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4881,4,'                              ','Jueves 23 de Junio del 05, a las 09:36:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4882,4,'                              ','Jueves 23 de Junio del 05, a las 09:37:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4883,4,'                              ','Jueves 23 de Junio del 05, a las 09:37:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4884,4,'                              ','Jueves 23 de Junio del 05, a las 09:38:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4885,4,'                              ','Jueves 23 de Junio del 05, a las 09:38:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4886,4,'                              ','Jueves 23 de Junio del 05, a las 09:39:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4887,4,'                              ','Jueves 23 de Junio del 05, a las 09:40:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4888,4,'                              ','Jueves 23 de Junio del 05, a las 09:40:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4889,4,'                              ','Jueves 23 de Junio del 05, a las 09:41:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4890,4,'                              ','Jueves 23 de Junio del 05, a las 09:41:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4891,4,'                              ','Jueves 23 de Junio del 05, a las 09:41:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4892,4,'                              ','Jueves 23 de Junio del 05, a las 09:42:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4893,4,'                              ','Jueves 23 de Junio del 05, a las 09:42:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4894,4,'                              ','Jueves 23 de Junio del 05, a las 09:43:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4895,4,'                              ','Jueves 23 de Junio del 05, a las 09:43:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4896,4,'                              ','Jueves 23 de Junio del 05, a las 09:45:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4897,4,'                              ','Jueves 23 de Junio del 05, a las 09:46:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4898,4,'                              ','Jueves 23 de Junio del 05, a las 09:46:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4899,4,'                              ','Jueves 23 de Junio del 05, a las 09:46:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4900,4,'                              ','Jueves 23 de Junio del 05, a las 09:47:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4901,4,'                              ','Jueves 23 de Junio del 05, a las 09:47:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4902,4,'                              ','Jueves 23 de Junio del 05, a las 09:48:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4903,4,'                              ','Jueves 23 de Junio del 05, a las 09:48:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4904,4,'                              ','Jueves 23 de Junio del 05, a las 09:49:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4905,4,'                              ','Jueves 23 de Junio del 05, a las 09:49:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4906,4,'                              ','Jueves 23 de Junio del 05, a las 09:50:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4907,4,'                              ','Jueves 23 de Junio del 05, a las 10:07:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4908,4,'                              ','Jueves 23 de Junio del 05, a las 10:08:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4909,4,'                              ','Jueves 23 de Junio del 05, a las 10:08:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4910,4,'                              ','Jueves 23 de Junio del 05, a las 10:09:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4911,4,'                              ','Jueves 23 de Junio del 05, a las 10:09:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4912,4,'                              ','Jueves 23 de Junio del 05, a las 10:10:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4913,4,'                              ','Jueves 23 de Junio del 05, a las 10:11:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4914,4,'                              ','Jueves 23 de Junio del 05, a las 10:11:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4915,4,'                              ','Jueves 23 de Junio del 05, a las 10:11:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4916,4,'                              ','Jueves 23 de Junio del 05, a las 10:12:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4917,4,'                              ','Jueves 23 de Junio del 05, a las 10:12:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4918,4,'                              ','Jueves 23 de Junio del 05, a las 10:13:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4919,4,'                              ','Jueves 23 de Junio del 05, a las 10:13:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4920,4,'                              ','Jueves 23 de Junio del 05, a las 10:14:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4921,4,'                              ','Jueves 23 de Junio del 05, a las 10:14:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4922,4,'                              ','Jueves 23 de Junio del 05, a las 10:15:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4923,4,'                              ','Jueves 23 de Junio del 05, a las 10:15:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4924,4,'                              ','Jueves 23 de Junio del 05, a las 10:15:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4925,4,'                              ','Jueves 23 de Junio del 05, a las 10:16:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4926,4,'                              ','Jueves 23 de Junio del 05, a las 10:25:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4927,4,'                              ','Jueves 23 de Junio del 05, a las 10:25:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4928,4,'                              ','Jueves 23 de Junio del 05, a las 10:26:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4929,4,'                              ','Jueves 23 de Junio del 05, a las 10:26:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4930,4,'                              ','Jueves 23 de Junio del 05, a las 10:27:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4931,4,'                              ','Jueves 23 de Junio del 05, a las 10:27:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4932,4,'                              ','Jueves 23 de Junio del 05, a las 10:28:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4933,4,'                              ','Jueves 23 de Junio del 05, a las 10:29:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4934,4,'                              ','Jueves 23 de Junio del 05, a las 10:29:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4935,4,'                              ','Jueves 23 de Junio del 05, a las 10:29:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4936,4,'                              ','Jueves 23 de Junio del 05, a las 10:30:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4937,4,'                              ','Jueves 23 de Junio del 05, a las 10:31:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4938,4,'                              ','Jueves 23 de Junio del 05, a las 10:31:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4939,4,'                              ','Jueves 23 de Junio del 05, a las 10:31:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4940,4,'                              ','Jueves 23 de Junio del 05, a las 10:32:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4941,4,'                              ','Jueves 23 de Junio del 05, a las 10:32:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4942,4,'                              ','Jueves 23 de Junio del 05, a las 10:33:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4943,4,'                              ','Jueves 23 de Junio del 05, a las 10:33:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4944,4,'                              ','Jueves 23 de Junio del 05, a las 10:33:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4945,4,'                              ','Jueves 23 de Junio del 05, a las 10:34:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4946,4,'                              ','Jueves 23 de Junio del 05, a las 10:34:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4947,4,'                              ','Jueves 23 de Junio del 05, a las 10:35:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4948,4,'                              ','Jueves 23 de Junio del 05, a las 10:35:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4949,8,'                              ','Jueves 23 de Junio del 05, a las 14:29:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4950,8,'                              ','Jueves 23 de Junio del 05, a las 14:30:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4951,8,'                              ','Viernes 24 de Junio del 05, a las 10:06:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4952,8,'                              ','Viernes 24 de Junio del 05, a las 10:08:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4953,8,'                              ','Viernes 24 de Junio del 05, a las 10:28:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4954,8,'                              ','Viernes 24 de Junio del 05, a las 10:29:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4955,8,'                              ','Viernes 24 de Junio del 05, a las 10:30:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4956,8,'                              ','Viernes 24 de Junio del 05, a las 10:34:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4957,8,'                              ','Viernes 24 de Junio del 05, a las 10:41:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4958,8,'                              ','Viernes 24 de Junio del 05, a las 11:31:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4959,8,'                              ','Viernes 24 de Junio del 05, a las 11:34:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4960,8,'                              ','Viernes 24 de Junio del 05, a las 11:35:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4961,8,'                              ','Viernes 24 de Junio del 05, a las 11:38:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4962,8,'                              ','Viernes 24 de Junio del 05, a las 11:50:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4963,8,'                              ','Viernes 24 de Junio del 05, a las 11:50:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4964,8,'                              ','Viernes 24 de Junio del 05, a las 11:52:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4965,8,'                              ','Viernes 24 de Junio del 05, a las 11:58:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4966,8,'                              ','Viernes 24 de Junio del 05, a las 12:00:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4967,8,'                              ','Viernes 24 de Junio del 05, a las 12:19:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4968,8,'                              ','Viernes 24 de Junio del 05, a las 12:22:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4969,8,'                              ','Viernes 24 de Junio del 05, a las 12:26:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4970,8,'                              ','Viernes 24 de Junio del 05, a las 12:29:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4971,8,'                              ','Viernes 24 de Junio del 05, a las 12:39:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4972,8,'                              ','Viernes 24 de Junio del 05, a las 12:43:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4973,8,'                              ','Viernes 24 de Junio del 05, a las 12:46:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4974,8,'                              ','Viernes 24 de Junio del 05, a las 12:48:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4975,8,'                              ','Viernes 24 de Junio del 05, a las 12:52:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4976,8,'                              ','Viernes 24 de Junio del 05, a las 13:08:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4977,8,'                              ','Viernes 24 de Junio del 05, a las 13:10:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4978,8,'                              ','Viernes 24 de Junio del 05, a las 13:14:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4979,8,'                              ','Viernes 24 de Junio del 05, a las 13:19:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4980,8,'                              ','Viernes 24 de Junio del 05, a las 13:22:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4981,8,'                              ','Viernes 24 de Junio del 05, a las 13:33:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4982,8,'                              ','Viernes 24 de Junio del 05, a las 13:36:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4983,8,'                              ','Viernes 24 de Junio del 05, a las 13:39:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4984,8,'                              ','Viernes 24 de Junio del 05, a las 13:41:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4985,8,'                              ','Viernes 24 de Junio del 05, a las 13:42:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4986,8,'                              ','Viernes 24 de Junio del 05, a las 13:45:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4987,2,'Bib Datos Propopios           ','Viernes 24 de Junio del 05, a las 14:06:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4988,8,'                              ','Viernes 24 de Junio del 05, a las 15:26:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4989,8,'                              ','Viernes 24 de Junio del 05, a las 15:28:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4990,8,'                              ','Viernes 24 de Junio del 05, a las 15:32:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4991,8,'                              ','Viernes 24 de Junio del 05, a las 15:38:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4992,8,'                              ','Viernes 24 de Junio del 05, a las 15:41:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4993,8,'                              ','Viernes 24 de Junio del 05, a las 15:44:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4994,8,'                              ','Viernes 24 de Junio del 05, a las 15:49:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4995,8,'                              ','Viernes 24 de Junio del 05, a las 15:52:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4996,8,'                              ','Viernes 24 de Junio del 05, a las 15:56:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4997,8,'                              ','Viernes 24 de Junio del 05, a las 16:01:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4998,8,'                              ','Viernes 24 de Junio del 05, a las 16:04:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (4999,8,'                              ','Viernes 24 de Junio del 05, a las 16:06:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5000,8,'                              ','Viernes 24 de Junio del 05, a las 16:09:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5001,8,'                              ','Viernes 24 de Junio del 05, a las 16:12:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5002,8,'                              ','Viernes 24 de Junio del 05, a las 16:15:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5003,8,'                              ','Viernes 24 de Junio del 05, a las 16:19:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5004,8,'                              ','Viernes 24 de Junio del 05, a las 16:21:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5005,8,'                              ','Viernes 24 de Junio del 05, a las 16:22:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5006,8,'                              ','Lunes 27 de Junio del 05, a las 10:31:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5007,8,'                              ','Lunes 27 de Junio del 05, a las 10:36:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5008,8,'                              ','Lunes 27 de Junio del 05, a las 10:38:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5009,8,'                              ','Lunes 27 de Junio del 05, a las 10:39:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5010,8,'                              ','Lunes 27 de Junio del 05, a las 10:57:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5011,8,'                              ','Lunes 27 de Junio del 05, a las 10:58:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5012,8,'                              ','Lunes 27 de Junio del 05, a las 11:00:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5013,8,'                              ','Lunes 27 de Junio del 05, a las 11:04:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5014,8,'                              ','Lunes 27 de Junio del 05, a las 11:08:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5015,8,'                              ','Lunes 27 de Junio del 05, a las 11:16:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5016,8,'                              ','Lunes 27 de Junio del 05, a las 11:17:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5017,8,'                              ','Lunes 27 de Junio del 05, a las 11:19:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5018,8,'                              ','Lunes 27 de Junio del 05, a las 11:28:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5019,8,'                              ','Lunes 27 de Junio del 05, a las 11:31:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5020,8,'                              ','Lunes 27 de Junio del 05, a las 11:32:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5021,8,'                              ','Lunes 27 de Junio del 05, a las 11:33:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5022,8,'                              ','Lunes 27 de Junio del 05, a las 11:37:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5023,8,'                              ','Lunes 27 de Junio del 05, a las 11:40:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5024,8,'                              ','Lunes 27 de Junio del 05, a las 11:43:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5025,8,'                              ','Lunes 27 de Junio del 05, a las 11:45:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5026,8,'                              ','Lunes 27 de Junio del 05, a las 11:48:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5027,8,'                              ','Lunes 27 de Junio del 05, a las 12:01:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5028,8,'                              ','Lunes 27 de Junio del 05, a las 12:04:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5029,8,'                              ','Lunes 27 de Junio del 05, a las 12:06:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5030,8,'                              ','Lunes 27 de Junio del 05, a las 12:08:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5031,8,'                              ','Lunes 27 de Junio del 05, a las 12:11:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5032,8,'                              ','Lunes 27 de Junio del 05, a las 12:13:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5033,8,'                              ','Lunes 27 de Junio del 05, a las 12:37:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5034,8,'                              ','Lunes 27 de Junio del 05, a las 12:42:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5035,8,'                              ','Lunes 27 de Junio del 05, a las 12:44:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5036,8,'                              ','Lunes 27 de Junio del 05, a las 12:47:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5037,8,'                              ','Lunes 27 de Junio del 05, a las 13:21:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5038,8,'                              ','Lunes 27 de Junio del 05, a las 13:23:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5039,8,'                              ','Lunes 27 de Junio del 05, a las 13:26:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5040,8,'                              ','Lunes 27 de Junio del 05, a las 13:29:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5041,8,'                              ','Lunes 27 de Junio del 05, a las 13:33:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5042,8,'                              ','Lunes 27 de Junio del 05, a las 13:34:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5043,8,'                              ','Lunes 27 de Junio del 05, a las 13:36:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5044,8,'                              ','Lunes 27 de Junio del 05, a las 13:39:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5045,8,'                              ','Lunes 27 de Junio del 05, a las 13:40:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5046,8,'                              ','Lunes 27 de Junio del 05, a las 13:43:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5047,8,'                              ','Lunes 27 de Junio del 05, a las 13:43:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5048,8,'                              ','Lunes 27 de Junio del 05, a las 13:47:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5049,8,'                              ','Lunes 27 de Junio del 05, a las 14:32:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5050,8,'                              ','Lunes 27 de Junio del 05, a las 14:51:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5051,8,'                              ','Lunes 27 de Junio del 05, a las 14:54:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5052,8,'                              ','Lunes 27 de Junio del 05, a las 14:57:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5053,8,'                              ','Lunes 27 de Junio del 05, a las 15:02:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5054,8,'                              ','Lunes 27 de Junio del 05, a las 15:03:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5055,8,'                              ','Lunes 27 de Junio del 05, a las 15:06:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5056,8,'                              ','Lunes 27 de Junio del 05, a las 15:54:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5057,8,'                              ','Lunes 27 de Junio del 05, a las 15:57:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5058,8,'                              ','Lunes 27 de Junio del 05, a las 15:58:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5059,8,'                              ','Lunes 27 de Junio del 05, a las 16:00:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5060,8,'                              ','Lunes 27 de Junio del 05, a las 16:04:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5061,8,'                              ','Lunes 27 de Junio del 05, a las 16:07:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5062,8,'                              ','Lunes 27 de Junio del 05, a las 16:10:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5063,8,'                              ','Lunes 27 de Junio del 05, a las 16:12:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5064,8,'                              ','Lunes 27 de Junio del 05, a las 16:14:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5065,8,'                              ','Lunes 27 de Junio del 05, a las 16:25:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5066,8,'                              ','Martes 28 de Junio del 05, a las 09:24:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5067,8,'                              ','Martes 28 de Junio del 05, a las 10:09:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5068,8,'                              ','Martes 28 de Junio del 05, a las 10:14:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5069,8,'                              ','Martes 28 de Junio del 05, a las 10:16:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5070,8,'                              ','Martes 28 de Junio del 05, a las 10:19:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5071,8,'                              ','Martes 28 de Junio del 05, a las 10:21:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5072,8,'                              ','Martes 28 de Junio del 05, a las 10:24:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5073,8,'                              ','Martes 28 de Junio del 05, a las 10:26:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5074,8,'                              ','Martes 28 de Junio del 05, a las 10:27:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5075,8,'                              ','Martes 28 de Junio del 05, a las 10:29:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5076,8,'                              ','Martes 28 de Junio del 05, a las 10:30:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5077,8,'                              ','Martes 28 de Junio del 05, a las 10:34:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5078,8,'                              ','Martes 28 de Junio del 05, a las 10:37:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5079,8,'                              ','Martes 28 de Junio del 05, a las 10:39:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5080,8,'                              ','Martes 28 de Junio del 05, a las 10:41:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5081,8,'                              ','Martes 28 de Junio del 05, a las 10:41:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5082,8,'                              ','Martes 28 de Junio del 05, a las 10:43:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5083,8,'                              ','Martes 28 de Junio del 05, a las 10:45:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5084,8,'                              ','Martes 28 de Junio del 05, a las 10:48:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5085,8,'                              ','Martes 28 de Junio del 05, a las 10:51:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5086,8,'                              ','Martes 28 de Junio del 05, a las 10:54:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5087,8,'                              ','Martes 28 de Junio del 05, a las 10:56:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5088,8,'                              ','Martes 28 de Junio del 05, a las 10:57:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5089,8,'                              ','Martes 28 de Junio del 05, a las 10:58:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5090,8,'                              ','Martes 28 de Junio del 05, a las 11:00:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5091,8,'                              ','Martes 28 de Junio del 05, a las 11:02:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5092,8,'                              ','Martes 28 de Junio del 05, a las 11:04:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5093,8,'                              ','Martes 28 de Junio del 05, a las 11:09:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5094,8,'                              ','Martes 28 de Junio del 05, a las 11:10:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5095,8,'                              ','Martes 28 de Junio del 05, a las 11:11:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5096,8,'                              ','Martes 28 de Junio del 05, a las 11:12:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5097,8,'                              ','Martes 28 de Junio del 05, a las 11:13:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5098,8,'                              ','Martes 28 de Junio del 05, a las 11:14:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5099,8,'                              ','Martes 28 de Junio del 05, a las 11:14:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5100,8,'                              ','Martes 28 de Junio del 05, a las 11:15:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5101,8,'                              ','Martes 28 de Junio del 05, a las 11:17:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5102,8,'                              ','Martes 28 de Junio del 05, a las 11:18:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5103,8,'                              ','Martes 28 de Junio del 05, a las 11:19:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5104,8,'                              ','Martes 28 de Junio del 05, a las 11:20:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5105,8,'                              ','Martes 28 de Junio del 05, a las 11:21:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5106,8,'                              ','Martes 28 de Junio del 05, a las 11:22:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5107,8,'                              ','Martes 28 de Junio del 05, a las 11:23:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5108,8,'                              ','Martes 28 de Junio del 05, a las 11:24:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5109,8,'                              ','Martes 28 de Junio del 05, a las 11:25:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5110,8,'                              ','Martes 28 de Junio del 05, a las 11:26:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5111,8,'                              ','Martes 28 de Junio del 05, a las 11:29:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5112,8,'                              ','Martes 28 de Junio del 05, a las 11:30:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5113,8,'                              ','Martes 28 de Junio del 05, a las 11:31:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5114,8,'                              ','Martes 28 de Junio del 05, a las 11:32:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5115,8,'                              ','Martes 28 de Junio del 05, a las 11:33:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5116,8,'                              ','Martes 28 de Junio del 05, a las 11:38:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5117,8,'                              ','Martes 28 de Junio del 05, a las 11:38:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5118,8,'                              ','Martes 28 de Junio del 05, a las 11:40:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5119,8,'                              ','Martes 28 de Junio del 05, a las 11:42:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5120,8,'                              ','Martes 28 de Junio del 05, a las 11:44:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5121,8,'                              ','Martes 28 de Junio del 05, a las 11:45:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5122,8,'                              ','Martes 28 de Junio del 05, a las 11:48:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5123,8,'                              ','Martes 28 de Junio del 05, a las 11:50:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5124,8,'                              ','Martes 28 de Junio del 05, a las 11:53:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5125,8,'                              ','Martes 28 de Junio del 05, a las 11:55:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5126,8,'                              ','Martes 28 de Junio del 05, a las 11:56:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5127,8,'                              ','Martes 28 de Junio del 05, a las 12:11:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5128,8,'                              ','Martes 28 de Junio del 05, a las 12:13:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5129,8,'                              ','Martes 28 de Junio del 05, a las 12:14:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5130,8,'                              ','Martes 28 de Junio del 05, a las 12:15:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5131,8,'                              ','Martes 28 de Junio del 05, a las 12:16:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5132,8,'                              ','Martes 28 de Junio del 05, a las 12:19:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5133,8,'                              ','Martes 28 de Junio del 05, a las 12:22:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5134,8,'                              ','Martes 28 de Junio del 05, a las 12:23:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5135,8,'                              ','Martes 28 de Junio del 05, a las 12:24:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5136,8,'                              ','Martes 28 de Junio del 05, a las 12:26:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5137,8,'                              ','Martes 28 de Junio del 05, a las 12:27:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5138,8,'                              ','Martes 28 de Junio del 05, a las 12:28:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5139,8,'                              ','Martes 28 de Junio del 05, a las 12:28:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5140,8,'                              ','Martes 28 de Junio del 05, a las 12:29:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5141,8,'                              ','Martes 28 de Junio del 05, a las 12:29:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5142,8,'                              ','Martes 28 de Junio del 05, a las 12:30:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5143,8,'                              ','Martes 28 de Junio del 05, a las 12:31:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5144,8,'                              ','Martes 28 de Junio del 05, a las 12:32:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5145,8,'                              ','Martes 28 de Junio del 05, a las 12:33:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5146,8,'                              ','Martes 28 de Junio del 05, a las 12:34:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5147,8,'                              ','Martes 28 de Junio del 05, a las 12:35:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5148,8,'                              ','Martes 28 de Junio del 05, a las 12:36:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5149,8,'                              ','Martes 28 de Junio del 05, a las 12:37:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5150,8,'                              ','Martes 28 de Junio del 05, a las 12:40:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5151,8,'                              ','Martes 28 de Junio del 05, a las 12:41:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5152,8,'                              ','Martes 28 de Junio del 05, a las 12:42:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5153,8,'                              ','Martes 28 de Junio del 05, a las 12:43:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5154,8,'                              ','Martes 28 de Junio del 05, a las 12:43:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5155,8,'                              ','Martes 28 de Junio del 05, a las 12:45:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5156,8,'                              ','Martes 28 de Junio del 05, a las 12:45:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5157,8,'                              ','Martes 28 de Junio del 05, a las 12:46:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5158,8,'                              ','Martes 28 de Junio del 05, a las 12:47:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5159,8,'                              ','Martes 28 de Junio del 05, a las 12:48:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5160,8,'                              ','Martes 28 de Junio del 05, a las 12:49:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5161,8,'                              ','Martes 28 de Junio del 05, a las 12:49:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5162,8,'                              ','Martes 28 de Junio del 05, a las 12:51:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5163,8,'                              ','Martes 28 de Junio del 05, a las 12:54:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5164,8,'                              ','Martes 28 de Junio del 05, a las 12:54:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5165,8,'                              ','Martes 28 de Junio del 05, a las 12:55:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5166,8,'                              ','Martes 28 de Junio del 05, a las 12:56:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5167,8,'                              ','Martes 28 de Junio del 05, a las 12:57:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5168,8,'                              ','Martes 28 de Junio del 05, a las 12:57:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5169,8,'                              ','Martes 28 de Junio del 05, a las 12:59:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5170,8,'                              ','Martes 28 de Junio del 05, a las 13:00:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5171,8,'                              ','Martes 28 de Junio del 05, a las 13:00:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5172,8,'                              ','Martes 28 de Junio del 05, a las 13:01:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5173,8,'                              ','Martes 28 de Junio del 05, a las 13:02:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5174,8,'                              ','Martes 28 de Junio del 05, a las 13:03:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5175,8,'                              ','Martes 28 de Junio del 05, a las 13:04:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5176,8,'                              ','Martes 28 de Junio del 05, a las 13:05:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5177,8,'                              ','Martes 28 de Junio del 05, a las 13:06:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5178,8,'                              ','Martes 28 de Junio del 05, a las 13:07:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5179,8,'                              ','Martes 28 de Junio del 05, a las 13:08:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5180,8,'                              ','Martes 28 de Junio del 05, a las 13:10:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5181,8,'                              ','Martes 28 de Junio del 05, a las 13:10:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5182,8,'                              ','Martes 28 de Junio del 05, a las 13:12:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5183,8,'                              ','Martes 28 de Junio del 05, a las 13:12:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5184,8,'                              ','Martes 28 de Junio del 05, a las 13:13:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5185,8,'                              ','Martes 28 de Junio del 05, a las 13:14:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5186,8,'                              ','Martes 28 de Junio del 05, a las 13:16:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5187,8,'                              ','Martes 28 de Junio del 05, a las 13:17:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5188,8,'                              ','Martes 28 de Junio del 05, a las 13:17:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5189,8,'                              ','Martes 28 de Junio del 05, a las 13:23:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5190,8,'                              ','Martes 28 de Junio del 05, a las 13:24:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5191,8,'                              ','Martes 28 de Junio del 05, a las 13:24:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5192,8,'                              ','Martes 28 de Junio del 05, a las 13:25:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5193,8,'                              ','Martes 28 de Junio del 05, a las 13:26:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5194,8,'                              ','Martes 28 de Junio del 05, a las 13:27:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5195,8,'                              ','Martes 28 de Junio del 05, a las 13:27:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5196,8,'                              ','Martes 28 de Junio del 05, a las 13:28:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5197,8,'                              ','Martes 28 de Junio del 05, a las 13:29:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5198,8,'                              ','Martes 28 de Junio del 05, a las 13:30:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5199,8,'                              ','Martes 28 de Junio del 05, a las 15:46:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5200,8,'                              ','Martes 28 de Junio del 05, a las 15:50:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5201,8,'                              ','Martes 28 de Junio del 05, a las 15:52:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5202,8,'                              ','Martes 28 de Junio del 05, a las 15:55:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5203,8,'                              ','Martes 28 de Junio del 05, a las 15:57:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5204,8,'                              ','Martes 28 de Junio del 05, a las 16:01:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5205,8,'                              ','Martes 28 de Junio del 05, a las 16:04:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5206,8,'                              ','Martes 28 de Junio del 05, a las 16:05:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5207,8,'                              ','Martes 28 de Junio del 05, a las 16:14:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5208,8,'                              ','Martes 28 de Junio del 05, a las 16:16:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5209,8,'                              ','Martes 28 de Junio del 05, a las 16:20:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5210,8,'                              ','Martes 28 de Junio del 05, a las 16:22:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5211,8,'                              ','Mircoles 29 de Junio del 05, a las 10:09:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5212,8,'                              ','Mircoles 29 de Junio del 05, a las 10:11:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5213,8,'                              ','Mircoles 29 de Junio del 05, a las 10:12:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5214,8,'                              ','Mircoles 29 de Junio del 05, a las 10:13:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5215,8,'                              ','Mircoles 29 de Junio del 05, a las 10:14:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5216,8,'                              ','Mircoles 29 de Junio del 05, a las 10:15:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5217,8,'                              ','Mircoles 29 de Junio del 05, a las 10:16:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5218,8,'                              ','Mircoles 29 de Junio del 05, a las 10:16:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5219,8,'                              ','Mircoles 29 de Junio del 05, a las 10:17:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5220,8,'                              ','Mircoles 29 de Junio del 05, a las 10:17:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5221,8,'                              ','Mircoles 29 de Junio del 05, a las 10:20:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5222,8,'                              ','Mircoles 29 de Junio del 05, a las 10:21:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5223,8,'                              ','Mircoles 29 de Junio del 05, a las 10:23:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5224,8,'                              ','Mircoles 29 de Junio del 05, a las 10:25:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5225,8,'                              ','Mircoles 29 de Junio del 05, a las 10:27:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5226,8,'                              ','Mircoles 29 de Junio del 05, a las 10:31:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5227,8,'                              ','Mircoles 29 de Junio del 05, a las 10:55:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5228,8,'                              ','Mircoles 29 de Junio del 05, a las 13:17:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5229,8,'                              ','Mircoles 29 de Junio del 05, a las 13:18:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5230,8,'                              ','Mircoles 29 de Junio del 05, a las 13:19:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5231,8,'                              ','Mircoles 29 de Junio del 05, a las 13:20:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5232,8,'                              ','Mircoles 29 de Junio del 05, a las 13:23:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5233,8,'                              ','Mircoles 29 de Junio del 05, a las 13:35:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5234,8,'                              ','Mircoles 29 de Junio del 05, a las 13:41:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5235,8,'                              ','Mircoles 29 de Junio del 05, a las 13:47:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5236,8,'                              ','Mircoles 29 de Junio del 05, a las 14:16:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5237,2,'Bib Datos Propopios           ','Mircoles 29 de Junio del 05, a las 14:32:55      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5238,2,'Bib Datos Propopios           ','Mircoles 29 de Junio del 05, a las 14:33:09      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5239,2,'Bib Datos Propopios           ','Mircoles 29 de Junio del 05, a las 14:33:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5240,2,'Bib Datos Propopios           ','Mircoles 29 de Junio del 05, a las 14:33:41      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5241,4,'                              ','Mircoles 29 de Junio del 05, a las 15:01:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5242,4,'                              ','Mircoles 29 de Junio del 05, a las 15:14:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5243,4,'                              ','Mircoles 29 de Junio del 05, a las 15:15:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5244,8,'                              ','Mircoles 29 de Junio del 05, a las 15:35:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5245,8,'                              ','Mircoles 29 de Junio del 05, a las 15:38:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5246,8,'                              ','Mircoles 29 de Junio del 05, a las 15:39:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5247,8,'                              ','Mircoles 29 de Junio del 05, a las 15:40:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5248,8,'                              ','Mircoles 29 de Junio del 05, a las 15:41:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5249,8,'                              ','Mircoles 29 de Junio del 05, a las 15:41:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5250,8,'                              ','Jueves 30 de Junio del 05, a las 10:06:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5251,8,'                              ','Jueves 30 de Junio del 05, a las 10:07:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5252,8,'                              ','Jueves 30 de Junio del 05, a las 10:09:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5253,8,'                              ','Jueves 30 de Junio del 05, a las 10:10:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5254,8,'                              ','Jueves 30 de Junio del 05, a las 11:32:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5255,4,'                              ','Jueves 30 de Junio del 05, a las 11:37:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5256,4,'                              ','Jueves 30 de Junio del 05, a las 11:38:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5257,8,'                              ','Jueves 30 de Junio del 05, a las 11:40:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5258,8,'                              ','Jueves 30 de Junio del 05, a las 11:41:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5259,8,'                              ','Jueves 30 de Junio del 05, a las 11:41:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5260,8,'                              ','Jueves 30 de Junio del 05, a las 11:42:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5261,8,'                              ','Jueves 30 de Junio del 05, a las 11:43:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5262,4,'                              ','Jueves 30 de Junio del 05, a las 11:46:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5263,8,'                              ','Jueves 30 de Junio del 05, a las 11:49:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5264,4,'                              ','Jueves 30 de Junio del 05, a las 11:51:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5265,8,'                              ','Jueves 30 de Junio del 05, a las 11:53:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5266,4,'                              ','Jueves 30 de Junio del 05, a las 11:54:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5267,8,'                              ','Jueves 30 de Junio del 05, a las 11:56:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5268,4,'                              ','Jueves 30 de Junio del 05, a las 11:57:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5269,8,'                              ','Jueves 30 de Junio del 05, a las 11:59:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5270,8,'                              ','Jueves 30 de Junio del 05, a las 11:59:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5271,8,'                              ','Jueves 30 de Junio del 05, a las 12:00:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5272,4,'                              ','Jueves 30 de Junio del 05, a las 12:01:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5273,8,'                              ','Jueves 30 de Junio del 05, a las 12:02:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5274,4,'                              ','Jueves 30 de Junio del 05, a las 12:48:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5275,8,'                              ','Jueves 30 de Junio del 05, a las 12:50:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5276,4,'                              ','Jueves 30 de Junio del 05, a las 12:52:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5277,8,'                              ','Jueves 30 de Junio del 05, a las 12:54:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5278,4,'                              ','Jueves 30 de Junio del 05, a las 12:56:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5279,8,'                              ','Jueves 30 de Junio del 05, a las 12:57:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5280,4,'                              ','Jueves 30 de Junio del 05, a las 12:59:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5281,4,'                              ','Jueves 30 de Junio del 05, a las 13:03:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5282,8,'                              ','Jueves 30 de Junio del 05, a las 13:05:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5283,8,'                              ','Jueves 30 de Junio del 05, a las 13:05:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5284,8,'                              ','Jueves 30 de Junio del 05, a las 13:08:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5285,4,'                              ','Jueves 30 de Junio del 05, a las 13:09:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5286,8,'                              ','Jueves 30 de Junio del 05, a las 13:10:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5287,4,'                              ','Jueves 30 de Junio del 05, a las 13:11:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5288,8,'                              ','Jueves 30 de Junio del 05, a las 13:12:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5289,4,'                              ','Jueves 30 de Junio del 05, a las 13:16:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5290,8,'                              ','Jueves 30 de Junio del 05, a las 13:17:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5291,8,'                              ','Jueves 30 de Junio del 05, a las 13:18:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5292,8,'                              ','Jueves 30 de Junio del 05, a las 13:20:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5293,4,'                              ','Jueves 30 de Junio del 05, a las 13:22:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5294,8,'                              ','Jueves 30 de Junio del 05, a las 13:23:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5295,4,'                              ','Jueves 30 de Junio del 05, a las 13:25:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5296,8,'                              ','Jueves 30 de Junio del 05, a las 13:27:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5297,4,'                              ','Jueves 30 de Junio del 05, a las 13:29:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5298,8,'                              ','Jueves 30 de Junio del 05, a las 13:30:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5299,8,'                              ','Jueves 30 de Junio del 05, a las 13:32:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5300,4,'                              ','Jueves 30 de Junio del 05, a las 13:34:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5301,8,'                              ','Jueves 30 de Junio del 05, a las 13:38:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5302,4,'                              ','Jueves 30 de Junio del 05, a las 13:40:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5303,8,'                              ','Jueves 30 de Junio del 05, a las 13:43:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5304,4,'                              ','Jueves 30 de Junio del 05, a las 13:49:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5305,8,'                              ','Jueves 30 de Junio del 05, a las 13:51:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5306,4,'                              ','Jueves 30 de Junio del 05, a las 13:53:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5307,8,'                              ','Jueves 30 de Junio del 05, a las 14:17:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5308,4,'                              ','Jueves 30 de Junio del 05, a las 14:46:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5309,8,'                              ','Jueves 30 de Junio del 05, a las 14:52:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5310,4,'                              ','Jueves 30 de Junio del 05, a las 14:54:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5311,8,'                              ','Jueves 30 de Junio del 05, a las 14:56:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5312,4,'                              ','Jueves 30 de Junio del 05, a las 14:57:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5313,8,'                              ','Jueves 30 de Junio del 05, a las 14:58:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5314,4,'                              ','Jueves 30 de Junio del 05, a las 14:59:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5315,8,'                              ','Jueves 30 de Junio del 05, a las 15:01:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5316,8,'                              ','Jueves 30 de Junio del 05, a las 15:01:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5317,4,'                              ','Jueves 30 de Junio del 05, a las 15:02:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5318,8,'                              ','Jueves 30 de Junio del 05, a las 15:03:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5319,4,'                              ','Jueves 30 de Junio del 05, a las 15:09:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5320,8,'                              ','Jueves 30 de Junio del 05, a las 15:11:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5321,4,'                              ','Jueves 30 de Junio del 05, a las 15:13:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5322,8,'                              ','Jueves 30 de Junio del 05, a las 15:14:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5323,4,'                              ','Jueves 30 de Junio del 05, a las 15:18:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5324,8,'                              ','Jueves 30 de Junio del 05, a las 15:20:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5325,4,'                              ','Jueves 30 de Junio del 05, a las 15:21:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5326,8,'                              ','Jueves 30 de Junio del 05, a las 15:22:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5327,4,'                              ','Jueves 30 de Junio del 05, a las 15:24:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5328,8,'                              ','Jueves 30 de Junio del 05, a las 15:26:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5329,4,'                              ','Jueves 30 de Junio del 05, a las 15:31:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5330,8,'                              ','Jueves 30 de Junio del 05, a las 15:33:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5331,4,'                              ','Jueves 30 de Junio del 05, a las 15:34:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5332,8,'                              ','Jueves 30 de Junio del 05, a las 15:35:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5333,4,'                              ','Jueves 30 de Junio del 05, a las 15:42:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5334,8,'                              ','Jueves 30 de Junio del 05, a las 15:43:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5335,4,'                              ','Jueves 30 de Junio del 05, a las 17:25:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5336,8,'                              ','Jueves 30 de Junio del 05, a las 17:27:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5337,4,'                              ','Jueves 30 de Junio del 05, a las 17:28:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5338,8,'                              ','Jueves 30 de Junio del 05, a las 17:30:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5339,4,'                              ','Jueves 30 de Junio del 05, a las 17:31:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5340,8,'                              ','Jueves 30 de Junio del 05, a las 17:34:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5341,8,'                              ','Jueves 30 de Junio del 05, a las 17:37:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5342,8,'                              ','Jueves 30 de Junio del 05, a las 17:37:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5343,4,'                              ','Jueves 30 de Junio del 05, a las 17:40:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5344,8,'                              ','Jueves 30 de Junio del 05, a las 17:41:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5345,8,'                              ','Jueves 30 de Junio del 05, a las 18:02:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5346,8,'                              ','Jueves 30 de Junio del 05, a las 18:03:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5347,4,'                              ','Jueves 30 de Junio del 05, a las 18:04:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5348,8,'                              ','Jueves 30 de Junio del 05, a las 18:08:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5349,8,'                              ','Jueves 30 de Junio del 05, a las 18:09:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5350,4,'                              ','Jueves 30 de Junio del 05, a las 18:10:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5351,8,'                              ','Jueves 30 de Junio del 05, a las 18:12:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5352,8,'                              ','Jueves 30 de Junio del 05, a las 18:14:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5353,4,'                              ','Jueves 30 de Junio del 05, a las 18:16:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5354,8,'                              ','Jueves 30 de Junio del 05, a las 18:19:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5355,8,'                              ','Jueves 30 de Junio del 05, a las 18:20:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5356,4,'                              ','Jueves 30 de Junio del 05, a las 18:23:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5357,8,'                              ','Jueves 30 de Junio del 05, a las 18:25:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5358,4,'                              ','Jueves 30 de Junio del 05, a las 18:26:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5359,8,'                              ','Jueves 30 de Junio del 05, a las 18:28:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5360,4,'                              ','Jueves 30 de Junio del 05, a las 18:33:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5361,8,'                              ','Jueves 30 de Junio del 05, a las 18:35:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5362,4,'                              ','Jueves 30 de Junio del 05, a las 18:37:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5363,8,'                              ','Jueves 30 de Junio del 05, a las 18:39:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5364,4,'                              ','Viernes 1 de Julio del 05, a las 10:36:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5365,8,'                              ','Viernes 1 de Julio del 05, a las 10:38:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5366,4,'                              ','Viernes 1 de Julio del 05, a las 10:44:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5367,8,'                              ','Viernes 1 de Julio del 05, a las 10:47:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5368,8,'                              ','Viernes 1 de Julio del 05, a las 10:48:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5369,4,'                              ','Viernes 1 de Julio del 05, a las 10:49:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5370,8,'                              ','Viernes 1 de Julio del 05, a las 10:54:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5371,4,'                              ','Viernes 1 de Julio del 05, a las 10:57:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5372,8,'                              ','Viernes 1 de Julio del 05, a las 11:00:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5373,4,'                              ','Viernes 1 de Julio del 05, a las 11:22:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5374,4,'                              ','Viernes 1 de Julio del 05, a las 11:24:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5375,4,'                              ','Viernes 1 de Julio del 05, a las 11:27:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5376,4,'                              ','Viernes 1 de Julio del 05, a las 12:14:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5377,4,'                              ','Viernes 1 de Julio del 05, a las 12:15:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5378,8,'                              ','Viernes 1 de Julio del 05, a las 12:16:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5379,8,'                              ','Viernes 1 de Julio del 05, a las 12:17:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5380,8,'                              ','Viernes 1 de Julio del 05, a las 12:18:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5381,4,'                              ','Viernes 1 de Julio del 05, a las 12:19:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5382,8,'                              ','Viernes 1 de Julio del 05, a las 12:21:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5383,4,'                              ','Viernes 1 de Julio del 05, a las 12:22:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5384,8,'                              ','Viernes 1 de Julio del 05, a las 12:24:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5385,4,'                              ','Viernes 1 de Julio del 05, a las 12:25:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5386,8,'                              ','Viernes 1 de Julio del 05, a las 12:27:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5387,4,'                              ','Viernes 1 de Julio del 05, a las 12:28:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5388,8,'                              ','Viernes 1 de Julio del 05, a las 12:31:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5389,4,'                              ','Viernes 1 de Julio del 05, a las 12:33:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5390,8,'                              ','Viernes 1 de Julio del 05, a las 12:34:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5391,4,'                              ','Viernes 1 de Julio del 05, a las 12:36:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5392,8,'                              ','Viernes 1 de Julio del 05, a las 12:42:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5393,8,'                              ','Viernes 1 de Julio del 05, a las 12:48:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5394,4,'                              ','Viernes 1 de Julio del 05, a las 12:50:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5395,8,'                              ','Viernes 1 de Julio del 05, a las 12:51:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5396,4,'                              ','Viernes 1 de Julio del 05, a las 12:53:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5397,8,'                              ','Viernes 1 de Julio del 05, a las 12:55:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5398,4,'                              ','Viernes 1 de Julio del 05, a las 12:59:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5399,8,'                              ','Viernes 1 de Julio del 05, a las 13:04:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5400,4,'                              ','Viernes 1 de Julio del 05, a las 13:05:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5401,8,'                              ','Viernes 1 de Julio del 05, a las 13:08:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5402,4,'                              ','Viernes 1 de Julio del 05, a las 13:21:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5403,4,'                              ','Viernes 1 de Julio del 05, a las 13:23:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5404,4,'                              ','Viernes 1 de Julio del 05, a las 13:26:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5405,4,'                              ','Viernes 1 de Julio del 05, a las 13:27:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5406,4,'                              ','Viernes 1 de Julio del 05, a las 13:28:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5407,4,'                              ','Viernes 1 de Julio del 05, a las 13:29:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5408,4,'                              ','Viernes 1 de Julio del 05, a las 13:30:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5409,4,'                              ','Viernes 1 de Julio del 05, a las 13:30:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5410,8,'                              ','Viernes 1 de Julio del 05, a las 13:31:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5411,4,'                              ','Viernes 1 de Julio del 05, a las 13:32:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5412,4,'                              ','Viernes 1 de Julio del 05, a las 13:34:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5413,4,'                              ','Viernes 1 de Julio del 05, a las 13:37:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5414,4,'                              ','Viernes 1 de Julio del 05, a las 13:41:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5415,4,'                              ','Viernes 1 de Julio del 05, a las 13:43:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5416,4,'                              ','Viernes 1 de Julio del 05, a las 13:43:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5417,4,'                              ','Viernes 1 de Julio del 05, a las 13:44:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5418,8,'                              ','Viernes 1 de Julio del 05, a las 13:45:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5419,4,'                              ','Viernes 1 de Julio del 05, a las 13:46:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5420,4,'                              ','Viernes 1 de Julio del 05, a las 13:47:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5421,4,'                              ','Viernes 1 de Julio del 05, a las 13:47:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5422,8,'                              ','Viernes 1 de Julio del 05, a las 13:50:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5423,4,'                              ','Viernes 1 de Julio del 05, a las 13:50:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5424,8,'                              ','Viernes 1 de Julio del 05, a las 13:51:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5425,4,'                              ','Viernes 1 de Julio del 05, a las 13:51:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5426,2,'Bib Datos Propopios           ','Viernes 1 de Julio del 05, a las 13:52:05         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5427,4,'                              ','Viernes 1 de Julio del 05, a las 13:52:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5428,4,'                              ','Viernes 1 de Julio del 05, a las 13:52:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5429,4,'                              ','Viernes 1 de Julio del 05, a las 13:53:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5430,8,'                              ','Viernes 1 de Julio del 05, a las 13:53:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5431,8,'                              ','Viernes 1 de Julio del 05, a las 13:54:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5432,4,'                              ','Viernes 1 de Julio del 05, a las 13:54:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5433,4,'                              ','Viernes 1 de Julio del 05, a las 13:55:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5434,4,'                              ','Viernes 1 de Julio del 05, a las 13:56:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5435,8,'                              ','Viernes 1 de Julio del 05, a las 13:57:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5436,8,'                              ','Viernes 1 de Julio del 05, a las 13:57:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5437,4,'                              ','Viernes 1 de Julio del 05, a las 13:58:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5438,4,'                              ','Viernes 1 de Julio del 05, a las 13:59:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5439,4,'                              ','Viernes 1 de Julio del 05, a las 13:59:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5440,4,'                              ','Viernes 1 de Julio del 05, a las 14:00:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5441,8,'                              ','Viernes 1 de Julio del 05, a las 14:00:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5442,4,'                              ','Viernes 1 de Julio del 05, a las 14:01:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5443,4,'                              ','Viernes 1 de Julio del 05, a las 14:02:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5444,8,'                              ','Viernes 1 de Julio del 05, a las 14:04:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5445,4,'                              ','Viernes 1 de Julio del 05, a las 14:05:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5446,4,'                              ','Viernes 1 de Julio del 05, a las 14:06:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5447,4,'                              ','Viernes 1 de Julio del 05, a las 14:07:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5448,4,'                              ','Viernes 1 de Julio del 05, a las 14:08:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5449,8,'                              ','Viernes 1 de Julio del 05, a las 14:09:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5450,4,'                              ','Viernes 1 de Julio del 05, a las 14:09:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5451,4,'                              ','Viernes 1 de Julio del 05, a las 14:10:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5452,4,'                              ','Viernes 1 de Julio del 05, a las 14:11:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5453,4,'                              ','Viernes 1 de Julio del 05, a las 14:11:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5454,4,'                              ','Viernes 1 de Julio del 05, a las 14:12:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5455,4,'                              ','Viernes 1 de Julio del 05, a las 14:13:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5456,4,'                              ','Viernes 1 de Julio del 05, a las 14:13:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5457,4,'                              ','Viernes 1 de Julio del 05, a las 14:15:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5458,4,'                              ','Viernes 1 de Julio del 05, a las 14:16:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5459,4,'                              ','Viernes 1 de Julio del 05, a las 14:17:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5460,4,'                              ','Viernes 1 de Julio del 05, a las 14:18:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5461,4,'                              ','Viernes 1 de Julio del 05, a las 14:19:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5462,4,'                              ','Viernes 1 de Julio del 05, a las 14:21:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5463,4,'                              ','Viernes 1 de Julio del 05, a las 14:23:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5464,4,'                              ','Viernes 1 de Julio del 05, a las 14:23:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5465,8,'                              ','Viernes 1 de Julio del 05, a las 14:26:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5466,8,'                              ','Viernes 1 de Julio del 05, a las 14:37:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5467,8,'                              ','Viernes 1 de Julio del 05, a las 14:39:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5468,8,'                              ','Viernes 1 de Julio del 05, a las 14:42:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5469,4,'                              ','Viernes 1 de Julio del 05, a las 14:43:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5470,8,'                              ','Viernes 1 de Julio del 05, a las 14:45:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5471,4,'                              ','Viernes 1 de Julio del 05, a las 14:46:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5472,8,'                              ','Viernes 1 de Julio del 05, a las 14:47:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5473,4,'                              ','Viernes 1 de Julio del 05, a las 14:48:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5474,8,'                              ','Viernes 1 de Julio del 05, a las 14:52:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5475,8,'                              ','Viernes 1 de Julio del 05, a las 14:53:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5476,4,'                              ','Viernes 1 de Julio del 05, a las 14:54:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5477,8,'                              ','Viernes 1 de Julio del 05, a las 14:56:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5478,4,'                              ','Viernes 1 de Julio del 05, a las 14:57:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5479,8,'                              ','Viernes 1 de Julio del 05, a las 15:01:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5480,4,'                              ','Viernes 1 de Julio del 05, a las 15:02:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5481,8,'                              ','Viernes 1 de Julio del 05, a las 15:04:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5482,4,'                              ','Viernes 1 de Julio del 05, a las 15:05:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5483,8,'                              ','Viernes 1 de Julio del 05, a las 15:07:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5484,8,'                              ','Viernes 1 de Julio del 05, a las 15:29:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5485,4,'                              ','Viernes 1 de Julio del 05, a las 15:31:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5486,8,'                              ','Viernes 1 de Julio del 05, a las 15:32:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5487,4,'                              ','Viernes 1 de Julio del 05, a las 15:33:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5488,8,'                              ','Viernes 1 de Julio del 05, a las 15:35:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5489,4,'                              ','Viernes 1 de Julio del 05, a las 15:36:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5490,8,'                              ','Viernes 1 de Julio del 05, a las 15:37:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5491,4,'                              ','Viernes 1 de Julio del 05, a las 16:51:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5492,4,'                              ','Viernes 1 de Julio del 05, a las 16:52:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5493,4,'                              ','Viernes 1 de Julio del 05, a las 16:53:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5494,4,'                              ','Viernes 1 de Julio del 05, a las 17:04:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5495,4,'                              ','Viernes 1 de Julio del 05, a las 17:06:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5496,4,'                              ','Viernes 1 de Julio del 05, a las 17:08:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5497,4,'                              ','Viernes 1 de Julio del 05, a las 17:08:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5498,4,'                              ','Viernes 1 de Julio del 05, a las 17:10:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5499,4,'                              ','Viernes 1 de Julio del 05, a las 17:11:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5500,4,'                              ','Viernes 1 de Julio del 05, a las 17:12:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5501,4,'                              ','Viernes 1 de Julio del 05, a las 17:13:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5502,4,'                              ','Viernes 1 de Julio del 05, a las 17:14:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5503,4,'                              ','Viernes 1 de Julio del 05, a las 17:15:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5504,4,'                              ','Viernes 1 de Julio del 05, a las 17:16:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5505,4,'                              ','Viernes 1 de Julio del 05, a las 17:17:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5506,4,'                              ','Viernes 1 de Julio del 05, a las 17:18:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5507,4,'                              ','Viernes 1 de Julio del 05, a las 17:19:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5508,4,'                              ','Viernes 1 de Julio del 05, a las 17:20:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5509,4,'                              ','Viernes 1 de Julio del 05, a las 17:20:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5510,4,'                              ','Viernes 1 de Julio del 05, a las 17:21:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5511,4,'                              ','Viernes 1 de Julio del 05, a las 17:23:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5512,4,'                              ','Viernes 1 de Julio del 05, a las 17:23:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5513,4,'                              ','Viernes 1 de Julio del 05, a las 17:25:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5514,4,'                              ','Viernes 1 de Julio del 05, a las 17:27:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5515,4,'                              ','Viernes 1 de Julio del 05, a las 17:28:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5516,4,'                              ','Viernes 1 de Julio del 05, a las 17:30:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5517,4,'                              ','Viernes 1 de Julio del 05, a las 17:31:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5518,4,'                              ','Viernes 1 de Julio del 05, a las 17:32:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5519,4,'                              ','Viernes 1 de Julio del 05, a las 17:33:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5520,4,'                              ','Viernes 1 de Julio del 05, a las 17:34:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5521,4,'                              ','Viernes 1 de Julio del 05, a las 17:37:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5522,4,'                              ','Viernes 1 de Julio del 05, a las 17:38:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5523,4,'                              ','Viernes 1 de Julio del 05, a las 17:39:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5524,4,'                              ','Viernes 1 de Julio del 05, a las 17:40:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5525,4,'                              ','Viernes 1 de Julio del 05, a las 17:41:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5526,4,'                              ','Viernes 1 de Julio del 05, a las 17:42:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5527,4,'                              ','Viernes 1 de Julio del 05, a las 17:43:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5528,4,'                              ','Viernes 1 de Julio del 05, a las 17:43:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5529,4,'                              ','Viernes 1 de Julio del 05, a las 17:44:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5530,4,'                              ','Viernes 1 de Julio del 05, a las 17:44:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5531,4,'                              ','Viernes 1 de Julio del 05, a las 17:45:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5532,4,'                              ','Viernes 1 de Julio del 05, a las 17:46:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5533,4,'                              ','Viernes 1 de Julio del 05, a las 17:46:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5534,4,'                              ','Viernes 1 de Julio del 05, a las 17:48:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5535,4,'                              ','Viernes 1 de Julio del 05, a las 17:49:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5536,4,'                              ','Viernes 1 de Julio del 05, a las 17:51:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5537,4,'                              ','Viernes 1 de Julio del 05, a las 17:51:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5538,4,'                              ','Viernes 1 de Julio del 05, a las 17:52:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5539,4,'                              ','Viernes 1 de Julio del 05, a las 17:52:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5540,4,'                              ','Viernes 1 de Julio del 05, a las 17:53:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5541,4,'                              ','Viernes 1 de Julio del 05, a las 17:53:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5542,8,'                              ','Viernes 1 de Julio del 05, a las 17:54:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5543,4,'                              ','Viernes 1 de Julio del 05, a las 17:54:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5544,8,'                              ','Viernes 1 de Julio del 05, a las 17:55:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5545,4,'                              ','Viernes 1 de Julio del 05, a las 17:56:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5546,4,'                              ','Viernes 1 de Julio del 05, a las 17:57:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5547,8,'                              ','Viernes 1 de Julio del 05, a las 17:57:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5548,4,'                              ','Viernes 1 de Julio del 05, a las 17:58:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5549,4,'                              ','Viernes 1 de Julio del 05, a las 17:58:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5550,4,'                              ','Viernes 1 de Julio del 05, a las 17:58:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5551,4,'                              ','Viernes 1 de Julio del 05, a las 17:59:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5552,4,'                              ','Viernes 1 de Julio del 05, a las 18:00:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5553,8,'                              ','Viernes 1 de Julio del 05, a las 18:02:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5554,4,'                              ','Viernes 1 de Julio del 05, a las 18:03:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5555,8,'                              ','Viernes 1 de Julio del 05, a las 18:05:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5556,4,'                              ','Viernes 1 de Julio del 05, a las 18:05:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5557,8,'                              ','Viernes 1 de Julio del 05, a las 18:07:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5558,4,'                              ','Viernes 1 de Julio del 05, a las 18:08:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5559,4,'                              ','Viernes 1 de Julio del 05, a las 18:08:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5560,8,'                              ','Viernes 1 de Julio del 05, a las 18:09:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5561,4,'                              ','Viernes 1 de Julio del 05, a las 18:10:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5562,4,'                              ','Viernes 1 de Julio del 05, a las 18:10:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5563,8,'                              ','Viernes 1 de Julio del 05, a las 18:11:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5564,4,'                              ','Viernes 1 de Julio del 05, a las 18:11:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5565,4,'                              ','Viernes 1 de Julio del 05, a las 18:11:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5566,4,'                              ','Viernes 1 de Julio del 05, a las 18:12:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5567,4,'                              ','Viernes 1 de Julio del 05, a las 18:13:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5568,8,'                              ','Viernes 1 de Julio del 05, a las 18:13:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5569,4,'                              ','Viernes 1 de Julio del 05, a las 18:13:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5570,4,'                              ','Viernes 1 de Julio del 05, a las 18:13:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5571,8,'                              ','Viernes 1 de Julio del 05, a las 18:15:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5572,4,'                              ','Viernes 1 de Julio del 05, a las 18:16:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5573,4,'                              ','Viernes 1 de Julio del 05, a las 18:16:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5574,4,'                              ','Viernes 1 de Julio del 05, a las 18:17:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5575,4,'                              ','Viernes 1 de Julio del 05, a las 18:17:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5576,8,'                              ','Viernes 1 de Julio del 05, a las 18:18:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5577,4,'                              ','Viernes 1 de Julio del 05, a las 18:19:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5578,8,'                              ','Viernes 1 de Julio del 05, a las 18:20:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5579,4,'                              ','Viernes 1 de Julio del 05, a las 18:20:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5580,4,'                              ','Viernes 1 de Julio del 05, a las 18:20:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5581,4,'                              ','Viernes 1 de Julio del 05, a las 18:21:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5582,8,'                              ','Viernes 1 de Julio del 05, a las 18:21:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5583,4,'                              ','Viernes 1 de Julio del 05, a las 18:23:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5584,8,'                              ','Viernes 1 de Julio del 05, a las 18:23:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5585,4,'                              ','Viernes 1 de Julio del 05, a las 18:24:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5586,4,'                              ','Viernes 1 de Julio del 05, a las 18:25:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5587,4,'                              ','Viernes 1 de Julio del 05, a las 18:25:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5588,4,'                              ','Viernes 1 de Julio del 05, a las 18:26:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5589,4,'                              ','Viernes 1 de Julio del 05, a las 18:27:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5590,4,'                              ','Viernes 1 de Julio del 05, a las 18:27:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5591,8,'                              ','Viernes 1 de Julio del 05, a las 18:28:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5592,4,'                              ','Viernes 1 de Julio del 05, a las 18:29:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5593,4,'                              ','Viernes 1 de Julio del 05, a las 18:30:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5594,8,'                              ','Viernes 1 de Julio del 05, a las 18:31:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5595,4,'                              ','Viernes 1 de Julio del 05, a las 18:31:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5596,8,'                              ','Viernes 1 de Julio del 05, a las 18:32:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5597,4,'                              ','Viernes 1 de Julio del 05, a las 18:33:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5598,8,'                              ','Viernes 1 de Julio del 05, a las 18:35:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5599,4,'                              ','Viernes 1 de Julio del 05, a las 18:47:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5600,4,'                              ','Viernes 1 de Julio del 05, a las 18:48:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5601,4,'                              ','Viernes 1 de Julio del 05, a las 18:49:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5602,4,'                              ','Viernes 1 de Julio del 05, a las 18:49:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5603,4,'                              ','Viernes 1 de Julio del 05, a las 18:51:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5604,4,'                              ','Viernes 1 de Julio del 05, a las 18:52:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5605,4,'                              ','Viernes 1 de Julio del 05, a las 18:54:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5606,4,'                              ','Viernes 1 de Julio del 05, a las 18:54:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5607,4,'                              ','Viernes 1 de Julio del 05, a las 18:56:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5608,4,'                              ','Viernes 1 de Julio del 05, a las 18:57:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5609,4,'                              ','Viernes 1 de Julio del 05, a las 18:58:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5610,4,'                              ','Viernes 1 de Julio del 05, a las 19:27:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5611,4,'                              ','Viernes 1 de Julio del 05, a las 19:28:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5612,4,'                              ','Viernes 1 de Julio del 05, a las 19:30:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5613,4,'                              ','Viernes 1 de Julio del 05, a las 19:31:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5614,4,'                              ','Viernes 1 de Julio del 05, a las 19:35:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5615,4,'                              ','Viernes 1 de Julio del 05, a las 19:37:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5616,4,'                              ','Viernes 1 de Julio del 05, a las 19:40:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5617,4,'                              ','Viernes 1 de Julio del 05, a las 19:41:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5618,4,'                              ','Viernes 1 de Julio del 05, a las 19:42:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5619,4,'                              ','Viernes 1 de Julio del 05, a las 19:43:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5620,4,'                              ','Lunes 4 de Julio del 05, a las 10:01:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5621,4,'                              ','Lunes 4 de Julio del 05, a las 10:01:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5622,4,'                              ','Lunes 4 de Julio del 05, a las 10:05:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5623,4,'                              ','Lunes 4 de Julio del 05, a las 10:06:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5624,8,'                              ','Lunes 4 de Julio del 05, a las 10:08:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5625,4,'                              ','Lunes 4 de Julio del 05, a las 10:10:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5626,4,'                              ','Lunes 4 de Julio del 05, a las 10:10:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5627,4,'                              ','Lunes 4 de Julio del 05, a las 10:11:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5628,8,'                              ','Lunes 4 de Julio del 05, a las 10:11:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5629,4,'                              ','Lunes 4 de Julio del 05, a las 10:12:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5630,4,'                              ','Lunes 4 de Julio del 05, a las 10:17:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5631,4,'                              ','Lunes 4 de Julio del 05, a las 10:21:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5632,4,'                              ','Lunes 4 de Julio del 05, a las 10:21:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5633,8,'                              ','Lunes 4 de Julio del 05, a las 10:22:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5634,4,'                              ','Lunes 4 de Julio del 05, a las 10:22:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5635,4,'                              ','Lunes 4 de Julio del 05, a las 10:23:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5636,4,'                              ','Lunes 4 de Julio del 05, a las 10:24:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5637,8,'                              ','Lunes 4 de Julio del 05, a las 10:25:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5638,4,'                              ','Lunes 4 de Julio del 05, a las 10:26:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5639,8,'                              ','Lunes 4 de Julio del 05, a las 10:28:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5640,4,'                              ','Lunes 4 de Julio del 05, a las 10:29:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5641,8,'                              ','Lunes 4 de Julio del 05, a las 10:30:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5642,4,'                              ','Lunes 4 de Julio del 05, a las 10:31:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5643,8,'                              ','Lunes 4 de Julio del 05, a las 10:32:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5644,4,'                              ','Lunes 4 de Julio del 05, a las 10:33:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5645,4,'                              ','Lunes 4 de Julio del 05, a las 10:34:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5646,4,'                              ','Lunes 4 de Julio del 05, a las 10:35:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5647,8,'                              ','Lunes 4 de Julio del 05, a las 10:36:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5648,4,'                              ','Lunes 4 de Julio del 05, a las 10:38:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5649,4,'                              ','Lunes 4 de Julio del 05, a las 10:38:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5650,8,'                              ','Lunes 4 de Julio del 05, a las 10:39:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5651,4,'                              ','Lunes 4 de Julio del 05, a las 10:42:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5652,8,'                              ','Lunes 4 de Julio del 05, a las 10:44:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5653,4,'                              ','Lunes 4 de Julio del 05, a las 10:49:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5654,4,'                              ','Lunes 4 de Julio del 05, a las 10:50:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5655,4,'                              ','Lunes 4 de Julio del 05, a las 10:50:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5656,8,'                              ','Lunes 4 de Julio del 05, a las 10:51:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5657,8,'                              ','Lunes 4 de Julio del 05, a las 10:53:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5658,4,'                              ','Lunes 4 de Julio del 05, a las 10:54:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5659,8,'                              ','Lunes 4 de Julio del 05, a las 10:55:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5660,4,'                              ','Lunes 4 de Julio del 05, a las 10:57:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5661,8,'                              ','Lunes 4 de Julio del 05, a las 11:00:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5662,4,'                              ','Lunes 4 de Julio del 05, a las 11:00:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5663,8,'                              ','Lunes 4 de Julio del 05, a las 11:02:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5664,4,'                              ','Lunes 4 de Julio del 05, a las 11:05:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5665,4,'                              ','Lunes 4 de Julio del 05, a las 11:06:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5666,4,'                              ','Lunes 4 de Julio del 05, a las 11:06:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5667,4,'                              ','Lunes 4 de Julio del 05, a las 11:07:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5668,8,'                              ','Lunes 4 de Julio del 05, a las 11:08:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5669,4,'                              ','Lunes 4 de Julio del 05, a las 11:09:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5670,4,'                              ','Lunes 4 de Julio del 05, a las 11:09:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5671,8,'                              ','Lunes 4 de Julio del 05, a las 11:10:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5672,4,'                              ','Lunes 4 de Julio del 05, a las 11:11:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5673,4,'                              ','Lunes 4 de Julio del 05, a las 11:12:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5674,4,'                              ','Lunes 4 de Julio del 05, a las 11:13:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5675,4,'                              ','Lunes 4 de Julio del 05, a las 11:24:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5676,4,'                              ','Lunes 4 de Julio del 05, a las 11:26:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5677,4,'                              ','Lunes 4 de Julio del 05, a las 11:29:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5678,4,'                              ','Lunes 4 de Julio del 05, a las 11:54:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5679,4,'                              ','Lunes 4 de Julio del 05, a las 13:24:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5680,4,'                              ','Lunes 4 de Julio del 05, a las 13:27:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5681,4,'                              ','Lunes 4 de Julio del 05, a las 13:29:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5682,4,'                              ','Lunes 4 de Julio del 05, a las 13:35:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5683,8,'                              ','Lunes 4 de Julio del 05, a las 13:37:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5684,4,'                              ','Lunes 4 de Julio del 05, a las 13:38:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5685,8,'                              ','Lunes 4 de Julio del 05, a las 13:40:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5686,4,'                              ','Lunes 4 de Julio del 05, a las 13:41:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5687,4,'                              ','Lunes 4 de Julio del 05, a las 13:42:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5688,8,'                              ','Lunes 4 de Julio del 05, a las 13:42:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5689,4,'                              ','Lunes 4 de Julio del 05, a las 13:44:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5690,4,'                              ','Lunes 4 de Julio del 05, a las 13:45:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5691,8,'                              ','Lunes 4 de Julio del 05, a las 13:46:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5692,4,'                              ','Lunes 4 de Julio del 05, a las 13:46:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5693,4,'                              ','Lunes 4 de Julio del 05, a las 13:48:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5694,4,'                              ','Lunes 4 de Julio del 05, a las 13:48:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5695,8,'                              ','Lunes 4 de Julio del 05, a las 13:49:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5696,4,'                              ','Lunes 4 de Julio del 05, a las 13:49:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5697,4,'                              ','Lunes 4 de Julio del 05, a las 13:50:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5698,4,'                              ','Lunes 4 de Julio del 05, a las 13:52:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5699,8,'                              ','Lunes 4 de Julio del 05, a las 13:52:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5700,4,'                              ','Lunes 4 de Julio del 05, a las 13:53:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5701,4,'                              ','Lunes 4 de Julio del 05, a las 13:53:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5702,4,'                              ','Lunes 4 de Julio del 05, a las 13:55:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5703,8,'                              ','Lunes 4 de Julio del 05, a las 13:56:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5704,4,'                              ','Lunes 4 de Julio del 05, a las 13:58:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5705,4,'                              ','Lunes 4 de Julio del 05, a las 13:59:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5706,8,'                              ','Lunes 4 de Julio del 05, a las 14:00:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5707,4,'                              ','Lunes 4 de Julio del 05, a las 14:01:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5708,4,'                              ','Lunes 4 de Julio del 05, a las 14:02:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5709,4,'                              ','Lunes 4 de Julio del 05, a las 14:02:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5710,8,'                              ','Lunes 4 de Julio del 05, a las 14:04:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5711,4,'                              ','Lunes 4 de Julio del 05, a las 14:05:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5712,4,'                              ','Lunes 4 de Julio del 05, a las 14:06:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5713,8,'                              ','Lunes 4 de Julio del 05, a las 14:07:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5714,4,'                              ','Lunes 4 de Julio del 05, a las 14:08:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5715,4,'                              ','Lunes 4 de Julio del 05, a las 14:09:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5716,8,'                              ','Lunes 4 de Julio del 05, a las 14:10:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5717,4,'                              ','Lunes 4 de Julio del 05, a las 14:11:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5718,4,'                              ','Lunes 4 de Julio del 05, a las 14:13:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5719,8,'                              ','Lunes 4 de Julio del 05, a las 14:14:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5720,4,'                              ','Lunes 4 de Julio del 05, a las 14:15:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5721,4,'                              ','Lunes 4 de Julio del 05, a las 14:15:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5722,4,'                              ','Lunes 4 de Julio del 05, a las 14:16:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5723,8,'                              ','Lunes 4 de Julio del 05, a las 14:17:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5724,4,'                              ','Lunes 4 de Julio del 05, a las 14:18:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5725,4,'                              ','Lunes 4 de Julio del 05, a las 14:18:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5726,8,'                              ','Lunes 4 de Julio del 05, a las 14:20:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5727,4,'                              ','Lunes 4 de Julio del 05, a las 14:20:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5728,4,'                              ','Lunes 4 de Julio del 05, a las 14:22:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5729,4,'                              ','Lunes 4 de Julio del 05, a las 14:22:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5730,4,'                              ','Lunes 4 de Julio del 05, a las 14:22:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5731,8,'                              ','Lunes 4 de Julio del 05, a las 14:23:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5732,4,'                              ','Lunes 4 de Julio del 05, a las 14:24:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5733,4,'                              ','Lunes 4 de Julio del 05, a las 14:25:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5734,4,'                              ','Lunes 4 de Julio del 05, a las 14:25:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5735,4,'                              ','Lunes 4 de Julio del 05, a las 14:28:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5736,8,'                              ','Lunes 4 de Julio del 05, a las 14:29:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5737,4,'                              ','Lunes 4 de Julio del 05, a las 14:30:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5738,4,'                              ','Lunes 4 de Julio del 05, a las 14:30:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5739,8,'                              ','Lunes 4 de Julio del 05, a las 14:32:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5740,4,'                              ','Lunes 4 de Julio del 05, a las 14:32:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5741,4,'                              ','Lunes 4 de Julio del 05, a las 14:34:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5742,4,'                              ','Lunes 4 de Julio del 05, a las 14:34:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5743,4,'                              ','Lunes 4 de Julio del 05, a las 14:34:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5744,4,'                              ','Lunes 4 de Julio del 05, a las 14:35:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5745,8,'                              ','Lunes 4 de Julio del 05, a las 14:36:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5746,8,'                              ','Lunes 4 de Julio del 05, a las 14:36:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5747,4,'                              ','Lunes 4 de Julio del 05, a las 14:37:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5748,4,'                              ','Lunes 4 de Julio del 05, a las 14:37:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5749,8,'                              ','Lunes 4 de Julio del 05, a las 14:39:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5750,4,'                              ','Lunes 4 de Julio del 05, a las 14:39:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5751,4,'                              ','Lunes 4 de Julio del 05, a las 14:40:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5752,4,'                              ','Lunes 4 de Julio del 05, a las 14:41:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5753,8,'                              ','Lunes 4 de Julio del 05, a las 14:43:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5754,4,'                              ','Lunes 4 de Julio del 05, a las 14:46:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5755,8,'                              ','Lunes 4 de Julio del 05, a las 14:48:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5756,4,'                              ','Lunes 4 de Julio del 05, a las 14:49:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5757,8,'                              ','Lunes 4 de Julio del 05, a las 14:52:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5758,4,'                              ','Lunes 4 de Julio del 05, a las 14:54:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5759,8,'                              ','Lunes 4 de Julio del 05, a las 14:56:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5760,4,'                              ','Lunes 4 de Julio del 05, a las 14:58:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5761,8,'                              ','Lunes 4 de Julio del 05, a las 15:04:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5762,4,'                              ','Lunes 4 de Julio del 05, a las 15:06:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5763,8,'                              ','Lunes 4 de Julio del 05, a las 15:09:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5764,8,'                              ','Lunes 4 de Julio del 05, a las 15:10:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5765,4,'                              ','Lunes 4 de Julio del 05, a las 15:12:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5766,8,'                              ','Lunes 4 de Julio del 05, a las 15:14:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5767,4,'                              ','Lunes 4 de Julio del 05, a las 15:15:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5768,4,'                              ','Lunes 4 de Julio del 05, a las 15:15:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5769,8,'                              ','Lunes 4 de Julio del 05, a las 15:22:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5770,4,'                              ','Lunes 4 de Julio del 05, a las 15:59:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5771,4,'                              ','Lunes 4 de Julio del 05, a las 16:00:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5772,4,'                              ','Lunes 4 de Julio del 05, a las 16:02:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5773,4,'                              ','Lunes 4 de Julio del 05, a las 16:04:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5774,4,'                              ','Lunes 4 de Julio del 05, a las 16:05:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5775,4,'                              ','Lunes 4 de Julio del 05, a las 16:08:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5776,4,'                              ','Lunes 4 de Julio del 05, a las 16:10:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5777,4,'                              ','Lunes 4 de Julio del 05, a las 16:12:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5778,4,'                              ','Lunes 4 de Julio del 05, a las 16:14:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5779,4,'                              ','Lunes 4 de Julio del 05, a las 16:16:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5780,4,'                              ','Lunes 4 de Julio del 05, a las 16:17:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5781,4,'                              ','Lunes 4 de Julio del 05, a las 16:20:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5782,4,'                              ','Lunes 4 de Julio del 05, a las 16:22:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5783,4,'                              ','Lunes 4 de Julio del 05, a las 16:23:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5784,4,'                              ','Lunes 4 de Julio del 05, a las 16:25:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5785,4,'                              ','Lunes 4 de Julio del 05, a las 16:27:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5786,4,'                              ','Lunes 4 de Julio del 05, a las 16:28:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5787,4,'                              ','Lunes 4 de Julio del 05, a las 18:28:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5788,4,'                              ','Lunes 4 de Julio del 05, a las 18:28:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5789,4,'                              ','Lunes 4 de Julio del 05, a las 18:29:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5790,4,'                              ','Lunes 4 de Julio del 05, a las 18:30:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5791,4,'                              ','Lunes 4 de Julio del 05, a las 18:31:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5792,4,'                              ','Lunes 4 de Julio del 05, a las 18:32:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5793,4,'                              ','Lunes 4 de Julio del 05, a las 18:33:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5794,4,'                              ','Lunes 4 de Julio del 05, a las 18:34:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5795,4,'                              ','Lunes 4 de Julio del 05, a las 18:35:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5796,4,'                              ','Lunes 4 de Julio del 05, a las 18:36:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5797,4,'                              ','Lunes 4 de Julio del 05, a las 18:37:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5798,4,'                              ','Lunes 4 de Julio del 05, a las 18:39:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5799,4,'                              ','Lunes 4 de Julio del 05, a las 18:39:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5800,4,'                              ','Lunes 4 de Julio del 05, a las 18:40:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5801,4,'                              ','Lunes 4 de Julio del 05, a las 18:41:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5802,4,'                              ','Lunes 4 de Julio del 05, a las 18:41:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5803,4,'                              ','Lunes 4 de Julio del 05, a las 18:42:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5804,4,'                              ','Lunes 4 de Julio del 05, a las 18:43:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5805,4,'                              ','Lunes 4 de Julio del 05, a las 18:44:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5806,4,'                              ','Lunes 4 de Julio del 05, a las 18:44:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5807,4,'                              ','Lunes 4 de Julio del 05, a las 18:45:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5808,4,'                              ','Lunes 4 de Julio del 05, a las 18:46:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5809,4,'                              ','Lunes 4 de Julio del 05, a las 18:46:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5810,4,'                              ','Lunes 4 de Julio del 05, a las 18:47:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5811,4,'                              ','Lunes 4 de Julio del 05, a las 18:48:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5812,4,'                              ','Lunes 4 de Julio del 05, a las 18:49:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5813,4,'                              ','Lunes 4 de Julio del 05, a las 18:52:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5814,4,'                              ','Lunes 4 de Julio del 05, a las 18:52:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5815,4,'                              ','Lunes 4 de Julio del 05, a las 18:53:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5816,4,'                              ','Lunes 4 de Julio del 05, a las 18:55:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5817,4,'                              ','Lunes 4 de Julio del 05, a las 18:55:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5818,4,'                              ','Lunes 4 de Julio del 05, a las 18:56:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5819,4,'                              ','Lunes 4 de Julio del 05, a las 18:56:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5820,4,'                              ','Lunes 4 de Julio del 05, a las 18:57:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5821,4,'                              ','Lunes 4 de Julio del 05, a las 18:58:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5822,4,'                              ','Lunes 4 de Julio del 05, a las 18:59:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5823,4,'                              ','Lunes 4 de Julio del 05, a las 19:13:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5824,4,'                              ','Lunes 4 de Julio del 05, a las 19:14:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5825,4,'                              ','Lunes 4 de Julio del 05, a las 19:15:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5826,4,'                              ','Lunes 4 de Julio del 05, a las 19:29:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5827,4,'                              ','Lunes 4 de Julio del 05, a las 19:30:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5828,4,'                              ','Lunes 4 de Julio del 05, a las 19:31:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5829,4,'                              ','Lunes 4 de Julio del 05, a las 19:32:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5830,4,'                              ','Lunes 4 de Julio del 05, a las 19:33:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5831,4,'                              ','Lunes 4 de Julio del 05, a las 19:33:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5832,4,'                              ','Lunes 4 de Julio del 05, a las 19:34:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5833,4,'                              ','Lunes 4 de Julio del 05, a las 19:35:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5834,4,'                              ','Lunes 4 de Julio del 05, a las 19:35:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5835,4,'                              ','Lunes 4 de Julio del 05, a las 19:36:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5836,4,'                              ','Lunes 4 de Julio del 05, a las 19:37:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5837,4,'                              ','Martes 5 de Julio del 05, a las 10:08:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5838,4,'                              ','Martes 5 de Julio del 05, a las 10:09:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5839,4,'                              ','Martes 5 de Julio del 05, a las 10:11:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5840,4,'                              ','Martes 5 de Julio del 05, a las 10:12:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5841,4,'                              ','Martes 5 de Julio del 05, a las 10:13:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5842,4,'                              ','Martes 5 de Julio del 05, a las 10:13:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5843,4,'                              ','Martes 5 de Julio del 05, a las 10:15:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5844,4,'                              ','Martes 5 de Julio del 05, a las 10:18:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5845,4,'                              ','Martes 5 de Julio del 05, a las 10:23:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5846,4,'                              ','Martes 5 de Julio del 05, a las 10:23:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5847,4,'                              ','Martes 5 de Julio del 05, a las 10:31:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5848,4,'                              ','Martes 5 de Julio del 05, a las 10:32:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5849,4,'                              ','Martes 5 de Julio del 05, a las 10:33:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5850,4,'                              ','Martes 5 de Julio del 05, a las 10:33:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5851,4,'                              ','Martes 5 de Julio del 05, a las 10:34:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5852,4,'                              ','Martes 5 de Julio del 05, a las 10:35:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5853,4,'                              ','Martes 5 de Julio del 05, a las 11:14:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5854,4,'                              ','Martes 5 de Julio del 05, a las 11:15:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5855,4,'                              ','Martes 5 de Julio del 05, a las 11:16:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5856,4,'                              ','Martes 5 de Julio del 05, a las 11:16:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5857,4,'                              ','Martes 5 de Julio del 05, a las 11:17:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5858,4,'                              ','Martes 5 de Julio del 05, a las 11:17:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5859,4,'                              ','Martes 5 de Julio del 05, a las 11:18:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5860,4,'                              ','Martes 5 de Julio del 05, a las 11:18:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5861,4,'                              ','Martes 5 de Julio del 05, a las 11:19:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5862,4,'                              ','Martes 5 de Julio del 05, a las 11:19:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5863,4,'                              ','Martes 5 de Julio del 05, a las 11:20:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5864,4,'                              ','Martes 5 de Julio del 05, a las 11:20:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5865,4,'                              ','Martes 5 de Julio del 05, a las 11:21:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5866,4,'                              ','Martes 5 de Julio del 05, a las 11:21:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5867,4,'                              ','Martes 5 de Julio del 05, a las 11:22:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5868,4,'                              ','Martes 5 de Julio del 05, a las 11:23:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5869,4,'                              ','Martes 5 de Julio del 05, a las 11:23:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5870,4,'                              ','Martes 5 de Julio del 05, a las 11:23:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5871,4,'                              ','Martes 5 de Julio del 05, a las 11:24:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5872,4,'                              ','Martes 5 de Julio del 05, a las 11:25:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5873,4,'                              ','Martes 5 de Julio del 05, a las 11:25:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5874,4,'                              ','Martes 5 de Julio del 05, a las 11:26:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5875,4,'                              ','Martes 5 de Julio del 05, a las 11:26:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5876,4,'                              ','Martes 5 de Julio del 05, a las 11:29:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5877,4,'                              ','Martes 5 de Julio del 05, a las 11:29:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5878,4,'                              ','Martes 5 de Julio del 05, a las 11:32:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5879,4,'                              ','Martes 5 de Julio del 05, a las 11:33:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5880,4,'                              ','Martes 5 de Julio del 05, a las 11:36:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5881,4,'                              ','Martes 5 de Julio del 05, a las 11:39:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5882,4,'                              ','Martes 5 de Julio del 05, a las 11:40:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5883,4,'                              ','Martes 5 de Julio del 05, a las 11:45:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5884,4,'                              ','Martes 5 de Julio del 05, a las 11:47:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5885,4,'                              ','Martes 5 de Julio del 05, a las 11:49:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5886,4,'                              ','Martes 5 de Julio del 05, a las 11:50:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5887,4,'                              ','Martes 5 de Julio del 05, a las 11:50:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5888,4,'                              ','Martes 5 de Julio del 05, a las 11:51:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5889,4,'                              ','Martes 5 de Julio del 05, a las 11:51:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5890,4,'                              ','Martes 5 de Julio del 05, a las 11:51:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5891,4,'                              ','Martes 5 de Julio del 05, a las 11:54:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5892,4,'                              ','Martes 5 de Julio del 05, a las 11:54:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5893,4,'                              ','Martes 5 de Julio del 05, a las 11:55:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5894,4,'                              ','Martes 5 de Julio del 05, a las 11:55:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5895,4,'                              ','Martes 5 de Julio del 05, a las 11:55:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5896,4,'                              ','Martes 5 de Julio del 05, a las 11:56:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5897,4,'                              ','Martes 5 de Julio del 05, a las 11:56:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5898,4,'                              ','Martes 5 de Julio del 05, a las 11:57:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5899,4,'                              ','Martes 5 de Julio del 05, a las 11:59:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5900,4,'                              ','Martes 5 de Julio del 05, a las 11:59:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5901,4,'                              ','Martes 5 de Julio del 05, a las 12:00:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5902,4,'                              ','Martes 5 de Julio del 05, a las 12:00:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5903,4,'                              ','Martes 5 de Julio del 05, a las 12:02:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5904,4,'                              ','Martes 5 de Julio del 05, a las 12:13:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5905,4,'                              ','Martes 5 de Julio del 05, a las 12:20:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5906,4,'                              ','Martes 5 de Julio del 05, a las 12:22:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5907,4,'                              ','Martes 5 de Julio del 05, a las 12:22:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5908,4,'                              ','Martes 5 de Julio del 05, a las 12:23:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5909,4,'                              ','Martes 5 de Julio del 05, a las 12:24:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5910,4,'                              ','Martes 5 de Julio del 05, a las 12:26:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5911,4,'                              ','Martes 5 de Julio del 05, a las 12:27:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5912,4,'                              ','Martes 5 de Julio del 05, a las 12:27:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5913,4,'                              ','Martes 5 de Julio del 05, a las 12:28:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5914,4,'                              ','Martes 5 de Julio del 05, a las 12:28:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5915,4,'                              ','Martes 5 de Julio del 05, a las 12:29:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5916,4,'                              ','Martes 5 de Julio del 05, a las 12:30:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5917,4,'                              ','Martes 5 de Julio del 05, a las 12:31:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5918,4,'                              ','Martes 5 de Julio del 05, a las 12:31:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5919,4,'                              ','Martes 5 de Julio del 05, a las 12:32:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5920,4,'                              ','Martes 5 de Julio del 05, a las 12:32:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5921,4,'                              ','Martes 5 de Julio del 05, a las 12:33:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5922,4,'                              ','Martes 5 de Julio del 05, a las 12:33:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5923,4,'                              ','Martes 5 de Julio del 05, a las 12:34:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5924,4,'                              ','Martes 5 de Julio del 05, a las 12:34:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5925,4,'                              ','Martes 5 de Julio del 05, a las 12:35:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5926,4,'                              ','Martes 5 de Julio del 05, a las 12:35:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5927,4,'                              ','Martes 5 de Julio del 05, a las 12:36:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5928,4,'                              ','Martes 5 de Julio del 05, a las 12:36:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5929,4,'                              ','Martes 5 de Julio del 05, a las 12:37:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5930,4,'                              ','Martes 5 de Julio del 05, a las 12:37:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5931,4,'                              ','Martes 5 de Julio del 05, a las 12:38:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5932,4,'                              ','Martes 5 de Julio del 05, a las 12:39:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5933,4,'                              ','Martes 5 de Julio del 05, a las 12:39:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5934,4,'                              ','Martes 5 de Julio del 05, a las 12:39:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5935,4,'                              ','Martes 5 de Julio del 05, a las 12:41:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5936,4,'                              ','Martes 5 de Julio del 05, a las 12:43:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5937,4,'                              ','Martes 5 de Julio del 05, a las 12:44:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5938,4,'                              ','Martes 5 de Julio del 05, a las 12:45:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5939,4,'                              ','Martes 5 de Julio del 05, a las 12:47:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5940,4,'                              ','Martes 5 de Julio del 05, a las 12:48:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5941,4,'                              ','Martes 5 de Julio del 05, a las 12:48:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5942,4,'                              ','Martes 5 de Julio del 05, a las 12:50:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5943,4,'                              ','Martes 5 de Julio del 05, a las 12:52:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5944,4,'                              ','Martes 5 de Julio del 05, a las 12:52:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5945,4,'                              ','Martes 5 de Julio del 05, a las 12:53:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5946,4,'                              ','Martes 5 de Julio del 05, a las 12:54:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5947,4,'                              ','Martes 5 de Julio del 05, a las 12:55:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5948,4,'                              ','Martes 5 de Julio del 05, a las 12:56:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5949,4,'                              ','Martes 5 de Julio del 05, a las 12:56:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5950,4,'                              ','Martes 5 de Julio del 05, a las 12:57:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5951,4,'                              ','Martes 5 de Julio del 05, a las 12:58:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5952,4,'                              ','Martes 5 de Julio del 05, a las 12:59:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5953,4,'                              ','Martes 5 de Julio del 05, a las 13:00:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5954,4,'                              ','Martes 5 de Julio del 05, a las 13:01:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5955,4,'                              ','Martes 5 de Julio del 05, a las 13:01:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5956,4,'                              ','Martes 5 de Julio del 05, a las 13:04:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5957,4,'                              ','Martes 5 de Julio del 05, a las 13:06:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5958,4,'                              ','Martes 5 de Julio del 05, a las 13:06:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5959,4,'                              ','Martes 5 de Julio del 05, a las 13:07:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5960,4,'                              ','Martes 5 de Julio del 05, a las 13:08:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5961,4,'                              ','Martes 5 de Julio del 05, a las 13:08:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5962,4,'                              ','Martes 5 de Julio del 05, a las 13:09:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5963,4,'                              ','Martes 5 de Julio del 05, a las 13:10:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5964,4,'                              ','Martes 5 de Julio del 05, a las 13:11:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5965,4,'                              ','Martes 5 de Julio del 05, a las 13:12:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5966,4,'                              ','Martes 5 de Julio del 05, a las 13:27:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5967,4,'                              ','Martes 5 de Julio del 05, a las 13:38:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5968,4,'                              ','Martes 5 de Julio del 05, a las 13:40:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5969,4,'                              ','Martes 5 de Julio del 05, a las 13:42:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5970,4,'                              ','Martes 5 de Julio del 05, a las 13:45:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5971,4,'                              ','Martes 5 de Julio del 05, a las 13:54:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5972,4,'                              ','Martes 5 de Julio del 05, a las 13:59:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5973,4,'                              ','Martes 5 de Julio del 05, a las 14:05:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5974,6,'                              ','Martes 5 de Julio del 05, a las 14:52:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5975,6,'                              ','Martes 5 de Julio del 05, a las 14:56:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5976,6,'                              ','Martes 5 de Julio del 05, a las 14:57:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5977,6,'                              ','Martes 5 de Julio del 05, a las 15:03:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5978,6,'                              ','Martes 5 de Julio del 05, a las 15:04:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5979,6,'                              ','Martes 5 de Julio del 05, a las 15:06:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5980,6,'                              ','Martes 5 de Julio del 05, a las 15:08:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5981,6,'                              ','Martes 5 de Julio del 05, a las 15:09:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5982,6,'                              ','Martes 5 de Julio del 05, a las 15:10:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5983,6,'                              ','Martes 5 de Julio del 05, a las 15:17:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5984,4,'                              ','Martes 5 de Julio del 05, a las 15:48:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5985,4,'                              ','Martes 5 de Julio del 05, a las 15:49:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5986,4,'                              ','Martes 5 de Julio del 05, a las 15:54:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5987,4,'                              ','Martes 5 de Julio del 05, a las 15:58:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5988,4,'                              ','Mircoles 6 de Julio del 05, a las 09:30:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5989,4,'                              ','Mircoles 6 de Julio del 05, a las 09:31:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5990,4,'                              ','Mircoles 6 de Julio del 05, a las 09:31:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5991,4,'                              ','Mircoles 6 de Julio del 05, a las 09:31:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5992,4,'                              ','Mircoles 6 de Julio del 05, a las 09:32:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5993,4,'                              ','Mircoles 6 de Julio del 05, a las 09:32:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5994,4,'                              ','Mircoles 6 de Julio del 05, a las 09:33:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5995,4,'                              ','Mircoles 6 de Julio del 05, a las 09:33:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5996,4,'                              ','Mircoles 6 de Julio del 05, a las 09:33:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5997,4,'                              ','Mircoles 6 de Julio del 05, a las 09:34:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5998,4,'                              ','Mircoles 6 de Julio del 05, a las 09:34:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (5999,4,'                              ','Mircoles 6 de Julio del 05, a las 09:35:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6000,4,'                              ','Mircoles 6 de Julio del 05, a las 09:35:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6001,4,'                              ','Mircoles 6 de Julio del 05, a las 09:35:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6002,4,'                              ','Mircoles 6 de Julio del 05, a las 09:36:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6003,4,'                              ','Mircoles 6 de Julio del 05, a las 09:36:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6004,4,'                              ','Mircoles 6 de Julio del 05, a las 09:45:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6005,4,'                              ','Mircoles 6 de Julio del 05, a las 09:45:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6006,4,'                              ','Mircoles 6 de Julio del 05, a las 09:45:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6007,4,'                              ','Mircoles 6 de Julio del 05, a las 09:46:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6008,4,'                              ','Mircoles 6 de Julio del 05, a las 09:46:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6009,4,'                              ','Mircoles 6 de Julio del 05, a las 09:46:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6010,4,'                              ','Mircoles 6 de Julio del 05, a las 09:47:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6011,4,'                              ','Mircoles 6 de Julio del 05, a las 09:47:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6012,4,'                              ','Mircoles 6 de Julio del 05, a las 09:48:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6013,4,'                              ','Mircoles 6 de Julio del 05, a las 09:49:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6014,4,'                              ','Mircoles 6 de Julio del 05, a las 09:50:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6015,4,'                              ','Mircoles 6 de Julio del 05, a las 09:50:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6016,4,'                              ','Mircoles 6 de Julio del 05, a las 09:51:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6017,4,'                              ','Mircoles 6 de Julio del 05, a las 09:52:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6018,4,'                              ','Mircoles 6 de Julio del 05, a las 09:53:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6019,4,'                              ','Mircoles 6 de Julio del 05, a las 09:55:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6020,4,'                              ','Mircoles 6 de Julio del 05, a las 09:56:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6021,4,'                              ','Mircoles 6 de Julio del 05, a las 10:58:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6022,4,'                              ','Mircoles 6 de Julio del 05, a las 11:00:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6023,4,'                              ','Mircoles 6 de Julio del 05, a las 11:02:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6024,4,'                              ','Mircoles 6 de Julio del 05, a las 11:02:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6025,4,'                              ','Mircoles 6 de Julio del 05, a las 11:19:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6026,4,'                              ','Mircoles 6 de Julio del 05, a las 11:19:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6027,4,'                              ','Mircoles 6 de Julio del 05, a las 11:20:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6028,4,'                              ','Mircoles 6 de Julio del 05, a las 11:25:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6029,4,'                              ','Mircoles 6 de Julio del 05, a las 11:26:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6030,4,'                              ','Mircoles 6 de Julio del 05, a las 11:26:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6031,4,'                              ','Mircoles 6 de Julio del 05, a las 11:27:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6032,4,'                              ','Mircoles 6 de Julio del 05, a las 11:28:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6033,4,'                              ','Mircoles 6 de Julio del 05, a las 11:29:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6034,4,'                              ','Mircoles 6 de Julio del 05, a las 11:30:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6035,6,'                              ','Mircoles 6 de Julio del 05, a las 11:48:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6036,6,'                              ','Mircoles 6 de Julio del 05, a las 11:53:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6037,11,'                              ','Mircoles 6 de Julio del 05, a las 11:54:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6038,8,'                              ','Mircoles 6 de Julio del 05, a las 12:00:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6039,6,'                              ','Mircoles 6 de Julio del 05, a las 12:07:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6040,53,'                              ','Mircoles 6 de Julio del 05, a las 12:08:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6041,4,'                              ','Mircoles 6 de Julio del 05, a las 13:37:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6042,4,'                              ','Mircoles 6 de Julio del 05, a las 14:53:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6043,4,'                              ','Mircoles 6 de Julio del 05, a las 14:55:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6044,4,'                              ','Mircoles 6 de Julio del 05, a las 14:56:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6045,4,'                              ','Mircoles 6 de Julio del 05, a las 15:02:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6046,4,'                              ','Mircoles 6 de Julio del 05, a las 15:31:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6047,4,'                              ','Mircoles 6 de Julio del 05, a las 15:38:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6048,6,'                              ','Jueves 7 de Julio del 05, a las 17:47:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6049,6,'                              ','Jueves 7 de Julio del 05, a las 17:49:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6050,53,'                              ','Viernes 12 de Agosto del 05, a las 11:23:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6051,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:30:12  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6052,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:33:17  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6053,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:34:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6054,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:36:50  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6055,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:38:31  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6056,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:47:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6057,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:54:16  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6058,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:55:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6059,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:56:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6060,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:57:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6061,6,'                              ','Mircoles 7 de Septiembre del 05, a las 15:58:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6062,6,'                              ','Mircoles 7 de Septiembre del 05, a las 17:25:39  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6063,6,'                              ','Mircoles 7 de Septiembre del 05, a las 17:26:39  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6064,6,'                              ','Mircoles 7 de Septiembre del 05, a las 17:27:39  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6065,6,'                              ','Jueves 8 de Septiembre del 05, a las 10:25:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6066,11,'                              ','Viernes 9 de Septiembre del 05, a las 11:32:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6067,11,'                              ','Viernes 9 de Septiembre del 05, a las 11:33:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6068,11,'                              ','Viernes 9 de Septiembre del 05, a las 11:34:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6069,11,'                              ','Viernes 9 de Septiembre del 05, a las 11:34:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6070,11,'                              ','Viernes 9 de Septiembre del 05, a las 18:49:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6071,11,'                              ','Viernes 9 de Septiembre del 05, a las 18:52:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6072,11,'                              ','Viernes 9 de Septiembre del 05, a las 18:52:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6073,11,'                              ','Viernes 9 de Septiembre del 05, a las 18:53:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6074,53,'                              ','Viernes 9 de Septiembre del 05, a las 18:55:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6075,6,'                              ','Viernes 9 de Septiembre del 05, a las 18:57:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6076,6,'                              ','Viernes 9 de Septiembre del 05, a las 18:58:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6077,11,'                              ','Viernes 9 de Septiembre del 05, a las 19:02:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6078,11,'                              ','Viernes 9 de Septiembre del 05, a las 19:03:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6079,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:31:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6080,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:34:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6081,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:37:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6082,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:38:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6083,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:38:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6084,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:39:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6085,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:40:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6086,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:41:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6087,6,'                              ','Lunes 12 de Septiembre del 05, a las 17:43:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6088,11,'                              ','Jueves 16 de Febrero del 06, a las 11:50:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6089,11,'                              ','Jueves 16 de Febrero del 06, a las 11:52:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6090,11,'                              ','Jueves 16 de Febrero del 06, a las 11:52:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6091,11,'                              ','Jueves 16 de Febrero del 06, a las 11:55:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6092,11,'                              ','Jueves 16 de Febrero del 06, a las 12:03:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6093,11,'                              ','Jueves 16 de Febrero del 06, a las 12:04:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6094,11,'                              ','Jueves 16 de Febrero del 06, a las 12:05:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6095,11,'                              ','Jueves 16 de Febrero del 06, a las 12:06:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6096,11,'                              ','Jueves 16 de Febrero del 06, a las 12:07:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6097,11,'                              ','Jueves 16 de Febrero del 06, a las 12:14:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6098,11,'                              ','Jueves 16 de Febrero del 06, a las 12:22:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6099,11,'                              ','Jueves 16 de Febrero del 06, a las 12:24:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6100,11,'                              ','Jueves 16 de Febrero del 06, a las 12:25:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6101,11,'                              ','Jueves 16 de Febrero del 06, a las 12:26:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6102,11,'                              ','Jueves 16 de Febrero del 06, a las 12:27:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6103,11,'                              ','Jueves 16 de Febrero del 06, a las 12:28:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6104,11,'                              ','Jueves 16 de Febrero del 06, a las 12:29:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6105,11,'                              ','Jueves 16 de Febrero del 06, a las 12:30:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6106,11,'                              ','Jueves 16 de Febrero del 06, a las 12:31:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6107,11,'                              ','Jueves 16 de Febrero del 06, a las 12:32:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6108,11,'                              ','Jueves 16 de Febrero del 06, a las 12:33:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6109,11,'                              ','Jueves 16 de Febrero del 06, a las 12:33:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6110,11,'                              ','Jueves 16 de Febrero del 06, a las 12:34:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6111,11,'                              ','Jueves 16 de Febrero del 06, a las 12:34:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6112,11,'                              ','Jueves 16 de Febrero del 06, a las 12:35:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6113,11,'                              ','Jueves 16 de Febrero del 06, a las 12:36:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6114,11,'                              ','Jueves 16 de Febrero del 06, a las 12:38:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6115,11,'                              ','Jueves 16 de Febrero del 06, a las 12:39:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6116,6,'                              ','Jueves 16 de Febrero del 06, a las 19:38:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6117,6,'                              ','Jueves 16 de Febrero del 06, a las 19:39:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6118,6,'                              ','Jueves 16 de Febrero del 06, a las 19:40:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6119,3,'                              ','Martes 21 de Febrero del 06, a las 12:38:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6120,4,'                              ','Martes 21 de Febrero del 06, a las 12:39:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6121,4,'                              ','Martes 21 de Febrero del 06, a las 13:00:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6122,4,'                              ','Martes 21 de Febrero del 06, a las 13:25:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6123,3,'                              ','Martes 21 de Febrero del 06, a las 13:26:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6124,11,'                              ','Martes 21 de Febrero del 06, a las 14:17:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6125,11,'                              ','Martes 21 de Febrero del 06, a las 14:52:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6126,11,'                              ','Martes 21 de Febrero del 06, a las 14:54:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6127,11,'                              ','Martes 21 de Febrero del 06, a las 14:56:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6128,11,'                              ','Martes 21 de Febrero del 06, a las 14:56:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6129,11,'                              ','Martes 21 de Febrero del 06, a las 14:57:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6130,6,'                              ','Martes 21 de Febrero del 06, a las 15:31:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6131,4,'                              ','Martes 21 de Febrero del 06, a las 15:33:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6132,4,'                              ','Martes 21 de Febrero del 06, a las 15:34:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6133,4,'                              ','Martes 21 de Febrero del 06, a las 15:35:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6134,6,'                              ','Martes 21 de Febrero del 06, a las 15:37:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6135,6,'                              ','Martes 21 de Febrero del 06, a las 15:40:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6136,6,'                              ','Martes 21 de Febrero del 06, a las 15:40:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6137,4,'                              ','Martes 21 de Febrero del 06, a las 16:29:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6138,6,'                              ','Martes 21 de Febrero del 06, a las 18:04:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6139,53,'                              ','Martes 21 de Febrero del 06, a las 18:12:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6140,53,'                              ','Martes 21 de Febrero del 06, a las 18:13:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6141,53,'                              ','Martes 21 de Febrero del 06, a las 18:15:16       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6142,11,'                              ','Martes 21 de Febrero del 06, a las 18:18:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6143,11,'                              ','Martes 21 de Febrero del 06, a las 18:19:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6144,11,'                              ','Martes 21 de Febrero del 06, a las 18:21:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6145,11,'                              ','Martes 21 de Febrero del 06, a las 18:22:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6146,11,'                              ','Martes 21 de Febrero del 06, a las 18:24:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6147,11,'                              ','Martes 21 de Febrero del 06, a las 18:26:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6148,11,'                              ','Martes 21 de Febrero del 06, a las 18:27:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6149,11,'                              ','Martes 21 de Febrero del 06, a las 18:31:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6150,11,'                              ','Martes 21 de Febrero del 06, a las 18:34:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6151,11,'                              ','Martes 21 de Febrero del 06, a las 18:35:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6152,6,'                              ','Martes 21 de Febrero del 06, a las 18:44:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6153,11,'                              ','Martes 21 de Febrero del 06, a las 18:47:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6154,11,'                              ','Martes 21 de Febrero del 06, a las 18:50:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6155,6,'                              ','Martes 21 de Febrero del 06, a las 18:52:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6156,11,'                              ','Martes 21 de Febrero del 06, a las 18:54:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6157,11,'                              ','Martes 21 de Febrero del 06, a las 18:56:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6158,11,'                              ','Martes 21 de Febrero del 06, a las 18:58:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6159,11,'                              ','Martes 21 de Febrero del 06, a las 21:04:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6160,11,'                              ','Martes 21 de Febrero del 06, a las 21:06:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6161,11,'                              ','Martes 21 de Febrero del 06, a las 21:07:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6162,11,'                              ','Martes 21 de Febrero del 06, a las 21:07:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6163,6,'                              ','Martes 21 de Febrero del 06, a las 21:09:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6164,11,'                              ','Martes 21 de Febrero del 06, a las 21:12:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6165,4,'                              ','Martes 21 de Febrero del 06, a las 21:13:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6166,4,'                              ','Martes 21 de Febrero del 06, a las 21:13:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6167,4,'                              ','Martes 21 de Febrero del 06, a las 21:14:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6168,4,'                              ','Martes 21 de Febrero del 06, a las 21:15:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6169,4,'                              ','Martes 21 de Febrero del 06, a las 21:15:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6170,6,'                              ','Martes 21 de Febrero del 06, a las 21:19:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6171,11,'                              ','Martes 21 de Febrero del 06, a las 21:19:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6172,11,'                              ','Martes 21 de Febrero del 06, a las 21:20:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6173,6,'                              ','Martes 21 de Febrero del 06, a las 21:22:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6174,11,'                              ','Martes 21 de Febrero del 06, a las 21:24:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6175,11,'                              ','Martes 21 de Febrero del 06, a las 21:25:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6176,11,'                              ','Martes 21 de Febrero del 06, a las 21:26:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6177,3,'                              ','Martes 21 de Febrero del 06, a las 21:27:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6178,3,'                              ','Martes 21 de Febrero del 06, a las 21:28:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6179,4,'                              ','Martes 21 de Febrero del 06, a las 21:29:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6180,4,'                              ','Martes 21 de Febrero del 06, a las 21:32:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6181,53,'                              ','Martes 21 de Febrero del 06, a las 21:34:03       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6182,53,'                              ','Martes 21 de Febrero del 06, a las 21:34:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6183,6,'                              ','Martes 21 de Febrero del 06, a las 21:35:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6184,11,'                              ','Martes 21 de Febrero del 06, a las 21:39:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6185,6,'                              ','Martes 21 de Febrero del 06, a las 21:41:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6186,11,'                              ','Martes 21 de Febrero del 06, a las 21:42:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6187,53,'                              ','Martes 21 de Febrero del 06, a las 21:45:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6188,11,'                              ','Martes 21 de Febrero del 06, a las 21:50:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6189,11,'                              ','Martes 21 de Febrero del 06, a las 21:53:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6190,11,'                              ','Martes 21 de Febrero del 06, a las 21:56:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6191,11,'                              ','Martes 21 de Febrero del 06, a las 21:59:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6192,53,'                              ','Mircoles 22 de Febrero del 06, a las 09:08:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6193,11,'                              ','Mircoles 22 de Febrero del 06, a las 09:22:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6194,53,'                              ','Mircoles 22 de Febrero del 06, a las 09:25:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6195,11,'                              ','Mircoles 22 de Febrero del 06, a las 09:26:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6196,11,'                              ','Mircoles 22 de Febrero del 06, a las 09:27:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6197,4,'                              ','Mircoles 22 de Febrero del 06, a las 09:40:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6198,53,'                              ','Mircoles 22 de Febrero del 06, a las 09:43:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6199,53,'                              ','Mircoles 22 de Febrero del 06, a las 09:45:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6200,53,'                              ','Mircoles 22 de Febrero del 06, a las 09:46:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6201,4,'                              ','Mircoles 22 de Febrero del 06, a las 09:48:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6202,11,'                              ','Mircoles 22 de Febrero del 06, a las 09:50:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6203,11,'                              ','Mircoles 22 de Febrero del 06, a las 09:51:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6204,11,'                              ','Mircoles 22 de Febrero del 06, a las 09:58:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6205,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:00:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6206,4,'                              ','Mircoles 22 de Febrero del 06, a las 10:14:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6207,4,'                              ','Mircoles 22 de Febrero del 06, a las 10:15:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6208,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:27:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6209,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:29:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6210,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:30:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6211,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:38:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6212,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:39:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6213,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:41:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6214,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:42:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6215,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:46:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6216,11,'                              ','Mircoles 22 de Febrero del 06, a las 10:47:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6217,11,'                              ','Mircoles 22 de Febrero del 06, a las 11:12:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6218,11,'                              ','Mircoles 22 de Febrero del 06, a las 12:08:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6219,11,'                              ','Mircoles 22 de Febrero del 06, a las 12:10:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6220,11,'                              ','Mircoles 22 de Febrero del 06, a las 12:11:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6221,11,'                              ','Mircoles 22 de Febrero del 06, a las 12:13:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6222,11,'                              ','Mircoles 22 de Febrero del 06, a las 12:16:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6223,11,'                              ','Mircoles 22 de Febrero del 06, a las 12:57:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6224,53,'                              ','Mircoles 22 de Febrero del 06, a las 12:59:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6225,53,'                              ','Mircoles 22 de Febrero del 06, a las 13:01:00    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6226,8,'                              ','Mircoles 22 de Febrero del 06, a las 13:01:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6227,8,'                              ','Mircoles 22 de Febrero del 06, a las 13:02:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6228,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:04:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6229,8,'                              ','Mircoles 22 de Febrero del 06, a las 13:05:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6230,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:06:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6231,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:08:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6232,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:08:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6233,53,'                              ','Mircoles 22 de Febrero del 06, a las 13:10:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6234,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:13:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6235,53,'                              ','Mircoles 22 de Febrero del 06, a las 13:15:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6236,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:16:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6237,6,'                              ','Mircoles 22 de Febrero del 06, a las 13:23:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6238,6,'                              ','Mircoles 22 de Febrero del 06, a las 13:25:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6239,6,'                              ','Mircoles 22 de Febrero del 06, a las 13:32:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6240,6,'                              ','Mircoles 22 de Febrero del 06, a las 13:34:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6241,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:35:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6242,6,'                              ','Mircoles 22 de Febrero del 06, a las 13:38:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6243,6,'                              ','Mircoles 22 de Febrero del 06, a las 13:39:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6244,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:41:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6245,53,'                              ','Mircoles 22 de Febrero del 06, a las 13:49:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6246,11,'                              ','Mircoles 22 de Febrero del 06, a las 13:51:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6247,53,'                              ','Mircoles 22 de Febrero del 06, a las 13:59:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6248,53,'                              ','Mircoles 22 de Febrero del 06, a las 13:59:50    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6249,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:00:55    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6250,53,'                              ','Mircoles 22 de Febrero del 06, a las 14:04:11    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6251,53,'                              ','Mircoles 22 de Febrero del 06, a las 14:05:40    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6252,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:07:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6253,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:08:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6254,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:09:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6255,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:10:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6256,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:10:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6257,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:13:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6258,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:13:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6259,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:16:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6260,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:17:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6261,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:18:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6262,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:19:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6263,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:21:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6264,53,'                              ','Mircoles 22 de Febrero del 06, a las 14:24:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6265,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:31:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6266,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:32:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6267,6,'                              ','Mircoles 22 de Febrero del 06, a las 14:35:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6268,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:36:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6269,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:37:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6270,8,'                              ','Mircoles 22 de Febrero del 06, a las 14:37:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6271,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:39:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6272,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:39:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6273,6,'                              ','Mircoles 22 de Febrero del 06, a las 14:50:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6274,53,'                              ','Mircoles 22 de Febrero del 06, a las 14:51:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6275,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:54:46    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6276,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:55:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6277,6,'                              ','Mircoles 22 de Febrero del 06, a las 14:57:17    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6278,11,'                              ','Mircoles 22 de Febrero del 06, a las 14:57:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6279,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:10:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6280,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:12:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6281,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:13:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6282,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:14:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6283,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:15:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6284,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:16:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6285,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:20:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6286,53,'                              ','Mircoles 22 de Febrero del 06, a las 15:21:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6287,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:22:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6288,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:24:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6289,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:25:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6290,53,'                              ','Mircoles 22 de Febrero del 06, a las 15:26:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6291,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:27:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6292,53,'                              ','Mircoles 22 de Febrero del 06, a las 15:29:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6293,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:30:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6294,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:32:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6295,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:33:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6296,53,'                              ','Mircoles 22 de Febrero del 06, a las 15:33:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6297,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:34:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6298,11,'                              ','Mircoles 22 de Febrero del 06, a las 15:37:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6299,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:43:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6300,6,'                              ','Mircoles 22 de Febrero del 06, a las 15:43:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6301,6,'                              ','Mircoles 22 de Febrero del 06, a las 16:15:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6302,11,'                              ','Mircoles 22 de Febrero del 06, a las 16:16:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6303,11,'                              ','Mircoles 22 de Febrero del 06, a las 16:16:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6304,11,'                              ','Mircoles 22 de Febrero del 06, a las 16:17:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6305,11,'                              ','Jueves 23 de Febrero del 06, a las 20:17:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6306,11,'                              ','Jueves 23 de Febrero del 06, a las 20:20:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6307,11,'                              ','Jueves 23 de Febrero del 06, a las 20:21:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6308,11,'                              ','Jueves 23 de Febrero del 06, a las 20:22:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6309,11,'                              ','Jueves 23 de Febrero del 06, a las 20:24:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6310,11,'                              ','Jueves 23 de Febrero del 06, a las 20:32:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6311,6,'                              ','Jueves 23 de Febrero del 06, a las 20:41:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6312,53,'                              ','Jueves 23 de Febrero del 06, a las 20:45:22       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6313,11,'                              ','Jueves 23 de Febrero del 06, a las 20:47:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6314,11,'                              ','Jueves 23 de Febrero del 06, a las 20:48:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6315,11,'                              ','Jueves 23 de Febrero del 06, a las 20:50:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6316,6,'                              ','Jueves 23 de Febrero del 06, a las 20:58:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6317,6,'                              ','Jueves 23 de Febrero del 06, a las 20:59:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6318,11,'                              ','Jueves 23 de Febrero del 06, a las 21:00:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6319,53,'                              ','Jueves 23 de Febrero del 06, a las 21:02:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6320,53,'                              ','Jueves 23 de Febrero del 06, a las 21:05:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6321,11,'                              ','Jueves 23 de Febrero del 06, a las 21:05:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6322,11,'                              ','Jueves 23 de Febrero del 06, a las 21:07:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6323,6,'                              ','Jueves 23 de Febrero del 06, a las 21:10:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6324,11,'                              ','Jueves 23 de Febrero del 06, a las 21:12:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6325,53,'                              ','Jueves 23 de Febrero del 06, a las 21:15:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6326,53,'                              ','Jueves 23 de Febrero del 06, a las 21:16:23       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6327,3,'                              ','Jueves 23 de Febrero del 06, a las 21:19:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6328,6,'                              ','Jueves 23 de Febrero del 06, a las 21:21:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6329,11,'                              ','Jueves 23 de Febrero del 06, a las 21:24:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6330,53,'                              ','Jueves 23 de Febrero del 06, a las 21:26:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6331,53,'                              ','Jueves 23 de Febrero del 06, a las 21:27:26       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6332,6,'                              ','Jueves 23 de Febrero del 06, a las 21:30:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6333,6,'                              ','Jueves 23 de Febrero del 06, a las 21:30:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6334,6,'                              ','Jueves 23 de Febrero del 06, a las 21:31:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6335,6,'                              ','Jueves 23 de Febrero del 06, a las 21:32:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6336,6,'                              ','Jueves 23 de Febrero del 06, a las 21:33:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6337,6,'                              ','Jueves 23 de Febrero del 06, a las 21:42:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6338,6,'                              ','Jueves 23 de Febrero del 06, a las 21:46:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6339,11,'                              ','Jueves 23 de Febrero del 06, a las 21:47:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6340,53,'                              ','Jueves 23 de Febrero del 06, a las 21:49:46       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6341,53,'                              ','Jueves 23 de Febrero del 06, a las 21:51:14       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6342,6,'                              ','Jueves 23 de Febrero del 06, a las 21:53:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6343,6,'                              ','Jueves 23 de Febrero del 06, a las 21:54:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6344,11,'                              ','Lunes 27 de Febrero del 06, a las 12:11:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6345,6,'                              ','Lunes 27 de Febrero del 06, a las 12:12:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6346,11,'                              ','Lunes 27 de Febrero del 06, a las 12:16:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6347,6,'                              ','Lunes 27 de Febrero del 06, a las 12:18:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6348,6,'                              ','Lunes 27 de Febrero del 06, a las 12:18:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6349,6,'                              ','Lunes 27 de Febrero del 06, a las 12:19:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6350,6,'                              ','Lunes 27 de Febrero del 06, a las 12:20:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6351,11,'                              ','Lunes 27 de Febrero del 06, a las 12:25:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6352,6,'                              ','Lunes 27 de Febrero del 06, a las 12:28:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6353,11,'                              ','Lunes 27 de Febrero del 06, a las 12:56:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6354,6,'                              ','Lunes 27 de Febrero del 06, a las 12:57:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6355,4,'                              ','Lunes 27 de Febrero del 06, a las 12:58:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6356,4,'                              ','Lunes 27 de Febrero del 06, a las 12:58:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6357,6,'                              ','Lunes 27 de Febrero del 06, a las 13:10:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6358,6,'                              ','Lunes 27 de Febrero del 06, a las 13:18:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6359,53,'                              ','Lunes 27 de Febrero del 06, a las 13:18:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6360,11,'                              ','Lunes 27 de Febrero del 06, a las 13:22:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6361,6,'                              ','Lunes 27 de Febrero del 06, a las 13:40:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6362,11,'                              ','Lunes 27 de Febrero del 06, a las 13:41:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6363,6,'                              ','Lunes 27 de Febrero del 06, a las 13:42:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6364,11,'                              ','Lunes 27 de Febrero del 06, a las 13:43:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6365,6,'                              ','Lunes 27 de Febrero del 06, a las 13:46:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6366,6,'                              ','Lunes 27 de Febrero del 06, a las 13:47:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6367,11,'                              ','Lunes 27 de Febrero del 06, a las 13:49:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6368,11,'                              ','Lunes 27 de Febrero del 06, a las 13:49:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6369,6,'                              ','Lunes 27 de Febrero del 06, a las 13:52:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6370,4,'                              ','Lunes 27 de Febrero del 06, a las 13:54:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6371,4,'                              ','Lunes 27 de Febrero del 06, a las 13:58:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6372,53,'                              ','Lunes 27 de Febrero del 06, a las 14:16:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6373,53,'                              ','Lunes 27 de Febrero del 06, a las 14:16:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6374,53,'                              ','Lunes 27 de Febrero del 06, a las 14:17:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6375,6,'                              ','Lunes 27 de Febrero del 06, a las 14:23:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6376,6,'                              ','Lunes 27 de Febrero del 06, a las 14:37:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6377,6,'                              ','Lunes 27 de Febrero del 06, a las 14:56:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6378,6,'                              ','Lunes 27 de Febrero del 06, a las 15:58:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6379,11,'                              ','Lunes 27 de Febrero del 06, a las 16:03:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6380,11,'                              ','Lunes 27 de Febrero del 06, a las 16:05:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6381,11,'                              ','Lunes 27 de Febrero del 06, a las 16:08:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6382,11,'                              ','Lunes 27 de Febrero del 06, a las 16:08:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6383,11,'                              ','Lunes 27 de Febrero del 06, a las 16:43:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6384,11,'                              ','Lunes 27 de Febrero del 06, a las 16:47:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6385,6,'                              ','Lunes 27 de Febrero del 06, a las 16:49:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6386,53,'                              ','Martes 28 de Febrero del 06, a las 10:05:58       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6387,11,'                              ','Martes 28 de Febrero del 06, a las 10:11:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6388,11,'                              ','Martes 28 de Febrero del 06, a las 10:14:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6389,11,'                              ','Martes 28 de Febrero del 06, a las 10:14:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6390,11,'                              ','Martes 28 de Febrero del 06, a las 10:25:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6391,11,'                              ','Martes 28 de Febrero del 06, a las 11:46:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6392,11,'                              ','Martes 28 de Febrero del 06, a las 11:47:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6393,11,'                              ','Martes 28 de Febrero del 06, a las 11:49:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6394,11,'                              ','Martes 28 de Febrero del 06, a las 12:56:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6395,53,'                              ','Martes 28 de Febrero del 06, a las 12:59:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6396,11,'                              ','Martes 28 de Febrero del 06, a las 13:02:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6397,11,'                              ','Martes 28 de Febrero del 06, a las 13:06:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6398,11,'                              ','Martes 28 de Febrero del 06, a las 13:09:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6399,11,'                              ','Martes 28 de Febrero del 06, a las 13:13:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6400,6,'                              ','Martes 28 de Febrero del 06, a las 13:16:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6401,6,'                              ','Martes 28 de Febrero del 06, a las 13:17:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6402,53,'                              ','Martes 28 de Febrero del 06, a las 13:23:07       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6403,53,'                              ','Martes 28 de Febrero del 06, a las 13:23:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6404,53,'                              ','Martes 28 de Febrero del 06, a las 13:29:53       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6405,53,'                              ','Martes 28 de Febrero del 06, a las 13:30:44       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6406,53,'                              ','Martes 28 de Febrero del 06, a las 13:50:52       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6407,11,'                              ','Martes 28 de Febrero del 06, a las 13:57:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6408,11,'                              ','Martes 28 de Febrero del 06, a las 14:00:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6409,11,'                              ','Martes 28 de Febrero del 06, a las 14:01:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6410,11,'                              ','Martes 28 de Febrero del 06, a las 14:01:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6411,11,'                              ','Martes 28 de Febrero del 06, a las 14:03:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6412,11,'                              ','Martes 28 de Febrero del 06, a las 14:03:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6413,11,'                              ','Martes 28 de Febrero del 06, a las 14:03:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6414,11,'                              ','Martes 28 de Febrero del 06, a las 14:07:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6415,11,'                              ','Martes 28 de Febrero del 06, a las 14:31:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6416,11,'                              ','Martes 28 de Febrero del 06, a las 14:41:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6417,2,'Bib Datos Propopios           ','Martes 28 de Febrero del 06, a las 14:43:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6418,11,'                              ','Martes 28 de Febrero del 06, a las 14:46:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6419,11,'                              ','Martes 28 de Febrero del 06, a las 14:53:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6420,53,'                              ','Martes 28 de Febrero del 06, a las 14:55:14       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6421,53,'                              ','Martes 28 de Febrero del 06, a las 14:55:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6422,11,'                              ','Martes 28 de Febrero del 06, a las 14:57:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6423,6,'                              ','Martes 28 de Febrero del 06, a las 15:00:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6424,4,'                              ','Martes 28 de Febrero del 06, a las 15:00:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6425,4,'                              ','Martes 28 de Febrero del 06, a las 15:01:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6426,11,'                              ','Martes 28 de Febrero del 06, a las 15:03:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6427,6,'                              ','Martes 28 de Febrero del 06, a las 15:04:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6428,11,'                              ','Martes 28 de Febrero del 06, a las 15:07:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6429,4,'                              ','Martes 28 de Febrero del 06, a las 15:10:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6430,4,'                              ','Martes 28 de Febrero del 06, a las 15:10:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6431,4,'                              ','Martes 28 de Febrero del 06, a las 15:11:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6432,11,'                              ','Martes 28 de Febrero del 06, a las 15:22:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6433,11,'                              ','Martes 28 de Febrero del 06, a las 15:23:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6434,4,'                              ','Martes 28 de Febrero del 06, a las 15:34:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6435,4,'                              ','Martes 28 de Febrero del 06, a las 15:36:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6436,11,'                              ','Martes 28 de Febrero del 06, a las 15:38:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6437,53,'                              ','Martes 28 de Febrero del 06, a las 15:51:49       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6438,11,'                              ','Martes 28 de Febrero del 06, a las 15:53:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6439,11,'                              ','Martes 28 de Febrero del 06, a las 15:56:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6440,11,'                              ','Martes 28 de Febrero del 06, a las 16:00:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6441,11,'                              ','Martes 28 de Febrero del 06, a las 16:00:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6442,4,'                              ','Martes 28 de Febrero del 06, a las 16:15:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6443,4,'                              ','Martes 28 de Febrero del 06, a las 16:16:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6444,6,'                              ','Martes 28 de Febrero del 06, a las 16:18:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6445,53,'                              ','Martes 28 de Febrero del 06, a las 16:22:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6446,53,'                              ','Martes 28 de Febrero del 06, a las 16:23:07       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6447,11,'                              ','Martes 28 de Febrero del 06, a las 16:26:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6448,11,'                              ','Martes 28 de Febrero del 06, a las 16:27:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6449,11,'                              ','Martes 28 de Febrero del 06, a las 18:28:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6450,11,'                              ','Martes 28 de Febrero del 06, a las 18:28:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6451,6,'                              ','Martes 28 de Febrero del 06, a las 18:30:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6452,11,'                              ','Martes 28 de Febrero del 06, a las 18:33:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6453,11,'                              ','Martes 28 de Febrero del 06, a las 18:33:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6454,11,'                              ','Martes 28 de Febrero del 06, a las 18:35:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6455,11,'                              ','Martes 28 de Febrero del 06, a las 18:38:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6456,11,'                              ','Martes 28 de Febrero del 06, a las 18:44:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6457,11,'                              ','Martes 28 de Febrero del 06, a las 18:44:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6458,6,'                              ','Martes 28 de Febrero del 06, a las 18:46:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6459,11,'                              ','Martes 28 de Febrero del 06, a las 18:48:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6460,11,'                              ','Martes 28 de Febrero del 06, a las 18:51:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6461,6,'                              ','Martes 28 de Febrero del 06, a las 18:52:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6462,11,'                              ','Martes 28 de Febrero del 06, a las 18:53:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6463,11,'                              ','Martes 28 de Febrero del 06, a las 18:55:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6464,11,'                              ','Martes 28 de Febrero del 06, a las 18:57:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6465,11,'                              ','Martes 28 de Febrero del 06, a las 19:00:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6466,2,'Bib Datos Propopios           ','Martes 28 de Febrero del 06, a las 19:01:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6467,4,'                              ','Martes 28 de Febrero del 06, a las 19:03:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6468,11,'                              ','Martes 28 de Febrero del 06, a las 19:06:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6469,11,'                              ','Martes 28 de Febrero del 06, a las 19:17:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6470,6,'                              ','Martes 28 de Febrero del 06, a las 19:19:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6471,11,'                              ','Martes 28 de Febrero del 06, a las 19:30:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6472,11,'                              ','Martes 28 de Febrero del 06, a las 19:32:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6473,11,'                              ','Martes 28 de Febrero del 06, a las 19:53:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6474,11,'                              ','Martes 28 de Febrero del 06, a las 19:54:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6475,4,'                              ','Martes 28 de Febrero del 06, a las 20:00:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6476,11,'                              ','Martes 28 de Febrero del 06, a las 20:34:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6477,11,'                              ','Martes 28 de Febrero del 06, a las 20:40:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6478,11,'                              ','Martes 28 de Febrero del 06, a las 20:43:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6479,53,'                              ','Martes 28 de Febrero del 06, a las 20:44:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6480,11,'                              ','Martes 28 de Febrero del 06, a las 20:47:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6481,11,'                              ','Martes 28 de Febrero del 06, a las 20:51:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6482,11,'                              ','Martes 28 de Febrero del 06, a las 20:54:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6483,11,'                              ','Martes 28 de Febrero del 06, a las 20:55:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6484,11,'                              ','Martes 28 de Febrero del 06, a las 20:56:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6485,11,'                              ','Martes 28 de Febrero del 06, a las 20:58:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6486,11,'                              ','Martes 28 de Febrero del 06, a las 20:59:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6487,11,'                              ','Martes 28 de Febrero del 06, a las 21:00:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6488,11,'                              ','Martes 28 de Febrero del 06, a las 21:02:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6489,11,'                              ','Martes 28 de Febrero del 06, a las 21:02:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6490,11,'                              ','Martes 28 de Febrero del 06, a las 21:04:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6491,11,'                              ','Martes 28 de Febrero del 06, a las 21:04:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6492,11,'                              ','Martes 28 de Febrero del 06, a las 21:05:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6493,11,'                              ','Martes 28 de Febrero del 06, a las 21:07:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6494,11,'                              ','Martes 28 de Febrero del 06, a las 21:07:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6495,11,'                              ','Martes 28 de Febrero del 06, a las 21:11:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6496,11,'                              ','Martes 28 de Febrero del 06, a las 21:12:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6497,11,'                              ','Martes 28 de Febrero del 06, a las 21:13:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6498,11,'                              ','Martes 28 de Febrero del 06, a las 21:13:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6499,11,'                              ','Martes 28 de Febrero del 06, a las 21:14:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6500,11,'                              ','Martes 28 de Febrero del 06, a las 21:14:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6501,11,'                              ','Martes 28 de Febrero del 06, a las 21:15:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6502,11,'                              ','Martes 28 de Febrero del 06, a las 21:16:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6503,11,'                              ','Martes 28 de Febrero del 06, a las 21:16:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6504,11,'                              ','Martes 28 de Febrero del 06, a las 21:17:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6505,11,'                              ','Martes 28 de Febrero del 06, a las 21:17:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6506,11,'                              ','Martes 28 de Febrero del 06, a las 21:18:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6507,11,'                              ','Martes 28 de Febrero del 06, a las 21:19:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6508,11,'                              ','Martes 28 de Febrero del 06, a las 21:21:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6509,11,'                              ','Martes 28 de Febrero del 06, a las 21:22:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6510,11,'                              ','Martes 28 de Febrero del 06, a las 21:23:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6511,11,'                              ','Martes 28 de Febrero del 06, a las 21:23:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6512,11,'                              ','Martes 28 de Febrero del 06, a las 21:25:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6513,11,'                              ','Martes 28 de Febrero del 06, a las 21:26:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6514,11,'                              ','Martes 28 de Febrero del 06, a las 21:26:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6515,11,'                              ','Martes 28 de Febrero del 06, a las 21:26:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6516,11,'                              ','Martes 28 de Febrero del 06, a las 21:27:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6517,11,'                              ','Martes 28 de Febrero del 06, a las 21:27:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6518,11,'                              ','Martes 28 de Febrero del 06, a las 21:28:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6519,11,'                              ','Martes 28 de Febrero del 06, a las 21:28:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6520,11,'                              ','Martes 28 de Febrero del 06, a las 21:29:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6521,11,'                              ','Martes 28 de Febrero del 06, a las 21:30:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6522,11,'                              ','Martes 28 de Febrero del 06, a las 21:30:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6523,11,'                              ','Martes 28 de Febrero del 06, a las 21:32:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6524,11,'                              ','Martes 28 de Febrero del 06, a las 21:34:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6525,11,'                              ','Martes 28 de Febrero del 06, a las 21:38:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6526,11,'                              ','Martes 28 de Febrero del 06, a las 21:41:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6527,11,'                              ','Martes 28 de Febrero del 06, a las 21:43:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6528,53,'                              ','Martes 28 de Febrero del 06, a las 21:46:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6529,53,'                              ','Martes 28 de Febrero del 06, a las 21:46:14       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6530,6,'                              ','Mircoles 1 de Marzo del 06, a las 09:58:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6531,6,'                              ','Mircoles 1 de Marzo del 06, a las 09:59:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6532,6,'                              ','Mircoles 1 de Marzo del 06, a las 10:01:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6533,6,'                              ','Mircoles 1 de Marzo del 06, a las 10:02:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6534,6,'                              ','Mircoles 1 de Marzo del 06, a las 10:03:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6535,6,'                              ','Mircoles 1 de Marzo del 06, a las 10:08:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6536,4,'                              ','Mircoles 1 de Marzo del 06, a las 13:07:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6537,4,'                              ','Mircoles 1 de Marzo del 06, a las 13:08:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6538,11,'                              ','Mircoles 1 de Marzo del 06, a las 13:14:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6539,11,'                              ','Mircoles 1 de Marzo del 06, a las 13:15:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6540,11,'                              ','Mircoles 1 de Marzo del 06, a las 13:17:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6541,8,'                              ','Mircoles 1 de Marzo del 06, a las 13:24:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6542,8,'                              ','Mircoles 1 de Marzo del 06, a las 13:25:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6543,8,'                              ','Mircoles 1 de Marzo del 06, a las 13:25:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6544,8,'                              ','Mircoles 1 de Marzo del 06, a las 13:26:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6545,11,'                              ','Mircoles 1 de Marzo del 06, a las 13:36:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6546,8,'                              ','Mircoles 1 de Marzo del 06, a las 14:00:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6547,8,'                              ','Mircoles 1 de Marzo del 06, a las 14:01:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6548,8,'                              ','Mircoles 1 de Marzo del 06, a las 14:22:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6549,8,'                              ','Mircoles 1 de Marzo del 06, a las 14:23:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6550,4,'                              ','Mircoles 1 de Marzo del 06, a las 14:29:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6551,6,'                              ','Mircoles 1 de Marzo del 06, a las 15:36:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6552,6,'                              ','Mircoles 1 de Marzo del 06, a las 15:37:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6553,6,'                              ','Mircoles 1 de Marzo del 06, a las 15:44:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6554,2,'Bib Datos Propopios           ','Mircoles 1 de Marzo del 06, a las 15:59:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6555,2,'Bib Datos Propopios           ','Mircoles 1 de Marzo del 06, a las 16:00:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6556,2,'Bib Datos Propopios           ','Martes 7 de Marzo del 06, a las 19:57:04          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6557,2,'Bib Datos Propopios           ','Martes 7 de Marzo del 06, a las 19:57:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6558,2,'Bib Datos Propopios           ','Mircoles 8 de Marzo del 06, a las 19:04:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6559,4,'                              ','Mircoles 15 de Marzo del 06, a las 18:41:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6560,4,'                              ','Mircoles 15 de Marzo del 06, a las 18:41:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6561,4,'                              ','Mircoles 15 de Marzo del 06, a las 18:41:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6562,2,'Bib Datos Propopios           ','Lunes 20 de Marzo del 06, a las 14:49:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6563,2,'Bib Datos Propopios           ','Lunes 20 de Marzo del 06, a las 14:51:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6564,2,'Bib Datos Propopios           ','Lunes 20 de Marzo del 06, a las 14:51:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6565,2,'Bib Datos Propopios           ','Lunes 20 de Marzo del 06, a las 15:21:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6566,8,'                              ','Lunes 20 de Marzo del 06, a las 15:24:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6567,10,'                              ','Lunes 20 de Marzo del 06, a las 15:27:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6568,4,'                              ','Lunes 20 de Marzo del 06, a las 15:29:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6569,4,'                              ','Lunes 20 de Marzo del 06, a las 15:29:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6570,2,'Bib Datos Propopios           ','Mircoles 22 de Marzo del 06, a las 11:10:16      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6571,4,'                              ','Mircoles 22 de Marzo del 06, a las 14:00:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6572,6,'                              ','Mircoles 22 de Marzo del 06, a las 14:01:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6573,6,'                              ','Mircoles 22 de Marzo del 06, a las 14:01:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6574,6,'                              ','Jueves 23 de Marzo del 06, a las 14:50:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6575,11,'                              ','Jueves 23 de Marzo del 06, a las 14:54:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6576,6,'                              ','Jueves 23 de Marzo del 06, a las 15:01:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6577,6,'                              ','Jueves 23 de Marzo del 06, a las 15:03:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6578,11,'                              ','Jueves 23 de Marzo del 06, a las 15:06:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6579,6,'                              ','Jueves 23 de Marzo del 06, a las 15:29:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6580,11,'                              ','Jueves 23 de Marzo del 06, a las 15:36:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6581,11,'                              ','Jueves 23 de Marzo del 06, a las 15:45:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6582,6,'                              ','Jueves 23 de Marzo del 06, a las 15:51:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6583,11,'                              ','Jueves 23 de Marzo del 06, a las 15:52:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6584,4,'                              ','Jueves 23 de Marzo del 06, a las 15:55:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6585,6,'                              ','Jueves 23 de Marzo del 06, a las 16:03:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6586,53,'                              ','Jueves 23 de Marzo del 06, a las 16:07:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6587,53,'                              ','Jueves 23 de Marzo del 06, a las 16:08:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6588,11,'                              ','Jueves 23 de Marzo del 06, a las 16:14:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6589,11,'                              ','Jueves 23 de Marzo del 06, a las 16:15:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6590,11,'                              ','Jueves 23 de Marzo del 06, a las 16:16:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6591,11,'                              ','Jueves 23 de Marzo del 06, a las 16:22:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6592,4,'                              ','Jueves 23 de Marzo del 06, a las 16:25:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6593,11,'                              ','Jueves 23 de Marzo del 06, a las 16:26:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6594,11,'                              ','Jueves 23 de Marzo del 06, a las 16:28:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6595,11,'                              ','Jueves 23 de Marzo del 06, a las 16:30:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6596,11,'                              ','Jueves 23 de Marzo del 06, a las 16:31:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6597,6,'                              ','Jueves 23 de Marzo del 06, a las 16:32:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6598,6,'                              ','Viernes 24 de Marzo del 06, a las 11:37:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6599,6,'                              ','Viernes 24 de Marzo del 06, a las 14:24:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6600,6,'                              ','Viernes 24 de Marzo del 06, a las 14:26:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6601,6,'                              ','Viernes 24 de Marzo del 06, a las 14:27:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6602,6,'                              ','Viernes 24 de Marzo del 06, a las 14:28:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6603,6,'                              ','Viernes 24 de Marzo del 06, a las 14:34:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6604,6,'                              ','Viernes 24 de Marzo del 06, a las 14:37:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6605,6,'                              ','Viernes 24 de Marzo del 06, a las 15:52:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6606,6,'                              ','Viernes 24 de Marzo del 06, a las 15:56:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6607,4,'                              ','Viernes 24 de Marzo del 06, a las 20:07:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6608,11,'                              ','Viernes 24 de Marzo del 06, a las 20:33:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6609,4,'                              ','Viernes 24 de Marzo del 06, a las 20:35:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6610,11,'                              ','Viernes 24 de Marzo del 06, a las 20:37:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6611,11,'                              ','Viernes 24 de Marzo del 06, a las 20:38:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6612,11,'                              ','Viernes 24 de Marzo del 06, a las 20:39:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6613,11,'                              ','Viernes 24 de Marzo del 06, a las 20:43:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6614,11,'                              ','Viernes 24 de Marzo del 06, a las 20:45:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6615,4,'                              ','Viernes 24 de Marzo del 06, a las 20:46:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6616,6,'                              ','Viernes 24 de Marzo del 06, a las 20:57:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6617,11,'                              ','Viernes 24 de Marzo del 06, a las 20:59:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6618,6,'                              ','Viernes 24 de Marzo del 06, a las 21:01:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6619,11,'                              ','Viernes 24 de Marzo del 06, a las 21:04:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6620,11,'                              ','Viernes 24 de Marzo del 06, a las 21:04:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6621,6,'                              ','Viernes 24 de Marzo del 06, a las 21:08:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6622,4,'                              ','Sbado 25 de Marzo del 06, a las 12:45:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6623,4,'                              ','Sbado 25 de Marzo del 06, a las 12:49:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6624,4,'                              ','Sbado 25 de Marzo del 06, a las 12:56:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6625,6,'                              ','Sbado 25 de Marzo del 06, a las 12:57:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6626,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 13:02:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6627,4,'                              ','Sbado 25 de Marzo del 06, a las 13:03:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6628,4,'                              ','Sbado 25 de Marzo del 06, a las 13:21:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6629,4,'                              ','Sbado 25 de Marzo del 06, a las 13:23:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6630,4,'                              ','Sbado 25 de Marzo del 06, a las 13:25:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6631,4,'                              ','Sbado 25 de Marzo del 06, a las 13:33:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6632,4,'                              ','Sbado 25 de Marzo del 06, a las 13:36:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6633,4,'                              ','Sbado 25 de Marzo del 06, a las 13:46:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6634,4,'                              ','Sbado 25 de Marzo del 06, a las 13:48:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6635,4,'                              ','Sbado 25 de Marzo del 06, a las 13:54:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6636,6,'                              ','Sbado 25 de Marzo del 06, a las 13:56:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6637,6,'                              ','Sbado 25 de Marzo del 06, a las 14:06:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6638,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 14:15:34         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6639,4,'                              ','Sbado 25 de Marzo del 06, a las 14:16:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6640,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 14:23:54         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6641,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 14:26:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6642,4,'                              ','Sbado 25 de Marzo del 06, a las 14:27:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6643,4,'                              ','Sbado 25 de Marzo del 06, a las 14:30:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6644,4,'                              ','Sbado 25 de Marzo del 06, a las 14:32:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6645,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 14:36:15         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6646,4,'                              ','Sbado 25 de Marzo del 06, a las 14:36:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6647,4,'                              ','Sbado 25 de Marzo del 06, a las 14:41:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6648,4,'                              ','Sbado 25 de Marzo del 06, a las 14:44:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6649,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 14:53:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6650,4,'                              ','Sbado 25 de Marzo del 06, a las 14:59:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6651,4,'                              ','Sbado 25 de Marzo del 06, a las 15:01:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6652,2,'Bib Datos Propopios           ','Sbado 25 de Marzo del 06, a las 15:05:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6653,4,'                              ','Sbado 25 de Marzo del 06, a las 15:06:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6654,4,'                              ','Sbado 25 de Marzo del 06, a las 15:09:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6655,4,'                              ','Sbado 25 de Marzo del 06, a las 15:20:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6656,4,'                              ','Sbado 25 de Marzo del 06, a las 15:25:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6657,4,'                              ','Lunes 27 de Marzo del 06, a las 11:34:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6658,6,'                              ','Lunes 27 de Marzo del 06, a las 11:35:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6659,4,'                              ','Lunes 27 de Marzo del 06, a las 11:36:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6660,6,'                              ','Lunes 27 de Marzo del 06, a las 11:38:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6661,6,'                              ','Lunes 27 de Marzo del 06, a las 11:43:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6662,6,'                              ','Lunes 27 de Marzo del 06, a las 11:47:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6663,4,'                              ','Lunes 27 de Marzo del 06, a las 11:50:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6664,6,'                              ','Lunes 27 de Marzo del 06, a las 11:52:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6665,4,'                              ','Lunes 27 de Marzo del 06, a las 12:17:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6666,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 12:19:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6667,6,'                              ','Lunes 27 de Marzo del 06, a las 12:37:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6668,4,'                              ','Lunes 27 de Marzo del 06, a las 12:52:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6669,6,'                              ','Lunes 27 de Marzo del 06, a las 12:54:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6670,11,'                              ','Lunes 27 de Marzo del 06, a las 12:58:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6671,11,'                              ','Lunes 27 de Marzo del 06, a las 13:00:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6672,6,'                              ','Lunes 27 de Marzo del 06, a las 13:39:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6673,6,'                              ','Lunes 27 de Marzo del 06, a las 13:44:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6674,11,'                              ','Lunes 27 de Marzo del 06, a las 13:45:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6675,11,'                              ','Lunes 27 de Marzo del 06, a las 13:51:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6676,4,'                              ','Lunes 27 de Marzo del 06, a las 13:55:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6677,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 13:59:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6678,4,'                              ','Lunes 27 de Marzo del 06, a las 14:00:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6679,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:01:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6680,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:03:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6681,4,'                              ','Lunes 27 de Marzo del 06, a las 14:04:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6682,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:08:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6683,4,'                              ','Lunes 27 de Marzo del 06, a las 14:08:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6684,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:11:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6685,4,'                              ','Lunes 27 de Marzo del 06, a las 14:12:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6686,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:14:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6687,4,'                              ','Lunes 27 de Marzo del 06, a las 14:15:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6688,6,'                              ','Lunes 27 de Marzo del 06, a las 14:16:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6689,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:18:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6690,4,'                              ','Lunes 27 de Marzo del 06, a las 14:19:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6691,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:22:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6692,4,'                              ','Lunes 27 de Marzo del 06, a las 14:23:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6693,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:27:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6694,4,'                              ','Lunes 27 de Marzo del 06, a las 14:28:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6695,4,'                              ','Lunes 27 de Marzo del 06, a las 14:29:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6696,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:32:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6697,4,'                              ','Lunes 27 de Marzo del 06, a las 14:32:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6698,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 14:35:05          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6699,4,'                              ','Lunes 27 de Marzo del 06, a las 14:35:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6700,4,'                              ','Lunes 27 de Marzo del 06, a las 14:40:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6701,4,'                              ','Lunes 27 de Marzo del 06, a las 14:43:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6702,4,'                              ','Lunes 27 de Marzo del 06, a las 14:46:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6703,4,'                              ','Lunes 27 de Marzo del 06, a las 14:52:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6704,4,'                              ','Lunes 27 de Marzo del 06, a las 14:56:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6705,4,'                              ','Lunes 27 de Marzo del 06, a las 14:58:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6706,6,'                              ','Lunes 27 de Marzo del 06, a las 15:04:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6707,11,'                              ','Lunes 27 de Marzo del 06, a las 15:05:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6708,4,'                              ','Lunes 27 de Marzo del 06, a las 15:10:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6709,4,'                              ','Lunes 27 de Marzo del 06, a las 15:12:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6710,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 15:16:17          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6711,4,'                              ','Lunes 27 de Marzo del 06, a las 15:17:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6712,4,'                              ','Lunes 27 de Marzo del 06, a las 15:22:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6713,4,'                              ','Lunes 27 de Marzo del 06, a las 15:24:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6714,4,'                              ','Lunes 27 de Marzo del 06, a las 15:46:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6715,4,'                              ','Lunes 27 de Marzo del 06, a las 17:11:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6716,4,'                              ','Lunes 27 de Marzo del 06, a las 17:12:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6717,4,'                              ','Lunes 27 de Marzo del 06, a las 17:19:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6718,4,'                              ','Lunes 27 de Marzo del 06, a las 17:22:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6719,53,'                              ','Lunes 27 de Marzo del 06, a las 17:24:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6720,4,'                              ','Lunes 27 de Marzo del 06, a las 17:26:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6721,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 17:29:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6722,4,'                              ','Lunes 27 de Marzo del 06, a las 17:30:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6723,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 17:34:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6724,4,'                              ','Lunes 27 de Marzo del 06, a las 17:35:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6725,6,'                              ','Lunes 27 de Marzo del 06, a las 17:38:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6726,6,'                              ','Lunes 27 de Marzo del 06, a las 17:39:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6727,11,'                              ','Lunes 27 de Marzo del 06, a las 17:40:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6728,2,'Bib Datos Propopios           ','Lunes 27 de Marzo del 06, a las 17:45:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6729,4,'                              ','Lunes 27 de Marzo del 06, a las 17:53:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6730,4,'                              ','Lunes 27 de Marzo del 06, a las 19:17:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6731,6,'                              ','Lunes 27 de Marzo del 06, a las 21:21:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6732,8,'                              ','Martes 28 de Marzo del 06, a las 09:54:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6733,8,'                              ','Martes 28 de Marzo del 06, a las 09:55:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6734,11,'                              ','Martes 28 de Marzo del 06, a las 09:56:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6735,11,'                              ','Martes 28 de Marzo del 06, a las 09:57:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6736,11,'                              ','Martes 28 de Marzo del 06, a las 09:58:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6737,11,'                              ','Martes 28 de Marzo del 06, a las 10:00:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6738,11,'                              ','Martes 28 de Marzo del 06, a las 10:02:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6739,11,'                              ','Martes 28 de Marzo del 06, a las 10:03:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6740,6,'                              ','Viernes 21 de Abril del 06, a las 14:17:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6741,6,'                              ','Viernes 21 de Abril del 06, a las 14:21:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6742,6,'                              ','Viernes 21 de Abril del 06, a las 14:50:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6743,6,'                              ','Viernes 21 de Abril del 06, a las 14:53:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6744,6,'                              ','Viernes 21 de Abril del 06, a las 14:57:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6745,6,'                              ','Viernes 21 de Abril del 06, a las 14:59:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6746,6,'                              ','Viernes 21 de Abril del 06, a las 15:01:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6747,6,'                              ','Viernes 21 de Abril del 06, a las 15:02:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6748,6,'                              ','Viernes 21 de Abril del 06, a las 15:03:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6749,6,'                              ','Viernes 21 de Abril del 06, a las 15:06:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6750,6,'                              ','Viernes 21 de Abril del 06, a las 15:06:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6751,6,'                              ','Viernes 21 de Abril del 06, a las 15:07:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6752,6,'                              ','Viernes 21 de Abril del 06, a las 15:08:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6753,6,'                              ','Viernes 21 de Abril del 06, a las 15:10:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6754,6,'                              ','Viernes 21 de Abril del 06, a las 15:11:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6755,11,'                              ','Viernes 21 de Abril del 06, a las 15:11:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6756,6,'                              ','Viernes 21 de Abril del 06, a las 15:40:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6757,6,'                              ','Viernes 21 de Abril del 06, a las 15:43:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6758,6,'                              ','Viernes 21 de Abril del 06, a las 15:44:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6759,6,'                              ','Viernes 21 de Abril del 06, a las 15:45:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6760,6,'                              ','Viernes 21 de Abril del 06, a las 15:48:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6761,6,'                              ','Viernes 21 de Abril del 06, a las 15:50:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6762,6,'                              ','Viernes 21 de Abril del 06, a las 15:53:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6763,6,'                              ','Viernes 21 de Abril del 06, a las 15:57:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6764,6,'                              ','Viernes 21 de Abril del 06, a las 15:59:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6765,6,'                              ','Viernes 21 de Abril del 06, a las 16:00:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6766,4,'                              ','Viernes 21 de Abril del 06, a las 21:10:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6767,6,'                              ','Viernes 21 de Abril del 06, a las 21:12:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6768,11,'                              ','Viernes 21 de Abril del 06, a las 21:12:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6769,11,'                              ','Viernes 21 de Abril del 06, a las 21:13:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6770,11,'                              ','Viernes 21 de Abril del 06, a las 21:13:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6771,8,'                              ','Viernes 21 de Abril del 06, a las 21:14:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6772,6,'                              ','Viernes 21 de Abril del 06, a las 21:28:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6773,6,'                              ','Viernes 21 de Abril del 06, a las 21:32:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6774,11,'                              ','Viernes 21 de Abril del 06, a las 21:35:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6775,11,'                              ','Viernes 21 de Abril del 06, a las 21:36:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6776,6,'                              ','Lunes 8 de Mayo del 06, a las 13:12:15            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6777,6,'                              ','Lunes 8 de Mayo del 06, a las 13:16:26            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6778,6,'                              ','Lunes 8 de Mayo del 06, a las 13:18:02            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6779,6,'                              ','Lunes 8 de Mayo del 06, a las 13:18:13            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6780,6,'                              ','Lunes 8 de Mayo del 06, a las 13:18:52            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6781,6,'                              ','Lunes 8 de Mayo del 06, a las 13:20:22            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6782,6,'                              ','Lunes 8 de Mayo del 06, a las 13:24:09            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6783,6,'                              ','Lunes 8 de Mayo del 06, a las 13:24:27            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6784,6,'                              ','Lunes 8 de Mayo del 06, a las 13:25:17            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6785,6,'                              ','Lunes 8 de Mayo del 06, a las 13:26:43            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6786,6,'                              ','Lunes 8 de Mayo del 06, a las 13:26:51            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6787,6,'                              ','Lunes 8 de Mayo del 06, a las 13:27:53            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6788,6,'                              ','Jueves 18 de Mayo del 06, a las 14:35:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6789,11,'                              ','Jueves 18 de Mayo del 06, a las 14:36:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6790,4,'                              ','Jueves 18 de Mayo del 06, a las 14:37:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6791,2,'Bib Datos Propopios           ','Lunes 22 de Mayo del 06, a las 21:44:55           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6792,2,'Bib Datos Propopios           ','Lunes 22 de Mayo del 06, a las 21:45:04           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6793,6,'                              ','Jueves 25 de Mayo del 06, a las 15:00:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6794,6,'                              ','Jueves 25 de Mayo del 06, a las 15:00:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6795,6,'                              ','Jueves 25 de Mayo del 06, a las 15:02:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6796,6,'                              ','Jueves 25 de Mayo del 06, a las 15:05:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6797,6,'                              ','Jueves 25 de Mayo del 06, a las 15:05:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6798,6,'                              ','Jueves 25 de Mayo del 06, a las 15:07:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6799,4,'                              ','Jueves 25 de Mayo del 06, a las 15:09:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6800,6,'                              ','Martes 30 de Mayo del 06, a las 12:23:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6801,6,'                              ','Martes 30 de Mayo del 06, a las 12:26:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6802,6,'                              ','Martes 30 de Mayo del 06, a las 12:28:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6803,6,'                              ','Martes 30 de Mayo del 06, a las 12:30:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6804,6,'                              ','Martes 30 de Mayo del 06, a las 12:30:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6805,6,'                              ','Martes 30 de Mayo del 06, a las 12:31:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6806,8,'                              ','Martes 30 de Mayo del 06, a las 12:36:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6807,8,'                              ','Martes 30 de Mayo del 06, a las 12:37:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6808,8,'                              ','Martes 30 de Mayo del 06, a las 12:38:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6809,6,'                              ','Martes 30 de Mayo del 06, a las 12:38:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6810,6,'                              ','Martes 30 de Mayo del 06, a las 12:40:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6811,6,'                              ','Martes 30 de Mayo del 06, a las 12:42:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6812,6,'                              ','Martes 30 de Mayo del 06, a las 12:46:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6813,6,'                              ','Martes 30 de Mayo del 06, a las 12:47:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6814,8,'                              ','Martes 30 de Mayo del 06, a las 14:16:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6815,6,'                              ','Martes 30 de Mayo del 06, a las 14:20:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6816,6,'                              ','Martes 30 de Mayo del 06, a las 14:23:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6817,6,'                              ','Martes 30 de Mayo del 06, a las 14:25:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6818,6,'                              ','Martes 30 de Mayo del 06, a las 14:28:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6819,6,'                              ','Martes 30 de Mayo del 06, a las 14:28:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6820,6,'                              ','Martes 30 de Mayo del 06, a las 14:29:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6821,6,'                              ','Martes 30 de Mayo del 06, a las 14:30:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6822,6,'                              ','Martes 30 de Mayo del 06, a las 14:31:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6823,6,'                              ','Mircoles 31 de Mayo del 06, a las 10:23:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6824,6,'                              ','Mircoles 31 de Mayo del 06, a las 11:17:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6825,11,'                              ','Mircoles 31 de Mayo del 06, a las 11:18:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6826,8,'                              ','Mircoles 31 de Mayo del 06, a las 11:19:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6827,6,'                              ','Jueves 1 de Junio del 06, a las 17:12:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6828,6,'                              ','Viernes 2 de Junio del 06, a las 12:49:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6829,11,'                              ','Viernes 2 de Junio del 06, a las 12:49:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6830,11,'                              ','Viernes 2 de Junio del 06, a las 13:44:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6831,6,'                              ','Viernes 2 de Junio del 06, a las 13:45:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6832,11,'                              ','Viernes 2 de Junio del 06, a las 13:46:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6833,6,'                              ','Jueves 8 de Junio del 06, a las 15:47:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6834,6,'                              ','Jueves 8 de Junio del 06, a las 15:50:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6835,6,'                              ','Jueves 8 de Junio del 06, a las 15:54:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6836,6,'                              ','Jueves 8 de Junio del 06, a las 16:21:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6837,6,'                              ','Jueves 8 de Junio del 06, a las 16:24:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6838,6,'                              ','Jueves 8 de Junio del 06, a las 16:26:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6839,6,'                              ','Jueves 8 de Junio del 06, a las 16:27:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6840,6,'                              ','Jueves 8 de Junio del 06, a las 16:28:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6841,6,'                              ','Viernes 9 de Junio del 06, a las 15:36:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6842,6,'                              ','Lunes 12 de Junio del 06, a las 11:21:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6843,6,'                              ','Viernes 16 de Junio del 06, a las 12:33:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6844,6,'                              ','Viernes 16 de Junio del 06, a las 12:55:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6845,6,'                              ','Lunes 26 de Junio del 06, a las 13:51:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6846,6,'                              ','Lunes 26 de Junio del 06, a las 13:53:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6847,53,'                              ','Lunes 26 de Junio del 06, a las 13:55:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6848,8,'                              ','Lunes 26 de Junio del 06, a las 13:58:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6849,11,'                              ','Jueves 6 de Julio del 06, a las 11:48:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6850,6,'                              ','Jueves 6 de Julio del 06, a las 11:55:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6851,6,'                              ','Jueves 6 de Julio del 06, a las 11:56:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6852,4,'                              ','Martes 15 de Agosto del 06, a las 12:22:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6853,4,'                              ','Martes 15 de Agosto del 06, a las 12:36:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6854,11,'                              ','Martes 15 de Agosto del 06, a las 12:46:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6855,11,'                              ','Martes 15 de Agosto del 06, a las 13:03:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6856,11,'                              ','Martes 15 de Agosto del 06, a las 13:12:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6857,11,'                              ','Martes 15 de Agosto del 06, a las 13:19:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6858,11,'                              ','Martes 15 de Agosto del 06, a las 13:25:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6859,11,'                              ','Martes 15 de Agosto del 06, a las 13:29:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6860,11,'                              ','Martes 15 de Agosto del 06, a las 13:30:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6861,11,'                              ','Martes 15 de Agosto del 06, a las 13:33:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6862,11,'                              ','Martes 15 de Agosto del 06, a las 13:35:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6863,11,'                              ','Martes 15 de Agosto del 06, a las 13:42:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6864,11,'                              ','Martes 15 de Agosto del 06, a las 13:43:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6865,11,'                              ','Martes 15 de Agosto del 06, a las 13:47:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6866,11,'                              ','Martes 15 de Agosto del 06, a las 13:53:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6867,11,'                              ','Martes 15 de Agosto del 06, a las 13:55:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6868,11,'                              ','Martes 15 de Agosto del 06, a las 14:00:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6869,11,'                              ','Martes 15 de Agosto del 06, a las 14:11:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6870,11,'                              ','Martes 15 de Agosto del 06, a las 14:20:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6871,11,'                              ','Martes 15 de Agosto del 06, a las 14:51:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6872,11,'                              ','Martes 15 de Agosto del 06, a las 14:54:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6873,4,'                              ','Martes 15 de Agosto del 06, a las 14:58:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6874,11,'                              ','Martes 15 de Agosto del 06, a las 15:02:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6875,11,'                              ','Martes 15 de Agosto del 06, a las 15:15:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6876,11,'                              ','Martes 15 de Agosto del 06, a las 15:18:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6877,11,'                              ','Martes 15 de Agosto del 06, a las 15:25:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6878,11,'                              ','Martes 15 de Agosto del 06, a las 15:30:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6879,11,'                              ','Martes 15 de Agosto del 06, a las 15:35:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6880,11,'                              ','Martes 15 de Agosto del 06, a las 15:45:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6881,11,'                              ','Martes 15 de Agosto del 06, a las 15:53:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6882,11,'                              ','Martes 15 de Agosto del 06, a las 16:16:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6883,4,'                              ','Martes 15 de Agosto del 06, a las 16:17:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6884,6,'                              ','Martes 15 de Agosto del 06, a las 16:19:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6885,11,'                              ','Martes 15 de Agosto del 06, a las 16:21:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6886,11,'                              ','Martes 15 de Agosto del 06, a las 16:28:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6887,11,'                              ','Martes 15 de Agosto del 06, a las 16:32:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6888,11,'                              ','Martes 15 de Agosto del 06, a las 16:34:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6889,11,'                              ','Martes 15 de Agosto del 06, a las 16:38:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6890,11,'                              ','Jueves 17 de Agosto del 06, a las 16:45:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6891,11,'                              ','Jueves 17 de Agosto del 06, a las 16:46:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6892,11,'                              ','Jueves 17 de Agosto del 06, a las 17:00:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6893,11,'                              ','Jueves 17 de Agosto del 06, a las 17:04:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6894,11,'                              ','Jueves 17 de Agosto del 06, a las 17:05:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6895,11,'                              ','Jueves 17 de Agosto del 06, a las 17:07:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6896,11,'                              ','Jueves 17 de Agosto del 06, a las 17:10:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6897,11,'                              ','Viernes 18 de Agosto del 06, a las 11:09:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6898,11,'                              ','Viernes 18 de Agosto del 06, a las 11:18:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6899,11,'                              ','Viernes 18 de Agosto del 06, a las 11:22:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6900,11,'                              ','Viernes 18 de Agosto del 06, a las 11:27:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6901,11,'                              ','Viernes 18 de Agosto del 06, a las 11:28:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6902,11,'                              ','Viernes 18 de Agosto del 06, a las 11:45:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6903,11,'                              ','Viernes 18 de Agosto del 06, a las 11:47:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6904,11,'                              ','Viernes 18 de Agosto del 06, a las 11:49:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6905,11,'                              ','Viernes 18 de Agosto del 06, a las 11:56:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6906,11,'                              ','Viernes 18 de Agosto del 06, a las 12:01:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6907,11,'                              ','Viernes 18 de Agosto del 06, a las 12:41:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6908,11,'                              ','Viernes 18 de Agosto del 06, a las 12:44:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6909,11,'                              ','Viernes 18 de Agosto del 06, a las 12:46:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6910,11,'                              ','Viernes 18 de Agosto del 06, a las 12:49:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6911,11,'                              ','Viernes 18 de Agosto del 06, a las 12:54:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6912,11,'                              ','Viernes 18 de Agosto del 06, a las 13:01:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6913,11,'                              ','Viernes 18 de Agosto del 06, a las 13:29:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6914,11,'                              ','Viernes 18 de Agosto del 06, a las 14:03:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6915,11,'                              ','Viernes 18 de Agosto del 06, a las 14:11:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6916,11,'                              ','Viernes 18 de Agosto del 06, a las 14:15:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6917,11,'                              ','Viernes 18 de Agosto del 06, a las 14:18:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6918,11,'                              ','Viernes 18 de Agosto del 06, a las 14:24:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6919,11,'                              ','Viernes 18 de Agosto del 06, a las 14:24:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6920,11,'                              ','Viernes 18 de Agosto del 06, a las 14:29:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6921,11,'                              ','Viernes 18 de Agosto del 06, a las 14:29:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6922,11,'                              ','Viernes 18 de Agosto del 06, a las 14:32:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6923,11,'                              ','Viernes 18 de Agosto del 06, a las 14:33:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6924,11,'                              ','Viernes 18 de Agosto del 06, a las 14:34:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6925,11,'                              ','Viernes 18 de Agosto del 06, a las 14:35:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6926,11,'                              ','Viernes 18 de Agosto del 06, a las 14:35:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6927,11,'                              ','Viernes 18 de Agosto del 06, a las 14:52:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6928,11,'                              ','Viernes 18 de Agosto del 06, a las 14:57:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6929,11,'                              ','Viernes 18 de Agosto del 06, a las 14:59:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6930,11,'                              ','Viernes 18 de Agosto del 06, a las 15:04:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6931,11,'                              ','Viernes 18 de Agosto del 06, a las 15:22:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6932,11,'                              ','Viernes 18 de Agosto del 06, a las 15:33:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6933,11,'                              ','Viernes 18 de Agosto del 06, a las 15:33:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6934,11,'                              ','Viernes 18 de Agosto del 06, a las 15:41:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6935,11,'                              ','Viernes 18 de Agosto del 06, a las 15:42:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6936,11,'                              ','Viernes 18 de Agosto del 06, a las 15:45:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6937,11,'                              ','Viernes 18 de Agosto del 06, a las 15:50:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6938,11,'                              ','Lunes 21 de Agosto del 06, a las 10:25:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6939,11,'                              ','Lunes 21 de Agosto del 06, a las 10:27:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6940,11,'                              ','Lunes 21 de Agosto del 06, a las 10:35:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6941,11,'                              ','Lunes 21 de Agosto del 06, a las 11:59:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6942,11,'                              ','Lunes 21 de Agosto del 06, a las 12:00:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6943,11,'                              ','Lunes 21 de Agosto del 06, a las 12:04:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6944,11,'                              ','Lunes 21 de Agosto del 06, a las 12:44:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6945,4,'                              ','Lunes 21 de Agosto del 06, a las 13:01:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6946,11,'                              ','Lunes 21 de Agosto del 06, a las 13:02:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6947,4,'                              ','Lunes 21 de Agosto del 06, a las 13:03:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6948,11,'                              ','Lunes 21 de Agosto del 06, a las 13:05:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6949,11,'                              ','Lunes 21 de Agosto del 06, a las 13:07:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6950,11,'                              ','Lunes 21 de Agosto del 06, a las 13:12:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6951,11,'                              ','Lunes 21 de Agosto del 06, a las 13:18:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6952,11,'                              ','Lunes 21 de Agosto del 06, a las 13:18:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6953,4,'                              ','Lunes 21 de Agosto del 06, a las 13:22:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6954,11,'                              ','Lunes 21 de Agosto del 06, a las 13:23:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6955,11,'                              ','Lunes 21 de Agosto del 06, a las 13:24:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6956,11,'                              ','Lunes 21 de Agosto del 06, a las 13:28:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6957,11,'                              ','Lunes 21 de Agosto del 06, a las 13:31:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6958,11,'                              ','Lunes 21 de Agosto del 06, a las 13:35:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6959,11,'                              ','Lunes 21 de Agosto del 06, a las 13:49:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6960,6,'                              ','Lunes 21 de Agosto del 06, a las 15:10:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6961,6,'                              ','Lunes 21 de Agosto del 06, a las 15:12:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6962,11,'                              ','Lunes 21 de Agosto del 06, a las 15:42:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6963,11,'                              ','Lunes 21 de Agosto del 06, a las 15:46:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6964,11,'                              ','Lunes 21 de Agosto del 06, a las 15:48:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6965,11,'                              ','Lunes 21 de Agosto del 06, a las 15:50:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6966,11,'                              ','Lunes 21 de Agosto del 06, a las 15:55:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6967,11,'                              ','Lunes 21 de Agosto del 06, a las 15:59:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6968,11,'                              ','Lunes 21 de Agosto del 06, a las 16:03:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6969,11,'                              ','Lunes 21 de Agosto del 06, a las 16:03:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6970,11,'                              ','Lunes 21 de Agosto del 06, a las 16:19:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6971,11,'                              ','Lunes 21 de Agosto del 06, a las 16:23:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6972,11,'                              ','Lunes 21 de Agosto del 06, a las 16:28:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6973,11,'                              ','Lunes 21 de Agosto del 06, a las 16:31:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6974,11,'                              ','Lunes 21 de Agosto del 06, a las 16:32:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6975,11,'                              ','Lunes 21 de Agosto del 06, a las 16:32:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6976,11,'                              ','Lunes 21 de Agosto del 06, a las 16:34:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6977,11,'                              ','Lunes 21 de Agosto del 06, a las 16:41:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6978,6,'                              ','Lunes 21 de Agosto del 06, a las 16:47:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6979,11,'                              ','Lunes 21 de Agosto del 06, a las 16:53:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6980,11,'                              ','Lunes 21 de Agosto del 06, a las 16:55:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6981,11,'                              ','Lunes 21 de Agosto del 06, a las 16:55:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6982,11,'                              ','Lunes 21 de Agosto del 06, a las 16:56:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6983,11,'                              ','Lunes 21 de Agosto del 06, a las 16:57:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6984,11,'                              ','Martes 22 de Agosto del 06, a las 12:20:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6985,11,'                              ','Martes 22 de Agosto del 06, a las 12:24:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6986,11,'                              ','Martes 22 de Agosto del 06, a las 12:25:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6987,11,'                              ','Martes 22 de Agosto del 06, a las 12:26:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6988,11,'                              ','Martes 22 de Agosto del 06, a las 12:26:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6989,11,'                              ','Martes 22 de Agosto del 06, a las 12:36:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6990,11,'                              ','Martes 22 de Agosto del 06, a las 12:38:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6991,11,'                              ','Martes 22 de Agosto del 06, a las 12:42:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6992,11,'                              ','Martes 22 de Agosto del 06, a las 12:46:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6993,11,'                              ','Martes 22 de Agosto del 06, a las 12:55:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6994,11,'                              ','Martes 22 de Agosto del 06, a las 12:56:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6995,11,'                              ','Martes 22 de Agosto del 06, a las 13:02:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6996,11,'                              ','Martes 22 de Agosto del 06, a las 13:21:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6997,11,'                              ','Martes 22 de Agosto del 06, a las 13:22:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6998,11,'                              ','Martes 22 de Agosto del 06, a las 13:22:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (6999,4,'                              ','Martes 22 de Agosto del 06, a las 13:40:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7000,11,'                              ','Martes 22 de Agosto del 06, a las 13:42:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7001,11,'                              ','Martes 22 de Agosto del 06, a las 13:46:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7002,11,'                              ','Martes 22 de Agosto del 06, a las 14:04:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7003,11,'                              ','Martes 22 de Agosto del 06, a las 14:07:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7004,11,'                              ','Martes 22 de Agosto del 06, a las 14:10:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7005,11,'                              ','Martes 22 de Agosto del 06, a las 14:11:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7006,11,'                              ','Martes 22 de Agosto del 06, a las 14:11:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7007,11,'                              ','Martes 22 de Agosto del 06, a las 14:28:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7008,11,'                              ','Martes 22 de Agosto del 06, a las 14:35:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7009,11,'                              ','Martes 22 de Agosto del 06, a las 14:36:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7010,11,'                              ','Martes 22 de Agosto del 06, a las 14:41:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7011,11,'                              ','Martes 22 de Agosto del 06, a las 14:41:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7012,11,'                              ','Martes 22 de Agosto del 06, a las 14:45:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7013,11,'                              ','Martes 22 de Agosto del 06, a las 15:12:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7014,11,'                              ','Martes 22 de Agosto del 06, a las 15:13:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7015,11,'                              ','Martes 22 de Agosto del 06, a las 15:16:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7016,11,'                              ','Martes 22 de Agosto del 06, a las 15:20:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7017,11,'                              ','Martes 22 de Agosto del 06, a las 15:20:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7018,4,'                              ','Martes 22 de Agosto del 06, a las 15:49:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7019,11,'                              ','Martes 22 de Agosto del 06, a las 15:55:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7020,11,'                              ','Martes 22 de Agosto del 06, a las 15:56:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7021,11,'                              ','Martes 22 de Agosto del 06, a las 15:56:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7022,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:03:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7023,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:03:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7024,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:10:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7025,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:14:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7026,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:16:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7027,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:18:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7028,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:22:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7029,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:23:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7030,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:25:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7031,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:26:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7032,11,'                              ','Mircoles 23 de Agosto del 06, a las 18:27:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7033,6,'                              ','Mircoles 23 de Agosto del 06, a las 18:30:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7034,6,'                              ','Mircoles 23 de Agosto del 06, a las 18:32:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7035,11,'                              ','Jueves 24 de Agosto del 06, a las 12:13:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7036,11,'                              ','Jueves 24 de Agosto del 06, a las 12:14:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7037,6,'                              ','Jueves 24 de Agosto del 06, a las 12:16:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7038,6,'                              ','Jueves 24 de Agosto del 06, a las 12:19:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7039,11,'                              ','Jueves 24 de Agosto del 06, a las 12:20:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7040,11,'                              ','Jueves 24 de Agosto del 06, a las 12:20:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7041,11,'                              ','Jueves 24 de Agosto del 06, a las 12:21:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7042,11,'                              ','Jueves 24 de Agosto del 06, a las 12:22:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7043,11,'                              ','Jueves 24 de Agosto del 06, a las 12:23:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7044,11,'                              ','Jueves 24 de Agosto del 06, a las 12:25:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7045,11,'                              ','Jueves 24 de Agosto del 06, a las 12:26:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7046,11,'                              ','Jueves 24 de Agosto del 06, a las 12:28:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7047,11,'                              ','Jueves 24 de Agosto del 06, a las 12:28:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7048,11,'                              ','Jueves 24 de Agosto del 06, a las 12:30:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7049,11,'                              ','Jueves 24 de Agosto del 06, a las 12:31:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7050,11,'                              ','Jueves 24 de Agosto del 06, a las 12:31:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7051,11,'                              ','Jueves 24 de Agosto del 06, a las 12:32:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7052,11,'                              ','Jueves 24 de Agosto del 06, a las 12:33:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7053,11,'                              ','Jueves 24 de Agosto del 06, a las 12:35:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7054,11,'                              ','Jueves 24 de Agosto del 06, a las 12:37:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7055,11,'                              ','Jueves 24 de Agosto del 06, a las 12:38:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7056,11,'                              ','Jueves 24 de Agosto del 06, a las 12:41:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7057,11,'                              ','Jueves 24 de Agosto del 06, a las 12:42:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7058,11,'                              ','Jueves 24 de Agosto del 06, a las 12:43:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7059,6,'                              ','Jueves 24 de Agosto del 06, a las 12:49:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7060,53,'                              ','Jueves 24 de Agosto del 06, a las 12:52:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7061,11,'                              ','Jueves 24 de Agosto del 06, a las 12:52:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7062,11,'                              ','Jueves 24 de Agosto del 06, a las 12:53:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7063,6,'                              ','Jueves 24 de Agosto del 06, a las 12:54:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7064,11,'                              ','Jueves 24 de Agosto del 06, a las 12:55:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7065,6,'                              ','Jueves 24 de Agosto del 06, a las 12:56:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7066,11,'                              ','Jueves 24 de Agosto del 06, a las 12:58:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7067,11,'                              ','Jueves 24 de Agosto del 06, a las 12:59:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7068,11,'                              ','Jueves 24 de Agosto del 06, a las 12:59:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7069,11,'                              ','Jueves 24 de Agosto del 06, a las 13:01:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7070,11,'                              ','Jueves 24 de Agosto del 06, a las 13:03:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7071,11,'                              ','Jueves 24 de Agosto del 06, a las 13:04:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7072,11,'                              ','Jueves 24 de Agosto del 06, a las 13:05:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7073,11,'                              ','Jueves 24 de Agosto del 06, a las 13:07:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7074,11,'                              ','Jueves 24 de Agosto del 06, a las 13:08:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7075,8,'                              ','Jueves 24 de Agosto del 06, a las 13:21:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7076,11,'                              ','Jueves 24 de Agosto del 06, a las 13:26:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7077,11,'                              ','Jueves 24 de Agosto del 06, a las 13:37:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7078,11,'                              ','Jueves 24 de Agosto del 06, a las 13:39:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7079,11,'                              ','Jueves 24 de Agosto del 06, a las 13:39:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7080,11,'                              ','Jueves 24 de Agosto del 06, a las 13:43:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7081,11,'                              ','Jueves 24 de Agosto del 06, a las 13:44:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7082,11,'                              ','Jueves 24 de Agosto del 06, a las 13:50:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7083,11,'                              ','Jueves 24 de Agosto del 06, a las 13:51:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7084,11,'                              ','Jueves 24 de Agosto del 06, a las 13:56:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7085,11,'                              ','Jueves 24 de Agosto del 06, a las 13:58:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7086,11,'                              ','Jueves 24 de Agosto del 06, a las 13:58:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7087,11,'                              ','Jueves 24 de Agosto del 06, a las 14:04:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7088,11,'                              ','Jueves 24 de Agosto del 06, a las 14:11:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7089,6,'                              ','Jueves 24 de Agosto del 06, a las 14:12:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7090,11,'                              ','Jueves 24 de Agosto del 06, a las 14:12:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7091,8,'                              ','Jueves 24 de Agosto del 06, a las 14:15:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7092,8,'                              ','Jueves 24 de Agosto del 06, a las 14:16:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7093,8,'                              ','Jueves 24 de Agosto del 06, a las 14:17:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7094,11,'                              ','Jueves 24 de Agosto del 06, a las 14:19:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7095,11,'                              ','Jueves 24 de Agosto del 06, a las 15:08:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7096,11,'                              ','Jueves 24 de Agosto del 06, a las 15:13:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7097,11,'                              ','Jueves 24 de Agosto del 06, a las 15:19:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7098,11,'                              ','Jueves 24 de Agosto del 06, a las 15:24:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7099,11,'                              ','Jueves 24 de Agosto del 06, a las 15:42:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7100,11,'                              ','Jueves 24 de Agosto del 06, a las 16:07:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7101,11,'                              ','Jueves 24 de Agosto del 06, a las 16:08:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7102,11,'                              ','Jueves 24 de Agosto del 06, a las 16:09:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7103,11,'                              ','Jueves 24 de Agosto del 06, a las 16:35:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7104,11,'                              ','Jueves 24 de Agosto del 06, a las 16:48:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7105,11,'                              ','Jueves 24 de Agosto del 06, a las 16:51:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7106,11,'                              ','Jueves 24 de Agosto del 06, a las 17:11:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7107,11,'                              ','Jueves 24 de Agosto del 06, a las 17:14:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7108,11,'                              ','Jueves 24 de Agosto del 06, a las 17:17:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7109,11,'                              ','Jueves 24 de Agosto del 06, a las 17:22:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7110,11,'                              ','Jueves 24 de Agosto del 06, a las 17:26:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7111,11,'                              ','Jueves 24 de Agosto del 06, a las 17:26:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7112,11,'                              ','Jueves 24 de Agosto del 06, a las 17:28:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7113,11,'                              ','Jueves 24 de Agosto del 06, a las 17:31:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7114,11,'                              ','Jueves 24 de Agosto del 06, a las 17:36:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7115,11,'                              ','Jueves 24 de Agosto del 06, a las 18:01:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7116,11,'                              ','Jueves 24 de Agosto del 06, a las 18:34:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7117,11,'                              ','Jueves 24 de Agosto del 06, a las 18:43:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7118,11,'                              ','Jueves 24 de Agosto del 06, a las 18:46:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7119,11,'                              ','Jueves 24 de Agosto del 06, a las 18:49:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7120,6,'                              ','Viernes 25 de Agosto del 06, a las 12:26:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7121,6,'                              ','Viernes 25 de Agosto del 06, a las 12:28:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7122,6,'                              ','Mircoles 30 de Agosto del 06, a las 12:53:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7123,6,'                              ','Mircoles 30 de Agosto del 06, a las 12:55:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7124,53,'                              ','Mircoles 30 de Agosto del 06, a las 12:58:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7125,6,'                              ','Mircoles 30 de Agosto del 06, a las 13:00:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7126,11,'                              ','Mircoles 30 de Agosto del 06, a las 13:00:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7127,8,'                              ','Mircoles 30 de Agosto del 06, a las 13:03:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7128,6,'                              ','Mircoles 30 de Agosto del 06, a las 13:06:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7129,51,'Direccion                     ','Mircoles 30 de Agosto del 06, a las 13:13:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7130,53,'                              ','Mircoles 30 de Agosto del 06, a las 13:15:55     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7131,51,'Direccion                     ','Mircoles 30 de Agosto del 06, a las 13:16:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7132,6,'                              ','Mircoles 30 de Agosto del 06, a las 13:31:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7133,53,'                              ','Jueves 31 de Agosto del 06, a las 14:59:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7134,53,'                              ','Jueves 31 de Agosto del 06, a las 15:00:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7135,6,'                              ','Jueves 31 de Agosto del 06, a las 15:04:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7136,6,'                              ','Jueves 31 de Agosto del 06, a las 15:06:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7137,6,'                              ','Jueves 31 de Agosto del 06, a las 17:04:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7138,6,'                              ','Jueves 31 de Agosto del 06, a las 17:06:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7139,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:14:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7140,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:16:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7141,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:16:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7142,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:17:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7143,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:17:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7144,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:18:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7145,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:18:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7146,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:19:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7147,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:19:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7148,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:20:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7149,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:20:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7150,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:21:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7151,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:21:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7152,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:22:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7153,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:23:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7154,6,'                              ','Viernes 1 de Septiembre del 06, a las 13:23:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7155,6,'                              ','Lunes 4 de Septiembre del 06, a las 13:03:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7156,6,'                              ','Lunes 4 de Septiembre del 06, a las 13:04:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7157,53,'                              ','Lunes 4 de Septiembre del 06, a las 13:17:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7158,6,'                              ','Lunes 4 de Septiembre del 06, a las 13:20:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7159,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:11:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7160,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:12:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7161,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:13:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7162,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:15:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7163,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:18:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7164,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:19:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7165,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:19:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7166,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:21:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7167,6,'                              ','Jueves 7 de Septiembre del 06, a las 12:22:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7168,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:49:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7169,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:50:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7170,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:51:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7171,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:53:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7172,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:56:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7173,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:56:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7174,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:57:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7175,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:58:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7176,6,'                              ','Viernes 8 de Septiembre del 06, a las 17:58:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7177,6,'                              ','Martes 12 de Septiembre del 06, a las 16:59:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7178,6,'                              ','Martes 12 de Septiembre del 06, a las 17:00:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7179,8,'                              ','Martes 12 de Septiembre del 06, a las 17:06:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7180,6,'                              ','Mircoles 13 de Septiembre del 06, a las 13:31:50 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7181,6,'                              ','Mircoles 13 de Septiembre del 06, a las 14:20:02 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7182,6,'                              ','Mircoles 13 de Septiembre del 06, a las 14:35:14 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7183,6,'                              ','Jueves 21 de Septiembre del 06, a las 15:02:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7184,6,'                              ','Martes 3 de Octubre del 06, a las 15:50:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7185,6,'                              ','Martes 3 de Octubre del 06, a las 15:52:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7186,6,'                              ','Martes 3 de Octubre del 06, a las 15:52:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7187,6,'                              ','Martes 3 de Octubre del 06, a las 15:54:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7188,6,'                              ','Martes 3 de Octubre del 06, a las 15:57:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7189,6,'                              ','Martes 3 de Octubre del 06, a las 15:58:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7190,6,'                              ','Martes 3 de Octubre del 06, a las 15:59:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7191,6,'                              ','Martes 3 de Octubre del 06, a las 15:59:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7192,6,'                              ','Martes 3 de Octubre del 06, a las 16:00:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7193,6,'                              ','Martes 3 de Octubre del 06, a las 16:13:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7194,6,'                              ','Martes 3 de Octubre del 06, a las 16:16:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7195,6,'                              ','Martes 3 de Octubre del 06, a las 16:16:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7196,6,'                              ','Martes 3 de Octubre del 06, a las 16:18:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7197,6,'                              ','Martes 3 de Octubre del 06, a las 16:22:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7198,6,'                              ','Martes 3 de Octubre del 06, a las 16:23:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7199,6,'                              ','Martes 3 de Octubre del 06, a las 16:27:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7200,6,'                              ','Martes 3 de Octubre del 06, a las 16:28:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7201,6,'                              ','Martes 3 de Octubre del 06, a las 16:34:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7202,6,'                              ','Martes 3 de Octubre del 06, a las 16:36:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7203,6,'                              ','Martes 3 de Octubre del 06, a las 16:38:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7204,6,'                              ','Martes 3 de Octubre del 06, a las 16:41:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7205,6,'                              ','Martes 3 de Octubre del 06, a las 16:43:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7206,6,'                              ','Martes 3 de Octubre del 06, a las 16:45:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7207,6,'                              ','Martes 3 de Octubre del 06, a las 16:46:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7208,6,'                              ','Martes 3 de Octubre del 06, a las 16:48:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7209,6,'                              ','Martes 3 de Octubre del 06, a las 16:50:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7210,6,'                              ','Martes 3 de Octubre del 06, a las 16:56:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7211,6,'                              ','Martes 3 de Octubre del 06, a las 19:05:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7212,6,'                              ','Martes 3 de Octubre del 06, a las 19:07:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7213,6,'                              ','Martes 3 de Octubre del 06, a las 19:07:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7214,6,'                              ','Martes 3 de Octubre del 06, a las 19:08:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7215,6,'                              ','Martes 3 de Octubre del 06, a las 19:10:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7216,6,'                              ','Martes 3 de Octubre del 06, a las 19:10:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7217,6,'                              ','Viernes 6 de Octubre del 06, a las 14:24:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7218,6,'                              ','Viernes 6 de Octubre del 06, a las 14:26:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7219,6,'                              ','Mircoles 11 de Octubre del 06, a las 12:51:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7220,6,'                              ','Mircoles 11 de Octubre del 06, a las 12:52:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7221,6,'                              ','Viernes 13 de Octubre del 06, a las 14:33:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7222,6,'                              ','Viernes 13 de Octubre del 06, a las 14:40:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7223,6,'                              ','Viernes 13 de Octubre del 06, a las 14:49:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7224,6,'                              ','Viernes 13 de Octubre del 06, a las 14:54:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7225,6,'                              ','Viernes 13 de Octubre del 06, a las 14:56:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7226,6,'                              ','Viernes 13 de Octubre del 06, a las 15:26:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7227,53,'                              ','Viernes 13 de Octubre del 06, a las 15:29:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7228,51,'Direccion                     ','Viernes 13 de Octubre del 06, a las 15:31:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7229,51,'Direccion                     ','Viernes 13 de Octubre del 06, a las 15:32:22      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7230,6,'                              ','Viernes 13 de Octubre del 06, a las 15:33:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7231,6,'                              ','Viernes 13 de Octubre del 06, a las 15:44:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7232,6,'                              ','Viernes 13 de Octubre del 06, a las 15:45:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7233,53,'                              ','Viernes 13 de Octubre del 06, a las 15:48:45      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7234,6,'                              ','Viernes 13 de Octubre del 06, a las 15:52:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7235,6,'                              ','Viernes 13 de Octubre del 06, a las 15:54:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7236,6,'                              ','Viernes 13 de Octubre del 06, a las 16:13:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7237,6,'                              ','Viernes 13 de Octubre del 06, a las 17:42:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7238,6,'                              ','Martes 17 de Octubre del 06, a las 16:14:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7239,6,'                              ','Martes 17 de Octubre del 06, a las 17:22:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7240,6,'                              ','Martes 17 de Octubre del 06, a las 17:25:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7241,6,'                              ','Martes 17 de Octubre del 06, a las 17:27:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7242,6,'                              ','Martes 17 de Octubre del 06, a las 17:29:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7243,6,'                              ','Martes 17 de Octubre del 06, a las 17:31:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7244,6,'                              ','Martes 17 de Octubre del 06, a las 17:32:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7245,6,'                              ','Martes 17 de Octubre del 06, a las 17:40:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7246,6,'                              ','Martes 17 de Octubre del 06, a las 17:41:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7247,6,'                              ','Martes 17 de Octubre del 06, a las 17:41:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7248,6,'                              ','Mircoles 18 de Octubre del 06, a las 12:27:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7249,6,'                              ','Mircoles 18 de Octubre del 06, a las 12:30:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7250,11,'                              ','Mircoles 18 de Octubre del 06, a las 12:30:17    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7251,6,'                              ','Mircoles 18 de Octubre del 06, a las 12:34:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7252,11,'                              ','Mircoles 18 de Octubre del 06, a las 12:34:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7253,6,'                              ','Mircoles 18 de Octubre del 06, a las 12:37:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7254,11,'                              ','Mircoles 18 de Octubre del 06, a las 12:38:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7255,53,'                              ','Mircoles 18 de Octubre del 06, a las 12:48:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7256,6,'                              ','Mircoles 18 de Octubre del 06, a las 12:49:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7257,11,'                              ','Mircoles 18 de Octubre del 06, a las 12:49:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7258,53,'                              ','Mircoles 18 de Octubre del 06, a las 13:00:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7259,6,'                              ','Mircoles 18 de Octubre del 06, a las 13:01:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7260,6,'                              ','Mircoles 18 de Octubre del 06, a las 13:03:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7261,53,'                              ','Mircoles 18 de Octubre del 06, a las 13:11:02    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7262,6,'                              ','Mircoles 18 de Octubre del 06, a las 13:14:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7263,6,'                              ','Mircoles 18 de Octubre del 06, a las 13:16:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7264,53,'                              ','Mircoles 18 de Octubre del 06, a las 13:19:46    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7265,11,'                              ','Mircoles 18 de Octubre del 06, a las 13:36:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7266,8,'                              ','Jueves 19 de Octubre del 06, a las 13:15:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7267,8,'                              ','Jueves 19 de Octubre del 06, a las 13:16:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7268,8,'                              ','Jueves 19 de Octubre del 06, a las 13:17:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7269,8,'                              ','Jueves 19 de Octubre del 06, a las 13:18:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7270,8,'                              ','Jueves 19 de Octubre del 06, a las 13:18:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7271,8,'                              ','Jueves 19 de Octubre del 06, a las 13:20:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7272,2,'Bib Datos Propopios           ','Jueves 19 de Octubre del 06, a las 13:20:43       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7273,8,'                              ','Jueves 19 de Octubre del 06, a las 13:21:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7274,8,'                              ','Jueves 19 de Octubre del 06, a las 13:21:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7275,8,'                              ','Jueves 19 de Octubre del 06, a las 13:22:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7276,8,'                              ','Jueves 19 de Octubre del 06, a las 13:23:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7277,2,'Bib Datos Propopios           ','Jueves 19 de Octubre del 06, a las 13:23:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7278,8,'                              ','Jueves 19 de Octubre del 06, a las 13:24:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7279,8,'                              ','Jueves 19 de Octubre del 06, a las 13:24:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7280,2,'Bib Datos Propopios           ','Jueves 19 de Octubre del 06, a las 13:25:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7281,8,'                              ','Jueves 19 de Octubre del 06, a las 13:25:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7282,6,'                              ','Jueves 19 de Octubre del 06, a las 14:17:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7283,6,'                              ','Jueves 19 de Octubre del 06, a las 14:59:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7284,53,'                              ','Jueves 19 de Octubre del 06, a las 14:59:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7285,4,'                              ','Jueves 19 de Octubre del 06, a las 15:17:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7286,6,'                              ','Jueves 19 de Octubre del 06, a las 15:34:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7287,53,'                              ','Jueves 19 de Octubre del 06, a las 15:36:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7288,53,'                              ','Jueves 19 de Octubre del 06, a las 15:40:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7289,6,'                              ','Jueves 19 de Octubre del 06, a las 15:40:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7290,6,'                              ','Jueves 19 de Octubre del 06, a las 15:53:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7291,6,'                              ','Jueves 19 de Octubre del 06, a las 15:55:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7292,6,'                              ','Jueves 19 de Octubre del 06, a las 16:00:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7293,6,'                              ','Jueves 19 de Octubre del 06, a las 16:06:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7294,53,'                              ','Jueves 19 de Octubre del 06, a las 16:09:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7295,53,'                              ','Jueves 19 de Octubre del 06, a las 16:10:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7296,6,'                              ','Jueves 19 de Octubre del 06, a las 16:11:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7297,6,'                              ','Jueves 19 de Octubre del 06, a las 16:12:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7298,6,'                              ','Jueves 19 de Octubre del 06, a las 16:13:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7299,6,'                              ','Jueves 19 de Octubre del 06, a las 16:16:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7300,53,'                              ','Jueves 19 de Octubre del 06, a las 16:40:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7301,6,'                              ','Jueves 19 de Octubre del 06, a las 16:41:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7302,6,'                              ','Jueves 19 de Octubre del 06, a las 16:42:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7303,53,'                              ','Jueves 19 de Octubre del 06, a las 16:43:37       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7304,6,'                              ','Jueves 19 de Octubre del 06, a las 17:08:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7305,6,'                              ','Jueves 19 de Octubre del 06, a las 17:11:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7306,6,'                              ','Jueves 19 de Octubre del 06, a las 17:13:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7307,6,'                              ','Jueves 19 de Octubre del 06, a las 17:16:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7308,6,'                              ','Jueves 19 de Octubre del 06, a las 17:18:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7309,6,'                              ','Jueves 19 de Octubre del 06, a las 17:22:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7310,6,'                              ','Jueves 19 de Octubre del 06, a las 17:25:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7311,6,'                              ','Lunes 23 de Octubre del 06, a las 14:09:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7312,53,'                              ','Martes 24 de Octubre del 06, a las 10:49:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7313,53,'                              ','Martes 24 de Octubre del 06, a las 10:51:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7314,6,'                              ','Martes 24 de Octubre del 06, a las 10:51:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7315,6,'                              ','Martes 24 de Octubre del 06, a las 11:17:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7316,6,'                              ','Martes 24 de Octubre del 06, a las 11:20:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7317,53,'                              ','Martes 24 de Octubre del 06, a las 11:20:44       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7318,6,'                              ','Martes 24 de Octubre del 06, a las 11:22:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7319,53,'                              ','Martes 24 de Octubre del 06, a las 11:23:31       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7320,6,'                              ','Martes 24 de Octubre del 06, a las 11:23:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7321,6,'                              ','Martes 24 de Octubre del 06, a las 11:24:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7322,53,'                              ','Martes 24 de Octubre del 06, a las 11:34:20       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7323,6,'                              ','Martes 24 de Octubre del 06, a las 11:44:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7324,6,'                              ','Martes 24 de Octubre del 06, a las 11:46:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7325,53,'                              ','Martes 24 de Octubre del 06, a las 11:50:06       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7326,53,'                              ','Martes 24 de Octubre del 06, a las 11:50:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7327,53,'                              ','Martes 24 de Octubre del 06, a las 11:52:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7328,6,'                              ','Martes 24 de Octubre del 06, a las 12:33:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7329,6,'                              ','Martes 24 de Octubre del 06, a las 12:34:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7330,6,'                              ','Martes 24 de Octubre del 06, a las 12:35:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7331,53,'                              ','Martes 24 de Octubre del 06, a las 12:35:35       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7332,6,'                              ','Martes 24 de Octubre del 06, a las 12:38:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7333,6,'                              ','Martes 24 de Octubre del 06, a las 12:51:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7334,6,'                              ','Martes 24 de Octubre del 06, a las 12:52:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7335,53,'                              ','Martes 24 de Octubre del 06, a las 12:52:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7336,6,'                              ','Martes 24 de Octubre del 06, a las 12:54:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7337,6,'                              ','Martes 24 de Octubre del 06, a las 12:56:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7338,6,'                              ','Martes 24 de Octubre del 06, a las 12:57:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7339,6,'                              ','Martes 24 de Octubre del 06, a las 12:58:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7340,8,'                              ','Martes 24 de Octubre del 06, a las 13:16:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7341,8,'                              ','Martes 24 de Octubre del 06, a las 13:16:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7342,8,'                              ','Martes 24 de Octubre del 06, a las 13:17:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7343,8,'                              ','Martes 24 de Octubre del 06, a las 13:18:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7344,8,'                              ','Martes 24 de Octubre del 06, a las 13:48:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7345,6,'                              ','Martes 24 de Octubre del 06, a las 13:57:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7346,6,'                              ','Martes 24 de Octubre del 06, a las 14:12:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7347,6,'                              ','Martes 24 de Octubre del 06, a las 14:19:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7348,6,'                              ','Martes 24 de Octubre del 06, a las 14:29:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7349,53,'                              ','Martes 24 de Octubre del 06, a las 14:57:51       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7350,6,'                              ','Martes 24 de Octubre del 06, a las 14:59:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7351,53,'                              ','Martes 24 de Octubre del 06, a las 15:00:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7352,6,'                              ','Martes 24 de Octubre del 06, a las 15:01:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7353,6,'                              ','Martes 24 de Octubre del 06, a las 15:03:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7354,6,'                              ','Martes 24 de Octubre del 06, a las 15:04:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7355,53,'                              ','Martes 24 de Octubre del 06, a las 15:12:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7356,6,'                              ','Martes 24 de Octubre del 06, a las 16:24:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7357,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:22:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7358,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:23:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7359,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:43:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7360,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:47:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7361,11,'                              ','Mircoles 25 de Octubre del 06, a las 14:49:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7362,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:51:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7363,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:53:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7364,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:54:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7365,8,'                              ','Mircoles 25 de Octubre del 06, a las 14:55:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7366,8,'                              ','Mircoles 25 de Octubre del 06, a las 17:50:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7367,8,'                              ','Mircoles 25 de Octubre del 06, a las 17:52:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7368,8,'                              ','Mircoles 25 de Octubre del 06, a las 17:54:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7369,8,'                              ','Mircoles 25 de Octubre del 06, a las 17:56:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7370,2,'Bib Datos Propopios           ','Mircoles 25 de Octubre del 06, a las 20:12:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7371,2,'Bib Datos Propopios           ','Mircoles 25 de Octubre del 06, a las 20:12:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7372,8,'                              ','Jueves 26 de Octubre del 06, a las 16:51:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7373,8,'                              ','Jueves 26 de Octubre del 06, a las 16:52:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7374,8,'                              ','Jueves 26 de Octubre del 06, a las 16:57:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7375,8,'                              ','Jueves 26 de Octubre del 06, a las 17:02:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7376,8,'                              ','Jueves 26 de Octubre del 06, a las 17:04:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7377,8,'                              ','Jueves 26 de Octubre del 06, a las 17:05:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7378,8,'                              ','Jueves 26 de Octubre del 06, a las 17:05:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7379,8,'                              ','Jueves 26 de Octubre del 06, a las 17:08:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7380,8,'                              ','Jueves 26 de Octubre del 06, a las 17:10:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7381,8,'                              ','Jueves 26 de Octubre del 06, a las 17:11:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7382,8,'                              ','Jueves 26 de Octubre del 06, a las 17:15:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7383,8,'                              ','Jueves 26 de Octubre del 06, a las 17:16:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7384,8,'                              ','Jueves 26 de Octubre del 06, a las 17:23:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7385,8,'                              ','Jueves 26 de Octubre del 06, a las 17:30:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7386,8,'                              ','Jueves 26 de Octubre del 06, a las 17:32:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7387,8,'                              ','Jueves 26 de Octubre del 06, a las 17:53:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7388,8,'                              ','Viernes 27 de Octubre del 06, a las 17:17:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7389,8,'                              ','Viernes 27 de Octubre del 06, a las 17:20:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7390,8,'                              ','Viernes 27 de Octubre del 06, a las 17:21:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7391,8,'                              ','Viernes 27 de Octubre del 06, a las 17:23:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7392,8,'                              ','Viernes 27 de Octubre del 06, a las 17:24:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7393,8,'                              ','Viernes 27 de Octubre del 06, a las 17:26:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7394,8,'                              ','Viernes 27 de Octubre del 06, a las 17:27:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7395,8,'                              ','Viernes 27 de Octubre del 06, a las 17:28:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7396,6,'                              ','Lunes 30 de Octubre del 06, a las 11:47:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7397,6,'                              ','Lunes 30 de Octubre del 06, a las 11:51:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7398,6,'                              ','Lunes 30 de Octubre del 06, a las 11:55:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7399,6,'                              ','Lunes 30 de Octubre del 06, a las 11:58:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7400,6,'                              ','Lunes 30 de Octubre del 06, a las 11:59:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7401,8,'                              ','Martes 31 de Octubre del 06, a las 16:08:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7402,8,'                              ','Martes 31 de Octubre del 06, a las 16:14:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7403,8,'                              ','Martes 31 de Octubre del 06, a las 16:15:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7404,8,'                              ','Martes 31 de Octubre del 06, a las 16:18:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7405,8,'                              ','Martes 31 de Octubre del 06, a las 16:19:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7406,8,'                              ','Martes 31 de Octubre del 06, a las 16:24:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7407,8,'                              ','Martes 31 de Octubre del 06, a las 16:24:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7408,8,'                              ','Martes 31 de Octubre del 06, a las 16:33:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7409,8,'                              ','Martes 31 de Octubre del 06, a las 16:37:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7410,8,'                              ','Martes 31 de Octubre del 06, a las 16:39:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7411,8,'                              ','Martes 31 de Octubre del 06, a las 16:40:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7412,8,'                              ','Martes 31 de Octubre del 06, a las 16:42:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7413,8,'                              ','Martes 31 de Octubre del 06, a las 16:43:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7414,8,'                              ','Martes 31 de Octubre del 06, a las 16:45:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7415,8,'                              ','Martes 31 de Octubre del 06, a las 16:49:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7416,8,'                              ','Martes 31 de Octubre del 06, a las 16:50:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7417,8,'                              ','Martes 31 de Octubre del 06, a las 16:53:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7418,8,'                              ','Martes 31 de Octubre del 06, a las 16:56:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7419,8,'                              ','Martes 31 de Octubre del 06, a las 16:57:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7420,8,'                              ','Martes 31 de Octubre del 06, a las 16:59:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7421,8,'                              ','Martes 31 de Octubre del 06, a las 17:03:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7422,8,'                              ','Martes 31 de Octubre del 06, a las 17:04:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7423,8,'                              ','Martes 31 de Octubre del 06, a las 17:07:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7424,8,'                              ','Martes 31 de Octubre del 06, a las 17:10:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7425,8,'                              ','Martes 31 de Octubre del 06, a las 17:12:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7426,8,'                              ','Martes 31 de Octubre del 06, a las 17:14:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7427,8,'                              ','Martes 31 de Octubre del 06, a las 17:16:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7428,8,'                              ','Martes 31 de Octubre del 06, a las 17:20:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7429,8,'                              ','Martes 31 de Octubre del 06, a las 17:24:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7430,8,'                              ','Martes 31 de Octubre del 06, a las 17:24:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7431,8,'                              ','Martes 31 de Octubre del 06, a las 17:24:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7432,8,'                              ','Martes 31 de Octubre del 06, a las 17:28:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7433,8,'                              ','Viernes 3 de Noviembre del 06, a las 13:17:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7434,8,'                              ','Viernes 3 de Noviembre del 06, a las 13:19:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7435,8,'                              ','Viernes 3 de Noviembre del 06, a las 13:25:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7436,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:04:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7437,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:10:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7438,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:11:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7439,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:11:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7440,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:13:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7441,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:14:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7442,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:15:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7443,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:15:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7444,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:15:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7445,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:16:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7446,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:16:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7447,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:16:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7448,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:17:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7449,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:18:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7450,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:19:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7451,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:19:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7452,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:20:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7453,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:21:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7454,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:22:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7455,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:23:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7456,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:36:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7457,11,'                              ','Viernes 3 de Noviembre del 06, a las 14:39:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7458,8,'                              ','Viernes 3 de Noviembre del 06, a las 14:42:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7459,11,'                              ','Viernes 3 de Noviembre del 06, a las 14:44:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7460,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:09:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7461,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:22:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7462,11,'                              ','Viernes 3 de Noviembre del 06, a las 15:24:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7463,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:31:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7464,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:32:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7465,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:34:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7466,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:37:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7467,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:39:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7468,11,'                              ','Viernes 3 de Noviembre del 06, a las 15:41:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7469,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:49:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7470,11,'                              ','Viernes 3 de Noviembre del 06, a las 15:52:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7471,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:54:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7472,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:56:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7473,8,'                              ','Viernes 3 de Noviembre del 06, a las 15:57:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7474,11,'                              ','Viernes 3 de Noviembre del 06, a las 16:03:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7475,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:09:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7476,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:11:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7477,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:12:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7478,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:16:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7479,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:18:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7480,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:18:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7481,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:23:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7482,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:24:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7483,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:32:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7484,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:34:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7485,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:34:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7486,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:35:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7487,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:36:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7488,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:39:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7489,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:41:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7490,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:42:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7491,11,'                              ','Viernes 3 de Noviembre del 06, a las 16:45:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7492,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:55:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7493,8,'                              ','Viernes 3 de Noviembre del 06, a las 16:57:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7494,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:05:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7495,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:09:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7496,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:14:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7497,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:16:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7498,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:18:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7499,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:21:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7500,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:24:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7501,8,'                              ','Viernes 3 de Noviembre del 06, a las 17:36:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7502,8,'                              ','Lunes 6 de Noviembre del 06, a las 16:35:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7503,11,'                              ','Lunes 6 de Noviembre del 06, a las 16:36:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7504,11,'                              ','Lunes 6 de Noviembre del 06, a las 16:37:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7505,8,'                              ','Lunes 6 de Noviembre del 06, a las 16:45:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7506,8,'                              ','Lunes 6 de Noviembre del 06, a las 16:46:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7507,11,'                              ','Lunes 6 de Noviembre del 06, a las 16:47:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7508,8,'                              ','Lunes 6 de Noviembre del 06, a las 16:52:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7509,11,'                              ','Lunes 6 de Noviembre del 06, a las 16:53:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7510,8,'                              ','Lunes 6 de Noviembre del 06, a las 16:59:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7511,8,'                              ','Lunes 6 de Noviembre del 06, a las 17:00:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7512,11,'                              ','Lunes 6 de Noviembre del 06, a las 17:01:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7513,8,'                              ','Lunes 6 de Noviembre del 06, a las 17:03:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7514,11,'                              ','Mircoles 8 de Noviembre del 06, a las 13:37:28   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7515,8,'                              ','Mircoles 8 de Noviembre del 06, a las 13:49:25   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7516,8,'                              ','Mircoles 8 de Noviembre del 06, a las 13:55:13   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7517,11,'                              ','Mircoles 8 de Noviembre del 06, a las 13:56:31   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7518,8,'                              ','Mircoles 8 de Noviembre del 06, a las 14:05:54   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7519,8,'                              ','Mircoles 8 de Noviembre del 06, a las 14:14:33   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7520,8,'                              ','Mircoles 8 de Noviembre del 06, a las 14:50:37   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7521,8,'                              ','Mircoles 8 de Noviembre del 06, a las 14:52:25   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7522,8,'                              ','Mircoles 8 de Noviembre del 06, a las 14:55:20   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7523,8,'                              ','Mircoles 8 de Noviembre del 06, a las 14:58:49   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7524,8,'                              ','Mircoles 8 de Noviembre del 06, a las 15:02:40   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7525,6,'                              ','Viernes 17 de Noviembre del 06, a las 18:07:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7526,6,'                              ','Viernes 17 de Noviembre del 06, a las 18:17:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7527,6,'                              ','Viernes 17 de Noviembre del 06, a las 18:26:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7528,6,'                              ','Viernes 17 de Noviembre del 06, a las 18:28:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7529,6,'                              ','Viernes 17 de Noviembre del 06, a las 18:28:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7530,6,'                              ','Viernes 17 de Noviembre del 06, a las 18:49:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7531,6,'                              ','Viernes 17 de Noviembre del 06, a las 19:49:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7532,6,'                              ','Viernes 17 de Noviembre del 06, a las 19:49:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7533,6,'                              ','Viernes 17 de Noviembre del 06, a las 19:50:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7534,6,'                              ','Viernes 17 de Noviembre del 06, a las 19:50:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7535,6,'                              ','Martes 21 de Noviembre del 06, a las 15:45:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7536,6,'                              ','Martes 21 de Noviembre del 06, a las 20:21:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7537,6,'                              ','Martes 21 de Noviembre del 06, a las 20:24:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7538,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:25:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7539,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:28:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7540,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:31:03     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7541,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:31:12     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7542,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:35:53     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7543,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:36:03     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7544,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:38:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7545,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:38:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7546,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:40:40     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7547,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:40:49     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7548,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:40:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7549,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:41:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7550,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:44:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7551,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:44:35     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7552,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:44:44     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7553,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:44:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7554,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:45:45     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7555,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:45:51     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7556,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:46:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7557,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:46:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7558,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:47:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7559,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:47:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7560,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:56:27     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7561,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:56:34     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7562,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:56:43     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7563,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:56:51     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7564,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:57:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7565,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:57:28     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7566,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:57:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7567,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:57:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7568,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 16:58:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7569,53,'                              ','Jueves 23 de Noviembre del 06, a las 16:58:30     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7570,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:00:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7571,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:00:48     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7572,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:00:58     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7573,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:01:23     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7574,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:01:33     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7575,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:01:58     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7576,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:02:07     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7577,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:08:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7578,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:09:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7579,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:09:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7580,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:10:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7581,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:10:30     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7582,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:10:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7583,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:11:07     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7584,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:11:59     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7585,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:12:29     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7586,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:12:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7587,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:13:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7588,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:13:19     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7589,51,'Direccion                     ','Jueves 23 de Noviembre del 06, a las 17:13:47     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7590,53,'                              ','Jueves 23 de Noviembre del 06, a las 17:13:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7591,8,'                              ','Jueves 30 de Noviembre del 06, a las 11:49:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7592,8,'                              ','Jueves 30 de Noviembre del 06, a las 11:52:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7593,8,'                              ','Jueves 30 de Noviembre del 06, a las 11:54:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7594,8,'                              ','Jueves 30 de Noviembre del 06, a las 11:55:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7595,8,'                              ','Lunes 4 de Diciembre del 06, a las 11:48:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7596,8,'                              ','Lunes 4 de Diciembre del 06, a las 11:48:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7597,8,'                              ','Lunes 4 de Diciembre del 06, a las 11:49:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7598,8,'                              ','Lunes 4 de Diciembre del 06, a las 11:50:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7599,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:06:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7600,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:07:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7601,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:10:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7602,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:12:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7603,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:15:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7604,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:17:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7605,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:33:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7606,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:34:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7607,8,'                              ','Lunes 4 de Diciembre del 06, a las 12:34:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7608,8,'                              ','Lunes 4 de Diciembre del 06, a las 13:11:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7609,8,'                              ','Lunes 4 de Diciembre del 06, a las 13:55:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7610,8,'                              ','Lunes 4 de Diciembre del 06, a las 14:07:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7611,8,'                              ','Lunes 4 de Diciembre del 06, a las 14:15:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7612,6,'                              ','Lunes 4 de Diciembre del 06, a las 14:59:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7613,8,'                              ','Lunes 4 de Diciembre del 06, a las 15:02:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7614,8,'                              ','Lunes 4 de Diciembre del 06, a las 15:05:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7615,8,'                              ','Lunes 4 de Diciembre del 06, a las 15:06:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7616,8,'                              ','Lunes 4 de Diciembre del 06, a las 15:17:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7617,4,'                              ','Lunes 4 de Diciembre del 06, a las 17:07:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7618,4,'                              ','Lunes 4 de Diciembre del 06, a las 17:08:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7619,4,'                              ','Lunes 4 de Diciembre del 06, a las 17:12:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7620,4,'                              ','Martes 5 de Diciembre del 06, a las 15:37:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7621,4,'                              ','Martes 5 de Diciembre del 06, a las 15:38:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7622,4,'                              ','Martes 5 de Diciembre del 06, a las 15:40:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7623,53,'                              ','Martes 5 de Diciembre del 06, a las 16:04:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7624,8,'                              ','Mircoles 6 de Diciembre del 06, a las 12:51:13   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7625,8,'                              ','Mircoles 6 de Diciembre del 06, a las 12:51:41   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7626,8,'                              ','Mircoles 6 de Diciembre del 06, a las 13:40:53   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7627,6,'                              ','Mircoles 6 de Diciembre del 06, a las 14:27:49   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7628,6,'                              ','Mircoles 6 de Diciembre del 06, a las 14:31:30   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7629,6,'                              ','Mircoles 6 de Diciembre del 06, a las 14:35:01   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7630,6,'                              ','Mircoles 6 de Diciembre del 06, a las 14:36:52   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7631,53,'                              ','Mircoles 6 de Diciembre del 06, a las 14:38:09   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7632,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:00:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7633,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:01:50  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7634,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:03:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7635,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:04:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7636,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:07:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7637,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:10:07  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7638,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:10:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7639,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:12:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7640,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:16:16  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7641,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:17:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7642,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:22:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7643,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:23:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7644,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:24:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7645,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:25:06  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7646,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:27:05  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7647,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:28:06  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7648,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:29:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7649,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:31:20  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7650,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:31:57  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7651,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:35:57  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7652,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:38:03  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7653,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:38:45  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7654,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:39:30  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7655,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:40:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7656,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:40:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7657,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:41:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7658,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:42:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7659,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:43:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7660,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:44:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7661,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:45:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7662,8,'                              ','Mircoles 13 de Diciembre del 06, a las 13:46:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7663,6,'                              ','Mircoles 17 de Enero del 07, a las 11:00:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7664,6,'                              ','Mircoles 17 de Enero del 07, a las 11:02:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7665,6,'                              ','Mircoles 17 de Enero del 07, a las 11:03:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7666,6,'                              ','Mircoles 17 de Enero del 07, a las 11:06:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7667,6,'                              ','Mircoles 17 de Enero del 07, a las 11:11:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7668,4,'                              ','Mircoles 17 de Enero del 07, a las 12:57:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7669,2,'Bib Datos Propopios           ','Mircoles 17 de Enero del 07, a las 12:58:50      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7670,4,'                              ','Mircoles 17 de Enero del 07, a las 13:48:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7671,4,'                              ','Mircoles 17 de Enero del 07, a las 13:49:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7672,4,'                              ','Mircoles 17 de Enero del 07, a las 14:00:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7673,4,'                              ','Mircoles 17 de Enero del 07, a las 16:01:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7674,4,'                              ','Mircoles 17 de Enero del 07, a las 16:02:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7675,4,'                              ','Mircoles 17 de Enero del 07, a las 16:03:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7676,4,'                              ','Mircoles 17 de Enero del 07, a las 16:05:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7677,2,'Bib Datos Propopios           ','Mircoles 17 de Enero del 07, a las 16:07:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7678,4,'                              ','Mircoles 17 de Enero del 07, a las 16:08:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7679,4,'                              ','Mircoles 17 de Enero del 07, a las 16:09:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7680,4,'                              ','Mircoles 17 de Enero del 07, a las 16:11:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7681,4,'                              ','Mircoles 17 de Enero del 07, a las 16:12:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7682,2,'Bib Datos Propopios           ','Mircoles 17 de Enero del 07, a las 16:16:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7683,4,'                              ','Mircoles 17 de Enero del 07, a las 16:17:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7684,4,'                              ','Mircoles 17 de Enero del 07, a las 16:22:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7685,4,'                              ','Mircoles 17 de Enero del 07, a las 16:24:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7686,4,'                              ','Jueves 18 de Enero del 07, a las 10:51:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7687,2,'Bib Datos Propopios           ','Jueves 18 de Enero del 07, a las 10:51:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7688,4,'                              ','Jueves 18 de Enero del 07, a las 10:53:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7689,4,'                              ','Jueves 18 de Enero del 07, a las 10:56:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7690,6,'                              ','Lunes 22 de Enero del 07, a las 15:14:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7691,6,'                              ','Lunes 22 de Enero del 07, a las 15:21:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7692,6,'                              ','Lunes 22 de Enero del 07, a las 15:22:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7693,6,'                              ','Lunes 22 de Enero del 07, a las 15:29:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7694,6,'                              ','Lunes 22 de Enero del 07, a las 15:32:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7695,6,'                              ','Lunes 22 de Enero del 07, a las 15:46:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7696,6,'                              ','Lunes 22 de Enero del 07, a las 15:52:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7697,6,'                              ','Lunes 22 de Enero del 07, a las 15:54:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7698,6,'                              ','Lunes 22 de Enero del 07, a las 16:11:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7699,6,'                              ','Lunes 22 de Enero del 07, a las 16:13:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7700,6,'                              ','Lunes 22 de Enero del 07, a las 16:17:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7701,6,'                              ','Martes 23 de Enero del 07, a las 14:13:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7702,6,'                              ','Martes 23 de Enero del 07, a las 15:53:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7703,6,'                              ','Martes 23 de Enero del 07, a las 15:54:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7704,11,'                              ','Martes 23 de Enero del 07, a las 15:55:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7705,6,'                              ','Martes 23 de Enero del 07, a las 15:58:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7706,6,'                              ','Martes 23 de Enero del 07, a las 16:01:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7707,6,'                              ','Martes 23 de Enero del 07, a las 16:04:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7708,6,'                              ','Martes 23 de Enero del 07, a las 16:07:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7709,6,'                              ','Martes 23 de Enero del 07, a las 16:09:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7710,6,'                              ','Martes 23 de Enero del 07, a las 16:13:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7711,6,'                              ','Martes 23 de Enero del 07, a las 16:16:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7712,6,'                              ','Mircoles 24 de Enero del 07, a las 11:04:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7713,6,'                              ','Mircoles 24 de Enero del 07, a las 11:25:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7714,6,'                              ','Mircoles 24 de Enero del 07, a las 11:33:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7715,6,'                              ','Mircoles 24 de Enero del 07, a las 11:40:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7716,4,'                              ','Mircoles 24 de Enero del 07, a las 11:41:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7717,4,'                              ','Mircoles 24 de Enero del 07, a las 11:42:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7718,2,'Bib Datos Propopios           ','Mircoles 24 de Enero del 07, a las 11:43:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7719,2,'Bib Datos Propopios           ','Mircoles 24 de Enero del 07, a las 11:44:59      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7720,6,'                              ','Mircoles 24 de Enero del 07, a las 11:56:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7721,6,'                              ','Mircoles 24 de Enero del 07, a las 12:14:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7722,6,'                              ','Mircoles 24 de Enero del 07, a las 12:21:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7723,6,'                              ','Mircoles 24 de Enero del 07, a las 12:27:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7724,11,'                              ','Mircoles 24 de Enero del 07, a las 12:40:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7725,11,'                              ','Mircoles 24 de Enero del 07, a las 12:41:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7726,6,'                              ','Mircoles 24 de Enero del 07, a las 12:50:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7727,53,'                              ','Mircoles 24 de Enero del 07, a las 13:04:01      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7728,53,'                              ','Mircoles 24 de Enero del 07, a las 13:14:05      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7729,6,'                              ','Mircoles 24 de Enero del 07, a las 13:29:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7730,6,'                              ','Mircoles 24 de Enero del 07, a las 13:29:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7731,11,'                              ','Mircoles 24 de Enero del 07, a las 13:30:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7732,53,'                              ','Mircoles 24 de Enero del 07, a las 13:34:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7733,53,'                              ','Mircoles 24 de Enero del 07, a las 13:35:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7734,6,'                              ','Mircoles 24 de Enero del 07, a las 14:33:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7735,6,'                              ','Jueves 25 de Enero del 07, a las 12:32:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7736,6,'                              ','Jueves 25 de Enero del 07, a las 12:33:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7737,6,'                              ','Jueves 25 de Enero del 07, a las 15:57:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7738,6,'                              ','Jueves 25 de Enero del 07, a las 16:02:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7739,51,'Direccion                     ','Jueves 25 de Enero del 07, a las 16:05:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7740,51,'Direccion                     ','Jueves 25 de Enero del 07, a las 16:08:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7741,4,'                              ','Viernes 26 de Enero del 07, a las 10:39:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7742,2,'Bib Datos Propopios           ','Viernes 26 de Enero del 07, a las 10:39:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7743,6,'                              ','Viernes 26 de Enero del 07, a las 10:39:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7744,2,'Bib Datos Propopios           ','Viernes 26 de Enero del 07, a las 10:40:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7745,2,'Bib Datos Propopios           ','Viernes 26 de Enero del 07, a las 10:49:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7746,2,'Bib Datos Propopios           ','Lunes 29 de Enero del 07, a las 12:48:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7747,2,'Bib Datos Propopios           ','Lunes 29 de Enero del 07, a las 12:50:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7748,2,'Bib Datos Propopios           ','Lunes 29 de Enero del 07, a las 12:51:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7749,2,'Bib Datos Propopios           ','Martes 30 de Enero del 07, a las 18:41:15         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7750,2,'Bib Datos Propopios           ','Mircoles 31 de Enero del 07, a las 16:10:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7751,2,'Bib Datos Propopios           ','Mircoles 31 de Enero del 07, a las 16:12:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7752,53,'                              ','Mircoles 7 de Febrero del 07, a las 10:30:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7753,6,'                              ','Mircoles 7 de Febrero del 07, a las 10:31:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7754,51,'Direccion                     ','Mircoles 7 de Febrero del 07, a las 10:32:32     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7755,51,'Direccion                     ','Mircoles 7 de Febrero del 07, a las 10:34:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7756,53,'                              ','Mircoles 7 de Febrero del 07, a las 11:05:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7757,53,'                              ','Mircoles 7 de Febrero del 07, a las 11:07:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7758,51,'Direccion                     ','Mircoles 7 de Febrero del 07, a las 11:09:54     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7759,51,'Direccion                     ','Mircoles 7 de Febrero del 07, a las 11:10:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7760,51,'Direccion                     ','Mircoles 7 de Febrero del 07, a las 11:14:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7761,53,'                              ','Mircoles 7 de Febrero del 07, a las 11:15:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7762,53,'                              ','Jueves 8 de Febrero del 07, a las 14:18:56        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7763,51,'Direccion                     ','Jueves 8 de Febrero del 07, a las 14:20:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7764,53,'                              ','Jueves 8 de Febrero del 07, a las 14:21:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7765,53,'                              ','Jueves 8 de Febrero del 07, a las 14:22:11        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7766,53,'                              ','Jueves 8 de Febrero del 07, a las 14:22:46        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7767,53,'                              ','Jueves 8 de Febrero del 07, a las 14:23:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7768,53,'                              ','Jueves 8 de Febrero del 07, a las 14:23:42        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7769,53,'                              ','Jueves 8 de Febrero del 07, a las 14:23:58        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7770,53,'                              ','Jueves 8 de Febrero del 07, a las 14:24:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7771,53,'                              ','Jueves 8 de Febrero del 07, a las 14:24:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7772,53,'                              ','Jueves 8 de Febrero del 07, a las 14:24:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7773,53,'                              ','Jueves 8 de Febrero del 07, a las 14:27:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7774,51,'Direccion                     ','Jueves 8 de Febrero del 07, a las 14:29:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7775,2,'Bib Datos Propopios           ','Jueves 8 de Febrero del 07, a las 14:36:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7776,2,'Bib Datos Propopios           ','Jueves 8 de Febrero del 07, a las 14:42:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7777,2,'Bib Datos Propopios           ','Jueves 8 de Febrero del 07, a las 14:47:33        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7778,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 11:11:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7779,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 11:12:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7780,53,'                              ','Lunes 19 de Febrero del 07, a las 11:13:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7781,53,'                              ','Lunes 19 de Febrero del 07, a las 11:13:49        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7782,6,'                              ','Lunes 19 de Febrero del 07, a las 11:16:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7783,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 11:23:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7784,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 11:24:43        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7785,53,'                              ','Lunes 19 de Febrero del 07, a las 12:28:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7786,6,'                              ','Lunes 19 de Febrero del 07, a las 12:29:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7787,53,'                              ','Lunes 19 de Febrero del 07, a las 12:37:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7788,6,'                              ','Lunes 19 de Febrero del 07, a las 12:38:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7789,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 12:40:52        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7790,53,'                              ','Lunes 19 de Febrero del 07, a las 12:47:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7791,6,'                              ','Lunes 19 de Febrero del 07, a las 12:49:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7792,53,'                              ','Lunes 19 de Febrero del 07, a las 13:01:46        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7793,6,'                              ','Lunes 19 de Febrero del 07, a las 13:03:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7794,6,'                              ','Lunes 19 de Febrero del 07, a las 13:04:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7795,6,'                              ','Lunes 19 de Febrero del 07, a las 13:05:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7796,53,'                              ','Lunes 19 de Febrero del 07, a las 13:08:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7797,6,'                              ','Lunes 19 de Febrero del 07, a las 13:10:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7798,53,'                              ','Lunes 19 de Febrero del 07, a las 13:11:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7799,6,'                              ','Lunes 19 de Febrero del 07, a las 13:12:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7800,53,'                              ','Lunes 19 de Febrero del 07, a las 13:16:29        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7801,53,'                              ','Lunes 19 de Febrero del 07, a las 13:16:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7802,6,'                              ','Lunes 19 de Febrero del 07, a las 14:43:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7803,6,'                              ','Lunes 19 de Febrero del 07, a las 14:44:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7804,6,'                              ','Lunes 19 de Febrero del 07, a las 14:46:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7805,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 14:48:48        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7806,6,'                              ','Lunes 19 de Febrero del 07, a las 14:52:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7807,6,'                              ','Lunes 19 de Febrero del 07, a las 14:52:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7808,53,'                              ','Lunes 19 de Febrero del 07, a las 14:54:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7809,53,'                              ','Lunes 19 de Febrero del 07, a las 14:56:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7810,53,'                              ','Lunes 19 de Febrero del 07, a las 14:56:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7811,53,'                              ','Lunes 19 de Febrero del 07, a las 15:03:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7812,53,'                              ','Lunes 19 de Febrero del 07, a las 15:04:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7813,53,'                              ','Lunes 19 de Febrero del 07, a las 15:05:21        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7814,53,'                              ','Lunes 19 de Febrero del 07, a las 15:07:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7815,53,'                              ','Lunes 19 de Febrero del 07, a las 15:11:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7816,51,'Direccion                     ','Lunes 19 de Febrero del 07, a las 15:11:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7817,53,'                              ','Lunes 19 de Febrero del 07, a las 15:11:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7818,53,'                              ','Lunes 19 de Febrero del 07, a las 15:13:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7819,51,'Direccion                     ','Mircoles 21 de Febrero del 07, a las 10:49:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7820,53,'                              ','Mircoles 21 de Febrero del 07, a las 10:49:37    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7821,53,'                              ','Mircoles 21 de Febrero del 07, a las 10:55:55    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7822,53,'                              ','Mircoles 21 de Febrero del 07, a las 10:58:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7823,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:00:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7824,53,'                              ','Mircoles 21 de Febrero del 07, a las 11:02:07    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7825,11,'                              ','Mircoles 21 de Febrero del 07, a las 11:02:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7826,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:03:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7827,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:21:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7828,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:22:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7829,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:22:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7830,11,'                              ','Mircoles 21 de Febrero del 07, a las 11:23:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7831,53,'                              ','Mircoles 21 de Febrero del 07, a las 11:26:40    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7832,53,'                              ','Mircoles 21 de Febrero del 07, a las 11:35:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7833,53,'                              ','Mircoles 21 de Febrero del 07, a las 11:40:24    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7834,53,'                              ','Mircoles 21 de Febrero del 07, a las 11:41:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7835,53,'                              ','Mircoles 21 de Febrero del 07, a las 11:43:26    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7836,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:47:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7837,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:48:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7838,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:50:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7839,6,'                              ','Mircoles 21 de Febrero del 07, a las 11:51:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7840,6,'                              ','Mircoles 21 de Febrero del 07, a las 12:11:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7841,6,'                              ','Mircoles 21 de Febrero del 07, a las 12:13:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7842,6,'                              ','Mircoles 21 de Febrero del 07, a las 12:14:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7843,11,'                              ','Mircoles 21 de Febrero del 07, a las 12:15:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7844,6,'                              ','Mircoles 21 de Febrero del 07, a las 12:19:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7845,53,'                              ','Mircoles 21 de Febrero del 07, a las 12:20:02    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7846,53,'                              ','Mircoles 21 de Febrero del 07, a las 12:26:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7847,51,'Direccion                     ','Mircoles 21 de Febrero del 07, a las 12:27:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7848,51,'Direccion                     ','Mircoles 21 de Febrero del 07, a las 12:29:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7849,53,'                              ','Mircoles 21 de Febrero del 07, a las 12:29:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7850,53,'                              ','Mircoles 21 de Febrero del 07, a las 12:32:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7851,6,'                              ','Mircoles 21 de Febrero del 07, a las 12:34:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7852,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:10:39    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7853,6,'                              ','Mircoles 21 de Febrero del 07, a las 13:11:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7854,51,'Direccion                     ','Mircoles 21 de Febrero del 07, a las 13:15:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7855,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:16:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7856,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:17:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7857,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:19:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7858,6,'                              ','Mircoles 21 de Febrero del 07, a las 13:52:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7859,6,'                              ','Mircoles 21 de Febrero del 07, a las 13:53:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7860,6,'                              ','Mircoles 21 de Febrero del 07, a las 13:53:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7861,11,'                              ','Mircoles 21 de Febrero del 07, a las 13:54:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7862,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:54:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7863,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:55:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7864,53,'                              ','Mircoles 21 de Febrero del 07, a las 13:55:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7865,53,'                              ','Mircoles 21 de Febrero del 07, a las 17:01:09    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7866,53,'                              ','Mircoles 21 de Febrero del 07, a las 17:01:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7867,11,'                              ','Mircoles 21 de Febrero del 07, a las 17:02:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7868,11,'                              ','Mircoles 21 de Febrero del 07, a las 17:04:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7869,6,'                              ','Mircoles 21 de Febrero del 07, a las 17:08:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7870,53,'                              ','Mircoles 21 de Febrero del 07, a las 17:10:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7871,53,'                              ','Mircoles 21 de Febrero del 07, a las 17:10:39    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7872,6,'                              ','Jueves 22 de Febrero del 07, a las 11:36:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7873,6,'                              ','Jueves 22 de Febrero del 07, a las 11:37:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7874,11,'                              ','Jueves 22 de Febrero del 07, a las 11:38:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7875,6,'                              ','Jueves 22 de Febrero del 07, a las 17:18:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7876,6,'                              ','Jueves 22 de Febrero del 07, a las 17:19:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7877,6,'                              ','Jueves 22 de Febrero del 07, a las 17:20:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7878,6,'                              ','Jueves 22 de Febrero del 07, a las 17:22:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7879,6,'                              ','Jueves 22 de Febrero del 07, a las 17:24:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7880,6,'                              ','Jueves 22 de Febrero del 07, a las 17:25:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7881,6,'                              ','Jueves 22 de Febrero del 07, a las 17:25:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7882,6,'                              ','Jueves 22 de Febrero del 07, a las 17:28:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7883,6,'                              ','Jueves 22 de Febrero del 07, a las 17:29:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7884,6,'                              ','Jueves 22 de Febrero del 07, a las 17:30:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7885,6,'                              ','Jueves 22 de Febrero del 07, a las 17:35:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7886,6,'                              ','Jueves 22 de Febrero del 07, a las 17:36:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7887,6,'                              ','Jueves 22 de Febrero del 07, a las 17:37:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7888,6,'                              ','Jueves 22 de Febrero del 07, a las 17:38:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7889,6,'                              ','Jueves 22 de Febrero del 07, a las 17:39:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7890,6,'                              ','Jueves 22 de Febrero del 07, a las 17:40:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7891,53,'                              ','Viernes 23 de Febrero del 07, a las 16:44:26      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7892,6,'                              ','Viernes 23 de Febrero del 07, a las 16:45:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7893,53,'                              ','Viernes 23 de Febrero del 07, a las 16:47:17      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7894,6,'                              ','Viernes 23 de Febrero del 07, a las 16:51:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7895,6,'                              ','Viernes 23 de Febrero del 07, a las 16:51:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7896,11,'                              ','Viernes 23 de Febrero del 07, a las 16:53:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7897,11,'                              ','Viernes 23 de Febrero del 07, a las 16:56:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7898,6,'                              ','Viernes 23 de Febrero del 07, a las 16:57:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7899,6,'                              ','Viernes 23 de Febrero del 07, a las 16:58:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7900,6,'                              ','Viernes 23 de Febrero del 07, a las 16:59:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7901,6,'                              ','Viernes 23 de Febrero del 07, a las 17:00:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7902,6,'                              ','Viernes 23 de Febrero del 07, a las 17:01:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7903,53,'                              ','Viernes 23 de Febrero del 07, a las 17:03:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7904,11,'                              ','Viernes 23 de Febrero del 07, a las 17:05:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7905,11,'                              ','Viernes 23 de Febrero del 07, a las 17:07:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7906,11,'                              ','Viernes 23 de Febrero del 07, a las 17:08:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7907,11,'                              ','Viernes 23 de Febrero del 07, a las 17:11:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7908,6,'                              ','Viernes 23 de Febrero del 07, a las 17:14:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7909,6,'                              ','Viernes 23 de Febrero del 07, a las 17:15:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7910,11,'                              ','Viernes 23 de Febrero del 07, a las 17:15:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7911,53,'                              ','Viernes 23 de Febrero del 07, a las 17:22:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7912,53,'                              ','Viernes 23 de Febrero del 07, a las 17:23:10      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7913,11,'                              ','Viernes 23 de Febrero del 07, a las 17:24:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7914,53,'                              ','Viernes 23 de Febrero del 07, a las 17:25:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7915,53,'                              ','Viernes 23 de Febrero del 07, a las 17:26:28      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7916,53,'                              ','Viernes 23 de Febrero del 07, a las 17:58:05      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7917,6,'                              ','Viernes 23 de Febrero del 07, a las 18:00:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7918,6,'                              ','Viernes 23 de Febrero del 07, a las 18:02:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7919,11,'                              ','Viernes 23 de Febrero del 07, a las 18:02:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7920,11,'                              ','Viernes 23 de Febrero del 07, a las 18:03:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7921,6,'                              ','Viernes 23 de Febrero del 07, a las 18:06:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7922,11,'                              ','Viernes 23 de Febrero del 07, a las 18:06:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7923,6,'                              ','Viernes 23 de Febrero del 07, a las 18:08:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7924,11,'                              ','Viernes 23 de Febrero del 07, a las 18:25:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7925,6,'                              ','Viernes 23 de Febrero del 07, a las 18:27:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7926,6,'                              ','Viernes 23 de Febrero del 07, a las 18:28:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7927,6,'                              ','Viernes 23 de Febrero del 07, a las 18:28:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7928,6,'                              ','Viernes 23 de Febrero del 07, a las 18:31:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7929,53,'                              ','Viernes 23 de Febrero del 07, a las 18:32:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7930,11,'                              ','Viernes 23 de Febrero del 07, a las 18:33:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7931,6,'                              ','Viernes 23 de Febrero del 07, a las 18:34:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7932,6,'                              ','Viernes 23 de Febrero del 07, a las 18:36:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7933,6,'                              ','Viernes 23 de Febrero del 07, a las 18:37:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7934,53,'                              ','Lunes 26 de Febrero del 07, a las 10:41:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7935,6,'                              ','Lunes 26 de Febrero del 07, a las 16:08:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7936,6,'                              ','Lunes 26 de Febrero del 07, a las 16:10:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7937,6,'                              ','Lunes 26 de Febrero del 07, a las 16:12:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7938,11,'                              ','Lunes 26 de Febrero del 07, a las 16:12:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7939,6,'                              ','Lunes 26 de Febrero del 07, a las 16:14:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7940,6,'                              ','Lunes 26 de Febrero del 07, a las 16:15:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7941,11,'                              ','Lunes 26 de Febrero del 07, a las 16:17:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7942,6,'                              ','Lunes 26 de Febrero del 07, a las 16:18:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7943,6,'                              ','Lunes 26 de Febrero del 07, a las 16:19:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7944,6,'                              ','Lunes 26 de Febrero del 07, a las 16:20:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7945,6,'                              ','Lunes 26 de Febrero del 07, a las 16:21:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7946,6,'                              ','Lunes 26 de Febrero del 07, a las 16:21:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7947,53,'                              ','Lunes 26 de Febrero del 07, a las 16:22:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7948,6,'                              ','Lunes 26 de Febrero del 07, a las 16:22:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7949,6,'                              ','Lunes 26 de Febrero del 07, a las 16:23:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7950,6,'                              ','Lunes 26 de Febrero del 07, a las 16:25:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7951,6,'                              ','Lunes 26 de Febrero del 07, a las 16:28:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7952,6,'                              ','Lunes 26 de Febrero del 07, a las 16:30:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7953,53,'                              ','Lunes 26 de Febrero del 07, a las 16:30:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7954,11,'                              ','Lunes 26 de Febrero del 07, a las 16:30:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7955,6,'                              ','Lunes 26 de Febrero del 07, a las 16:32:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7956,6,'                              ','Lunes 26 de Febrero del 07, a las 16:33:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7957,11,'                              ','Lunes 26 de Febrero del 07, a las 16:33:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7958,6,'                              ','Lunes 26 de Febrero del 07, a las 16:34:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7959,6,'                              ','Lunes 26 de Febrero del 07, a las 16:35:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7960,53,'                              ','Lunes 26 de Febrero del 07, a las 16:35:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7961,6,'                              ','Lunes 26 de Febrero del 07, a las 16:36:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7962,6,'                              ','Lunes 26 de Febrero del 07, a las 16:37:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7963,6,'                              ','Lunes 26 de Febrero del 07, a las 16:38:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7964,53,'                              ','Lunes 26 de Febrero del 07, a las 16:38:40        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7965,6,'                              ','Lunes 26 de Febrero del 07, a las 16:39:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7966,6,'                              ','Lunes 26 de Febrero del 07, a las 16:40:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7967,11,'                              ','Lunes 26 de Febrero del 07, a las 16:40:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7968,6,'                              ','Lunes 26 de Febrero del 07, a las 16:41:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7969,6,'                              ','Lunes 26 de Febrero del 07, a las 16:42:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7970,6,'                              ','Lunes 26 de Febrero del 07, a las 16:42:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7971,6,'                              ','Lunes 26 de Febrero del 07, a las 16:43:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7972,53,'                              ','Lunes 26 de Febrero del 07, a las 16:44:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7973,11,'                              ','Martes 27 de Febrero del 07, a las 09:53:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7974,6,'                              ','Martes 27 de Febrero del 07, a las 09:56:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7975,6,'                              ','Martes 27 de Febrero del 07, a las 10:00:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7976,6,'                              ','Martes 27 de Febrero del 07, a las 10:01:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7977,53,'                              ','Martes 27 de Febrero del 07, a las 10:02:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7978,6,'                              ','Martes 27 de Febrero del 07, a las 10:02:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7979,53,'                              ','Martes 27 de Febrero del 07, a las 10:16:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7980,6,'                              ','Martes 27 de Febrero del 07, a las 10:16:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7981,6,'                              ','Martes 27 de Febrero del 07, a las 10:18:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7982,6,'                              ','Martes 27 de Febrero del 07, a las 10:19:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7983,53,'                              ','Martes 27 de Febrero del 07, a las 10:19:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7984,6,'                              ','Martes 27 de Febrero del 07, a las 10:21:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7985,6,'                              ','Martes 27 de Febrero del 07, a las 10:24:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7986,11,'                              ','Martes 27 de Febrero del 07, a las 10:25:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7987,6,'                              ','Martes 27 de Febrero del 07, a las 10:27:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7988,6,'                              ','Martes 27 de Febrero del 07, a las 10:28:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7989,11,'                              ','Martes 27 de Febrero del 07, a las 10:28:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7990,6,'                              ','Martes 27 de Febrero del 07, a las 10:30:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7991,6,'                              ','Martes 27 de Febrero del 07, a las 10:31:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7992,6,'                              ','Martes 27 de Febrero del 07, a las 10:32:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7993,6,'                              ','Martes 27 de Febrero del 07, a las 10:33:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7994,6,'                              ','Martes 27 de Febrero del 07, a las 10:35:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7995,6,'                              ','Martes 27 de Febrero del 07, a las 10:57:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7996,6,'                              ','Martes 27 de Febrero del 07, a las 10:58:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7997,6,'                              ','Martes 27 de Febrero del 07, a las 10:58:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7998,6,'                              ','Martes 27 de Febrero del 07, a las 10:59:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (7999,6,'                              ','Martes 27 de Febrero del 07, a las 11:00:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8000,6,'                              ','Martes 27 de Febrero del 07, a las 11:10:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8001,6,'                              ','Martes 27 de Febrero del 07, a las 11:10:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8002,6,'                              ','Martes 27 de Febrero del 07, a las 11:13:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8003,6,'                              ','Martes 27 de Febrero del 07, a las 11:13:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8004,6,'                              ','Martes 27 de Febrero del 07, a las 11:16:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8005,53,'                              ','Martes 27 de Febrero del 07, a las 11:16:23       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8006,6,'                              ','Martes 27 de Febrero del 07, a las 11:17:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8007,53,'                              ','Martes 27 de Febrero del 07, a las 11:17:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8008,6,'                              ','Martes 27 de Febrero del 07, a las 11:18:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8009,6,'                              ','Martes 27 de Febrero del 07, a las 11:19:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8010,53,'                              ','Martes 27 de Febrero del 07, a las 11:23:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8011,53,'                              ','Martes 27 de Febrero del 07, a las 11:30:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8012,11,'                              ','Martes 27 de Febrero del 07, a las 11:31:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8013,6,'                              ','Martes 27 de Febrero del 07, a las 11:32:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8014,53,'                              ','Martes 27 de Febrero del 07, a las 11:32:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8015,53,'                              ','Martes 27 de Febrero del 07, a las 11:32:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8016,6,'                              ','Martes 27 de Febrero del 07, a las 11:34:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8017,6,'                              ','Martes 27 de Febrero del 07, a las 11:35:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8018,6,'                              ','Martes 27 de Febrero del 07, a las 11:36:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8019,6,'                              ','Martes 27 de Febrero del 07, a las 11:38:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8020,6,'                              ','Martes 27 de Febrero del 07, a las 11:41:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8021,53,'                              ','Martes 27 de Febrero del 07, a las 11:42:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8022,6,'                              ','Martes 27 de Febrero del 07, a las 11:43:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8023,6,'                              ','Martes 27 de Febrero del 07, a las 11:45:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8024,53,'                              ','Martes 27 de Febrero del 07, a las 11:45:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8025,53,'                              ','Martes 27 de Febrero del 07, a las 11:45:33       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8026,11,'                              ','Martes 27 de Febrero del 07, a las 11:45:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8027,53,'                              ','Martes 27 de Febrero del 07, a las 11:49:07       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8028,6,'                              ','Martes 27 de Febrero del 07, a las 11:51:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8029,53,'                              ','Martes 27 de Febrero del 07, a las 11:51:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8030,6,'                              ','Martes 27 de Febrero del 07, a las 11:52:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8031,6,'                              ','Martes 27 de Febrero del 07, a las 11:56:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8032,6,'                              ','Martes 27 de Febrero del 07, a las 11:58:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8033,6,'                              ','Martes 27 de Febrero del 07, a las 12:01:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8034,53,'                              ','Martes 27 de Febrero del 07, a las 12:01:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8035,53,'                              ','Martes 27 de Febrero del 07, a las 12:02:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8036,6,'                              ','Martes 27 de Febrero del 07, a las 12:08:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8037,6,'                              ','Martes 27 de Febrero del 07, a las 12:11:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8038,6,'                              ','Martes 27 de Febrero del 07, a las 12:14:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8039,6,'                              ','Martes 27 de Febrero del 07, a las 12:15:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8040,53,'                              ','Martes 27 de Febrero del 07, a las 12:16:14       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8041,6,'                              ','Martes 27 de Febrero del 07, a las 12:17:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8042,6,'                              ','Martes 27 de Febrero del 07, a las 12:20:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8043,6,'                              ','Martes 27 de Febrero del 07, a las 12:22:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8044,6,'                              ','Martes 27 de Febrero del 07, a las 12:24:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8045,6,'                              ','Martes 27 de Febrero del 07, a las 12:25:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8046,6,'                              ','Martes 27 de Febrero del 07, a las 12:28:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8047,11,'                              ','Martes 27 de Febrero del 07, a las 12:28:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8048,6,'                              ','Martes 27 de Febrero del 07, a las 12:29:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8049,6,'                              ','Martes 27 de Febrero del 07, a las 12:32:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8050,6,'                              ','Martes 27 de Febrero del 07, a las 12:53:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8051,6,'                              ','Martes 27 de Febrero del 07, a las 13:04:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8052,6,'                              ','Martes 27 de Febrero del 07, a las 13:06:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8053,6,'                              ','Martes 27 de Febrero del 07, a las 13:07:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8054,6,'                              ','Martes 27 de Febrero del 07, a las 13:08:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8055,6,'                              ','Martes 27 de Febrero del 07, a las 13:10:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8056,6,'                              ','Martes 27 de Febrero del 07, a las 13:12:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8057,6,'                              ','Martes 27 de Febrero del 07, a las 13:13:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8058,6,'                              ','Martes 27 de Febrero del 07, a las 13:14:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8059,6,'                              ','Martes 27 de Febrero del 07, a las 13:15:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8060,6,'                              ','Martes 27 de Febrero del 07, a las 13:24:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8061,6,'                              ','Martes 27 de Febrero del 07, a las 13:30:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8062,6,'                              ','Martes 27 de Febrero del 07, a las 13:31:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8063,6,'                              ','Martes 27 de Febrero del 07, a las 13:33:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8064,6,'                              ','Mircoles 28 de Febrero del 07, a las 13:52:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8065,6,'                              ','Mircoles 28 de Febrero del 07, a las 13:53:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8066,53,'                              ','Mircoles 28 de Febrero del 07, a las 13:53:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8067,11,'                              ','Mircoles 28 de Febrero del 07, a las 13:54:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8068,53,'                              ','Mircoles 28 de Febrero del 07, a las 13:55:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8069,53,'                              ','Mircoles 28 de Febrero del 07, a las 13:55:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8070,6,'                              ','Mircoles 28 de Febrero del 07, a las 13:56:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8071,6,'                              ','Mircoles 28 de Febrero del 07, a las 13:56:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8072,6,'                              ','Mircoles 28 de Febrero del 07, a las 13:57:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8073,53,'                              ','Mircoles 28 de Febrero del 07, a las 13:58:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8074,11,'                              ','Mircoles 28 de Febrero del 07, a las 13:59:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8075,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:00:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8076,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:01:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8077,53,'                              ','Mircoles 28 de Febrero del 07, a las 14:01:50    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8078,11,'                              ','Mircoles 28 de Febrero del 07, a las 14:02:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8079,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:03:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8080,53,'                              ','Mircoles 28 de Febrero del 07, a las 14:03:55    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8081,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:05:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8082,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:05:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8083,53,'                              ','Mircoles 28 de Febrero del 07, a las 14:06:48    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8084,11,'                              ','Mircoles 28 de Febrero del 07, a las 14:07:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8085,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:11:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8086,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:12:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8087,11,'                              ','Mircoles 28 de Febrero del 07, a las 14:12:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8088,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:14:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8089,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:15:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8090,53,'                              ','Mircoles 28 de Febrero del 07, a las 14:16:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8091,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:18:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8092,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:19:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8093,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:19:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8094,11,'                              ','Mircoles 28 de Febrero del 07, a las 14:20:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8095,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:22:55    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8096,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:25:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8097,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:29:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8098,11,'                              ','Mircoles 28 de Febrero del 07, a las 14:29:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8099,53,'                              ','Mircoles 28 de Febrero del 07, a las 14:35:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8100,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:41:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8101,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:43:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8102,53,'                              ','Mircoles 28 de Febrero del 07, a las 14:44:30    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8103,11,'                              ','Mircoles 28 de Febrero del 07, a las 14:45:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8104,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:56:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8105,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:58:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8106,6,'                              ','Mircoles 28 de Febrero del 07, a las 14:59:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8107,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:01:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8108,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:02:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8109,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:03:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8110,53,'                              ','Mircoles 28 de Febrero del 07, a las 15:03:48    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8111,11,'                              ','Mircoles 28 de Febrero del 07, a las 15:04:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8112,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:06:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8113,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:07:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8114,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:09:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8115,11,'                              ','Mircoles 28 de Febrero del 07, a las 15:10:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8116,53,'                              ','Mircoles 28 de Febrero del 07, a las 15:11:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8117,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:17:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8118,53,'                              ','Mircoles 28 de Febrero del 07, a las 15:19:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8119,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:19:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8120,11,'                              ','Mircoles 28 de Febrero del 07, a las 15:20:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8121,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:20:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8122,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:21:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8123,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:22:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8124,6,'                              ','Mircoles 28 de Febrero del 07, a las 15:31:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8125,53,'                              ','Mircoles 28 de Febrero del 07, a las 15:32:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8126,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:00:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8127,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:01:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8128,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:10:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8129,53,'                              ','Mircoles 28 de Febrero del 07, a las 16:11:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8130,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:11:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8131,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:12:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8132,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:21:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8133,53,'                              ','Mircoles 28 de Febrero del 07, a las 16:21:41    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8134,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:22:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8135,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:23:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8136,53,'                              ','Mircoles 28 de Febrero del 07, a las 16:24:42    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8137,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:26:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8138,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:27:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8139,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:28:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8140,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:29:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8141,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:30:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8142,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:31:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8143,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:32:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8144,53,'                              ','Mircoles 28 de Febrero del 07, a las 16:33:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8145,53,'                              ','Mircoles 28 de Febrero del 07, a las 16:34:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8146,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:35:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8147,53,'                              ','Mircoles 28 de Febrero del 07, a las 16:36:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8148,6,'                              ','Mircoles 28 de Febrero del 07, a las 16:37:17    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8149,6,'                              ','Jueves 1 de Marzo del 07, a las 11:40:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8150,6,'                              ','Jueves 1 de Marzo del 07, a las 13:35:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8151,6,'                              ','Jueves 1 de Marzo del 07, a las 13:36:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8152,6,'                              ','Jueves 1 de Marzo del 07, a las 13:40:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8153,53,'                              ','Jueves 1 de Marzo del 07, a las 13:41:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8154,11,'                              ','Jueves 1 de Marzo del 07, a las 13:42:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8155,8,'                              ','Jueves 1 de Marzo del 07, a las 13:42:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8156,11,'                              ','Jueves 1 de Marzo del 07, a las 13:44:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8157,11,'                              ','Jueves 1 de Marzo del 07, a las 13:45:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8158,8,'                              ','Jueves 1 de Marzo del 07, a las 13:46:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8159,6,'                              ','Jueves 1 de Marzo del 07, a las 13:57:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8160,6,'                              ','Jueves 1 de Marzo del 07, a las 14:02:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8161,6,'                              ','Jueves 1 de Marzo del 07, a las 15:20:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8162,6,'                              ','Jueves 1 de Marzo del 07, a las 15:22:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8163,6,'                              ','Jueves 1 de Marzo del 07, a las 15:23:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8164,6,'                              ','Jueves 1 de Marzo del 07, a las 15:24:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8165,6,'                              ','Jueves 1 de Marzo del 07, a las 15:25:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8166,6,'                              ','Jueves 1 de Marzo del 07, a las 15:26:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8167,6,'                              ','Jueves 1 de Marzo del 07, a las 15:47:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8168,11,'                              ','Jueves 1 de Marzo del 07, a las 15:48:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8169,11,'                              ','Jueves 1 de Marzo del 07, a las 15:49:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8170,11,'                              ','Jueves 1 de Marzo del 07, a las 15:51:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8171,11,'                              ','Jueves 1 de Marzo del 07, a las 15:51:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8172,11,'                              ','Jueves 1 de Marzo del 07, a las 15:52:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8173,53,'                              ','Jueves 1 de Marzo del 07, a las 15:52:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8174,4,'                              ','Jueves 1 de Marzo del 07, a las 15:53:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8175,4,'                              ','Jueves 1 de Marzo del 07, a las 15:53:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8176,11,'                              ','Jueves 1 de Marzo del 07, a las 15:55:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8177,6,'                              ','Viernes 2 de Marzo del 07, a las 13:13:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8178,6,'                              ','Viernes 2 de Marzo del 07, a las 15:26:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8179,6,'                              ','Viernes 2 de Marzo del 07, a las 16:13:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8180,6,'                              ','Viernes 2 de Marzo del 07, a las 16:17:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8181,6,'                              ','Lunes 5 de Marzo del 07, a las 15:04:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8182,53,'                              ','Lunes 5 de Marzo del 07, a las 15:09:17           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8183,6,'                              ','Lunes 5 de Marzo del 07, a las 15:12:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8184,6,'                              ','Lunes 5 de Marzo del 07, a las 15:16:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8185,6,'                              ','Lunes 5 de Marzo del 07, a las 15:24:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8186,6,'                              ','Lunes 5 de Marzo del 07, a las 15:28:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8187,6,'                              ','Martes 6 de Marzo del 07, a las 12:44:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8188,6,'                              ','Mircoles 7 de Marzo del 07, a las 10:59:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8189,6,'                              ','Jueves 8 de Marzo del 07, a las 14:31:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8190,53,'                              ','Jueves 8 de Marzo del 07, a las 14:34:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8191,53,'                              ','Jueves 8 de Marzo del 07, a las 14:35:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8192,11,'                              ','Jueves 8 de Marzo del 07, a las 14:53:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8193,11,'                              ','Jueves 8 de Marzo del 07, a las 16:22:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8194,53,'                              ','Jueves 8 de Marzo del 07, a las 16:44:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8195,53,'                              ','Jueves 8 de Marzo del 07, a las 16:45:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8196,53,'                              ','Jueves 8 de Marzo del 07, a las 16:48:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8197,6,'                              ','Jueves 8 de Marzo del 07, a las 16:51:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8198,6,'                              ','Jueves 8 de Marzo del 07, a las 17:05:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8199,53,'                              ','Jueves 8 de Marzo del 07, a las 17:15:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8200,6,'                              ','Jueves 8 de Marzo del 07, a las 17:19:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8201,6,'                              ','Jueves 8 de Marzo del 07, a las 17:21:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8202,53,'                              ','Jueves 8 de Marzo del 07, a las 17:28:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8203,53,'                              ','Jueves 8 de Marzo del 07, a las 17:47:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8204,6,'                              ','Viernes 9 de Marzo del 07, a las 10:52:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8205,6,'                              ','Viernes 9 de Marzo del 07, a las 10:55:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8206,53,'                              ','Viernes 9 de Marzo del 07, a las 10:56:19         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8207,53,'                              ','Viernes 9 de Marzo del 07, a las 10:57:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8208,6,'                              ','Viernes 9 de Marzo del 07, a las 12:40:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8209,53,'                              ','Viernes 9 de Marzo del 07, a las 12:40:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8210,6,'                              ','Viernes 9 de Marzo del 07, a las 12:41:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8211,6,'                              ','Viernes 9 de Marzo del 07, a las 12:41:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8212,6,'                              ','Viernes 9 de Marzo del 07, a las 12:42:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8213,6,'                              ','Viernes 9 de Marzo del 07, a las 12:42:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8214,6,'                              ','Viernes 9 de Marzo del 07, a las 12:43:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8215,6,'                              ','Viernes 9 de Marzo del 07, a las 12:43:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8216,11,'                              ','Viernes 9 de Marzo del 07, a las 14:39:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8217,6,'                              ','Viernes 9 de Marzo del 07, a las 14:40:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8218,6,'                              ','Viernes 9 de Marzo del 07, a las 15:10:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8219,6,'                              ','Viernes 9 de Marzo del 07, a las 15:16:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8220,6,'                              ','Viernes 9 de Marzo del 07, a las 15:16:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8221,6,'                              ','Viernes 9 de Marzo del 07, a las 15:17:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8222,6,'                              ','Viernes 9 de Marzo del 07, a las 15:17:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8223,6,'                              ','Viernes 9 de Marzo del 07, a las 16:57:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8224,6,'                              ','Viernes 9 de Marzo del 07, a las 16:57:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8225,11,'                              ','Viernes 9 de Marzo del 07, a las 16:58:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8226,6,'                              ','Viernes 9 de Marzo del 07, a las 16:59:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8227,53,'                              ','Viernes 9 de Marzo del 07, a las 17:00:16         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8228,53,'                              ','Viernes 9 de Marzo del 07, a las 17:00:57         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8229,6,'                              ','Viernes 9 de Marzo del 07, a las 17:01:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8230,6,'                              ','Viernes 9 de Marzo del 07, a las 17:01:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8231,6,'                              ','Viernes 9 de Marzo del 07, a las 17:02:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8232,6,'                              ','Viernes 9 de Marzo del 07, a las 17:34:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8233,53,'                              ','Viernes 9 de Marzo del 07, a las 17:36:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8234,53,'                              ','Martes 13 de Marzo del 07, a las 11:31:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8235,6,'                              ','Martes 13 de Marzo del 07, a las 11:35:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8236,6,'                              ','Martes 13 de Marzo del 07, a las 11:38:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8237,6,'                              ','Mircoles 14 de Marzo del 07, a las 11:40:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8238,6,'                              ','Mircoles 14 de Marzo del 07, a las 11:41:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8239,6,'                              ','Mircoles 14 de Marzo del 07, a las 11:41:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8240,6,'                              ','Mircoles 14 de Marzo del 07, a las 11:42:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8241,6,'                              ','Viernes 16 de Marzo del 07, a las 13:40:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8242,6,'                              ','Viernes 16 de Marzo del 07, a las 13:41:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8243,53,'                              ','Viernes 16 de Marzo del 07, a las 13:43:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8244,11,'                              ','Viernes 16 de Marzo del 07, a las 14:01:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8245,11,'                              ','Viernes 16 de Marzo del 07, a las 14:02:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8246,6,'                              ','Martes 20 de Marzo del 07, a las 16:47:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8247,11,'                              ','Martes 20 de Marzo del 07, a las 16:49:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8248,11,'                              ','Martes 20 de Marzo del 07, a las 16:49:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8249,11,'                              ','Martes 20 de Marzo del 07, a las 16:50:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8250,11,'                              ','Martes 20 de Marzo del 07, a las 16:51:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8251,11,'                              ','Martes 20 de Marzo del 07, a las 16:52:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8252,11,'                              ','Martes 20 de Marzo del 07, a las 16:53:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8253,53,'                              ','Martes 20 de Marzo del 07, a las 17:20:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8254,53,'                              ','Martes 20 de Marzo del 07, a las 17:21:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8255,6,'                              ','Martes 20 de Marzo del 07, a las 17:23:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8256,6,'                              ','Martes 20 de Marzo del 07, a las 17:24:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8257,6,'                              ','Martes 20 de Marzo del 07, a las 17:28:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8258,53,'                              ','Martes 20 de Marzo del 07, a las 17:29:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8259,11,'                              ','Martes 20 de Marzo del 07, a las 17:29:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8260,6,'                              ','Martes 20 de Marzo del 07, a las 17:31:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8261,6,'                              ','Martes 20 de Marzo del 07, a las 17:33:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8262,6,'                              ','Martes 20 de Marzo del 07, a las 17:35:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8263,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:52:06      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8264,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:52:47      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8265,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:53:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8266,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:54:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8267,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:54:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8268,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:54:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8269,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:55:15      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8270,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:55:35      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8271,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:56:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8272,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:57:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8273,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:57:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8274,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:58:17      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8275,53,'                              ','Mircoles 21 de Marzo del 07, a las 10:58:45      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8276,6,'                              ','Mircoles 21 de Marzo del 07, a las 10:59:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8277,51,'Direccion                     ','Mircoles 21 de Marzo del 07, a las 11:02:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8278,6,'                              ','Mircoles 21 de Marzo del 07, a las 11:51:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8279,53,'                              ','Mircoles 21 de Marzo del 07, a las 11:54:40      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8280,53,'                              ','Mircoles 21 de Marzo del 07, a las 11:55:34      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8281,53,'                              ','Mircoles 21 de Marzo del 07, a las 11:55:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8282,51,'Direccion                     ','Mircoles 21 de Marzo del 07, a las 11:56:47      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8283,6,'                              ','Mircoles 21 de Marzo del 07, a las 11:58:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8284,6,'                              ','Mircoles 21 de Marzo del 07, a las 12:00:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8285,53,'                              ','Mircoles 21 de Marzo del 07, a las 12:02:15      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8286,6,'                              ','Mircoles 21 de Marzo del 07, a las 12:09:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8287,53,'                              ','Mircoles 21 de Marzo del 07, a las 12:18:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8288,53,'                              ','Mircoles 21 de Marzo del 07, a las 12:19:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8289,53,'                              ','Mircoles 21 de Marzo del 07, a las 12:20:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8290,6,'                              ','Mircoles 21 de Marzo del 07, a las 13:26:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8291,6,'                              ','Mircoles 21 de Marzo del 07, a las 13:27:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8292,6,'                              ','Mircoles 21 de Marzo del 07, a las 13:34:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8293,53,'                              ','Mircoles 21 de Marzo del 07, a las 13:35:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8294,53,'                              ','Mircoles 21 de Marzo del 07, a las 13:46:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8295,53,'                              ','Mircoles 21 de Marzo del 07, a las 13:46:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8296,53,'                              ','Mircoles 21 de Marzo del 07, a las 13:47:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8297,6,'                              ','Mircoles 21 de Marzo del 07, a las 14:06:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8298,6,'                              ','Mircoles 21 de Marzo del 07, a las 14:06:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8299,6,'                              ','Mircoles 21 de Marzo del 07, a las 14:07:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8300,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:33:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8301,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:34:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8302,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:35:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8303,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:40:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8304,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:42:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8305,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:44:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8306,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:49:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8307,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:52:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8308,53,'                              ','Mircoles 21 de Marzo del 07, a las 16:54:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8309,6,'                              ','Mircoles 21 de Marzo del 07, a las 16:57:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8310,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:01:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8311,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:04:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8312,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:04:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8313,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:07:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8314,53,'                              ','Mircoles 21 de Marzo del 07, a las 17:08:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8315,53,'                              ','Mircoles 21 de Marzo del 07, a las 17:11:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8316,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:12:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8317,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:17:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8318,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:19:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8319,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:22:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8320,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:26:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8321,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:28:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8322,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:31:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8323,53,'                              ','Mircoles 21 de Marzo del 07, a las 17:34:35      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8324,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:37:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8325,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:41:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8326,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:45:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8327,11,'                              ','Mircoles 21 de Marzo del 07, a las 17:47:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8328,11,'                              ','Mircoles 21 de Marzo del 07, a las 17:48:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8329,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:51:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8330,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:55:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8331,6,'                              ','Mircoles 21 de Marzo del 07, a las 17:58:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8332,6,'                              ','Jueves 22 de Marzo del 07, a las 10:15:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8333,53,'                              ','Jueves 22 de Marzo del 07, a las 10:16:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8334,11,'                              ','Jueves 22 de Marzo del 07, a las 10:18:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8335,11,'                              ','Jueves 22 de Marzo del 07, a las 10:21:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8336,6,'                              ','Jueves 22 de Marzo del 07, a las 10:22:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8337,6,'                              ','Jueves 22 de Marzo del 07, a las 10:31:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8338,53,'                              ','Jueves 22 de Marzo del 07, a las 10:50:36         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8339,6,'                              ','Jueves 22 de Marzo del 07, a las 10:53:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8340,53,'                              ','Jueves 22 de Marzo del 07, a las 10:53:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8341,6,'                              ','Jueves 22 de Marzo del 07, a las 10:56:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8342,6,'                              ','Jueves 22 de Marzo del 07, a las 10:57:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8343,6,'                              ','Jueves 22 de Marzo del 07, a las 11:01:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8344,6,'                              ','Jueves 22 de Marzo del 07, a las 11:07:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8345,6,'                              ','Jueves 22 de Marzo del 07, a las 11:09:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8346,6,'                              ','Jueves 22 de Marzo del 07, a las 11:09:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8347,53,'                              ','Jueves 22 de Marzo del 07, a las 11:12:59         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8348,6,'                              ','Jueves 22 de Marzo del 07, a las 11:17:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8349,6,'                              ','Jueves 22 de Marzo del 07, a las 11:20:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8350,6,'                              ','Jueves 22 de Marzo del 07, a las 11:23:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8351,6,'                              ','Jueves 22 de Marzo del 07, a las 11:26:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8352,6,'                              ','Jueves 22 de Marzo del 07, a las 11:33:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8353,6,'                              ','Jueves 22 de Marzo del 07, a las 11:33:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8354,6,'                              ','Jueves 22 de Marzo del 07, a las 11:36:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8355,6,'                              ','Jueves 22 de Marzo del 07, a las 11:38:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8356,6,'                              ','Jueves 22 de Marzo del 07, a las 11:38:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8357,53,'                              ','Jueves 22 de Marzo del 07, a las 11:39:52         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8358,6,'                              ','Jueves 22 de Marzo del 07, a las 11:43:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8359,53,'                              ','Jueves 22 de Marzo del 07, a las 11:47:07         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8360,6,'                              ','Jueves 22 de Marzo del 07, a las 11:48:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8361,11,'                              ','Jueves 22 de Marzo del 07, a las 11:48:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8362,6,'                              ','Jueves 22 de Marzo del 07, a las 12:00:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8363,11,'                              ','Jueves 22 de Marzo del 07, a las 12:01:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8364,53,'                              ','Jueves 22 de Marzo del 07, a las 12:16:52         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8365,6,'                              ','Jueves 22 de Marzo del 07, a las 12:28:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8366,6,'                              ','Jueves 22 de Marzo del 07, a las 12:32:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8367,6,'                              ','Jueves 22 de Marzo del 07, a las 12:49:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8368,6,'                              ','Jueves 22 de Marzo del 07, a las 12:50:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8369,53,'                              ','Jueves 22 de Marzo del 07, a las 12:52:47         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8370,11,'                              ','Jueves 22 de Marzo del 07, a las 12:53:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8371,6,'                              ','Jueves 22 de Marzo del 07, a las 13:01:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8372,6,'                              ','Jueves 22 de Marzo del 07, a las 13:14:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8373,6,'                              ','Jueves 22 de Marzo del 07, a las 13:20:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8374,6,'                              ','Jueves 22 de Marzo del 07, a las 13:22:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8375,11,'                              ','Jueves 22 de Marzo del 07, a las 13:23:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8376,53,'                              ','Jueves 22 de Marzo del 07, a las 13:25:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8377,6,'                              ','Jueves 22 de Marzo del 07, a las 13:30:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8378,6,'                              ','Jueves 22 de Marzo del 07, a las 13:30:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8379,53,'                              ','Jueves 22 de Marzo del 07, a las 13:31:48         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8380,53,'                              ','Jueves 22 de Marzo del 07, a las 13:32:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8381,6,'                              ','Jueves 22 de Marzo del 07, a las 13:35:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8382,6,'                              ','Jueves 22 de Marzo del 07, a las 13:39:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8383,11,'                              ','Jueves 22 de Marzo del 07, a las 13:40:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8384,6,'                              ','Jueves 22 de Marzo del 07, a las 13:45:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8385,6,'                              ','Jueves 22 de Marzo del 07, a las 13:46:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8386,6,'                              ','Jueves 22 de Marzo del 07, a las 13:49:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8387,6,'                              ','Jueves 22 de Marzo del 07, a las 13:51:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8388,53,'                              ','Jueves 22 de Marzo del 07, a las 13:53:18         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8389,6,'                              ','Jueves 22 de Marzo del 07, a las 13:54:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8390,6,'                              ','Jueves 22 de Marzo del 07, a las 14:01:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8391,6,'                              ','Jueves 22 de Marzo del 07, a las 14:02:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8392,11,'                              ','Jueves 22 de Marzo del 07, a las 14:02:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8393,6,'                              ','Jueves 22 de Marzo del 07, a las 14:08:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8394,53,'                              ','Jueves 22 de Marzo del 07, a las 14:09:19         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8395,6,'                              ','Jueves 22 de Marzo del 07, a las 14:13:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8396,6,'                              ','Jueves 22 de Marzo del 07, a las 14:14:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8397,6,'                              ','Jueves 22 de Marzo del 07, a las 14:18:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8398,53,'                              ','Jueves 22 de Marzo del 07, a las 14:19:22         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8399,11,'                              ','Jueves 22 de Marzo del 07, a las 14:19:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8400,6,'                              ','Jueves 22 de Marzo del 07, a las 14:24:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8401,53,'                              ','Jueves 22 de Marzo del 07, a las 14:26:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8402,11,'                              ','Jueves 22 de Marzo del 07, a las 14:29:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8403,11,'                              ','Jueves 22 de Marzo del 07, a las 14:35:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8404,11,'                              ','Jueves 22 de Marzo del 07, a las 14:39:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8405,53,'                              ','Jueves 22 de Marzo del 07, a las 15:10:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8406,53,'                              ','Jueves 22 de Marzo del 07, a las 15:10:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8407,53,'                              ','Jueves 22 de Marzo del 07, a las 15:36:10         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8408,53,'                              ','Jueves 22 de Marzo del 07, a las 15:37:00         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8409,6,'                              ','Viernes 23 de Marzo del 07, a las 12:26:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8410,6,'                              ','Viernes 23 de Marzo del 07, a las 12:28:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8411,53,'                              ','Viernes 23 de Marzo del 07, a las 12:28:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8412,53,'                              ','Viernes 23 de Marzo del 07, a las 12:35:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8413,6,'                              ','Viernes 23 de Marzo del 07, a las 12:36:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8414,11,'                              ','Viernes 23 de Marzo del 07, a las 12:37:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8415,6,'                              ','Viernes 23 de Marzo del 07, a las 12:38:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8416,6,'                              ','Viernes 23 de Marzo del 07, a las 12:45:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8417,53,'                              ','Viernes 23 de Marzo del 07, a las 12:46:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8418,53,'                              ','Viernes 23 de Marzo del 07, a las 12:47:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8419,6,'                              ','Viernes 23 de Marzo del 07, a las 13:05:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8420,53,'                              ','Viernes 23 de Marzo del 07, a las 13:06:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8421,6,'                              ','Viernes 23 de Marzo del 07, a las 13:09:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8422,6,'                              ','Viernes 23 de Marzo del 07, a las 13:11:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8423,53,'                              ','Viernes 23 de Marzo del 07, a las 13:17:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8424,6,'                              ','Viernes 23 de Marzo del 07, a las 17:18:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8425,6,'                              ','Lunes 26 de Marzo del 07, a las 13:06:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8426,6,'                              ','Lunes 26 de Marzo del 07, a las 13:07:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8427,6,'                              ','Lunes 26 de Marzo del 07, a las 13:08:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8428,6,'                              ','Lunes 26 de Marzo del 07, a las 16:43:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8429,6,'                              ','Lunes 26 de Marzo del 07, a las 16:50:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8430,6,'                              ','Lunes 26 de Marzo del 07, a las 16:51:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8431,6,'                              ','Lunes 26 de Marzo del 07, a las 16:52:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8432,6,'                              ','Lunes 26 de Marzo del 07, a las 16:52:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8433,53,'                              ','Martes 27 de Marzo del 07, a las 13:24:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8434,6,'                              ','Martes 27 de Marzo del 07, a las 16:23:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8435,6,'                              ','Martes 27 de Marzo del 07, a las 16:30:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8436,6,'                              ','Martes 27 de Marzo del 07, a las 17:23:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8437,6,'                              ','Viernes 30 de Marzo del 07, a las 12:05:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8438,53,'                              ','Viernes 30 de Marzo del 07, a las 12:07:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8439,6,'                              ','Viernes 30 de Marzo del 07, a las 12:08:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8440,6,'                              ','Viernes 30 de Marzo del 07, a las 12:17:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8441,11,'                              ','Viernes 30 de Marzo del 07, a las 12:31:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8442,6,'                              ','Viernes 30 de Marzo del 07, a las 12:31:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8443,6,'                              ','Viernes 30 de Marzo del 07, a las 12:44:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8444,6,'                              ','Viernes 30 de Marzo del 07, a las 12:47:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8445,6,'                              ','Viernes 30 de Marzo del 07, a las 12:49:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8446,6,'                              ','Viernes 30 de Marzo del 07, a las 13:24:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8447,6,'                              ','Viernes 30 de Marzo del 07, a las 13:25:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8448,6,'                              ','Viernes 30 de Marzo del 07, a las 13:27:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8449,6,'                              ','Viernes 30 de Marzo del 07, a las 13:28:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8450,6,'                              ','Viernes 30 de Marzo del 07, a las 13:29:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8451,6,'                              ','Viernes 30 de Marzo del 07, a las 13:53:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8452,6,'                              ','Viernes 30 de Marzo del 07, a las 13:54:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8453,53,'                              ','Viernes 30 de Marzo del 07, a las 13:55:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8454,11,'                              ','Viernes 30 de Marzo del 07, a las 13:57:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8455,11,'                              ','Viernes 30 de Marzo del 07, a las 14:00:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8456,6,'                              ','Viernes 30 de Marzo del 07, a las 14:06:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8457,53,'                              ','Viernes 30 de Marzo del 07, a las 14:07:25        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8458,6,'                              ','Viernes 30 de Marzo del 07, a las 14:07:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8459,11,'                              ','Viernes 30 de Marzo del 07, a las 14:12:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8460,11,'                              ','Viernes 30 de Marzo del 07, a las 14:14:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8461,11,'                              ','Viernes 30 de Marzo del 07, a las 14:15:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8462,11,'                              ','Viernes 30 de Marzo del 07, a las 14:18:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8463,11,'                              ','Viernes 30 de Marzo del 07, a las 14:21:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8464,53,'                              ','Viernes 30 de Marzo del 07, a las 14:24:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8465,6,'                              ','Viernes 30 de Marzo del 07, a las 14:26:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8466,11,'                              ','Viernes 30 de Marzo del 07, a las 14:26:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8467,53,'                              ','Viernes 30 de Marzo del 07, a las 14:28:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8468,53,'                              ','Viernes 30 de Marzo del 07, a las 14:28:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8469,6,'                              ','Mircoles 25 de Abril del 07, a las 10:03:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8470,6,'                              ','Mircoles 25 de Abril del 07, a las 10:16:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8471,6,'                              ','Lunes 14 de Mayo del 07, a las 12:09:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8472,2,'Bib Datos Propopios           ','Lunes 14 de Mayo del 07, a las 12:10:32           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8473,6,'                              ','Lunes 14 de Mayo del 07, a las 12:10:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8474,6,'                              ','Mircoles 16 de Mayo del 07, a las 14:49:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8475,6,'                              ','Viernes 18 de Mayo del 07, a las 14:44:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8476,6,'                              ','Viernes 18 de Mayo del 07, a las 14:45:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8477,6,'                              ','Viernes 18 de Mayo del 07, a las 14:47:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8478,53,'                              ','Viernes 18 de Mayo del 07, a las 14:51:34         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8479,6,'                              ','Viernes 18 de Mayo del 07, a las 14:52:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8480,11,'                              ','Viernes 18 de Mayo del 07, a las 14:54:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8481,6,'                              ','Viernes 18 de Mayo del 07, a las 14:57:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8482,6,'                              ','Viernes 18 de Mayo del 07, a las 15:04:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8483,6,'                              ','Viernes 18 de Mayo del 07, a las 15:05:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8484,11,'                              ','Viernes 18 de Mayo del 07, a las 15:05:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8485,11,'                              ','Viernes 18 de Mayo del 07, a las 15:05:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8486,11,'                              ','Viernes 18 de Mayo del 07, a las 15:08:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8487,11,'                              ','Viernes 18 de Mayo del 07, a las 16:06:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8488,6,'                              ','Mircoles 23 de Mayo del 07, a las 10:25:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8489,53,'                              ','Mircoles 23 de Mayo del 07, a las 14:10:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8490,53,'                              ','Mircoles 23 de Mayo del 07, a las 14:10:23       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8491,6,'                              ','Viernes 25 de Mayo del 07, a las 12:12:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8492,6,'                              ','Viernes 25 de Mayo del 07, a las 14:04:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8493,11,'                              ','Viernes 25 de Mayo del 07, a las 14:05:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8494,11,'                              ','Mircoles 30 de Mayo del 07, a las 11:26:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8495,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:27:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8496,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:30:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8497,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:32:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8498,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:33:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8499,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:33:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8500,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:35:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8501,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:36:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8502,6,'                              ','Mircoles 30 de Mayo del 07, a las 11:37:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8503,6,'                              ','Mircoles 30 de Mayo del 07, a las 16:40:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8504,6,'                              ','Mircoles 30 de Mayo del 07, a las 16:40:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8505,53,'                              ','Mircoles 30 de Mayo del 07, a las 16:49:46       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8506,6,'                              ','Jueves 31 de Mayo del 07, a las 12:58:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8507,11,'                              ','Jueves 31 de Mayo del 07, a las 12:59:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8508,6,'                              ','Jueves 31 de Mayo del 07, a las 13:01:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8509,6,'                              ','Jueves 31 de Mayo del 07, a las 13:07:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8510,6,'                              ','Jueves 31 de Mayo del 07, a las 13:08:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8511,6,'                              ','Jueves 31 de Mayo del 07, a las 13:08:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8512,11,'                              ','Jueves 31 de Mayo del 07, a las 16:31:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8513,11,'                              ','Jueves 31 de Mayo del 07, a las 16:32:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8514,53,'                              ','Jueves 31 de Mayo del 07, a las 18:07:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8515,6,'                              ','Martes 5 de Junio del 07, a las 17:56:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8516,6,'                              ','Viernes 8 de Junio del 07, a las 13:39:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8517,6,'                              ','Viernes 8 de Junio del 07, a las 13:44:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8518,6,'                              ','Viernes 8 de Junio del 07, a las 14:11:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8519,6,'                              ','Viernes 8 de Junio del 07, a las 14:12:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8520,6,'                              ','Viernes 8 de Junio del 07, a las 14:15:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8521,6,'                              ','Viernes 8 de Junio del 07, a las 14:17:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8522,6,'                              ','Viernes 8 de Junio del 07, a las 14:20:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8523,53,'                              ','Viernes 8 de Junio del 07, a las 15:44:28         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8524,6,'                              ','Viernes 8 de Junio del 07, a las 15:45:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8525,6,'                              ','Viernes 8 de Junio del 07, a las 15:46:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8526,6,'                              ','Viernes 8 de Junio del 07, a las 15:47:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8527,6,'                              ','Viernes 8 de Junio del 07, a las 15:49:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8528,6,'                              ','Viernes 8 de Junio del 07, a las 15:49:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8529,6,'                              ','Viernes 8 de Junio del 07, a las 15:50:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8530,53,'                              ','Viernes 8 de Junio del 07, a las 17:23:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8531,53,'                              ','Lunes 11 de Junio del 07, a las 10:41:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8532,6,'                              ','Martes 12 de Junio del 07, a las 10:50:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8533,6,'                              ','Martes 12 de Junio del 07, a las 10:54:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8534,6,'                              ','Martes 12 de Junio del 07, a las 10:55:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8535,51,'Direccion                     ','Martes 12 de Junio del 07, a las 13:23:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8536,51,'Direccion                     ','Martes 12 de Junio del 07, a las 13:23:33         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8537,53,'                              ','Martes 12 de Junio del 07, a las 13:31:40         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8538,53,'                              ','Martes 12 de Junio del 07, a las 13:31:50         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8539,6,'                              ','Martes 12 de Junio del 07, a las 18:08:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8540,6,'                              ','Martes 12 de Junio del 07, a las 18:09:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8541,6,'                              ','Mircoles 13 de Junio del 07, a las 11:47:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8542,53,'                              ','Mircoles 13 de Junio del 07, a las 12:00:47      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8543,11,'                              ','Mircoles 13 de Junio del 07, a las 15:37:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8544,2,'Bib Datos Propopios           ','Jueves 14 de Junio del 07, a las 16:59:26         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8545,4,'                              ','Jueves 14 de Junio del 07, a las 17:01:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8546,2,'Bib Datos Propopios           ','Jueves 14 de Junio del 07, a las 17:04:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8547,4,'                              ','Jueves 14 de Junio del 07, a las 17:05:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8548,2,'Bib Datos Propopios           ','Jueves 14 de Junio del 07, a las 17:07:10         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8549,4,'                              ','Jueves 14 de Junio del 07, a las 17:07:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8550,6,'                              ','Jueves 14 de Junio del 07, a las 17:09:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8551,11,'                              ','Jueves 14 de Junio del 07, a las 17:12:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8552,4,'                              ','Jueves 14 de Junio del 07, a las 17:18:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8553,4,'                              ','Jueves 14 de Junio del 07, a las 17:19:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8554,4,'                              ','Jueves 14 de Junio del 07, a las 17:19:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8555,4,'                              ','Jueves 14 de Junio del 07, a las 17:20:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8556,4,'                              ','Jueves 14 de Junio del 07, a las 17:21:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8557,4,'                              ','Jueves 14 de Junio del 07, a las 17:21:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8558,4,'                              ','Jueves 14 de Junio del 07, a las 17:24:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8559,11,'                              ','Jueves 14 de Junio del 07, a las 17:33:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8560,11,'                              ','Jueves 14 de Junio del 07, a las 17:34:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8561,6,'                              ','Viernes 15 de Junio del 07, a las 10:02:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8562,11,'                              ','Viernes 15 de Junio del 07, a las 10:05:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8563,11,'                              ','Viernes 15 de Junio del 07, a las 10:07:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8564,11,'                              ','Viernes 15 de Junio del 07, a las 10:35:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8565,53,'                              ','Viernes 15 de Junio del 07, a las 10:38:00        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8566,8,'                              ','Viernes 15 de Junio del 07, a las 10:40:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8567,6,'                              ','Viernes 15 de Junio del 07, a las 11:02:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8568,11,'                              ','Viernes 15 de Junio del 07, a las 11:24:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8569,53,'                              ','Viernes 15 de Junio del 07, a las 11:27:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8570,6,'                              ','Viernes 15 de Junio del 07, a las 11:28:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8571,11,'                              ','Viernes 15 de Junio del 07, a las 11:35:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8572,6,'                              ','Viernes 15 de Junio del 07, a las 11:38:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8573,53,'                              ','Viernes 15 de Junio del 07, a las 11:39:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8574,11,'                              ','Viernes 15 de Junio del 07, a las 11:42:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8575,11,'                              ','Viernes 15 de Junio del 07, a las 12:13:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8576,11,'                              ','Viernes 15 de Junio del 07, a las 12:15:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8577,11,'                              ','Viernes 15 de Junio del 07, a las 12:16:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8578,2,'Bib Datos Propopios           ','Viernes 15 de Junio del 07, a las 12:25:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8579,4,'                              ','Viernes 15 de Junio del 07, a las 12:26:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8580,2,'Bib Datos Propopios           ','Viernes 15 de Junio del 07, a las 12:50:58        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8581,4,'                              ','Viernes 15 de Junio del 07, a las 12:52:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8582,2,'Bib Datos Propopios           ','Viernes 15 de Junio del 07, a las 14:34:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8583,4,'                              ','Viernes 15 de Junio del 07, a las 14:35:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8584,6,'                              ','Viernes 15 de Junio del 07, a las 16:42:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8585,11,'                              ','Viernes 15 de Junio del 07, a las 16:51:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8586,53,'                              ','Viernes 15 de Junio del 07, a las 16:51:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8587,6,'                              ','Viernes 15 de Junio del 07, a las 16:53:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8588,6,'                              ','Viernes 15 de Junio del 07, a las 17:02:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8589,11,'                              ','Viernes 15 de Junio del 07, a las 17:21:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8590,53,'                              ','Viernes 15 de Junio del 07, a las 17:22:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8591,6,'                              ','Viernes 15 de Junio del 07, a las 17:25:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8592,6,'                              ','Viernes 15 de Junio del 07, a las 17:26:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8593,6,'                              ','Lunes 18 de Junio del 07, a las 11:16:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8594,53,'                              ','Lunes 18 de Junio del 07, a las 11:16:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8595,11,'                              ','Lunes 18 de Junio del 07, a las 11:19:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8596,6,'                              ','Lunes 18 de Junio del 07, a las 11:23:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8597,11,'                              ','Lunes 18 de Junio del 07, a las 11:24:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8598,53,'                              ','Lunes 18 de Junio del 07, a las 11:24:38          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8599,6,'                              ','Lunes 18 de Junio del 07, a las 11:37:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8600,6,'                              ','Lunes 18 de Junio del 07, a las 11:38:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8601,53,'                              ','Lunes 18 de Junio del 07, a las 11:46:31          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8602,53,'                              ','Lunes 18 de Junio del 07, a las 11:49:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8603,11,'                              ','Lunes 18 de Junio del 07, a las 12:03:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8604,6,'                              ','Lunes 18 de Junio del 07, a las 12:03:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8605,11,'                              ','Lunes 18 de Junio del 07, a las 12:07:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8606,6,'                              ','Lunes 18 de Junio del 07, a las 12:26:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8607,53,'                              ','Lunes 18 de Junio del 07, a las 12:30:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8608,6,'                              ','Lunes 18 de Junio del 07, a las 12:30:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8609,11,'                              ','Lunes 18 de Junio del 07, a las 12:32:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8610,11,'                              ','Lunes 18 de Junio del 07, a las 12:41:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8611,11,'                              ','Lunes 18 de Junio del 07, a las 12:42:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8612,11,'                              ','Lunes 18 de Junio del 07, a las 12:44:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8613,11,'                              ','Lunes 18 de Junio del 07, a las 12:45:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8614,11,'                              ','Lunes 18 de Junio del 07, a las 12:49:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8615,11,'                              ','Lunes 18 de Junio del 07, a las 13:00:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8616,6,'                              ','Lunes 18 de Junio del 07, a las 13:03:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8617,6,'                              ','Lunes 18 de Junio del 07, a las 13:05:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8618,6,'                              ','Lunes 18 de Junio del 07, a las 13:05:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8619,6,'                              ','Lunes 18 de Junio del 07, a las 13:36:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8620,6,'                              ','Lunes 18 de Junio del 07, a las 13:36:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8621,6,'                              ','Lunes 18 de Junio del 07, a las 13:38:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8622,6,'                              ','Lunes 18 de Junio del 07, a las 13:39:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8623,11,'                              ','Lunes 18 de Junio del 07, a las 13:45:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8624,6,'                              ','Lunes 18 de Junio del 07, a las 13:48:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8625,6,'                              ','Lunes 18 de Junio del 07, a las 14:13:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8626,53,'                              ','Lunes 18 de Junio del 07, a las 14:14:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8627,53,'                              ','Lunes 18 de Junio del 07, a las 14:14:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8628,53,'                              ','Lunes 18 de Junio del 07, a las 14:34:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8629,6,'                              ','Lunes 18 de Junio del 07, a las 14:34:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8630,53,'                              ','Lunes 18 de Junio del 07, a las 14:35:20          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8631,6,'                              ','Lunes 18 de Junio del 07, a las 14:36:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8632,6,'                              ','Lunes 18 de Junio del 07, a las 14:40:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8633,6,'                              ','Lunes 18 de Junio del 07, a las 14:41:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8634,6,'                              ','Lunes 18 de Junio del 07, a las 14:41:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8635,6,'                              ','Lunes 18 de Junio del 07, a las 14:42:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8636,6,'                              ','Lunes 18 de Junio del 07, a las 14:43:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8637,6,'                              ','Lunes 18 de Junio del 07, a las 16:40:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8638,53,'                              ','Lunes 18 de Junio del 07, a las 16:41:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8639,6,'                              ','Lunes 18 de Junio del 07, a las 16:43:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8640,6,'                              ','Lunes 18 de Junio del 07, a las 17:02:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8641,53,'                              ','Lunes 18 de Junio del 07, a las 17:03:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8642,53,'                              ','Lunes 18 de Junio del 07, a las 17:03:29          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8643,6,'                              ','Lunes 18 de Junio del 07, a las 17:11:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8644,11,'                              ','Lunes 18 de Junio del 07, a las 17:12:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8645,53,'                              ','Lunes 18 de Junio del 07, a las 17:12:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8646,53,'                              ','Lunes 18 de Junio del 07, a las 17:18:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8647,53,'                              ','Lunes 18 de Junio del 07, a las 17:19:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8648,53,'                              ','Lunes 18 de Junio del 07, a las 17:23:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8649,53,'                              ','Lunes 18 de Junio del 07, a las 17:30:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8650,6,'                              ','Lunes 18 de Junio del 07, a las 17:44:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8651,53,'                              ','Lunes 18 de Junio del 07, a las 17:45:20          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8652,6,'                              ','Lunes 18 de Junio del 07, a las 17:45:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8653,11,'                              ','Lunes 18 de Junio del 07, a las 17:52:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8654,6,'                              ','Lunes 18 de Junio del 07, a las 17:53:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8655,53,'                              ','Lunes 18 de Junio del 07, a las 17:54:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8656,53,'                              ','Lunes 18 de Junio del 07, a las 18:00:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8657,6,'                              ','Lunes 18 de Junio del 07, a las 18:00:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8658,53,'                              ','Lunes 18 de Junio del 07, a las 18:04:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8659,6,'                              ','Lunes 18 de Junio del 07, a las 18:13:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8660,6,'                              ','Lunes 18 de Junio del 07, a las 18:17:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8661,6,'                              ','Lunes 18 de Junio del 07, a las 18:23:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8662,53,'                              ','Lunes 18 de Junio del 07, a las 18:27:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8663,6,'                              ','Lunes 18 de Junio del 07, a las 18:32:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8664,53,'                              ','Lunes 18 de Junio del 07, a las 18:36:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8665,6,'                              ','Lunes 18 de Junio del 07, a las 18:44:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8666,53,'                              ','Martes 19 de Junio del 07, a las 10:25:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8667,53,'                              ','Martes 19 de Junio del 07, a las 10:27:26         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8668,6,'                              ','Martes 19 de Junio del 07, a las 10:35:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8669,6,'                              ','Martes 19 de Junio del 07, a las 10:40:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8670,6,'                              ','Martes 19 de Junio del 07, a las 10:43:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8671,53,'                              ','Martes 19 de Junio del 07, a las 10:43:48         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8672,11,'                              ','Martes 19 de Junio del 07, a las 10:50:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8673,2,'Bib Datos Propopios           ','Martes 19 de Junio del 07, a las 11:05:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8674,4,'                              ','Martes 19 de Junio del 07, a las 11:07:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8675,4,'                              ','Martes 19 de Junio del 07, a las 11:10:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8676,53,'                              ','Martes 19 de Junio del 07, a las 11:14:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8677,6,'                              ','Martes 19 de Junio del 07, a las 11:42:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8678,11,'                              ','Martes 19 de Junio del 07, a las 11:43:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8679,6,'                              ','Martes 19 de Junio del 07, a las 11:46:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8680,53,'                              ','Martes 19 de Junio del 07, a las 11:49:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8681,53,'                              ','Martes 19 de Junio del 07, a las 11:55:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8682,11,'                              ','Martes 19 de Junio del 07, a las 11:56:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8683,6,'                              ','Martes 19 de Junio del 07, a las 11:59:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8684,6,'                              ','Martes 19 de Junio del 07, a las 12:00:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8685,6,'                              ','Martes 19 de Junio del 07, a las 12:05:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8686,6,'                              ','Martes 19 de Junio del 07, a las 12:06:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8687,6,'                              ','Martes 19 de Junio del 07, a las 12:06:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8688,53,'                              ','Martes 19 de Junio del 07, a las 12:07:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8689,6,'                              ','Martes 19 de Junio del 07, a las 12:14:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8690,53,'                              ','Martes 19 de Junio del 07, a las 12:28:02         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8691,6,'                              ','Martes 19 de Junio del 07, a las 12:37:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8692,6,'                              ','Martes 19 de Junio del 07, a las 12:38:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8693,53,'                              ','Martes 19 de Junio del 07, a las 12:39:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8694,6,'                              ','Martes 19 de Junio del 07, a las 12:45:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8695,6,'                              ','Martes 19 de Junio del 07, a las 12:47:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8696,53,'                              ','Martes 19 de Junio del 07, a las 12:47:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8697,53,'                              ','Martes 19 de Junio del 07, a las 14:38:18         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8698,53,'                              ','Mircoles 20 de Junio del 07, a las 14:30:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8699,11,'                              ','Mircoles 20 de Junio del 07, a las 14:32:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8700,11,'                              ','Mircoles 20 de Junio del 07, a las 14:34:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8701,11,'                              ','Mircoles 20 de Junio del 07, a las 14:36:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8702,11,'                              ','Mircoles 20 de Junio del 07, a las 14:38:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8703,11,'                              ','Mircoles 20 de Junio del 07, a las 14:42:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8704,11,'                              ','Mircoles 20 de Junio del 07, a las 14:45:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8705,51,'Direccion                     ','Mircoles 20 de Junio del 07, a las 14:52:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8706,2,'Bib Datos Propopios           ','Jueves 21 de Junio del 07, a las 11:58:21         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8707,4,'                              ','Jueves 21 de Junio del 07, a las 11:59:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8708,2,'Bib Datos Propopios           ','Jueves 21 de Junio del 07, a las 12:05:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8709,4,'                              ','Jueves 21 de Junio del 07, a las 12:08:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8710,2,'Bib Datos Propopios           ','Jueves 21 de Junio del 07, a las 12:18:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8711,4,'                              ','Jueves 21 de Junio del 07, a las 12:19:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8712,53,'                              ','Jueves 21 de Junio del 07, a las 13:26:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8713,53,'                              ','Jueves 21 de Junio del 07, a las 13:26:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8714,53,'                              ','Jueves 21 de Junio del 07, a las 13:44:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8715,53,'                              ','Jueves 21 de Junio del 07, a las 13:45:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8716,53,'                              ','Jueves 21 de Junio del 07, a las 13:45:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8717,53,'                              ','Jueves 21 de Junio del 07, a las 13:46:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8718,53,'                              ','Jueves 21 de Junio del 07, a las 13:47:15         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8719,4,'                              ','Jueves 21 de Junio del 07, a las 13:48:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8720,2,'Bib Datos Propopios           ','Jueves 21 de Junio del 07, a las 13:49:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8721,2,'Bib Datos Propopios           ','Jueves 21 de Junio del 07, a las 13:51:07         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8722,4,'                              ','Jueves 21 de Junio del 07, a las 14:07:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8723,4,'                              ','Jueves 21 de Junio del 07, a las 14:10:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8724,4,'                              ','Jueves 21 de Junio del 07, a las 14:11:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8725,4,'                              ','Jueves 21 de Junio del 07, a las 14:13:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8726,53,'                              ','Jueves 21 de Junio del 07, a las 14:36:48         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8727,53,'                              ','Martes 26 de Junio del 07, a las 10:18:39         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8728,2,'Bib Datos Propopios           ','Martes 26 de Junio del 07, a las 12:02:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8729,4,'                              ','Martes 26 de Junio del 07, a las 12:02:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8730,53,'                              ','Jueves 28 de Junio del 07, a las 13:37:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8731,53,'                              ','Jueves 28 de Junio del 07, a las 13:38:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8732,6,'                              ','Viernes 29 de Junio del 07, a las 13:31:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8733,6,'                              ','Viernes 29 de Junio del 07, a las 13:36:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8734,2,'Bib Datos Propopios           ','Lunes 2 de Julio del 07, a las 11:25:38           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8735,4,'                              ','Lunes 2 de Julio del 07, a las 11:26:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8736,53,'                              ','Lunes 2 de Julio del 07, a las 11:40:31           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8737,6,'                              ','Lunes 2 de Julio del 07, a las 11:41:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8738,51,'Direccion                     ','Lunes 2 de Julio del 07, a las 11:49:58           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8739,6,'                              ','Lunes 2 de Julio del 07, a las 11:51:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8740,6,'                              ','Lunes 2 de Julio del 07, a las 13:33:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8741,6,'                              ','Lunes 2 de Julio del 07, a las 13:35:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8742,6,'                              ','Lunes 2 de Julio del 07, a las 13:36:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8743,6,'                              ','Lunes 2 de Julio del 07, a las 13:40:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8744,6,'                              ','Lunes 2 de Julio del 07, a las 13:41:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8745,6,'                              ','Lunes 2 de Julio del 07, a las 13:41:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8746,6,'                              ','Mircoles 4 de Julio del 07, a las 13:09:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8747,6,'                              ','Mircoles 4 de Julio del 07, a las 13:10:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8748,6,'                              ','Mircoles 4 de Julio del 07, a las 13:11:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8749,6,'                              ','Mircoles 4 de Julio del 07, a las 13:11:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8750,6,'                              ','Mircoles 4 de Julio del 07, a las 13:12:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8751,6,'                              ','Mircoles 4 de Julio del 07, a las 16:09:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8752,6,'                              ','Mircoles 4 de Julio del 07, a las 16:09:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8753,6,'                              ','Mircoles 4 de Julio del 07, a las 16:10:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8754,6,'                              ','Mircoles 4 de Julio del 07, a las 16:10:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8755,6,'                              ','Mircoles 4 de Julio del 07, a las 16:10:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8756,11,'                              ','Mircoles 4 de Julio del 07, a las 16:42:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8757,11,'                              ','Mircoles 4 de Julio del 07, a las 16:47:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8758,6,'                              ','Jueves 5 de Julio del 07, a las 14:30:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8759,53,'                              ','Jueves 5 de Julio del 07, a las 14:32:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8760,6,'                              ','Jueves 5 de Julio del 07, a las 17:21:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8761,6,'                              ','Mircoles 1 de Agosto del 07, a las 12:06:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8762,2,'Bib Datos Propopios           ','Viernes 3 de Agosto del 07, a las 11:47:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8763,4,'                              ','Viernes 3 de Agosto del 07, a las 11:48:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8764,4,'                              ','Viernes 3 de Agosto del 07, a las 11:54:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8765,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 09:20:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8766,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 09:47:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8767,4,'                              ','Martes 7 de Agosto del 07, a las 09:48:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8768,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 09:54:23         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8769,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 11:13:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8770,4,'                              ','Martes 7 de Agosto del 07, a las 11:13:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8771,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 11:32:29         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8772,4,'                              ','Martes 7 de Agosto del 07, a las 11:32:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8773,4,'                              ','Martes 7 de Agosto del 07, a las 11:42:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8774,3,'                              ','Martes 7 de Agosto del 07, a las 11:50:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8775,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 12:02:18         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8776,4,'                              ','Martes 7 de Agosto del 07, a las 12:09:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8777,3,'                              ','Martes 7 de Agosto del 07, a las 12:14:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8778,3,'                              ','Martes 7 de Agosto del 07, a las 12:17:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8779,6,'                              ','Martes 7 de Agosto del 07, a las 12:19:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8780,2,'Bib Datos Propopios           ','Martes 7 de Agosto del 07, a las 15:45:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8781,4,'                              ','Martes 7 de Agosto del 07, a las 15:45:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8782,4,'                              ','Mircoles 8 de Agosto del 07, a las 08:51:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8783,3,'                              ','Mircoles 8 de Agosto del 07, a las 08:51:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8784,4,'                              ','Mircoles 8 de Agosto del 07, a las 08:57:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8785,53,'                              ','Mircoles 8 de Agosto del 07, a las 09:05:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8786,11,'                              ','Mircoles 8 de Agosto del 07, a las 09:09:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8787,11,'                              ','Mircoles 8 de Agosto del 07, a las 09:12:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8788,4,'                              ','Mircoles 8 de Agosto del 07, a las 09:43:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8789,2,'Bib Datos Propopios           ','Mircoles 8 de Agosto del 07, a las 10:15:28      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8790,3,'                              ','Mircoles 8 de Agosto del 07, a las 10:21:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8791,4,'                              ','Mircoles 8 de Agosto del 07, a las 10:31:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8792,3,'                              ','Mircoles 8 de Agosto del 07, a las 10:45:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8793,4,'                              ','Mircoles 8 de Agosto del 07, a las 10:53:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8794,4,'                              ','Mircoles 8 de Agosto del 07, a las 10:58:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8795,2,'Bib Datos Propopios           ','Mircoles 8 de Agosto del 07, a las 11:06:47      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8796,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:07:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8797,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:21:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8798,3,'                              ','Mircoles 8 de Agosto del 07, a las 11:22:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8799,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:28:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8800,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:38:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8801,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:41:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8802,2,'Bib Datos Propopios           ','Mircoles 8 de Agosto del 07, a las 11:44:11      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8803,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:44:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8804,4,'                              ','Mircoles 8 de Agosto del 07, a las 11:55:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8805,4,'                              ','Mircoles 8 de Agosto del 07, a las 12:00:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8806,2,'Bib Datos Propopios           ','Mircoles 8 de Agosto del 07, a las 12:01:22      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8807,11,'                              ','Mircoles 8 de Agosto del 07, a las 14:10:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8808,11,'                              ','Mircoles 8 de Agosto del 07, a las 14:13:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8809,11,'                              ','Mircoles 8 de Agosto del 07, a las 14:17:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8810,11,'                              ','Mircoles 8 de Agosto del 07, a las 14:19:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8811,6,'                              ','Lunes 13 de Agosto del 07, a las 11:01:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8812,11,'                              ','Lunes 13 de Agosto del 07, a las 11:03:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8813,11,'                              ','Lunes 13 de Agosto del 07, a las 11:05:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8814,53,'                              ','Lunes 13 de Agosto del 07, a las 11:17:07         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8815,4,'                              ','Lunes 13 de Agosto del 07, a las 16:18:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8816,4,'                              ','Lunes 13 de Agosto del 07, a las 16:19:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8817,53,'                              ','Martes 14 de Agosto del 07, a las 10:03:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8818,53,'                              ','Martes 14 de Agosto del 07, a las 13:06:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8819,4,'                              ','Martes 14 de Agosto del 07, a las 13:19:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8820,2,'Bib Datos Propopios           ','Martes 14 de Agosto del 07, a las 13:33:49        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8821,2,'Bib Datos Propopios           ','Martes 14 de Agosto del 07, a las 13:35:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8822,8,'                              ','Martes 14 de Agosto del 07, a las 14:58:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8823,8,'                              ','Martes 14 de Agosto del 07, a las 14:58:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8824,8,'                              ','Martes 14 de Agosto del 07, a las 14:59:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8825,2,'Bib Datos Propopios           ','Martes 14 de Agosto del 07, a las 15:00:04        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8826,8,'                              ','Martes 14 de Agosto del 07, a las 15:00:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8827,8,'                              ','Martes 14 de Agosto del 07, a las 15:01:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8828,8,'                              ','Martes 14 de Agosto del 07, a las 15:01:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8829,8,'                              ','Martes 14 de Agosto del 07, a las 15:01:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8830,8,'                              ','Martes 14 de Agosto del 07, a las 15:02:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8831,8,'                              ','Martes 14 de Agosto del 07, a las 15:03:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8832,8,'                              ','Martes 14 de Agosto del 07, a las 15:03:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8833,8,'                              ','Martes 14 de Agosto del 07, a las 15:04:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8834,8,'                              ','Martes 14 de Agosto del 07, a las 15:04:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8835,8,'                              ','Martes 14 de Agosto del 07, a las 15:05:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8836,8,'                              ','Martes 14 de Agosto del 07, a las 15:05:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8837,8,'                              ','Martes 14 de Agosto del 07, a las 15:05:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8838,8,'                              ','Martes 14 de Agosto del 07, a las 15:06:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8839,8,'                              ','Martes 14 de Agosto del 07, a las 15:08:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8840,8,'                              ','Martes 14 de Agosto del 07, a las 15:08:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8841,8,'                              ','Martes 14 de Agosto del 07, a las 15:09:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8842,8,'                              ','Martes 14 de Agosto del 07, a las 15:10:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8843,8,'                              ','Martes 14 de Agosto del 07, a las 15:10:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8844,8,'                              ','Martes 14 de Agosto del 07, a las 15:11:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8845,8,'                              ','Martes 14 de Agosto del 07, a las 15:11:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8846,8,'                              ','Martes 14 de Agosto del 07, a las 15:12:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8847,8,'                              ','Martes 14 de Agosto del 07, a las 15:12:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8848,8,'                              ','Martes 14 de Agosto del 07, a las 15:13:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8849,8,'                              ','Martes 14 de Agosto del 07, a las 15:13:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8850,8,'                              ','Martes 14 de Agosto del 07, a las 15:14:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8851,8,'                              ','Martes 14 de Agosto del 07, a las 15:15:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8852,8,'                              ','Martes 14 de Agosto del 07, a las 15:15:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8853,8,'                              ','Martes 14 de Agosto del 07, a las 15:15:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8854,8,'                              ','Martes 14 de Agosto del 07, a las 15:16:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8855,8,'                              ','Martes 14 de Agosto del 07, a las 15:16:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8856,8,'                              ','Martes 14 de Agosto del 07, a las 15:17:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8857,8,'                              ','Martes 14 de Agosto del 07, a las 15:17:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8858,8,'                              ','Martes 14 de Agosto del 07, a las 15:18:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8859,8,'                              ','Martes 14 de Agosto del 07, a las 15:18:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8860,8,'                              ','Martes 14 de Agosto del 07, a las 15:18:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8861,8,'                              ','Martes 14 de Agosto del 07, a las 15:20:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8862,8,'                              ','Martes 14 de Agosto del 07, a las 15:21:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8863,8,'                              ','Martes 14 de Agosto del 07, a las 15:21:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8864,8,'                              ','Martes 14 de Agosto del 07, a las 15:21:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8865,8,'                              ','Martes 14 de Agosto del 07, a las 15:22:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8866,8,'                              ','Martes 14 de Agosto del 07, a las 15:23:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8867,8,'                              ','Martes 14 de Agosto del 07, a las 15:23:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8868,8,'                              ','Martes 14 de Agosto del 07, a las 15:23:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8869,8,'                              ','Martes 14 de Agosto del 07, a las 15:24:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8870,8,'                              ','Martes 14 de Agosto del 07, a las 15:24:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8871,8,'                              ','Martes 14 de Agosto del 07, a las 15:25:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8872,8,'                              ','Martes 14 de Agosto del 07, a las 15:26:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8873,8,'                              ','Martes 14 de Agosto del 07, a las 15:27:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8874,8,'                              ','Martes 14 de Agosto del 07, a las 15:27:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8875,8,'                              ','Martes 14 de Agosto del 07, a las 15:27:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8876,8,'                              ','Martes 14 de Agosto del 07, a las 15:28:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8877,8,'                              ','Martes 14 de Agosto del 07, a las 15:28:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8878,8,'                              ','Martes 14 de Agosto del 07, a las 15:28:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8879,8,'                              ','Martes 14 de Agosto del 07, a las 15:29:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8880,8,'                              ','Martes 14 de Agosto del 07, a las 15:29:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8881,8,'                              ','Martes 14 de Agosto del 07, a las 15:29:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8882,8,'                              ','Martes 14 de Agosto del 07, a las 15:30:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8883,8,'                              ','Martes 14 de Agosto del 07, a las 15:30:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8884,8,'                              ','Martes 14 de Agosto del 07, a las 15:30:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8885,8,'                              ','Martes 14 de Agosto del 07, a las 15:31:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8886,8,'                              ','Martes 14 de Agosto del 07, a las 15:31:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8887,8,'                              ','Martes 14 de Agosto del 07, a las 15:32:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8888,8,'                              ','Martes 14 de Agosto del 07, a las 15:33:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8889,8,'                              ','Martes 14 de Agosto del 07, a las 15:33:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8890,8,'                              ','Martes 14 de Agosto del 07, a las 15:34:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8891,8,'                              ','Martes 14 de Agosto del 07, a las 15:34:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8892,8,'                              ','Martes 14 de Agosto del 07, a las 15:35:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8893,8,'                              ','Martes 14 de Agosto del 07, a las 15:35:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8894,8,'                              ','Martes 14 de Agosto del 07, a las 15:36:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8895,8,'                              ','Martes 14 de Agosto del 07, a las 15:36:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8896,8,'                              ','Martes 14 de Agosto del 07, a las 15:36:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8897,8,'                              ','Martes 14 de Agosto del 07, a las 15:37:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8898,8,'                              ','Martes 14 de Agosto del 07, a las 15:37:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8899,8,'                              ','Martes 14 de Agosto del 07, a las 15:38:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8900,8,'                              ','Martes 14 de Agosto del 07, a las 15:38:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8901,8,'                              ','Martes 14 de Agosto del 07, a las 15:39:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8902,8,'                              ','Martes 14 de Agosto del 07, a las 15:39:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8903,8,'                              ','Martes 14 de Agosto del 07, a las 15:41:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8904,8,'                              ','Martes 14 de Agosto del 07, a las 15:42:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8905,8,'                              ','Martes 14 de Agosto del 07, a las 15:42:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8906,8,'                              ','Martes 14 de Agosto del 07, a las 15:42:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8907,8,'                              ','Martes 14 de Agosto del 07, a las 15:43:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8908,8,'                              ','Martes 14 de Agosto del 07, a las 15:43:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8909,8,'                              ','Martes 14 de Agosto del 07, a las 15:55:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8910,8,'                              ','Martes 14 de Agosto del 07, a las 15:55:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8911,8,'                              ','Martes 14 de Agosto del 07, a las 15:55:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8912,8,'                              ','Martes 14 de Agosto del 07, a las 16:12:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8913,8,'                              ','Martes 14 de Agosto del 07, a las 16:13:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8914,8,'                              ','Martes 14 de Agosto del 07, a las 16:13:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8915,8,'                              ','Martes 14 de Agosto del 07, a las 16:13:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8916,8,'                              ','Martes 14 de Agosto del 07, a las 16:14:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8917,8,'                              ','Martes 14 de Agosto del 07, a las 16:14:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8918,8,'                              ','Martes 14 de Agosto del 07, a las 16:15:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8919,8,'                              ','Martes 14 de Agosto del 07, a las 16:15:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8920,8,'                              ','Martes 14 de Agosto del 07, a las 16:15:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8921,8,'                              ','Martes 14 de Agosto del 07, a las 16:16:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8922,8,'                              ','Martes 14 de Agosto del 07, a las 16:16:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8923,8,'                              ','Martes 14 de Agosto del 07, a las 16:18:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8924,8,'                              ','Martes 14 de Agosto del 07, a las 16:18:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8925,8,'                              ','Martes 14 de Agosto del 07, a las 16:18:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8926,8,'                              ','Martes 14 de Agosto del 07, a las 16:19:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8927,8,'                              ','Martes 14 de Agosto del 07, a las 16:19:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8928,8,'                              ','Martes 14 de Agosto del 07, a las 16:20:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8929,8,'                              ','Martes 14 de Agosto del 07, a las 16:20:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8930,8,'                              ','Martes 14 de Agosto del 07, a las 16:20:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8931,8,'                              ','Martes 14 de Agosto del 07, a las 16:21:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8932,8,'                              ','Martes 14 de Agosto del 07, a las 16:22:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8933,8,'                              ','Martes 14 de Agosto del 07, a las 16:24:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8934,8,'                              ','Martes 14 de Agosto del 07, a las 16:25:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8935,8,'                              ','Martes 14 de Agosto del 07, a las 16:25:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8936,8,'                              ','Martes 14 de Agosto del 07, a las 16:26:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8937,8,'                              ','Martes 14 de Agosto del 07, a las 16:26:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8938,8,'                              ','Martes 14 de Agosto del 07, a las 16:27:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8939,8,'                              ','Martes 14 de Agosto del 07, a las 16:27:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8940,8,'                              ','Martes 14 de Agosto del 07, a las 16:27:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8941,8,'                              ','Martes 14 de Agosto del 07, a las 16:28:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8942,8,'                              ','Martes 14 de Agosto del 07, a las 16:28:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8943,8,'                              ','Martes 14 de Agosto del 07, a las 16:29:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8944,8,'                              ','Martes 14 de Agosto del 07, a las 16:29:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8945,8,'                              ','Martes 14 de Agosto del 07, a las 16:29:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8946,8,'                              ','Martes 14 de Agosto del 07, a las 16:30:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8947,8,'                              ','Martes 14 de Agosto del 07, a las 16:31:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8948,8,'                              ','Martes 14 de Agosto del 07, a las 16:31:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8949,8,'                              ','Martes 14 de Agosto del 07, a las 16:32:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8950,8,'                              ','Martes 14 de Agosto del 07, a las 16:32:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8951,8,'                              ','Martes 14 de Agosto del 07, a las 16:33:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8952,8,'                              ','Martes 14 de Agosto del 07, a las 16:33:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8953,8,'                              ','Martes 14 de Agosto del 07, a las 16:34:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8954,8,'                              ','Martes 14 de Agosto del 07, a las 16:34:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8955,8,'                              ','Martes 14 de Agosto del 07, a las 16:35:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8956,8,'                              ','Martes 14 de Agosto del 07, a las 16:35:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8957,8,'                              ','Martes 14 de Agosto del 07, a las 16:36:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8958,8,'                              ','Martes 14 de Agosto del 07, a las 16:36:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8959,8,'                              ','Martes 14 de Agosto del 07, a las 16:37:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8960,8,'                              ','Martes 14 de Agosto del 07, a las 16:37:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8961,8,'                              ','Martes 14 de Agosto del 07, a las 16:37:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8962,8,'                              ','Martes 14 de Agosto del 07, a las 16:38:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8963,8,'                              ','Martes 14 de Agosto del 07, a las 16:38:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8964,8,'                              ','Martes 14 de Agosto del 07, a las 16:39:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8965,8,'                              ','Martes 14 de Agosto del 07, a las 16:39:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8966,8,'                              ','Martes 14 de Agosto del 07, a las 16:40:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8967,8,'                              ','Martes 14 de Agosto del 07, a las 16:40:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8968,8,'                              ','Martes 14 de Agosto del 07, a las 16:41:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8969,8,'                              ','Martes 14 de Agosto del 07, a las 16:42:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8970,8,'                              ','Martes 14 de Agosto del 07, a las 16:42:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8971,8,'                              ','Martes 14 de Agosto del 07, a las 16:42:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8972,8,'                              ','Martes 14 de Agosto del 07, a las 16:43:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8973,8,'                              ','Martes 14 de Agosto del 07, a las 16:43:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8974,8,'                              ','Martes 14 de Agosto del 07, a las 16:44:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8975,8,'                              ','Martes 14 de Agosto del 07, a las 16:44:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8976,8,'                              ','Martes 14 de Agosto del 07, a las 16:48:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8977,8,'                              ','Martes 14 de Agosto del 07, a las 16:48:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8978,8,'                              ','Martes 14 de Agosto del 07, a las 16:49:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8979,8,'                              ','Martes 14 de Agosto del 07, a las 16:49:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8980,8,'                              ','Martes 14 de Agosto del 07, a las 16:50:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8981,8,'                              ','Martes 14 de Agosto del 07, a las 16:50:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8982,8,'                              ','Martes 14 de Agosto del 07, a las 16:50:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8983,8,'                              ','Martes 14 de Agosto del 07, a las 16:51:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8984,8,'                              ','Martes 14 de Agosto del 07, a las 16:51:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8985,8,'                              ','Martes 14 de Agosto del 07, a las 16:51:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8986,8,'                              ','Martes 14 de Agosto del 07, a las 16:52:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8987,8,'                              ','Martes 14 de Agosto del 07, a las 16:53:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8988,8,'                              ','Martes 14 de Agosto del 07, a las 16:53:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8989,8,'                              ','Martes 14 de Agosto del 07, a las 16:53:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8990,8,'                              ','Martes 14 de Agosto del 07, a las 16:54:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8991,8,'                              ','Martes 14 de Agosto del 07, a las 16:55:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8992,8,'                              ','Martes 14 de Agosto del 07, a las 16:55:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8993,8,'                              ','Martes 14 de Agosto del 07, a las 16:56:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8994,8,'                              ','Martes 14 de Agosto del 07, a las 16:56:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8995,8,'                              ','Martes 14 de Agosto del 07, a las 16:57:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8996,8,'                              ','Martes 14 de Agosto del 07, a las 16:57:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8997,8,'                              ','Martes 14 de Agosto del 07, a las 16:58:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8998,53,'                              ','Mircoles 15 de Agosto del 07, a las 12:15:34     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (8999,53,'                              ','Mircoles 15 de Agosto del 07, a las 12:16:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9000,53,'                              ','Mircoles 15 de Agosto del 07, a las 12:16:40     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9001,51,'Direccion                     ','Mircoles 15 de Agosto del 07, a las 12:27:08     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9002,51,'Direccion                     ','Mircoles 15 de Agosto del 07, a las 12:27:17     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9003,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:06:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9004,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:07:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9005,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:13:50     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9006,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:19:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9007,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:23:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9008,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:23:16     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9009,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:23:29     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9010,53,'                              ','Mircoles 15 de Agosto del 07, a las 13:23:35     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9011,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:25:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9012,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:28:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9013,8,'                              ','Mircoles 15 de Agosto del 07, a las 13:29:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9014,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:29:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9015,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:31:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9016,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:33:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9017,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:36:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9018,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:38:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9019,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:41:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9020,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:43:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9021,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:44:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9022,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:46:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9023,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:48:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9024,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:50:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9025,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:52:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9026,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:53:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9027,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:55:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9028,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:56:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9029,11,'                              ','Mircoles 15 de Agosto del 07, a las 13:58:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9030,11,'                              ','Mircoles 15 de Agosto del 07, a las 14:00:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9031,11,'                              ','Mircoles 15 de Agosto del 07, a las 14:01:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9032,11,'                              ','Mircoles 15 de Agosto del 07, a las 14:03:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9033,11,'                              ','Mircoles 15 de Agosto del 07, a las 14:05:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9034,11,'                              ','Mircoles 15 de Agosto del 07, a las 14:07:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9035,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:07:35     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9036,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:08:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9037,2,'Bib Datos Propopios           ','Mircoles 15 de Agosto del 07, a las 14:23:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9038,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:23:23     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9039,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:23:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9040,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:24:47     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9041,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:25:43     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9042,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:26:27     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9043,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:26:50     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9044,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:27:17     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9045,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:28:32     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9046,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:29:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9047,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:29:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9048,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:30:38     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9049,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:32:29     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9050,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:32:32     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9051,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:34:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9052,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:35:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9053,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:36:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9054,53,'                              ','Mircoles 15 de Agosto del 07, a las 14:36:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9055,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:50:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9056,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:51:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9057,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:52:55     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9058,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:53:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9059,6,'                              ','Mircoles 15 de Agosto del 07, a las 15:54:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9060,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:54:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9061,6,'                              ','Mircoles 15 de Agosto del 07, a las 15:55:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9062,6,'                              ','Mircoles 15 de Agosto del 07, a las 15:56:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9063,4,'                              ','Mircoles 15 de Agosto del 07, a las 15:57:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9064,6,'                              ','Mircoles 15 de Agosto del 07, a las 15:58:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9065,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:58:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9066,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:59:17     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9067,53,'                              ','Mircoles 15 de Agosto del 07, a las 15:59:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9068,6,'                              ','Mircoles 15 de Agosto del 07, a las 16:01:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9069,53,'                              ','Mircoles 15 de Agosto del 07, a las 16:01:55     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9070,11,'                              ','Mircoles 15 de Agosto del 07, a las 16:02:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9071,6,'                              ','Mircoles 15 de Agosto del 07, a las 16:03:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9072,53,'                              ','Mircoles 15 de Agosto del 07, a las 16:07:59     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9073,4,'                              ','Mircoles 15 de Agosto del 07, a las 16:08:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9074,6,'                              ','Jueves 16 de Agosto del 07, a las 09:19:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9075,53,'                              ','Jueves 16 de Agosto del 07, a las 09:22:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9076,53,'                              ','Jueves 16 de Agosto del 07, a las 09:22:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9077,53,'                              ','Jueves 16 de Agosto del 07, a las 09:23:19        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9078,11,'                              ','Jueves 16 de Agosto del 07, a las 09:23:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9079,53,'                              ','Jueves 16 de Agosto del 07, a las 09:25:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9080,6,'                              ','Jueves 16 de Agosto del 07, a las 09:27:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9081,53,'                              ','Jueves 16 de Agosto del 07, a las 09:27:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9082,11,'                              ','Jueves 16 de Agosto del 07, a las 09:28:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9083,6,'                              ','Jueves 16 de Agosto del 07, a las 09:29:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9084,53,'                              ','Jueves 16 de Agosto del 07, a las 09:30:11        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9085,6,'                              ','Jueves 16 de Agosto del 07, a las 09:30:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9086,53,'                              ','Jueves 16 de Agosto del 07, a las 09:33:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9087,53,'                              ','Jueves 16 de Agosto del 07, a las 09:42:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9088,53,'                              ','Jueves 16 de Agosto del 07, a las 09:43:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9089,6,'                              ','Jueves 16 de Agosto del 07, a las 09:43:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9090,53,'                              ','Jueves 16 de Agosto del 07, a las 09:44:09        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9091,6,'                              ','Jueves 16 de Agosto del 07, a las 09:44:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9092,6,'                              ','Jueves 16 de Agosto del 07, a las 09:45:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9093,53,'                              ','Jueves 16 de Agosto del 07, a las 09:46:16        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9094,6,'                              ','Jueves 16 de Agosto del 07, a las 09:47:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9095,6,'                              ','Jueves 16 de Agosto del 07, a las 09:47:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9096,53,'                              ','Jueves 16 de Agosto del 07, a las 09:49:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9097,6,'                              ','Jueves 16 de Agosto del 07, a las 10:03:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9098,53,'                              ','Jueves 16 de Agosto del 07, a las 10:03:29        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9099,6,'                              ','Jueves 16 de Agosto del 07, a las 10:03:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9100,53,'                              ','Jueves 16 de Agosto del 07, a las 10:04:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9101,6,'                              ','Jueves 16 de Agosto del 07, a las 10:05:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9102,53,'                              ','Jueves 16 de Agosto del 07, a las 10:05:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9103,6,'                              ','Jueves 16 de Agosto del 07, a las 10:06:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9104,6,'                              ','Jueves 16 de Agosto del 07, a las 12:56:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9105,11,'                              ','Jueves 16 de Agosto del 07, a las 13:17:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9106,11,'                              ','Jueves 16 de Agosto del 07, a las 13:24:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9107,6,'                              ','Jueves 16 de Agosto del 07, a las 14:56:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9108,6,'                              ','Jueves 16 de Agosto del 07, a las 14:58:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9109,53,'                              ','Jueves 16 de Agosto del 07, a las 14:59:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9110,6,'                              ','Jueves 16 de Agosto del 07, a las 15:01:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9111,6,'                              ','Jueves 16 de Agosto del 07, a las 16:05:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9112,4,'                              ','Viernes 17 de Agosto del 07, a las 13:15:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9113,3,'                              ','Lunes 20 de Agosto del 07, a las 11:38:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9114,4,'                              ','Lunes 20 de Agosto del 07, a las 11:39:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9115,3,'                              ','Lunes 20 de Agosto del 07, a las 11:39:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9116,11,'                              ','Lunes 20 de Agosto del 07, a las 11:43:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9117,3,'                              ','Lunes 20 de Agosto del 07, a las 11:48:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9118,4,'                              ','Lunes 20 de Agosto del 07, a las 13:27:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9119,4,'                              ','Lunes 20 de Agosto del 07, a las 13:30:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9120,4,'                              ','Lunes 20 de Agosto del 07, a las 13:35:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9121,4,'                              ','Lunes 20 de Agosto del 07, a las 13:37:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9122,4,'                              ','Lunes 20 de Agosto del 07, a las 13:37:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9123,4,'                              ','Lunes 20 de Agosto del 07, a las 13:38:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9124,6,'                              ','Lunes 20 de Agosto del 07, a las 16:19:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9125,53,'                              ','Lunes 20 de Agosto del 07, a las 16:26:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9126,6,'                              ','Lunes 20 de Agosto del 07, a las 16:27:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9127,6,'                              ','Lunes 20 de Agosto del 07, a las 16:28:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9128,6,'                              ','Lunes 20 de Agosto del 07, a las 16:28:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9129,53,'                              ','Martes 21 de Agosto del 07, a las 10:14:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9130,6,'                              ','Martes 21 de Agosto del 07, a las 10:15:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9131,6,'                              ','Martes 21 de Agosto del 07, a las 10:15:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9132,6,'                              ','Martes 21 de Agosto del 07, a las 10:16:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9133,6,'                              ','Martes 21 de Agosto del 07, a las 10:17:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9134,53,'                              ','Martes 21 de Agosto del 07, a las 10:18:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9135,53,'                              ','Martes 21 de Agosto del 07, a las 10:18:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9136,53,'                              ','Martes 21 de Agosto del 07, a las 10:19:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9137,53,'                              ','Martes 21 de Agosto del 07, a las 10:19:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9138,53,'                              ','Martes 21 de Agosto del 07, a las 10:20:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9139,6,'                              ','Martes 21 de Agosto del 07, a las 10:21:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9140,6,'                              ','Martes 21 de Agosto del 07, a las 10:23:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9141,3,'                              ','Martes 21 de Agosto del 07, a las 10:23:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9142,4,'                              ','Martes 21 de Agosto del 07, a las 10:24:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9143,6,'                              ','Martes 21 de Agosto del 07, a las 10:25:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9144,6,'                              ','Martes 21 de Agosto del 07, a las 10:37:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9145,6,'                              ','Martes 21 de Agosto del 07, a las 10:38:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9146,2,'Bib Datos Propopios           ','Martes 21 de Agosto del 07, a las 10:44:00        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9147,4,'                              ','Martes 21 de Agosto del 07, a las 10:46:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9148,53,'                              ','Martes 21 de Agosto del 07, a las 10:47:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9149,53,'                              ','Martes 21 de Agosto del 07, a las 10:48:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9150,53,'                              ','Martes 21 de Agosto del 07, a las 10:48:49        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9151,53,'                              ','Martes 21 de Agosto del 07, a las 10:54:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9152,6,'                              ','Martes 21 de Agosto del 07, a las 10:55:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9153,6,'                              ','Martes 21 de Agosto del 07, a las 10:56:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9154,6,'                              ','Martes 21 de Agosto del 07, a las 10:57:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9155,53,'                              ','Martes 21 de Agosto del 07, a las 10:57:52        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9156,51,'Direccion                     ','Martes 21 de Agosto del 07, a las 10:58:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9157,6,'                              ','Martes 21 de Agosto del 07, a las 10:58:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9158,6,'                              ','Martes 21 de Agosto del 07, a las 10:59:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9159,6,'                              ','Martes 21 de Agosto del 07, a las 11:11:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9160,6,'                              ','Martes 21 de Agosto del 07, a las 11:14:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9161,6,'                              ','Martes 21 de Agosto del 07, a las 11:15:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9162,6,'                              ','Martes 21 de Agosto del 07, a las 11:16:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9163,6,'                              ','Martes 21 de Agosto del 07, a las 11:16:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9164,6,'                              ','Martes 21 de Agosto del 07, a las 11:17:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9165,51,'Direccion                     ','Martes 21 de Agosto del 07, a las 11:37:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9166,3,'                              ','Martes 21 de Agosto del 07, a las 11:43:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9167,4,'                              ','Martes 21 de Agosto del 07, a las 12:00:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9168,4,'                              ','Martes 21 de Agosto del 07, a las 12:01:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9169,6,'                              ','Martes 21 de Agosto del 07, a las 12:10:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9170,53,'                              ','Martes 21 de Agosto del 07, a las 12:11:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9171,4,'                              ','Martes 21 de Agosto del 07, a las 12:43:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9172,4,'                              ','Martes 21 de Agosto del 07, a las 12:44:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9173,4,'                              ','Martes 21 de Agosto del 07, a las 12:45:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9174,4,'                              ','Martes 21 de Agosto del 07, a las 13:03:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9175,4,'                              ','Martes 21 de Agosto del 07, a las 13:04:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9176,4,'                              ','Mircoles 22 de Agosto del 07, a las 12:30:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9177,4,'                              ','Mircoles 22 de Agosto del 07, a las 12:31:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9178,6,'                              ','Mircoles 22 de Agosto del 07, a las 15:33:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9179,53,'                              ','Mircoles 22 de Agosto del 07, a las 15:34:24     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9180,6,'                              ','Mircoles 22 de Agosto del 07, a las 15:35:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9181,53,'                              ','Mircoles 22 de Agosto del 07, a las 15:36:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9182,53,'                              ','Mircoles 22 de Agosto del 07, a las 15:37:23     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9183,53,'                              ','Mircoles 22 de Agosto del 07, a las 15:38:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9184,6,'                              ','Mircoles 22 de Agosto del 07, a las 15:38:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9185,53,'                              ','Mircoles 22 de Agosto del 07, a las 15:39:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9186,6,'                              ','Mircoles 22 de Agosto del 07, a las 15:40:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9187,53,'                              ','Mircoles 22 de Agosto del 07, a las 15:41:32     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9188,3,'                              ','Mircoles 22 de Agosto del 07, a las 15:43:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9189,4,'                              ','Mircoles 22 de Agosto del 07, a las 16:06:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9190,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:07:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9191,11,'                              ','Mircoles 22 de Agosto del 07, a las 16:12:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9192,11,'                              ','Mircoles 22 de Agosto del 07, a las 16:15:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9193,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:16:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9194,53,'                              ','Mircoles 22 de Agosto del 07, a las 16:17:12     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9195,53,'                              ','Mircoles 22 de Agosto del 07, a las 16:18:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9196,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:18:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9197,3,'                              ','Mircoles 22 de Agosto del 07, a las 16:19:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9198,4,'                              ','Mircoles 22 de Agosto del 07, a las 16:19:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9199,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:20:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9200,53,'                              ','Mircoles 22 de Agosto del 07, a las 16:20:32     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9201,51,'Direccion                     ','Mircoles 22 de Agosto del 07, a las 16:20:54     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9202,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:21:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9203,53,'                              ','Mircoles 22 de Agosto del 07, a las 16:21:40     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9204,51,'Direccion                     ','Mircoles 22 de Agosto del 07, a las 16:21:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9205,53,'                              ','Mircoles 22 de Agosto del 07, a las 16:29:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9206,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:33:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9207,6,'                              ','Mircoles 22 de Agosto del 07, a las 16:34:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9208,4,'                              ','Mircoles 22 de Agosto del 07, a las 16:38:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9209,3,'                              ','Mircoles 22 de Agosto del 07, a las 16:49:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9210,3,'                              ','Mircoles 22 de Agosto del 07, a las 16:51:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9211,4,'                              ','Jueves 23 de Agosto del 07, a las 09:40:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9212,4,'                              ','Jueves 23 de Agosto del 07, a las 09:43:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9213,4,'                              ','Jueves 23 de Agosto del 07, a las 09:45:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9214,4,'                              ','Jueves 23 de Agosto del 07, a las 09:54:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9215,4,'                              ','Jueves 23 de Agosto del 07, a las 09:55:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9216,4,'                              ','Jueves 23 de Agosto del 07, a las 10:04:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9217,53,'                              ','Jueves 23 de Agosto del 07, a las 13:47:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9218,11,'                              ','Jueves 23 de Agosto del 07, a las 13:47:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9219,53,'                              ','Jueves 23 de Agosto del 07, a las 13:48:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9220,6,'                              ','Jueves 23 de Agosto del 07, a las 13:49:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9221,53,'                              ','Jueves 23 de Agosto del 07, a las 13:50:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9222,51,'Direccion                     ','Jueves 23 de Agosto del 07, a las 13:51:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9223,51,'Direccion                     ','Jueves 23 de Agosto del 07, a las 13:51:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9224,53,'                              ','Jueves 23 de Agosto del 07, a las 13:52:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9225,51,'Direccion                     ','Jueves 23 de Agosto del 07, a las 13:52:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9226,51,'Direccion                     ','Jueves 23 de Agosto del 07, a las 13:52:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9227,53,'                              ','Jueves 23 de Agosto del 07, a las 14:01:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9228,53,'                              ','Jueves 23 de Agosto del 07, a las 14:09:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9229,6,'                              ','Jueves 23 de Agosto del 07, a las 14:09:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9230,53,'                              ','Jueves 23 de Agosto del 07, a las 14:10:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9231,51,'Direccion                     ','Jueves 23 de Agosto del 07, a las 14:11:30        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9232,53,'                              ','Jueves 23 de Agosto del 07, a las 14:12:25        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9233,6,'                              ','Jueves 23 de Agosto del 07, a las 14:13:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9234,53,'                              ','Jueves 23 de Agosto del 07, a las 14:14:25        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9235,6,'                              ','Jueves 23 de Agosto del 07, a las 14:14:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9236,53,'                              ','Jueves 23 de Agosto del 07, a las 14:15:48        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9237,53,'                              ','Jueves 23 de Agosto del 07, a las 14:16:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9238,53,'                              ','Jueves 23 de Agosto del 07, a las 14:23:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9239,11,'                              ','Viernes 24 de Agosto del 07, a las 11:13:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9240,11,'                              ','Viernes 24 de Agosto del 07, a las 11:15:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9241,6,'                              ','Viernes 24 de Agosto del 07, a las 15:35:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9242,53,'                              ','Viernes 24 de Agosto del 07, a las 16:29:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9243,6,'                              ','Viernes 24 de Agosto del 07, a las 16:30:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9244,6,'                              ','Viernes 24 de Agosto del 07, a las 16:31:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9245,53,'                              ','Viernes 24 de Agosto del 07, a las 16:32:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9246,6,'                              ','Viernes 24 de Agosto del 07, a las 16:32:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9247,53,'                              ','Viernes 24 de Agosto del 07, a las 16:33:17       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9248,6,'                              ','Viernes 24 de Agosto del 07, a las 16:33:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9249,11,'                              ','Viernes 24 de Agosto del 07, a las 16:34:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9250,6,'                              ','Viernes 24 de Agosto del 07, a las 16:41:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9251,6,'                              ','Viernes 24 de Agosto del 07, a las 16:42:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9252,6,'                              ','Viernes 24 de Agosto del 07, a las 16:42:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9253,6,'                              ','Viernes 24 de Agosto del 07, a las 16:43:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9254,6,'                              ','Viernes 24 de Agosto del 07, a las 16:44:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9255,6,'                              ','Viernes 24 de Agosto del 07, a las 16:55:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9256,6,'                              ','Viernes 24 de Agosto del 07, a las 16:56:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9257,53,'                              ','Viernes 24 de Agosto del 07, a las 16:56:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9258,6,'                              ','Viernes 24 de Agosto del 07, a las 16:58:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9259,53,'                              ','Viernes 24 de Agosto del 07, a las 16:59:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9260,11,'                              ','Viernes 24 de Agosto del 07, a las 16:59:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9261,11,'                              ','Lunes 27 de Agosto del 07, a las 11:14:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9262,6,'                              ','Lunes 27 de Agosto del 07, a las 11:15:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9263,11,'                              ','Lunes 27 de Agosto del 07, a las 11:15:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9264,53,'                              ','Lunes 27 de Agosto del 07, a las 11:17:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9265,11,'                              ','Lunes 27 de Agosto del 07, a las 11:17:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9266,11,'                              ','Lunes 27 de Agosto del 07, a las 11:18:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9267,53,'                              ','Lunes 27 de Agosto del 07, a las 11:19:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9268,11,'                              ','Lunes 27 de Agosto del 07, a las 11:20:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9269,6,'                              ','Lunes 27 de Agosto del 07, a las 11:20:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9270,53,'                              ','Lunes 27 de Agosto del 07, a las 11:21:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9271,11,'                              ','Lunes 27 de Agosto del 07, a las 11:22:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9272,11,'                              ','Lunes 27 de Agosto del 07, a las 11:24:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9273,6,'                              ','Lunes 27 de Agosto del 07, a las 11:25:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9274,11,'                              ','Lunes 27 de Agosto del 07, a las 11:26:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9275,6,'                              ','Lunes 27 de Agosto del 07, a las 11:26:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9276,11,'                              ','Lunes 27 de Agosto del 07, a las 11:26:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9277,11,'                              ','Lunes 27 de Agosto del 07, a las 11:27:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9278,11,'                              ','Lunes 27 de Agosto del 07, a las 11:28:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9279,6,'                              ','Lunes 27 de Agosto del 07, a las 11:28:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9280,53,'                              ','Lunes 27 de Agosto del 07, a las 11:29:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9281,11,'                              ','Lunes 27 de Agosto del 07, a las 11:30:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9282,6,'                              ','Lunes 27 de Agosto del 07, a las 11:31:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9283,53,'                              ','Lunes 27 de Agosto del 07, a las 11:31:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9284,11,'                              ','Lunes 27 de Agosto del 07, a las 11:32:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9285,11,'                              ','Lunes 27 de Agosto del 07, a las 11:32:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9286,53,'                              ','Lunes 27 de Agosto del 07, a las 11:32:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9287,53,'                              ','Lunes 27 de Agosto del 07, a las 11:40:51         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9288,53,'                              ','Lunes 27 de Agosto del 07, a las 11:41:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9289,53,'                              ','Lunes 27 de Agosto del 07, a las 11:41:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9290,11,'                              ','Lunes 27 de Agosto del 07, a las 11:42:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9291,53,'                              ','Lunes 27 de Agosto del 07, a las 11:44:09         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9292,11,'                              ','Lunes 27 de Agosto del 07, a las 11:44:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9293,11,'                              ','Lunes 27 de Agosto del 07, a las 11:48:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9294,53,'                              ','Lunes 27 de Agosto del 07, a las 12:19:15         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9295,11,'                              ','Lunes 27 de Agosto del 07, a las 12:19:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9296,6,'                              ','Lunes 27 de Agosto del 07, a las 12:20:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9297,53,'                              ','Lunes 27 de Agosto del 07, a las 12:20:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9298,11,'                              ','Lunes 27 de Agosto del 07, a las 12:20:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9299,11,'                              ','Lunes 27 de Agosto del 07, a las 12:21:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9300,53,'                              ','Lunes 27 de Agosto del 07, a las 12:22:22         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9301,11,'                              ','Lunes 27 de Agosto del 07, a las 12:22:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9302,53,'                              ','Lunes 27 de Agosto del 07, a las 12:23:47         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9303,11,'                              ','Lunes 27 de Agosto del 07, a las 12:23:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9304,11,'                              ','Lunes 27 de Agosto del 07, a las 12:24:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9305,53,'                              ','Lunes 27 de Agosto del 07, a las 12:24:53         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9306,53,'                              ','Lunes 27 de Agosto del 07, a las 12:25:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9307,11,'                              ','Lunes 27 de Agosto del 07, a las 12:25:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9308,6,'                              ','Lunes 27 de Agosto del 07, a las 12:26:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9309,11,'                              ','Lunes 27 de Agosto del 07, a las 12:26:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9310,6,'                              ','Lunes 27 de Agosto del 07, a las 12:33:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9311,53,'                              ','Lunes 27 de Agosto del 07, a las 12:55:28         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9312,11,'                              ','Lunes 27 de Agosto del 07, a las 12:55:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9313,11,'                              ','Lunes 27 de Agosto del 07, a las 12:56:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9314,11,'                              ','Lunes 27 de Agosto del 07, a las 12:57:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9315,6,'                              ','Lunes 27 de Agosto del 07, a las 12:58:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9316,11,'                              ','Lunes 27 de Agosto del 07, a las 12:58:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9317,11,'                              ','Lunes 27 de Agosto del 07, a las 12:59:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9318,53,'                              ','Lunes 27 de Agosto del 07, a las 13:02:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9319,11,'                              ','Lunes 27 de Agosto del 07, a las 13:08:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9320,11,'                              ','Lunes 27 de Agosto del 07, a las 13:08:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9321,53,'                              ','Lunes 27 de Agosto del 07, a las 13:09:08         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9322,51,'Direccion                     ','Lunes 27 de Agosto del 07, a las 13:09:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9323,6,'                              ','Lunes 27 de Agosto del 07, a las 13:09:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9324,11,'                              ','Lunes 27 de Agosto del 07, a las 13:10:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9325,11,'                              ','Lunes 27 de Agosto del 07, a las 13:10:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9326,6,'                              ','Lunes 27 de Agosto del 07, a las 13:28:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9327,6,'                              ','Lunes 27 de Agosto del 07, a las 13:29:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9328,11,'                              ','Lunes 27 de Agosto del 07, a las 13:30:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9329,11,'                              ','Lunes 27 de Agosto del 07, a las 13:30:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9330,11,'                              ','Lunes 27 de Agosto del 07, a las 13:31:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9331,11,'                              ','Lunes 27 de Agosto del 07, a las 13:31:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9332,11,'                              ','Lunes 27 de Agosto del 07, a las 13:32:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9333,11,'                              ','Lunes 27 de Agosto del 07, a las 13:32:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9334,11,'                              ','Lunes 27 de Agosto del 07, a las 13:33:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9335,11,'                              ','Lunes 27 de Agosto del 07, a las 13:34:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9336,11,'                              ','Lunes 27 de Agosto del 07, a las 13:34:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9337,11,'                              ','Lunes 27 de Agosto del 07, a las 13:35:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9338,11,'                              ','Lunes 27 de Agosto del 07, a las 13:35:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9339,11,'                              ','Lunes 27 de Agosto del 07, a las 13:35:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9340,11,'                              ','Lunes 27 de Agosto del 07, a las 13:36:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9341,11,'                              ','Lunes 27 de Agosto del 07, a las 13:36:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9342,11,'                              ','Lunes 27 de Agosto del 07, a las 13:36:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9343,11,'                              ','Lunes 27 de Agosto del 07, a las 13:37:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9344,11,'                              ','Lunes 27 de Agosto del 07, a las 13:38:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9345,6,'                              ','Lunes 27 de Agosto del 07, a las 13:43:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9346,11,'                              ','Lunes 27 de Agosto del 07, a las 13:43:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9347,11,'                              ','Lunes 27 de Agosto del 07, a las 13:44:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9348,6,'                              ','Lunes 27 de Agosto del 07, a las 13:44:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9349,11,'                              ','Lunes 27 de Agosto del 07, a las 13:44:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9350,6,'                              ','Lunes 27 de Agosto del 07, a las 13:45:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9351,53,'                              ','Lunes 27 de Agosto del 07, a las 13:50:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9352,11,'                              ','Lunes 27 de Agosto del 07, a las 13:50:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9353,53,'                              ','Lunes 27 de Agosto del 07, a las 13:55:47         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9354,11,'                              ','Lunes 27 de Agosto del 07, a las 13:55:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9355,11,'                              ','Lunes 27 de Agosto del 07, a las 14:00:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9356,53,'                              ','Lunes 27 de Agosto del 07, a las 14:00:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9357,11,'                              ','Lunes 27 de Agosto del 07, a las 14:01:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9358,53,'                              ','Lunes 27 de Agosto del 07, a las 14:01:47         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9359,11,'                              ','Lunes 27 de Agosto del 07, a las 14:03:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9360,53,'                              ','Lunes 27 de Agosto del 07, a las 14:03:29         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9361,53,'                              ','Lunes 27 de Agosto del 07, a las 14:03:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9362,4,'                              ','Martes 28 de Agosto del 07, a las 11:30:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9363,4,'                              ','Martes 28 de Agosto del 07, a las 11:45:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9364,53,'                              ','Martes 28 de Agosto del 07, a las 14:14:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9365,4,'                              ','Martes 28 de Agosto del 07, a las 16:17:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9366,6,'                              ','Jueves 30 de Agosto del 07, a las 15:57:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9367,11,'                              ','Jueves 30 de Agosto del 07, a las 16:06:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9368,6,'                              ','Jueves 30 de Agosto del 07, a las 16:08:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9369,4,'                              ','Viernes 31 de Agosto del 07, a las 11:42:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9370,4,'                              ','Viernes 31 de Agosto del 07, a las 12:14:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9371,4,'                              ','Lunes 3 de Septiembre del 07, a las 12:29:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9372,11,'                              ','Lunes 3 de Septiembre del 07, a las 12:51:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9373,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:08:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9374,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:08:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9375,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:26:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9376,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:44:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9377,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:46:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9378,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:52:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9379,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:53:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9380,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:53:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9381,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:54:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9382,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:54:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9383,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:55:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9384,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:55:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9385,11,'                              ','Lunes 3 de Septiembre del 07, a las 13:56:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9386,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:02:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9387,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:02:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9388,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:03:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9389,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:03:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9390,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:12:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9391,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:12:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9392,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:13:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9393,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:13:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9394,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:14:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9395,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:14:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9396,11,'                              ','Lunes 3 de Septiembre del 07, a las 14:15:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9397,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:23:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9398,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:24:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9399,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:24:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9400,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:25:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9401,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:26:14      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9402,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:27:09      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9403,53,'                              ','Lunes 3 de Septiembre del 07, a las 15:27:42      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9404,11,'                              ','Lunes 3 de Septiembre del 07, a las 15:45:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9405,11,'                              ','Lunes 3 de Septiembre del 07, a las 16:18:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9406,6,'                              ','Martes 4 de Septiembre del 07, a las 09:27:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9407,6,'                              ','Martes 4 de Septiembre del 07, a las 12:24:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9408,6,'                              ','Martes 4 de Septiembre del 07, a las 15:59:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9409,6,'                              ','Martes 4 de Septiembre del 07, a las 16:00:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9410,6,'                              ','Martes 4 de Septiembre del 07, a las 16:00:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9411,6,'                              ','Martes 4 de Septiembre del 07, a las 16:01:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9412,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:15:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9413,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:15:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9414,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:16:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9415,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:17:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9416,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:17:36  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9417,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:18:07  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9418,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:18:31  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9419,6,'                              ','Mircoles 5 de Septiembre del 07, a las 09:22:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9420,4,'                              ','Mircoles 5 de Septiembre del 07, a las 11:10:37  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9421,2,'Bib Datos Propopios           ','Mircoles 5 de Septiembre del 07, a las 11:58:19  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9422,4,'                              ','Mircoles 5 de Septiembre del 07, a las 11:58:53  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9423,6,'                              ','Mircoles 5 de Septiembre del 07, a las 12:23:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9424,6,'                              ','Mircoles 5 de Septiembre del 07, a las 12:33:32  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9425,4,'                              ','Mircoles 5 de Septiembre del 07, a las 12:37:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9426,6,'                              ','Mircoles 5 de Septiembre del 07, a las 12:39:39  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9427,4,'                              ','Mircoles 5 de Septiembre del 07, a las 12:58:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9428,4,'                              ','Mircoles 5 de Septiembre del 07, a las 13:56:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9429,4,'                              ','Mircoles 5 de Septiembre del 07, a las 14:00:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9430,6,'                              ','Mircoles 5 de Septiembre del 07, a las 15:01:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9431,53,'                              ','Mircoles 5 de Septiembre del 07, a las 15:04:22  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9432,6,'                              ','Mircoles 5 de Septiembre del 07, a las 15:13:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9433,6,'                              ','Mircoles 5 de Septiembre del 07, a las 15:17:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9434,6,'                              ','Mircoles 5 de Septiembre del 07, a las 15:19:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9435,6,'                              ','Mircoles 5 de Septiembre del 07, a las 15:20:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9436,11,'                              ','Mircoles 5 de Septiembre del 07, a las 15:21:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9437,53,'                              ','Mircoles 5 de Septiembre del 07, a las 16:13:58  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9438,53,'                              ','Mircoles 5 de Septiembre del 07, a las 16:17:26  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9439,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:17:45  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9440,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:18:44  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9441,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:19:31  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9442,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:20:40  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9443,53,'                              ','Mircoles 5 de Septiembre del 07, a las 16:25:54  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9444,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:26:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9445,6,'                              ','Mircoles 5 de Septiembre del 07, a las 16:28:32  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9446,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:30:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9447,11,'                              ','Mircoles 5 de Septiembre del 07, a las 16:31:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9448,11,'                              ','Jueves 6 de Septiembre del 07, a las 09:41:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9449,11,'                              ','Jueves 6 de Septiembre del 07, a las 09:44:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9450,11,'                              ','Jueves 6 de Septiembre del 07, a las 09:46:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9451,53,'                              ','Jueves 6 de Septiembre del 07, a las 09:53:09     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9452,11,'                              ','Jueves 6 de Septiembre del 07, a las 09:53:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9453,11,'                              ','Jueves 6 de Septiembre del 07, a las 09:55:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9454,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:08:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9455,6,'                              ','Jueves 6 de Septiembre del 07, a las 10:08:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9456,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:10:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9457,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:42:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9458,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:44:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9459,53,'                              ','Jueves 6 de Septiembre del 07, a las 10:46:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9460,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:46:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9461,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:48:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9462,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:48:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9463,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:52:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9464,53,'                              ','Jueves 6 de Septiembre del 07, a las 10:52:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9465,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:54:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9466,11,'                              ','Jueves 6 de Septiembre del 07, a las 10:55:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9467,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:09:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9468,53,'                              ','Jueves 6 de Septiembre del 07, a las 11:09:44     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9469,6,'                              ','Jueves 6 de Septiembre del 07, a las 11:28:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9470,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:29:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9471,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:29:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9472,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:31:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9473,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:32:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9474,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:36:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9475,6,'                              ','Jueves 6 de Septiembre del 07, a las 11:38:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9476,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:39:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9477,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:44:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9478,53,'                              ','Jueves 6 de Septiembre del 07, a las 11:46:03     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9479,11,'                              ','Jueves 6 de Septiembre del 07, a las 11:46:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9480,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:16:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9481,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:17:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9482,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:35:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9483,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:36:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9484,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:37:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9485,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:39:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9486,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:40:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9487,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:45:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9488,11,'                              ','Jueves 6 de Septiembre del 07, a las 12:57:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9489,11,'                              ','Jueves 6 de Septiembre del 07, a las 13:05:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9490,11,'                              ','Jueves 6 de Septiembre del 07, a las 13:09:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9491,11,'                              ','Jueves 6 de Septiembre del 07, a las 13:11:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9492,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:28:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9493,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:32:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9494,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:33:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9495,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:34:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9496,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:34:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9497,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:35:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9498,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:35:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9499,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:36:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9500,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:36:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9501,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:37:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9502,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:37:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9503,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:37:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9504,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:38:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9505,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:38:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9506,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:38:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9507,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:39:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9508,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:40:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9509,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:41:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9510,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:41:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9511,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:42:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9512,8,'                              ','Jueves 6 de Septiembre del 07, a las 13:47:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9513,6,'                              ','Jueves 6 de Septiembre del 07, a las 14:17:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9514,11,'                              ','Jueves 6 de Septiembre del 07, a las 14:18:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9515,6,'                              ','Jueves 6 de Septiembre del 07, a las 14:20:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9516,11,'                              ','Jueves 6 de Septiembre del 07, a las 15:34:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9517,53,'                              ','Jueves 6 de Septiembre del 07, a las 15:37:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9518,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:30:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9519,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:30:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9520,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:30:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9521,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:31:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9522,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:32:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9523,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:32:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9524,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:32:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9525,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:32:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9526,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:33:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9527,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:33:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9528,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:33:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9529,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:34:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9530,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:34:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9531,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:34:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9532,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:34:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9533,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:35:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9534,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:35:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9535,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:35:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9536,8,'                              ','Jueves 6 de Septiembre del 07, a las 16:36:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9537,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:02:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9538,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:02:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9539,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:02:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9540,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:03:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9541,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:03:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9542,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:03:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9543,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:04:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9544,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:04:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9545,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:04:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9546,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:05:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9547,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:06:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9548,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:06:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9549,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:06:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9550,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:07:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9551,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:07:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9552,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:07:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9553,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:08:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9554,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:08:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9555,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:09:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9556,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:09:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9557,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:09:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9558,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:09:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9559,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:10:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9560,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:10:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9561,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:17:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9562,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:18:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9563,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:18:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9564,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:19:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9565,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:22:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9566,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:22:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9567,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:23:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9568,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:24:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9569,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:24:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9570,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:25:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9571,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:25:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9572,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:25:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9573,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:26:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9574,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:26:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9575,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:26:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9576,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:28:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9577,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:29:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9578,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:29:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9579,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:29:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9580,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:30:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9581,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:30:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9582,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:30:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9583,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:31:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9584,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:32:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9585,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:32:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9586,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:33:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9587,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:33:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9588,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:33:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9589,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:34:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9590,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:34:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9591,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:35:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9592,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:35:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9593,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:35:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9594,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:36:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9595,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:41:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9596,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:42:17    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9597,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:42:55    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9598,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:43:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9599,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:44:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9600,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:44:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9601,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:44:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9602,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:45:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9603,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:46:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9604,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:46:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9605,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:48:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9606,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:49:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9607,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:49:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9608,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:50:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9609,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:50:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9610,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:51:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9611,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:51:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9612,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:51:55    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9613,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:52:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9614,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:52:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9615,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:53:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9616,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:53:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9617,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:53:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9618,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:54:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9619,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:54:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9620,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:55:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9621,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:55:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9622,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:56:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9623,8,'                              ','Viernes 7 de Septiembre del 07, a las 10:56:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9624,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:51:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9625,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:52:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9626,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:52:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9627,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:52:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9628,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:52:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9629,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:53:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9630,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:53:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9631,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:53:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9632,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:54:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9633,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:54:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9634,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:54:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9635,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:55:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9636,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:56:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9637,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:56:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9638,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:56:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9639,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:57:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9640,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:57:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9641,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:58:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9642,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:58:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9643,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:58:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9644,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:59:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9645,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:59:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9646,8,'                              ','Viernes 7 de Septiembre del 07, a las 11:59:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9647,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:00:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9648,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:00:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9649,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:01:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9650,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:01:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9651,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:01:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9652,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:02:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9653,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:02:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9654,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:03:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9655,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:03:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9656,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:03:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9657,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:04:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9658,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:06:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9659,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:07:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9660,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:07:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9661,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:08:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9662,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:08:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9663,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:09:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9664,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:09:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9665,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:09:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9666,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:10:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9667,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:10:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9668,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:10:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9669,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:11:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9670,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:11:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9671,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:11:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9672,8,'                              ','Viernes 7 de Septiembre del 07, a las 12:12:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9673,11,'                              ','Viernes 7 de Septiembre del 07, a las 12:34:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9674,53,'                              ','Viernes 7 de Septiembre del 07, a las 12:37:41    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9675,53,'                              ','Viernes 7 de Septiembre del 07, a las 12:38:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9676,11,'                              ','Viernes 7 de Septiembre del 07, a las 16:02:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9677,11,'                              ','Viernes 7 de Septiembre del 07, a las 16:03:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9678,11,'                              ','Viernes 7 de Septiembre del 07, a las 16:03:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9679,6,'                              ','Viernes 7 de Septiembre del 07, a las 16:08:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9680,11,'                              ','Viernes 7 de Septiembre del 07, a las 16:12:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9681,6,'                              ','Mircoles 12 de Septiembre del 07, a las 15:17:39 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9682,6,'                              ','Mircoles 12 de Septiembre del 07, a las 15:18:55 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9683,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:38:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9684,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:40:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9685,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:40:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9686,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:43:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9687,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:46:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9688,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:49:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9689,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:50:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9690,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:54:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9691,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:58:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9692,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:59:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9693,4,'                              ','Jueves 13 de Septiembre del 07, a las 09:59:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9694,6,'                              ','Lunes 17 de Septiembre del 07, a las 14:24:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9695,6,'                              ','Lunes 17 de Septiembre del 07, a las 14:27:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9696,6,'                              ','Lunes 17 de Septiembre del 07, a las 14:28:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9697,6,'                              ','Lunes 17 de Septiembre del 07, a las 14:29:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9698,4,'                              ','Martes 18 de Septiembre del 07, a las 08:47:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9699,4,'                              ','Martes 18 de Septiembre del 07, a las 08:53:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9700,4,'                              ','Martes 18 de Septiembre del 07, a las 08:57:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9701,4,'                              ','Martes 18 de Septiembre del 07, a las 08:58:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9702,6,'                              ','Mircoles 19 de Septiembre del 07, a las 16:56:05 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9703,4,'                              ','Mircoles 19 de Septiembre del 07, a las 16:57:27 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9704,6,'                              ','Mircoles 19 de Septiembre del 07, a las 16:59:46 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9705,6,'                              ','Mircoles 19 de Septiembre del 07, a las 17:01:47 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9706,53,'                              ','Jueves 20 de Septiembre del 07, a las 09:34:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9707,8,'                              ','Jueves 20 de Septiembre del 07, a las 09:37:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9708,11,'                              ','Jueves 20 de Septiembre del 07, a las 09:38:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9709,53,'                              ','Jueves 20 de Septiembre del 07, a las 09:44:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9710,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:45:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9711,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:45:46    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9712,53,'                              ','Jueves 20 de Septiembre del 07, a las 09:45:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9713,53,'                              ','Jueves 20 de Septiembre del 07, a las 09:46:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9714,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:47:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9715,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:49:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9716,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:50:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9717,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:52:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9718,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:54:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9719,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:58:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9720,4,'                              ','Jueves 20 de Septiembre del 07, a las 09:59:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9721,4,'                              ','Jueves 20 de Septiembre del 07, a las 10:00:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9722,4,'                              ','Jueves 20 de Septiembre del 07, a las 10:04:46    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9723,4,'                              ','Jueves 20 de Septiembre del 07, a las 10:12:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9724,4,'                              ','Jueves 20 de Septiembre del 07, a las 10:22:17    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9725,11,'                              ','Jueves 20 de Septiembre del 07, a las 16:34:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9726,6,'                              ','Jueves 20 de Septiembre del 07, a las 16:40:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9727,53,'                              ','Jueves 20 de Septiembre del 07, a las 16:43:50    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9728,11,'                              ','Jueves 20 de Septiembre del 07, a las 16:53:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9729,4,'                              ','Viernes 21 de Septiembre del 07, a las 17:19:07   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9730,51,'Direccion                     ','Viernes 21 de Septiembre del 07, a las 17:27:15   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9731,4,'                              ','Viernes 21 de Septiembre del 07, a las 17:36:28   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9732,6,'                              ','Viernes 21 de Septiembre del 07, a las 17:39:44   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9733,6,'                              ','Viernes 21 de Septiembre del 07, a las 17:41:33   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9734,11,'                              ','Viernes 21 de Septiembre del 07, a las 17:42:31   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9735,11,'                              ','Viernes 21 de Septiembre del 07, a las 17:43:17   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9736,11,'                              ','Viernes 21 de Septiembre del 07, a las 17:43:36   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9737,11,'                              ','Viernes 21 de Septiembre del 07, a las 17:43:56   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9738,6,'                              ','Viernes 21 de Septiembre del 07, a las 17:44:33   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9739,6,'                              ','Viernes 21 de Septiembre del 07, a las 17:57:57   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9740,53,'                              ','Viernes 21 de Septiembre del 07, a las 17:58:29   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9741,6,'                              ','Viernes 21 de Septiembre del 07, a las 17:59:20   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9742,11,'                              ','Viernes 21 de Septiembre del 07, a las 18:02:27   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9743,11,'                              ','Viernes 21 de Septiembre del 07, a las 18:04:45   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9744,11,'                              ','Viernes 21 de Septiembre del 07, a las 18:05:42   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9745,11,'                              ','Viernes 21 de Septiembre del 07, a las 18:06:16   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9746,6,'                              ','Lunes 24 de Septiembre del 07, a las 15:38:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9747,6,'                              ','Lunes 24 de Septiembre del 07, a las 15:39:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9748,11,'                              ','Mircoles 26 de Septiembre del 07, a las 14:02:54 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9749,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:12:53 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9750,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:15:22 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9751,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:15:47 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9752,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:16:16 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9753,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:16:34 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9754,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:17:12 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9755,4,'                              ','Mircoles 26 de Septiembre del 07, a las 14:17:28 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9756,11,'                              ','Jueves 27 de Septiembre del 07, a las 13:58:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9757,2,'Bib Datos Propopios           ','Jueves 27 de Septiembre del 07, a las 13:58:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9758,6,'                              ','Martes 2 de Octubre del 07, a las 11:18:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9759,11,'                              ','Martes 2 de Octubre del 07, a las 11:18:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9760,6,'                              ','Mircoles 3 de Octubre del 07, a las 10:01:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9761,6,'                              ','Mircoles 3 de Octubre del 07, a las 10:04:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9762,6,'                              ','Mircoles 3 de Octubre del 07, a las 10:09:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9763,6,'                              ','Mircoles 3 de Octubre del 07, a las 10:12:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9764,6,'                              ','Viernes 5 de Octubre del 07, a las 09:42:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9765,6,'                              ','Viernes 5 de Octubre del 07, a las 09:44:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9766,6,'                              ','Viernes 5 de Octubre del 07, a las 13:58:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9767,6,'                              ','Viernes 5 de Octubre del 07, a las 14:07:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9768,53,'                              ','Viernes 5 de Octubre del 07, a las 14:08:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9769,6,'                              ','Viernes 5 de Octubre del 07, a las 14:54:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9770,53,'                              ','Viernes 5 de Octubre del 07, a las 14:55:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9771,6,'                              ','Viernes 5 de Octubre del 07, a las 14:56:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9772,53,'                              ','Viernes 5 de Octubre del 07, a las 14:57:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9773,6,'                              ','Viernes 5 de Octubre del 07, a las 14:58:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9774,6,'                              ','Martes 9 de Octubre del 07, a las 14:19:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9775,11,'                              ','Martes 9 de Octubre del 07, a las 14:22:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9776,4,'                              ','Mircoles 10 de Octubre del 07, a las 15:56:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9777,6,'                              ','Jueves 11 de Octubre del 07, a las 13:58:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9778,6,'                              ','Jueves 11 de Octubre del 07, a las 14:00:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9779,11,'                              ','Jueves 11 de Octubre del 07, a las 14:18:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9780,11,'                              ','Jueves 11 de Octubre del 07, a las 15:23:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9781,11,'                              ','Jueves 11 de Octubre del 07, a las 15:24:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9782,8,'                              ','Viernes 12 de Octubre del 07, a las 13:50:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9783,11,'                              ','Viernes 12 de Octubre del 07, a las 13:52:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9784,11,'                              ','Viernes 12 de Octubre del 07, a las 13:53:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9785,4,'                              ','Lunes 15 de Octubre del 07, a las 15:57:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9786,4,'                              ','Lunes 15 de Octubre del 07, a las 15:59:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9787,11,'                              ','Lunes 15 de Octubre del 07, a las 16:09:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9788,6,'                              ','Lunes 15 de Octubre del 07, a las 16:10:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9789,6,'                              ','Lunes 15 de Octubre del 07, a las 16:16:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9790,11,'                              ','Lunes 15 de Octubre del 07, a las 16:19:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9791,11,'                              ','Lunes 15 de Octubre del 07, a las 16:20:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9792,11,'                              ','Lunes 15 de Octubre del 07, a las 16:21:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9793,11,'                              ','Lunes 15 de Octubre del 07, a las 16:21:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9794,11,'                              ','Lunes 15 de Octubre del 07, a las 16:22:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9795,11,'                              ','Lunes 15 de Octubre del 07, a las 16:22:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9796,11,'                              ','Lunes 15 de Octubre del 07, a las 16:22:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9797,11,'                              ','Lunes 15 de Octubre del 07, a las 16:23:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9798,11,'                              ','Lunes 15 de Octubre del 07, a las 16:25:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9799,6,'                              ','Lunes 15 de Octubre del 07, a las 16:26:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9800,6,'                              ','Lunes 15 de Octubre del 07, a las 16:27:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9801,6,'                              ','Lunes 15 de Octubre del 07, a las 16:29:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9802,11,'                              ','Lunes 15 de Octubre del 07, a las 16:30:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9803,11,'                              ','Lunes 15 de Octubre del 07, a las 16:33:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9804,6,'                              ','Martes 16 de Octubre del 07, a las 14:31:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9805,11,'                              ','Martes 16 de Octubre del 07, a las 14:39:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9806,11,'                              ','Martes 16 de Octubre del 07, a las 14:39:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9807,6,'                              ','Martes 16 de Octubre del 07, a las 14:42:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9808,6,'                              ','Martes 16 de Octubre del 07, a las 14:42:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9809,4,'                              ','Mircoles 17 de Octubre del 07, a las 10:07:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9810,4,'                              ','Mircoles 17 de Octubre del 07, a las 10:09:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9811,6,'                              ','Mircoles 17 de Octubre del 07, a las 11:18:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9812,6,'                              ','Mircoles 17 de Octubre del 07, a las 11:53:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9813,6,'                              ','Mircoles 17 de Octubre del 07, a las 16:41:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9814,6,'                              ','Mircoles 17 de Octubre del 07, a las 16:46:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9815,53,'                              ','Mircoles 17 de Octubre del 07, a las 16:48:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9816,6,'                              ','Mircoles 17 de Octubre del 07, a las 16:53:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9817,6,'                              ','Mircoles 17 de Octubre del 07, a las 17:00:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9818,6,'                              ','Mircoles 17 de Octubre del 07, a las 17:01:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9819,4,'                              ','Jueves 18 de Octubre del 07, a las 10:13:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9820,4,'                              ','Jueves 18 de Octubre del 07, a las 10:14:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9821,4,'                              ','Jueves 18 de Octubre del 07, a las 10:15:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9822,4,'                              ','Jueves 18 de Octubre del 07, a las 10:15:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9823,2,'Bib Datos Propopios           ','Jueves 18 de Octubre del 07, a las 10:48:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9824,6,'                              ','Jueves 18 de Octubre del 07, a las 10:50:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9825,6,'                              ','Jueves 18 de Octubre del 07, a las 10:50:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9826,6,'                              ','Jueves 18 de Octubre del 07, a las 10:51:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9827,6,'                              ','Jueves 18 de Octubre del 07, a las 10:51:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9828,6,'                              ','Jueves 18 de Octubre del 07, a las 10:52:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9829,4,'                              ','Jueves 18 de Octubre del 07, a las 10:56:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9830,4,'                              ','Jueves 18 de Octubre del 07, a las 10:57:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9831,4,'                              ','Jueves 18 de Octubre del 07, a las 11:04:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9832,4,'                              ','Jueves 18 de Octubre del 07, a las 11:16:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9833,4,'                              ','Jueves 18 de Octubre del 07, a las 16:22:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9834,4,'                              ','Jueves 18 de Octubre del 07, a las 16:24:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9835,4,'                              ','Jueves 18 de Octubre del 07, a las 16:25:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9836,4,'                              ','Jueves 18 de Octubre del 07, a las 16:27:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9837,4,'                              ','Jueves 18 de Octubre del 07, a las 16:27:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9838,4,'                              ','Jueves 18 de Octubre del 07, a las 16:28:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9839,4,'                              ','Jueves 18 de Octubre del 07, a las 16:29:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9840,4,'                              ','Jueves 18 de Octubre del 07, a las 16:34:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9841,4,'                              ','Jueves 18 de Octubre del 07, a las 16:35:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9842,4,'                              ','Jueves 18 de Octubre del 07, a las 16:36:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9843,4,'                              ','Jueves 18 de Octubre del 07, a las 16:37:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9844,4,'                              ','Jueves 18 de Octubre del 07, a las 16:40:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9845,4,'                              ','Jueves 18 de Octubre del 07, a las 16:54:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9846,4,'                              ','Jueves 18 de Octubre del 07, a las 17:01:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9847,4,'                              ','Viernes 19 de Octubre del 07, a las 10:03:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9848,4,'                              ','Viernes 19 de Octubre del 07, a las 11:32:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9849,4,'                              ','Viernes 19 de Octubre del 07, a las 11:36:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9850,4,'                              ','Viernes 19 de Octubre del 07, a las 12:50:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9851,11,'                              ','Viernes 19 de Octubre del 07, a las 16:18:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9852,11,'                              ','Viernes 19 de Octubre del 07, a las 16:23:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9853,4,'                              ','Viernes 19 de Octubre del 07, a las 16:45:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9854,11,'                              ','Lunes 22 de Octubre del 07, a las 10:47:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9855,4,'                              ','Lunes 22 de Octubre del 07, a las 11:41:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9856,2,'Bib Datos Propopios           ','Lunes 22 de Octubre del 07, a las 12:38:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9857,4,'                              ','Lunes 22 de Octubre del 07, a las 12:41:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9858,2,'Bib Datos Propopios           ','Lunes 22 de Octubre del 07, a las 12:55:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9859,2,'Bib Datos Propopios           ','Lunes 22 de Octubre del 07, a las 12:56:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9860,4,'                              ','Lunes 22 de Octubre del 07, a las 13:28:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9861,6,'                              ','Lunes 22 de Octubre del 07, a las 15:30:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9862,53,'                              ','Lunes 22 de Octubre del 07, a las 15:30:54        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9863,4,'                              ','Lunes 22 de Octubre del 07, a las 15:46:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9864,6,'                              ','Lunes 22 de Octubre del 07, a las 16:15:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9865,6,'                              ','Lunes 22 de Octubre del 07, a las 16:29:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9866,53,'                              ','Martes 23 de Octubre del 07, a las 12:31:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9867,6,'                              ','Martes 23 de Octubre del 07, a las 13:54:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9868,4,'                              ','Martes 23 de Octubre del 07, a las 15:23:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9869,4,'                              ','Martes 23 de Octubre del 07, a las 15:25:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9870,4,'                              ','Martes 23 de Octubre del 07, a las 15:28:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9871,4,'                              ','Martes 23 de Octubre del 07, a las 15:29:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9872,4,'                              ','Martes 23 de Octubre del 07, a las 17:15:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9873,4,'                              ','Martes 23 de Octubre del 07, a las 17:16:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9874,4,'                              ','Martes 23 de Octubre del 07, a las 17:17:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9875,4,'                              ','Martes 23 de Octubre del 07, a las 17:18:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9876,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:44:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9877,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:45:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9878,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:49:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9879,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:51:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9880,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:54:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9881,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:57:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9882,4,'                              ','Mircoles 24 de Octubre del 07, a las 10:59:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9883,4,'                              ','Mircoles 24 de Octubre del 07, a las 11:01:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9884,6,'                              ','Mircoles 24 de Octubre del 07, a las 12:07:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9885,6,'                              ','Mircoles 24 de Octubre del 07, a las 12:09:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9886,53,'                              ','Mircoles 24 de Octubre del 07, a las 12:12:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9887,53,'                              ','Mircoles 24 de Octubre del 07, a las 12:13:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9888,4,'                              ','Mircoles 24 de Octubre del 07, a las 12:38:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9889,11,'                              ','Mircoles 24 de Octubre del 07, a las 15:35:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9890,11,'                              ','Mircoles 24 de Octubre del 07, a las 15:35:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9891,2,'Bib Datos Propopios           ','Mircoles 24 de Octubre del 07, a las 15:58:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9892,4,'                              ','Mircoles 24 de Octubre del 07, a las 16:00:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9893,6,'                              ','Mircoles 24 de Octubre del 07, a las 16:28:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9894,53,'                              ','Mircoles 24 de Octubre del 07, a las 16:39:41    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9895,11,'                              ','Jueves 25 de Octubre del 07, a las 12:58:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9896,53,'                              ','Jueves 25 de Octubre del 07, a las 13:05:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9897,53,'                              ','Jueves 25 de Octubre del 07, a las 13:12:17       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9898,11,'                              ','Jueves 25 de Octubre del 07, a las 13:13:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9899,53,'                              ','Jueves 25 de Octubre del 07, a las 13:18:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9900,53,'                              ','Jueves 25 de Octubre del 07, a las 13:18:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9901,6,'                              ','Jueves 25 de Octubre del 07, a las 13:39:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9902,6,'                              ','Jueves 25 de Octubre del 07, a las 13:51:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9903,11,'                              ','Viernes 26 de Octubre del 07, a las 10:44:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9904,2,'Bib Datos Propopios           ','Viernes 26 de Octubre del 07, a las 10:44:44      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9905,11,'                              ','Viernes 26 de Octubre del 07, a las 10:45:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9906,11,'                              ','Lunes 29 de Octubre del 07, a las 10:45:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9907,6,'                              ','Lunes 29 de Octubre del 07, a las 13:37:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9908,6,'                              ','Lunes 29 de Octubre del 07, a las 13:37:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9909,6,'                              ','Lunes 29 de Octubre del 07, a las 13:51:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9910,6,'                              ','Lunes 29 de Octubre del 07, a las 13:51:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9911,10,'                              ','Martes 6 de Noviembre del 07, a las 18:57:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9912,10,'                              ','Martes 6 de Noviembre del 07, a las 18:58:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9913,9,'                              ','Martes 6 de Noviembre del 07, a las 18:59:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9914,4,'                              ','Martes 6 de Noviembre del 07, a las 19:02:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9915,53,'                              ','Martes 6 de Noviembre del 07, a las 19:13:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9916,6,'                              ','Mircoles 7 de Noviembre del 07, a las 09:31:40   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9917,11,'                              ','Mircoles 7 de Noviembre del 07, a las 09:31:58   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9918,4,'                              ','Mircoles 7 de Noviembre del 07, a las 10:18:40   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9919,4,'                              ','Mircoles 7 de Noviembre del 07, a las 10:25:45   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9920,4,'                              ','Mircoles 7 de Noviembre del 07, a las 10:59:54   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9921,4,'                              ','Mircoles 7 de Noviembre del 07, a las 11:00:24   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9922,4,'                              ','Mircoles 7 de Noviembre del 07, a las 11:01:17   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9923,4,'                              ','Mircoles 7 de Noviembre del 07, a las 11:02:53   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9924,53,'                              ','Mircoles 7 de Noviembre del 07, a las 12:31:30   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9925,53,'                              ','Mircoles 7 de Noviembre del 07, a las 12:31:41   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9926,11,'                              ','Mircoles 7 de Noviembre del 07, a las 12:34:33   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9927,11,'                              ','Mircoles 7 de Noviembre del 07, a las 12:37:31   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9928,11,'                              ','Mircoles 7 de Noviembre del 07, a las 12:38:01   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9929,11,'                              ','Mircoles 7 de Noviembre del 07, a las 12:38:15   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9930,11,'                              ','Mircoles 7 de Noviembre del 07, a las 12:38:52   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9931,4,'                              ','Mircoles 7 de Noviembre del 07, a las 13:51:07   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9932,4,'                              ','Mircoles 7 de Noviembre del 07, a las 13:52:27   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9933,4,'                              ','Mircoles 7 de Noviembre del 07, a las 16:41:33   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9934,53,'                              ','Jueves 8 de Noviembre del 07, a las 10:30:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9935,53,'                              ','Jueves 8 de Noviembre del 07, a las 10:31:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9936,53,'                              ','Jueves 8 de Noviembre del 07, a las 10:33:39      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9937,53,'                              ','Jueves 8 de Noviembre del 07, a las 10:34:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9938,53,'                              ','Jueves 8 de Noviembre del 07, a las 10:35:28      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9939,53,'                              ','Jueves 8 de Noviembre del 07, a las 10:36:21      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9940,11,'                              ','Jueves 8 de Noviembre del 07, a las 11:50:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9941,11,'                              ','Jueves 8 de Noviembre del 07, a las 11:51:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9942,11,'                              ','Jueves 8 de Noviembre del 07, a las 11:51:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9943,4,'                              ','Jueves 8 de Noviembre del 07, a las 17:03:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9944,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:23:44  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9945,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:24:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9946,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:25:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9947,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:27:16  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9948,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:28:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9949,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:29:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9950,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:30:08  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9951,6,'                              ','Mircoles 21 de Noviembre del 07, a las 15:31:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9952,53,'                              ','Martes 27 de Noviembre del 07, a las 13:17:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9953,6,'                              ','Martes 27 de Noviembre del 07, a las 13:18:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9954,4,'                              ','Martes 27 de Noviembre del 07, a las 13:19:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9955,4,'                              ','Martes 27 de Noviembre del 07, a las 13:19:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9956,8,'                              ','Martes 27 de Noviembre del 07, a las 13:22:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9957,4,'                              ','Martes 27 de Noviembre del 07, a las 13:24:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9958,4,'                              ','Martes 27 de Noviembre del 07, a las 13:24:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9959,8,'                              ','Martes 27 de Noviembre del 07, a las 13:28:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9960,6,'                              ','Martes 27 de Noviembre del 07, a las 16:19:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9961,6,'                              ','Martes 27 de Noviembre del 07, a las 16:20:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9962,6,'                              ','Martes 27 de Noviembre del 07, a las 16:27:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9963,6,'                              ','Martes 27 de Noviembre del 07, a las 16:27:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9964,6,'                              ','Martes 27 de Noviembre del 07, a las 16:42:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9965,6,'                              ','Martes 27 de Noviembre del 07, a las 16:42:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9966,6,'                              ','Martes 27 de Noviembre del 07, a las 16:43:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9967,6,'                              ','Martes 27 de Noviembre del 07, a las 16:43:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9968,6,'                              ','Martes 27 de Noviembre del 07, a las 16:44:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9969,6,'                              ','Martes 27 de Noviembre del 07, a las 16:44:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9970,4,'                              ','Mircoles 28 de Noviembre del 07, a las 10:43:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9971,4,'                              ','Mircoles 28 de Noviembre del 07, a las 10:44:55  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9972,8,'                              ','Mircoles 28 de Noviembre del 07, a las 14:24:56  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9973,4,'                              ','Mircoles 28 de Noviembre del 07, a las 14:36:32  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9974,4,'                              ','Mircoles 28 de Noviembre del 07, a las 16:46:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9975,6,'                              ','Viernes 30 de Noviembre del 07, a las 14:28:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9976,6,'                              ','Lunes 3 de Diciembre del 07, a las 10:26:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9977,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:28:22       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9978,4,'                              ','Lunes 3 de Diciembre del 07, a las 10:29:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9979,6,'                              ','Lunes 3 de Diciembre del 07, a las 10:31:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9980,11,'                              ','Lunes 3 de Diciembre del 07, a las 10:35:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9981,53,'                              ','Lunes 3 de Diciembre del 07, a las 10:40:19       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9982,53,'                              ','Lunes 3 de Diciembre del 07, a las 10:45:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9983,53,'                              ','Lunes 3 de Diciembre del 07, a las 10:46:33       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9984,11,'                              ','Lunes 3 de Diciembre del 07, a las 10:46:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9985,11,'                              ','Lunes 3 de Diciembre del 07, a las 10:48:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9986,6,'                              ','Lunes 3 de Diciembre del 07, a las 10:52:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9987,4,'                              ','Lunes 3 de Diciembre del 07, a las 10:52:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9988,11,'                              ','Lunes 3 de Diciembre del 07, a las 10:52:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9989,6,'                              ','Lunes 3 de Diciembre del 07, a las 10:54:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9990,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:54:43       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9991,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:54:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9992,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:56:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9993,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:57:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9994,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:57:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9995,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:57:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9996,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:59:17       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9997,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:59:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9998,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 10:59:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (9999,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 11:01:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10000,4,'                              ','Lunes 3 de Diciembre del 07, a las 11:05:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10001,2,'Bib Datos Propopios           ','Lunes 3 de Diciembre del 07, a las 13:40:16       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10002,2,'Bib Datos Propopios           ','Lunes 3 de Diciembre del 07, a las 13:41:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10003,4,'                              ','Lunes 3 de Diciembre del 07, a las 13:43:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10004,4,'                              ','Lunes 3 de Diciembre del 07, a las 13:44:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10005,4,'                              ','Lunes 3 de Diciembre del 07, a las 14:33:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10006,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 14:34:35       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10007,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 14:43:53       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10008,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 14:52:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10009,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 14:53:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10010,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 14:53:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10011,53,'                              ','Lunes 3 de Diciembre del 07, a las 14:53:31       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10012,51,'Direccion                     ','Lunes 3 de Diciembre del 07, a las 14:53:44       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10013,53,'                              ','Lunes 3 de Diciembre del 07, a las 14:53:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10014,4,'                              ','Lunes 3 de Diciembre del 07, a las 15:41:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10015,4,'                              ','Lunes 3 de Diciembre del 07, a las 15:41:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10016,4,'                              ','Lunes 3 de Diciembre del 07, a las 15:42:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10017,4,'                              ','Lunes 3 de Diciembre del 07, a las 16:39:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10018,4,'                              ','Lunes 3 de Diciembre del 07, a las 16:39:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10019,4,'                              ','Lunes 3 de Diciembre del 07, a las 16:40:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10020,4,'                              ','Lunes 3 de Diciembre del 07, a las 16:42:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10021,4,'                              ','Lunes 3 de Diciembre del 07, a las 16:45:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10022,6,'                              ','Martes 4 de Diciembre del 07, a las 10:12:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10023,6,'                              ','Martes 4 de Diciembre del 07, a las 10:12:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10024,4,'                              ','Mircoles 5 de Diciembre del 07, a las 11:11:03   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10025,4,'                              ','Mircoles 5 de Diciembre del 07, a las 11:13:17   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10026,6,'                              ','Viernes 7 de Diciembre del 07, a las 12:00:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10027,6,'                              ','Viernes 7 de Diciembre del 07, a las 12:02:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10028,6,'                              ','Viernes 7 de Diciembre del 07, a las 12:17:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10029,51,'Direccion                     ','Lunes 10 de Diciembre del 07, a las 13:03:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10030,51,'Direccion                     ','Lunes 10 de Diciembre del 07, a las 13:03:42      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10031,53,'                              ','Lunes 10 de Diciembre del 07, a las 13:08:44      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10032,51,'Direccion                     ','Lunes 10 de Diciembre del 07, a las 13:09:13      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10033,51,'Direccion                     ','Lunes 10 de Diciembre del 07, a las 13:09:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10034,53,'                              ','Lunes 10 de Diciembre del 07, a las 13:10:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10035,53,'                              ','Lunes 10 de Diciembre del 07, a las 13:10:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10036,53,'                              ','Lunes 10 de Diciembre del 07, a las 13:11:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10037,6,'                              ','Martes 8 de Enero del 08, a las 15:52:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10038,11,'                              ','Martes 8 de Enero del 08, a las 15:52:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10039,6,'                              ','Mircoles 9 de Enero del 08, a las 11:52:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10040,53,'                              ','Mircoles 9 de Enero del 08, a las 11:54:49       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10041,53,'                              ','Mircoles 9 de Enero del 08, a las 11:56:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10042,6,'                              ','Mircoles 9 de Enero del 08, a las 16:41:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10043,6,'                              ','Jueves 10 de Enero del 08, a las 09:36:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10044,53,'                              ','Jueves 10 de Enero del 08, a las 13:14:09         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10045,6,'                              ','Jueves 10 de Enero del 08, a las 14:02:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10046,53,'                              ','Jueves 10 de Enero del 08, a las 14:16:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10047,4,'                              ','Jueves 10 de Enero del 08, a las 16:34:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10048,4,'                              ','Jueves 10 de Enero del 08, a las 16:53:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10049,4,'                              ','Jueves 10 de Enero del 08, a las 16:54:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10050,4,'                              ','Viernes 11 de Enero del 08, a las 10:14:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10051,53,'                              ','Viernes 11 de Enero del 08, a las 11:27:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10052,53,'                              ','Viernes 11 de Enero del 08, a las 11:28:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10053,6,'                              ','Viernes 11 de Enero del 08, a las 11:29:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10054,4,'                              ','Lunes 14 de Enero del 08, a las 15:00:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10055,53,'                              ','Martes 15 de Enero del 08, a las 11:18:10         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10056,4,'                              ','Martes 15 de Enero del 08, a las 13:07:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10057,2,'Bib Datos Propopios           ','Martes 15 de Enero del 08, a las 13:25:55         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10058,3,'                              ','Martes 15 de Enero del 08, a las 16:44:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10059,3,'                              ','Martes 15 de Enero del 08, a las 16:45:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10060,3,'                              ','Martes 15 de Enero del 08, a las 16:45:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10061,3,'                              ','Martes 15 de Enero del 08, a las 16:45:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10062,4,'                              ','Martes 15 de Enero del 08, a las 16:46:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10063,3,'                              ','Martes 15 de Enero del 08, a las 16:50:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10064,3,'                              ','Martes 15 de Enero del 08, a las 16:51:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10065,4,'                              ','Martes 15 de Enero del 08, a las 16:51:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10066,4,'                              ','Martes 15 de Enero del 08, a las 16:53:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10067,3,'                              ','Martes 15 de Enero del 08, a las 16:56:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10068,4,'                              ','Martes 15 de Enero del 08, a las 16:57:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10069,3,'                              ','Martes 15 de Enero del 08, a las 17:18:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10070,4,'                              ','Martes 15 de Enero del 08, a las 17:18:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10071,4,'                              ','Mircoles 16 de Enero del 08, a las 11:36:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10072,4,'                              ','Mircoles 16 de Enero del 08, a las 11:38:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10073,4,'                              ','Mircoles 16 de Enero del 08, a las 11:47:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10074,6,'                              ','Mircoles 16 de Enero del 08, a las 13:37:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10075,53,'                              ','Mircoles 16 de Enero del 08, a las 13:38:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10076,4,'                              ','Mircoles 16 de Enero del 08, a las 15:50:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10077,4,'                              ','Mircoles 16 de Enero del 08, a las 16:02:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10078,4,'                              ','Mircoles 16 de Enero del 08, a las 16:06:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10079,4,'                              ','Mircoles 16 de Enero del 08, a las 16:07:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10080,4,'                              ','Mircoles 16 de Enero del 08, a las 16:09:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10081,4,'                              ','Mircoles 16 de Enero del 08, a las 16:10:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10082,4,'                              ','Mircoles 16 de Enero del 08, a las 16:11:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10083,4,'                              ','Mircoles 16 de Enero del 08, a las 16:11:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10084,4,'                              ','Mircoles 16 de Enero del 08, a las 16:37:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10085,4,'                              ','Mircoles 16 de Enero del 08, a las 16:37:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10086,6,'                              ','Jueves 17 de Enero del 08, a las 15:30:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10087,6,'                              ','Jueves 17 de Enero del 08, a las 15:36:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10088,6,'                              ','Jueves 17 de Enero del 08, a las 15:49:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10089,6,'                              ','Jueves 17 de Enero del 08, a las 15:56:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10090,11,'                              ','Jueves 17 de Enero del 08, a las 15:56:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10091,6,'                              ','Jueves 17 de Enero del 08, a las 16:39:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10092,53,'                              ','Jueves 17 de Enero del 08, a las 16:39:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10093,6,'                              ','Jueves 17 de Enero del 08, a las 17:15:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10094,6,'                              ','Jueves 17 de Enero del 08, a las 17:29:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10095,6,'                              ','Jueves 17 de Enero del 08, a las 17:31:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10096,6,'                              ','Viernes 18 de Enero del 08, a las 11:43:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10097,6,'                              ','Viernes 18 de Enero del 08, a las 13:41:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10098,6,'                              ','Viernes 18 de Enero del 08, a las 13:43:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10099,6,'                              ','Viernes 18 de Enero del 08, a las 13:44:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10100,6,'                              ','Viernes 18 de Enero del 08, a las 14:01:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10101,6,'                              ','Viernes 18 de Enero del 08, a las 14:05:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10102,6,'                              ','Viernes 18 de Enero del 08, a las 14:07:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10103,6,'                              ','Viernes 18 de Enero del 08, a las 15:35:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10104,53,'                              ','Viernes 18 de Enero del 08, a las 16:37:58        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10105,11,'                              ','Viernes 18 de Enero del 08, a las 16:40:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10106,11,'                              ','Viernes 18 de Enero del 08, a las 16:41:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10107,11,'                              ','Viernes 18 de Enero del 08, a las 16:44:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10108,6,'                              ','Viernes 18 de Enero del 08, a las 16:50:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10109,6,'                              ','Viernes 18 de Enero del 08, a las 16:51:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10110,6,'                              ','Viernes 18 de Enero del 08, a las 16:54:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10111,6,'                              ','Viernes 18 de Enero del 08, a las 16:56:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10112,6,'                              ','Viernes 18 de Enero del 08, a las 16:57:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10113,6,'                              ','Lunes 21 de Enero del 08, a las 11:32:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10114,6,'                              ','Lunes 21 de Enero del 08, a las 11:33:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10115,6,'                              ','Lunes 21 de Enero del 08, a las 11:33:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10116,6,'                              ','Lunes 21 de Enero del 08, a las 14:39:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10117,6,'                              ','Lunes 21 de Enero del 08, a las 16:33:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10118,6,'                              ','Mircoles 23 de Enero del 08, a las 16:15:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10119,6,'                              ','Mircoles 23 de Enero del 08, a las 16:17:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10120,6,'                              ','Mircoles 23 de Enero del 08, a las 16:20:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10121,6,'                              ','Mircoles 23 de Enero del 08, a las 16:40:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10122,6,'                              ','Mircoles 23 de Enero del 08, a las 16:42:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10123,6,'                              ','Mircoles 23 de Enero del 08, a las 16:43:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10124,6,'                              ','Mircoles 23 de Enero del 08, a las 16:44:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10125,6,'                              ','Mircoles 23 de Enero del 08, a las 16:46:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10126,6,'                              ','Mircoles 23 de Enero del 08, a las 16:47:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10127,6,'                              ','Mircoles 23 de Enero del 08, a las 16:50:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10128,6,'                              ','Mircoles 23 de Enero del 08, a las 16:51:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10129,6,'                              ','Mircoles 23 de Enero del 08, a las 16:52:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10130,6,'                              ','Mircoles 23 de Enero del 08, a las 16:53:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10131,53,'                              ','Jueves 24 de Enero del 08, a las 10:57:40         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10132,6,'                              ','Jueves 24 de Enero del 08, a las 11:11:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10133,6,'                              ','Jueves 24 de Enero del 08, a las 11:12:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10134,6,'                              ','Jueves 24 de Enero del 08, a las 11:41:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10135,6,'                              ','Viernes 25 de Enero del 08, a las 10:16:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10136,6,'                              ','Martes 29 de Enero del 08, a las 11:38:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10137,53,'                              ','Martes 29 de Enero del 08, a las 11:41:18         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10138,6,'                              ','Martes 29 de Enero del 08, a las 12:03:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10139,11,'                              ','Martes 29 de Enero del 08, a las 12:34:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10140,53,'                              ','Martes 29 de Enero del 08, a las 13:30:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10141,11,'                              ','Martes 29 de Enero del 08, a las 13:31:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10142,11,'                              ','Martes 29 de Enero del 08, a las 13:31:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10143,6,'                              ','Martes 29 de Enero del 08, a las 13:40:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10144,53,'                              ','Martes 29 de Enero del 08, a las 13:41:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10145,53,'                              ','Martes 29 de Enero del 08, a las 13:43:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10146,53,'                              ','Martes 29 de Enero del 08, a las 13:44:31         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10147,53,'                              ','Martes 29 de Enero del 08, a las 13:45:51         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10148,53,'                              ','Martes 29 de Enero del 08, a las 13:46:31         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10149,53,'                              ','Martes 29 de Enero del 08, a las 13:47:09         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10150,2,'Bib Datos Propopios           ','Martes 29 de Enero del 08, a las 18:01:54         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10151,2,'Bib Datos Propopios           ','Martes 29 de Enero del 08, a las 18:02:39         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10152,2,'Bib Datos Propopios           ','Martes 29 de Enero del 08, a las 18:03:22         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10153,4,'                              ','Mircoles 30 de Enero del 08, a las 13:46:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10154,4,'                              ','Mircoles 30 de Enero del 08, a las 13:50:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10155,2,'Bib Datos Propopios           ','Mircoles 30 de Enero del 08, a las 13:51:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10156,4,'                              ','Mircoles 30 de Enero del 08, a las 13:53:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10157,4,'                              ','Mircoles 30 de Enero del 08, a las 14:00:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10158,6,'                              ','Martes 5 de Febrero del 08, a las 14:52:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10159,6,'                              ','Mircoles 6 de Febrero del 08, a las 14:39:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10160,6,'                              ','Mircoles 6 de Febrero del 08, a las 14:49:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10161,6,'                              ','Mircoles 6 de Febrero del 08, a las 14:50:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10162,6,'                              ','Mircoles 6 de Febrero del 08, a las 14:50:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10163,6,'                              ','Mircoles 6 de Febrero del 08, a las 14:52:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10164,6,'                              ','Jueves 7 de Febrero del 08, a las 13:02:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10165,6,'                              ','Jueves 7 de Febrero del 08, a las 13:34:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10166,6,'                              ','Jueves 7 de Febrero del 08, a las 13:35:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10167,6,'                              ','Jueves 7 de Febrero del 08, a las 13:36:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10168,6,'                              ','Jueves 7 de Febrero del 08, a las 13:37:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10169,6,'                              ','Jueves 7 de Febrero del 08, a las 13:39:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10170,6,'                              ','Jueves 7 de Febrero del 08, a las 13:43:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10171,6,'                              ','Jueves 7 de Febrero del 08, a las 13:43:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10172,6,'                              ','Jueves 7 de Febrero del 08, a las 13:44:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10173,6,'                              ','Jueves 7 de Febrero del 08, a las 13:56:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10174,6,'                              ','Jueves 7 de Febrero del 08, a las 14:02:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10175,6,'                              ','Jueves 7 de Febrero del 08, a las 14:02:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10176,6,'                              ','Jueves 7 de Febrero del 08, a las 14:05:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10177,6,'                              ','Jueves 7 de Febrero del 08, a las 14:06:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10178,6,'                              ','Jueves 7 de Febrero del 08, a las 14:10:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10179,6,'                              ','Jueves 7 de Febrero del 08, a las 14:10:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10180,6,'                              ','Jueves 7 de Febrero del 08, a las 14:11:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10181,6,'                              ','Jueves 7 de Febrero del 08, a las 14:11:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10182,6,'                              ','Jueves 7 de Febrero del 08, a las 14:12:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10183,6,'                              ','Jueves 7 de Febrero del 08, a las 16:38:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10184,6,'                              ','Jueves 7 de Febrero del 08, a las 16:39:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10185,6,'                              ','Jueves 7 de Febrero del 08, a las 16:40:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10186,6,'                              ','Jueves 7 de Febrero del 08, a las 16:42:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10187,6,'                              ','Lunes 11 de Febrero del 08, a las 11:44:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10188,6,'                              ','Lunes 11 de Febrero del 08, a las 11:53:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10189,6,'                              ','Lunes 11 de Febrero del 08, a las 11:55:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10190,4,'                              ','Martes 12 de Febrero del 08, a las 16:34:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10191,6,'                              ','Martes 12 de Febrero del 08, a las 16:39:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10192,51,'Direccion                     ','Martes 12 de Febrero del 08, a las 16:42:04       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10193,53,'                              ','Martes 12 de Febrero del 08, a las 16:43:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10194,51,'Direccion                     ','Martes 12 de Febrero del 08, a las 16:44:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10195,53,'                              ','Martes 12 de Febrero del 08, a las 16:45:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10196,6,'                              ','Martes 12 de Febrero del 08, a las 18:12:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10197,6,'                              ','Mircoles 13 de Febrero del 08, a las 10:52:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10198,11,'                              ','Mircoles 13 de Febrero del 08, a las 10:53:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10199,6,'                              ','Mircoles 13 de Febrero del 08, a las 11:46:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10200,6,'                              ','Mircoles 13 de Febrero del 08, a las 11:47:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10201,6,'                              ','Mircoles 13 de Febrero del 08, a las 11:47:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10202,6,'                              ','Jueves 14 de Febrero del 08, a las 17:01:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10203,4,'                              ','Martes 19 de Febrero del 08, a las 11:14:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10204,4,'                              ','Martes 19 de Febrero del 08, a las 11:23:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10205,4,'                              ','Martes 19 de Febrero del 08, a las 11:30:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10206,4,'                              ','Martes 19 de Febrero del 08, a las 11:33:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10207,4,'                              ','Martes 19 de Febrero del 08, a las 11:41:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10208,4,'                              ','Martes 19 de Febrero del 08, a las 11:45:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10209,4,'                              ','Martes 19 de Febrero del 08, a las 11:51:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10210,4,'                              ','Martes 19 de Febrero del 08, a las 12:33:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10211,4,'                              ','Martes 19 de Febrero del 08, a las 12:35:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10212,4,'                              ','Martes 19 de Febrero del 08, a las 12:40:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10213,4,'                              ','Martes 19 de Febrero del 08, a las 12:49:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10214,4,'                              ','Martes 19 de Febrero del 08, a las 15:43:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10215,4,'                              ','Martes 19 de Febrero del 08, a las 15:52:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10216,4,'                              ','Martes 19 de Febrero del 08, a las 15:54:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10217,4,'                              ','Martes 19 de Febrero del 08, a las 15:55:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10218,4,'                              ','Martes 19 de Febrero del 08, a las 15:56:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10219,4,'                              ','Martes 19 de Febrero del 08, a las 15:58:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10220,4,'                              ','Martes 19 de Febrero del 08, a las 15:59:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10221,4,'                              ','Martes 19 de Febrero del 08, a las 16:01:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10222,4,'                              ','Martes 19 de Febrero del 08, a las 16:08:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10223,4,'                              ','Martes 19 de Febrero del 08, a las 16:09:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10224,4,'                              ','Martes 19 de Febrero del 08, a las 16:11:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10225,4,'                              ','Martes 19 de Febrero del 08, a las 16:12:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10226,4,'                              ','Martes 19 de Febrero del 08, a las 16:15:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10227,4,'                              ','Martes 19 de Febrero del 08, a las 16:17:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10228,4,'                              ','Martes 19 de Febrero del 08, a las 16:18:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10229,4,'                              ','Martes 19 de Febrero del 08, a las 16:19:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10230,4,'                              ','Martes 19 de Febrero del 08, a las 16:21:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10231,4,'                              ','Martes 19 de Febrero del 08, a las 16:26:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10232,6,'                              ','Martes 19 de Febrero del 08, a las 17:09:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10233,6,'                              ','Mircoles 20 de Febrero del 08, a las 09:42:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10234,6,'                              ','Mircoles 20 de Febrero del 08, a las 09:43:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10235,6,'                              ','Mircoles 20 de Febrero del 08, a las 09:45:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10236,6,'                              ','Mircoles 20 de Febrero del 08, a las 09:46:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10237,4,'                              ','Jueves 21 de Febrero del 08, a las 10:20:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10238,4,'                              ','Jueves 21 de Febrero del 08, a las 10:22:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10239,4,'                              ','Jueves 21 de Febrero del 08, a las 10:24:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10240,4,'                              ','Jueves 21 de Febrero del 08, a las 10:25:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10241,4,'                              ','Jueves 21 de Febrero del 08, a las 10:26:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10242,4,'                              ','Jueves 21 de Febrero del 08, a las 10:27:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10243,4,'                              ','Jueves 21 de Febrero del 08, a las 10:27:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10244,4,'                              ','Jueves 21 de Febrero del 08, a las 10:28:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10245,4,'                              ','Jueves 21 de Febrero del 08, a las 10:46:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10246,4,'                              ','Jueves 21 de Febrero del 08, a las 10:48:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10247,4,'                              ','Jueves 21 de Febrero del 08, a las 10:50:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10248,4,'                              ','Jueves 21 de Febrero del 08, a las 10:52:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10249,4,'                              ','Jueves 21 de Febrero del 08, a las 11:02:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10250,4,'                              ','Jueves 21 de Febrero del 08, a las 11:02:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10251,4,'                              ','Jueves 21 de Febrero del 08, a las 11:03:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10252,4,'                              ','Jueves 21 de Febrero del 08, a las 11:03:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10253,4,'                              ','Jueves 21 de Febrero del 08, a las 11:04:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10254,4,'                              ','Jueves 21 de Febrero del 08, a las 11:04:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10255,4,'                              ','Jueves 21 de Febrero del 08, a las 11:05:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10256,4,'                              ','Jueves 21 de Febrero del 08, a las 11:05:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10257,4,'                              ','Jueves 21 de Febrero del 08, a las 11:05:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10258,4,'                              ','Jueves 21 de Febrero del 08, a las 11:06:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10259,4,'                              ','Jueves 21 de Febrero del 08, a las 11:06:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10260,4,'                              ','Jueves 21 de Febrero del 08, a las 11:07:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10261,4,'                              ','Jueves 21 de Febrero del 08, a las 11:07:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10262,4,'                              ','Jueves 21 de Febrero del 08, a las 11:08:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10263,4,'                              ','Jueves 21 de Febrero del 08, a las 11:08:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10264,4,'                              ','Jueves 21 de Febrero del 08, a las 11:09:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10265,4,'                              ','Jueves 21 de Febrero del 08, a las 11:09:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10266,4,'                              ','Jueves 21 de Febrero del 08, a las 11:10:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10267,4,'                              ','Jueves 21 de Febrero del 08, a las 11:11:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10268,4,'                              ','Jueves 21 de Febrero del 08, a las 11:11:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10269,4,'                              ','Jueves 21 de Febrero del 08, a las 11:11:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10270,4,'                              ','Jueves 21 de Febrero del 08, a las 11:12:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10271,4,'                              ','Jueves 21 de Febrero del 08, a las 11:12:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10272,4,'                              ','Jueves 21 de Febrero del 08, a las 11:13:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10273,4,'                              ','Viernes 22 de Febrero del 08, a las 15:37:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10274,4,'                              ','Viernes 22 de Febrero del 08, a las 15:38:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10275,4,'                              ','Viernes 22 de Febrero del 08, a las 15:38:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10276,4,'                              ','Viernes 22 de Febrero del 08, a las 15:39:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10277,4,'                              ','Viernes 22 de Febrero del 08, a las 15:39:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10278,4,'                              ','Viernes 22 de Febrero del 08, a las 15:39:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10279,4,'                              ','Viernes 22 de Febrero del 08, a las 15:40:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10280,4,'                              ','Viernes 22 de Febrero del 08, a las 15:40:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10281,4,'                              ','Viernes 22 de Febrero del 08, a las 15:41:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10282,4,'                              ','Viernes 22 de Febrero del 08, a las 15:41:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10283,4,'                              ','Viernes 22 de Febrero del 08, a las 15:41:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10284,4,'                              ','Viernes 22 de Febrero del 08, a las 15:42:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10285,4,'                              ','Viernes 22 de Febrero del 08, a las 15:42:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10286,4,'                              ','Viernes 22 de Febrero del 08, a las 15:43:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10287,4,'                              ','Viernes 22 de Febrero del 08, a las 15:43:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10288,4,'                              ','Viernes 22 de Febrero del 08, a las 15:44:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10289,4,'                              ','Viernes 22 de Febrero del 08, a las 15:44:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10290,4,'                              ','Viernes 22 de Febrero del 08, a las 15:45:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10291,4,'                              ','Viernes 22 de Febrero del 08, a las 15:45:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10292,4,'                              ','Viernes 22 de Febrero del 08, a las 15:45:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10293,4,'                              ','Viernes 22 de Febrero del 08, a las 15:46:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10294,4,'                              ','Viernes 22 de Febrero del 08, a las 15:46:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10295,4,'                              ','Viernes 22 de Febrero del 08, a las 15:46:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10296,4,'                              ','Viernes 22 de Febrero del 08, a las 15:47:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10297,6,'                              ','Martes 26 de Febrero del 08, a las 15:21:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10298,6,'                              ','Martes 26 de Febrero del 08, a las 15:24:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10299,6,'                              ','Martes 26 de Febrero del 08, a las 15:26:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10300,6,'                              ','Martes 26 de Febrero del 08, a las 15:27:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10301,6,'                              ','Martes 26 de Febrero del 08, a las 15:28:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10302,6,'                              ','Martes 26 de Febrero del 08, a las 15:28:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10303,6,'                              ','Martes 26 de Febrero del 08, a las 15:30:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10304,6,'                              ','Martes 26 de Febrero del 08, a las 15:30:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10305,6,'                              ','Martes 26 de Febrero del 08, a las 15:31:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10306,6,'                              ','Martes 26 de Febrero del 08, a las 15:32:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10307,6,'                              ','Mircoles 27 de Febrero del 08, a las 10:02:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10308,6,'                              ','Viernes 29 de Febrero del 08, a las 12:07:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10309,6,'                              ','Viernes 29 de Febrero del 08, a las 12:36:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10310,6,'                              ','Viernes 29 de Febrero del 08, a las 16:39:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10311,6,'                              ','Martes 4 de Marzo del 08, a las 10:53:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10312,6,'                              ','Martes 4 de Marzo del 08, a las 10:57:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10313,6,'                              ','Mircoles 5 de Marzo del 08, a las 14:30:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10314,6,'                              ','Viernes 7 de Marzo del 08, a las 10:11:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10315,6,'                              ','Viernes 7 de Marzo del 08, a las 10:38:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10316,6,'                              ','Viernes 7 de Marzo del 08, a las 10:57:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10317,6,'                              ','Viernes 7 de Marzo del 08, a las 15:34:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10318,6,'                              ','Lunes 10 de Marzo del 08, a las 11:55:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10319,6,'                              ','Lunes 10 de Marzo del 08, a las 12:21:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10320,6,'                              ','Lunes 10 de Marzo del 08, a las 14:12:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10321,2,'Bib Datos Propopios           ','Viernes 14 de Marzo del 08, a las 09:27:47        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10322,4,'                              ','Viernes 14 de Marzo del 08, a las 10:44:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10323,4,'                              ','Viernes 14 de Marzo del 08, a las 10:45:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10324,6,'                              ','Viernes 14 de Marzo del 08, a las 10:51:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10325,6,'                              ','Viernes 14 de Marzo del 08, a las 13:50:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10326,6,'                              ','Lunes 24 de Marzo del 08, a las 15:40:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10327,6,'                              ','Lunes 24 de Marzo del 08, a las 15:47:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10328,6,'                              ','Lunes 24 de Marzo del 08, a las 15:54:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10329,6,'                              ','Lunes 24 de Marzo del 08, a las 17:01:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10330,6,'                              ','Lunes 24 de Marzo del 08, a las 17:05:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10331,6,'                              ','Lunes 24 de Marzo del 08, a las 17:07:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10332,6,'                              ','Martes 25 de Marzo del 08, a las 10:43:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10333,6,'                              ','Martes 25 de Marzo del 08, a las 11:08:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10334,6,'                              ','Martes 25 de Marzo del 08, a las 15:43:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10335,53,'                              ','Martes 25 de Marzo del 08, a las 16:03:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10336,6,'                              ','Mircoles 26 de Marzo del 08, a las 11:25:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10337,6,'                              ','Mircoles 26 de Marzo del 08, a las 11:25:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10338,6,'                              ','Mircoles 26 de Marzo del 08, a las 11:27:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10339,11,'                              ','Jueves 27 de Marzo del 08, a las 12:38:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10340,53,'                              ','Jueves 27 de Marzo del 08, a las 12:39:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10341,6,'                              ','Jueves 27 de Marzo del 08, a las 14:36:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10342,6,'                              ','Jueves 27 de Marzo del 08, a las 14:39:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10343,6,'                              ','Jueves 27 de Marzo del 08, a las 14:40:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10344,6,'                              ','Viernes 28 de Marzo del 08, a las 10:28:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10345,6,'                              ','Viernes 28 de Marzo del 08, a las 10:32:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10346,2,'Bib Datos Propopios           ','Viernes 4 de Abril del 08, a las 10:52:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10347,6,'                              ','Lunes 7 de Abril del 08, a las 13:30:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10348,6,'                              ','Lunes 7 de Abril del 08, a las 13:31:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10349,6,'                              ','Lunes 7 de Abril del 08, a las 14:16:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10350,6,'                              ','Lunes 7 de Abril del 08, a las 14:18:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10351,6,'                              ','Lunes 7 de Abril del 08, a las 14:19:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10352,6,'                              ','Lunes 7 de Abril del 08, a las 14:21:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10353,6,'                              ','Lunes 7 de Abril del 08, a las 14:22:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10354,6,'                              ','Mircoles 9 de Abril del 08, a las 17:57:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10355,6,'                              ','Jueves 10 de Abril del 08, a las 11:42:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10356,6,'                              ','Jueves 10 de Abril del 08, a las 16:33:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10357,6,'                              ','Lunes 14 de Abril del 08, a las 16:14:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10358,6,'                              ','Mircoles 16 de Abril del 08, a las 11:23:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10359,11,'                              ','Mircoles 16 de Abril del 08, a las 11:24:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10360,6,'                              ','Mircoles 16 de Abril del 08, a las 11:38:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10361,11,'                              ','Mircoles 16 de Abril del 08, a las 11:38:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10362,11,'                              ','Viernes 18 de Abril del 08, a las 15:28:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10363,6,'                              ','Viernes 18 de Abril del 08, a las 15:29:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10364,6,'                              ','Mircoles 23 de Abril del 08, a las 11:00:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10365,6,'                              ','Jueves 24 de Abril del 08, a las 16:56:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10366,6,'                              ','Viernes 25 de Abril del 08, a las 13:35:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10367,11,'                              ','Viernes 25 de Abril del 08, a las 13:56:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10368,11,'                              ','Viernes 25 de Abril del 08, a las 14:03:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10369,6,'                              ','Martes 29 de Abril del 08, a las 16:31:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10370,6,'                              ','Martes 6 de Mayo del 08, a las 13:23:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10371,11,'                              ','Martes 6 de Mayo del 08, a las 13:24:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10372,11,'                              ','Martes 6 de Mayo del 08, a las 13:27:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10373,6,'                              ','Mircoles 7 de Mayo del 08, a las 12:34:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10374,6,'                              ','Mircoles 7 de Mayo del 08, a las 12:40:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10375,6,'                              ','Mircoles 7 de Mayo del 08, a las 12:41:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10376,6,'                              ','Jueves 8 de Mayo del 08, a las 10:45:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10377,6,'                              ','Lunes 12 de Mayo del 08, a las 10:56:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10378,6,'                              ','Martes 13 de Mayo del 08, a las 15:30:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10379,6,'                              ','Viernes 16 de Mayo del 08, a las 13:29:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10380,6,'                              ','Viernes 16 de Mayo del 08, a las 13:38:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10381,6,'                              ','Viernes 16 de Mayo del 08, a las 13:39:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10382,6,'                              ','Viernes 16 de Mayo del 08, a las 13:39:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10383,6,'                              ','Viernes 16 de Mayo del 08, a las 13:40:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10384,6,'                              ','Lunes 19 de Mayo del 08, a las 13:14:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10385,6,'                              ','Lunes 19 de Mayo del 08, a las 13:23:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10386,6,'                              ','Martes 20 de Mayo del 08, a las 15:45:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10387,6,'                              ','Jueves 22 de Mayo del 08, a las 14:56:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10388,6,'                              ','Jueves 22 de Mayo del 08, a las 16:09:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10389,6,'                              ','Viernes 23 de Mayo del 08, a las 12:11:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10390,6,'                              ','Viernes 23 de Mayo del 08, a las 12:13:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10391,6,'                              ','Viernes 23 de Mayo del 08, a las 13:02:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10392,6,'                              ','Jueves 29 de Mayo del 08, a las 14:12:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10393,6,'                              ','Jueves 29 de Mayo del 08, a las 14:12:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10394,6,'                              ','Jueves 5 de Junio del 08, a las 10:14:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10395,6,'                              ','Jueves 5 de Junio del 08, a las 13:10:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10396,11,'                              ','Jueves 5 de Junio del 08, a las 15:51:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10397,11,'                              ','Jueves 5 de Junio del 08, a las 15:51:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10398,2,'Bib Datos Propopios           ','Viernes 6 de Junio del 08, a las 09:41:13         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10399,2,'Bib Datos Propopios           ','Viernes 6 de Junio del 08, a las 09:41:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10400,6,'                              ','Viernes 6 de Junio del 08, a las 09:44:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10401,6,'                              ','Viernes 6 de Junio del 08, a las 13:31:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10402,6,'                              ','Viernes 6 de Junio del 08, a las 13:31:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10403,6,'                              ','Viernes 6 de Junio del 08, a las 13:32:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10404,8,'                              ','Viernes 6 de Junio del 08, a las 14:03:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10405,8,'                              ','Viernes 6 de Junio del 08, a las 14:03:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10406,6,'                              ','Mircoles 11 de Junio del 08, a las 11:35:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10407,6,'                              ','Mircoles 11 de Junio del 08, a las 11:42:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10408,6,'                              ','Mircoles 11 de Junio del 08, a las 11:44:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10409,6,'                              ','Jueves 12 de Junio del 08, a las 12:40:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10410,6,'                              ','Martes 17 de Junio del 08, a las 14:07:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10411,6,'                              ','Martes 17 de Junio del 08, a las 15:52:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10412,6,'                              ','Mircoles 18 de Junio del 08, a las 11:28:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10413,6,'                              ','Mircoles 18 de Junio del 08, a las 11:29:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10414,6,'                              ','Mircoles 18 de Junio del 08, a las 11:32:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10415,6,'                              ','Mircoles 18 de Junio del 08, a las 11:36:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10416,6,'                              ','Mircoles 18 de Junio del 08, a las 11:48:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10417,6,'                              ','Mircoles 18 de Junio del 08, a las 11:50:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10418,6,'                              ','Mircoles 18 de Junio del 08, a las 11:52:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10419,6,'                              ','Mircoles 18 de Junio del 08, a las 11:53:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10420,6,'                              ','Mircoles 18 de Junio del 08, a las 11:58:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10421,6,'                              ','Mircoles 18 de Junio del 08, a las 15:19:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10422,6,'                              ','Jueves 19 de Junio del 08, a las 10:33:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10423,53,'                              ','Jueves 19 de Junio del 08, a las 18:54:34         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10424,53,'                              ','Jueves 19 de Junio del 08, a las 18:58:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10425,53,'                              ','Jueves 19 de Junio del 08, a las 19:32:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10426,53,'                              ','Jueves 19 de Junio del 08, a las 19:33:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10427,53,'                              ','Jueves 19 de Junio del 08, a las 19:34:30         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10428,53,'                              ','Jueves 19 de Junio del 08, a las 19:37:22         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10429,6,'                              ','Lunes 23 de Junio del 08, a las 15:20:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10430,53,'                              ','Martes 24 de Junio del 08, a las 11:38:53         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10431,53,'                              ','Martes 24 de Junio del 08, a las 11:48:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10432,53,'                              ','Martes 24 de Junio del 08, a las 12:01:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10433,53,'                              ','Martes 24 de Junio del 08, a las 12:03:02         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10434,4,'                              ','Martes 24 de Junio del 08, a las 12:55:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10435,53,'                              ','Martes 24 de Junio del 08, a las 12:58:34         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10436,8,'                              ','Martes 24 de Junio del 08, a las 13:08:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10437,4,'                              ','Martes 24 de Junio del 08, a las 13:26:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10438,8,'                              ','Martes 24 de Junio del 08, a las 13:30:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10439,8,'                              ','Martes 24 de Junio del 08, a las 13:30:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10440,11,'                              ','Martes 24 de Junio del 08, a las 13:34:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10441,11,'                              ','Martes 24 de Junio del 08, a las 13:37:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10442,11,'                              ','Martes 24 de Junio del 08, a las 13:40:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10443,6,'                              ','Martes 24 de Junio del 08, a las 14:13:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10444,6,'                              ','Martes 24 de Junio del 08, a las 14:16:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10445,6,'                              ','Martes 24 de Junio del 08, a las 14:16:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10446,6,'                              ','Martes 24 de Junio del 08, a las 14:17:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10447,9,'                              ','Viernes 27 de Junio del 08, a las 14:07:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10448,11,'                              ','Viernes 27 de Junio del 08, a las 14:09:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10449,6,'                              ','Lunes 30 de Junio del 08, a las 13:23:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10450,53,'                              ','Martes 1 de Julio del 08, a las 09:07:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10451,53,'                              ','Martes 1 de Julio del 08, a las 09:09:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10452,53,'                              ','Martes 1 de Julio del 08, a las 09:11:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10453,53,'                              ','Martes 1 de Julio del 08, a las 13:06:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10454,53,'                              ','Martes 1 de Julio del 08, a las 13:06:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10455,53,'                              ','Martes 1 de Julio del 08, a las 13:08:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10456,53,'                              ','Martes 1 de Julio del 08, a las 13:09:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10457,53,'                              ','Martes 1 de Julio del 08, a las 13:10:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10458,53,'                              ','Martes 1 de Julio del 08, a las 13:18:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10459,53,'                              ','Martes 1 de Julio del 08, a las 13:20:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10460,53,'                              ','Martes 1 de Julio del 08, a las 13:21:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10461,53,'                              ','Martes 1 de Julio del 08, a las 13:21:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10462,6,'                              ','Viernes 4 de Julio del 08, a las 13:45:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10463,11,'                              ','Viernes 4 de Julio del 08, a las 13:48:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10464,11,'                              ','Mircoles 30 de Julio del 08, a las 15:27:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10465,6,'                              ','Mircoles 30 de Julio del 08, a las 15:31:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10466,53,'                              ','Mircoles 30 de Julio del 08, a las 15:33:11      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10467,6,'                              ','Jueves 31 de Julio del 08, a las 13:49:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10468,6,'                              ','Lunes 4 de Agosto del 08, a las 14:33:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10469,6,'                              ','Lunes 4 de Agosto del 08, a las 14:43:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10470,6,'                              ','Lunes 4 de Agosto del 08, a las 14:45:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10471,6,'                              ','Lunes 4 de Agosto del 08, a las 14:47:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10472,6,'                              ','Lunes 4 de Agosto del 08, a las 14:48:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10473,6,'                              ','Lunes 4 de Agosto del 08, a las 14:50:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10474,6,'                              ','Viernes 8 de Agosto del 08, a las 16:28:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10475,11,'                              ','Viernes 8 de Agosto del 08, a las 16:29:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10476,4,'                              ','Jueves 21 de Agosto del 08, a las 15:07:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10477,51,'Direccion                     ','Jueves 21 de Agosto del 08, a las 15:10:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10478,11,'                              ','Viernes 22 de Agosto del 08, a las 11:20:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10479,11,'                              ','Viernes 22 de Agosto del 08, a las 11:22:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10480,11,'                              ','Viernes 22 de Agosto del 08, a las 11:24:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10481,11,'                              ','Viernes 22 de Agosto del 08, a las 11:29:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10482,11,'                              ','Viernes 22 de Agosto del 08, a las 11:30:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10483,11,'                              ','Viernes 22 de Agosto del 08, a las 11:31:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10484,11,'                              ','Viernes 22 de Agosto del 08, a las 11:34:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10485,11,'                              ','Viernes 22 de Agosto del 08, a las 11:36:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10486,11,'                              ','Viernes 22 de Agosto del 08, a las 11:43:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10487,11,'                              ','Viernes 22 de Agosto del 08, a las 11:45:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10488,11,'                              ','Viernes 22 de Agosto del 08, a las 11:46:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10489,11,'                              ','Viernes 22 de Agosto del 08, a las 11:49:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10490,11,'                              ','Viernes 22 de Agosto del 08, a las 11:51:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10491,11,'                              ','Viernes 22 de Agosto del 08, a las 11:54:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10492,11,'                              ','Viernes 22 de Agosto del 08, a las 11:56:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10493,11,'                              ','Viernes 22 de Agosto del 08, a las 12:33:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10494,11,'                              ','Viernes 22 de Agosto del 08, a las 12:34:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10495,11,'                              ','Viernes 22 de Agosto del 08, a las 12:36:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10496,11,'                              ','Viernes 22 de Agosto del 08, a las 12:37:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10497,11,'                              ','Viernes 22 de Agosto del 08, a las 12:40:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10498,11,'                              ','Viernes 22 de Agosto del 08, a las 12:40:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10499,11,'                              ','Viernes 22 de Agosto del 08, a las 12:44:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10500,11,'                              ','Viernes 22 de Agosto del 08, a las 12:46:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10501,11,'                              ','Viernes 22 de Agosto del 08, a las 12:50:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10502,11,'                              ','Viernes 22 de Agosto del 08, a las 12:51:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10503,11,'                              ','Viernes 22 de Agosto del 08, a las 12:52:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10504,11,'                              ','Viernes 22 de Agosto del 08, a las 12:56:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10505,11,'                              ','Viernes 22 de Agosto del 08, a las 12:57:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10506,11,'                              ','Viernes 22 de Agosto del 08, a las 12:58:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10507,11,'                              ','Viernes 22 de Agosto del 08, a las 12:59:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10508,11,'                              ','Viernes 22 de Agosto del 08, a las 13:00:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10509,11,'                              ','Viernes 22 de Agosto del 08, a las 13:02:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10510,11,'                              ','Viernes 22 de Agosto del 08, a las 14:57:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10511,11,'                              ','Viernes 22 de Agosto del 08, a las 14:58:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10512,11,'                              ','Viernes 22 de Agosto del 08, a las 14:59:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10513,11,'                              ','Viernes 22 de Agosto del 08, a las 15:00:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10514,11,'                              ','Viernes 22 de Agosto del 08, a las 15:01:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10515,11,'                              ','Viernes 22 de Agosto del 08, a las 15:02:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10516,11,'                              ','Viernes 22 de Agosto del 08, a las 15:04:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10517,11,'                              ','Viernes 22 de Agosto del 08, a las 15:05:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10518,11,'                              ','Viernes 22 de Agosto del 08, a las 15:07:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10519,11,'                              ','Viernes 22 de Agosto del 08, a las 15:09:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10520,11,'                              ','Viernes 22 de Agosto del 08, a las 15:12:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10521,11,'                              ','Viernes 22 de Agosto del 08, a las 15:13:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10522,11,'                              ','Viernes 22 de Agosto del 08, a las 15:20:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10523,11,'                              ','Viernes 22 de Agosto del 08, a las 15:20:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10524,11,'                              ','Viernes 22 de Agosto del 08, a las 15:22:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10525,11,'                              ','Viernes 22 de Agosto del 08, a las 15:25:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10526,11,'                              ','Viernes 22 de Agosto del 08, a las 15:26:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10527,11,'                              ','Viernes 22 de Agosto del 08, a las 15:28:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10528,11,'                              ','Viernes 22 de Agosto del 08, a las 15:30:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10529,11,'                              ','Viernes 22 de Agosto del 08, a las 15:33:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10530,11,'                              ','Viernes 22 de Agosto del 08, a las 15:33:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10531,11,'                              ','Viernes 22 de Agosto del 08, a las 15:43:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10532,11,'                              ','Viernes 22 de Agosto del 08, a las 15:53:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10533,11,'                              ','Viernes 22 de Agosto del 08, a las 15:55:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10534,11,'                              ','Viernes 22 de Agosto del 08, a las 15:56:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10535,11,'                              ','Viernes 22 de Agosto del 08, a las 15:58:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10536,11,'                              ','Lunes 25 de Agosto del 08, a las 10:49:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10537,11,'                              ','Lunes 25 de Agosto del 08, a las 10:51:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10538,11,'                              ','Lunes 25 de Agosto del 08, a las 10:51:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10539,11,'                              ','Lunes 25 de Agosto del 08, a las 10:53:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10540,11,'                              ','Lunes 25 de Agosto del 08, a las 10:55:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10541,6,'                              ','Lunes 25 de Agosto del 08, a las 15:51:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10542,6,'                              ','Lunes 25 de Agosto del 08, a las 15:55:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10543,6,'                              ','Martes 26 de Agosto del 08, a las 15:11:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10544,6,'                              ','Martes 26 de Agosto del 08, a las 15:56:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10545,6,'                              ','Martes 26 de Agosto del 08, a las 15:57:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10546,6,'                              ','Mircoles 27 de Agosto del 08, a las 09:46:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10547,6,'                              ','Mircoles 27 de Agosto del 08, a las 09:47:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10548,6,'                              ','Mircoles 27 de Agosto del 08, a las 09:53:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10549,6,'                              ','Mircoles 27 de Agosto del 08, a las 10:19:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10550,6,'                              ','Mircoles 27 de Agosto del 08, a las 10:30:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10551,4,'                              ','Mircoles 27 de Agosto del 08, a las 13:24:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10552,4,'                              ','Mircoles 27 de Agosto del 08, a las 13:24:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10553,4,'                              ','Mircoles 27 de Agosto del 08, a las 13:28:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10554,4,'                              ','Mircoles 27 de Agosto del 08, a las 15:25:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10555,6,'                              ','Jueves 28 de Agosto del 08, a las 10:39:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10556,6,'                              ','Jueves 28 de Agosto del 08, a las 12:51:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10557,6,'                              ','Jueves 28 de Agosto del 08, a las 13:02:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10558,6,'                              ','Jueves 28 de Agosto del 08, a las 13:21:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10559,6,'                              ','Jueves 28 de Agosto del 08, a las 13:46:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10560,11,'                              ','Lunes 1 de Septiembre del 08, a las 14:52:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10561,6,'                              ','Martes 2 de Septiembre del 08, a las 14:53:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10562,6,'                              ','Mircoles 3 de Septiembre del 08, a las 09:55:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10563,6,'                              ','Jueves 4 de Septiembre del 08, a las 09:37:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10564,6,'                              ','Jueves 4 de Septiembre del 08, a las 09:42:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10565,6,'                              ','Viernes 5 de Septiembre del 08, a las 09:02:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10566,6,'                              ','Viernes 5 de Septiembre del 08, a las 09:03:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10567,6,'                              ','Lunes 8 de Septiembre del 08, a las 10:33:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10568,6,'                              ','Lunes 8 de Septiembre del 08, a las 10:36:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10569,6,'                              ','Jueves 11 de Septiembre del 08, a las 09:47:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10570,6,'                              ','Jueves 11 de Septiembre del 08, a las 09:51:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10571,6,'                              ','Jueves 11 de Septiembre del 08, a las 13:47:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10572,6,'                              ','Jueves 11 de Septiembre del 08, a las 13:47:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10573,6,'                              ','Jueves 18 de Septiembre del 08, a las 15:12:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10574,6,'                              ','Jueves 18 de Septiembre del 08, a las 15:14:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10575,6,'                              ','Jueves 18 de Septiembre del 08, a las 15:15:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10576,51,'Direccion                     ','Martes 23 de Septiembre del 08, a las 13:30:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10577,51,'Direccion                     ','Martes 23 de Septiembre del 08, a las 13:30:33    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10578,51,'Direccion                     ','Martes 23 de Septiembre del 08, a las 13:30:50    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10579,51,'Direccion                     ','Martes 23 de Septiembre del 08, a las 13:31:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10580,11,'                              ','Martes 23 de Septiembre del 08, a las 13:47:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10581,11,'                              ','Martes 23 de Septiembre del 08, a las 13:50:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10582,4,'                              ','Mircoles 24 de Septiembre del 08, a las 13:49:35 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10583,4,'                              ','Mircoles 24 de Septiembre del 08, a las 13:50:23 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10584,6,'                              ','Viernes 26 de Septiembre del 08, a las 12:15:05   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10585,6,'                              ','Martes 30 de Septiembre del 08, a las 16:11:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10586,6,'                              ','Martes 30 de Septiembre del 08, a las 16:12:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10587,4,'                              ','Jueves 2 de Octubre del 08, a las 10:38:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10588,4,'                              ','Jueves 2 de Octubre del 08, a las 10:39:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10589,11,'                              ','Jueves 2 de Octubre del 08, a las 10:40:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10590,4,'                              ','Jueves 2 de Octubre del 08, a las 10:45:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10591,4,'                              ','Jueves 2 de Octubre del 08, a las 10:46:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10592,2,'Bib Datos Propopios           ','Lunes 6 de Octubre del 08, a las 13:33:16         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10593,6,'                              ','Mircoles 15 de Octubre del 08, a las 13:13:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10594,6,'                              ','Mircoles 15 de Octubre del 08, a las 13:13:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10595,6,'                              ','Mircoles 15 de Octubre del 08, a las 15:03:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10596,6,'                              ','Lunes 20 de Octubre del 08, a las 12:08:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10597,6,'                              ','Lunes 20 de Octubre del 08, a las 12:12:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10598,6,'                              ','Lunes 20 de Octubre del 08, a las 12:22:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10599,6,'                              ','Lunes 20 de Octubre del 08, a las 12:27:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10600,6,'                              ','Lunes 20 de Octubre del 08, a las 12:31:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10601,6,'                              ','Lunes 20 de Octubre del 08, a las 12:38:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10602,6,'                              ','Lunes 20 de Octubre del 08, a las 12:39:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10603,6,'                              ','Lunes 20 de Octubre del 08, a las 12:48:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10604,6,'                              ','Lunes 20 de Octubre del 08, a las 13:19:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10605,6,'                              ','Lunes 20 de Octubre del 08, a las 13:22:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10606,6,'                              ','Lunes 20 de Octubre del 08, a las 13:35:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10607,6,'                              ','Lunes 20 de Octubre del 08, a las 13:40:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10608,6,'                              ','Lunes 20 de Octubre del 08, a las 13:51:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10609,6,'                              ','Lunes 20 de Octubre del 08, a las 13:53:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10610,6,'                              ','Lunes 20 de Octubre del 08, a las 14:19:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10611,6,'                              ','Lunes 20 de Octubre del 08, a las 14:29:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10612,6,'                              ','Lunes 20 de Octubre del 08, a las 14:35:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10613,6,'                              ','Martes 21 de Octubre del 08, a las 10:21:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10614,6,'                              ','Martes 21 de Octubre del 08, a las 10:28:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10615,6,'                              ','Martes 21 de Octubre del 08, a las 10:31:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10616,6,'                              ','Martes 21 de Octubre del 08, a las 10:33:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10617,6,'                              ','Martes 21 de Octubre del 08, a las 10:39:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10618,6,'                              ','Martes 21 de Octubre del 08, a las 10:44:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10619,6,'                              ','Martes 21 de Octubre del 08, a las 11:11:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10620,6,'                              ','Martes 21 de Octubre del 08, a las 11:16:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10621,6,'                              ','Martes 21 de Octubre del 08, a las 11:23:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10622,6,'                              ','Martes 21 de Octubre del 08, a las 11:31:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10623,6,'                              ','Martes 21 de Octubre del 08, a las 11:37:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10624,6,'                              ','Martes 21 de Octubre del 08, a las 11:41:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10625,6,'                              ','Martes 21 de Octubre del 08, a las 11:43:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10626,6,'                              ','Martes 21 de Octubre del 08, a las 12:10:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10627,6,'                              ','Martes 21 de Octubre del 08, a las 12:20:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10628,6,'                              ','Martes 21 de Octubre del 08, a las 12:25:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10629,6,'                              ','Martes 21 de Octubre del 08, a las 12:30:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10630,6,'                              ','Martes 21 de Octubre del 08, a las 12:32:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10631,6,'                              ','Martes 21 de Octubre del 08, a las 12:50:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10632,6,'                              ','Martes 21 de Octubre del 08, a las 13:38:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10633,6,'                              ','Martes 21 de Octubre del 08, a las 14:39:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10634,6,'                              ','Mircoles 22 de Octubre del 08, a las 10:14:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10635,6,'                              ','Mircoles 22 de Octubre del 08, a las 10:21:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10636,6,'                              ','Mircoles 22 de Octubre del 08, a las 10:32:31    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10637,6,'                              ','Mircoles 22 de Octubre del 08, a las 10:42:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10638,6,'                              ','Mircoles 22 de Octubre del 08, a las 10:43:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10639,6,'                              ','Mircoles 22 de Octubre del 08, a las 10:58:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10640,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:01:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10641,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:10:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10642,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:11:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10643,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:18:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10644,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:19:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10645,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:25:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10646,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:28:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10647,6,'                              ','Mircoles 22 de Octubre del 08, a las 11:33:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10648,6,'                              ','Mircoles 22 de Octubre del 08, a las 12:13:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10649,6,'                              ','Mircoles 22 de Octubre del 08, a las 12:16:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10650,6,'                              ','Mircoles 22 de Octubre del 08, a las 12:18:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10651,6,'                              ','Mircoles 22 de Octubre del 08, a las 12:55:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10652,6,'                              ','Mircoles 22 de Octubre del 08, a las 13:24:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10653,6,'                              ','Mircoles 22 de Octubre del 08, a las 13:43:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10654,6,'                              ','Mircoles 22 de Octubre del 08, a las 13:52:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10655,6,'                              ','Mircoles 22 de Octubre del 08, a las 14:03:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10656,6,'                              ','Jueves 23 de Octubre del 08, a las 09:36:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10657,6,'                              ','Jueves 23 de Octubre del 08, a las 09:39:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10658,6,'                              ','Jueves 23 de Octubre del 08, a las 09:55:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10659,6,'                              ','Jueves 23 de Octubre del 08, a las 09:57:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10660,6,'                              ','Jueves 23 de Octubre del 08, a las 10:03:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10661,6,'                              ','Jueves 23 de Octubre del 08, a las 10:06:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10662,6,'                              ','Jueves 23 de Octubre del 08, a las 10:23:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10663,6,'                              ','Jueves 23 de Octubre del 08, a las 10:28:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10664,6,'                              ','Jueves 23 de Octubre del 08, a las 10:32:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10665,6,'                              ','Jueves 23 de Octubre del 08, a las 10:38:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10666,6,'                              ','Jueves 23 de Octubre del 08, a las 10:42:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10667,6,'                              ','Jueves 23 de Octubre del 08, a las 10:45:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10668,6,'                              ','Jueves 23 de Octubre del 08, a las 10:53:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10669,6,'                              ','Jueves 23 de Octubre del 08, a las 10:54:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10670,6,'                              ','Jueves 23 de Octubre del 08, a las 11:09:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10671,6,'                              ','Jueves 23 de Octubre del 08, a las 11:13:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10672,6,'                              ','Jueves 23 de Octubre del 08, a las 12:35:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10673,6,'                              ','Jueves 23 de Octubre del 08, a las 12:37:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10674,6,'                              ','Jueves 23 de Octubre del 08, a las 12:46:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10675,6,'                              ','Jueves 23 de Octubre del 08, a las 12:47:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10676,6,'                              ','Viernes 24 de Octubre del 08, a las 10:13:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10677,6,'                              ','Viernes 24 de Octubre del 08, a las 10:25:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10678,6,'                              ','Viernes 24 de Octubre del 08, a las 10:30:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10679,6,'                              ','Viernes 24 de Octubre del 08, a las 10:32:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10680,6,'                              ','Viernes 24 de Octubre del 08, a las 10:34:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10681,6,'                              ','Viernes 24 de Octubre del 08, a las 10:39:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10682,6,'                              ','Viernes 24 de Octubre del 08, a las 10:50:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10683,6,'                              ','Viernes 24 de Octubre del 08, a las 10:52:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10684,6,'                              ','Viernes 24 de Octubre del 08, a las 10:54:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10685,6,'                              ','Martes 28 de Octubre del 08, a las 14:01:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10686,6,'                              ','Martes 28 de Octubre del 08, a las 14:02:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10687,6,'                              ','Jueves 30 de Octubre del 08, a las 15:33:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10688,6,'                              ','Jueves 30 de Octubre del 08, a las 15:33:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10689,6,'                              ','Jueves 30 de Octubre del 08, a las 15:40:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10690,6,'                              ','Viernes 31 de Octubre del 08, a las 13:18:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10691,6,'                              ','Viernes 31 de Octubre del 08, a las 13:19:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10692,6,'                              ','Martes 4 de Noviembre del 08, a las 14:58:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10693,6,'                              ','Mircoles 5 de Noviembre del 08, a las 09:44:47   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10694,6,'                              ','Mircoles 5 de Noviembre del 08, a las 09:47:32   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10695,6,'                              ','Mircoles 5 de Noviembre del 08, a las 09:52:45   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10696,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:28:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10697,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:31:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10698,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:33:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10699,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:35:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10700,2,'Bib Datos Propopios           ','Jueves 6 de Noviembre del 08, a las 09:37:05      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10701,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:38:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10702,2,'Bib Datos Propopios           ','Jueves 6 de Noviembre del 08, a las 09:40:01      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10703,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:41:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10704,3,'                              ','Jueves 6 de Noviembre del 08, a las 09:42:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10705,4,'                              ','Jueves 6 de Noviembre del 08, a las 09:45:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10706,2,'Bib Datos Propopios           ','Jueves 6 de Noviembre del 08, a las 09:46:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10707,6,'                              ','Viernes 7 de Noviembre del 08, a las 10:35:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10708,6,'                              ','Viernes 7 de Noviembre del 08, a las 10:38:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10709,4,'                              ','Viernes 7 de Noviembre del 08, a las 10:50:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10710,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 10:51:45     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10711,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 10:57:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10712,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 11:05:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10713,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 11:11:50     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10714,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 11:14:50     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10715,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 11:18:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10716,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 12:10:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10717,51,'Direccion                     ','Viernes 7 de Noviembre del 08, a las 12:24:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10718,51,'Direccion                     ','Viernes 7 de Noviembre del 08, a las 12:25:09     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10719,6,'                              ','Viernes 7 de Noviembre del 08, a las 12:28:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10720,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 12:32:17     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10721,2,'Bib Datos Propopios           ','Viernes 7 de Noviembre del 08, a las 12:33:19     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10722,51,'Direccion                     ','Viernes 7 de Noviembre del 08, a las 12:37:32     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10723,6,'                              ','Viernes 7 de Noviembre del 08, a las 12:40:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10724,6,'                              ','Martes 11 de Noviembre del 08, a las 10:15:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10725,6,'                              ','Martes 11 de Noviembre del 08, a las 10:17:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10726,6,'                              ','Mircoles 12 de Noviembre del 08, a las 14:42:43  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10727,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 14:47:41  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10728,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 14:49:45  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10729,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 14:50:02  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10730,6,'                              ','Mircoles 12 de Noviembre del 08, a las 14:51:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10731,2,'Bib Datos Propopios           ','Mircoles 12 de Noviembre del 08, a las 15:07:04  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10732,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 15:09:35  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10733,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 15:11:47  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10734,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 15:12:00  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10735,6,'                              ','Mircoles 12 de Noviembre del 08, a las 15:15:16  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10736,2,'Bib Datos Propopios           ','Mircoles 12 de Noviembre del 08, a las 15:17:57  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10737,2,'Bib Datos Propopios           ','Mircoles 12 de Noviembre del 08, a las 15:18:34  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10738,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 15:20:14  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10739,6,'                              ','Mircoles 12 de Noviembre del 08, a las 15:22:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10740,2,'Bib Datos Propopios           ','Mircoles 12 de Noviembre del 08, a las 15:24:46  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10741,2,'Bib Datos Propopios           ','Mircoles 12 de Noviembre del 08, a las 15:25:03  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10742,51,'Direccion                     ','Mircoles 12 de Noviembre del 08, a las 15:28:44  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10743,6,'                              ','Mircoles 12 de Noviembre del 08, a las 15:34:34  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10744,2,'Bib Datos Propopios           ','Mircoles 12 de Noviembre del 08, a las 17:42:29  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10745,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:05:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10746,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:11:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10747,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 11:16:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10748,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 11:17:37    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10749,6,'                              ','Viernes 14 de Noviembre del 08, a las 11:20:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10750,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:23:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10751,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 11:26:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10752,6,'                              ','Viernes 14 de Noviembre del 08, a las 11:28:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10753,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:31:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10754,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 11:40:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10755,6,'                              ','Viernes 14 de Noviembre del 08, a las 11:42:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10756,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:48:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10757,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 11:53:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10758,6,'                              ','Viernes 14 de Noviembre del 08, a las 11:57:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10759,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:58:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10760,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 11:59:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10761,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 12:01:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10762,6,'                              ','Viernes 14 de Noviembre del 08, a las 12:03:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10763,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 12:05:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10764,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 12:09:26    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10765,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 12:10:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10766,6,'                              ','Viernes 14 de Noviembre del 08, a las 12:12:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10767,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 12:17:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10768,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 12:19:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10769,6,'                              ','Viernes 14 de Noviembre del 08, a las 12:36:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10770,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 12:46:48    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10771,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 12:51:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10772,6,'                              ','Viernes 14 de Noviembre del 08, a las 12:55:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10773,6,'                              ','Viernes 14 de Noviembre del 08, a las 12:55:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10774,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 12:56:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10775,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 12:58:14    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10776,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 13:07:11    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10777,6,'                              ','Viernes 14 de Noviembre del 08, a las 13:12:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10778,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 13:16:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10779,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 13:16:55    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10780,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 13:21:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10781,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 13:23:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10782,6,'                              ','Viernes 14 de Noviembre del 08, a las 13:32:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10783,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 13:36:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10784,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 13:36:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10785,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 13:38:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10786,6,'                              ','Viernes 14 de Noviembre del 08, a las 13:41:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10787,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:37:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10788,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 14:43:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10789,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:45:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10790,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:46:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10791,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 14:47:30    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10792,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:48:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10793,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:49:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10794,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 14:50:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10795,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:52:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10796,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:52:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10797,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:54:10    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10798,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:55:24    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10799,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:57:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10800,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:57:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10801,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 14:59:02    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10802,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 14:59:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10803,51,'Direccion                     ','Viernes 14 de Noviembre del 08, a las 14:59:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10804,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 15:00:33    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10805,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 15:01:33    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10806,2,'Bib Datos Propopios           ','Viernes 14 de Noviembre del 08, a las 15:02:46    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10807,4,'                              ','Martes 18 de Noviembre del 08, a las 08:46:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10808,4,'                              ','Martes 18 de Noviembre del 08, a las 08:48:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10809,53,'                              ','Martes 18 de Noviembre del 08, a las 08:52:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10810,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 08:59:24     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10811,4,'                              ','Martes 18 de Noviembre del 08, a las 09:01:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10812,53,'                              ','Martes 18 de Noviembre del 08, a las 09:02:55     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10813,53,'                              ','Martes 18 de Noviembre del 08, a las 09:03:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10814,53,'                              ','Martes 18 de Noviembre del 08, a las 09:05:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10815,53,'                              ','Martes 18 de Noviembre del 08, a las 09:06:27     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10816,53,'                              ','Martes 18 de Noviembre del 08, a las 09:11:38     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10817,53,'                              ','Martes 18 de Noviembre del 08, a las 09:15:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10818,53,'                              ','Martes 18 de Noviembre del 08, a las 09:18:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10819,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:19:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10820,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:20:28     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10821,53,'                              ','Martes 18 de Noviembre del 08, a las 09:21:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10822,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:22:43     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10823,53,'                              ','Martes 18 de Noviembre del 08, a las 09:26:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10824,53,'                              ','Martes 18 de Noviembre del 08, a las 09:26:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10825,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:27:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10826,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:28:19     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10827,53,'                              ','Martes 18 de Noviembre del 08, a las 09:30:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10828,53,'                              ','Martes 18 de Noviembre del 08, a las 09:30:14     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10829,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:31:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10830,53,'                              ','Martes 18 de Noviembre del 08, a las 09:32:45     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10831,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:33:58     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10832,53,'                              ','Martes 18 de Noviembre del 08, a las 09:35:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10833,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:39:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10834,53,'                              ','Martes 18 de Noviembre del 08, a las 09:41:30     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10835,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:42:33     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10836,53,'                              ','Martes 18 de Noviembre del 08, a las 09:44:00     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10837,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:44:16     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10838,53,'                              ','Martes 18 de Noviembre del 08, a las 09:44:50     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10839,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:45:54     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10840,53,'                              ','Martes 18 de Noviembre del 08, a las 09:48:03     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10841,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:48:24     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10842,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:49:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10843,53,'                              ','Martes 18 de Noviembre del 08, a las 09:51:23     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10844,53,'                              ','Martes 18 de Noviembre del 08, a las 09:52:28     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10845,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:53:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10846,53,'                              ','Martes 18 de Noviembre del 08, a las 09:53:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10847,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:54:52     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10848,53,'                              ','Martes 18 de Noviembre del 08, a las 09:56:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10849,51,'Direccion                     ','Martes 18 de Noviembre del 08, a las 09:57:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10850,53,'                              ','Martes 18 de Noviembre del 08, a las 09:59:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10851,6,'                              ','Martes 18 de Noviembre del 08, a las 11:02:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10852,6,'                              ','Martes 18 de Noviembre del 08, a las 11:09:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10853,6,'                              ','Martes 18 de Noviembre del 08, a las 11:16:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10854,6,'                              ','Martes 18 de Noviembre del 08, a las 11:21:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10855,6,'                              ','Martes 18 de Noviembre del 08, a las 11:25:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10856,6,'                              ','Martes 18 de Noviembre del 08, a las 11:26:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10857,6,'                              ','Martes 18 de Noviembre del 08, a las 11:37:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10858,6,'                              ','Martes 18 de Noviembre del 08, a las 11:46:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10859,6,'                              ','Martes 18 de Noviembre del 08, a las 11:48:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10860,6,'                              ','Martes 18 de Noviembre del 08, a las 11:50:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10861,6,'                              ','Martes 18 de Noviembre del 08, a las 11:51:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10862,6,'                              ','Martes 18 de Noviembre del 08, a las 11:53:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10863,6,'                              ','Martes 18 de Noviembre del 08, a las 12:12:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10864,6,'                              ','Martes 18 de Noviembre del 08, a las 12:14:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10865,6,'                              ','Martes 18 de Noviembre del 08, a las 12:18:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10866,6,'                              ','Martes 18 de Noviembre del 08, a las 12:21:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10867,6,'                              ','Martes 18 de Noviembre del 08, a las 12:22:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10868,6,'                              ','Martes 18 de Noviembre del 08, a las 12:23:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10869,6,'                              ','Martes 18 de Noviembre del 08, a las 13:03:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10870,53,'                              ','Mircoles 19 de Noviembre del 08, a las 13:37:58  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10871,53,'                              ','Mircoles 19 de Noviembre del 08, a las 13:39:05  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10872,6,'                              ','Mircoles 19 de Noviembre del 08, a las 15:12:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10873,53,'                              ','Mircoles 19 de Noviembre del 08, a las 15:14:32  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10874,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:14:51  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10875,6,'                              ','Mircoles 19 de Noviembre del 08, a las 15:19:20  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10876,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:20:45  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10877,53,'                              ','Mircoles 19 de Noviembre del 08, a las 15:21:09  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10878,6,'                              ','Mircoles 19 de Noviembre del 08, a las 15:23:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10879,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:25:02  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10880,53,'                              ','Mircoles 19 de Noviembre del 08, a las 15:25:29  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10881,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:28:50  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10882,6,'                              ','Mircoles 19 de Noviembre del 08, a las 15:31:42  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10883,6,'                              ','Mircoles 19 de Noviembre del 08, a las 15:32:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10884,53,'                              ','Mircoles 19 de Noviembre del 08, a las 15:34:44  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10885,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:35:33  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10886,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:41:07  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10887,53,'                              ','Mircoles 19 de Noviembre del 08, a las 15:41:38  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10888,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:41:54  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10889,6,'                              ','Mircoles 19 de Noviembre del 08, a las 15:57:27  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10890,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 15:58:39  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10891,53,'                              ','Mircoles 19 de Noviembre del 08, a las 15:58:54  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10892,6,'                              ','Mircoles 19 de Noviembre del 08, a las 16:00:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10893,51,'Direccion                     ','Mircoles 19 de Noviembre del 08, a las 16:01:53  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10894,53,'                              ','Mircoles 19 de Noviembre del 08, a las 16:02:10  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10895,6,'                              ','Mircoles 19 de Noviembre del 08, a las 16:03:30  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10896,6,'                              ','Mircoles 19 de Noviembre del 08, a las 16:07:51  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10897,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 11:03:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10898,53,'                              ','Jueves 20 de Noviembre del 08, a las 11:03:54     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10899,6,'                              ','Jueves 20 de Noviembre del 08, a las 11:04:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10900,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 11:05:30     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10901,53,'                              ','Jueves 20 de Noviembre del 08, a las 11:05:54     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10902,6,'                              ','Jueves 20 de Noviembre del 08, a las 11:10:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10903,6,'                              ','Jueves 20 de Noviembre del 08, a las 11:12:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10904,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 11:14:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10905,53,'                              ','Jueves 20 de Noviembre del 08, a las 11:14:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10906,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 11:14:59     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10907,6,'                              ','Jueves 20 de Noviembre del 08, a las 11:16:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10908,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 11:17:44     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10909,53,'                              ','Jueves 20 de Noviembre del 08, a las 11:18:33     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10910,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 11:19:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10911,6,'                              ','Jueves 20 de Noviembre del 08, a las 11:21:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10912,6,'                              ','Jueves 20 de Noviembre del 08, a las 11:22:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10913,53,'                              ','Jueves 20 de Noviembre del 08, a las 12:12:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10914,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 12:18:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10915,6,'                              ','Jueves 20 de Noviembre del 08, a las 12:20:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10916,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 12:24:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10917,53,'                              ','Jueves 20 de Noviembre del 08, a las 12:25:48     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10918,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 12:26:24     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10919,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 12:26:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10920,6,'                              ','Jueves 20 de Noviembre del 08, a las 12:28:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10921,6,'                              ','Jueves 20 de Noviembre del 08, a las 12:34:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10922,53,'                              ','Jueves 20 de Noviembre del 08, a las 12:36:03     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10923,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 12:36:39     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10924,6,'                              ','Jueves 20 de Noviembre del 08, a las 12:46:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10925,6,'                              ','Jueves 20 de Noviembre del 08, a las 14:52:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10926,6,'                              ','Jueves 20 de Noviembre del 08, a las 14:56:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10927,6,'                              ','Jueves 20 de Noviembre del 08, a las 15:15:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10928,53,'                              ','Jueves 20 de Noviembre del 08, a las 15:16:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10929,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 15:17:28     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10930,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 15:21:24     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10931,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 15:23:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10932,53,'                              ','Jueves 20 de Noviembre del 08, a las 15:24:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10933,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 15:33:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10934,51,'Direccion                     ','Jueves 20 de Noviembre del 08, a las 16:02:40     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10935,6,'                              ','Jueves 20 de Noviembre del 08, a las 16:03:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10936,6,'                              ','Jueves 20 de Noviembre del 08, a las 16:04:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10937,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:03:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10938,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:04:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10939,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:05:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10940,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:05:25    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10941,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:05:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10942,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:07:39    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10943,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:08:15    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10944,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:08:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10945,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:11:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10946,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:12:22    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10947,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:13:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10948,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:14:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10949,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:15:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10950,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:15:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10951,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:16:41    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10952,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:17:15    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10953,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:18:25    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10954,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:18:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10955,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:23:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10956,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:23:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10957,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:24:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10958,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:26:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10959,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:26:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10960,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:27:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10961,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:28:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10962,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:37:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10963,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:38:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10964,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:40:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10965,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:40:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10966,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:41:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10967,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:41:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10968,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:42:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10969,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 10:44:00    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10970,53,'                              ','Viernes 21 de Noviembre del 08, a las 10:44:37    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10971,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:00:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10972,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:00:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10973,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:04:50    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10974,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:14:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10975,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:15:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10976,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:16:10    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10977,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:16:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10978,6,'                              ','Viernes 21 de Noviembre del 08, a las 11:19:01    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10979,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:25:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10980,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:25:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10981,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:27:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10982,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:27:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10983,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:28:38    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10984,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:30:33    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10985,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:32:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10986,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:33:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10987,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:34:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10988,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:36:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10989,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:36:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10990,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:38:14    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10991,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:38:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10992,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:41:24    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10993,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:42:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10994,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:43:40    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10995,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:47:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10996,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:48:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10997,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:52:00    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10998,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:52:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (10999,53,'                              ','Viernes 21 de Noviembre del 08, a las 11:58:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11000,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 11:59:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11001,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:11:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11002,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:12:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11003,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:12:40    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11004,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:13:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11005,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:13:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11006,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:14:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11007,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:15:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11008,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:18:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11009,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:18:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11010,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:20:09    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11011,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:21:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11012,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:24:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11013,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:24:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11014,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:26:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11015,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:27:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11016,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:28:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11017,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:28:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11018,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:29:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11019,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:30:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11020,6,'                              ','Viernes 21 de Noviembre del 08, a las 12:48:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11021,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:51:00    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11022,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:51:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11023,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:52:14    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11024,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:53:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11025,53,'                              ','Viernes 21 de Noviembre del 08, a las 12:54:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11026,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 12:55:09    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11027,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 13:00:39    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11028,53,'                              ','Viernes 21 de Noviembre del 08, a las 13:01:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11029,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 13:03:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11030,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 13:03:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11031,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 13:04:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11032,53,'                              ','Viernes 21 de Noviembre del 08, a las 14:14:42    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11033,53,'                              ','Viernes 21 de Noviembre del 08, a las 14:15:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11034,53,'                              ','Viernes 21 de Noviembre del 08, a las 14:16:31    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11035,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 14:17:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11036,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 14:18:25    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11037,6,'                              ','Viernes 21 de Noviembre del 08, a las 14:20:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11038,2,'Bib Datos Propopios           ','Viernes 21 de Noviembre del 08, a las 14:21:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11039,2,'Bib Datos Propopios           ','Viernes 21 de Noviembre del 08, a las 14:23:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11040,2,'Bib Datos Propopios           ','Viernes 21 de Noviembre del 08, a las 14:23:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11041,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 14:24:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11042,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 14:27:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11043,53,'                              ','Viernes 21 de Noviembre del 08, a las 14:29:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11044,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 14:30:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11045,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 14:30:24    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11046,53,'                              ','Viernes 21 de Noviembre del 08, a las 15:53:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11047,53,'                              ','Viernes 21 de Noviembre del 08, a las 15:53:10    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11048,53,'                              ','Viernes 21 de Noviembre del 08, a las 16:04:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11049,51,'Direccion                     ','Viernes 21 de Noviembre del 08, a las 16:04:42    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11050,53,'                              ','Lunes 24 de Noviembre del 08, a las 09:04:33      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11051,53,'                              ','Lunes 24 de Noviembre del 08, a las 09:08:13      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11052,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 09:28:15      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11053,53,'                              ','Lunes 24 de Noviembre del 08, a las 09:37:17      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11054,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:16:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11055,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:17:34      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11056,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 10:19:39      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11057,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:22:17      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11058,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:32:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11059,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:34:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11060,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:39:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11061,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 10:44:06      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11062,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:44:32      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11063,6,'                              ','Lunes 24 de Noviembre del 08, a las 10:46:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11064,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 10:52:10      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11065,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 10:54:08      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11066,53,'                              ','Lunes 24 de Noviembre del 08, a las 10:54:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11067,6,'                              ','Lunes 24 de Noviembre del 08, a las 10:58:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11068,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:11:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11069,53,'                              ','Lunes 24 de Noviembre del 08, a las 11:12:14      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11070,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:16:28      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11071,53,'                              ','Lunes 24 de Noviembre del 08, a las 11:16:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11072,6,'                              ','Lunes 24 de Noviembre del 08, a las 11:19:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11073,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 11:28:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11074,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 11:28:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11075,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:32:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11076,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 11:34:35      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11077,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 11:39:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11078,6,'                              ','Lunes 24 de Noviembre del 08, a las 11:46:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11079,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:50:12      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11080,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:52:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11081,53,'                              ','Lunes 24 de Noviembre del 08, a las 11:54:01      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11082,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 11:55:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11083,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:57:31      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11084,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 11:59:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11085,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 12:02:41      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11086,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 12:04:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11087,6,'                              ','Lunes 24 de Noviembre del 08, a las 12:17:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11088,51,'Direccion                     ','Lunes 24 de Noviembre del 08, a las 13:36:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11089,53,'                              ','Lunes 24 de Noviembre del 08, a las 13:37:11      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11090,53,'                              ','Lunes 24 de Noviembre del 08, a las 13:38:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11091,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 14:08:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11092,2,'Bib Datos Propopios           ','Lunes 24 de Noviembre del 08, a las 14:11:34      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11093,6,'                              ','Lunes 24 de Noviembre del 08, a las 15:47:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11094,6,'                              ','Lunes 24 de Noviembre del 08, a las 15:51:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11095,6,'                              ','Lunes 24 de Noviembre del 08, a las 15:52:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11096,6,'                              ','Lunes 24 de Noviembre del 08, a las 15:53:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11097,6,'                              ','Lunes 24 de Noviembre del 08, a las 15:54:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11098,6,'                              ','Lunes 24 de Noviembre del 08, a las 15:58:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11099,6,'                              ','Lunes 24 de Noviembre del 08, a las 16:01:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11100,6,'                              ','Lunes 24 de Noviembre del 08, a las 16:03:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11101,6,'                              ','Lunes 24 de Noviembre del 08, a las 16:04:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11102,6,'                              ','Lunes 24 de Noviembre del 08, a las 16:04:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11103,53,'                              ','Martes 25 de Noviembre del 08, a las 13:46:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11104,53,'                              ','Martes 25 de Noviembre del 08, a las 13:47:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11105,53,'                              ','Martes 25 de Noviembre del 08, a las 14:18:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11106,6,'                              ','Martes 25 de Noviembre del 08, a las 14:31:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11107,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:32:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11108,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:33:41     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11109,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:34:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11110,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:34:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11111,53,'                              ','Martes 25 de Noviembre del 08, a las 14:35:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11112,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:36:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11113,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:41:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11114,6,'                              ','Martes 25 de Noviembre del 08, a las 14:47:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11115,51,'Direccion                     ','Martes 25 de Noviembre del 08, a las 14:48:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11116,6,'                              ','Martes 25 de Noviembre del 08, a las 14:49:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11117,6,'                              ','Martes 25 de Noviembre del 08, a las 14:51:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11118,6,'                              ','Martes 25 de Noviembre del 08, a las 14:53:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11119,6,'                              ','Martes 25 de Noviembre del 08, a las 15:01:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11120,6,'                              ','Martes 25 de Noviembre del 08, a las 15:02:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11121,6,'                              ','Martes 25 de Noviembre del 08, a las 15:04:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11122,6,'                              ','Martes 25 de Noviembre del 08, a las 15:05:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11123,6,'                              ','Martes 25 de Noviembre del 08, a las 15:06:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11124,2,'Bib Datos Propopios           ','Mircoles 26 de Noviembre del 08, a las 09:40:35  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11125,53,'                              ','Mircoles 26 de Noviembre del 08, a las 10:55:28  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11126,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 10:56:13  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11127,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 11:05:56  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11128,53,'                              ','Mircoles 26 de Noviembre del 08, a las 11:52:02  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11129,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:00:51  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11130,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:31:00  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11131,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:32:51  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11132,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:33:32  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11133,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:36:45  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11134,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:44:03  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11135,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:44:43  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11136,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:46:30  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11137,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:47:29  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11138,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:47:41  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11139,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:49:50  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11140,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:52:04  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11141,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:52:33  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11142,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:53:22  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11143,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:56:34  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11144,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:56:48  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11145,53,'                              ','Mircoles 26 de Noviembre del 08, a las 12:57:51  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11146,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 12:58:44  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11147,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:00:01  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11148,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:01:22  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11149,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:07:28  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11150,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:07:46  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11151,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:12:46  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11152,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:13:04  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11153,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:16:57  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11154,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:19:22  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11155,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:20:18  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11156,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:22:03  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11157,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:22:37  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11158,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:23:47  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11159,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:24:12  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11160,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:27:09  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11161,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:30:18  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11162,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:32:59  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11163,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:33:30  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11164,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:45:53  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11165,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:47:45  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11166,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:49:11  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11167,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:57:13  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11168,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:57:33  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11169,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 13:58:29  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11170,53,'                              ','Mircoles 26 de Noviembre del 08, a las 13:58:45  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11171,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:00:56  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11172,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:01:35  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11173,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:01:55  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11174,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:05:59  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11175,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:08:28  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11176,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:09:16  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11177,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:13:13  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11178,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:13:49  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11179,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:14:05  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11180,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:14:53  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11181,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:15:07  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11182,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:15:38  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11183,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:34:29  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11184,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:34:56  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11185,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:36:07  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11186,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:36:30  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11187,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:37:35  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11188,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:39:21  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11189,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:39:36  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11190,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:47:22  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11191,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:48:06  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11192,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:49:11  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11193,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:50:08  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11194,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:50:56  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11195,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:51:33  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11196,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:52:13  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11197,53,'                              ','Mircoles 26 de Noviembre del 08, a las 14:53:32  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11198,51,'Direccion                     ','Mircoles 26 de Noviembre del 08, a las 14:54:35  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11199,6,'                              ','Jueves 27 de Noviembre del 08, a las 13:28:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11200,6,'                              ','Jueves 27 de Noviembre del 08, a las 13:32:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11201,6,'                              ','Jueves 27 de Noviembre del 08, a las 14:10:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11202,6,'                              ','Jueves 27 de Noviembre del 08, a las 14:14:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11203,6,'                              ','Jueves 27 de Noviembre del 08, a las 14:27:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11204,6,'                              ','Jueves 27 de Noviembre del 08, a las 14:42:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11205,6,'                              ','Jueves 27 de Noviembre del 08, a las 14:45:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11206,6,'                              ','Jueves 27 de Noviembre del 08, a las 14:55:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11207,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:02:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11208,51,'Direccion                     ','Jueves 27 de Noviembre del 08, a las 15:13:16     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11209,53,'                              ','Jueves 27 de Noviembre del 08, a las 15:14:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11210,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:15:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11211,53,'                              ','Jueves 27 de Noviembre del 08, a las 15:16:49     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11212,53,'                              ','Jueves 27 de Noviembre del 08, a las 15:17:46     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11213,53,'                              ','Jueves 27 de Noviembre del 08, a las 15:18:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11214,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:20:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11215,53,'                              ','Jueves 27 de Noviembre del 08, a las 15:22:01     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11216,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:26:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11217,51,'Direccion                     ','Jueves 27 de Noviembre del 08, a las 15:28:33     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11218,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:33:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11219,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:35:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11220,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:37:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11221,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:38:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11222,53,'                              ','Jueves 27 de Noviembre del 08, a las 15:39:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11223,6,'                              ','Jueves 27 de Noviembre del 08, a las 15:41:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11224,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:45:57    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11225,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:48:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11226,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:49:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11227,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:49:38    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11228,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 09:50:14    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11229,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:51:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11230,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 09:52:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11231,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:52:33    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11232,53,'                              ','Viernes 28 de Noviembre del 08, a las 09:53:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11233,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 09:55:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11234,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 09:59:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11235,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:00:14    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11236,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 10:01:09    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11237,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:01:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11238,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:03:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11239,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 10:15:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11240,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:15:32    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11241,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:17:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11242,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 10:19:09    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11243,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:20:38    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11244,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:20:49    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11245,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 10:21:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11246,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 10:24:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11247,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:24:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11248,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:25:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11249,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:32:48    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11250,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:33:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11251,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:33:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11252,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:35:46    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11253,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:38:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11254,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:39:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11255,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:41:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11256,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:46:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11257,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:57:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11258,53,'                              ','Viernes 28 de Noviembre del 08, a las 10:58:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11259,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:00:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11260,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:00:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11261,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:02:02    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11262,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:03:37    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11263,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:04:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11264,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:05:18    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11265,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:06:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11266,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:07:48    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11267,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:08:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11268,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:21:37    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11269,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:23:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11270,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:24:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11271,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:25:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11272,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:26:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11273,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:26:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11274,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:27:02    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11275,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:39:10    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11276,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:39:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11277,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:45:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11278,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:45:33    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11279,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:46:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11280,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:46:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11281,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:47:11    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11282,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:48:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11283,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:48:35    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11284,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:49:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11285,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:49:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11286,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:50:50    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11287,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:51:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11288,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:52:21    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11289,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:52:37    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11290,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:53:31    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11291,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:53:41    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11292,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:54:24    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11293,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:54:36    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11294,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:55:43    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11295,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:56:05    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11296,53,'                              ','Viernes 28 de Noviembre del 08, a las 11:57:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11297,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:57:46    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11298,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:58:56    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11299,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 11:59:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11300,51,'Direccion                     ','Viernes 28 de Noviembre del 08, a las 12:00:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11301,53,'                              ','Viernes 28 de Noviembre del 08, a las 12:00:55    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11302,53,'                              ','Viernes 28 de Noviembre del 08, a las 12:01:24    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11303,6,'                              ','Viernes 28 de Noviembre del 08, a las 12:49:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11304,6,'                              ','Viernes 28 de Noviembre del 08, a las 12:53:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11305,6,'                              ','Viernes 28 de Noviembre del 08, a las 12:54:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11306,6,'                              ','Viernes 28 de Noviembre del 08, a las 12:59:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11307,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:03:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11308,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:04:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11309,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:06:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11310,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:09:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11311,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:10:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11312,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:12:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11313,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:15:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11314,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:17:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11315,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:20:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11316,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:22:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11317,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:23:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11318,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:23:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11319,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:25:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11320,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:28:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11321,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:29:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11322,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:30:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11323,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:33:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11324,6,'                              ','Viernes 28 de Noviembre del 08, a las 13:33:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11325,53,'                              ','Lunes 1 de Diciembre del 08, a las 12:38:37       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11326,6,'                              ','Lunes 1 de Diciembre del 08, a las 12:57:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11327,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:02:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11328,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:05:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11329,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:07:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11330,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:09:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11331,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:10:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11332,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:13:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11333,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:19:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11334,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:25:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11335,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:30:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11336,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:31:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11337,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:33:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11338,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:40:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11339,6,'                              ','Lunes 1 de Diciembre del 08, a las 13:40:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11340,6,'                              ','Lunes 1 de Diciembre del 08, a las 14:07:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11341,6,'                              ','Lunes 1 de Diciembre del 08, a las 14:30:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11342,6,'                              ','Lunes 1 de Diciembre del 08, a las 14:32:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11343,6,'                              ','Lunes 1 de Diciembre del 08, a las 14:34:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11344,6,'                              ','Lunes 1 de Diciembre del 08, a las 14:36:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11345,6,'                              ','Lunes 1 de Diciembre del 08, a las 15:31:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11346,6,'                              ','Lunes 1 de Diciembre del 08, a las 15:32:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11347,6,'                              ','Lunes 1 de Diciembre del 08, a las 15:38:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11348,6,'                              ','Lunes 1 de Diciembre del 08, a las 15:40:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11349,6,'                              ','Lunes 1 de Diciembre del 08, a las 15:42:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11350,6,'                              ','Lunes 1 de Diciembre del 08, a las 15:43:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11351,51,'Direccion                     ','Martes 2 de Diciembre del 08, a las 08:50:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11352,51,'Direccion                     ','Martes 2 de Diciembre del 08, a las 08:51:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11353,6,'                              ','Martes 2 de Diciembre del 08, a las 08:59:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11354,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 09:15:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11355,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 09:18:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11356,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 09:48:56      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11357,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 10:09:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11358,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 12:40:21      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11359,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 12:43:40      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11360,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 12:44:21      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11361,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 13:03:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11362,2,'Bib Datos Propopios           ','Martes 2 de Diciembre del 08, a las 13:03:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11363,6,'                              ','Martes 2 de Diciembre del 08, a las 14:20:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11364,6,'                              ','Martes 2 de Diciembre del 08, a las 14:22:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11365,6,'                              ','Martes 2 de Diciembre del 08, a las 14:24:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11366,6,'                              ','Martes 2 de Diciembre del 08, a las 14:37:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11367,6,'                              ','Martes 2 de Diciembre del 08, a las 14:44:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11368,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:54:00   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11369,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:54:36   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11370,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:56:44   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11371,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:57:11   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11372,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:57:29   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11373,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:57:48   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11374,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:58:30   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11375,6,'                              ','Mircoles 3 de Diciembre del 08, a las 13:59:17   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11376,6,'                              ','Mircoles 3 de Diciembre del 08, a las 14:00:05   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11377,6,'                              ','Mircoles 3 de Diciembre del 08, a las 14:02:05   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11378,6,'                              ','Mircoles 3 de Diciembre del 08, a las 14:09:40   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11379,6,'                              ','Mircoles 3 de Diciembre del 08, a las 15:56:29   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11380,6,'                              ','Mircoles 3 de Diciembre del 08, a las 16:02:55   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11381,2,'Bib Datos Propopios           ','Lunes 12 de Enero del 09, a las 14:18:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11382,51,'Direccion                     ','Lunes 12 de Enero del 09, a las 14:25:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11383,51,'Direccion                     ','Lunes 12 de Enero del 09, a las 14:28:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11384,51,'Direccion                     ','Lunes 12 de Enero del 09, a las 14:29:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11385,53,'                              ','Lunes 12 de Enero del 09, a las 14:31:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11386,53,'                              ','Lunes 12 de Enero del 09, a las 14:35:18          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11387,6,'                              ','Jueves 15 de Enero del 09, a las 12:42:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11388,53,'                              ','Jueves 15 de Enero del 09, a las 12:45:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11389,6,'                              ','Jueves 15 de Enero del 09, a las 12:49:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11390,11,'                              ','Jueves 15 de Enero del 09, a las 12:52:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11391,11,'                              ','Jueves 15 de Enero del 09, a las 12:53:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11392,11,'                              ','Jueves 15 de Enero del 09, a las 12:54:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11393,53,'                              ','Jueves 15 de Enero del 09, a las 13:00:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11394,51,'Direccion                     ','Jueves 15 de Enero del 09, a las 15:02:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11395,6,'                              ','Jueves 15 de Enero del 09, a las 15:05:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11396,6,'                              ','Jueves 15 de Enero del 09, a las 15:09:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11397,6,'                              ','Jueves 15 de Enero del 09, a las 15:25:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11398,6,'                              ','Jueves 15 de Enero del 09, a las 15:26:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11399,6,'                              ','Viernes 16 de Enero del 09, a las 11:32:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11400,6,'                              ','Viernes 16 de Enero del 09, a las 11:37:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11401,53,'                              ','Viernes 16 de Enero del 09, a las 11:54:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11402,6,'                              ','Viernes 16 de Enero del 09, a las 12:04:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11403,11,'                              ','Viernes 16 de Enero del 09, a las 12:07:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11404,11,'                              ','Viernes 16 de Enero del 09, a las 12:07:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11405,6,'                              ','Viernes 16 de Enero del 09, a las 12:17:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11406,6,'                              ','Viernes 16 de Enero del 09, a las 12:21:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11407,6,'                              ','Viernes 16 de Enero del 09, a las 12:25:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11408,6,'                              ','Viernes 16 de Enero del 09, a las 12:26:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11409,6,'                              ','Viernes 16 de Enero del 09, a las 12:29:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11410,6,'                              ','Viernes 16 de Enero del 09, a las 12:32:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11411,6,'                              ','Viernes 16 de Enero del 09, a las 12:36:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11412,6,'                              ','Viernes 16 de Enero del 09, a las 12:42:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11413,6,'                              ','Viernes 16 de Enero del 09, a las 12:58:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11414,6,'                              ','Viernes 16 de Enero del 09, a las 13:08:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11415,6,'                              ','Viernes 16 de Enero del 09, a las 13:09:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11416,6,'                              ','Viernes 16 de Enero del 09, a las 13:13:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11417,6,'                              ','Viernes 16 de Enero del 09, a las 13:16:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11418,6,'                              ','Viernes 16 de Enero del 09, a las 13:17:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11419,6,'                              ','Viernes 16 de Enero del 09, a las 13:20:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11420,6,'                              ','Viernes 16 de Enero del 09, a las 13:25:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11421,6,'                              ','Viernes 16 de Enero del 09, a las 13:30:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11422,6,'                              ','Viernes 16 de Enero del 09, a las 13:33:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11423,6,'                              ','Viernes 16 de Enero del 09, a las 13:35:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11424,6,'                              ','Viernes 16 de Enero del 09, a las 13:39:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11425,6,'                              ','Viernes 16 de Enero del 09, a las 13:44:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11426,6,'                              ','Viernes 16 de Enero del 09, a las 13:49:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11427,53,'                              ','Viernes 16 de Enero del 09, a las 13:50:33        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11428,51,'Direccion                     ','Viernes 16 de Enero del 09, a las 14:11:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11429,6,'                              ','Viernes 16 de Enero del 09, a las 14:21:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11430,6,'                              ','Lunes 19 de Enero del 09, a las 12:42:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11431,6,'                              ','Lunes 19 de Enero del 09, a las 12:48:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11432,6,'                              ','Lunes 19 de Enero del 09, a las 13:01:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11433,6,'                              ','Lunes 19 de Enero del 09, a las 13:03:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11434,6,'                              ','Lunes 19 de Enero del 09, a las 13:29:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11435,6,'                              ','Mircoles 21 de Enero del 09, a las 12:35:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11436,2,'Bib Datos Propopios           ','Mircoles 21 de Enero del 09, a las 12:41:28      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11437,4,'                              ','Mircoles 21 de Enero del 09, a las 12:42:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11438,6,'                              ','Jueves 22 de Enero del 09, a las 09:03:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11439,6,'                              ','Jueves 22 de Enero del 09, a las 09:12:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11440,6,'                              ','Jueves 22 de Enero del 09, a las 09:12:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11441,6,'                              ','Jueves 22 de Enero del 09, a las 09:18:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11442,6,'                              ','Jueves 22 de Enero del 09, a las 09:19:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11443,6,'                              ','Jueves 22 de Enero del 09, a las 09:20:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11444,6,'                              ','Jueves 22 de Enero del 09, a las 09:22:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11445,6,'                              ','Jueves 22 de Enero del 09, a las 09:23:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11446,6,'                              ','Jueves 22 de Enero del 09, a las 09:25:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11447,6,'                              ','Jueves 22 de Enero del 09, a las 09:27:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11448,6,'                              ','Jueves 22 de Enero del 09, a las 09:27:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11449,6,'                              ','Jueves 22 de Enero del 09, a las 09:27:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11450,6,'                              ','Jueves 22 de Enero del 09, a las 09:36:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11451,6,'                              ','Jueves 22 de Enero del 09, a las 09:37:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11452,6,'                              ','Jueves 22 de Enero del 09, a las 09:39:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11453,6,'                              ','Jueves 22 de Enero del 09, a las 09:41:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11454,6,'                              ','Jueves 22 de Enero del 09, a las 09:45:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11455,6,'                              ','Jueves 22 de Enero del 09, a las 09:46:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11456,6,'                              ','Jueves 22 de Enero del 09, a las 13:46:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11457,6,'                              ','Jueves 22 de Enero del 09, a las 13:48:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11458,2,'Bib Datos Propopios           ','Jueves 22 de Enero del 09, a las 14:04:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11459,4,'                              ','Jueves 22 de Enero del 09, a las 14:05:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11460,6,'                              ','Jueves 22 de Enero del 09, a las 15:54:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11461,6,'                              ','Viernes 23 de Enero del 09, a las 09:29:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11462,6,'                              ','Viernes 23 de Enero del 09, a las 09:35:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11463,6,'                              ','Viernes 23 de Enero del 09, a las 09:38:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11464,6,'                              ','Viernes 23 de Enero del 09, a las 09:43:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11465,6,'                              ','Viernes 23 de Enero del 09, a las 09:44:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11466,6,'                              ','Viernes 23 de Enero del 09, a las 09:59:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11467,6,'                              ','Viernes 23 de Enero del 09, a las 13:13:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11468,6,'                              ','Viernes 23 de Enero del 09, a las 13:21:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11469,6,'                              ','Viernes 23 de Enero del 09, a las 13:21:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11470,6,'                              ','Viernes 23 de Enero del 09, a las 13:33:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11471,6,'                              ','Lunes 26 de Enero del 09, a las 09:08:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11472,6,'                              ','Lunes 26 de Enero del 09, a las 09:15:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11473,51,'Direccion                     ','Lunes 26 de Enero del 09, a las 09:17:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11474,53,'                              ','Lunes 26 de Enero del 09, a las 09:18:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11475,6,'                              ','Lunes 26 de Enero del 09, a las 09:23:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11476,6,'                              ','Lunes 26 de Enero del 09, a las 09:27:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11477,6,'                              ','Lunes 26 de Enero del 09, a las 09:39:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11478,6,'                              ','Lunes 26 de Enero del 09, a las 09:40:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11479,6,'                              ','Lunes 26 de Enero del 09, a las 09:42:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11480,6,'                              ','Lunes 26 de Enero del 09, a las 09:44:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11481,6,'                              ','Lunes 26 de Enero del 09, a las 09:47:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11482,6,'                              ','Lunes 26 de Enero del 09, a las 09:47:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11483,6,'                              ','Lunes 26 de Enero del 09, a las 10:20:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11484,6,'                              ','Lunes 26 de Enero del 09, a las 11:35:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11485,6,'                              ','Lunes 26 de Enero del 09, a las 15:15:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11486,6,'                              ','Lunes 26 de Enero del 09, a las 15:19:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11487,11,'                              ','Lunes 26 de Enero del 09, a las 15:21:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11488,6,'                              ','Lunes 26 de Enero del 09, a las 15:36:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11489,6,'                              ','Lunes 26 de Enero del 09, a las 15:58:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11490,6,'                              ','Lunes 26 de Enero del 09, a las 15:59:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11491,6,'                              ','Mircoles 28 de Enero del 09, a las 10:59:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11492,6,'                              ','Mircoles 28 de Enero del 09, a las 14:10:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11493,6,'                              ','Mircoles 28 de Enero del 09, a las 14:11:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11494,6,'                              ','Mircoles 28 de Enero del 09, a las 14:23:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11495,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:26:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11496,4,'                              ','Mircoles 28 de Enero del 09, a las 14:31:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11497,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:34:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11498,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:39:16      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11499,4,'                              ','Mircoles 28 de Enero del 09, a las 14:41:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11500,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:42:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11501,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:45:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11502,4,'                              ','Mircoles 28 de Enero del 09, a las 14:46:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11503,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:47:01      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11504,4,'                              ','Mircoles 28 de Enero del 09, a las 14:47:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11505,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:49:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11506,4,'                              ','Mircoles 28 de Enero del 09, a las 14:50:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11507,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:51:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11508,4,'                              ','Mircoles 28 de Enero del 09, a las 14:52:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11509,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 14:53:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11510,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 15:05:42      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11511,3,'                              ','Mircoles 28 de Enero del 09, a las 15:06:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11512,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 15:06:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11513,4,'                              ','Mircoles 28 de Enero del 09, a las 15:07:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11514,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 15:09:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11515,3,'                              ','Mircoles 28 de Enero del 09, a las 15:10:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11516,4,'                              ','Mircoles 28 de Enero del 09, a las 15:10:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11517,2,'Bib Datos Propopios           ','Mircoles 28 de Enero del 09, a las 15:13:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11518,6,'                              ','Viernes 30 de Enero del 09, a las 09:47:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11519,6,'                              ','Viernes 30 de Enero del 09, a las 10:07:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11520,6,'                              ','Viernes 30 de Enero del 09, a las 10:09:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11521,6,'                              ','Viernes 30 de Enero del 09, a las 10:11:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11522,6,'                              ','Viernes 30 de Enero del 09, a las 10:11:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11523,6,'                              ','Viernes 30 de Enero del 09, a las 10:14:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11524,6,'                              ','Martes 3 de Febrero del 09, a las 12:49:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11525,4,'                              ','Martes 3 de Febrero del 09, a las 14:35:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11526,6,'                              ','Martes 3 de Febrero del 09, a las 14:39:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11527,6,'                              ','Martes 3 de Febrero del 09, a las 15:18:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11528,6,'                              ','Martes 3 de Febrero del 09, a las 15:21:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11529,6,'                              ','Martes 3 de Febrero del 09, a las 15:25:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11530,6,'                              ','Martes 3 de Febrero del 09, a las 15:47:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11531,2,'Bib Datos Propopios           ','Mircoles 4 de Febrero del 09, a las 11:05:39     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11532,2,'Bib Datos Propopios           ','Mircoles 4 de Febrero del 09, a las 11:08:07     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11533,6,'                              ','Mircoles 4 de Febrero del 09, a las 12:55:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11534,6,'                              ','Mircoles 4 de Febrero del 09, a las 13:21:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11535,6,'                              ','Mircoles 4 de Febrero del 09, a las 13:34:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11536,6,'                              ','Mircoles 4 de Febrero del 09, a las 13:54:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11537,6,'                              ','Mircoles 4 de Febrero del 09, a las 13:55:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11538,6,'                              ','Mircoles 4 de Febrero del 09, a las 16:15:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11539,6,'                              ','Jueves 5 de Febrero del 09, a las 12:39:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11540,6,'                              ','Jueves 5 de Febrero del 09, a las 15:18:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11541,6,'                              ','Viernes 6 de Febrero del 09, a las 11:51:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11542,6,'                              ','Viernes 6 de Febrero del 09, a las 11:56:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11543,4,'                              ','Viernes 6 de Febrero del 09, a las 11:57:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11544,6,'                              ','Viernes 6 de Febrero del 09, a las 13:10:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11545,6,'                              ','Mircoles 11 de Febrero del 09, a las 10:08:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11546,11,'                              ','Mircoles 11 de Febrero del 09, a las 10:16:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11547,6,'                              ','Mircoles 11 de Febrero del 09, a las 10:20:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11548,11,'                              ','Mircoles 11 de Febrero del 09, a las 10:22:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11549,11,'                              ','Mircoles 11 de Febrero del 09, a las 10:26:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11550,6,'                              ','Mircoles 11 de Febrero del 09, a las 10:38:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11551,11,'                              ','Mircoles 11 de Febrero del 09, a las 10:40:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11552,11,'                              ','Jueves 12 de Febrero del 09, a las 13:26:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11553,11,'                              ','Jueves 12 de Febrero del 09, a las 15:29:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11554,11,'                              ','Lunes 16 de Febrero del 09, a las 11:47:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11555,6,'                              ','Lunes 16 de Febrero del 09, a las 14:59:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11556,6,'                              ','Lunes 16 de Febrero del 09, a las 15:08:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11557,6,'                              ','Lunes 16 de Febrero del 09, a las 15:08:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11558,6,'                              ','Lunes 16 de Febrero del 09, a las 15:09:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11559,6,'                              ','Martes 17 de Febrero del 09, a las 15:04:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11560,6,'                              ','Martes 17 de Febrero del 09, a las 15:10:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11561,6,'                              ','Martes 17 de Febrero del 09, a las 15:11:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11562,6,'                              ','Martes 17 de Febrero del 09, a las 15:13:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11563,6,'                              ','Martes 17 de Febrero del 09, a las 15:15:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11564,6,'                              ','Martes 17 de Febrero del 09, a las 15:17:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11565,6,'                              ','Martes 24 de Febrero del 09, a las 15:51:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11566,6,'                              ','Martes 3 de Marzo del 09, a las 15:03:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11567,11,'                              ','Martes 3 de Marzo del 09, a las 15:05:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11568,6,'                              ','Mircoles 4 de Marzo del 09, a las 10:00:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11569,6,'                              ','Mircoles 4 de Marzo del 09, a las 10:10:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11570,6,'                              ','Jueves 5 de Marzo del 09, a las 14:25:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11571,6,'                              ','Jueves 5 de Marzo del 09, a las 14:26:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11572,6,'                              ','Jueves 5 de Marzo del 09, a las 14:40:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11573,6,'                              ','Lunes 9 de Marzo del 09, a las 12:54:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11574,51,'Direccion                     ','Martes 10 de Marzo del 09, a las 10:46:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11575,53,'                              ','Martes 10 de Marzo del 09, a las 10:47:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11576,6,'                              ','Martes 10 de Marzo del 09, a las 16:30:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11577,6,'                              ','Mircoles 11 de Marzo del 09, a las 09:33:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11578,6,'                              ','Jueves 12 de Marzo del 09, a las 12:52:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11579,6,'                              ','Jueves 12 de Marzo del 09, a las 16:00:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11580,6,'                              ','Jueves 12 de Marzo del 09, a las 16:14:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11581,6,'                              ','Martes 17 de Marzo del 09, a las 15:25:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11582,6,'                              ','Mircoles 18 de Marzo del 09, a las 10:43:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11583,6,'                              ','Mircoles 18 de Marzo del 09, a las 10:48:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11584,6,'                              ','Mircoles 18 de Marzo del 09, a las 10:50:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11585,6,'                              ','Mircoles 18 de Marzo del 09, a las 10:51:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11586,6,'                              ','Mircoles 18 de Marzo del 09, a las 10:52:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11587,6,'                              ','Mircoles 18 de Marzo del 09, a las 10:54:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11588,6,'                              ','Viernes 20 de Marzo del 09, a las 12:50:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11589,11,'                              ','Viernes 20 de Marzo del 09, a las 12:57:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11590,11,'                              ','Viernes 20 de Marzo del 09, a las 12:59:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11591,6,'                              ','Viernes 20 de Marzo del 09, a las 13:00:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11592,53,'                              ','Viernes 20 de Marzo del 09, a las 13:01:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11593,11,'                              ','Viernes 20 de Marzo del 09, a las 14:25:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11594,11,'                              ','Viernes 20 de Marzo del 09, a las 14:26:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11595,53,'                              ','Viernes 20 de Marzo del 09, a las 14:31:00        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11596,11,'                              ','Viernes 20 de Marzo del 09, a las 15:03:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11597,11,'                              ','Viernes 20 de Marzo del 09, a las 15:04:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11598,6,'                              ','Viernes 20 de Marzo del 09, a las 15:16:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11599,6,'                              ','Viernes 20 de Marzo del 09, a las 15:19:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11600,6,'                              ','Martes 24 de Marzo del 09, a las 10:03:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11601,51,'Direccion                     ','Martes 24 de Marzo del 09, a las 10:06:59         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11602,6,'                              ','Lunes 30 de Marzo del 09, a las 13:48:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11603,53,'                              ','Mircoles 1 de Abril del 09, a las 13:14:48       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11604,6,'                              ','Jueves 16 de Abril del 09, a las 09:31:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11605,6,'                              ','Jueves 16 de Abril del 09, a las 09:37:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11606,6,'                              ','Lunes 20 de Abril del 09, a las 14:18:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11607,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:19:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11608,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:19:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11609,53,'                              ','Lunes 20 de Abril del 09, a las 14:20:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11610,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:21:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11611,53,'                              ','Lunes 20 de Abril del 09, a las 14:22:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11612,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:22:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11613,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:41:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11614,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:55:09          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11615,51,'Direccion                     ','Lunes 20 de Abril del 09, a las 14:55:40          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11616,53,'                              ','Martes 21 de Abril del 09, a las 16:26:24         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11617,53,'                              ','Martes 21 de Abril del 09, a las 16:29:27         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11618,2,'Bib Datos Propopios           ','Mircoles 22 de Abril del 09, a las 15:12:23      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11619,2,'Bib Datos Propopios           ','Mircoles 22 de Abril del 09, a las 15:14:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11620,4,'                              ','Mircoles 22 de Abril del 09, a las 15:26:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11621,6,'                              ','Mircoles 22 de Abril del 09, a las 15:29:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11622,4,'                              ','Mircoles 22 de Abril del 09, a las 15:32:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11623,6,'                              ','Mircoles 22 de Abril del 09, a las 15:44:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11624,51,'Direccion                     ','Mircoles 22 de Abril del 09, a las 15:52:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11625,53,'                              ','Mircoles 22 de Abril del 09, a las 15:56:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11626,6,'                              ','Lunes 11 de Mayo del 09, a las 10:33:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11627,6,'                              ','Lunes 11 de Mayo del 09, a las 10:36:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11628,11,'                              ','Lunes 11 de Mayo del 09, a las 10:38:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11629,6,'                              ','Lunes 11 de Mayo del 09, a las 15:01:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11630,6,'                              ','Lunes 11 de Mayo del 09, a las 15:05:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11631,6,'                              ','Lunes 11 de Mayo del 09, a las 15:09:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11632,6,'                              ','Lunes 11 de Mayo del 09, a las 15:09:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11633,6,'                              ','Mircoles 13 de Mayo del 09, a las 14:51:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11634,6,'                              ','Mircoles 13 de Mayo del 09, a las 14:51:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11635,6,'                              ','Mircoles 13 de Mayo del 09, a las 14:53:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11636,6,'                              ','Mircoles 13 de Mayo del 09, a las 14:58:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11637,6,'                              ','Mircoles 13 de Mayo del 09, a las 14:59:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11638,6,'                              ','Mircoles 13 de Mayo del 09, a las 15:00:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11639,6,'                              ','Martes 19 de Mayo del 09, a las 13:43:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11640,6,'                              ','Martes 19 de Mayo del 09, a las 13:46:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11641,6,'                              ','Martes 19 de Mayo del 09, a las 14:04:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11642,6,'                              ','Martes 19 de Mayo del 09, a las 14:06:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11643,6,'                              ','Martes 19 de Mayo del 09, a las 14:09:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11644,6,'                              ','Martes 19 de Mayo del 09, a las 14:11:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11645,6,'                              ','Martes 19 de Mayo del 09, a las 14:13:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11646,6,'                              ','Martes 19 de Mayo del 09, a las 14:14:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11647,6,'                              ','Martes 19 de Mayo del 09, a las 14:15:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11648,6,'                              ','Martes 19 de Mayo del 09, a las 14:15:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11649,6,'                              ','Martes 19 de Mayo del 09, a las 14:17:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11650,6,'                              ','Martes 19 de Mayo del 09, a las 14:19:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11651,6,'                              ','Martes 19 de Mayo del 09, a las 14:21:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11652,6,'                              ','Martes 19 de Mayo del 09, a las 14:41:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11653,6,'                              ','Martes 19 de Mayo del 09, a las 14:43:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11654,51,'Direccion                     ','Martes 19 de Mayo del 09, a las 14:48:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11655,51,'Direccion                     ','Martes 19 de Mayo del 09, a las 14:49:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11656,51,'Direccion                     ','Martes 19 de Mayo del 09, a las 14:50:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11657,51,'Direccion                     ','Martes 19 de Mayo del 09, a las 14:52:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11658,51,'Direccion                     ','Martes 19 de Mayo del 09, a las 16:25:54          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11659,51,'Direccion                     ','Martes 19 de Mayo del 09, a las 16:26:34          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11660,6,'                              ','Jueves 28 de Mayo del 09, a las 09:34:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11661,6,'                              ','Mircoles 3 de Junio del 09, a las 08:58:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11662,6,'                              ','Mircoles 3 de Junio del 09, a las 08:59:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11663,6,'                              ','Jueves 18 de Junio del 09, a las 09:26:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11664,6,'                              ','Jueves 18 de Junio del 09, a las 09:28:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11665,6,'                              ','Martes 23 de Junio del 09, a las 09:09:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11666,6,'                              ','Viernes 31 de Julio del 09, a las 12:14:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11667,6,'                              ','Mircoles 5 de Agosto del 09, a las 11:31:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11668,11,'                              ','Mircoles 5 de Agosto del 09, a las 11:34:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11669,11,'                              ','Mircoles 5 de Agosto del 09, a las 11:35:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11670,6,'                              ','Mircoles 5 de Agosto del 09, a las 15:59:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11671,11,'                              ','Mircoles 5 de Agosto del 09, a las 16:09:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11672,11,'                              ','Mircoles 5 de Agosto del 09, a las 16:10:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11673,4,'                              ','Viernes 7 de Agosto del 09, a las 09:06:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11674,4,'                              ','Viernes 7 de Agosto del 09, a las 09:44:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11675,4,'                              ','Viernes 7 de Agosto del 09, a las 09:45:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11676,4,'                              ','Viernes 7 de Agosto del 09, a las 09:46:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11677,4,'                              ','Viernes 7 de Agosto del 09, a las 09:47:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11678,4,'                              ','Viernes 7 de Agosto del 09, a las 09:52:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11679,4,'                              ','Viernes 7 de Agosto del 09, a las 09:53:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11680,4,'                              ','Viernes 7 de Agosto del 09, a las 09:55:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11681,4,'                              ','Viernes 7 de Agosto del 09, a las 09:56:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11682,4,'                              ','Viernes 7 de Agosto del 09, a las 09:58:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11683,4,'                              ','Viernes 7 de Agosto del 09, a las 09:59:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11684,6,'                              ','Jueves 13 de Agosto del 09, a las 08:52:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11685,6,'                              ','Viernes 14 de Agosto del 09, a las 10:12:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11686,6,'                              ','Lunes 24 de Agosto del 09, a las 10:16:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11687,6,'                              ','Lunes 24 de Agosto del 09, a las 15:57:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11688,6,'                              ','Lunes 24 de Agosto del 09, a las 16:00:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11689,11,'                              ','Martes 25 de Agosto del 09, a las 08:49:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11690,6,'                              ','Jueves 3 de Septiembre del 09, a las 09:35:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11691,6,'                              ','Jueves 3 de Septiembre del 09, a las 10:00:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11692,6,'                              ','Jueves 3 de Septiembre del 09, a las 10:03:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11693,6,'                              ','Martes 8 de Septiembre del 09, a las 15:56:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11694,6,'                              ','Jueves 1 de Octubre del 09, a las 10:28:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11695,6,'                              ','Jueves 1 de Octubre del 09, a las 12:00:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11696,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:24:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11697,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:30:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11698,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:33:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11699,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:33:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11700,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:41:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11701,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:50:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11702,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:53:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11703,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:53:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11704,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:55:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11705,6,'                              ','Mircoles 7 de Octubre del 09, a las 11:59:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11706,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:02:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11707,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:06:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11708,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:10:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11709,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:11:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11710,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:13:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11711,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:14:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11712,6,'                              ','Mircoles 7 de Octubre del 09, a las 12:15:55     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11713,2,'Bib Datos Propopios           ','Mircoles 7 de Octubre del 09, a las 12:20:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11714,2,'Bib Datos Propopios           ','Mircoles 7 de Octubre del 09, a las 12:22:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11715,4,'                              ','Mircoles 7 de Octubre del 09, a las 12:25:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11716,4,'                              ','Mircoles 7 de Octubre del 09, a las 12:33:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11717,4,'                              ','Mircoles 7 de Octubre del 09, a las 12:35:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11718,4,'                              ','Mircoles 7 de Octubre del 09, a las 12:37:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11719,11,'                              ','Martes 13 de Octubre del 09, a las 08:53:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11720,11,'                              ','Martes 13 de Octubre del 09, a las 08:56:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11721,6,'                              ','Martes 13 de Octubre del 09, a las 14:54:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11722,11,'                              ','Martes 13 de Octubre del 09, a las 15:03:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11723,6,'                              ','Jueves 15 de Octubre del 09, a las 08:53:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11724,6,'                              ','Jueves 15 de Octubre del 09, a las 08:54:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11725,6,'                              ','Jueves 22 de Octubre del 09, a las 13:30:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11726,11,'                              ','Jueves 22 de Octubre del 09, a las 13:36:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11727,2,'Bib Datos Propopios           ','Mircoles 28 de Octubre del 09, a las 14:20:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11728,3,'                              ','Mircoles 28 de Octubre del 09, a las 14:22:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11729,2,'Bib Datos Propopios           ','Mircoles 28 de Octubre del 09, a las 14:23:27    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11730,3,'                              ','Mircoles 28 de Octubre del 09, a las 14:24:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11731,6,'                              ','Jueves 5 de Noviembre del 09, a las 09:23:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11732,6,'                              ','Jueves 5 de Noviembre del 09, a las 09:28:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11733,6,'                              ','Jueves 5 de Noviembre del 09, a las 09:29:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11734,6,'                              ','Jueves 3 de Diciembre del 09, a las 09:24:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11735,6,'                              ','Lunes 7 de Diciembre del 09, a las 16:22:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11736,6,'                              ','Lunes 7 de Diciembre del 09, a las 16:25:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11737,6,'                              ','Martes 8 de Diciembre del 09, a las 09:45:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11738,6,'                              ','Martes 8 de Diciembre del 09, a las 09:50:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11739,6,'                              ','Martes 8 de Diciembre del 09, a las 09:52:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11740,6,'                              ','Martes 8 de Diciembre del 09, a las 09:55:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11741,11,'                              ','Martes 8 de Diciembre del 09, a las 09:57:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11742,6,'                              ','Mircoles 9 de Diciembre del 09, a las 09:32:55   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11743,6,'                              ','Lunes 4 de Enero del 10, a las 13:59:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11744,6,'                              ','Jueves 7 de Enero del 10, a las 09:53:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11745,6,'                              ','Jueves 7 de Enero del 10, a las 09:53:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11746,6,'                              ','Viernes 8 de Enero del 10, a las 10:27:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11747,6,'                              ','Viernes 8 de Enero del 10, a las 10:28:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11748,11,'                              ','Viernes 8 de Enero del 10, a las 10:29:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11749,6,'                              ','Viernes 8 de Enero del 10, a las 13:02:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11750,11,'                              ','Viernes 8 de Enero del 10, a las 13:02:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11751,4,'                              ','Mircoles 13 de Enero del 10, a las 09:21:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11752,4,'                              ','Mircoles 13 de Enero del 10, a las 09:26:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11753,4,'                              ','Mircoles 13 de Enero del 10, a las 09:31:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11754,6,'                              ','Jueves 14 de Enero del 10, a las 11:22:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11755,6,'                              ','Jueves 14 de Enero del 10, a las 11:22:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11756,6,'                              ','Jueves 14 de Enero del 10, a las 11:25:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11757,6,'                              ','Jueves 14 de Enero del 10, a las 11:26:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11758,6,'                              ','Martes 19 de Enero del 10, a las 16:45:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11759,6,'                              ','Mircoles 20 de Enero del 10, a las 08:43:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11760,6,'                              ','Mircoles 20 de Enero del 10, a las 11:14:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11761,6,'                              ','Jueves 21 de Enero del 10, a las 14:35:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11762,6,'                              ','Lunes 25 de Enero del 10, a las 10:59:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11763,6,'                              ','Martes 26 de Enero del 10, a las 09:07:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11764,6,'                              ','Martes 26 de Enero del 10, a las 09:08:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11765,6,'                              ','Martes 26 de Enero del 10, a las 09:09:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11766,6,'                              ','Martes 26 de Enero del 10, a las 09:11:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11767,6,'                              ','Martes 26 de Enero del 10, a las 09:18:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11768,6,'                              ','Martes 26 de Enero del 10, a las 09:40:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11769,6,'                              ','Martes 26 de Enero del 10, a las 09:42:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11770,6,'                              ','Mircoles 27 de Enero del 10, a las 12:58:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11771,6,'                              ','Jueves 28 de Enero del 10, a las 11:48:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11772,6,'                              ','Jueves 28 de Enero del 10, a las 11:57:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11773,6,'                              ','Jueves 28 de Enero del 10, a las 11:58:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11774,6,'                              ','Jueves 28 de Enero del 10, a las 12:06:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11775,6,'                              ','Jueves 28 de Enero del 10, a las 12:07:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11776,6,'                              ','Jueves 28 de Enero del 10, a las 12:10:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11777,11,'                              ','Jueves 28 de Enero del 10, a las 12:12:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11778,11,'                              ','Jueves 28 de Enero del 10, a las 12:12:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11779,6,'                              ','Jueves 28 de Enero del 10, a las 12:23:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11780,6,'                              ','Jueves 28 de Enero del 10, a las 12:35:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11781,6,'                              ','Martes 2 de Febrero del 10, a las 15:23:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11782,6,'                              ','Mircoles 3 de Febrero del 10, a las 11:17:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11783,11,'                              ','Jueves 4 de Febrero del 10, a las 13:41:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11784,11,'                              ','Jueves 4 de Febrero del 10, a las 13:42:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11785,11,'                              ','Jueves 4 de Febrero del 10, a las 13:45:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11786,6,'                              ','Lunes 8 de Febrero del 10, a las 10:03:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11787,6,'                              ','Lunes 8 de Febrero del 10, a las 10:04:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11788,6,'                              ','Lunes 8 de Febrero del 10, a las 10:05:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11789,6,'                              ','Martes 9 de Febrero del 10, a las 12:59:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11790,6,'                              ','Jueves 11 de Febrero del 10, a las 16:24:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11791,6,'                              ','Jueves 11 de Febrero del 10, a las 16:26:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11792,6,'                              ','Jueves 11 de Febrero del 10, a las 16:27:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11793,6,'                              ','Jueves 11 de Febrero del 10, a las 16:28:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11794,6,'                              ','Jueves 11 de Febrero del 10, a las 16:29:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11795,6,'                              ','Jueves 11 de Febrero del 10, a las 16:31:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11796,6,'                              ','Jueves 11 de Febrero del 10, a las 16:32:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11797,6,'                              ','Jueves 18 de Febrero del 10, a las 09:55:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11798,6,'                              ','Jueves 18 de Febrero del 10, a las 09:56:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11799,6,'                              ','Jueves 18 de Febrero del 10, a las 10:01:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11800,6,'                              ','Jueves 18 de Febrero del 10, a las 10:04:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11801,6,'                              ','Jueves 18 de Febrero del 10, a las 10:07:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11802,11,'                              ','Jueves 18 de Febrero del 10, a las 10:10:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11803,6,'                              ','Jueves 18 de Febrero del 10, a las 10:14:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11804,6,'                              ','Jueves 18 de Febrero del 10, a las 10:16:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11805,6,'                              ','Viernes 19 de Febrero del 10, a las 10:26:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11806,6,'                              ','Viernes 19 de Febrero del 10, a las 10:40:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11807,6,'                              ','Viernes 19 de Febrero del 10, a las 10:40:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11808,6,'                              ','Viernes 19 de Febrero del 10, a las 10:41:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11809,6,'                              ','Mircoles 24 de Febrero del 10, a las 11:20:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11810,6,'                              ','Mircoles 24 de Febrero del 10, a las 11:23:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11811,6,'                              ','Mircoles 24 de Febrero del 10, a las 11:24:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11812,6,'                              ','Viernes 26 de Febrero del 10, a las 09:52:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11813,6,'                              ','Lunes 1 de Marzo del 10, a las 17:15:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11814,6,'                              ','Martes 2 de Marzo del 10, a las 15:16:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11815,6,'                              ','Martes 2 de Marzo del 10, a las 15:19:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11816,6,'                              ','Jueves 4 de Marzo del 10, a las 10:21:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11817,6,'                              ','Jueves 4 de Marzo del 10, a las 10:25:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11818,6,'                              ','Jueves 4 de Marzo del 10, a las 15:52:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11819,11,'                              ','Jueves 4 de Marzo del 10, a las 15:55:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11820,6,'                              ','Viernes 5 de Marzo del 10, a las 10:25:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11821,4,'                              ','Viernes 5 de Marzo del 10, a las 10:26:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11822,3,'                              ','Viernes 5 de Marzo del 10, a las 10:27:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11823,6,'                              ','Viernes 5 de Marzo del 10, a las 10:28:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11824,6,'                              ','Viernes 5 de Marzo del 10, a las 10:29:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11825,6,'                              ','Lunes 22 de Marzo del 10, a las 16:29:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11826,6,'                              ','Lunes 22 de Marzo del 10, a las 16:31:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11827,6,'                              ','Jueves 25 de Marzo del 10, a las 09:31:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11828,6,'                              ','Lunes 5 de Abril del 10, a las 10:14:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11829,6,'                              ','Lunes 5 de Abril del 10, a las 10:16:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11830,6,'                              ','Martes 6 de Abril del 10, a las 12:31:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11831,6,'                              ','Jueves 8 de Abril del 10, a las 13:37:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11832,6,'                              ','Jueves 8 de Abril del 10, a las 13:41:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11833,6,'                              ','Jueves 8 de Abril del 10, a las 13:48:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11834,6,'                              ','Jueves 8 de Abril del 10, a las 13:53:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11835,6,'                              ','Jueves 8 de Abril del 10, a las 14:41:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11836,6,'                              ','Jueves 8 de Abril del 10, a las 14:46:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11837,6,'                              ','Lunes 19 de Abril del 10, a las 15:34:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11838,6,'                              ','Lunes 19 de Abril del 10, a las 15:54:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11839,6,'                              ','Lunes 19 de Abril del 10, a las 15:54:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11840,11,'                              ','Lunes 19 de Abril del 10, a las 15:56:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11841,6,'                              ','Lunes 19 de Abril del 10, a las 15:59:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11842,6,'                              ','Lunes 19 de Abril del 10, a las 16:00:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11843,6,'                              ','Lunes 19 de Abril del 10, a las 16:01:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11844,11,'                              ','Lunes 19 de Abril del 10, a las 16:03:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11845,6,'                              ','Lunes 19 de Abril del 10, a las 16:06:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11846,6,'                              ','Lunes 19 de Abril del 10, a las 16:07:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11847,11,'                              ','Lunes 19 de Abril del 10, a las 16:09:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11848,6,'                              ','Lunes 19 de Abril del 10, a las 16:12:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11849,6,'                              ','Lunes 19 de Abril del 10, a las 16:16:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11850,6,'                              ','Lunes 19 de Abril del 10, a las 16:19:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11851,11,'                              ','Lunes 19 de Abril del 10, a las 16:20:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11852,6,'                              ','Lunes 19 de Abril del 10, a las 16:22:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11853,6,'                              ','Lunes 19 de Abril del 10, a las 16:23:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11854,6,'                              ','Lunes 19 de Abril del 10, a las 16:29:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11855,6,'                              ','Lunes 19 de Abril del 10, a las 16:34:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11856,6,'                              ','Lunes 19 de Abril del 10, a las 16:35:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11857,6,'                              ','Lunes 19 de Abril del 10, a las 16:38:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11858,6,'                              ','Lunes 19 de Abril del 10, a las 16:38:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11859,6,'                              ','Lunes 19 de Abril del 10, a las 16:41:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11860,6,'                              ','Lunes 19 de Abril del 10, a las 16:42:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11861,6,'                              ','Lunes 19 de Abril del 10, a las 16:43:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11862,6,'                              ','Lunes 19 de Abril del 10, a las 16:44:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11863,6,'                              ','Lunes 19 de Abril del 10, a las 16:46:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11864,6,'                              ','Lunes 19 de Abril del 10, a las 16:47:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11865,6,'                              ','Lunes 19 de Abril del 10, a las 16:49:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11866,6,'                              ','Lunes 19 de Abril del 10, a las 16:52:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11867,6,'                              ','Lunes 19 de Abril del 10, a las 16:56:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11868,6,'                              ','Lunes 19 de Abril del 10, a las 16:57:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11869,6,'                              ','Martes 20 de Abril del 10, a las 09:50:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11870,6,'                              ','Martes 20 de Abril del 10, a las 09:54:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11871,11,'                              ','Martes 20 de Abril del 10, a las 09:55:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11872,6,'                              ','Martes 20 de Abril del 10, a las 10:14:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11873,6,'                              ','Martes 20 de Abril del 10, a las 10:16:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11874,11,'                              ','Martes 20 de Abril del 10, a las 10:16:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11875,6,'                              ','Martes 20 de Abril del 10, a las 10:23:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11876,6,'                              ','Martes 20 de Abril del 10, a las 10:26:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11877,11,'                              ','Martes 20 de Abril del 10, a las 10:28:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11878,11,'                              ','Martes 20 de Abril del 10, a las 10:28:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11879,6,'                              ','Martes 20 de Abril del 10, a las 10:32:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11880,51,'Direccion                     ','Martes 20 de Abril del 10, a las 14:13:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11881,51,'Direccion                     ','Martes 20 de Abril del 10, a las 14:17:00         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11882,51,'Direccion                     ','Martes 20 de Abril del 10, a las 14:21:54         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11883,51,'Direccion                     ','Martes 20 de Abril del 10, a las 14:29:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11884,6,'                              ','Jueves 22 de Abril del 10, a las 12:58:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11885,6,'                              ','Jueves 22 de Abril del 10, a las 13:01:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11886,6,'                              ','Jueves 22 de Abril del 10, a las 13:01:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11887,6,'                              ','Jueves 22 de Abril del 10, a las 13:04:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11888,11,'                              ','Jueves 22 de Abril del 10, a las 13:04:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11889,6,'                              ','Jueves 22 de Abril del 10, a las 13:16:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11890,6,'                              ','Jueves 22 de Abril del 10, a las 13:19:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11891,6,'                              ','Jueves 22 de Abril del 10, a las 13:23:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11892,6,'                              ','Jueves 22 de Abril del 10, a las 14:12:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11893,6,'                              ','Jueves 22 de Abril del 10, a las 14:14:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11894,6,'                              ','Jueves 22 de Abril del 10, a las 14:16:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11895,6,'                              ','Jueves 22 de Abril del 10, a las 14:18:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11896,6,'                              ','Jueves 22 de Abril del 10, a las 14:22:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11897,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:33:29         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11898,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:34:31         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11899,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:35:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11900,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:35:42         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11901,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:36:15         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11902,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:41:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11903,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:42:30         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11904,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:43:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11905,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:44:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11906,6,'                              ','Jueves 22 de Abril del 10, a las 15:49:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11907,6,'                              ','Jueves 22 de Abril del 10, a las 15:52:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11908,6,'                              ','Jueves 22 de Abril del 10, a las 15:56:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11909,6,'                              ','Jueves 22 de Abril del 10, a las 15:58:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11910,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 15:59:40         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11911,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:00:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11912,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:02:46         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11913,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:03:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11914,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:04:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11915,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:04:30         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11916,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:04:49         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11917,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:05:09         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11918,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:05:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11919,2,'Bib Datos Propopios           ','Jueves 22 de Abril del 10, a las 16:05:53         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11920,6,'                              ','Jueves 22 de Abril del 10, a las 16:08:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11921,11,'                              ','Jueves 22 de Abril del 10, a las 16:10:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11922,6,'                              ','Jueves 22 de Abril del 10, a las 16:15:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11923,11,'                              ','Jueves 22 de Abril del 10, a las 16:16:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11924,6,'                              ','Viernes 23 de Abril del 10, a las 10:11:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11925,6,'                              ','Viernes 23 de Abril del 10, a las 10:21:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11926,6,'                              ','Viernes 23 de Abril del 10, a las 10:22:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11927,6,'                              ','Viernes 23 de Abril del 10, a las 10:24:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11928,11,'                              ','Viernes 23 de Abril del 10, a las 10:24:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11929,6,'                              ','Viernes 23 de Abril del 10, a las 10:56:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11930,11,'                              ','Viernes 23 de Abril del 10, a las 10:57:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11931,6,'                              ','Viernes 23 de Abril del 10, a las 11:00:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11932,6,'                              ','Viernes 23 de Abril del 10, a las 11:02:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11933,6,'                              ','Viernes 23 de Abril del 10, a las 11:06:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11934,6,'                              ','Viernes 23 de Abril del 10, a las 11:07:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11935,6,'                              ','Viernes 23 de Abril del 10, a las 11:08:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11936,6,'                              ','Viernes 23 de Abril del 10, a las 11:09:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11937,6,'                              ','Viernes 23 de Abril del 10, a las 11:13:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11938,11,'                              ','Viernes 23 de Abril del 10, a las 11:14:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11939,6,'                              ','Viernes 23 de Abril del 10, a las 11:25:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11940,11,'                              ','Viernes 23 de Abril del 10, a las 11:25:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11941,6,'                              ','Viernes 23 de Abril del 10, a las 11:28:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11942,6,'                              ','Viernes 23 de Abril del 10, a las 11:29:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11943,6,'                              ','Viernes 23 de Abril del 10, a las 11:31:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11944,6,'                              ','Viernes 23 de Abril del 10, a las 11:32:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11945,6,'                              ','Viernes 23 de Abril del 10, a las 11:35:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11946,6,'                              ','Viernes 23 de Abril del 10, a las 11:37:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11947,6,'                              ','Viernes 23 de Abril del 10, a las 11:39:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11948,6,'                              ','Viernes 23 de Abril del 10, a las 11:42:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11949,6,'                              ','Viernes 23 de Abril del 10, a las 11:44:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11950,6,'                              ','Viernes 23 de Abril del 10, a las 11:45:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11951,51,'Direccion                     ','Viernes 23 de Abril del 10, a las 11:47:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11952,11,'                              ','Viernes 23 de Abril del 10, a las 11:50:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11953,11,'                              ','Viernes 23 de Abril del 10, a las 11:50:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11954,6,'                              ','Viernes 23 de Abril del 10, a las 11:53:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11955,6,'                              ','Viernes 23 de Abril del 10, a las 11:55:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11956,51,'Direccion                     ','Viernes 23 de Abril del 10, a las 11:56:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11957,6,'                              ','Viernes 23 de Abril del 10, a las 11:59:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11958,6,'                              ','Viernes 23 de Abril del 10, a las 12:01:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11959,11,'                              ','Viernes 23 de Abril del 10, a las 12:02:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11960,6,'                              ','Viernes 23 de Abril del 10, a las 12:06:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11961,6,'                              ','Viernes 23 de Abril del 10, a las 12:09:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11962,11,'                              ','Viernes 23 de Abril del 10, a las 12:09:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11963,6,'                              ','Viernes 23 de Abril del 10, a las 12:15:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11964,6,'                              ','Viernes 23 de Abril del 10, a las 12:17:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11965,11,'                              ','Viernes 23 de Abril del 10, a las 12:19:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11966,6,'                              ','Viernes 23 de Abril del 10, a las 12:23:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11967,6,'                              ','Viernes 23 de Abril del 10, a las 12:24:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11968,11,'                              ','Viernes 23 de Abril del 10, a las 12:25:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11969,6,'                              ','Viernes 23 de Abril del 10, a las 12:33:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11970,6,'                              ','Viernes 23 de Abril del 10, a las 12:35:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11971,6,'                              ','Viernes 23 de Abril del 10, a las 12:37:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11972,6,'                              ','Viernes 23 de Abril del 10, a las 12:38:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11973,6,'                              ','Viernes 23 de Abril del 10, a las 12:41:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11974,6,'                              ','Viernes 23 de Abril del 10, a las 12:44:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11975,11,'                              ','Viernes 23 de Abril del 10, a las 12:45:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11976,6,'                              ','Viernes 23 de Abril del 10, a las 12:48:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11977,6,'                              ','Viernes 23 de Abril del 10, a las 12:51:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11978,11,'                              ','Viernes 23 de Abril del 10, a las 12:52:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11979,6,'                              ','Viernes 23 de Abril del 10, a las 12:59:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11980,6,'                              ','Viernes 23 de Abril del 10, a las 12:59:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11981,11,'                              ','Viernes 23 de Abril del 10, a las 13:21:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11982,11,'                              ','Viernes 23 de Abril del 10, a las 13:27:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11983,6,'                              ','Viernes 23 de Abril del 10, a las 13:29:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11984,11,'                              ','Viernes 23 de Abril del 10, a las 13:31:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11985,6,'                              ','Viernes 23 de Abril del 10, a las 13:36:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11986,6,'                              ','Viernes 23 de Abril del 10, a las 13:39:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11987,6,'                              ','Viernes 23 de Abril del 10, a las 13:41:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11988,11,'                              ','Viernes 23 de Abril del 10, a las 13:42:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11989,6,'                              ','Viernes 23 de Abril del 10, a las 13:47:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11990,6,'                              ','Viernes 23 de Abril del 10, a las 13:49:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11991,6,'                              ','Viernes 23 de Abril del 10, a las 13:52:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11992,6,'                              ','Viernes 23 de Abril del 10, a las 13:53:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11993,6,'                              ','Viernes 23 de Abril del 10, a las 13:55:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11994,6,'                              ','Viernes 23 de Abril del 10, a las 13:57:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11995,6,'                              ','Viernes 23 de Abril del 10, a las 14:00:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11996,11,'                              ','Viernes 23 de Abril del 10, a las 14:01:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11997,2,'Bib Datos Propopios           ','Viernes 23 de Abril del 10, a las 14:14:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11998,4,'                              ','Viernes 23 de Abril del 10, a las 14:15:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (11999,2,'Bib Datos Propopios           ','Viernes 23 de Abril del 10, a las 14:17:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12000,4,'                              ','Viernes 23 de Abril del 10, a las 14:18:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12001,2,'Bib Datos Propopios           ','Viernes 23 de Abril del 10, a las 14:20:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12002,2,'Bib Datos Propopios           ','Viernes 23 de Abril del 10, a las 14:20:52        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12003,4,'                              ','Viernes 23 de Abril del 10, a las 14:22:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12004,4,'                              ','Viernes 23 de Abril del 10, a las 14:23:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12005,4,'                              ','Viernes 23 de Abril del 10, a las 14:24:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12006,4,'                              ','Viernes 23 de Abril del 10, a las 14:25:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12007,4,'                              ','Viernes 23 de Abril del 10, a las 14:27:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12008,4,'                              ','Viernes 23 de Abril del 10, a las 14:28:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12009,4,'                              ','Viernes 23 de Abril del 10, a las 14:29:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12010,4,'                              ','Viernes 23 de Abril del 10, a las 14:31:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12011,4,'                              ','Viernes 23 de Abril del 10, a las 14:33:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12012,4,'                              ','Viernes 23 de Abril del 10, a las 14:36:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12013,4,'                              ','Viernes 23 de Abril del 10, a las 14:37:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12014,4,'                              ','Viernes 23 de Abril del 10, a las 14:38:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12015,4,'                              ','Viernes 23 de Abril del 10, a las 14:39:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12016,4,'                              ','Viernes 23 de Abril del 10, a las 14:41:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12017,4,'                              ','Viernes 23 de Abril del 10, a las 14:42:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12018,4,'                              ','Viernes 23 de Abril del 10, a las 14:44:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12019,6,'                              ','Martes 27 de Abril del 10, a las 09:34:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12020,6,'                              ','Martes 27 de Abril del 10, a las 09:35:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12021,6,'                              ','Martes 27 de Abril del 10, a las 09:35:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12022,6,'                              ','Martes 27 de Abril del 10, a las 09:37:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12023,6,'                              ','Martes 27 de Abril del 10, a las 09:38:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12024,11,'                              ','Martes 27 de Abril del 10, a las 09:40:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12025,6,'                              ','Martes 27 de Abril del 10, a las 09:46:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12026,6,'                              ','Martes 27 de Abril del 10, a las 09:47:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12027,6,'                              ','Martes 27 de Abril del 10, a las 09:50:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12028,6,'                              ','Martes 27 de Abril del 10, a las 09:55:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12029,6,'                              ','Martes 27 de Abril del 10, a las 09:57:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12030,6,'                              ','Martes 27 de Abril del 10, a las 09:59:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12031,6,'                              ','Martes 27 de Abril del 10, a las 10:01:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12032,6,'                              ','Martes 27 de Abril del 10, a las 10:03:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12033,6,'                              ','Martes 27 de Abril del 10, a las 10:04:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12034,6,'                              ','Martes 27 de Abril del 10, a las 10:05:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12035,6,'                              ','Martes 27 de Abril del 10, a las 10:10:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12036,6,'                              ','Martes 27 de Abril del 10, a las 10:11:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12037,53,'                              ','Martes 27 de Abril del 10, a las 10:12:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12038,51,'Direccion                     ','Martes 27 de Abril del 10, a las 10:13:31         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12039,6,'                              ','Martes 27 de Abril del 10, a las 10:15:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12040,6,'                              ','Martes 27 de Abril del 10, a las 10:18:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12041,6,'                              ','Martes 27 de Abril del 10, a las 10:20:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12042,6,'                              ','Martes 27 de Abril del 10, a las 10:21:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12043,2,'Bib Datos Propopios           ','Martes 27 de Abril del 10, a las 10:23:08         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12044,6,'                              ','Martes 27 de Abril del 10, a las 10:26:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12045,6,'                              ','Martes 27 de Abril del 10, a las 10:31:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12046,6,'                              ','Martes 27 de Abril del 10, a las 10:35:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12047,6,'                              ','Martes 27 de Abril del 10, a las 10:37:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12048,4,'                              ','Martes 27 de Abril del 10, a las 10:39:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12049,4,'                              ','Martes 27 de Abril del 10, a las 10:40:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12050,4,'                              ','Martes 27 de Abril del 10, a las 10:41:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12051,4,'                              ','Martes 27 de Abril del 10, a las 10:43:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12052,4,'                              ','Martes 27 de Abril del 10, a las 10:44:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12053,4,'                              ','Martes 27 de Abril del 10, a las 10:45:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12054,4,'                              ','Martes 27 de Abril del 10, a las 10:45:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12055,2,'Bib Datos Propopios           ','Martes 27 de Abril del 10, a las 10:48:10         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12056,2,'Bib Datos Propopios           ','Martes 27 de Abril del 10, a las 10:48:50         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12057,4,'                              ','Martes 27 de Abril del 10, a las 12:59:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12058,2,'Bib Datos Propopios           ','Martes 27 de Abril del 10, a las 13:00:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12059,6,'                              ','Mircoles 28 de Abril del 10, a las 12:52:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12060,6,'                              ','Mircoles 28 de Abril del 10, a las 12:54:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12061,6,'                              ','Mircoles 28 de Abril del 10, a las 12:56:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12062,6,'                              ','Mircoles 28 de Abril del 10, a las 13:11:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12063,6,'                              ','Mircoles 28 de Abril del 10, a las 13:14:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12064,6,'                              ','Mircoles 28 de Abril del 10, a las 13:17:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12065,6,'                              ','Mircoles 28 de Abril del 10, a las 13:18:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12066,11,'                              ','Mircoles 28 de Abril del 10, a las 13:21:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12067,6,'                              ','Mircoles 28 de Abril del 10, a las 13:23:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12068,6,'                              ','Mircoles 28 de Abril del 10, a las 13:26:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12069,53,'                              ','Viernes 30 de Abril del 10, a las 14:39:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12070,6,'                              ','Lunes 3 de Mayo del 10, a las 13:27:29            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12071,11,'                              ','Lunes 3 de Mayo del 10, a las 13:31:27            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12072,6,'                              ','Lunes 3 de Mayo del 10, a las 13:34:23            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12073,6,'                              ','Lunes 3 de Mayo del 10, a las 13:37:43            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12074,6,'                              ','Lunes 3 de Mayo del 10, a las 13:40:03            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12075,6,'                              ','Lunes 3 de Mayo del 10, a las 13:42:03            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12076,6,'                              ','Lunes 3 de Mayo del 10, a las 13:43:31            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12077,6,'                              ','Lunes 3 de Mayo del 10, a las 13:46:17            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12078,6,'                              ','Lunes 3 de Mayo del 10, a las 13:55:28            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12079,6,'                              ','Lunes 3 de Mayo del 10, a las 14:00:52            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12080,6,'                              ','Lunes 3 de Mayo del 10, a las 14:06:02            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12081,6,'                              ','Lunes 3 de Mayo del 10, a las 14:11:38            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12082,6,'                              ','Lunes 3 de Mayo del 10, a las 14:13:22            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12083,6,'                              ','Lunes 3 de Mayo del 10, a las 14:27:02            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12084,6,'                              ','Lunes 3 de Mayo del 10, a las 14:28:27            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12085,6,'                              ','Lunes 3 de Mayo del 10, a las 14:31:34            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12086,11,'                              ','Lunes 3 de Mayo del 10, a las 14:32:44            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12087,6,'                              ','Lunes 3 de Mayo del 10, a las 14:36:09            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12088,11,'                              ','Lunes 3 de Mayo del 10, a las 14:37:32            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12089,6,'                              ','Lunes 3 de Mayo del 10, a las 14:40:52            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12090,6,'                              ','Lunes 3 de Mayo del 10, a las 14:41:19            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12091,6,'                              ','Lunes 3 de Mayo del 10, a las 14:41:59            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12092,6,'                              ','Lunes 3 de Mayo del 10, a las 14:43:56            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12093,6,'                              ','Lunes 3 de Mayo del 10, a las 14:47:38            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12094,6,'                              ','Lunes 3 de Mayo del 10, a las 14:51:27            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12095,11,'                              ','Lunes 3 de Mayo del 10, a las 14:52:34            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12096,6,'                              ','Jueves 6 de Mayo del 10, a las 09:33:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12097,6,'                              ','Jueves 6 de Mayo del 10, a las 09:36:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12098,11,'                              ','Jueves 6 de Mayo del 10, a las 09:39:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12099,6,'                              ','Jueves 6 de Mayo del 10, a las 09:41:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12100,11,'                              ','Jueves 6 de Mayo del 10, a las 09:43:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12101,6,'                              ','Jueves 6 de Mayo del 10, a las 09:46:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12102,6,'                              ','Jueves 6 de Mayo del 10, a las 09:48:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12103,6,'                              ','Viernes 7 de Mayo del 10, a las 11:13:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12104,6,'                              ','Viernes 7 de Mayo del 10, a las 11:17:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12105,6,'                              ','Viernes 7 de Mayo del 10, a las 11:20:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12106,6,'                              ','Viernes 7 de Mayo del 10, a las 11:22:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12107,6,'                              ','Viernes 7 de Mayo del 10, a las 11:26:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12108,6,'                              ','Viernes 7 de Mayo del 10, a las 11:33:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12109,6,'                              ','Viernes 7 de Mayo del 10, a las 11:36:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12110,6,'                              ','Viernes 7 de Mayo del 10, a las 11:40:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12111,6,'                              ','Viernes 7 de Mayo del 10, a las 11:43:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12112,6,'                              ','Viernes 7 de Mayo del 10, a las 11:45:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12113,6,'                              ','Viernes 7 de Mayo del 10, a las 11:47:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12114,6,'                              ','Viernes 7 de Mayo del 10, a las 11:51:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12115,6,'                              ','Viernes 7 de Mayo del 10, a las 11:55:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12116,6,'                              ','Viernes 7 de Mayo del 10, a las 11:58:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12117,6,'                              ','Viernes 7 de Mayo del 10, a las 12:20:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12118,6,'                              ','Viernes 7 de Mayo del 10, a las 12:23:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12119,6,'                              ','Viernes 7 de Mayo del 10, a las 12:27:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12120,6,'                              ','Viernes 7 de Mayo del 10, a las 12:29:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12121,6,'                              ','Viernes 7 de Mayo del 10, a las 12:32:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12122,6,'                              ','Viernes 7 de Mayo del 10, a las 12:34:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12123,11,'                              ','Viernes 7 de Mayo del 10, a las 12:36:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12124,11,'                              ','Viernes 7 de Mayo del 10, a las 12:36:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12125,6,'                              ','Martes 11 de Mayo del 10, a las 09:55:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12126,6,'                              ','Martes 11 de Mayo del 10, a las 09:59:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12127,6,'                              ','Martes 11 de Mayo del 10, a las 10:03:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12128,6,'                              ','Martes 11 de Mayo del 10, a las 10:22:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12129,6,'                              ','Martes 11 de Mayo del 10, a las 10:24:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12130,11,'                              ','Martes 11 de Mayo del 10, a las 10:27:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12131,6,'                              ','Mircoles 12 de Mayo del 10, a las 09:34:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12132,11,'                              ','Mircoles 12 de Mayo del 10, a las 09:35:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12133,11,'                              ','Mircoles 12 de Mayo del 10, a las 09:35:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12134,6,'                              ','Mircoles 12 de Mayo del 10, a las 09:37:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12135,6,'                              ','Mircoles 12 de Mayo del 10, a las 16:09:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12136,6,'                              ','Viernes 14 de Mayo del 10, a las 09:35:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12137,6,'                              ','Viernes 14 de Mayo del 10, a las 09:39:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12138,11,'                              ','Viernes 14 de Mayo del 10, a las 09:41:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12139,6,'                              ','Viernes 14 de Mayo del 10, a las 09:47:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12140,6,'                              ','Viernes 14 de Mayo del 10, a las 09:49:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12141,6,'                              ','Martes 18 de Mayo del 10, a las 09:24:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12142,11,'                              ','Martes 18 de Mayo del 10, a las 09:26:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12143,6,'                              ','Martes 18 de Mayo del 10, a las 09:30:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12144,6,'                              ','Martes 18 de Mayo del 10, a las 09:33:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12145,6,'                              ','Martes 18 de Mayo del 10, a las 09:38:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12146,6,'                              ','Martes 18 de Mayo del 10, a las 09:40:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12147,6,'                              ','Martes 18 de Mayo del 10, a las 09:45:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12148,6,'                              ','Martes 18 de Mayo del 10, a las 11:02:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12149,6,'                              ','Martes 18 de Mayo del 10, a las 11:09:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12150,6,'                              ','Martes 18 de Mayo del 10, a las 11:16:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12151,6,'                              ','Mircoles 19 de Mayo del 10, a las 11:10:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12152,6,'                              ','Mircoles 19 de Mayo del 10, a las 13:35:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12153,6,'                              ','Mircoles 19 de Mayo del 10, a las 14:02:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12154,6,'                              ','Mircoles 19 de Mayo del 10, a las 14:03:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12155,6,'                              ','Mircoles 19 de Mayo del 10, a las 14:05:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12156,6,'                              ','Mircoles 19 de Mayo del 10, a las 14:11:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12157,6,'                              ','Mircoles 19 de Mayo del 10, a las 14:11:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12158,6,'                              ','Jueves 20 de Mayo del 10, a las 11:43:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12159,6,'                              ','Jueves 20 de Mayo del 10, a las 11:48:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12160,6,'                              ','Lunes 24 de Mayo del 10, a las 12:33:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12161,6,'                              ','Lunes 24 de Mayo del 10, a las 12:41:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12162,6,'                              ','Martes 25 de Mayo del 10, a las 09:01:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12163,11,'                              ','Martes 25 de Mayo del 10, a las 09:02:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12164,6,'                              ','Jueves 27 de Mayo del 10, a las 11:05:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12165,6,'                              ','Jueves 27 de Mayo del 10, a las 15:39:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12166,6,'                              ','Jueves 27 de Mayo del 10, a las 15:40:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12167,6,'                              ','Jueves 27 de Mayo del 10, a las 15:40:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12168,6,'                              ','Jueves 27 de Mayo del 10, a las 16:14:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12169,6,'                              ','Jueves 27 de Mayo del 10, a las 16:20:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12170,6,'                              ','Jueves 27 de Mayo del 10, a las 16:23:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12171,6,'                              ','Jueves 27 de Mayo del 10, a las 16:26:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12172,6,'                              ','Jueves 27 de Mayo del 10, a las 16:28:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12173,6,'                              ','Jueves 27 de Mayo del 10, a las 16:39:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12174,6,'                              ','Jueves 27 de Mayo del 10, a las 16:54:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12175,51,'Direccion                     ','Jueves 17 de Junio del 10, a las 12:15:19         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12176,6,'                              ','Jueves 17 de Junio del 10, a las 12:17:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12177,53,'                              ','Jueves 17 de Junio del 10, a las 12:19:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12178,6,'                              ','Jueves 17 de Junio del 10, a las 12:22:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12179,2,'Bib Datos Propopios           ','Mircoles 23 de Junio del 10, a las 13:29:40      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12180,2,'Bib Datos Propopios           ','Mircoles 23 de Junio del 10, a las 13:30:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12181,2,'Bib Datos Propopios           ','Mircoles 23 de Junio del 10, a las 13:36:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12182,4,'                              ','Mircoles 23 de Junio del 10, a las 13:39:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12183,4,'                              ','Mircoles 23 de Junio del 10, a las 13:41:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12184,4,'                              ','Mircoles 23 de Junio del 10, a las 13:43:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12185,4,'                              ','Mircoles 23 de Junio del 10, a las 13:46:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12186,4,'                              ','Mircoles 23 de Junio del 10, a las 13:51:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12187,4,'                              ','Mircoles 23 de Junio del 10, a las 13:55:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12188,4,'                              ','Mircoles 23 de Junio del 10, a las 13:59:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12189,4,'                              ','Mircoles 23 de Junio del 10, a las 14:02:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12190,4,'                              ','Mircoles 23 de Junio del 10, a las 14:04:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12191,4,'                              ','Mircoles 23 de Junio del 10, a las 14:10:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12192,4,'                              ','Mircoles 23 de Junio del 10, a las 14:13:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12193,4,'                              ','Mircoles 23 de Junio del 10, a las 14:14:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12194,6,'                              ','Viernes 25 de Junio del 10, a las 14:34:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12195,6,'                              ','Mircoles 30 de Junio del 10, a las 09:16:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12196,6,'                              ','Mircoles 30 de Junio del 10, a las 09:23:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12197,6,'                              ','Mircoles 30 de Junio del 10, a las 09:24:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12198,6,'                              ','Mircoles 30 de Junio del 10, a las 11:30:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12199,6,'                              ','Mircoles 30 de Junio del 10, a las 11:35:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12200,6,'                              ','Mircoles 30 de Junio del 10, a las 11:39:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12201,6,'                              ','Mircoles 30 de Junio del 10, a las 11:46:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12202,6,'                              ','Mircoles 30 de Junio del 10, a las 11:46:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12203,6,'                              ','Lunes 26 de Julio del 10, a las 10:49:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12204,6,'                              ','Lunes 26 de Julio del 10, a las 12:28:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12205,6,'                              ','Mircoles 28 de Julio del 10, a las 15:14:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12206,6,'                              ','Mircoles 28 de Julio del 10, a las 15:14:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12207,6,'                              ','Martes 10 de Agosto del 10, a las 09:34:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12208,6,'                              ','Martes 10 de Agosto del 10, a las 09:54:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12209,6,'                              ','Martes 10 de Agosto del 10, a las 09:56:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12210,6,'                              ','Martes 10 de Agosto del 10, a las 09:57:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12211,6,'                              ','Jueves 12 de Agosto del 10, a las 10:49:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12212,6,'                              ','Jueves 12 de Agosto del 10, a las 10:50:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12213,6,'                              ','Jueves 12 de Agosto del 10, a las 10:52:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12214,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 10:56:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12215,4,'                              ','Jueves 12 de Agosto del 10, a las 10:57:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12216,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 10:59:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12217,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:00:26        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12218,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:02:17        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12219,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:04:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12220,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:05:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12221,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:08:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12222,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:11:04        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12223,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:12:56        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12224,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:14:25        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12225,2,'Bib Datos Propopios           ','Jueves 12 de Agosto del 10, a las 11:18:04        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12226,4,'                              ','Jueves 12 de Agosto del 10, a las 11:21:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12227,4,'                              ','Jueves 12 de Agosto del 10, a las 11:23:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12228,3,'                              ','Jueves 12 de Agosto del 10, a las 11:24:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12229,3,'                              ','Jueves 12 de Agosto del 10, a las 11:25:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12230,4,'                              ','Jueves 12 de Agosto del 10, a las 11:25:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12231,4,'                              ','Jueves 12 de Agosto del 10, a las 11:28:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12232,4,'                              ','Jueves 12 de Agosto del 10, a las 11:31:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12233,6,'                              ','Viernes 20 de Agosto del 10, a las 11:01:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12234,6,'                              ','Viernes 20 de Agosto del 10, a las 12:44:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12235,6,'                              ','Viernes 20 de Agosto del 10, a las 12:47:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12236,6,'                              ','Viernes 20 de Agosto del 10, a las 13:05:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12237,6,'                              ','Martes 24 de Agosto del 10, a las 16:31:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12238,53,'                              ','Martes 31 de Agosto del 10, a las 14:28:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12239,6,'                              ','Martes 31 de Agosto del 10, a las 14:32:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12240,53,'                              ','Martes 31 de Agosto del 10, a las 14:50:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12241,6,'                              ','Mircoles 1 de Septiembre del 10, a las 15:06:08  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12242,53,'                              ','Jueves 2 de Septiembre del 10, a las 15:49:48     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12243,6,'                              ','Jueves 2 de Septiembre del 10, a las 15:51:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12244,4,'                              ','Jueves 2 de Septiembre del 10, a las 17:40:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12245,4,'                              ','Jueves 2 de Septiembre del 10, a las 17:40:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12246,4,'                              ','Jueves 2 de Septiembre del 10, a las 17:42:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12247,6,'                              ','Mircoles 8 de Septiembre del 10, a las 08:40:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12248,6,'                              ','Mircoles 8 de Septiembre del 10, a las 08:47:50  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12249,6,'                              ','Jueves 9 de Septiembre del 10, a las 10:03:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12250,6,'                              ','Jueves 9 de Septiembre del 10, a las 11:32:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12251,6,'                              ','Jueves 9 de Septiembre del 10, a las 11:33:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12252,11,'                              ','Viernes 10 de Septiembre del 10, a las 15:43:43   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12253,6,'                              ','Lunes 13 de Septiembre del 10, a las 09:10:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12254,6,'                              ','Lunes 13 de Septiembre del 10, a las 09:10:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12255,6,'                              ','Martes 14 de Septiembre del 10, a las 16:07:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12256,6,'                              ','Martes 14 de Septiembre del 10, a las 16:08:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12257,6,'                              ','Martes 14 de Septiembre del 10, a las 16:11:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12258,6,'                              ','Martes 14 de Septiembre del 10, a las 16:14:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12259,53,'                              ','Lunes 27 de Septiembre del 10, a las 13:40:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12260,53,'                              ','Lunes 27 de Septiembre del 10, a las 13:40:57     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12261,51,'Direccion                     ','Lunes 27 de Septiembre del 10, a las 14:29:27     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12262,2,'Bib Datos Propopios           ','Lunes 27 de Septiembre del 10, a las 14:31:20     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12263,6,'                              ','Lunes 27 de Septiembre del 10, a las 14:33:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12264,11,'                              ','Martes 28 de Septiembre del 10, a las 15:30:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12265,6,'                              ','Lunes 4 de Octubre del 10, a las 16:25:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12266,11,'                              ','Martes 5 de Octubre del 10, a las 11:06:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12267,11,'                              ','Martes 5 de Octubre del 10, a las 11:07:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12268,11,'                              ','Martes 5 de Octubre del 10, a las 11:08:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12269,11,'                              ','Martes 5 de Octubre del 10, a las 11:09:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12270,11,'                              ','Martes 5 de Octubre del 10, a las 11:10:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12271,11,'                              ','Martes 5 de Octubre del 10, a las 11:15:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12272,6,'                              ','Martes 5 de Octubre del 10, a las 11:20:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12273,6,'                              ','Mircoles 6 de Octubre del 10, a las 09:14:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12274,6,'                              ','Mircoles 6 de Octubre del 10, a las 15:19:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12275,6,'                              ','Jueves 7 de Octubre del 10, a las 09:46:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12276,11,'                              ','Jueves 7 de Octubre del 10, a las 09:54:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12277,11,'                              ','Jueves 7 de Octubre del 10, a las 10:03:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12278,11,'                              ','Jueves 7 de Octubre del 10, a las 10:08:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12279,11,'                              ','Jueves 7 de Octubre del 10, a las 10:11:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12280,6,'                              ','Jueves 7 de Octubre del 10, a las 10:17:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12281,6,'                              ','Jueves 7 de Octubre del 10, a las 10:19:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12282,6,'                              ','Jueves 7 de Octubre del 10, a las 10:21:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12283,6,'                              ','Jueves 7 de Octubre del 10, a las 10:29:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12284,6,'                              ','Jueves 7 de Octubre del 10, a las 11:15:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12285,6,'                              ','Jueves 7 de Octubre del 10, a las 16:21:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12286,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:29:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12287,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:33:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12288,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:36:46    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12289,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:40:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12290,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:43:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12291,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:48:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12292,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:52:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12293,8,'                              ','Mircoles 20 de Octubre del 10, a las 09:55:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12294,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:00:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12295,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:02:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12296,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:04:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12297,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:09:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12298,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:14:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12299,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:18:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12300,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:20:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12301,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:22:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12302,8,'                              ','Mircoles 20 de Octubre del 10, a las 10:23:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12303,8,'                              ','Jueves 21 de Octubre del 10, a las 10:50:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12304,8,'                              ','Jueves 21 de Octubre del 10, a las 10:55:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12305,8,'                              ','Jueves 21 de Octubre del 10, a las 10:57:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12306,8,'                              ','Jueves 21 de Octubre del 10, a las 11:00:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12307,8,'                              ','Jueves 21 de Octubre del 10, a las 11:03:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12308,8,'                              ','Jueves 21 de Octubre del 10, a las 11:05:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12309,8,'                              ','Jueves 21 de Octubre del 10, a las 11:06:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12310,8,'                              ','Jueves 21 de Octubre del 10, a las 11:09:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12311,8,'                              ','Jueves 21 de Octubre del 10, a las 11:09:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12312,8,'                              ','Jueves 21 de Octubre del 10, a las 11:11:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12313,8,'                              ','Jueves 21 de Octubre del 10, a las 11:13:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12314,8,'                              ','Jueves 21 de Octubre del 10, a las 11:15:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12315,8,'                              ','Jueves 21 de Octubre del 10, a las 11:16:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12316,8,'                              ','Jueves 21 de Octubre del 10, a las 11:18:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12317,8,'                              ','Jueves 21 de Octubre del 10, a las 11:20:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12318,8,'                              ','Jueves 21 de Octubre del 10, a las 11:24:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12319,8,'                              ','Jueves 21 de Octubre del 10, a las 11:26:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12320,8,'                              ','Jueves 21 de Octubre del 10, a las 11:28:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12321,8,'                              ','Jueves 21 de Octubre del 10, a las 11:30:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12322,8,'                              ','Jueves 21 de Octubre del 10, a las 11:40:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12323,8,'                              ','Jueves 21 de Octubre del 10, a las 11:44:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12324,8,'                              ','Jueves 21 de Octubre del 10, a las 11:58:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12325,8,'                              ','Jueves 21 de Octubre del 10, a las 12:01:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12326,8,'                              ','Jueves 21 de Octubre del 10, a las 12:08:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12327,8,'                              ','Jueves 21 de Octubre del 10, a las 12:29:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12328,8,'                              ','Jueves 21 de Octubre del 10, a las 12:33:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12329,8,'                              ','Jueves 21 de Octubre del 10, a las 12:36:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12330,8,'                              ','Jueves 21 de Octubre del 10, a las 12:47:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12331,8,'                              ','Jueves 21 de Octubre del 10, a las 12:55:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12332,8,'                              ','Jueves 21 de Octubre del 10, a las 13:00:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12333,8,'                              ','Jueves 21 de Octubre del 10, a las 15:28:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12334,8,'                              ','Jueves 21 de Octubre del 10, a las 15:34:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12335,8,'                              ','Jueves 21 de Octubre del 10, a las 15:46:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12336,8,'                              ','Jueves 21 de Octubre del 10, a las 15:48:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12337,8,'                              ','Jueves 21 de Octubre del 10, a las 15:51:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12338,8,'                              ','Jueves 21 de Octubre del 10, a las 15:54:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12339,8,'                              ','Jueves 21 de Octubre del 10, a las 15:57:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12340,8,'                              ','Jueves 21 de Octubre del 10, a las 16:01:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12341,8,'                              ','Jueves 21 de Octubre del 10, a las 16:04:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12342,8,'                              ','Jueves 21 de Octubre del 10, a las 16:06:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12343,8,'                              ','Jueves 21 de Octubre del 10, a las 16:08:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12344,8,'                              ','Jueves 21 de Octubre del 10, a las 16:10:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12345,8,'                              ','Viernes 22 de Octubre del 10, a las 13:31:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12346,8,'                              ','Viernes 22 de Octubre del 10, a las 13:34:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12347,8,'                              ','Viernes 22 de Octubre del 10, a las 13:42:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12348,8,'                              ','Viernes 22 de Octubre del 10, a las 13:44:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12349,8,'                              ','Viernes 22 de Octubre del 10, a las 13:51:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12350,8,'                              ','Viernes 22 de Octubre del 10, a las 13:56:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12351,8,'                              ','Viernes 22 de Octubre del 10, a las 14:00:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12352,8,'                              ','Viernes 22 de Octubre del 10, a las 14:01:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12353,8,'                              ','Viernes 22 de Octubre del 10, a las 14:12:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12354,8,'                              ','Viernes 22 de Octubre del 10, a las 14:17:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12355,8,'                              ','Viernes 22 de Octubre del 10, a las 14:20:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12356,8,'                              ','Viernes 22 de Octubre del 10, a las 14:20:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12357,8,'                              ','Viernes 22 de Octubre del 10, a las 14:28:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12358,8,'                              ','Viernes 22 de Octubre del 10, a las 14:29:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12359,8,'                              ','Viernes 22 de Octubre del 10, a las 14:29:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12360,8,'                              ','Viernes 22 de Octubre del 10, a las 14:32:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12361,8,'                              ','Viernes 22 de Octubre del 10, a las 14:37:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12362,8,'                              ','Viernes 22 de Octubre del 10, a las 14:37:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12363,8,'                              ','Viernes 22 de Octubre del 10, a las 14:42:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12364,8,'                              ','Viernes 22 de Octubre del 10, a las 14:46:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12365,8,'                              ','Viernes 22 de Octubre del 10, a las 14:52:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12366,8,'                              ','Viernes 22 de Octubre del 10, a las 14:53:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12367,8,'                              ','Viernes 22 de Octubre del 10, a las 14:56:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12368,8,'                              ','Viernes 22 de Octubre del 10, a las 15:00:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12369,8,'                              ','Viernes 22 de Octubre del 10, a las 15:03:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12370,8,'                              ','Viernes 22 de Octubre del 10, a las 15:12:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12371,8,'                              ','Viernes 22 de Octubre del 10, a las 15:18:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12372,8,'                              ','Viernes 22 de Octubre del 10, a las 15:23:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12373,8,'                              ','Viernes 22 de Octubre del 10, a las 15:28:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12374,8,'                              ','Viernes 22 de Octubre del 10, a las 15:36:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12375,8,'                              ','Viernes 22 de Octubre del 10, a las 15:59:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12376,8,'                              ','Viernes 22 de Octubre del 10, a las 16:03:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12377,8,'                              ','Viernes 22 de Octubre del 10, a las 16:05:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12378,8,'                              ','Viernes 22 de Octubre del 10, a las 16:11:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12379,8,'                              ','Viernes 22 de Octubre del 10, a las 16:16:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12380,8,'                              ','Viernes 22 de Octubre del 10, a las 16:19:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12381,8,'                              ','Viernes 22 de Octubre del 10, a las 16:19:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12382,8,'                              ','Viernes 22 de Octubre del 10, a las 16:22:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12383,2,'Bib Datos Propopios           ','Lunes 25 de Octubre del 10, a las 10:41:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12384,2,'Bib Datos Propopios           ','Lunes 25 de Octubre del 10, a las 10:44:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12385,2,'Bib Datos Propopios           ','Lunes 25 de Octubre del 10, a las 10:46:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12386,4,'                              ','Lunes 25 de Octubre del 10, a las 10:49:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12387,8,'                              ','Lunes 25 de Octubre del 10, a las 10:59:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12388,8,'                              ','Lunes 25 de Octubre del 10, a las 11:02:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12389,8,'                              ','Lunes 25 de Octubre del 10, a las 11:06:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12390,8,'                              ','Lunes 25 de Octubre del 10, a las 11:07:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12391,8,'                              ','Lunes 25 de Octubre del 10, a las 11:17:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12392,8,'                              ','Lunes 25 de Octubre del 10, a las 11:20:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12393,8,'                              ','Lunes 25 de Octubre del 10, a las 11:24:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12394,8,'                              ','Lunes 25 de Octubre del 10, a las 11:26:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12395,8,'                              ','Lunes 25 de Octubre del 10, a las 11:29:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12396,8,'                              ','Lunes 25 de Octubre del 10, a las 11:32:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12397,8,'                              ','Lunes 25 de Octubre del 10, a las 11:37:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12398,8,'                              ','Lunes 25 de Octubre del 10, a las 11:58:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12399,8,'                              ','Lunes 25 de Octubre del 10, a las 12:01:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12400,8,'                              ','Lunes 25 de Octubre del 10, a las 12:05:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12401,8,'                              ','Lunes 25 de Octubre del 10, a las 12:11:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12402,8,'                              ','Lunes 25 de Octubre del 10, a las 12:26:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12403,8,'                              ','Lunes 25 de Octubre del 10, a las 12:32:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12404,8,'                              ','Lunes 25 de Octubre del 10, a las 12:35:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12405,8,'                              ','Lunes 25 de Octubre del 10, a las 12:37:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12406,8,'                              ','Lunes 25 de Octubre del 10, a las 12:57:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12407,8,'                              ','Lunes 25 de Octubre del 10, a las 13:01:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12408,8,'                              ','Lunes 25 de Octubre del 10, a las 13:04:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12409,8,'                              ','Lunes 25 de Octubre del 10, a las 13:18:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12410,8,'                              ','Lunes 25 de Octubre del 10, a las 13:23:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12411,8,'                              ','Lunes 25 de Octubre del 10, a las 13:26:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12412,8,'                              ','Lunes 25 de Octubre del 10, a las 13:28:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12413,11,'                              ','Lunes 25 de Octubre del 10, a las 13:48:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12414,11,'                              ','Lunes 25 de Octubre del 10, a las 13:50:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12415,11,'                              ','Lunes 25 de Octubre del 10, a las 13:50:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12416,11,'                              ','Lunes 25 de Octubre del 10, a las 13:51:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12417,11,'                              ','Lunes 25 de Octubre del 10, a las 13:52:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12418,11,'                              ','Lunes 25 de Octubre del 10, a las 16:12:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12419,11,'                              ','Lunes 25 de Octubre del 10, a las 16:13:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12420,11,'                              ','Martes 26 de Octubre del 10, a las 09:20:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12421,11,'                              ','Martes 26 de Octubre del 10, a las 09:29:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12422,11,'                              ','Martes 26 de Octubre del 10, a las 09:33:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12423,11,'                              ','Martes 26 de Octubre del 10, a las 09:35:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12424,11,'                              ','Martes 26 de Octubre del 10, a las 09:40:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12425,11,'                              ','Martes 26 de Octubre del 10, a las 09:43:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12426,11,'                              ','Martes 26 de Octubre del 10, a las 09:44:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12427,11,'                              ','Martes 26 de Octubre del 10, a las 09:45:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12428,11,'                              ','Martes 26 de Octubre del 10, a las 09:49:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12429,11,'                              ','Martes 26 de Octubre del 10, a las 09:49:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12430,11,'                              ','Martes 26 de Octubre del 10, a las 09:54:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12431,11,'                              ','Martes 26 de Octubre del 10, a las 09:58:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12432,11,'                              ','Martes 26 de Octubre del 10, a las 10:02:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12433,11,'                              ','Martes 26 de Octubre del 10, a las 10:16:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12434,11,'                              ','Martes 26 de Octubre del 10, a las 10:16:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12435,11,'                              ','Martes 26 de Octubre del 10, a las 10:21:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12436,11,'                              ','Martes 26 de Octubre del 10, a las 10:21:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12437,11,'                              ','Martes 26 de Octubre del 10, a las 10:22:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12438,11,'                              ','Martes 26 de Octubre del 10, a las 10:26:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12439,11,'                              ','Martes 26 de Octubre del 10, a las 10:31:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12440,11,'                              ','Martes 26 de Octubre del 10, a las 10:35:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12441,11,'                              ','Martes 26 de Octubre del 10, a las 15:56:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12442,11,'                              ','Martes 26 de Octubre del 10, a las 15:58:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12443,11,'                              ','Martes 26 de Octubre del 10, a las 16:03:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12444,11,'                              ','Martes 26 de Octubre del 10, a las 16:05:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12445,11,'                              ','Martes 26 de Octubre del 10, a las 16:07:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12446,11,'                              ','Martes 26 de Octubre del 10, a las 16:08:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12447,11,'                              ','Martes 26 de Octubre del 10, a las 16:11:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12448,11,'                              ','Martes 26 de Octubre del 10, a las 16:12:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12449,11,'                              ','Martes 26 de Octubre del 10, a las 16:14:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12450,11,'                              ','Martes 26 de Octubre del 10, a las 16:17:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12451,11,'                              ','Martes 26 de Octubre del 10, a las 16:20:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12452,11,'                              ','Martes 26 de Octubre del 10, a las 16:21:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12453,11,'                              ','Martes 26 de Octubre del 10, a las 16:21:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12454,11,'                              ','Martes 26 de Octubre del 10, a las 16:23:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12455,11,'                              ','Martes 26 de Octubre del 10, a las 16:25:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12456,11,'                              ','Martes 26 de Octubre del 10, a las 16:25:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12457,11,'                              ','Martes 26 de Octubre del 10, a las 16:28:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12458,11,'                              ','Martes 26 de Octubre del 10, a las 16:28:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12459,11,'                              ','Martes 26 de Octubre del 10, a las 16:30:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12460,8,'                              ','Jueves 28 de Octubre del 10, a las 09:52:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12461,8,'                              ','Jueves 28 de Octubre del 10, a las 09:57:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12462,8,'                              ','Jueves 28 de Octubre del 10, a las 10:01:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12463,8,'                              ','Jueves 28 de Octubre del 10, a las 10:06:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12464,8,'                              ','Jueves 28 de Octubre del 10, a las 10:07:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12465,8,'                              ','Jueves 28 de Octubre del 10, a las 10:10:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12466,8,'                              ','Jueves 28 de Octubre del 10, a las 10:15:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12467,8,'                              ','Jueves 28 de Octubre del 10, a las 10:18:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12468,8,'                              ','Jueves 28 de Octubre del 10, a las 10:19:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12469,8,'                              ','Jueves 28 de Octubre del 10, a las 10:23:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12470,8,'                              ','Jueves 28 de Octubre del 10, a las 10:26:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12471,8,'                              ','Jueves 28 de Octubre del 10, a las 10:29:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12472,8,'                              ','Jueves 28 de Octubre del 10, a las 10:33:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12473,8,'                              ','Jueves 28 de Octubre del 10, a las 10:37:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12474,8,'                              ','Jueves 28 de Octubre del 10, a las 10:40:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12475,8,'                              ','Jueves 28 de Octubre del 10, a las 10:40:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12476,8,'                              ','Jueves 28 de Octubre del 10, a las 10:44:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12477,8,'                              ','Jueves 28 de Octubre del 10, a las 10:47:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12478,8,'                              ','Jueves 28 de Octubre del 10, a las 10:51:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12479,8,'                              ','Jueves 28 de Octubre del 10, a las 10:51:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12480,8,'                              ','Jueves 28 de Octubre del 10, a las 10:54:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12481,8,'                              ','Jueves 28 de Octubre del 10, a las 10:56:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12482,8,'                              ','Jueves 28 de Octubre del 10, a las 11:00:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12483,8,'                              ','Jueves 28 de Octubre del 10, a las 11:03:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12484,8,'                              ','Jueves 28 de Octubre del 10, a las 11:13:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12485,8,'                              ','Jueves 28 de Octubre del 10, a las 11:16:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12486,8,'                              ','Jueves 28 de Octubre del 10, a las 11:19:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12487,8,'                              ','Jueves 28 de Octubre del 10, a las 11:23:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12488,8,'                              ','Jueves 28 de Octubre del 10, a las 11:23:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12489,8,'                              ','Jueves 28 de Octubre del 10, a las 11:26:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12490,8,'                              ','Jueves 28 de Octubre del 10, a las 11:30:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12491,8,'                              ','Jueves 28 de Octubre del 10, a las 11:30:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12492,8,'                              ','Jueves 28 de Octubre del 10, a las 11:31:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12493,8,'                              ','Jueves 28 de Octubre del 10, a las 11:34:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12494,8,'                              ','Jueves 28 de Octubre del 10, a las 11:36:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12495,8,'                              ','Jueves 28 de Octubre del 10, a las 14:59:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12496,8,'                              ','Viernes 29 de Octubre del 10, a las 15:44:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12497,8,'                              ','Viernes 29 de Octubre del 10, a las 15:47:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12498,8,'                              ','Viernes 29 de Octubre del 10, a las 15:50:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12499,8,'                              ','Viernes 29 de Octubre del 10, a las 15:53:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12500,8,'                              ','Viernes 29 de Octubre del 10, a las 15:55:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12501,8,'                              ','Viernes 29 de Octubre del 10, a las 16:06:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12502,8,'                              ','Viernes 29 de Octubre del 10, a las 16:10:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12503,8,'                              ','Viernes 29 de Octubre del 10, a las 16:13:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12504,8,'                              ','Viernes 29 de Octubre del 10, a las 16:15:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12505,8,'                              ','Viernes 29 de Octubre del 10, a las 16:18:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12506,8,'                              ','Viernes 29 de Octubre del 10, a las 16:18:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12507,8,'                              ','Viernes 29 de Octubre del 10, a las 16:21:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12508,8,'                              ','Viernes 29 de Octubre del 10, a las 16:29:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12509,8,'                              ','Viernes 29 de Octubre del 10, a las 16:33:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12510,8,'                              ','Viernes 29 de Octubre del 10, a las 16:35:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12511,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:31:06   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12512,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:35:00   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12513,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:38:14   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12514,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:40:50   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12515,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:44:19   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12516,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:46:43   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12517,8,'                              ','Mircoles 3 de Noviembre del 10, a las 09:50:29   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12518,53,'                              ','Mircoles 3 de Noviembre del 10, a las 14:23:50   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12519,53,'                              ','Mircoles 3 de Noviembre del 10, a las 14:27:26   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12520,6,'                              ','Lunes 8 de Noviembre del 10, a las 09:48:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12521,6,'                              ','Lunes 8 de Noviembre del 10, a las 09:49:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12522,6,'                              ','Mircoles 10 de Noviembre del 10, a las 09:46:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12523,6,'                              ','Mircoles 17 de Noviembre del 10, a las 13:37:27  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12524,6,'                              ','Mircoles 17 de Noviembre del 10, a las 13:39:37  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12525,6,'                              ','Mircoles 1 de Diciembre del 10, a las 09:25:49   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12526,6,'                              ','Mircoles 1 de Diciembre del 10, a las 09:30:58   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12527,6,'                              ','Mircoles 1 de Diciembre del 10, a las 09:31:46   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12528,6,'                              ','Martes 7 de Diciembre del 10, a las 16:39:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12529,6,'                              ','Mircoles 8 de Diciembre del 10, a las 11:55:28   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12530,6,'                              ','Mircoles 8 de Diciembre del 10, a las 11:57:00   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12531,6,'                              ','Mircoles 8 de Diciembre del 10, a las 11:58:26   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12532,6,'                              ','Mircoles 8 de Diciembre del 10, a las 11:58:49   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12533,6,'                              ','Mircoles 8 de Diciembre del 10, a las 16:01:08   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12534,6,'                              ','Jueves 16 de Diciembre del 10, a las 10:45:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12535,6,'                              ','Jueves 16 de Diciembre del 10, a las 10:45:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12536,6,'                              ','Jueves 16 de Diciembre del 10, a las 10:51:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12537,6,'                              ','Jueves 13 de Enero del 11, a las 16:08:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12538,6,'                              ','Lunes 17 de Enero del 11, a las 09:24:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12539,6,'                              ','Lunes 17 de Enero del 11, a las 09:29:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12540,6,'                              ','Lunes 17 de Enero del 11, a las 09:40:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12541,6,'                              ','Lunes 17 de Enero del 11, a las 09:45:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12542,6,'                              ','Lunes 17 de Enero del 11, a las 09:46:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12543,6,'                              ','Martes 18 de Enero del 11, a las 11:00:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12544,6,'                              ','Martes 18 de Enero del 11, a las 11:06:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12545,6,'                              ','Martes 18 de Enero del 11, a las 11:08:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12546,6,'                              ','Martes 18 de Enero del 11, a las 11:09:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12547,6,'                              ','Martes 18 de Enero del 11, a las 11:12:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12548,6,'                              ','Mircoles 19 de Enero del 11, a las 12:59:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12549,6,'                              ','Mircoles 19 de Enero del 11, a las 13:01:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12550,6,'                              ','Mircoles 19 de Enero del 11, a las 13:05:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12551,6,'                              ','Mircoles 19 de Enero del 11, a las 13:09:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12552,6,'                              ','Viernes 21 de Enero del 11, a las 09:35:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12553,6,'                              ','Viernes 21 de Enero del 11, a las 09:37:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12554,6,'                              ','Viernes 21 de Enero del 11, a las 15:50:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12555,6,'                              ','Viernes 21 de Enero del 11, a las 15:55:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12556,6,'                              ','Lunes 24 de Enero del 11, a las 09:49:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12557,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 09:53:14          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12558,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 09:55:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12559,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 09:56:03          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12560,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 09:56:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12561,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 09:57:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12562,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 09:59:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12563,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 10:00:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12564,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 10:01:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12565,2,'Bib Datos Propopios           ','Lunes 24 de Enero del 11, a las 10:02:31          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12566,6,'                              ','Lunes 24 de Enero del 11, a las 10:10:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12567,4,'                              ','Lunes 24 de Enero del 11, a las 10:16:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12568,4,'                              ','Lunes 24 de Enero del 11, a las 10:21:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12569,4,'                              ','Lunes 24 de Enero del 11, a las 10:23:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12570,4,'                              ','Lunes 24 de Enero del 11, a las 10:36:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12571,4,'                              ','Lunes 24 de Enero del 11, a las 10:37:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12572,4,'                              ','Martes 25 de Enero del 11, a las 12:59:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12573,4,'                              ','Martes 25 de Enero del 11, a las 13:01:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12574,4,'                              ','Martes 25 de Enero del 11, a las 13:02:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12575,4,'                              ','Martes 25 de Enero del 11, a las 13:03:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12576,4,'                              ','Martes 25 de Enero del 11, a las 13:04:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12577,4,'                              ','Martes 25 de Enero del 11, a las 13:05:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12578,4,'                              ','Martes 25 de Enero del 11, a las 13:06:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12579,4,'                              ','Martes 25 de Enero del 11, a las 13:07:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12580,4,'                              ','Martes 25 de Enero del 11, a las 13:08:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12581,2,'Bib Datos Propopios           ','Martes 25 de Enero del 11, a las 13:09:40         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12582,6,'                              ','Martes 25 de Enero del 11, a las 13:12:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12583,51,'Direccion                     ','Martes 25 de Enero del 11, a las 13:13:39         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12584,4,'                              ','Martes 25 de Enero del 11, a las 13:16:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12585,6,'                              ','Mircoles 26 de Enero del 11, a las 11:36:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12586,6,'                              ','Jueves 27 de Enero del 11, a las 10:14:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12587,6,'                              ','Jueves 27 de Enero del 11, a las 16:00:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12588,6,'                              ','Jueves 27 de Enero del 11, a las 16:03:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12589,6,'                              ','Lunes 31 de Enero del 11, a las 16:12:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12590,6,'                              ','Martes 1 de Febrero del 11, a las 11:35:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12591,6,'                              ','Martes 1 de Febrero del 11, a las 11:51:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12592,6,'                              ','Mircoles 2 de Febrero del 11, a las 09:49:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12593,11,'                              ','Mircoles 2 de Febrero del 11, a las 09:54:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12594,6,'                              ','Martes 15 de Febrero del 11, a las 11:29:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12595,6,'                              ','Jueves 17 de Febrero del 11, a las 10:50:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12596,6,'                              ','Mircoles 2 de Marzo del 11, a las 09:20:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12597,11,'                              ','Mircoles 2 de Marzo del 11, a las 09:22:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12598,11,'                              ','Mircoles 2 de Marzo del 11, a las 09:26:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12599,11,'                              ','Mircoles 2 de Marzo del 11, a las 09:27:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12600,6,'                              ','Jueves 3 de Marzo del 11, a las 16:17:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12601,11,'                              ','Martes 8 de Marzo del 11, a las 15:19:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12602,6,'                              ','Jueves 10 de Marzo del 11, a las 13:30:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12603,6,'                              ','Jueves 10 de Marzo del 11, a las 13:31:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12604,6,'                              ','Jueves 10 de Marzo del 11, a las 13:36:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12605,6,'                              ','Jueves 17 de Marzo del 11, a las 09:13:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12606,6,'                              ','Jueves 17 de Marzo del 11, a las 09:14:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12607,6,'                              ','Jueves 17 de Marzo del 11, a las 09:37:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12608,6,'                              ','Jueves 24 de Marzo del 11, a las 14:12:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12609,6,'                              ','Jueves 24 de Marzo del 11, a las 14:16:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12610,6,'                              ','Jueves 24 de Marzo del 11, a las 14:20:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12611,6,'                              ','Jueves 24 de Marzo del 11, a las 15:54:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12612,6,'                              ','Jueves 24 de Marzo del 11, a las 15:57:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12613,6,'                              ','Jueves 24 de Marzo del 11, a las 15:57:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12614,6,'                              ','Jueves 24 de Marzo del 11, a las 16:11:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12615,6,'                              ','Viernes 25 de Marzo del 11, a las 16:23:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12616,6,'                              ','Viernes 25 de Marzo del 11, a las 16:24:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12617,6,'                              ','Jueves 7 de Abril del 11, a las 16:28:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12618,6,'                              ','Jueves 7 de Abril del 11, a las 16:28:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12619,6,'                              ','Jueves 7 de Abril del 11, a las 16:29:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12620,6,'                              ','Jueves 7 de Abril del 11, a las 16:31:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12621,6,'                              ','Jueves 7 de Abril del 11, a las 16:32:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12622,6,'                              ','Jueves 7 de Abril del 11, a las 16:33:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12623,6,'                              ','Jueves 7 de Abril del 11, a las 16:33:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12624,11,'                              ','Lunes 25 de Abril del 11, a las 10:51:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12625,8,'                              ','Lunes 25 de Abril del 11, a las 10:53:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12626,8,'                              ','Lunes 25 de Abril del 11, a las 10:58:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12627,11,'                              ','Lunes 25 de Abril del 11, a las 11:00:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12628,6,'                              ','Martes 26 de Abril del 11, a las 09:52:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12629,6,'                              ','Martes 26 de Abril del 11, a las 09:56:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12630,6,'                              ','Lunes 2 de Mayo del 11, a las 10:03:43            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12631,11,'                              ','Lunes 2 de Mayo del 11, a las 10:07:08            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12632,11,'                              ','Lunes 2 de Mayo del 11, a las 10:07:54            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12633,11,'                              ','Lunes 2 de Mayo del 11, a las 10:08:28            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12634,6,'                              ','Martes 3 de Mayo del 11, a las 09:51:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12635,6,'                              ','Martes 3 de Mayo del 11, a las 09:55:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12636,6,'                              ','Martes 3 de Mayo del 11, a las 09:58:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12637,6,'                              ','Martes 3 de Mayo del 11, a las 10:00:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12638,6,'                              ','Jueves 5 de Mayo del 11, a las 14:50:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12639,6,'                              ','Lunes 9 de Mayo del 11, a las 11:05:06            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12640,11,'                              ','Lunes 9 de Mayo del 11, a las 11:08:14            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12641,11,'                              ','Lunes 9 de Mayo del 11, a las 11:14:32            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12642,11,'                              ','Lunes 9 de Mayo del 11, a las 11:15:28            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12643,11,'                              ','Lunes 9 de Mayo del 11, a las 11:41:01            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12644,11,'                              ','Lunes 9 de Mayo del 11, a las 11:41:29            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12645,11,'                              ','Lunes 9 de Mayo del 11, a las 11:41:55            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12646,11,'                              ','Lunes 9 de Mayo del 11, a las 11:43:57            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12647,11,'                              ','Lunes 9 de Mayo del 11, a las 11:44:13            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12648,6,'                              ','Martes 17 de Mayo del 11, a las 16:42:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12649,6,'                              ','Viernes 20 de Mayo del 11, a las 09:34:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12650,6,'                              ','Viernes 20 de Mayo del 11, a las 09:41:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12651,6,'                              ','Viernes 20 de Mayo del 11, a las 09:44:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12652,11,'                              ','Viernes 20 de Mayo del 11, a las 09:46:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12653,6,'                              ','Lunes 23 de Mayo del 11, a las 16:58:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12654,6,'                              ','Mircoles 25 de Mayo del 11, a las 09:37:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12655,6,'                              ','Martes 31 de Mayo del 11, a las 16:01:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12656,6,'                              ','Martes 31 de Mayo del 11, a las 16:03:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12657,6,'                              ','Martes 31 de Mayo del 11, a las 16:05:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12658,6,'                              ','Martes 31 de Mayo del 11, a las 16:07:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12659,6,'                              ','Martes 31 de Mayo del 11, a las 16:10:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12660,2,'Bib Datos Propopios           ','Martes 31 de Mayo del 11, a las 16:11:08          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12661,6,'                              ','Martes 31 de Mayo del 11, a las 16:11:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12662,6,'                              ','Martes 31 de Mayo del 11, a las 16:13:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12663,6,'                              ','Martes 31 de Mayo del 11, a las 16:20:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12664,6,'                              ','Martes 31 de Mayo del 11, a las 16:21:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12665,11,'                              ','Martes 31 de Mayo del 11, a las 16:22:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12666,11,'                              ','Mircoles 1 de Junio del 11, a las 16:26:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12667,6,'                              ','Mircoles 1 de Junio del 11, a las 16:32:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12668,11,'                              ','Mircoles 1 de Junio del 11, a las 16:35:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12669,8,'                              ','Mircoles 1 de Junio del 11, a las 16:38:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12670,11,'                              ','Mircoles 1 de Junio del 11, a las 16:44:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12671,6,'                              ','Mircoles 1 de Junio del 11, a las 16:48:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12672,11,'                              ','Mircoles 1 de Junio del 11, a las 16:50:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12673,6,'                              ','Mircoles 1 de Junio del 11, a las 16:53:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12674,11,'                              ','Mircoles 1 de Junio del 11, a las 16:54:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12675,6,'                              ','Mircoles 1 de Junio del 11, a las 16:59:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12676,11,'                              ','Mircoles 1 de Junio del 11, a las 17:01:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12677,6,'                              ','Mircoles 1 de Junio del 11, a las 17:04:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12678,6,'                              ','Martes 7 de Junio del 11, a las 10:37:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12679,11,'                              ','Martes 7 de Junio del 11, a las 10:40:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12680,6,'                              ','Martes 7 de Junio del 11, a las 10:43:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12681,11,'                              ','Martes 7 de Junio del 11, a las 10:44:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12682,11,'                              ','Martes 7 de Junio del 11, a las 10:47:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12683,6,'                              ','Martes 7 de Junio del 11, a las 10:49:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12684,6,'                              ','Martes 7 de Junio del 11, a las 10:52:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12685,6,'                              ','Martes 7 de Junio del 11, a las 10:54:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12686,6,'                              ','Martes 7 de Junio del 11, a las 10:57:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12687,11,'                              ','Martes 7 de Junio del 11, a las 10:58:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12688,6,'                              ','Martes 7 de Junio del 11, a las 11:03:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12689,8,'                              ','Martes 7 de Junio del 11, a las 11:07:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12690,8,'                              ','Martes 7 de Junio del 11, a las 11:08:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12691,8,'                              ','Martes 7 de Junio del 11, a las 11:08:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12692,11,'                              ','Martes 7 de Junio del 11, a las 11:12:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12693,11,'                              ','Martes 7 de Junio del 11, a las 11:17:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12694,6,'                              ','Martes 7 de Junio del 11, a las 11:19:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12695,6,'                              ','Martes 7 de Junio del 11, a las 11:19:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12696,6,'                              ','Martes 7 de Junio del 11, a las 11:23:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12697,11,'                              ','Martes 7 de Junio del 11, a las 11:26:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12698,11,'                              ','Martes 7 de Junio del 11, a las 11:31:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12699,11,'                              ','Martes 7 de Junio del 11, a las 11:32:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12700,6,'                              ','Viernes 10 de Junio del 11, a las 11:43:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12701,6,'                              ','Martes 14 de Junio del 11, a las 14:14:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12702,6,'                              ','Martes 14 de Junio del 11, a las 14:15:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12703,6,'                              ','Martes 14 de Junio del 11, a las 15:24:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12704,6,'                              ','Martes 28 de Junio del 11, a las 14:19:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12705,6,'                              ','Mircoles 29 de Junio del 11, a las 09:32:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12706,6,'                              ','Mircoles 29 de Junio del 11, a las 09:34:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12707,6,'                              ','Mircoles 29 de Junio del 11, a las 09:38:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12708,6,'                              ','Jueves 30 de Junio del 11, a las 15:44:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12709,6,'                              ','Viernes 29 de Julio del 11, a las 09:37:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12710,6,'                              ','Viernes 29 de Julio del 11, a las 09:38:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12711,6,'                              ','Viernes 29 de Julio del 11, a las 13:56:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12712,4,'                              ','Martes 2 de Agosto del 11, a las 15:53:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12713,4,'                              ','Martes 2 de Agosto del 11, a las 15:56:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12714,4,'                              ','Martes 2 de Agosto del 11, a las 15:59:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12715,2,'Bib Datos Propopios           ','Martes 2 de Agosto del 11, a las 16:00:36         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12716,2,'Bib Datos Propopios           ','Martes 2 de Agosto del 11, a las 16:02:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12717,4,'                              ','Martes 2 de Agosto del 11, a las 16:03:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12718,6,'                              ','Mircoles 3 de Agosto del 11, a las 13:36:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12719,6,'                              ','Mircoles 3 de Agosto del 11, a las 13:37:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12720,6,'                              ','Mircoles 3 de Agosto del 11, a las 13:39:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12721,6,'                              ','Mircoles 3 de Agosto del 11, a las 13:40:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12722,2,'Bib Datos Propopios           ','Mircoles 3 de Agosto del 11, a las 13:42:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12723,2,'Bib Datos Propopios           ','Mircoles 3 de Agosto del 11, a las 13:43:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12724,4,'                              ','Mircoles 3 de Agosto del 11, a las 13:54:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12725,3,'                              ','Mircoles 3 de Agosto del 11, a las 13:56:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12726,4,'                              ','Mircoles 3 de Agosto del 11, a las 13:57:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12727,4,'                              ','Mircoles 3 de Agosto del 11, a las 13:57:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12728,6,'                              ','Viernes 5 de Agosto del 11, a las 16:25:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12729,6,'                              ','Lunes 22 de Agosto del 11, a las 15:40:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12730,11,'                              ','Martes 23 de Agosto del 11, a las 10:51:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12731,6,'                              ','Martes 23 de Agosto del 11, a las 15:02:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12732,6,'                              ','Martes 23 de Agosto del 11, a las 15:04:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12733,6,'                              ','Martes 23 de Agosto del 11, a las 15:05:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12734,4,'                              ','Lunes 29 de Agosto del 11, a las 14:32:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12735,4,'                              ','Lunes 29 de Agosto del 11, a las 14:33:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12736,6,'                              ','Martes 30 de Agosto del 11, a las 10:20:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12737,6,'                              ','Martes 30 de Agosto del 11, a las 10:22:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12738,6,'                              ','Martes 30 de Agosto del 11, a las 10:36:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12739,6,'                              ','Martes 30 de Agosto del 11, a las 19:05:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12740,6,'                              ','Martes 30 de Agosto del 11, a las 19:13:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12741,6,'                              ','Mircoles 7 de Septiembre del 11, a las 14:10:05  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12742,6,'                              ','Mircoles 7 de Septiembre del 11, a las 14:17:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12743,6,'                              ','Martes 13 de Septiembre del 11, a las 16:23:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12744,6,'                              ','Martes 13 de Septiembre del 11, a las 16:27:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12745,6,'                              ','Martes 13 de Septiembre del 11, a las 16:28:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12746,2,'Bib Datos Propopios           ','Martes 20 de Septiembre del 11, a las 10:30:11    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12747,51,'Direccion                     ','Martes 20 de Septiembre del 11, a las 10:38:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12748,6,'                              ','Martes 20 de Septiembre del 11, a las 10:46:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12749,6,'                              ','Martes 20 de Septiembre del 11, a las 10:47:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12750,4,'                              ','Martes 20 de Septiembre del 11, a las 10:52:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12751,4,'                              ','Martes 20 de Septiembre del 11, a las 10:53:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12752,6,'                              ','Martes 20 de Septiembre del 11, a las 10:58:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12753,6,'                              ','Martes 20 de Septiembre del 11, a las 10:58:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12754,8,'                              ','Martes 20 de Septiembre del 11, a las 11:38:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12755,11,'                              ','Martes 20 de Septiembre del 11, a las 11:44:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12756,11,'                              ','Martes 20 de Septiembre del 11, a las 11:54:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12757,6,'                              ','Mircoles 21 de Septiembre del 11, a las 16:11:35 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12758,11,'                              ','Viernes 23 de Septiembre del 11, a las 10:06:38   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12759,53,'                              ','Viernes 23 de Septiembre del 11, a las 10:13:56   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12760,53,'                              ','Viernes 23 de Septiembre del 11, a las 10:26:17   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12761,11,'                              ','Viernes 23 de Septiembre del 11, a las 10:27:39   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12762,2,'Bib Datos Propopios           ','Viernes 23 de Septiembre del 11, a las 12:37:07   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12763,2,'Bib Datos Propopios           ','Viernes 23 de Septiembre del 11, a las 12:37:15   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12764,2,'Bib Datos Propopios           ','Viernes 23 de Septiembre del 11, a las 12:53:01   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12765,2,'Bib Datos Propopios           ','Viernes 23 de Septiembre del 11, a las 12:53:13   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12766,2,'Bib Datos Propopios           ','Viernes 23 de Septiembre del 11, a las 12:53:26   ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12767,6,'                              ','Viernes 23 de Septiembre del 11, a las 12:54:43   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12768,6,'                              ','Viernes 23 de Septiembre del 11, a las 12:54:57   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12769,11,'                              ','Martes 27 de Septiembre del 11, a las 11:03:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12770,11,'                              ','Martes 27 de Septiembre del 11, a las 11:05:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12771,6,'                              ','Martes 27 de Septiembre del 11, a las 11:46:38    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12772,6,'                              ','Martes 27 de Septiembre del 11, a las 11:47:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12773,11,'                              ','Martes 27 de Septiembre del 11, a las 12:13:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12774,11,'                              ','Martes 27 de Septiembre del 11, a las 12:13:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12775,11,'                              ','Martes 27 de Septiembre del 11, a las 12:17:06    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12776,11,'                              ','Martes 27 de Septiembre del 11, a las 12:19:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12777,11,'                              ','Martes 27 de Septiembre del 11, a las 12:22:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12778,11,'                              ','Martes 27 de Septiembre del 11, a las 12:23:29    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12779,6,'                              ','Martes 4 de Octubre del 11, a las 14:42:31        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12780,6,'                              ','Martes 4 de Octubre del 11, a las 15:15:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12781,6,'                              ','Mircoles 5 de Octubre del 11, a las 09:32:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12782,6,'                              ','Mircoles 5 de Octubre del 11, a las 09:42:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12783,6,'                              ','Mircoles 5 de Octubre del 11, a las 09:43:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12784,6,'                              ','Mircoles 5 de Octubre del 11, a las 09:44:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12785,6,'                              ','Mircoles 5 de Octubre del 11, a las 09:47:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12786,6,'                              ','Viernes 21 de Octubre del 11, a las 12:41:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12787,6,'                              ','Jueves 3 de Noviembre del 11, a las 11:36:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12788,53,'                              ','Martes 15 de Noviembre del 11, a las 09:46:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12789,53,'                              ','Martes 15 de Noviembre del 11, a las 09:50:18     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12790,6,'                              ','Martes 15 de Noviembre del 11, a las 09:52:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12791,11,'                              ','Martes 15 de Noviembre del 11, a las 09:54:03     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12792,6,'                              ','Mircoles 30 de Noviembre del 11, a las 09:54:38  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12793,6,'                              ','Mircoles 30 de Noviembre del 11, a las 09:57:40  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12794,6,'                              ','Mircoles 30 de Noviembre del 11, a las 09:58:45  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12795,6,'                              ','Mircoles 30 de Noviembre del 11, a las 10:00:31  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12796,6,'                              ','Mircoles 30 de Noviembre del 11, a las 10:00:46  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12797,6,'                              ','Mircoles 30 de Noviembre del 11, a las 10:01:58  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12798,6,'                              ','Mircoles 30 de Noviembre del 11, a las 10:03:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12799,6,'                              ','Viernes 9 de Diciembre del 11, a las 09:27:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12800,6,'                              ','Mircoles 11 de Enero del 12, a las 13:11:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12801,6,'                              ','Mircoles 11 de Enero del 12, a las 14:49:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12802,6,'                              ','Jueves 12 de Enero del 12, a las 10:14:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12803,6,'                              ','Jueves 12 de Enero del 12, a las 10:15:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12804,4,'                              ','Jueves 12 de Enero del 12, a las 10:18:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12805,4,'                              ','Jueves 12 de Enero del 12, a las 10:21:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12806,4,'                              ','Jueves 12 de Enero del 12, a las 10:23:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12807,4,'                              ','Jueves 12 de Enero del 12, a las 10:25:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12808,4,'                              ','Jueves 12 de Enero del 12, a las 10:28:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12809,4,'                              ','Jueves 12 de Enero del 12, a las 10:30:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12810,4,'                              ','Jueves 12 de Enero del 12, a las 10:33:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12811,4,'                              ','Jueves 12 de Enero del 12, a las 10:36:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12812,2,'Bib Datos Propopios           ','Jueves 12 de Enero del 12, a las 10:41:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12813,2,'Bib Datos Propopios           ','Jueves 12 de Enero del 12, a las 10:42:31         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12814,2,'Bib Datos Propopios           ','Jueves 12 de Enero del 12, a las 10:44:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12815,6,'                              ','Jueves 12 de Enero del 12, a las 11:30:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12816,6,'                              ','Jueves 12 de Enero del 12, a las 11:32:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12817,6,'                              ','Jueves 12 de Enero del 12, a las 11:40:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12818,6,'                              ','Jueves 12 de Enero del 12, a las 11:42:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12819,6,'                              ','Jueves 12 de Enero del 12, a las 11:44:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12820,6,'                              ','Jueves 12 de Enero del 12, a las 11:50:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12821,6,'                              ','Jueves 12 de Enero del 12, a las 11:54:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12822,6,'                              ','Lunes 16 de Enero del 12, a las 14:12:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12823,6,'                              ','Lunes 16 de Enero del 12, a las 14:23:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12824,6,'                              ','Lunes 16 de Enero del 12, a las 14:40:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12825,6,'                              ','Lunes 16 de Enero del 12, a las 14:41:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12826,6,'                              ','Lunes 16 de Enero del 12, a las 14:46:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12827,6,'                              ','Lunes 16 de Enero del 12, a las 14:48:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12828,6,'                              ','Lunes 16 de Enero del 12, a las 14:48:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12829,6,'                              ','Mircoles 18 de Enero del 12, a las 09:59:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12830,11,'                              ','Mircoles 18 de Enero del 12, a las 10:01:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12831,6,'                              ','Mircoles 18 de Enero del 12, a las 10:05:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12832,53,'                              ','Mircoles 18 de Enero del 12, a las 10:11:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12833,6,'                              ','Viernes 20 de Enero del 12, a las 10:21:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12834,6,'                              ','Viernes 20 de Enero del 12, a las 10:22:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12835,6,'                              ','Viernes 20 de Enero del 12, a las 10:23:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12836,6,'                              ','Viernes 20 de Enero del 12, a las 10:24:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12837,6,'                              ','Viernes 20 de Enero del 12, a las 10:25:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12838,6,'                              ','Viernes 20 de Enero del 12, a las 10:27:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12839,6,'                              ','Viernes 20 de Enero del 12, a las 10:28:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12840,6,'                              ','Viernes 20 de Enero del 12, a las 10:28:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12841,6,'                              ','Viernes 20 de Enero del 12, a las 10:30:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12842,6,'                              ','Viernes 20 de Enero del 12, a las 10:30:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12843,6,'                              ','Viernes 20 de Enero del 12, a las 10:31:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12844,6,'                              ','Viernes 20 de Enero del 12, a las 10:33:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12845,6,'                              ','Viernes 20 de Enero del 12, a las 11:12:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12846,11,'                              ','Viernes 20 de Enero del 12, a las 11:13:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12847,6,'                              ','Viernes 20 de Enero del 12, a las 15:53:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12848,6,'                              ','Lunes 23 de Enero del 12, a las 09:24:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12849,6,'                              ','Lunes 23 de Enero del 12, a las 09:25:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12850,6,'                              ','Lunes 23 de Enero del 12, a las 09:30:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12851,6,'                              ','Martes 24 de Enero del 12, a las 09:22:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12852,6,'                              ','Martes 24 de Enero del 12, a las 09:24:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12853,6,'                              ','Martes 24 de Enero del 12, a las 12:16:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12854,6,'                              ','Martes 24 de Enero del 12, a las 12:18:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12855,6,'                              ','Martes 24 de Enero del 12, a las 12:20:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12856,11,'                              ','Martes 24 de Enero del 12, a las 12:21:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12857,6,'                              ','Martes 24 de Enero del 12, a las 15:33:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12858,6,'                              ','Martes 24 de Enero del 12, a las 15:35:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12859,6,'                              ','Martes 24 de Enero del 12, a las 15:37:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12860,11,'                              ','Martes 24 de Enero del 12, a las 15:37:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12861,6,'                              ','Mircoles 25 de Enero del 12, a las 09:19:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12862,11,'                              ','Mircoles 25 de Enero del 12, a las 09:21:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12863,6,'                              ','Mircoles 25 de Enero del 12, a las 09:24:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12864,6,'                              ','Mircoles 25 de Enero del 12, a las 09:26:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12865,6,'                              ','Mircoles 25 de Enero del 12, a las 09:27:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12866,6,'                              ','Mircoles 25 de Enero del 12, a las 09:30:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12867,6,'                              ','Mircoles 25 de Enero del 12, a las 10:03:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12868,6,'                              ','Mircoles 25 de Enero del 12, a las 10:05:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12869,11,'                              ','Mircoles 25 de Enero del 12, a las 10:06:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12870,11,'                              ','Jueves 26 de Enero del 12, a las 15:48:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12871,53,'                              ','Viernes 27 de Enero del 12, a las 09:28:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12872,11,'                              ','Viernes 27 de Enero del 12, a las 09:48:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12873,11,'                              ','Viernes 27 de Enero del 12, a las 09:50:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12874,6,'                              ','Viernes 27 de Enero del 12, a las 09:53:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12875,6,'                              ','Viernes 27 de Enero del 12, a las 09:57:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12876,6,'                              ','Viernes 27 de Enero del 12, a las 16:52:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12877,6,'                              ','Viernes 27 de Enero del 12, a las 16:54:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12878,6,'                              ','Lunes 30 de Enero del 12, a las 16:44:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12879,4,'                              ','Lunes 30 de Enero del 12, a las 16:47:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12880,11,'                              ','Lunes 30 de Enero del 12, a las 16:48:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12881,6,'                              ','Martes 31 de Enero del 12, a las 09:30:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12882,6,'                              ','Martes 31 de Enero del 12, a las 09:33:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12883,6,'                              ','Martes 31 de Enero del 12, a las 09:33:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12884,6,'                              ','Martes 31 de Enero del 12, a las 09:35:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12885,6,'                              ','Martes 31 de Enero del 12, a las 09:36:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12886,6,'                              ','Martes 31 de Enero del 12, a las 09:38:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12887,6,'                              ','Martes 31 de Enero del 12, a las 09:41:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12888,6,'                              ','Mircoles 1 de Febrero del 12, a las 10:01:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12889,11,'                              ','Mircoles 1 de Febrero del 12, a las 10:04:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12890,6,'                              ','Mircoles 1 de Febrero del 12, a las 10:05:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12891,6,'                              ','Mircoles 1 de Febrero del 12, a las 10:09:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12892,6,'                              ','Mircoles 1 de Febrero del 12, a las 10:12:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12893,6,'                              ','Viernes 3 de Febrero del 12, a las 13:33:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12894,6,'                              ','Viernes 3 de Febrero del 12, a las 13:35:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12895,6,'                              ','Viernes 3 de Febrero del 12, a las 14:31:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12896,6,'                              ','Viernes 3 de Febrero del 12, a las 15:09:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12897,6,'                              ','Martes 7 de Febrero del 12, a las 11:05:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12898,6,'                              ','Martes 7 de Febrero del 12, a las 11:09:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12899,11,'                              ','Martes 7 de Febrero del 12, a las 11:09:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12900,6,'                              ','Martes 7 de Febrero del 12, a las 12:42:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12901,11,'                              ','Martes 7 de Febrero del 12, a las 12:44:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12902,6,'                              ','Martes 7 de Febrero del 12, a las 12:45:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12903,11,'                              ','Martes 7 de Febrero del 12, a las 12:49:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12904,6,'                              ','Mircoles 8 de Febrero del 12, a las 09:59:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12905,11,'                              ','Mircoles 8 de Febrero del 12, a las 10:03:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12906,11,'                              ','Mircoles 8 de Febrero del 12, a las 10:03:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12907,6,'                              ','Mircoles 8 de Febrero del 12, a las 10:08:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12908,11,'                              ','Mircoles 8 de Febrero del 12, a las 10:10:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12909,6,'                              ','Mircoles 8 de Febrero del 12, a las 16:58:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12910,6,'                              ','Mircoles 8 de Febrero del 12, a las 16:59:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12911,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:00:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12912,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:03:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12913,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:04:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12914,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:05:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12915,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:07:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12916,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:08:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12917,6,'                              ','Mircoles 8 de Febrero del 12, a las 17:10:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12918,6,'                              ','Jueves 9 de Febrero del 12, a las 09:49:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12919,6,'                              ','Jueves 9 de Febrero del 12, a las 13:07:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12920,6,'                              ','Jueves 9 de Febrero del 12, a las 13:09:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12921,6,'                              ','Jueves 9 de Febrero del 12, a las 13:43:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12922,6,'                              ','Jueves 9 de Febrero del 12, a las 13:44:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12923,6,'                              ','Jueves 9 de Febrero del 12, a las 16:59:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12924,6,'                              ','Viernes 10 de Febrero del 12, a las 13:28:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12925,6,'                              ','Viernes 10 de Febrero del 12, a las 13:30:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12926,6,'                              ','Martes 14 de Febrero del 12, a las 10:31:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12927,6,'                              ','Martes 14 de Febrero del 12, a las 10:34:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12928,6,'                              ','Martes 14 de Febrero del 12, a las 10:36:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12929,6,'                              ','Martes 14 de Febrero del 12, a las 15:44:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12930,6,'                              ','Mircoles 15 de Febrero del 12, a las 11:03:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12931,6,'                              ','Mircoles 15 de Febrero del 12, a las 11:08:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12932,6,'                              ','Mircoles 15 de Febrero del 12, a las 16:14:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12933,6,'                              ','Mircoles 15 de Febrero del 12, a las 16:14:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12934,6,'                              ','Mircoles 15 de Febrero del 12, a las 16:14:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12935,6,'                              ','Jueves 16 de Febrero del 12, a las 09:54:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12936,11,'                              ','Jueves 16 de Febrero del 12, a las 09:55:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12937,6,'                              ','Jueves 16 de Febrero del 12, a las 13:12:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12938,6,'                              ','Lunes 20 de Febrero del 12, a las 11:33:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12939,6,'                              ','Lunes 20 de Febrero del 12, a las 11:35:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12940,6,'                              ','Lunes 20 de Febrero del 12, a las 11:39:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12941,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:39:08    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12942,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:43:09    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12943,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:43:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12944,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:46:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12945,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:46:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12946,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:52:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12947,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:54:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12948,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:56:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12949,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:58:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12950,6,'                              ','Mircoles 22 de Febrero del 12, a las 09:59:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12951,6,'                              ','Mircoles 22 de Febrero del 12, a las 10:31:51    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12952,6,'                              ','Mircoles 22 de Febrero del 12, a las 10:38:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12953,6,'                              ','Lunes 27 de Febrero del 12, a las 16:52:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12954,6,'                              ','Mircoles 29 de Febrero del 12, a las 09:46:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12955,6,'                              ','Mircoles 29 de Febrero del 12, a las 09:46:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12956,11,'                              ','Jueves 1 de Marzo del 12, a las 16:40:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12957,6,'                              ','Mircoles 7 de Marzo del 12, a las 11:12:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12958,6,'                              ','Mircoles 7 de Marzo del 12, a las 11:12:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12959,53,'                              ','Mircoles 7 de Marzo del 12, a las 11:21:05       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12960,6,'                              ','Mircoles 7 de Marzo del 12, a las 11:27:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12961,53,'                              ','Mircoles 7 de Marzo del 12, a las 11:28:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12962,51,'Direccion                     ','Mircoles 7 de Marzo del 12, a las 11:31:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12963,51,'Direccion                     ','Mircoles 7 de Marzo del 12, a las 11:31:20       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12964,51,'Direccion                     ','Mircoles 7 de Marzo del 12, a las 11:33:20       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12965,51,'Direccion                     ','Mircoles 7 de Marzo del 12, a las 14:17:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12966,53,'                              ','Mircoles 7 de Marzo del 12, a las 14:18:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12967,6,'                              ','Mircoles 7 de Marzo del 12, a las 14:23:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12968,6,'                              ','Mircoles 7 de Marzo del 12, a las 14:24:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12969,11,'                              ','Mircoles 7 de Marzo del 12, a las 14:25:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12970,6,'                              ','Lunes 12 de Marzo del 12, a las 14:40:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12971,6,'                              ','Lunes 12 de Marzo del 12, a las 14:43:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12972,6,'                              ','Lunes 12 de Marzo del 12, a las 14:44:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12973,6,'                              ','Martes 13 de Marzo del 12, a las 12:51:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12974,6,'                              ','Mircoles 14 de Marzo del 12, a las 10:42:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12975,6,'                              ','Mircoles 14 de Marzo del 12, a las 10:50:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12976,6,'                              ','Viernes 16 de Marzo del 12, a las 10:20:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12977,6,'                              ','Mircoles 21 de Marzo del 12, a las 14:41:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12978,6,'                              ','Mircoles 21 de Marzo del 12, a las 14:43:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12979,6,'                              ','Mircoles 21 de Marzo del 12, a las 14:45:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12980,11,'                              ','Martes 27 de Marzo del 12, a las 14:47:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12981,11,'                              ','Mircoles 28 de Marzo del 12, a las 11:23:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12982,6,'                              ','Mircoles 28 de Marzo del 12, a las 13:16:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12983,6,'                              ','Mircoles 28 de Marzo del 12, a las 13:46:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12984,6,'                              ','Mircoles 28 de Marzo del 12, a las 13:47:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12985,6,'                              ','Viernes 30 de Marzo del 12, a las 11:02:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12986,6,'                              ','Viernes 30 de Marzo del 12, a las 13:40:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12987,6,'                              ','Viernes 30 de Marzo del 12, a las 13:42:29        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12988,6,'                              ','Viernes 30 de Marzo del 12, a las 13:43:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12989,53,'                              ','Viernes 30 de Marzo del 12, a las 13:45:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12990,53,'                              ','Viernes 30 de Marzo del 12, a las 13:46:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12991,53,'                              ','Viernes 30 de Marzo del 12, a las 13:47:40        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12992,11,'                              ','Viernes 30 de Marzo del 12, a las 13:54:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12993,11,'                              ','Viernes 30 de Marzo del 12, a las 13:55:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12994,8,'                              ','Viernes 30 de Marzo del 12, a las 14:03:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12995,53,'                              ','Viernes 30 de Marzo del 12, a las 14:36:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12996,11,'                              ','Viernes 30 de Marzo del 12, a las 14:38:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12997,53,'                              ','Viernes 30 de Marzo del 12, a las 14:44:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12998,11,'                              ','Viernes 30 de Marzo del 12, a las 14:45:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (12999,6,'                              ','Martes 10 de Abril del 12, a las 15:21:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13000,6,'                              ','Jueves 12 de Abril del 12, a las 13:08:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13001,6,'                              ','Jueves 12 de Abril del 12, a las 13:37:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13002,6,'                              ','Jueves 12 de Abril del 12, a las 13:41:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13003,6,'                              ','Lunes 16 de Abril del 12, a las 14:52:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13004,6,'                              ','Lunes 16 de Abril del 12, a las 15:14:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13005,6,'                              ','Lunes 16 de Abril del 12, a las 15:19:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13006,6,'                              ','Lunes 16 de Abril del 12, a las 15:32:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13007,6,'                              ','Lunes 16 de Abril del 12, a las 15:33:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13008,6,'                              ','Lunes 16 de Abril del 12, a las 15:40:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13009,6,'                              ','Lunes 16 de Abril del 12, a las 15:46:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13010,53,'                              ','Lunes 16 de Abril del 12, a las 15:49:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13011,11,'                              ','Lunes 16 de Abril del 12, a las 15:52:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13012,8,'                              ','Lunes 16 de Abril del 12, a las 16:00:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13013,8,'                              ','Lunes 16 de Abril del 12, a las 16:01:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13014,6,'                              ','Lunes 16 de Abril del 12, a las 16:17:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13015,6,'                              ','Lunes 16 de Abril del 12, a las 16:21:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13016,2,'Bib Datos Propopios           ','Lunes 16 de Abril del 12, a las 16:27:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13017,2,'Bib Datos Propopios           ','Lunes 16 de Abril del 12, a las 16:28:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13018,4,'                              ','Lunes 16 de Abril del 12, a las 16:30:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13019,2,'Bib Datos Propopios           ','Lunes 16 de Abril del 12, a las 16:34:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13020,6,'                              ','Lunes 16 de Abril del 12, a las 16:38:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13021,4,'                              ','Lunes 16 de Abril del 12, a las 16:43:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13022,11,'                              ','Lunes 16 de Abril del 12, a las 16:44:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13023,4,'                              ','Lunes 16 de Abril del 12, a las 16:52:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13024,6,'                              ','Mircoles 18 de Abril del 12, a las 10:40:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13025,6,'                              ','Mircoles 18 de Abril del 12, a las 10:54:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13026,6,'                              ','Mircoles 18 de Abril del 12, a las 16:34:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13027,6,'                              ','Mircoles 18 de Abril del 12, a las 16:38:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13028,6,'                              ','Mircoles 18 de Abril del 12, a las 16:39:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13029,6,'                              ','Mircoles 18 de Abril del 12, a las 16:40:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13030,6,'                              ','Mircoles 18 de Abril del 12, a las 16:41:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13031,6,'                              ','Mircoles 18 de Abril del 12, a las 16:43:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13032,53,'                              ','Mircoles 18 de Abril del 12, a las 16:45:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13033,6,'                              ','Mircoles 18 de Abril del 12, a las 16:48:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13034,6,'                              ','Mircoles 18 de Abril del 12, a las 16:53:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13035,6,'                              ','Viernes 20 de Abril del 12, a las 10:17:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13036,6,'                              ','Viernes 20 de Abril del 12, a las 10:24:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13037,6,'                              ','Viernes 20 de Abril del 12, a las 10:35:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13038,6,'                              ','Viernes 20 de Abril del 12, a las 11:01:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13039,6,'                              ','Viernes 20 de Abril del 12, a las 11:12:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13040,6,'                              ','Viernes 20 de Abril del 12, a las 11:13:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13041,6,'                              ','Viernes 20 de Abril del 12, a las 11:17:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13042,6,'                              ','Viernes 20 de Abril del 12, a las 11:23:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13043,6,'                              ','Viernes 20 de Abril del 12, a las 11:25:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13044,6,'                              ','Viernes 20 de Abril del 12, a las 11:25:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13045,6,'                              ','Viernes 20 de Abril del 12, a las 11:27:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13046,6,'                              ','Viernes 20 de Abril del 12, a las 11:38:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13047,6,'                              ','Viernes 20 de Abril del 12, a las 11:40:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13048,6,'                              ','Viernes 20 de Abril del 12, a las 11:44:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13049,6,'                              ','Viernes 20 de Abril del 12, a las 11:47:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13050,6,'                              ','Viernes 20 de Abril del 12, a las 11:55:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13051,6,'                              ','Viernes 20 de Abril del 12, a las 12:03:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13052,6,'                              ','Viernes 20 de Abril del 12, a las 12:11:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13053,6,'                              ','Viernes 20 de Abril del 12, a las 12:15:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13054,6,'                              ','Viernes 20 de Abril del 12, a las 12:17:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13055,6,'                              ','Viernes 20 de Abril del 12, a las 12:19:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13056,6,'                              ','Viernes 20 de Abril del 12, a las 12:44:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13057,6,'                              ','Viernes 20 de Abril del 12, a las 12:53:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13058,6,'                              ','Viernes 20 de Abril del 12, a las 12:55:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13059,6,'                              ','Viernes 20 de Abril del 12, a las 12:56:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13060,6,'                              ','Viernes 20 de Abril del 12, a las 13:01:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13061,6,'                              ','Viernes 20 de Abril del 12, a las 13:04:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13062,6,'                              ','Viernes 20 de Abril del 12, a las 13:06:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13063,6,'                              ','Martes 24 de Abril del 12, a las 10:34:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13064,6,'                              ','Martes 24 de Abril del 12, a las 10:37:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13065,6,'                              ','Martes 24 de Abril del 12, a las 10:41:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13066,6,'                              ','Martes 24 de Abril del 12, a las 10:43:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13067,6,'                              ','Martes 24 de Abril del 12, a las 10:44:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13068,6,'                              ','Martes 24 de Abril del 12, a las 10:50:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13069,6,'                              ','Martes 24 de Abril del 12, a las 10:53:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13070,6,'                              ','Martes 24 de Abril del 12, a las 10:56:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13071,6,'                              ','Martes 24 de Abril del 12, a las 10:57:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13072,6,'                              ','Martes 24 de Abril del 12, a las 11:02:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13073,6,'                              ','Martes 24 de Abril del 12, a las 11:02:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13074,6,'                              ','Martes 24 de Abril del 12, a las 11:06:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13075,6,'                              ','Martes 24 de Abril del 12, a las 11:18:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13076,51,'Direccion                     ','Martes 24 de Abril del 12, a las 11:20:11         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13077,6,'                              ','Martes 24 de Abril del 12, a las 11:25:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13078,6,'                              ','Martes 24 de Abril del 12, a las 11:27:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13079,6,'                              ','Martes 24 de Abril del 12, a las 11:31:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13080,6,'                              ','Martes 24 de Abril del 12, a las 11:37:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13081,6,'                              ','Martes 24 de Abril del 12, a las 11:38:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13082,6,'                              ','Martes 24 de Abril del 12, a las 11:41:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13083,6,'                              ','Martes 24 de Abril del 12, a las 11:44:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13084,6,'                              ','Martes 24 de Abril del 12, a las 11:47:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13085,6,'                              ','Martes 24 de Abril del 12, a las 11:51:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13086,6,'                              ','Martes 24 de Abril del 12, a las 11:59:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13087,6,'                              ','Martes 24 de Abril del 12, a las 12:04:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13088,6,'                              ','Martes 24 de Abril del 12, a las 12:05:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13089,6,'                              ','Martes 24 de Abril del 12, a las 12:05:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13090,6,'                              ','Martes 24 de Abril del 12, a las 12:09:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13091,6,'                              ','Martes 24 de Abril del 12, a las 12:11:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13092,6,'                              ','Martes 24 de Abril del 12, a las 12:12:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13093,6,'                              ','Martes 24 de Abril del 12, a las 12:13:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13094,6,'                              ','Martes 24 de Abril del 12, a las 12:15:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13095,6,'                              ','Martes 24 de Abril del 12, a las 12:18:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13096,6,'                              ','Martes 24 de Abril del 12, a las 12:18:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13097,6,'                              ','Martes 24 de Abril del 12, a las 12:19:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13098,6,'                              ','Martes 24 de Abril del 12, a las 12:20:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13099,6,'                              ','Martes 24 de Abril del 12, a las 12:23:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13100,6,'                              ','Martes 24 de Abril del 12, a las 12:24:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13101,6,'                              ','Martes 24 de Abril del 12, a las 12:26:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13102,6,'                              ','Martes 24 de Abril del 12, a las 12:26:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13103,6,'                              ','Martes 24 de Abril del 12, a las 12:28:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13104,6,'                              ','Martes 24 de Abril del 12, a las 12:31:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13105,6,'                              ','Martes 24 de Abril del 12, a las 12:32:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13106,6,'                              ','Martes 24 de Abril del 12, a las 12:53:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13107,6,'                              ','Martes 24 de Abril del 12, a las 12:55:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13108,6,'                              ','Martes 24 de Abril del 12, a las 12:57:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13109,6,'                              ','Martes 24 de Abril del 12, a las 13:00:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13110,6,'                              ','Martes 24 de Abril del 12, a las 13:01:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13111,6,'                              ','Martes 24 de Abril del 12, a las 13:03:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13112,6,'                              ','Martes 24 de Abril del 12, a las 13:06:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13113,6,'                              ','Martes 24 de Abril del 12, a las 13:07:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13114,6,'                              ','Martes 24 de Abril del 12, a las 13:11:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13115,6,'                              ','Martes 24 de Abril del 12, a las 13:13:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13116,6,'                              ','Martes 24 de Abril del 12, a las 13:16:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13117,6,'                              ','Martes 24 de Abril del 12, a las 13:18:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13118,6,'                              ','Martes 24 de Abril del 12, a las 13:20:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13119,6,'                              ','Martes 24 de Abril del 12, a las 13:21:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13120,6,'                              ','Martes 24 de Abril del 12, a las 13:23:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13121,6,'                              ','Martes 24 de Abril del 12, a las 13:23:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13122,6,'                              ','Martes 24 de Abril del 12, a las 13:25:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13123,6,'                              ','Martes 24 de Abril del 12, a las 13:28:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13124,6,'                              ','Martes 24 de Abril del 12, a las 13:29:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13125,6,'                              ','Martes 24 de Abril del 12, a las 13:33:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13126,6,'                              ','Martes 24 de Abril del 12, a las 13:46:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13127,6,'                              ','Martes 24 de Abril del 12, a las 13:47:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13128,6,'                              ','Martes 24 de Abril del 12, a las 13:50:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13129,6,'                              ','Martes 24 de Abril del 12, a las 13:52:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13130,6,'                              ','Martes 24 de Abril del 12, a las 13:55:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13131,6,'                              ','Martes 24 de Abril del 12, a las 13:59:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13132,6,'                              ','Martes 24 de Abril del 12, a las 14:00:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13133,6,'                              ','Martes 24 de Abril del 12, a las 14:03:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13134,6,'                              ','Martes 24 de Abril del 12, a las 14:09:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13135,6,'                              ','Martes 24 de Abril del 12, a las 14:10:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13136,6,'                              ','Martes 24 de Abril del 12, a las 14:13:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13137,6,'                              ','Martes 24 de Abril del 12, a las 14:14:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13138,6,'                              ','Martes 24 de Abril del 12, a las 14:16:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13139,6,'                              ','Martes 24 de Abril del 12, a las 14:20:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13140,6,'                              ','Martes 24 de Abril del 12, a las 14:26:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13141,6,'                              ','Martes 24 de Abril del 12, a las 14:27:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13142,6,'                              ','Martes 24 de Abril del 12, a las 14:29:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13143,6,'                              ','Martes 24 de Abril del 12, a las 14:30:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13144,6,'                              ','Martes 24 de Abril del 12, a las 14:33:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13145,6,'                              ','Martes 24 de Abril del 12, a las 14:35:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13146,6,'                              ','Martes 24 de Abril del 12, a las 14:37:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13147,6,'                              ','Martes 24 de Abril del 12, a las 14:38:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13148,6,'                              ','Martes 24 de Abril del 12, a las 14:41:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13149,6,'                              ','Martes 24 de Abril del 12, a las 14:42:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13150,6,'                              ','Martes 24 de Abril del 12, a las 14:44:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13151,6,'                              ','Martes 24 de Abril del 12, a las 14:45:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13152,6,'                              ','Martes 24 de Abril del 12, a las 14:47:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13153,6,'                              ','Martes 24 de Abril del 12, a las 14:50:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13154,6,'                              ','Martes 24 de Abril del 12, a las 14:53:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13155,6,'                              ','Martes 24 de Abril del 12, a las 14:58:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13156,6,'                              ','Martes 24 de Abril del 12, a las 15:01:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13157,6,'                              ','Martes 24 de Abril del 12, a las 15:22:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13158,6,'                              ','Martes 24 de Abril del 12, a las 15:25:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13159,6,'                              ','Martes 24 de Abril del 12, a las 15:28:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13160,6,'                              ','Martes 24 de Abril del 12, a las 15:39:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13161,6,'                              ','Martes 24 de Abril del 12, a las 15:40:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13162,6,'                              ','Martes 24 de Abril del 12, a las 15:41:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13163,6,'                              ','Martes 24 de Abril del 12, a las 15:43:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13164,6,'                              ','Martes 24 de Abril del 12, a las 15:45:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13165,6,'                              ','Mircoles 25 de Abril del 12, a las 10:57:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13166,6,'                              ','Mircoles 25 de Abril del 12, a las 11:00:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13167,6,'                              ','Mircoles 25 de Abril del 12, a las 11:01:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13168,6,'                              ','Mircoles 25 de Abril del 12, a las 11:05:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13169,6,'                              ','Mircoles 25 de Abril del 12, a las 11:39:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13170,6,'                              ','Mircoles 25 de Abril del 12, a las 11:45:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13171,6,'                              ','Jueves 26 de Abril del 12, a las 10:32:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13172,6,'                              ','Jueves 26 de Abril del 12, a las 10:37:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13173,6,'                              ','Jueves 26 de Abril del 12, a las 10:40:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13174,6,'                              ','Jueves 26 de Abril del 12, a las 10:47:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13175,6,'                              ','Jueves 26 de Abril del 12, a las 10:51:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13176,6,'                              ','Jueves 26 de Abril del 12, a las 10:56:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13177,6,'                              ','Jueves 26 de Abril del 12, a las 11:16:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13178,6,'                              ','Jueves 26 de Abril del 12, a las 11:17:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13179,6,'                              ','Jueves 26 de Abril del 12, a las 11:20:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13180,6,'                              ','Jueves 26 de Abril del 12, a las 11:22:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13181,6,'                              ','Jueves 26 de Abril del 12, a las 11:24:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13182,6,'                              ','Jueves 26 de Abril del 12, a las 11:27:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13183,6,'                              ','Jueves 26 de Abril del 12, a las 11:28:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13184,6,'                              ','Jueves 26 de Abril del 12, a las 11:29:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13185,6,'                              ','Jueves 26 de Abril del 12, a las 11:39:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13186,6,'                              ','Jueves 26 de Abril del 12, a las 11:41:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13187,6,'                              ','Jueves 26 de Abril del 12, a las 11:44:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13188,6,'                              ','Jueves 26 de Abril del 12, a las 11:48:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13189,6,'                              ','Jueves 26 de Abril del 12, a las 11:51:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13190,6,'                              ','Jueves 26 de Abril del 12, a las 11:55:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13191,6,'                              ','Jueves 26 de Abril del 12, a las 11:57:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13192,51,'Direccion                     ','Jueves 26 de Abril del 12, a las 11:59:23         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13193,6,'                              ','Jueves 26 de Abril del 12, a las 12:01:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13194,6,'                              ','Jueves 26 de Abril del 12, a las 12:03:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13195,6,'                              ','Jueves 26 de Abril del 12, a las 12:11:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13196,6,'                              ','Viernes 27 de Abril del 12, a las 16:40:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13197,6,'                              ','Viernes 27 de Abril del 12, a las 16:41:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13198,6,'                              ','Lunes 30 de Abril del 12, a las 15:55:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13199,6,'                              ','Lunes 30 de Abril del 12, a las 15:56:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13200,6,'                              ','Mircoles 2 de Mayo del 12, a las 13:21:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13201,6,'                              ','Mircoles 2 de Mayo del 12, a las 13:22:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13202,6,'                              ','Mircoles 2 de Mayo del 12, a las 13:48:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13203,6,'                              ','Mircoles 2 de Mayo del 12, a las 14:53:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13204,6,'                              ','Mircoles 2 de Mayo del 12, a las 15:02:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13205,6,'                              ','Mircoles 2 de Mayo del 12, a las 15:03:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13206,6,'                              ','Jueves 3 de Mayo del 12, a las 10:15:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13207,6,'                              ','Jueves 3 de Mayo del 12, a las 10:18:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13208,6,'                              ','Jueves 3 de Mayo del 12, a las 10:32:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13209,6,'                              ','Jueves 3 de Mayo del 12, a las 10:43:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13210,6,'                              ','Jueves 3 de Mayo del 12, a las 10:55:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13211,6,'                              ','Jueves 3 de Mayo del 12, a las 11:01:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13212,6,'                              ','Jueves 3 de Mayo del 12, a las 11:14:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13213,6,'                              ','Jueves 3 de Mayo del 12, a las 11:19:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13214,6,'                              ','Jueves 3 de Mayo del 12, a las 11:24:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13215,6,'                              ','Jueves 3 de Mayo del 12, a las 11:32:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13216,6,'                              ','Jueves 3 de Mayo del 12, a las 11:39:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13217,6,'                              ','Jueves 3 de Mayo del 12, a las 11:43:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13218,6,'                              ','Jueves 3 de Mayo del 12, a las 11:44:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13219,6,'                              ','Viernes 4 de Mayo del 12, a las 10:52:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13220,6,'                              ','Viernes 4 de Mayo del 12, a las 10:54:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13221,6,'                              ','Viernes 4 de Mayo del 12, a las 10:57:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13222,6,'                              ','Viernes 4 de Mayo del 12, a las 11:01:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13223,6,'                              ','Viernes 4 de Mayo del 12, a las 11:06:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13224,6,'                              ','Viernes 4 de Mayo del 12, a las 11:10:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13225,6,'                              ','Viernes 4 de Mayo del 12, a las 11:15:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13226,6,'                              ','Viernes 4 de Mayo del 12, a las 11:17:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13227,6,'                              ','Viernes 4 de Mayo del 12, a las 11:21:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13228,6,'                              ','Viernes 4 de Mayo del 12, a las 11:23:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13229,6,'                              ','Viernes 4 de Mayo del 12, a las 11:24:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13230,6,'                              ','Viernes 4 de Mayo del 12, a las 11:26:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13231,6,'                              ','Viernes 4 de Mayo del 12, a las 11:27:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13232,6,'                              ','Viernes 4 de Mayo del 12, a las 11:28:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13233,6,'                              ','Viernes 4 de Mayo del 12, a las 11:29:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13234,6,'                              ','Viernes 4 de Mayo del 12, a las 11:31:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13235,6,'                              ','Viernes 4 de Mayo del 12, a las 11:33:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13236,6,'                              ','Viernes 4 de Mayo del 12, a las 11:34:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13237,6,'                              ','Viernes 4 de Mayo del 12, a las 11:37:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13238,6,'                              ','Viernes 4 de Mayo del 12, a las 11:38:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13239,6,'                              ','Viernes 4 de Mayo del 12, a las 11:39:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13240,6,'                              ','Viernes 4 de Mayo del 12, a las 12:49:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13241,6,'                              ','Viernes 4 de Mayo del 12, a las 13:05:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13242,6,'                              ','Viernes 4 de Mayo del 12, a las 13:06:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13243,6,'                              ','Viernes 4 de Mayo del 12, a las 13:08:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13244,6,'                              ','Viernes 4 de Mayo del 12, a las 13:10:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13245,6,'                              ','Viernes 4 de Mayo del 12, a las 13:14:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13246,6,'                              ','Viernes 4 de Mayo del 12, a las 13:17:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13247,6,'                              ','Viernes 4 de Mayo del 12, a las 13:27:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13248,6,'                              ','Viernes 4 de Mayo del 12, a las 13:30:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13249,6,'                              ','Viernes 4 de Mayo del 12, a las 13:40:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13250,6,'                              ','Viernes 4 de Mayo del 12, a las 13:45:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13251,6,'                              ','Viernes 4 de Mayo del 12, a las 13:46:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13252,6,'                              ','Viernes 4 de Mayo del 12, a las 13:47:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13253,6,'                              ','Mircoles 9 de Mayo del 12, a las 16:58:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13254,6,'                              ','Mircoles 9 de Mayo del 12, a las 16:59:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13255,6,'                              ','Mircoles 9 de Mayo del 12, a las 16:59:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13256,6,'                              ','Jueves 17 de Mayo del 12, a las 10:24:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13257,6,'                              ','Jueves 17 de Mayo del 12, a las 11:12:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13258,6,'                              ','Jueves 17 de Mayo del 12, a las 11:12:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13259,6,'                              ','Mircoles 23 de Mayo del 12, a las 09:36:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13260,6,'                              ','Lunes 28 de Mayo del 12, a las 16:35:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13261,11,'                              ','Lunes 28 de Mayo del 12, a las 16:37:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13262,11,'                              ','Lunes 28 de Mayo del 12, a las 16:39:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13263,11,'                              ','Lunes 28 de Mayo del 12, a las 16:39:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13264,11,'                              ','Lunes 28 de Mayo del 12, a las 16:47:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13265,6,'                              ','Martes 29 de Mayo del 12, a las 12:32:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13266,6,'                              ','Martes 29 de Mayo del 12, a las 12:41:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13267,6,'                              ','Martes 29 de Mayo del 12, a las 12:47:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13268,6,'                              ','Martes 29 de Mayo del 12, a las 12:49:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13269,6,'                              ','Martes 29 de Mayo del 12, a las 13:22:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13270,6,'                              ','Martes 29 de Mayo del 12, a las 13:36:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13271,6,'                              ','Martes 29 de Mayo del 12, a las 13:39:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13272,6,'                              ','Martes 29 de Mayo del 12, a las 14:05:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13273,6,'                              ','Martes 29 de Mayo del 12, a las 14:06:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13274,6,'                              ','Martes 29 de Mayo del 12, a las 14:07:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13275,6,'                              ','Martes 29 de Mayo del 12, a las 14:16:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13276,6,'                              ','Martes 29 de Mayo del 12, a las 14:18:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13277,6,'                              ','Martes 29 de Mayo del 12, a las 14:38:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13278,6,'                              ','Martes 29 de Mayo del 12, a las 14:59:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13279,6,'                              ','Martes 29 de Mayo del 12, a las 15:00:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13280,6,'                              ','Martes 29 de Mayo del 12, a las 15:07:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13281,6,'                              ','Martes 29 de Mayo del 12, a las 15:07:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13282,6,'                              ','Martes 29 de Mayo del 12, a las 15:08:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13283,11,'                              ','Martes 29 de Mayo del 12, a las 15:10:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13284,11,'                              ','Martes 29 de Mayo del 12, a las 15:11:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13285,11,'                              ','Martes 29 de Mayo del 12, a las 15:18:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13286,11,'                              ','Martes 29 de Mayo del 12, a las 15:20:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13287,11,'                              ','Martes 29 de Mayo del 12, a las 15:21:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13288,11,'                              ','Martes 29 de Mayo del 12, a las 15:22:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13289,8,'                              ','Martes 29 de Mayo del 12, a las 15:23:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13290,11,'                              ','Martes 29 de Mayo del 12, a las 15:26:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13291,11,'                              ','Martes 29 de Mayo del 12, a las 15:27:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13292,6,'                              ','Martes 29 de Mayo del 12, a las 15:45:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13293,11,'                              ','Martes 29 de Mayo del 12, a las 15:58:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13294,11,'                              ','Martes 29 de Mayo del 12, a las 15:59:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13295,6,'                              ','Martes 29 de Mayo del 12, a las 16:11:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13296,6,'                              ','Martes 29 de Mayo del 12, a las 16:12:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13297,6,'                              ','Martes 29 de Mayo del 12, a las 16:20:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13298,6,'                              ','Mircoles 30 de Mayo del 12, a las 16:08:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13299,6,'                              ','Mircoles 30 de Mayo del 12, a las 16:10:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13300,53,'                              ','Mircoles 30 de Mayo del 12, a las 16:11:48       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13301,11,'                              ','Mircoles 30 de Mayo del 12, a las 16:18:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13302,11,'                              ','Mircoles 30 de Mayo del 12, a las 16:20:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13303,11,'                              ','Mircoles 30 de Mayo del 12, a las 16:22:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13304,8,'                              ','Mircoles 30 de Mayo del 12, a las 16:24:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13305,8,'                              ','Jueves 31 de Mayo del 12, a las 10:01:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13306,11,'                              ','Jueves 31 de Mayo del 12, a las 11:11:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13307,11,'                              ','Jueves 31 de Mayo del 12, a las 11:13:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13308,11,'                              ','Jueves 31 de Mayo del 12, a las 11:22:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13309,11,'                              ','Jueves 31 de Mayo del 12, a las 11:28:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13310,6,'                              ','Lunes 4 de Junio del 12, a las 11:45:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13311,6,'                              ','Lunes 4 de Junio del 12, a las 11:45:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13312,6,'                              ','Lunes 4 de Junio del 12, a las 11:46:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13313,11,'                              ','Lunes 4 de Junio del 12, a las 11:51:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13314,6,'                              ','Lunes 4 de Junio del 12, a las 11:54:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13315,6,'                              ','Lunes 4 de Junio del 12, a las 11:58:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13316,11,'                              ','Lunes 4 de Junio del 12, a las 11:58:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13317,6,'                              ','Lunes 4 de Junio del 12, a las 12:00:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13318,2,'Bib Datos Propopios           ','Lunes 4 de Junio del 12, a las 13:19:16           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13319,2,'Bib Datos Propopios           ','Lunes 4 de Junio del 12, a las 13:21:27           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13320,4,'                              ','Lunes 4 de Junio del 12, a las 13:24:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13321,4,'                              ','Lunes 4 de Junio del 12, a las 13:25:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13322,4,'                              ','Lunes 4 de Junio del 12, a las 13:27:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13323,4,'                              ','Lunes 4 de Junio del 12, a las 13:28:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13324,4,'                              ','Lunes 4 de Junio del 12, a las 13:29:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13325,4,'                              ','Lunes 4 de Junio del 12, a las 13:32:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13326,4,'                              ','Lunes 4 de Junio del 12, a las 13:34:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13327,6,'                              ','Martes 5 de Junio del 12, a las 11:26:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13328,6,'                              ','Martes 5 de Junio del 12, a las 11:27:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13329,6,'                              ','Martes 5 de Junio del 12, a las 11:31:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13330,6,'                              ','Martes 5 de Junio del 12, a las 11:35:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13331,6,'                              ','Mircoles 6 de Junio del 12, a las 13:55:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13332,6,'                              ','Mircoles 6 de Junio del 12, a las 13:57:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13333,6,'                              ','Mircoles 6 de Junio del 12, a las 13:58:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13334,6,'                              ','Mircoles 6 de Junio del 12, a las 13:59:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13335,6,'                              ','Jueves 7 de Junio del 12, a las 12:42:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13336,11,'                              ','Jueves 7 de Junio del 12, a las 13:16:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13337,6,'                              ','Viernes 8 de Junio del 12, a las 09:46:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13338,6,'                              ','Viernes 8 de Junio del 12, a las 09:54:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13339,11,'                              ','Viernes 8 de Junio del 12, a las 09:59:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13340,11,'                              ','Viernes 8 de Junio del 12, a las 10:00:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13341,6,'                              ','Viernes 8 de Junio del 12, a las 11:16:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13342,11,'                              ','Viernes 8 de Junio del 12, a las 11:20:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13343,8,'                              ','Viernes 8 de Junio del 12, a las 11:23:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13344,8,'                              ','Viernes 8 de Junio del 12, a las 11:25:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13345,8,'                              ','Viernes 8 de Junio del 12, a las 11:26:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13346,6,'                              ','Viernes 8 de Junio del 12, a las 12:59:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13347,11,'                              ','Viernes 8 de Junio del 12, a las 13:00:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13348,11,'                              ','Viernes 8 de Junio del 12, a las 13:03:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13349,11,'                              ','Viernes 8 de Junio del 12, a las 13:03:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13350,6,'                              ','Viernes 8 de Junio del 12, a las 13:19:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13351,11,'                              ','Viernes 8 de Junio del 12, a las 13:24:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13352,11,'                              ','Viernes 8 de Junio del 12, a las 13:25:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13353,8,'                              ','Viernes 8 de Junio del 12, a las 13:28:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13354,6,'                              ','Viernes 8 de Junio del 12, a las 16:14:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13355,6,'                              ','Lunes 11 de Junio del 12, a las 09:31:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13356,6,'                              ','Lunes 11 de Junio del 12, a las 16:12:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13357,11,'                              ','Lunes 11 de Junio del 12, a las 16:18:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13358,11,'                              ','Lunes 11 de Junio del 12, a las 16:19:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13359,8,'                              ','Martes 12 de Junio del 12, a las 10:22:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13360,11,'                              ','Martes 12 de Junio del 12, a las 10:26:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13361,11,'                              ','Martes 12 de Junio del 12, a las 10:30:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13362,11,'                              ','Martes 12 de Junio del 12, a las 12:31:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13363,8,'                              ','Martes 12 de Junio del 12, a las 12:33:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13364,6,'                              ','Martes 12 de Junio del 12, a las 12:50:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13365,6,'                              ','Martes 12 de Junio del 12, a las 12:53:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13366,8,'                              ','Martes 12 de Junio del 12, a las 12:58:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13367,11,'                              ','Martes 12 de Junio del 12, a las 13:04:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13368,53,'                              ','Martes 12 de Junio del 12, a las 13:05:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13369,11,'                              ','Martes 12 de Junio del 12, a las 13:07:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13370,8,'                              ','Martes 12 de Junio del 12, a las 13:09:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13371,6,'                              ','Martes 12 de Junio del 12, a las 16:43:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13372,11,'                              ','Mircoles 13 de Junio del 12, a las 11:08:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13373,6,'                              ','Mircoles 13 de Junio del 12, a las 11:15:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13374,11,'                              ','Mircoles 13 de Junio del 12, a las 11:27:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13375,6,'                              ','Jueves 14 de Junio del 12, a las 10:45:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13376,6,'                              ','Jueves 14 de Junio del 12, a las 10:49:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13377,6,'                              ','Jueves 14 de Junio del 12, a las 10:51:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13378,6,'                              ','Jueves 14 de Junio del 12, a las 10:54:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13379,6,'                              ','Jueves 14 de Junio del 12, a las 10:56:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13380,6,'                              ','Jueves 14 de Junio del 12, a las 10:58:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13381,11,'                              ','Jueves 14 de Junio del 12, a las 12:05:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13382,6,'                              ','Jueves 14 de Junio del 12, a las 14:37:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13383,6,'                              ','Jueves 14 de Junio del 12, a las 14:48:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13384,6,'                              ','Jueves 14 de Junio del 12, a las 14:49:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13385,6,'                              ','Jueves 14 de Junio del 12, a las 14:52:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13386,6,'                              ','Viernes 15 de Junio del 12, a las 10:58:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13387,6,'                              ','Viernes 15 de Junio del 12, a las 13:01:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13388,6,'                              ','Jueves 21 de Junio del 12, a las 10:36:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13389,6,'                              ','Viernes 22 de Junio del 12, a las 10:37:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13390,6,'                              ','Viernes 22 de Junio del 12, a las 10:37:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13391,6,'                              ','Viernes 22 de Junio del 12, a las 10:39:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13392,6,'                              ','Viernes 22 de Junio del 12, a las 10:40:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13393,6,'                              ','Viernes 22 de Junio del 12, a las 10:43:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13394,6,'                              ','Viernes 22 de Junio del 12, a las 10:43:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13395,6,'                              ','Viernes 22 de Junio del 12, a las 10:45:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13396,6,'                              ','Viernes 22 de Junio del 12, a las 10:46:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13397,6,'                              ','Viernes 22 de Junio del 12, a las 10:48:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13398,6,'                              ','Viernes 22 de Junio del 12, a las 10:49:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13399,6,'                              ','Viernes 22 de Junio del 12, a las 10:51:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13400,6,'                              ','Viernes 22 de Junio del 12, a las 10:54:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13401,6,'                              ','Viernes 22 de Junio del 12, a las 10:56:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13402,11,'                              ','Lunes 25 de Junio del 12, a las 09:56:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13403,6,'                              ','Mircoles 27 de Junio del 12, a las 09:35:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13404,2,'Bib Datos Propopios           ','Mircoles 27 de Junio del 12, a las 09:38:14      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13405,2,'Bib Datos Propopios           ','Mircoles 27 de Junio del 12, a las 09:39:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13406,6,'                              ','Mircoles 27 de Junio del 12, a las 09:47:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13407,6,'                              ','Mircoles 27 de Junio del 12, a las 09:48:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13408,6,'                              ','Viernes 29 de Junio del 12, a las 12:48:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13409,6,'                              ','Viernes 29 de Junio del 12, a las 12:49:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13410,6,'                              ','Viernes 29 de Junio del 12, a las 12:51:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13411,6,'                              ','Viernes 29 de Junio del 12, a las 12:53:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13412,6,'                              ','Viernes 29 de Junio del 12, a las 12:54:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13413,6,'                              ','Viernes 29 de Junio del 12, a las 12:56:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13414,6,'                              ','Viernes 29 de Junio del 12, a las 13:00:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13415,6,'                              ','Viernes 29 de Junio del 12, a las 13:02:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13416,6,'                              ','Viernes 29 de Junio del 12, a las 14:27:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13417,6,'                              ','Viernes 29 de Junio del 12, a las 14:28:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13418,6,'                              ','Viernes 29 de Junio del 12, a las 14:29:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13419,6,'                              ','Viernes 29 de Junio del 12, a las 14:30:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13420,6,'                              ','Viernes 29 de Junio del 12, a las 14:32:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13421,6,'                              ','Viernes 29 de Junio del 12, a las 14:33:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13422,6,'                              ','Mircoles 25 de Julio del 12, a las 13:17:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13423,6,'                              ','Mircoles 25 de Julio del 12, a las 13:19:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13424,6,'                              ','Mircoles 25 de Julio del 12, a las 13:23:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13425,6,'                              ','Mircoles 25 de Julio del 12, a las 13:26:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13426,6,'                              ','Mircoles 25 de Julio del 12, a las 13:28:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13427,6,'                              ','Mircoles 25 de Julio del 12, a las 13:30:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13428,4,'                              ','Lunes 30 de Julio del 12, a las 09:46:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13429,11,'                              ','Lunes 30 de Julio del 12, a las 10:03:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13430,6,'                              ','Lunes 30 de Julio del 12, a las 10:18:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13431,6,'                              ','Lunes 30 de Julio del 12, a las 10:20:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13432,6,'                              ','Lunes 30 de Julio del 12, a las 10:21:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13433,6,'                              ','Mircoles 1 de Agosto del 12, a las 16:28:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13434,6,'                              ','Jueves 2 de Agosto del 12, a las 09:29:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13435,4,'                              ','Lunes 6 de Agosto del 12, a las 12:37:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13436,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 12:40:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13437,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 12:42:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13438,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 12:43:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13439,4,'                              ','Lunes 6 de Agosto del 12, a las 12:44:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13440,4,'                              ','Lunes 6 de Agosto del 12, a las 12:47:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13441,4,'                              ','Lunes 6 de Agosto del 12, a las 12:48:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13442,4,'                              ','Lunes 6 de Agosto del 12, a las 12:51:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13443,4,'                              ','Lunes 6 de Agosto del 12, a las 12:53:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13444,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 13:00:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13445,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 13:03:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13446,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 13:03:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13447,2,'Bib Datos Propopios           ','Lunes 6 de Agosto del 12, a las 13:04:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13448,6,'                              ','Lunes 6 de Agosto del 12, a las 13:16:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13449,6,'                              ','Lunes 6 de Agosto del 12, a las 13:17:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13450,6,'                              ','Lunes 6 de Agosto del 12, a las 13:41:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13451,6,'                              ','Martes 7 de Agosto del 12, a las 14:33:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13452,6,'                              ','Martes 7 de Agosto del 12, a las 14:38:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13453,6,'                              ','Martes 7 de Agosto del 12, a las 14:42:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13454,6,'                              ','Martes 7 de Agosto del 12, a las 14:48:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13455,6,'                              ','Martes 7 de Agosto del 12, a las 15:05:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13456,6,'                              ','Martes 7 de Agosto del 12, a las 15:07:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13457,6,'                              ','Jueves 9 de Agosto del 12, a las 13:00:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13458,6,'                              ','Jueves 9 de Agosto del 12, a las 14:24:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13459,6,'                              ','Jueves 9 de Agosto del 12, a las 14:27:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13460,6,'                              ','Lunes 20 de Agosto del 12, a las 12:01:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13461,53,'                              ','Lunes 20 de Agosto del 12, a las 13:01:50         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13462,6,'                              ','Martes 21 de Agosto del 12, a las 15:22:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13463,6,'                              ','Martes 21 de Agosto del 12, a las 15:28:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13464,6,'                              ','Martes 21 de Agosto del 12, a las 15:30:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13465,6,'                              ','Mircoles 22 de Agosto del 12, a las 11:35:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13466,6,'                              ','Mircoles 22 de Agosto del 12, a las 11:41:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13467,6,'                              ','Mircoles 22 de Agosto del 12, a las 11:50:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13468,6,'                              ','Mircoles 22 de Agosto del 12, a las 15:27:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13469,6,'                              ','Mircoles 22 de Agosto del 12, a las 15:30:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13470,6,'                              ','Mircoles 22 de Agosto del 12, a las 15:30:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13471,6,'                              ','Jueves 23 de Agosto del 12, a las 15:12:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13472,6,'                              ','Jueves 23 de Agosto del 12, a las 15:13:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13473,6,'                              ','Jueves 23 de Agosto del 12, a las 15:15:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13474,6,'                              ','Jueves 23 de Agosto del 12, a las 15:22:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13475,6,'                              ','Jueves 23 de Agosto del 12, a las 15:27:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13476,6,'                              ','Jueves 23 de Agosto del 12, a las 15:29:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13477,6,'                              ','Jueves 23 de Agosto del 12, a las 15:34:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13478,6,'                              ','Jueves 23 de Agosto del 12, a las 15:42:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13479,6,'                              ','Jueves 23 de Agosto del 12, a las 15:44:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13480,6,'                              ','Jueves 23 de Agosto del 12, a las 15:48:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13481,6,'                              ','Viernes 31 de Agosto del 12, a las 16:14:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13482,6,'                              ','Viernes 31 de Agosto del 12, a las 16:17:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13483,6,'                              ','Viernes 31 de Agosto del 12, a las 16:18:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13484,6,'                              ','Viernes 31 de Agosto del 12, a las 16:19:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13485,6,'                              ','Viernes 31 de Agosto del 12, a las 16:21:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13486,6,'                              ','Viernes 31 de Agosto del 12, a las 16:21:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13487,6,'                              ','Viernes 31 de Agosto del 12, a las 16:22:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13488,6,'                              ','Viernes 31 de Agosto del 12, a las 16:23:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13489,6,'                              ','Viernes 31 de Agosto del 12, a las 16:27:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13490,6,'                              ','Viernes 31 de Agosto del 12, a las 16:27:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13491,6,'                              ','Viernes 31 de Agosto del 12, a las 16:32:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13492,6,'                              ','Viernes 31 de Agosto del 12, a las 16:34:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13493,6,'                              ','Viernes 31 de Agosto del 12, a las 16:38:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13494,6,'                              ','Viernes 31 de Agosto del 12, a las 16:40:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13495,6,'                              ','Viernes 31 de Agosto del 12, a las 16:42:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13496,6,'                              ','Viernes 31 de Agosto del 12, a las 16:47:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13497,6,'                              ','Viernes 31 de Agosto del 12, a las 16:48:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13498,6,'                              ','Viernes 31 de Agosto del 12, a las 16:52:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13499,6,'                              ','Viernes 31 de Agosto del 12, a las 16:52:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13500,6,'                              ','Viernes 31 de Agosto del 12, a las 16:54:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13501,6,'                              ','Viernes 31 de Agosto del 12, a las 16:56:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13502,6,'                              ','Viernes 31 de Agosto del 12, a las 16:59:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13503,6,'                              ','Viernes 31 de Agosto del 12, a las 17:01:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13504,6,'                              ','Lunes 3 de Septiembre del 12, a las 10:55:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13505,6,'                              ','Lunes 3 de Septiembre del 12, a las 10:59:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13506,6,'                              ','Mircoles 5 de Septiembre del 12, a las 11:30:24  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13507,6,'                              ','Mircoles 5 de Septiembre del 12, a las 11:31:51  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13508,2,'Bib Datos Propopios           ','Mircoles 5 de Septiembre del 12, a las 15:25:55  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13509,2,'Bib Datos Propopios           ','Mircoles 5 de Septiembre del 12, a las 15:26:42  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13510,2,'Bib Datos Propopios           ','Mircoles 5 de Septiembre del 12, a las 15:28:24  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13511,4,'                              ','Mircoles 5 de Septiembre del 12, a las 15:34:20  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13512,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:35:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13513,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:38:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13514,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:42:01  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13515,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:48:49  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13516,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:49:13  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13517,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:50:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13518,6,'                              ','Mircoles 5 de Septiembre del 12, a las 15:54:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13519,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:02:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13520,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:05:07  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13521,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:08:31  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13522,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:13:13  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13523,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:16:30  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13524,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:19:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13525,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:23:50  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13526,6,'                              ','Mircoles 5 de Septiembre del 12, a las 16:37:12  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13527,6,'                              ','Mircoles 5 de Septiembre del 12, a las 17:00:20  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13528,6,'                              ','Mircoles 5 de Septiembre del 12, a las 17:04:43  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13529,6,'                              ','Mircoles 5 de Septiembre del 12, a las 17:06:30  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13530,6,'                              ','Jueves 6 de Septiembre del 12, a las 11:58:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13531,6,'                              ','Jueves 6 de Septiembre del 12, a las 11:58:33     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13532,6,'                              ','Jueves 6 de Septiembre del 12, a las 12:06:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13533,6,'                              ','Jueves 6 de Septiembre del 12, a las 12:21:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13534,6,'                              ','Jueves 6 de Septiembre del 12, a las 12:29:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13535,6,'                              ','Viernes 7 de Septiembre del 12, a las 12:10:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13536,6,'                              ','Lunes 10 de Septiembre del 12, a las 11:58:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13537,6,'                              ','Lunes 10 de Septiembre del 12, a las 12:03:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13538,6,'                              ','Lunes 10 de Septiembre del 12, a las 12:16:31     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13539,6,'                              ','Lunes 10 de Septiembre del 12, a las 12:54:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13540,6,'                              ','Lunes 10 de Septiembre del 12, a las 12:55:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13541,6,'                              ','Lunes 10 de Septiembre del 12, a las 12:59:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13542,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:03:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13543,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:13:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13544,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:16:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13545,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:19:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13546,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:22:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13547,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:22:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13548,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:25:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13549,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:39:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13550,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:43:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13551,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:46:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13552,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:47:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13553,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:48:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13554,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:50:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13555,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:51:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13556,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:55:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13557,6,'                              ','Lunes 10 de Septiembre del 12, a las 13:58:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13558,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:01:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13559,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:05:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13560,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:22:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13561,2,'Bib Datos Propopios           ','Lunes 10 de Septiembre del 12, a las 14:23:50     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13562,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:24:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13563,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:24:51     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13564,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:27:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13565,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:40:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13566,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:43:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13567,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:44:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13568,6,'                              ','Lunes 10 de Septiembre del 12, a las 14:44:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13569,6,'                              ','Lunes 10 de Septiembre del 12, a las 15:18:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13570,6,'                              ','Lunes 10 de Septiembre del 12, a las 15:22:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13571,11,'                              ','Lunes 17 de Septiembre del 12, a las 16:21:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13572,11,'                              ','Lunes 17 de Septiembre del 12, a las 16:22:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13573,11,'                              ','Lunes 17 de Septiembre del 12, a las 16:23:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13574,6,'                              ','Viernes 28 de Septiembre del 12, a las 09:27:21   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13575,6,'                              ','Viernes 28 de Septiembre del 12, a las 09:46:25   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13576,6,'                              ','Viernes 28 de Septiembre del 12, a las 09:52:14   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13577,6,'                              ','Viernes 28 de Septiembre del 12, a las 09:57:31   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13578,6,'                              ','Mircoles 3 de Octubre del 12, a las 10:02:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13579,6,'                              ','Viernes 5 de Octubre del 12, a las 13:00:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13580,6,'                              ','Viernes 5 de Octubre del 12, a las 13:01:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13581,53,'                              ','Viernes 5 de Octubre del 12, a las 13:03:06       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13582,53,'                              ','Viernes 5 de Octubre del 12, a las 13:05:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13583,53,'                              ','Viernes 5 de Octubre del 12, a las 13:22:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13584,53,'                              ','Viernes 5 de Octubre del 12, a las 13:23:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13585,53,'                              ','Viernes 5 de Octubre del 12, a las 13:32:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13586,11,'                              ','Viernes 5 de Octubre del 12, a las 13:36:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13587,6,'                              ','Viernes 5 de Octubre del 12, a las 13:50:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13588,6,'                              ','Mircoles 10 de Octubre del 12, a las 11:59:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13589,11,'                              ','Mircoles 10 de Octubre del 12, a las 15:09:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13590,6,'                              ','Mircoles 10 de Octubre del 12, a las 15:16:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13591,6,'                              ','Mircoles 10 de Octubre del 12, a las 15:26:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13592,6,'                              ','Mircoles 10 de Octubre del 12, a las 15:34:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13593,6,'                              ','Jueves 11 de Octubre del 12, a las 12:49:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13594,6,'                              ','Martes 23 de Octubre del 12, a las 10:12:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13595,6,'                              ','Martes 23 de Octubre del 12, a las 10:41:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13596,51,'Direccion                     ','Jueves 25 de Octubre del 12, a las 12:13:19       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13597,2,'Bib Datos Propopios           ','Viernes 26 de Octubre del 12, a las 13:48:33      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13598,6,'                              ','Lunes 29 de Octubre del 12, a las 15:07:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13599,4,'                              ','Mircoles 31 de Octubre del 12, a las 11:50:02    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13600,2,'Bib Datos Propopios           ','Mircoles 31 de Octubre del 12, a las 11:55:42    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13601,4,'                              ','Mircoles 31 de Octubre del 12, a las 12:00:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13602,4,'                              ','Mircoles 31 de Octubre del 12, a las 12:03:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13603,6,'                              ','Martes 6 de Noviembre del 12, a las 10:37:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13604,6,'                              ','Viernes 9 de Noviembre del 12, a las 09:37:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13605,6,'                              ','Viernes 9 de Noviembre del 12, a las 10:55:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13606,6,'                              ','Viernes 9 de Noviembre del 12, a las 10:56:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13607,6,'                              ','Lunes 12 de Noviembre del 12, a las 16:42:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13608,11,'                              ','Lunes 12 de Noviembre del 12, a las 16:42:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13609,6,'                              ','Martes 13 de Noviembre del 12, a las 09:59:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13610,6,'                              ','Mircoles 14 de Noviembre del 12, a las 11:26:57  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13611,11,'                              ','Mircoles 14 de Noviembre del 12, a las 11:30:20  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13612,2,'Bib Datos Propopios           ','Mircoles 21 de Noviembre del 12, a las 14:46:38  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13613,2,'Bib Datos Propopios           ','Mircoles 21 de Noviembre del 12, a las 15:16:39  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13614,53,'                              ','Viernes 23 de Noviembre del 12, a las 12:06:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13615,53,'                              ','Viernes 23 de Noviembre del 12, a las 12:09:38    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13616,53,'                              ','Viernes 23 de Noviembre del 12, a las 12:11:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13617,53,'                              ','Viernes 23 de Noviembre del 12, a las 12:16:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13618,53,'                              ','Viernes 23 de Noviembre del 12, a las 12:20:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13619,53,'                              ','Viernes 23 de Noviembre del 12, a las 12:25:58    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13620,51,'Direccion                     ','Viernes 23 de Noviembre del 12, a las 12:27:39    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13621,6,'                              ','Jueves 6 de Diciembre del 12, a las 10:48:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13622,6,'                              ','Jueves 6 de Diciembre del 12, a las 12:12:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13623,6,'                              ','Jueves 6 de Diciembre del 12, a las 12:30:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13624,8,'                              ','Jueves 6 de Diciembre del 12, a las 12:36:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13625,11,'                              ','Jueves 6 de Diciembre del 12, a las 12:37:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13626,11,'                              ','Jueves 6 de Diciembre del 12, a las 12:37:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13627,11,'                              ','Jueves 6 de Diciembre del 12, a las 12:42:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13628,11,'                              ','Jueves 6 de Diciembre del 12, a las 12:44:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13629,6,'                              ','Jueves 6 de Diciembre del 12, a las 12:49:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13630,11,'                              ','Jueves 6 de Diciembre del 12, a las 12:56:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13631,11,'                              ','Jueves 6 de Diciembre del 12, a las 12:56:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13632,6,'                              ','Jueves 6 de Diciembre del 12, a las 13:00:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13633,11,'                              ','Jueves 6 de Diciembre del 12, a las 13:02:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13634,11,'                              ','Jueves 6 de Diciembre del 12, a las 13:04:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13635,11,'                              ','Jueves 6 de Diciembre del 12, a las 13:05:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13636,11,'                              ','Jueves 6 de Diciembre del 12, a las 13:06:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13637,11,'                              ','Jueves 6 de Diciembre del 12, a las 13:15:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13638,11,'                              ','Jueves 6 de Diciembre del 12, a las 13:17:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13639,6,'                              ','Lunes 7 de Enero del 13, a las 16:39:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13640,6,'                              ','Lunes 7 de Enero del 13, a las 16:44:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13641,6,'                              ','Martes 8 de Enero del 13, a las 14:15:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13642,6,'                              ','Martes 8 de Enero del 13, a las 14:17:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13643,6,'                              ','Martes 8 de Enero del 13, a las 14:18:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13644,6,'                              ','Martes 8 de Enero del 13, a las 14:20:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13645,6,'                              ','Martes 8 de Enero del 13, a las 14:21:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13646,6,'                              ','Mircoles 9 de Enero del 13, a las 10:03:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13647,6,'                              ','Mircoles 9 de Enero del 13, a las 10:05:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13648,6,'                              ','Mircoles 9 de Enero del 13, a las 15:07:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13649,6,'                              ','Jueves 10 de Enero del 13, a las 17:01:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13650,6,'                              ','Jueves 10 de Enero del 13, a las 17:02:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13651,6,'                              ','Jueves 10 de Enero del 13, a las 17:03:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13652,6,'                              ','Jueves 10 de Enero del 13, a las 17:04:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13653,6,'                              ','Jueves 10 de Enero del 13, a las 17:05:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13654,6,'                              ','Viernes 11 de Enero del 13, a las 13:12:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13655,6,'                              ','Viernes 11 de Enero del 13, a las 14:39:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13656,6,'                              ','Viernes 11 de Enero del 13, a las 15:07:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13657,6,'                              ','Lunes 14 de Enero del 13, a las 16:15:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13658,6,'                              ','Lunes 14 de Enero del 13, a las 16:25:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13659,6,'                              ','Lunes 14 de Enero del 13, a las 16:27:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13660,6,'                              ','Lunes 14 de Enero del 13, a las 16:35:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13661,6,'                              ','Martes 15 de Enero del 13, a las 10:59:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13662,6,'                              ','Mircoles 16 de Enero del 13, a las 10:30:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13663,6,'                              ','Mircoles 16 de Enero del 13, a las 15:57:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13664,6,'                              ','Jueves 17 de Enero del 13, a las 11:19:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13665,6,'                              ','Lunes 21 de Enero del 13, a las 14:02:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13666,6,'                              ','Lunes 21 de Enero del 13, a las 14:03:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13667,11,'                              ','Mircoles 23 de Enero del 13, a las 10:52:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13668,6,'                              ','Lunes 28 de Enero del 13, a las 15:08:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13669,6,'                              ','Jueves 31 de Enero del 13, a las 13:02:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13670,6,'                              ','Jueves 31 de Enero del 13, a las 13:03:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13671,6,'                              ','Viernes 1 de Febrero del 13, a las 12:18:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13672,6,'                              ','Viernes 1 de Febrero del 13, a las 12:20:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13673,6,'                              ','Mircoles 6 de Febrero del 13, a las 16:41:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13674,6,'                              ','Lunes 11 de Febrero del 13, a las 14:40:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13675,6,'                              ','Mircoles 20 de Febrero del 13, a las 11:02:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13676,6,'                              ','Mircoles 20 de Febrero del 13, a las 12:27:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13677,6,'                              ','Mircoles 20 de Febrero del 13, a las 12:28:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13678,6,'                              ','Mircoles 20 de Febrero del 13, a las 12:29:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13679,4,'                              ','Mircoles 20 de Febrero del 13, a las 13:50:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13680,11,'                              ','Mircoles 20 de Febrero del 13, a las 13:55:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13681,6,'                              ','Jueves 21 de Febrero del 13, a las 13:36:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13682,6,'                              ','Martes 5 de Marzo del 13, a las 11:18:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13683,6,'                              ','Martes 5 de Marzo del 13, a las 15:15:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13684,6,'                              ','Martes 5 de Marzo del 13, a las 15:16:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13685,6,'                              ','Mircoles 6 de Marzo del 13, a las 10:19:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13686,6,'                              ','Jueves 7 de Marzo del 13, a las 12:32:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13687,6,'                              ','Jueves 7 de Marzo del 13, a las 12:33:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13688,6,'                              ','Jueves 7 de Marzo del 13, a las 12:34:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13689,6,'                              ','Mircoles 13 de Marzo del 13, a las 09:41:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13690,6,'                              ','Jueves 14 de Marzo del 13, a las 16:49:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13691,6,'                              ','Jueves 14 de Marzo del 13, a las 16:51:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13692,6,'                              ','Lunes 1 de Abril del 13, a las 16:14:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13693,6,'                              ','Lunes 1 de Abril del 13, a las 16:15:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13694,6,'                              ','Mircoles 3 de Abril del 13, a las 10:25:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13695,6,'                              ','Mircoles 3 de Abril del 13, a las 10:27:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13696,4,'                              ','Mircoles 10 de Abril del 13, a las 10:53:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13697,11,'                              ','Mircoles 10 de Abril del 13, a las 10:55:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13698,11,'                              ','Mircoles 10 de Abril del 13, a las 10:55:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13699,11,'                              ','Mircoles 10 de Abril del 13, a las 10:55:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13700,4,'                              ','Mircoles 10 de Abril del 13, a las 11:11:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13701,4,'                              ','Mircoles 10 de Abril del 13, a las 11:22:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13702,4,'                              ','Mircoles 10 de Abril del 13, a las 11:24:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13703,4,'                              ','Mircoles 10 de Abril del 13, a las 11:28:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13704,4,'                              ','Mircoles 10 de Abril del 13, a las 11:30:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13705,4,'                              ','Mircoles 10 de Abril del 13, a las 11:32:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13706,4,'                              ','Mircoles 10 de Abril del 13, a las 11:35:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13707,4,'                              ','Mircoles 10 de Abril del 13, a las 11:40:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13708,4,'                              ','Mircoles 10 de Abril del 13, a las 11:42:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13709,4,'                              ','Mircoles 10 de Abril del 13, a las 11:46:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13710,6,'                              ','Mircoles 10 de Abril del 13, a las 11:49:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13711,6,'                              ','Mircoles 10 de Abril del 13, a las 11:52:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13712,6,'                              ','Mircoles 10 de Abril del 13, a las 11:54:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13713,6,'                              ','Martes 16 de Abril del 13, a las 14:43:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13714,6,'                              ','Martes 16 de Abril del 13, a las 14:43:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13715,6,'                              ','Martes 16 de Abril del 13, a las 14:45:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13716,6,'                              ','Martes 16 de Abril del 13, a las 14:46:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13717,6,'                              ','Martes 16 de Abril del 13, a las 14:47:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13718,6,'                              ','Martes 16 de Abril del 13, a las 14:48:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13719,6,'                              ','Martes 16 de Abril del 13, a las 14:55:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13720,6,'                              ','Martes 16 de Abril del 13, a las 14:56:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13721,6,'                              ','Martes 16 de Abril del 13, a las 15:13:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13722,6,'                              ','Martes 16 de Abril del 13, a las 15:18:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13723,6,'                              ','Martes 16 de Abril del 13, a las 15:20:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13724,6,'                              ','Martes 16 de Abril del 13, a las 15:21:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13725,6,'                              ','Mircoles 17 de Abril del 13, a las 15:13:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13726,6,'                              ','Mircoles 17 de Abril del 13, a las 15:17:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13727,6,'                              ','Mircoles 17 de Abril del 13, a las 15:19:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13728,6,'                              ','Jueves 18 de Abril del 13, a las 13:04:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13729,6,'                              ','Viernes 19 de Abril del 13, a las 09:55:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13730,6,'                              ','Martes 23 de Abril del 13, a las 10:12:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13731,6,'                              ','Jueves 2 de Mayo del 13, a las 17:15:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13732,2,'Bib Datos Propopios           ','Jueves 9 de Mayo del 13, a las 11:21:11           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13733,6,'                              ','Jueves 9 de Mayo del 13, a las 11:46:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13734,6,'                              ','Jueves 9 de Mayo del 13, a las 11:54:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13735,2,'Bib Datos Propopios           ','Jueves 9 de Mayo del 13, a las 11:59:31           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13736,4,'                              ','Jueves 9 de Mayo del 13, a las 12:04:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13737,2,'Bib Datos Propopios           ','Jueves 9 de Mayo del 13, a las 12:05:34           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13738,6,'                              ','Jueves 9 de Mayo del 13, a las 12:07:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13739,4,'                              ','Jueves 9 de Mayo del 13, a las 12:12:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13740,6,'                              ','Jueves 9 de Mayo del 13, a las 12:18:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13741,6,'                              ','Jueves 9 de Mayo del 13, a las 12:20:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13742,4,'                              ','Jueves 9 de Mayo del 13, a las 12:24:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13743,4,'                              ','Jueves 9 de Mayo del 13, a las 12:26:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13744,4,'                              ','Jueves 9 de Mayo del 13, a las 12:27:37           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13745,4,'                              ','Jueves 9 de Mayo del 13, a las 12:31:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13746,4,'                              ','Jueves 9 de Mayo del 13, a las 12:34:27           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13747,4,'                              ','Jueves 9 de Mayo del 13, a las 12:37:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13748,3,'                              ','Lunes 13 de Mayo del 13, a las 12:47:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13749,6,'                              ','Lunes 13 de Mayo del 13, a las 14:40:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13750,6,'                              ','Lunes 13 de Mayo del 13, a las 14:41:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13751,6,'                              ','Lunes 13 de Mayo del 13, a las 14:47:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13752,4,'                              ','Jueves 16 de Mayo del 13, a las 11:18:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13753,4,'                              ','Jueves 16 de Mayo del 13, a las 11:34:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13754,4,'                              ','Jueves 16 de Mayo del 13, a las 11:41:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13755,4,'                              ','Jueves 16 de Mayo del 13, a las 11:41:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13756,6,'                              ','Jueves 16 de Mayo del 13, a las 11:47:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13757,4,'                              ','Jueves 16 de Mayo del 13, a las 11:52:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13758,6,'                              ','Jueves 16 de Mayo del 13, a las 11:52:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13759,6,'                              ','Jueves 16 de Mayo del 13, a las 11:56:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13760,6,'                              ','Jueves 16 de Mayo del 13, a las 12:01:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13761,2,'Bib Datos Propopios           ','Jueves 16 de Mayo del 13, a las 12:02:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13762,4,'                              ','Jueves 16 de Mayo del 13, a las 12:03:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13763,4,'                              ','Jueves 16 de Mayo del 13, a las 12:05:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13764,4,'                              ','Jueves 16 de Mayo del 13, a las 12:07:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13765,2,'Bib Datos Propopios           ','Jueves 16 de Mayo del 13, a las 12:11:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13766,4,'                              ','Viernes 17 de Mayo del 13, a las 15:32:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13767,6,'                              ','Martes 21 de Mayo del 13, a las 16:34:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13768,6,'                              ','Martes 21 de Mayo del 13, a las 16:42:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13769,4,'                              ','Martes 21 de Mayo del 13, a las 16:46:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13770,4,'                              ','Martes 21 de Mayo del 13, a las 16:48:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13771,53,'                              ','Martes 21 de Mayo del 13, a las 16:57:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13772,11,'                              ','Martes 21 de Mayo del 13, a las 17:02:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13773,11,'                              ','Martes 21 de Mayo del 13, a las 17:04:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13774,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 10:35:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13775,6,'                              ','Mircoles 22 de Mayo del 13, a las 10:39:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13776,6,'                              ','Mircoles 22 de Mayo del 13, a las 10:47:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13777,6,'                              ','Mircoles 22 de Mayo del 13, a las 10:50:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13778,6,'                              ','Mircoles 22 de Mayo del 13, a las 10:54:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13779,6,'                              ','Mircoles 22 de Mayo del 13, a las 10:58:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13780,4,'                              ','Mircoles 22 de Mayo del 13, a las 11:02:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13781,8,'                              ','Mircoles 22 de Mayo del 13, a las 11:05:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13782,6,'                              ','Mircoles 22 de Mayo del 13, a las 11:08:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13783,6,'                              ','Mircoles 22 de Mayo del 13, a las 11:10:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13784,6,'                              ','Mircoles 22 de Mayo del 13, a las 11:14:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13785,6,'                              ','Mircoles 22 de Mayo del 13, a las 11:17:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13786,6,'                              ','Mircoles 22 de Mayo del 13, a las 11:23:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13787,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 11:25:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13788,6,'                              ','Mircoles 22 de Mayo del 13, a las 11:27:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13789,4,'                              ','Mircoles 22 de Mayo del 13, a las 11:29:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13790,4,'                              ','Mircoles 22 de Mayo del 13, a las 11:31:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13791,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 11:52:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13792,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 11:53:58       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13793,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 12:11:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13794,4,'                              ','Mircoles 22 de Mayo del 13, a las 12:12:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13795,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 12:17:37       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13796,4,'                              ','Mircoles 22 de Mayo del 13, a las 12:18:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13797,4,'                              ','Mircoles 22 de Mayo del 13, a las 12:21:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13798,6,'                              ','Mircoles 22 de Mayo del 13, a las 12:28:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13799,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 12:33:49       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13800,4,'                              ','Mircoles 22 de Mayo del 13, a las 12:35:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13801,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 12:41:51       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13802,4,'                              ','Mircoles 22 de Mayo del 13, a las 12:44:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13803,6,'                              ','Mircoles 22 de Mayo del 13, a las 12:56:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13804,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 13:03:34       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13805,4,'                              ','Mircoles 22 de Mayo del 13, a las 13:04:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13806,6,'                              ','Mircoles 22 de Mayo del 13, a las 13:07:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13807,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 13:10:34       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13808,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 13:11:16       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13809,6,'                              ','Mircoles 22 de Mayo del 13, a las 13:13:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13810,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 16:24:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13811,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 16:26:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13812,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 16:30:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13813,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 16:31:28       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13814,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 16:34:46       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13815,51,'Direccion                     ','Mircoles 22 de Mayo del 13, a las 16:38:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13816,53,'                              ','Mircoles 22 de Mayo del 13, a las 16:40:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13817,4,'                              ','Mircoles 22 de Mayo del 13, a las 16:42:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13818,2,'Bib Datos Propopios           ','Mircoles 22 de Mayo del 13, a las 16:45:32       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13819,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 10:57:33         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13820,11,'                              ','Viernes 24 de Mayo del 13, a las 11:00:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13821,6,'                              ','Viernes 24 de Mayo del 13, a las 11:11:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13822,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 11:12:30         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13823,11,'                              ','Viernes 24 de Mayo del 13, a las 11:16:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13824,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 11:20:37         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13825,6,'                              ','Viernes 24 de Mayo del 13, a las 11:23:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13826,6,'                              ','Viernes 24 de Mayo del 13, a las 11:24:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13827,6,'                              ','Viernes 24 de Mayo del 13, a las 11:27:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13828,6,'                              ','Viernes 24 de Mayo del 13, a las 11:29:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13829,11,'                              ','Viernes 24 de Mayo del 13, a las 11:33:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13830,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 11:41:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13831,6,'                              ','Viernes 24 de Mayo del 13, a las 11:45:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13832,6,'                              ','Viernes 24 de Mayo del 13, a las 11:51:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13833,6,'                              ','Viernes 24 de Mayo del 13, a las 11:53:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13834,11,'                              ','Viernes 24 de Mayo del 13, a las 11:55:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13835,11,'                              ','Viernes 24 de Mayo del 13, a las 11:56:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13836,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 12:47:00         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13837,4,'                              ','Viernes 24 de Mayo del 13, a las 12:49:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13838,11,'                              ','Viernes 24 de Mayo del 13, a las 12:50:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13839,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 12:52:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13840,6,'                              ','Viernes 24 de Mayo del 13, a las 12:55:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13841,4,'                              ','Viernes 24 de Mayo del 13, a las 12:58:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13842,11,'                              ','Viernes 24 de Mayo del 13, a las 13:02:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13843,6,'                              ','Viernes 24 de Mayo del 13, a las 13:08:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13844,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 13:09:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13845,2,'Bib Datos Propopios           ','Viernes 24 de Mayo del 13, a las 13:12:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13846,4,'                              ','Viernes 24 de Mayo del 13, a las 13:15:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13847,4,'                              ','Viernes 24 de Mayo del 13, a las 13:15:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13848,6,'                              ','Viernes 24 de Mayo del 13, a las 13:16:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13849,11,'                              ','Viernes 24 de Mayo del 13, a las 13:18:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13850,6,'                              ','Martes 28 de Mayo del 13, a las 11:48:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13851,4,'                              ','Martes 28 de Mayo del 13, a las 11:50:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13852,4,'                              ','Martes 28 de Mayo del 13, a las 11:51:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13853,6,'                              ','Martes 28 de Mayo del 13, a las 11:54:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13854,11,'                              ','Martes 28 de Mayo del 13, a las 11:56:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13855,11,'                              ','Martes 28 de Mayo del 13, a las 11:56:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13856,2,'Bib Datos Propopios           ','Martes 28 de Mayo del 13, a las 12:16:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13857,4,'                              ','Martes 28 de Mayo del 13, a las 12:18:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13858,2,'Bib Datos Propopios           ','Martes 28 de Mayo del 13, a las 12:29:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13859,51,'Direccion                     ','Martes 28 de Mayo del 13, a las 12:36:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13860,6,'                              ','Martes 28 de Mayo del 13, a las 12:38:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13861,4,'                              ','Martes 28 de Mayo del 13, a las 12:39:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13862,53,'                              ','Martes 28 de Mayo del 13, a las 12:42:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13863,53,'                              ','Martes 28 de Mayo del 13, a las 12:43:03          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13864,6,'                              ','Martes 28 de Mayo del 13, a las 12:45:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13865,11,'                              ','Martes 28 de Mayo del 13, a las 12:50:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13866,11,'                              ','Martes 28 de Mayo del 13, a las 12:50:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13867,2,'Bib Datos Propopios           ','Martes 28 de Mayo del 13, a las 12:55:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13868,6,'                              ','Martes 28 de Mayo del 13, a las 12:58:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13869,4,'                              ','Martes 28 de Mayo del 13, a las 12:59:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13870,6,'                              ','Martes 28 de Mayo del 13, a las 13:08:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13871,11,'                              ','Martes 28 de Mayo del 13, a las 13:12:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13872,2,'Bib Datos Propopios           ','Martes 28 de Mayo del 13, a las 13:14:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13873,2,'Bib Datos Propopios           ','Martes 28 de Mayo del 13, a las 13:15:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13874,4,'                              ','Martes 28 de Mayo del 13, a las 13:19:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13875,4,'                              ','Martes 28 de Mayo del 13, a las 13:19:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13876,11,'                              ','Martes 28 de Mayo del 13, a las 13:22:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13877,2,'Bib Datos Propopios           ','Martes 28 de Mayo del 13, a las 14:03:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13878,4,'                              ','Martes 28 de Mayo del 13, a las 14:05:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13879,6,'                              ','Martes 28 de Mayo del 13, a las 14:13:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13880,6,'                              ','Martes 28 de Mayo del 13, a las 14:15:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13881,11,'                              ','Martes 28 de Mayo del 13, a las 14:16:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13882,6,'                              ','Martes 28 de Mayo del 13, a las 14:19:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13883,6,'                              ','Mircoles 29 de Mayo del 13, a las 10:49:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13884,2,'Bib Datos Propopios           ','Mircoles 29 de Mayo del 13, a las 11:59:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13885,6,'                              ','Mircoles 29 de Mayo del 13, a las 12:02:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13886,6,'                              ','Mircoles 29 de Mayo del 13, a las 12:03:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13887,2,'Bib Datos Propopios           ','Mircoles 29 de Mayo del 13, a las 12:05:08       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13888,4,'                              ','Mircoles 29 de Mayo del 13, a las 12:07:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13889,6,'                              ','Mircoles 29 de Mayo del 13, a las 12:09:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13890,11,'                              ','Mircoles 29 de Mayo del 13, a las 12:12:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13891,2,'Bib Datos Propopios           ','Mircoles 29 de Mayo del 13, a las 12:18:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13892,11,'                              ','Mircoles 29 de Mayo del 13, a las 12:21:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13893,2,'Bib Datos Propopios           ','Mircoles 29 de Mayo del 13, a las 12:24:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13894,4,'                              ','Mircoles 29 de Mayo del 13, a las 12:27:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13895,6,'                              ','Mircoles 29 de Mayo del 13, a las 12:29:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13896,11,'                              ','Mircoles 29 de Mayo del 13, a las 12:32:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13897,6,'                              ','Jueves 30 de Mayo del 13, a las 12:51:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13898,6,'                              ','Jueves 30 de Mayo del 13, a las 12:52:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13899,6,'                              ','Jueves 30 de Mayo del 13, a las 12:54:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13900,6,'                              ','Jueves 30 de Mayo del 13, a las 12:55:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13901,6,'                              ','Jueves 30 de Mayo del 13, a las 12:56:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13902,6,'                              ','Jueves 30 de Mayo del 13, a las 12:57:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13903,6,'                              ','Jueves 30 de Mayo del 13, a las 12:58:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13904,6,'                              ','Jueves 30 de Mayo del 13, a las 12:59:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13905,6,'                              ','Jueves 30 de Mayo del 13, a las 13:00:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13906,6,'                              ','Lunes 3 de Junio del 13, a las 10:01:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13907,6,'                              ','Lunes 3 de Junio del 13, a las 17:03:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13908,4,'                              ','Martes 4 de Junio del 13, a las 11:04:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13909,6,'                              ','Martes 4 de Junio del 13, a las 11:07:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13910,4,'                              ','Martes 4 de Junio del 13, a las 11:13:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13911,4,'                              ','Martes 4 de Junio del 13, a las 11:28:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13912,11,'                              ','Martes 4 de Junio del 13, a las 11:30:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13913,6,'                              ','Jueves 6 de Junio del 13, a las 10:08:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13914,11,'                              ','Jueves 6 de Junio del 13, a las 10:10:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13915,11,'                              ','Jueves 6 de Junio del 13, a las 10:10:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13916,6,'                              ','Jueves 6 de Junio del 13, a las 10:14:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13917,11,'                              ','Jueves 6 de Junio del 13, a las 10:16:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13918,11,'                              ','Jueves 6 de Junio del 13, a las 10:17:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13919,6,'                              ','Jueves 6 de Junio del 13, a las 10:37:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13920,11,'                              ','Jueves 6 de Junio del 13, a las 10:41:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13921,6,'                              ','Jueves 6 de Junio del 13, a las 10:46:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13922,6,'                              ','Jueves 6 de Junio del 13, a las 10:49:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13923,6,'                              ','Jueves 6 de Junio del 13, a las 10:52:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13924,6,'                              ','Lunes 10 de Junio del 13, a las 11:30:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13925,11,'                              ','Lunes 10 de Junio del 13, a las 11:45:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13926,11,'                              ','Lunes 10 de Junio del 13, a las 11:47:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13927,11,'                              ','Lunes 10 de Junio del 13, a las 12:12:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13928,11,'                              ','Lunes 10 de Junio del 13, a las 12:26:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13929,8,'                              ','Lunes 10 de Junio del 13, a las 14:33:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13930,11,'                              ','Lunes 10 de Junio del 13, a las 14:43:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13931,6,'                              ','Lunes 10 de Junio del 13, a las 15:02:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13932,6,'                              ','Lunes 10 de Junio del 13, a las 15:05:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13933,11,'                              ','Lunes 10 de Junio del 13, a las 15:08:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13934,6,'                              ','Lunes 10 de Junio del 13, a las 15:21:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13935,11,'                              ','Lunes 10 de Junio del 13, a las 15:24:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13936,6,'                              ','Lunes 10 de Junio del 13, a las 15:29:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13937,11,'                              ','Lunes 10 de Junio del 13, a las 15:31:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13938,8,'                              ','Lunes 10 de Junio del 13, a las 15:35:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13939,6,'                              ','Lunes 10 de Junio del 13, a las 15:52:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13940,6,'                              ','Lunes 10 de Junio del 13, a las 15:55:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13941,11,'                              ','Lunes 10 de Junio del 13, a las 15:57:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13942,2,'Bib Datos Propopios           ','Lunes 10 de Junio del 13, a las 16:01:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13943,4,'                              ','Lunes 10 de Junio del 13, a las 16:04:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13944,11,'                              ','Lunes 10 de Junio del 13, a las 16:08:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13945,8,'                              ','Lunes 10 de Junio del 13, a las 16:11:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13946,11,'                              ','Lunes 10 de Junio del 13, a las 16:12:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13947,11,'                              ','Lunes 10 de Junio del 13, a las 16:15:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13948,11,'                              ','Lunes 10 de Junio del 13, a las 16:16:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13949,11,'                              ','Lunes 10 de Junio del 13, a las 16:18:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13950,11,'                              ','Martes 11 de Junio del 13, a las 11:15:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13951,11,'                              ','Martes 11 de Junio del 13, a las 11:16:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13952,11,'                              ','Martes 11 de Junio del 13, a las 11:25:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13953,11,'                              ','Martes 11 de Junio del 13, a las 13:23:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13954,6,'                              ','Martes 11 de Junio del 13, a las 13:25:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13955,11,'                              ','Mircoles 12 de Junio del 13, a las 10:44:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13956,11,'                              ','Mircoles 12 de Junio del 13, a las 10:51:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13957,11,'                              ','Mircoles 12 de Junio del 13, a las 11:00:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13958,11,'                              ','Mircoles 12 de Junio del 13, a las 11:06:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13959,11,'                              ','Mircoles 12 de Junio del 13, a las 11:08:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13960,11,'                              ','Mircoles 12 de Junio del 13, a las 11:36:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13961,6,'                              ','Mircoles 12 de Junio del 13, a las 11:40:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13962,11,'                              ','Mircoles 12 de Junio del 13, a las 11:47:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13963,11,'                              ','Mircoles 12 de Junio del 13, a las 11:49:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13964,11,'                              ','Mircoles 12 de Junio del 13, a las 12:13:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13965,11,'                              ','Mircoles 12 de Junio del 13, a las 12:15:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13966,11,'                              ','Mircoles 12 de Junio del 13, a las 12:29:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13967,6,'                              ','Mircoles 12 de Junio del 13, a las 12:32:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13968,8,'                              ','Mircoles 12 de Junio del 13, a las 12:36:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13969,6,'                              ','Mircoles 12 de Junio del 13, a las 12:36:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13970,6,'                              ','Mircoles 12 de Junio del 13, a las 12:37:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13971,11,'                              ','Mircoles 12 de Junio del 13, a las 12:40:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13972,11,'                              ','Mircoles 12 de Junio del 13, a las 12:42:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13973,11,'                              ','Mircoles 12 de Junio del 13, a las 12:49:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13974,11,'                              ','Jueves 13 de Junio del 13, a las 13:13:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13975,6,'                              ','Jueves 13 de Junio del 13, a las 13:18:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13976,6,'                              ','Jueves 13 de Junio del 13, a las 13:19:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13977,6,'                              ','Jueves 13 de Junio del 13, a las 13:53:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13978,11,'                              ','Jueves 13 de Junio del 13, a las 13:54:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13979,3,'                              ','Jueves 13 de Junio del 13, a las 14:03:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13980,3,'                              ','Jueves 13 de Junio del 13, a las 14:03:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13981,3,'                              ','Jueves 13 de Junio del 13, a las 14:04:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13982,3,'                              ','Jueves 13 de Junio del 13, a las 14:06:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13983,3,'                              ','Jueves 13 de Junio del 13, a las 14:07:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13984,6,'                              ','Jueves 13 de Junio del 13, a las 14:08:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13985,11,'                              ','Jueves 13 de Junio del 13, a las 14:09:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13986,11,'                              ','Viernes 14 de Junio del 13, a las 10:54:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13987,11,'                              ','Viernes 14 de Junio del 13, a las 11:06:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13988,11,'                              ','Viernes 14 de Junio del 13, a las 11:07:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13989,8,'                              ','Viernes 14 de Junio del 13, a las 11:12:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13990,11,'                              ','Viernes 14 de Junio del 13, a las 11:44:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13991,11,'                              ','Viernes 14 de Junio del 13, a las 11:47:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13992,11,'                              ','Viernes 14 de Junio del 13, a las 11:55:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13993,6,'                              ','Viernes 14 de Junio del 13, a las 12:06:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13994,11,'                              ','Lunes 17 de Junio del 13, a las 14:02:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13995,11,'                              ','Lunes 17 de Junio del 13, a las 14:13:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13996,11,'                              ','Lunes 17 de Junio del 13, a las 14:19:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13997,11,'                              ','Lunes 17 de Junio del 13, a las 14:24:10          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13998,6,'                              ','Lunes 17 de Junio del 13, a las 14:27:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (13999,51,'Direccion                     ','Lunes 17 de Junio del 13, a las 14:31:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14000,51,'Direccion                     ','Lunes 17 de Junio del 13, a las 14:31:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14001,53,'                              ','Lunes 17 de Junio del 13, a las 14:33:23          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14002,11,'                              ','Lunes 17 de Junio del 13, a las 14:38:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14003,6,'                              ','Martes 18 de Junio del 13, a las 13:32:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14004,6,'                              ','Martes 18 de Junio del 13, a las 13:33:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14005,11,'                              ','Martes 18 de Junio del 13, a las 13:45:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14006,6,'                              ','Martes 18 de Junio del 13, a las 13:48:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14007,6,'                              ','Martes 18 de Junio del 13, a las 13:50:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14008,11,'                              ','Martes 18 de Junio del 13, a las 13:56:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14009,11,'                              ','Martes 18 de Junio del 13, a las 16:22:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14010,6,'                              ','Mircoles 19 de Junio del 13, a las 15:38:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14011,6,'                              ','Jueves 20 de Junio del 13, a las 10:03:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14012,6,'                              ','Jueves 20 de Junio del 13, a las 10:04:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14013,6,'                              ','Lunes 22 de Julio del 13, a las 16:59:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14014,6,'                              ','Lunes 22 de Julio del 13, a las 17:01:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14015,6,'                              ','Martes 23 de Julio del 13, a las 11:09:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14016,6,'                              ','Martes 23 de Julio del 13, a las 11:10:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14017,4,'                              ','Martes 23 de Julio del 13, a las 11:34:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14018,3,'                              ','Martes 23 de Julio del 13, a las 11:39:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14019,6,'                              ','Martes 23 de Julio del 13, a las 11:52:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14020,6,'                              ','Martes 23 de Julio del 13, a las 11:57:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14021,6,'                              ','Martes 23 de Julio del 13, a las 12:02:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14022,6,'                              ','Martes 23 de Julio del 13, a las 12:05:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14023,6,'                              ','Martes 23 de Julio del 13, a las 12:06:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14024,6,'                              ','Martes 23 de Julio del 13, a las 12:07:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14025,6,'                              ','Jueves 25 de Julio del 13, a las 10:37:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14026,6,'                              ','Jueves 25 de Julio del 13, a las 10:37:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14027,6,'                              ','Jueves 25 de Julio del 13, a las 10:40:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14028,6,'                              ','Jueves 1 de Agosto del 13, a las 16:26:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14029,6,'                              ','Jueves 1 de Agosto del 13, a las 16:28:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14030,6,'                              ','Jueves 1 de Agosto del 13, a las 16:34:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14031,6,'                              ','Jueves 1 de Agosto del 13, a las 16:36:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14032,6,'                              ','Jueves 1 de Agosto del 13, a las 16:38:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14033,6,'                              ','Jueves 1 de Agosto del 13, a las 16:40:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14034,6,'                              ','Jueves 1 de Agosto del 13, a las 16:41:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14035,6,'                              ','Jueves 1 de Agosto del 13, a las 16:42:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14036,6,'                              ','Jueves 1 de Agosto del 13, a las 16:44:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14037,6,'                              ','Jueves 1 de Agosto del 13, a las 16:45:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14038,6,'                              ','Jueves 1 de Agosto del 13, a las 16:46:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14039,6,'                              ','Jueves 1 de Agosto del 13, a las 16:49:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14040,6,'                              ','Lunes 5 de Agosto del 13, a las 10:03:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14041,6,'                              ','Lunes 5 de Agosto del 13, a las 10:22:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14042,6,'                              ','Lunes 5 de Agosto del 13, a las 10:31:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14043,6,'                              ','Lunes 5 de Agosto del 13, a las 10:33:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14044,6,'                              ','Lunes 5 de Agosto del 13, a las 10:34:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14045,6,'                              ','Lunes 5 de Agosto del 13, a las 10:34:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14046,6,'                              ','Lunes 5 de Agosto del 13, a las 10:35:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14047,6,'                              ','Lunes 5 de Agosto del 13, a las 10:37:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14048,11,'                              ','Martes 6 de Agosto del 13, a las 10:07:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14049,4,'                              ','Mircoles 7 de Agosto del 13, a las 10:57:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14050,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 11:04:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14051,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:05:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14052,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:08:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14053,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 11:09:56      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14054,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 11:11:39      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14055,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:12:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14056,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 11:18:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14057,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:19:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14058,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:20:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14059,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:22:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14060,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 11:24:15      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14061,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:25:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14062,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:28:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14063,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:33:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14064,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:36:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14065,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 11:39:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14066,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:41:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14067,4,'                              ','Mircoles 7 de Agosto del 13, a las 11:43:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14068,3,'                              ','Mircoles 7 de Agosto del 13, a las 11:50:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14069,3,'                              ','Mircoles 7 de Agosto del 13, a las 11:53:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14070,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 12:04:02      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14071,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:05:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14072,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 12:16:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14073,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:18:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14074,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:20:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14075,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 12:22:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14076,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:25:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14077,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 12:30:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14078,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:33:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14079,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:33:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14080,4,'                              ','Mircoles 7 de Agosto del 13, a las 12:35:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14081,2,'Bib Datos Propopios           ','Mircoles 7 de Agosto del 13, a las 12:39:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14082,6,'                              ','Mircoles 7 de Agosto del 13, a las 12:52:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14083,4,'                              ','Mircoles 7 de Agosto del 13, a las 13:00:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14084,11,'                              ','Jueves 8 de Agosto del 13, a las 11:50:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14085,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 11:52:53         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14086,4,'                              ','Jueves 8 de Agosto del 13, a las 11:54:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14087,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 11:56:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14088,4,'                              ','Jueves 8 de Agosto del 13, a las 11:57:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14089,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 11:59:28         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14090,4,'                              ','Jueves 8 de Agosto del 13, a las 12:00:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14091,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:02:29         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14092,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:03:23         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14093,4,'                              ','Jueves 8 de Agosto del 13, a las 12:05:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14094,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:07:19         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14095,4,'                              ','Jueves 8 de Agosto del 13, a las 12:08:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14096,4,'                              ','Jueves 8 de Agosto del 13, a las 12:09:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14097,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:11:40         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14098,4,'                              ','Jueves 8 de Agosto del 13, a las 12:13:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14099,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:14:48         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14100,4,'                              ','Jueves 8 de Agosto del 13, a las 12:16:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14101,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:19:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14102,4,'                              ','Jueves 8 de Agosto del 13, a las 12:20:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14103,2,'Bib Datos Propopios           ','Jueves 8 de Agosto del 13, a las 12:22:14         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14104,4,'                              ','Jueves 8 de Agosto del 13, a las 12:23:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14105,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 13:19:53         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14106,4,'                              ','Lunes 12 de Agosto del 13, a las 13:21:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14107,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 13:23:48         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14108,4,'                              ','Lunes 12 de Agosto del 13, a las 13:25:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14109,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 13:27:28         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14110,4,'                              ','Lunes 12 de Agosto del 13, a las 13:28:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14111,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 13:29:48         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14112,4,'                              ','Lunes 12 de Agosto del 13, a las 13:30:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14113,4,'                              ','Lunes 12 de Agosto del 13, a las 14:14:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14114,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 14:16:30         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14115,4,'                              ','Lunes 12 de Agosto del 13, a las 14:18:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14116,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 14:20:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14117,4,'                              ','Lunes 12 de Agosto del 13, a las 14:21:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14118,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 14:25:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14119,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 14:26:21         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14120,4,'                              ','Lunes 12 de Agosto del 13, a las 14:27:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14121,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 14:31:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14122,4,'                              ','Lunes 12 de Agosto del 13, a las 14:33:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14123,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 16:20:16         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14124,4,'                              ','Lunes 12 de Agosto del 13, a las 16:21:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14125,2,'Bib Datos Propopios           ','Lunes 12 de Agosto del 13, a las 16:23:32         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14126,4,'                              ','Lunes 12 de Agosto del 13, a las 16:26:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14127,4,'                              ','Lunes 12 de Agosto del 13, a las 16:28:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14128,4,'                              ','Lunes 12 de Agosto del 13, a las 16:34:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14129,4,'                              ','Martes 13 de Agosto del 13, a las 10:23:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14130,4,'                              ','Martes 13 de Agosto del 13, a las 10:26:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14131,4,'                              ','Martes 13 de Agosto del 13, a las 10:32:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14132,4,'                              ','Martes 13 de Agosto del 13, a las 10:35:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14133,4,'                              ','Martes 13 de Agosto del 13, a las 10:48:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14134,4,'                              ','Mircoles 14 de Agosto del 13, a las 09:57:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14135,4,'                              ','Mircoles 14 de Agosto del 13, a las 09:59:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14136,3,'                              ','Mircoles 14 de Agosto del 13, a las 10:00:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14137,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:05:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14138,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:09:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14139,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:13:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14140,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:17:45     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14141,2,'Bib Datos Propopios           ','Mircoles 14 de Agosto del 13, a las 10:22:04     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14142,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:23:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14143,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:25:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14144,2,'Bib Datos Propopios           ','Mircoles 14 de Agosto del 13, a las 10:29:15     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14145,3,'                              ','Mircoles 14 de Agosto del 13, a las 10:31:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14146,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:34:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14147,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:35:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14148,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:37:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14149,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:39:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14150,4,'                              ','Mircoles 14 de Agosto del 13, a las 10:44:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14151,6,'                              ','Mircoles 14 de Agosto del 13, a las 12:45:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14152,6,'                              ','Jueves 15 de Agosto del 13, a las 13:17:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14153,4,'                              ','Viernes 16 de Agosto del 13, a las 10:00:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14154,2,'Bib Datos Propopios           ','Viernes 16 de Agosto del 13, a las 10:02:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14155,4,'                              ','Viernes 16 de Agosto del 13, a las 10:04:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14156,2,'Bib Datos Propopios           ','Viernes 16 de Agosto del 13, a las 10:12:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14157,4,'                              ','Viernes 16 de Agosto del 13, a las 10:14:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14158,2,'Bib Datos Propopios           ','Viernes 16 de Agosto del 13, a las 10:19:14       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14159,4,'                              ','Viernes 16 de Agosto del 13, a las 10:28:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14160,4,'                              ','Viernes 16 de Agosto del 13, a las 10:29:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14161,4,'                              ','Viernes 16 de Agosto del 13, a las 10:30:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14162,4,'                              ','Viernes 16 de Agosto del 13, a las 10:31:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14163,4,'                              ','Viernes 16 de Agosto del 13, a las 10:32:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14164,4,'                              ','Viernes 16 de Agosto del 13, a las 10:33:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14165,4,'                              ','Viernes 16 de Agosto del 13, a las 10:35:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14166,4,'                              ','Viernes 16 de Agosto del 13, a las 10:40:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14167,2,'Bib Datos Propopios           ','Viernes 16 de Agosto del 13, a las 10:46:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14168,4,'                              ','Viernes 16 de Agosto del 13, a las 10:53:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14169,4,'                              ','Viernes 16 de Agosto del 13, a las 11:04:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14170,4,'                              ','Viernes 16 de Agosto del 13, a las 11:10:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14171,4,'                              ','Viernes 16 de Agosto del 13, a las 11:14:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14172,2,'Bib Datos Propopios           ','Viernes 16 de Agosto del 13, a las 11:21:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14173,4,'                              ','Viernes 16 de Agosto del 13, a las 11:23:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14174,4,'                              ','Viernes 16 de Agosto del 13, a las 11:25:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14175,3,'                              ','Viernes 16 de Agosto del 13, a las 11:25:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14176,3,'                              ','Viernes 16 de Agosto del 13, a las 11:28:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14177,4,'                              ','Viernes 16 de Agosto del 13, a las 11:32:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14178,4,'                              ','Viernes 16 de Agosto del 13, a las 11:33:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14179,6,'                              ','Viernes 16 de Agosto del 13, a las 11:34:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14180,4,'                              ','Viernes 16 de Agosto del 13, a las 11:35:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14181,4,'                              ','Viernes 16 de Agosto del 13, a las 11:38:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14182,4,'                              ','Viernes 16 de Agosto del 13, a las 11:40:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14183,4,'                              ','Viernes 16 de Agosto del 13, a las 11:41:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14184,4,'                              ','Viernes 16 de Agosto del 13, a las 11:42:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14185,2,'Bib Datos Propopios           ','Martes 20 de Agosto del 13, a las 16:52:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14186,2,'Bib Datos Propopios           ','Martes 20 de Agosto del 13, a las 16:52:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14187,2,'Bib Datos Propopios           ','Martes 20 de Agosto del 13, a las 16:53:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14188,4,'                              ','Martes 20 de Agosto del 13, a las 17:02:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14189,6,'                              ','Mircoles 21 de Agosto del 13, a las 09:56:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14190,6,'                              ','Mircoles 21 de Agosto del 13, a las 09:57:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14191,6,'                              ','Jueves 22 de Agosto del 13, a las 10:26:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14192,6,'                              ','Jueves 22 de Agosto del 13, a las 10:27:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14193,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 10:30:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14194,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 10:39:47        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14195,4,'                              ','Jueves 22 de Agosto del 13, a las 10:40:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14196,4,'                              ','Jueves 22 de Agosto del 13, a las 10:45:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14197,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 10:47:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14198,4,'                              ','Jueves 22 de Agosto del 13, a las 10:48:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14199,3,'                              ','Jueves 22 de Agosto del 13, a las 10:50:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14200,4,'                              ','Jueves 22 de Agosto del 13, a las 10:51:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14201,3,'                              ','Jueves 22 de Agosto del 13, a las 10:52:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14202,4,'                              ','Jueves 22 de Agosto del 13, a las 10:53:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14203,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 10:58:26        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14204,4,'                              ','Jueves 22 de Agosto del 13, a las 10:59:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14205,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 11:01:09        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14206,4,'                              ','Jueves 22 de Agosto del 13, a las 11:02:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14207,4,'                              ','Jueves 22 de Agosto del 13, a las 11:03:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14208,4,'                              ','Jueves 22 de Agosto del 13, a las 11:03:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14209,4,'                              ','Jueves 22 de Agosto del 13, a las 11:05:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14210,3,'                              ','Jueves 22 de Agosto del 13, a las 11:07:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14211,4,'                              ','Jueves 22 de Agosto del 13, a las 11:08:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14212,3,'                              ','Jueves 22 de Agosto del 13, a las 11:09:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14213,4,'                              ','Jueves 22 de Agosto del 13, a las 11:09:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14214,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 11:11:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14215,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 11:11:58        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14216,4,'                              ','Jueves 22 de Agosto del 13, a las 11:12:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14217,4,'                              ','Jueves 22 de Agosto del 13, a las 11:13:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14218,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 11:15:21        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14219,4,'                              ','Jueves 22 de Agosto del 13, a las 11:18:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14220,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 11:20:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14221,4,'                              ','Jueves 22 de Agosto del 13, a las 11:21:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14222,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 11:23:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14223,4,'                              ','Jueves 22 de Agosto del 13, a las 11:24:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14224,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:04:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14225,4,'                              ','Jueves 22 de Agosto del 13, a las 12:05:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14226,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:06:56        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14227,4,'                              ','Jueves 22 de Agosto del 13, a las 12:07:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14228,3,'                              ','Jueves 22 de Agosto del 13, a las 12:09:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14229,3,'                              ','Jueves 22 de Agosto del 13, a las 12:09:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14230,4,'                              ','Jueves 22 de Agosto del 13, a las 12:11:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14231,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:15:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14232,4,'                              ','Jueves 22 de Agosto del 13, a las 12:16:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14233,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:17:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14234,4,'                              ','Jueves 22 de Agosto del 13, a las 12:18:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14235,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:19:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14236,4,'                              ','Jueves 22 de Agosto del 13, a las 12:21:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14237,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:24:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14238,4,'                              ','Jueves 22 de Agosto del 13, a las 12:25:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14239,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:29:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14240,2,'Bib Datos Propopios           ','Jueves 22 de Agosto del 13, a las 12:29:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14241,4,'                              ','Jueves 22 de Agosto del 13, a las 12:31:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14242,2,'Bib Datos Propopios           ','Viernes 23 de Agosto del 13, a las 11:50:37       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14243,4,'                              ','Viernes 23 de Agosto del 13, a las 11:52:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14244,4,'                              ','Viernes 23 de Agosto del 13, a las 11:54:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14245,4,'                              ','Viernes 23 de Agosto del 13, a las 11:57:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14246,2,'Bib Datos Propopios           ','Viernes 23 de Agosto del 13, a las 11:59:55       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14247,4,'                              ','Viernes 23 de Agosto del 13, a las 12:01:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14248,2,'Bib Datos Propopios           ','Viernes 23 de Agosto del 13, a las 12:10:42       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14249,2,'Bib Datos Propopios           ','Viernes 23 de Agosto del 13, a las 12:44:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14250,4,'                              ','Viernes 23 de Agosto del 13, a las 12:44:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14251,4,'                              ','Martes 27 de Agosto del 13, a las 12:49:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14252,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 12:51:17        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14253,4,'                              ','Martes 27 de Agosto del 13, a las 12:52:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14254,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 12:54:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14255,4,'                              ','Martes 27 de Agosto del 13, a las 12:55:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14256,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 12:57:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14257,4,'                              ','Martes 27 de Agosto del 13, a las 12:58:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14258,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 13:01:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14259,4,'                              ','Martes 27 de Agosto del 13, a las 13:02:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14260,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 13:03:24        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14261,4,'                              ','Martes 27 de Agosto del 13, a las 13:03:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14262,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 13:05:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14263,4,'                              ','Martes 27 de Agosto del 13, a las 13:06:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14264,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 13:07:09        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14265,4,'                              ','Martes 27 de Agosto del 13, a las 13:07:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14266,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 13:08:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14267,4,'                              ','Martes 27 de Agosto del 13, a las 13:09:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14268,2,'Bib Datos Propopios           ','Martes 27 de Agosto del 13, a las 13:10:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14269,4,'                              ','Martes 27 de Agosto del 13, a las 13:10:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14270,6,'                              ','Martes 27 de Agosto del 13, a las 15:12:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14271,6,'                              ','Martes 27 de Agosto del 13, a las 15:14:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14272,6,'                              ','Martes 27 de Agosto del 13, a las 15:15:40        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14273,6,'                              ','Martes 27 de Agosto del 13, a las 16:22:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14274,6,'                              ','Viernes 30 de Agosto del 13, a las 10:31:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14275,6,'                              ','Viernes 30 de Agosto del 13, a las 10:38:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14276,6,'                              ','Viernes 30 de Agosto del 13, a las 10:40:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14277,6,'                              ','Martes 3 de Septiembre del 13, a las 10:37:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14278,6,'                              ','Lunes 9 de Septiembre del 13, a las 14:50:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14279,6,'                              ','Lunes 9 de Septiembre del 13, a las 14:50:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14280,6,'                              ','Lunes 9 de Septiembre del 13, a las 14:54:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14281,4,'                              ','Lunes 9 de Septiembre del 13, a las 15:01:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14282,4,'                              ','Lunes 9 de Septiembre del 13, a las 15:02:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14283,2,'Bib Datos Propopios           ','Jueves 19 de Septiembre del 13, a las 10:50:08    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14284,6,'                              ','Viernes 20 de Septiembre del 13, a las 14:30:38   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14285,6,'                              ','Viernes 20 de Septiembre del 13, a las 14:31:46   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14286,6,'                              ','Mircoles 25 de Septiembre del 13, a las 16:15:26 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14287,6,'                              ','Lunes 30 de Septiembre del 13, a las 12:28:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14288,11,'                              ','Lunes 30 de Septiembre del 13, a las 12:41:35     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14289,8,'                              ','Lunes 30 de Septiembre del 13, a las 13:00:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14290,8,'                              ','Lunes 30 de Septiembre del 13, a las 13:13:23     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14291,8,'                              ','Lunes 30 de Septiembre del 13, a las 13:15:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14292,11,'                              ','Lunes 30 de Septiembre del 13, a las 14:21:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14293,11,'                              ','Lunes 30 de Septiembre del 13, a las 16:11:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14294,11,'                              ','Martes 1 de Octubre del 13, a las 10:46:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14295,6,'                              ','Viernes 4 de Octubre del 13, a las 11:27:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14296,6,'                              ','Martes 8 de Octubre del 13, a las 11:14:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14297,4,'                              ','Martes 8 de Octubre del 13, a las 11:18:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14298,4,'                              ','Martes 8 de Octubre del 13, a las 11:19:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14299,4,'                              ','Martes 8 de Octubre del 13, a las 11:24:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14300,4,'                              ','Martes 8 de Octubre del 13, a las 11:29:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14301,4,'                              ','Martes 8 de Octubre del 13, a las 11:34:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14302,4,'                              ','Martes 8 de Octubre del 13, a las 11:35:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14303,4,'                              ','Martes 8 de Octubre del 13, a las 12:37:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14304,4,'                              ','Martes 8 de Octubre del 13, a las 12:43:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14305,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:06:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14306,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:10:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14307,2,'Bib Datos Propopios           ','Mircoles 9 de Octubre del 13, a las 12:12:02     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14308,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:13:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14309,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:15:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14310,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:16:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14311,2,'Bib Datos Propopios           ','Mircoles 9 de Octubre del 13, a las 12:19:16     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14312,2,'Bib Datos Propopios           ','Mircoles 9 de Octubre del 13, a las 12:19:40     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14313,2,'Bib Datos Propopios           ','Mircoles 9 de Octubre del 13, a las 12:20:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14314,2,'Bib Datos Propopios           ','Mircoles 9 de Octubre del 13, a las 12:25:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14315,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:26:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14316,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:27:36     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14317,4,'                              ','Mircoles 9 de Octubre del 13, a las 12:28:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14318,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:17:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14319,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:20:19       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14320,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:20:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14321,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:26:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14322,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:30:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14323,4,'                              ','Jueves 10 de Octubre del 13, a las 14:36:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14324,4,'                              ','Jueves 10 de Octubre del 13, a las 14:41:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14325,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:42:53       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14326,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:45:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14327,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:48:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14328,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:51:11       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14329,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:53:49       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14330,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 14:56:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14331,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 15:00:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14332,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 15:01:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14333,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 15:04:07       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14334,2,'Bib Datos Propopios           ','Jueves 10 de Octubre del 13, a las 15:06:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14335,2,'Bib Datos Propopios           ','Viernes 11 de Octubre del 13, a las 11:30:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14336,2,'Bib Datos Propopios           ','Viernes 11 de Octubre del 13, a las 11:37:01      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14337,2,'Bib Datos Propopios           ','Viernes 11 de Octubre del 13, a las 11:39:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14338,2,'Bib Datos Propopios           ','Lunes 14 de Octubre del 13, a las 12:42:43        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14339,4,'                              ','Lunes 14 de Octubre del 13, a las 12:47:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14340,4,'                              ','Lunes 14 de Octubre del 13, a las 12:49:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14341,4,'                              ','Lunes 14 de Octubre del 13, a las 12:50:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14342,6,'                              ','Martes 15 de Octubre del 13, a las 16:44:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14343,2,'Bib Datos Propopios           ','Mircoles 16 de Octubre del 13, a las 14:43:26    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14344,2,'Bib Datos Propopios           ','Mircoles 16 de Octubre del 13, a las 14:45:40    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14345,2,'Bib Datos Propopios           ','Mircoles 16 de Octubre del 13, a las 14:49:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14346,2,'Bib Datos Propopios           ','Mircoles 16 de Octubre del 13, a las 14:51:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14347,2,'Bib Datos Propopios           ','Mircoles 16 de Octubre del 13, a las 14:53:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14348,6,'                              ','Mircoles 23 de Octubre del 13, a las 11:38:12    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14349,6,'                              ','Mircoles 23 de Octubre del 13, a las 11:38:46    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14350,4,'                              ','Mircoles 23 de Octubre del 13, a las 11:45:56    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14351,4,'                              ','Mircoles 23 de Octubre del 13, a las 12:03:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14352,4,'                              ','Mircoles 23 de Octubre del 13, a las 12:05:50    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14353,4,'                              ','Mircoles 23 de Octubre del 13, a las 12:09:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14354,4,'                              ','Mircoles 23 de Octubre del 13, a las 12:17:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14355,4,'                              ','Mircoles 23 de Octubre del 13, a las 12:21:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14356,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 12:27:01    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14357,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 12:30:20    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14358,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 12:32:06    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14359,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 12:35:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14360,4,'                              ','Mircoles 23 de Octubre del 13, a las 12:37:34    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14361,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 12:59:51    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14362,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 13:10:54    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14363,2,'Bib Datos Propopios           ','Mircoles 23 de Octubre del 13, a las 13:11:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14364,6,'                              ','Lunes 28 de Octubre del 13, a las 09:58:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14365,6,'                              ','Lunes 28 de Octubre del 13, a las 16:19:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14366,6,'                              ','Mircoles 30 de Octubre del 13, a las 14:30:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14367,6,'                              ','Mircoles 30 de Octubre del 13, a las 14:31:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14368,6,'                              ','Mircoles 30 de Octubre del 13, a las 14:36:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14369,2,'Bib Datos Propopios           ','Mircoles 30 de Octubre del 13, a las 17:01:22    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14370,2,'Bib Datos Propopios           ','Jueves 31 de Octubre del 13, a las 17:03:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14371,4,'                              ','Jueves 31 de Octubre del 13, a las 17:05:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14372,6,'                              ','Martes 5 de Noviembre del 13, a las 16:47:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14373,11,'                              ','Mircoles 6 de Noviembre del 13, a las 11:01:39   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14374,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:04:15   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14375,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:04:41   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14376,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:05:07   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14377,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:10:36   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14378,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:12:02   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14379,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:16:12   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14380,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:19:39   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14381,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:21:38   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14382,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:31:06   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14383,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:32:35   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14384,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:33:46   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14385,8,'                              ','Mircoles 6 de Noviembre del 13, a las 11:34:56   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14386,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:43:52   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14387,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:44:58   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14388,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:46:13   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14389,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:47:34   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14390,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:48:45   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14391,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:50:15   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14392,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:52:09   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14393,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:54:47   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14394,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:56:14   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14395,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:58:15   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14396,8,'                              ','Mircoles 6 de Noviembre del 13, a las 12:59:21   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14397,8,'                              ','Mircoles 6 de Noviembre del 13, a las 13:00:22   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14398,8,'                              ','Mircoles 6 de Noviembre del 13, a las 13:01:32   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14399,8,'                              ','Mircoles 6 de Noviembre del 13, a las 13:02:42   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14400,8,'                              ','Mircoles 6 de Noviembre del 13, a las 13:04:20   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14401,8,'                              ','Mircoles 6 de Noviembre del 13, a las 13:06:26   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14402,8,'                              ','Mircoles 6 de Noviembre del 13, a las 13:08:01   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14403,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:46:29   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14404,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:48:55   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14405,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:50:02   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14406,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:51:52   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14407,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:54:03   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14408,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:55:52   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14409,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:57:11   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14410,8,'                              ','Mircoles 6 de Noviembre del 13, a las 16:58:35   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14411,8,'                              ','Mircoles 6 de Noviembre del 13, a las 17:00:39   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14412,8,'                              ','Mircoles 6 de Noviembre del 13, a las 17:01:55   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14413,8,'                              ','Mircoles 6 de Noviembre del 13, a las 17:04:50   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14414,8,'                              ','Jueves 7 de Noviembre del 13, a las 11:52:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14415,8,'                              ','Jueves 7 de Noviembre del 13, a las 11:53:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14416,8,'                              ','Jueves 7 de Noviembre del 13, a las 11:54:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14417,8,'                              ','Jueves 7 de Noviembre del 13, a las 11:56:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14418,8,'                              ','Jueves 7 de Noviembre del 13, a las 11:57:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14419,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:02:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14420,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:03:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14421,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:04:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14422,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:05:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14423,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:06:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14424,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:07:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14425,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:08:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14426,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:09:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14427,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:10:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14428,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:12:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14429,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:15:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14430,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:18:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14431,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:19:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14432,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:22:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14433,8,'                              ','Jueves 7 de Noviembre del 13, a las 12:24:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14434,2,'Bib Datos Propopios           ','Jueves 7 de Noviembre del 13, a las 13:26:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14435,4,'                              ','Jueves 7 de Noviembre del 13, a las 13:29:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14436,11,'                              ','Jueves 7 de Noviembre del 13, a las 13:37:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14437,11,'                              ','Jueves 7 de Noviembre del 13, a las 13:41:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14438,8,'                              ','Jueves 7 de Noviembre del 13, a las 13:42:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14439,8,'                              ','Jueves 7 de Noviembre del 13, a las 13:53:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14440,6,'                              ','Jueves 7 de Noviembre del 13, a las 14:08:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14441,11,'                              ','Jueves 7 de Noviembre del 13, a las 16:30:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14442,11,'                              ','Jueves 7 de Noviembre del 13, a las 16:31:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14443,11,'                              ','Jueves 7 de Noviembre del 13, a las 16:40:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14444,11,'                              ','Jueves 7 de Noviembre del 13, a las 16:43:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14445,11,'                              ','Jueves 7 de Noviembre del 13, a las 16:45:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14446,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:34:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14447,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:36:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14448,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:37:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14449,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:43:11    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14450,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:45:45    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14451,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:54:46    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14452,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:56:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14453,8,'                              ','Viernes 22 de Noviembre del 13, a las 10:57:43    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14454,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:02:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14455,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:08:14    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14456,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:09:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14457,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:12:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14458,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:13:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14459,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:17:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14460,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:18:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14461,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:22:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14462,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:39:23    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14463,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:40:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14464,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:42:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14465,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:43:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14466,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:45:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14467,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:50:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14468,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:51:49    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14469,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:53:04    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14470,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:54:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14471,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:55:47    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14472,8,'                              ','Viernes 22 de Noviembre del 13, a las 11:56:55    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14473,8,'                              ','Viernes 22 de Noviembre del 13, a las 12:00:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14474,8,'                              ','Viernes 22 de Noviembre del 13, a las 12:01:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14475,8,'                              ','Viernes 22 de Noviembre del 13, a las 12:03:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14476,8,'                              ','Viernes 22 de Noviembre del 13, a las 12:04:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14477,8,'                              ','Viernes 22 de Noviembre del 13, a las 12:57:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14478,8,'                              ','Viernes 22 de Noviembre del 13, a las 12:58:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14479,8,'                              ','Viernes 22 de Noviembre del 13, a las 13:00:30    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14480,8,'                              ','Viernes 22 de Noviembre del 13, a las 13:00:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14481,8,'                              ','Viernes 22 de Noviembre del 13, a las 13:18:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14482,8,'                              ','Viernes 22 de Noviembre del 13, a las 13:20:10    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14483,8,'                              ','Viernes 22 de Noviembre del 13, a las 13:21:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14484,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:19:55  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14485,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:21:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14486,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:28:17  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14487,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:29:59  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14488,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:32:05  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14489,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:34:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14490,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:35:33  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14491,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:37:20  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14492,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:39:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14493,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:40:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14494,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:41:36  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14495,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:42:13  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14496,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:45:44  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14497,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:57:36  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14498,8,'                              ','Mircoles 27 de Noviembre del 13, a las 12:58:44  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14499,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:01:57  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14500,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:02:27  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14501,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:04:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14502,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:07:17  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14503,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:13:26  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14504,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:24:53  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14505,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:26:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14506,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:28:07  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14507,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:30:37  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14508,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:32:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14509,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:33:34  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14510,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:34:53  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14511,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:36:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14512,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:38:29  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14513,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:40:09  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14514,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:41:34  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14515,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:42:52  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14516,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:45:43  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14517,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:46:51  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14518,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:48:11  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14519,8,'                              ','Mircoles 27 de Noviembre del 13, a las 13:50:06  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14520,6,'                              ','Mircoles 4 de Diciembre del 13, a las 10:09:18   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14521,6,'                              ','Jueves 5 de Diciembre del 13, a las 13:18:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14522,11,'                              ','Jueves 5 de Diciembre del 13, a las 13:29:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14523,53,'                              ','Jueves 5 de Diciembre del 13, a las 13:30:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14524,4,'                              ','Jueves 5 de Diciembre del 13, a las 14:08:41      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14525,4,'                              ','Jueves 5 de Diciembre del 13, a las 14:09:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14526,6,'                              ','Jueves 5 de Diciembre del 13, a las 14:21:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14527,6,'                              ','Lunes 9 de Diciembre del 13, a las 15:21:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14528,6,'                              ','Martes 10 de Diciembre del 13, a las 11:43:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14529,11,'                              ','Martes 10 de Diciembre del 13, a las 12:09:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14530,11,'                              ','Martes 10 de Diciembre del 13, a las 13:25:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14531,6,'                              ','Martes 10 de Diciembre del 13, a las 16:54:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14532,6,'                              ','Martes 10 de Diciembre del 13, a las 16:58:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14533,6,'                              ','Martes 7 de Enero del 14, a las 11:10:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14534,6,'                              ','Martes 7 de Enero del 14, a las 11:13:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14535,6,'                              ','Martes 7 de Enero del 14, a las 11:20:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14536,6,'                              ','Martes 7 de Enero del 14, a las 11:24:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14537,6,'                              ','Martes 7 de Enero del 14, a las 11:25:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14538,6,'                              ','Martes 7 de Enero del 14, a las 11:30:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14539,6,'                              ','Martes 7 de Enero del 14, a las 14:08:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14540,6,'                              ','Martes 7 de Enero del 14, a las 14:10:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14541,6,'                              ','Martes 7 de Enero del 14, a las 16:40:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14542,6,'                              ','Martes 7 de Enero del 14, a las 16:43:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14543,6,'                              ','Mircoles 8 de Enero del 14, a las 09:58:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14544,11,'                              ','Mircoles 8 de Enero del 14, a las 10:06:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14545,6,'                              ','Mircoles 8 de Enero del 14, a las 16:37:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14546,6,'                              ','Mircoles 8 de Enero del 14, a las 16:41:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14547,6,'                              ','Mircoles 8 de Enero del 14, a las 16:42:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14548,4,'                              ','Mircoles 8 de Enero del 14, a las 16:44:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14549,6,'                              ','Jueves 9 de Enero del 14, a las 13:36:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14550,6,'                              ','Viernes 10 de Enero del 14, a las 10:00:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14551,53,'                              ','Viernes 10 de Enero del 14, a las 10:05:25        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14552,11,'                              ','Viernes 10 de Enero del 14, a las 10:09:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14553,6,'                              ','Viernes 10 de Enero del 14, a las 10:14:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14554,6,'                              ','Viernes 10 de Enero del 14, a las 10:16:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14555,6,'                              ','Viernes 10 de Enero del 14, a las 10:19:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14556,53,'                              ','Viernes 10 de Enero del 14, a las 15:26:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14557,4,'                              ','Viernes 10 de Enero del 14, a las 15:27:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14558,6,'                              ','Martes 14 de Enero del 14, a las 10:26:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14559,6,'                              ','Martes 14 de Enero del 14, a las 10:31:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14560,6,'                              ','Martes 14 de Enero del 14, a las 15:05:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14561,6,'                              ','Martes 14 de Enero del 14, a las 16:12:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14562,6,'                              ','Mircoles 22 de Enero del 14, a las 09:48:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14563,4,'                              ','Viernes 24 de Enero del 14, a las 13:42:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14564,6,'                              ','Jueves 6 de Febrero del 14, a las 10:59:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14565,6,'                              ','Jueves 6 de Febrero del 14, a las 11:04:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14566,6,'                              ','Viernes 7 de Febrero del 14, a las 12:46:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14567,6,'                              ','Viernes 7 de Febrero del 14, a las 12:47:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14568,6,'                              ','Viernes 7 de Febrero del 14, a las 13:02:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14569,53,'                              ','Lunes 10 de Febrero del 14, a las 13:42:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14570,6,'                              ','Martes 11 de Febrero del 14, a las 11:36:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14571,6,'                              ','Viernes 14 de Febrero del 14, a las 14:54:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14572,6,'                              ','Viernes 14 de Febrero del 14, a las 15:02:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14573,51,'Direccion                     ','Lunes 17 de Febrero del 14, a las 18:16:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14574,6,'                              ','Lunes 17 de Febrero del 14, a las 18:17:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14575,6,'                              ','Lunes 17 de Febrero del 14, a las 18:18:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14576,51,'Direccion                     ','Lunes 17 de Febrero del 14, a las 18:20:29        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14577,6,'                              ','Lunes 17 de Febrero del 14, a las 18:21:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14578,6,'                              ','Lunes 17 de Febrero del 14, a las 18:22:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14579,6,'                              ','Martes 18 de Febrero del 14, a las 13:28:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14580,6,'                              ','Martes 18 de Febrero del 14, a las 13:33:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14581,53,'                              ','Martes 18 de Febrero del 14, a las 13:57:54       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14582,11,'                              ','Martes 18 de Febrero del 14, a las 14:01:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14583,8,'                              ','Martes 18 de Febrero del 14, a las 15:08:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14584,4,'                              ','Martes 18 de Febrero del 14, a las 15:10:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14585,6,'                              ','Martes 18 de Febrero del 14, a las 15:13:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14586,4,'                              ','Martes 18 de Febrero del 14, a las 15:20:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14587,53,'                              ','Martes 18 de Febrero del 14, a las 15:23:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14588,6,'                              ','Martes 18 de Febrero del 14, a las 15:35:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14589,8,'                              ','Martes 18 de Febrero del 14, a las 15:49:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14590,11,'                              ','Martes 18 de Febrero del 14, a las 15:53:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14591,11,'                              ','Martes 18 de Febrero del 14, a las 15:53:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14592,2,'Bib Datos Propopios           ','Martes 18 de Febrero del 14, a las 15:55:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14593,2,'Bib Datos Propopios           ','Martes 18 de Febrero del 14, a las 15:55:53       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14594,2,'Bib Datos Propopios           ','Martes 18 de Febrero del 14, a las 15:55:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14595,4,'                              ','Martes 18 de Febrero del 14, a las 15:57:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14596,4,'                              ','Martes 18 de Febrero del 14, a las 15:59:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14597,4,'                              ','Martes 18 de Febrero del 14, a las 16:03:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14598,6,'                              ','Martes 18 de Febrero del 14, a las 16:06:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14599,2,'Bib Datos Propopios           ','Martes 18 de Febrero del 14, a las 16:09:45       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14600,2,'Bib Datos Propopios           ','Martes 18 de Febrero del 14, a las 16:10:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14601,6,'                              ','Martes 18 de Febrero del 14, a las 17:07:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14602,53,'                              ','Mircoles 19 de Febrero del 14, a las 10:56:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14603,4,'                              ','Mircoles 19 de Febrero del 14, a las 10:59:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14604,8,'                              ','Mircoles 19 de Febrero del 14, a las 12:16:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14605,8,'                              ','Mircoles 19 de Febrero del 14, a las 12:21:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14606,2,'Bib Datos Propopios           ','Lunes 24 de Febrero del 14, a las 11:43:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14607,11,'                              ','Lunes 24 de Febrero del 14, a las 11:46:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14608,2,'Bib Datos Propopios           ','Lunes 24 de Febrero del 14, a las 11:53:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14609,11,'                              ','Lunes 24 de Febrero del 14, a las 11:55:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14610,2,'Bib Datos Propopios           ','Martes 4 de Marzo del 14, a las 10:26:29          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14611,6,'                              ','Martes 4 de Marzo del 14, a las 10:32:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14612,6,'                              ','Martes 4 de Marzo del 14, a las 10:35:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14613,2,'Bib Datos Propopios           ','Martes 4 de Marzo del 14, a las 16:18:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14614,6,'                              ','Martes 4 de Marzo del 14, a las 16:22:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14615,2,'Bib Datos Propopios           ','Jueves 6 de Marzo del 14, a las 11:31:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14616,6,'                              ','Jueves 6 de Marzo del 14, a las 11:32:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14617,6,'                              ','Jueves 6 de Marzo del 14, a las 11:33:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14618,6,'                              ','Jueves 6 de Marzo del 14, a las 12:05:22          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14619,6,'                              ','Lunes 10 de Marzo del 14, a las 15:33:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14620,2,'Bib Datos Propopios           ','Lunes 10 de Marzo del 14, a las 15:34:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14621,6,'                              ','Martes 11 de Marzo del 14, a las 14:05:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14622,2,'Bib Datos Propopios           ','Martes 11 de Marzo del 14, a las 14:06:40         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14623,4,'                              ','Martes 11 de Marzo del 14, a las 14:19:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14624,2,'Bib Datos Propopios           ','Martes 11 de Marzo del 14, a las 14:20:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14625,2,'Bib Datos Propopios           ','Martes 11 de Marzo del 14, a las 14:21:33         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14626,2,'Bib Datos Propopios           ','Martes 11 de Marzo del 14, a las 14:23:41         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14627,6,'                              ','Martes 11 de Marzo del 14, a las 14:27:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14628,2,'Bib Datos Propopios           ','Martes 11 de Marzo del 14, a las 14:28:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14629,6,'                              ','Martes 11 de Marzo del 14, a las 14:30:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14630,6,'                              ','Martes 11 de Marzo del 14, a las 14:31:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14631,2,'Bib Datos Propopios           ','Martes 11 de Marzo del 14, a las 14:32:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14632,6,'                              ','Martes 11 de Marzo del 14, a las 14:34:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14633,6,'                              ','Martes 11 de Marzo del 14, a las 14:39:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14634,2,'Bib Datos Propopios           ','Viernes 14 de Marzo del 14, a las 10:24:49        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14635,11,'                              ','Viernes 14 de Marzo del 14, a las 10:29:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14636,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 10:09:49         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14637,6,'                              ','Martes 18 de Marzo del 14, a las 10:12:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14638,6,'                              ','Martes 18 de Marzo del 14, a las 10:21:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14639,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 10:24:29         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14640,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 10:25:23         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14641,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 10:46:57         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14642,6,'                              ','Martes 18 de Marzo del 14, a las 10:50:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14643,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 11:01:23         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14644,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 11:02:27         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14645,2,'Bib Datos Propopios           ','Martes 18 de Marzo del 14, a las 11:05:52         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14646,2,'Bib Datos Propopios           ','Lunes 24 de Marzo del 14, a las 11:02:08          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14647,6,'                              ','Lunes 24 de Marzo del 14, a las 11:20:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14648,2,'Bib Datos Propopios           ','Lunes 24 de Marzo del 14, a las 11:40:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14649,6,'                              ','Lunes 24 de Marzo del 14, a las 12:04:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14650,11,'                              ','Lunes 24 de Marzo del 14, a las 12:14:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14651,11,'                              ','Lunes 24 de Marzo del 14, a las 12:18:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14652,11,'                              ','Lunes 24 de Marzo del 14, a las 12:19:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14653,11,'                              ','Lunes 24 de Marzo del 14, a las 12:23:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14654,11,'                              ','Lunes 24 de Marzo del 14, a las 12:27:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14655,6,'                              ','Lunes 24 de Marzo del 14, a las 14:07:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14656,6,'                              ','Lunes 24 de Marzo del 14, a las 14:08:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14657,2,'Bib Datos Propopios           ','Lunes 24 de Marzo del 14, a las 15:00:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14658,6,'                              ','Lunes 24 de Marzo del 14, a las 15:01:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14659,11,'                              ','Lunes 24 de Marzo del 14, a las 15:01:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14660,2,'Bib Datos Propopios           ','Mircoles 26 de Marzo del 14, a las 11:08:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14661,2,'Bib Datos Propopios           ','Lunes 31 de Marzo del 14, a las 12:05:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14662,6,'                              ','Lunes 31 de Marzo del 14, a las 12:06:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14663,6,'                              ','Lunes 31 de Marzo del 14, a las 12:14:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14664,6,'                              ','Mircoles 2 de Abril del 14, a las 13:32:29       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14665,2,'Bib Datos Propopios           ','Viernes 4 de Abril del 14, a las 09:50:58         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14666,6,'                              ','Viernes 4 de Abril del 14, a las 09:57:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14667,6,'                              ','Viernes 4 de Abril del 14, a las 09:58:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14668,2,'Bib Datos Propopios           ','Viernes 4 de Abril del 14, a las 09:59:01         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14669,2,'Bib Datos Propopios           ','Jueves 10 de Abril del 14, a las 17:35:38         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14670,11,'                              ','Jueves 10 de Abril del 14, a las 17:36:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14671,2,'Bib Datos Propopios           ','Viernes 11 de Abril del 14, a las 17:05:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14672,51,'Direccion                     ','Viernes 11 de Abril del 14, a las 17:07:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14673,53,'                              ','Viernes 11 de Abril del 14, a las 17:09:16        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14674,6,'                              ','Viernes 11 de Abril del 14, a las 17:11:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14675,11,'                              ','Viernes 11 de Abril del 14, a las 17:25:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14676,4,'                              ','Viernes 11 de Abril del 14, a las 17:32:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14677,11,'                              ','Viernes 11 de Abril del 14, a las 17:36:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14678,6,'                              ','Viernes 11 de Abril del 14, a las 17:38:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14679,6,'                              ','Viernes 11 de Abril del 14, a las 17:38:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14680,11,'                              ','Lunes 21 de Abril del 14, a las 12:15:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14681,11,'                              ','Lunes 21 de Abril del 14, a las 12:41:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14682,11,'                              ','Lunes 21 de Abril del 14, a las 12:41:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14683,2,'Bib Datos Propopios           ','Lunes 21 de Abril del 14, a las 12:44:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14684,11,'                              ','Lunes 21 de Abril del 14, a las 12:56:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14685,2,'Bib Datos Propopios           ','Martes 22 de Abril del 14, a las 13:54:43         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14686,6,'                              ','Martes 22 de Abril del 14, a las 13:55:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14687,6,'                              ','Martes 22 de Abril del 14, a las 13:56:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14688,6,'                              ','Martes 22 de Abril del 14, a las 13:57:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14689,6,'                              ','Martes 22 de Abril del 14, a las 13:57:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14690,6,'                              ','Martes 22 de Abril del 14, a las 13:58:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14691,6,'                              ','Martes 22 de Abril del 14, a las 13:59:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14692,6,'                              ','Mircoles 23 de Abril del 14, a las 10:37:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14693,6,'                              ','Mircoles 23 de Abril del 14, a las 11:41:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14694,6,'                              ','Mircoles 23 de Abril del 14, a las 11:43:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14695,2,'Bib Datos Propopios           ','Mircoles 23 de Abril del 14, a las 16:08:16      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14696,6,'                              ','Mircoles 23 de Abril del 14, a las 16:08:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14697,2,'Bib Datos Propopios           ','Jueves 24 de Abril del 14, a las 14:25:20         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14698,2,'Bib Datos Propopios           ','Jueves 24 de Abril del 14, a las 14:33:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14699,2,'Bib Datos Propopios           ','Martes 29 de Abril del 14, a las 11:47:44         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14700,6,'                              ','Martes 29 de Abril del 14, a las 11:49:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14701,11,'                              ','Martes 29 de Abril del 14, a las 11:51:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14702,6,'                              ','Martes 29 de Abril del 14, a las 16:02:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14703,6,'                              ','Martes 29 de Abril del 14, a las 16:04:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14704,6,'                              ','Martes 29 de Abril del 14, a las 16:11:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14705,6,'                              ','Martes 29 de Abril del 14, a las 16:11:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14706,11,'                              ','Martes 29 de Abril del 14, a las 16:12:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14707,2,'Bib Datos Propopios           ','Martes 29 de Abril del 14, a las 16:13:57         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14708,2,'Bib Datos Propopios           ','Martes 29 de Abril del 14, a las 16:14:56         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14709,11,'                              ','Martes 29 de Abril del 14, a las 16:15:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14710,2,'Bib Datos Propopios           ','Martes 29 de Abril del 14, a las 16:16:42         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14711,11,'                              ','Martes 29 de Abril del 14, a las 16:17:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14712,2,'Bib Datos Propopios           ','Martes 29 de Abril del 14, a las 16:18:35         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14713,11,'                              ','Martes 29 de Abril del 14, a las 16:19:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14714,2,'Bib Datos Propopios           ','Martes 29 de Abril del 14, a las 16:20:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14715,11,'                              ','Martes 29 de Abril del 14, a las 16:20:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14716,11,'                              ','Martes 29 de Abril del 14, a las 16:23:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14717,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:38:31           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14718,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:44:58           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14719,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:45:25           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14720,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:45:31           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14721,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:46:40           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14722,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:47:07           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14723,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:48:14           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14724,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:49:00           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14725,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:50:39           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14726,6,'                              ','Martes 6 de Mayo del 14, a las 15:54:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14727,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:55:31           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14728,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:56:12           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14729,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 15:58:48           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14730,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:00:07           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14731,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:02:47           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14732,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:03:40           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14733,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:04:50           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14734,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:46:10           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14735,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:47:21           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14736,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:47:32           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14737,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:48:08           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14738,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:53:25           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14739,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:55:12           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14740,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:55:24           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14741,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:56:09           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14742,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:56:36           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14743,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 16:57:55           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14744,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:00:21           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14745,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:00:53           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14746,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:01:24           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14747,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:02:19           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14748,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:04:03           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14749,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:04:34           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14750,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:04:45           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14751,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:05:49           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14752,2,'Bib Datos Propopios           ','Martes 6 de Mayo del 14, a las 17:06:24           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14753,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 10:05:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14754,6,'                              ','Mircoles 7 de Mayo del 14, a las 10:12:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14755,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 10:16:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14756,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 10:17:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14757,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 10:19:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14758,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 10:20:30        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14759,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 10:26:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14760,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 11:11:17        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14761,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 11:15:24        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14762,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 11:15:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14763,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 11:16:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14764,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 11:20:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14765,2,'Bib Datos Propopios           ','Mircoles 7 de Mayo del 14, a las 12:54:16        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14766,6,'                              ','Mircoles 7 de Mayo del 14, a las 13:07:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14767,6,'                              ','Mircoles 7 de Mayo del 14, a las 13:16:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14768,6,'                              ','Mircoles 7 de Mayo del 14, a las 13:33:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14769,6,'                              ','Mircoles 7 de Mayo del 14, a las 13:34:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14770,6,'                              ','Mircoles 7 de Mayo del 14, a las 13:42:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14771,6,'                              ','Mircoles 7 de Mayo del 14, a las 16:38:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14772,6,'                              ','Mircoles 7 de Mayo del 14, a las 16:39:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14773,6,'                              ','Jueves 8 de Mayo del 14, a las 11:27:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14774,6,'                              ','Jueves 8 de Mayo del 14, a las 11:29:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14775,6,'                              ','Jueves 8 de Mayo del 14, a las 11:32:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14776,6,'                              ','Jueves 8 de Mayo del 14, a las 11:34:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14777,2,'Bib Datos Propopios           ','Jueves 8 de Mayo del 14, a las 11:36:47           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14778,6,'                              ','Jueves 8 de Mayo del 14, a las 11:37:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14779,6,'                              ','Jueves 8 de Mayo del 14, a las 11:44:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14780,6,'                              ','Jueves 8 de Mayo del 14, a las 11:50:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14781,2,'Bib Datos Propopios           ','Jueves 8 de Mayo del 14, a las 12:02:26           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14782,6,'                              ','Jueves 8 de Mayo del 14, a las 12:17:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14783,6,'                              ','Jueves 8 de Mayo del 14, a las 12:20:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14784,2,'Bib Datos Propopios           ','Jueves 8 de Mayo del 14, a las 12:21:33           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14785,6,'                              ','Jueves 8 de Mayo del 14, a las 12:30:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14786,6,'                              ','Lunes 12 de Mayo del 14, a las 13:15:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14787,6,'                              ','Lunes 12 de Mayo del 14, a las 13:16:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14788,6,'                              ','Lunes 12 de Mayo del 14, a las 13:22:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14789,6,'                              ','Lunes 12 de Mayo del 14, a las 13:31:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14790,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 13:43:11           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14791,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 13:44:45           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14792,6,'                              ','Lunes 12 de Mayo del 14, a las 13:46:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14793,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 13:47:23           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14794,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 13:48:18           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14795,6,'                              ','Lunes 12 de Mayo del 14, a las 13:50:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14796,6,'                              ','Lunes 12 de Mayo del 14, a las 13:50:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14797,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 13:51:36           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14798,6,'                              ','Lunes 12 de Mayo del 14, a las 13:55:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14799,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 13:56:03           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14800,6,'                              ','Lunes 12 de Mayo del 14, a las 13:58:13           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14801,6,'                              ','Lunes 12 de Mayo del 14, a las 14:10:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14802,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:10:40           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14803,6,'                              ','Lunes 12 de Mayo del 14, a las 14:15:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14804,6,'                              ','Lunes 12 de Mayo del 14, a las 14:21:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14805,6,'                              ','Lunes 12 de Mayo del 14, a las 14:24:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14806,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:26:20           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14807,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:27:56           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14808,6,'                              ','Lunes 12 de Mayo del 14, a las 14:29:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14809,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:35:25           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14810,6,'                              ','Lunes 12 de Mayo del 14, a las 14:39:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14811,6,'                              ','Lunes 12 de Mayo del 14, a las 14:41:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14812,6,'                              ','Lunes 12 de Mayo del 14, a las 14:43:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14813,6,'                              ','Lunes 12 de Mayo del 14, a las 14:46:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14814,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:49:06           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14815,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:50:02           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14816,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:55:38           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14817,6,'                              ','Lunes 12 de Mayo del 14, a las 14:56:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14818,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:58:05           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14819,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 14:58:58           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14820,6,'                              ','Lunes 12 de Mayo del 14, a las 15:00:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14821,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:01:54           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14822,6,'                              ','Lunes 12 de Mayo del 14, a las 15:03:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14823,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:04:25           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14824,6,'                              ','Lunes 12 de Mayo del 14, a las 15:05:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14825,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:06:24           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14826,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:08:56           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14827,6,'                              ','Lunes 12 de Mayo del 14, a las 15:12:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14828,6,'                              ','Lunes 12 de Mayo del 14, a las 15:16:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14829,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:16:46           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14830,6,'                              ','Lunes 12 de Mayo del 14, a las 15:18:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14831,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:19:27           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14832,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:24:26           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14833,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:27:46           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14834,6,'                              ','Lunes 12 de Mayo del 14, a las 15:29:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14835,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:32:03           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14836,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:33:14           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14837,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:34:20           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14838,6,'                              ','Lunes 12 de Mayo del 14, a las 15:36:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14839,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:36:53           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14840,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:39:07           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14841,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:40:39           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14842,2,'Bib Datos Propopios           ','Lunes 12 de Mayo del 14, a las 15:41:55           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14843,6,'                              ','Lunes 12 de Mayo del 14, a las 15:53:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14844,6,'                              ','Lunes 12 de Mayo del 14, a las 16:00:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14845,6,'                              ','Martes 13 de Mayo del 14, a las 13:30:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14846,6,'                              ','Martes 13 de Mayo del 14, a las 13:34:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14847,2,'Bib Datos Propopios           ','Martes 13 de Mayo del 14, a las 13:36:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14848,2,'Bib Datos Propopios           ','Martes 13 de Mayo del 14, a las 14:00:31          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14849,2,'Bib Datos Propopios           ','Martes 13 de Mayo del 14, a las 14:01:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14850,6,'                              ','Martes 13 de Mayo del 14, a las 14:03:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14851,2,'Bib Datos Propopios           ','Martes 13 de Mayo del 14, a las 14:03:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14852,6,'                              ','Martes 13 de Mayo del 14, a las 17:25:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14853,6,'                              ','Martes 13 de Mayo del 14, a las 17:29:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14854,6,'                              ','Martes 13 de Mayo del 14, a las 17:31:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14855,6,'                              ','Martes 13 de Mayo del 14, a las 17:31:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14856,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:24:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14857,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:31:41       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14858,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:32:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14859,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:41:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14860,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:49:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14861,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:52:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14862,6,'                              ','Mircoles 14 de Mayo del 14, a las 10:57:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14863,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:07:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14864,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:08:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14865,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:12:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14866,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:16:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14867,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:21:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14868,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:26:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14869,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:39:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14870,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:41:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14871,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:44:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14872,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:55:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14873,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:57:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14874,6,'                              ','Mircoles 14 de Mayo del 14, a las 11:59:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14875,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:02:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14876,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:10:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14877,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:13:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14878,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:16:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14879,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:18:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14880,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:23:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14881,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:27:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14882,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:29:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14883,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:38:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14884,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:41:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14885,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:44:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14886,6,'                              ','Mircoles 14 de Mayo del 14, a las 12:48:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14887,6,'                              ','Jueves 22 de Mayo del 14, a las 11:25:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14888,53,'                              ','Jueves 22 de Mayo del 14, a las 15:59:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14889,6,'                              ','Jueves 22 de Mayo del 14, a las 16:00:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14890,6,'                              ','Jueves 22 de Mayo del 14, a las 16:00:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14891,6,'                              ','Jueves 22 de Mayo del 14, a las 16:02:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14892,6,'                              ','Jueves 22 de Mayo del 14, a las 16:19:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14893,6,'                              ','Jueves 22 de Mayo del 14, a las 16:38:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14894,4,'                              ','Jueves 22 de Mayo del 14, a las 16:40:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14895,6,'                              ','Jueves 22 de Mayo del 14, a las 16:44:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14896,6,'                              ','Jueves 22 de Mayo del 14, a las 16:45:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14897,8,'                              ','Jueves 22 de Mayo del 14, a las 16:49:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14898,11,'                              ','Jueves 22 de Mayo del 14, a las 16:54:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14899,11,'                              ','Jueves 22 de Mayo del 14, a las 18:12:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14900,11,'                              ','Jueves 22 de Mayo del 14, a las 18:19:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14901,8,'                              ','Jueves 22 de Mayo del 14, a las 18:21:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14902,53,'                              ','Jueves 22 de Mayo del 14, a las 18:22:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14903,53,'                              ','Jueves 22 de Mayo del 14, a las 18:23:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14904,6,'                              ','Viernes 30 de Mayo del 14, a las 10:47:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14905,6,'                              ','Viernes 30 de Mayo del 14, a las 10:47:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14906,6,'                              ','Martes 3 de Junio del 14, a las 10:54:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14907,6,'                              ','Martes 3 de Junio del 14, a las 10:58:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14908,6,'                              ','Martes 3 de Junio del 14, a las 10:59:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14909,6,'                              ','Jueves 5 de Junio del 14, a las 16:03:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14910,6,'                              ','Jueves 5 de Junio del 14, a las 16:05:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14911,6,'                              ','Jueves 5 de Junio del 14, a las 16:08:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14912,6,'                              ','Jueves 5 de Junio del 14, a las 16:12:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14913,6,'                              ','Jueves 5 de Junio del 14, a las 16:16:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14914,6,'                              ','Jueves 5 de Junio del 14, a las 16:19:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14915,6,'                              ','Jueves 5 de Junio del 14, a las 16:21:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14916,6,'                              ','Jueves 5 de Junio del 14, a las 16:24:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14917,6,'                              ','Jueves 5 de Junio del 14, a las 16:28:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14918,6,'                              ','Jueves 5 de Junio del 14, a las 16:31:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14919,6,'                              ','Jueves 5 de Junio del 14, a las 16:32:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14920,6,'                              ','Jueves 5 de Junio del 14, a las 16:34:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14921,6,'                              ','Jueves 5 de Junio del 14, a las 16:34:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14922,6,'                              ','Jueves 5 de Junio del 14, a las 16:37:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14923,6,'                              ','Jueves 5 de Junio del 14, a las 16:45:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14924,6,'                              ','Jueves 5 de Junio del 14, a las 16:45:45          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14925,6,'                              ','Jueves 5 de Junio del 14, a las 16:58:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14926,6,'                              ','Jueves 5 de Junio del 14, a las 17:04:11          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14927,6,'                              ','Jueves 5 de Junio del 14, a las 17:07:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14928,6,'                              ','Jueves 5 de Junio del 14, a las 17:07:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14929,6,'                              ','Jueves 5 de Junio del 14, a las 17:10:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14930,6,'                              ','Jueves 5 de Junio del 14, a las 17:10:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14931,6,'                              ','Viernes 6 de Junio del 14, a las 12:01:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14932,4,'                              ','Viernes 6 de Junio del 14, a las 15:14:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14933,11,'                              ','Viernes 6 de Junio del 14, a las 15:22:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14934,6,'                              ','Mircoles 11 de Junio del 14, a las 14:40:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14935,6,'                              ','Mircoles 11 de Junio del 14, a las 14:44:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14936,6,'                              ','Mircoles 11 de Junio del 14, a las 14:52:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14937,6,'                              ','Mircoles 11 de Junio del 14, a las 14:52:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14938,6,'                              ','Mircoles 11 de Junio del 14, a las 14:56:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14939,6,'                              ','Mircoles 11 de Junio del 14, a las 15:01:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14940,6,'                              ','Mircoles 11 de Junio del 14, a las 15:04:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14941,6,'                              ','Mircoles 11 de Junio del 14, a las 15:07:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14942,6,'                              ','Mircoles 11 de Junio del 14, a las 15:11:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14943,6,'                              ','Mircoles 11 de Junio del 14, a las 15:14:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14944,6,'                              ','Mircoles 11 de Junio del 14, a las 15:29:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14945,6,'                              ','Mircoles 11 de Junio del 14, a las 15:32:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14946,6,'                              ','Mircoles 11 de Junio del 14, a las 15:34:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14947,6,'                              ','Mircoles 11 de Junio del 14, a las 15:37:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14948,6,'                              ','Mircoles 11 de Junio del 14, a las 15:40:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14949,11,'                              ','Mircoles 11 de Junio del 14, a las 16:59:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14950,6,'                              ','Viernes 20 de Junio del 14, a las 12:28:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14951,6,'                              ','Viernes 20 de Junio del 14, a las 12:31:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14952,6,'                              ','Viernes 20 de Junio del 14, a las 12:32:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14953,6,'                              ','Viernes 20 de Junio del 14, a las 12:33:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14954,6,'                              ','Viernes 20 de Junio del 14, a las 12:35:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14955,6,'                              ','Viernes 20 de Junio del 14, a las 12:37:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14956,6,'                              ','Viernes 20 de Junio del 14, a las 12:38:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14957,6,'                              ','Viernes 20 de Junio del 14, a las 12:40:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14958,6,'                              ','Martes 24 de Junio del 14, a las 16:53:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14959,6,'                              ','Martes 24 de Junio del 14, a las 16:54:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14960,6,'                              ','Martes 24 de Junio del 14, a las 17:01:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14961,6,'                              ','Martes 24 de Junio del 14, a las 17:05:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14962,11,'                              ','Mircoles 25 de Junio del 14, a las 10:59:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14963,11,'                              ','Lunes 30 de Junio del 14, a las 10:04:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14964,11,'                              ','Lunes 30 de Junio del 14, a las 10:06:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14965,11,'                              ','Lunes 30 de Junio del 14, a las 10:06:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14966,11,'                              ','Lunes 30 de Junio del 14, a las 10:10:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14967,6,'                              ','Martes 1 de Julio del 14, a las 09:35:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14968,6,'                              ','Martes 1 de Julio del 14, a las 14:18:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14969,6,'                              ','Martes 1 de Julio del 14, a las 17:04:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14970,6,'                              ','Viernes 4 de Julio del 14, a las 12:02:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14971,6,'                              ','Viernes 4 de Julio del 14, a las 15:10:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14972,11,'                              ','Lunes 28 de Julio del 14, a las 12:31:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14973,11,'                              ','Lunes 28 de Julio del 14, a las 12:32:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14974,4,'                              ','Viernes 1 de Agosto del 14, a las 14:18:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14975,6,'                              ','Viernes 1 de Agosto del 14, a las 14:24:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14976,11,'                              ','Viernes 1 de Agosto del 14, a las 14:26:27        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14977,6,'                              ','Viernes 1 de Agosto del 14, a las 14:29:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14978,11,'                              ','Viernes 1 de Agosto del 14, a las 14:31:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14979,6,'                              ','Viernes 1 de Agosto del 14, a las 17:35:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14980,6,'                              ','Viernes 1 de Agosto del 14, a las 17:38:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14981,8,'                              ','Lunes 4 de Agosto del 14, a las 10:12:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14982,6,'                              ','Martes 5 de Agosto del 14, a las 09:58:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14983,6,'                              ','Martes 5 de Agosto del 14, a las 10:35:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14984,6,'                              ','Martes 5 de Agosto del 14, a las 10:35:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14985,4,'                              ','Martes 5 de Agosto del 14, a las 10:37:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14986,11,'                              ','Martes 5 de Agosto del 14, a las 10:39:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14987,6,'                              ','Martes 5 de Agosto del 14, a las 10:51:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14988,6,'                              ','Martes 5 de Agosto del 14, a las 10:53:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14989,6,'                              ','Martes 5 de Agosto del 14, a las 10:54:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14990,6,'                              ','Martes 5 de Agosto del 14, a las 10:55:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14991,6,'                              ','Martes 5 de Agosto del 14, a las 11:02:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14992,6,'                              ','Martes 5 de Agosto del 14, a las 11:05:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14993,6,'                              ','Martes 5 de Agosto del 14, a las 11:06:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14994,6,'                              ','Martes 5 de Agosto del 14, a las 11:07:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14995,6,'                              ','Martes 5 de Agosto del 14, a las 11:08:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14996,6,'                              ','Martes 5 de Agosto del 14, a las 11:10:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14997,6,'                              ','Martes 5 de Agosto del 14, a las 11:11:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14998,6,'                              ','Martes 5 de Agosto del 14, a las 11:12:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (14999,4,'                              ','Martes 5 de Agosto del 14, a las 15:02:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15000,4,'                              ','Martes 5 de Agosto del 14, a las 15:09:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15001,4,'                              ','Martes 5 de Agosto del 14, a las 15:12:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15002,4,'                              ','Martes 5 de Agosto del 14, a las 15:12:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15003,4,'                              ','Martes 5 de Agosto del 14, a las 15:19:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15004,4,'                              ','Martes 5 de Agosto del 14, a las 15:20:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15005,4,'                              ','Martes 5 de Agosto del 14, a las 15:23:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15006,4,'                              ','Martes 5 de Agosto del 14, a las 15:25:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15007,4,'                              ','Martes 5 de Agosto del 14, a las 15:26:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15008,4,'                              ','Martes 5 de Agosto del 14, a las 15:27:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15009,4,'                              ','Martes 5 de Agosto del 14, a las 15:29:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15010,53,'                              ','Mircoles 6 de Agosto del 14, a las 13:55:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15011,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:02:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15012,53,'                              ','Mircoles 6 de Agosto del 14, a las 14:08:47      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15013,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:14:14      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15014,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:17:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15015,53,'                              ','Mircoles 6 de Agosto del 14, a las 14:21:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15016,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:24:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15017,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:25:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15018,53,'                              ','Mircoles 6 de Agosto del 14, a las 14:29:01      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15019,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:40:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15020,53,'                              ','Mircoles 6 de Agosto del 14, a las 14:46:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15021,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:49:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15022,53,'                              ','Mircoles 6 de Agosto del 14, a las 14:53:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15023,6,'                              ','Mircoles 6 de Agosto del 14, a las 14:55:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15024,11,'                              ','Mircoles 6 de Agosto del 14, a las 14:59:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15025,53,'                              ','Mircoles 6 de Agosto del 14, a las 15:02:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15026,11,'                              ','Mircoles 6 de Agosto del 14, a las 15:05:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15027,53,'                              ','Mircoles 6 de Agosto del 14, a las 15:08:25      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15028,53,'                              ','Mircoles 6 de Agosto del 14, a las 15:09:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15029,11,'                              ','Mircoles 6 de Agosto del 14, a las 15:11:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15030,53,'                              ','Mircoles 6 de Agosto del 14, a las 15:13:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15031,11,'                              ','Mircoles 6 de Agosto del 14, a las 15:17:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15032,2,'Bib Datos Propopios           ','Jueves 7 de Agosto del 14, a las 15:59:28         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15033,2,'Bib Datos Propopios           ','Jueves 7 de Agosto del 14, a las 16:03:02         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15034,6,'                              ','Martes 12 de Agosto del 14, a las 14:19:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15035,6,'                              ','Mircoles 13 de Agosto del 14, a las 13:10:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15036,4,'                              ','Mircoles 13 de Agosto del 14, a las 14:43:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15037,4,'                              ','Mircoles 13 de Agosto del 14, a las 14:46:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15038,4,'                              ','Mircoles 13 de Agosto del 14, a las 15:03:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15039,3,'                              ','Mircoles 13 de Agosto del 14, a las 15:03:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15040,3,'                              ','Mircoles 13 de Agosto del 14, a las 15:03:54     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15041,4,'                              ','Mircoles 13 de Agosto del 14, a las 15:10:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15042,4,'                              ','Mircoles 13 de Agosto del 14, a las 15:55:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15043,4,'                              ','Mircoles 13 de Agosto del 14, a las 15:58:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15044,2,'Bib Datos Propopios           ','Mircoles 13 de Agosto del 14, a las 17:18:16     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15045,2,'Bib Datos Propopios           ','Mircoles 13 de Agosto del 14, a las 17:20:11     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15046,4,'                              ','Mircoles 13 de Agosto del 14, a las 17:21:04     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15047,4,'                              ','Mircoles 13 de Agosto del 14, a las 17:24:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15048,4,'                              ','Mircoles 13 de Agosto del 14, a las 17:25:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15049,6,'                              ','Viernes 15 de Agosto del 14, a las 17:16:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15050,6,'                              ','Viernes 15 de Agosto del 14, a las 17:28:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15051,6,'                              ','Viernes 15 de Agosto del 14, a las 17:30:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15052,6,'                              ','Viernes 15 de Agosto del 14, a las 17:31:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15053,53,'                              ','Viernes 15 de Agosto del 14, a las 17:33:16       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15054,6,'                              ','Lunes 18 de Agosto del 14, a las 11:10:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15055,6,'                              ','Lunes 18 de Agosto del 14, a las 11:12:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15056,6,'                              ','Lunes 18 de Agosto del 14, a las 11:14:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15057,6,'                              ','Lunes 18 de Agosto del 14, a las 11:15:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15058,6,'                              ','Lunes 18 de Agosto del 14, a las 11:17:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15059,4,'                              ','Martes 19 de Agosto del 14, a las 14:18:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15060,4,'                              ','Martes 19 de Agosto del 14, a las 14:40:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15061,11,'                              ','Mircoles 20 de Agosto del 14, a las 12:02:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15062,8,'                              ','Mircoles 20 de Agosto del 14, a las 12:04:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15063,6,'                              ','Mircoles 20 de Agosto del 14, a las 15:53:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15064,4,'                              ','Mircoles 20 de Agosto del 14, a las 17:16:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15065,4,'                              ','Mircoles 20 de Agosto del 14, a las 17:19:12     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15066,4,'                              ','Mircoles 20 de Agosto del 14, a las 17:22:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15067,4,'                              ','Jueves 21 de Agosto del 14, a las 17:31:14        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15068,4,'                              ','Viernes 22 de Agosto del 14, a las 16:11:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15069,6,'                              ','Viernes 22 de Agosto del 14, a las 16:13:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15070,6,'                              ','Viernes 22 de Agosto del 14, a las 17:24:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15071,6,'                              ','Lunes 25 de Agosto del 14, a las 17:11:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15072,6,'                              ','Lunes 25 de Agosto del 14, a las 17:15:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15073,6,'                              ','Lunes 25 de Agosto del 14, a las 17:18:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15074,4,'                              ','Jueves 28 de Agosto del 14, a las 12:27:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15075,4,'                              ','Jueves 28 de Agosto del 14, a las 13:57:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15076,4,'                              ','Jueves 28 de Agosto del 14, a las 14:00:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15077,2,'Bib Datos Propopios           ','Jueves 28 de Agosto del 14, a las 14:02:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15078,4,'                              ','Jueves 28 de Agosto del 14, a las 14:03:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15079,4,'                              ','Jueves 28 de Agosto del 14, a las 14:04:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15080,6,'                              ','Jueves 28 de Agosto del 14, a las 17:20:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15081,2,'Bib Datos Propopios           ','Jueves 28 de Agosto del 14, a las 17:29:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15082,4,'                              ','Jueves 28 de Agosto del 14, a las 17:29:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15083,6,'                              ','Lunes 1 de Septiembre del 14, a las 14:29:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15084,11,'                              ','Lunes 1 de Septiembre del 14, a las 14:37:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15085,11,'                              ','Martes 2 de Septiembre del 14, a las 12:43:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15086,6,'                              ','Martes 2 de Septiembre del 14, a las 13:25:47     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15087,6,'                              ','Martes 2 de Septiembre del 14, a las 13:27:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15088,6,'                              ','Martes 2 de Septiembre del 14, a las 13:28:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15089,6,'                              ','Martes 2 de Septiembre del 14, a las 13:30:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15090,6,'                              ','Martes 2 de Septiembre del 14, a las 13:31:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15091,6,'                              ','Martes 2 de Septiembre del 14, a las 14:50:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15092,6,'                              ','Mircoles 3 de Septiembre del 14, a las 11:10:24  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15093,11,'                              ','Mircoles 3 de Septiembre del 14, a las 16:40:24  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15094,6,'                              ','Mircoles 10 de Septiembre del 14, a las 10:37:26 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15095,6,'                              ','Mircoles 10 de Septiembre del 14, a las 10:39:11 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15096,6,'                              ','Mircoles 10 de Septiembre del 14, a las 10:47:38 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15097,6,'                              ','Mircoles 10 de Septiembre del 14, a las 10:49:06 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15098,6,'                              ','Mircoles 17 de Septiembre del 14, a las 17:42:57 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15099,6,'                              ','Mircoles 17 de Septiembre del 14, a las 17:44:56 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15100,6,'                              ','Mircoles 17 de Septiembre del 14, a las 17:45:20 ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15101,6,'                              ','Martes 7 de Octubre del 14, a las 11:57:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15102,11,'                              ','Martes 7 de Octubre del 14, a las 12:45:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15103,11,'                              ','Martes 7 de Octubre del 14, a las 12:54:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15104,6,'                              ','Martes 7 de Octubre del 14, a las 12:57:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15105,53,'                              ','Mircoles 8 de Octubre del 14, a las 12:22:26     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15106,11,'                              ','Mircoles 8 de Octubre del 14, a las 12:31:57     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15107,11,'                              ','Mircoles 8 de Octubre del 14, a las 12:43:19     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15108,11,'                              ','Mircoles 8 de Octubre del 14, a las 12:44:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15109,11,'                              ','Mircoles 8 de Octubre del 14, a las 12:46:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15110,6,'                              ','Lunes 13 de Octubre del 14, a las 12:16:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15111,11,'                              ','Lunes 13 de Octubre del 14, a las 14:24:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15112,11,'                              ','Lunes 13 de Octubre del 14, a las 14:30:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15113,11,'                              ','Lunes 13 de Octubre del 14, a las 15:39:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15114,11,'                              ','Lunes 13 de Octubre del 14, a las 15:42:43        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15115,11,'                              ','Lunes 13 de Octubre del 14, a las 15:44:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15116,53,'                              ','Lunes 13 de Octubre del 14, a las 15:57:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15117,6,'                              ','Lunes 13 de Octubre del 14, a las 15:58:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15118,6,'                              ','Lunes 13 de Octubre del 14, a las 16:00:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15119,11,'                              ','Lunes 13 de Octubre del 14, a las 16:09:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15120,11,'                              ','Lunes 13 de Octubre del 14, a las 16:14:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15121,11,'                              ','Lunes 13 de Octubre del 14, a las 16:18:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15122,11,'                              ','Lunes 13 de Octubre del 14, a las 17:16:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15123,6,'                              ','Lunes 13 de Octubre del 14, a las 17:18:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15124,53,'                              ','Martes 14 de Octubre del 14, a las 16:52:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15125,6,'                              ','Martes 14 de Octubre del 14, a las 17:33:23       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15126,11,'                              ','Jueves 16 de Octubre del 14, a las 15:41:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15127,11,'                              ','Jueves 16 de Octubre del 14, a las 15:45:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15128,11,'                              ','Jueves 16 de Octubre del 14, a las 15:47:37       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15129,11,'                              ','Jueves 16 de Octubre del 14, a las 16:37:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15130,11,'                              ','Jueves 16 de Octubre del 14, a las 16:38:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15131,11,'                              ','Jueves 16 de Octubre del 14, a las 16:46:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15132,11,'                              ','Jueves 16 de Octubre del 14, a las 16:48:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15133,6,'                              ','Martes 21 de Octubre del 14, a las 11:13:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15134,4,'                              ','Martes 21 de Octubre del 14, a las 11:14:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15135,4,'                              ','Martes 21 de Octubre del 14, a las 11:15:06       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15136,2,'Bib Datos Propopios           ','Jueves 23 de Octubre del 14, a las 13:45:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15137,2,'Bib Datos Propopios           ','Jueves 23 de Octubre del 14, a las 14:05:03       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15138,6,'                              ','Jueves 23 de Octubre del 14, a las 14:13:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15139,53,'                              ','Martes 28 de Octubre del 14, a las 15:11:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15140,53,'                              ','Martes 28 de Octubre del 14, a las 15:13:32       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15141,53,'                              ','Martes 28 de Octubre del 14, a las 15:15:12       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15142,53,'                              ','Martes 28 de Octubre del 14, a las 15:16:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15143,53,'                              ','Martes 28 de Octubre del 14, a las 15:18:31       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15144,53,'                              ','Martes 28 de Octubre del 14, a las 15:20:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15145,53,'                              ','Martes 28 de Octubre del 14, a las 15:20:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15146,53,'                              ','Martes 28 de Octubre del 14, a las 15:22:18       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15147,53,'                              ','Martes 28 de Octubre del 14, a las 15:23:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15148,53,'                              ','Martes 28 de Octubre del 14, a las 15:25:03       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15149,53,'                              ','Martes 28 de Octubre del 14, a las 15:38:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15150,53,'                              ','Martes 28 de Octubre del 14, a las 15:39:35       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15151,53,'                              ','Martes 28 de Octubre del 14, a las 15:40:48       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15152,53,'                              ','Martes 28 de Octubre del 14, a las 15:42:51       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15153,53,'                              ','Martes 28 de Octubre del 14, a las 15:44:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15154,53,'                              ','Martes 28 de Octubre del 14, a las 15:45:43       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15155,53,'                              ','Martes 28 de Octubre del 14, a las 15:46:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15156,53,'                              ','Martes 28 de Octubre del 14, a las 15:55:32       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15157,53,'                              ','Martes 28 de Octubre del 14, a las 15:57:53       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15158,53,'                              ','Martes 28 de Octubre del 14, a las 15:59:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15159,53,'                              ','Martes 28 de Octubre del 14, a las 16:01:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15160,53,'                              ','Martes 28 de Octubre del 14, a las 16:02:49       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15161,53,'                              ','Martes 28 de Octubre del 14, a las 16:04:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15162,53,'                              ','Martes 28 de Octubre del 14, a las 16:04:52       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15163,53,'                              ','Martes 28 de Octubre del 14, a las 16:06:35       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15164,53,'                              ','Martes 28 de Octubre del 14, a las 16:08:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15165,53,'                              ','Martes 28 de Octubre del 14, a las 16:10:50       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15166,53,'                              ','Martes 28 de Octubre del 14, a las 16:12:06       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15167,53,'                              ','Martes 28 de Octubre del 14, a las 16:13:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15168,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:10:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15169,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:12:11    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15170,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:13:19    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15171,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:15:09    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15172,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:17:16    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15173,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:19:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15174,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:20:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15175,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:21:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15176,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:23:10    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15177,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:24:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15178,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:25:15    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15179,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:27:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15180,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:43:53    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15181,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:44:59    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15182,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:46:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15183,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:48:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15184,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:49:11    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15185,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:50:30    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15186,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:52:03    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15187,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:52:23    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15188,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:53:44    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15189,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:55:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15190,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:56:47    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15191,53,'                              ','Mircoles 29 de Octubre del 14, a las 12:58:13    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15192,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:00:04    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15193,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:01:30    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15194,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:02:52    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15195,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:04:17    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15196,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:05:22    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15197,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:06:46    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15198,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:07:55    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15199,53,'                              ','Mircoles 29 de Octubre del 14, a las 13:09:28    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15200,53,'                              ','Jueves 30 de Octubre del 14, a las 11:59:41       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15201,53,'                              ','Jueves 30 de Octubre del 14, a las 12:01:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15202,53,'                              ','Jueves 30 de Octubre del 14, a las 12:03:43       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15203,53,'                              ','Jueves 30 de Octubre del 14, a las 12:05:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15204,53,'                              ','Jueves 30 de Octubre del 14, a las 12:07:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15205,53,'                              ','Jueves 30 de Octubre del 14, a las 12:08:37       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15206,53,'                              ','Jueves 30 de Octubre del 14, a las 12:10:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15207,53,'                              ','Jueves 30 de Octubre del 14, a las 12:13:45       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15208,53,'                              ','Jueves 30 de Octubre del 14, a las 12:15:45       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15209,53,'                              ','Jueves 30 de Octubre del 14, a las 12:19:12       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15210,53,'                              ','Jueves 30 de Octubre del 14, a las 12:21:18       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15211,53,'                              ','Jueves 30 de Octubre del 14, a las 12:23:20       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15212,53,'                              ','Jueves 30 de Octubre del 14, a las 12:24:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15213,53,'                              ','Jueves 30 de Octubre del 14, a las 12:26:23       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15214,53,'                              ','Jueves 30 de Octubre del 14, a las 12:28:17       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15215,53,'                              ','Jueves 30 de Octubre del 14, a las 12:48:08       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15216,53,'                              ','Jueves 30 de Octubre del 14, a las 12:50:56       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15217,53,'                              ','Jueves 30 de Octubre del 14, a las 12:52:12       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15218,53,'                              ','Jueves 30 de Octubre del 14, a las 12:54:43       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15219,53,'                              ','Jueves 30 de Octubre del 14, a las 12:57:03       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15220,53,'                              ','Jueves 30 de Octubre del 14, a las 13:07:15       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15221,53,'                              ','Jueves 30 de Octubre del 14, a las 13:08:16       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15222,53,'                              ','Jueves 30 de Octubre del 14, a las 13:09:31       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15223,53,'                              ','Jueves 30 de Octubre del 14, a las 13:10:26       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15224,53,'                              ','Jueves 30 de Octubre del 14, a las 13:12:10       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15225,53,'                              ','Jueves 30 de Octubre del 14, a las 13:12:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15226,53,'                              ','Jueves 30 de Octubre del 14, a las 13:27:53       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15227,53,'                              ','Jueves 30 de Octubre del 14, a las 13:30:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15228,53,'                              ','Jueves 30 de Octubre del 14, a las 13:36:09       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15229,53,'                              ','Jueves 30 de Octubre del 14, a las 13:36:46       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15230,53,'                              ','Jueves 30 de Octubre del 14, a las 13:39:04       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15231,53,'                              ','Jueves 30 de Octubre del 14, a las 13:40:24       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15232,53,'                              ','Jueves 30 de Octubre del 14, a las 13:42:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15233,53,'                              ','Jueves 30 de Octubre del 14, a las 13:44:06       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15234,53,'                              ','Jueves 30 de Octubre del 14, a las 13:46:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15235,53,'                              ','Jueves 30 de Octubre del 14, a las 13:50:36       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15236,53,'                              ','Jueves 30 de Octubre del 14, a las 13:52:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15237,53,'                              ','Jueves 30 de Octubre del 14, a las 16:02:40       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15238,53,'                              ','Jueves 30 de Octubre del 14, a las 16:04:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15239,53,'                              ','Jueves 30 de Octubre del 14, a las 16:05:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15240,53,'                              ','Jueves 30 de Octubre del 14, a las 16:06:58       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15241,53,'                              ','Jueves 30 de Octubre del 14, a las 16:08:52       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15242,53,'                              ','Jueves 30 de Octubre del 14, a las 16:11:10       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15243,53,'                              ','Jueves 30 de Octubre del 14, a las 16:12:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15244,53,'                              ','Jueves 30 de Octubre del 14, a las 16:13:30       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15245,53,'                              ','Jueves 30 de Octubre del 14, a las 16:14:57       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15246,53,'                              ','Jueves 30 de Octubre del 14, a las 16:16:27       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15247,53,'                              ','Jueves 30 de Octubre del 14, a las 16:22:25       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15248,53,'                              ','Jueves 30 de Octubre del 14, a las 16:27:23       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15249,53,'                              ','Jueves 30 de Octubre del 14, a las 16:32:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15250,53,'                              ','Lunes 3 de Noviembre del 14, a las 11:43:31       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15251,53,'                              ','Lunes 3 de Noviembre del 14, a las 11:45:34       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15252,53,'                              ','Lunes 3 de Noviembre del 14, a las 11:48:35       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15253,53,'                              ','Martes 4 de Noviembre del 14, a las 11:30:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15254,53,'                              ','Martes 4 de Noviembre del 14, a las 11:32:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15255,53,'                              ','Martes 4 de Noviembre del 14, a las 11:43:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15256,53,'                              ','Martes 4 de Noviembre del 14, a las 11:45:06      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15257,53,'                              ','Martes 4 de Noviembre del 14, a las 11:46:24      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15258,53,'                              ','Martes 4 de Noviembre del 14, a las 11:47:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15259,53,'                              ','Martes 4 de Noviembre del 14, a las 11:49:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15260,53,'                              ','Martes 4 de Noviembre del 14, a las 11:51:34      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15261,53,'                              ','Martes 4 de Noviembre del 14, a las 11:52:41      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15262,53,'                              ','Martes 4 de Noviembre del 14, a las 11:53:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15263,53,'                              ','Martes 4 de Noviembre del 14, a las 11:55:30      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15264,53,'                              ','Martes 4 de Noviembre del 14, a las 11:56:08      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15265,53,'                              ','Martes 4 de Noviembre del 14, a las 11:57:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15266,53,'                              ','Martes 4 de Noviembre del 14, a las 12:00:22      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15267,53,'                              ','Martes 4 de Noviembre del 14, a las 12:00:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15268,53,'                              ','Martes 4 de Noviembre del 14, a las 12:01:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15269,53,'                              ','Martes 4 de Noviembre del 14, a las 12:08:22      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15270,53,'                              ','Martes 4 de Noviembre del 14, a las 12:08:41      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15271,53,'                              ','Martes 4 de Noviembre del 14, a las 12:19:35      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15272,53,'                              ','Martes 4 de Noviembre del 14, a las 12:31:02      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15273,53,'                              ','Martes 4 de Noviembre del 14, a las 12:32:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15274,53,'                              ','Martes 4 de Noviembre del 14, a las 12:43:20      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15275,53,'                              ','Martes 4 de Noviembre del 14, a las 12:44:36      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15276,53,'                              ','Martes 4 de Noviembre del 14, a las 12:44:48      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15277,53,'                              ','Martes 4 de Noviembre del 14, a las 12:47:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15278,53,'                              ','Martes 4 de Noviembre del 14, a las 12:48:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15279,53,'                              ','Martes 4 de Noviembre del 14, a las 12:49:59      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15280,53,'                              ','Martes 4 de Noviembre del 14, a las 12:50:56      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15281,53,'                              ','Martes 4 de Noviembre del 14, a las 12:52:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15282,53,'                              ','Martes 4 de Noviembre del 14, a las 12:54:26      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15283,53,'                              ','Martes 4 de Noviembre del 14, a las 12:57:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15284,53,'                              ','Martes 4 de Noviembre del 14, a las 12:59:10      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15285,53,'                              ','Martes 4 de Noviembre del 14, a las 13:04:37      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15286,53,'                              ','Martes 4 de Noviembre del 14, a las 13:06:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15287,53,'                              ','Martes 4 de Noviembre del 14, a las 13:08:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15288,53,'                              ','Martes 4 de Noviembre del 14, a las 13:10:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15289,53,'                              ','Martes 4 de Noviembre del 14, a las 13:12:08      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15290,53,'                              ','Martes 4 de Noviembre del 14, a las 13:13:27      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15291,53,'                              ','Martes 4 de Noviembre del 14, a las 13:14:55      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15292,53,'                              ','Martes 4 de Noviembre del 14, a las 13:18:53      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15293,53,'                              ','Martes 4 de Noviembre del 14, a las 13:22:18      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15294,53,'                              ','Martes 4 de Noviembre del 14, a las 13:25:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15295,53,'                              ','Martes 4 de Noviembre del 14, a las 13:25:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15296,53,'                              ','Martes 4 de Noviembre del 14, a las 13:32:22      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15297,53,'                              ','Martes 4 de Noviembre del 14, a las 13:33:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15298,53,'                              ','Martes 4 de Noviembre del 14, a las 13:34:58      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15299,53,'                              ','Martes 4 de Noviembre del 14, a las 13:37:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15300,53,'                              ','Martes 4 de Noviembre del 14, a las 13:38:17      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15301,53,'                              ','Martes 4 de Noviembre del 14, a las 13:39:26      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15302,53,'                              ','Martes 4 de Noviembre del 14, a las 13:40:43      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15303,53,'                              ','Martes 4 de Noviembre del 14, a las 13:44:07      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15304,53,'                              ','Martes 4 de Noviembre del 14, a las 13:45:33      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15305,53,'                              ','Martes 4 de Noviembre del 14, a las 13:47:02      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15306,53,'                              ','Martes 4 de Noviembre del 14, a las 13:48:41      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15307,53,'                              ','Martes 4 de Noviembre del 14, a las 13:52:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15308,53,'                              ','Martes 4 de Noviembre del 14, a las 13:52:57      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15309,53,'                              ','Martes 4 de Noviembre del 14, a las 13:54:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15310,53,'                              ','Martes 4 de Noviembre del 14, a las 13:55:42      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15311,53,'                              ','Martes 4 de Noviembre del 14, a las 13:56:54      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15312,53,'                              ','Martes 4 de Noviembre del 14, a las 13:58:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15313,53,'                              ','Martes 4 de Noviembre del 14, a las 14:02:33      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15314,6,'                              ','Lunes 10 de Noviembre del 14, a las 10:21:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15315,6,'                              ','Mircoles 19 de Noviembre del 14, a las 10:27:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15316,4,'                              ','Mircoles 19 de Noviembre del 14, a las 11:06:19  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15317,2,'Bib Datos Propopios           ','Mircoles 19 de Noviembre del 14, a las 11:11:29  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15318,2,'Bib Datos Propopios           ','Mircoles 19 de Noviembre del 14, a las 11:23:02  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15319,4,'                              ','Mircoles 19 de Noviembre del 14, a las 11:32:27  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15320,2,'Bib Datos Propopios           ','Mircoles 19 de Noviembre del 14, a las 11:40:47  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15321,4,'                              ','Mircoles 19 de Noviembre del 14, a las 11:49:17  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15322,8,'                              ','Mircoles 19 de Noviembre del 14, a las 11:59:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15323,8,'                              ','Mircoles 19 de Noviembre del 14, a las 12:00:55  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15324,2,'Bib Datos Propopios           ','Jueves 20 de Noviembre del 14, a las 12:26:28     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15325,2,'Bib Datos Propopios           ','Jueves 20 de Noviembre del 14, a las 12:30:31     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15326,2,'Bib Datos Propopios           ','Jueves 20 de Noviembre del 14, a las 12:34:36     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15327,4,'                              ','Jueves 20 de Noviembre del 14, a las 12:43:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15328,2,'Bib Datos Propopios           ','Jueves 20 de Noviembre del 14, a las 12:59:30     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15329,2,'Bib Datos Propopios           ','Jueves 20 de Noviembre del 14, a las 12:59:44     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15330,6,'                              ','Martes 25 de Noviembre del 14, a las 15:47:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15331,6,'                              ','Martes 2 de Diciembre del 14, a las 16:47:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15332,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 11:40:29       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15333,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 11:45:02       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15334,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 11:45:39       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15335,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 11:51:13       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15336,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 11:58:00       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15337,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 12:03:59       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15338,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 12:04:47       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15339,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 12:06:01       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15340,2,'Bib Datos Propopios           ','Lunes 8 de Diciembre del 14, a las 12:10:21       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15341,6,'                              ','Mircoles 10 de Diciembre del 14, a las 14:53:04  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15342,2,'Bib Datos Propopios           ','Mircoles 10 de Diciembre del 14, a las 14:55:45  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15343,6,'                              ','Lunes 5 de Enero del 15, a las 16:32:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15344,6,'                              ','Lunes 5 de Enero del 15, a las 16:33:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15345,6,'                              ','Lunes 12 de Enero del 15, a las 14:29:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15346,6,'                              ','Lunes 12 de Enero del 15, a las 14:41:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15347,6,'                              ','Lunes 12 de Enero del 15, a las 15:57:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15348,4,'                              ','Lunes 12 de Enero del 15, a las 16:00:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15349,4,'                              ','Lunes 12 de Enero del 15, a las 16:01:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15350,4,'                              ','Lunes 12 de Enero del 15, a las 16:10:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15351,4,'                              ','Lunes 12 de Enero del 15, a las 16:11:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15352,4,'                              ','Lunes 12 de Enero del 15, a las 16:11:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15353,4,'                              ','Lunes 12 de Enero del 15, a las 16:14:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15354,4,'                              ','Lunes 12 de Enero del 15, a las 16:15:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15355,6,'                              ','Mircoles 14 de Enero del 15, a las 13:42:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15356,4,'                              ','Jueves 15 de Enero del 15, a las 11:48:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15357,4,'                              ','Jueves 15 de Enero del 15, a las 11:50:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15358,4,'                              ','Jueves 15 de Enero del 15, a las 11:50:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15359,53,'                              ','Jueves 15 de Enero del 15, a las 11:52:49         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15360,51,'Direccion                     ','Jueves 15 de Enero del 15, a las 11:54:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15361,6,'                              ','Jueves 15 de Enero del 15, a las 16:57:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15362,4,'                              ','Jueves 15 de Enero del 15, a las 16:59:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15363,4,'                              ','Jueves 15 de Enero del 15, a las 17:01:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15364,4,'                              ','Jueves 15 de Enero del 15, a las 17:02:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15365,4,'                              ','Jueves 15 de Enero del 15, a las 17:04:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15366,6,'                              ','Lunes 19 de Enero del 15, a las 14:12:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15367,6,'                              ','Lunes 19 de Enero del 15, a las 17:22:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15368,4,'                              ','Martes 20 de Enero del 15, a las 11:32:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15369,4,'                              ','Martes 20 de Enero del 15, a las 11:53:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15370,6,'                              ','Martes 20 de Enero del 15, a las 15:19:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15371,3,'                              ','Martes 20 de Enero del 15, a las 17:19:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15372,4,'                              ','Martes 20 de Enero del 15, a las 17:20:33         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15373,4,'                              ','Martes 20 de Enero del 15, a las 17:23:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15374,4,'                              ','Martes 20 de Enero del 15, a las 17:25:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15375,4,'                              ','Martes 20 de Enero del 15, a las 17:28:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15376,6,'                              ','Mircoles 21 de Enero del 15, a las 12:04:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15377,6,'                              ','Mircoles 21 de Enero del 15, a las 12:07:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15378,6,'                              ','Mircoles 21 de Enero del 15, a las 12:17:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15379,6,'                              ','Mircoles 21 de Enero del 15, a las 12:19:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15380,6,'                              ','Mircoles 21 de Enero del 15, a las 12:21:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15381,6,'                              ','Mircoles 21 de Enero del 15, a las 12:26:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15382,6,'                              ','Mircoles 21 de Enero del 15, a las 12:29:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15383,6,'                              ','Mircoles 21 de Enero del 15, a las 12:42:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15384,4,'                              ','Mircoles 21 de Enero del 15, a las 13:30:46      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15385,6,'                              ','Mircoles 21 de Enero del 15, a las 15:32:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15386,6,'                              ','Jueves 22 de Enero del 15, a las 11:06:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15387,6,'                              ','Jueves 22 de Enero del 15, a las 11:11:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15388,6,'                              ','Jueves 22 de Enero del 15, a las 14:57:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15389,6,'                              ','Lunes 26 de Enero del 15, a las 13:14:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15390,11,'                              ','Lunes 26 de Enero del 15, a las 13:17:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15391,6,'                              ','Lunes 26 de Enero del 15, a las 13:20:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15392,11,'                              ','Lunes 26 de Enero del 15, a las 13:24:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15393,11,'                              ','Lunes 26 de Enero del 15, a las 14:08:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15394,53,'                              ','Lunes 26 de Enero del 15, a las 14:11:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15395,11,'                              ','Lunes 26 de Enero del 15, a las 14:13:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15396,11,'                              ','Lunes 26 de Enero del 15, a las 14:16:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15397,6,'                              ','Lunes 26 de Enero del 15, a las 14:26:20          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15398,11,'                              ','Lunes 26 de Enero del 15, a las 14:30:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15399,11,'                              ','Martes 27 de Enero del 15, a las 11:59:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15400,11,'                              ','Martes 27 de Enero del 15, a las 11:59:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15401,11,'                              ','Martes 27 de Enero del 15, a las 12:28:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15402,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 12:33:25         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15403,11,'                              ','Martes 27 de Enero del 15, a las 12:43:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15404,11,'                              ','Martes 27 de Enero del 15, a las 12:51:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15405,11,'                              ','Martes 27 de Enero del 15, a las 12:52:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15406,6,'                              ','Martes 27 de Enero del 15, a las 12:57:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15407,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 13:00:19         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15408,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 13:00:26         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15409,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 13:00:31         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15410,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 13:01:51         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15411,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 13:01:59         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15412,2,'Bib Datos Propopios           ','Martes 27 de Enero del 15, a las 13:02:04         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15413,11,'                              ','Mircoles 28 de Enero del 15, a las 11:28:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15414,6,'                              ','Mircoles 28 de Enero del 15, a las 11:33:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15415,4,'                              ','Jueves 29 de Enero del 15, a las 10:06:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15416,4,'                              ','Jueves 29 de Enero del 15, a las 10:08:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15417,4,'                              ','Jueves 29 de Enero del 15, a las 10:12:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15418,6,'                              ','Jueves 5 de Febrero del 15, a las 10:55:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15419,53,'                              ','Martes 10 de Febrero del 15, a las 13:13:43       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15420,6,'                              ','Martes 10 de Febrero del 15, a las 13:17:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15421,6,'                              ','Martes 10 de Febrero del 15, a las 13:20:07       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15422,11,'                              ','Martes 10 de Febrero del 15, a las 13:28:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15423,4,'                              ','Martes 10 de Febrero del 15, a las 13:30:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15424,4,'                              ','Martes 10 de Febrero del 15, a las 13:31:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15425,6,'                              ','Mircoles 11 de Febrero del 15, a las 14:13:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15426,11,'                              ','Jueves 12 de Febrero del 15, a las 11:17:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15427,6,'                              ','Jueves 12 de Febrero del 15, a las 11:26:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15428,6,'                              ','Jueves 12 de Febrero del 15, a las 13:56:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15429,6,'                              ','Jueves 12 de Febrero del 15, a las 13:57:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15430,6,'                              ','Jueves 12 de Febrero del 15, a las 14:19:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15431,6,'                              ','Jueves 12 de Febrero del 15, a las 14:20:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15432,6,'                              ','Jueves 12 de Febrero del 15, a las 14:23:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15433,6,'                              ','Jueves 12 de Febrero del 15, a las 17:17:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15434,6,'                              ','Jueves 12 de Febrero del 15, a las 17:18:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15435,6,'                              ','Viernes 13 de Febrero del 15, a las 13:41:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15436,11,'                              ','Viernes 13 de Febrero del 15, a las 14:56:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15437,6,'                              ','Lunes 16 de Febrero del 15, a las 10:54:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15438,11,'                              ','Lunes 16 de Febrero del 15, a las 11:08:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15439,6,'                              ','Lunes 16 de Febrero del 15, a las 16:11:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15440,6,'                              ','Lunes 16 de Febrero del 15, a las 16:11:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15441,6,'                              ','Martes 17 de Febrero del 15, a las 12:16:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15442,6,'                              ','Martes 17 de Febrero del 15, a las 12:40:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15443,6,'                              ','Martes 17 de Febrero del 15, a las 12:41:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15444,6,'                              ','Martes 17 de Febrero del 15, a las 13:13:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15445,6,'                              ','Martes 17 de Febrero del 15, a las 14:57:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15446,6,'                              ','Martes 17 de Febrero del 15, a las 14:59:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15447,6,'                              ','Martes 17 de Febrero del 15, a las 15:01:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15448,6,'                              ','Martes 17 de Febrero del 15, a las 15:04:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15449,6,'                              ','Martes 17 de Febrero del 15, a las 15:06:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15450,53,'                              ','Mircoles 18 de Febrero del 15, a las 13:10:29    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15451,53,'                              ','Mircoles 18 de Febrero del 15, a las 13:11:12    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15452,53,'                              ','Mircoles 18 de Febrero del 15, a las 13:12:42    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15453,53,'                              ','Mircoles 18 de Febrero del 15, a las 13:13:07    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15454,6,'                              ','Mircoles 18 de Febrero del 15, a las 13:13:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15455,6,'                              ','Mircoles 25 de Febrero del 15, a las 12:21:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15456,6,'                              ','Mircoles 25 de Febrero del 15, a las 12:44:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15457,6,'                              ','Mircoles 25 de Febrero del 15, a las 12:45:40    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15458,11,'                              ','Mircoles 25 de Febrero del 15, a las 12:46:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15459,6,'                              ','Mircoles 25 de Febrero del 15, a las 17:51:07    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15460,6,'                              ','Jueves 26 de Febrero del 15, a las 15:14:35       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15461,6,'                              ','Jueves 26 de Febrero del 15, a las 15:15:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15462,6,'                              ','Jueves 26 de Febrero del 15, a las 15:16:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15463,6,'                              ','Jueves 26 de Febrero del 15, a las 15:17:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15464,6,'                              ','Jueves 26 de Febrero del 15, a las 15:18:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15465,11,'                              ','Viernes 27 de Febrero del 15, a las 10:57:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15466,53,'                              ','Viernes 27 de Febrero del 15, a las 11:06:03      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15467,53,'                              ','Viernes 27 de Febrero del 15, a las 11:46:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15468,51,'Direccion                     ','Viernes 27 de Febrero del 15, a las 11:47:42      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15469,53,'                              ','Viernes 27 de Febrero del 15, a las 11:48:19      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15470,53,'                              ','Viernes 27 de Febrero del 15, a las 11:49:38      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15471,53,'                              ','Viernes 27 de Febrero del 15, a las 11:51:34      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15472,51,'Direccion                     ','Viernes 27 de Febrero del 15, a las 11:52:41      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15473,53,'                              ','Viernes 27 de Febrero del 15, a las 11:53:09      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15474,51,'Direccion                     ','Viernes 27 de Febrero del 15, a las 11:54:21      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15475,53,'                              ','Viernes 27 de Febrero del 15, a las 11:54:49      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15476,53,'                              ','Viernes 27 de Febrero del 15, a las 12:23:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15477,11,'                              ','Viernes 27 de Febrero del 15, a las 16:49:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15478,53,'                              ','Viernes 27 de Febrero del 15, a las 16:50:24      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15479,11,'                              ','Viernes 27 de Febrero del 15, a las 17:07:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15480,6,'                              ','Jueves 5 de Marzo del 15, a las 15:08:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15481,6,'                              ','Martes 10 de Marzo del 15, a las 14:57:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15482,6,'                              ','Viernes 20 de Marzo del 15, a las 14:25:52        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15483,6,'                              ','Viernes 20 de Marzo del 15, a las 14:28:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15484,11,'                              ','Viernes 20 de Marzo del 15, a las 14:34:07        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15485,11,'                              ','Viernes 20 de Marzo del 15, a las 15:00:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15486,53,'                              ','Viernes 20 de Marzo del 15, a las 15:06:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15487,11,'                              ','Viernes 20 de Marzo del 15, a las 15:12:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15488,11,'                              ','Viernes 20 de Marzo del 15, a las 15:12:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15489,11,'                              ','Viernes 20 de Marzo del 15, a las 16:58:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15490,11,'                              ','Viernes 20 de Marzo del 15, a las 17:04:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15491,11,'                              ','Viernes 20 de Marzo del 15, a las 17:05:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15492,11,'                              ','Viernes 20 de Marzo del 15, a las 17:05:39        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15493,6,'                              ','Viernes 20 de Marzo del 15, a las 17:30:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15494,11,'                              ','Viernes 20 de Marzo del 15, a las 17:35:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15495,11,'                              ','Viernes 20 de Marzo del 15, a las 17:35:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15496,11,'                              ','Lunes 23 de Marzo del 15, a las 12:55:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15497,11,'                              ','Lunes 23 de Marzo del 15, a las 12:57:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15498,11,'                              ','Lunes 23 de Marzo del 15, a las 13:08:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15499,53,'                              ','Lunes 23 de Marzo del 15, a las 13:15:38          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15500,6,'                              ','Lunes 23 de Marzo del 15, a las 13:16:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15501,8,'                              ','Lunes 23 de Marzo del 15, a las 13:17:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15502,11,'                              ','Lunes 23 de Marzo del 15, a las 13:21:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15503,53,'                              ','Lunes 23 de Marzo del 15, a las 13:29:38          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15504,11,'                              ','Lunes 23 de Marzo del 15, a las 13:32:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15505,11,'                              ','Lunes 23 de Marzo del 15, a las 14:08:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15506,11,'                              ','Lunes 23 de Marzo del 15, a las 14:21:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15507,6,'                              ','Lunes 23 de Marzo del 15, a las 14:26:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15508,6,'                              ','Lunes 23 de Marzo del 15, a las 14:27:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15509,11,'                              ','Lunes 23 de Marzo del 15, a las 14:59:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15510,11,'                              ','Lunes 23 de Marzo del 15, a las 15:02:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15511,11,'                              ','Lunes 23 de Marzo del 15, a las 15:38:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15512,11,'                              ','Lunes 23 de Marzo del 15, a las 15:39:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15513,11,'                              ','Lunes 23 de Marzo del 15, a las 15:40:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15514,11,'                              ','Lunes 23 de Marzo del 15, a las 15:43:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15515,11,'                              ','Martes 24 de Marzo del 15, a las 12:38:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15516,11,'                              ','Martes 24 de Marzo del 15, a las 12:42:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15517,11,'                              ','Martes 24 de Marzo del 15, a las 12:43:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15518,6,'                              ','Martes 24 de Marzo del 15, a las 12:45:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15519,11,'                              ','Martes 24 de Marzo del 15, a las 12:52:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15520,6,'                              ','Martes 24 de Marzo del 15, a las 12:59:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15521,11,'                              ','Martes 24 de Marzo del 15, a las 12:59:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15522,11,'                              ','Martes 24 de Marzo del 15, a las 13:00:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15523,53,'                              ','Martes 24 de Marzo del 15, a las 13:03:08         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15524,11,'                              ','Martes 24 de Marzo del 15, a las 13:05:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15525,6,'                              ','Martes 24 de Marzo del 15, a las 13:39:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15526,11,'                              ','Martes 24 de Marzo del 15, a las 13:41:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15527,53,'                              ','Martes 24 de Marzo del 15, a las 13:44:06         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15528,11,'                              ','Martes 24 de Marzo del 15, a las 13:46:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15529,6,'                              ','Mircoles 25 de Marzo del 15, a las 12:18:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15530,6,'                              ','Mircoles 25 de Marzo del 15, a las 12:24:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15531,11,'                              ','Mircoles 25 de Marzo del 15, a las 12:31:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15532,11,'                              ','Mircoles 25 de Marzo del 15, a las 12:35:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15533,6,'                              ','Mircoles 25 de Marzo del 15, a las 16:24:37      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15534,11,'                              ','Mircoles 25 de Marzo del 15, a las 17:15:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15535,6,'                              ','Jueves 26 de Marzo del 15, a las 10:38:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15536,6,'                              ','Lunes 6 de Abril del 15, a las 11:32:56           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15537,6,'                              ','Lunes 6 de Abril del 15, a las 11:34:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15538,6,'                              ','Lunes 6 de Abril del 15, a las 11:35:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15539,6,'                              ','Lunes 6 de Abril del 15, a las 11:38:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15540,6,'                              ','Lunes 6 de Abril del 15, a las 11:39:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15541,6,'                              ','Lunes 6 de Abril del 15, a las 11:41:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15542,6,'                              ','Lunes 6 de Abril del 15, a las 14:11:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15543,6,'                              ','Lunes 6 de Abril del 15, a las 14:17:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15544,6,'                              ','Lunes 6 de Abril del 15, a las 15:16:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15545,6,'                              ','Lunes 6 de Abril del 15, a las 15:17:36           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15546,6,'                              ','Lunes 6 de Abril del 15, a las 15:18:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15547,6,'                              ','Lunes 6 de Abril del 15, a las 15:19:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15548,6,'                              ','Lunes 6 de Abril del 15, a las 15:21:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15549,6,'                              ','Lunes 6 de Abril del 15, a las 15:22:22           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15550,6,'                              ','Lunes 6 de Abril del 15, a las 15:24:03           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15551,6,'                              ','Lunes 6 de Abril del 15, a las 15:25:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15552,6,'                              ','Lunes 6 de Abril del 15, a las 15:27:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15553,6,'                              ','Lunes 6 de Abril del 15, a las 15:28:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15554,6,'                              ','Lunes 6 de Abril del 15, a las 15:29:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15555,6,'                              ','Lunes 6 de Abril del 15, a las 15:30:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15556,6,'                              ','Martes 14 de Abril del 15, a las 17:23:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15557,6,'                              ','Lunes 20 de Abril del 15, a las 10:40:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15558,6,'                              ','Mircoles 22 de Abril del 15, a las 10:22:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15559,6,'                              ','Jueves 23 de Abril del 15, a las 11:54:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15560,4,'                              ','Martes 28 de Abril del 15, a las 17:36:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15561,4,'                              ','Jueves 30 de Abril del 15, a las 12:54:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15562,4,'                              ','Jueves 30 de Abril del 15, a las 12:55:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15563,4,'                              ','Jueves 30 de Abril del 15, a las 12:55:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15564,4,'                              ','Jueves 30 de Abril del 15, a las 12:59:43         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15565,4,'                              ','Jueves 30 de Abril del 15, a las 13:01:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15566,4,'                              ','Jueves 30 de Abril del 15, a las 16:20:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15567,4,'                              ','Jueves 30 de Abril del 15, a las 16:22:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15568,4,'                              ','Jueves 30 de Abril del 15, a las 16:24:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15569,4,'                              ','Jueves 30 de Abril del 15, a las 16:25:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15570,4,'                              ','Jueves 30 de Abril del 15, a las 16:26:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15571,4,'                              ','Jueves 30 de Abril del 15, a las 16:28:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15572,4,'                              ','Jueves 30 de Abril del 15, a las 16:30:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15573,4,'                              ','Jueves 30 de Abril del 15, a las 16:59:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15574,4,'                              ','Jueves 30 de Abril del 15, a las 17:01:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15575,4,'                              ','Jueves 30 de Abril del 15, a las 17:02:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15576,4,'                              ','Lunes 4 de Mayo del 15, a las 13:55:14            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15577,4,'                              ','Lunes 4 de Mayo del 15, a las 13:55:56            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15578,6,'                              ','Lunes 4 de Mayo del 15, a las 15:09:31            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15579,6,'                              ','Lunes 4 de Mayo del 15, a las 15:16:04            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15580,4,'                              ','Lunes 4 de Mayo del 15, a las 17:25:16            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15581,4,'                              ','Lunes 4 de Mayo del 15, a las 17:29:37            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15582,6,'                              ','Mircoles 6 de Mayo del 15, a las 12:00:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15583,11,'                              ','Mircoles 6 de Mayo del 15, a las 12:01:54        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15584,6,'                              ','Mircoles 6 de Mayo del 15, a las 14:03:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15585,11,'                              ','Mircoles 6 de Mayo del 15, a las 14:06:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15586,6,'                              ','Martes 12 de Mayo del 15, a las 16:59:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15587,6,'                              ','Mircoles 13 de Mayo del 15, a las 11:18:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15588,6,'                              ','Mircoles 13 de Mayo del 15, a las 13:36:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15589,11,'                              ','Mircoles 13 de Mayo del 15, a las 13:43:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15590,11,'                              ','Mircoles 13 de Mayo del 15, a las 14:05:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15591,11,'                              ','Mircoles 13 de Mayo del 15, a las 14:07:25       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15592,11,'                              ','Mircoles 13 de Mayo del 15, a las 14:43:14       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15593,11,'                              ','Mircoles 13 de Mayo del 15, a las 16:07:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15594,11,'                              ','Mircoles 13 de Mayo del 15, a las 16:35:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15595,11,'                              ','Mircoles 13 de Mayo del 15, a las 16:36:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15596,11,'                              ','Jueves 14 de Mayo del 15, a las 12:49:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15597,11,'                              ','Jueves 14 de Mayo del 15, a las 13:01:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15598,11,'                              ','Jueves 14 de Mayo del 15, a las 13:02:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15599,11,'                              ','Jueves 14 de Mayo del 15, a las 13:13:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15600,4,'                              ','Jueves 14 de Mayo del 15, a las 15:43:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15601,11,'                              ','Jueves 14 de Mayo del 15, a las 15:59:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15602,6,'                              ','Martes 19 de Mayo del 15, a las 10:35:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15603,6,'                              ','Mircoles 20 de Mayo del 15, a las 11:59:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15604,6,'                              ','Mircoles 20 de Mayo del 15, a las 12:02:32       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15605,11,'                              ','Mircoles 20 de Mayo del 15, a las 13:22:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15606,11,'                              ','Mircoles 20 de Mayo del 15, a las 13:24:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15607,4,'                              ','Mircoles 20 de Mayo del 15, a las 16:01:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15608,11,'                              ','Mircoles 20 de Mayo del 15, a las 16:08:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15609,11,'                              ','Mircoles 20 de Mayo del 15, a las 16:39:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15610,11,'                              ','Mircoles 20 de Mayo del 15, a las 16:40:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15611,11,'                              ','Jueves 21 de Mayo del 15, a las 13:04:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15612,11,'                              ','Jueves 21 de Mayo del 15, a las 13:07:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15613,11,'                              ','Jueves 21 de Mayo del 15, a las 13:10:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15614,11,'                              ','Jueves 21 de Mayo del 15, a las 13:14:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15615,11,'                              ','Jueves 21 de Mayo del 15, a las 13:16:42          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15616,11,'                              ','Jueves 21 de Mayo del 15, a las 13:26:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15617,11,'                              ','Jueves 21 de Mayo del 15, a las 13:30:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15618,11,'                              ','Jueves 21 de Mayo del 15, a las 13:33:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15619,11,'                              ','Jueves 21 de Mayo del 15, a las 13:37:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15620,11,'                              ','Jueves 21 de Mayo del 15, a las 13:37:44          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15621,11,'                              ','Viernes 22 de Mayo del 15, a las 11:40:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15622,11,'                              ','Viernes 22 de Mayo del 15, a las 11:41:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15623,4,'                              ','Viernes 22 de Mayo del 15, a las 11:45:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15624,11,'                              ','Viernes 22 de Mayo del 15, a las 11:48:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15625,11,'                              ','Viernes 22 de Mayo del 15, a las 11:50:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15626,11,'                              ','Viernes 22 de Mayo del 15, a las 11:59:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15627,11,'                              ','Viernes 22 de Mayo del 15, a las 12:04:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15628,11,'                              ','Viernes 22 de Mayo del 15, a las 12:09:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15629,11,'                              ','Viernes 22 de Mayo del 15, a las 12:09:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15630,11,'                              ','Viernes 22 de Mayo del 15, a las 12:12:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15631,11,'                              ','Viernes 22 de Mayo del 15, a las 12:26:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15632,11,'                              ','Viernes 22 de Mayo del 15, a las 12:27:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15633,6,'                              ','Lunes 25 de Mayo del 15, a las 09:59:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15634,11,'                              ','Lunes 25 de Mayo del 15, a las 10:01:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15635,11,'                              ','Lunes 25 de Mayo del 15, a las 10:25:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15636,11,'                              ','Lunes 25 de Mayo del 15, a las 11:02:35           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15637,6,'                              ','Lunes 25 de Mayo del 15, a las 11:04:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15638,6,'                              ','Lunes 25 de Mayo del 15, a las 11:04:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15639,6,'                              ','Lunes 25 de Mayo del 15, a las 11:07:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15640,6,'                              ','Lunes 25 de Mayo del 15, a las 12:09:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15641,6,'                              ','Lunes 25 de Mayo del 15, a las 12:09:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15642,11,'                              ','Lunes 25 de Mayo del 15, a las 14:48:34           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15643,11,'                              ','Lunes 25 de Mayo del 15, a las 14:54:59           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15644,11,'                              ','Lunes 25 de Mayo del 15, a las 15:00:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15645,11,'                              ','Lunes 25 de Mayo del 15, a las 15:05:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15646,11,'                              ','Lunes 25 de Mayo del 15, a las 15:07:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15647,11,'                              ','Lunes 25 de Mayo del 15, a las 15:10:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15648,11,'                              ','Lunes 25 de Mayo del 15, a las 15:12:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15649,11,'                              ','Lunes 25 de Mayo del 15, a las 15:15:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15650,11,'                              ','Lunes 25 de Mayo del 15, a las 15:21:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15651,11,'                              ','Lunes 25 de Mayo del 15, a las 15:24:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15652,11,'                              ','Martes 26 de Mayo del 15, a las 12:24:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15653,11,'                              ','Martes 26 de Mayo del 15, a las 12:28:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15654,11,'                              ','Martes 26 de Mayo del 15, a las 12:32:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15655,11,'                              ','Martes 26 de Mayo del 15, a las 12:36:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15656,11,'                              ','Martes 26 de Mayo del 15, a las 12:39:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15657,11,'                              ','Martes 26 de Mayo del 15, a las 12:42:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15658,6,'                              ','Martes 26 de Mayo del 15, a las 14:29:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15659,11,'                              ','Mircoles 27 de Mayo del 15, a las 11:29:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15660,6,'                              ','Mircoles 27 de Mayo del 15, a las 12:28:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15661,8,'                              ','Mircoles 27 de Mayo del 15, a las 14:18:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15662,11,'                              ','Mircoles 27 de Mayo del 15, a las 14:50:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15663,6,'                              ','Jueves 28 de Mayo del 15, a las 11:39:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15664,6,'                              ','Jueves 28 de Mayo del 15, a las 11:40:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15665,53,'                              ','Viernes 29 de Mayo del 15, a las 17:11:42         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15666,11,'                              ','Viernes 29 de Mayo del 15, a las 17:14:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15667,11,'                              ','Viernes 29 de Mayo del 15, a las 17:15:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15668,4,'                              ','Viernes 29 de Mayo del 15, a las 17:16:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15669,53,'                              ','Viernes 29 de Mayo del 15, a las 17:18:22         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15670,11,'                              ','Viernes 29 de Mayo del 15, a las 17:26:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15671,11,'                              ','Viernes 29 de Mayo del 15, a las 17:26:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15672,11,'                              ','Viernes 29 de Mayo del 15, a las 17:27:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15673,4,'                              ','Viernes 29 de Mayo del 15, a las 17:31:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15674,4,'                              ','Viernes 29 de Mayo del 15, a las 17:31:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15675,11,'                              ','Lunes 1 de Junio del 15, a las 14:40:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15676,11,'                              ','Lunes 1 de Junio del 15, a las 14:40:46           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15677,4,'                              ','Lunes 1 de Junio del 15, a las 14:42:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15678,6,'                              ','Lunes 1 de Junio del 15, a las 14:58:07           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15679,11,'                              ','Lunes 1 de Junio del 15, a las 15:07:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15680,8,'                              ','Lunes 1 de Junio del 15, a las 15:08:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15681,4,'                              ','Lunes 1 de Junio del 15, a las 15:14:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15682,11,'                              ','Lunes 1 de Junio del 15, a las 15:22:39           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15683,6,'                              ','Lunes 1 de Junio del 15, a las 15:28:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15684,11,'                              ','Lunes 1 de Junio del 15, a las 15:33:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15685,11,'                              ','Lunes 1 de Junio del 15, a las 15:34:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15686,8,'                              ','Lunes 1 de Junio del 15, a las 15:38:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15687,8,'                              ','Lunes 1 de Junio del 15, a las 15:38:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15688,11,'                              ','Lunes 1 de Junio del 15, a las 15:51:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15689,6,'                              ','Lunes 1 de Junio del 15, a las 16:15:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15690,6,'                              ','Lunes 1 de Junio del 15, a las 16:18:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15691,6,'                              ','Lunes 1 de Junio del 15, a las 16:20:11           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15692,6,'                              ','Lunes 1 de Junio del 15, a las 16:25:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15693,6,'                              ','Lunes 1 de Junio del 15, a las 16:27:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15694,6,'                              ','Lunes 1 de Junio del 15, a las 16:29:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15695,6,'                              ','Lunes 1 de Junio del 15, a las 16:30:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15696,6,'                              ','Martes 2 de Junio del 15, a las 11:29:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15697,11,'                              ','Martes 2 de Junio del 15, a las 11:46:09          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15698,11,'                              ','Martes 2 de Junio del 15, a las 11:46:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15699,53,'                              ','Martes 2 de Junio del 15, a las 11:59:08          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15700,11,'                              ','Martes 2 de Junio del 15, a las 16:01:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15701,8,'                              ','Martes 2 de Junio del 15, a las 16:04:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15702,6,'                              ','Mircoles 3 de Junio del 15, a las 11:52:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15703,11,'                              ','Mircoles 3 de Junio del 15, a las 12:10:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15704,11,'                              ','Mircoles 3 de Junio del 15, a las 12:14:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15705,11,'                              ','Mircoles 3 de Junio del 15, a las 12:15:43       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15706,4,'                              ','Mircoles 3 de Junio del 15, a las 12:18:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15707,11,'                              ','Mircoles 3 de Junio del 15, a las 12:22:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15708,11,'                              ','Mircoles 3 de Junio del 15, a las 12:23:01       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15709,11,'                              ','Mircoles 3 de Junio del 15, a las 13:45:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15710,8,'                              ','Mircoles 3 de Junio del 15, a las 13:47:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15711,8,'                              ','Mircoles 3 de Junio del 15, a las 13:47:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15712,4,'                              ','Mircoles 3 de Junio del 15, a las 13:50:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15713,4,'                              ','Mircoles 3 de Junio del 15, a las 13:54:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15714,11,'                              ','Mircoles 3 de Junio del 15, a las 13:57:22       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15715,11,'                              ','Mircoles 3 de Junio del 15, a las 14:03:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15716,11,'                              ','Mircoles 3 de Junio del 15, a las 14:50:18       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15717,11,'                              ','Mircoles 3 de Junio del 15, a las 14:50:47       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15718,8,'                              ','Mircoles 3 de Junio del 15, a las 14:56:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15719,11,'                              ','Mircoles 3 de Junio del 15, a las 15:18:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15720,11,'                              ','Mircoles 3 de Junio del 15, a las 15:25:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15721,11,'                              ','Mircoles 3 de Junio del 15, a las 15:26:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15722,4,'                              ','Mircoles 3 de Junio del 15, a las 15:27:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15723,6,'                              ','Jueves 4 de Junio del 15, a las 12:26:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15724,11,'                              ','Jueves 4 de Junio del 15, a las 12:28:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15725,11,'                              ','Viernes 5 de Junio del 15, a las 17:02:17         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15726,11,'                              ','Viernes 5 de Junio del 15, a las 17:09:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15727,11,'                              ','Viernes 5 de Junio del 15, a las 17:11:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15728,11,'                              ','Viernes 5 de Junio del 15, a las 17:14:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15729,11,'                              ','Viernes 5 de Junio del 15, a las 17:16:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15730,11,'                              ','Viernes 5 de Junio del 15, a las 17:29:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15731,11,'                              ','Lunes 8 de Junio del 15, a las 12:42:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15732,11,'                              ','Lunes 8 de Junio del 15, a las 12:44:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15733,8,'                              ','Lunes 8 de Junio del 15, a las 12:52:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15734,4,'                              ','Lunes 8 de Junio del 15, a las 12:54:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15735,8,'                              ','Lunes 8 de Junio del 15, a las 12:57:44           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15736,11,'                              ','Lunes 8 de Junio del 15, a las 13:04:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15737,8,'                              ','Lunes 8 de Junio del 15, a las 13:07:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15738,11,'                              ','Lunes 8 de Junio del 15, a las 13:15:57           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15739,11,'                              ','Lunes 8 de Junio del 15, a las 13:16:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15740,11,'                              ','Lunes 8 de Junio del 15, a las 13:22:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15741,4,'                              ','Lunes 8 de Junio del 15, a las 13:30:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15742,8,'                              ','Lunes 8 de Junio del 15, a las 13:32:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15743,11,'                              ','Lunes 8 de Junio del 15, a las 13:39:28           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15744,11,'                              ','Lunes 8 de Junio del 15, a las 13:42:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15745,4,'                              ','Lunes 8 de Junio del 15, a las 13:49:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15746,9,'                              ','Lunes 8 de Junio del 15, a las 13:49:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15747,8,'                              ','Lunes 8 de Junio del 15, a las 13:52:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15748,11,'                              ','Lunes 8 de Junio del 15, a las 13:55:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15749,11,'                              ','Lunes 8 de Junio del 15, a las 13:57:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15750,4,'                              ','Lunes 8 de Junio del 15, a las 14:08:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15751,8,'                              ','Lunes 8 de Junio del 15, a las 14:10:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15752,11,'                              ','Lunes 8 de Junio del 15, a las 14:23:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15753,11,'                              ','Lunes 8 de Junio del 15, a las 14:24:05           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15754,11,'                              ','Lunes 8 de Junio del 15, a las 14:25:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15755,11,'                              ','Lunes 8 de Junio del 15, a las 14:34:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15756,8,'                              ','Lunes 8 de Junio del 15, a las 14:40:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15757,11,'                              ','Lunes 8 de Junio del 15, a las 14:44:43           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15758,11,'                              ','Lunes 8 de Junio del 15, a las 14:45:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15759,11,'                              ','Lunes 8 de Junio del 15, a las 14:56:45           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15760,8,'                              ','Lunes 8 de Junio del 15, a las 15:00:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15761,11,'                              ','Lunes 8 de Junio del 15, a las 15:06:00           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15762,11,'                              ','Lunes 8 de Junio del 15, a las 16:29:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15763,11,'                              ','Lunes 8 de Junio del 15, a las 16:31:20           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15764,11,'                              ','Lunes 8 de Junio del 15, a las 16:34:58           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15765,6,'                              ','Martes 9 de Junio del 15, a las 11:23:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15766,6,'                              ','Martes 9 de Junio del 15, a las 11:25:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15767,6,'                              ','Martes 9 de Junio del 15, a las 11:27:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15768,6,'                              ','Martes 9 de Junio del 15, a las 11:38:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15769,6,'                              ','Martes 9 de Junio del 15, a las 11:41:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15770,6,'                              ','Mircoles 10 de Junio del 15, a las 11:03:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15771,6,'                              ','Mircoles 10 de Junio del 15, a las 11:05:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15772,6,'                              ','Mircoles 10 de Junio del 15, a las 11:07:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15773,6,'                              ','Mircoles 10 de Junio del 15, a las 11:08:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15774,6,'                              ','Mircoles 10 de Junio del 15, a las 11:11:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15775,6,'                              ','Mircoles 10 de Junio del 15, a las 11:13:00      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15776,6,'                              ','Mircoles 10 de Junio del 15, a las 11:15:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15777,11,'                              ','Mircoles 10 de Junio del 15, a las 11:35:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15778,11,'                              ','Mircoles 10 de Junio del 15, a las 11:37:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15779,11,'                              ','Mircoles 10 de Junio del 15, a las 11:38:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15780,11,'                              ','Mircoles 10 de Junio del 15, a las 11:40:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15781,11,'                              ','Mircoles 10 de Junio del 15, a las 11:40:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15782,11,'                              ','Mircoles 10 de Junio del 15, a las 11:43:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15783,6,'                              ','Mircoles 10 de Junio del 15, a las 12:06:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15784,11,'                              ','Mircoles 10 de Junio del 15, a las 12:41:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15785,8,'                              ','Mircoles 10 de Junio del 15, a las 12:48:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15786,8,'                              ','Mircoles 10 de Junio del 15, a las 12:54:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15787,8,'                              ','Mircoles 10 de Junio del 15, a las 12:56:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15788,8,'                              ','Mircoles 10 de Junio del 15, a las 12:58:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15789,8,'                              ','Mircoles 10 de Junio del 15, a las 13:02:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15790,8,'                              ','Mircoles 10 de Junio del 15, a las 13:02:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15791,8,'                              ','Mircoles 10 de Junio del 15, a las 13:12:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15792,11,'                              ','Mircoles 10 de Junio del 15, a las 13:46:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15793,8,'                              ','Mircoles 10 de Junio del 15, a las 13:48:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15794,11,'                              ','Mircoles 10 de Junio del 15, a las 13:57:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15795,8,'                              ','Mircoles 10 de Junio del 15, a las 13:59:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15796,4,'                              ','Mircoles 10 de Junio del 15, a las 14:05:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15797,4,'                              ','Mircoles 10 de Junio del 15, a las 14:07:03      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15798,11,'                              ','Mircoles 10 de Junio del 15, a las 14:14:53      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15799,8,'                              ','Mircoles 10 de Junio del 15, a las 14:18:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15800,11,'                              ','Mircoles 10 de Junio del 15, a las 15:45:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15801,4,'                              ','Mircoles 10 de Junio del 15, a las 15:45:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15802,8,'                              ','Mircoles 10 de Junio del 15, a las 15:52:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15803,11,'                              ','Mircoles 10 de Junio del 15, a las 16:24:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15804,4,'                              ','Mircoles 10 de Junio del 15, a las 16:26:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15805,4,'                              ','Mircoles 10 de Junio del 15, a las 16:29:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15806,11,'                              ','Jueves 11 de Junio del 15, a las 12:06:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15807,11,'                              ','Jueves 11 de Junio del 15, a las 12:10:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15808,11,'                              ','Jueves 11 de Junio del 15, a las 12:27:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15809,4,'                              ','Jueves 11 de Junio del 15, a las 12:31:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15810,11,'                              ','Jueves 11 de Junio del 15, a las 12:34:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15811,11,'                              ','Jueves 11 de Junio del 15, a las 12:38:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15812,6,'                              ','Jueves 11 de Junio del 15, a las 12:42:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15813,11,'                              ','Jueves 11 de Junio del 15, a las 12:46:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15814,11,'                              ','Jueves 11 de Junio del 15, a las 12:48:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15815,4,'                              ','Jueves 11 de Junio del 15, a las 13:45:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15816,8,'                              ','Jueves 11 de Junio del 15, a las 13:46:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15817,11,'                              ','Jueves 11 de Junio del 15, a las 13:50:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15818,4,'                              ','Jueves 11 de Junio del 15, a las 13:56:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15819,11,'                              ','Jueves 11 de Junio del 15, a las 14:09:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15820,11,'                              ','Jueves 11 de Junio del 15, a las 14:10:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15821,4,'                              ','Jueves 11 de Junio del 15, a las 14:14:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15822,11,'                              ','Jueves 11 de Junio del 15, a las 14:18:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15823,11,'                              ','Jueves 11 de Junio del 15, a las 14:23:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15824,11,'                              ','Jueves 11 de Junio del 15, a las 14:24:00         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15825,11,'                              ','Jueves 11 de Junio del 15, a las 14:41:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15826,11,'                              ','Jueves 11 de Junio del 15, a las 14:43:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15827,11,'                              ','Jueves 11 de Junio del 15, a las 14:50:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15828,6,'                              ','Jueves 11 de Junio del 15, a las 16:52:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15829,11,'                              ','Jueves 11 de Junio del 15, a las 17:08:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15830,4,'                              ','Viernes 12 de Junio del 15, a las 11:31:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15831,4,'                              ','Lunes 15 de Junio del 15, a las 11:45:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15832,6,'                              ','Lunes 15 de Junio del 15, a las 11:48:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15833,6,'                              ','Lunes 15 de Junio del 15, a las 11:48:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15834,11,'                              ','Lunes 15 de Junio del 15, a las 11:54:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15835,11,'                              ','Lunes 15 de Junio del 15, a las 11:55:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15836,11,'                              ','Lunes 15 de Junio del 15, a las 11:57:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15837,4,'                              ','Lunes 15 de Junio del 15, a las 12:01:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15838,6,'                              ','Lunes 15 de Junio del 15, a las 12:03:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15839,8,'                              ','Lunes 15 de Junio del 15, a las 12:04:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15840,11,'                              ','Lunes 15 de Junio del 15, a las 12:31:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15841,4,'                              ','Lunes 15 de Junio del 15, a las 12:35:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15842,6,'                              ','Lunes 15 de Junio del 15, a las 12:37:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15843,11,'                              ','Lunes 15 de Junio del 15, a las 12:42:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15844,11,'                              ','Lunes 15 de Junio del 15, a las 12:43:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15845,11,'                              ','Lunes 15 de Junio del 15, a las 12:54:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15846,11,'                              ','Lunes 15 de Junio del 15, a las 12:55:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15847,11,'                              ','Lunes 15 de Junio del 15, a las 12:55:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15848,4,'                              ','Lunes 15 de Junio del 15, a las 13:14:34          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15849,6,'                              ','Lunes 15 de Junio del 15, a las 13:26:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15850,8,'                              ','Lunes 15 de Junio del 15, a las 13:30:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15851,8,'                              ','Lunes 15 de Junio del 15, a las 13:31:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15852,11,'                              ','Lunes 15 de Junio del 15, a las 13:35:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15853,11,'                              ','Lunes 15 de Junio del 15, a las 13:39:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15854,11,'                              ','Lunes 15 de Junio del 15, a las 13:43:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15855,6,'                              ','Lunes 15 de Junio del 15, a las 13:45:53          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15856,6,'                              ','Lunes 15 de Junio del 15, a las 14:51:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15857,11,'                              ','Lunes 15 de Junio del 15, a las 14:56:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15858,4,'                              ','Lunes 15 de Junio del 15, a las 15:00:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15859,6,'                              ','Lunes 15 de Junio del 15, a las 15:04:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15860,6,'                              ','Lunes 15 de Junio del 15, a las 15:11:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15861,11,'                              ','Lunes 15 de Junio del 15, a las 15:18:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15862,11,'                              ','Lunes 15 de Junio del 15, a las 15:20:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15863,8,'                              ','Lunes 15 de Junio del 15, a las 15:23:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15864,8,'                              ','Lunes 15 de Junio del 15, a las 15:25:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15865,4,'                              ','Lunes 15 de Junio del 15, a las 15:27:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15866,11,'                              ','Lunes 15 de Junio del 15, a las 15:34:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15867,6,'                              ','Lunes 15 de Junio del 15, a las 15:51:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15868,8,'                              ','Lunes 15 de Junio del 15, a las 15:55:30          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15869,11,'                              ','Lunes 15 de Junio del 15, a las 16:05:32          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15870,4,'                              ','Lunes 15 de Junio del 15, a las 16:06:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15871,4,'                              ','Lunes 15 de Junio del 15, a las 16:12:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15872,8,'                              ','Lunes 15 de Junio del 15, a las 16:16:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15873,11,'                              ','Lunes 15 de Junio del 15, a las 16:22:13          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15874,6,'                              ','Lunes 15 de Junio del 15, a las 16:27:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15875,4,'                              ','Lunes 15 de Junio del 15, a las 16:28:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15876,6,'                              ','Lunes 15 de Junio del 15, a las 16:29:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15877,11,'                              ','Lunes 15 de Junio del 15, a las 16:33:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15878,4,'                              ','Mircoles 17 de Junio del 15, a las 12:11:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15879,11,'                              ','Mircoles 17 de Junio del 15, a las 12:16:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15880,8,'                              ','Mircoles 17 de Junio del 15, a las 12:28:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15881,11,'                              ','Mircoles 17 de Junio del 15, a las 12:38:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15882,4,'                              ','Mircoles 17 de Junio del 15, a las 12:45:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15883,6,'                              ','Mircoles 17 de Junio del 15, a las 12:46:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15884,4,'                              ','Mircoles 17 de Junio del 15, a las 12:47:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15885,8,'                              ','Mircoles 17 de Junio del 15, a las 13:10:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15886,11,'                              ','Mircoles 17 de Junio del 15, a las 13:17:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15887,11,'                              ','Mircoles 17 de Junio del 15, a las 13:19:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15888,11,'                              ','Mircoles 17 de Junio del 15, a las 13:20:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15889,11,'                              ','Mircoles 17 de Junio del 15, a las 13:40:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15890,11,'                              ','Mircoles 17 de Junio del 15, a las 13:41:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15891,4,'                              ','Mircoles 17 de Junio del 15, a las 14:14:16      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15892,11,'                              ','Mircoles 17 de Junio del 15, a las 14:55:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15893,4,'                              ','Mircoles 17 de Junio del 15, a las 15:02:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15894,8,'                              ','Mircoles 17 de Junio del 15, a las 15:06:17      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15895,6,'                              ','Mircoles 17 de Junio del 15, a las 15:08:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15896,6,'                              ','Mircoles 17 de Junio del 15, a las 15:09:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15897,8,'                              ','Mircoles 17 de Junio del 15, a las 15:16:47      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15898,11,'                              ','Mircoles 17 de Junio del 15, a las 15:25:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15899,11,'                              ','Mircoles 17 de Junio del 15, a las 15:25:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15900,4,'                              ','Mircoles 17 de Junio del 15, a las 15:35:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15901,8,'                              ','Mircoles 17 de Junio del 15, a las 15:40:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15902,11,'                              ','Mircoles 17 de Junio del 15, a las 15:46:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15903,4,'                              ','Mircoles 17 de Junio del 15, a las 15:49:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15904,11,'                              ','Mircoles 17 de Junio del 15, a las 15:59:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15905,4,'                              ','Mircoles 17 de Junio del 15, a las 16:02:51      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15906,6,'                              ','Mircoles 17 de Junio del 15, a las 16:03:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15907,6,'                              ','Mircoles 17 de Junio del 15, a las 16:06:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15908,11,'                              ','Jueves 18 de Junio del 15, a las 11:44:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15909,8,'                              ','Jueves 18 de Junio del 15, a las 11:53:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15910,11,'                              ','Jueves 18 de Junio del 15, a las 12:02:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15911,11,'                              ','Jueves 18 de Junio del 15, a las 12:03:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15912,8,'                              ','Jueves 18 de Junio del 15, a las 12:18:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15913,6,'                              ','Jueves 18 de Junio del 15, a las 12:21:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15914,11,'                              ','Jueves 18 de Junio del 15, a las 12:25:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15915,8,'                              ','Jueves 18 de Junio del 15, a las 12:58:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15916,4,'                              ','Viernes 19 de Junio del 15, a las 11:34:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15917,8,'                              ','Viernes 19 de Junio del 15, a las 11:37:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15918,11,'                              ','Viernes 19 de Junio del 15, a las 11:55:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15919,11,'                              ','Viernes 19 de Junio del 15, a las 11:57:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15920,8,'                              ','Viernes 19 de Junio del 15, a las 12:03:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15921,8,'                              ','Viernes 19 de Junio del 15, a las 12:04:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15922,11,'                              ','Viernes 19 de Junio del 15, a las 12:35:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15923,4,'                              ','Viernes 19 de Junio del 15, a las 12:36:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15924,11,'                              ','Martes 23 de Junio del 15, a las 11:42:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15925,11,'                              ','Martes 23 de Junio del 15, a las 11:57:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15926,11,'                              ','Martes 23 de Junio del 15, a las 12:00:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15927,11,'                              ','Martes 23 de Junio del 15, a las 12:03:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15928,11,'                              ','Martes 23 de Junio del 15, a las 12:03:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15929,11,'                              ','Martes 23 de Junio del 15, a las 12:04:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15930,11,'                              ','Martes 23 de Junio del 15, a las 12:09:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15931,11,'                              ','Martes 23 de Junio del 15, a las 12:11:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15932,11,'                              ','Martes 23 de Junio del 15, a las 12:24:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15933,11,'                              ','Martes 23 de Junio del 15, a las 12:36:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15934,11,'                              ','Martes 23 de Junio del 15, a las 12:38:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15935,11,'                              ','Martes 23 de Junio del 15, a las 13:03:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15936,11,'                              ','Martes 23 de Junio del 15, a las 13:04:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15937,11,'                              ','Martes 23 de Junio del 15, a las 13:06:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15938,11,'                              ','Martes 23 de Junio del 15, a las 13:15:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15939,11,'                              ','Martes 23 de Junio del 15, a las 13:18:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15940,11,'                              ','Martes 23 de Junio del 15, a las 13:20:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15941,11,'                              ','Martes 23 de Junio del 15, a las 13:22:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15942,11,'                              ','Martes 23 de Junio del 15, a las 13:23:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15943,11,'                              ','Martes 23 de Junio del 15, a las 13:27:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15944,11,'                              ','Martes 23 de Junio del 15, a las 13:28:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15945,11,'                              ','Mircoles 24 de Junio del 15, a las 13:56:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15946,11,'                              ','Mircoles 24 de Junio del 15, a las 13:58:58      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15947,11,'                              ','Mircoles 24 de Junio del 15, a las 13:59:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15948,11,'                              ','Mircoles 24 de Junio del 15, a las 14:01:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15949,11,'                              ','Mircoles 24 de Junio del 15, a las 14:05:28      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15950,11,'                              ','Mircoles 24 de Junio del 15, a las 14:07:43      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15951,11,'                              ','Mircoles 24 de Junio del 15, a las 14:09:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15952,11,'                              ','Mircoles 24 de Junio del 15, a las 14:14:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15953,11,'                              ','Mircoles 24 de Junio del 15, a las 14:17:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15954,11,'                              ','Mircoles 24 de Junio del 15, a las 14:19:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15955,11,'                              ','Mircoles 24 de Junio del 15, a las 14:29:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15956,11,'                              ','Mircoles 24 de Junio del 15, a las 14:30:27      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15957,11,'                              ','Mircoles 24 de Junio del 15, a las 14:30:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15958,11,'                              ','Mircoles 24 de Junio del 15, a las 14:37:11      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15959,11,'                              ','Mircoles 24 de Junio del 15, a las 14:39:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15960,11,'                              ','Mircoles 24 de Junio del 15, a las 14:43:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15961,11,'                              ','Mircoles 24 de Junio del 15, a las 14:46:15      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15962,11,'                              ','Mircoles 24 de Junio del 15, a las 14:49:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15963,11,'                              ','Mircoles 24 de Junio del 15, a las 14:51:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15964,11,'                              ','Mircoles 24 de Junio del 15, a las 14:52:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15965,11,'                              ','Mircoles 24 de Junio del 15, a las 14:55:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15966,11,'                              ','Mircoles 24 de Junio del 15, a las 14:58:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15967,11,'                              ','Mircoles 24 de Junio del 15, a las 15:01:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15968,11,'                              ','Mircoles 24 de Junio del 15, a las 15:05:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15969,11,'                              ','Mircoles 24 de Junio del 15, a las 15:09:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15970,11,'                              ','Mircoles 24 de Junio del 15, a las 15:14:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15971,11,'                              ','Mircoles 24 de Junio del 15, a las 15:15:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15972,11,'                              ','Mircoles 24 de Junio del 15, a las 15:17:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15973,11,'                              ','Jueves 25 de Junio del 15, a las 15:22:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15974,11,'                              ','Jueves 25 de Junio del 15, a las 15:22:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15975,11,'                              ','Jueves 25 de Junio del 15, a las 15:23:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15976,11,'                              ','Jueves 25 de Junio del 15, a las 15:40:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15977,11,'                              ','Jueves 25 de Junio del 15, a las 15:41:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15978,11,'                              ','Jueves 25 de Junio del 15, a las 15:43:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15979,11,'                              ','Jueves 25 de Junio del 15, a las 15:44:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15980,11,'                              ','Viernes 26 de Junio del 15, a las 11:33:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15981,11,'                              ','Viernes 26 de Junio del 15, a las 11:36:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15982,6,'                              ','Viernes 26 de Junio del 15, a las 11:37:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15983,11,'                              ','Viernes 26 de Junio del 15, a las 11:38:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15984,11,'                              ','Viernes 26 de Junio del 15, a las 11:41:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15985,11,'                              ','Viernes 26 de Junio del 15, a las 11:42:49        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15986,11,'                              ','Viernes 26 de Junio del 15, a las 13:22:44        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15987,11,'                              ','Viernes 26 de Junio del 15, a las 13:26:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15988,11,'                              ','Viernes 26 de Junio del 15, a las 13:37:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15989,11,'                              ','Viernes 26 de Junio del 15, a las 13:40:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15990,11,'                              ','Viernes 26 de Junio del 15, a las 13:44:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15991,11,'                              ','Viernes 26 de Junio del 15, a las 13:46:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15992,11,'                              ','Viernes 26 de Junio del 15, a las 13:48:22        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15993,11,'                              ','Viernes 26 de Junio del 15, a las 13:52:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15994,11,'                              ','Viernes 26 de Junio del 15, a las 13:52:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15995,6,'                              ','Viernes 26 de Junio del 15, a las 15:09:23        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15996,11,'                              ','Viernes 26 de Junio del 15, a las 15:11:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15997,11,'                              ','Viernes 26 de Junio del 15, a las 15:14:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15998,6,'                              ','Viernes 26 de Junio del 15, a las 17:06:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (15999,11,'                              ','Viernes 26 de Junio del 15, a las 17:06:47        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16000,8,'                              ','Martes 30 de Junio del 15, a las 11:49:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16001,11,'                              ','Martes 30 de Junio del 15, a las 11:50:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16002,11,'                              ','Martes 30 de Junio del 15, a las 12:04:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16003,11,'                              ','Martes 30 de Junio del 15, a las 12:12:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16004,11,'                              ','Martes 30 de Junio del 15, a las 12:44:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16005,11,'                              ','Martes 30 de Junio del 15, a las 13:01:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16006,11,'                              ','Martes 30 de Junio del 15, a las 13:03:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16007,11,'                              ','Martes 30 de Junio del 15, a las 13:48:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16008,6,'                              ','Martes 30 de Junio del 15, a las 13:51:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16009,6,'                              ','Martes 30 de Junio del 15, a las 13:53:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16010,11,'                              ','Martes 30 de Junio del 15, a las 14:37:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16011,6,'                              ','Martes 30 de Junio del 15, a las 15:28:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16012,4,'                              ','Martes 30 de Junio del 15, a las 15:49:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16013,11,'                              ','Martes 30 de Junio del 15, a las 15:51:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16014,6,'                              ','Jueves 2 de Julio del 15, a las 12:31:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16015,6,'                              ','Jueves 2 de Julio del 15, a las 12:32:27          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16016,6,'                              ','Jueves 2 de Julio del 15, a las 12:35:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16017,6,'                              ','Jueves 2 de Julio del 15, a las 12:38:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16018,6,'                              ','Jueves 2 de Julio del 15, a las 12:41:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16019,11,'                              ','Jueves 30 de Julio del 15, a las 13:02:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16020,11,'                              ','Jueves 30 de Julio del 15, a las 13:04:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16021,11,'                              ','Jueves 30 de Julio del 15, a las 14:25:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16022,11,'                              ','Jueves 30 de Julio del 15, a las 14:28:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16023,11,'                              ','Jueves 30 de Julio del 15, a las 14:28:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16024,11,'                              ','Jueves 30 de Julio del 15, a las 14:35:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16025,11,'                              ','Jueves 30 de Julio del 15, a las 15:10:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16026,11,'                              ','Jueves 30 de Julio del 15, a las 15:16:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16027,11,'                              ','Lunes 3 de Agosto del 15, a las 13:37:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16028,11,'                              ','Lunes 3 de Agosto del 15, a las 13:47:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16029,53,'                              ','Lunes 3 de Agosto del 15, a las 14:01:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16030,53,'                              ','Lunes 3 de Agosto del 15, a las 14:01:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16031,11,'                              ','Lunes 3 de Agosto del 15, a las 14:09:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16032,6,'                              ','Martes 4 de Agosto del 15, a las 14:10:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16033,4,'                              ','Martes 4 de Agosto del 15, a las 14:15:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16034,11,'                              ','Martes 4 de Agosto del 15, a las 14:23:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16035,53,'                              ','Martes 4 de Agosto del 15, a las 14:24:39         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16036,53,'                              ','Martes 4 de Agosto del 15, a las 14:25:17         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16037,11,'                              ','Martes 4 de Agosto del 15, a las 14:43:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16038,11,'                              ','Martes 4 de Agosto del 15, a las 14:43:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16039,4,'                              ','Martes 4 de Agosto del 15, a las 14:50:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16040,10,'                              ','Martes 4 de Agosto del 15, a las 14:53:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16041,11,'                              ','Martes 4 de Agosto del 15, a las 15:03:38         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16042,4,'                              ','Martes 4 de Agosto del 15, a las 15:08:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16043,11,'                              ','Martes 4 de Agosto del 15, a las 15:11:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16044,11,'                              ','Martes 4 de Agosto del 15, a las 15:22:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16045,11,'                              ','Martes 4 de Agosto del 15, a las 15:24:20         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16046,6,'                              ','Jueves 6 de Agosto del 15, a las 12:34:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16047,6,'                              ','Jueves 13 de Agosto del 15, a las 13:56:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16048,11,'                              ','Lunes 17 de Agosto del 15, a las 13:44:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16049,6,'                              ','Lunes 17 de Agosto del 15, a las 13:45:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16050,6,'                              ','Lunes 17 de Agosto del 15, a las 13:46:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16051,4,'                              ','Lunes 17 de Agosto del 15, a las 13:47:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16052,11,'                              ','Lunes 17 de Agosto del 15, a las 13:49:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16053,4,'                              ','Lunes 17 de Agosto del 15, a las 17:40:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16054,11,'                              ','Lunes 17 de Agosto del 15, a las 17:44:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16055,4,'                              ','Martes 18 de Agosto del 15, a las 12:35:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16056,4,'                              ','Martes 18 de Agosto del 15, a las 12:38:15        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16057,4,'                              ','Martes 18 de Agosto del 15, a las 12:42:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16058,11,'                              ','Martes 18 de Agosto del 15, a las 12:48:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16059,3,'                              ','Martes 18 de Agosto del 15, a las 13:06:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16060,4,'                              ','Martes 18 de Agosto del 15, a las 13:11:59        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16061,4,'                              ','Martes 18 de Agosto del 15, a las 13:36:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16062,4,'                              ','Martes 18 de Agosto del 15, a las 13:45:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16063,4,'                              ','Martes 18 de Agosto del 15, a las 13:52:01        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16064,4,'                              ','Martes 18 de Agosto del 15, a las 14:00:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16065,4,'                              ','Martes 18 de Agosto del 15, a las 14:06:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16066,4,'                              ','Martes 18 de Agosto del 15, a las 14:11:24        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16067,4,'                              ','Martes 18 de Agosto del 15, a las 14:19:06        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16068,4,'                              ','Martes 18 de Agosto del 15, a las 14:27:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16069,4,'                              ','Martes 18 de Agosto del 15, a las 14:33:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16070,4,'                              ','Martes 18 de Agosto del 15, a las 14:34:41        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16071,4,'                              ','Martes 18 de Agosto del 15, a las 14:58:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16072,6,'                              ','Jueves 20 de Agosto del 15, a las 14:56:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16073,6,'                              ','Lunes 24 de Agosto del 15, a las 12:21:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16074,53,'                              ','Lunes 24 de Agosto del 15, a las 13:56:03         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16075,6,'                              ','Mircoles 26 de Agosto del 15, a las 15:09:53     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16076,6,'                              ','Jueves 27 de Agosto del 15, a las 10:32:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16077,6,'                              ','Jueves 27 de Agosto del 15, a las 10:33:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16078,11,'                              ','Mircoles 2 de Septiembre del 15, a las 12:48:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16079,11,'                              ','Mircoles 2 de Septiembre del 15, a las 12:51:33  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16080,11,'                              ','Mircoles 2 de Septiembre del 15, a las 12:52:36  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16081,6,'                              ','Jueves 3 de Septiembre del 15, a las 11:55:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16082,6,'                              ','Viernes 4 de Septiembre del 15, a las 13:25:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16083,6,'                              ','Viernes 4 de Septiembre del 15, a las 13:28:52    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16084,6,'                              ','Viernes 4 de Septiembre del 15, a las 13:29:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16085,53,'                              ','Lunes 7 de Septiembre del 15, a las 13:18:51      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16086,8,'                              ','Lunes 7 de Septiembre del 15, a las 13:20:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16087,11,'                              ','Lunes 7 de Septiembre del 15, a las 13:30:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16088,11,'                              ','Lunes 7 de Septiembre del 15, a las 13:33:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16089,53,'                              ','Lunes 7 de Septiembre del 15, a las 13:45:52      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16090,11,'                              ','Lunes 7 de Septiembre del 15, a las 13:48:48      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16091,8,'                              ','Lunes 7 de Septiembre del 15, a las 13:50:02      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16092,4,'                              ','Lunes 7 de Septiembre del 15, a las 13:52:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16093,11,'                              ','Lunes 7 de Septiembre del 15, a las 13:56:23      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16094,11,'                              ','Lunes 7 de Septiembre del 15, a las 13:57:20      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16095,53,'                              ','Lunes 7 de Septiembre del 15, a las 14:03:00      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16096,8,'                              ','Lunes 7 de Septiembre del 15, a las 14:04:10      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16097,11,'                              ','Lunes 7 de Septiembre del 15, a las 14:08:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16098,53,'                              ','Lunes 7 de Septiembre del 15, a las 14:12:13      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16099,8,'                              ','Lunes 7 de Septiembre del 15, a las 14:14:34      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16100,11,'                              ','Lunes 7 de Septiembre del 15, a las 14:19:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16101,53,'                              ','Lunes 7 de Septiembre del 15, a las 14:21:46      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16102,8,'                              ','Lunes 7 de Septiembre del 15, a las 14:22:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16103,11,'                              ','Lunes 7 de Septiembre del 15, a las 14:25:26      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16104,4,'                              ','Lunes 7 de Septiembre del 15, a las 14:28:19      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16105,8,'                              ','Lunes 7 de Septiembre del 15, a las 14:29:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16106,11,'                              ','Lunes 7 de Septiembre del 15, a las 14:31:22      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16107,10,'                              ','Lunes 7 de Septiembre del 15, a las 14:32:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16108,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:19:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16109,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:21:07      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16110,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:21:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16111,4,'                              ','Lunes 7 de Septiembre del 15, a las 15:24:56      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16112,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:27:21      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16113,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:28:29      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16114,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:40:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16115,11,'                              ','Lunes 7 de Septiembre del 15, a las 15:42:30      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16116,11,'                              ','Martes 8 de Septiembre del 15, a las 12:56:26     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16117,8,'                              ','Martes 8 de Septiembre del 15, a las 12:57:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16118,8,'                              ','Martes 8 de Septiembre del 15, a las 13:00:16     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16119,10,'                              ','Martes 8 de Septiembre del 15, a las 13:02:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16120,53,'                              ','Martes 8 de Septiembre del 15, a las 13:03:53     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16121,4,'                              ','Martes 8 de Septiembre del 15, a las 13:04:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16122,11,'                              ','Martes 8 de Septiembre del 15, a las 13:08:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16123,11,'                              ','Martes 8 de Septiembre del 15, a las 13:09:13     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16124,10,'                              ','Martes 8 de Septiembre del 15, a las 13:10:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16125,53,'                              ','Martes 8 de Septiembre del 15, a las 13:20:59     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16126,8,'                              ','Martes 8 de Septiembre del 15, a las 13:23:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16127,8,'                              ','Martes 8 de Septiembre del 15, a las 13:23:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16128,11,'                              ','Martes 8 de Septiembre del 15, a las 13:26:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16129,53,'                              ','Martes 8 de Septiembre del 15, a las 13:30:55     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16130,11,'                              ','Martes 8 de Septiembre del 15, a las 13:44:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16131,11,'                              ','Martes 8 de Septiembre del 15, a las 13:47:14     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16132,4,'                              ','Martes 8 de Septiembre del 15, a las 13:48:27     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16133,4,'                              ','Martes 8 de Septiembre del 15, a las 13:51:49     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16134,53,'                              ','Martes 8 de Septiembre del 15, a las 13:52:12     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16135,11,'                              ','Martes 8 de Septiembre del 15, a las 13:56:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16136,11,'                              ','Martes 8 de Septiembre del 15, a las 13:56:48     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16137,6,'                              ','Lunes 14 de Septiembre del 15, a las 11:52:34     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16138,6,'                              ','Lunes 14 de Septiembre del 15, a las 11:57:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16139,6,'                              ','Lunes 14 de Septiembre del 15, a las 12:04:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16140,6,'                              ','Lunes 14 de Septiembre del 15, a las 12:10:43     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16141,6,'                              ','Lunes 14 de Septiembre del 15, a las 12:14:41     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16142,6,'                              ','Lunes 14 de Septiembre del 15, a las 12:18:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16143,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:28:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16144,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:28:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16145,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:35:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16146,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:39:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16147,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:42:10     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16148,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:48:25     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16149,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:52:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16150,6,'                              ','Lunes 14 de Septiembre del 15, a las 13:57:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16151,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:02:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16152,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:03:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16153,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:05:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16154,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:07:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16155,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:10:50     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16156,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:11:59     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16157,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:14:06     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16158,6,'                              ','Lunes 14 de Septiembre del 15, a las 14:15:22     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16159,6,'                              ','Viernes 18 de Septiembre del 15, a las 12:57:17   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16160,6,'                              ','Viernes 18 de Septiembre del 15, a las 12:58:57   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16161,6,'                              ','Viernes 18 de Septiembre del 15, a las 13:06:26   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16162,6,'                              ','Viernes 18 de Septiembre del 15, a las 13:10:33   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16163,6,'                              ','Viernes 18 de Septiembre del 15, a las 13:19:02   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16164,6,'                              ','Viernes 18 de Septiembre del 15, a las 13:23:14   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16165,6,'                              ','Viernes 18 de Septiembre del 15, a las 13:35:55   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16166,6,'                              ','Viernes 18 de Septiembre del 15, a las 13:40:13   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16167,6,'                              ','Jueves 24 de Septiembre del 15, a las 11:43:26    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16168,6,'                              ','Jueves 24 de Septiembre del 15, a las 11:47:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16169,6,'                              ','Jueves 24 de Septiembre del 15, a las 11:49:35    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16170,6,'                              ','Jueves 24 de Septiembre del 15, a las 11:53:57    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16171,6,'                              ','Jueves 24 de Septiembre del 15, a las 11:56:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16172,6,'                              ','Mircoles 14 de Octubre del 15, a las 10:43:59    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16173,6,'                              ','Mircoles 14 de Octubre del 15, a las 10:44:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16174,6,'                              ','Mircoles 14 de Octubre del 15, a las 10:47:16    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16175,4,'                              ','Jueves 15 de Octubre del 15, a las 12:56:59       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16176,6,'                              ','Viernes 16 de Octubre del 15, a las 11:27:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16177,6,'                              ','Jueves 22 de Octubre del 15, a las 16:16:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16178,6,'                              ','Jueves 22 de Octubre del 15, a las 16:24:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16179,6,'                              ','Jueves 22 de Octubre del 15, a las 16:24:57       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16180,4,'                              ','Viernes 23 de Octubre del 15, a las 15:46:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16181,4,'                              ','Viernes 23 de Octubre del 15, a las 15:50:38      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16182,6,'                              ','Mircoles 4 de Noviembre del 15, a las 17:04:57   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16183,6,'                              ','Jueves 12 de Noviembre del 15, a las 10:40:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16184,6,'                              ','Jueves 12 de Noviembre del 15, a las 10:41:11     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16185,6,'                              ','Martes 17 de Noviembre del 15, a las 14:43:46     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16186,51,'Direccion                     ','Mircoles 18 de Noviembre del 15, a las 22:13:34  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16187,53,'                              ','Mircoles 18 de Noviembre del 15, a las 22:13:54  ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16188,4,'                              ','Mircoles 18 de Noviembre del 15, a las 22:15:54  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16189,11,'                              ','Jueves 19 de Noviembre del 15, a las 12:22:01     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16190,11,'                              ','Jueves 19 de Noviembre del 15, a las 12:24:24     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16191,6,'                              ','Jueves 19 de Noviembre del 15, a las 16:17:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16192,11,'                              ','Jueves 19 de Noviembre del 15, a las 16:19:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16193,11,'                              ','Jueves 19 de Noviembre del 15, a las 16:20:40     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16194,11,'                              ','Jueves 19 de Noviembre del 15, a las 16:21:18     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16195,4,'                              ','Viernes 20 de Noviembre del 15, a las 11:18:21    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16196,53,'                              ','Viernes 20 de Noviembre del 15, a las 11:24:34    ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16197,6,'                              ','Viernes 20 de Noviembre del 15, a las 11:27:37    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16198,11,'                              ','Viernes 20 de Noviembre del 15, a las 11:31:27    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16199,11,'                              ','Viernes 20 de Noviembre del 15, a las 11:32:39    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16200,11,'                              ','Viernes 20 de Noviembre del 15, a las 11:33:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16201,10,'                              ','Viernes 20 de Noviembre del 15, a las 11:33:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16202,6,'                              ','Viernes 20 de Noviembre del 15, a las 17:24:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16203,6,'                              ','Viernes 20 de Noviembre del 15, a las 17:24:20    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16204,11,'                              ','Viernes 20 de Noviembre del 15, a las 17:33:28    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16205,6,'                              ','Viernes 20 de Noviembre del 15, a las 18:22:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16206,6,'                              ','Viernes 20 de Noviembre del 15, a las 18:23:24    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16207,6,'                              ','Viernes 20 de Noviembre del 15, a las 18:24:05    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16208,11,'                              ','Viernes 20 de Noviembre del 15, a las 18:27:44    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16209,53,'                              ','Martes 24 de Noviembre del 15, a las 16:09:55     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16210,53,'                              ','Martes 24 de Noviembre del 15, a las 16:10:22     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16211,51,'Direccion                     ','Martes 24 de Noviembre del 15, a las 16:11:39     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16212,51,'Direccion                     ','Martes 24 de Noviembre del 15, a las 16:13:49     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16213,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:30:21  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16214,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:33:14  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16215,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:37:35  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16216,11,'                              ','Mircoles 25 de Noviembre del 15, a las 09:41:23  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16217,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:48:47  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16218,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:53:46  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16219,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:54:15  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16220,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:55:43  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16221,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:58:48  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16222,6,'                              ','Mircoles 25 de Noviembre del 15, a las 09:59:46  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16223,6,'                              ','Mircoles 25 de Noviembre del 15, a las 10:00:07  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16224,6,'                              ','Mircoles 25 de Noviembre del 15, a las 10:05:22  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16225,6,'                              ','Mircoles 25 de Noviembre del 15, a las 10:06:02  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16226,6,'                              ','Mircoles 25 de Noviembre del 15, a las 10:07:55  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16227,6,'                              ','Mircoles 2 de Diciembre del 15, a las 10:31:22   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16228,11,'                              ','Mircoles 2 de Diciembre del 15, a las 10:32:05   ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16229,6,'                              ','Lunes 4 de Enero del 16, a las 15:06:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16230,6,'                              ','Martes 5 de Enero del 16, a las 08:55:12          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16231,11,'                              ','Martes 5 de Enero del 16, a las 08:57:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16232,6,'                              ','Jueves 7 de Enero del 16, a las 13:37:31          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16233,6,'                              ','Lunes 11 de Enero del 16, a las 09:48:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16234,6,'                              ','Lunes 11 de Enero del 16, a las 09:48:58          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16235,6,'                              ','Lunes 11 de Enero del 16, a las 09:51:36          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16236,6,'                              ','Lunes 11 de Enero del 16, a las 11:21:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16237,6,'                              ','Lunes 11 de Enero del 16, a las 11:22:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16238,6,'                              ','Lunes 11 de Enero del 16, a las 13:57:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16239,6,'                              ','Viernes 15 de Enero del 16, a las 08:12:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16240,6,'                              ','Viernes 15 de Enero del 16, a las 08:20:57        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16241,6,'                              ','Viernes 15 de Enero del 16, a las 08:31:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16242,6,'                              ','Viernes 15 de Enero del 16, a las 08:32:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16243,11,'                              ','Martes 19 de Enero del 16, a las 13:14:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16244,6,'                              ','Martes 19 de Enero del 16, a las 15:58:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16245,6,'                              ','Mircoles 20 de Enero del 16, a las 08:58:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16246,6,'                              ','Jueves 21 de Enero del 16, a las 14:32:18         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16247,6,'                              ','Viernes 22 de Enero del 16, a las 10:21:33        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16248,6,'                              ','Viernes 22 de Enero del 16, a las 10:23:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16249,6,'                              ','Viernes 22 de Enero del 16, a las 10:37:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16250,6,'                              ','Viernes 22 de Enero del 16, a las 10:48:46        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16251,6,'                              ','Viernes 22 de Enero del 16, a las 10:51:18        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16252,6,'                              ','Viernes 22 de Enero del 16, a las 10:59:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16253,6,'                              ','Viernes 22 de Enero del 16, a las 11:10:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16254,6,'                              ','Viernes 22 de Enero del 16, a las 11:11:11        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16255,6,'                              ','Viernes 22 de Enero del 16, a las 11:15:17        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16256,6,'                              ','Viernes 22 de Enero del 16, a las 11:34:45        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16257,6,'                              ','Viernes 22 de Enero del 16, a las 11:39:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16258,6,'                              ','Viernes 22 de Enero del 16, a las 11:48:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16259,6,'                              ','Viernes 22 de Enero del 16, a las 11:57:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16260,6,'                              ','Viernes 22 de Enero del 16, a las 12:01:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16261,6,'                              ','Viernes 22 de Enero del 16, a las 12:05:25        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16262,6,'                              ','Viernes 22 de Enero del 16, a las 12:09:16        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16263,6,'                              ','Viernes 22 de Enero del 16, a las 12:11:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16264,6,'                              ','Lunes 25 de Enero del 16, a las 09:08:24          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16265,6,'                              ','Lunes 25 de Enero del 16, a las 09:09:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16266,6,'                              ','Lunes 25 de Enero del 16, a las 09:11:33          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16267,6,'                              ','Lunes 25 de Enero del 16, a las 09:24:38          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16268,6,'                              ','Martes 26 de Enero del 16, a las 09:09:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16269,6,'                              ','Martes 26 de Enero del 16, a las 09:10:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16270,6,'                              ','Mircoles 27 de Enero del 16, a las 08:30:57      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16271,6,'                              ','Mircoles 27 de Enero del 16, a las 08:34:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16272,6,'                              ','Jueves 4 de Febrero del 16, a las 09:01:32        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16273,6,'                              ','Jueves 4 de Febrero del 16, a las 09:10:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16274,6,'                              ','Jueves 4 de Febrero del 16, a las 09:12:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16275,6,'                              ','Viernes 5 de Febrero del 16, a las 10:30:54       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16276,53,'                              ','Viernes 5 de Febrero del 16, a las 12:50:38       ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16277,6,'                              ','Viernes 5 de Febrero del 16, a las 12:52:36       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16278,6,'                              ','Viernes 5 de Febrero del 16, a las 12:53:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16279,6,'                              ','Viernes 5 de Febrero del 16, a las 14:43:31       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16280,6,'                              ','Martes 9 de Febrero del 16, a las 13:36:21        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16281,6,'                              ','Martes 9 de Febrero del 16, a las 13:41:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16282,6,'                              ','Martes 9 de Febrero del 16, a las 13:56:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16283,6,'                              ','Mircoles 10 de Febrero del 16, a las 09:39:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16284,6,'                              ','Jueves 11 de Febrero del 16, a las 08:35:17       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16285,6,'                              ','Lunes 15 de Febrero del 16, a las 10:26:28        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16286,6,'                              ','Lunes 15 de Febrero del 16, a las 10:30:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16287,6,'                              ','Jueves 18 de Febrero del 16, a las 09:08:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16288,4,'                              ','Jueves 18 de Febrero del 16, a las 09:11:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16289,6,'                              ','Martes 23 de Febrero del 16, a las 08:44:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16290,6,'                              ','Mircoles 24 de Febrero del 16, a las 10:00:19    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16291,6,'                              ','Mircoles 24 de Febrero del 16, a las 10:06:41    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16292,6,'                              ','Mircoles 24 de Febrero del 16, a las 10:21:55    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16293,6,'                              ','Mircoles 24 de Febrero del 16, a las 10:24:03    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16294,6,'                              ','Mircoles 24 de Febrero del 16, a las 10:26:13    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16295,6,'                              ','Mircoles 24 de Febrero del 16, a las 10:29:00    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16296,4,'                              ','Mircoles 24 de Febrero del 16, a las 12:04:54    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16297,6,'                              ','Mircoles 24 de Febrero del 16, a las 12:40:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16298,6,'                              ','Mircoles 24 de Febrero del 16, a las 14:48:18    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16299,6,'                              ','Mircoles 24 de Febrero del 16, a las 14:49:15    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16300,53,'                              ','Lunes 29 de Febrero del 16, a las 09:11:17        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16301,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:12:42        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16302,53,'                              ','Lunes 29 de Febrero del 16, a las 09:13:03        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16303,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:13:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16304,53,'                              ','Lunes 29 de Febrero del 16, a las 09:13:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16305,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:14:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16306,53,'                              ','Lunes 29 de Febrero del 16, a las 09:14:50        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16307,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:15:30        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16308,53,'                              ','Lunes 29 de Febrero del 16, a las 09:15:47        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16309,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:17:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16310,53,'                              ','Lunes 29 de Febrero del 16, a las 09:18:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16311,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:19:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16312,53,'                              ','Lunes 29 de Febrero del 16, a las 09:20:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16313,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:21:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16314,53,'                              ','Lunes 29 de Febrero del 16, a las 09:21:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16315,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:25:37        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16316,53,'                              ','Lunes 29 de Febrero del 16, a las 09:25:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16317,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:26:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16318,53,'                              ','Lunes 29 de Febrero del 16, a las 09:27:19        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16319,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:34:17        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16320,53,'                              ','Lunes 29 de Febrero del 16, a las 09:34:54        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16321,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:35:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16322,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:37:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16323,53,'                              ','Lunes 29 de Febrero del 16, a las 09:37:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16324,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 09:38:56        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16325,53,'                              ','Lunes 29 de Febrero del 16, a las 09:39:19        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16326,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:00:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16327,53,'                              ','Lunes 29 de Febrero del 16, a las 10:01:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16328,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:11:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16329,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:11:54        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16330,53,'                              ','Lunes 29 de Febrero del 16, a las 10:12:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16331,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:14:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16332,53,'                              ','Lunes 29 de Febrero del 16, a las 10:14:24        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16333,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:14:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16334,53,'                              ','Lunes 29 de Febrero del 16, a las 10:15:14        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16335,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:16:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16336,53,'                              ','Lunes 29 de Febrero del 16, a las 10:16:29        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16337,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:17:20        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16338,53,'                              ','Lunes 29 de Febrero del 16, a las 10:17:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16339,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:18:31        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16340,53,'                              ','Lunes 29 de Febrero del 16, a las 10:18:54        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16341,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:19:41        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16342,53,'                              ','Lunes 29 de Febrero del 16, a las 10:23:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16343,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:23:45        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16344,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:24:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16345,53,'                              ','Lunes 29 de Febrero del 16, a las 10:28:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16346,53,'                              ','Lunes 29 de Febrero del 16, a las 10:28:57        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16347,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:30:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16348,53,'                              ','Lunes 29 de Febrero del 16, a las 10:30:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16349,53,'                              ','Lunes 29 de Febrero del 16, a las 10:31:42        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16350,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:33:23        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16351,53,'                              ','Lunes 29 de Febrero del 16, a las 10:33:43        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16352,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:34:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16353,53,'                              ','Lunes 29 de Febrero del 16, a las 10:35:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16354,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:38:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16355,53,'                              ','Lunes 29 de Febrero del 16, a las 10:38:34        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16356,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:39:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16357,53,'                              ','Lunes 29 de Febrero del 16, a las 10:40:01        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16358,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:40:48        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16359,53,'                              ','Lunes 29 de Febrero del 16, a las 10:41:05        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16360,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:41:54        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16361,53,'                              ','Lunes 29 de Febrero del 16, a las 10:42:09        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16362,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:42:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16363,53,'                              ','Lunes 29 de Febrero del 16, a las 10:43:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16364,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:43:39        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16365,53,'                              ','Lunes 29 de Febrero del 16, a las 10:44:00        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16366,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 10:44:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16367,53,'                              ','Lunes 29 de Febrero del 16, a las 10:45:13        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16368,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:10:16        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16369,53,'                              ','Lunes 29 de Febrero del 16, a las 11:10:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16370,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:11:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16371,53,'                              ','Lunes 29 de Febrero del 16, a las 11:11:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16372,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:12:22        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16373,53,'                              ','Lunes 29 de Febrero del 16, a las 11:12:36        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16374,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:13:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16375,53,'                              ','Lunes 29 de Febrero del 16, a las 11:13:29        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16376,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:14:19        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16377,53,'                              ','Lunes 29 de Febrero del 16, a las 11:14:35        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16378,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:15:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16379,53,'                              ','Lunes 29 de Febrero del 16, a las 11:15:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16380,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:16:12        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16381,53,'                              ','Lunes 29 de Febrero del 16, a las 11:16:26        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16382,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:17:02        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16383,53,'                              ','Lunes 29 de Febrero del 16, a las 11:17:18        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16384,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:17:51        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16385,53,'                              ','Lunes 29 de Febrero del 16, a las 11:18:08        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16386,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:18:38        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16387,53,'                              ','Lunes 29 de Febrero del 16, a las 11:18:56        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16388,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:19:30        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16389,53,'                              ','Lunes 29 de Febrero del 16, a las 11:19:49        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16390,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:20:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16391,53,'                              ','Lunes 29 de Febrero del 16, a las 11:20:44        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16392,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:21:16        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16393,53,'                              ','Lunes 29 de Febrero del 16, a las 11:21:32        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16394,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:22:06        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16395,53,'                              ','Lunes 29 de Febrero del 16, a las 11:22:28        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16396,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:22:59        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16397,53,'                              ','Lunes 29 de Febrero del 16, a las 11:23:15        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16398,51,'Direccion                     ','Lunes 29 de Febrero del 16, a las 11:23:53        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16399,53,'                              ','Lunes 29 de Febrero del 16, a las 11:24:10        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16400,6,'                              ','Lunes 29 de Febrero del 16, a las 13:52:12        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16401,6,'                              ','Lunes 29 de Febrero del 16, a las 14:04:20        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16402,6,'                              ','Lunes 29 de Febrero del 16, a las 14:05:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16403,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:32:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16404,53,'                              ','Martes 1 de Marzo del 16, a las 08:33:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16405,53,'                              ','Martes 1 de Marzo del 16, a las 08:33:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16406,53,'                              ','Martes 1 de Marzo del 16, a las 08:35:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16407,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:41:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16408,53,'                              ','Martes 1 de Marzo del 16, a las 08:41:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16409,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:43:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16410,53,'                              ','Martes 1 de Marzo del 16, a las 08:43:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16411,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:44:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16412,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:45:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16413,53,'                              ','Martes 1 de Marzo del 16, a las 08:45:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16414,53,'                              ','Martes 1 de Marzo del 16, a las 08:48:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16415,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:49:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16416,53,'                              ','Martes 1 de Marzo del 16, a las 08:49:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16417,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:50:54          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16418,53,'                              ','Martes 1 de Marzo del 16, a las 08:51:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16419,53,'                              ','Martes 1 de Marzo del 16, a las 08:52:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16420,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 08:56:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16421,53,'                              ','Martes 1 de Marzo del 16, a las 08:56:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16422,53,'                              ','Martes 1 de Marzo del 16, a las 08:59:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16423,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:00:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16424,53,'                              ','Martes 1 de Marzo del 16, a las 09:00:49          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16425,53,'                              ','Martes 1 de Marzo del 16, a las 09:02:04          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16426,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:02:42          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16427,53,'                              ','Martes 1 de Marzo del 16, a las 09:03:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16428,53,'                              ','Martes 1 de Marzo del 16, a las 09:05:17          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16429,53,'                              ','Martes 1 de Marzo del 16, a las 09:06:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16430,53,'                              ','Martes 1 de Marzo del 16, a las 09:07:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16431,53,'                              ','Martes 1 de Marzo del 16, a las 09:08:14          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16432,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:12:04          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16433,53,'                              ','Martes 1 de Marzo del 16, a las 09:12:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16434,53,'                              ','Martes 1 de Marzo del 16, a las 09:13:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16435,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:14:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16436,53,'                              ','Martes 1 de Marzo del 16, a las 09:14:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16437,53,'                              ','Martes 1 de Marzo del 16, a las 09:16:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16438,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:17:54          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16439,53,'                              ','Martes 1 de Marzo del 16, a las 09:18:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16440,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:18:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16441,53,'                              ','Martes 1 de Marzo del 16, a las 09:19:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16442,53,'                              ','Martes 1 de Marzo del 16, a las 09:20:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16443,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:20:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16444,53,'                              ','Martes 1 de Marzo del 16, a las 09:21:14          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16445,53,'                              ','Martes 1 de Marzo del 16, a las 09:21:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16446,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 09:22:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16447,53,'                              ','Martes 1 de Marzo del 16, a las 09:22:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16448,53,'                              ','Martes 1 de Marzo del 16, a las 09:23:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16449,53,'                              ','Martes 1 de Marzo del 16, a las 09:24:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16450,53,'                              ','Martes 1 de Marzo del 16, a las 09:24:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16451,53,'                              ','Martes 1 de Marzo del 16, a las 09:25:16          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16452,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:08:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16453,53,'                              ','Martes 1 de Marzo del 16, a las 10:08:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16454,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:09:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16455,53,'                              ','Martes 1 de Marzo del 16, a las 10:12:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16456,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:13:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16457,53,'                              ','Martes 1 de Marzo del 16, a las 10:14:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16458,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:15:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16459,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:16:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16460,53,'                              ','Martes 1 de Marzo del 16, a las 10:17:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16461,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:17:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16462,53,'                              ','Martes 1 de Marzo del 16, a las 10:17:47          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16463,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:18:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16464,53,'                              ','Martes 1 de Marzo del 16, a las 10:18:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16465,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:19:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16466,53,'                              ','Martes 1 de Marzo del 16, a las 10:20:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16467,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:27:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16468,53,'                              ','Martes 1 de Marzo del 16, a las 10:27:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16469,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:28:26          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16470,53,'                              ','Martes 1 de Marzo del 16, a las 10:28:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16471,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:29:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16472,53,'                              ','Martes 1 de Marzo del 16, a las 10:30:11          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16473,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:30:55          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16474,53,'                              ','Martes 1 de Marzo del 16, a las 10:31:13          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16475,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:32:08          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16476,53,'                              ','Martes 1 de Marzo del 16, a las 10:32:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16477,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:33:14          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16478,53,'                              ','Martes 1 de Marzo del 16, a las 10:33:30          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16479,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:34:08          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16480,53,'                              ','Martes 1 de Marzo del 16, a las 10:34:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16481,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:35:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16482,53,'                              ','Martes 1 de Marzo del 16, a las 10:35:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16483,53,'                              ','Martes 1 de Marzo del 16, a las 10:37:09          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16484,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:47:38          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16485,53,'                              ','Martes 1 de Marzo del 16, a las 10:47:57          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16486,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:48:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16487,53,'                              ','Martes 1 de Marzo del 16, a las 10:48:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16488,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:49:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16489,53,'                              ','Martes 1 de Marzo del 16, a las 10:50:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16490,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:50:50          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16491,53,'                              ','Martes 1 de Marzo del 16, a las 10:51:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16492,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:52:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16493,53,'                              ','Martes 1 de Marzo del 16, a las 10:52:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16494,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:53:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16495,53,'                              ','Martes 1 de Marzo del 16, a las 10:53:27          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16496,53,'                              ','Martes 1 de Marzo del 16, a las 10:54:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16497,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:54:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16498,53,'                              ','Martes 1 de Marzo del 16, a las 10:55:10          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16499,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:55:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16500,53,'                              ','Martes 1 de Marzo del 16, a las 10:56:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16501,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:56:44          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16502,53,'                              ','Martes 1 de Marzo del 16, a las 10:57:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16503,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:58:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16504,53,'                              ','Martes 1 de Marzo del 16, a las 10:58:37          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16505,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 10:59:12          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16506,53,'                              ','Martes 1 de Marzo del 16, a las 10:59:32          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16507,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 11:00:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16508,53,'                              ','Martes 1 de Marzo del 16, a las 11:00:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16509,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 11:01:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16510,53,'                              ','Martes 1 de Marzo del 16, a las 11:01:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16511,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 11:02:41          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16512,53,'                              ','Martes 1 de Marzo del 16, a las 11:02:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16513,51,'Direccion                     ','Martes 1 de Marzo del 16, a las 11:03:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16514,53,'                              ','Martes 1 de Marzo del 16, a las 11:04:07          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16515,6,'                              ','Mircoles 2 de Marzo del 16, a las 09:39:58       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16516,6,'                              ','Mircoles 2 de Marzo del 16, a las 09:45:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16517,6,'                              ','Jueves 3 de Marzo del 16, a las 11:52:08          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16518,6,'                              ','Jueves 3 de Marzo del 16, a las 11:54:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16519,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 10:46:48          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16520,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 10:47:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16521,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 10:52:29          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16522,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 10:55:33          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16523,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 10:58:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16524,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 10:59:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16525,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:17:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16526,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:19:39          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16527,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:21:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16528,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:22:35          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16529,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:23:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16530,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:26:22          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16531,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:27:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16532,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:31:58          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16533,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:35:45          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16534,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:38:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16535,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:43:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16536,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:46:59          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16537,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 11:47:46          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16538,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 12:03:25          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16539,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 12:07:36          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16540,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 12:10:02          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16541,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 12:11:56          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16542,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 12:14:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16543,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 12:50:52          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16544,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:05:28          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16545,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:06:00          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16546,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:09:21          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16547,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:10:06          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16548,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:13:43          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16549,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:16:01          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16550,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:16:19          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16551,51,'Direccion                     ','Martes 8 de Marzo del 16, a las 13:20:51          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16552,6,'                              ','Viernes 11 de Marzo del 16, a las 08:15:51        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16553,6,'                              ','Viernes 11 de Marzo del 16, a las 08:16:30        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16554,6,'                              ','Lunes 14 de Marzo del 16, a las 16:04:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16555,6,'                              ','Lunes 14 de Marzo del 16, a las 16:06:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16556,6,'                              ','Martes 15 de Marzo del 16, a las 09:56:39         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16557,6,'                              ','Martes 15 de Marzo del 16, a las 09:56:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16558,6,'                              ','Martes 15 de Marzo del 16, a las 10:10:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16559,6,'                              ','Martes 15 de Marzo del 16, a las 10:13:55         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16560,6,'                              ','Martes 15 de Marzo del 16, a las 10:16:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16561,6,'                              ','Martes 15 de Marzo del 16, a las 10:17:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16562,6,'                              ','Martes 15 de Marzo del 16, a las 10:19:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16563,6,'                              ','Martes 15 de Marzo del 16, a las 10:20:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16564,6,'                              ','Martes 15 de Marzo del 16, a las 10:20:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16565,6,'                              ','Martes 15 de Marzo del 16, a las 10:21:56         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16566,6,'                              ','Martes 15 de Marzo del 16, a las 10:22:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16567,6,'                              ','Martes 15 de Marzo del 16, a las 10:26:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16568,6,'                              ','Mircoles 16 de Marzo del 16, a las 09:41:01      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16569,6,'                              ','Viernes 18 de Marzo del 16, a las 14:03:09        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16570,6,'                              ','Martes 29 de Marzo del 16, a las 15:39:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16571,6,'                              ','Jueves 31 de Marzo del 16, a las 09:21:11         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16572,6,'                              ','Jueves 31 de Marzo del 16, a las 09:36:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16573,6,'                              ','Lunes 4 de Abril del 16, a las 14:11:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16574,6,'                              ','Lunes 4 de Abril del 16, a las 14:23:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16575,6,'                              ','Lunes 4 de Abril del 16, a las 14:29:49           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16576,6,'                              ','Mircoles 6 de Abril del 16, a las 13:32:55       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16577,6,'                              ','Mircoles 6 de Abril del 16, a las 13:40:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16578,6,'                              ','Mircoles 6 de Abril del 16, a las 13:49:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16579,8,'                              ','Mircoles 6 de Abril del 16, a las 13:51:21       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16580,4,'                              ','Mircoles 6 de Abril del 16, a las 13:55:38       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16581,6,'                              ','Mircoles 6 de Abril del 16, a las 16:08:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16582,6,'                              ','Lunes 11 de Abril del 16, a las 15:35:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16583,6,'                              ','Lunes 11 de Abril del 16, a las 15:37:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16584,6,'                              ','Martes 12 de Abril del 16, a las 09:42:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16585,6,'                              ','Martes 12 de Abril del 16, a las 09:44:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16586,6,'                              ','Martes 12 de Abril del 16, a las 15:01:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16587,6,'                              ','Martes 12 de Abril del 16, a las 15:02:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16588,6,'                              ','Jueves 14 de Abril del 16, a las 09:06:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16589,6,'                              ','Jueves 14 de Abril del 16, a las 09:17:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16590,6,'                              ','Jueves 14 de Abril del 16, a las 09:38:16         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16591,6,'                              ','Jueves 14 de Abril del 16, a las 14:15:12         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16592,6,'                              ','Jueves 14 de Abril del 16, a las 14:15:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16593,6,'                              ','Jueves 14 de Abril del 16, a las 14:18:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16594,6,'                              ','Jueves 14 de Abril del 16, a las 14:19:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16595,6,'                              ','Jueves 14 de Abril del 16, a las 14:22:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16596,6,'                              ','Jueves 21 de Abril del 16, a las 10:05:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16597,6,'                              ','Jueves 21 de Abril del 16, a las 10:07:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16598,4,'                              ','Lunes 25 de Abril del 16, a las 10:57:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16599,6,'                              ','Martes 26 de Abril del 16, a las 09:32:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16600,6,'                              ','Martes 26 de Abril del 16, a las 09:38:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16601,6,'                              ','Martes 26 de Abril del 16, a las 09:45:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16602,6,'                              ','Martes 26 de Abril del 16, a las 09:46:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16603,51,'Direccion                     ','Martes 26 de Abril del 16, a las 09:48:45         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16604,51,'Direccion                     ','Martes 26 de Abril del 16, a las 09:49:07         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16605,51,'Direccion                     ','Martes 26 de Abril del 16, a las 09:49:59         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16606,6,'                              ','Martes 26 de Abril del 16, a las 10:34:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16607,6,'                              ','Martes 26 de Abril del 16, a las 10:37:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16608,6,'                              ','Martes 26 de Abril del 16, a las 12:44:10         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16609,6,'                              ','Martes 26 de Abril del 16, a las 13:04:58         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16610,6,'                              ','Martes 26 de Abril del 16, a las 13:12:50         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16611,6,'                              ','Martes 26 de Abril del 16, a las 13:47:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16612,6,'                              ','Martes 26 de Abril del 16, a las 14:23:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16613,6,'                              ','Martes 26 de Abril del 16, a las 15:51:06         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16614,6,'                              ','Martes 26 de Abril del 16, a las 15:51:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16615,6,'                              ','Martes 26 de Abril del 16, a las 15:54:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16616,6,'                              ','Martes 26 de Abril del 16, a las 16:01:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16617,6,'                              ','Martes 26 de Abril del 16, a las 16:02:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16618,6,'                              ','Martes 26 de Abril del 16, a las 16:03:52         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16619,6,'                              ','Martes 26 de Abril del 16, a las 16:07:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16620,51,'Direccion                     ','Mircoles 27 de Abril del 16, a las 09:55:29      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16621,6,'                              ','Mircoles 27 de Abril del 16, a las 10:30:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16622,6,'                              ','Mircoles 27 de Abril del 16, a las 11:12:52      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16623,6,'                              ','Jueves 28 de Abril del 16, a las 08:57:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16624,6,'                              ','Jueves 28 de Abril del 16, a las 09:02:45         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16625,6,'                              ','Lunes 2 de Mayo del 16, a las 15:20:17            ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16626,6,'                              ','Martes 3 de Mayo del 16, a las 14:48:06           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16627,6,'                              ','Martes 3 de Mayo del 16, a las 14:48:41           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16628,6,'                              ','Jueves 12 de Mayo del 16, a las 09:21:54          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16629,6,'                              ','Jueves 12 de Mayo del 16, a las 13:04:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16630,6,'                              ','Martes 17 de Mayo del 16, a las 15:41:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16631,6,'                              ','Martes 17 de Mayo del 16, a las 15:42:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16632,6,'                              ','Mircoles 18 de Mayo del 16, a las 11:36:42       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16633,4,'                              ','Lunes 23 de Mayo del 16, a las 11:15:16           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16634,6,'                              ','Lunes 30 de Mayo del 16, a las 10:11:17           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16635,6,'                              ','Martes 31 de Mayo del 16, a las 09:45:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16636,6,'                              ','Martes 31 de Mayo del 16, a las 09:50:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16637,6,'                              ','Martes 31 de Mayo del 16, a las 09:58:51          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16638,6,'                              ','Martes 31 de Mayo del 16, a las 10:59:19          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16639,6,'                              ','Martes 31 de Mayo del 16, a las 11:09:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16640,6,'                              ','Mircoles 1 de Junio del 16, a las 09:24:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16641,6,'                              ','Mircoles 1 de Junio del 16, a las 09:24:34       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16642,6,'                              ','Mircoles 1 de Junio del 16, a las 09:26:20       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16643,6,'                              ','Jueves 2 de Junio del 16, a las 13:22:41          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16644,6,'                              ','Jueves 2 de Junio del 16, a las 13:23:26          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16645,6,'                              ','Viernes 17 de Junio del 16, a las 10:11:26        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16646,9,'                              ','Viernes 17 de Junio del 16, a las 10:13:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16647,4,'                              ','Viernes 17 de Junio del 16, a las 14:34:55        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16648,4,'                              ','Viernes 17 de Junio del 16, a las 14:40:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16649,4,'                              ','Martes 28 de Junio del 16, a las 11:01:57         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16650,4,'                              ','Martes 28 de Junio del 16, a las 11:05:14         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16651,4,'                              ','Martes 28 de Junio del 16, a las 11:38:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16652,4,'                              ','Martes 28 de Junio del 16, a las 11:43:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16653,4,'                              ','Martes 28 de Junio del 16, a las 11:46:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16654,4,'                              ','Martes 28 de Junio del 16, a las 11:49:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16655,4,'                              ','Martes 28 de Junio del 16, a las 11:53:59         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16656,4,'                              ','Martes 28 de Junio del 16, a las 11:55:40         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16657,4,'                              ','Martes 28 de Junio del 16, a las 12:12:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16658,4,'                              ','Martes 28 de Junio del 16, a las 12:16:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16659,4,'                              ','Martes 28 de Junio del 16, a las 12:17:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16660,6,'                              ','Jueves 30 de Junio del 16, a las 10:02:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16661,6,'                              ','Mircoles 27 de Julio del 16, a las 15:17:13      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16662,6,'                              ','Mircoles 27 de Julio del 16, a las 15:25:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16663,53,'                              ','Viernes 29 de Julio del 16, a las 15:55:55        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16664,6,'                              ','Viernes 29 de Julio del 16, a las 16:01:37        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16665,4,'                              ','Viernes 29 de Julio del 16, a las 16:02:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16666,51,'Direccion                     ','Viernes 29 de Julio del 16, a las 16:11:07        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16667,53,'                              ','Viernes 29 de Julio del 16, a las 16:11:27        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16668,11,'                              ','Viernes 29 de Julio del 16, a las 16:14:13        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16669,6,'                              ','Martes 2 de Agosto del 16, a las 16:38:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16670,6,'                              ','Viernes 5 de Agosto del 16, a las 08:40:53        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16671,6,'                              ','Viernes 5 de Agosto del 16, a las 10:40:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16672,6,'                              ','Martes 9 de Agosto del 16, a las 11:01:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16673,6,'                              ','Martes 9 de Agosto del 16, a las 11:01:28         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16674,6,'                              ','Martes 16 de Agosto del 16, a las 16:07:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16675,6,'                              ','Mircoles 17 de Agosto del 16, a las 10:50:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16676,6,'                              ','Mircoles 17 de Agosto del 16, a las 10:51:05     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16677,6,'                              ','Mircoles 17 de Agosto del 16, a las 10:51:38     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16678,11,'                              ','Mircoles 17 de Agosto del 16, a las 10:52:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16679,6,'                              ','Viernes 19 de Agosto del 16, a las 14:49:52       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16680,6,'                              ','Lunes 29 de Agosto del 16, a las 14:05:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16681,4,'                              ','Lunes 29 de Agosto del 16, a las 14:12:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16682,53,'                              ','Mircoles 31 de Agosto del 16, a las 15:53:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16683,53,'                              ','Mircoles 31 de Agosto del 16, a las 15:58:01     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16684,51,'Direccion                     ','Mircoles 31 de Agosto del 16, a las 15:59:05     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16685,53,'                              ','Mircoles 31 de Agosto del 16, a las 15:59:25     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16686,51,'Direccion                     ','Mircoles 31 de Agosto del 16, a las 16:01:42     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16687,51,'Direccion                     ','Mircoles 31 de Agosto del 16, a las 16:04:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16688,53,'                              ','Mircoles 31 de Agosto del 16, a las 16:04:49     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16689,51,'Direccion                     ','Mircoles 31 de Agosto del 16, a las 16:05:06     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16690,6,'                              ','Jueves 1 de Septiembre del 16, a las 14:03:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16691,6,'                              ','Jueves 1 de Septiembre del 16, a las 14:04:58     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16692,6,'                              ','Jueves 1 de Septiembre del 16, a las 14:05:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16693,6,'                              ','Jueves 1 de Septiembre del 16, a las 14:10:15     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16694,6,'                              ','Mircoles 7 de Septiembre del 16, a las 13:36:45  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16695,6,'                              ','Mircoles 7 de Septiembre del 16, a las 16:05:37  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16696,6,'                              ','Mircoles 7 de Septiembre del 16, a las 16:05:55  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16697,6,'                              ','Martes 13 de Septiembre del 16, a las 11:20:32    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16698,4,'                              ','Martes 20 de Septiembre del 16, a las 10:39:42    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16699,4,'                              ','Martes 20 de Septiembre del 16, a las 10:40:33    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16700,11,'                              ','Jueves 29 de Septiembre del 16, a las 11:46:36    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16701,11,'                              ','Jueves 29 de Septiembre del 16, a las 11:47:53    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16702,4,'                              ','Jueves 29 de Septiembre del 16, a las 12:29:25    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16703,4,'                              ','Jueves 29 de Septiembre del 16, a las 12:30:48    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16704,4,'                              ','Jueves 29 de Septiembre del 16, a las 12:31:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16705,6,'                              ','Jueves 29 de Septiembre del 16, a las 12:35:22    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16706,6,'                              ','Lunes 3 de Octubre del 16, a las 16:16:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16707,10,'                              ','Martes 4 de Octubre del 16, a las 12:35:04        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16708,11,'                              ','Mircoles 5 de Octubre del 16, a las 09:27:56     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16709,11,'                              ','Mircoles 5 de Octubre del 16, a las 09:30:20     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16710,6,'                              ','Mircoles 5 de Octubre del 16, a las 09:31:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16711,11,'                              ','Mircoles 5 de Octubre del 16, a las 09:39:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16712,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:07:37     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16713,6,'                              ','Mircoles 5 de Octubre del 16, a las 10:09:28     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16714,6,'                              ','Mircoles 5 de Octubre del 16, a las 10:10:08     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16715,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:12:42     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16716,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:21:21     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16717,53,'                              ','Mircoles 5 de Octubre del 16, a las 10:23:10     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16718,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:24:17     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16719,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:25:32     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16720,53,'                              ','Mircoles 5 de Octubre del 16, a las 10:29:37     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16721,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:31:07     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16722,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:40:52     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16723,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:41:30     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16724,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:49:09     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16725,11,'                              ','Mircoles 5 de Octubre del 16, a las 10:51:00     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16726,53,'                              ','Mircoles 5 de Octubre del 16, a las 10:52:56     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16727,53,'                              ','Mircoles 5 de Octubre del 16, a las 10:53:21     ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16728,6,'                              ','Jueves 6 de Octubre del 16, a las 10:18:42        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16729,6,'                              ','Jueves 6 de Octubre del 16, a las 10:19:10        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16730,6,'                              ','Jueves 6 de Octubre del 16, a las 10:56:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16731,6,'                              ','Viernes 14 de Octubre del 16, a las 14:02:31      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16732,6,'                              ','Lunes 17 de Octubre del 16, a las 15:42:58        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16733,53,'                              ','Lunes 17 de Octubre del 16, a las 15:43:42        ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16734,6,'                              ','Jueves 20 de Octubre del 16, a las 10:03:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16735,6,'                              ','Jueves 20 de Octubre del 16, a las 10:03:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16736,4,'                              ','Jueves 20 de Octubre del 16, a las 10:12:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16737,6,'                              ','Jueves 20 de Octubre del 16, a las 10:12:48       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16738,6,'                              ','Jueves 20 de Octubre del 16, a las 10:13:39       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16739,4,'                              ','Jueves 20 de Octubre del 16, a las 10:19:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16740,51,'Direccion                     ','Jueves 3 de Noviembre del 16, a las 15:58:09      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16741,51,'Direccion                     ','Jueves 3 de Noviembre del 16, a las 15:58:22      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16742,53,'                              ','Jueves 3 de Noviembre del 16, a las 15:59:04      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16743,53,'                              ','Jueves 3 de Noviembre del 16, a las 16:02:10      ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16744,3,'                              ','Jueves 3 de Noviembre del 16, a las 16:11:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16745,4,'                              ','Jueves 3 de Noviembre del 16, a las 16:12:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16746,4,'                              ','Lunes 14 de Noviembre del 16, a las 13:50:12      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16747,6,'                              ','Mircoles 16 de Noviembre del 16, a las 14:36:52  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16748,6,'                              ','Mircoles 16 de Noviembre del 16, a las 14:53:33  ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16749,6,'                              ','Viernes 18 de Noviembre del 16, a las 09:27:58    ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16750,6,'                              ','Martes 13 de Diciembre del 16, a las 12:09:29     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16751,6,'                              ','Martes 13 de Diciembre del 16, a las 12:12:39     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16752,6,'                              ','Martes 13 de Diciembre del 16, a las 12:17:02     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16753,6,'                              ','Martes 13 de Diciembre del 16, a las 13:06:44     ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16754,6,'                              ','Martes 10 de Enero del 17, a las 13:14:03         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16755,6,'                              ','Martes 10 de Enero del 17, a las 13:25:54         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16756,6,'                              ','Martes 10 de Enero del 17, a las 14:38:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16757,6,'                              ','Martes 10 de Enero del 17, a las 14:49:36         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16758,6,'                              ','Martes 10 de Enero del 17, a las 14:50:13         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16759,6,'                              ','Mircoles 11 de Enero del 17, a las 08:28:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16760,6,'                              ','Mircoles 11 de Enero del 17, a las 08:32:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16761,6,'                              ','Mircoles 11 de Enero del 17, a las 08:36:42      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16762,6,'                              ','Mircoles 11 de Enero del 17, a las 09:39:04      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16763,6,'                              ','Mircoles 11 de Enero del 17, a las 09:40:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16764,6,'                              ','Mircoles 11 de Enero del 17, a las 09:43:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16765,6,'                              ','Mircoles 11 de Enero del 17, a las 09:55:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16766,6,'                              ','Mircoles 11 de Enero del 17, a las 09:58:55      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16767,6,'                              ','Mircoles 11 de Enero del 17, a las 10:05:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16768,6,'                              ','Mircoles 11 de Enero del 17, a las 10:09:36      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16769,6,'                              ','Mircoles 11 de Enero del 17, a las 10:17:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16770,6,'                              ','Mircoles 11 de Enero del 17, a las 10:21:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16771,6,'                              ','Mircoles 11 de Enero del 17, a las 13:33:50      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16772,6,'                              ','Mircoles 11 de Enero del 17, a las 13:42:49      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16773,6,'                              ','Jueves 12 de Enero del 17, a las 10:08:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16774,6,'                              ','Viernes 13 de Enero del 17, a las 15:32:56        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16775,6,'                              ','Viernes 13 de Enero del 17, a las 15:47:00        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16776,6,'                              ','Lunes 16 de Enero del 17, a las 13:08:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16777,6,'                              ','Lunes 16 de Enero del 17, a las 13:36:57          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16778,6,'                              ','Lunes 16 de Enero del 17, a las 13:37:28          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16779,6,'                              ','Lunes 16 de Enero del 17, a las 13:41:02          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16780,6,'                              ','Lunes 16 de Enero del 17, a las 15:21:46          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16781,6,'                              ','Martes 17 de Enero del 17, a las 10:02:49         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16782,6,'                              ','Martes 17 de Enero del 17, a las 10:03:34         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16783,6,'                              ','Martes 17 de Enero del 17, a las 10:04:23         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16784,6,'                              ','Martes 17 de Enero del 17, a las 10:55:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16785,11,'                              ','Lunes 23 de Enero del 17, a las 10:04:59          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16786,6,'                              ','Viernes 27 de Enero del 17, a las 15:12:48        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16787,11,'                              ','Lunes 30 de Enero del 17, a las 12:25:16          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16788,53,'                              ','Lunes 30 de Enero del 17, a las 12:30:15          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16789,53,'                              ','Lunes 30 de Enero del 17, a las 12:30:53          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16790,4,'                              ','Martes 31 de Enero del 17, a las 15:37:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16791,6,'                              ','Viernes 3 de Febrero del 17, a las 14:24:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16792,6,'                              ','Viernes 3 de Febrero del 17, a las 14:26:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16793,6,'                              ','Viernes 3 de Febrero del 17, a las 14:27:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16794,6,'                              ','Viernes 3 de Febrero del 17, a las 14:28:04       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16795,6,'                              ','Viernes 3 de Febrero del 17, a las 14:28:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16796,6,'                              ','Martes 7 de Febrero del 17, a las 10:10:38        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16797,6,'                              ','Martes 7 de Febrero del 17, a las 10:12:02        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16798,6,'                              ','Martes 7 de Febrero del 17, a las 10:12:50        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16799,6,'                              ','Jueves 9 de Febrero del 17, a las 09:38:34        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16800,6,'                              ','Jueves 9 de Febrero del 17, a las 09:45:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16801,6,'                              ','Jueves 9 de Febrero del 17, a las 09:46:19        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16802,6,'                              ','Jueves 9 de Febrero del 17, a las 14:35:05        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16803,6,'                              ','Martes 21 de Febrero del 17, a las 16:12:02       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16804,6,'                              ','Martes 21 de Febrero del 17, a las 16:24:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16805,6,'                              ','Jueves 23 de Febrero del 17, a las 10:00:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16806,6,'                              ','Mircoles 1 de Marzo del 17, a las 09:49:50       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16807,11,'                              ','Mircoles 1 de Marzo del 17, a las 09:53:08       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16808,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:07:56       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16809,11,'                              ','Mircoles 1 de Marzo del 17, a las 10:09:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16810,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:19:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16811,11,'                              ','Mircoles 1 de Marzo del 17, a las 10:23:51       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16812,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:40:15       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16813,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:40:45       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16814,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:43:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16815,11,'                              ','Mircoles 1 de Marzo del 17, a las 10:44:13       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16816,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:46:30       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16817,11,'                              ','Mircoles 1 de Marzo del 17, a las 10:47:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16818,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:47:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16819,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:50:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16820,11,'                              ','Mircoles 1 de Marzo del 17, a las 10:51:53       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16821,6,'                              ','Mircoles 1 de Marzo del 17, a las 10:55:11       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16822,6,'                              ','Mircoles 1 de Marzo del 17, a las 11:39:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16823,11,'                              ','Mircoles 1 de Marzo del 17, a las 11:40:40       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16824,6,'                              ','Mircoles 1 de Marzo del 17, a las 11:56:44       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16825,11,'                              ','Mircoles 1 de Marzo del 17, a las 11:57:46       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16826,6,'                              ','Mircoles 1 de Marzo del 17, a las 12:03:49       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16827,6,'                              ','Mircoles 1 de Marzo del 17, a las 12:05:00       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16828,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:06:26       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16829,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:11:12       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16830,6,'                              ','Mircoles 1 de Marzo del 17, a las 12:15:28       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16831,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:16:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16832,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:25:27       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16833,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:28:09       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16834,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:32:16       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16835,6,'                              ','Mircoles 1 de Marzo del 17, a las 12:38:33       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16836,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:40:05       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16837,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:42:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16838,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:44:24       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16839,11,'                              ','Mircoles 1 de Marzo del 17, a las 12:47:03       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16840,6,'                              ','Lunes 6 de Marzo del 17, a las 10:40:10           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16841,6,'                              ','Lunes 6 de Marzo del 17, a las 14:12:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16842,11,'                              ','Lunes 6 de Marzo del 17, a las 14:14:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16843,11,'                              ','Lunes 6 de Marzo del 17, a las 14:14:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16844,4,'                              ','Lunes 6 de Marzo del 17, a las 16:03:55           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16845,4,'                              ','Lunes 6 de Marzo del 17, a las 16:05:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16846,4,'                              ','Lunes 6 de Marzo del 17, a las 16:06:14           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16847,4,'                              ','Lunes 6 de Marzo del 17, a las 16:12:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16848,4,'                              ','Lunes 6 de Marzo del 17, a las 16:17:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16849,6,'                              ','Viernes 10 de Marzo del 17, a las 09:49:36        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16850,4,'                              ','Lunes 13 de Marzo del 17, a las 11:56:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16851,6,'                              ','Martes 14 de Marzo del 17, a las 14:04:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16852,6,'                              ','Martes 14 de Marzo del 17, a las 15:51:04         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16853,11,'                              ','Martes 14 de Marzo del 17, a las 15:52:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16854,11,'                              ','Martes 14 de Marzo del 17, a las 15:53:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16855,6,'                              ','Mircoles 15 de Marzo del 17, a las 12:08:06      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16856,6,'                              ','Mircoles 15 de Marzo del 17, a las 12:10:24      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16857,6,'                              ','Mircoles 15 de Marzo del 17, a las 12:11:45      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16858,6,'                              ','Mircoles 15 de Marzo del 17, a las 12:13:33      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16859,6,'                              ','Mircoles 15 de Marzo del 17, a las 12:15:18      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16860,11,'                              ','Mircoles 15 de Marzo del 17, a las 12:17:35      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16861,11,'                              ','Mircoles 15 de Marzo del 17, a las 12:18:05      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16862,11,'                              ','Mircoles 15 de Marzo del 17, a las 12:21:59      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16863,6,'                              ','Jueves 16 de Marzo del 17, a las 11:23:47         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16864,6,'                              ','Viernes 17 de Marzo del 17, a las 16:16:35        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16865,6,'                              ','Viernes 17 de Marzo del 17, a las 16:19:03        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16866,6,'                              ','Martes 21 de Marzo del 17, a las 09:12:24         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16867,11,'                              ','Jueves 23 de Marzo del 17, a las 15:05:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16868,6,'                              ','Lunes 27 de Marzo del 17, a las 11:54:14          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16869,6,'                              ','Lunes 27 de Marzo del 17, a las 12:35:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16870,11,'                              ','Jueves 30 de Marzo del 17, a las 12:09:27         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16871,11,'                              ','Jueves 30 de Marzo del 17, a las 12:25:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16872,11,'                              ','Jueves 30 de Marzo del 17, a las 12:36:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16873,11,'                              ','Jueves 30 de Marzo del 17, a las 12:38:41         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16874,11,'                              ','Jueves 30 de Marzo del 17, a las 12:55:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16875,11,'                              ','Jueves 30 de Marzo del 17, a las 12:58:19         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16876,11,'                              ','Jueves 30 de Marzo del 17, a las 13:04:26         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16877,11,'                              ','Jueves 30 de Marzo del 17, a las 13:07:31         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16878,11,'                              ','Jueves 30 de Marzo del 17, a las 13:11:09         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16879,6,'                              ','Viernes 31 de Marzo del 17, a las 16:31:08        ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16880,11,'                              ','Lunes 3 de Abril del 17, a las 12:38:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16881,6,'                              ','Jueves 20 de Abril del 17, a las 09:16:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16882,6,'                              ','Jueves 20 de Abril del 17, a las 09:23:29         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16883,6,'                              ','Jueves 20 de Abril del 17, a las 09:24:07         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16884,6,'                              ','Jueves 20 de Abril del 17, a las 09:32:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16885,6,'                              ','Jueves 20 de Abril del 17, a las 09:42:21         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16886,6,'                              ','Jueves 20 de Abril del 17, a las 09:43:37         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16887,11,'                              ','Jueves 20 de Abril del 17, a las 09:59:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16888,11,'                              ','Jueves 20 de Abril del 17, a las 10:01:48         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16889,11,'                              ','Jueves 20 de Abril del 17, a las 10:24:22         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16890,6,'                              ','Lunes 24 de Abril del 17, a las 09:18:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16891,11,'                              ','Lunes 24 de Abril del 17, a las 09:31:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16892,11,'                              ','Lunes 24 de Abril del 17, a las 09:32:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16893,6,'                              ','Lunes 24 de Abril del 17, a las 13:30:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16894,11,'                              ','Martes 9 de Mayo del 17, a las 10:48:40           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16895,6,'                              ','Jueves 11 de Mayo del 17, a las 09:33:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16896,6,'                              ','Martes 16 de Mayo del 17, a las 11:50:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16897,6,'                              ','Martes 16 de Mayo del 17, a las 12:07:17          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16898,11,'                              ','Martes 16 de Mayo del 17, a las 12:30:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16899,6,'                              ','Martes 16 de Mayo del 17, a las 12:51:07          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16900,11,'                              ','Martes 16 de Mayo del 17, a las 12:54:01          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16901,6,'                              ','Martes 16 de Mayo del 17, a las 12:56:04          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16902,4,'                              ','Mircoles 24 de Mayo del 17, a las 14:31:19       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16903,11,'                              ','Mircoles 24 de Mayo del 17, a las 14:33:10       ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16904,6,'                              ','Viernes 26 de Mayo del 17, a las 13:30:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16905,6,'                              ','Viernes 26 de Mayo del 17, a las 14:12:30         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16906,11,'                              ','Viernes 26 de Mayo del 17, a las 14:14:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16907,10,'                              ','Viernes 26 de Mayo del 17, a las 14:14:35         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16908,8,'                              ','Viernes 26 de Mayo del 17, a las 14:16:15         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16909,6,'                              ','Jueves 1 de Junio del 17, a las 12:46:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16910,6,'                              ','Jueves 1 de Junio del 17, a las 12:47:05          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16911,6,'                              ','Jueves 1 de Junio del 17, a las 12:50:03          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16912,6,'                              ','Jueves 1 de Junio del 17, a las 12:53:40          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16913,11,'                              ','Lunes 5 de Junio del 17, a las 10:02:54           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16914,11,'                              ','Lunes 5 de Junio del 17, a las 10:10:01           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16915,11,'                              ','Lunes 5 de Junio del 17, a las 10:31:30           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16916,11,'                              ','Lunes 5 de Junio del 17, a las 10:33:09           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16917,11,'                              ','Lunes 5 de Junio del 17, a las 10:34:53           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16918,11,'                              ','Lunes 5 de Junio del 17, a las 10:37:38           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16919,11,'                              ','Lunes 5 de Junio del 17, a las 10:38:12           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16920,11,'                              ','Lunes 5 de Junio del 17, a las 10:41:18           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16921,11,'                              ','Lunes 5 de Junio del 17, a las 10:51:23           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16922,11,'                              ','Lunes 5 de Junio del 17, a las 10:59:51           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16923,11,'                              ','Lunes 5 de Junio del 17, a las 11:07:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16924,11,'                              ','Lunes 5 de Junio del 17, a las 11:09:48           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16925,11,'                              ','Lunes 5 de Junio del 17, a las 11:16:42           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16926,11,'                              ','Lunes 5 de Junio del 17, a las 11:23:33           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16927,11,'                              ','Lunes 5 de Junio del 17, a las 11:36:15           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16928,11,'                              ','Lunes 5 de Junio del 17, a las 11:54:32           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16929,11,'                              ','Lunes 5 de Junio del 17, a las 11:58:21           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16930,53,'                              ','Lunes 5 de Junio del 17, a las 12:01:12           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16931,11,'                              ','Lunes 5 de Junio del 17, a las 12:04:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16932,6,'                              ','Lunes 5 de Junio del 17, a las 12:07:02           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16933,11,'                              ','Lunes 5 de Junio del 17, a las 12:17:25           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16934,11,'                              ','Lunes 5 de Junio del 17, a las 12:49:52           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16935,11,'                              ','Lunes 5 de Junio del 17, a las 12:55:24           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16936,11,'                              ','Lunes 5 de Junio del 17, a las 13:02:47           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16937,11,'                              ','Lunes 5 de Junio del 17, a las 14:09:26           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16938,53,'                              ','Lunes 5 de Junio del 17, a las 14:23:20           ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16939,6,'                              ','Lunes 5 de Junio del 17, a las 14:37:19           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16940,11,'                              ','Lunes 5 de Junio del 17, a las 14:41:08           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16941,11,'                              ','Lunes 5 de Junio del 17, a las 14:42:29           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16942,6,'                              ','Lunes 5 de Junio del 17, a las 14:44:31           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16943,6,'                              ','Lunes 5 de Junio del 17, a las 14:44:50           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16944,11,'                              ','Lunes 5 de Junio del 17, a las 14:50:04           ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16945,6,'                              ','Jueves 8 de Junio del 17, a las 13:56:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16946,6,'                              ','Lunes 12 de Junio del 17, a las 10:29:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16947,6,'                              ','Lunes 12 de Junio del 17, a las 10:30:18          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16948,11,'                              ','Lunes 12 de Junio del 17, a las 10:34:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16949,11,'                              ','Lunes 12 de Junio del 17, a las 10:37:21          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16950,4,'                              ','Lunes 12 de Junio del 17, a las 11:00:00          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16951,11,'                              ','Lunes 12 de Junio del 17, a las 11:43:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16952,6,'                              ','Lunes 12 de Junio del 17, a las 11:50:39          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16953,6,'                              ','Lunes 12 de Junio del 17, a las 11:53:15          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16954,6,'                              ','Lunes 12 de Junio del 17, a las 11:56:23          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16955,6,'                              ','Lunes 12 de Junio del 17, a las 11:58:37          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16956,53,'                              ','Lunes 12 de Junio del 17, a las 12:00:24          ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16957,6,'                              ','Lunes 12 de Junio del 17, a las 12:02:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16958,11,'                              ','Lunes 12 de Junio del 17, a las 12:04:43          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16959,6,'                              ','Lunes 12 de Junio del 17, a las 12:08:47          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16960,6,'                              ','Lunes 12 de Junio del 17, a las 12:09:52          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16961,6,'                              ','Lunes 12 de Junio del 17, a las 12:10:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16962,6,'                              ','Lunes 12 de Junio del 17, a las 12:11:29          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16963,6,'                              ','Lunes 12 de Junio del 17, a las 12:11:49          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16964,11,'                              ','Lunes 12 de Junio del 17, a las 12:15:56          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16965,11,'                              ','Lunes 12 de Junio del 17, a las 12:20:48          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16966,6,'                              ','Lunes 12 de Junio del 17, a las 12:22:25          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16967,11,'                              ','Lunes 12 de Junio del 17, a las 12:34:06          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16968,4,'                              ','Martes 13 de Junio del 17, a las 12:08:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16969,6,'                              ','Martes 13 de Junio del 17, a las 13:23:53         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16970,6,'                              ','Martes 13 de Junio del 17, a las 13:25:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16971,6,'                              ','Mircoles 14 de Junio del 17, a las 10:18:39      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16972,6,'                              ','Mircoles 14 de Junio del 17, a las 10:21:54      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16973,11,'                              ','Mircoles 14 de Junio del 17, a las 10:58:09      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16974,11,'                              ','Mircoles 14 de Junio del 17, a las 11:31:08      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16975,11,'                              ','Mircoles 14 de Junio del 17, a las 11:31:44      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16976,11,'                              ','Mircoles 14 de Junio del 17, a las 11:36:40      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16977,11,'                              ','Jueves 15 de Junio del 17, a las 09:57:42         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16978,11,'                              ','Jueves 15 de Junio del 17, a las 10:05:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16979,11,'                              ','Jueves 15 de Junio del 17, a las 10:08:25         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16980,11,'                              ','Jueves 15 de Junio del 17, a las 10:17:08         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16981,11,'                              ','Jueves 15 de Junio del 17, a las 10:21:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16982,11,'                              ','Jueves 15 de Junio del 17, a las 10:25:46         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16983,11,'                              ','Jueves 15 de Junio del 17, a las 12:59:44         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16984,11,'                              ','Jueves 15 de Junio del 17, a las 13:06:02         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16985,11,'                              ','Jueves 15 de Junio del 17, a las 13:29:51         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16986,53,'                              ','Jueves 15 de Junio del 17, a las 13:30:12         ',6);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16987,11,'                              ','Jueves 15 de Junio del 17, a las 13:34:32         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16988,6,'                              ','Jueves 15 de Junio del 17, a las 13:38:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16989,6,'                              ','Jueves 15 de Junio del 17, a las 13:40:01         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16990,11,'                              ','Jueves 15 de Junio del 17, a las 13:44:05         ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16991,6,'                              ','Lunes 19 de Junio del 17, a las 09:32:35          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16992,6,'                              ','Lunes 19 de Junio del 17, a las 09:33:55          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16993,6,'                              ','Lunes 19 de Junio del 17, a las 09:39:50          ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16994,6,'                              ','Mircoles 21 de Junio del 17, a las 16:00:25      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16995,11,'                              ','Mircoles 21 de Junio del 17, a las 16:08:32      ',0);
INSERT INTO "modificacion" ("mod_id","mod_id_tabla","mod_tabla","mod_fecha","mod_area") VALUES (16996,53,'                              ','Mircoles 21 de Junio del 17, a las 16:20:43      ',6);
--
-- Data for TOC Entry ID 69 (OID 3235416)
--
-- Name: bitacora Type: TABLE DATA Owner: israeld
--


INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1,'20170110','15:00:39','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2,'20170110','15:00:48','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3,'20170110','15:01:30','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4,'20170110','15:08:16','148.228.121.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5,'20170110','15:11:49','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6,'20170110','15:21:50','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7,'20170110','15:23:25','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (8,'20170110','15:40:26','200.23.51.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (9,'20170110','16:19:24','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (10,'20170110','16:36:17','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (11,'20170110','17:01:49','132.248.182.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (12,'20170110','17:17:27','148.243.123.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (13,'20170110','18:01:54','132.248.242.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (14,'20170110','18:14:02','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (15,'20170110','18:17:52','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (16,'20170110','18:37:01','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (17,'20170110','18:50:59','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (18,'20170110','18:57:54','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (19,'20170110','21:18:32','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (20,'20170110','21:19:00','189.216.197.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (21,'20170110','22:40:48','189.217.227.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (22,'20170110','22:42:50','189.217.203.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (23,'20170111','00:16:21','187.169.47.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (24,'20170111','05:16:18','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (25,'20170111','06:56:19','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (26,'20170111','08:09:38','132.248.95.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (27,'20170111','08:25:34','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (28,'20170111','08:47:50','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (29,'20170111','08:50:39','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (30,'20170111','08:51:49','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (31,'20170111','09:23:23','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (32,'20170111','09:45:54','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (33,'20170111','09:49:42','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (34,'20170111','10:01:13','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (35,'20170111','10:04:10','187.207.0.255');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (36,'20170111','10:09:07','189.147.110.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (37,'20170111','10:17:31','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (38,'20170111','10:17:32','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (39,'20170111','10:17:57','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (40,'20170111','10:18:36','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (41,'20170111','10:20:07','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (42,'20170111','10:34:48','189.146.218.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (43,'20170111','10:36:01','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (44,'20170111','11:02:10','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (45,'20170111','11:19:56','189.216.205.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (46,'20170111','11:43:01','189.217.68.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (47,'20170111','11:43:14','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (48,'20170111','11:43:33','148.204.42.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (49,'20170111','11:44:37','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (50,'20170111','11:47:33','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (51,'20170111','12:07:45','132.248.182.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (52,'20170111','12:09:17','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (53,'20170111','12:26:55','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (54,'20170111','12:29:16','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (55,'20170111','12:41:28','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (56,'20170111','12:58:04','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (57,'20170111','13:03:55','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (58,'20170111','13:04:01','187.234.61.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (59,'20170111','13:15:01','66.249.65.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (60,'20170111','13:21:32','187.234.211.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (61,'20170111','13:48:33','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (62,'20170111','13:51:37','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (63,'20170111','14:28:53','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (64,'20170111','14:30:21','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (65,'20170111','14:31:46','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (66,'20170111','14:48:32','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (67,'20170111','14:51:17','66.249.65.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (68,'20170111','15:07:00','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (69,'20170111','15:34:41','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (70,'20170111','15:42:25','132.248.101.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (71,'20170111','15:49:54','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (72,'20170111','16:30:51','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (73,'20170111','16:39:38','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (74,'20170111','16:48:03','132.248.178.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (75,'20170111','17:04:33','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (76,'20170111','17:46:28','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (77,'20170111','18:10:05','187.163.198.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (78,'20170111','18:25:32','201.153.249.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (79,'20170111','18:54:18','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (80,'20170111','19:49:49','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (81,'20170111','21:02:16','66.102.7.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (82,'20170111','21:02:44','66.102.7.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (83,'20170111','21:34:35','201.102.251.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (84,'20170112','08:41:04','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (85,'20170112','08:55:44','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (86,'20170112','09:05:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (87,'20170112','09:15:45','200.76.83.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (88,'20170112','09:16:16','200.76.83.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (89,'20170112','09:16:31','200.76.83.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (90,'20170112','09:16:34','200.76.83.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (91,'20170112','09:25:43','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (92,'20170112','09:28:37','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (93,'20170112','09:31:05','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (94,'20170112','09:44:53','148.247.103.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (95,'20170112','09:52:33','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (96,'20170112','10:25:22','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (97,'20170112','10:45:50','192.100.180.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (98,'20170112','10:51:30','180.76.15.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (99,'20170112','11:04:48','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (100,'20170112','11:26:49','66.102.7.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (101,'20170112','11:42:53','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (102,'20170112','11:56:20','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (103,'20170112','11:57:01','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (104,'20170112','12:01:57','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (105,'20170112','12:20:05','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (106,'20170112','12:46:14','201.137.22.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (107,'20170112','13:05:58','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (108,'20170112','13:07:18','132.248.245.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (109,'20170112','13:12:20','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (110,'20170112','13:12:43','189.216.180.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (111,'20170112','13:25:52','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (112,'20170112','13:28:42','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (113,'20170112','13:41:42','132.248.67.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (114,'20170112','13:45:11','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (115,'20170112','13:57:04','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (116,'20170112','13:59:26','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (117,'20170112','14:07:06','201.141.160.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (118,'20170112','14:11:50','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (119,'20170112','14:18:18','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (120,'20170112','14:27:25','132.248.26.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (121,'20170112','15:07:39','189.216.182.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (122,'20170112','15:07:48','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (123,'20170112','15:20:59','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (124,'20170112','15:35:41','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (125,'20170112','15:43:21','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (126,'20170112','16:26:29','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (127,'20170112','17:05:08','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (128,'20170112','17:47:10','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (129,'20170112','17:54:22','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (130,'20170112','18:32:00','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (131,'20170112','18:37:42','201.141.23.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (132,'20170112','19:04:27','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (133,'20170112','19:59:22','200.33.101.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (134,'20170112','20:16:02','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (135,'20170112','20:38:32','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (136,'20170112','21:49:56','201.110.162.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (137,'20170113','06:20:26','66.249.65.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (138,'20170113','07:35:31','180.76.15.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (139,'20170113','08:39:25','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (140,'20170113','08:54:56','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (141,'20170113','09:03:54','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (142,'20170113','09:09:12','132.248.67.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (143,'20170113','09:27:08','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (144,'20170113','09:33:59','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (145,'20170113','09:50:36','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (146,'20170113','09:53:15','132.248.182.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (147,'20170113','09:58:31','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (148,'20170113','10:20:02','132.248.92.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (149,'20170113','10:39:38','132.248.35.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (150,'20170113','10:45:35','132.248.26.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (151,'20170113','10:49:21','66.249.66.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (152,'20170113','10:54:32','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (153,'20170113','11:13:54','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (154,'20170113','11:25:24','132.248.86.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (155,'20170113','11:44:02','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (156,'20170113','11:50:11','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (157,'20170113','11:53:22','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (158,'20170113','11:59:34','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (159,'20170113','12:11:18','132.248.160.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (160,'20170113','12:24:09','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (161,'20170113','12:47:51','187.189.220.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (162,'20170113','12:54:30','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (163,'20170113','12:56:50','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (164,'20170113','13:00:12','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (165,'20170113','13:40:35','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (166,'20170113','13:48:40','132.248.54.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (167,'20170113','14:10:35','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (168,'20170113','14:11:12','201.141.163.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (169,'20170113','14:15:55','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (170,'20170113','15:29:02','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (171,'20170113','16:27:13','132.248.178.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (172,'20170113','16:57:38','187.228.90.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (173,'20170113','17:07:47','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (174,'20170113','17:10:12','189.216.180.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (175,'20170113','17:33:35','200.56.146.107');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (176,'20170113','19:18:23','132.248.60.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (177,'20170114','00:13:47','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (178,'20170114','01:55:47','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (179,'20170114','03:32:39','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (180,'20170114','08:42:22','180.76.15.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (181,'20170114','11:32:08','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (182,'20170114','16:26:05','189.249.83.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (183,'20170115','02:41:58','180.76.15.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (184,'20170115','03:41:49','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (185,'20170115','06:06:05','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (186,'20170115','06:31:26','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (187,'20170115','06:41:15','189.216.150.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (188,'20170115','07:20:33','41.47.90.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (189,'20170115','07:59:41','187.213.173.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (190,'20170115','09:11:56','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (191,'20170115','18:11:14','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (192,'20170115','22:07:54','187.190.81.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (193,'20170115','23:30:00','83.50.60.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (194,'20170116','04:01:39','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (195,'20170116','08:39:51','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (196,'20170116','08:54:31','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (197,'20170116','09:12:16','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (198,'20170116','09:20:33','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (199,'20170116','09:49:06','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (200,'20170116','09:54:44','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (201,'20170116','10:03:24','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (202,'20170116','10:09:42','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (203,'20170116','10:18:47','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (204,'20170116','10:30:09','132.248.9.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (205,'20170116','11:17:48','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (206,'20170116','11:23:06','187.189.117.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (207,'20170116','11:24:31','189.146.192.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (208,'20170116','11:27:49','189.241.227.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (209,'20170116','11:32:02','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (210,'20170116','11:47:50','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (211,'20170116','11:50:14','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (212,'20170116','11:52:54','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (213,'20170116','11:57:58','187.189.220.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (214,'20170116','12:30:10','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (215,'20170116','12:32:53','148.206.160.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (216,'20170116','12:44:54','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (217,'20170116','12:50:59','189.211.128.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (218,'20170116','12:51:00','132.248.82.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (219,'20170116','12:56:35','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (220,'20170116','13:00:45','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (221,'20170116','13:09:39','148.240.197.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (222,'20170116','13:12:20','132.248.159.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (223,'20170116','13:15:16','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (224,'20170116','13:20:59','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (225,'20170116','13:37:14','140.148.78.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (226,'20170116','14:12:36','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (227,'20170116','14:27:32','200.57.3.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (228,'20170116','14:32:07','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (229,'20170116','14:44:01','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (230,'20170116','14:57:57','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (231,'20170116','15:16:07','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (232,'20170116','16:18:41','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (233,'20170116','17:08:40','201.103.43.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (234,'20170116','17:12:18','132.247.172.45');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (235,'20170116','17:18:06','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (236,'20170116','17:18:20','189.216.197.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (237,'20170116','17:34:34','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (238,'20170116','18:19:31','187.169.195.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (239,'20170116','18:41:32','187.145.153.37');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (240,'20170116','20:07:58','132.248.87.40');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (241,'20170116','20:15:56','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (242,'20170116','20:39:15','132.248.141.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (243,'20170116','21:57:28','201.119.145.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (244,'20170117','00:07:27','108.61.60.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (245,'20170117','00:09:19','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (246,'20170117','00:14:27','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (247,'20170117','01:05:33','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (248,'20170117','08:28:37','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (249,'20170117','09:02:28','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (250,'20170117','09:11:08','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (251,'20170117','09:13:21','132.248.95.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (252,'20170117','09:44:27','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (253,'20170117','09:50:19','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (254,'20170117','09:58:03','148.206.160.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (255,'20170117','10:00:25','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (256,'20170117','10:17:03','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (257,'20170117','10:20:28','148.247.69.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (258,'20170117','10:25:34','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (259,'20170117','10:26:48','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (260,'20170117','10:27:07','189.216.204.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (261,'20170117','11:11:04','180.76.15.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (262,'20170117','11:32:52','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (263,'20170117','11:44:33','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (264,'20170117','11:56:09','189.216.113.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (265,'20170117','11:59:49','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (266,'20170117','12:38:08','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (267,'20170117','12:42:17','187.227.149.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (268,'20170117','12:45:29','132.248.74.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (269,'20170117','12:50:53','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (270,'20170117','13:15:36','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (271,'20170117','13:19:02','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (272,'20170117','13:26:35','187.168.16.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (273,'20170117','13:31:07','201.103.176.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (274,'20170117','13:34:24','207.46.13.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (275,'20170117','13:55:19','201.103.210.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (276,'20170117','14:36:10','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (277,'20170117','14:47:13','187.170.8.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (278,'20170117','15:31:55','52.201.244.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (279,'20170117','16:27:41','177.237.185.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (280,'20170117','17:07:30','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (281,'20170117','17:27:56','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (282,'20170117','18:08:05','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (283,'20170117','18:45:54','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (284,'20170117','18:58:21','148.206.53.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (285,'20170117','19:01:40','52.207.224.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (286,'20170117','19:17:27','180.76.15.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (287,'20170117','19:27:05','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (288,'20170117','21:55:00','189.143.71.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (289,'20170118','01:19:44','189.146.228.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (290,'20170118','03:44:44','113.160.62.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (291,'20170118','07:44:20','194.187.170.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (292,'20170118','08:52:15','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (293,'20170118','09:01:36','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (294,'20170118','09:02:28','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (295,'20170118','09:02:46','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (296,'20170118','09:23:06','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (297,'20170118','09:24:19','132.248.95.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (298,'20170118','09:40:18','201.137.174.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (299,'20170118','09:40:32','201.137.168.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (300,'20170118','09:41:45','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (301,'20170118','09:55:09','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (302,'20170118','09:55:09','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (303,'20170118','10:02:28','201.119.216.192');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (304,'20170118','10:08:04','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (305,'20170118','10:14:58','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (306,'20170118','10:17:13','68.180.230.50');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (307,'20170118','10:23:14','148.240.208.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (308,'20170118','10:24:00','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (309,'20170118','10:39:17','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (310,'20170118','11:06:49','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (311,'20170118','11:18:11','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (312,'20170118','11:19:14','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (313,'20170118','11:23:14','132.248.26.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (314,'20170118','11:26:30','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (315,'20170118','11:34:54','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (316,'20170118','11:43:42','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (317,'20170118','11:47:27','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (318,'20170118','12:18:55','132.248.51.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (319,'20170118','12:44:33','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (320,'20170118','12:48:52','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (321,'20170118','12:57:18','132.248.86.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (322,'20170118','13:22:43','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (323,'20170118','13:28:35','189.217.203.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (324,'20170118','13:36:28','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (325,'20170118','13:42:03','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (326,'20170118','14:18:18','132.247.74.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (327,'20170118','14:25:56','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (328,'20170118','14:38:06','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (329,'20170118','14:43:38','201.141.170.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (330,'20170118','15:23:38','201.103.29.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (331,'20170118','16:05:30','201.130.58.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (332,'20170118','16:16:52','187.214.184.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (333,'20170118','16:23:23','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (334,'20170118','17:04:34','132.248.99.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (335,'20170118','17:22:27','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (336,'20170118','17:27:38','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (337,'20170118','17:28:31','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (338,'20170118','17:46:22','132.248.74.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (339,'20170118','18:01:21','189.167.240.35');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (340,'20170118','20:03:00','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (341,'20170118','20:57:26','132.248.102.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (342,'20170118','23:56:06','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (343,'20170118','23:58:48','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (344,'20170119','00:11:32','201.137.74.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (345,'20170119','03:06:24','180.76.15.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (346,'20170119','06:28:11','180.76.15.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (347,'20170119','08:08:27','132.247.61.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (348,'20170119','08:28:37','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (349,'20170119','08:44:31','201.161.11.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (350,'20170119','08:50:07','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (351,'20170119','08:53:28','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (352,'20170119','08:54:38','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (353,'20170119','09:14:45','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (354,'20170119','09:48:23','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (355,'20170119','09:55:56','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (356,'20170119','10:06:41','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (357,'20170119','10:09:15','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (358,'20170119','10:16:16','132.247.172.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (359,'20170119','10:49:58','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (360,'20170119','11:08:13','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (361,'20170119','11:18:16','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (362,'20170119','11:22:05','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (363,'20170119','12:00:54','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (364,'20170119','12:35:38','132.248.150.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (365,'20170119','12:39:28','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (366,'20170119','12:41:23','132.247.184.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (367,'20170119','12:50:14','140.148.78.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (368,'20170119','12:54:56','187.190.21.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (369,'20170119','12:56:17','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (370,'20170119','13:15:12','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (371,'20170119','13:24:28','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (372,'20170119','13:29:14','132.248.35.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (373,'20170119','13:40:44','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (374,'20170119','14:04:22','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (375,'20170119','14:10:23','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (376,'20170119','14:22:43','201.141.85.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (377,'20170119','14:25:15','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (378,'20170119','14:30:16','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (379,'20170119','14:37:57','201.103.12.225');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (380,'20170119','14:47:55','201.151.78.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (381,'20170119','14:56:51','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (382,'20170119','15:07:39','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (383,'20170119','17:15:08','132.247.198.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (384,'20170119','17:38:05','189.245.225.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (385,'20170119','17:57:07','66.249.84.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (386,'20170119','17:57:38','66.249.84.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (387,'20170119','17:57:47','66.249.84.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (388,'20170119','18:01:07','148.202.254.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (389,'20170119','18:03:34','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (390,'20170119','18:49:43','140.148.78.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (391,'20170119','19:13:53','187.159.53.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (392,'20170119','19:35:42','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (393,'20170119','19:53:06','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (394,'20170119','19:53:26','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (395,'20170119','21:14:07','187.169.185.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (396,'20170119','23:05:13','189.147.232.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (397,'20170119','23:38:13','180.76.15.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (398,'20170120','00:06:56','189.148.47.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (399,'20170120','02:09:47','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (400,'20170120','02:20:07','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (401,'20170120','04:32:28','180.76.15.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (402,'20170120','08:40:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (403,'20170120','08:48:29','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (404,'20170120','09:25:20','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (405,'20170120','09:43:42','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (406,'20170120','09:48:37','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (407,'20170120','09:48:57','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (408,'20170120','09:53:32','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (409,'20170120','09:58:13','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (410,'20170120','10:14:26','129.59.151.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (411,'20170120','10:24:47','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (412,'20170120','10:25:19','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (413,'20170120','10:33:57','148.206.160.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (414,'20170120','10:54:44','201.103.133.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (415,'20170120','10:58:50','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (416,'20170120','11:12:11','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (417,'20170120','11:16:45','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (418,'20170120','11:35:26','201.103.0.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (419,'20170120','11:36:40','132.248.9.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (420,'20170120','11:37:00','132.248.52.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (421,'20170120','12:14:22','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (422,'20170120','12:16:59','148.243.123.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (423,'20170120','12:27:25','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (424,'20170120','12:39:10','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (425,'20170120','12:49:30','201.103.54.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (426,'20170120','12:55:57','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (427,'20170120','13:18:29','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (428,'20170120','13:20:32','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (429,'20170120','13:31:50','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (430,'20170120','13:53:34','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (431,'20170120','14:10:00','187.234.228.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (432,'20170120','14:12:23','132.248.59.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (433,'20170120','14:29:32','187.170.98.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (434,'20170120','14:31:22','132.248.182.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (435,'20170120','14:48:41','207.46.13.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (436,'20170120','15:12:08','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (437,'20170120','15:13:14','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (438,'20170120','15:33:10','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (439,'20170120','15:51:11','201.161.11.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (440,'20170120','16:56:23','187.214.184.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (441,'20170120','17:48:31','132.248.164.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (442,'20170120','17:56:36','181.39.158.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (443,'20170120','18:01:52','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (444,'20170120','18:06:16','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (445,'20170120','18:19:58','189.200.47.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (446,'20170120','19:12:41','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (447,'20170120','20:06:08','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (448,'20170120','21:10:21','148.230.10.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (449,'20170120','23:07:22','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (450,'20170121','02:21:29','180.76.15.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (451,'20170121','05:17:35','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (452,'20170121','07:58:03','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (453,'20170121','08:36:40','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (454,'20170121','13:35:27','123.126.113.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (455,'20170121','18:57:18','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (456,'20170121','22:42:05','187.237.14.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (457,'20170122','05:14:27','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (458,'20170122','11:15:02','180.76.15.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (459,'20170122','13:56:34','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (460,'20170122','14:07:36','189.216.198.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (461,'20170122','16:41:39','108.62.204.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (462,'20170122','18:36:10','189.136.20.53');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (463,'20170122','19:16:50','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (464,'20170122','19:52:17','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (465,'20170122','23:18:42','189.143.46.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (466,'20170123','00:04:47','189.239.66.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (467,'20170123','00:54:10','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (468,'20170123','00:58:38','187.168.16.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (469,'20170123','02:26:01','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (470,'20170123','03:06:57','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (471,'20170123','08:52:14','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (472,'20170123','08:58:54','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (473,'20170123','08:59:02','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (474,'20170123','09:09:43','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (475,'20170123','09:16:02','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (476,'20170123','09:18:16','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (477,'20170123','09:18:21','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (478,'20170123','09:30:04','189.146.153.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (479,'20170123','09:41:53','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (480,'20170123','09:46:56','132.248.90.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (481,'20170123','09:47:38','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (482,'20170123','09:50:28','148.243.123.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (483,'20170123','09:53:11','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (484,'20170123','10:04:32','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (485,'20170123','10:05:09','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (486,'20170123','10:17:29','132.247.172.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (487,'20170123','10:20:05','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (488,'20170123','10:24:48','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (489,'20170123','10:32:17','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (490,'20170123','10:34:33','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (491,'20170123','10:41:30','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (492,'20170123','11:13:22','201.103.153.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (493,'20170123','11:24:09','201.159.133.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (494,'20170123','11:26:15','189.143.144.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (495,'20170123','11:27:43','189.216.180.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (496,'20170123','11:41:31','132.247.204.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (497,'20170123','11:49:15','187.206.170.50');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (498,'20170123','12:07:56','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (499,'20170123','12:11:52','140.148.78.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (500,'20170123','12:22:26','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (501,'20170123','12:22:46','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (502,'20170123','12:35:32','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (503,'20170123','12:40:45','132.248.228.127');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (504,'20170123','12:46:49','132.248.90.118');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (505,'20170123','12:58:48','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (506,'20170123','13:06:16','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (507,'20170123','13:47:31','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (508,'20170123','13:53:22','148.206.53.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (509,'20170123','14:25:02','132.248.101.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (510,'20170123','14:36:08','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (511,'20170123','14:51:40','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (512,'20170123','15:03:20','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (513,'20170123','15:13:52','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (514,'20170123','15:50:50','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (515,'20170123','16:10:19','180.76.15.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (516,'20170123','16:33:45','200.33.101.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (517,'20170123','16:36:02','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (518,'20170123','17:13:16','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (519,'20170123','17:28:30','187.214.184.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (520,'20170123','17:43:38','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (521,'20170123','18:18:57','189.216.104.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (522,'20170123','18:29:26','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (523,'20170123','18:58:52','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (524,'20170123','19:20:31','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (525,'20170123','20:44:52','132.248.67.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (526,'20170123','20:57:37','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (527,'20170123','21:20:25','189.217.62.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (528,'20170124','00:14:22','180.76.15.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (529,'20170124','08:26:52','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (530,'20170124','08:51:04','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (531,'20170124','09:00:03','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (532,'20170124','09:33:46','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (533,'20170124','09:40:49','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (534,'20170124','09:41:32','148.243.123.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (535,'20170124','09:55:07','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (536,'20170124','09:55:47','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (537,'20170124','10:00:09','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (538,'20170124','10:14:42','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (539,'20170124','10:18:51','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (540,'20170124','10:18:52','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (541,'20170124','10:32:19','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (542,'20170124','10:44:48','163.172.64.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (543,'20170124','10:45:27','148.213.80.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (544,'20170124','10:54:22','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (545,'20170124','10:55:59','148.206.160.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (546,'20170124','11:08:24','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (547,'20170124','11:31:16','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (548,'20170124','11:35:51','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (549,'20170124','11:48:14','189.216.205.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (550,'20170124','11:51:43','132.248.52.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (551,'20170124','12:00:17','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (552,'20170124','12:04:08','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (553,'20170124','12:20:40','132.248.92.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (554,'20170124','12:52:17','132.247.204.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (555,'20170124','13:06:52','132.248.86.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (556,'20170124','13:17:21','132.247.172.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (557,'20170124','13:21:05','132.248.9.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (558,'20170124','13:21:42','132.248.41.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (559,'20170124','13:33:27','189.216.180.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (560,'20170124','13:34:03','189.216.181.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (561,'20170124','13:34:54','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (562,'20170124','13:42:09','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (563,'20170124','14:19:03','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (564,'20170124','14:24:36','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (565,'20170124','14:37:09','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (566,'20170124','14:57:54','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (567,'20170124','15:01:36','201.153.238.231');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (568,'20170124','15:05:26','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (569,'20170124','15:07:44','132.248.143.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (570,'20170124','15:20:31','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (571,'20170124','15:48:49','187.228.57.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (572,'20170124','16:11:32','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (573,'20170124','16:35:06','189.216.199.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (574,'20170124','16:41:11','189.137.220.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (575,'20170124','16:41:52','132.248.44.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (576,'20170124','16:49:39','132.248.150.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (577,'20170124','17:09:48','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (578,'20170124','17:38:11','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (579,'20170124','17:54:38','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (580,'20170124','17:59:39','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (581,'20170124','19:14:04','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (582,'20170124','19:44:05','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (583,'20170124','19:46:29','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (584,'20170124','19:49:43','132.248.67.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (585,'20170124','20:35:18','148.206.53.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (586,'20170125','01:02:30','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (587,'20170125','08:45:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (588,'20170125','08:55:55','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (589,'20170125','08:57:27','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (590,'20170125','09:00:20','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (591,'20170125','09:01:44','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (592,'20170125','09:02:37','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (593,'20170125','09:17:06','189.136.225.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (594,'20170125','09:20:54','180.76.15.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (595,'20170125','09:37:36','132.248.26.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (596,'20170125','09:41:24','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (597,'20170125','09:42:09','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (598,'20170125','09:44:29','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (599,'20170125','09:55:56','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (600,'20170125','10:10:41','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (601,'20170125','10:16:24','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (602,'20170125','10:45:06','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (603,'20170125','10:50:20','187.207.145.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (604,'20170125','11:18:42','189.208.142.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (605,'20170125','11:19:34','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (606,'20170125','11:27:13','132.248.159.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (607,'20170125','11:48:57','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (608,'20170125','12:03:24','132.247.120.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (609,'20170125','12:03:36','132.247.120.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (610,'20170125','12:03:36','132.247.120.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (611,'20170125','12:13:07','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (612,'20170125','12:28:19','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (613,'20170125','12:37:29','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (614,'20170125','12:45:26','187.188.82.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (615,'20170125','12:45:39','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (616,'20170125','12:46:20','187.234.237.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (617,'20170125','12:46:51','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (618,'20170125','12:48:11','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (619,'20170125','13:00:02','143.0.102.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (620,'20170125','13:02:26','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (621,'20170125','13:20:21','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (622,'20170125','13:47:15','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (623,'20170125','13:54:24','144.76.102.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (624,'20170125','13:54:32','189.216.182.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (625,'20170125','14:06:08','132.248.147.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (626,'20170125','14:28:54','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (627,'20170125','14:48:42','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (628,'20170125','15:03:18','132.248.64.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (629,'20170125','15:32:29','132.248.9.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (630,'20170125','15:41:19','189.216.180.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (631,'20170125','16:04:47','148.206.53.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (632,'20170125','16:47:13','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (633,'20170125','16:49:05','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (634,'20170125','16:51:14','132.247.110.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (635,'20170125','17:13:40','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (636,'20170125','17:37:17','189.177.166.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (637,'20170125','18:05:35','189.144.61.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (638,'20170125','18:35:03','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (639,'20170125','19:06:31','132.248.86.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (640,'20170125','19:55:41','189.216.199.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (641,'20170125','20:07:41','189.216.150.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (642,'20170125','21:02:21','201.113.55.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (643,'20170126','00:31:28','189.215.230.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (644,'20170126','00:31:51','187.206.7.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (645,'20170126','02:47:37','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (646,'20170126','08:42:50','180.76.15.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (647,'20170126','08:43:15','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (648,'20170126','08:52:16','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (649,'20170126','08:52:26','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (650,'20170126','09:00:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (651,'20170126','09:33:22','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (652,'20170126','09:45:58','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (653,'20170126','09:54:23','132.248.159.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (654,'20170126','09:55:40','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (655,'20170126','10:04:35','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (656,'20170126','10:10:00','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (657,'20170126','10:10:18','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (658,'20170126','10:11:19','132.248.9.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (659,'20170126','10:18:05','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (660,'20170126','10:34:46','132.248.87.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (661,'20170126','10:39:00','132.247.204.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (662,'20170126','10:41:02','132.248.90.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (663,'20170126','10:48:03','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (664,'20170126','11:01:55','132.248.67.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (665,'20170126','11:04:01','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (666,'20170126','11:19:04','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (667,'20170126','11:19:20','132.248.51.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (668,'20170126','11:35:21','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (669,'20170126','11:41:14','132.247.184.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (670,'20170126','11:58:57','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (671,'20170126','12:01:12','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (672,'20170126','12:04:42','132.247.110.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (673,'20170126','12:26:19','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (674,'20170126','12:37:44','132.248.168.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (675,'20170126','12:40:50','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (676,'20170126','12:58:54','132.248.164.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (677,'20170126','13:03:08','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (678,'20170126','13:08:48','52.26.43.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (679,'20170126','13:09:07','189.146.75.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (680,'20170126','13:15:10','132.248.67.50');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (681,'20170126','13:33:00','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (682,'20170126','13:56:38','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (683,'20170126','14:03:51','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (684,'20170126','14:04:42','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (685,'20170126','14:06:01','189.216.183.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (686,'20170126','14:25:20','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (687,'20170126','14:27:13','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (688,'20170126','14:37:20','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (689,'20170126','14:38:34','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (690,'20170126','14:52:33','201.175.132.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (691,'20170126','15:08:14','132.248.116.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (692,'20170126','15:15:29','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (693,'20170126','15:27:41','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (694,'20170126','15:42:16','222.249.165.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (695,'20170126','16:24:11','189.216.199.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (696,'20170126','16:30:43','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (697,'20170126','16:59:58','132.248.196.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (698,'20170126','17:16:23','180.76.15.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (699,'20170126','17:23:39','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (700,'20170126','18:04:09','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (701,'20170126','18:07:51','201.113.55.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (702,'20170126','18:20:18','148.243.123.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (703,'20170126','18:34:04','200.33.101.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (704,'20170126','18:44:59','52.4.48.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (705,'20170126','19:48:36','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (706,'20170126','20:44:03','177.233.184.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (707,'20170126','21:37:48','201.157.87.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (708,'20170127','00:36:38','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (709,'20170127','00:36:39','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (710,'20170127','02:02:47','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (711,'20170127','08:50:55','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (712,'20170127','09:02:00','132.248.92.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (713,'20170127','09:03:00','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (714,'20170127','09:08:37','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (715,'20170127','09:11:04','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (716,'20170127','09:13:36','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (717,'20170127','09:35:36','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (718,'20170127','09:40:08','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (719,'20170127','09:40:14','187.188.82.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (720,'20170127','09:43:03','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (721,'20170127','10:26:47','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (722,'20170127','10:46:16','132.248.40.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (723,'20170127','10:50:52','187.141.124.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (724,'20170127','10:57:02','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (725,'20170127','10:57:50','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (726,'20170127','11:00:07','189.147.135.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (727,'20170127','11:21:12','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (728,'20170127','11:31:33','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (729,'20170127','11:44:45','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (730,'20170127','11:52:33','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (731,'20170127','12:03:09','132.248.67.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (732,'20170127','12:06:34','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (733,'20170127','12:25:00','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (734,'20170127','12:29:52','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (735,'20170127','12:44:16','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (736,'20170127','13:03:24','148.206.160.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (737,'20170127','13:19:03','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (738,'20170127','13:42:40','189.136.210.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (739,'20170127','13:43:33','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (740,'20170127','14:00:13','187.227.156.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (741,'20170127','14:02:53','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (742,'20170127','14:16:56','132.248.209.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (743,'20170127','14:17:32','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (744,'20170127','14:19:57','132.248.101.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (745,'20170127','14:49:58','189.147.224.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (746,'20170127','15:06:07','200.52.255.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (747,'20170127','15:18:49','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (748,'20170127','15:21:47','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (749,'20170127','15:38:09','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (750,'20170127','16:26:30','180.76.15.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (751,'20170127','16:31:22','187.217.106.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (752,'20170127','17:17:12','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (753,'20170127','18:14:43','52.86.176.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (754,'20170127','18:33:39','132.248.51.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (755,'20170127','19:11:31','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (756,'20170127','20:12:36','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (757,'20170127','22:45:55','187.170.221.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (758,'20170128','01:10:32','207.46.13.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (759,'20170128','09:08:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (760,'20170128','09:45:43','65.29.234.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (761,'20170128','11:17:55','189.148.205.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (762,'20170128','14:06:18','180.76.15.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (763,'20170128','15:11:46','148.246.68.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (764,'20170128','21:56:33','187.227.0.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (765,'20170128','22:30:08','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (766,'20170129','09:05:10','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (767,'20170129','14:37:28','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (768,'20170129','14:48:35','187.170.70.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (769,'20170129','21:33:15','189.217.227.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (770,'20170129','22:14:55','189.216.98.67');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (771,'20170129','23:14:10','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (772,'20170130','01:40:35','187.226.239.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (773,'20170130','08:45:54','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (774,'20170130','08:52:06','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (775,'20170130','09:00:08','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (776,'20170130','09:26:52','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (777,'20170130','09:39:04','132.248.72.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (778,'20170130','09:44:21','132.248.87.231');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (779,'20170130','10:13:26','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (780,'20170130','10:17:34','132.248.95.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (781,'20170130','10:20:59','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (782,'20170130','10:23:45','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (783,'20170130','10:42:49','148.206.160.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (784,'20170130','10:52:01','132.247.60.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (785,'20170130','10:53:39','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (786,'20170130','10:53:44','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (787,'20170130','10:53:51','132.247.172.107');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (788,'20170130','11:07:51','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (789,'20170130','11:35:50','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (790,'20170130','11:44:08','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (791,'20170130','12:05:50','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (792,'20170130','12:47:57','132.247.148.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (793,'20170130','12:56:41','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (794,'20170130','12:57:11','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (795,'20170130','13:01:46','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (796,'20170130','13:15:53','132.248.184.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (797,'20170130','13:20:40','189.245.182.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (798,'20170130','13:41:18','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (799,'20170130','13:49:56','201.221.122.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (800,'20170130','13:52:37','132.248.100.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (801,'20170130','13:59:18','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (802,'20170130','15:15:30','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (803,'20170130','15:45:45','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (804,'20170130','15:51:43','189.241.112.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (805,'20170130','16:01:38','207.46.13.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (806,'20170130','16:08:29','200.52.255.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (807,'20170130','16:16:27','132.247.218.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (808,'20170130','16:34:10','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (809,'20170130','16:57:57','132.248.180.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (810,'20170130','17:26:12','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (811,'20170130','18:00:14','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (812,'20170130','18:28:57','187.226.104.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (813,'20170130','18:34:36','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (814,'20170130','18:40:26','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (815,'20170130','19:03:45','189.146.58.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (816,'20170130','19:27:38','132.247.144.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (817,'20170130','21:15:15','189.216.181.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (818,'20170130','21:42:55','189.144.183.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (819,'20170130','23:51:41','180.76.15.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (820,'20170131','04:57:26','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (821,'20170131','08:05:38','132.247.63.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (822,'20170131','08:38:39','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (823,'20170131','08:46:32','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (824,'20170131','08:55:08','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (825,'20170131','09:01:02','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (826,'20170131','09:02:23','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (827,'20170131','09:53:11','148.206.160.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (828,'20170131','09:53:54','148.206.160.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (829,'20170131','10:19:37','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (830,'20170131','10:23:37','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (831,'20170131','10:38:33','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (832,'20170131','10:42:00','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (833,'20170131','10:42:17','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (834,'20170131','10:58:45','132.248.116.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (835,'20170131','11:26:17','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (836,'20170131','11:32:25','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (837,'20170131','12:07:14','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (838,'20170131','12:07:39','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (839,'20170131','12:13:06','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (840,'20170131','12:23:48','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (841,'20170131','12:41:16','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (842,'20170131','12:47:00','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (843,'20170131','12:59:29','201.157.90.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (844,'20170131','13:02:41','132.248.182.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (845,'20170131','13:08:06','132.248.90.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (846,'20170131','13:08:30','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (847,'20170131','13:12:21','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (848,'20170131','13:26:47','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (849,'20170131','13:42:48','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (850,'20170131','13:57:47','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (851,'20170131','14:06:55','132.248.67.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (852,'20170131','14:07:34','132.248.67.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (853,'20170131','14:13:04','187.168.6.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (854,'20170131','14:16:28','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (855,'20170131','14:37:34','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (856,'20170131','14:38:12','132.248.213.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (857,'20170131','14:39:30','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (858,'20170131','14:48:52','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (859,'20170131','14:55:09','132.248.172.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (860,'20170131','14:58:12','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (861,'20170131','15:04:57','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (862,'20170131','15:17:37','201.164.172.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (863,'20170131','15:29:11','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (864,'20170131','15:57:53','201.156.37.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (865,'20170131','16:34:08','200.52.255.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (866,'20170131','16:42:09','132.248.147.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (867,'20170131','16:46:16','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (868,'20170131','16:53:11','189.216.204.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (869,'20170131','17:04:37','187.241.68.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (870,'20170131','18:00:02','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (871,'20170131','18:40:29','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (872,'20170131','18:55:09','187.234.211.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (873,'20170131','19:01:33','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (874,'20170131','20:20:43','187.145.196.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (875,'20170131','20:26:50','189.203.188.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (876,'20170131','20:30:02','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (877,'20170131','21:07:48','187.190.154.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (878,'20170131','22:51:50','187.223.42.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (879,'20170131','23:44:21','201.137.121.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (880,'20170201','01:25:45','187.207.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (881,'20170201','01:39:46','189.216.115.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (882,'20170201','02:27:05','187.224.18.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (883,'20170201','08:48:41','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (884,'20170201','09:01:34','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (885,'20170201','09:04:34','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (886,'20170201','09:09:21','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (887,'20170201','09:18:25','132.248.67.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (888,'20170201','09:32:46','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (889,'20170201','09:47:01','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (890,'20170201','09:53:06','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (891,'20170201','09:58:03','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (892,'20170201','09:58:59','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (893,'20170201','10:03:43','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (894,'20170201','10:06:48','190.217.58.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (895,'20170201','10:13:05','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (896,'20170201','10:16:10','132.248.242.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (897,'20170201','10:16:27','66.220.156.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (898,'20170201','10:19:40','187.190.167.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (899,'20170201','10:33:36','187.223.67.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (900,'20170201','10:34:42','68.180.228.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (901,'20170201','11:04:20','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (902,'20170201','11:14:53','132.248.89.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (903,'20170201','11:33:29','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (904,'20170201','11:33:48','84.57.54.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (905,'20170201','11:35:28','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (906,'20170201','11:39:46','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (907,'20170201','11:40:47','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (908,'20170201','11:55:21','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (909,'20170201','12:05:39','201.132.160.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (910,'20170201','12:10:08','132.248.123.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (911,'20170201','12:11:52','148.206.160.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (912,'20170201','12:17:46','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (913,'20170201','12:24:32','132.248.122.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (914,'20170201','12:40:06','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (915,'20170201','12:46:41','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (916,'20170201','12:47:42','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (917,'20170201','12:58:24','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (918,'20170201','12:58:45','132.248.218.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (919,'20170201','13:33:20','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (920,'20170201','13:47:05','174.199.21.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (921,'20170201','13:50:42','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (922,'20170201','13:58:24','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (923,'20170201','14:18:42','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (924,'20170201','14:39:09','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (925,'20170201','14:55:45','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (926,'20170201','15:04:30','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (927,'20170201','15:08:48','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (928,'20170201','15:17:35','132.248.101.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (929,'20170201','15:27:14','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (930,'20170201','15:34:59','200.52.255.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (931,'20170201','15:36:53','132.248.67.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (932,'20170201','15:40:25','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (933,'20170201','15:41:17','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (934,'20170201','15:52:13','177.234.3.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (935,'20170201','16:01:24','66.249.69.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (936,'20170201','16:09:35','132.247.198.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (937,'20170201','16:12:46','132.248.11.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (938,'20170201','16:33:05','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (939,'20170201','16:36:48','187.190.21.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (940,'20170201','16:38:56','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (941,'20170201','16:56:48','189.143.5.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (942,'20170201','17:13:12','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (943,'20170201','17:21:03','192.0.89.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (944,'20170201','17:21:08','192.0.91.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (944,'20170201','17:21:08','192.0.91.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (946,'20170201','17:21:15','192.0.91.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (946,'20170201','17:21:15','192.0.91.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (948,'20170201','18:10:03','132.248.59.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (949,'20170201','18:21:14','66.249.69.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (950,'20170201','18:34:56','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (951,'20170201','18:39:54','132.248.9.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (952,'20170201','18:42:42','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (953,'20170201','18:44:23','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (954,'20170201','18:56:40','201.141.123.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (955,'20170201','19:04:22','187.200.76.37');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (956,'20170201','19:41:30','132.248.128.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (957,'20170201','19:50:01','187.188.14.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (958,'20170201','21:07:14','189.187.206.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (959,'20170201','23:07:48','187.190.4.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (960,'20170201','23:16:12','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (961,'20170201','23:53:11','187.188.8.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (962,'20170202','01:17:27','82.131.83.172');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (963,'20170202','01:48:52','187.254.158.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (964,'20170202','05:18:47','187.224.41.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (965,'20170202','07:20:46','187.199.7.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (966,'20170202','08:04:43','132.248.102.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (967,'20170202','08:15:14','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (968,'20170202','08:35:19','189.203.150.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (969,'20170202','09:02:01','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (970,'20170202','09:34:36','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (971,'20170202','09:37:18','72.195.137.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (972,'20170202','09:43:00','201.161.2.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (973,'20170202','09:45:37','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (974,'20170202','09:51:03','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (975,'20170202','10:09:26','132.248.242.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (976,'20170202','10:11:53','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (977,'20170202','10:16:31','132.248.9.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (978,'20170202','10:17:53','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (979,'20170202','10:20:19','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (980,'20170202','10:21:14','194.95.188.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (981,'20170202','10:34:38','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (982,'20170202','10:34:47','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (983,'20170202','10:37:52','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (984,'20170202','10:40:43','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (985,'20170202','10:41:46','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (986,'20170202','11:05:22','187.190.22.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (987,'20170202','11:10:12','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (988,'20170202','11:20:58','132.248.242.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (989,'20170202','11:21:41','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (990,'20170202','11:33:44','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (991,'20170202','11:39:14','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (992,'20170202','11:40:14','187.190.4.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (993,'20170202','11:59:40','132.247.63.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (994,'20170202','12:08:16','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (995,'20170202','12:08:44','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (996,'20170202','12:29:52','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (997,'20170202','12:45:52','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (998,'20170202','13:11:03','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (999,'20170202','13:30:58','187.162.1.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1000,'20170202','13:31:41','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1001,'20170202','14:44:00','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1002,'20170202','14:48:51','132.248.67.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1003,'20170202','16:01:51','132.248.55.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1004,'20170202','16:06:09','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1005,'20170202','16:23:51','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1006,'20170202','16:43:13','189.212.166.237');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1007,'20170202','16:43:40','189.216.182.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1008,'20170202','16:46:55','187.217.195.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1009,'20170202','17:18:58','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1010,'20170202','17:19:35','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1011,'20170202','17:37:55','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1012,'20170202','18:13:34','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1013,'20170202','18:16:38','187.214.196.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1014,'20170202','18:35:43','132.248.86.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1015,'20170202','18:38:29','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1016,'20170202','18:39:39','132.248.181.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1017,'20170202','18:45:55','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1018,'20170202','19:07:29','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1019,'20170202','19:32:33','132.248.141.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1020,'20170202','19:34:04','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1021,'20170202','19:34:30','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1022,'20170202','20:33:06','132.248.67.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1023,'20170202','22:29:19','66.249.69.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1024,'20170202','23:03:29','180.76.15.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1025,'20170202','23:13:19','187.200.48.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1026,'20170203','00:26:21','180.76.15.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1027,'20170203','01:36:11','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1028,'20170203','08:53:49','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1029,'20170203','08:59:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1030,'20170203','09:03:45','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1031,'20170203','09:21:05','189.202.227.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1032,'20170203','09:32:42','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1033,'20170203','09:58:25','148.206.53.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1034,'20170203','09:58:32','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1035,'20170203','10:01:53','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1036,'20170203','10:38:01','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1037,'20170203','10:51:53','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1038,'20170203','10:52:01','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1039,'20170203','11:08:17','132.247.204.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1040,'20170203','11:32:19','132.248.216.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1041,'20170203','11:46:23','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1042,'20170203','11:59:42','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1043,'20170203','12:00:07','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1044,'20170203','12:02:32','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1045,'20170203','12:12:40','132.248.67.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1046,'20170203','12:16:39','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1047,'20170203','12:33:12','132.248.90.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1048,'20170203','13:01:49','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1049,'20170203','13:03:56','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1050,'20170203','13:26:24','132.248.9.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1051,'20170203','13:29:15','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1052,'20170203','13:29:24','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1053,'20170203','13:33:13','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1054,'20170203','13:36:24','189.216.180.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1055,'20170203','13:44:50','141.161.13.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1056,'20170203','13:45:28','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1057,'20170203','13:48:49','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1058,'20170203','13:50:08','201.141.30.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1059,'20170203','14:15:16','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1060,'20170203','14:27:25','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1061,'20170203','15:03:34','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1062,'20170203','15:21:27','200.3.152.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1063,'20170203','15:41:39','187.214.196.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1064,'20170203','15:53:41','200.52.255.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1065,'20170203','16:30:09','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1066,'20170203','16:42:08','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1067,'20170203','18:28:00','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1068,'20170203','18:29:54','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1069,'20170203','19:34:47','192.0.116.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1070,'20170204','02:20:33','180.76.15.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1071,'20170204','07:26:13','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1072,'20170204','08:12:20','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1073,'20170204','09:12:52','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1074,'20170204','10:04:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1075,'20170204','10:26:18','180.76.15.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1076,'20170204','11:58:46','189.230.81.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1077,'20170204','12:28:51','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1078,'20170204','13:12:52','187.230.32.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1079,'20170204','14:56:09','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1080,'20170204','18:35:38','189.249.50.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1081,'20170205','03:57:49','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1082,'20170205','04:12:52','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1083,'20170205','04:54:43','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1084,'20170205','06:40:50','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1085,'20170205','10:55:29','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1086,'20170205','18:03:16','189.216.207.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1087,'20170205','21:04:01','189.216.205.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1088,'20170205','23:15:13','189.242.154.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1089,'20170206','00:20:09','189.143.64.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1090,'20170206','03:39:47','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1091,'20170206','05:56:52','188.87.238.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1092,'20170206','08:17:34','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1093,'20170206','10:44:32','189.225.186.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1094,'20170206','12:08:10','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1095,'20170206','14:54:01','189.207.168.231');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1096,'20170206','14:59:42','180.76.15.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1097,'20170206','19:10:26','189.129.118.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1098,'20170206','19:33:22','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1099,'20170206','19:51:25','189.216.180.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1100,'20170206','20:07:37','179.7.163.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1101,'20170206','21:05:34','201.156.10.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1102,'20170206','23:20:26','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1103,'20170206','23:26:54','187.170.26.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1104,'20170206','23:38:09','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1105,'20170207','03:08:56','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1106,'20170207','03:54:57','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1107,'20170207','09:09:04','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1108,'20170207','09:18:12','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1109,'20170207','09:41:33','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1110,'20170207','09:45:42','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1111,'20170207','10:01:16','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1112,'20170207','10:09:07','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1113,'20170207','10:14:05','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1114,'20170207','10:14:20','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1115,'20170207','10:21:53','187.190.21.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1116,'20170207','10:34:26','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1117,'20170207','10:38:54','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1118,'20170207','10:48:32','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1119,'20170207','10:54:30','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1120,'20170207','11:07:35','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1121,'20170207','11:12:56','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1122,'20170207','11:13:15','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1123,'20170207','11:13:33','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1124,'20170207','11:16:23','132.247.74.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1125,'20170207','11:19:17','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1126,'20170207','11:26:19','148.243.130.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1127,'20170207','11:34:46','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1128,'20170207','11:35:58','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1129,'20170207','11:51:45','101.108.71.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1130,'20170207','11:56:21','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1131,'20170207','12:11:20','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1132,'20170207','12:15:09','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1133,'20170207','12:20:47','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1134,'20170207','12:26:58','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1135,'20170207','12:36:33','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1136,'20170207','12:36:52','201.99.139.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1137,'20170207','12:40:57','180.76.15.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1138,'20170207','12:42:16','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1139,'20170207','12:47:17','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1140,'20170207','12:47:44','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1141,'20170207','12:47:50','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1142,'20170207','13:27:42','187.233.96.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1143,'20170207','13:36:14','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1144,'20170207','13:40:55','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1145,'20170207','13:42:56','132.248.43.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1146,'20170207','13:58:36','189.247.20.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1147,'20170207','14:01:36','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1148,'20170207','14:09:16','132.248.16.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1149,'20170207','14:12:51','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1150,'20170207','14:50:06','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1151,'20170207','15:01:05','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1152,'20170207','15:03:36','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1153,'20170207','15:08:43','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1154,'20170207','15:35:26','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1155,'20170207','15:53:09','187.227.77.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1156,'20170207','16:14:54','190.120.6.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1157,'20170207','16:40:29','132.248.67.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1158,'20170207','16:46:17','132.248.101.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1159,'20170207','17:25:07','201.156.10.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1160,'20170207','17:27:32','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1161,'20170207','17:55:21','187.190.156.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1162,'20170207','18:01:44','40.77.167.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1163,'20170207','18:07:04','187.130.162.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1164,'20170207','18:54:39','132.247.198.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1165,'20170207','19:11:26','148.206.99.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1166,'20170207','19:45:58','187.223.32.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1167,'20170207','20:46:57','201.110.217.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1168,'20170207','20:49:58','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1169,'20170207','21:47:15','187.237.226.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1170,'20170207','22:59:48','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1171,'20170207','23:15:34','187.144.112.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1172,'20170207','23:28:53','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1173,'20170208','00:30:15','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1174,'20170208','00:40:34','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1175,'20170208','05:02:05','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1176,'20170208','08:53:41','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1177,'20170208','08:55:36','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1178,'20170208','09:06:37','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1179,'20170208','09:08:40','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1180,'20170208','09:46:45','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1181,'20170208','09:49:05','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1182,'20170208','09:50:28','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1183,'20170208','09:58:25','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1184,'20170208','10:01:06','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1185,'20170208','10:09:17','189.211.85.237');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1186,'20170208','10:10:56','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1187,'20170208','10:15:07','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1188,'20170208','10:23:14','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1189,'20170208','10:35:29','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1190,'20170208','10:43:17','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1191,'20170208','10:46:43','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1192,'20170208','10:51:52','132.248.67.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1193,'20170208','10:59:29','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1194,'20170208','11:03:13','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1195,'20170208','11:14:39','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1196,'20170208','11:17:54','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1197,'20170208','11:32:34','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1198,'20170208','11:38:37','200.79.20.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1199,'20170208','11:43:52','189.216.114.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1200,'20170208','12:02:42','132.248.67.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1201,'20170208','12:27:52','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1202,'20170208','12:31:38','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1203,'20170208','12:55:10','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1204,'20170208','12:58:53','201.137.174.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1205,'20170208','12:59:07','201.137.170.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1206,'20170208','13:13:27','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1207,'20170208','13:15:45','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1208,'20170208','13:22:03','189.240.194.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1209,'20170208','13:38:45','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1210,'20170208','13:48:57','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1211,'20170208','13:51:17','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1212,'20170208','14:00:39','189.216.181.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1213,'20170208','14:09:35','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1214,'20170208','14:25:39','189.147.114.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1215,'20170208','14:26:26','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1216,'20170208','14:30:33','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1217,'20170208','14:49:20','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1218,'20170208','14:58:14','132.248.67.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1219,'20170208','15:15:18','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1220,'20170208','15:38:44','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1221,'20170208','15:55:25','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1222,'20170208','16:24:48','200.23.51.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1223,'20170208','16:37:48','132.248.123.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1224,'20170208','16:59:20','187.220.85.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1225,'20170208','17:07:34','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1226,'20170208','17:12:26','132.248.99.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1227,'20170208','17:43:04','201.156.10.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1228,'20170208','18:15:13','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1229,'20170208','18:29:07','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1230,'20170208','18:31:36','201.137.126.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1231,'20170208','18:41:08','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1232,'20170208','18:45:03','187.214.178.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1233,'20170208','19:12:04','201.153.57.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1234,'20170208','19:34:59','187.220.61.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1235,'20170208','19:56:41','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1236,'20170208','20:58:01','187.228.123.245');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1237,'20170208','21:05:40','189.143.204.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1238,'20170208','21:18:09','189.216.105.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1239,'20170208','22:37:08','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1240,'20170208','22:38:07','201.164.162.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1241,'20170208','23:12:45','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1242,'20170208','23:13:23','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1243,'20170209','00:11:17','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1244,'20170209','06:58:35','62.254.247.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1245,'20170209','08:50:34','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1246,'20170209','09:00:49','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1247,'20170209','09:17:25','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1248,'20170209','09:17:27','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1248,'20170209','09:17:27','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1250,'20170209','09:17:29','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1250,'20170209','09:17:29','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1252,'20170209','09:17:48','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1253,'20170209','09:17:51','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1253,'20170209','09:17:50','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1255,'20170209','09:18:35','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1256,'20170209','09:26:45','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1257,'20170209','09:31:08','201.156.10.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1258,'20170209','09:46:52','201.137.31.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1259,'20170209','09:56:37','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1260,'20170209','10:09:12','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1261,'20170209','11:06:19','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1262,'20170209','11:10:15','132.248.116.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1263,'20170209','11:14:38','132.248.92.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1264,'20170209','11:31:54','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1265,'20170209','11:45:58','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1266,'20170209','11:48:01','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1267,'20170209','11:48:42','132.247.74.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1268,'20170209','12:16:16','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1269,'20170209','12:16:19','132.248.132.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1270,'20170209','12:25:40','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1271,'20170209','12:49:04','189.179.157.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1272,'20170209','12:49:44','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1273,'20170209','12:58:56','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1274,'20170209','13:10:24','144.36.31.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1275,'20170209','13:15:50','189.140.4.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1276,'20170209','13:16:32','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1277,'20170209','13:18:26','189.208.21.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1278,'20170209','13:25:38','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1279,'20170209','13:26:05','132.248.182.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1280,'20170209','13:29:14','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1281,'20170209','13:32:47','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1282,'20170209','13:32:47','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1283,'20170209','13:41:31','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1284,'20170209','13:49:30','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1285,'20170209','13:59:10','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1286,'20170209','14:01:46','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1287,'20170209','14:16:44','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1288,'20170209','14:18:36','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1289,'20170209','14:21:55','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1290,'20170209','14:25:53','132.247.184.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1291,'20170209','14:26:16','132.248.55.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1292,'20170209','14:32:08','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1293,'20170209','14:33:54','189.216.250.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1294,'20170209','14:36:29','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1295,'20170209','14:42:31','148.206.53.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1296,'20170209','14:46:53','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1297,'20170209','14:56:58','148.218.95.35');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1298,'20170209','15:04:32','189.216.180.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1299,'20170209','15:12:49','132.248.67.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1300,'20170209','15:23:59','200.23.51.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1301,'20170209','15:26:22','132.248.67.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1302,'20170209','15:36:29','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1303,'20170209','15:58:54','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1304,'20170209','15:59:05','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1305,'20170209','16:00:00','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1306,'20170209','16:02:14','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1307,'20170209','17:28:48','132.248.32.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1308,'20170209','18:21:24','132.248.180.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1309,'20170209','18:32:02','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1310,'20170209','19:39:19','148.206.53.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1311,'20170209','20:09:46','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1312,'20170209','20:41:49','189.134.39.117');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1313,'20170209','21:23:12','189.253.5.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1314,'20170209','22:24:17','189.217.137.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1315,'20170210','00:20:55','177.226.251.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1316,'20170210','03:33:55','193.145.230.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1317,'20170210','08:35:57','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1318,'20170210','08:46:36','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1319,'20170210','09:09:17','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1320,'20170210','09:19:03','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1321,'20170210','09:41:27','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1322,'20170210','09:43:03','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1323,'20170210','09:46:50','180.76.15.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1324,'20170210','09:47:41','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1325,'20170210','09:53:25','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1326,'20170210','09:56:57','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1327,'20170210','09:58:10','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1328,'20170210','10:05:41','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1329,'20170210','10:25:20','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1330,'20170210','10:32:12','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1331,'20170210','10:41:04','148.206.160.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1332,'20170210','10:42:11','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1333,'20170210','10:45:39','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1334,'20170210','10:46:30','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1335,'20170210','10:58:10','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1336,'20170210','10:58:33','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1337,'20170210','11:07:11','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1338,'20170210','11:07:52','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1339,'20170210','11:07:53','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1340,'20170210','11:15:07','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1341,'20170210','11:33:31','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1342,'20170210','11:34:39','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1343,'20170210','11:40:35','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1344,'20170210','12:34:25','187.221.223.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1345,'20170210','12:55:26','187.225.39.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1346,'20170210','13:08:25','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1347,'20170210','13:09:14','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1348,'20170210','13:12:01','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1349,'20170210','13:13:42','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1350,'20170210','13:25:12','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1351,'20170210','13:35:12','128.84.116.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1352,'20170210','13:41:30','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1353,'20170210','13:41:36','200.68.128.78');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1354,'20170210','13:41:58','187.237.231.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1355,'20170210','13:57:28','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1356,'20170210','13:59:04','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1357,'20170210','14:04:44','189.216.183.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1358,'20170210','14:43:38','148.247.69.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1359,'20170210','15:04:20','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1360,'20170210','15:11:42','200.33.232.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1361,'20170210','15:19:51','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1362,'20170210','15:46:27','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1363,'20170210','17:19:47','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1364,'20170210','17:56:10','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1365,'20170210','17:57:20','187.194.68.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1366,'20170210','18:04:03','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1367,'20170210','18:09:21','187.214.196.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1368,'20170210','18:15:27','140.234.255.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1369,'20170210','18:26:00','200.128.68.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1370,'20170210','18:27:43','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1371,'20170210','18:35:16','187.248.20.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1372,'20170210','18:52:13','132.248.67.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1373,'20170210','19:10:00','132.248.44.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1374,'20170210','20:18:02','189.216.180.71');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1375,'20170210','20:18:11','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1376,'20170210','20:30:59','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1377,'20170210','20:54:20','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1378,'20170211','08:11:51','66.249.84.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1379,'20170211','10:38:00','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1380,'20170211','13:34:57','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1381,'20170211','14:05:22','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1382,'20170211','16:24:41','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1383,'20170211','17:53:08','201.114.202.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1384,'20170211','20:46:41','189.134.154.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1385,'20170211','22:18:21','189.216.50.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1386,'20170212','00:34:41','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1387,'20170212','01:25:58','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1388,'20170212','01:55:36','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1389,'20170212','02:10:56','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1390,'20170212','04:15:21','5.164.109.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1391,'20170212','07:02:37','95.28.180.255');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1392,'20170212','09:58:36','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1393,'20170212','10:04:34','189.216.59.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1394,'20170212','10:39:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1395,'20170212','12:08:26','197.237.215.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1396,'20170212','14:20:30','189.216.142.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1397,'20170212','14:33:35','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1398,'20170212','14:37:15','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1399,'20170212','16:17:05','187.207.40.53');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1400,'20170212','17:49:14','187.213.196.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1401,'20170212','18:04:41','189.140.123.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1402,'20170212','18:36:51','189.137.13.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1403,'20170212','20:01:45','189.193.213.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1404,'20170212','21:58:17','177.243.36.127');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1405,'20170212','23:51:23','46.188.81.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1406,'20170213','03:38:14','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1407,'20170213','03:43:14','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1408,'20170213','04:29:55','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1409,'20170213','08:39:51','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1410,'20170213','08:51:56','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1411,'20170213','08:52:53','189.242.31.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1412,'20170213','08:56:44','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1413,'20170213','08:57:57','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1414,'20170213','09:20:38','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1415,'20170213','09:33:44','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1416,'20170213','09:42:52','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1417,'20170213','09:59:03','132.248.9.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1418,'20170213','09:59:42','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1419,'20170213','10:10:52','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1420,'20170213','10:18:35','132.248.9.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1421,'20170213','10:21:46','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1422,'20170213','10:26:04','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1423,'20170213','10:39:11','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1424,'20170213','10:41:30','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1425,'20170213','10:42:20','132.248.16.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1426,'20170213','11:01:47','132.248.9.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1427,'20170213','11:02:05','187.214.140.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1428,'20170213','11:04:50','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1429,'20170213','11:09:21','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1430,'20170213','11:16:36','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1431,'20170213','11:19:00','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1432,'20170213','11:26:52','132.248.242.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1433,'20170213','11:39:47','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1434,'20170213','11:47:46','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1435,'20170213','12:13:05','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1436,'20170213','12:28:22','189.135.47.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1437,'20170213','12:28:25','132.248.242.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1438,'20170213','12:36:46','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1439,'20170213','12:44:10','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1440,'20170213','12:57:19','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1441,'20170213','13:02:38','132.248.9.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1442,'20170213','13:05:53','132.248.16.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1443,'20170213','13:23:22','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1444,'20170213','13:24:30','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1445,'20170213','13:28:32','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1446,'20170213','13:31:34','132.248.139.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1447,'20170213','13:41:14','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1448,'20170213','13:42:01','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1449,'20170213','13:50:19','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1450,'20170213','13:51:48','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1451,'20170213','13:52:12','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1452,'20170213','14:00:55','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1453,'20170213','14:14:47','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1454,'20170213','14:20:25','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1455,'20170213','14:43:05','189.202.204.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1456,'20170213','14:44:00','157.55.39.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1457,'20170213','15:14:50','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1458,'20170213','15:16:38','187.189.180.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1459,'20170213','15:50:40','187.159.105.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1460,'20170213','15:54:27','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1461,'20170213','15:56:43','132.248.242.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1462,'20170213','16:12:30','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1463,'20170213','16:25:43','192.100.180.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1464,'20170213','16:47:30','168.234.75.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1465,'20170213','17:00:04','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1466,'20170213','17:01:13','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1467,'20170213','17:04:00','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1468,'20170213','17:35:46','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1469,'20170213','17:49:26','132.248.242.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1470,'20170213','18:38:02','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1471,'20170213','19:28:19','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1472,'20170214','00:43:00','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1473,'20170214','01:39:15','187.168.24.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1474,'20170214','06:29:59','189.144.232.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1475,'20170214','07:25:36','66.249.69.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1476,'20170214','08:41:48','189.213.56.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1477,'20170214','08:58:10','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1478,'20170214','09:01:50','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1479,'20170214','09:25:39','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1480,'20170214','09:31:21','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1481,'20170214','09:38:26','132.247.246.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1482,'20170214','09:40:04','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1483,'20170214','09:40:28','200.94.19.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1484,'20170214','09:46:49','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1485,'20170214','10:02:56','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1486,'20170214','10:19:53','132.248.16.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1487,'20170214','10:42:17','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1488,'20170214','10:53:56','148.206.160.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1489,'20170214','10:54:54','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1490,'20170214','10:59:24','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1491,'20170214','11:05:53','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1492,'20170214','11:16:51','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1493,'20170214','11:25:55','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1494,'20170214','11:40:29','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1495,'20170214','11:49:18','189.216.181.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1496,'20170214','11:54:29','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1497,'20170214','12:02:32','132.248.141.53');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1498,'20170214','12:20:21','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1499,'20170214','12:32:42','148.247.69.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1500,'20170214','12:43:41','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1501,'20170214','12:45:32','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1502,'20170214','12:45:54','207.46.13.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1503,'20170214','12:45:56','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1504,'20170214','12:56:50','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1505,'20170214','12:57:22','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1506,'20170214','13:04:42','189.225.235.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1507,'20170214','13:05:10','132.248.89.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1508,'20170214','13:18:22','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1509,'20170214','13:27:41','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1510,'20170214','13:40:01','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1511,'20170214','13:44:30','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1512,'20170214','13:46:41','187.190.4.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1513,'20170214','13:48:49','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1514,'20170214','13:50:34','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1515,'20170214','13:54:13','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1516,'20170214','14:34:42','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1517,'20170214','14:57:39','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1518,'20170214','15:09:24','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1519,'20170214','15:09:25','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1520,'20170214','15:09:26','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1521,'20170214','15:09:27','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1521,'20170214','15:09:27','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1523,'20170214','15:09:28','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1523,'20170214','15:09:28','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1525,'20170214','15:09:32','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1526,'20170214','15:09:42','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1527,'20170214','15:21:10','132.248.64.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1528,'20170214','17:20:16','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1529,'20170214','17:53:50','187.214.196.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1530,'20170214','18:10:07','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1531,'20170214','19:17:55','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1532,'20170214','19:57:20','189.134.160.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1533,'20170214','21:19:28','201.137.185.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1534,'20170214','21:26:34','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1535,'20170214','21:35:12','189.217.210.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1536,'20170214','22:08:31','189.217.206.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1537,'20170215','01:11:33','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1538,'20170215','01:36:16','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1539,'20170215','05:22:43','207.46.13.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1540,'20170215','08:21:52','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1541,'20170215','08:53:31','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1542,'20170215','08:59:39','148.206.53.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1543,'20170215','09:04:36','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1544,'20170215','09:06:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1545,'20170215','09:06:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1546,'20170215','09:19:14','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1547,'20170215','09:31:04','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1548,'20170215','09:56:21','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1549,'20170215','10:04:08','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1550,'20170215','10:04:26','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1551,'20170215','10:10:35','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1552,'20170215','10:13:38','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1553,'20170215','10:16:00','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1554,'20170215','10:30:53','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1555,'20170215','10:40:46','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1556,'20170215','10:40:54','148.202.183.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1557,'20170215','10:44:12','68.180.230.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1558,'20170215','10:45:20','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1559,'20170215','10:52:11','201.99.139.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1560,'20170215','10:54:47','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1561,'20170215','10:55:24','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1562,'20170215','11:02:13','189.248.205.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1563,'20170215','11:03:44','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1564,'20170215','11:09:03','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1565,'20170215','11:26:17','148.247.69.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1566,'20170215','11:54:11','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1567,'20170215','11:57:08','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1568,'20170215','12:08:41','187.159.243.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1569,'20170215','12:10:35','177.234.3.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1570,'20170215','12:13:14','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1571,'20170215','12:13:57','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1572,'20170215','12:14:20','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1573,'20170215','13:02:56','200.23.10.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1574,'20170215','13:07:05','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1575,'20170215','13:07:58','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1576,'20170215','13:20:04','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1577,'20170215','13:22:29','200.34.165.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1578,'20170215','13:31:02','187.170.12.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1579,'20170215','13:34:42','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1580,'20170215','13:35:53','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1581,'20170215','13:36:54','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1582,'20170215','13:43:12','189.137.143.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1583,'20170215','13:55:11','189.129.161.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1584,'20170215','14:07:06','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1585,'20170215','14:43:16','187.168.6.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1586,'20170215','14:52:11','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1587,'20170215','15:00:54','148.206.99.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1588,'20170215','15:11:35','148.226.112.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1589,'20170215','15:23:34','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1590,'20170215','16:29:49','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1591,'20170215','16:53:33','132.248.103.245');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1592,'20170215','16:58:56','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1593,'20170215','17:18:06','148.206.39.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1594,'20170215','17:51:03','189.179.119.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1595,'20170215','18:05:37','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1596,'20170215','18:05:38','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1596,'20170215','18:05:38','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1596,'20170215','18:05:38','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1598,'20170215','18:05:38','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1600,'20170215','18:05:40','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1601,'20170215','18:05:40','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1602,'20170215','18:05:42','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1603,'20170215','18:05:46','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1604,'20170215','18:13:18','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1605,'20170215','18:16:22','189.135.47.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1606,'20170215','18:53:33','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1607,'20170215','19:00:08','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1608,'20170215','19:26:04','187.177.126.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1609,'20170215','19:36:12','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1610,'20170215','19:37:01','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1611,'20170215','19:52:00','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1612,'20170215','21:33:16','189.245.159.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1613,'20170216','00:28:03','189.137.200.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1614,'20170216','03:09:11','187.224.124.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1615,'20170216','08:36:23','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1616,'20170216','08:54:53','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1617,'20170216','08:58:20','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1618,'20170216','09:07:10','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1619,'20170216','09:13:16','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1620,'20170216','09:29:24','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1621,'20170216','09:31:54','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1622,'20170216','09:58:52','201.124.60.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1623,'20170216','10:05:13','132.248.95.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1624,'20170216','10:05:48','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1625,'20170216','10:24:12','187.151.44.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1626,'20170216','10:30:41','189.189.220.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1627,'20170216','10:31:56','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1628,'20170216','10:32:19','187.217.92.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1629,'20170216','10:33:13','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1630,'20170216','10:33:26','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1631,'20170216','10:46:03','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1632,'20170216','10:46:45','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1633,'20170216','11:10:21','189.205.178.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1634,'20170216','11:13:18','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1635,'20170216','11:13:40','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1636,'20170216','11:14:16','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1637,'20170216','11:16:14','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1638,'20170216','11:18:12','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1639,'20170216','11:25:31','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1640,'20170216','11:50:08','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1641,'20170216','11:55:25','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1642,'20170216','12:07:51','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1643,'20170216','12:15:57','189.146.74.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1644,'20170216','12:20:47','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1645,'20170216','12:23:18','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1646,'20170216','12:23:24','132.248.132.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1647,'20170216','12:27:31','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1648,'20170216','12:37:07','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1649,'20170216','12:57:31','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1650,'20170216','13:13:08','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1651,'20170216','13:27:47','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1652,'20170216','13:50:18','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1653,'20170216','14:04:20','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1654,'20170216','14:18:27','189.137.143.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1655,'20170216','14:23:26','187.217.163.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1656,'20170216','14:33:52','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1657,'20170216','14:37:52','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1658,'20170216','15:14:37','190.104.115.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1659,'20170216','15:29:20','187.237.231.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1660,'20170216','15:48:26','132.248.199.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1661,'20170216','16:07:16','189.165.153.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1662,'20170216','16:07:49','148.247.69.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1663,'20170216','16:09:31','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1664,'20170216','16:22:26','187.207.129.236');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1665,'20170216','16:32:56','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1666,'20170216','16:39:39','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1667,'20170216','17:11:12','148.234.86.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1668,'20170216','17:15:42','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1669,'20170216','17:19:56','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1670,'20170216','17:34:20','132.248.157.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1671,'20170216','17:37:11','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1672,'20170216','17:39:18','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1673,'20170216','18:16:03','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1674,'20170216','18:24:37','132.248.67.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1675,'20170216','18:24:40','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1676,'20170216','18:36:26','132.248.44.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1677,'20170216','18:46:54','187.162.107.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1678,'20170216','19:31:55','187.207.124.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1679,'20170216','19:51:16','189.245.127.50');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1680,'20170216','20:20:55','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1680,'20170216','20:20:55','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1682,'20170216','20:20:55','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1683,'20170216','20:20:56','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1684,'20170216','20:20:56','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1684,'20170216','20:20:56','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1686,'20170216','20:20:56','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1687,'20170216','20:20:58','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1688,'20170216','20:20:58','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1689,'20170216','20:41:28','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1690,'20170216','21:00:44','180.76.15.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1691,'20170216','21:54:05','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1692,'20170216','22:34:48','200.68.132.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1693,'20170216','23:02:28','187.169.107.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1694,'20170217','00:11:01','108.61.60.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1695,'20170217','00:23:51','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1696,'20170217','05:10:55','187.187.29.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1697,'20170217','05:35:59','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1698,'20170217','07:42:11','148.209.181.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1699,'20170217','08:27:28','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1700,'20170217','09:03:05','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1701,'20170217','09:10:07','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1702,'20170217','09:32:32','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1703,'20170217','09:33:55','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1704,'20170217','09:38:22','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1705,'20170217','09:41:25','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1706,'20170217','09:51:09','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1707,'20170217','10:04:43','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1708,'20170217','10:12:54','132.248.103.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1709,'20170217','10:20:45','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1710,'20170217','10:23:53','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1711,'20170217','10:38:01','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1712,'20170217','10:43:40','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1713,'20170217','10:46:20','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1714,'20170217','10:46:37','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1715,'20170217','10:52:39','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1716,'20170217','10:54:11','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1717,'20170217','10:55:04','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1718,'20170217','10:56:27','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1719,'20170217','11:01:37','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1720,'20170217','11:01:48','132.248.51.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1721,'20170217','11:16:10','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1722,'20170217','11:22:04','132.248.150.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1723,'20170217','11:24:28','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1724,'20170217','11:45:07','187.170.223.117');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1725,'20170217','11:46:12','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1726,'20170217','11:49:00','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1727,'20170217','12:10:45','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1728,'20170217','12:16:33','132.248.110.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1729,'20170217','12:24:48','132.248.9.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1730,'20170217','12:32:19','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1731,'20170217','12:32:32','189.216.180.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1732,'20170217','12:43:42','187.214.196.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1733,'20170217','12:58:46','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1734,'20170217','13:07:02','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1735,'20170217','13:28:11','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1736,'20170217','13:33:07','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1736,'20170217','13:33:07','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1738,'20170217','13:45:07','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1739,'20170217','13:48:31','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1740,'20170217','13:54:00','132.248.63.192');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1741,'20170217','14:07:45','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1742,'20170217','14:35:51','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1743,'20170217','14:36:14','187.237.248.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1744,'20170217','14:41:02','187.230.109.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1745,'20170217','14:51:11','187.230.73.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1746,'20170217','15:14:28','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1747,'20170217','15:56:03','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1748,'20170217','16:30:19','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1749,'20170217','16:54:36','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1750,'20170217','17:17:45','189.137.143.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1751,'20170217','18:00:37','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1752,'20170217','18:20:31','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1753,'20170217','18:26:37','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1754,'20170217','18:28:39','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1755,'20170217','18:30:32','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1756,'20170217','18:39:55','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1757,'20170217','18:41:31','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1758,'20170217','19:02:49','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1759,'20170217','19:22:21','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1760,'20170217','21:52:34','187.168.250.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1761,'20170217','23:39:52','201.141.155.195');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1762,'20170218','00:04:34','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1763,'20170218','00:45:41','189.180.236.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1764,'20170218','03:24:05','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1765,'20170218','05:20:56','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1766,'20170218','09:30:39','189.230.6.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1767,'20170218','09:39:05','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1768,'20170218','10:16:15','187.254.157.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1769,'20170218','12:41:01','189.136.73.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1770,'20170218','13:03:49','187.191.7.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1771,'20170218','13:50:25','201.114.178.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1772,'20170218','14:18:45','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1773,'20170218','14:18:55','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1774,'20170218','14:28:52','189.216.57.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1775,'20170218','15:20:59','187.228.60.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1776,'20170218','16:19:50','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1777,'20170218','19:05:33','189.162.166.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1778,'20170218','22:23:48','189.245.43.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1779,'20170219','01:18:00','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1780,'20170219','02:04:54','187.226.106.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1781,'20170219','05:51:03','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1782,'20170219','09:59:46','200.56.149.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1783,'20170219','10:05:43','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1784,'20170219','11:26:20','189.216.182.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1785,'20170219','12:38:17','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1786,'20170219','13:22:31','189.204.159.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1787,'20170219','15:10:21','52.86.176.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1788,'20170219','17:33:09','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1789,'20170219','19:51:33','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1790,'20170219','21:40:50','201.103.35.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1791,'20170219','22:13:19','189.216.206.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1792,'20170219','22:28:31','187.199.81.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1793,'20170220','00:52:08','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1794,'20170220','01:32:49','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1795,'20170220','03:26:33','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1796,'20170220','04:00:49','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1797,'20170220','08:30:12','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1798,'20170220','08:31:49','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1799,'20170220','08:32:14','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1800,'20170220','08:45:25','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1801,'20170220','08:53:59','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1802,'20170220','08:59:34','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1803,'20170220','09:28:21','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1804,'20170220','09:49:16','189.207.68.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1805,'20170220','09:55:01','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1806,'20170220','10:12:52','189.216.181.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1807,'20170220','10:15:45','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1808,'20170220','10:17:35','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1809,'20170220','10:22:31','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1810,'20170220','10:23:56','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1811,'20170220','10:24:43','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1812,'20170220','10:38:07','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1813,'20170220','10:42:29','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1814,'20170220','10:53:54','189.191.74.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1815,'20170220','10:57:58','189.208.59.71');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1816,'20170220','10:58:18','148.206.190.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1817,'20170220','11:04:25','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1818,'20170220','11:10:26','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1819,'20170220','11:11:51','132.248.159.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1820,'20170220','11:15:54','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1821,'20170220','11:20:32','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1822,'20170220','11:23:37','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1823,'20170220','11:30:23','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1824,'20170220','11:30:25','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1825,'20170220','11:30:25','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1826,'20170220','11:30:27','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1827,'20170220','11:30:27','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1827,'20170220','11:30:27','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1829,'20170220','11:30:27','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1830,'20170220','11:30:37','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1831,'20170220','11:31:26','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1832,'20170220','11:33:49','189.216.57.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1833,'20170220','11:44:51','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1834,'20170220','11:47:34','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1835,'20170220','11:52:16','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1836,'20170220','11:52:36','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1837,'20170220','12:04:18','189.216.181.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1838,'20170220','12:05:17','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1839,'20170220','12:08:41','187.214.196.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1840,'20170220','12:08:50','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1841,'20170220','12:19:15','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1842,'20170220','12:40:34','132.247.204.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1843,'20170220','12:41:57','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1843,'20170220','12:41:58','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1845,'20170220','12:43:22','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1846,'20170220','12:44:28','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1847,'20170220','12:51:39','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1848,'20170220','12:54:04','187.237.231.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1849,'20170220','12:54:20','187.237.231.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1850,'20170220','13:07:18','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1851,'20170220','13:12:03','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1852,'20170220','13:13:59','132.248.164.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1853,'20170220','13:18:36','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1854,'20170220','13:19:12','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1855,'20170220','13:26:39','132.248.50.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1856,'20170220','13:27:09','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1857,'20170220','13:34:01','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1858,'20170220','13:45:57','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1859,'20170220','14:50:48','132.248.90.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1860,'20170220','15:04:44','132.248.80.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1861,'20170220','15:41:41','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1862,'20170220','15:42:08','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1863,'20170220','16:01:17','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1864,'20170220','17:11:43','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1865,'20170220','17:42:11','187.237.14.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1866,'20170220','17:43:25','187.237.14.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1867,'20170220','17:47:56','201.111.28.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1868,'20170220','18:21:48','187.254.158.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1869,'20170220','18:24:01','200.68.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1870,'20170220','18:24:07','187.237.231.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1871,'20170220','18:26:06','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1872,'20170220','18:38:47','187.214.253.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1873,'20170220','18:43:05','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1874,'20170220','18:44:03','132.248.95.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1875,'20170220','18:52:05','132.247.113.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1876,'20170220','19:00:37','189.216.156.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1877,'20170220','19:00:52','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1878,'20170220','19:41:59','132.248.67.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1879,'20170220','20:09:51','187.214.178.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1880,'20170220','20:52:35','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1881,'20170220','22:31:05','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1882,'20170220','23:24:11','201.141.147.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1883,'20170221','00:18:06','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1884,'20170221','01:07:21','189.144.58.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1885,'20170221','06:18:38','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1886,'20170221','06:34:05','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1887,'20170221','07:41:28','201.124.128.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1888,'20170221','07:51:14','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1889,'20170221','08:54:02','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1890,'20170221','08:55:20','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1891,'20170221','09:02:04','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1892,'20170221','09:28:13','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1893,'20170221','09:28:21','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1894,'20170221','09:33:32','148.247.69.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1895,'20170221','09:37:27','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1896,'20170221','10:03:41','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1897,'20170221','10:04:25','132.248.192.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1898,'20170221','10:06:45','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1899,'20170221','10:16:42','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1900,'20170221','10:17:46','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1901,'20170221','10:21:38','148.228.148.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1902,'20170221','10:37:42','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1903,'20170221','10:48:43','132.248.9.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1904,'20170221','10:49:20','132.248.103.245');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1905,'20170221','10:51:40','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1906,'20170221','11:02:17','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1907,'20170221','11:11:48','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1908,'20170221','11:20:00','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1909,'20170221','11:28:46','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1910,'20170221','11:44:56','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1911,'20170221','11:47:15','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1912,'20170221','11:49:08','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1913,'20170221','12:02:34','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1914,'20170221','12:04:11','201.141.108.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1915,'20170221','12:21:08','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1916,'20170221','12:40:36','187.214.236.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1917,'20170221','12:52:51','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1918,'20170221','13:28:59','189.206.56.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1919,'20170221','13:29:29','177.234.0.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1920,'20170221','13:44:25','132.247.74.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1921,'20170221','13:50:19','132.248.9.53');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1922,'20170221','13:52:40','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1923,'20170221','14:00:46','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1924,'20170221','14:12:30','187.226.76.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1925,'20170221','14:18:27','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1926,'20170221','14:22:56','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1927,'20170221','14:25:33','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1928,'20170221','14:34:04','148.247.41.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1929,'20170221','14:36:12','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1930,'20170221','15:29:17','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1931,'20170221','15:43:59','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1932,'20170221','16:02:24','132.248.159.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1933,'20170221','16:04:13','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1934,'20170221','17:55:19','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1935,'20170221','17:55:42','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1936,'20170221','18:25:30','132.248.16.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1937,'20170221','18:39:05','201.137.31.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1938,'20170221','18:39:23','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1939,'20170221','19:00:34','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1940,'20170221','19:25:30','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1941,'20170221','19:36:39','187.228.106.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1942,'20170221','19:59:01','138.122.201.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1943,'20170221','20:30:51','179.176.186.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1944,'20170221','20:36:24','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1945,'20170221','20:40:07','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1946,'20170221','20:40:23','189.216.181.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1947,'20170221','21:47:15','104.198.210.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1948,'20170221','22:17:45','207.46.13.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1949,'20170221','22:46:56','189.216.122.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1950,'20170221','23:16:14','189.216.191.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1951,'20170222','00:36:16','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1952,'20170222','01:01:35','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1953,'20170222','01:54:17','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1954,'20170222','07:34:13','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1955,'20170222','07:42:46','201.175.133.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1956,'20170222','08:51:07','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1957,'20170222','08:56:10','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1958,'20170222','08:58:01','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1959,'20170222','09:01:33','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1960,'20170222','09:15:54','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1961,'20170222','09:33:24','201.137.31.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1962,'20170222','09:37:37','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1963,'20170222','09:42:07','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1964,'20170222','09:47:54','132.248.54.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1965,'20170222','10:05:18','187.170.246.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1966,'20170222','10:08:13','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1967,'20170222','10:11:26','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1968,'20170222','10:20:52','132.248.242.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1969,'20170222','10:26:11','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1970,'20170222','10:33:48','148.206.190.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1971,'20170222','10:46:59','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1972,'20170222','10:50:13','187.210.20.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1973,'20170222','10:58:36','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1974,'20170222','11:02:40','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1975,'20170222','11:06:30','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1976,'20170222','11:14:28','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1977,'20170222','11:22:06','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1978,'20170222','11:40:22','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1978,'20170222','11:40:22','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1978,'20170222','11:40:22','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1981,'20170222','12:01:51','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1982,'20170222','12:04:01','132.248.128.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1983,'20170222','12:20:00','148.247.69.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1984,'20170222','12:26:26','130.211.224.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1985,'20170222','12:33:30','148.202.195.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1986,'20170222','12:52:10','177.234.0.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1987,'20170222','12:58:12','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1988,'20170222','13:00:39','148.227.26.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1989,'20170222','13:01:37','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1990,'20170222','13:01:51','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1990,'20170222','13:01:51','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1992,'20170222','14:01:08','132.248.139.231');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1993,'20170222','14:14:27','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1994,'20170222','14:25:56','132.248.9.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1995,'20170222','14:35:55','187.159.168.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1996,'20170222','14:38:44','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1997,'20170222','14:43:32','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1998,'20170222','14:43:43','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (1999,'20170222','14:46:55','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2000,'20170222','15:13:15','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2001,'20170222','15:27:05','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2002,'20170222','15:32:52','132.248.110.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2003,'20170222','15:33:26','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2004,'20170222','15:45:03','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2005,'20170222','15:58:29','187.188.13.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2006,'20170222','16:04:19','132.248.9.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2007,'20170222','16:42:28','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2008,'20170222','17:00:10','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2009,'20170222','17:05:51','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2010,'20170222','17:22:17','123.126.113.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2011,'20170222','17:49:14','66.249.85.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2012,'20170222','17:49:30','66.249.85.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2013,'20170222','17:52:18','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2014,'20170222','19:20:05','132.248.32.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2015,'20170222','19:30:27','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2016,'20170222','19:54:22','189.216.199.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2017,'20170222','20:04:50','187.159.200.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2018,'20170222','23:42:01','187.214.156.78');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2019,'20170223','00:09:38','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2020,'20170223','00:45:19','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2021,'20170223','03:07:45','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2022,'20170223','07:09:25','187.254.158.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2023,'20170223','08:36:54','148.204.10.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2024,'20170223','08:55:33','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2025,'20170223','09:02:30','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2026,'20170223','09:15:56','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2027,'20170223','09:15:59','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2028,'20170223','09:32:20','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2029,'20170223','09:35:59','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2030,'20170223','10:04:50','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2031,'20170223','10:14:39','132.248.9.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2032,'20170223','10:27:07','187.207.54.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2033,'20170223','10:50:33','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2034,'20170223','10:51:10','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2035,'20170223','10:54:12','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2036,'20170223','11:09:41','148.247.69.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2037,'20170223','11:09:57','200.78.223.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2038,'20170223','11:14:12','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2039,'20170223','11:14:19','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2040,'20170223','11:28:00','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2041,'20170223','11:33:56','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2042,'20170223','11:38:22','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2043,'20170223','11:38:24','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2044,'20170223','12:09:34','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2045,'20170223','12:13:29','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2046,'20170223','12:16:27','132.248.92.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2047,'20170223','12:24:44','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2048,'20170223','12:37:04','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2049,'20170223','13:06:16','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2050,'20170223','13:17:00','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2051,'20170223','13:29:55','132.248.9.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2052,'20170223','13:50:15','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2053,'20170223','14:17:31','132.248.52.225');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2054,'20170223','14:24:55','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2055,'20170223','14:27:33','148.214.80.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2056,'20170223','14:43:59','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2057,'20170223','14:48:37','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2058,'20170223','14:58:42','72.195.137.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2059,'20170223','15:06:03','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2060,'20170223','15:06:39','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2061,'20170223','15:17:09','189.216.180.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2062,'20170223','15:59:19','69.122.10.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2063,'20170223','16:08:28','200.4.2.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2064,'20170223','16:15:18','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2065,'20170223','17:13:04','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2066,'20170223','17:17:50','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2067,'20170223','17:19:27','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2068,'20170223','17:35:47','148.234.86.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2069,'20170223','18:03:26','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2070,'20170223','18:38:55','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2071,'20170223','18:54:27','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2072,'20170223','19:04:09','132.248.76.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2073,'20170223','20:02:00','189.216.182.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2074,'20170223','21:54:18','201.141.25.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2075,'20170223','22:11:06','201.119.13.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2076,'20170223','23:34:21','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2077,'20170224','00:41:33','187.169.57.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2078,'20170224','01:56:53','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2079,'20170224','03:08:13','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2080,'20170224','06:03:41','185.8.241.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2081,'20170224','06:18:54','130.211.224.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2082,'20170224','07:37:36','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2083,'20170224','08:43:25','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2084,'20170224','08:49:56','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2085,'20170224','08:58:03','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2086,'20170224','09:10:46','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2087,'20170224','09:27:02','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2088,'20170224','09:35:40','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2089,'20170224','09:35:41','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2090,'20170224','09:49:08','187.145.189.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2091,'20170224','09:50:55','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2092,'20170224','09:52:26','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2093,'20170224','09:52:51','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2094,'20170224','10:05:33','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2095,'20170224','10:05:33','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2096,'20170224','10:08:01','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2097,'20170224','10:24:33','189.211.117.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2098,'20170224','10:27:32','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2099,'20170224','10:44:21','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2100,'20170224','11:39:05','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2101,'20170224','11:39:26','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2102,'20170224','11:40:39','132.248.54.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2103,'20170224','11:51:15','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2104,'20170224','11:52:48','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2105,'20170224','12:05:36','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2106,'20170224','12:30:06','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2107,'20170224','12:36:29','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2108,'20170224','12:36:55','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2109,'20170224','12:37:48','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2110,'20170224','12:45:01','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2111,'20170224','12:48:54','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2112,'20170224','13:01:52','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2113,'20170224','13:29:16','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2114,'20170224','13:36:51','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2115,'20170224','13:44:01','148.211.36.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2116,'20170224','13:47:30','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2116,'20170224','13:47:30','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2117,'20170224','13:47:30','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2118,'20170224','13:47:30','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2119,'20170224','13:47:30','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2121,'20170224','13:47:30','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2122,'20170224','13:47:31','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2123,'20170224','13:47:33','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2123,'20170224','13:47:33','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2125,'20170224','14:12:35','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2126,'20170224','14:22:59','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2127,'20170224','14:34:06','132.248.72.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2128,'20170224','14:55:24','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2129,'20170224','15:07:56','132.247.162.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2130,'20170224','15:12:56','132.248.67.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2131,'20170224','15:35:21','52.3.127.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2132,'20170224','15:45:33','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2133,'20170224','16:40:48','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2134,'20170224','17:19:04','187.214.178.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2135,'20170224','17:20:10','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2136,'20170224','18:11:13','132.248.242.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2137,'20170224','18:11:15','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2138,'20170224','18:30:49','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2139,'20170224','19:43:24','189.147.236.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2140,'20170224','20:29:24','201.124.171.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2141,'20170224','22:18:19','189.216.204.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2142,'20170225','01:33:16','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2143,'20170225','02:24:06','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2144,'20170225','03:32:31','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2145,'20170225','03:45:30','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2146,'20170225','05:11:12','201.102.36.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2147,'20170225','06:33:21','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2148,'20170225','08:58:32','180.76.15.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2149,'20170225','09:49:15','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2150,'20170225','10:36:15','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2151,'20170225','12:03:58','66.249.85.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2152,'20170225','12:04:11','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2153,'20170225','12:21:08','66.249.85.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2154,'20170225','13:24:02','189.242.246.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2155,'20170225','13:33:57','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2156,'20170225','15:20:54','201.113.228.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2157,'20170225','16:55:57','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2158,'20170225','22:58:53','187.161.235.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2159,'20170225','23:57:48','189.216.58.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2160,'20170226','00:00:29','189.216.58.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2161,'20170226','00:23:12','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2162,'20170226','01:24:38','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2163,'20170226','03:11:47','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2164,'20170226','09:23:05','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2165,'20170226','11:40:53','66.249.69.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2166,'20170226','11:56:12','66.249.69.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2167,'20170226','12:59:12','187.240.181.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2168,'20170226','15:44:49','187.227.246.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2169,'20170226','15:50:33','66.249.69.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2170,'20170226','16:04:39','189.216.198.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2171,'20170226','18:02:45','177.239.49.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2172,'20170226','18:43:55','52.4.48.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2173,'20170226','19:37:52','187.206.200.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2174,'20170226','21:25:08','187.222.95.116');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2175,'20170227','00:02:39','189.217.217.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2176,'20170227','02:59:29','66.249.69.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2177,'20170227','03:14:02','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2178,'20170227','03:19:48','66.249.69.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2179,'20170227','07:16:04','66.249.69.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2180,'20170227','08:35:57','64.233.172.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2181,'20170227','08:36:53','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2182,'20170227','08:46:05','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2183,'20170227','08:47:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2184,'20170227','08:58:27','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2185,'20170227','09:27:27','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2186,'20170227','09:40:12','98.198.73.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2187,'20170227','09:41:44','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2188,'20170227','09:43:09','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2189,'20170227','09:58:23','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2190,'20170227','10:03:56','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2191,'20170227','10:06:08','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2192,'20170227','10:08:57','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2193,'20170227','11:13:44','132.248.16.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2194,'20170227','11:24:10','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2194,'20170227','11:24:10','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2196,'20170227','11:50:04','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2197,'20170227','11:52:15','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2198,'20170227','12:02:52','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2199,'20170227','12:17:10','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2200,'20170227','12:20:32','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2201,'20170227','12:26:30','132.248.63.192');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2202,'20170227','12:27:58','200.4.83.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2203,'20170227','12:29:25','187.234.135.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2204,'20170227','12:33:07','177.234.2.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2205,'20170227','12:35:58','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2206,'20170227','12:37:32','159.16.106.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2207,'20170227','12:52:23','189.189.93.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2208,'20170227','12:52:29','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2209,'20170227','13:19:38','189.137.143.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2210,'20170227','14:00:52','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2211,'20170227','14:02:04','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2212,'20170227','14:45:47','108.51.32.116');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2213,'20170227','14:53:15','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2214,'20170227','14:58:37','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2215,'20170227','15:03:23','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2216,'20170227','15:11:51','177.234.1.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2217,'20170227','15:43:02','132.248.91.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2218,'20170227','15:48:38','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2219,'20170227','16:03:32','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2220,'20170227','16:25:29','189.216.182.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2221,'20170227','16:39:22','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2222,'20170227','17:05:03','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2223,'20170227','17:26:40','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2224,'20170227','17:33:08','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2225,'20170227','17:43:46','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2226,'20170227','17:48:06','132.247.113.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2227,'20170227','18:02:36','132.247.113.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2228,'20170227','18:11:58','187.190.39.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2229,'20170227','18:21:27','132.248.67.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2230,'20170227','18:33:05','201.114.64.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2231,'20170227','19:15:34','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2232,'20170227','19:33:34','132.247.74.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2233,'20170227','19:58:40','187.207.240.50');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2234,'20170227','21:28:02','189.191.139.117');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2235,'20170228','00:22:25','66.249.69.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2236,'20170228','00:42:45','66.249.69.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2237,'20170228','04:35:03','180.76.15.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2238,'20170228','06:18:05','66.249.69.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2239,'20170228','06:21:21','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2240,'20170228','08:43:01','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2241,'20170228','08:48:07','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2242,'20170228','09:10:08','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2243,'20170228','09:14:14','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2244,'20170228','09:16:30','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2245,'20170228','09:20:37','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2246,'20170228','09:21:20','148.247.69.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2247,'20170228','09:30:14','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2248,'20170228','09:30:36','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2249,'20170228','09:31:25','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2250,'20170228','09:47:00','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2251,'20170228','09:57:41','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2252,'20170228','10:03:31','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2253,'20170228','10:07:30','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2254,'20170228','10:18:18','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2255,'20170228','10:18:58','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2256,'20170228','10:54:48','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2257,'20170228','10:57:32','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2258,'20170228','11:10:19','187.221.125.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2259,'20170228','11:14:11','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2260,'20170228','11:15:41','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2261,'20170228','11:16:45','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2262,'20170228','11:18:47','132.248.29.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2263,'20170228','11:25:47','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2264,'20170228','11:34:45','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2265,'20170228','11:39:14','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2266,'20170228','12:03:33','189.216.207.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2267,'20170228','12:17:24','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2268,'20170228','12:19:15','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2269,'20170228','12:19:44','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2270,'20170228','12:31:17','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2271,'20170228','13:00:12','66.249.79.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2272,'20170228','13:03:57','132.248.248.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2273,'20170228','13:29:54','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2273,'20170228','13:29:54','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2275,'20170228','13:34:20','66.249.85.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2276,'20170228','13:35:30','66.249.85.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2277,'20170228','13:36:29','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2278,'20170228','13:51:30','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2279,'20170228','14:12:22','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2280,'20170228','14:18:49','180.76.15.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2281,'20170228','14:22:02','189.137.143.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2282,'20170228','14:37:45','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2283,'20170228','14:59:05','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2284,'20170228','15:00:24','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2285,'20170228','15:06:21','132.248.9.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2286,'20170228','15:16:26','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2287,'20170228','17:02:17','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2288,'20170228','17:24:34','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2289,'20170228','17:29:51','132.248.79.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2290,'20170228','17:38:20','132.248.182.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2291,'20170228','17:52:14','132.248.54.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2292,'20170228','18:39:09','132.247.80.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2293,'20170228','18:49:40','201.99.139.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2294,'20170228','19:25:45','207.46.13.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2295,'20170228','19:30:07','189.242.85.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2296,'20170228','19:32:43','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2297,'20170228','19:49:25','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2298,'20170228','20:05:13','189.216.149.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2299,'20170228','20:19:45','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2300,'20170228','20:44:43','187.145.170.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2301,'20170228','22:40:43','66.249.79.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2302,'20170301','02:05:43','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2303,'20170301','02:31:12','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2304,'20170301','06:30:34','160.120.4.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2305,'20170301','06:44:41','190.148.39.245');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2306,'20170301','08:34:21','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2307,'20170301','08:39:07','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2308,'20170301','08:48:08','132.248.216.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2309,'20170301','08:51:55','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2310,'20170301','09:24:22','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2311,'20170301','09:26:48','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2312,'20170301','09:50:09','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2313,'20170301','09:52:24','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2314,'20170301','10:03:12','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2315,'20170301','10:11:20','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2316,'20170301','10:34:08','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2317,'20170301','10:38:50','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2318,'20170301','10:54:09','68.180.230.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2319,'20170301','10:58:05','189.225.1.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2320,'20170301','10:58:33','189.216.206.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2321,'20170301','11:13:53','189.140.214.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2322,'20170301','11:21:37','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2323,'20170301','11:26:29','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2324,'20170301','11:44:19','132.248.101.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2325,'20170301','11:55:45','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2326,'20170301','11:59:52','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2326,'20170301','11:59:52','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2328,'20170301','12:01:57','66.249.65.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2329,'20170301','12:06:57','132.248.181.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2330,'20170301','12:10:15','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2331,'20170301','12:45:44','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2332,'20170301','12:52:21','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2333,'20170301','13:06:02','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2334,'20170301','13:18:26','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2335,'20170301','13:21:39','187.210.189.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2336,'20170301','13:49:41','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2337,'20170301','13:55:40','132.248.90.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2338,'20170301','13:59:37','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2338,'20170301','13:59:37','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2340,'20170301','13:59:38','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2341,'20170301','13:59:40','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2342,'20170301','13:59:41','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2343,'20170301','13:59:49','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2344,'20170301','13:59:50','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2345,'20170301','14:11:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2346,'20170301','14:12:45','201.141.175.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2347,'20170301','14:13:24','187.207.207.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2348,'20170301','14:21:52','66.249.65.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2349,'20170301','14:27:01','66.249.65.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2350,'20170301','14:32:08','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2351,'20170301','14:54:05','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2352,'20170301','15:03:47','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2353,'20170301','15:05:42','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2354,'20170301','15:38:18','189.215.207.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2355,'20170301','15:41:36','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2356,'20170301','16:01:55','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2357,'20170301','16:20:50','132.248.86.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2358,'20170301','16:32:25','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2359,'20170301','16:35:32','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2360,'20170301','16:39:55','132.248.67.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2361,'20170301','16:41:29','200.34.78.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2362,'20170301','16:52:56','132.248.248.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2363,'20170301','17:07:36','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2364,'20170301','17:14:16','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2365,'20170301','17:25:14','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2366,'20170301','18:05:07','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2367,'20170301','19:19:18','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2368,'20170301','19:48:00','187.189.255.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2369,'20170301','20:55:36','187.228.182.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2370,'20170301','21:12:59','189.217.53.245');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2371,'20170301','22:19:27','189.134.219.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2372,'20170301','22:22:09','187.145.253.127');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2373,'20170301','22:32:02','187.228.139.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2374,'20170301','23:15:34','132.248.32.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2375,'20170302','08:41:16','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2376,'20170302','08:54:14','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2377,'20170302','09:02:08','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2378,'20170302','09:23:00','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2379,'20170302','09:36:54','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2380,'20170302','09:44:42','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2381,'20170302','09:44:50','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2382,'20170302','09:45:18','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2383,'20170302','09:47:52','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2384,'20170302','09:58:17','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2385,'20170302','10:00:41','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2386,'20170302','10:12:15','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2387,'20170302','10:23:43','132.248.16.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2388,'20170302','10:47:41','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2389,'20170302','10:51:20','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2390,'20170302','10:56:33','189.225.1.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2391,'20170302','11:10:26','132.248.76.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2392,'20170302','11:14:28','187.228.102.231');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2393,'20170302','11:17:36','132.248.9.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2394,'20170302','11:26:52','201.157.108.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2395,'20170302','11:33:15','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2396,'20170302','11:35:50','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2397,'20170302','12:08:04','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2398,'20170302','12:51:00','132.248.82.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2399,'20170302','12:55:49','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2400,'20170302','12:55:54','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2401,'20170302','13:01:06','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2402,'20170302','13:09:22','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2403,'20170302','13:13:21','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2404,'20170302','13:54:38','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2405,'20170302','14:13:04','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2406,'20170302','14:13:40','132.248.48.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2407,'20170302','14:30:49','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2408,'20170302','14:36:08','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2409,'20170302','14:40:29','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2410,'20170302','14:53:40','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2411,'20170302','15:11:51','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2412,'20170302','15:15:08','189.137.73.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2413,'20170302','15:17:16','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2414,'20170302','15:27:14','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2415,'20170302','15:50:21','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2416,'20170302','16:03:35','189.216.180.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2417,'20170302','16:06:55','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2418,'20170302','16:07:39','187.214.178.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2419,'20170302','16:44:53','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2420,'20170302','18:09:59','189.216.50.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2421,'20170302','18:14:13','187.237.231.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2422,'20170302','18:25:39','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2423,'20170302','18:36:44','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2424,'20170302','18:41:14','189.217.241.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2425,'20170302','18:44:09','132.248.74.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2426,'20170302','18:45:50','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2427,'20170302','18:46:44','132.248.9.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2428,'20170302','19:05:29','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2429,'20170302','19:53:06','189.216.149.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2430,'20170302','20:19:26','189.217.217.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2431,'20170302','21:53:46','207.46.13.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2432,'20170303','00:04:04','189.216.205.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2433,'20170303','05:49:13','189.216.198.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2434,'20170303','08:30:14','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2435,'20170303','08:48:20','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2436,'20170303','08:50:38','132.248.184.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2437,'20170303','08:53:24','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2438,'20170303','09:04:56','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2439,'20170303','09:08:49','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2440,'20170303','10:01:50','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2441,'20170303','10:13:51','189.249.182.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2442,'20170303','10:15:14','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2443,'20170303','10:28:39','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2444,'20170303','10:35:39','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2444,'20170303','10:35:39','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2446,'20170303','10:36:29','189.216.182.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2447,'20170303','10:38:10','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2448,'20170303','10:39:09','187.228.102.231');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2449,'20170303','10:51:15','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2450,'20170303','10:57:15','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2451,'20170303','10:59:13','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2452,'20170303','11:01:26','132.247.159.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2453,'20170303','11:07:33','66.249.85.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2454,'20170303','11:18:27','187.168.29.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2455,'20170303','11:32:13','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2456,'20170303','11:34:02','189.137.227.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2457,'20170303','11:49:59','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2458,'20170303','12:19:55','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2459,'20170303','12:22:49','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2460,'20170303','12:27:35','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2461,'20170303','12:43:43','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2462,'20170303','12:59:16','132.248.9.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2463,'20170303','13:11:07','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2464,'20170303','13:15:46','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2465,'20170303','13:22:14','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2466,'20170303','13:33:46','132.247.192.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2467,'20170303','13:40:18','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2468,'20170303','13:50:04','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2469,'20170303','14:31:55','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2470,'20170303','15:11:42','132.248.80.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2471,'20170303','15:11:43','132.248.80.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2471,'20170303','15:11:43','132.248.80.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2473,'20170303','15:14:15','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2474,'20170303','15:43:47','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2475,'20170303','15:46:37','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2476,'20170303','16:11:42','132.248.9.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2477,'20170303','16:22:44','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2478,'20170303','17:27:43','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2479,'20170303','17:48:30','201.124.215.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2480,'20170303','17:59:19','189.134.82.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2481,'20170303','18:00:08','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2482,'20170303','18:48:52','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2483,'20170303','18:53:01','132.248.216.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2484,'20170303','19:22:28','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2485,'20170303','19:43:03','187.237.14.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2486,'20170303','19:43:26','187.237.14.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2487,'20170303','19:59:16','189.216.123.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2488,'20170303','22:15:27','189.216.197.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2489,'20170303','23:19:06','189.136.20.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2490,'20170304','01:15:38','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2491,'20170304','06:49:32','180.76.15.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2492,'20170304','10:20:15','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2493,'20170304','11:57:19','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2494,'20170304','11:58:10','201.130.8.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2495,'20170304','13:21:53','201.141.30.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2496,'20170304','13:51:57','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2497,'20170304','16:12:42','201.137.117.37');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2498,'20170304','16:53:48','177.252.240.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2499,'20170304','21:15:41','189.216.196.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2500,'20170304','21:54:24','187.223.215.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2501,'20170305','01:18:43','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2502,'20170305','01:18:45','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2503,'20170305','01:29:43','189.147.19.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2504,'20170305','04:44:43','180.76.15.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2505,'20170305','06:31:08','207.46.13.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2506,'20170305','07:47:23','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2507,'20170305','10:51:54','187.222.9.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2508,'20170305','12:37:26','201.137.117.37');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2509,'20170305','13:07:15','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2510,'20170305','13:23:54','187.168.31.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2511,'20170305','16:43:10','189.216.196.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2512,'20170305','18:07:03','148.246.82.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2513,'20170305','19:20:50','187.189.93.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2514,'20170305','19:36:48','187.210.189.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2515,'20170305','20:28:01','189.203.174.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2516,'20170306','00:22:05','187.230.55.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2517,'20170306','00:44:07','189.147.197.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2518,'20170306','01:13:10','201.114.175.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2519,'20170306','02:32:01','212.128.118.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2520,'20170306','03:35:08','201.124.122.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2521,'20170306','08:35:40','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2522,'20170306','09:23:02','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2523,'20170306','09:29:26','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2524,'20170306','09:34:35','189.142.235.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2525,'20170306','09:53:05','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2526,'20170306','10:07:47','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2527,'20170306','10:20:26','132.248.89.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2528,'20170306','10:33:33','148.218.95.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2529,'20170306','10:33:42','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2530,'20170306','10:37:21','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2531,'20170306','10:43:34','132.248.143.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2532,'20170306','10:46:13','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2533,'20170306','10:46:51','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2534,'20170306','10:47:20','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2535,'20170306','11:14:48','148.202.26.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2536,'20170306','11:23:40','187.228.135.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2537,'20170306','11:24:19','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2537,'20170306','11:24:19','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2539,'20170306','11:27:56','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2540,'20170306','11:28:28','189.144.164.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2541,'20170306','11:35:44','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2542,'20170306','11:46:19','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2543,'20170306','11:46:31','189.146.140.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2544,'20170306','11:59:08','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2545,'20170306','12:04:05','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2546,'20170306','12:10:36','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2547,'20170306','12:17:45','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2548,'20170306','12:23:49','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2549,'20170306','12:37:25','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2550,'20170306','12:46:55','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2551,'20170306','12:47:21','132.248.103.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2552,'20170306','13:02:21','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2553,'20170306','13:15:33','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2554,'20170306','13:20:51','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2555,'20170306','13:20:58','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2556,'20170306','13:21:13','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2557,'20170306','13:33:02','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2558,'20170306','13:40:15','132.248.41.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2559,'20170306','13:40:17','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2560,'20170306','13:43:01','132.248.37.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2561,'20170306','14:02:37','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2562,'20170306','14:08:29','187.237.231.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2563,'20170306','14:23:00','157.55.39.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2564,'20170306','14:38:03','132.248.51.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2565,'20170306','14:40:57','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2566,'20170306','16:20:17','189.216.197.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2567,'20170306','16:22:10','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2568,'20170306','16:59:59','132.248.103.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2569,'20170306','17:17:06','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2570,'20170306','17:19:49','132.248.199.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2571,'20170306','17:34:30','187.221.53.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2572,'20170306','17:46:42','66.102.8.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2573,'20170306','17:47:22','132.248.9.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2574,'20170306','18:23:08','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2575,'20170306','18:24:28','132.248.67.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2576,'20170306','19:12:55','187.223.78.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2577,'20170306','19:30:54','132.248.74.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2578,'20170306','20:16:11','132.248.43.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2579,'20170306','20:37:35','132.248.89.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2580,'20170306','21:44:05','187.190.11.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2581,'20170306','22:36:24','187.169.54.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2582,'20170307','00:40:36','66.102.6.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2583,'20170307','01:10:25','187.226.29.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2584,'20170307','05:24:21','52.201.243.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2585,'20170307','07:54:23','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2586,'20170307','08:28:50','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2587,'20170307','08:39:29','201.117.1.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2588,'20170307','08:44:04','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2589,'20170307','08:56:57','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2590,'20170307','09:01:59','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2591,'20170307','09:09:53','163.172.66.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2592,'20170307','09:21:32','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2593,'20170307','09:38:07','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2594,'20170307','09:39:00','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2595,'20170307','09:39:21','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2596,'20170307','09:51:26','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2597,'20170307','09:53:49','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2598,'20170307','10:01:50','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2599,'20170307','10:30:42','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2600,'20170307','10:38:32','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2601,'20170307','10:55:47','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2602,'20170307','10:57:47','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2603,'20170307','11:06:41','132.248.91.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2604,'20170307','11:28:35','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2605,'20170307','11:31:50','187.168.33.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2606,'20170307','11:34:34','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2607,'20170307','11:38:28','201.124.188.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2608,'20170307','11:40:34','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2609,'20170307','12:19:50','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2610,'20170307','12:22:31','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2611,'20170307','12:23:26','132.248.25.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2612,'20170307','12:47:15','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2613,'20170307','12:56:42','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2614,'20170307','13:11:27','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2615,'20170307','13:30:44','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2616,'20170307','13:36:46','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2617,'20170307','13:53:05','132.247.186.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2618,'20170307','13:56:39','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2619,'20170307','14:02:47','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2620,'20170307','14:13:13','132.248.37.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2621,'20170307','14:16:07','148.206.53.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2622,'20170307','14:38:07','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2623,'20170307','14:40:35','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2624,'20170307','14:44:05','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2625,'20170307','14:44:06','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2625,'20170307','14:44:06','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2625,'20170307','14:44:06','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2625,'20170307','14:44:06','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2629,'20170307','14:44:07','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2630,'20170307','14:44:09','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2631,'20170307','14:44:39','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2632,'20170307','14:45:20','200.33.101.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2633,'20170307','14:54:13','132.248.128.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2634,'20170307','14:54:29','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2635,'20170307','15:19:45','190.217.58.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2636,'20170307','15:31:39','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2637,'20170307','15:35:56','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2638,'20170307','15:49:24','132.248.67.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2639,'20170307','15:57:33','66.249.69.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2640,'20170307','16:13:17','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2641,'20170307','16:16:30','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2642,'20170307','16:37:47','189.228.144.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2643,'20170307','17:03:40','180.76.15.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2644,'20170307','17:03:56','201.141.123.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2645,'20170307','17:27:41','189.216.198.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2646,'20170307','17:43:55','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2647,'20170307','17:55:50','177.231.174.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2648,'20170307','17:59:50','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2649,'20170307','18:40:44','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2650,'20170307','19:34:19','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2651,'20170307','19:55:14','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2652,'20170307','23:13:42','177.233.184.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2653,'20170307','23:15:26','189.217.176.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2654,'20170308','08:58:44','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2655,'20170308','09:23:37','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2656,'20170308','09:24:14','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2657,'20170308','09:37:06','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2658,'20170308','09:41:34','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2659,'20170308','09:49:03','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2660,'20170308','10:13:38','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2661,'20170308','10:15:19','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2662,'20170308','10:20:02','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2663,'20170308','10:26:38','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2664,'20170308','10:40:34','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2665,'20170308','11:05:32','68.180.230.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2666,'20170308','11:09:42','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2667,'20170308','11:38:03','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2668,'20170308','11:38:17','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2669,'20170308','12:06:28','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2670,'20170308','12:09:55','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2671,'20170308','12:12:59','132.248.110.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2672,'20170308','12:24:12','132.248.151.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2673,'20170308','12:39:31','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2674,'20170308','12:49:36','189.211.8.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2675,'20170308','12:56:08','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2676,'20170308','13:07:26','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2677,'20170308','13:11:02','201.117.1.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2678,'20170308','13:46:01','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2679,'20170308','14:20:39','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2680,'20170308','14:23:18','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2681,'20170308','14:59:40','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2682,'20170308','15:10:19','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2683,'20170308','15:29:59','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2684,'20170308','15:43:58','189.241.24.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2685,'20170308','17:03:46','132.248.41.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2686,'20170308','17:15:16','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2687,'20170308','17:30:39','66.249.93.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2688,'20170308','18:09:36','132.248.9.167');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2689,'20170308','18:21:42','189.216.198.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2690,'20170308','18:40:55','181.49.188.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2691,'20170308','18:47:06','132.247.192.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2692,'20170308','19:02:07','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2693,'20170308','19:56:35','132.248.67.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2694,'20170308','20:23:15','189.147.52.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2695,'20170308','20:34:15','177.226.228.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2696,'20170308','20:57:22','189.216.199.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2697,'20170308','21:39:30','201.166.235.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2698,'20170308','22:46:54','187.225.250.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2699,'20170308','23:12:21','187.234.50.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2700,'20170309','02:12:48','201.157.87.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2701,'20170309','04:02:56','159.237.12.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2702,'20170309','08:35:53','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2703,'20170309','08:58:44','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2704,'20170309','09:05:11','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2705,'20170309','09:21:00','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2706,'20170309','09:36:24','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2707,'20170309','09:56:31','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2708,'20170309','09:58:43','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2709,'20170309','10:04:37','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2710,'20170309','10:20:38','132.248.9.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2711,'20170309','10:24:04','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2712,'20170309','10:39:02','88.23.166.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2713,'20170309','10:46:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2714,'20170309','10:47:22','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2715,'20170309','10:52:17','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2716,'20170309','10:53:56','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2717,'20170309','11:08:00','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2718,'20170309','11:14:30','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2719,'20170309','11:39:46','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2720,'20170309','11:48:43','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2721,'20170309','12:25:57','132.247.198.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2722,'20170309','13:01:11','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2723,'20170309','13:05:51','132.248.67.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2724,'20170309','13:29:59','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2725,'20170309','13:40:33','189.216.196.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2726,'20170309','13:44:53','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2727,'20170309','13:48:31','189.207.184.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2728,'20170309','14:16:24','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2729,'20170309','15:00:16','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2730,'20170309','15:03:18','201.155.106.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2731,'20170309','15:16:31','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2732,'20170309','15:54:01','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2733,'20170309','16:20:36','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2734,'20170309','17:10:46','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2735,'20170309','17:13:59','200.76.91.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2736,'20170309','17:47:01','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2737,'20170309','18:22:38','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2738,'20170309','18:23:05','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2739,'20170309','19:29:29','189.148.52.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2740,'20170309','19:37:50','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2741,'20170309','20:40:29','187.189.154.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2742,'20170309','22:08:23','187.223.40.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2743,'20170309','22:21:43','189.217.64.40');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2744,'20170309','22:34:15','189.146.48.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2745,'20170310','06:02:28','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2746,'20170310','07:26:51','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2747,'20170310','08:42:07','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2748,'20170310','08:48:55','132.248.86.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2749,'20170310','09:05:11','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2750,'20170310','09:29:08','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2751,'20170310','09:36:04','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2752,'20170310','09:39:07','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2753,'20170310','09:57:34','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2754,'20170310','10:00:26','187.223.49.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2755,'20170310','10:01:42','189.216.196.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2756,'20170310','10:02:13','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2757,'20170310','10:09:08','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2758,'20170310','10:14:34','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2759,'20170310','10:15:53','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2760,'20170310','10:17:00','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2761,'20170310','10:28:02','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2762,'20170310','10:36:16','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2763,'20170310','10:39:03','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2764,'20170310','10:40:25','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2765,'20170310','10:51:51','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2766,'20170310','10:59:52','132.248.196.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2767,'20170310','11:03:40','132.247.184.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2768,'20170310','11:08:11','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2769,'20170310','11:11:15','187.188.82.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2770,'20170310','11:23:44','132.248.181.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2771,'20170310','11:30:56','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2772,'20170310','11:34:43','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2773,'20170310','11:35:25','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2774,'20170310','11:42:09','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2775,'20170310','11:51:44','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2776,'20170310','11:54:23','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2777,'20170310','11:58:58','189.216.180.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2778,'20170310','12:34:36','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2779,'20170310','13:06:22','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2780,'20170310','13:59:24','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2781,'20170310','14:08:02','153.254.146.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2782,'20170310','14:40:55','132.248.92.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2783,'20170310','15:03:04','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2784,'20170310','15:09:19','132.248.150.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2785,'20170310','15:42:25','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2786,'20170310','15:48:17','132.248.128.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2787,'20170310','15:50:27','132.248.16.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2788,'20170310','16:14:49','189.216.112.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2789,'20170310','16:47:46','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2790,'20170310','17:25:04','189.146.119.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2791,'20170310','18:06:08','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2792,'20170310','18:06:41','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2793,'20170310','18:11:37','132.248.47.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2794,'20170310','18:49:43','77.66.1.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2795,'20170310','19:34:00','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2796,'20170311','02:00:06','187.234.212.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2797,'20170311','05:27:01','81.40.6.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2798,'20170311','08:15:50','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2799,'20170311','09:45:28','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2800,'20170311','11:25:41','189.216.120.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2801,'20170311','11:50:42','132.248.181.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2802,'20170311','11:59:45','157.55.39.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2803,'20170311','13:47:20','187.226.223.236');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2804,'20170311','16:23:12','104.197.241.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2805,'20170311','16:33:48','187.189.240.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2806,'20170312','08:54:00','187.145.197.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2807,'20170312','13:41:50','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2808,'20170312','14:20:35','189.245.181.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2809,'20170312','15:46:12','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2810,'20170312','18:28:05','189.137.84.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2811,'20170312','18:38:51','189.216.197.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2812,'20170313','08:53:44','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2813,'20170313','08:54:15','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2814,'20170313','09:06:43','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2815,'20170313','09:31:49','187.190.166.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2816,'20170313','09:52:54','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2817,'20170313','09:57:26','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2818,'20170313','10:29:08','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2819,'20170313','10:31:00','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2820,'20170313','10:47:32','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2821,'20170313','11:03:05','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2822,'20170313','11:05:54','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2823,'20170313','11:18:53','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2824,'20170313','11:33:23','132.248.100.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2825,'20170313','11:53:34','132.248.132.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2826,'20170313','11:56:53','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2827,'20170313','11:58:45','66.249.85.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2828,'20170313','12:05:43','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2829,'20170313','12:23:43','187.207.203.116');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2830,'20170313','12:33:18','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2831,'20170313','12:38:50','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2832,'20170313','12:52:56','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2833,'20170313','13:23:22','132.248.128.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2834,'20170313','13:32:08','132.248.240.172');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2835,'20170313','13:38:59','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2836,'20170313','13:47:41','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2837,'20170313','13:48:05','200.57.117.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2838,'20170313','14:17:36','201.159.133.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2839,'20170313','14:56:36','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2840,'20170313','15:09:07','148.206.53.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2841,'20170313','15:18:15','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2842,'20170313','15:26:49','132.248.245.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2843,'20170313','15:46:59','187.145.229.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2844,'20170313','15:52:11','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2845,'20170313','15:59:16','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2846,'20170313','16:06:54','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2847,'20170313','17:08:39','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2848,'20170313','17:23:18','132.248.143.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2849,'20170313','17:47:23','201.137.142.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2850,'20170313','18:11:31','132.248.174.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2851,'20170313','18:33:30','146.148.100.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2852,'20170313','18:33:51','189.216.198.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2853,'20170313','19:08:43','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2854,'20170313','19:56:31','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2855,'20170313','20:20:17','132.248.98.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2856,'20170313','21:04:00','187.225.52.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2857,'20170313','21:42:34','189.191.66.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2858,'20170313','23:15:05','187.190.186.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2859,'20170314','07:53:24','180.76.15.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2860,'20170314','08:46:48','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2860,'20170314','08:46:48','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2862,'20170314','08:46:51','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2862,'20170314','08:46:51','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2862,'20170314','08:46:51','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2862,'20170314','08:46:52','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2862,'20170314','08:46:52','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2867,'20170314','08:46:57','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2868,'20170314','08:47:08','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2869,'20170314','08:47:45','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2870,'20170314','08:59:31','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2871,'20170314','09:20:45','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2872,'20170314','09:26:08','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2873,'20170314','09:28:18','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2874,'20170314','09:32:14','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2875,'20170314','09:47:22','132.248.114.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2876,'20170314','10:08:50','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2877,'20170314','10:17:12','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2878,'20170314','10:22:10','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2879,'20170314','10:23:45','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2880,'20170314','10:38:21','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2880,'20170314','10:38:21','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2882,'20170314','10:54:27','132.248.238.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2883,'20170314','10:58:24','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2884,'20170314','11:12:30','132.248.44.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2885,'20170314','11:24:45','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2886,'20170314','11:38:23','187.145.202.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2887,'20170314','11:43:22','201.117.1.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2888,'20170314','12:15:04','187.141.124.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2889,'20170314','12:17:51','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2890,'20170314','12:31:45','132.248.91.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2891,'20170314','12:34:29','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2892,'20170314','12:35:55','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2893,'20170314','12:42:14','189.216.205.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2894,'20170314','12:50:01','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2895,'20170314','12:59:08','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2896,'20170314','13:14:15','189.216.150.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2897,'20170314','13:24:08','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2898,'20170314','13:24:40','201.99.139.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2899,'20170314','13:42:54','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2900,'20170314','13:57:52','148.206.53.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2901,'20170314','13:59:54','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2902,'20170314','14:05:01','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2903,'20170314','14:21:45','189.216.180.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2904,'20170314','14:44:47','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2905,'20170314','15:05:35','189.216.49.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2906,'20170314','15:10:02','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2907,'20170314','15:14:53','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2908,'20170314','15:51:43','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2909,'20170314','16:20:32','146.148.100.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2910,'20170314','16:48:41','189.216.197.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2911,'20170314','17:02:47','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2912,'20170314','17:08:43','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2913,'20170314','17:38:53','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2914,'20170314','17:40:19','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2915,'20170314','18:03:08','189.254.237.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2916,'20170314','18:16:44','177.234.0.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2917,'20170314','18:18:56','189.206.56.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2918,'20170314','18:40:05','132.248.50.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2919,'20170314','20:53:43','189.136.112.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2920,'20170314','21:28:28','187.234.149.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2921,'20170314','21:51:04','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2922,'20170315','06:47:57','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2923,'20170315','07:57:56','180.76.15.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2924,'20170315','08:04:28','189.240.100.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2925,'20170315','08:42:39','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2926,'20170315','08:54:57','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2927,'20170315','09:08:38','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2928,'20170315','09:12:56','200.4.2.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2929,'20170315','09:38:19','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2930,'20170315','09:38:55','201.137.24.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2931,'20170315','09:38:56','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2932,'20170315','09:39:20','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2933,'20170315','09:41:59','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2934,'20170315','09:50:44','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2935,'20170315','10:03:31','201.117.1.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2936,'20170315','10:16:32','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2937,'20170315','10:37:57','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2938,'20170315','10:52:02','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2939,'20170315','10:56:42','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2940,'20170315','11:04:26','187.190.155.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2941,'20170315','11:04:37','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2942,'20170315','11:05:45','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2943,'20170315','11:11:33','68.180.231.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2944,'20170315','11:19:05','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2945,'20170315','11:23:25','132.248.74.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2946,'20170315','11:41:05','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2947,'20170315','11:46:20','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2948,'20170315','11:53:15','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2949,'20170315','11:57:04','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2950,'20170315','12:24:43','132.248.9.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2951,'20170315','12:26:26','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2952,'20170315','12:55:42','200.23.200.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2953,'20170315','13:30:04','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2954,'20170315','13:34:05','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2955,'20170315','13:58:35','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2956,'20170315','14:02:22','132.248.242.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2957,'20170315','14:18:20','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2958,'20170315','14:28:43','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2959,'20170315','14:31:09','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2960,'20170315','14:34:08','189.211.128.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2961,'20170315','14:55:15','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2962,'20170315','15:09:40','157.55.39.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2963,'20170315','15:10:12','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2963,'20170315','15:10:12','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2965,'20170315','15:10:13','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2966,'20170315','15:10:14','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2966,'20170315','15:10:14','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2968,'20170315','15:10:15','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2968,'20170315','15:10:16','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2970,'20170315','15:10:18','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2971,'20170315','15:10:25','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2972,'20170315','15:12:46','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2973,'20170315','15:17:02','200.57.117.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2974,'20170315','15:22:33','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2975,'20170315','15:42:51','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2976,'20170315','15:54:13','132.248.67.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2977,'20170315','16:34:57','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2978,'20170315','16:41:53','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2979,'20170315','16:42:28','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2980,'20170315','16:56:03','132.248.43.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2981,'20170315','17:15:51','132.248.143.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2982,'20170315','17:29:18','132.248.132.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2983,'20170315','17:40:33','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2984,'20170315','18:04:13','189.216.196.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2985,'20170315','18:18:41','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2986,'20170315','18:21:55','132.248.248.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2987,'20170315','19:04:56','189.216.197.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2988,'20170315','19:34:19','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2989,'20170315','22:37:42','187.159.88.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2990,'20170315','23:28:22','180.76.15.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2991,'20170315','23:36:32','187.226.210.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2992,'20170316','00:27:16','189.216.49.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2993,'20170316','00:36:48','189.136.59.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2994,'20170316','00:39:51','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2995,'20170316','01:10:57','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2996,'20170316','01:53:34','189.221.205.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2997,'20170316','02:36:48','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2998,'20170316','03:37:55','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (2999,'20170316','04:28:23','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3000,'20170316','08:27:26','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3001,'20170316','08:47:16','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3002,'20170316','09:05:55','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3003,'20170316','09:35:05','132.248.84.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3004,'20170316','09:43:12','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3005,'20170316','10:07:37','132.248.103.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3006,'20170316','10:09:47','132.248.199.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3007,'20170316','10:16:10','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3008,'20170316','10:26:50','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3009,'20170316','10:29:26','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3010,'20170316','10:31:33','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3011,'20170316','10:33:14','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3012,'20170316','10:38:13','66.249.64.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3013,'20170316','10:40:57','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3014,'20170316','10:45:13','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3015,'20170316','10:47:31','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3016,'20170316','10:56:59','66.249.64.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3017,'20170316','10:57:01','66.249.64.45');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3018,'20170316','11:07:44','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3019,'20170316','11:18:00','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3020,'20170316','11:19:14','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3021,'20170316','11:38:55','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3022,'20170316','11:46:03','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3023,'20170316','11:50:25','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3024,'20170316','12:00:50','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3025,'20170316','12:02:50','66.249.64.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3026,'20170316','12:03:42','189.216.64.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3027,'20170316','12:06:37','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3028,'20170316','12:10:35','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3029,'20170316','12:11:12','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3030,'20170316','12:24:04','187.168.19.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3031,'20170316','12:33:32','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3032,'20170316','12:49:06','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3033,'20170316','13:14:41','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3034,'20170316','13:19:25','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3035,'20170316','13:26:00','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3036,'20170316','13:32:30','189.203.217.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3037,'20170316','13:33:17','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3038,'20170316','13:39:09','66.249.64.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3039,'20170316','13:40:16','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3040,'20170316','13:47:38','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3041,'20170316','13:50:05','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3042,'20170316','14:05:40','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3043,'20170316','14:12:19','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3044,'20170316','14:18:24','189.211.81.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3045,'20170316','14:25:27','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3046,'20170316','14:27:02','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3047,'20170316','14:56:58','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3048,'20170316','15:06:13','132.248.61.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3049,'20170316','15:08:57','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3050,'20170316','15:12:08','189.216.205.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3051,'20170316','15:50:26','187.237.14.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3052,'20170316','15:57:00','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3053,'20170316','15:57:06','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3054,'20170316','15:57:34','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3055,'20170316','16:06:28','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3056,'20170316','16:20:46','132.248.95.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3057,'20170316','16:41:10','132.247.184.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3058,'20170316','16:47:55','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3059,'20170316','17:32:35','189.217.58.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3060,'20170316','17:33:01','189.217.225.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3061,'20170316','17:40:05','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3062,'20170316','17:48:19','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3063,'20170316','18:31:34','187.237.14.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3064,'20170316','19:09:52','189.216.197.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3065,'20170316','19:31:01','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3066,'20170316','19:35:33','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3067,'20170316','21:02:36','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3068,'20170317','01:13:45','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3069,'20170317','01:29:14','180.76.15.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3070,'20170317','02:32:55','40.77.167.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3071,'20170317','07:41:44','66.249.64.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3072,'20170317','08:30:21','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3073,'20170317','08:43:26','187.214.240.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3074,'20170317','08:43:28','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3075,'20170317','08:59:19','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3076,'20170317','09:36:35','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3077,'20170317','09:42:57','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3078,'20170317','10:02:42','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3079,'20170317','10:20:48','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3080,'20170317','10:30:51','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3081,'20170317','10:44:36','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3082,'20170317','10:45:36','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3083,'20170317','10:49:03','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3084,'20170317','10:50:29','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3085,'20170317','10:53:43','187.190.155.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3086,'20170317','11:01:05','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3087,'20170317','11:04:16','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3088,'20170317','11:22:42','189.216.149.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3089,'20170317','11:25:56','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3090,'20170317','11:41:06','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3091,'20170317','11:58:24','189.216.180.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3092,'20170317','12:10:57','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3093,'20170317','12:23:39','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3094,'20170317','12:26:28','187.227.209.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3095,'20170317','12:29:24','200.23.200.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3096,'20170317','12:56:26','132.247.135.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3097,'20170317','13:02:12','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3098,'20170317','13:25:51','132.247.171.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3099,'20170317','13:42:08','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3100,'20170317','13:42:08','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3101,'20170317','13:42:09','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3102,'20170317','13:42:10','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3102,'20170317','13:42:10','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3104,'20170317','13:45:33','200.34.167.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3105,'20170317','13:54:04','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3106,'20170317','14:00:15','64.233.172.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3107,'20170317','14:09:43','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3108,'20170317','14:15:25','132.247.86.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3109,'20170317','14:19:57','201.137.17.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3110,'20170317','14:24:48','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3111,'20170317','14:30:35','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3112,'20170317','15:05:54','158.122.37.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3113,'20170317','15:20:22','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3114,'20170317','15:29:11','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3115,'20170317','15:38:05','201.166.188.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3116,'20170317','16:58:08','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3117,'20170317','16:59:17','132.248.93.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3118,'20170317','17:16:22','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3119,'20170317','17:25:19','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3120,'20170317','17:26:32','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3121,'20170317','17:31:16','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3122,'20170317','17:54:18','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3123,'20170317','17:58:13','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3124,'20170317','18:12:47','132.248.123.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3125,'20170317','18:15:53','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3126,'20170317','18:38:36','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3127,'20170317','18:40:14','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3128,'20170317','18:50:16','189.216.197.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3129,'20170317','19:13:31','132.248.79.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3130,'20170317','19:50:30','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3131,'20170317','20:08:09','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3132,'20170317','20:27:48','180.76.15.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3133,'20170317','20:42:42','187.151.30.45');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3134,'20170317','22:33:27','181.56.132.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3135,'20170318','09:08:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3136,'20170318','10:19:20','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3137,'20170318','10:53:00','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3138,'20170318','14:31:21','201.141.170.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3139,'20170318','18:12:22','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3140,'20170318','18:14:47','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3141,'20170318','19:03:24','46.242.121.116');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3142,'20170318','19:42:16','187.191.6.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3143,'20170318','22:27:37','189.239.7.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3144,'20170318','23:11:18','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3145,'20170319','01:18:36','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3146,'20170319','05:22:15','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3147,'20170319','09:32:38','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3148,'20170319','13:00:38','37.72.175.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3149,'20170319','17:57:13','59.90.112.78');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3150,'20170319','20:24:26','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3151,'20170319','21:43:46','189.239.32.237');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3152,'20170319','23:57:24','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3153,'20170320','00:41:44','95.28.185.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3154,'20170320','06:57:39','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3155,'20170320','10:06:09','187.145.200.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3156,'20170320','10:22:06','66.249.69.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3157,'20170320','11:33:09','66.249.75.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3158,'20170320','11:38:08','187.208.238.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3159,'20170320','12:34:36','189.144.254.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3160,'20170320','12:46:12','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3161,'20170320','12:49:24','189.216.196.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3162,'20170320','13:32:20','189.203.174.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3163,'20170320','14:38:24','66.249.75.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3164,'20170320','15:14:11','66.249.75.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3165,'20170320','15:15:26','189.242.152.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3166,'20170320','17:45:36','189.216.181.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3167,'20170320','18:04:04','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3168,'20170320','18:06:02','189.144.106.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3169,'20170320','18:44:41','189.215.154.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3170,'20170320','19:48:12','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3171,'20170320','21:16:18','187.151.247.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3172,'20170320','21:32:14','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3173,'20170321','08:08:55','187.234.241.219');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3173,'20170321','08:08:55','187.234.241.219');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3175,'20170321','08:25:46','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3176,'20170321','08:36:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3177,'20170321','08:59:17','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3178,'20170321','09:01:35','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3179,'20170321','09:25:46','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3180,'20170321','09:35:44','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3181,'20170321','09:40:47','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3182,'20170321','10:27:49','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3183,'20170321','10:31:21','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3184,'20170321','10:42:14','187.145.231.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3185,'20170321','10:44:54','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3186,'20170321','11:33:28','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3187,'20170321','11:38:56','132.248.114.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3188,'20170321','11:44:04','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3189,'20170321','11:55:21','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3190,'20170321','12:07:36','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3191,'20170321','12:12:09','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3192,'20170321','12:28:46','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3193,'20170321','12:31:50','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3194,'20170321','12:36:52','189.216.196.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3195,'20170321','12:44:37','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3196,'20170321','12:49:45','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3197,'20170321','12:50:58','189.216.73.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3198,'20170321','13:06:57','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3199,'20170321','13:34:42','132.248.45.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3200,'20170321','13:37:15','132.247.113.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3201,'20170321','13:48:44','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3202,'20170321','14:03:17','108.62.204.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3203,'20170321','14:44:07','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3204,'20170321','15:35:12','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3205,'20170321','15:40:35','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3206,'20170321','16:06:45','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3207,'20170321','16:39:44','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3208,'20170321','17:00:17','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3209,'20170321','17:22:52','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3210,'20170321','17:41:45','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3211,'20170321','17:49:05','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3212,'20170321','18:02:52','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3213,'20170321','18:11:43','66.249.69.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3214,'20170321','18:23:23','189.216.198.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3215,'20170321','18:48:04','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3216,'20170321','19:00:47','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3217,'20170321','19:04:47','66.249.93.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3218,'20170321','21:47:27','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3219,'20170322','00:15:02','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3220,'20170322','00:46:57','177.232.100.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3221,'20170322','05:56:27','148.251.136.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3222,'20170322','06:13:01','189.215.226.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3223,'20170322','08:29:40','207.46.13.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3224,'20170322','08:43:30','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3224,'20170322','08:43:31','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3225,'20170322','08:43:32','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3227,'20170322','08:43:35','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3228,'20170322','08:43:39','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3228,'20170322','08:43:40','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3230,'20170322','08:44:00','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3231,'20170322','08:44:09','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3232,'20170322','08:44:27','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3233,'20170322','08:45:21','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3234,'20170322','08:56:25','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3235,'20170322','09:04:51','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3236,'20170322','09:11:30','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3237,'20170322','09:37:06','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3238,'20170322','09:49:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3239,'20170322','10:12:42','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3240,'20170322','10:24:42','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3241,'20170322','10:44:59','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3242,'20170322','10:51:47','187.145.144.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3243,'20170322','10:59:05','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3244,'20170322','11:14:35','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3245,'20170322','11:23:47','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3246,'20170322','11:30:51','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3247,'20170322','11:42:39','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3248,'20170322','11:43:36','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3249,'20170322','11:48:19','148.206.70.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3250,'20170322','11:53:42','132.248.208.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3251,'20170322','12:03:54','132.248.93.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3252,'20170322','12:11:08','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3253,'20170322','12:17:32','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3254,'20170322','12:23:38','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3255,'20170322','12:24:27','200.68.128.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3256,'20170322','12:44:04','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3257,'20170322','13:08:32','132.248.84.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3258,'20170322','13:27:46','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3259,'20170322','13:28:26','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3260,'20170322','13:39:31','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3261,'20170322','13:56:43','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3262,'20170322','14:03:43','201.144.18.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3263,'20170322','14:48:13','207.46.13.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3264,'20170322','15:08:25','132.248.90.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3265,'20170322','15:09:52','187.188.108.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3266,'20170322','15:33:51','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3267,'20170322','16:18:34','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3268,'20170322','16:19:45','187.207.189.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3269,'20170322','17:21:13','132.248.178.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3270,'20170322','17:31:35','132.248.103.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3271,'20170322','18:37:10','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3272,'20170322','19:38:42','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3273,'20170322','19:40:37','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3274,'20170322','20:18:10','187.171.31.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3275,'20170322','23:22:21','189.171.147.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3276,'20170323','00:26:44','189.134.90.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3277,'20170323','07:11:10','189.146.159.219');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3278,'20170323','08:48:11','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3279,'20170323','08:54:08','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3280,'20170323','08:55:50','200.148.0.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3281,'20170323','09:11:56','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3282,'20170323','09:20:31','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3283,'20170323','09:24:33','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3284,'20170323','09:45:05','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3285,'20170323','09:47:56','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3286,'20170323','09:53:32','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3287,'20170323','10:10:15','189.141.224.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3288,'20170323','10:12:16','200.78.50.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3289,'20170323','10:14:30','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3290,'20170323','10:14:37','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3291,'20170323','10:43:24','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3292,'20170323','10:51:42','66.249.85.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3293,'20170323','11:16:38','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3294,'20170323','11:33:19','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3295,'20170323','11:50:05','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3296,'20170323','12:41:33','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3297,'20170323','12:58:00','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3298,'20170323','13:14:09','207.249.125.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3299,'20170323','13:20:56','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3300,'20170323','13:26:40','200.76.91.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3301,'20170323','13:38:22','189.190.154.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3302,'20170323','13:40:31','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3303,'20170323','13:46:33','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3304,'20170323','13:46:34','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3305,'20170323','13:46:35','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3306,'20170323','13:46:36','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3307,'20170323','13:46:36','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3308,'20170323','13:46:42','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3309,'20170323','13:46:47','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3310,'20170323','13:52:08','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3311,'20170323','14:00:42','148.245.48.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3312,'20170323','14:02:56','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3313,'20170323','14:03:36','132.247.74.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3314,'20170323','14:03:48','187.237.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3315,'20170323','14:04:29','187.237.14.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3316,'20170323','14:16:35','201.137.123.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3317,'20170323','14:16:46','201.137.151.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3318,'20170323','14:22:07','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3319,'20170323','14:32:20','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3320,'20170323','14:57:09','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3321,'20170323','14:57:22','134.249.120.217');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3322,'20170323','15:13:04','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3323,'20170323','15:24:39','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3324,'20170323','15:50:09','132.248.199.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3325,'20170323','16:25:52','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3326,'20170323','16:55:35','169.57.7.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3327,'20170323','17:01:35','201.168.129.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3328,'20170323','17:26:34','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3329,'20170323','17:42:58','201.137.160.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3330,'20170323','17:46:39','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3331,'20170323','17:48:12','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3332,'20170323','18:03:46','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3333,'20170323','19:03:39','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3334,'20170323','19:13:01','132.248.87.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3335,'20170323','19:21:02','180.76.15.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3336,'20170323','19:27:58','132.247.113.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3337,'20170323','19:34:34','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3338,'20170323','20:44:52','200.33.232.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3339,'20170323','22:06:25','187.199.43.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3340,'20170323','22:06:55','189.230.104.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3341,'20170324','00:03:16','189.216.190.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3342,'20170324','08:47:44','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3343,'20170324','08:51:11','132.248.181.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3344,'20170324','08:58:07','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3345,'20170324','09:19:52','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3346,'20170324','09:25:20','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3347,'20170324','09:36:19','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3348,'20170324','09:41:40','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3349,'20170324','09:49:06','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3349,'20170324','09:49:06','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3349,'20170324','09:49:06','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3352,'20170324','09:51:09','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3353,'20170324','09:53:17','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3354,'20170324','10:19:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3354,'20170324','10:19:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3354,'20170324','10:19:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3354,'20170324','10:19:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3355,'20170324','10:19:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3359,'20170324','10:34:04','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3360,'20170324','10:34:32','200.95.44.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3361,'20170324','10:37:06','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3362,'20170324','10:44:41','177.234.2.118');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3363,'20170324','10:56:34','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3364,'20170324','11:02:48','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3365,'20170324','11:11:03','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3366,'20170324','11:19:53','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3367,'20170324','11:51:55','187.190.155.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3368,'20170324','11:54:31','189.135.215.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3369,'20170324','12:05:45','201.124.55.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3370,'20170324','12:13:32','200.38.124.71');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3371,'20170324','12:21:40','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3372,'20170324','12:29:49','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3373,'20170324','12:31:25','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3374,'20170324','13:05:46','187.162.103.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3375,'20170324','13:05:46','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3376,'20170324','13:26:21','132.248.102.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3377,'20170324','13:27:04','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3378,'20170324','13:28:03','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3379,'20170324','13:30:57','132.254.101.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3380,'20170324','13:39:01','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3381,'20170324','14:01:27','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3382,'20170324','14:35:46','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3383,'20170324','15:25:04','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3384,'20170324','16:26:56','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3385,'20170324','17:18:45','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3386,'20170324','17:20:26','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3387,'20170324','17:30:05','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3388,'20170324','18:21:04','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3389,'20170324','18:43:09','132.248.103.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3390,'20170324','20:01:18','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3391,'20170324','22:10:42','154.68.60.219');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3392,'20170325','02:19:09','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3393,'20170325','04:00:29','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3394,'20170325','09:12:16','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3395,'20170325','09:28:05','37.110.33.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3396,'20170325','09:50:44','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3397,'20170325','10:56:56','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3398,'20170325','11:51:41','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3399,'20170325','12:21:59','188.243.168.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3400,'20170325','12:22:22','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3401,'20170325','13:34:22','189.241.246.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3402,'20170325','15:15:40','189.216.207.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3403,'20170325','20:52:30','168.235.205.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3404,'20170326','00:22:51','157.55.39.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3405,'20170326','02:45:53','66.249.79.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3406,'20170326','10:17:17','200.78.1.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3407,'20170326','11:54:16','201.130.60.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3408,'20170326','14:08:54','201.141.97.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3409,'20170326','15:23:01','187.189.92.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3410,'20170326','17:57:52','189.216.183.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3411,'20170326','19:23:08','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3412,'20170326','21:40:14','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3413,'20170326','22:55:22','54.211.79.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3414,'20170327','01:25:16','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3415,'20170327','03:12:34','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3416,'20170327','06:55:08','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3417,'20170327','08:45:45','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3418,'20170327','08:48:31','177.234.2.118');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3419,'20170327','08:52:33','132.248.50.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3420,'20170327','09:12:51','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3421,'20170327','09:12:56','212.170.52.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3422,'20170327','09:33:38','217.114.233.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3423,'20170327','09:56:08','132.248.67.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3424,'20170327','09:56:30','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3425,'20170327','09:57:09','187.213.126.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3426,'20170327','10:00:00','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3427,'20170327','10:04:27','5.188.211.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3428,'20170327','10:06:19','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3429,'20170327','10:19:55','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3430,'20170327','10:30:42','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3431,'20170327','10:31:59','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3432,'20170327','10:52:44','187.217.106.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3433,'20170327','10:53:02','132.248.129.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3434,'20170327','11:05:08','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3435,'20170327','11:05:10','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3436,'20170327','11:11:34','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3437,'20170327','11:14:23','132.248.9.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3438,'20170327','11:24:44','132.248.178.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3439,'20170327','11:31:03','132.247.162.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3440,'20170327','11:34:09','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3441,'20170327','11:49:32','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3442,'20170327','11:50:18','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3443,'20170327','11:52:08','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3444,'20170327','11:53:17','132.247.74.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3445,'20170327','11:58:25','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3446,'20170327','12:05:56','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3447,'20170327','12:17:06','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3448,'20170327','12:23:53','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3449,'20170327','12:33:17','132.248.150.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3450,'20170327','12:36:21','132.248.92.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3451,'20170327','12:37:43','132.248.229.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3452,'20170327','12:47:28','189.216.181.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3453,'20170327','13:05:32','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3454,'20170327','13:10:17','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3455,'20170327','13:42:03','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3456,'20170327','13:48:39','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3457,'20170327','13:50:55','189.202.233.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3458,'20170327','13:58:21','199.67.131.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3459,'20170327','14:08:32','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3460,'20170327','14:08:46','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3461,'20170327','14:16:46','132.248.218.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3462,'20170327','14:30:11','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3463,'20170327','14:42:15','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3464,'20170327','14:46:14','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3465,'20170327','14:50:37','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3466,'20170327','15:21:31','187.227.116.255');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3467,'20170327','15:25:45','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3468,'20170327','15:56:00','187.253.120.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3469,'20170327','16:06:36','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3470,'20170327','16:39:11','132.248.67.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3471,'20170327','16:44:12','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3472,'20170327','16:49:22','201.124.128.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3473,'20170327','17:22:14','189.228.201.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3474,'20170327','17:47:49','39.40.253.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3475,'20170327','18:02:32','132.248.229.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3476,'20170327','18:17:02','132.248.112.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3477,'20170327','18:40:48','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3478,'20170327','18:45:01','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3479,'20170327','18:49:45','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3480,'20170327','18:54:36','187.168.24.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3481,'20170327','20:02:39','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3482,'20170327','23:08:16','189.217.58.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3483,'20170328','00:11:36','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3484,'20170328','00:14:06','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3485,'20170328','01:37:56','189.216.197.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3486,'20170328','03:54:56','109.207.83.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3487,'20170328','04:51:12','190.60.88.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3488,'20170328','07:26:12','37.144.45.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3489,'20170328','07:47:16','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3490,'20170328','08:57:52','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3491,'20170328','08:59:42','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3492,'20170328','09:02:13','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3493,'20170328','09:12:34','189.202.227.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3494,'20170328','09:34:43','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3495,'20170328','09:41:30','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3496,'20170328','10:07:57','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3497,'20170328','10:11:22','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3498,'20170328','10:12:02','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3499,'20170328','10:19:54','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3500,'20170328','10:25:43','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3501,'20170328','10:28:18','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3502,'20170328','10:34:16','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3503,'20170328','10:41:04','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3504,'20170328','10:48:35','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3505,'20170328','10:52:41','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3506,'20170328','10:53:40','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3507,'20170328','11:00:59','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3508,'20170328','11:13:40','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3509,'20170328','11:17:44','177.234.2.118');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3510,'20170328','11:18:37','132.248.103.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3511,'20170328','11:38:35','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3512,'20170328','11:39:16','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3513,'20170328','11:41:57','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3514,'20170328','11:42:54','189.216.180.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3515,'20170328','12:05:14','132.248.218.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3516,'20170328','12:05:46','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3517,'20170328','12:14:42','148.234.25.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3518,'20170328','12:23:14','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3519,'20170328','12:23:40','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3519,'20170328','12:23:40','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3519,'20170328','12:23:40','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3522,'20170328','12:27:38','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3523,'20170328','13:06:54','132.248.44.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3524,'20170328','13:18:56','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3525,'20170328','13:49:59','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3526,'20170328','13:53:47','128.210.106.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3527,'20170328','14:16:03','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3528,'20170328','14:18:27','132.248.132.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3529,'20170328','14:26:19','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3530,'20170328','14:48:23','132.248.102.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3531,'20170328','14:51:20','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3532,'20170328','14:51:20','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3533,'20170328','14:51:21','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3534,'20170328','14:51:21','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3535,'20170328','14:51:21','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3535,'20170328','14:51:22','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3537,'20170328','14:51:23','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3538,'20170328','14:54:04','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3539,'20170328','14:54:43','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3540,'20170328','15:18:22','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3541,'20170328','15:32:19','187.168.29.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3542,'20170328','15:45:40','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3543,'20170328','16:08:52','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3544,'20170328','16:51:38','64.233.172.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3545,'20170328','17:40:22','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3546,'20170328','17:58:09','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3547,'20170328','18:30:36','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3548,'20170328','18:45:41','187.234.212.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3549,'20170328','18:52:11','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3550,'20170328','18:59:11','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3551,'20170328','20:22:21','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3552,'20170328','21:45:46','189.216.99.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3553,'20170328','23:44:35','52.2.10.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3554,'20170329','05:50:56','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3555,'20170329','07:10:53','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3556,'20170329','07:56:21','188.244.46.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3557,'20170329','08:39:29','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3558,'20170329','08:54:55','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3559,'20170329','09:12:23','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3560,'20170329','09:54:37','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3561,'20170329','09:59:46','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3562,'20170329','10:20:33','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3563,'20170329','10:24:41','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3564,'20170329','10:39:31','132.248.218.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3565,'20170329','10:40:21','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3566,'20170329','10:50:14','132.248.74.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3567,'20170329','11:06:43','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3568,'20170329','11:19:03','66.102.6.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3569,'20170329','11:32:00','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3570,'20170329','11:43:18','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3571,'20170329','11:46:52','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3572,'20170329','11:56:24','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3573,'20170329','11:59:33','187.237.14.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3574,'20170329','12:00:05','187.237.14.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3575,'20170329','12:35:08','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3576,'20170329','13:03:34','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3577,'20170329','13:22:35','189.142.235.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3578,'20170329','13:31:15','132.248.110.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3579,'20170329','13:32:13','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3580,'20170329','13:48:20','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3581,'20170329','13:53:01','132.248.103.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3582,'20170329','14:01:32','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3583,'20170329','14:18:34','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3584,'20170329','14:19:24','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3585,'20170329','14:25:51','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3586,'20170329','14:30:13','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3587,'20170329','14:46:40','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3588,'20170329','15:01:24','91.121.209.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3589,'20170329','15:21:48','140.148.34.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3590,'20170329','15:26:52','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3591,'20170329','15:28:51','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3592,'20170329','16:00:57','54.172.241.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3593,'20170329','17:47:45','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3594,'20170329','17:49:34','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3595,'20170329','17:59:25','52.2.10.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3596,'20170329','19:16:09','66.102.7.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3597,'20170329','22:05:49','201.124.77.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3598,'20170329','23:32:01','189.203.174.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3599,'20170329','23:36:57','66.249.65.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3600,'20170330','06:56:18','95.28.194.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3601,'20170330','06:56:32','189.137.246.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3602,'20170330','08:34:22','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3603,'20170330','08:35:33','200.95.43.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3604,'20170330','08:39:45','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3605,'20170330','08:59:46','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3606,'20170330','09:01:57','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3607,'20170330','09:16:25','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3608,'20170330','09:41:11','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3609,'20170330','10:15:23','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3610,'20170330','10:17:33','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3611,'20170330','10:39:38','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3612,'20170330','10:50:12','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3613,'20170330','10:51:42','192.100.180.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3614,'20170330','10:53:57','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3615,'20170330','11:02:32','200.78.203.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3616,'20170330','11:05:16','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3617,'20170330','11:11:44','132.248.116.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3618,'20170330','11:30:37','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3619,'20170330','11:31:38','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3620,'20170330','11:35:43','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3621,'20170330','11:56:23','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3622,'20170330','11:59:59','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3623,'20170330','12:06:27','66.249.93.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3624,'20170330','12:16:11','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3625,'20170330','12:21:14','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3626,'20170330','12:36:23','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3627,'20170330','12:40:38','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3628,'20170330','12:54:00','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3629,'20170330','12:55:49','132.248.74.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3630,'20170330','12:58:13','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3631,'20170330','13:00:43','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3632,'20170330','13:02:03','201.117.1.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3633,'20170330','13:02:27','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3634,'20170330','13:07:21','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3635,'20170330','13:32:19','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3636,'20170330','13:34:16','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3637,'20170330','13:34:48','66.102.6.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3638,'20170330','13:42:18','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3639,'20170330','13:43:44','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3640,'20170330','13:46:52','5.188.211.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3641,'20170330','13:54:26','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3642,'20170330','13:58:00','132.248.9.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3643,'20170330','14:14:51','189.136.64.168');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3644,'20170330','14:30:16','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3645,'20170330','14:53:35','132.247.117.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3646,'20170330','14:55:14','189.206.35.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3647,'20170330','15:14:08','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3648,'20170330','15:16:16','140.148.34.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3649,'20170330','15:28:52','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3650,'20170330','15:39:43','132.248.9.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3651,'20170330','16:10:28','201.130.58.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3652,'20170330','16:17:20','192.100.180.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3653,'20170330','16:28:59','187.189.140.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3654,'20170330','16:44:43','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3655,'20170330','17:16:54','200.78.223.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3656,'20170330','17:29:00','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3657,'20170330','17:51:58','132.248.196.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3658,'20170330','18:18:54','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3659,'20170330','18:19:29','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3660,'20170330','18:52:53','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3661,'20170330','19:35:53','189.216.59.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3662,'20170330','19:41:14','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3663,'20170330','20:14:14','132.248.44.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3664,'20170330','20:27:03','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3665,'20170330','21:13:00','187.227.23.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3666,'20170330','21:32:39','189.137.162.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3667,'20170330','21:45:59','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3668,'20170330','21:48:53','189.136.119.168');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3669,'20170330','22:12:05','187.168.153.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3670,'20170330','22:25:42','177.226.118.195');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3671,'20170330','22:48:12','189.216.123.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3671,'20170330','22:48:12','189.216.123.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3673,'20170331','02:25:18','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3674,'20170331','04:03:25','37.145.10.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3675,'20170331','04:13:53','95.27.254.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3676,'20170331','05:36:59','157.55.39.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3677,'20170331','08:22:13','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3678,'20170331','08:35:41','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3679,'20170331','08:46:29','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3680,'20170331','08:51:06','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3681,'20170331','09:16:34','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3682,'20170331','09:38:05','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3683,'20170331','09:38:31','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3684,'20170331','09:49:21','189.136.82.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3685,'20170331','09:55:37','66.102.6.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3686,'20170331','09:59:59','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3687,'20170331','10:00:01','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3688,'20170331','10:02:04','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3689,'20170331','10:16:44','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3690,'20170331','10:26:21','177.234.34.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3691,'20170331','10:45:36','163.178.144.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3692,'20170331','11:21:07','132.248.143.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3693,'20170331','11:26:29','187.214.180.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3694,'20170331','11:26:51','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3695,'20170331','11:41:18','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3696,'20170331','11:41:52','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3697,'20170331','11:46:03','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3698,'20170331','11:48:44','132.248.164.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3699,'20170331','11:56:23','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3700,'20170331','12:43:51','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3701,'20170331','12:47:23','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3702,'20170331','13:00:40','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3703,'20170331','13:03:30','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3704,'20170331','13:09:39','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3705,'20170331','13:16:15','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3706,'20170331','13:31:08','201.137.181.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3707,'20170331','13:41:27','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3708,'20170331','13:42:54','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3709,'20170331','13:44:01','187.222.254.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3710,'20170331','14:18:33','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3711,'20170331','14:32:27','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3712,'20170331','14:43:49','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3713,'20170331','14:49:34','187.188.85.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3714,'20170331','15:09:29','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3715,'20170331','15:20:53','132.248.143.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3716,'20170331','15:38:18','132.247.162.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3717,'20170331','15:41:58','132.248.160.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3718,'20170331','15:44:59','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3719,'20170331','16:41:41','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3720,'20170331','16:50:31','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3721,'20170331','17:31:39','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3722,'20170331','17:59:21','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3723,'20170331','18:33:09','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3724,'20170331','18:37:37','187.168.225.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3725,'20170331','18:53:09','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3726,'20170331','18:56:58','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3727,'20170331','19:28:58','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3728,'20170331','19:46:19','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3729,'20170331','20:27:53','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3730,'20170331','23:48:37','187.234.179.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3731,'20170401','02:43:52','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3732,'20170401','04:25:02','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3733,'20170401','04:30:13','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3734,'20170401','10:56:15','189.216.181.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3735,'20170401','11:07:18','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3736,'20170401','13:07:32','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3737,'20170401','14:41:37','201.175.133.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3738,'20170401','14:50:18','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3739,'20170401','17:31:21','187.206.170.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3740,'20170401','19:28:15','201.124.136.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3741,'20170401','20:15:44','201.137.143.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3742,'20170402','00:05:04','187.194.104.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3743,'20170402','03:35:13','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3744,'20170402','05:10:52','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3745,'20170402','09:52:55','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3746,'20170402','10:20:17','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3747,'20170402','13:21:55','189.216.114.71');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3748,'20170402','15:10:04','201.137.126.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3749,'20170402','17:26:56','187.190.4.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3750,'20170402','18:14:32','187.207.248.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3751,'20170402','20:17:56','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3752,'20170402','20:54:19','189.225.74.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3753,'20170402','21:18:36','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3754,'20170402','22:54:06','189.249.71.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3755,'20170402','23:12:54','187.226.130.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3756,'20170403','01:40:35','189.239.202.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3757,'20170403','03:20:08','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3758,'20170403','08:12:06','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3759,'20170403','08:43:49','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3760,'20170403','08:58:15','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3761,'20170403','09:15:35','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3762,'20170403','09:33:55','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3763,'20170403','09:47:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3764,'20170403','09:57:25','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3765,'20170403','10:10:34','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3766,'20170403','10:21:00','200.95.86.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3767,'20170403','10:33:30','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3768,'20170403','10:59:48','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3769,'20170403','11:06:52','189.203.45.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3770,'20170403','11:09:32','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3771,'20170403','11:26:14','132.248.74.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3772,'20170403','11:30:27','201.124.77.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3773,'20170403','11:33:16','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3774,'20170403','11:41:02','132.248.44.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3775,'20170403','11:43:03','189.210.55.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3776,'20170403','11:51:45','132.248.9.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3777,'20170403','11:54:44','132.248.67.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3778,'20170403','11:59:39','200.57.117.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3779,'20170403','12:13:58','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3780,'20170403','12:16:28','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3781,'20170403','12:16:29','132.248.74.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3782,'20170403','12:16:38','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3783,'20170403','12:20:56','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3784,'20170403','12:43:02','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3785,'20170403','12:59:19','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3786,'20170403','13:10:59','187.168.164.45');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3787,'20170403','13:10:59','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3788,'20170403','13:14:28','132.248.9.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3789,'20170403','13:21:31','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3790,'20170403','13:58:22','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3791,'20170403','14:05:16','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3792,'20170403','14:05:19','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3793,'20170403','14:06:35','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3794,'20170403','14:08:34','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3795,'20170403','14:09:38','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3795,'20170403','14:09:38','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3797,'20170403','14:22:16','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3798,'20170403','14:36:33','187.226.246.127');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3799,'20170403','14:49:03','132.247.117.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3800,'20170403','15:58:57','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3801,'20170403','16:02:05','132.248.97.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3802,'20170403','16:39:28','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3803,'20170403','17:02:43','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3804,'20170403','17:39:30','187.168.252.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3805,'20170403','17:49:48','132.248.141.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3806,'20170403','18:39:45','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3807,'20170403','18:39:46','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3808,'20170403','18:44:01','200.33.101.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3809,'20170403','19:52:22','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3810,'20170403','22:20:57','187.223.51.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3811,'20170403','23:03:02','201.171.46.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3812,'20170404','04:49:00','66.249.75.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3813,'20170404','05:24:18','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3814,'20170404','07:25:28','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3815,'20170404','09:01:51','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3816,'20170404','09:02:48','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3817,'20170404','09:04:09','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3818,'20170404','09:11:46','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3819,'20170404','09:14:36','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3820,'20170404','09:28:38','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3821,'20170404','09:52:32','66.102.7.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3822,'20170404','09:53:10','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3823,'20170404','09:57:02','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3824,'20170404','09:57:22','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3825,'20170404','09:59:17','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3826,'20170404','10:02:32','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3827,'20170404','10:07:37','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3828,'20170404','10:11:22','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3829,'20170404','10:18:41','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3830,'20170404','10:31:49','132.248.44.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3831,'20170404','10:34:07','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3832,'20170404','10:41:35','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3833,'20170404','11:10:54','189.216.149.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3834,'20170404','11:16:45','132.247.162.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3835,'20170404','11:25:45','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3836,'20170404','11:35:49','187.142.11.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3837,'20170404','11:37:19','187.142.13.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3838,'20170404','11:48:52','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3839,'20170404','11:51:01','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3840,'20170404','11:53:08','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3841,'20170404','11:56:50','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3842,'20170404','11:57:43','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3843,'20170404','12:03:52','132.247.107.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3844,'20170404','12:11:05','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3845,'20170404','12:23:12','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3846,'20170404','12:26:54','132.248.51.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3847,'20170404','12:47:10','201.137.18.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3848,'20170404','12:48:25','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3849,'20170404','13:00:08','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3850,'20170404','13:14:11','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3851,'20170404','13:14:37','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3852,'20170404','13:20:58','132.248.60.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3853,'20170404','13:21:09','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3854,'20170404','13:35:14','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3855,'20170404','13:37:05','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3856,'20170404','13:43:12','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3857,'20170404','13:48:25','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3858,'20170404','14:05:50','189.216.180.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3859,'20170404','14:28:23','132.248.233.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3860,'20170404','14:44:53','187.190.155.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3861,'20170404','14:57:28','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3862,'20170404','15:02:47','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3863,'20170404','15:07:46','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3864,'20170404','15:56:55','66.249.65.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3865,'20170404','16:04:17','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3866,'20170404','16:15:05','179.97.96.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3867,'20170404','16:37:14','201.113.187.172');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3868,'20170404','16:37:42','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3869,'20170404','17:13:42','148.206.53.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3870,'20170404','17:22:54','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3871,'20170404','17:34:33','66.249.65.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3872,'20170404','17:41:50','132.248.248.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3873,'20170404','17:52:04','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3874,'20170404','17:55:33','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3875,'20170404','19:00:43','66.249.65.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3876,'20170404','19:02:08','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3877,'20170404','19:09:34','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3878,'20170404','19:57:35','200.68.128.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3879,'20170404','20:14:15','189.167.91.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3880,'20170404','22:50:33','187.189.240.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3881,'20170404','23:52:18','68.180.229.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3882,'20170405','00:40:18','66.102.6.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3883,'20170405','00:40:48','66.102.6.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3884,'20170405','01:14:35','66.249.65.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3885,'20170405','01:29:50','66.249.65.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3886,'20170405','02:12:12','189.216.149.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3887,'20170405','04:56:39','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3888,'20170405','05:12:09','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3889,'20170405','08:37:04','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3890,'20170405','08:45:48','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3891,'20170405','08:52:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3892,'20170405','08:55:04','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3893,'20170405','09:04:49','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3894,'20170405','09:07:08','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3895,'20170405','09:17:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3896,'20170405','09:40:06','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3897,'20170405','09:48:48','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3898,'20170405','09:55:22','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3899,'20170405','10:06:17','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3900,'20170405','10:11:18','132.247.82.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3901,'20170405','10:30:25','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3902,'20170405','10:31:13','200.95.169.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3903,'20170405','10:44:18','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3904,'20170405','10:53:36','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3905,'20170405','10:56:17','187.227.107.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3906,'20170405','11:03:09','132.248.218.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3907,'20170405','11:13:40','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3908,'20170405','11:15:13','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3909,'20170405','11:16:36','201.159.133.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3910,'20170405','11:19:13','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3911,'20170405','11:21:19','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3912,'20170405','11:27:25','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3913,'20170405','11:28:05','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3914,'20170405','11:41:16','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3915,'20170405','11:49:31','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3916,'20170405','11:54:14','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3917,'20170405','12:04:01','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3918,'20170405','12:17:13','189.216.182.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3919,'20170405','12:26:36','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3920,'20170405','12:28:27','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3921,'20170405','12:49:34','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3922,'20170405','13:22:24','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3923,'20170405','13:29:05','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3924,'20170405','14:15:39','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3925,'20170405','14:17:54','201.122.77.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3926,'20170405','14:30:54','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3927,'20170405','14:41:43','201.124.58.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3928,'20170405','14:41:59','132.247.113.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3929,'20170405','15:08:50','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3930,'20170405','15:13:18','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3931,'20170405','15:14:19','132.248.67.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3932,'20170405','15:28:53','187.216.136.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3933,'20170405','15:50:00','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3934,'20170405','15:52:47','187.151.38.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3935,'20170405','17:03:17','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3936,'20170405','17:11:39','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3937,'20170405','17:41:37','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3938,'20170405','19:23:30','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3939,'20170405','19:40:55','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3940,'20170405','19:52:01','200.68.128.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3941,'20170405','20:06:58','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3942,'20170405','21:57:41','189.216.205.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3943,'20170405','22:48:37','189.245.183.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3944,'20170406','00:56:42','201.119.163.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3945,'20170406','02:40:38','189.217.187.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3946,'20170406','03:30:14','66.249.66.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3947,'20170406','06:12:43','66.249.66.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3948,'20170406','08:52:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3949,'20170406','08:59:05','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3950,'20170406','08:59:23','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3951,'20170406','09:01:44','66.249.66.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3952,'20170406','09:07:21','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3953,'20170406','09:09:00','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3954,'20170406','09:24:19','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3955,'20170406','10:04:50','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3956,'20170406','10:04:55','189.228.246.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3957,'20170406','10:39:54','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3958,'20170406','10:43:55','66.102.6.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3959,'20170406','11:06:20','217.114.229.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3960,'20170406','11:06:35','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3961,'20170406','11:12:33','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3962,'20170406','11:21:09','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3963,'20170406','11:29:17','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3964,'20170406','11:38:13','187.207.145.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3965,'20170406','12:05:08','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3966,'20170406','12:09:41','132.248.35.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3967,'20170406','12:33:39','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3968,'20170406','12:33:55','148.205.120.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3969,'20170406','12:34:47','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3970,'20170406','13:02:05','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3971,'20170406','13:20:38','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3972,'20170406','13:26:03','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3973,'20170406','13:27:46','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3974,'20170406','13:40:30','132.247.131.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3975,'20170406','13:51:43','132.248.132.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3976,'20170406','14:04:48','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3977,'20170406','14:20:35','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3978,'20170406','14:24:14','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3979,'20170406','14:30:22','189.207.170.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3980,'20170406','14:36:53','132.248.86.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3981,'20170406','14:38:28','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3982,'20170406','14:40:41','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3983,'20170406','15:03:59','66.249.65.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3984,'20170406','15:27:27','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3985,'20170406','15:41:43','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3986,'20170406','17:41:06','132.248.100.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3987,'20170406','17:44:04','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3988,'20170406','17:44:35','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3989,'20170406','17:45:44','201.124.58.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3990,'20170406','17:59:29','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3991,'20170406','18:08:47','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3992,'20170406','18:46:14','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3993,'20170406','18:51:00','201.130.58.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3994,'20170406','19:13:41','132.248.174.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3995,'20170406','19:20:55','189.216.51.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3996,'20170406','19:25:57','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3997,'20170406','19:38:39','148.231.64.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3998,'20170406','19:40:38','187.207.183.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (3999,'20170406','19:47:50','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4000,'20170406','20:54:20','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4001,'20170406','20:59:19','187.222.140.225');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4002,'20170406','21:05:34','189.216.197.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4003,'20170406','21:53:17','189.203.174.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4004,'20170406','23:15:41','189.137.232.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4005,'20170407','04:38:32','187.190.148.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4006,'20170407','05:07:41','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4007,'20170407','05:45:18','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4008,'20170407','07:18:44','66.249.65.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4009,'20170407','09:00:38','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4010,'20170407','09:04:28','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4011,'20170407','09:09:22','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4012,'20170407','09:13:17','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4013,'20170407','10:01:05','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4014,'20170407','10:04:01','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4015,'20170407','10:25:49','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4016,'20170407','10:37:07','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4017,'20170407','10:41:15','132.248.16.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4018,'20170407','10:44:29','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4019,'20170407','11:08:21','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4020,'20170407','11:12:00','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4021,'20170407','11:19:53','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4022,'20170407','11:34:18','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4023,'20170407','11:58:24','132.248.74.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4024,'20170407','12:06:12','132.248.61.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4025,'20170407','12:13:41','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4026,'20170407','12:19:44','148.206.53.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4027,'20170407','12:46:45','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4028,'20170407','13:28:36','66.102.6.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4029,'20170407','13:39:49','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4030,'20170407','14:15:30','132.248.9.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4031,'20170407','14:33:54','132.247.113.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4032,'20170407','14:46:28','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4033,'20170407','14:57:05','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4034,'20170407','15:12:51','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4035,'20170407','15:34:28','201.174.75.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4036,'20170407','15:36:39','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4037,'20170407','15:54:35','187.237.231.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4038,'20170407','15:54:35','187.210.189.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4039,'20170407','16:12:49','187.199.85.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4040,'20170407','16:31:45','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4041,'20170407','16:52:45','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4042,'20170407','17:02:15','132.248.248.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4043,'20170407','17:17:07','189.216.58.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4044,'20170407','17:30:55','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4045,'20170407','18:14:02','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4046,'20170407','20:06:08','187.198.217.195');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4047,'20170407','20:44:34','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4048,'20170407','20:44:57','187.168.145.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4049,'20170407','21:20:21','189.242.195.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4050,'20170407','23:10:32','189.137.232.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4051,'20170408','02:59:24','176.195.124.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4052,'20170408','09:16:58','52.3.105.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4053,'20170408','09:35:35','189.216.49.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4054,'20170408','09:36:37','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4055,'20170408','09:43:47','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4056,'20170408','12:09:08','187.254.145.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4057,'20170408','12:55:16','66.102.6.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4058,'20170408','12:58:28','187.237.231.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4059,'20170408','13:44:01','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4060,'20170408','15:17:30','200.33.20.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4061,'20170408','20:03:55','66.249.75.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4062,'20170409','00:40:28','189.216.151.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4063,'20170409','06:12:07','180.76.15.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4064,'20170409','07:48:24','79.165.185.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4065,'20170409','11:21:12','187.221.111.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4066,'20170409','11:30:42','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4067,'20170409','12:27:32','164.132.161.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4068,'20170409','16:21:48','189.228.237.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4069,'20170409','17:10:14','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4070,'20170410','10:08:10','176.195.107.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4071,'20170410','10:21:04','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4072,'20170410','11:27:39','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4073,'20170410','11:36:46','177.234.2.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4074,'20170410','12:19:29','201.157.89.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4075,'20170410','12:31:22','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4076,'20170410','13:08:53','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4077,'20170410','13:45:56','189.216.58.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4078,'20170410','14:37:41','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4079,'20170411','10:01:16','132.248.9.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4080,'20170411','10:16:31','180.76.15.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4081,'20170411','10:38:32','187.135.41.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4082,'20170411','11:32:11','180.76.15.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4083,'20170411','12:02:02','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4084,'20170411','12:06:16','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4085,'20170411','12:11:09','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4086,'20170411','12:13:11','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4087,'20170411','13:21:42','201.103.0.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4088,'20170411','13:55:53','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4089,'20170411','14:19:45','66.102.6.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4090,'20170411','14:32:21','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4091,'20170411','14:48:58','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4092,'20170411','15:21:52','189.216.150.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4093,'20170411','18:42:13','189.217.65.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4094,'20170411','18:58:11','201.119.58.59');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4095,'20170411','19:38:12','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4096,'20170411','21:02:27','201.137.226.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4097,'20170411','23:51:12','201.141.177.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4098,'20170412','00:23:36','68.180.229.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4099,'20170412','00:31:26','189.217.210.117');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4100,'20170412','03:22:14','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4101,'20170412','07:15:29','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4102,'20170412','07:31:01','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4103,'20170412','08:03:15','180.76.15.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4104,'20170412','10:53:48','148.211.129.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4105,'20170412','11:09:05','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4106,'20170412','11:30:04','201.103.0.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4107,'20170412','12:08:14','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4108,'20170412','12:32:23','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4109,'20170412','12:33:11','66.249.66.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4110,'20170412','13:14:21','180.76.15.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4111,'20170412','13:35:17','40.77.167.71');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4112,'20170412','13:37:00','189.202.233.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4113,'20170412','15:45:15','189.228.84.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4114,'20170412','16:12:38','189.191.69.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4115,'20170412','16:33:51','132.248.182.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4116,'20170412','17:08:27','187.214.237.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4117,'20170412','17:58:27','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4118,'20170412','19:43:54','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4119,'20170412','23:04:52','187.190.4.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4120,'20170413','00:45:11','66.102.6.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4121,'20170413','00:45:29','66.102.6.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4122,'20170413','00:45:37','66.102.6.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4123,'20170413','05:10:20','95.221.231.255');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4124,'20170413','07:23:30','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4125,'20170413','07:38:03','66.249.66.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4126,'20170413','08:49:15','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4127,'20170413','09:07:29','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4128,'20170413','12:22:24','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4129,'20170413','13:43:06','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4130,'20170413','16:16:18','187.190.167.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4131,'20170413','16:42:53','200.76.91.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4132,'20170413','18:23:25','180.76.15.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4133,'20170413','18:53:53','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4134,'20170413','19:49:15','180.76.15.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4135,'20170414','03:11:09','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4136,'20170414','12:55:25','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4137,'20170414','13:04:50','200.68.128.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4138,'20170414','13:05:13','187.237.231.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4139,'20170414','13:42:46','189.216.148.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4140,'20170414','15:27:58','187.221.56.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4141,'20170414','17:52:12','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4142,'20170414','20:11:53','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4143,'20170414','20:12:33','66.249.66.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4144,'20170414','20:22:36','52.2.10.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4145,'20170415','00:34:26','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4146,'20170415','01:13:40','187.214.224.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4147,'20170415','05:23:28','115.178.237.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4148,'20170415','10:51:34','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4149,'20170415','12:11:11','180.76.15.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4150,'20170415','13:12:43','132.248.67.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4151,'20170415','13:30:37','66.249.66.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4152,'20170415','14:18:50','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4153,'20170415','14:36:35','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4154,'20170415','16:14:38','132.248.67.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4155,'20170415','18:15:45','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4156,'20170415','19:07:11','187.226.79.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4157,'20170415','21:31:19','200.76.91.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4158,'20170415','23:22:11','66.102.6.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4159,'20170416','00:25:19','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4160,'20170416','01:50:39','200.76.83.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4161,'20170416','10:34:01','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4162,'20170416','10:54:48','177.247.122.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4163,'20170416','11:12:18','189.230.191.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4164,'20170416','14:19:39','187.207.202.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4165,'20170416','16:30:22','180.76.15.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4166,'20170416','20:16:38','66.102.6.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4167,'20170416','21:14:28','189.136.198.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4168,'20170416','21:21:29','200.78.184.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4169,'20170417','08:57:29','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4170,'20170417','09:20:56','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4171,'20170417','09:30:08','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4172,'20170417','09:34:16','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4173,'20170417','09:36:50','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4174,'20170417','09:55:29','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4175,'20170417','09:57:59','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4176,'20170417','10:04:59','180.76.15.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4177,'20170417','10:08:13','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4178,'20170417','10:11:26','132.247.162.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4179,'20170417','10:16:24','180.76.15.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4180,'20170417','10:27:36','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4181,'20170417','10:41:09','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4182,'20170417','11:06:42','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4183,'20170417','11:08:32','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4184,'20170417','11:13:00','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4185,'20170417','11:15:11','66.102.6.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4186,'20170417','11:18:39','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4187,'20170417','11:25:03','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4188,'20170417','11:25:27','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4189,'20170417','11:51:03','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4190,'20170417','11:56:32','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4191,'20170417','12:09:55','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4192,'20170417','12:17:32','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4193,'20170417','12:18:00','132.248.224.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4194,'20170417','12:23:47','132.248.79.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4195,'20170417','12:30:07','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4196,'20170417','12:56:24','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4197,'20170417','13:07:32','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4198,'20170417','13:09:53','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4199,'20170417','13:23:42','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4200,'20170417','13:55:34','132.248.216.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4201,'20170417','13:58:39','132.248.251.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4202,'20170417','13:59:50','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4203,'20170417','14:43:55','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4204,'20170417','15:10:28','189.136.28.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4205,'20170417','15:17:45','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4205,'20170417','15:17:45','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4207,'20170417','15:30:19','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4208,'20170417','15:40:13','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4209,'20170417','15:45:35','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4210,'20170417','16:37:05','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4211,'20170417','16:54:12','132.248.182.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4212,'20170417','16:55:54','140.148.34.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4213,'20170417','16:58:49','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4214,'20170417','17:31:33','66.102.6.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4215,'20170417','17:56:09','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4216,'20170417','18:13:44','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4217,'20170417','18:28:17','201.106.127.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4218,'20170417','18:47:51','132.247.113.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4219,'20170417','19:27:17','189.146.56.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4220,'20170417','19:45:24','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4221,'20170417','20:53:25','187.187.207.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4222,'20170417','22:47:47','189.216.204.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4223,'20170418','00:40:24','187.207.219.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4224,'20170418','05:56:17','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4225,'20170418','08:53:21','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4226,'20170418','09:00:43','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4227,'20170418','09:29:16','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4228,'20170418','09:37:43','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4229,'20170418','09:38:52','187.190.15.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4230,'20170418','09:48:10','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4231,'20170418','09:56:52','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4232,'20170418','10:01:39','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4233,'20170418','10:06:45','189.245.46.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4234,'20170418','10:12:17','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4235,'20170418','10:22:22','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4236,'20170418','10:24:21','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4237,'20170418','10:28:32','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4238,'20170418','10:32:27','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4239,'20170418','10:33:11','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4240,'20170418','10:36:07','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4241,'20170418','10:51:24','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4242,'20170418','10:56:53','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4243,'20170418','11:09:41','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4244,'20170418','11:14:05','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4245,'20170418','11:16:06','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4246,'20170418','11:16:19','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4247,'20170418','11:41:10','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4248,'20170418','11:52:47','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4249,'20170418','11:57:46','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4250,'20170418','11:58:02','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4251,'20170418','12:00:28','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4252,'20170418','12:03:30','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4253,'20170418','12:17:12','132.247.149.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4254,'20170418','12:34:22','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4255,'20170418','12:36:47','187.168.238.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4256,'20170418','12:37:00','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4257,'20170418','12:55:33','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4258,'20170418','13:15:51','132.247.198.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4259,'20170418','13:44:20','201.157.89.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4260,'20170418','13:48:31','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4261,'20170418','13:49:26','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4262,'20170418','14:06:23','132.248.116.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4263,'20170418','14:19:56','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4264,'20170418','14:51:14','201.103.93.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4265,'20170418','15:15:23','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4266,'20170418','15:19:33','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4267,'20170418','15:26:05','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4268,'20170418','15:48:34','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4269,'20170418','15:57:11','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4270,'20170418','16:21:51','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4271,'20170418','16:53:25','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4272,'20170418','16:54:43','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4273,'20170418','17:01:49','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4274,'20170418','17:19:17','66.249.69.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4275,'20170418','17:33:33','201.114.98.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4276,'20170418','17:39:55','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4277,'20170418','17:43:46','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4278,'20170418','17:44:03','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4279,'20170418','18:08:10','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4280,'20170418','18:31:29','132.248.182.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4281,'20170418','18:59:21','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4281,'20170418','18:59:21','189.203.188.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4283,'20170418','19:21:42','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4284,'20170418','20:18:40','189.216.198.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4285,'20170418','20:24:03','189.140.141.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4286,'20170418','22:14:42','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4287,'20170418','23:07:32','189.147.138.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4288,'20170418','23:55:19','189.216.206.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4289,'20170419','00:16:27','66.249.69.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4290,'20170419','00:45:13','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4291,'20170419','00:51:05','189.170.4.116');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4292,'20170419','01:30:03','52.2.10.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4293,'20170419','08:32:55','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4294,'20170419','08:56:46','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4295,'20170419','09:00:46','63.243.252.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4296,'20170419','09:02:44','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4297,'20170419','10:07:04','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4298,'20170419','10:25:07','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4299,'20170419','10:29:23','148.226.210.239');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4300,'20170419','10:32:06','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4301,'20170419','10:40:43','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4302,'20170419','10:56:07','201.103.93.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4303,'20170419','11:07:19','132.248.143.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4304,'20170419','11:08:33','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4305,'20170419','11:08:35','201.122.222.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4306,'20170419','11:22:51','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4307,'20170419','11:29:13','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4308,'20170419','11:44:39','132.248.110.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4309,'20170419','12:10:33','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4310,'20170419','12:10:58','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4311,'20170419','12:15:38','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4311,'20170419','12:15:38','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4313,'20170419','12:15:41','132.248.17.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4314,'20170419','12:21:39','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4315,'20170419','12:26:03','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4316,'20170419','12:47:40','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4317,'20170419','12:52:05','132.247.107.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4318,'20170419','12:52:54','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4319,'20170419','13:18:52','132.248.67.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4320,'20170419','13:28:27','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4321,'20170419','13:49:38','66.249.85.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4322,'20170419','13:58:17','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4323,'20170419','14:05:41','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4324,'20170419','14:08:28','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4325,'20170419','15:06:18','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4326,'20170419','15:07:22','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4327,'20170419','15:57:51','132.248.228.127');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4328,'20170419','16:03:27','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4329,'20170419','17:08:19','189.225.180.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4330,'20170419','17:10:22','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4331,'20170419','17:43:04','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4332,'20170419','19:41:38','200.52.255.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4333,'20170419','19:46:27','132.248.98.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4334,'20170419','20:04:32','185.182.81.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4334,'20170419','20:04:32','185.182.81.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4336,'20170419','20:15:43','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4337,'20170419','22:01:15','190.217.55.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4338,'20170420','00:24:11','187.168.241.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4339,'20170420','01:06:34','187.254.146.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4340,'20170420','01:33:28','189.166.88.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4341,'20170420','08:08:01','180.76.15.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4342,'20170420','08:59:40','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4343,'20170420','09:00:44','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4344,'20170420','09:24:20','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4345,'20170420','10:04:53','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4346,'20170420','10:31:44','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4347,'20170420','10:45:38','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4348,'20170420','10:48:56','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4349,'20170420','10:52:26','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4350,'20170420','11:05:31','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4351,'20170420','11:11:59','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4352,'20170420','11:21:54','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4353,'20170420','11:26:28','132.248.209.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4354,'20170420','11:46:03','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4355,'20170420','12:23:06','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4356,'20170420','12:28:41','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4357,'20170420','12:32:03','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4358,'20170420','12:34:38','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4359,'20170420','12:40:53','201.114.229.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4360,'20170420','12:41:03','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4361,'20170420','12:45:26','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4362,'20170420','12:46:24','187.246.35.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4363,'20170420','12:55:49','189.136.217.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4364,'20170420','13:00:55','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4365,'20170420','13:04:10','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4366,'20170420','13:04:46','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4367,'20170420','13:24:18','132.248.159.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4368,'20170420','13:32:53','132.247.105.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4369,'20170420','13:38:06','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4370,'20170420','13:45:10','201.99.139.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4371,'20170420','13:45:13','201.130.60.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4372,'20170420','14:04:59','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4373,'20170420','14:19:58','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4374,'20170420','14:20:40','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4375,'20170420','14:28:05','187.237.231.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4376,'20170420','14:28:26','200.68.128.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4377,'20170420','14:32:51','189.216.114.225');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4378,'20170420','14:40:09','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4379,'20170420','14:43:07','132.248.208.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4380,'20170420','14:53:18','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4381,'20170420','15:31:55','132.248.51.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4382,'20170420','15:56:48','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4383,'20170420','16:11:38','148.206.130.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4384,'20170420','16:17:19','132.248.97.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4385,'20170420','16:54:29','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4386,'20170420','16:54:53','132.248.9.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4387,'20170420','16:55:08','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4388,'20170420','17:21:54','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4389,'20170420','17:46:13','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4390,'20170420','17:56:35','35.184.109.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4391,'20170420','18:18:16','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4392,'20170420','18:26:32','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4393,'20170420','18:47:33','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4394,'20170420','19:11:20','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4395,'20170420','19:38:27','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4396,'20170421','00:36:36','187.224.89.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4397,'20170421','00:56:51','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4398,'20170421','05:55:53','180.76.15.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4399,'20170421','07:16:46','180.76.15.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4400,'20170421','08:12:09','189.146.112.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4401,'20170421','08:45:12','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4402,'20170421','08:46:34','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4403,'20170421','08:49:26','201.114.229.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4404,'20170421','08:52:20','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4405,'20170421','08:58:06','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4406,'20170421','09:59:51','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4407,'20170421','10:12:08','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4408,'20170421','10:16:46','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4409,'20170421','10:25:07','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4410,'20170421','10:41:51','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4411,'20170421','10:42:48','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4412,'20170421','10:44:02','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4413,'20170421','11:40:38','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4414,'20170421','11:57:08','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4415,'20170421','12:03:46','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4416,'20170421','12:27:04','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4417,'20170421','12:32:05','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4418,'20170421','12:49:26','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4419,'20170421','12:55:22','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4420,'20170421','13:06:13','189.216.158.204');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4421,'20170421','13:16:18','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4422,'20170421','13:31:55','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4423,'20170421','13:50:40','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4424,'20170421','14:28:15','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4425,'20170421','15:08:21','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4426,'20170421','15:16:08','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4427,'20170421','15:28:49','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4428,'20170421','17:19:57','148.244.136.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4429,'20170421','17:23:20','201.103.93.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4430,'20170421','17:26:31','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4431,'20170421','18:18:41','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4432,'20170421','18:26:06','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4433,'20170421','18:48:27','187.188.82.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4434,'20170421','19:04:01','148.223.228.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4435,'20170421','19:04:21','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4436,'20170421','19:15:36','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4437,'20170421','19:32:13','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4438,'20170421','20:58:09','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4439,'20170421','22:00:31','187.220.171.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4440,'20170421','22:18:24','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4441,'20170421','23:37:46','66.249.66.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4442,'20170422','00:32:53','189.147.68.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4443,'20170422','03:06:31','180.76.15.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4444,'20170422','06:38:04','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4445,'20170422','10:25:09','187.223.201.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4446,'20170422','11:17:50','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4447,'20170422','12:10:26','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4448,'20170422','12:25:57','180.76.15.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4449,'20170422','14:17:28','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4450,'20170422','15:06:04','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4451,'20170422','15:11:41','189.222.131.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4452,'20170422','17:24:37','187.178.230.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4453,'20170422','17:27:04','187.190.159.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4454,'20170422','18:33:17','201.141.108.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4455,'20170422','19:53:47','189.216.199.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4456,'20170422','21:18:09','201.141.100.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4457,'20170422','23:28:40','180.76.15.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4458,'20170423','00:46:45','177.238.108.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4459,'20170423','05:22:29','188.32.29.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4460,'20170423','08:42:35','180.76.15.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4461,'20170423','09:00:22','187.140.141.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4462,'20170423','11:03:02','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4463,'20170423','14:03:57','187.214.208.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4464,'20170423','15:04:48','201.141.111.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4465,'20170423','15:56:21','189.232.72.79');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4466,'20170423','16:26:55','187.150.227.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4467,'20170423','17:12:24','189.216.148.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4468,'20170423','17:56:37','180.76.15.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4469,'20170423','18:41:28','189.226.95.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4470,'20170423','20:35:24','187.221.140.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4471,'20170423','21:24:42','187.145.215.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4472,'20170423','21:59:20','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4473,'20170423','22:42:06','54.159.123.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4474,'20170423','23:38:09','189.216.197.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4475,'20170424','00:23:13','189.217.224.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4476,'20170424','02:08:09','66.249.73.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4477,'20170424','05:24:11','201.137.122.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4478,'20170424','07:33:39','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4479,'20170424','07:51:55','180.76.15.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4480,'20170424','08:33:56','132.248.86.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4481,'20170424','08:48:12','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4482,'20170424','08:49:07','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4483,'20170424','09:26:17','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4484,'20170424','10:05:32','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4485,'20170424','10:16:40','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4486,'20170424','10:17:45','189.216.197.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4487,'20170424','10:25:48','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4488,'20170424','10:28:52','189.216.157.204');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4489,'20170424','10:53:18','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4490,'20170424','10:54:47','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4491,'20170424','11:05:22','201.137.229.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4492,'20170424','11:09:39','201.103.93.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4493,'20170424','11:35:41','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4494,'20170424','11:58:19','132.248.242.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4495,'20170424','12:00:45','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4496,'20170424','12:23:01','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4497,'20170424','12:23:19','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4498,'20170424','12:33:35','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4499,'20170424','12:49:14','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4500,'20170424','12:53:23','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4501,'20170424','13:19:49','200.125.234.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4502,'20170424','13:28:33','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4503,'20170424','13:59:18','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4504,'20170424','14:06:42','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4505,'20170424','14:26:55','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4506,'20170424','14:27:13','148.237.74.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4507,'20170424','14:36:24','189.216.180.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4508,'20170424','14:42:04','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4508,'20170424','14:42:04','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4510,'20170424','15:03:17','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4511,'20170424','15:12:40','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4512,'20170424','15:12:43','201.166.188.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4513,'20170424','15:17:50','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4514,'20170424','15:27:38','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4515,'20170424','15:31:18','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4516,'20170424','15:34:13','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4517,'20170424','16:14:45','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4518,'20170424','16:34:17','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4519,'20170424','16:36:42','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4520,'20170424','17:20:13','187.224.111.192');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4521,'20170424','17:21:25','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4522,'20170424','17:22:05','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4523,'20170424','18:17:59','132.248.170.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4524,'20170424','18:18:39','132.248.159.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4525,'20170424','19:00:22','189.144.40.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4526,'20170424','20:39:24','132.248.98.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4527,'20170424','22:00:55','64.233.172.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4528,'20170425','02:28:00','95.211.190.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4529,'20170425','03:15:21','83.217.214.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4530,'20170425','07:33:54','69.196.253.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4531,'20170425','08:06:10','128.255.53.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4532,'20170425','08:38:49','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4533,'20170425','09:00:05','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4534,'20170425','09:15:54','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4535,'20170425','09:24:35','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4536,'20170425','09:27:48','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4537,'20170425','09:30:47','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4538,'20170425','09:32:13','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4539,'20170425','09:35:35','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4540,'20170425','09:42:27','180.76.15.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4541,'20170425','09:46:38','201.103.95.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4542,'20170425','09:53:37','132.248.9.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4543,'20170425','10:00:00','189.216.156.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4544,'20170425','10:04:47','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4545,'20170425','10:12:04','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4546,'20170425','10:23:42','189.137.207.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4547,'20170425','10:37:58','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4548,'20170425','10:51:22','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4549,'20170425','11:01:54','180.76.15.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4550,'20170425','11:08:16','140.234.255.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4551,'20170425','11:08:53','132.248.16.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4552,'20170425','11:14:25','148.206.128.67');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4553,'20170425','11:17:08','132.248.82.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4554,'20170425','11:19:40','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4554,'20170425','11:19:40','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4556,'20170425','11:29:45','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4557,'20170425','11:39:14','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4558,'20170425','11:50:08','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4559,'20170425','12:41:22','187.190.21.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4560,'20170425','12:45:36','189.211.8.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4561,'20170425','12:59:10','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4562,'20170425','13:01:02','46.42.165.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4563,'20170425','13:18:08','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4564,'20170425','13:28:20','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4565,'20170425','13:44:11','132.248.229.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4566,'20170425','14:05:12','187.145.151.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4567,'20170425','14:30:16','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4568,'20170425','14:43:09','200.48.248.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4569,'20170425','14:48:16','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4570,'20170425','14:49:12','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4571,'20170425','14:52:44','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4572,'20170425','14:56:26','132.248.1.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4573,'20170425','15:06:16','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4574,'20170425','15:14:52','140.148.78.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4575,'20170425','15:19:56','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4576,'20170425','15:24:46','132.248.103.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4577,'20170425','15:26:45','187.237.14.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4578,'20170425','15:27:03','187.237.14.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4579,'20170425','16:24:37','187.188.82.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4580,'20170425','17:38:27','194.187.170.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4581,'20170425','17:57:53','132.248.99.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4582,'20170425','18:09:27','132.247.24.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4582,'20170425','18:09:27','132.247.24.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4584,'20170425','19:22:06','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4585,'20170425','19:34:18','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4586,'20170425','19:34:59','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4587,'20170425','19:59:57','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4588,'20170425','20:14:28','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4589,'20170425','20:25:53','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4590,'20170425','22:00:22','104.154.58.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4591,'20170426','02:17:20','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4592,'20170426','03:38:27','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4593,'20170426','05:08:02','189.136.154.255');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4594,'20170426','05:18:42','180.76.15.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4595,'20170426','08:04:20','163.172.71.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4596,'20170426','08:04:21','200.123.133.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4597,'20170426','08:40:09','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4598,'20170426','08:45:43','167.56.207.53');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4599,'20170426','08:53:24','180.76.15.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4600,'20170426','09:13:43','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4601,'20170426','09:16:54','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4602,'20170426','09:32:45','64.233.172.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4603,'20170426','09:32:57','64.233.172.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4604,'20170426','09:53:59','132.247.82.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4605,'20170426','09:53:59','132.247.82.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4606,'20170426','09:54:01','132.247.82.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4607,'20170426','09:54:04','132.247.82.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4608,'20170426','09:54:09','132.247.82.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4609,'20170426','09:54:10','132.247.82.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4610,'20170426','09:54:17','132.247.82.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4611,'20170426','09:54:18','132.247.82.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4612,'20170426','09:57:41','189.216.159.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4613,'20170426','10:15:53','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4614,'20170426','10:19:47','148.204.151.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4615,'20170426','10:26:52','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4616,'20170426','10:31:19','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4617,'20170426','11:05:04','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4618,'20170426','11:07:46','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4619,'20170426','11:10:20','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4620,'20170426','11:32:54','187.190.166.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4621,'20170426','11:40:42','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4622,'20170426','11:41:48','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4623,'20170426','11:44:17','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4624,'20170426','11:50:43','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4625,'20170426','12:01:20','189.202.40.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4626,'20170426','12:12:47','148.247.69.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4627,'20170426','12:16:32','173.163.10.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4628,'20170426','12:20:44','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4629,'20170426','12:39:24','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4630,'20170426','12:45:45','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4631,'20170426','12:51:09','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4632,'20170426','13:08:00','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4633,'20170426','13:12:26','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4634,'20170426','13:54:32','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4635,'20170426','13:55:08','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4636,'20170426','14:23:13','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4637,'20170426','14:41:39','140.148.78.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4638,'20170426','14:49:02','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4639,'20170426','15:02:34','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4640,'20170426','15:08:09','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4641,'20170426','15:43:49','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4642,'20170426','16:17:28','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4642,'20170426','16:17:28','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4644,'20170426','16:17:29','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4645,'20170426','16:17:31','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4645,'20170426','16:17:31','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4647,'20170426','16:17:32','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4647,'20170426','16:17:32','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4649,'20170426','16:17:36','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4650,'20170426','16:57:54','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4651,'20170426','17:10:45','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4652,'20170426','19:17:40','201.157.108.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4653,'20170426','19:21:53','180.76.15.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4654,'20170426','19:41:03','180.76.15.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4655,'20170426','21:04:22','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4656,'20170426','21:56:55','52.4.48.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4657,'20170426','22:52:29','95.28.166.167');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4658,'20170426','23:59:51','189.232.104.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4659,'20170427','02:51:14','180.76.15.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4660,'20170427','03:34:38','200.48.248.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4661,'20170427','07:34:25','180.76.15.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4662,'20170427','08:03:33','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4663,'20170427','08:38:11','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4664,'20170427','09:01:55','34.207.98.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4665,'20170427','09:09:19','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4666,'20170427','09:19:51','189.216.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4667,'20170427','09:21:11','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4668,'20170427','09:25:09','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4669,'20170427','09:30:10','187.190.29.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4670,'20170427','09:40:18','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4671,'20170427','09:56:01','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4672,'20170427','09:58:26','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4673,'20170427','10:04:29','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4674,'20170427','10:20:31','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4675,'20170427','10:25:03','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4676,'20170427','10:29:31','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4677,'20170427','10:42:31','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4678,'20170427','10:57:30','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4678,'20170427','10:57:30','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4680,'20170427','11:44:08','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4681,'20170427','11:44:46','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4682,'20170427','11:45:41','148.247.69.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4683,'20170427','11:50:42','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4684,'20170427','12:01:17','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4685,'20170427','12:09:05','132.248.9.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4686,'20170427','12:19:47','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4687,'20170427','12:29:19','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4688,'20170427','12:33:34','180.76.15.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4689,'20170427','12:52:27','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4690,'20170427','12:53:22','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4691,'20170427','13:02:29','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4692,'20170427','13:15:39','148.230.10.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4693,'20170427','13:29:21','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4694,'20170427','13:39:45','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4695,'20170427','15:41:26','187.214.167.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4696,'20170427','15:51:22','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4697,'20170427','16:03:25','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4698,'20170427','16:26:04','189.240.99.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4699,'20170427','16:47:08','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4700,'20170427','17:28:40','189.216.157.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4701,'20170427','17:48:45','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4702,'20170427','17:50:51','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4703,'20170427','18:24:09','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4704,'20170427','18:41:35','201.113.184.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4705,'20170427','18:43:37','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4706,'20170427','18:54:07','132.248.122.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4707,'20170427','20:33:59','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4708,'20170427','20:42:41','189.203.232.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4709,'20170427','23:47:14','189.137.232.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4710,'20170428','08:30:46','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4711,'20170428','09:11:09','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4712,'20170428','09:12:47','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4713,'20170428','09:33:54','189.216.156.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4714,'20170428','09:35:13','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4714,'20170428','09:35:13','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4716,'20170428','09:42:00','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4717,'20170428','09:42:27','201.175.134.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4718,'20170428','10:07:17','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4719,'20170428','10:08:42','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4720,'20170428','10:15:04','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4721,'20170428','10:19:01','201.103.95.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4722,'20170428','10:53:41','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4723,'20170428','11:01:47','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4724,'20170428','11:06:12','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4725,'20170428','11:07:16','189.143.100.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4726,'20170428','11:19:02','187.190.28.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4727,'20170428','11:29:35','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4728,'20170428','11:50:43','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4729,'20170428','11:53:24','189.216.207.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4730,'20170428','12:00:46','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4731,'20170428','12:02:01','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4732,'20170428','12:09:25','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4733,'20170428','12:20:04','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4734,'20170428','12:27:53','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4735,'20170428','12:38:02','132.248.242.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4736,'20170428','12:55:40','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4737,'20170428','12:56:45','132.248.9.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4738,'20170428','13:06:39','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4739,'20170428','13:19:54','180.76.15.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4740,'20170428','13:35:18','66.102.6.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4741,'20170428','13:53:07','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4742,'20170428','14:13:07','187.207.196.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4743,'20170428','14:14:28','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4744,'20170428','14:15:53','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4745,'20170428','14:32:48','189.189.109.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4746,'20170428','14:38:12','132.248.193.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4747,'20170428','14:41:09','189.216.205.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4748,'20170428','14:45:32','187.237.41.35');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4749,'20170428','14:45:57','200.79.20.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4750,'20170428','15:26:41','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4751,'20170428','15:34:34','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4752,'20170428','15:56:00','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4753,'20170428','16:01:17','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4754,'20170428','16:03:44','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4755,'20170428','19:07:28','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4756,'20170428','23:21:55','34.207.98.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4757,'20170429','02:08:44','200.76.91.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4758,'20170429','05:06:06','157.55.39.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4759,'20170429','07:50:28','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4760,'20170429','08:04:26','89.178.92.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4761,'20170429','09:59:39','187.214.143.0');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4762,'20170429','10:21:59','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4763,'20170429','11:14:41','180.76.15.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4764,'20170429','11:38:39','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4765,'20170429','15:38:27','189.215.232.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4766,'20170429','18:08:55','189.253.153.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4767,'20170429','21:08:38','187.253.124.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4768,'20170430','09:41:40','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4769,'20170430','11:08:37','187.225.252.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4770,'20170430','15:57:21','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4771,'20170430','16:53:26','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4772,'20170430','17:25:12','148.251.126.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4773,'20170430','20:05:36','187.207.221.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4774,'20170501','00:25:51','180.76.15.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4775,'20170501','02:16:33','69.196.253.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4776,'20170501','02:45:59','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4777,'20170501','04:14:06','180.76.15.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4778,'20170501','06:52:00','180.76.15.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4779,'20170501','08:05:00','189.242.131.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4780,'20170501','09:57:24','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4781,'20170501','10:08:31','68.180.228.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4782,'20170501','11:20:23','66.249.73.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4783,'20170501','15:22:23','180.76.15.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4784,'20170501','19:48:22','189.215.227.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4785,'20170501','23:11:04','187.190.20.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4786,'20170502','01:12:53','66.249.75.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4787,'20170502','08:49:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4788,'20170502','09:03:15','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4789,'20170502','09:11:56','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4790,'20170502','09:33:19','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4791,'20170502','09:58:35','40.77.167.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4792,'20170502','09:59:52','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4793,'20170502','10:20:31','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4794,'20170502','10:24:36','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4795,'20170502','10:45:03','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4796,'20170502','10:46:37','132.248.9.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4797,'20170502','10:54:55','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4798,'20170502','11:01:47','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4799,'20170502','11:10:28','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4800,'20170502','11:21:10','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4801,'20170502','11:26:04','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4802,'20170502','11:28:17','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4803,'20170502','11:36:48','189.216.158.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4804,'20170502','11:38:08','187.189.93.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4805,'20170502','11:40:23','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4806,'20170502','11:47:31','148.218.99.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4807,'20170502','11:51:05','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4808,'20170502','12:00:46','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4809,'20170502','12:01:35','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4810,'20170502','12:05:30','189.137.227.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4811,'20170502','12:11:25','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4812,'20170502','12:30:43','132.248.150.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4813,'20170502','12:33:54','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4814,'20170502','12:40:36','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4815,'20170502','12:41:30','187.190.26.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4816,'20170502','13:00:43','132.248.37.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4817,'20170502','13:42:17','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4818,'20170502','14:08:54','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4819,'20170502','14:25:37','163.172.71.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4820,'20170502','15:07:54','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4821,'20170502','15:22:49','201.153.121.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4822,'20170502','15:49:04','132.248.143.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4823,'20170502','16:10:01','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4824,'20170502','16:17:50','189.216.196.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4825,'20170502','16:25:35','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4826,'20170502','17:24:55','178.197.224.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4827,'20170502','17:51:00','187.199.201.203');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4828,'20170502','18:11:04','189.216.149.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4829,'20170502','18:25:02','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4830,'20170502','18:37:34','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4831,'20170502','18:45:46','180.76.15.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4832,'20170502','20:08:15','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4833,'20170502','21:03:54','189.216.107.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4834,'20170502','22:56:33','68.180.228.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4835,'20170503','00:01:43','189.173.92.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4836,'20170503','07:52:22','81.33.219.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4837,'20170503','07:54:34','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4838,'20170503','08:36:28','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4839,'20170503','08:44:56','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4840,'20170503','08:45:10','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4841,'20170503','09:03:18','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4842,'20170503','09:47:39','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4843,'20170503','09:48:28','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4844,'20170503','09:51:38','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4845,'20170503','09:59:23','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4846,'20170503','10:07:16','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4847,'20170503','10:10:43','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4848,'20170503','10:16:47','201.147.98.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4849,'20170503','10:23:21','187.223.206.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4850,'20170503','10:25:17','132.248.95.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4851,'20170503','10:28:49','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4852,'20170503','10:45:10','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4853,'20170503','10:52:05','132.247.117.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4854,'20170503','11:02:34','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4855,'20170503','12:04:20','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4856,'20170503','12:11:30','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4857,'20170503','12:19:12','192.0.89.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4858,'20170503','12:19:13','192.0.91.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4858,'20170503','12:19:13','192.0.91.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4860,'20170503','12:19:21','192.0.91.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4861,'20170503','12:29:59','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4862,'20170503','12:32:52','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4863,'20170503','12:45:59','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4864,'20170503','13:03:08','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4865,'20170503','13:06:53','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4866,'20170503','13:08:33','189.216.158.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4867,'20170503','13:20:37','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4868,'20170503','13:22:26','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4869,'20170503','13:36:55','200.34.175.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4870,'20170503','13:40:03','132.248.9.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4871,'20170503','14:05:52','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4872,'20170503','14:07:39','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4873,'20170503','14:15:48','189.137.180.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4874,'20170503','14:31:31','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4875,'20170503','14:42:11','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4876,'20170503','14:51:54','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4877,'20170503','15:00:49','201.122.222.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4878,'20170503','15:15:05','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4879,'20170503','15:24:45','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4880,'20170503','16:07:32','187.189.102.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4881,'20170503','16:13:59','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4882,'20170503','16:23:24','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4883,'20170503','16:52:05','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4884,'20170503','17:03:48','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4885,'20170503','17:17:31','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4886,'20170503','18:26:48','189.216.182.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4887,'20170503','18:28:00','201.141.31.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4888,'20170503','18:42:42','201.103.95.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4889,'20170503','19:05:54','189.216.56.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4890,'20170503','19:08:14','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4891,'20170503','19:09:29','132.248.82.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4892,'20170503','19:12:49','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4893,'20170503','19:55:56','132.248.229.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4894,'20170503','20:01:58','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4895,'20170503','20:18:39','201.130.60.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4896,'20170503','20:21:29','132.248.141.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4897,'20170503','20:25:18','187.221.92.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4898,'20170503','20:46:08','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4899,'20170503','21:32:48','201.141.146.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4900,'20170503','22:24:46','180.76.15.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4901,'20170503','22:25:20','187.228.197.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4902,'20170503','22:41:21','187.222.254.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4903,'20170504','00:18:03','187.228.197.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4904,'20170504','01:32:59','66.249.73.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4905,'20170504','08:30:13','189.204.159.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4906,'20170504','08:36:11','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4907,'20170504','08:51:44','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4908,'20170504','09:11:51','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4909,'20170504','09:26:16','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4910,'20170504','09:28:01','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4911,'20170504','09:34:21','189.202.189.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4912,'20170504','09:43:52','187.237.231.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4913,'20170504','09:57:56','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4914,'20170504','10:04:03','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4915,'20170504','10:05:44','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4916,'20170504','10:12:38','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4917,'20170504','10:19:59','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4918,'20170504','10:47:28','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4919,'20170504','10:53:18','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4920,'20170504','11:03:46','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4921,'20170504','11:14:04','187.237.14.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4922,'20170504','11:19:30','200.57.115.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4923,'20170504','11:19:58','189.205.233.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4924,'20170504','11:39:55','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4925,'20170504','11:41:13','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4926,'20170504','11:42:33','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4927,'20170504','11:47:41','189.216.113.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4928,'20170504','11:56:03','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4929,'20170504','11:58:24','132.248.182.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4930,'20170504','12:03:29','189.216.183.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4931,'20170504','12:05:27','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4932,'20170504','12:19:14','132.248.182.92');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4933,'20170504','12:37:15','132.248.3.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4934,'20170504','12:52:02','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4935,'20170504','13:20:40','132.248.87.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4936,'20170504','13:32:21','168.255.251.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4937,'20170504','13:40:54','180.76.15.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4938,'20170504','13:43:33','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4939,'20170504','14:16:53','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4940,'20170504','14:17:13','132.248.242.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4941,'20170504','14:26:36','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4942,'20170504','14:48:49','180.76.15.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4943,'20170504','16:08:27','132.247.72.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4944,'20170504','16:39:19','180.76.15.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4945,'20170504','16:43:05','148.247.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4946,'20170504','16:44:23','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4947,'20170504','17:04:12','132.248.242.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4948,'20170504','17:14:56','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4949,'20170504','18:03:18','189.137.198.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4950,'20170504','20:43:36','35.184.189.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4951,'20170504','21:52:01','180.76.15.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4952,'20170505','03:35:06','194.187.170.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4953,'20170505','08:17:23','35.184.189.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4954,'20170505','08:27:20','68.180.228.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4955,'20170505','09:21:48','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4956,'20170505','09:38:22','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4957,'20170505','09:50:18','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4958,'20170505','10:25:10','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4959,'20170505','10:25:23','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4960,'20170505','10:39:37','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4961,'20170505','11:13:27','189.217.209.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4962,'20170505','11:27:22','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4963,'20170505','11:41:40','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4964,'20170505','11:44:34','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4965,'20170505','11:45:56','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4966,'20170505','11:49:12','132.248.102.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4967,'20170505','11:52:53','201.175.132.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4968,'20170505','12:00:21','132.247.159.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4969,'20170505','12:00:23','132.247.159.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4969,'20170505','12:00:23','132.247.159.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4971,'20170505','12:00:25','132.247.159.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4971,'20170505','12:00:25','132.247.159.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4973,'20170505','12:00:28','132.247.159.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4974,'20170505','12:00:29','132.247.159.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4975,'20170505','12:00:30','132.247.159.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4976,'20170505','12:00:37','132.247.159.180');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4977,'20170505','12:00:37','64.233.172.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4978,'20170505','12:00:45','132.247.159.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4979,'20170505','12:00:49','132.247.159.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4980,'20170505','12:00:55','64.233.172.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4981,'20170505','12:01:12','132.247.159.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4981,'20170505','12:01:12','132.247.159.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4983,'20170505','12:01:16','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4983,'20170505','12:01:16','132.247.159.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4985,'20170505','12:01:16','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4986,'20170505','12:01:21','132.247.159.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4987,'20170505','12:01:49','132.247.159.192');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4988,'20170505','12:01:58','132.247.159.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4989,'20170505','12:06:20','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4990,'20170505','12:30:37','189.216.158.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4991,'20170505','12:40:00','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4992,'20170505','12:48:52','148.205.120.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4993,'20170505','12:57:52','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4994,'20170505','13:03:30','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4995,'20170505','13:40:01','148.202.51.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4996,'20170505','14:13:42','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4997,'20170505','14:26:00','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4998,'20170505','14:29:08','201.103.200.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (4999,'20170505','14:30:11','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5000,'20170505','15:07:05','189.216.183.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5001,'20170505','15:32:38','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5002,'20170505','15:53:17','132.248.143.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5003,'20170505','17:23:13','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5004,'20170505','17:29:02','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5005,'20170505','18:12:30','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5006,'20170505','18:49:31','201.130.60.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5007,'20170505','19:16:12','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5008,'20170505','19:17:19','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5009,'20170505','19:25:44','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5010,'20170505','19:53:54','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5011,'20170505','19:54:00','180.76.15.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5012,'20170505','20:11:03','189.216.151.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5013,'20170505','20:11:05','187.227.17.0');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5014,'20170505','20:52:35','177.232.16.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5015,'20170505','21:14:20','187.199.78.212');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5016,'20170506','05:12:27','54.160.101.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5017,'20170506','09:30:00','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5018,'20170506','16:06:31','189.143.113.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5019,'20170506','16:19:12','95.211.190.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5020,'20170506','16:23:42','187.190.186.236');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5021,'20170506','16:45:34','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5022,'20170506','16:55:57','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5023,'20170507','01:18:48','180.76.15.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5024,'20170507','06:41:59','68.180.228.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5025,'20170507','09:33:03','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5026,'20170507','10:54:22','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5027,'20170507','11:35:57','189.216.148.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5028,'20170507','13:08:34','201.124.203.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5029,'20170507','21:02:28','66.249.79.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5030,'20170507','21:02:39','187.199.201.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5031,'20170508','00:03:08','177.229.145.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5032,'20170508','01:46:59','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5033,'20170508','01:47:00','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5034,'20170508','08:26:21','132.248.182.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5035,'20170508','08:44:23','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5036,'20170508','09:05:56','189.216.159.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5037,'20170508','09:23:50','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5038,'20170508','09:34:39','132.247.183.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5039,'20170508','09:47:15','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5040,'20170508','09:52:59','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5041,'20170508','09:59:29','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5042,'20170508','10:04:01','201.141.159.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5043,'20170508','10:10:54','132.248.67.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5044,'20170508','10:35:19','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5045,'20170508','10:44:48','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5046,'20170508','10:53:54','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5047,'20170508','10:58:57','201.99.139.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5048,'20170508','11:03:41','189.171.145.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5049,'20170508','11:10:33','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5050,'20170508','11:12:33','189.144.59.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5051,'20170508','11:33:32','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5052,'20170508','11:36:33','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5053,'20170508','11:38:09','132.248.242.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5054,'20170508','11:50:43','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5055,'20170508','11:54:14','201.103.0.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5056,'20170508','12:00:01','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5057,'20170508','12:05:08','132.248.242.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5058,'20170508','12:07:59','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5059,'20170508','12:14:35','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5060,'20170508','12:14:37','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5061,'20170508','12:14:38','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5062,'20170508','12:14:40','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5063,'20170508','12:14:41','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5064,'20170508','12:14:42','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5065,'20170508','12:14:43','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5065,'20170508','12:14:43','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5067,'20170508','12:14:44','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5068,'20170508','12:15:12','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5069,'20170508','12:26:05','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5070,'20170508','12:32:37','148.244.90.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5071,'20170508','12:34:16','148.247.69.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5072,'20170508','12:35:33','201.151.210.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5073,'20170508','13:03:54','189.216.198.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5074,'20170508','13:13:00','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5075,'20170508','13:15:43','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5076,'20170508','13:29:30','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5077,'20170508','13:39:41','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5078,'20170508','13:45:29','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5079,'20170508','13:48:16','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5080,'20170508','13:49:31','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5081,'20170508','13:49:47','189.216.196.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5082,'20170508','13:56:44','192.231.246.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5083,'20170508','14:03:28','187.163.166.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5084,'20170508','14:08:52','187.190.165.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5085,'20170508','14:14:29','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5086,'20170508','14:20:20','189.216.59.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5087,'20170508','14:39:56','132.248.229.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5088,'20170508','14:40:37','132.248.102.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5089,'20170508','15:09:47','189.216.181.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5090,'20170508','16:21:39','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5091,'20170508','16:32:52','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5092,'20170508','16:49:52','180.76.15.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5093,'20170508','18:06:13','180.76.15.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5094,'20170508','19:02:12','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5095,'20170508','19:08:06','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5096,'20170508','22:19:58','148.246.65.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5097,'20170508','23:19:56','64.233.172.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5098,'20170508','23:20:17','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5099,'20170508','23:21:02','64.233.172.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5100,'20170509','01:24:31','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5101,'20170509','01:25:42','201.103.126.245');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5102,'20170509','02:17:44','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5103,'20170509','03:18:07','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5104,'20170509','03:21:36','180.76.15.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5105,'20170509','08:39:51','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5106,'20170509','08:50:06','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5107,'20170509','09:02:42','132.248.67.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5108,'20170509','09:07:35','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5109,'20170509','09:16:21','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5110,'20170509','09:19:48','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5111,'20170509','09:21:42','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5112,'20170509','09:27:56','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5113,'20170509','09:45:38','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5114,'20170509','09:48:43','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5115,'20170509','09:50:17','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5116,'20170509','09:56:21','132.248.59.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5117,'20170509','10:01:09','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5118,'20170509','10:08:47','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5119,'20170509','10:33:38','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5120,'20170509','10:39:44','132.248.242.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5121,'20170509','10:55:42','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5122,'20170509','10:56:28','201.103.200.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5123,'20170509','11:06:41','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5124,'20170509','11:35:25','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5125,'20170509','11:36:02','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5126,'20170509','11:52:54','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5127,'20170509','11:53:19','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5128,'20170509','12:13:48','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5129,'20170509','12:16:34','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5130,'20170509','12:36:07','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5131,'20170509','12:38:24','200.37.4.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5132,'20170509','12:39:54','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5133,'20170509','12:49:10','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5134,'20170509','12:52:56','132.248.32.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5135,'20170509','12:57:29','200.68.128.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5136,'20170509','13:14:21','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5137,'20170509','13:14:36','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5138,'20170509','13:22:20','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5139,'20170509','13:27:52','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5140,'20170509','13:42:20','132.248.233.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5141,'20170509','13:42:34','189.216.183.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5142,'20170509','13:43:13','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5143,'20170509','13:56:05','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5144,'20170509','14:02:11','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5145,'20170509','14:23:53','132.248.242.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5146,'20170509','14:37:11','189.216.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5147,'20170509','14:50:28','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5148,'20170509','14:51:55','132.248.67.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5149,'20170509','15:18:30','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5150,'20170509','15:22:10','201.103.0.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5151,'20170509','15:38:56','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5152,'20170509','15:53:44','163.172.71.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5153,'20170509','16:59:00','189.171.145.194');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5154,'20170509','17:16:53','132.248.233.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5155,'20170509','17:26:46','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5156,'20170509','17:33:17','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5157,'20170509','17:36:51','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5158,'20170509','17:45:06','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5159,'20170509','17:51:25','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5160,'20170509','19:06:10','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5161,'20170509','21:07:13','189.249.153.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5162,'20170509','23:09:53','187.227.3.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5163,'20170510','00:11:34','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5164,'20170510','03:33:17','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5165,'20170510','06:47:36','180.76.15.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5166,'20170510','10:36:22','180.76.15.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5167,'20170510','10:43:31','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5168,'20170510','11:46:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5169,'20170510','12:52:20','189.137.181.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5170,'20170510','13:24:00','148.240.167.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5171,'20170510','14:12:06','187.168.11.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5172,'20170510','15:41:24','180.76.15.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5173,'20170510','16:33:03','187.169.36.35');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5174,'20170510','17:57:23','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5175,'20170510','19:04:46','180.76.15.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5176,'20170510','22:00:53','201.102.112.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5177,'20170511','00:58:59','121.125.221.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5178,'20170511','06:19:40','35.184.189.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5179,'20170511','08:28:34','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5180,'20170511','08:50:53','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5181,'20170511','08:57:51','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5182,'20170511','08:58:21','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5183,'20170511','09:24:21','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5184,'20170511','09:40:25','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5185,'20170511','09:42:10','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5186,'20170511','10:09:56','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5187,'20170511','10:18:14','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5188,'20170511','10:21:05','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5189,'20170511','10:22:47','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5190,'20170511','10:24:45','132.248.89.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5191,'20170511','11:01:11','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5192,'20170511','11:16:28','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5193,'20170511','11:38:49','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5194,'20170511','11:57:45','189.216.180.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5195,'20170511','12:01:02','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5196,'20170511','12:06:52','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5197,'20170511','12:12:32','148.247.69.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5198,'20170511','12:17:34','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5199,'20170511','12:21:26','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5200,'20170511','12:22:38','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5201,'20170511','12:24:30','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5202,'20170511','12:42:58','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5203,'20170511','13:16:00','132.248.182.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5204,'20170511','13:22:18','206.221.145.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5205,'20170511','13:23:34','201.114.248.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5206,'20170511','13:31:43','132.248.76.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5207,'20170511','13:43:51','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5208,'20170511','13:44:27','148.206.91.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5209,'20170511','13:53:08','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5210,'20170511','14:02:53','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5211,'20170511','14:16:21','201.122.222.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5212,'20170511','14:18:10','132.248.224.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5213,'20170511','14:25:02','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5214,'20170511','14:39:34','132.248.9.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5215,'20170511','15:26:37','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5216,'20170511','16:18:24','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5217,'20170511','16:31:23','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5218,'20170511','16:45:32','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5219,'20170511','17:01:07','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5220,'20170511','17:12:18','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5221,'20170511','17:52:02','189.216.150.127');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5222,'20170511','17:52:47','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5223,'20170511','17:54:07','132.248.99.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5224,'20170511','18:00:14','132.248.213.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5225,'20170511','18:47:23','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5226,'20170511','18:49:09','187.154.212.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5227,'20170511','18:56:25','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5228,'20170511','19:31:32','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5229,'20170512','01:17:34','165.255.212.117');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5230,'20170512','03:31:10','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5231,'20170512','03:49:40','194.153.113.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5232,'20170512','05:54:37','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5233,'20170512','06:30:03','187.254.146.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5234,'20170512','08:48:59','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5235,'20170512','08:57:42','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5236,'20170512','09:26:09','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5237,'20170512','09:27:10','201.110.156.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5238,'20170512','09:37:14','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5239,'20170512','09:39:40','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5240,'20170512','09:42:26','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5241,'20170512','09:42:58','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5242,'20170512','09:57:41','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5243,'20170512','09:59:59','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5244,'20170512','10:20:28','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5245,'20170512','10:24:25','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5246,'20170512','10:27:11','63.243.252.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5247,'20170512','10:53:36','148.240.197.94');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5248,'20170512','11:05:34','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5249,'20170512','11:09:41','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5250,'20170512','11:15:35','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5250,'20170512','11:15:35','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5252,'20170512','11:17:54','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5253,'20170512','11:18:07','187.227.177.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5254,'20170512','11:19:19','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5255,'20170512','11:58:59','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5256,'20170512','12:02:54','132.248.9.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5257,'20170512','12:15:18','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5258,'20170512','12:26:52','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5259,'20170512','12:36:28','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5260,'20170512','12:52:11','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5261,'20170512','12:59:01','148.205.120.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5262,'20170512','13:12:50','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5263,'20170512','13:29:47','189.191.104.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5264,'20170512','13:37:12','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5265,'20170512','13:59:14','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5266,'20170512','14:33:00','189.216.158.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5267,'20170512','14:53:37','189.206.212.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5268,'20170512','14:58:16','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5269,'20170512','15:12:32','189.179.118.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5270,'20170512','15:26:20','200.76.91.167');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5271,'20170512','16:41:49','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5272,'20170512','17:13:03','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5273,'20170512','17:29:12','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5274,'20170512','17:37:04','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5275,'20170512','18:21:35','132.247.149.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5276,'20170512','19:03:06','148.205.120.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5277,'20170512','20:08:47','180.76.15.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5278,'20170512','20:15:59','132.248.90.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5279,'20170512','21:10:01','187.214.243.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5280,'20170512','22:05:36','64.233.172.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5281,'20170512','22:49:35','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5282,'20170513','03:24:47','180.76.15.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5283,'20170513','03:51:56','2.92.35.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5284,'20170513','06:47:37','180.76.15.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5285,'20170513','07:48:03','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5286,'20170513','09:06:50','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5287,'20170513','10:10:33','189.216.199.75');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5288,'20170513','12:07:41','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5289,'20170513','15:35:47','180.76.15.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5290,'20170514','02:47:44','5.188.211.35');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5291,'20170514','08:22:05','207.46.13.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5292,'20170514','09:06:31','180.76.15.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5293,'20170514','11:58:02','66.249.69.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5294,'20170514','12:47:13','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5295,'20170514','13:47:37','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5296,'20170514','16:03:18','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5297,'20170514','16:58:22','66.249.69.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5298,'20170514','18:23:03','180.76.15.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5299,'20170514','19:11:37','66.249.84.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5300,'20170514','21:37:22','201.166.190.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5301,'20170514','22:13:18','187.200.141.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5302,'20170514','22:54:43','187.169.52.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5303,'20170515','00:54:55','66.249.69.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5304,'20170515','02:28:40','189.58.203.107');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5305,'20170515','02:34:01','180.76.15.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5306,'20170515','05:41:52','51.255.65.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5307,'20170515','06:28:31','66.249.69.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5308,'20170515','07:05:50','180.76.15.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5309,'20170515','09:46:25','189.136.67.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5310,'20170515','09:47:54','189.216.199.239');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5311,'20170515','10:23:54','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5312,'20170515','10:26:07','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5313,'20170515','11:27:20','189.233.133.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5314,'20170515','13:33:29','66.249.69.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5315,'20170515','14:03:40','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5316,'20170515','14:28:21','187.188.80.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5317,'20170515','14:43:05','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5318,'20170515','17:15:15','148.240.65.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5319,'20170515','18:38:55','187.214.176.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5320,'20170515','19:29:05','187.207.0.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5321,'20170515','20:08:41','189.216.98.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5322,'20170515','21:16:47','189.242.38.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5323,'20170515','22:15:32','180.76.15.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5324,'20170516','07:27:31','207.46.13.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5325,'20170516','08:37:55','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5326,'20170516','08:51:25','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5327,'20170516','09:00:20','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5328,'20170516','09:07:16','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5329,'20170516','09:41:20','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5329,'20170516','09:41:20','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5331,'20170516','09:43:54','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5332,'20170516','09:54:56','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5333,'20170516','10:09:45','132.248.25.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5334,'20170516','10:10:14','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5335,'20170516','10:15:54','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5336,'20170516','10:31:40','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5337,'20170516','10:35:49','148.206.53.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5338,'20170516','10:38:25','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5339,'20170516','10:41:39','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5340,'20170516','10:44:51','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5341,'20170516','10:45:57','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5342,'20170516','10:57:52','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5343,'20170516','11:01:28','187.168.88.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5344,'20170516','11:02:02','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5345,'20170516','11:23:49','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5346,'20170516','11:25:22','187.214.228.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5347,'20170516','11:25:57','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5348,'20170516','11:34:44','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5349,'20170516','11:54:24','132.248.116.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5350,'20170516','12:08:20','132.248.79.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5351,'20170516','12:10:39','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5352,'20170516','12:11:37','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5353,'20170516','12:20:20','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5354,'20170516','12:49:44','132.248.103.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5355,'20170516','12:50:31','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5356,'20170516','12:54:20','132.248.3.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5357,'20170516','13:14:04','187.159.112.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5358,'20170516','13:44:20','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5359,'20170516','13:52:57','78.49.161.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5360,'20170516','14:04:56','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5361,'20170516','14:06:08','132.248.67.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5362,'20170516','14:39:27','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5363,'20170516','14:44:40','132.248.204.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5364,'20170516','15:27:49','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5365,'20170516','17:23:07','132.247.110.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5366,'20170516','17:47:30','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5367,'20170516','18:07:17','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5368,'20170516','18:16:43','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5369,'20170516','18:22:47','187.190.155.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5370,'20170516','18:46:37','132.247.149.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5371,'20170516','18:59:49','187.176.24.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5372,'20170516','19:13:51','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5373,'20170516','19:50:25','132.248.180.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5374,'20170516','21:21:16','189.217.207.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5375,'20170516','21:47:41','187.145.172.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5376,'20170516','22:11:54','180.76.15.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5377,'20170516','23:57:44','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5378,'20170517','00:12:55','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5379,'20170517','00:29:25','180.76.15.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5380,'20170517','00:38:05','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5381,'20170517','00:39:28','187.169.6.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5382,'20170517','00:45:41','187.170.206.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5383,'20170517','01:01:12','187.220.123.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5384,'20170517','01:22:44','64.233.172.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5385,'20170517','01:23:14','64.233.172.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5386,'20170517','01:23:16','187.190.26.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5387,'20170517','02:35:14','180.76.15.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5388,'20170517','02:39:59','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5389,'20170517','05:15:23','5.188.211.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5390,'20170517','07:38:32','201.119.243.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5391,'20170517','08:36:00','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5392,'20170517','08:55:24','64.233.172.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5393,'20170517','09:04:53','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5394,'20170517','09:15:28','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5395,'20170517','09:48:56','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5396,'20170517','10:10:16','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5397,'20170517','10:13:55','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5398,'20170517','10:15:56','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5399,'20170517','10:42:24','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5400,'20170517','10:51:02','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5401,'20170517','10:58:37','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5402,'20170517','11:08:40','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5403,'20170517','11:14:07','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5404,'20170517','11:14:46','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5405,'20170517','11:23:00','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5406,'20170517','11:24:29','132.248.9.84');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5407,'20170517','11:29:29','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5408,'20170517','11:34:40','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5409,'20170517','11:43:06','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5410,'20170517','11:45:11','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5411,'20170517','11:54:06','200.6.239.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5412,'20170517','12:00:02','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5413,'20170517','12:06:58','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5414,'20170517','12:18:21','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5415,'20170517','12:38:12','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5415,'20170517','12:38:12','132.248.159.47');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5417,'20170517','12:48:14','189.249.168.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5418,'20170517','12:55:42','132.248.235.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5419,'20170517','13:09:07','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5420,'20170517','13:35:53','187.226.90.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5421,'20170517','13:59:48','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5422,'20170517','14:02:10','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5423,'20170517','14:17:57','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5424,'20170517','14:28:53','201.103.26.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5425,'20170517','14:33:37','201.137.165.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5426,'20170517','14:35:12','107.167.104.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5427,'20170517','14:47:08','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5428,'20170517','14:50:14','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5428,'20170517','14:50:14','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5430,'20170517','14:50:15','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5431,'20170517','14:50:16','132.248.123.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5432,'20170517','14:50:17','132.248.197.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5432,'20170517','14:50:17','132.248.197.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5432,'20170517','14:50:17','132.248.123.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5435,'20170517','14:50:18','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5436,'20170517','14:50:36','132.248.197.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5437,'20170517','14:50:57','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5438,'20170517','15:01:10','132.248.16.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5439,'20170517','15:24:17','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5440,'20170517','15:28:31','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5441,'20170517','16:06:09','132.247.148.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5442,'20170517','16:18:09','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5443,'20170517','16:24:04','132.248.67.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5444,'20170517','16:28:05','189.137.181.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5445,'20170517','16:32:35','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5446,'20170517','17:05:32','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5447,'20170517','17:23:13','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5448,'20170517','18:00:31','187.227.169.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5449,'20170517','18:09:03','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5450,'20170517','18:18:31','187.207.17.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5451,'20170517','18:24:21','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5452,'20170517','19:00:40','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5453,'20170517','20:22:10','189.216.114.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5454,'20170517','20:25:47','187.234.253.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5455,'20170517','21:25:11','189.217.191.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5456,'20170517','21:28:49','189.137.153.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5457,'20170518','01:33:20','189.216.157.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5458,'20170518','04:56:55','207.46.13.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5459,'20170518','06:08:04','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5460,'20170518','07:06:41','148.204.155.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5461,'20170518','07:52:27','201.106.112.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5462,'20170518','08:45:02','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5463,'20170518','08:57:54','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5464,'20170518','09:00:16','189.217.211.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5465,'20170518','09:05:53','180.76.15.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5466,'20170518','09:25:33','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5467,'20170518','09:27:24','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5468,'20170518','09:29:16','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5469,'20170518','09:37:43','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5470,'20170518','09:37:53','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5471,'20170518','09:39:52','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5472,'20170518','09:47:41','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5473,'20170518','10:06:53','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5474,'20170518','10:12:16','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5475,'20170518','10:25:13','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5476,'20170518','10:28:32','148.247.69.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5477,'20170518','10:34:01','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5478,'20170518','11:05:44','132.248.103.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5479,'20170518','11:07:36','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5480,'20170518','11:10:04','201.114.186.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5481,'20170518','11:33:34','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5482,'20170518','11:35:52','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5483,'20170518','11:36:05','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5484,'20170518','11:39:34','187.169.239.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5485,'20170518','11:43:41','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5486,'20170518','11:50:10','132.248.237.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5487,'20170518','11:50:34','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5488,'20170518','11:57:55','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5489,'20170518','12:05:17','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5490,'20170518','12:07:18','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5491,'20170518','12:10:32','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5492,'20170518','12:25:05','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5493,'20170518','12:38:56','180.76.15.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5494,'20170518','12:53:24','148.205.120.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5495,'20170518','12:55:28','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5496,'20170518','12:59:23','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5497,'20170518','13:01:05','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5498,'20170518','13:13:57','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5499,'20170518','13:27:01','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5500,'20170518','13:28:32','180.76.15.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5501,'20170518','13:56:37','148.206.91.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5502,'20170518','14:08:13','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5503,'20170518','14:28:28','200.33.30.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5504,'20170518','14:28:57','201.158.189.66');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5505,'20170518','14:35:34','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5506,'20170518','14:48:01','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5507,'20170518','15:00:08','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5508,'20170518','15:12:22','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5509,'20170518','15:37:42','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5510,'20170518','15:42:55','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5511,'20170518','16:00:44','151.182.60.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5512,'20170518','16:23:39','132.248.228.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5513,'20170518','17:06:09','181.30.66.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5514,'20170518','17:24:23','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5515,'20170518','17:33:06','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5516,'20170518','17:36:09','192.100.201.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5517,'20170518','18:02:57','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5518,'20170518','18:27:07','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5519,'20170518','18:33:25','132.248.128.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5520,'20170518','18:59:12','132.248.82.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5521,'20170518','21:33:57','180.76.15.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5522,'20170518','23:19:27','187.230.46.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5523,'20170519','08:24:47','187.237.14.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5524,'20170519','08:30:51','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5525,'20170519','09:20:55','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5526,'20170519','09:24:09','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5527,'20170519','09:27:46','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5528,'20170519','09:37:52','132.248.216.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5529,'20170519','09:47:02','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5530,'20170519','09:53:56','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5531,'20170519','10:00:04','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5532,'20170519','10:24:39','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5533,'20170519','10:37:36','189.150.243.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5534,'20170519','10:38:33','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5535,'20170519','10:42:11','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5536,'20170519','11:03:26','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5537,'20170519','11:17:01','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5538,'20170519','11:52:25','201.114.157.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5539,'20170519','11:58:17','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5540,'20170519','11:59:12','200.52.255.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5541,'20170519','12:01:28','187.169.240.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5542,'20170519','12:12:33','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5543,'20170519','12:14:24','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5544,'20170519','12:19:53','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5545,'20170519','12:38:56','189.216.157.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5546,'20170519','12:44:30','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5547,'20170519','12:47:08','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5548,'20170519','12:54:14','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5549,'20170519','13:03:20','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5550,'20170519','13:29:46','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5551,'20170519','13:35:02','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5552,'20170519','13:54:55','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5553,'20170519','13:57:02','132.248.143.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5554,'20170519','14:22:06','189.216.157.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5555,'20170519','14:33:48','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5556,'20170519','14:41:35','201.141.36.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5557,'20170519','14:50:55','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5558,'20170519','14:58:54','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5559,'20170519','15:37:53','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5560,'20170519','15:47:44','132.248.74.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5561,'20170519','15:57:41','132.248.242.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5562,'20170519','16:03:33','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5563,'20170519','16:39:16','189.164.165.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5564,'20170519','16:55:11','132.248.101.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5565,'20170519','18:04:18','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5566,'20170519','18:29:02','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5567,'20170519','18:41:04','66.249.93.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5568,'20170519','19:07:14','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5569,'20170520','00:36:34','200.76.91.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5570,'20170520','08:37:01','189.216.150.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5571,'20170520','08:49:36','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5572,'20170520','09:24:38','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5573,'20170520','11:08:08','180.76.15.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5574,'20170520','12:01:37','187.189.91.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5575,'20170520','12:06:08','66.249.79.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5576,'20170520','12:06:10','66.249.79.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5577,'20170520','14:10:58','180.76.15.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5578,'20170520','17:44:05','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5579,'20170520','19:00:32','189.217.236.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5580,'20170520','20:49:07','189.230.188.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5581,'20170520','21:37:27','201.103.15.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5582,'20170520','23:43:08','189.216.113.177');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5583,'20170521','00:26:37','189.217.129.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5584,'20170521','00:29:05','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5585,'20170521','03:06:46','66.249.66.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5586,'20170521','05:04:05','66.249.66.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5587,'20170521','06:00:00','189.217.16.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5588,'20170521','09:28:49','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5589,'20170521','13:06:23','189.216.204.37');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5590,'20170521','16:06:44','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5591,'20170521','16:47:13','201.114.129.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5592,'20170521','19:21:08','180.76.15.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5593,'20170521','19:24:31','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5594,'20170521','21:55:50','157.55.39.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5595,'20170522','00:39:51','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5596,'20170522','01:49:48','187.169.13.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5597,'20170522','06:29:47','180.76.15.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5598,'20170522','08:38:31','180.76.15.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5599,'20170522','08:44:14','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5600,'20170522','09:03:07','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5601,'20170522','09:12:15','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5602,'20170522','10:01:50','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5603,'20170522','10:36:49','78.31.43.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5604,'20170522','10:41:24','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5605,'20170522','10:44:42','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5606,'20170522','10:53:04','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5607,'20170522','10:54:32','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5608,'20170522','11:09:50','187.224.2.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5609,'20170522','11:12:46','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5610,'20170522','11:23:55','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5611,'20170522','11:41:15','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5612,'20170522','11:41:26','177.234.2.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5613,'20170522','11:53:07','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5614,'20170522','12:18:31','132.248.159.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5615,'20170522','12:25:55','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5616,'20170522','12:27:19','132.248.9.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5617,'20170522','12:29:09','132.248.50.63');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5618,'20170522','12:48:01','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5619,'20170522','12:53:20','180.76.15.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5620,'20170522','12:57:23','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5621,'20170522','13:22:25','132.247.215.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5622,'20170522','13:23:40','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5622,'20170522','13:23:40','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5622,'20170522','13:23:40','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5622,'20170522','13:23:40','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5623,'20170522','13:23:40','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5623,'20170522','13:23:40','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5628,'20170522','13:29:38','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5629,'20170522','13:30:53','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5630,'20170522','13:31:53','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5631,'20170522','13:47:08','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5632,'20170522','13:47:20','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5633,'20170522','14:01:06','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5634,'20170522','14:17:45','132.248.9.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5635,'20170522','14:21:11','189.216.183.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5636,'20170522','14:26:46','132.248.242.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5637,'20170522','14:48:48','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5638,'20170522','14:52:25','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5639,'20170522','15:07:43','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5640,'20170522','15:08:03','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5641,'20170522','15:30:23','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5642,'20170522','15:31:32','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5643,'20170522','15:43:24','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5644,'20170522','16:49:16','189.216.158.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5645,'20170522','17:31:33','132.248.101.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5646,'20170522','17:44:48','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5647,'20170522','18:20:46','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5648,'20170522','18:21:55','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5649,'20170522','19:32:54','132.247.149.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5650,'20170522','19:48:49','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5651,'20170522','20:59:24','187.234.248.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5652,'20170522','21:16:07','180.76.15.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5653,'20170522','21:59:21','190.228.210.45');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5654,'20170522','22:07:30','180.76.15.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5655,'20170522','22:16:19','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5656,'20170522','23:54:01','189.191.124.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5657,'20170523','08:35:34','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5658,'20170523','09:03:05','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5659,'20170523','09:16:43','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5660,'20170523','09:35:03','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5661,'20170523','09:42:10','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5662,'20170523','09:43:08','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5663,'20170523','09:56:15','132.248.94.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5664,'20170523','10:08:04','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5665,'20170523','10:09:42','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5666,'20170523','10:11:19','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5667,'20170523','10:19:17','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5668,'20170523','10:34:10','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5669,'20170523','10:37:52','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5670,'20170523','10:37:53','66.249.64.224');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5671,'20170523','10:38:07','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5672,'20170523','10:43:00','189.216.157.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5673,'20170523','10:45:42','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5674,'20170523','10:45:47','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5675,'20170523','10:56:38','189.216.113.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5676,'20170523','11:18:38','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5677,'20170523','11:21:23','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5678,'20170523','11:29:05','159.16.249.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5679,'20170523','11:32:36','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5680,'20170523','11:44:20','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5681,'20170523','11:47:29','132.248.86.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5682,'20170523','12:21:44','50.241.89.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5683,'20170523','12:24:20','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5684,'20170523','12:38:34','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5685,'20170523','12:47:56','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5686,'20170523','12:48:56','187.171.142.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5687,'20170523','12:54:20','132.248.123.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5688,'20170523','12:55:08','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5689,'20170523','12:59:19','200.33.101.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5690,'20170523','13:11:11','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5691,'20170523','13:13:45','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5692,'20170523','13:17:08','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5693,'20170523','13:18:23','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5694,'20170523','13:19:39','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5695,'20170523','13:37:00','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5696,'20170523','13:59:55','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5697,'20170523','14:19:16','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5698,'20170523','14:36:45','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5699,'20170523','15:37:11','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5700,'20170523','16:28:08','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5701,'20170523','16:56:37','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5702,'20170523','17:22:21','69.196.253.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5703,'20170523','17:37:51','77.66.120.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5704,'20170523','17:51:56','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5705,'20170523','17:59:21','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5706,'20170523','18:50:24','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5707,'20170523','19:35:15','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5708,'20170523','19:53:28','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5709,'20170523','20:16:24','132.248.213.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5710,'20170523','20:42:11','132.248.76.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5711,'20170523','23:49:30','189.216.112.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5712,'20170524','00:16:40','189.147.120.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5713,'20170524','01:47:19','66.249.64.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5714,'20170524','02:17:50','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5715,'20170524','05:38:52','180.76.15.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5716,'20170524','08:30:53','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5717,'20170524','08:56:44','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5718,'20170524','09:07:10','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5719,'20170524','09:13:49','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5720,'20170524','09:14:39','66.249.64.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5721,'20170524','09:24:20','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5722,'20170524','09:48:27','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5723,'20170524','10:08:08','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5724,'20170524','10:41:19','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5725,'20170524','10:43:38','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5726,'20170524','10:51:40','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5727,'20170524','10:55:37','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5728,'20170524','11:04:56','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5729,'20170524','11:05:18','201.157.35.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5730,'20170524','11:13:07','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5731,'20170524','11:37:36','187.228.32.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5732,'20170524','11:58:39','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5733,'20170524','11:59:29','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5734,'20170524','12:03:41','132.248.12.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5735,'20170524','12:09:25','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5736,'20170524','12:20:53','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5737,'20170524','12:25:10','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5738,'20170524','12:27:01','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5739,'20170524','12:34:00','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5740,'20170524','12:34:10','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5741,'20170524','12:43:07','187.214.194.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5742,'20170524','13:11:12','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5743,'20170524','13:11:58','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5744,'20170524','13:34:07','132.248.9.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5745,'20170524','13:47:20','189.179.137.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5746,'20170524','15:09:00','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5747,'20170524','15:14:11','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5748,'20170524','15:16:13','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5749,'20170524','15:50:33','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5750,'20170524','16:14:54','187.237.231.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5751,'20170524','16:15:25','200.68.128.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5752,'20170524','16:33:52','132.248.99.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5753,'20170524','16:55:15','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5754,'20170524','17:06:23','187.248.20.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5755,'20170524','17:13:46','148.246.148.116');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5756,'20170524','17:46:35','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5757,'20170524','17:52:29','132.248.182.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5758,'20170524','18:20:20','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5759,'20170524','18:21:35','187.237.231.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5760,'20170524','18:22:07','187.237.231.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5761,'20170524','18:57:08','187.226.165.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5762,'20170524','19:31:17','201.114.173.204');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5763,'20170524','20:15:57','189.249.63.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5764,'20170524','21:50:57','66.102.6.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5765,'20170525','09:59:38','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5766,'20170525','10:00:21','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5767,'20170525','10:08:11','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5768,'20170525','10:08:46','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5769,'20170525','10:12:03','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5770,'20170525','10:12:17','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5771,'20170525','10:14:48','200.56.75.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5772,'20170525','10:28:27','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5773,'20170525','10:28:45','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5774,'20170525','10:33:17','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5775,'20170525','10:36:02','169.253.194.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5776,'20170525','10:36:37','201.103.26.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5777,'20170525','10:38:08','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5778,'20170525','10:38:43','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5779,'20170525','10:42:08','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5780,'20170525','10:49:09','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5781,'20170525','10:49:34','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5782,'20170525','10:55:31','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5783,'20170525','11:11:06','212.47.239.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5784,'20170525','11:23:45','93.115.95.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5785,'20170525','11:28:51','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5786,'20170525','11:39:05','201.141.114.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5787,'20170525','11:39:54','128.52.128.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5788,'20170525','11:48:01','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5789,'20170525','11:54:59','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5790,'20170525','12:00:21','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5791,'20170525','12:05:17','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5792,'20170525','12:05:44','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5793,'20170525','12:16:56','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5794,'20170525','12:24:05','187.214.163.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5795,'20170525','12:28:38','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5796,'20170525','12:29:11','132.248.218.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5797,'20170525','12:36:12','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5798,'20170525','12:52:36','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5799,'20170525','12:54:28','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5800,'20170525','12:56:17','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5801,'20170525','12:59:35','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5802,'20170525','13:00:55','187.168.38.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5803,'20170525','13:02:27','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5804,'20170525','13:55:59','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5805,'20170525','14:21:52','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5806,'20170525','14:22:37','148.247.107.38');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5807,'20170525','14:46:29','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5808,'20170525','15:06:41','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5809,'20170525','15:12:56','189.210.95.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5810,'20170525','15:16:21','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5811,'20170525','15:43:31','189.216.180.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5812,'20170525','15:53:57','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5813,'20170525','16:33:24','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5814,'20170525','17:29:13','200.38.81.186');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5815,'20170525','18:12:03','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5816,'20170525','18:15:59','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5817,'20170525','18:37:35','66.249.93.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5818,'20170525','18:45:04','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5819,'20170525','19:01:36','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5820,'20170525','19:05:14','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5821,'20170525','20:09:00','201.114.173.204');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5822,'20170525','23:31:58','207.46.13.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5823,'20170526','02:41:59','201.119.135.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5824,'20170526','07:44:31','180.76.15.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5825,'20170526','08:37:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5826,'20170526','09:03:27','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5827,'20170526','09:06:26','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5828,'20170526','09:32:27','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5829,'20170526','09:34:57','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5830,'20170526','09:36:09','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5831,'20170526','09:38:15','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5832,'20170526','10:05:20','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5833,'20170526','10:06:52','66.249.84.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5834,'20170526','10:09:05','66.102.6.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5835,'20170526','10:20:22','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5836,'20170526','10:26:01','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5837,'20170526','10:30:03','180.76.15.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5838,'20170526','10:32:01','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5839,'20170526','10:32:05','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5840,'20170526','10:34:45','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5841,'20170526','10:35:42','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5842,'20170526','10:46:40','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5843,'20170526','10:53:39','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5844,'20170526','11:07:50','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5845,'20170526','11:08:16','189.216.181.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5846,'20170526','11:09:18','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5847,'20170526','11:15:27','187.221.13.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5848,'20170526','11:20:45','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5849,'20170526','11:25:30','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5850,'20170526','11:25:33','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5851,'20170526','11:35:22','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5852,'20170526','11:41:39','132.248.101.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5853,'20170526','11:51:06','201.103.200.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5854,'20170526','12:01:44','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5855,'20170526','12:13:24','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5856,'20170526','12:15:20','132.248.9.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5857,'20170526','12:23:23','200.52.255.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5858,'20170526','12:30:04','132.248.242.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5859,'20170526','12:33:46','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5860,'20170526','12:35:46','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5861,'20170526','12:39:28','189.211.128.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5862,'20170526','13:21:24','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5863,'20170526','13:39:11','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5864,'20170526','13:53:09','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5865,'20170526','14:22:30','180.76.15.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5866,'20170526','14:31:56','148.240.167.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5867,'20170526','14:49:18','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5868,'20170526','14:53:49','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5869,'20170526','14:58:32','189.240.99.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5870,'20170526','15:12:29','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5871,'20170526','15:25:16','192.243.88.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5872,'20170526','16:31:24','187.190.4.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5873,'20170526','16:40:48','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5874,'20170526','16:47:06','132.248.248.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5875,'20170526','17:07:02','187.170.27.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5876,'20170526','18:18:40','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5877,'20170526','18:27:04','132.248.224.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5878,'20170526','18:56:53','68.180.229.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5879,'20170526','22:01:52','200.33.232.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5880,'20170526','22:18:41','66.249.75.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5881,'20170526','22:37:59','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5882,'20170526','23:30:14','52.4.48.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5883,'20170527','00:07:04','66.249.75.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5884,'20170527','00:49:53','180.76.15.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5885,'20170527','01:24:30','66.249.69.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5886,'20170527','01:36:15','180.76.15.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5887,'20170527','02:12:39','66.102.6.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5888,'20170527','03:11:45','66.249.69.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5889,'20170527','05:29:23','66.249.69.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5890,'20170527','08:00:36','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5891,'20170527','08:57:22','146.155.148.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5892,'20170527','09:01:15','54.162.203.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5893,'20170527','15:20:02','189.202.29.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5894,'20170527','15:59:27','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5895,'20170527','17:26:08','180.76.15.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5896,'20170527','20:12:33','180.76.15.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5897,'20170527','21:58:47','180.76.15.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5898,'20170528','00:28:17','189.239.65.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5899,'20170528','00:50:29','66.249.64.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5900,'20170528','09:46:49','180.76.15.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5901,'20170528','10:47:41','180.76.15.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5902,'20170528','15:51:58','98.122.129.218');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5903,'20170528','17:09:42','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5904,'20170528','17:29:51','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5905,'20170528','19:03:41','108.62.204.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5906,'20170528','19:05:12','177.231.171.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5907,'20170528','19:42:05','180.76.15.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5908,'20170528','20:22:52','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5909,'20170528','20:55:08','180.76.15.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5910,'20170528','21:52:01','189.216.198.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5911,'20170529','06:02:33','88.3.156.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5912,'20170529','08:10:42','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5913,'20170529','08:52:08','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5914,'20170529','09:04:57','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5915,'20170529','09:21:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5916,'20170529','09:24:51','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5917,'20170529','10:09:09','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5918,'20170529','10:15:15','189.213.84.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5919,'20170529','11:02:48','132.248.242.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5920,'20170529','11:08:48','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5921,'20170529','11:30:36','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5922,'20170529','11:40:30','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5923,'20170529','12:00:03','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5924,'20170529','12:03:28','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5925,'20170529','12:07:42','132.248.89.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5926,'20170529','12:22:41','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5927,'20170529','12:30:57','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5928,'20170529','12:53:40','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5929,'20170529','12:57:14','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5930,'20170529','13:00:31','132.248.51.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5931,'20170529','13:01:31','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5932,'20170529','13:04:09','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5933,'20170529','13:05:31','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5934,'20170529','13:10:11','132.247.184.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5935,'20170529','13:14:21','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5936,'20170529','13:27:30','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5937,'20170529','13:33:54','198.176.80.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5938,'20170529','13:36:49','189.139.195.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5939,'20170529','13:40:42','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5940,'20170529','13:46:21','132.248.102.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5941,'20170529','13:55:16','132.248.84.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5942,'20170529','13:58:55','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5943,'20170529','14:04:33','189.240.99.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5944,'20170529','14:06:08','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5945,'20170529','14:11:22','189.216.182.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5946,'20170529','14:19:03','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5947,'20170529','14:43:43','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5948,'20170529','14:52:57','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5949,'20170529','14:54:50','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5950,'20170529','15:30:45','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5951,'20170529','15:36:22','187.227.174.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5952,'20170529','15:37:13','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5953,'20170529','15:41:18','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5954,'20170529','16:00:25','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5955,'20170529','16:24:54','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5956,'20170529','16:45:13','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5957,'20170529','17:50:19','180.76.15.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5958,'20170529','17:53:36','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5959,'20170529','17:59:53','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5960,'20170529','18:16:18','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5961,'20170529','19:07:35','132.248.110.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5962,'20170529','19:35:00','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5963,'20170529','20:22:35','189.216.180.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5964,'20170529','21:07:44','207.46.13.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5965,'20170529','21:39:03','201.141.190.53');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5966,'20170529','22:42:43','177.224.221.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5967,'20170529','23:14:29','200.120.200.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5968,'20170530','04:46:56','217.141.200.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5969,'20170530','08:27:25','148.209.181.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5970,'20170530','08:30:23','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5971,'20170530','08:57:43','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5972,'20170530','09:13:28','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5973,'20170530','09:19:28','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5974,'20170530','09:32:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5975,'20170530','09:49:47','189.242.22.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5976,'20170530','09:55:36','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5977,'20170530','10:21:00','132.248.147.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5978,'20170530','10:21:51','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5979,'20170530','10:22:49','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5980,'20170530','10:39:26','189.216.182.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5981,'20170530','10:52:47','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5982,'20170530','10:53:51','132.248.103.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5983,'20170530','10:54:03','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5984,'20170530','10:58:27','176.195.172.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5985,'20170530','11:09:57','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5986,'20170530','11:12:07','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5987,'20170530','11:18:15','188.243.168.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5988,'20170530','11:19:35','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5989,'20170530','11:25:20','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5990,'20170530','11:55:00','132.248.51.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5991,'20170530','11:59:22','189.216.56.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5992,'20170530','12:07:51','187.228.135.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5993,'20170530','12:28:08','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5994,'20170530','12:35:35','189.216.56.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5995,'20170530','12:37:43','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5996,'20170530','12:41:36','132.248.110.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5997,'20170530','12:48:31','132.248.74.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5998,'20170530','12:56:49','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (5999,'20170530','13:00:28','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6000,'20170530','13:06:29','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6001,'20170530','13:07:37','201.132.93.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6002,'20170530','13:17:32','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6003,'20170530','13:32:23','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6004,'20170530','13:41:37','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6005,'20170530','13:45:11','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6006,'20170530','13:51:10','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6007,'20170530','13:58:28','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6008,'20170530','14:00:02','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6009,'20170530','14:09:42','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6010,'20170530','14:16:10','189.137.218.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6011,'20170530','14:18:29','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6012,'20170530','14:30:02','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6013,'20170530','14:36:21','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6014,'20170530','14:43:18','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6015,'20170530','15:18:34','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6016,'20170530','15:22:15','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6017,'20170530','15:45:42','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6018,'20170530','15:46:49','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6019,'20170530','16:31:05','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6020,'20170530','16:46:52','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6021,'20170530','16:51:15','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6022,'20170530','17:03:38','187.176.64.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6023,'20170530','17:16:24','189.216.114.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6024,'20170530','17:33:01','132.248.248.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6025,'20170530','17:34:20','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6026,'20170530','17:37:00','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6027,'20170530','17:42:47','189.158.80.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6028,'20170530','18:10:22','132.248.33.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6029,'20170530','18:12:25','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6030,'20170530','19:03:08','201.153.199.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6031,'20170530','19:52:11','189.217.223.203');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6032,'20170530','20:12:24','168.255.251.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6033,'20170530','20:29:36','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6034,'20170530','22:21:11','180.76.15.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6035,'20170530','22:36:54','201.141.187.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6036,'20170531','02:41:20','180.76.15.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6037,'20170531','06:19:50','160.120.3.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6038,'20170531','09:11:47','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6039,'20170531','09:13:54','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6040,'20170531','09:18:12','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6041,'20170531','09:27:54','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6042,'20170531','09:32:07','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6043,'20170531','09:43:36','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6044,'20170531','10:01:30','200.24.16.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6045,'20170531','10:11:38','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6046,'20170531','10:12:58','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6047,'20170531','10:30:57','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6048,'20170531','10:32:20','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6049,'20170531','10:34:50','132.248.216.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6050,'20170531','10:37:58','148.206.181.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6051,'20170531','10:55:41','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6052,'20170531','10:56:37','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6053,'20170531','11:15:38','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6054,'20170531','11:19:06','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6055,'20170531','11:23:08','132.248.123.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6056,'20170531','11:28:58','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6057,'20170531','11:43:41','189.216.181.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6058,'20170531','11:46:36','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6059,'20170531','12:03:17','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6060,'20170531','12:17:17','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6061,'20170531','12:27:13','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6062,'20170531','12:40:58','132.248.67.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6063,'20170531','13:03:09','168.255.251.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6064,'20170531','13:14:15','132.248.9.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6065,'20170531','13:15:11','200.23.51.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6066,'20170531','13:27:24','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6067,'20170531','13:28:24','132.248.9.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6068,'20170531','13:49:10','201.166.188.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6069,'20170531','14:12:23','194.187.170.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6070,'20170531','14:19:58','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6071,'20170531','14:25:50','200.23.113.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6072,'20170531','14:37:11','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6073,'20170531','14:45:20','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6074,'20170531','15:05:12','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6075,'20170531','15:22:35','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6076,'20170531','15:28:56','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6077,'20170531','15:52:01','189.202.227.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6078,'20170531','16:38:01','180.76.15.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6079,'20170531','16:52:34','200.70.48.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6080,'20170531','17:07:44','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6081,'20170531','17:24:25','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6082,'20170531','17:57:50','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6083,'20170531','18:07:43','187.247.71.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6084,'20170531','18:41:54','132.248.209.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6085,'20170531','18:44:52','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6086,'20170531','19:15:45','132.248.248.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6087,'20170531','20:05:10','201.165.165.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6088,'20170531','20:17:15','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6089,'20170601','04:35:11','180.76.15.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6090,'20170601','07:22:50','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6091,'20170601','08:39:46','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6092,'20170601','08:51:45','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6093,'20170601','09:01:56','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6094,'20170601','09:19:17','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6095,'20170601','09:50:15','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6096,'20170601','09:53:21','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6097,'20170601','10:01:02','148.247.69.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6098,'20170601','10:05:05','201.113.175.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6099,'20170601','10:22:46','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6100,'20170601','10:32:05','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6101,'20170601','10:39:35','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6102,'20170601','11:02:14','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6103,'20170601','11:06:06','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6104,'20170601','11:17:23','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6105,'20170601','11:30:49','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6106,'20170601','11:32:46','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6107,'20170601','11:53:58','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6108,'20170601','11:58:53','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6109,'20170601','12:01:45','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6110,'20170601','12:09:07','201.139.253.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6111,'20170601','12:33:51','132.248.242.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6112,'20170601','12:35:22','189.144.44.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6113,'20170601','12:38:54','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6114,'20170601','12:43:41','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6115,'20170601','12:43:42','201.114.229.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6116,'20170601','12:47:29','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6117,'20170601','13:20:54','187.234.172.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6118,'20170601','13:47:10','201.117.1.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6119,'20170601','14:01:48','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6120,'20170601','14:03:35','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6121,'20170601','14:12:34','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6122,'20170601','14:14:08','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6123,'20170601','14:28:58','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6124,'20170601','14:42:20','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6125,'20170601','14:59:51','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6126,'20170601','15:13:47','132.248.123.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6127,'20170601','15:44:36','132.248.233.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6128,'20170601','15:48:34','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6129,'20170601','15:51:51','187.237.14.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6130,'20170601','15:52:16','187.237.14.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6131,'20170601','15:56:17','180.76.15.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6132,'20170601','16:07:58','200.33.14.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6133,'20170601','16:55:21','201.103.200.7');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6134,'20170601','16:58:18','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6135,'20170601','16:59:25','132.247.117.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6136,'20170601','17:05:10','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6137,'20170601','17:10:43','201.153.28.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6138,'20170601','17:18:03','187.227.164.191');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6139,'20170601','17:48:32','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6140,'20170601','18:12:25','189.216.196.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6141,'20170601','18:28:33','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6142,'20170601','18:36:29','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6142,'20170601','18:36:29','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6144,'20170601','18:46:33','148.215.15.96');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6145,'20170601','20:10:42','66.249.66.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6146,'20170601','21:28:47','201.114.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6147,'20170602','00:56:00','180.76.15.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6148,'20170602','08:56:11','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6149,'20170602','09:03:47','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6150,'20170602','09:13:54','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6151,'20170602','09:22:08','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6152,'20170602','09:36:34','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6153,'20170602','09:56:50','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6154,'20170602','09:57:18','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6155,'20170602','10:00:50','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6156,'20170602','10:07:09','189.137.218.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6157,'20170602','10:09:34','132.248.230.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6158,'20170602','10:36:32','187.220.7.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6159,'20170602','10:36:35','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6160,'20170602','10:53:28','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6161,'20170602','10:54:35','201.114.229.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6162,'20170602','11:12:36','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6163,'20170602','11:13:38','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6164,'20170602','11:14:42','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6165,'20170602','11:17:47','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6166,'20170602','11:22:28','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6167,'20170602','11:28:20','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6168,'20170602','11:47:11','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6169,'20170602','11:50:33','132.248.242.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6170,'20170602','11:50:36','132.248.67.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6171,'20170602','11:54:43','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6172,'20170602','12:00:02','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6173,'20170602','12:21:46','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6174,'20170602','12:24:22','189.216.58.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6175,'20170602','12:33:24','189.232.43.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6176,'20170602','12:37:31','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6177,'20170602','12:40:32','180.76.15.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6178,'20170602','12:49:53','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6179,'20170602','12:51:57','132.248.9.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6180,'20170602','13:11:38','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6181,'20170602','13:17:40','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6182,'20170602','13:23:14','132.248.211.101');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6183,'20170602','13:42:52','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6184,'20170602','13:52:06','132.248.159.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6185,'20170602','14:02:50','132.248.9.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6186,'20170602','14:14:17','132.248.233.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6187,'20170602','14:19:04','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6188,'20170602','14:30:49','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6189,'20170602','14:49:33','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6190,'20170602','15:01:31','132.248.251.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6191,'20170602','15:13:04','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6192,'20170602','15:56:24','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6193,'20170602','16:13:59','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6194,'20170602','16:33:03','132.248.245.126');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6195,'20170602','16:48:10','187.141.12.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6196,'20170602','16:49:32','189.217.105.185');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6197,'20170602','17:22:45','132.247.76.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6198,'20170602','18:06:01','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6199,'20170602','18:28:03','132.248.123.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6200,'20170602','18:43:28','132.248.180.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6201,'20170602','19:35:22','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6202,'20170602','19:47:07','132.248.242.175');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6203,'20170602','19:50:01','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6204,'20170602','20:39:34','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6205,'20170602','20:46:51','132.248.44.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6206,'20170602','20:51:53','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6207,'20170602','21:03:23','180.76.15.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6208,'20170602','23:43:56','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6209,'20170603','00:07:58','180.76.15.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6210,'20170603','07:15:42','76.179.200.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6211,'20170603','08:52:13','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6212,'20170603','09:54:56','180.76.15.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6213,'20170603','11:57:58','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6214,'20170603','15:25:04','189.216.149.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6215,'20170604','00:07:25','180.76.15.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6216,'20170604','08:34:11','180.76.15.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6217,'20170604','10:04:17','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6218,'20170604','13:50:46','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6219,'20170604','14:42:10','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6220,'20170604','15:58:53','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6221,'20170604','17:53:21','187.199.87.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6222,'20170604','19:37:54','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6223,'20170604','23:17:56','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6224,'20170605','00:28:35','189.216.206.251');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6225,'20170605','00:45:29','180.76.15.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6226,'20170605','01:05:36','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6227,'20170605','01:53:12','180.76.15.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6228,'20170605','08:55:21','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6229,'20170605','08:58:13','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6230,'20170605','09:00:28','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6231,'20170605','09:04:47','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6232,'20170605','09:09:20','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6233,'20170605','09:27:00','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6234,'20170605','09:28:23','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6235,'20170605','09:47:24','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6236,'20170605','10:16:24','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6237,'20170605','10:41:52','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6238,'20170605','10:52:57','132.248.9.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6239,'20170605','11:09:55','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6240,'20170605','11:10:30','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6241,'20170605','11:23:17','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6242,'20170605','11:23:41','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6243,'20170605','11:26:05','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6244,'20170605','11:28:40','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6245,'20170605','11:30:45','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6246,'20170605','11:48:00','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6247,'20170605','11:50:48','132.247.162.174');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6248,'20170605','11:55:36','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6249,'20170605','12:03:25','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6250,'20170605','12:28:05','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6251,'20170605','12:35:51','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6252,'20170605','12:37:59','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6253,'20170605','12:39:29','132.248.242.172');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6254,'20170605','12:43:36','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6255,'20170605','12:46:42','187.168.28.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6256,'20170605','13:03:49','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6257,'20170605','13:22:04','168.255.251.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6258,'20170605','13:34:17','189.211.128.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6259,'20170605','13:34:38','132.248.9.64');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6260,'20170605','13:43:24','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6261,'20170605','14:12:43','132.247.117.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6262,'20170605','14:37:58','198.0.156.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6263,'20170605','14:38:16','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6264,'20170605','14:46:58','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6265,'20170605','15:06:56','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6266,'20170605','15:07:55','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6267,'20170605','15:58:03','201.137.177.62');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6268,'20170605','16:15:33','180.76.15.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6269,'20170605','17:04:33','132.248.9.125');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6270,'20170605','17:17:27','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6271,'20170605','17:30:06','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6272,'20170605','17:51:54','189.216.199.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6273,'20170605','18:16:28','201.114.108.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6274,'20170605','18:22:31','131.178.193.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6275,'20170605','20:58:15','70.54.72.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6276,'20170605','21:39:22','180.76.15.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6277,'20170605','23:25:38','180.76.15.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6278,'20170605','23:52:16','180.76.15.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6279,'20170606','07:54:22','180.76.15.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6280,'20170606','08:00:48','81.90.111.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6281,'20170606','08:28:27','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6282,'20170606','08:41:52','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6283,'20170606','08:45:35','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6284,'20170606','09:02:37','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6285,'20170606','09:15:19','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6286,'20170606','09:23:40','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6287,'20170606','09:45:52','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6288,'20170606','09:47:19','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6289,'20170606','09:56:07','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6290,'20170606','10:00:07','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6291,'20170606','10:03:45','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6292,'20170606','10:20:46','132.248.148.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6293,'20170606','10:26:29','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6294,'20170606','10:30:53','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6295,'20170606','10:34:44','187.237.14.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6296,'20170606','10:39:04','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6297,'20170606','11:05:10','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6298,'20170606','11:20:28','132.248.9.100');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6299,'20170606','11:20:50','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6300,'20170606','11:22:27','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6301,'20170606','11:39:27','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6302,'20170606','11:41:39','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6303,'20170606','12:01:41','189.202.227.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6304,'20170606','12:01:43','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6305,'20170606','12:03:34','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6306,'20170606','12:07:36','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6307,'20170606','12:08:48','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6308,'20170606','12:29:09','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6309,'20170606','12:42:21','66.249.88.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6310,'20170606','12:45:35','148.247.69.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6311,'20170606','12:46:49','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6312,'20170606','12:50:39','157.55.39.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6313,'20170606','12:59:09','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6314,'20170606','13:26:45','187.217.89.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6315,'20170606','13:27:29','132.248.143.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6316,'20170606','14:03:58','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6317,'20170606','14:15:28','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6318,'20170606','14:17:54','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6319,'20170606','14:18:25','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6320,'20170606','14:29:56','201.137.196.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6321,'20170606','14:58:18','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6322,'20170606','15:00:14','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6323,'20170606','15:13:43','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6324,'20170606','15:36:39','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6325,'20170606','17:15:08','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6326,'20170606','17:44:53','180.76.15.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6327,'20170606','18:01:29','180.76.15.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6328,'20170606','18:07:06','187.145.207.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6329,'20170606','19:09:25','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6330,'20170606','19:19:14','132.248.14.35');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6331,'20170606','19:37:47','189.135.202.236');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6332,'20170606','19:53:34','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6333,'20170606','20:44:40','187.240.173.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6334,'20170606','21:08:55','187.220.92.107');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6335,'20170606','21:35:28','157.55.39.179');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6336,'20170606','23:26:30','187.220.151.71');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6337,'20170607','00:23:50','189.216.167.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6338,'20170607','03:24:44','180.76.15.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6339,'20170607','06:07:29','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6340,'20170607','07:57:08','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6341,'20170607','08:26:46','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6342,'20170607','08:28:05','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6343,'20170607','08:36:12','148.238.251.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6344,'20170607','09:08:10','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6345,'20170607','09:16:41','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6346,'20170607','09:24:45','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6347,'20170607','09:35:31','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6348,'20170607','09:42:20','66.102.6.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6349,'20170607','09:46:43','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6350,'20170607','10:04:09','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6351,'20170607','10:45:53','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6352,'20170607','10:47:37','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6353,'20170607','10:48:43','132.247.158.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6354,'20170607','11:05:57','192.100.180.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6355,'20170607','11:10:39','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6356,'20170607','11:15:20','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6357,'20170607','11:30:13','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6358,'20170607','11:33:00','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6359,'20170607','11:34:52','187.168.47.233');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6360,'20170607','11:38:14','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6361,'20170607','11:38:20','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6362,'20170607','11:41:04','132.248.206.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6363,'20170607','11:45:49','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6364,'20170607','11:46:08','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6365,'20170607','11:46:49','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6366,'20170607','11:53:20','132.248.160.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6367,'20170607','11:57:44','189.203.168.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6368,'20170607','12:02:32','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6369,'20170607','12:29:29','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6370,'20170607','12:54:45','132.247.58.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6371,'20170607','13:18:52','132.248.147.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6372,'20170607','13:28:04','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6373,'20170607','14:05:04','132.248.67.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6374,'20170607','14:09:57','132.248.246.219');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6375,'20170607','14:10:17','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6376,'20170607','14:37:30','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6377,'20170607','14:47:02','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6378,'20170607','14:56:26','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6379,'20170607','15:30:37','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6379,'20170607','15:30:37','132.248.197.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6381,'20170607','15:30:39','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6382,'20170607','15:30:49','132.248.123.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6383,'20170607','15:32:28','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6384,'20170607','15:40:51','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6385,'20170607','15:55:01','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6386,'20170607','16:07:48','148.206.70.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6387,'20170607','16:35:14','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6388,'20170607','16:51:03','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6389,'20170607','17:53:23','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6390,'20170607','17:59:39','132.248.9.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6391,'20170607','18:13:34','200.126.51.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6392,'20170607','18:39:26','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6393,'20170607','18:42:14','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6394,'20170607','19:23:39','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6395,'20170607','19:28:26','132.248.141.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6396,'20170607','20:04:41','132.248.89.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6397,'20170607','20:25:26','132.248.199.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6398,'20170607','23:01:42','187.221.44.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6399,'20170607','23:18:39','201.114.243.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6400,'20170608','03:56:49','66.249.69.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6401,'20170608','07:10:49','66.249.69.81');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6402,'20170608','08:39:50','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6403,'20170608','09:00:06','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6404,'20170608','09:19:02','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6405,'20170608','09:38:52','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6406,'20170608','09:54:05','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6407,'20170608','09:54:52','66.249.69.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6408,'20170608','10:04:29','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6409,'20170608','10:14:53','66.249.88.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6410,'20170608','10:23:31','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6411,'20170608','10:25:25','132.248.9.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6412,'20170608','10:34:57','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6413,'20170608','10:43:30','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6414,'20170608','10:45:11','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6415,'20170608','10:49:13','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6416,'20170608','10:52:12','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6417,'20170608','10:57:35','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6418,'20170608','11:03:10','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6419,'20170608','11:07:28','132.248.67.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6420,'20170608','11:20:22','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6421,'20170608','11:21:51','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6422,'20170608','11:38:33','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6423,'20170608','11:39:16','132.248.9.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6424,'20170608','11:47:04','132.248.102.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6425,'20170608','11:47:58','189.201.132.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6426,'20170608','11:55:40','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6427,'20170608','11:57:44','132.248.9.65');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6428,'20170608','11:58:35','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6429,'20170608','12:00:36','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6430,'20170608','12:16:18','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6431,'20170608','12:49:04','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6432,'20170608','12:52:42','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6433,'20170608','13:02:09','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6434,'20170608','13:06:17','132.248.67.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6435,'20170608','13:40:59','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6435,'20170608','13:40:59','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6437,'20170608','13:55:46','132.248.67.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6438,'20170608','14:02:29','201.166.188.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6439,'20170608','14:04:19','132.248.242.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6440,'20170608','14:46:11','132.248.123.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6441,'20170608','14:47:03','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6442,'20170608','14:47:47','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6443,'20170608','14:53:00','132.248.45.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6444,'20170608','15:06:22','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6445,'20170608','15:11:21','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6446,'20170608','15:21:06','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6447,'20170608','15:28:27','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6448,'20170608','15:31:17','189.137.255.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6449,'20170608','15:55:04','187.171.253.184');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6450,'20170608','15:59:08','187.234.129.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6450,'20170608','15:59:08','187.234.129.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6452,'20170608','16:42:17','201.103.42.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6453,'20170608','16:55:07','132.248.44.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6454,'20170608','16:56:35','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6455,'20170608','17:11:59','148.244.120.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6456,'20170608','17:59:48','132.248.123.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6457,'20170608','18:06:24','132.248.76.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6458,'20170608','18:14:52','189.203.232.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6459,'20170608','18:42:42','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6460,'20170608','19:19:57','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6461,'20170608','20:04:13','180.76.15.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6462,'20170608','20:05:37','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6463,'20170608','22:21:24','189.249.94.16');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6464,'20170609','04:48:57','66.249.64.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6465,'20170609','05:48:00','189.217.106.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6465,'20170609','05:48:00','189.217.106.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6467,'20170609','08:34:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6468,'20170609','09:30:21','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6469,'20170609','09:39:03','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6470,'20170609','09:51:49','200.52.81.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6471,'20170609','09:57:28','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6472,'20170609','09:58:39','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6473,'20170609','10:08:46','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6474,'20170609','10:19:46','189.137.203.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6475,'20170609','10:23:04','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6476,'20170609','10:23:59','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6477,'20170609','10:35:53','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6478,'20170609','10:37:23','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6479,'20170609','11:02:06','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6480,'20170609','11:04:51','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6481,'20170609','11:06:43','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6482,'20170609','11:11:36','187.150.83.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6483,'20170609','11:18:56','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6484,'20170609','11:24:46','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6485,'20170609','11:30:42','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6486,'20170609','12:00:31','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6487,'20170609','12:22:47','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6488,'20170609','12:24:06','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6489,'20170609','12:25:54','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6490,'20170609','12:34:51','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6491,'20170609','12:36:41','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6492,'20170609','12:57:22','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6493,'20170609','13:06:24','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6494,'20170609','13:16:54','132.248.123.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6495,'20170609','13:31:38','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6496,'20170609','13:47:30','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6497,'20170609','14:08:22','148.204.172.78');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6498,'20170609','14:19:05','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6499,'20170609','14:28:27','132.248.9.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6500,'20170609','14:31:50','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6501,'20170609','14:37:09','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6502,'20170609','15:17:10','132.248.101.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6503,'20170609','15:23:35','132.248.141.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6504,'20170609','15:26:16','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6505,'20170609','15:34:01','132.248.67.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6506,'20170609','15:54:47','189.207.138.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6507,'20170609','15:59:22','37.48.68.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6508,'20170609','16:05:14','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6509,'20170609','16:22:10','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6510,'20170609','18:02:17','132.248.9.167');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6511,'20170609','18:33:35','200.23.223.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6512,'20170609','19:05:52','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6513,'20170609','19:34:25','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6514,'20170609','19:57:53','201.157.85.225');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6515,'20170609','20:03:24','189.241.30.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6516,'20170609','21:32:59','180.76.15.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6517,'20170609','21:34:10','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6518,'20170610','01:20:23','201.141.126.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6519,'20170610','04:23:05','180.76.15.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6520,'20170610','04:42:53','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6521,'20170610','07:39:14','180.76.15.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6522,'20170610','09:24:33','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6523,'20170610','09:37:39','176.14.223.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6524,'20170610','09:50:56','180.76.15.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6525,'20170610','10:58:08','180.76.15.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6526,'20170610','11:33:00','180.76.15.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6527,'20170610','11:53:54','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6528,'20170610','13:45:29','200.53.239.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6529,'20170610','15:57:53','180.76.15.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6530,'20170610','21:18:54','180.76.15.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6531,'20170610','22:22:13','187.221.49.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6532,'20170611','00:04:11','189.216.99.249');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6533,'20170611','01:44:21','180.76.15.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6534,'20170611','02:16:09','180.76.15.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6535,'20170611','10:44:39','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6536,'20170611','12:26:16','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6537,'20170611','14:41:11','157.55.39.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6538,'20170611','15:13:59','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6539,'20170611','15:54:39','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6540,'20170611','18:09:30','189.225.218.123');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6541,'20170611','18:49:02','187.242.153.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6542,'20170611','19:20:46','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6543,'20170612','08:30:58','64.233.172.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6544,'20170612','08:36:41','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6545,'20170612','08:46:08','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6546,'20170612','08:48:34','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6547,'20170612','08:57:56','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6548,'20170612','09:02:58','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6549,'20170612','09:11:47','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6550,'20170612','09:28:59','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6551,'20170612','09:43:12','189.216.150.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6552,'20170612','09:47:43','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6553,'20170612','09:48:33','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6554,'20170612','09:48:44','132.247.113.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6555,'20170612','10:00:59','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6556,'20170612','10:06:45','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6557,'20170612','10:24:52','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6558,'20170612','10:42:43','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6559,'20170612','10:52:09','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6560,'20170612','11:00:12','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6561,'20170612','11:08:50','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6562,'20170612','11:10:19','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6563,'20170612','11:14:53','187.210.186.200');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6564,'20170612','11:15:01','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6565,'20170612','11:17:08','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6566,'20170612','11:28:39','132.248.110.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6566,'20170612','11:28:39','132.248.110.205');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6568,'20170612','11:32:27','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6569,'20170612','11:40:14','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6570,'20170612','11:41:26','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6571,'20170612','11:51:15','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6572,'20170612','11:56:59','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6573,'20170612','11:58:49','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6574,'20170612','12:03:31','132.247.107.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6575,'20170612','12:11:40','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6576,'20170612','12:20:32','132.248.9.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6577,'20170612','12:20:52','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6578,'20170612','12:22:01','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6579,'20170612','12:23:11','148.241.227.40');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6580,'20170612','12:26:48','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6581,'20170612','13:04:06','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6582,'20170612','13:09:48','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6583,'20170612','13:11:41','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6584,'20170612','13:14:55','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6585,'20170612','14:05:22','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6586,'20170612','14:10:47','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6587,'20170612','14:11:37','187.207.156.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6588,'20170612','14:13:08','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6589,'20170612','14:15:48','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6590,'20170612','14:20:46','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6591,'20170612','14:46:44','132.248.67.193');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6592,'20170612','14:49:42','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6593,'20170612','14:58:18','132.248.89.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6594,'20170612','14:59:21','132.248.174.176');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6595,'20170612','15:01:03','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6596,'20170612','16:32:14','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6597,'20170612','16:38:10','189.230.115.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6598,'20170612','16:48:51','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6599,'20170612','17:09:30','187.145.192.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6600,'20170612','18:02:02','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6601,'20170612','18:24:48','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6602,'20170612','18:37:29','66.249.88.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6603,'20170612','18:44:49','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6604,'20170612','18:48:13','132.248.199.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6605,'20170612','19:17:27','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6606,'20170612','19:40:14','187.220.189.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6607,'20170612','21:39:46','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6608,'20170612','22:03:47','187.223.3.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6609,'20170612','22:17:01','189.216.151.250');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6610,'20170613','00:10:21','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6611,'20170613','00:45:16','180.76.15.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6612,'20170613','02:06:29','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6613,'20170613','06:39:45','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6614,'20170613','08:05:22','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6615,'20170613','08:52:09','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6616,'20170613','08:56:02','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6617,'20170613','08:59:41','132.248.25.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6618,'20170613','09:44:50','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6619,'20170613','09:44:59','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6620,'20170613','10:04:44','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6621,'20170613','10:07:02','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6622,'20170613','10:14:06','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6623,'20170613','10:14:35','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6624,'20170613','10:18:18','168.255.251.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6625,'20170613','10:19:01','187.189.230.20');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6626,'20170613','10:29:41','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6627,'20170613','10:43:35','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6628,'20170613','10:44:59','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6629,'20170613','11:05:00','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6630,'20170613','11:05:18','128.135.181.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6631,'20170613','11:06:11','66.102.6.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6632,'20170613','11:21:37','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6633,'20170613','11:27:25','132.248.82.45');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6634,'20170613','11:35:34','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6635,'20170613','11:42:16','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6636,'20170613','11:44:51','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6637,'20170613','11:48:55','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6638,'20170613','12:05:44','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6639,'20170613','12:10:36','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6640,'20170613','12:26:26','132.248.67.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6641,'20170613','12:26:45','187.190.163.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6642,'20170613','12:35:51','132.248.180.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6643,'20170613','12:45:41','187.207.63.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6644,'20170613','12:47:03','132.248.9.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6645,'20170613','12:59:27','176.14.238.157');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6646,'20170613','13:32:04','132.247.225.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6647,'20170613','13:36:15','132.248.9.202');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6648,'20170613','13:53:09','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6649,'20170613','13:57:05','132.248.197.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6650,'20170613','14:05:41','132.248.44.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6651,'20170613','14:07:28','189.216.150.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6652,'20170613','14:19:17','52.86.176.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6653,'20170613','14:19:54','132.248.116.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6654,'20170613','14:21:16','132.248.51.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6655,'20170613','14:31:02','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6656,'20170613','14:35:55','132.248.132.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6657,'20170613','14:36:58','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6658,'20170613','14:41:37','132.248.251.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6659,'20170613','14:57:11','132.248.51.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6660,'20170613','14:58:36','132.248.51.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6661,'20170613','15:02:40','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6662,'20170613','15:03:55','132.248.51.232');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6663,'20170613','15:39:35','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6664,'20170613','15:39:43','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6665,'20170613','15:40:47','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6666,'20170613','15:47:33','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6667,'20170613','16:01:17','132.248.182.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6668,'20170613','16:13:34','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6669,'20170613','16:26:30','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6670,'20170613','16:38:05','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6671,'20170613','17:37:24','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6672,'20170613','17:55:46','187.145.192.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6673,'20170613','17:55:53','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6674,'20170613','18:12:29','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6675,'20170613','19:43:58','189.216.198.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6676,'20170613','20:00:45','148.228.104.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6677,'20170613','20:03:02','189.137.203.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6678,'20170613','21:57:08','187.220.178.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6679,'20170614','08:50:01','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6680,'20170614','08:52:21','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6681,'20170614','08:53:30','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6682,'20170614','09:00:55','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6683,'20170614','09:09:48','132.248.182.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6684,'20170614','09:28:24','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6685,'20170614','09:34:20','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6686,'20170614','09:46:51','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6687,'20170614','10:03:33','132.248.75.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6688,'20170614','10:12:07','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6689,'20170614','10:17:32','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6690,'20170614','10:20:27','132.248.242.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6691,'20170614','10:26:32','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6692,'20170614','10:40:42','132.248.97.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6693,'20170614','10:41:19','132.248.97.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6694,'20170614','10:49:26','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6695,'20170614','10:54:46','132.248.67.182');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6696,'20170614','11:06:15','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6697,'20170614','11:17:12','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6698,'20170614','11:18:14','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6699,'20170614','11:20:58','132.248.82.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6700,'20170614','11:21:31','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6701,'20170614','11:22:15','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6702,'20170614','11:27:34','132.248.132.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6703,'20170614','11:30:07','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6704,'20170614','11:41:14','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6705,'20170614','11:42:11','189.216.189.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6706,'20170614','11:46:17','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6707,'20170614','12:05:51','189.202.227.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6708,'20170614','12:12:29','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6709,'20170614','12:25:44','200.78.223.183');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6710,'20170614','12:26:30','132.248.139.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6711,'20170614','12:36:32','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6712,'20170614','12:45:58','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6713,'20170614','12:47:47','187.214.135.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6714,'20170614','13:01:18','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6715,'20170614','13:23:05','189.216.198.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6716,'20170614','13:35:55','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6717,'20170614','13:39:42','187.145.192.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6718,'20170614','13:41:40','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6719,'20170614','14:03:05','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6720,'20170614','14:07:35','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6721,'20170614','14:08:33','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6722,'20170614','15:05:38','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6723,'20170614','15:34:26','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6724,'20170614','15:35:55','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6725,'20170614','17:05:32','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6726,'20170614','17:11:52','187.227.82.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6727,'20170614','17:40:28','189.208.30.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6728,'20170614','17:56:50','132.248.233.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6729,'20170614','18:08:29','66.249.88.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6730,'20170614','19:09:40','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6731,'20170614','21:45:51','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6732,'20170614','22:39:19','189.216.207.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6733,'20170615','00:03:03','66.249.79.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6734,'20170615','00:10:54','187.214.177.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6735,'20170615','00:33:34','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6736,'20170615','00:45:31','187.190.166.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6737,'20170615','06:44:05','180.76.15.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6738,'20170615','07:16:57','200.76.91.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6739,'20170615','08:38:15','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6740,'20170615','09:00:40','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6741,'20170615','09:01:47','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6742,'20170615','09:13:45','132.248.77.144');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6743,'20170615','09:27:50','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6744,'20170615','09:36:29','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6745,'20170615','09:36:45','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6746,'20170615','09:42:19','66.249.88.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6747,'20170615','09:50:30','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6748,'20170615','10:05:09','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6749,'20170615','10:17:06','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6750,'20170615','10:20:54','132.248.9.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6751,'20170615','10:23:36','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6752,'20170615','10:35:08','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6753,'20170615','10:35:23','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6754,'20170615','10:51:24','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6755,'20170615','11:07:58','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6756,'20170615','11:10:17','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6757,'20170615','11:13:00','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6758,'20170615','11:27:22','132.248.242.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6759,'20170615','11:32:48','64.233.172.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6760,'20170615','11:34:12','64.233.172.180');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6761,'20170615','11:40:16','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6762,'20170615','12:00:03','132.248.123.76');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6763,'20170615','12:00:09','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6764,'20170615','12:03:00','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6765,'20170615','12:17:51','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6766,'20170615','12:27:57','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6767,'20170615','12:28:59','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6768,'20170615','12:33:14','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6769,'20170615','12:38:19','132.248.9.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6770,'20170615','12:42:35','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6771,'20170615','13:08:23','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6772,'20170615','13:23:17','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6773,'20170615','13:36:44','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6774,'20170615','13:47:42','132.248.59.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6775,'20170615','14:06:08','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6776,'20170615','14:09:17','200.38.167.104');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6777,'20170615','14:11:09','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6778,'20170615','14:27:11','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6779,'20170615','14:35:38','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6780,'20170615','14:49:36','200.33.13.67');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6781,'20170615','15:03:31','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6782,'20170615','15:30:46','132.248.123.93');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6783,'20170615','15:34:20','189.216.58.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6784,'20170615','15:36:02','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6785,'20170615','15:57:29','132.248.123.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6786,'20170615','16:47:58','189.216.150.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6787,'20170615','16:58:39','187.159.88.13');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6788,'20170615','17:08:17','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6789,'20170615','18:05:25','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6790,'20170615','18:22:27','132.248.101.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6791,'20170615','18:40:04','189.136.155.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6792,'20170615','22:51:54','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6793,'20170615','22:55:13','189.216.97.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6794,'20170615','23:44:20','189.217.137.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6795,'20170616','00:13:10','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6796,'20170616','00:29:49','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6797,'20170616','01:04:21','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6798,'20170616','02:41:41','123.126.113.88');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6799,'20170616','03:14:41','180.76.15.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6800,'20170616','04:34:15','180.76.15.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6801,'20170616','06:35:50','180.76.15.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6802,'20170616','07:41:22','180.76.15.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6803,'20170616','08:32:55','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6804,'20170616','08:37:09','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6805,'20170616','08:57:22','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6806,'20170616','09:06:11','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6807,'20170616','09:10:29','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6808,'20170616','09:15:37','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6809,'20170616','09:31:06','201.103.233.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6810,'20170616','10:01:35','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6811,'20170616','10:05:49','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6812,'20170616','10:10:52','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6813,'20170616','10:23:28','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6814,'20170616','10:35:18','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6815,'20170616','10:40:04','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6816,'20170616','10:45:21','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6817,'20170616','10:48:00','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6818,'20170616','10:51:54','189.216.150.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6819,'20170616','11:01:12','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6820,'20170616','11:22:02','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6821,'20170616','11:29:03','132.248.62.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6822,'20170616','11:39:40','132.248.91.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6823,'20170616','11:44:55','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6824,'20170616','12:03:42','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6825,'20170616','12:36:29','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6826,'20170616','12:58:12','132.248.101.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6827,'20170616','12:59:46','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6828,'20170616','13:14:32','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6829,'20170616','13:52:38','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6830,'20170616','13:53:26','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6831,'20170616','13:56:34','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6832,'20170616','14:15:44','187.214.243.29');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6833,'20170616','14:57:31','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6834,'20170616','15:03:15','132.248.178.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6835,'20170616','16:06:00','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6836,'20170616','16:27:08','189.129.138.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6837,'20170616','17:57:53','132.248.16.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6838,'20170616','18:07:26','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6839,'20170616','18:16:05','189.216.75.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6840,'20170616','18:55:28','132.248.60.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6841,'20170616','18:57:54','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6842,'20170616','19:25:02','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6843,'20170616','20:12:57','201.119.61.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6844,'20170616','20:50:00','187.226.141.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6845,'20170616','20:52:40','189.217.87.167');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6846,'20170616','23:46:42','178.45.195.207');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6847,'20170616','23:51:24','180.76.15.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6848,'20170617','01:20:04','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6849,'20170617','06:44:10','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6850,'20170617','07:01:34','180.76.15.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6851,'20170617','07:56:21','189.216.148.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6852,'20170617','09:13:21','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6853,'20170617','10:19:32','163.172.68.99');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6854,'20170617','12:50:54','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6855,'20170617','13:27:00','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6856,'20170617','13:30:24','95.24.112.214');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6857,'20170617','13:31:31','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6858,'20170617','13:58:39','132.248.55.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6859,'20170617','14:03:59','177.234.17.30');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6860,'20170617','16:43:30','189.137.203.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6861,'20170618','01:54:20','189.137.203.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6862,'20170618','02:02:29','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6863,'20170618','02:02:31','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6864,'20170618','02:33:23','180.76.15.141');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6865,'20170618','07:44:57','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6866,'20170618','08:50:19','189.216.97.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6867,'20170618','09:40:42','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6868,'20170618','11:15:44','180.76.15.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6869,'20170618','13:04:14','187.199.194.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6870,'20170618','13:23:38','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6871,'20170618','15:42:43','187.145.217.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6872,'20170618','16:08:19','189.137.236.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6873,'20170618','16:48:25','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6874,'20170619','01:00:48','189.216.96.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6875,'20170619','01:12:43','189.216.188.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6876,'20170619','01:22:24','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6877,'20170619','01:30:47','180.76.15.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6878,'20170619','01:37:13','200.76.83.203');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6879,'20170619','02:34:10','189.216.159.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6880,'20170619','03:09:47','201.137.236.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6881,'20170619','03:17:56','95.83.102.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6882,'20170619','03:56:47','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6883,'20170619','06:08:33','37.110.70.90');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6884,'20170619','07:59:12','200.76.83.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6885,'20170619','08:52:04','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6886,'20170619','08:55:01','200.76.83.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6887,'20170619','08:57:27','66.249.75.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6888,'20170619','08:58:05','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6889,'20170619','08:58:32','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6890,'20170619','09:20:05','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6891,'20170619','09:43:13','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6892,'20170619','09:56:40','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6893,'20170619','10:29:50','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6894,'20170619','10:48:14','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6895,'20170619','11:08:28','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6896,'20170619','11:13:52','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6897,'20170619','11:16:43','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6898,'20170619','11:28:07','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6899,'20170619','11:31:26','132.248.67.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6900,'20170619','11:40:46','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6901,'20170619','11:42:02','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6902,'20170619','11:49:28','201.102.20.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6903,'20170619','11:49:40','177.234.0.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6904,'20170619','11:50:44','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6905,'20170619','11:51:56','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6906,'20170619','11:53:05','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6907,'20170619','12:09:32','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6908,'20170619','12:33:29','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6909,'20170619','12:44:56','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6910,'20170619','12:48:13','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6911,'20170619','12:50:13','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6912,'20170619','12:56:27','132.248.95.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6913,'20170619','12:59:13','132.248.224.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6914,'20170619','13:11:39','187.227.138.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6915,'20170619','13:17:00','189.210.48.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6916,'20170619','13:21:18','63.243.252.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6917,'20170619','13:22:42','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6918,'20170619','13:28:04','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6919,'20170619','13:36:41','132.248.67.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6920,'20170619','13:45:57','180.76.15.155');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6921,'20170619','13:49:29','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6922,'20170619','13:51:03','132.248.199.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6923,'20170619','13:53:08','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6924,'20170619','13:58:03','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6925,'20170619','14:24:48','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6926,'20170619','14:46:52','201.114.159.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6927,'20170619','15:00:40','132.248.62.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6928,'20170619','15:15:19','180.76.15.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6929,'20170619','15:18:58','132.248.139.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6930,'20170619','15:20:27','187.189.93.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6931,'20170619','15:46:40','132.248.132.246');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6932,'20170619','16:48:46','187.145.192.137');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6933,'20170619','17:04:57','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6934,'20170619','17:28:25','132.248.16.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6935,'20170619','18:12:18','132.247.192.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6936,'20170619','18:44:51','66.102.6.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6937,'20170619','18:45:16','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6938,'20170619','18:45:54','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6939,'20170619','18:56:12','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6940,'20170619','19:01:29','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6941,'20170619','19:12:05','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6942,'20170619','19:55:30','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6943,'20170619','20:03:28','189.215.230.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6944,'20170619','20:27:50','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6945,'20170619','20:35:29','66.249.88.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6946,'20170619','21:27:08','180.76.15.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6947,'20170619','21:39:30','189.215.231.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6948,'20170619','21:47:15','66.249.75.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6949,'20170619','21:53:07','187.222.6.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6950,'20170620','01:08:43','180.76.15.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6951,'20170620','02:59:59','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6952,'20170620','06:28:56','66.249.69.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6953,'20170620','07:32:42','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6954,'20170620','07:54:28','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6955,'20170620','08:47:06','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6956,'20170620','08:49:16','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6957,'20170620','08:58:07','187.224.6.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6958,'20170620','09:03:01','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6959,'20170620','09:33:50','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6960,'20170620','09:39:45','201.164.65.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6961,'20170620','09:42:24','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6962,'20170620','09:46:21','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6963,'20170620','09:50:49','66.249.75.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6964,'20170620','10:04:15','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6965,'20170620','10:09:27','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6966,'20170620','10:27:51','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6967,'20170620','10:59:47','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6968,'20170620','11:09:25','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6969,'20170620','11:13:49','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6970,'20170620','11:21:17','132.247.113.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6971,'20170620','11:23:51','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6972,'20170620','11:31:35','148.206.53.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6973,'20170620','11:37:17','132.248.242.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6974,'20170620','11:37:30','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6975,'20170620','12:00:47','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6976,'20170620','12:08:29','164.73.28.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6977,'20170620','12:13:47','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6978,'20170620','12:33:21','132.248.72.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6979,'20170620','12:36:10','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6980,'20170620','13:01:14','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6981,'20170620','13:13:19','187.176.8.225');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6982,'20170620','13:15:48','132.248.18.138');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6983,'20170620','13:33:02','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6984,'20170620','13:35:19','189.211.128.148');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6985,'20170620','13:57:21','132.248.51.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6986,'20170620','14:05:45','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6987,'20170620','14:06:28','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6988,'20170620','14:10:23','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6989,'20170620','14:18:08','66.249.64.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6990,'20170620','14:26:06','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6991,'20170620','14:34:00','128.68.108.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6992,'20170620','14:34:37','132.248.44.181');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6993,'20170620','14:35:37','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6994,'20170620','14:38:10','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6995,'20170620','14:44:02','177.234.3.118');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6996,'20170620','14:45:45','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6997,'20170620','14:50:12','189.210.48.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6998,'20170620','14:59:28','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (6999,'20170620','15:02:19','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7000,'20170620','15:03:04','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7001,'20170620','15:08:48','180.76.15.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7002,'20170620','15:13:45','132.248.9.169');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7003,'20170620','15:15:41','140.148.78.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7004,'20170620','16:13:34','132.248.143.89');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7005,'20170620','16:23:45','132.248.199.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7006,'20170620','16:39:27','201.163.20.121');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7007,'20170620','16:56:04','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7008,'20170620','16:59:26','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7009,'20170620','17:33:48','66.249.84.208');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7010,'20170620','17:34:33','66.249.84.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7011,'20170620','17:51:50','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7012,'20170620','17:55:21','66.249.84.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7013,'20170620','17:55:42','200.33.13.67');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7014,'20170620','18:46:08','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7015,'20170620','19:43:05','132.247.249.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7016,'20170620','19:57:20','66.249.64.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7017,'20170620','20:01:16','189.216.112.82');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7018,'20170620','22:07:27','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7019,'20170620','22:08:37','66.102.6.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7020,'20170620','22:08:45','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7021,'20170620','22:40:00','66.249.64.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7022,'20170621','03:29:48','163.172.71.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7023,'20170621','03:59:38','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7024,'20170621','06:42:43','37.145.104.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7025,'20170621','08:31:49','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7026,'20170621','09:13:34','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7027,'20170621','09:15:38','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7028,'20170621','09:37:58','176.193.121.77');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7029,'20170621','09:39:42','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7030,'20170621','09:43:10','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7031,'20170621','09:53:01','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7032,'20170621','10:17:57','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7033,'20170621','10:27:07','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7034,'20170621','11:04:18','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7035,'20170621','11:19:30','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7036,'20170621','11:27:24','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7037,'20170621','11:48:59','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7038,'20170621','11:58:11','189.211.179.153');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7039,'20170621','11:59:41','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7040,'20170621','12:03:35','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7041,'20170621','12:10:00','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7042,'20170621','12:20:57','132.248.240.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7043,'20170621','12:44:06','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7044,'20170621','12:49:24','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7045,'20170621','12:56:10','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7046,'20170621','13:11:03','189.217.71.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7047,'20170621','13:11:14','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7048,'20170621','13:13:51','189.249.214.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7049,'20170621','13:19:25','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7050,'20170621','13:44:30','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7051,'20170621','13:52:18','187.237.231.61');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7052,'20170621','13:52:43','187.210.189.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7053,'20170621','14:21:08','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7054,'20170621','14:55:06','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7055,'20170621','15:04:31','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7056,'20170621','15:14:07','132.248.9.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7057,'20170621','15:19:43','132.248.43.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7058,'20170621','15:37:02','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7059,'20170621','15:42:17','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7060,'20170621','16:00:37','132.247.242.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7061,'20170621','16:06:12','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7062,'20170621','16:08:05','132.248.12.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7063,'20170621','16:23:28','132.248.150.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7064,'20170621','16:42:47','189.137.203.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7065,'20170621','17:02:12','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7066,'20170621','17:24:00','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7067,'20170621','17:31:59','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7068,'20170621','17:40:54','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7069,'20170621','17:51:57','200.33.3.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7070,'20170621','17:59:31','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7071,'20170621','18:11:38','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7072,'20170621','19:12:09','31.221.90.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7073,'20170621','19:54:02','201.134.231.201');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7074,'20170621','20:41:30','132.248.177.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7075,'20170621','21:28:47','189.216.65.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7076,'20170622','00:38:14','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7077,'20170622','02:07:14','180.76.15.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7078,'20170622','02:07:54','187.168.215.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7079,'20170622','08:32:40','180.76.15.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7080,'20170622','08:39:55','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7081,'20170622','09:02:02','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7082,'20170622','09:28:55','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7083,'20170622','09:39:11','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7084,'20170622','09:56:18','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7085,'20170622','10:00:39','132.248.76.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7086,'20170622','10:03:13','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7087,'20170622','10:22:49','132.248.177.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7088,'20170622','10:29:18','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7089,'20170622','10:30:23','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7090,'20170622','10:57:50','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7091,'20170622','11:28:53','66.102.7.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7092,'20170622','11:31:54','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7093,'20170622','11:32:31','189.216.150.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7094,'20170622','11:36:07','187.214.223.235');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7095,'20170622','11:36:22','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7096,'20170622','11:36:27','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7097,'20170622','11:39:47','187.168.23.37');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7098,'20170622','11:52:13','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7099,'20170622','11:52:36','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7100,'20170622','11:56:14','189.241.24.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7101,'20170622','12:03:35','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7102,'20170622','12:16:35','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7103,'20170622','12:16:44','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7104,'20170622','12:18:44','132.248.102.98');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7105,'20170622','12:23:44','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7106,'20170622','12:37:45','132.248.33.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7107,'20170622','12:57:29','132.248.82.112');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7108,'20170622','13:40:50','132.248.9.113');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7109,'20170622','13:56:21','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7110,'20170622','13:56:24','148.244.65.170');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7111,'20170622','14:31:47','177.234.16.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7112,'20170622','14:36:07','132.248.121.195');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7113,'20170622','15:09:44','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7114,'20170622','15:16:54','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7115,'20170622','15:51:34','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7116,'20170622','16:11:14','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7117,'20170622','16:58:35','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7118,'20170622','17:09:43','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7119,'20170622','17:40:59','187.227.132.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7120,'20170622','17:43:42','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7121,'20170622','17:45:58','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7122,'20170622','17:53:39','187.154.29.44');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7123,'20170622','18:20:51','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7124,'20170622','18:39:52','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7125,'20170622','19:16:38','148.223.228.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7126,'20170622','19:48:05','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7127,'20170622','21:11:56','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7128,'20170622','22:43:21','189.216.58.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7129,'20170623','00:05:59','189.216.58.57');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7130,'20170623','00:12:38','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7131,'20170623','00:58:23','201.119.66.107');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7132,'20170623','03:29:43','217.182.132.69');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7133,'20170623','03:34:27','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7134,'20170623','09:07:50','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7135,'20170623','09:27:38','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7136,'20170623','09:31:37','148.204.186.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7137,'20170623','09:35:17','180.76.15.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7138,'20170623','09:40:07','132.248.67.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7139,'20170623','09:42:36','132.248.65.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7140,'20170623','09:47:08','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7141,'20170623','10:01:27','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7142,'20170623','10:19:28','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7143,'20170623','10:22:35','132.248.103.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7144,'20170623','10:30:48','148.241.176.161');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7145,'20170623','10:33:57','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7145,'20170623','10:33:57','132.248.184.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7147,'20170623','10:35:27','132.248.67.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7148,'20170623','10:35:33','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7149,'20170623','10:35:46','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7150,'20170623','10:36:58','66.102.6.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7151,'20170623','10:40:55','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7152,'20170623','11:05:59','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7153,'20170623','11:18:21','109.63.196.110');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7154,'20170623','11:44:39','132.248.159.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7155,'20170623','11:58:34','132.248.178.199');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7156,'20170623','12:22:18','148.240.148.163');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7157,'20170623','12:26:21','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7158,'20170623','13:03:56','132.248.2.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7159,'20170623','13:14:18','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7160,'20170623','13:21:17','132.248.67.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7161,'20170623','13:33:23','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7162,'20170623','13:43:39','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7163,'20170623','13:48:54','187.227.132.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7164,'20170623','14:10:59','132.248.184.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7165,'20170623','14:28:34','200.76.83.228');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7166,'20170623','14:39:18','180.76.15.156');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7167,'20170623','15:01:53','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7168,'20170623','15:06:05','189.216.157.106');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7169,'20170623','15:12:15','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7170,'20170623','15:28:29','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7171,'20170623','15:38:53','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7172,'20170623','15:48:47','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7173,'20170623','16:01:29','200.57.204.46');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7174,'20170623','17:11:28','132.248.67.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7175,'20170623','17:48:43','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7176,'20170623','18:16:29','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7177,'20170623','18:36:49','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7178,'20170623','18:39:07','66.249.84.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7179,'20170623','18:39:24','66.249.84.206');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7180,'20170623','19:15:22','128.69.152.114');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7181,'20170623','19:15:51','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7182,'20170623','19:41:11','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7183,'20170623','19:48:43','66.249.79.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7184,'20170623','19:58:49','68.180.229.41');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7185,'20170623','22:03:57','187.145.211.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7186,'20170623','22:12:41','201.141.46.159');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7187,'20170623','23:02:03','180.76.15.23');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7188,'20170623','23:11:38','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7189,'20170623','23:54:15','128.69.222.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7190,'20170624','03:20:27','66.249.79.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7191,'20170624','03:58:50','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7192,'20170624','05:13:12','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7193,'20170624','05:44:11','66.249.79.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7194,'20170624','08:43:24','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7195,'20170624','10:34:51','201.137.13.167');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7196,'20170624','12:15:20','201.124.150.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7197,'20170624','15:52:55','148.202.17.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7198,'20170624','16:44:11','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7199,'20170624','16:52:12','187.145.211.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7200,'20170624','21:26:20','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7201,'20170625','01:44:06','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7202,'20170625','08:49:52','66.249.66.14');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7202,'20170625','08:49:52','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7204,'20170625','13:18:20','187.228.191.164');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7205,'20170625','13:45:42','180.76.15.142');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7206,'20170625','15:54:51','37.204.82.187');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7207,'20170625','16:12:05','180.76.15.25');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7208,'20170625','16:18:12','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7209,'20170625','16:19:58','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7210,'20170625','16:58:27','180.76.15.160');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7211,'20170625','20:40:35','190.212.215.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7212,'20170625','22:31:08','66.102.7.254');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7213,'20170625','22:53:34','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7214,'20170625','23:48:43','176.9.113.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7215,'20170626','03:32:42','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7215,'20170626','03:32:42','66.249.66.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7217,'20170626','06:24:17','41.189.38.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7218,'20170626','07:25:15','37.144.88.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7219,'20170626','08:27:54','189.217.16.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7220,'20170626','08:48:58','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7221,'20170626','08:51:21','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7222,'20170626','09:09:27','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7223,'20170626','09:53:23','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7224,'20170626','09:59:30','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7225,'20170626','10:03:39','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7226,'20170626','10:04:05','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7227,'20170626','10:15:53','132.247.249.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7228,'20170626','10:28:13','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7229,'20170626','10:29:53','66.249.79.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7230,'20170626','10:40:36','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7231,'20170626','10:42:40','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7232,'20170626','10:49:28','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7233,'20170626','10:52:57','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7234,'20170626','10:55:01','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7235,'20170626','10:58:15','187.189.240.133');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7236,'20170626','11:04:41','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7237,'20170626','11:11:31','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7238,'20170626','11:15:08','132.248.49.197');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7239,'20170626','11:17:21','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7240,'20170626','11:17:37','187.163.48.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7241,'20170626','11:17:37','187.163.48.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7242,'20170626','11:28:27','148.206.53.124');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7243,'20170626','11:35:25','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7244,'20170626','11:35:26','66.249.66.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7245,'20170626','11:39:34','95.220.35.109');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7246,'20170626','11:48:52','189.216.180.27');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7247,'20170626','11:49:33','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7248,'20170626','12:12:05','132.248.184.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7249,'20170626','12:19:58','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7250,'20170626','12:24:30','132.248.82.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7251,'20170626','12:26:43','180.76.15.6');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7252,'20170626','12:37:59','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7253,'20170626','12:44:27','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7254,'20170626','12:54:23','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7255,'20170626','12:55:14','201.163.162.108');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7256,'20170626','13:05:32','132.248.116.43');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7257,'20170626','13:07:19','132.248.33.216');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7258,'20170626','13:10:11','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7259,'20170626','13:13:20','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7260,'20170626','13:19:15','132.248.67.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7261,'20170626','13:19:23','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7262,'20170626','13:29:50','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7263,'20170626','13:33:37','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7264,'20170626','13:51:28','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7265,'20170626','13:52:11','66.102.6.149');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7266,'20170626','13:55:24','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7267,'20170626','14:01:37','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7268,'20170626','14:36:59','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7269,'20170626','14:43:17','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7270,'20170626','15:08:43','148.204.177.97');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7271,'20170626','15:10:44','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7272,'20170626','15:19:50','132.247.200.252');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7273,'20170626','15:25:28','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7274,'20170626','15:30:03','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7275,'20170626','15:53:16','201.103.3.36');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7276,'20170626','15:56:15','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7277,'20170626','16:01:53','132.248.101.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7278,'20170626','16:07:29','132.248.242.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7279,'20170626','16:10:29','176.193.141.83');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7280,'20170626','16:14:18','132.248.209.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7281,'20170626','16:40:17','132.248.9.120');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7282,'20170626','16:53:21','189.248.136.24');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7283,'20170626','17:46:51','132.248.209.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7284,'20170626','17:52:33','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7284,'20170626','17:52:33','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7284,'20170626','17:52:33','132.248.132.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7287,'20170626','18:19:12','132.248.192.242');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7288,'20170626','18:33:20','187.168.45.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7289,'20170626','18:43:32','132.248.86.31');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7290,'20170626','18:44:05','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7291,'20170626','18:44:08','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7291,'20170626','18:44:09','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7291,'20170626','18:44:09','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7294,'20170626','19:03:29','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7295,'20170626','19:14:31','66.249.79.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7296,'20170626','19:19:32','187.199.29.210');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7297,'20170626','19:31:46','132.248.183.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7298,'20170626','20:10:06','140.148.78.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7299,'20170626','20:33:43','52.86.176.3');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7300,'20170626','21:29:14','180.76.15.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7301,'20170626','21:55:56','198.176.81.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7302,'20170626','23:52:11','189.216.150.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7303,'20170627','02:34:48','180.76.15.146');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7304,'20170627','08:15:50','95.221.215.227');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7305,'20170627','08:46:01','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7306,'20170627','09:03:43','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7307,'20170627','09:16:30','132.248.130.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7308,'20170627','09:34:07','66.102.7.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7309,'20170627','09:41:33','132.248.233.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7310,'20170627','09:46:02','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7311,'20170627','10:07:33','132.248.123.244');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7312,'20170627','10:15:33','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7313,'20170627','10:17:30','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7314,'20170627','10:26:51','213.124.127.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7315,'20170627','10:30:07','132.248.35.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7316,'20170627','10:38:35','132.248.62.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7317,'20170627','10:42:02','132.248.110.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7318,'20170627','10:42:51','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7319,'20170627','11:24:06','132.248.9.95');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7320,'20170627','11:24:37','180.76.15.151');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7321,'20170627','11:28:01','66.249.88.11');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7322,'20170627','11:28:05','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7323,'20170627','11:51:05','52.71.155.178');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7324,'20170627','12:20:15','189.137.221.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7325,'20170627','12:24:25','201.134.170.15');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7326,'20170627','12:26:49','132.248.181.49');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7327,'20170627','12:35:55','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7328,'20170627','12:48:13','132.248.193.60');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7329,'20170627','13:04:32','132.248.180.152');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7330,'20170627','13:06:49','132.248.67.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7331,'20170627','13:07:57','132.248.238.130');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7332,'20170627','13:31:00','180.76.15.22');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7333,'20170627','13:49:10','201.134.231.33');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7334,'20170627','13:52:00','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7335,'20170627','14:11:59','200.87.14.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7336,'20170627','14:15:07','180.76.15.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7337,'20170627','14:22:45','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7338,'20170627','14:29:11','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7339,'20170627','14:37:10','132.248.82.111');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7340,'20170627','15:31:57','146.148.64.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7341,'20170627','15:35:50','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7342,'20170627','15:39:16','37.147.104.78');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7343,'20170627','15:53:03','132.248.9.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7344,'20170627','16:15:53','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7345,'20170627','17:04:21','132.248.67.122');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7346,'20170627','17:12:16','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7347,'20170627','17:17:39','66.249.79.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7348,'20170627','17:45:56','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7349,'20170627','17:58:18','66.249.79.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7350,'20170627','18:04:20','132.248.242.85');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7351,'20170627','18:12:21','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7352,'20170627','18:26:53','132.248.245.129');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7353,'20170627','18:41:35','132.248.67.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7354,'20170627','18:44:45','66.102.6.150');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7355,'20170627','18:45:40','132.248.9.68');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7356,'20170627','18:59:57','140.148.78.48');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7357,'20170627','19:06:28','200.33.14.105');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7358,'20170627','19:16:59','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7359,'20170627','19:46:52','201.157.108.118');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7360,'20170627','19:48:55','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7361,'20170627','19:52:34','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7362,'20170627','20:40:18','187.214.179.12');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7363,'20170628','06:20:41','66.249.79.147');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7364,'20170628','07:52:28','66.249.79.145');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7365,'20170628','08:17:49','66.249.79.143');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7366,'20170628','08:19:30','187.210.230.2');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7367,'20170628','08:30:11','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7368,'20170628','09:01:43','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7369,'20170628','09:46:40','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7370,'20170628','09:55:06','148.205.120.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7371,'20170628','09:57:08','132.248.11.243');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7372,'20170628','09:58:04','132.248.184.165');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7373,'20170628','10:00:33','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7374,'20170628','10:05:07','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7375,'20170628','10:05:42','132.248.9.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7376,'20170628','10:05:58','187.145.203.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7377,'20170628','10:16:30','132.248.159.234');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7378,'20170628','10:19:02','132.248.103.241');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7379,'20170628','10:23:02','201.166.189.139');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7380,'20170628','10:52:56','189.203.164.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7381,'20170628','10:58:16','132.248.67.54');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7382,'20170628','11:03:06','132.248.67.10');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7383,'20170628','11:13:57','187.207.144.189');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7384,'20170628','11:18:13','132.248.26.220');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7385,'20170628','11:19:57','132.248.9.17');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7386,'20170628','11:20:35','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7387,'20170628','11:24:09','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7388,'20170628','11:26:02','132.248.9.135');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7389,'20170628','11:44:47','132.248.156.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7390,'20170628','11:54:15','132.248.67.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7391,'20170628','11:55:26','189.137.221.115');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7392,'20170628','12:01:00','132.248.9.171');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7393,'20170628','12:06:22','132.248.9.162');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7394,'20170628','12:18:06','132.248.48.86');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7395,'20170628','12:19:19','132.248.101.4');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7396,'20170628','12:22:37','185.204.59.213');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7397,'20170628','12:48:32','132.248.242.26');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7398,'20170628','13:00:17','132.248.9.136');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7399,'20170628','13:02:45','132.248.9.131');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7400,'20170628','13:04:44','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7401,'20170628','13:07:05','187.248.22.211');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7402,'20170628','13:07:44','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7403,'20170628','13:08:55','132.248.48.158');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7404,'20170628','13:27:15','132.248.67.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7405,'20170628','13:29:33','132.248.62.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7406,'20170628','13:29:42','132.248.102.91');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7407,'20170628','13:32:08','132.248.101.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7408,'20170628','13:35:06','132.248.228.73');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7409,'20170628','13:35:06','132.248.25.190');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7410,'20170628','13:35:07','132.248.228.229');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7411,'20170628','13:35:09','132.248.228.72');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7412,'20170628','13:35:10','132.248.25.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7413,'20170628','13:35:13','132.248.228.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7414,'20170628','13:35:34','132.248.228.70');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7415,'20170628','13:35:36','132.248.228.78');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7416,'20170628','13:43:56','132.248.67.240');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7417,'20170628','13:45:27','132.248.41.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7418,'20170628','13:56:51','132.248.30.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7419,'20170628','14:03:07','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7420,'20170628','14:26:48','132.248.177.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7421,'20170628','14:30:06','132.248.9.140');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7422,'20170628','14:42:40','132.248.67.215');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7423,'20170628','14:52:24','66.249.80.52');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7424,'20170628','15:02:02','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7425,'20170628','15:09:06','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7426,'20170628','15:11:10','148.206.135.34');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7427,'20170628','15:54:19','132.247.186.1');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7428,'20170628','16:13:00','189.202.227.196');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7429,'20170628','16:20:57','132.248.67.19');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7430,'20170628','16:45:19','132.248.9.128');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7431,'20170628','17:19:56','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7432,'20170628','17:19:59','66.249.73.222');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7433,'20170628','17:27:47','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7434,'20170628','18:12:36','187.157.185.18');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7435,'20170628','18:30:22','132.247.192.55');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7436,'20170628','19:02:52','201.137.170.198');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7437,'20170628','19:05:42','132.248.67.103');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7438,'20170628','19:28:01','200.68.138.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7439,'20170628','21:45:30','201.166.189.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7440,'20170629','01:10:02','66.249.73.221');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7441,'20170629','03:58:11','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7442,'20170629','04:41:13','176.193.122.39');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7443,'20170629','09:01:59','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7444,'20170629','09:04:44','132.248.228.119');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7445,'20170629','09:36:07','132.248.67.247');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7446,'20170629','10:28:59','132.248.66.253');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7447,'20170629','10:49:40','132.248.67.102');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7448,'20170629','10:57:44','132.248.67.154');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7449,'20170629','11:01:15','132.248.14.230');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7450,'20170629','11:03:56','132.248.13.5');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7451,'20170629','11:11:09','132.248.101.9');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7452,'20170629','11:33:34','132.248.9.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7453,'20170629','11:53:38','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7454,'20170629','12:22:56','132.248.52.56');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7455,'20170629','12:46:30','132.248.72.209');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7456,'20170629','12:47:34','132.248.177.42');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7457,'20170629','12:48:41','132.248.184.87');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7458,'20170629','13:09:49','66.249.88.8');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7459,'20170629','13:27:00','132.248.199.134');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7460,'20170629','14:23:20','173.252.90.80');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7461,'20170629','14:41:22','132.248.67.166');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7462,'20170629','14:52:39','132.248.9.51');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7463,'20170629','15:02:21','201.149.55.226');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7464,'20170629','15:14:18','132.248.209.74');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7465,'20170629','15:15:11','132.248.101.58');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7466,'20170629','15:48:25','132.248.67.173');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7467,'20170629','16:40:04','200.13.105.132');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7468,'20170629','18:02:53','132.248.67.32');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7469,'20170629','19:09:31','200.76.83.238');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7470,'20170629','19:33:04','132.248.131.28');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7471,'20170629','20:36:19','132.248.9.21');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7472,'20170630','00:11:53','66.249.73.223');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7473,'20170630','08:36:19','132.248.67.248');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7474,'20170630','08:56:38','132.248.67.188');
INSERT INTO "bitacora" ("identificador","fecha","hora","ip") VALUES (7475,'20170630','09:00:22','132.248.228.119');
--
-- TOC Entry ID 33 (OID 3327336)
--
-- Name: "apdopost_apdo_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX apdopost_apdo_id_key ON apdopost USING btree (apdo_id);

--
-- TOC Entry ID 49 (OID 3327337)
--
-- Name: "xpkapdopost" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkapdopost ON apdopost USING btree (apdo_id);

--
-- TOC Entry ID 43 (OID 3327338)
--
-- Name: "datosdepen_dep_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX datosdepen_dep_id_key ON datosdepen USING btree (dep_id);

--
-- TOC Entry ID 39 (OID 3327339)
--
-- Name: "xpkdatosdepen" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkdatosdepen ON datosdepen USING btree (dep_id);

--
-- TOC Entry ID 34 (OID 3327340)
--
-- Name: "datosubdep_subdep_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX datosubdep_subdep_id_key ON datosubdep USING btree (subdep_id);

--
-- TOC Entry ID 50 (OID 3327341)
--
-- Name: "xpkdatosubdep" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkdatosubdep ON datosubdep USING btree (subdep_id, dep_id);

--
-- TOC Entry ID 44 (OID 3327342)
--
-- Name: "datosbiblio_bib_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX datosbiblio_bib_id_key ON datosbiblio USING btree (bib_id);

--
-- TOC Entry ID 40 (OID 3327343)
--
-- Name: "xpkdatosbiblio" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkdatosbiblio ON datosbiblio USING btree (bib_id);

--
-- TOC Entry ID 35 (OID 3327344)
--
-- Name: "xpkdireccion" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkdireccion ON direccion USING btree (dir_id, bib_id, dep_id, subdep_id);

--
-- TOC Entry ID 51 (OID 3327345)
--
-- Name: "xpkcoleccion" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkcoleccion ON coleccion USING btree (bib_id);

--
-- TOC Entry ID 45 (OID 3327346)
--
-- Name: "datospersona_per_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX datospersona_per_id_key ON datospersona USING btree (per_id);

--
-- TOC Entry ID 41 (OID 3327347)
--
-- Name: "xpkdatospersona" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkdatospersona ON datospersona USING btree (per_id);

--
-- TOC Entry ID 36 (OID 3327348)
--
-- Name: "xpkinfraestructura" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkinfraestructura ON infraestructura USING btree (bib_id);

--
-- TOC Entry ID 52 (OID 3327349)
--
-- Name: "xpknormatividad" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpknormatividad ON normatividad USING btree (bib_id);

--
-- TOC Entry ID 46 (OID 3327350)
--
-- Name: "xpkpersona" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkpersona ON persona USING btree (bib_id, per_id);

--
-- TOC Entry ID 47 (OID 3327351)
--
-- Name: "xpkrechumanos" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkrechumanos ON rechumanos USING btree (bib_id);

--
-- TOC Entry ID 37 (OID 3327352)
--
-- Name: "xpkservicio" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkservicio ON servicio USING btree (bib_id);

--
-- TOC Entry ID 53 (OID 3327353)
--
-- Name: "usuario_usu_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX usuario_usu_id_key ON usuario USING btree (usu_id);

--
-- TOC Entry ID 48 (OID 3327354)
--
-- Name: "xpkusuario" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkusuario ON usuario USING btree (usu_id);

--
-- TOC Entry ID 42 (OID 3327355)
--
-- Name: "modificacion_mod_id_key" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX modificacion_mod_id_key ON modificacion USING btree (mod_id);

--
-- TOC Entry ID 38 (OID 3327356)
--
-- Name: "xpkmodificacion" Type: INDEX Owner: israeld
--

CREATE UNIQUE INDEX xpkmodificacion ON modificacion USING btree (mod_id);

--
-- TOC Entry ID 95 (OID 3327358)
--
-- Name: "RI_ConstraintTrigger_3327357" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "coleccion"  FROM "datosbiblio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'coleccion', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 79 (OID 3327360)
--
-- Name: "RI_ConstraintTrigger_3327359" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosbiblio"  FROM "coleccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'coleccion', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 80 (OID 3327362)
--
-- Name: "RI_ConstraintTrigger_3327361" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosbiblio"  FROM "coleccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'coleccion', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 91 (OID 3327364)
--
-- Name: "RI_ConstraintTrigger_3327363" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "direccion"  FROM "apdopost" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'direccion', 'apdopost', 'UNSPECIFIED', 'apdo_id', 'apdo_id');

--
-- TOC Entry ID 70 (OID 3327366)
--
-- Name: "RI_ConstraintTrigger_3327365" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "apdopost"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_setnull_del" ('<unnamed>', 'direccion', 'apdopost', 'UNSPECIFIED', 'apdo_id', 'apdo_id');

--
-- TOC Entry ID 71 (OID 3327368)
--
-- Name: "RI_ConstraintTrigger_3327367" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "apdopost"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_setnull_upd" ('<unnamed>', 'direccion', 'apdopost', 'UNSPECIFIED', 'apdo_id', 'apdo_id');

--
-- TOC Entry ID 92 (OID 3327370)
--
-- Name: "RI_ConstraintTrigger_3327369" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "direccion"  FROM "datosdepen" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'direccion', 'datosdepen', 'UNSPECIFIED', 'dep_id', 'dep_id');

--
-- TOC Entry ID 72 (OID 3327372)
--
-- Name: "RI_ConstraintTrigger_3327371" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosdepen"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'direccion', 'datosdepen', 'UNSPECIFIED', 'dep_id', 'dep_id');

--
-- TOC Entry ID 73 (OID 3327374)
--
-- Name: "RI_ConstraintTrigger_3327373" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosdepen"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'direccion', 'datosdepen', 'UNSPECIFIED', 'dep_id', 'dep_id');

--
-- TOC Entry ID 93 (OID 3327376)
--
-- Name: "RI_ConstraintTrigger_3327375" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "direccion"  FROM "datosbiblio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'direccion', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 81 (OID 3327378)
--
-- Name: "RI_ConstraintTrigger_3327377" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosbiblio"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'direccion', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 82 (OID 3327380)
--
-- Name: "RI_ConstraintTrigger_3327379" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosbiblio"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'direccion', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 94 (OID 3327382)
--
-- Name: "RI_ConstraintTrigger_3327381" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "direccion"  FROM "datosubdep" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'direccion', 'datosubdep', 'UNSPECIFIED', 'subdep_id', 'subdep_id');

--
-- TOC Entry ID 76 (OID 3327384)
--
-- Name: "RI_ConstraintTrigger_3327383" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosubdep"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'direccion', 'datosubdep', 'UNSPECIFIED', 'subdep_id', 'subdep_id');

--
-- TOC Entry ID 77 (OID 3327386)
--
-- Name: "RI_ConstraintTrigger_3327385" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosubdep"  FROM "direccion" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'direccion', 'datosubdep', 'UNSPECIFIED', 'subdep_id', 'subdep_id');

--
-- TOC Entry ID 98 (OID 3327388)
--
-- Name: "RI_ConstraintTrigger_3327387" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "infraestructura"  FROM "datosbiblio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'infraestructura', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 83 (OID 3327390)
--
-- Name: "RI_ConstraintTrigger_3327389" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosbiblio"  FROM "infraestructura" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'infraestructura', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 84 (OID 3327392)
--
-- Name: "RI_ConstraintTrigger_3327391" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosbiblio"  FROM "infraestructura" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'infraestructura', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 99 (OID 3327394)
--
-- Name: "RI_ConstraintTrigger_3327393" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "normatividad"  FROM "datosbiblio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'normatividad', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 85 (OID 3327396)
--
-- Name: "RI_ConstraintTrigger_3327395" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosbiblio"  FROM "normatividad" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'normatividad', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 86 (OID 3327398)
--
-- Name: "RI_ConstraintTrigger_3327397" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosbiblio"  FROM "normatividad" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'normatividad', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 100 (OID 3327400)
--
-- Name: "RI_ConstraintTrigger_3327399" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "persona"  FROM "datospersona" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'persona', 'datospersona', 'UNSPECIFIED', 'per_id', 'per_id');

--
-- TOC Entry ID 96 (OID 3327402)
--
-- Name: "RI_ConstraintTrigger_3327401" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datospersona"  FROM "persona" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'persona', 'datospersona', 'UNSPECIFIED', 'per_id', 'per_id');

--
-- TOC Entry ID 97 (OID 3327404)
--
-- Name: "RI_ConstraintTrigger_3327403" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datospersona"  FROM "persona" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'persona', 'datospersona', 'UNSPECIFIED', 'per_id', 'per_id');

--
-- TOC Entry ID 101 (OID 3327406)
--
-- Name: "RI_ConstraintTrigger_3327405" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "rechumanos"  FROM "datosbiblio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'rechumanos', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 87 (OID 3327408)
--
-- Name: "RI_ConstraintTrigger_3327407" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosbiblio"  FROM "rechumanos" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'rechumanos', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 88 (OID 3327410)
--
-- Name: "RI_ConstraintTrigger_3327409" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosbiblio"  FROM "rechumanos" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'rechumanos', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 102 (OID 3327412)
--
-- Name: "RI_ConstraintTrigger_3327411" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "servicio"  FROM "datosbiblio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'servicio', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 89 (OID 3327414)
--
-- Name: "RI_ConstraintTrigger_3327413" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosbiblio"  FROM "servicio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'servicio', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 90 (OID 3327416)
--
-- Name: "RI_ConstraintTrigger_3327415" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosbiblio"  FROM "servicio" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'servicio', 'datosbiblio', 'UNSPECIFIED', 'bib_id', 'bib_id');

--
-- TOC Entry ID 78 (OID 3327418)
--
-- Name: "RI_ConstraintTrigger_3327417" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "datosubdep"  FROM "datosdepen" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'datosubdep', 'datosdepen', 'UNSPECIFIED', 'dep_id', 'dep_id');

--
-- TOC Entry ID 74 (OID 3327420)
--
-- Name: "RI_ConstraintTrigger_3327419" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "datosdepen"  FROM "datosubdep" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_del" ('<unnamed>', 'datosubdep', 'datosdepen', 'UNSPECIFIED', 'dep_id', 'dep_id');

--
-- TOC Entry ID 75 (OID 3327422)
--
-- Name: "RI_ConstraintTrigger_3327421" Type: TRIGGER Owner: israeld
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "datosdepen"  FROM "datosubdep" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_restrict_upd" ('<unnamed>', 'datosubdep', 'datosdepen', 'UNSPECIFIED', 'dep_id', 'dep_id');

--
-- TOC Entry ID 3 (OID 3235330)
--
-- Name: apdopost_apdo_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"apdopost_apdo_id_seq"', 1, false);

--
-- TOC Entry ID 5 (OID 3235335)
--
-- Name: datosdepen_dep_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"datosdepen_dep_id_seq"', 1, false);

--
-- TOC Entry ID 7 (OID 3235343)
--
-- Name: datosubdep_subdep_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"datosubdep_subdep_id_seq"', 1, false);

--
-- TOC Entry ID 9 (OID 3235351)
--
-- Name: datosbiblio_bib_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"datosbiblio_bib_id_seq"', 1, false);

--
-- TOC Entry ID 11 (OID 3235371)
--
-- Name: datospersona_per_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"datospersona_per_id_seq"', 1, false);

--
-- TOC Entry ID 13 (OID 3235406)
--
-- Name: usuario_usu_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"usuario_usu_id_seq"', 1, false);

--
-- TOC Entry ID 15 (OID 3235411)
--
-- Name: modificacion_mod_id_seq Type: SEQUENCE SET Owner: israeld
--

SELECT setval ('"modificacion_mod_id_seq"', 16996, true);

